/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/network","vs/base/common/types","electron","vs/platform/files/common/files","vs/base/common/resources","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/errors","vs/platform/product/common/productService","vs/base/common/cancellation","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/platform/workspace/common/workspace","vs/base/common/arrays","vs/platform/environment/electron-main/environmentMainService","fs","os","vs/base/common/extpath","vs/base/common/uuid","vs/base/common/strings","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/labels","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/platform/policy/common/policy","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","vs/base/common/decorators","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/id","vs/base/parts/ipc/node/ipc.net","vs/base/node/processes","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/shell/node/shellEnv","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/color","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/decoder","string_decoder","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/backup/electron-main/backupMainService","vs/platform/storage/electron-main/storageIpc","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","path","graceful-fs","vscode-policy-watcher","zlib","vs/code/electron-main/main"],X=function(z){for(var e=[],v=0,t=z.length;v<t;v++)e[v]=Y[z[v]];return e};define(Y[115],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(t,D){if(!t)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=v}),define(Y[116],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function v(M){return M?M.replace(/\$\((.*?)\)/g,(S,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=v;class t{constructor(S,d,p){this.id=S,this.definition=d,this.description=p,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function D(M,S){const d=["codicon","codicon-"+M];return S&&d.push("codicon-modifier-"+S),d}e.getClassNamesArray=D;var R;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function d(k){if(k instanceof t)return["codicon","codicon-"+k.id];const y=S.exec(k.id);if(!y)return d(t.error);const[,m,u]=y,b=["codicon","codicon-"+m];return u&&b.push("codicon-modifier-"+u.substr(1)),b}M.asClassNameArray=d;function p(k){return d(k).join(" ")}M.asClassName=p;function C(k){return"."+d(k).join(".")}M.asCSSSelector=C})(R=e.CSSIcon||(e.CSSIcon={}))}),define(Y[117],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function v(S,d){const p=Math.pow(10,d);return Math.round(S*p)/p}class t{constructor(d,p,C,k=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,p))|0,this.b=Math.min(255,Math.max(0,C))|0,this.a=v(Math.max(Math.min(1,k),0),3)}static equals(d,p){return d.r===p.r&&d.g===p.g&&d.b===p.b&&d.a===p.a}}e.RGBA=t;class D{constructor(d,p,C,k){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=v(Math.max(Math.min(1,p),0),3),this.l=v(Math.max(Math.min(1,C),0),3),this.a=v(Math.max(Math.min(1,k),0),3)}static equals(d,p){return d.h===p.h&&d.s===p.s&&d.l===p.l&&d.a===p.a}static fromRGBA(d){const p=d.r/255,C=d.g/255,k=d.b/255,y=d.a,m=Math.max(p,C,k),u=Math.min(p,C,k);let b=0,w=0;const E=(u+m)/2,I=m-u;if(I>0){switch(w=Math.min(E<=.5?I/(2*E):I/(2-2*E),1),m){case p:b=(C-k)/I+(C<k?6:0);break;case C:b=(k-p)/I+2;break;case k:b=(p-C)/I+4;break}b*=60,b=Math.round(b)}return new D(b,w,E,y)}static _hue2rgb(d,p,C){return C<0&&(C+=1),C>1&&(C-=1),C<1/6?d+(p-d)*6*C:C<1/2?p:C<2/3?d+(p-d)*(2/3-C)*6:d}static toRGBA(d){const p=d.h/360,{s:C,l:k,a:y}=d;let m,u,b;if(C===0)m=u=b=k;else{const w=k<.5?k*(1+C):k+C-k*C,E=2*k-w;m=D._hue2rgb(E,w,p+1/3),u=D._hue2rgb(E,w,p),b=D._hue2rgb(E,w,p-1/3)}return new t(Math.round(m*255),Math.round(u*255),Math.round(b*255),y)}}e.HSLA=D;class R{constructor(d,p,C,k){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=v(Math.max(Math.min(1,p),0),3),this.v=v(Math.max(Math.min(1,C),0),3),this.a=v(Math.max(Math.min(1,k),0),3)}static equals(d,p){return d.h===p.h&&d.s===p.s&&d.v===p.v&&d.a===p.a}static fromRGBA(d){const p=d.r/255,C=d.g/255,k=d.b/255,y=Math.max(p,C,k),m=Math.min(p,C,k),u=y-m,b=y===0?0:u/y;let w;return u===0?w=0:y===p?w=((C-k)/u%6+6)%6:y===C?w=(k-p)/u+2:w=(p-C)/u+4,new R(Math.round(w*60),b,y,d.a)}static toRGBA(d){const{h:p,s:C,v:k,a:y}=d,m=k*C,u=m*(1-Math.abs(p/60%2-1)),b=k-m;let[w,E,I]=[0,0,0];return p<60?(w=m,E=u):p<120?(w=u,E=m):p<180?(E=m,I=u):p<240?(E=u,I=m):p<300?(w=u,I=m):p<=360&&(w=m,I=u),w=Math.round((w+b)*255),E=Math.round((E+b)*255),I=Math.round((I+b)*255),new t(w,E,I,y)}}e.HSVA=R;class M{constructor(d){if(d)if(d instanceof t)this.rgba=d;else if(d instanceof D)this._hsla=d,this.rgba=D.toRGBA(d);else if(d instanceof R)this._hsva=d,this.rgba=R.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(d){return M.Format.CSS.parseHex(d)||M.red}get hsla(){return this._hsla?this._hsla:D.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}equals(d){return!!d&&t.equals(this.rgba,d.rgba)&&D.equals(this.hsla,d.hsla)&&R.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=M._relativeLuminanceForComponent(this.rgba.r),p=M._relativeLuminanceForComponent(this.rgba.g),C=M._relativeLuminanceForComponent(this.rgba.b),k=.2126*d+.7152*p+.0722*C;return v(k,4)}static _relativeLuminanceForComponent(d){const p=d/255;return p<=.03928?p/12.92:Math.pow((p+.055)/1.055,2.4)}getContrastRatio(d){const p=this.getRelativeLuminance(),C=d.getRelativeLuminance();return p>C?(p+.05)/(C+.05):(C+.05)/(p+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const p=this.getRelativeLuminance(),C=d.getRelativeLuminance();return p>C}isDarkerThan(d){const p=this.getRelativeLuminance(),C=d.getRelativeLuminance();return p<C}lighten(d){return new M(new D(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new M(new D(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:p,g:C,b:k,a:y}=this.rgba;return new M(new t(p,C,k,y*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const p=d.rgba,C=this.rgba.a,k=p.a,y=C+k*(1-C);if(y<1e-6)return M.transparent;const m=this.rgba.r*C/y+p.r*k*(1-C)/y,u=this.rgba.g*C/y+p.g*k*(1-C)/y,b=this.rgba.b*C/y+p.b*k*(1-C)/y;return new M(new t(m,u,b,y))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:p,g:C,b:k,a:y}=this.rgba;return new M(new t(d.rgba.r-y*(d.rgba.r-p),d.rgba.g-y*(d.rgba.g-C),d.rgba.b-y*(d.rgba.b-k),1))}flatten(...d){const p=d.reduceRight((C,k)=>M._flatten(k,C));return M._flatten(this,p)}static _flatten(d,p){const C=1-d.rgba.a;return new M(new t(C*p.rgba.r+d.rgba.a*d.rgba.r,C*p.rgba.g+d.rgba.a*d.rgba.g,C*p.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this._toString||(this._toString=M.Format.CSS.format(this)),this._toString}static getLighterColor(d,p,C){if(d.isLighterThan(p))return d;C=C||.5;const k=d.getRelativeLuminance(),y=p.getRelativeLuminance();return C=C*(y-k)/y,d.lighten(C)}static getDarkerColor(d,p,C){if(d.isDarkerThan(p))return d;C=C||.5;const k=d.getRelativeLuminance(),y=p.getRelativeLuminance();return C=C*(k-y)/k,d.darken(C)}}e.Color=M,M.white=new M(new t(255,255,255,1)),M.black=new M(new t(0,0,0,1)),M.red=new M(new t(255,0,0,1)),M.blue=new M(new t(0,0,255,1)),M.green=new M(new t(0,255,0,1)),M.cyan=new M(new t(0,255,255,1)),M.lightgrey=new M(new t(211,211,211,1)),M.transparent=new M(new t(0,0,0,0)),function(S){let d;(function(p){let C;(function(k){function y(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:S.Format.CSS.formatRGBA(n)}k.formatRGB=y;function m(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}k.formatRGBA=m;function u(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(n)}k.formatHSL=u;function b(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}k.formatHSLA=b;function w(n){const r=n.toString(16);return r.length!==2?"0"+r:r}function E(n){return`#${w(n.rgba.r)}${w(n.rgba.g)}${w(n.rgba.b)}`}k.formatHex=E;function I(n,r=!1){return r&&n.rgba.a===1?S.Format.CSS.formatHex(n):`#${w(n.rgba.r)}${w(n.rgba.g)}${w(n.rgba.b)}${w(Math.round(n.rgba.a*255))}`}k.formatHexA=I;function g(n){return n.isOpaque()?S.Format.CSS.formatHex(n):S.Format.CSS.formatRGBA(n)}k.format=g;function h(n){const r=n.length;if(r===0||n.charCodeAt(0)!==35)return null;if(r===7){const i=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),s=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),o=16*l(n.charCodeAt(5))+l(n.charCodeAt(6));return new S(new t(i,s,o,1))}if(r===9){const i=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),s=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),o=16*l(n.charCodeAt(5))+l(n.charCodeAt(6)),a=16*l(n.charCodeAt(7))+l(n.charCodeAt(8));return new S(new t(i,s,o,a/255))}if(r===4){const i=l(n.charCodeAt(1)),s=l(n.charCodeAt(2)),o=l(n.charCodeAt(3));return new S(new t(16*i+i,16*s+s,16*o+o))}if(r===5){const i=l(n.charCodeAt(1)),s=l(n.charCodeAt(2)),o=l(n.charCodeAt(3)),a=l(n.charCodeAt(4));return new S(new t(16*i+i,16*s+s,16*o+o,(16*a+a)/255))}return null}k.parseHex=h;function l(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(C=p.CSS||(p.CSS={}))})(d=S.Format||(S.Format={}))}(M=e.Color||(e.Color={}))}),define(Y[51],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(M){return(S,d,p)=>{let C=null,k=null;if(typeof p.value=="function"?(C="value",k=p.value):typeof p.get=="function"&&(C="get",k=p.get),!k)throw new Error("not supported");p[C]=M(k,d)}}e.createDecorator=v;function t(M,S,d){let p=null,C=null;if(typeof d.value=="function"?(p="value",C=d.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(p="get",C=d.get),!C)throw new Error("not supported");const k=`$memoize$${S}`;d[p]=function(...y){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,y)}),this[k]}}e.memoize=t;function D(M,S,d){return v((p,C)=>{const k=`$debounce$${C}`,y=`$debounce$result$${C}`;return function(...m){this[y]||(this[y]=d?d():void 0),clearTimeout(this[k]),S&&(this[y]=S(this[y],...m),m=[this[y]]),this[k]=setTimeout(()=>{p.apply(this,m),this[y]=d?d():void 0},M)}})}e.debounce=D;function R(M,S,d){return v((p,C)=>{const k=`$throttle$timer$${C}`,y=`$throttle$result$${C}`,m=`$throttle$lastRun$${C}`,u=`$throttle$pending$${C}`;return function(...b){if(this[y]||(this[y]=d?d():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),S&&(this[y]=S(this[y],...b)),this[u])return;const w=this[m]+M;w<=Date.now()?(this[m]=Date.now(),p.apply(this,[this[y]]),this[y]=d?d():void 0):(this[u]=!0,this[k]=setTimeout(()=>{this[u]=!1,this[m]=Date.now(),p.apply(this,[this[y]]),this[y]=d?d():void 0},w-Date.now()))}})}e.throttle=R}),define(Y[19],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?g.isErrorNoTelemetry(n)?new g(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(r=>{r(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=v,e.errorHandler=new v;function t(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=t;function D(l){d(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=D;function R(l){d(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=R;function M(l){if(l instanceof Error){const{name:n,message:r}=l,i=l.stacktrace||l.stack;return{$isError:!0,name:n,message:r,stack:i,noTelemetry:g.isErrorNoTelemetry(l)}}return l}e.transformErrorForSerialization=M;const S="Canceled";function d(l){return l instanceof p?!0:l instanceof Error&&l.name===S&&l.message===S}e.isCancellationError=d;class p extends Error{constructor(){super(S);this.name=this.message}}e.CancellationError=p;function C(){const l=new Error(S);return l.name=l.message,l}e.canceled=C;function k(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=k;function y(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=y;function m(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function u(l){const n=new Error(`${l} has been disposed`);return n.name="DISPOSED",n}e.disposed=u;function b(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=b;class w extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=w;class E extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=E;class I extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=I;class g extends Error{constructor(n){super(n);this.name="ErrorNoTelemetry"}static fromError(n){if(n instanceof g)return n;const r=new g;return r.message=n.message,r.stack=n.stack,r}static isErrorNoTelemetry(n){return n.name==="ErrorNoTelemetry"}}e.ErrorNoTelemetry=g;class h extends Error{constructor(n){super(n||"An unexpected bug occurred.");Object.setPrototypeOf(this,h.prototype);debugger}}e.BugIndicatingError=h}),define(Y[25],X([0,1,19]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(U,K=0){return U[U.length-(1+K)]}e.tail=t;function D(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=D;function R(U,K,Z=(ae,le)=>ae===le){if(U===K)return!0;if(!U||!K||U.length!==K.length)return!1;for(let ae=0,le=U.length;ae<le;ae++)if(!Z(U[ae],K[ae]))return!1;return!0}e.equals=R;function M(U,K){const Z=U.length-1;K<Z&&(U[K]=U[Z]),U.pop()}e.removeFastWithoutKeepingOrder=M;function S(U,K,Z){return d(U.length,ae=>Z(U[ae],K))}e.binarySearch=S;function d(U,K){let Z=0,ae=U-1;for(;Z<=ae;){const le=(Z+ae)/2|0,ge=K(le);if(ge<0)Z=le+1;else if(ge>0)ae=le-1;else return le}return-(Z+1)}e.binarySearch2=d;function p(U,K){let Z=0,ae=U.length;if(ae===0)return 0;for(;Z<ae;){const le=Math.floor((Z+ae)/2);K(U[le])?ae=le:Z=le+1}return Z}e.findFirstInSorted=p;function C(U,K,Z){if(U=U|0,U>=K.length)throw new TypeError("invalid index");const ae=K[Math.floor(K.length*Math.random())],le=[],ge=[],be=[];for(const Le of K){const Ce=Z(Le,ae);Ce<0?le.push(Le):Ce>0?ge.push(Le):be.push(Le)}return U<le.length?C(U,le,Z):U<le.length+be.length?be[0]:C(U-(le.length+be.length),ge,Z)}e.quickSelect=C;function k(U,K){const Z=[];let ae;for(const le of U.slice(0).sort(K))!ae||K(ae[0],le)!==0?(ae=[le],Z.push(ae)):ae.push(le);return Z}e.groupBy=k;function y(U,K,Z){const ae=[];function le(Le,Ce,ke){if(Ce===0&&ke.length===0)return;const Ae=ae[ae.length-1];Ae&&Ae.start+Ae.deleteCount===Le?(Ae.deleteCount+=Ce,Ae.toInsert.push(...ke)):ae.push({start:Le,deleteCount:Ce,toInsert:ke})}let ge=0,be=0;for(;;){if(ge===U.length){le(ge,0,K.slice(be));break}if(be===K.length){le(ge,U.length-ge,[]);break}const Le=U[ge],Ce=K[be],ke=Z(Le,Ce);ke===0?(ge+=1,be+=1):ke<0?(le(ge,1,[]),ge+=1):ke>0&&(le(ge,0,[Ce]),be+=1)}return ae}e.sortedDiff=y;function m(U,K,Z){const ae=y(U,K,Z),le=[],ge=[];for(const be of ae)le.push(...U.slice(be.start,be.start+be.deleteCount)),ge.push(...be.toInsert);return{removed:le,added:ge}}e.delta=m;function u(U,K,Z){if(Z===0)return[];const ae=U.slice(0,Z).sort(K);return w(U,K,ae,Z,U.length),ae}e.top=u;function b(U,K,Z,ae,le){return Z===0?Promise.resolve([]):new Promise((ge,be)=>{(async()=>{const Le=U.length,Ce=U.slice(0,Z).sort(K);for(let ke=Z,Ae=Math.min(Z+ae,Le);ke<Le;ke=Ae,Ae=Math.min(Ae+ae,Le)){if(ke>Z&&await new Promise(ue=>setTimeout(ue)),le&&le.isCancellationRequested)throw new v.CancellationError;w(U,K,Ce,ke,Ae)}return Ce})().then(ge,be)})}e.topAsync=b;function w(U,K,Z,ae,le){for(const ge=Z.length;ae<le;ae++){const be=U[ae];if(K(be,Z[ge-1])<0){Z.pop();const Le=p(Z,Ce=>K(be,Ce)<0);Z.splice(Le,0,be)}}}function E(U){return U.filter(K=>!!K)}e.coalesce=E;function I(U){let K=0;for(let Z=0;Z<U.length;Z++)U[Z]&&(U[K]=U[Z],K+=1);U.length=K}e.coalesceInPlace=I;function g(U,K,Z){U.splice(Z,0,U.splice(K,1)[0])}e.move=g;function h(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=h;function l(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=l;function n(U,K=Z=>Z){const Z=new Set;return U.filter(ae=>{const le=K(ae);return Z.has(le)?!1:(Z.add(le),!0)})}e.distinct=n;function r(U){const K=new Set;return Z=>{const ae=U(Z);return K.has(ae)?!1:(K.add(ae),!0)}}e.uniqueFilter=r;function i(U,K){const Z=s(U,K);if(Z!==-1)return U[Z]}e.findLast=i;function s(U,K){for(let Z=U.length-1;Z>=0;Z--){const ae=U[Z];if(K(ae))return Z}return-1}e.lastIndex=s;function o(U,K){return U.length>0?U[0]:K}e.firstOrDefault=o;function a(U,K){return U.length>0?U[U.length-1]:K}e.lastOrDefault=a;function c(U,K,Z=(ae,le)=>ae===le){let ae=0;for(let le=0,ge=Math.min(U.length,K.length);le<ge&&Z(U[le],K[le]);le++)ae++;return ae}e.commonPrefixLength=c;function f(U){return[].concat(...U)}e.flatten=f;function P(U,K){let Z=typeof K=="number"?U:0;typeof K=="number"?Z=U:(Z=0,K=U);const ae=[];if(Z<=K)for(let le=Z;le<K;le++)ae.push(le);else for(let le=Z;le>K;le--)ae.push(le);return ae}e.range=P;function L(U,K,Z){return U.reduce((ae,le)=>(ae[K(le)]=Z?Z(le):le,ae),Object.create(null))}e.index=L;function T(U,K){return U.push(K),()=>W(U,K)}e.insert=T;function W(U,K){const Z=U.indexOf(K);if(Z>-1)return U.splice(Z,1),K}e.remove=W;function $(U,K,Z){const ae=U.slice(0,K),le=U.slice(K);return ae.concat(Z,le)}e.arrayInsert=$;function te(U,K){let Z;if(typeof K=="number"){let ae=K;Z=()=>{const le=Math.sin(ae++)*179426549;return le-Math.floor(le)}}else Z=Math.random;for(let ae=U.length-1;ae>0;ae-=1){const le=Math.floor(Z()*(ae+1)),ge=U[ae];U[ae]=U[le],U[le]=ge}}e.shuffle=te;function re(U,K){const Z=U.indexOf(K);Z>-1&&(U.splice(Z,1),U.unshift(K))}e.pushToStart=re;function ie(U,K){const Z=U.indexOf(K);Z>-1&&(U.splice(Z,1),U.push(K))}e.pushToEnd=ie;function se(U,K){for(const Z of K)U.push(Z)}e.pushMany=se;function ce(U,K){return Array.isArray(U)?U.map(K):K(U)}e.mapArrayOrNot=ce;function q(U){return Array.isArray(U)?U:[U]}e.asArray=q;function ne(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=ne;function O(U,K){for(const Z of U){const ae=K(Z);if(ae!==void 0)return ae}}e.mapFind=O;function _(U,K,Z){const ae=Q(U,K),le=U.length,ge=Z.length;U.length=le+ge;for(let be=le-1;be>=ae;be--)U[be+ge]=U[be];for(let be=0;be<ge;be++)U[be+ae]=Z[be]}e.insertInto=_;function B(U,K,Z,ae){const le=Q(U,K),ge=U.splice(le,Z);return _(U,le,ae),ge}e.splice=B;function Q(U,K){return K<0?Math.max(K+U.length,0):Math.min(K,U.length)}var H;(function(U){function K(le){return le<0}U.isLessThan=K;function Z(le){return le>0}U.isGreaterThan=Z;function ae(le){return le===0}U.isNeitherLessOrGreaterThan=ae,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(H=e.CompareResult||(e.CompareResult={}));function G(U,K){return(Z,ae)=>K(U(Z),U(ae))}e.compareBy=G;function x(...U){return(K,Z)=>{for(const ae of U){const le=ae(K,Z);if(!H.isNeitherLessOrGreaterThan(le))return le}return H.neitherLessOrGreaterThan}}e.tieBreakComparators=x;const A=(U,K)=>U-K;e.numberComparator=A;function F(U,K){if(U.length===0)return;let Z=U[0];for(let ae=1;ae<U.length;ae++){const le=U[ae];K(le,Z)>0&&(Z=le)}return Z}e.findMaxBy=F;function N(U,K){if(U.length===0)return;let Z=U[0];for(let ae=1;ae<U.length;ae++){const le=U[ae];K(le,Z)>=0&&(Z=le)}return Z}e.findLastMaxBy=N;function j(U,K){return F(U,(Z,ae)=>-K(Z,ae))}e.findMinBy=j;class J{constructor(K){this.items=K,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(K){let Z=this.firstIdx;for(;Z<this.items.length&&K(this.items[Z]);)Z++;const ae=Z===this.firstIdx?null:this.items.slice(this.firstIdx,Z);return this.firstIdx=Z,ae}takeFromEndWhile(K){let Z=this.lastIdx;for(;Z>=0&&K(this.items[Z]);)Z--;const ae=Z===this.lastIdx?null:this.items.slice(Z+1,this.lastIdx+1);return this.lastIdx=Z,ae}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const K=this.items[this.firstIdx];return this.firstIdx++,K}removeLast(){const K=this.items[this.lastIdx];return this.lastIdx--,K}takeCount(K){const Z=this.items.slice(this.firstIdx,this.firstIdx+K);return this.firstIdx+=K,Z}}e.ArrayQueue=J}),define(Y[48],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(t){const D=this;let R=!1,M;return function(){return R||(R=!0,M=t.apply(D,arguments)),M}}e.once=v}),define(Y[54],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(t){function D(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}t.is=D;const R=Object.freeze([]);function M(){return R}t.empty=M;function*S(r){yield r}t.single=S;function d(r){return r||R}t.from=d;function p(r){return!r||r[Symbol.iterator]().next().done===!0}t.isEmpty=p;function C(r){return r[Symbol.iterator]().next().value}t.first=C;function k(r,i){for(const s of r)if(i(s))return!0;return!1}t.some=k;function y(r,i){for(const s of r)if(i(s))return s}t.find=y;function*m(r,i){for(const s of r)i(s)&&(yield s)}t.filter=m;function*u(r,i){let s=0;for(const o of r)yield i(o,s++)}t.map=u;function*b(...r){for(const i of r)for(const s of i)yield s}t.concat=b;function*w(r){for(const i of r)for(const s of i)yield s}t.concatNested=w;function E(r,i,s){let o=s;for(const a of r)o=i(o,a);return o}t.reduce=E;function I(r,i){let s=0;for(const o of r)i(o,s++)}t.forEach=I;function*g(r,i,s=r.length){for(i<0&&(i+=r.length),s<0?s+=r.length:s>r.length&&(s=r.length);i<s;i++)yield r[i]}t.slice=g;function h(r,i=Number.POSITIVE_INFINITY){const s=[];if(i===0)return[s,r];const o=r[Symbol.iterator]();for(let a=0;a<i;a++){const c=o.next();if(c.done)return[s,t.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return o}}]}t.consume=h;function l(r){return h(r)[0]}t.collect=l;function n(r,i,s=(o,a)=>o===a){const o=r[Symbol.iterator](),a=i[Symbol.iterator]();for(;;){const c=o.next(),f=a.next();if(c.done!==f.done)return!1;if(c.done)return!0;if(!s(c.value,f.value))return!1}}t.equals=n})(v=e.Iterable||(e.Iterable={}))}),define(Y[49],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(n){n.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function M(n,r=!1){let i=0;const s=n.length;let o="",a=0,c=16,f=0;function P(ie){let se=0,ce=0;for(;se<ie;){const q=n.charCodeAt(i);if(q>=48&&q<=57)ce=ce*16+q-48;else if(q>=65&&q<=70)ce=ce*16+q-65+10;else if(q>=97&&q<=102)ce=ce*16+q-97+10;else break;i++,se++}return se<ie&&(ce=-1),ce}function L(ie){i=ie,o="",a=0,c=16,f=0}function T(){const ie=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&p(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&p(n.charCodeAt(i)))for(i++;i<n.length&&p(n.charCodeAt(i));)i++;else return f=3,n.substring(ie,i);let se=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&p(n.charCodeAt(i))){for(i++;i<n.length&&p(n.charCodeAt(i));)i++;se=i}else f=3;return n.substring(ie,se)}function W(){let ie="",se=i;for(;;){if(i>=s){ie+=n.substring(se,i),f=2;break}const ce=n.charCodeAt(i);if(ce===34){ie+=n.substring(se,i),i++;break}if(ce===92){if(ie+=n.substring(se,i),i++,i>=s){f=2;break}switch(n.charCodeAt(i++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const ne=P(4);ne>=0?ie+=String.fromCharCode(ne):f=4;break}default:f=5}se=i;continue}if(ce>=0&&ce<=31)if(d(ce)){ie+=n.substring(se,i),f=2;break}else f=6;i++}return ie}function $(){if(o="",f=0,a=i,i>=s)return a=s,c=17;let ie=n.charCodeAt(i);if(S(ie)){do i++,o+=String.fromCharCode(ie),ie=n.charCodeAt(i);while(S(ie));return c=15}if(d(ie))return i++,o+=String.fromCharCode(ie),ie===13&&n.charCodeAt(i)===10&&(i++,o+=`
`),c=14;switch(ie){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,o=W(),c=10;case 47:{const se=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<s&&!d(n.charCodeAt(i));)i++;return o=n.substring(se,i),c=12}if(n.charCodeAt(i+1)===42){i+=2;const ce=s-1;let q=!1;for(;i<ce;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,q=!0;break}i++}return q||(i++,f=1),o=n.substring(se,i),c=13}return o+=String.fromCharCode(ie),i++,c=16}case 45:if(o+=String.fromCharCode(ie),i++,i===s||!p(n.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=T(),c=11;default:for(;i<s&&te(ie);)i++,ie=n.charCodeAt(i);if(a!==i){switch(o=n.substring(a,i),o){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return o+=String.fromCharCode(ie),i++,c=16}}function te(ie){if(S(ie)||d(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let ie;do ie=$();while(ie>=12&&ie<=15);return ie}return{setPosition:L,getPosition:()=>i,scan:r?re:$,getToken:()=>c,getTokenValue:()=>o,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>f}}e.createScanner=M;function S(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function d(n){return n===10||n===13||n===8232||n===8233}function p(n){return n>=48&&n<=57}var C;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(C||(C={}));function k(n,r){const i=[],s=new Object;let o;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function f(P,L,T,W){a.value=P,a.offset=L,a.length=T,a.type=W,a.colonOffset=void 0,o=a}try{g(n,{onObjectBegin:(P,L)=>{if(r<=P)throw s;o=void 0,c=r>P,i.push("")},onObjectProperty:(P,L,T)=>{if(r<L||(f(P,L,T,"property"),i[i.length-1]=P,r<=L+T))throw s},onObjectEnd:(P,L)=>{if(r<=P)throw s;o=void 0,i.pop()},onArrayBegin:(P,L)=>{if(r<=P)throw s;o=void 0,i.push(0)},onArrayEnd:(P,L)=>{if(r<=P)throw s;o=void 0,i.pop()},onLiteralValue:(P,L,T)=>{if(r<L||(f(P,L,T,l(P)),r<=L+T))throw s},onSeparator:(P,L,T)=>{if(r<=L)throw s;if(P===":"&&o&&o.type==="property")o.colonOffset=L,c=!1,o=void 0;else if(P===","){const W=i[i.length-1];typeof W=="number"?i[i.length-1]=W+1:(c=!0,i[i.length-1]=""),o=void 0}}})}catch(P){if(P!==s)throw P}return{path:i,previousNode:o,isAtPropertyKey:c,matches:P=>{let L=0;for(let T=0;L<P.length&&T<i.length;T++)if(P[L]===i[T]||P[L]==="*")L++;else if(P[L]!=="**")return!1;return L===P.length}}}e.getLocation=k;function y(n,r=[],i=R.DEFAULT){let s=null,o=[];const a=[];function c(P){Array.isArray(o)?o.push(P):s!==null&&(o[s]=P)}return g(n,{onObjectBegin:()=>{const P={};c(P),a.push(o),o=P,s=null},onObjectProperty:P=>{s=P},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const P=[];c(P),a.push(o),o=P,s=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:c,onError:(P,L,T)=>{r.push({error:P,offset:L,length:T})}},i),o[0]}e.parse=y;function m(n,r=[],i=R.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(P){s.type==="property"&&(s.length=P-s.offset,s=s.parent)}function a(P){return s.children.push(P),P}g(n,{onObjectBegin:P=>{s=a({type:"object",offset:P,length:-1,parent:s,children:[]})},onObjectProperty:(P,L,T)=>{s=a({type:"property",offset:L,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:P,offset:L,length:T,parent:s})},onObjectEnd:(P,L)=>{s.length=P+L-s.offset,s=s.parent,o(P+L)},onArrayBegin:(P,L)=>{s=a({type:"array",offset:P,length:-1,parent:s,children:[]})},onArrayEnd:(P,L)=>{s.length=P+L-s.offset,s=s.parent,o(P+L)},onLiteralValue:(P,L,T)=>{a({type:l(P),offset:L,length:T,parent:s,value:P}),o(L+T)},onSeparator:(P,L,T)=>{s.type==="property"&&(P===":"?s.colonOffset=L:P===","&&o(L))},onError:(P,L,T)=>{r.push({error:P,offset:L,length:T})}},i);const f=s.children[0];return f&&delete f.parent,f}e.parseTree=m;function u(n,r){if(!n)return;let i=n;for(const s of r)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===s){i=a.children[1],o=!0;break}if(!o)return}else{const o=s;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=u;function b(n){if(!n.parent||!n.parent.children)return[];const r=b(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;r.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&r.push(i)}return r}e.getNodePath=b;function w(n){switch(n.type){case"array":return n.children.map(w);case"object":{const r=Object.create(null);for(const i of n.children){const s=i.children[1];s&&(r[i.children[0].value]=w(s))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=w;function E(n,r,i=!1){return r>=n.offset&&r<n.offset+n.length||i&&r===n.offset+n.length}e.contains=E;function I(n,r,i=!1){if(E(n,r,i)){const s=n.children;if(Array.isArray(s))for(let o=0;o<s.length&&s[o].offset<=r;o++){const a=I(s[o],r,i);if(a)return a}return n}}e.findNodeAtOffset=I;function g(n,r,i=R.DEFAULT){const s=M(n,!1);function o(G){return G?()=>G(s.getTokenOffset(),s.getTokenLength()):()=>!0}function a(G){return G?x=>G(x,s.getTokenOffset(),s.getTokenLength()):()=>!0}const c=o(r.onObjectBegin),f=a(r.onObjectProperty),P=o(r.onObjectEnd),L=o(r.onArrayBegin),T=o(r.onArrayEnd),W=a(r.onLiteralValue),$=a(r.onSeparator),te=o(r.onComment),re=a(r.onError),ie=i&&i.disallowComments,se=i&&i.allowTrailingComma;function ce(){for(;;){const G=s.scan();switch(s.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:ie||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(G){case 12:case 13:ie?q(10):te();break;case 16:q(1);break;case 15:case 14:break;default:return G}}}function q(G,x=[],A=[]){if(re(G),x.length+A.length>0){let F=s.getToken();for(;F!==17;){if(x.indexOf(F)!==-1){ce();break}else if(A.indexOf(F)!==-1)break;F=ce()}}}function ne(G){const x=s.getTokenValue();return G?W(x):f(x),ce(),!0}function O(){switch(s.getToken()){case 11:{let G=0;try{G=JSON.parse(s.getTokenValue()),typeof G!="number"&&(q(2),G=0)}catch{q(2)}W(G);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return ce(),!0}function _(){return s.getToken()!==10?(q(3,[],[2,5]),!1):(ne(!1),s.getToken()===6?($(":"),ce(),H()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function B(){c(),ce();let G=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(G||q(4,[],[]),$(","),ce(),s.getToken()===2&&se)break}else G&&q(6,[],[]);_()||q(4,[],[2,5]),G=!0}return P(),s.getToken()!==2?q(7,[2],[]):ce(),!0}function Q(){L(),ce();let G=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(G||q(4,[],[]),$(","),ce(),s.getToken()===4&&se)break}else G&&q(6,[],[]);H()||q(4,[],[4,5]),G=!0}return T(),s.getToken()!==4?q(8,[4],[]):ce(),!0}function H(){switch(s.getToken()){case 3:return Q();case 1:return B();case 10:return ne(!0);default:return O()}}return ce(),s.getToken()===17?i.allowEmptyContent?!0:(q(4,[],[]),!1):H()?(s.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.visit=g;function h(n,r){const i=M(n),s=[];let o,a=0,c;do switch(c=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:a!==c&&s.push(n.substring(a,c)),r!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,r)),a=i.getPosition();break}while(o!==17);return s.join("")}e.stripComments=h;function l(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(Y[118],X([0,1,49]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(p,C,k){let y,m,u,b,w;if(C){for(b=C.offset,w=b+C.length,u=b;u>0&&!d(p,u-1);)u--;let c=w;for(;c<p.length&&!d(p,c);)c++;m=p.substring(u,c),y=M(m,k)}else m=p,y=0,u=0,b=0,w=p.length;const E=S(k,p);let I=!1,g=0,h;k.insertSpaces?h=R(" ",k.tabSize||4):h="	";const l=(0,v.createScanner)(m,!1);let n=!1;function r(){return E+R(h,y+g)}function i(){let c=l.scan();for(I=!1;c===15||c===14;)I=I||c===14,c=l.scan();return n=c===16||l.getTokenError()!==0,c}const s=[];function o(c,f,P){!n&&f<w&&P>b&&p.substring(f,P)!==c&&s.push({offset:f,length:P-f,content:c})}let a=i();if(a!==17){const c=l.getTokenOffset()+u,f=R(h,y);o(f,u,c)}for(;a!==17;){let c=l.getTokenOffset()+l.getTokenLength()+u,f=i(),P="";for(;!I&&(f===12||f===13);){const T=l.getTokenOffset()+u;o(" ",c,T),c=l.getTokenOffset()+l.getTokenLength()+u,P=f===12?r():"",f=i()}if(f===2)a!==1&&(g--,P=r());else if(f===4)a!==3&&(g--,P=r());else{switch(a){case 3:case 1:g++,P=r();break;case 5:case 12:P=r();break;case 13:I?P=r():P=" ";break;case 6:P=" ";break;case 10:if(f===6){P="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?P=" ":f!==5&&f!==17&&(n=!0);break;case 16:n=!0;break}I&&(f===12||f===13)&&(P=r())}const L=l.getTokenOffset()+u;o(P,c,L),a=f}return s}e.format=t;function D(p,C){const k=JSON.stringify(p,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?k.replace(/\r\n|\r|\n/g,C.eol):k}e.toFormattedString=D;function R(p,C){let k="";for(let y=0;y<C;y++)k+=p;return k}function M(p,C){let k=0,y=0;const m=C.tabSize||4;for(;k<p.length;){const u=p.charAt(k);if(u===" ")y++;else if(u==="	")y+=m;else break;k++}return Math.floor(y/m)}function S(p,C){for(let k=0;k<C.length;k++){const y=C.charAt(k);if(y==="\r")return k+1<C.length&&C.charAt(k+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return p&&p.eol||`
`}e.getEOL=S;function d(p,C){return`\r
`.indexOf(p.charAt(C))!==-1}e.isEOL=d}),define(Y[119],X([0,1,49,118]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(p,C,k){return R(p,C,void 0,k)}e.removeProperty=D;function R(p,C,k,y,m){const u=C.slice(),b=[],w=(0,v.parseTree)(p,b);let E,I;for(;u.length>0&&(I=u.pop(),E=(0,v.findNodeAtLocation)(w,u),E===void 0&&k!==void 0);)typeof I=="string"?k={[I]:k}:k=[k];if(E)if(E.type==="object"&&typeof I=="string"&&Array.isArray(E.children)){const g=(0,v.findNodeAtLocation)(E,[I]);if(g!==void 0)if(k===void 0){if(!g.parent)throw new Error("Malformed AST");const h=E.children.indexOf(g.parent);let l,n=g.parent.offset+g.parent.length;if(h>0){const r=E.children[h-1];l=r.offset+r.length}else l=E.offset+1,E.children.length>1&&(n=E.children[1].offset);return M(p,{offset:l,length:n-l,content:""},y)}else return M(p,{offset:g.offset,length:g.length,content:JSON.stringify(k)},y);else{if(k===void 0)return[];const h=`${JSON.stringify(I)}: ${JSON.stringify(k)}`,l=m?m(E.children.map(r=>r.children[0].value)):E.children.length;let n;if(l>0){const r=E.children[l-1];n={offset:r.offset+r.length,length:0,content:","+h}}else E.children.length===0?n={offset:E.offset+1,length:0,content:h}:n={offset:E.offset+1,length:0,content:h+","};return M(p,n,y)}}else if(E.type==="array"&&typeof I=="number"&&Array.isArray(E.children))if(k!==void 0){const g=`${JSON.stringify(k)}`;let h;if(E.children.length===0||I===0)h={offset:E.offset+1,length:0,content:E.children.length===0?g:g+","};else{const l=I===-1||I>E.children.length?E.children.length:I,n=E.children[l-1];h={offset:n.offset+n.length,length:0,content:","+g}}return M(p,h,y)}else{const g=I,h=E.children[g];let l;if(E.children.length===1)l={offset:E.offset+1,length:E.length-2,content:""};else if(E.children.length-1===g){const n=E.children[g-1],r=n.offset+n.length,i=E.offset+E.length;l={offset:r,length:i-2-r,content:""}}else l={offset:h.offset,length:E.children[g+1].offset-h.offset,content:""};return M(p,l,y)}else throw new Error(`Can not add ${typeof I!="number"?"index":"property"} to parent of type ${E.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return M(p,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(k)},y)}}e.setProperty=R;function M(p,C,k){let y=S(p,C),m=C.offset,u=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;m>0&&!(0,t.isEOL)(y,m-1);)m--;for(;u<y.length&&!(0,t.isEOL)(y,u);)u++}const b=(0,t.format)(y,{offset:m,length:u-m},k);for(let E=b.length-1;E>=0;E--){const I=b[E];y=S(y,I),m=Math.min(m,I.offset),u=Math.max(u,I.offset+I.length),u+=I.content.length-I.length}const w=p.length-(y.length-u)-m;return[{offset:m,length:w,content:y.substring(m,u)}]}e.withFormatting=M;function S(p,C){return p.substring(0,C.offset)+C.content+p.substring(C.offset+C.length)}e.applyEdit=S;function d(p,C){const k=C.slice(0).sort((m,u)=>{const b=m.offset-u.offset;return b===0?m.length-u.length:b});let y=p.length;for(let m=k.length-1;m>=0;m--){const u=k[m];if(u.offset+u.length<=y)p=S(p,u);else throw new Error("Overlapping edit");y=u.offset}return p}e.applyEdits=d}),define(Y[120],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new v(()=>D(this.getValue()))}}e.Lazy=v}),define(Y[2],X([0,1,48,54]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let R=null;function M(o){R=o}if(e.setDisposableTracker=M,D){const o="__is_disposable_tracked__";M(new class{trackDisposable(a){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[o]||console.log(c)},3e3)}setParent(a,c){if(a&&a!==I.None)try{a[o]=!0}catch{}}markAsDisposed(a){if(a&&a!==I.None)try{a[o]=!0}catch{}}markAsSingleton(a){}})}function S(o){return R?.trackDisposable(o),o}function d(o){R?.markAsDisposed(o)}function p(o,a){R?.setParent(o,a)}function C(o,a){if(!!R)for(const c of o)R.setParent(c,a)}function k(o){return R?.markAsSingleton(o),o}e.markAsSingleton=k;class y extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=y;function m(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=m;function u(o){if(t.Iterable.is(o)){const a=[];for(const c of o)if(c)try{c.dispose()}catch(f){a.push(f)}if(a.length===1)throw a[0];if(a.length>1)throw new y(a);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=u;function b(...o){const a=w(()=>u(o));return C(o,a),a}e.combinedDisposable=b;function w(o){const a=S({dispose:(0,v.once)(()=>{d(a),o()})});return a}e.toDisposable=w;class E{constructor(){this._toDispose=new Set,this._isDisposed=!1,S(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return p(a,this),this._isDisposed?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=E,E.DISABLE_DISPOSED_WARNING=!1;class I{constructor(){this._store=new E,S(this),p(this._store,this)}dispose(){d(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=I,I.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&p(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&p(a,null),a}}e.MutableDisposable=g;class h{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=h;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(a){let c=a;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,d(this))},this}}e.SafeDisposable=l;class n{constructor(){this.references=new Map}acquire(a,...c){let f=this.references.get(a);f||(f={counter:0,object:this.createReferencedObject(a,...c)},this.references.set(a,f));const{object:P}=f,L=(0,v.once)(()=>{--f.counter==0&&(this.destroyReferencedObject(a,f.object),this.references.delete(a))});return f.counter++,{object:P,dispose:L}}}e.ReferenceCollection=n;class r{constructor(a){this.referenceCollection=a}async acquire(a,...c){const f=this.referenceCollection.acquire(a,...c);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(P){throw f.dispose(),P}}}e.AsyncReferenceCollection=r;class i{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=i;function s(o){const a=new E;try{o(a)}finally{a.dispose()}}e.disposeOnReturn=s}),define(Y[121],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(R){this.element=R,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class t{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let R=this._first;for(;R!==v.Undefined;){const M=R.next;R.prev=v.Undefined,R.next=v.Undefined,R=M}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,M){const S=new v(R);if(this._first===v.Undefined)this._first=S,this._last=S;else if(M){const p=this._last;this._last=S,S.prev=p,p.next=S}else{const p=this._first;this._first=S,S.next=p,p.prev=S}this._size+=1;let d=!1;return()=>{d||(d=!0,this._remove(S))}}shift(){if(this._first!==v.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==v.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==v.Undefined&&R.next!==v.Undefined){const M=R.prev;M.next=R.next,R.next.prev=M}else R.prev===v.Undefined&&R.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):R.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):R.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==v.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),function(){function z(D){const R=[];typeof D=="number"&&R.push("code/timeOrigin",D);function M(d){R.push(d,Date.now())}function S(){const d=[];for(let p=0;p<R.length;p+=2)d.push({name:R[p],startTime:R[p+1]});return d}return{mark:M,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const M of performance.getEntriesByType("mark"))R.push({name:M.name,startTime:Math.round(D+M.startTime)});return R}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function v(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=v(t))}(),define(Y[122],X([0,1]),function(z,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(S,d,p){this.level=S,this.key=d,this.value=p,this.forward=[]}}const D=void 0;class R{constructor(S,d=2**16){this.comparator=S,this[v]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(d)|0),this._header=new t(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,D,D)}has(S){return Boolean(R._search(this,S,this.comparator))}get(S){return R._search(this,S,this.comparator)?.value}set(S,d){return R._insert(this,S,d,this.comparator)&&(this._size+=1),this}delete(S){const d=R._delete(this,S,this.comparator);return d&&(this._size-=1),d}forEach(S,d){let p=this._header.forward[0];for(;p;)S.call(d,p.value,p.key,this),p=p.forward[0]}[(v=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this._header.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this._header.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this._header.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",d=this._header.forward[0];for(;d;)S+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return S}static _search(S,d,p){let C=S._header;for(let k=S._level-1;k>=0;k--)for(;C.forward[k]&&p(C.forward[k].key,d)<0;)C=C.forward[k];if(C=C.forward[0],C&&p(C.key,d)===0)return C}static _insert(S,d,p,C){const k=[];let y=S._header;for(let m=S._level-1;m>=0;m--){for(;y.forward[m]&&C(y.forward[m].key,d)<0;)y=y.forward[m];k[m]=y}if(y=y.forward[0],y&&C(y.key,d)===0)return y.value=p,!1;{const m=R._randomLevel(S);if(m>S._level){for(let u=S._level;u<m;u++)k[u]=S._header;S._level=m}y=new t(m,d,p);for(let u=0;u<m;u++)y.forward[u]=k[u].forward[u],k[u].forward[u]=y;return!0}}static _randomLevel(S,d=.5){let p=1;for(;Math.random()<d&&p<S._maxLevel;)p+=1;return p}static _delete(S,d,p){const C=[];let k=S._header;for(let y=S._level-1;y>=0;y--){for(;k.forward[y]&&p(k.forward[y].key,d)<0;)k=k.forward[y];C[y]=k}if(k=k.forward[0],!k||p(k.key,d)!==0)return!1;for(let y=0;y<S._level&&C[y].forward[y]===k;y++)C[y].forward[y]=k.forward[y];for(;S._level>0&&S._header.forward[S._level-1]===D;)S._level-=1;return!0}}e.SkipList=R}),define(Y[55],X([0,1,19,2]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(h){const l=h;return l?typeof l.read=="function":!1}e.isReadable=D;function R(h){const l=h;return l?[l.on,l.pause,l.resume,l.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=R;function M(h){const l=h;return l?R(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=M;function S(h,l){return new d(h,l)}e.newWriteableStream=S;class d{constructor(l,n){this.reducer=l,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(n=>n(l))}emitError(l){this.listeners.error.length===0?(0,v.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(n=>n(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,n){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(l,n){if(this.state.destroyed)return;let r;switch(l){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const i=r.indexOf(n);i>=0&&r.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(h,l){const n=[];let r;for(;(r=h.read())!==null;)n.push(r);return l(n)}e.consumeReadable=p;function C(h,l,n){const r=[];let i;for(;(i=h.read())!==null&&r.length<n;)r.push(i);return i===null&&r.length>0?l(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i!="undefined"){const s=i;return i=void 0,s}return h.read()}}}e.peekReadable=C;function k(h,l){return new Promise((n,r)=>{const i=[];y(h,{onData:s=>{l&&i.push(s)},onError:s=>{l?r(s):n(void 0)},onEnd:()=>{n(l?l(i):void 0)}})})}e.consumeStream=k;function y(h,l){let n=!1;return h.on("error",r=>{n||l.onError(r)}),h.on("end",()=>{n||l.onEnd()}),h.on("data",r=>{n||l.onData(r)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=y;function m(h,l){return new Promise((n,r)=>{const i=new t.DisposableStore,s=[],o=f=>{if(s.push(f),s.length>l)return i.dispose(),h.pause(),n({stream:h,buffer:s,ended:!1})},a=f=>r(f),c=()=>n({stream:h,buffer:s,ended:!0});i.add((0,t.toDisposable)(()=>h.removeListener("error",a))),h.on("error",a),i.add((0,t.toDisposable)(()=>h.removeListener("end",c))),h.on("end",c),i.add((0,t.toDisposable)(()=>h.removeListener("data",o))),h.on("data",o)})}e.peekStream=m;function u(h,l){const n=S(l);return n.end(h),n}e.toStream=u;function b(){const h=S(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=b;function w(h){let l=!1;return{read:()=>l?null:(l=!0,h)}}e.toReadable=w;function E(h,l,n){const r=S(n);return y(h,{onData:i=>r.write(l.data(i)),onError:i=>r.error(l.error?l.error(i):i),onEnd:()=>r.end()}),r}e.transform=E;function I(h,l,n){let r=!1;return{read:()=>{const i=l.read();return r?i:(r=!0,i!==null?n([h,i]):h)}}}e.prefixedReadable=I;function g(h,l,n){let r=!1;const i=S(n);return y(l,{onData:s=>r?i.write(s):(r=!0,i.write(n([h,s]))),onError:s=>i.error(s),onEnd:()=>{r||(r=!0,i.write(h)),i.end()}}),i}e.prefixedStream=g}),define(Y[17],X([0,1,55]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let D,R;class M{constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}static alloc(f){return t?new M(Buffer.allocUnsafe(f)):new M(new Uint8Array(f))}static wrap(f){return t&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new M(f)}static fromString(f,P){return!(P?.dontUseNodeBuffer||!1)&&t?new M(Buffer.from(f)):(D||(D=new TextEncoder),new M(D.encode(f)))}static fromByteArray(f){const P=M.alloc(f.length);for(let L=0,T=f.length;L<T;L++)P.buffer[L]=f[L];return P}static concat(f,P){if(typeof P=="undefined"){P=0;for(let W=0,$=f.length;W<$;W++)P+=f[W].byteLength}const L=M.alloc(P);let T=0;for(let W=0,$=f.length;W<$;W++){const te=f[W];L.set(te,T),T+=te.byteLength}return L}clone(){const f=M.alloc(this.byteLength);return f.set(this),f}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(f,P){return new M(this.buffer.subarray(f,P))}set(f,P){if(f instanceof M)this.buffer.set(f.buffer,P);else if(f instanceof Uint8Array)this.buffer.set(f,P);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),P);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return p(this.buffer,f)}writeUInt32BE(f,P){C(this.buffer,f,P)}readUInt32LE(f){return k(this.buffer,f)}writeUInt32LE(f,P){y(this.buffer,f,P)}readUInt8(f){return m(this.buffer,f)}writeUInt8(f,P){u(this.buffer,f,P)}}e.VSBuffer=M;function S(c,f){return c[f+0]<<0>>>0|c[f+1]<<8>>>0}e.readUInt16LE=S;function d(c,f,P){c[P+0]=f&255,f=f>>>8,c[P+1]=f&255}e.writeUInt16LE=d;function p(c,f){return c[f]*2**24+c[f+1]*2**16+c[f+2]*2**8+c[f+3]}e.readUInt32BE=p;function C(c,f,P){c[P+3]=f,f=f>>>8,c[P+2]=f,f=f>>>8,c[P+1]=f,f=f>>>8,c[P]=f}e.writeUInt32BE=C;function k(c,f){return c[f+0]<<0>>>0|c[f+1]<<8>>>0|c[f+2]<<16>>>0|c[f+3]<<24>>>0}e.readUInt32LE=k;function y(c,f,P){c[P+0]=f&255,f=f>>>8,c[P+1]=f&255,f=f>>>8,c[P+2]=f&255,f=f>>>8,c[P+3]=f&255}e.writeUInt32LE=y;function m(c,f){return c[f]}e.readUInt8=m;function u(c,f,P){c[P]=f}e.writeUInt8=u;function b(c){return v.consumeReadable(c,f=>M.concat(f))}e.readableToBuffer=b;function w(c){return v.toReadable(c)}e.bufferToReadable=w;function E(c){return v.consumeStream(c,f=>M.concat(f))}e.streamToBuffer=E;async function I(c){return c.ended?M.concat(c.buffer):M.concat([...c.buffer,await E(c.stream)])}e.bufferedStreamToBuffer=I;function g(c){return v.toStream(c,f=>M.concat(f))}e.bufferToStream=g;function h(c){return v.transform(c,{data:f=>typeof f=="string"?M.fromString(f):M.wrap(f)},f=>M.concat(f))}e.streamToBufferReadableStream=h;function l(c){return v.newWriteableStream(f=>M.concat(f),c)}e.newWriteableBufferStream=l;function n(c,f){return v.prefixedReadable(c,f,P=>M.concat(P))}e.prefixedBufferReadable=n;function r(c,f){return v.prefixedStream(c,f,P=>M.concat(P))}e.prefixedBufferStream=r;function i(c){let f=0,P=0,L=0;const T=new Uint8Array(Math.floor(c.length/4*3)),W=te=>{switch(P){case 3:T[L++]=f|te,P=0;break;case 2:T[L++]=f|te>>>2,f=te<<6,P=3;break;case 1:T[L++]=f|te>>>4,f=te<<4,P=2;break;default:f=te<<2,P=1}};for(let te=0;te<c.length;te++){const re=c.charCodeAt(te);if(re>=65&&re<=90)W(re-65);else if(re>=97&&re<=122)W(re-97+26);else if(re>=48&&re<=57)W(re-48+52);else if(re===43||re===45)W(62);else if(re===47||re===95)W(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${c[te]}`)}}const $=L;for(;P>0;)W(0);return M.wrap(T).slice(0,$)}e.decodeBase64=i;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:c},f=!0,P=!1){const L=P?o:s;let T="";const W=c.byteLength%3;let $=0;for(;$<c.byteLength-W;$+=3){const te=c[$+0],re=c[$+1],ie=c[$+2];T+=L[te>>>2],T+=L[(te<<4|re>>>4)&63],T+=L[(re<<2|ie>>>6)&63],T+=L[ie&63]}if(W===1){const te=c[$+0];T+=L[te>>>2],T+=L[te<<4&63],f&&(T+="==")}else if(W===2){const te=c[$+0],re=c[$+1];T+=L[te>>>2],T+=L[(te<<4|re>>>4)&63],T+=L[re<<2&63],f&&(T+="=")}return T}e.encodeBase64=a}),define(Y[13],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(c){return Array.isArray(c)}e.isArray=v;function t(c){return typeof c=="string"}e.isString=t;function D(c){return Array.isArray(c)&&c.every(f=>t(f))}e.isStringArray=D;function R(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=R;function M(c){const f=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof f}e.isTypedArray=M;function S(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=S;function d(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=d;function p(c){return c===!0||c===!1}e.isBoolean=p;function C(c){return typeof c=="undefined"}e.isUndefined=C;function k(c){return!y(c)}e.isDefined=k;function y(c){return C(c)||c===null}e.isUndefinedOrNull=y;function m(c,f){if(!c)throw new Error(f?`Unexpected type, expected '${f}'`:"Unexpected type")}e.assertType=m;function u(c){if(y(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=u;function b(...c){const f=[];for(let P=0;P<c.length;P++){const L=c[P];if(y(L))throw new Error(`Assertion Failed: argument at index ${P} is undefined or null`);f.push(L)}return f}e.assertAllDefined=b;const w=Object.prototype.hasOwnProperty;function E(c){if(!R(c))return!1;for(const f in c)if(w.call(c,f))return!1;return!0}e.isEmptyObject=E;function I(c){return typeof c=="function"}e.isFunction=I;function g(...c){return c.length>0&&c.every(I)}e.areFunctions=g;function h(c,f){const P=Math.min(c.length,f.length);for(let L=0;L<P;L++)l(c[L],f[L])}e.validateConstraints=h;function l(c,f){if(t(f)){if(typeof c!==f)throw new Error(`argument does not match constraint: typeof ${f}`)}else if(I(f)){try{if(c instanceof f)return}catch{}if(!y(c)&&c.constructor===f||f.length===1&&f.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function n(c){let f=[],P=Object.getPrototypeOf(c);for(;Object.prototype!==P;)f=f.concat(Object.getOwnPropertyNames(P)),P=Object.getPrototypeOf(P);return f}e.getAllPropertyNames=n;function r(c){const f=[];for(const P of n(c))typeof c[P]=="function"&&f.push(P);return f}e.getAllMethodNames=r;function i(c,f){const P=T=>function(){const W=Array.prototype.slice.call(arguments,0);return f(T,W)},L={};for(const T of c)L[T]=P(T);return L}e.createProxyObject=i;function s(c){return c===null?void 0:c}e.withNullAsUndefined=s;function o(c){return typeof c=="undefined"?null:c}e.withUndefinedAsNull=o;function a(c,f="Unreachable"){throw new Error(f)}e.assertNever=a}),define(Y[50],X([0,1,13]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const b=Array.isArray(u)?[]:{};return Object.keys(u).forEach(w=>{u[w]&&typeof u[w]=="object"?b[w]=t(u[w]):b[w]=u[w]}),b}e.deepClone=t;function D(u){if(!u||typeof u!="object")return u;const b=[u];for(;b.length>0;){const w=b.shift();Object.freeze(w);for(const E in w)if(R.call(w,E)){const I=w[E];typeof I=="object"&&!Object.isFrozen(I)&&!(0,v.isTypedArray)(I)&&b.push(I)}}return u}e.deepFreeze=D;const R=Object.prototype.hasOwnProperty;function M(u,b){return S(u,b,new Set)}e.cloneAndChange=M;function S(u,b,w){if((0,v.isUndefinedOrNull)(u))return u;const E=b(u);if(typeof E!="undefined")return E;if((0,v.isArray)(u)){const I=[];for(const g of u)I.push(S(g,b,w));return I}if((0,v.isObject)(u)){if(w.has(u))throw new Error("Cannot clone recursive data-structure");w.add(u);const I={};for(const g in u)R.call(u,g)&&(I[g]=S(u[g],b,w));return w.delete(u),I}return u}function d(u,b,w=!0){return(0,v.isObject)(u)?((0,v.isObject)(b)&&Object.keys(b).forEach(E=>{E in u?w&&((0,v.isObject)(u[E])&&(0,v.isObject)(b[E])?d(u[E],b[E],w):u[E]=b[E]):u[E]=b[E]}),u):b}e.mixin=d;function p(u,b){if(u===b)return!0;if(u==null||b===null||b===void 0||typeof u!=typeof b||typeof u!="object"||Array.isArray(u)!==Array.isArray(b))return!1;let w,E;if(Array.isArray(u)){if(u.length!==b.length)return!1;for(w=0;w<u.length;w++)if(!p(u[w],b[w]))return!1}else{const I=[];for(E in u)I.push(E);I.sort();const g=[];for(E in b)g.push(E);if(g.sort(),!p(I,g))return!1;for(w=0;w<I.length;w++)if(!p(u[I[w]],b[I[w]]))return!1}return!0}e.equals=p;function C(u){const b=new Set;return JSON.stringify(u,(w,E)=>{if((0,v.isObject)(E)||Array.isArray(E)){if(b.has(E))return"[Circular]";b.add(E)}return E})}e.safeStringify=C;function k(u,b){const w=Object.create(null);return!u||!b||Object.keys(b).forEach(I=>{const g=u[I],h=b[I];p(g,h)||(w[I]=h)}),w}e.distinct=k;function y(u,b){const w=b.toLowerCase(),E=Object.keys(u).find(I=>I.toLowerCase()===w);return E?u[E]:u[b]}e.getCaseInsensitive=y;function m(u,b){const w=Object.create(null);for(const[E,I]of Object.entries(u))b(E,I)&&(w[E]=I);return w}e.filter=m}),define(Y[30],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return v.test(D)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(S){for(let d=0;d<S.length;d++)S[d]=Math.floor(Math.random()*256);return S};const R=new Uint8Array(16),M=[];for(let S=0;S<256;S++)M.push(S.toString(16).padStart(2,"0"));return function(){D(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let d=0,p="";return p+=M[R[d++]],p+=M[R[d++]],p+=M[R[d++]],p+=M[R[d++]],p+="-",p+=M[R[d++]],p+=M[R[d++]],p+="-",p+=M[R[d++]],p+=M[R[d++]],p+="-",p+=M[R[d++]],p+=M[R[d++]],p+="-",p+=M[R[d++]],p+=M[R[d++]],p+=M[R[d++]],p+=M[R[d++]],p+=M[R[d++]],p+=M[R[d++]],p}}()}),define(Y[123],X([0,1,75,27,48]),function(z,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(M,S){if(await new Promise((C,k)=>{const y=t.createReadStream(M),m=v.createHash("sha1");y.pipe(m);const u=(0,D.once)((b,w)=>{y.removeAllListeners(),m.removeAllListeners(),b?k(b):C(w)});y.once("error",u),y.once("end",u),m.once("error",u),m.once("data",b=>u(void 0,b.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.checksum=R}),define(Y[124],X([0,1,125]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(R="utf8"){this.stringDecoder=new v.StringDecoder(R),this.remaining=null}write(R){const M=[],S=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(S.length<1)return M;let d=0,p,C=d;for(;C<S.length;)if(p=S.charCodeAt(C),p===13||p===10){if(M.push(S.substring(d,C)),C++,C<S.length){const k=p;p=S.charCodeAt(C),(k===13&&p===10||k===10&&p===13)&&C++}d=C}else C++;return this.remaining=d<S.length?S.substr(d):null,M}end(){return this.remaining}}e.LineDecoder=t}),define(Y[126],X([0,1,28]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(M){const S=M.replace(/\-/g,":").toLowerCase();return!t.has(S)}function R(){const M=(0,v.networkInterfaces)();for(const S in M){const d=M[S];if(d){for(const{mac:p}of d)if(D(p))return p}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(Y[90],X([0,1,76]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(S,d,p,C=1){let k=!1;return new Promise(y=>{const m=setTimeout(()=>{if(!k)return k=!0,y(0)},p);D(S,d,C,u=>{if(!k)return k=!0,clearTimeout(m),y(u)})})}e.findFreePort=t;function D(S,d,p,C){if(d===0)return C(0);const k=new v.Socket;k.once("connect",()=>(M(k),D(S+p,d-1,p,C))),k.once("data",()=>{}),k.once("error",y=>(M(k),y.code!=="ECONNREFUSED"?D(S+p,d-1,p,C):C(S))),k.connect(S,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(S,d,p){let C=!1,k,y=1;const m=v.createServer({pauseOnConnect:!0});function u(b,w){C||(C=!0,m.removeAllListeners(),m.close(),k&&clearTimeout(k),w(b))}return new Promise(b=>{k=setTimeout(()=>{u(0,b)},p),m.on("listening",()=>{u(S,b)}),m.on("error",w=>{w&&(w.code==="EADDRINUSE"||w.code==="EACCES")&&y<d?(S++,y++,m.listen(S,"127.0.0.1")):u(0,b)}),m.on("close",()=>{u(0,b)}),m.listen(S,"127.0.0.1")})}e.findFreePortFaster=R;function M(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(d){console.error(d)}}}),define(Y[127],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Y[128],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(D,R){this.sender=D,this.onMessage=R}send(D){try{this.sender.send("vscode:message",D.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(Y[38],X([0,1,14,19]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class D{constructor(){this.mapListenerToWrapper=new WeakMap}on(M,S){const d=(p,...C)=>{this.validateEvent(M,p)&&S(p,...C)};return this.mapListenerToWrapper.set(S,d),v.ipcMain.on(M,d),this}once(M,S){return v.ipcMain.once(M,(d,...p)=>{this.validateEvent(M,d)&&S(d,...p)}),this}handle(M,S){return v.ipcMain.handle(M,(d,...p)=>this.validateEvent(M,d)?S(d,...p):Promise.reject(`Invalid channel '${M}' or sender for ipcMain.handle() usage.`)),this}removeHandler(M){return v.ipcMain.removeHandler(M),this}removeListener(M,S){const d=this.mapListenerToWrapper.get(S);return d&&(v.ipcMain.removeListener(M,d),this.mapListenerToWrapper.delete(S)),this}validateEvent(M,S){if(!M||!M.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because the channel is unknown.`),!1;const d=S.senderFrame,p=d.url;if(!p)return!0;let C="unknown";try{C=new URL(p).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a malformed URL '${p}'.`),!1}return C!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a bad origin of '${C}'.`),!1):d.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because sender of origin '${C}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new D}),define(Y[129],X([0,1,14,38,13,127]),function(z,e,v,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(d,p,C,k,y)=>{const m=S(d,k,C);m.popup({window:(0,D.withNullAsUndefined)(v.BrowserWindow.fromWebContents(d.sender)),x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{m&&d.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,p)}})})}e.registerContextMenuListener=M;function S(d,p,C){const k=new v.Menu;return C.forEach(y=>{let m;y.type==="separator"?m=new v.MenuItem({type:y.type}):Array.isArray(y.submenu)?m=new v.MenuItem({submenu:S(d,p,y.submenu),label:y.label}):m=new v.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(u,b,w)=>d.sender.send(p,y.id,w)}),k.append(m)}),k}}),define(Y[130],X([11,10]),function(z,e){return z.create("vs/base/common/date",e)}),define(Y[131],X([0,1,130]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,D=t*60,R=D*24,M=R*7,S=R*30,d=R*365;function p(k,y,m){typeof k!="number"&&(k=k.getTime());const u=Math.round((new Date().getTime()-k)/1e3);if(u<-30)return(0,v.localize)(0,null,p(new Date().getTime()+u*1e3,!1));if(u<30)return(0,v.localize)(1,null);let b;return u<t?(b=u,y?b===1?m?(0,v.localize)(2,null,b):(0,v.localize)(3,null,b):m?(0,v.localize)(4,null,b):(0,v.localize)(5,null,b):b===1?m?(0,v.localize)(6,null,b):(0,v.localize)(7,null,b):m?(0,v.localize)(8,null,b):(0,v.localize)(9,null,b)):u<D?(b=Math.floor(u/t),y?b===1?m?(0,v.localize)(10,null,b):(0,v.localize)(11,null,b):m?(0,v.localize)(12,null,b):(0,v.localize)(13,null,b):b===1?m?(0,v.localize)(14,null,b):(0,v.localize)(15,null,b):m?(0,v.localize)(16,null,b):(0,v.localize)(17,null,b)):u<R?(b=Math.floor(u/D),y?b===1?m?(0,v.localize)(18,null,b):(0,v.localize)(19,null,b):m?(0,v.localize)(20,null,b):(0,v.localize)(21,null,b):b===1?m?(0,v.localize)(22,null,b):(0,v.localize)(23,null,b):m?(0,v.localize)(24,null,b):(0,v.localize)(25,null,b)):u<M?(b=Math.floor(u/R),y?b===1?(0,v.localize)(26,null,b):(0,v.localize)(27,null,b):b===1?(0,v.localize)(28,null,b):(0,v.localize)(29,null,b)):u<S?(b=Math.floor(u/M),y?b===1?m?(0,v.localize)(30,null,b):(0,v.localize)(31,null,b):m?(0,v.localize)(32,null,b):(0,v.localize)(33,null,b):b===1?m?(0,v.localize)(34,null,b):(0,v.localize)(35,null,b):m?(0,v.localize)(36,null,b):(0,v.localize)(37,null,b)):u<d?(b=Math.floor(u/S),y?b===1?m?(0,v.localize)(38,null,b):(0,v.localize)(39,null,b):m?(0,v.localize)(40,null,b):(0,v.localize)(41,null,b):b===1?m?(0,v.localize)(42,null,b):(0,v.localize)(43,null,b):m?(0,v.localize)(44,null,b):(0,v.localize)(45,null,b)):(b=Math.floor(u/d),y?b===1?m?(0,v.localize)(46,null,b):(0,v.localize)(47,null,b):m?(0,v.localize)(48,null,b):(0,v.localize)(49,null,b):b===1?m?(0,v.localize)(50,null,b):(0,v.localize)(51,null,b):m?(0,v.localize)(52,null,b):(0,v.localize)(53,null,b))}e.fromNow=p;function C(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(Y[132],X([11,10]),function(z,e){return z.create("vs/base/common/errorMessage",e)}),define(Y[41],X([0,1,25,13,132]),function(z,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(k,y){return y&&(k.stack||k.stacktrace)?D.localize(0,null,S(k),M(k.stack)||M(k.stacktrace)):S(k)}function M(k){return Array.isArray(k)?k.join(`
`):k}function S(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?D.localize(1,null,k.message):k.message||D.localize(2,null)}function d(k=null,y=!1){if(!k)return D.localize(3,null);if(Array.isArray(k)){const m=v.coalesce(k),u=d(m[0],y);return m.length>1?D.localize(4,null,u,m.length):u}if(t.isString(k))return k;if(k.detail){const m=k.detail;if(m.error)return R(m.error,y);if(m.exception)return R(m.exception,y)}return k.stack?R(k,y):k.message?k.message:D.localize(5,null)}e.toErrorMessage=d;function p(k){const y=k;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=p;function C(k,y){let m;return typeof k=="string"?m=new Error(k):m=k,m.actions=y,m}e.createErrorWithActions=C}),define(Y[133],X([11,10]),function(z,e){return z.create("vs/base/common/platform",e)}),define(Y[4],X([0,1,133]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let D=!1,R=!1,M=!1,S=!1,d=!1,p=!1,C=!1,k=!1,y=!1,m,u=t,b,w;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let E;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?E=e.globals.vscode.process:typeof process!="undefined"&&(E=process);const I=typeof E?.versions?.electron=="string",g=I&&E?.type==="renderer";if(typeof navigator=="object"&&!g)w=navigator.userAgent,D=w.indexOf("Windows")>=0,R=w.indexOf("Macintosh")>=0,k=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=w.indexOf("Linux")>=0,p=!0,m=v.getConfiguredDefaultLocale(v.localize(0,null))||t,u=m;else if(typeof E=="object"){D=E.platform==="win32",R=E.platform==="darwin",M=E.platform==="linux",S=M&&!!E.env.SNAP&&!!E.env.SNAP_REVISION,C=I,y=!!E.env.CI||!!E.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t,u=t;const c=E.env.VSCODE_NLS_CONFIG;if(c)try{const f=JSON.parse(c),P=f.availableLanguages["*"];m=f.locale,u=P||t,b=f._translationsConfigFile}catch{}d=!0}else console.error("Unable to resolve platform.");var h;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function l(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let n=0;R?n=1:D?n=3:M&&(n=2),e.isWindows=D,e.isMacintosh=R,e.isLinux=M,e.isLinuxSnap=S,e.isNative=d,e.isElectron=C,e.isWeb=p,e.isWebWorker=p&&typeof e.globals.importScripts=="function",e.isIOS=k,e.isCI=y,e.platform=n,e.userAgent=w,e.language=u;var r;(function(c){function f(){return e.language}c.value=f;function P(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}c.isDefaultVariant=P;function L(){return e.language==="en"}c.isDefault=L})(r=e.Language||(e.Language={})),e.locale=m,e.translationsConfigFile=b,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const c=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let L=0,T=c.length;L<T;L++){const W=c[L];if(W.id===P.data.vscodeScheduleAsyncWork){c.splice(L,1),W.callback();return}}});let f=0;return P=>{const L=++f;c.push({id:L,callback:P}),e.globals.postMessage({vscodeScheduleAsyncWork:L},"*")}}return c=>setTimeout(c)})();var i;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||k?2:D?1:3;let s=!0,o=!1;function a(){if(!o){o=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,s=new Uint16Array(c.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Y[36],X([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const D=v.globals.vscode.process;t={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Y[9],X([0,1,36]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,D=97,R=90,M=122,S=46,d=47,p=92,C=58,k=63;class y extends Error{constructor(h,l,n){let r;typeof l=="string"&&l.indexOf("not ")===0?(r="must not be",l=l.replace(/^not /,"")):r="must be";const i=h.indexOf(".")!==-1?"property":"argument";let s=`The "${h}" ${i} ${r} of type ${l}`;s+=`. Received type ${typeof n}`;super(s);this.code="ERR_INVALID_ARG_TYPE"}}function m(g,h){if(typeof g!="string")throw new y(h,"string",g)}function u(g){return g===d||g===p}function b(g){return g===d}function w(g){return g>=t&&g<=R||g>=D&&g<=M}function E(g,h,l,n){let r="",i=0,s=-1,o=0,a=0;for(let c=0;c<=g.length;++c){if(c<g.length)a=g.charCodeAt(c);else{if(n(a))break;a=d}if(n(a)){if(!(s===c-1||o===1))if(o===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==S||r.charCodeAt(r.length-2)!==S){if(r.length>2){const f=r.lastIndexOf(l);f===-1?(r="",i=0):(r=r.slice(0,f),i=r.length-1-r.lastIndexOf(l)),s=c,o=0;continue}else if(r.length!==0){r="",i=0,s=c,o=0;continue}}h&&(r+=r.length>0?`${l}..`:"..",i=2)}else r.length>0?r+=`${l}${g.slice(s+1,c)}`:r=g.slice(s+1,c),i=c-s-1;s=c,o=0}else a===S&&o!==-1?++o:o=-1}return r}function I(g,h){if(h===null||typeof h!="object")throw new y("pathObject","Object",h);const l=h.dir||h.root,n=h.base||`${h.name||""}${h.ext||""}`;return l?l===h.root?`${l}${n}`:`${l}${g}${n}`:n}e.win32={resolve(...g){let h="",l="",n=!1;for(let r=g.length-1;r>=-1;r--){let i;if(r>=0){if(i=g[r],m(i,"path"),i.length===0)continue}else h.length===0?i=v.cwd():(i=v.env[`=${h}`]||v.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==h.toLowerCase()&&i.charCodeAt(2)===p)&&(i=`${h}\\`));const s=i.length;let o=0,a="",c=!1;const f=i.charCodeAt(0);if(s===1)u(f)&&(o=1,c=!0);else if(u(f))if(c=!0,u(i.charCodeAt(1))){let P=2,L=P;for(;P<s&&!u(i.charCodeAt(P));)P++;if(P<s&&P!==L){const T=i.slice(L,P);for(L=P;P<s&&u(i.charCodeAt(P));)P++;if(P<s&&P!==L){for(L=P;P<s&&!u(i.charCodeAt(P));)P++;(P===s||P!==L)&&(a=`\\\\${T}\\${i.slice(L,P)}`,o=P)}}}else o=1;else w(f)&&i.charCodeAt(1)===C&&(a=i.slice(0,2),o=2,s>2&&u(i.charCodeAt(2))&&(c=!0,o=3));if(a.length>0)if(h.length>0){if(a.toLowerCase()!==h.toLowerCase())continue}else h=a;if(n){if(h.length>0)break}else if(l=`${i.slice(o)}\\${l}`,n=c,c&&h.length>0)break}return l=E(l,!n,"\\",u),n?`${h}\\${l}`:`${h}${l}`||"."},normalize(g){m(g,"path");const h=g.length;if(h===0)return".";let l=0,n,r=!1;const i=g.charCodeAt(0);if(h===1)return b(i)?"\\":g;if(u(i))if(r=!0,u(g.charCodeAt(1))){let o=2,a=o;for(;o<h&&!u(g.charCodeAt(o));)o++;if(o<h&&o!==a){const c=g.slice(a,o);for(a=o;o<h&&u(g.charCodeAt(o));)o++;if(o<h&&o!==a){for(a=o;o<h&&!u(g.charCodeAt(o));)o++;if(o===h)return`\\\\${c}\\${g.slice(a)}\\`;o!==a&&(n=`\\\\${c}\\${g.slice(a,o)}`,l=o)}}}else l=1;else w(i)&&g.charCodeAt(1)===C&&(n=g.slice(0,2),l=2,h>2&&u(g.charCodeAt(2))&&(r=!0,l=3));let s=l<h?E(g.slice(l),!r,"\\",u):"";return s.length===0&&!r&&(s="."),s.length>0&&u(g.charCodeAt(h-1))&&(s+="\\"),n===void 0?r?`\\${s}`:s:r?`${n}\\${s}`:`${n}${s}`},isAbsolute(g){m(g,"path");const h=g.length;if(h===0)return!1;const l=g.charCodeAt(0);return u(l)||h>2&&w(l)&&g.charCodeAt(1)===C&&u(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let h,l;for(let i=0;i<g.length;++i){const s=g[i];m(s,"path"),s.length>0&&(h===void 0?h=l=s:h+=`\\${s}`)}if(h===void 0)return".";let n=!0,r=0;if(typeof l=="string"&&u(l.charCodeAt(0))){++r;const i=l.length;i>1&&u(l.charCodeAt(1))&&(++r,i>2&&(u(l.charCodeAt(2))?++r:n=!1))}if(n){for(;r<h.length&&u(h.charCodeAt(r));)r++;r>=2&&(h=`\\${h.slice(r)}`)}return e.win32.normalize(h)},relative(g,h){if(m(g,"from"),m(h,"to"),g===h)return"";const l=e.win32.resolve(g),n=e.win32.resolve(h);if(l===n||(g=l.toLowerCase(),h=n.toLowerCase(),g===h))return"";let r=0;for(;r<g.length&&g.charCodeAt(r)===p;)r++;let i=g.length;for(;i-1>r&&g.charCodeAt(i-1)===p;)i--;const s=i-r;let o=0;for(;o<h.length&&h.charCodeAt(o)===p;)o++;let a=h.length;for(;a-1>o&&h.charCodeAt(a-1)===p;)a--;const c=a-o,f=s<c?s:c;let P=-1,L=0;for(;L<f;L++){const W=g.charCodeAt(r+L);if(W!==h.charCodeAt(o+L))break;W===p&&(P=L)}if(L!==f){if(P===-1)return n}else{if(c>f){if(h.charCodeAt(o+L)===p)return n.slice(o+L+1);if(L===2)return n.slice(o+L)}s>f&&(g.charCodeAt(r+L)===p?P=L:L===2&&(P=3)),P===-1&&(P=0)}let T="";for(L=r+P+1;L<=i;++L)(L===i||g.charCodeAt(L)===p)&&(T+=T.length===0?"..":"\\..");return o+=P,T.length>0?`${T}${n.slice(o,a)}`:(n.charCodeAt(o)===p&&++o,n.slice(o,a))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const h=e.win32.resolve(g);if(h.length<=2)return g;if(h.charCodeAt(0)===p){if(h.charCodeAt(1)===p){const l=h.charCodeAt(2);if(l!==k&&l!==S)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(w(h.charCodeAt(0))&&h.charCodeAt(1)===C&&h.charCodeAt(2)===p)return`\\\\?\\${h}`;return g},dirname(g){m(g,"path");const h=g.length;if(h===0)return".";let l=-1,n=0;const r=g.charCodeAt(0);if(h===1)return u(r)?g:".";if(u(r)){if(l=n=1,u(g.charCodeAt(1))){let o=2,a=o;for(;o<h&&!u(g.charCodeAt(o));)o++;if(o<h&&o!==a){for(a=o;o<h&&u(g.charCodeAt(o));)o++;if(o<h&&o!==a){for(a=o;o<h&&!u(g.charCodeAt(o));)o++;if(o===h)return g;o!==a&&(l=n=o+1)}}}}else w(r)&&g.charCodeAt(1)===C&&(l=h>2&&u(g.charCodeAt(2))?3:2,n=l);let i=-1,s=!0;for(let o=h-1;o>=n;--o)if(u(g.charCodeAt(o))){if(!s){i=o;break}}else s=!1;if(i===-1){if(l===-1)return".";i=l}return g.slice(0,i)},basename(g,h){h!==void 0&&m(h,"ext"),m(g,"path");let l=0,n=-1,r=!0,i;if(g.length>=2&&w(g.charCodeAt(0))&&g.charCodeAt(1)===C&&(l=2),h!==void 0&&h.length>0&&h.length<=g.length){if(h===g)return"";let s=h.length-1,o=-1;for(i=g.length-1;i>=l;--i){const a=g.charCodeAt(i);if(u(a)){if(!r){l=i+1;break}}else o===-1&&(r=!1,o=i+1),s>=0&&(a===h.charCodeAt(s)?--s==-1&&(n=i):(s=-1,n=o))}return l===n?n=o:n===-1&&(n=g.length),g.slice(l,n)}for(i=g.length-1;i>=l;--i)if(u(g.charCodeAt(i))){if(!r){l=i+1;break}}else n===-1&&(r=!1,n=i+1);return n===-1?"":g.slice(l,n)},extname(g){m(g,"path");let h=0,l=-1,n=0,r=-1,i=!0,s=0;g.length>=2&&g.charCodeAt(1)===C&&w(g.charCodeAt(0))&&(h=n=2);for(let o=g.length-1;o>=h;--o){const a=g.charCodeAt(o);if(u(a)){if(!i){n=o+1;break}continue}r===-1&&(i=!1,r=o+1),a===S?l===-1?l=o:s!==1&&(s=1):l!==-1&&(s=-1)}return l===-1||r===-1||s===0||s===1&&l===r-1&&l===n+1?"":g.slice(l,r)},format:I.bind(null,"\\"),parse(g){m(g,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return h;const l=g.length;let n=0,r=g.charCodeAt(0);if(l===1)return u(r)?(h.root=h.dir=g,h):(h.base=h.name=g,h);if(u(r)){if(n=1,u(g.charCodeAt(1))){let P=2,L=P;for(;P<l&&!u(g.charCodeAt(P));)P++;if(P<l&&P!==L){for(L=P;P<l&&u(g.charCodeAt(P));)P++;if(P<l&&P!==L){for(L=P;P<l&&!u(g.charCodeAt(P));)P++;P===l?n=P:P!==L&&(n=P+1)}}}}else if(w(r)&&g.charCodeAt(1)===C){if(l<=2)return h.root=h.dir=g,h;if(n=2,u(g.charCodeAt(2))){if(l===3)return h.root=h.dir=g,h;n=3}}n>0&&(h.root=g.slice(0,n));let i=-1,s=n,o=-1,a=!0,c=g.length-1,f=0;for(;c>=n;--c){if(r=g.charCodeAt(c),u(r)){if(!a){s=c+1;break}continue}o===-1&&(a=!1,o=c+1),r===S?i===-1?i=c:f!==1&&(f=1):i!==-1&&(f=-1)}return o!==-1&&(i===-1||f===0||f===1&&i===o-1&&i===s+1?h.base=h.name=g.slice(s,o):(h.name=g.slice(s,i),h.base=g.slice(s,o),h.ext=g.slice(i,o))),s>0&&s!==n?h.dir=g.slice(0,s-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let h="",l=!1;for(let n=g.length-1;n>=-1&&!l;n--){const r=n>=0?g[n]:v.cwd();m(r,"path"),r.length!==0&&(h=`${r}/${h}`,l=r.charCodeAt(0)===d)}return h=E(h,!l,"/",b),l?`/${h}`:h.length>0?h:"."},normalize(g){if(m(g,"path"),g.length===0)return".";const h=g.charCodeAt(0)===d,l=g.charCodeAt(g.length-1)===d;return g=E(g,!h,"/",b),g.length===0?h?"/":l?"./":".":(l&&(g+="/"),h?`/${g}`:g)},isAbsolute(g){return m(g,"path"),g.length>0&&g.charCodeAt(0)===d},join(...g){if(g.length===0)return".";let h;for(let l=0;l<g.length;++l){const n=g[l];m(n,"path"),n.length>0&&(h===void 0?h=n:h+=`/${n}`)}return h===void 0?".":e.posix.normalize(h)},relative(g,h){if(m(g,"from"),m(h,"to"),g===h||(g=e.posix.resolve(g),h=e.posix.resolve(h),g===h))return"";const l=1,n=g.length,r=n-l,i=1,s=h.length-i,o=r<s?r:s;let a=-1,c=0;for(;c<o;c++){const P=g.charCodeAt(l+c);if(P!==h.charCodeAt(i+c))break;P===d&&(a=c)}if(c===o)if(s>o){if(h.charCodeAt(i+c)===d)return h.slice(i+c+1);if(c===0)return h.slice(i+c)}else r>o&&(g.charCodeAt(l+c)===d?a=c:c===0&&(a=0));let f="";for(c=l+a+1;c<=n;++c)(c===n||g.charCodeAt(c)===d)&&(f+=f.length===0?"..":"/..");return`${f}${h.slice(i+a)}`},toNamespacedPath(g){return g},dirname(g){if(m(g,"path"),g.length===0)return".";const h=g.charCodeAt(0)===d;let l=-1,n=!0;for(let r=g.length-1;r>=1;--r)if(g.charCodeAt(r)===d){if(!n){l=r;break}}else n=!1;return l===-1?h?"/":".":h&&l===1?"//":g.slice(0,l)},basename(g,h){h!==void 0&&m(h,"ext"),m(g,"path");let l=0,n=-1,r=!0,i;if(h!==void 0&&h.length>0&&h.length<=g.length){if(h===g)return"";let s=h.length-1,o=-1;for(i=g.length-1;i>=0;--i){const a=g.charCodeAt(i);if(a===d){if(!r){l=i+1;break}}else o===-1&&(r=!1,o=i+1),s>=0&&(a===h.charCodeAt(s)?--s==-1&&(n=i):(s=-1,n=o))}return l===n?n=o:n===-1&&(n=g.length),g.slice(l,n)}for(i=g.length-1;i>=0;--i)if(g.charCodeAt(i)===d){if(!r){l=i+1;break}}else n===-1&&(r=!1,n=i+1);return n===-1?"":g.slice(l,n)},extname(g){m(g,"path");let h=-1,l=0,n=-1,r=!0,i=0;for(let s=g.length-1;s>=0;--s){const o=g.charCodeAt(s);if(o===d){if(!r){l=s+1;break}continue}n===-1&&(r=!1,n=s+1),o===S?h===-1?h=s:i!==1&&(i=1):h!==-1&&(i=-1)}return h===-1||n===-1||i===0||i===1&&h===n-1&&h===l+1?"":g.slice(h,n)},format:I.bind(null,"/"),parse(g){m(g,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return h;const l=g.charCodeAt(0)===d;let n;l?(h.root="/",n=1):n=0;let r=-1,i=0,s=-1,o=!0,a=g.length-1,c=0;for(;a>=n;--a){const f=g.charCodeAt(a);if(f===d){if(!o){i=a+1;break}continue}s===-1&&(o=!1,s=a+1),f===S?r===-1?r=a:c!==1&&(c=1):r!==-1&&(c=-1)}if(s!==-1){const f=i===0&&l?1:i;r===-1||c===0||c===1&&r===s-1&&r===i+1?h.base=h.name=g.slice(f,s):(h.name=g.slice(f,r),h.base=g.slice(f,s),h.ext=g.slice(r,s))}return i>0?h.dir=g.slice(0,i-1):l&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Y[77],X([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var D;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(S,...d){const p=d.reduce((y,m)=>(y[m]=!0,y),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(y=>!p[y]).forEach(y=>{for(let m=0;m<C.length;m++)if(y.search(C[m])!==-1){delete S[y];break}})}e.sanitizeProcessEnvironment=R;function M(S){!S||(delete S.DEBUG,v.isMacintosh&&delete S.DYLD_LIBRARY_PATH,v.isLinux&&delete S.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(Y[78],X([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=v.globals.performance&&typeof v.globals.performance.now=="function";class D{constructor(M){this._highResolution=t&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new D(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=D}),define(Y[3],X([0,1,19,48,2,121,78]),function(z,e,v,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const S=!1,d=!1;var p;(function(a){a.None=()=>D.Disposable.None;function c(F){if(d){const{onListenerDidAdd:N}=F,j=u.create();let J=0;F.onListenerDidAdd=()=>{++J==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),j.print()),N?.()}}}function f(F){return(N,j=null,J)=>{let U=!1,K;return K=F(Z=>{if(!U)return K?K.dispose():U=!0,N.call(j,Z)},null,J),U&&K.dispose(),K}}a.once=f;function P(F,N,j){return re((J,U=null,K)=>F(Z=>J.call(U,N(Z)),null,K),j)}a.map=P;function L(F,N,j){return re((J,U=null,K)=>F(Z=>{N(Z),J.call(U,Z)},null,K),j)}a.forEach=L;function T(F,N,j){return re((J,U=null,K)=>F(Z=>N(Z)&&J.call(U,Z),null,K),j)}a.filter=T;function W(F){return F}a.signal=W;function $(...F){return(N,j=null,J)=>(0,D.combinedDisposable)(...F.map(U=>U(K=>N.call(j,K),null,J)))}a.any=$;function te(F,N,j,J){let U=j;return P(F,K=>(U=N(U,K),U),J)}a.reduce=te;function re(F,N){let j;const J={onFirstListenerAdd(){j=F(U.fire,U)},onLastListenerRemove(){j?.dispose()}};N||c(J);const U=new w(J);return N?.add(U),U.event}function ie(F,N,j=100,J=!1,U,K){let Z,ae,le,ge=0;const be={leakWarningThreshold:U,onFirstListenerAdd(){Z=F(Ce=>{ge++,ae=N(ae,Ce),J&&!le&&(Le.fire(ae),ae=void 0),clearTimeout(le),le=setTimeout(()=>{const ke=ae;ae=void 0,le=void 0,(!J||ge>1)&&Le.fire(ke),ge=0},j)})},onLastListenerRemove(){Z.dispose()}};K||c(be);const Le=new w(be);return K?.add(Le),Le.event}a.debounce=ie;function se(F,N=(J,U)=>J===U,j){let J=!0,U;return T(F,K=>{const Z=J||!N(K,U);return J=!1,U=K,Z},j)}a.latch=se;function ce(F,N,j){return[a.filter(F,N,j),a.filter(F,J=>!N(J),j)]}a.split=ce;function q(F,N=!1,j=[]){let J=j.slice(),U=F(ae=>{J?J.push(ae):Z.fire(ae)});const K=()=>{J?.forEach(ae=>Z.fire(ae)),J=null},Z=new w({onFirstListenerAdd(){U||(U=F(ae=>Z.fire(ae)))},onFirstListenerDidAdd(){J&&(N?setTimeout(K):K())},onLastListenerRemove(){U&&U.dispose(),U=null}});return Z.event}a.buffer=q;class ne{constructor(N){this.event=N,this.disposables=new D.DisposableStore}map(N){return new ne(P(this.event,N,this.disposables))}forEach(N){return new ne(L(this.event,N,this.disposables))}filter(N){return new ne(T(this.event,N,this.disposables))}reduce(N,j){return new ne(te(this.event,N,j,this.disposables))}latch(){return new ne(se(this.event,void 0,this.disposables))}debounce(N,j=100,J=!1,U){return new ne(ie(this.event,N,j,J,U,this.disposables))}on(N,j,J){return this.event(N,j,J)}once(N,j,J){return f(this.event)(N,j,J)}dispose(){this.disposables.dispose()}}function O(F){return new ne(F)}a.chain=O;function _(F,N,j=J=>J){const J=(...ae)=>Z.fire(j(...ae)),U=()=>F.on(N,J),K=()=>F.removeListener(N,J),Z=new w({onFirstListenerAdd:U,onLastListenerRemove:K});return Z.event}a.fromNodeEventEmitter=_;function B(F,N,j=J=>J){const J=(...ae)=>Z.fire(j(...ae)),U=()=>F.addEventListener(N,J),K=()=>F.removeEventListener(N,J),Z=new w({onFirstListenerAdd:U,onLastListenerRemove:K});return Z.event}a.fromDOMEventEmitter=B;function Q(F){return new Promise(N=>f(F)(N))}a.toPromise=Q;function H(F,N){return N(void 0),F(j=>N(j))}a.runAndSubscribe=H;function G(F,N){let j=null;function J(K){j?.dispose(),j=new D.DisposableStore,N(K,j)}J(void 0);const U=F(K=>J(K));return(0,D.toDisposable)(()=>{U.dispose(),j?.dispose()})}a.runAndSubscribeWithStore=G;class x{constructor(N,j){this.obs=N,this._counter=0,this._hasChanged=!1;const J={onFirstListenerAdd:()=>{N.addObserver(this)},onLastListenerRemove:()=>{N.removeObserver(this)}};j||c(J),this.emitter=new w(J),j&&j.add(this.emitter)}beginUpdate(N){this._counter++}handleChange(N,j){this._hasChanged=!0}endUpdate(N){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function A(F,N){return new x(F,N).emitter.event}a.fromObservable=A})(p=e.Event||(e.Event={}));class C{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${C._idPool++}`}start(c){this._stopWatch=new M.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}C._idPool=0;let k=-1;function y(a){const c=k;return k=a,{dispose(){k=c}}}e.setGlobalLeakWarningThreshold=y;class m{constructor(c,f=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c,f){let P=k;if(typeof this.customThreshold=="number"&&(P=this.customThreshold),P<=0||f<P)return;this._stacks||(this._stacks=new Map);const L=this._stacks.get(c.value)||0;if(this._stacks.set(c.value,L+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=P*.5;let T,W=0;for(const[$,te]of this._stacks)(!T||W<te)&&(T=$,W=te);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${W}):`),console.warn(T)}return()=>{const T=this._stacks.get(c.value)||0;this._stacks.set(c.value,T-1)}}}class u{constructor(c){this.value=c}static create(){return new u(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(c,f,P){this.callback=c,this.callbackThis=f,this.stack=P,this.subscription=new D.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class w{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=k>0?new m(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(S){const c=Array.from(this._listeners);queueMicrotask(()=>{for(const f of c)f.subscription.isset()&&(f.subscription.unset(),f.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(c,f,P)=>{this._listeners||(this._listeners=new R.LinkedList);const L=this._listeners.isEmpty();L&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let T,W;this._leakageMon&&this._listeners.size>=30&&(W=u.create(),T=this._leakageMon.check(W,this._listeners.size+1)),S&&(W=W??u.create());const $=new b(c,f,W),te=this._listeners.push($);L&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,f);const re=$.subscription.set(()=>{T?.(),this._disposed||(te(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return P instanceof D.DisposableStore?P.add(re):Array.isArray(P)&&P.push(re),re}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new I);for(const f of this._listeners)this._deliveryQueue.push(this,f,c);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=w;class E{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(c,f,P){this._queue.push(new g(c,f,P))}clear(c){const f=new R.LinkedList;for(const P of this._queue)P.emitter!==c&&f.push(P);this._queue=f}deliver(){for(;this._queue.size>0;){const c=this._queue.shift();try{c.listener.invoke(c.event)}catch(f){(0,v.onUnexpectedError)(f)}}}}e.EventDeliveryQueue=E;class I extends E{clear(c){this._queue.clear()}}class g{constructor(c,f,P){this.emitter=c,this.listener=f,this.event=P}}class h extends w{async fireAsync(c,f,P){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const L of this._listeners)this._asyncDeliveryQueue.push([L,c]);for(;this._asyncDeliveryQueue.size>0&&!f.isCancellationRequested;){const[L,T]=this._asyncDeliveryQueue.shift(),W=[],$={...T,token:f,waitUntil:te=>{if(Object.isFrozen(W))throw new Error("waitUntil can NOT be called asynchronous");P&&(te=P(te,L.callback)),W.push(te)}};try{L.invoke($)}catch(te){(0,v.onUnexpectedError)(te);continue}Object.freeze(W),await Promise.allSettled(W).then(te=>{for(const re of te)re.status==="rejected"&&(0,v.onUnexpectedError)(re.reason)})}}}}e.AsyncEmitter=h;class l extends w{constructor(c){super(c);this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=l;class n extends l{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=n;class r extends w{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(f=>super.fire(f)),this._queuedEvents=[]})}}e.MicrotaskEmitter=r;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const f={event:c,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const P=()=>{this.hasListeners&&this.unhook(f);const L=this.events.indexOf(f);this.events.splice(L,1)};return(0,D.toDisposable)((0,t.once)(P))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(f=>this.emitter.fire(f))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class s{constructor(){this.buffers=[]}wrapEvent(c){return(f,P,L)=>c(T=>{const W=this.buffers[this.buffers.length-1];W?W.push(()=>f.call(P,T)):f.call(P,T)},void 0,L)}bufferEvents(c){const f=[];this.buffers.push(f);const P=c();return this.buffers.pop(),f.forEach(L=>L()),P}}e.EventBufferer=s;class o{constructor(){this.listening=!1,this.inputEvent=p.None,this.inputEventListener=D.Disposable.None,this.emitter=new w({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(Y[21],X([0,1,3]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(S,d){const p=setTimeout(S.bind(d),0);return{dispose(){clearTimeout(p)}}});var D;(function(S){function d(p){return p===S.None||p===S.Cancelled||p instanceof R?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}S.isCancellationToken=d,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(D=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=D.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=M}),define(Y[134],X([0,1,21]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(S){this.task=S,this.result=null}get(){if(this.result)return this.result;const S=new v.CancellationTokenSource,d=this.task(S.token);return this.result={promise:d,dispose:()=>{this.result=null,S.cancel(),S.dispose()}},this.result}}e.Cache=t;class D{constructor(S){this.fn=S,this.lastCache=void 0,this.lastArgKey=void 0}get(S){const d=JSON.stringify(S);return this.lastArgKey!==d&&(this.lastArgKey=d,this.lastCache=this.fn(S)),this.lastCache}}e.LRUCachedFunction=D;class R{constructor(S){this.fn=S,this._map=new Map}get cachedValues(){return this._map}get(S){if(this._map.has(S))return this._map.get(S);const d=this.fn(S);return this._map.set(S,d),d}}e.CachedFunction=R}),define(Y[91],X([0,1,3,2]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const D=M=>({onDidChange:v.Event.None,value:M});e.staticObservableValue=D;class R extends t.Disposable{constructor(S){super();this._value=S,this.changeEmitter=this._register(new v.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(S){S!==this._value&&(this._value=S,this.changeEmitter.fire(S))}}e.MutableObservableValue=R}),define(Y[31],X([0,1,134,120]),function(z,e,v,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(V){return!V||typeof V!="string"?!0:V.trim().length===0}e.isFalsyOrWhitespace=R;const M=/{(\d+)}/g;function S(V,...oe){return oe.length===0?V:V.replace(M,function(he,me){const Ee=parseInt(me,10);return isNaN(Ee)||Ee<0||Ee>=oe.length?he:oe[Ee]})}e.format=S;const d=/{([^}]+)}/g;function p(V,oe){return V.replace(d,(he,me)=>oe[me]??he)}e.format2=p;function C(V){return V.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=C;function k(V){return V.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function y(V,oe){let he=0;const me=oe.charCodeAt(0);for(let Ee=V.length-1;Ee>=0;Ee--)V.charCodeAt(Ee)===me&&he++;return he}e.count=y;function m(V,oe,he="\u2026"){return V.length<=oe?V:`${V.substr(0,oe)}${he}`}e.truncate=m;function u(V,oe=" "){const he=b(V,oe);return w(he,oe)}e.trim=u;function b(V,oe){if(!V||!oe)return V;const he=oe.length;if(he===0||V.length===0)return V;let me=0;for(;V.indexOf(oe,me)===me;)me=me+he;return V.substring(me)}e.ltrim=b;function w(V,oe){if(!V||!oe)return V;const he=oe.length,me=V.length;if(he===0||me===0)return V;let Ee=me,Re=-1;for(;Re=V.lastIndexOf(oe,Ee-1),!(Re===-1||Re+he!==Ee);){if(Re===0)return"";Ee=Re}return V.substring(0,Ee)}e.rtrim=w;function E(V){return V.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=E;function I(V){return V.replace(/\*/g,"")}e.stripWildcards=I;function g(V,oe,he={}){if(!V)throw new Error("Cannot create regex from empty string");oe||(V=k(V)),he.wholeWord&&(/\B/.test(V.charAt(0))||(V="\\b"+V),/\B/.test(V.charAt(V.length-1))||(V=V+"\\b"));let me="";return he.global&&(me+="g"),he.matchCase||(me+="i"),he.multiline&&(me+="m"),he.unicode&&(me+="u"),new RegExp(V,me)}e.createRegExp=g;function h(V){return V.source==="^"||V.source==="^$"||V.source==="$"||V.source==="^\\s*$"?!1:!!(V.exec("")&&V.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function l(V){return!!V.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function n(V){return(V.global?"g":"")+(V.ignoreCase?"i":"")+(V.multiline?"m":"")+(V.unicode?"u":"")}e.regExpFlags=n;function r(V){return V.split(/\r\n|\r|\n/)}e.splitLines=r;function i(V){for(let oe=0,he=V.length;oe<he;oe++){const me=V.charCodeAt(oe);if(me!==32&&me!==9)return oe}return-1}e.firstNonWhitespaceIndex=i;function s(V,oe=0,he=V.length){for(let me=oe;me<he;me++){const Ee=V.charCodeAt(me);if(Ee!==32&&Ee!==9)return V.substring(oe,me)}return V.substring(oe,he)}e.getLeadingWhitespace=s;function o(V,oe=V.length-1){for(let he=oe;he>=0;he--){const me=V.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.lastNonWhitespaceIndex=o;function a(V,oe,he){const me=[];let Ee=0;for(const Re of V.matchAll(oe)){if(me.push(V.slice(Ee,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Ee=Re.index+Re[0].length,me.push(he(Re[0],...Re.slice(1),Re.index,V,Re.groups))}return me.push(V.slice(Ee)),Promise.all(me).then(Re=>Re.join(""))}e.replaceAsync=a;function c(V,oe){return V<oe?-1:V>oe?1:0}e.compare=c;function f(V,oe,he=0,me=V.length,Ee=0,Re=oe.length){for(;he<me&&Ee<Re;he++,Ee++){const et=V.charCodeAt(he),He=oe.charCodeAt(Ee);if(et<He)return-1;if(et>He)return 1}const qe=me-he,nt=Re-Ee;return qe<nt?-1:qe>nt?1:0}e.compareSubstring=f;function P(V,oe){return L(V,oe,0,V.length,0,oe.length)}e.compareIgnoreCase=P;function L(V,oe,he=0,me=V.length,Ee=0,Re=oe.length){for(;he<me&&Ee<Re;he++,Ee++){let et=V.charCodeAt(he),He=oe.charCodeAt(Ee);if(et===He)continue;if(et>=128||He>=128)return f(V.toLowerCase(),oe.toLowerCase(),he,me,Ee,Re);W(et)&&(et-=32),W(He)&&(He-=32);const Je=et-He;if(Je!==0)return Je}const qe=me-he,nt=Re-Ee;return qe<nt?-1:qe>nt?1:0}e.compareSubstringIgnoreCase=L;function T(V){return V>=48&&V<=57}e.isAsciiDigit=T;function W(V){return V>=97&&V<=122}e.isLowerAsciiLetter=W;function $(V){return V>=65&&V<=90}e.isUpperAsciiLetter=$;function te(V,oe){return V.length===oe.length&&L(V,oe)===0}e.equalsIgnoreCase=te;function re(V,oe){const he=oe.length;return oe.length>V.length?!1:L(V,oe,0,he)===0}e.startsWithIgnoreCase=re;function ie(V,oe){const he=Math.min(V.length,oe.length);let me;for(me=0;me<he;me++)if(V.charCodeAt(me)!==oe.charCodeAt(me))return me;return he}e.commonPrefixLength=ie;function se(V,oe){const he=Math.min(V.length,oe.length);let me;const Ee=V.length-1,Re=oe.length-1;for(me=0;me<he;me++)if(V.charCodeAt(Ee-me)!==oe.charCodeAt(Re-me))return me;return he}e.commonSuffixLength=se;function ce(V){return 55296<=V&&V<=56319}e.isHighSurrogate=ce;function q(V){return 56320<=V&&V<=57343}e.isLowSurrogate=q;function ne(V,oe){return(V-55296<<10)+(oe-56320)+65536}e.computeCodePoint=ne;function O(V,oe,he){const me=V.charCodeAt(he);if(ce(me)&&he+1<oe){const Ee=V.charCodeAt(he+1);if(q(Ee))return ne(me,Ee)}return me}e.getNextCodePoint=O;function _(V,oe){const he=V.charCodeAt(oe-1);if(q(he)&&oe>1){const me=V.charCodeAt(oe-2);if(ce(me))return ne(me,he)}return he}class B{constructor(oe,he=0){this._str=oe,this._len=oe.length,this._offset=he}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=_(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=O(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=B;class Q{constructor(oe,he=0){this._iterator=new B(oe,he)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=Te.getInstance(),he=this._iterator,me=he.offset;let Ee=oe.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const Re=he.offset,qe=oe.getGraphemeBreakType(he.nextCodePoint());if(De(Ee,qe)){he.setOffset(Re);break}Ee=qe}return he.offset-me}prevGraphemeLength(){const oe=Te.getInstance(),he=this._iterator,me=he.offset;let Ee=oe.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const Re=he.offset,qe=oe.getGraphemeBreakType(he.prevCodePoint());if(De(qe,Ee)){he.setOffset(Re);break}Ee=qe}return me-he.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Q;function H(V,oe){return new Q(V,oe).nextGraphemeLength()}e.nextCharLength=H;function G(V,oe){return new Q(V,oe).prevGraphemeLength()}e.prevCharLength=G;function x(V,oe){oe>0&&q(V.charCodeAt(oe))&&oe--;const he=oe+H(V,oe);return[he-G(V,he),he]}e.getCharContainingOffset=x;const A=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function F(V){return A.test(V)}e.containsRTL=F;const N=/^[\t\n\r\x20-\x7E]*$/;function j(V){return N.test(V)}e.isBasicASCII=j,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function J(V){return e.UNUSUAL_LINE_TERMINATORS.test(V)}e.containsUnusualLineTerminators=J;function U(V){return V>=11904&&V<=55215||V>=63744&&V<=64255||V>=65281&&V<=65374}e.isFullWidthCharacter=U;function K(V){return V>=127462&&V<=127487||V===8986||V===8987||V===9200||V===9203||V>=9728&&V<=10175||V===11088||V===11093||V>=127744&&V<=128591||V>=128640&&V<=128764||V>=128992&&V<=129008||V>=129280&&V<=129535||V>=129648&&V<=129782}e.isEmojiImprecise=K;function Z(V,oe){if(V.length<oe)return V;const he=/\b/g;let me=0;for(;he.test(V)&&!(V.length-he.lastIndex<oe);)me=he.lastIndex,he.lastIndex+=1;return V.substring(me).replace(/^\s/,"")}e.lcut=Z;const ae=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,ge=/\x1b\[0?m/g;function be(V){return V&&(V=V.replace(ae,""),V=V.replace(le,""),V=V.replace(ge,"")),V}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(V){return!!(V&&V.length>0&&V.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function Ce(V){return Le(V)?V.substr(1):V}e.stripUTF8BOM=Ce;function ke(V,oe){if(!V||!oe||V.length<oe.length)return!1;const he=oe.length,me=V.toLowerCase();let Ee=0,Re=-1;for(;Ee<he;){const qe=me.indexOf(oe[Ee],Re+1);if(qe<0)return!1;Re=qe,Ee++}return!0}e.fuzzyContains=ke;function Ae(V,oe=!1){return V?(oe&&(V=V.replace(/\\./g,"")),V.toLowerCase()!==V):!1}e.containsUppercaseCharacter=Ae;function ue(V){return V.charAt(0).toUpperCase()+V.slice(1)}e.uppercaseFirstLetter=ue;function de(V,oe=1){if(oe===0)return"";let he=-1;do he=V.indexOf(`
`,he+1),oe--;while(oe>0&&he>=0);return he===-1?V:(V[he-1]==="\r"&&he--,V.substr(0,he))}e.getNLines=de;function pe(V){const oe=90-65+1;return V=V%(2*oe),V<oe?String.fromCharCode(97+V):String.fromCharCode(65+V-oe)}e.singleLetterHash=pe;function Ie(V){return Te.getInstance().getGraphemeBreakType(V)}e.getGraphemeBreakType=Ie;function De(V,oe){return V===0?oe!==5&&oe!==7:V===2&&oe===3?!1:V===4||V===2||V===3||oe===4||oe===2||oe===3?!0:!(V===8&&(oe===8||oe===9||oe===11||oe===12)||(V===11||V===9)&&(oe===9||oe===10)||(V===12||V===10)&&oe===10||oe===5||oe===13||oe===7||V===1||V===13&&oe===14||V===6&&oe===6)}var Xe;(function(V){V[V.Other=0]="Other",V[V.Prepend=1]="Prepend",V[V.CR=2]="CR",V[V.LF=3]="LF",V[V.Control=4]="Control",V[V.Extend=5]="Extend",V[V.Regional_Indicator=6]="Regional_Indicator",V[V.SpacingMark=7]="SpacingMark",V[V.L=8]="L",V[V.V=9]="V",V[V.T=10]="T",V[V.LV=11]="LV",V[V.LVT=12]="LVT",V[V.ZWJ=13]="ZWJ",V[V.Extended_Pictographic=14]="Extended_Pictographic"})(Xe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Te{constructor(){this._data=Be()}static getInstance(){return Te._INSTANCE||(Te._INSTANCE=new Te),Te._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const he=this._data,me=he.length/3;let Ee=1;for(;Ee<=me;)if(oe<he[3*Ee])Ee=2*Ee;else if(oe>he[3*Ee+1])Ee=2*Ee+1;else return he[3*Ee+2];return 0}}Te._INSTANCE=null;function Be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(V,oe){if(V===0)return 0;const he=Ye(V,oe);if(he!==void 0)return he;const me=new B(oe,V);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=We;function Ye(V,oe){const he=new B(oe,V);let me=he.prevCodePoint();for(;Qe(me)||me===65039||me===8419;){if(he.offset===0)return;me=he.prevCodePoint()}if(!K(me))return;let Ee=he.offset;return Ee>0&&he.prevCodePoint()===8205&&(Ee=he.offset),Ee}function Qe(V){return 127995<=V&&V<=127999}var Ze;(function(V){V[V.zwj=8205]="zwj",V[V.emojiVariantSelector=65039]="emojiVariantSelector",V[V.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={})),e.noBreakWhitespace="\xA0";class $e{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return $e.cache.get(Array.from(oe))}static getLocales(){return $e._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=$e,D=$e,$e.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),$e.cache=new v.LRUCachedFunction(V=>{function oe(He){const Je=new Map;for(let xe=0;xe<He.length;xe+=2)Je.set(He[xe],He[xe+1]);return Je}function he(He,Je){const xe=new Map(He);for(const[ct,lt]of Je)xe.set(ct,lt);return xe}function me(He,Je){if(!He)return Je;const xe=new Map;for(const[ct,lt]of He)Je.has(ct)&&xe.set(ct,lt);return xe}const Ee=D.ambiguousCharacterData.getValue();let Re=V.filter(He=>!He.startsWith("_")&&He in Ee);Re.length===0&&(Re=["_default"]);let qe;for(const He of Re){const Je=oe(Ee[He]);qe=me(qe,Je)}const nt=oe(Ee._common),et=he(nt,qe);return new $e(et)}),$e._locales=new t.Lazy(()=>Object.keys($e.ambiguousCharacterData.getValue()).filter(V=>!V.startsWith("_")));class je{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(je.getRawData())),this._data}static isInvisibleCharacter(oe){return je.getData().has(oe)}static get codePoints(){return je.getData()}}e.InvisibleCharacters=je,je._data=void 0}),define(Y[29],X([0,1,9,4,31,13]),function(z,e,v,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(o){return o===47||o===92}e.isPathSeparator=M;function S(o){return o.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=S;function d(o){return o.indexOf("/")===-1&&(o=S(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=d;function p(o,a=v.posix.sep){if(!o)return"";const c=o.length,f=o.charCodeAt(0);if(M(f)){if(M(o.charCodeAt(1))&&!M(o.charCodeAt(2))){let L=3;const T=L;for(;L<c&&!M(o.charCodeAt(L));L++);if(T!==L&&!M(o.charCodeAt(L+1))){for(L+=1;L<c;L++)if(M(o.charCodeAt(L)))return o.slice(0,L+1).replace(/[\\/]/g,a)}}return a}else if(E(f)&&o.charCodeAt(1)===58)return M(o.charCodeAt(2))?o.slice(0,2)+a:o.slice(0,2);let P=o.indexOf("://");if(P!==-1){for(P+=3;P<c;P++)if(M(o.charCodeAt(P)))return o.slice(0,P+1)}return""}e.getRoot=p;function C(o){if(!t.isWindows||!o||o.length<5)return!1;let a=o.charCodeAt(0);if(a!==92||(a=o.charCodeAt(1),a!==92))return!1;let c=2;const f=c;for(;c<o.length&&(a=o.charCodeAt(c),a!==92);c++);return!(f===c||(a=o.charCodeAt(c+1),isNaN(a)||a===92))}e.isUNC=C;const k=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(o,a=t.isWindows){const c=a?k:y;return!(!o||o.length===0||/^\s+$/.test(o)||(c.lastIndex=0,c.test(o))||a&&m.test(o)||o==="."||o===".."||a&&o[o.length-1]==="."||a&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=u;function b(o,a,c){const f=o===a;return!c||f?f:!o||!a?!1:(0,D.equalsIgnoreCase)(o,a)}e.isEqual=b;function w(o,a,c,f=v.sep){if(o===a)return!0;if(!o||!a||a.length>o.length)return!1;if(c){if(!(0,D.startsWithIgnoreCase)(o,a))return!1;if(a.length===o.length)return!0;let L=a.length;return a.charAt(a.length-1)===f&&L--,o.charAt(L)===f}return a.charAt(a.length-1)!==f&&(a+=f),o.indexOf(a)===0}e.isEqualOrParent=w;function E(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=E;function I(o,a){return t.isWindows&&o.endsWith(":")&&(o+=v.sep),(0,v.isAbsolute)(o)||(o=(0,v.join)(a,o)),o=(0,v.normalize)(o),t.isWindows?(o=(0,D.rtrim)(o,v.sep),o.endsWith(":")&&(o+=v.sep)):(o=(0,D.rtrim)(o,v.sep),o||(o=v.sep)),o}e.sanitizeFilePath=I;function g(o){const a=(0,v.normalize)(o);return t.isWindows?o.length>3?!1:h(a)&&(o.length===2||a.charCodeAt(2)===92):a===v.posix.sep}e.isRootOrDriveLetter=g;function h(o,a=t.isWindows){return a?E(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function l(o){return h(o)?o[0]:void 0}e.getDriveLetter=l;function n(o,a,c){return a.length>o.length?-1:o===a?0:(c&&(o=o.toLowerCase(),a=a.toLowerCase()),o.indexOf(a))}e.indexOfPath=n;function r(o){const a=o.split(":");let c,f,P;for(const L of a){const T=Number(L);(0,R.isNumber)(T)?f===void 0?f=T:P===void 0&&(P=T):c=c?[c,L].join(":"):L}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:f!==void 0?f:void 0,column:P!==void 0?P:f!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(o,a,c=8){let f="";for(let L=0;L<c;L++)f+=i.charAt(Math.floor(Math.random()*i.length));let P;return a?P=`${a}-${f}`:P=f,o?(0,v.join)(o,P):P}e.randomPath=s}),define(Y[65],X([0,1,31]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(E){return D(E,0)}e.hash=t;function D(E,I){switch(typeof E){case"object":return E===null?R(349,I):Array.isArray(E)?d(E,I):p(E,I);case"string":return S(E,I);case"boolean":return M(E,I);case"number":return R(E,I);case"undefined":return R(937,I);default:return R(617,I)}}e.doHash=D;function R(E,I){return(I<<5)-I+E|0}e.numberHash=R;function M(E,I){return R(E?433:863,I)}function S(E,I){I=R(149417,I);for(let g=0,h=E.length;g<h;g++)I=R(E.charCodeAt(g),I);return I}e.stringHash=S;function d(E,I){return I=R(104579,I),E.reduce((g,h)=>D(h,g),I)}function p(E,I){return I=R(181387,I),Object.keys(E).sort().reduce((g,h)=>(g=S(h,g),D(E[h],g)),I)}class C{constructor(){this._value=0}get value(){return this._value}hash(I){return this._value=D(I,this._value),this._value}}e.Hasher=C;var k;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function y(E,I,g=32){const h=g-I,l=~((1<<h)-1);return(E<<I|(l&E)>>>h)>>>0}function m(E,I=0,g=E.byteLength,h=0){for(let l=0;l<g;l++)E[I+l]=h}function u(E,I,g="0"){for(;E.length<I;)E=g+E;return E}function b(E,I=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(g=>g.toString(16).padStart(2,"0")).join(""):u((E>>>0).toString(16),I/4)}e.toHexString=b;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(I){const g=I.length;if(g===0)return;const h=this._buff;let l=this._buffLen,n=this._leftoverHighSurrogate,r,i;for(n!==0?(r=n,i=-1,n=0):(r=I.charCodeAt(0),i=0);;){let s=r;if(v.isHighSurrogate(r))if(i+1<g){const o=I.charCodeAt(i+1);v.isLowSurrogate(o)?(i++,s=v.computeCodePoint(r,o)):s=65533}else{n=r;break}else v.isLowSurrogate(r)&&(s=65533);if(l=this._push(h,l,s),i++,i<g)r=I.charCodeAt(i);else break}this._buffLen=l,this._leftoverHighSurrogate=n}_push(I,g,h){return h<128?I[g++]=h:h<2048?(I[g++]=192|(h&1984)>>>6,I[g++]=128|(h&63)>>>0):h<65536?(I[g++]=224|(h&61440)>>>12,I[g++]=128|(h&4032)>>>6,I[g++]=128|(h&63)>>>0):(I[g++]=240|(h&1835008)>>>18,I[g++]=128|(h&258048)>>>12,I[g++]=128|(h&4032)>>>6,I[g++]=128|(h&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,I[0]=I[64+0],I[1]=I[64+1],I[2]=I[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const I=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(I/4294967296),!1),this._buffDV.setUint32(60,I%4294967296,!1),this._step()}_step(){const I=w._bigBlock32,g=this._buffDV;for(let c=0;c<64;c+=4)I.setUint32(c,g.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)I.setUint32(c,y(I.getUint32(c-12,!1)^I.getUint32(c-32,!1)^I.getUint32(c-56,!1)^I.getUint32(c-64,!1),1),!1);let h=this._h0,l=this._h1,n=this._h2,r=this._h3,i=this._h4,s,o,a;for(let c=0;c<80;c++)c<20?(s=l&n|~l&r,o=1518500249):c<40?(s=l^n^r,o=1859775393):c<60?(s=l&n|l&r|n&r,o=2400959708):(s=l^n^r,o=3395469782),a=y(h,5)+s+i+o+I.getUint32(c*4,!1)&4294967295,i=r,r=n,n=y(l,30),l=h,h=a;this._h0=this._h0+h&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))});var At=this&&this.__classPrivateFieldSet||function(z,e,v,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?z!==e||!D:!e.has(z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(z,v):D?D.value=v:e.set(z,v),v},ot=this&&this.__classPrivateFieldGet||function(z,e,v,t){if(v==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?z!==e||!t:!e.has(z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?t:v==="a"?t.call(z):t?t.value:e.get(z)};define(Y[33],X([0,1,25,31]),function(z,e,v,t){"use strict";var D,R,M,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function d(o,a,c){let f=o.get(a);return f===void 0&&(f=c,o.set(a,f)),f}e.getOrSet=d;function p(o){const a=[];return o.forEach((c,f)=>{a.push(`${f} => ${c}`)}),`Map(${o.size}) {${a.join(", ")}}`}e.mapToString=p;function C(o){const a=[];return o.forEach(c=>{a.push(c)}),`Set(${o.size}) {${a.join(", ")}}`}e.setToString=C;class k{constructor(){this._value="",this._pos=0}reset(a){return this._value=a,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(a){const c=a.charCodeAt(0),f=this._value.charCodeAt(this._pos);return c-f}value(){return this._value[this._pos]}}e.StringIterator=k;class y{constructor(a=!0){this._caseSensitive=a}reset(a){return this._value=a,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(a)this._from++;else break;else a=!1;return this}cmp(a){return this._caseSensitive?(0,t.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class m{constructor(a=!0,c=!0){this._splitOnBackslash=a,this._caseSensitive=c}reset(a){this._from=0,this._to=0,this._value=a,this._valueLen=a.length;for(let c=a.length-1;c>=0;c--,this._valueLen--){const f=this._value.charCodeAt(c);if(!(f===47||this._splitOnBackslash&&f===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let a=!0;for(;this._to<this._valueLen;this._to++){const c=this._value.charCodeAt(this._to);if(c===47||this._splitOnBackslash&&c===92)if(a)this._from++;else break;else a=!1}return this}cmp(a){return this._caseSensitive?(0,t.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var u;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(u||(u={}));class b{constructor(a,c){this._ignorePathCasing=a,this._ignoreQueryAndFragment=c,this._states=[],this._stateIdx=0}reset(a){return this._value=a,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(a)),this._pathIterator.reset(a.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(a)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(a){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(a,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(a,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(a);if(this._states[this._stateIdx]===4)return(0,t.compare)(a,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(a,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=b;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(E||(E={}));class I{constructor(a){this._iter=a}static forUris(a=()=>!1,c=()=>!1){return new I(new b(a,c))}static forPaths(a=!1){return new I(new m(void 0,!a))}static forStrings(){return new I(new k)}static forConfigKeys(){return new I(new y)}clear(){this._root=void 0}fill(a,c){if(c){const f=c.slice(0);(0,v.shuffle)(f);for(const P of f)this.set(P,a)}else{const f=a.slice(0);(0,v.shuffle)(f);for(const P of f)this.set(P[0],P[1])}}set(a,c){const f=this._iter.reset(a);let P;this._root||(this._root=new w,this._root.segment=f.value());const L=[];for(P=this._root;;){const W=f.cmp(P.segment);if(W>0)P.left||(P.left=new w,P.left.segment=f.value()),L.push([-1,P]),P=P.left;else if(W<0)P.right||(P.right=new w,P.right.segment=f.value()),L.push([1,P]),P=P.right;else if(f.hasNext())f.next(),P.mid||(P.mid=new w,P.mid.segment=f.value()),L.push([0,P]),P=P.mid;else break}const T=P.value;P.value=c,P.key=a;for(let W=L.length-1;W>=0;W--){const $=L[W][1];$.updateHeight();const te=$.balanceFactor();if(te<-1||te>1){const re=L[W][0],ie=L[W+1][0];if(re===1&&ie===1)L[W][1]=$.rotateLeft();else if(re===-1&&ie===-1)L[W][1]=$.rotateRight();else if(re===1&&ie===-1)$.right=L[W+1][1]=L[W+1][1].rotateRight(),L[W][1]=$.rotateLeft();else if(re===-1&&ie===1)$.left=L[W+1][1]=L[W+1][1].rotateLeft(),L[W][1]=$.rotateRight();else throw new Error;if(W>0)switch(L[W-1][0]){case-1:L[W-1][1].left=L[W][1];break;case 1:L[W-1][1].right=L[W][1];break;case 0:L[W-1][1].mid=L[W][1];break}else this._root=L[0][1]}}return T}get(a){return this._getNode(a)?.value}_getNode(a){const c=this._iter.reset(a);let f=this._root;for(;f;){const P=c.cmp(f.segment);if(P>0)f=f.left;else if(P<0)f=f.right;else if(c.hasNext())c.next(),f=f.mid;else break}return f}has(a){const c=this._getNode(a);return!(c?.value===void 0&&c?.mid===void 0)}delete(a){return this._delete(a,!1)}deleteSuperstr(a){return this._delete(a,!0)}_delete(a,c){const f=this._iter.reset(a),P=[];let L=this._root;for(;L;){const T=f.cmp(L.segment);if(T>0)P.push([-1,L]),L=L.left;else if(T<0)P.push([1,L]),L=L.right;else if(f.hasNext())f.next(),P.push([0,L]),L=L.mid;else break}if(!!L){if(c?(L.left=void 0,L.mid=void 0,L.right=void 0,L.height=1):(L.key=void 0,L.value=void 0),!L.mid&&!L.value)if(L.left&&L.right){const T=this._min(L.right),{key:W,value:$,segment:te}=T;this._delete(T.key,!1),L.key=W,L.value=$,L.segment=te}else{const T=L.left??L.right;if(P.length>0){const[W,$]=P[P.length-1];switch(W){case-1:$.left=T;break;case 0:$.mid=T;break;case 1:$.right=T;break}}else this._root=T}for(let T=P.length-1;T>=0;T--){const W=P[T][1];W.updateHeight();const $=W.balanceFactor();if($>1?(W.right.balanceFactor()>=0||(W.right=W.right.rotateRight()),P[T][1]=W.rotateLeft()):$<-1&&(W.left.balanceFactor()<=0||(W.left=W.left.rotateLeft()),P[T][1]=W.rotateRight()),T>0)switch(P[T-1][0]){case-1:P[T-1][1].left=P[T][1];break;case 1:P[T-1][1].right=P[T][1];break;case 0:P[T-1][1].mid=P[T][1];break}else this._root=P[0][1]}}}_min(a){for(;a.left;)a=a.left;return a}findSubstr(a){const c=this._iter.reset(a);let f=this._root,P;for(;f;){const L=c.cmp(f.segment);if(L>0)f=f.left;else if(L<0)f=f.right;else if(c.hasNext())c.next(),P=f.value||P,f=f.mid;else break}return f&&f.value||P}findSuperstr(a){const c=this._iter.reset(a);let f=this._root;for(;f;){const P=c.cmp(f.segment);if(P>0)f=f.left;else if(P<0)f=f.right;else if(c.hasNext())c.next(),f=f.mid;else return f.mid?this._entries(f.mid):void 0}}forEach(a){for(const[c,f]of this)a(f,c)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(a){!a||(a.left&&(yield*this._entries(a.left)),a.value&&(yield[a.key,a.value]),a.mid&&(yield*this._entries(a.mid)),a.right&&(yield*this._entries(a.right)))}_isBalanced(){const a=c=>{if(!c)return!0;const f=c.balanceFactor();return f<-1||f>1?!1:a(c.left)&&a(c.right)};return a(this._root)}}e.TernarySearchTree=I;class g{constructor(a,c){this.uri=a,this.value=c}}class h{constructor(a,c){this[D]="ResourceMap",a instanceof h?(this.map=new Map(a.map),this.toKey=c??h.defaultToKey):(this.map=new Map,this.toKey=a??h.defaultToKey)}set(a,c){return this.map.set(this.toKey(a),new g(a,c)),this}get(a){return this.map.get(this.toKey(a))?.value}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,c){typeof c!="undefined"&&(a=a.bind(c));for(const[f,P]of this.map)a(P.value,P.uri,this)}*values(){for(const a of this.map.values())yield a.value}*keys(){for(const a of this.map.values())yield a.uri}*entries(){for(const a of this.map.values())yield[a.uri,a.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.map)yield[a.uri,a.value]}}e.ResourceMap=h,h.defaultToKey=o=>o.toString();class l{constructor(a,c){this[R]="ResourceSet",!a||typeof a=="function"?this._map=new h(a):(this._map=new h(c),a.forEach(this.add,this))}get size(){return this._map.size}add(a){return this._map.set(a,a),this}clear(){this._map.clear()}delete(a){return this._map.delete(a)}forEach(a,c){this._map.forEach((f,P)=>a.call(c,P,P,this))}has(a){return this._map.has(a)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=l;var n;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(n=e.Touch||(e.Touch={}));class r{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(a){return this._map.has(a)}get(a,c=0){const f=this._map.get(a);if(!!f)return c!==0&&this.touch(f,c),f.value}set(a,c,f=0){let P=this._map.get(a);if(P)P.value=c,f!==0&&this.touch(P,f);else{switch(P={key:a,value:c,next:void 0,previous:void 0},f){case 0:this.addItemLast(P);break;case 1:this.addItemFirst(P);break;case 2:this.addItemLast(P);break;default:this.addItemLast(P);break}this._map.set(a,P),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const c=this._map.get(a);if(!!c)return this._map.delete(a),this.removeItem(c),this._size--,c.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}forEach(a,c){const f=this._state;let P=this._head;for(;P;){if(c?a.bind(c)(P.value,P.key,this):a(P.value,P.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");P=P.next}}keys(){const a=this,c=this._state;let f=this._head;const P={[Symbol.iterator](){return P},next(){if(a._state!==c)throw new Error("LinkedMap got modified during iteration.");if(f){const L={value:f.key,done:!1};return f=f.next,L}else return{value:void 0,done:!0}}};return P}values(){const a=this,c=this._state;let f=this._head;const P={[Symbol.iterator](){return P},next(){if(a._state!==c)throw new Error("LinkedMap got modified during iteration.");if(f){const L={value:f.value,done:!1};return f=f.next,L}else return{value:void 0,done:!0}}};return P}entries(){const a=this,c=this._state;let f=this._head;const P={[Symbol.iterator](){return P},next(){if(a._state!==c)throw new Error("LinkedMap got modified during iteration.");if(f){const L={value:[f.key,f.value],done:!1};return f=f.next,L}else return{value:void 0,done:!0}}};return P}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(a){if(a>=this.size)return;if(a===0){this.clear();return}let c=this._head,f=this.size;for(;c&&f>a;)this._map.delete(c.key),c=c.next,f--;this._head=c,this._size=f,c&&(c.previous=void 0),this._state++}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const c=a.next,f=a.previous;if(!c||!f)throw new Error("Invalid list");c.previous=f,f.next=c}a.next=void 0,a.previous=void 0,this._state++}touch(a,c){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(a===this._head)return;const f=a.next,P=a.previous;a===this._tail?(P.next=void 0,this._tail=P):(f.previous=P,P.next=f),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(c===2){if(a===this._tail)return;const f=a.next,P=a.previous;a===this._head?(f.previous=void 0,this._head=f):(f.previous=P,P.next=f),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((c,f)=>{a.push([f,c])}),a}fromJSON(a){this.clear();for(const[c,f]of a)this.set(c,f)}}e.LinkedMap=r;class i extends r{constructor(a,c=1){super();this._limit=a,this._ratio=Math.min(Math.max(0,c),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,c=2){return super.get(a,c)}peek(a){return super.get(a,0)}set(a,c){return super.set(a,c,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class s{constructor(a){S.set(this,void 0),At(this,S,a,"f")}get size(){return ot(this,S,"f").size}forEach(a,c){ot(this,S,"f").forEach(a,c)}get(a){return ot(this,S,"f").get(a)}has(a){return ot(this,S,"f").has(a)}entries(){return ot(this,S,"f").entries()}keys(){return ot(this,S,"f").keys()}values(){return ot(this,S,"f").values()}[(S=new WeakMap,Symbol.iterator)](){return ot(this,S,"f").entries()}}e.ReadonlyMapView=s}),define(Y[79],X([0,1,33]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new v.LRUCache(1e4);function D(p){return d(p,"NFC",t)}e.normalizeNFC=D;const R=new v.LRUCache(1e4);function M(p){return d(p,"NFD",R)}e.normalizeNFD=M;const S=/[^\u0000-\u0080]/;function d(p,C,k){if(!p)return p;const y=k.get(p);if(y)return y;let m;return S.test(p)?m=p.normalize(C):m=p,k.set(p,m),m}e.removeAccents=function(){const p=/[\u0300-\u036f]/g;return function(C){return M(C).replace(p,"")}}()}),define(Y[7],X([0,1,9,4]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,R=/^\//,M=/^\/\//;function S(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!D.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(i,s){return!i&&!s?"file":i}function p(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==k&&(s=k+s):s=k;break}return s}const C="",k="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(s,o,a,c,f,P=!1){typeof s=="object"?(this.scheme=s.scheme||C,this.authority=s.authority||C,this.path=s.path||C,this.query=s.query||C,this.fragment=s.fragment||C):(this.scheme=d(s,P),this.authority=o||C,this.path=p(this.scheme,a||C),this.query=c||C,this.fragment=f||C,S(this,P))}static isUri(s){return s instanceof m?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return g(this,!1)}with(s){if(!s)return this;let{scheme:o,authority:a,path:c,query:f,fragment:P}=s;return o===void 0?o=this.scheme:o===null&&(o=C),a===void 0?a=this.authority:a===null&&(a=C),c===void 0?c=this.path:c===null&&(c=C),f===void 0?f=this.query:f===null&&(f=C),P===void 0?P=this.fragment:P===null&&(P=C),o===this.scheme&&a===this.authority&&c===this.path&&f===this.query&&P===this.fragment?this:new b(o,a,c,f,P)}static parse(s,o=!1){const a=y.exec(s);return a?new b(a[2]||C,r(a[4]||C),r(a[5]||C),r(a[7]||C),r(a[9]||C),o):new b(C,C,C,C,C)}static file(s){let o=C;if(t.isWindows&&(s=s.replace(/\\/g,k)),s[0]===k&&s[1]===k){const a=s.indexOf(k,2);a===-1?(o=s.substring(2),s=k):(o=s.substring(2,a),s=s.substring(a)||k)}return new b("file",o,s,C,C)}static from(s){const o=new b(s.scheme,s.authority,s.path,s.query,s.fragment);return S(o,!0),o}static joinPath(s,...o){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&s.scheme==="file"?a=m.file(v.win32.join(g(s,!0),...o)).path:a=v.posix.join(s.path,...o),s.with({path:a})}toString(s=!1){return h(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof m)return s;{const o=new b(s);return o._formatted=s.external,o._fsPath=s._sep===u?s.fsPath:null,o}}else return s}}e.URI=m;const u=t.isWindows?1:void 0;class b extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(s=!1){return s?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=u),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(i,s){let o,a=-1;for(let c=0;c<i.length;c++){const f=i.charCodeAt(c);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||s&&f===47)a!==-1&&(o+=encodeURIComponent(i.substring(a,c)),a=-1),o!==void 0&&(o+=i.charAt(c));else{o===void 0&&(o=i.substr(0,c));const P=w[f];P!==void 0?(a!==-1&&(o+=encodeURIComponent(i.substring(a,c)),a=-1),o+=P):a===-1&&(a=c)}}return a!==-1&&(o+=encodeURIComponent(i.substring(a))),o!==void 0?o:i}function I(i){let s;for(let o=0;o<i.length;o++){const a=i.charCodeAt(o);a===35||a===63?(s===void 0&&(s=i.substr(0,o)),s+=w[a]):s!==void 0&&(s+=i[o])}return s!==void 0?s:i}function g(i,s){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=g;function h(i,s){const o=s?I:E;let a="",{scheme:c,authority:f,path:P,query:L,fragment:T}=i;if(c&&(a+=c,a+=":"),(f||c==="file")&&(a+=k,a+=k),f){let W=f.indexOf("@");if(W!==-1){const $=f.substr(0,W);f=f.substr(W+1),W=$.indexOf(":"),W===-1?a+=o($,!1):(a+=o($.substr(0,W),!1),a+=":",a+=o($.substr(W+1),!1)),a+="@"}f=f.toLowerCase(),W=f.indexOf(":"),W===-1?a+=o(f,!1):(a+=o(f.substr(0,W),!1),a+=f.substr(W))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const W=P.charCodeAt(1);W>=65&&W<=90&&(P=`/${String.fromCharCode(W+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const W=P.charCodeAt(0);W>=65&&W<=90&&(P=`${String.fromCharCode(W+32)}:${P.substr(2)}`)}a+=o(P,!0)}return L&&(a+="?",a+=o(L,!1)),T&&(a+="#",a+=s?T:E(T,!1)),a}function l(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+l(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(n)?i.replace(n,s=>l(s)):i}}),define(Y[135],X([0,1,7]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(p){const C=p;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=t;function D(p){const C=[];let k;try{const y=JSON.parse(p.arguments),m=y[y.length-1];m&&m.__$stack&&(y.pop(),k=m.__$stack),C.push(...y)}catch{C.push("Unable to log remote console arguments",p.arguments)}return{args:C,stack:k}}e.parse=D;function R(p){if(typeof p!="string")return R(D(p).stack);const C=p;if(C){const k=M(C),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(y&&y.length===4)return{uri:v.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=R;function M(p){if(!p)return p;const C=p.indexOf(`
`);return C===-1?p:p.substring(0,C)}function S(p,C){const{args:k,stack:y}=D(p),m=typeof k[0]=="string"&&k.length===1;let u=M(y);u&&(u=`(${u.trim()})`);let b=[];if(typeof k[0]=="string"?u&&m?b=[`%c[${C}] %c${k[0]} %c${u}`,d("blue"),d(""),d("grey")]:b=[`%c[${C}] %c${k[0]}`,d("blue"),d(""),...k.slice(1)]:b=[`%c[${C}]%`,d("blue"),...k],u&&!m&&b.push(u),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,b)}e.log=S;function d(p){return`color: ${p}`}}),define(Y[66],X([0,1,17,31,7]),function(z,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(p){return JSON.stringify(p,S)}e.stringify=R;function M(p){let C=JSON.parse(p);return C=d(C),C}e.parse=M;function S(p,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,t.regExpFlags)(C)}:C}function d(p,C=0){if(!p||C>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return D.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 14:return new Date(p.source)}if(p instanceof v.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let k=0;k<p.length;++k)p[k]=d(p[k],C+1);else for(const k in p)Object.hasOwnProperty.call(p,k)&&(p[k]=d(p[k],C+1))}return p}e.revive=d}),define(Y[12],X([0,1,4,7]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(d){this._preferredWebSchema=d}setDelegate(d){this._delegate=d}setServerRootPath(d){this._remoteResourcesPath=`${d}/${D.vscodeRemoteResource}`}set(d,p,C){this._hosts[d]=p,this._ports[d]=C}setConnectionToken(d,p){this._connectionTokens[d]=p}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(d){if(this._delegate)return this._delegate(d);const p=d.authority;let C=this._hosts[p];C&&C.indexOf(":")!==-1&&(C=`[${C}]`);const k=this._ports[p],y=this._connectionTokens[p];let m=`path=${encodeURIComponent(d.path)}`;return typeof y=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),t.URI.from({scheme:v.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${C}:${k}`,path:this._remoteResourcesPath,query:m})}}e.RemoteAuthorities=new R;class M{asBrowserUri(d,p){const C=this.toUri(d,p);return C.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===D.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${D.vscodeFileResource}://${M.FALLBACK_AUTHORITY}`)?C.with({scheme:D.vscodeFileResource,authority:C.authority||M.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(d,p){const C=this.toUri(d,p);return C.scheme===D.vscodeFileResource?C.with({scheme:D.file,authority:C.authority!==M.FALLBACK_AUTHORITY?C.authority:null,query:null,fragment:null}):C}toUri(d,p){return t.URI.isUri(d)?d:t.URI.parse(p.toUrl(d))}}M.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new M}),define(Y[16],X([0,1,29,12,9,4,31,7]),function(z,e,v,t,D,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function d(m){return(0,S.uriToFsPath)(m,!0)}e.originalFSPath=d;class p{constructor(u){this._ignorePathCasing=u}compare(u,b,w=!1){return u===b?0:(0,M.compare)(this.getComparisonKey(u,w),this.getComparisonKey(b,w))}isEqual(u,b,w=!1){return u===b?!0:!u||!b?!1:this.getComparisonKey(u,w)===this.getComparisonKey(b,w)}getComparisonKey(u,b=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,b,w=!1){if(u.scheme===b.scheme){if(u.scheme===t.Schemas.file)return v.isEqualOrParent(d(u),d(b),this._ignorePathCasing(u))&&u.query===b.query&&(w||u.fragment===b.fragment);if((0,e.isEqualAuthority)(u.authority,b.authority))return v.isEqualOrParent(u.path,b.path,this._ignorePathCasing(u),"/")&&u.query===b.query&&(w||u.fragment===b.fragment)}return!1}joinPath(u,...b){return S.URI.joinPath(u,...b)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return D.posix.basename(u.path)}extname(u){return D.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let b;return u.scheme===t.Schemas.file?b=S.URI.file(D.dirname(d(u))).path:(b=D.posix.dirname(u.path),u.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),b="/")),u.with({path:b})}normalizePath(u){if(!u.path.length)return u;let b;return u.scheme===t.Schemas.file?b=S.URI.file(D.normalize(d(u))).path:b=D.posix.normalize(u.path),u.with({path:b})}relativePath(u,b){if(u.scheme!==b.scheme||!(0,e.isEqualAuthority)(u.authority,b.authority))return;if(u.scheme===t.Schemas.file){const I=D.relative(d(u),d(b));return R.isWindows?v.toSlashes(I):I}let w=u.path||"/";const E=b.path||"/";if(this._ignorePathCasing(u)){let I=0;for(const g=Math.min(w.length,E.length);I<g&&!(w.charCodeAt(I)!==E.charCodeAt(I)&&w.charAt(I).toLowerCase()!==E.charAt(I).toLowerCase());I++);w=E.substr(0,I)+w.substr(I)}return D.posix.relative(w,E)}resolvePath(u,b){if(u.scheme===t.Schemas.file){const w=S.URI.file(D.resolve(d(u),b));return u.with({authority:w.authority,path:w.path})}return b=v.toPosixPath(b),u.with({path:D.posix.resolve(u.path,b)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,b){return u===b||u!==void 0&&b!==void 0&&(0,M.equalsIgnoreCase)(u,b)}hasTrailingPathSeparator(u,b=D.sep){if(u.scheme===t.Schemas.file){const w=d(u);return w.length>v.getRoot(w).length&&w[w.length-1]===b}else{const w=u.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,b=D.sep){return(0,e.hasTrailingPathSeparator)(u,b)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,b=D.sep){let w=!1;if(u.scheme===t.Schemas.file){const E=d(u);w=E!==void 0&&E.length===v.getRoot(E).length&&E[E.length-1]===b}else{b="/";const E=u.path;w=E.length===1&&E.charCodeAt(E.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(u,b)?u.with({path:u.path+"/"}):u}}e.ExtUri=p,e.extUri=new p(()=>!1),e.extUriBiasedIgnorePathCase=new p(m=>m.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new p(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(m,u){const b=[];for(let w=0;w<m.length;w++){const E=u(m[w]);m.some((I,g)=>g===w?!1:(0,e.isEqualOrParent)(E,u(I)))||b.push(m[w])}return b}e.distinctParents=C;var k;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function u(b){const w=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(g=>{const[h,l]=g.split(":");h&&l&&w.set(h,l)});const I=b.path.substring(0,b.path.indexOf(";"));return I&&w.set(m.META_DATA_MIME,I),w}m.parseMetaData=u})(k=e.DataUri||(e.DataUri={}));function y(m,u,b){if(u){let w=m.path;return w&&w[0]!==D.posix.sep&&(w=D.posix.sep+w),m.with({scheme:b,authority:u,path:w})}return m.with({scheme:b})}e.toLocalResource=y}),define(Y[8],X([0,1,21,19,3,2,16,4]),function(z,e,v,t,D,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function d(x){return!!x&&typeof x.then=="function"}e.isThenable=d;function p(x){const A=new v.CancellationTokenSource,F=x(A.token),N=new Promise((j,J)=>{const U=A.token.onCancellationRequested(()=>{U.dispose(),A.dispose(),J(new t.CancellationError)});Promise.resolve(F).then(K=>{U.dispose(),A.dispose(),j(K)},K=>{U.dispose(),A.dispose(),J(K)})});return new class{cancel(){A.cancel()}then(j,J){return N.then(j,J)}catch(j){return this.then(void 0,j)}finally(j){return N.finally(j)}}}e.createCancelablePromise=p;function C(x,A,F){return new Promise((N,j)=>{const J=A.onCancellationRequested(()=>{J.dispose(),N(F)});x.then(N,j).finally(()=>J.dispose())})}e.raceCancellation=C;function k(x,A){return new Promise((F,N)=>{const j=A.onCancellationRequested(()=>{j.dispose(),N(new t.CancellationError)});x.then(F,N).finally(()=>j.dispose())})}e.raceCancellationError=k;async function y(x){let A=-1;const F=x.map((j,J)=>j.then(U=>(A=J,U))),N=await Promise.race(F);return x.forEach((j,J)=>{J!==A&&j.cancel()}),N}e.raceCancellablePromises=y;function m(x,A,F){let N;const j=setTimeout(()=>{N?.(void 0),F?.()},A);return Promise.race([x.finally(()=>clearTimeout(j)),new Promise(J=>N=J)])}e.raceTimeout=m;function u(x){return new Promise((A,F)=>{const N=x();d(N)?N.then(A,F):A(N)})}e.asPromise=u;class b{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(A){if(this.activePromise){if(this.queuedPromiseFactory=A,!this.queuedPromise){const F=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(F,F).then(N)})}return new Promise((F,N)=>{this.queuedPromise.then(F,N)})}return this.activePromise=A(),new Promise((F,N)=>{this.activePromise.then(j=>{this.activePromise=null,F(j)},j=>{this.activePromise=null,N(j)})})}}e.Throttler=b;class w{constructor(){this.current=Promise.resolve(null)}queue(A){return this.current=this.current.then(()=>A(),()=>A())}}e.Sequencer=w;class E{constructor(){this.promiseMap=new Map}queue(A,F){const j=(this.promiseMap.get(A)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.promiseMap.get(A)===j&&this.promiseMap.delete(A)});return this.promiseMap.set(A,j),j}}e.SequencerByKey=E;const I=(x,A)=>{let F=!0;const N=setTimeout(()=>{F=!1,A()},x);return{isTriggered:()=>F,dispose:()=>{clearTimeout(N),F=!1}}},g=x=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,x())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(A){this.defaultDelay=A,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(A,F=this.defaultDelay){this.task=A,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,J)=>{this.doResolve=j,this.doReject=J}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}}));const N=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=F===e.MicrotaskDelay?g(N):I(F,N),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=h;class l{constructor(A){this.delayer=new h(A),this.throttler=new b}trigger(A,F){return this.delayer.trigger(()=>this.throttler.queue(A),F)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class n{constructor(){this._isOpen=!1,this._promise=new Promise((A,F)=>{this._completePromise=A})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class r extends n{constructor(A){super();this._timeout=setTimeout(()=>this.open(),A)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function i(x,A){return A?new Promise((F,N)=>{const j=setTimeout(()=>{J.dispose(),F()},x),J=A.onCancellationRequested(()=>{clearTimeout(j),J.dispose(),N(new t.CancellationError)})}):p(F=>i(x,F))}e.timeout=i;function s(x,A=0){const F=setTimeout(x,A);return(0,R.toDisposable)(()=>clearTimeout(F))}e.disposableTimeout=s;function o(x){const A=[];let F=0;const N=x.length;function j(){return F<N?x[F++]():null}function J(U){U!=null&&A.push(U);const K=j();return K?K.then(J):Promise.resolve(A)}return Promise.resolve(null).then(J)}e.sequence=o;function a(x,A=N=>!!N,F=null){let N=0;const j=x.length,J=()=>{if(N>=j)return Promise.resolve(F);const U=x[N++];return Promise.resolve(U()).then(Z=>A(Z)?Promise.resolve(Z):J())};return J()}e.first=a;function c(x,A=N=>!!N,F=null){if(x.length===0)return Promise.resolve(F);let N=x.length;const j=()=>{N=-1;for(const J of x)J.cancel?.()};return new Promise((J,U)=>{for(const K of x)K.then(Z=>{--N>=0&&A(Z)?(j(),J(Z)):N===0&&J(F)}).catch(Z=>{--N>=0&&(j(),U(Z))})})}e.firstParallel=c;class f{constructor(A){this._size=0,this.maxDegreeOfParalellism=A,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(A){return this._size++,new Promise((F,N)=>{this.outstandingPromises.push({factory:A,c:F,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const A=this.outstandingPromises.shift();this.runningPromises++;const F=A.factory();F.then(A.c,A.e),F.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=f;class P extends f{constructor(){super(1)}}e.Queue=P;class L{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const A=new O;return this.drainers.add(A),A.p}isDrained(){for(const[,A]of this.queues)if(A.size>0)return!1;return!0}queueFor(A,F=M.extUri){const N=F.getComparisonKey(A);let j=this.queues.get(N);return j||(j=new P,D.Event.once(j.onDrained)(()=>{j?.dispose(),this.queues.delete(N),this.onDidQueueDrain()}),this.queues.set(N,j)),j}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const A of this.drainers)A.complete();this.drainers.clear()}dispose(){for(const[,A]of this.queues)A.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=L;class T{constructor(A,F){this._token=-1,typeof A=="function"&&typeof F=="number"&&this.setIfNotSet(A,F)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(A,F){this.cancel(),this._token=setTimeout(()=>{this._token=-1,A()},F)}setIfNotSet(A,F){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,A()},F))}}e.TimeoutTimer=T;class W{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(A,F){this.cancel(),this._token=setInterval(()=>{A()},F)}}e.IntervalTimer=W;class ${constructor(A,F){this.timeoutToken=-1,this.runner=A,this.timeout=F,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(A=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,A)}get delay(){return this.timeout}set delay(A){this.timeout=A}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=$;class te{constructor(A,F){F%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.runner=A,this.timeout=F,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(A=this.timeout){A%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(A/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=te;class re extends ${constructor(A,F){super(A,F);this.units=[]}work(A){this.units.push(A),this.isScheduled()||this.schedule()}doRun(){const A=this.units;this.units=[],this.runner?.(A)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=re;class ie extends R.Disposable{constructor(A,F){super();this.options=A,this.handler=F,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(A){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+A.length>this.options.maxBufferedWork)return!1}else if(this.pending+A.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...A),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new $(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ie,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=x=>{(0,S.setTimeout0)(()=>{if(A)return;const F=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(x,A)=>{const F=requestIdleCallback(x,typeof A=="number"?{timeout:A}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(F))}}}}();class se{constructor(A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(F){this._error=F}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function ce(x,A,F){let N;for(let j=0;j<F;j++)try{return await x()}catch(J){N=J,await i(A)}throw N}e.retry=ce;class q{hasPending(A){return this._pending?typeof A=="number"?this._pending.taskId===A:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(A,F,N){return this._pending={taskId:A,cancel:()=>N?.(),promise:F},F.then(()=>this.donePending(A),()=>this.donePending(A)),F}donePending(A){this._pending&&A===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const A=this._next;this._next=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this._next)this._next.run=A;else{let F,N;const j=new Promise((J,U)=>{F=J,N=U});this._next={run:A,promise:j,promiseResolve:F,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=q;class ne{constructor(A,F=()=>Date.now()){this.interval=A,this.nowFn=F,this.lastIncrementTime=0,this.value=0}increment(){const A=this.nowFn();return A-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=A,this.value=0),this.value++,this.value}}e.IntervalCounter=ne;class O{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((A,F)=>{this.completeCallback=A,this.errorCallback=F})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(A){return new Promise(F=>{this.completeCallback(A),this.resolved=!0,F()})}error(A){return new Promise(F=>{this.errorCallback(A),this.rejected=!0,F()})}cancel(){new Promise(A=>{this.errorCallback(new t.CancellationError),this.rejected=!0,A()})}}e.DeferredPromise=O;var _;(function(x){async function A(N){let j;const J=await Promise.all(N.map(U=>U.then(K=>K,K=>{j||(j=K)})));if(typeof j!="undefined")throw j;return J}x.settled=A;function F(N){return new Promise(async(j,J)=>{try{await N(j,J)}catch(U){J(U)}})}x.withAsyncBody=F})(_=e.Promises||(e.Promises={}));var B;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(B||(B={}));class Q{constructor(A){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const F={emitOne:N=>this.emitOne(N),emitMany:N=>this.emitMany(N),reject:N=>this.reject(N)};try{await Promise.resolve(A(F)),this.resolve()}catch(N){this.reject(N)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}static fromArray(A){return new Q(F=>{F.emitMany(A)})}static fromPromise(A){return new Q(async F=>{F.emitMany(await A)})}static fromPromises(A){return new Q(async F=>{await Promise.all(A.map(async N=>F.emitOne(await N)))})}static merge(A){return new Q(async F=>{await Promise.all(A.map(async N=>{for await(const j of N)F.emitOne(j)}))})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(A<this._results.length)return{done:!1,value:this._results[A++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(A,F){return new Q(async N=>{for await(const j of A)N.emitOne(F(j))})}map(A){return Q.map(this,A)}static filter(A,F){return new Q(async N=>{for await(const j of A)F(j)&&N.emitOne(j)})}filter(A){return Q.filter(this,A)}static coalesce(A){return Q.filter(A,F=>!!F)}coalesce(){return Q.coalesce(this)}static async toPromise(A){const F=[];for await(const N of A)F.push(N);return F}toPromise(){return Q.toPromise(this)}emitOne(A){this._state===0&&(this._results.push(A),this._onStateChanged.fire())}emitMany(A){this._state===0&&(this._results=this._results.concat(A),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(A){this._state===0&&(this._state=2,this._error=A,this._onStateChanged.fire())}}e.AsyncIterableObject=Q,Q.EMPTY=Q.fromArray([]);class H extends Q{constructor(A,F){super(F);this._source=A}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=H;function G(x){const A=new v.CancellationTokenSource,F=x(A.token);return new H(A,async N=>{const j=A.token.onCancellationRequested(()=>{j.dispose(),A.dispose(),N.reject(new t.CancellationError)});try{for await(const J of F){if(A.token.isCancellationRequested)return;N.emitOne(J)}j.dispose(),A.dispose()}catch(J){j.dispose(),A.dispose(),N.reject(J)}})}e.createCancelableAsyncIterable=G}),define(Y[92],X([0,1,25,8,29,33,9,4,31]),function(z,e,v,t,D,R,M,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function p(){return Object.create(null)}e.getEmptyExpression=p,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",k="[^/\\\\]",y=/\//g;function m(O,_){switch(O){case 0:return"";case 1:return`${k}*?`;default:return`(?:${C}|${k}+${C}${_?`|${C}${k}+`:""})*?`}}function u(O,_){if(!O)return[];const B=[];let Q=!1,H=!1,G="";for(const x of O){switch(x){case _:if(!Q&&!H){B.push(G),G="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":H=!0;break;case"]":H=!1;break}G+=x}return G&&B.push(G),B}e.splitGlobAware=u;function b(O){if(!O)return"";let _="";const B=u(O,e.GLOB_SPLIT);if(B.every(Q=>Q===e.GLOBSTAR))_=".*";else{let Q=!1;B.forEach((H,G)=>{if(H===e.GLOBSTAR){if(Q)return;_+=m(2,G===B.length-1)}else{let x=!1,A="",F=!1,N="";for(const j of H){if(j!=="}"&&x){A+=j;continue}if(F&&(j!=="]"||!N)){let J;j==="-"?J=j:(j==="^"||j==="!")&&!N?J="^":j===e.GLOB_SPLIT?J="":J=(0,d.escapeRegExpCharacters)(j),N+=J;continue}switch(j){case"{":x=!0;continue;case"[":F=!0;continue;case"}":{_+=`(?:${u(A,",").map(K=>b(K)).join("|")})`,x=!1,A="";break}case"]":{_+="["+N+"]",F=!1,N="";break}case"?":_+=k;continue;case"*":_+=m(1);continue;default:_+=(0,d.escapeRegExpCharacters)(j)}}G<B.length-1&&(B[G+1]!==e.GLOBSTAR||G+2<B.length)&&(_+=C)}Q=H===e.GLOBSTAR})}return _}const w=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new R.LRUCache(1e4),r=function(){return!1},i=function(){return null};function s(O,_){if(!O)return i;let B;typeof O!="string"?B=O.pattern:B=O,B=B.trim();const Q=`${B}_${!!_.trimForExclusions}`;let H=n.get(Q);if(H)return o(H,O);let G;return w.test(B)?H=c(B.substr(4),B):(G=E.exec(a(B,_)))?H=f(G[1],B):(_.trimForExclusions?g:I).test(B)?H=P(B,_):(G=h.exec(a(B,_)))?H=L(G[1].substr(1),B,!0):(G=l.exec(a(B,_)))?H=L(G[1],B,!1):H=T(B),n.set(Q,H),o(H,O)}function o(O,_){if(typeof _=="string")return O;const B=function(Q,H){return(0,D.isEqualOrParent)(Q,_.base,!S.isLinux)?O(Q.substr(_.base.length+1),H):null};return B.allBasenames=O.allBasenames,B.allPaths=O.allPaths,B.basenames=O.basenames,B.patterns=O.patterns,B}function a(O,_){return _.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function c(O,_){return function(B,Q){return typeof B=="string"&&B.endsWith(O)?_:null}}function f(O,_){const B=`/${O}`,Q=`\\${O}`,H=function(x,A){return typeof x!="string"?null:A?A===O?_:null:x===O||x.endsWith(B)||x.endsWith(Q)?_:null},G=[O];return H.basenames=G,H.patterns=[_],H.allBasenames=G,H}function P(O,_){const B=q(O.slice(1,-1).split(",").map(A=>s(A,_)).filter(A=>A!==i),O),Q=B.length;if(!Q)return i;if(Q===1)return B[0];const H=function(A,F){for(let N=0,j=B.length;N<j;N++)if(B[N](A,F))return O;return null},G=B.find(A=>!!A.allBasenames);G&&(H.allBasenames=G.allBasenames);const x=B.reduce((A,F)=>F.allPaths?A.concat(F.allPaths):A,[]);return x.length&&(H.allPaths=x),H}function L(O,_,B){const Q=M.sep===M.posix.sep,H=Q?O:O.replace(y,M.sep),G=M.sep+H,x=M.posix.sep+O;let A;return B?A=function(F,N){return typeof F=="string"&&(F===H||F.endsWith(G)||!Q&&(F===O||F.endsWith(x)))?_:null}:A=function(F,N){return typeof F=="string"&&(F===H||!Q&&F===O)?_:null},A.allPaths=[(B?"*/":"./")+O],A}function T(O){try{const _=new RegExp(`^${b(O)}$`);return function(B){return _.lastIndex=0,typeof B=="string"&&_.test(B)?O:null}}catch{return i}}function W(O,_,B){return!O||typeof _!="string"?!1:$(O)(_,void 0,B)}e.match=W;function $(O,_={}){if(!O)return r;if(typeof O=="string"||te(O)){const B=s(O,_);if(B===i)return r;const Q=function(H,G){return!!B(H,G)};return B.allBasenames&&(Q.allBasenames=B.allBasenames),B.allPaths&&(Q.allPaths=B.allPaths),Q}return se(O,_)}e.parse=$;function te(O){const _=O;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}e.isRelativePattern=te;function re(O){return O.allBasenames||[]}e.getBasenameTerms=re;function ie(O){return O.allPaths||[]}e.getPathTerms=ie;function se(O,_){const B=q(Object.getOwnPropertyNames(O).map(A=>ce(A,O[A],_)).filter(A=>A!==i)),Q=B.length;if(!Q)return i;if(!B.some(A=>!!A.requiresSiblings)){if(Q===1)return B[0];const A=function(j,J){let U;for(let K=0,Z=B.length;K<Z;K++){const ae=B[K](j,J);if(typeof ae=="string")return ae;(0,t.isThenable)(ae)&&(U||(U=[]),U.push(ae))}return U?(async()=>{for(const K of U){const Z=await K;if(typeof Z=="string")return Z}return null})():null},F=B.find(j=>!!j.allBasenames);F&&(A.allBasenames=F.allBasenames);const N=B.reduce((j,J)=>J.allPaths?j.concat(J.allPaths):j,[]);return N.length&&(A.allPaths=N),A}const H=function(A,F,N){let j,J;for(let U=0,K=B.length;U<K;U++){const Z=B[U];Z.requiresSiblings&&N&&(F||(F=(0,M.basename)(A)),j||(j=F.substr(0,F.length-(0,M.extname)(A).length)));const ae=Z(A,F,j,N);if(typeof ae=="string")return ae;(0,t.isThenable)(ae)&&(J||(J=[]),J.push(ae))}return J?(async()=>{for(const U of J){const K=await U;if(typeof K=="string")return K}return null})():null},G=B.find(A=>!!A.allBasenames);G&&(H.allBasenames=G.allBasenames);const x=B.reduce((A,F)=>F.allPaths?A.concat(F.allPaths):A,[]);return x.length&&(H.allPaths=x),H}function ce(O,_,B){if(_===!1)return i;const Q=s(O,B);if(Q===i)return i;if(typeof _=="boolean")return Q;if(_){const H=_.when;if(typeof H=="string"){const G=(x,A,F,N)=>{if(!N||!Q(x,A))return null;const j=H.replace("$(basename)",F),J=N(j);return(0,t.isThenable)(J)?J.then(U=>U?O:null):J?O:null};return G.requiresSiblings=!0,G}}return Q}function q(O,_){const B=O.filter(A=>!!A.basenames);if(B.length<2)return O;const Q=B.reduce((A,F)=>{const N=F.basenames;return N?A.concat(N):A},[]);let H;if(_){H=[];for(let A=0,F=Q.length;A<F;A++)H.push(_)}else H=B.reduce((A,F)=>{const N=F.patterns;return N?A.concat(N):A},[]);const G=function(A,F){if(typeof A!="string")return null;if(!F){let j;for(j=A.length;j>0;j--){const J=A.charCodeAt(j-1);if(J===47||J===92)break}F=A.substr(j)}const N=Q.indexOf(F);return N!==-1?H[N]:null};G.basenames=Q,G.patterns=H,G.allBasenames=Q;const x=O.filter(A=>!A.basenames);return x.push(G),x}function ne(O,_){return(0,v.equals)(O,_,(B,Q)=>typeof B=="string"&&typeof Q=="string"?B===Q:typeof B!="string"&&typeof Q!="string"?B.base===Q.base&&B.pattern===Q.pattern:!1)}e.patternsEquals=ne}),define(Y[34],X([0,1,25,29,9,4,16,31]),function(z,e,v,t,D,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function d(i,s){const{os:o,tildify:a,relative:c}=s;if(c){const L=p(i,c,o);if(typeof L=="string")return L}let f=i.fsPath;if(o===1&&!R.isWindows?f=f.replace(/\//g,"\\"):o!==1&&R.isWindows&&(f=f.replace(/\\/g,"/")),o!==1&&a?.userHome){const L=a.userHome.fsPath;let T;i.scheme!==a.userHome.scheme&&i.path.startsWith(D.posix.sep)?T=a.userHome.with({path:i.path}).fsPath:T=i.fsPath,f=y(T,L,o)}return(o===1?D.win32:D.posix).normalize(C(f,o===1))}e.getPathLabel=d;function p(i,s,o){const a=o===1?D.win32:D.posix,c=o===3?M.extUri:M.extUriIgnorePathCase,f=s.getWorkspace(),P=(0,v.firstOrDefault)(f.folders);if(!P)return;i.scheme!==P.uri.scheme&&i.path.startsWith(D.posix.sep)&&(i=P.uri.with({path:i.path}));const L=s.getWorkspaceFolder(i);if(!L)return;let T;if(c.isEqual(L.uri,i)?T="":T=c.relativePath(L.uri,i)??"",T&&(T=a.normalize(T)),f.folders.length>1&&!s.noPrefix){const W=L.name?L.name:c.basenameOrAuthority(L.uri);T=T?`${W} \u2022 ${T}`:W}return T}function C(i,s=R.isWindows){return(0,t.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=C;let k=Object.create(null);function y(i,s,o=R.OS){if(o===1||!i||!s)return i;let a=k.original===s?k.normalized:void 0;a||(a=s,R.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,S.rtrim)(a,D.posix.sep)}${D.posix.sep}`,k={original:s,normalized:a});let c=i;return R.isWindows&&(c=(0,t.toSlashes)(c)),(o===3?c.startsWith(a):(0,S.startsWithIgnoreCase)(c,a))?`~/${c.substr(a.length)}`:i}e.tildify=y;function m(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=m;const u="\u2026",b="\\\\",w="~";function E(i,s=D.sep){const o=new Array(i.length);let a=!1;for(let c=0;c<i.length;c++){const f=i[c];if(f===""){o[c]=`.${s}`;continue}if(!f){o[c]=f;continue}a=!0;let P="",L=f;L.indexOf(b)===0?(P=L.substr(0,L.indexOf(b)+b.length),L=L.substr(L.indexOf(b)+b.length)):L.indexOf(s)===0?(P=L.substr(0,L.indexOf(s)+s.length),L=L.substr(L.indexOf(s)+s.length)):L.indexOf(w)===0&&(P=L.substr(0,L.indexOf(w)+w.length),L=L.substr(L.indexOf(w)+w.length));const T=L.split(s);for(let W=1;a&&W<=T.length;W++)for(let $=T.length-W;a&&$>=0;$--){a=!1;let te=T.slice($,$+W).join(s);for(let re=0;!a&&re<i.length;re++)if(re!==c&&i[re]&&i[re].indexOf(te)>-1){const ie=$+W===T.length,se=$>0&&i[re].indexOf(s)>-1?s+te:te,ce=i[re].endsWith(se);a=!ie||ce}if(!a){let re="";(T[0].endsWith(":")||P!=="")&&($===1&&($=0,W++,te=T[0]+s+te),$>0&&(re=T[0]+s),re=P+re),$>0&&(re=re+u+s),re=re+te,$+W<T.length&&(re=re+s+u),o[c]=re}}a&&(o[c]=f)}return o}e.shorten=E;var I;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(I||(I={}));function g(i,s=Object.create(null)){const o=[];let a=!1,c="";for(const f of i)if(f==="$"||a&&f==="{")c&&o.push({value:c,type:I.TEXT}),c="",a=!0;else if(f==="}"&&a){const P=s[c];if(typeof P=="string")P.length&&o.push({value:P,type:I.VARIABLE});else if(P){const L=o[o.length-1];(!L||L.type!==I.SEPARATOR)&&o.push({value:P.label,type:I.SEPARATOR})}c="",a=!1}else c+=f;return c&&!a&&o.push({value:c,type:I.TEXT}),o.filter((f,P)=>{if(f.type===I.SEPARATOR){const L=o[P-1],T=o[P+1];return[L,T].every(W=>W&&(W.type===I.VARIABLE||W.type===I.TEXT)&&W.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=g;function h(i,s){return R.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function l(i,s){return R.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function n(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=n;function r(i){const s=i.indexOf("/")!==-1?D.posix:D.win32,o=s.basename(i),a=s.dirname(i);return o.length?{name:o,parentPath:a}:{name:a,parentPath:""}}e.splitName=r}),define(Y[136],X([0,1,7]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(C){return C.toJSON()}class D{constructor(k){this._uriTransformer=k}transformIncoming(k){const y=this._uriTransformer.transformIncoming(k);return y===k?k:t(v.URI.from(y))}transformOutgoing(k){const y=this._uriTransformer.transformOutgoing(k);return y===k?k:t(v.URI.from(y))}transformOutgoingURI(k){const y=this._uriTransformer.transformOutgoing(k);return y===k?k:v.URI.from(y)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function R(C,k,y){if(!C||y>200)return null;if(typeof C=="object"){if(C instanceof v.URI)return k.transformOutgoing(C);for(const m in C)if(Object.hasOwnProperty.call(C,m)){const u=R(C[m],k,y+1);u!==null&&(C[m]=u)}}return null}function M(C,k){const y=R(C,k,0);return y===null?C:y}e.transformOutgoingURIs=M;function S(C,k,y,m){if(!C||m>200)return null;if(typeof C=="object"){if(C.$mid===1)return y?v.URI.revive(k.transformIncoming(C)):k.transformIncoming(C);for(const u in C)if(Object.hasOwnProperty.call(C,u)){const b=S(C[u],k,y,m+1);b!==null&&(C[u]=b)}}return null}function d(C,k){const y=S(C,k,!1,0);return y===null?C:y}e.transformIncomingURIs=d;function p(C,k){const y=S(C,k,!0,0);return y===null?C:y}e.transformAndReviveIncomingURIs=p}),define(Y[80],X([0,1,28,19,33,30,126]),function(z,e,v,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(C){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(C)}value(){if(this._value===void 0){let C=0,k=0;const y=(0,v.networkInterfaces)();for(const m in y){const u=y[m];if(u)for(const{mac:b,internal:w}of u)w||(k+=1,this._isVirtualMachineMacAddress(b.toUpperCase())&&(C+=1))}this._value=k>0?C/k:0}return this._value}};let S;async function d(){return S||(S=(async()=>await p()||R.generateUuid())()),S}e.getMachineId=d;async function p(){try{const C=await new Promise((y,m)=>{z(["crypto"],y,m)}),k=(0,M.getMac)();return C.createHash("sha256").update(k,"utf8").digest("hex")}catch(C){t.onUnexpectedError(C);return}}}),define(Y[23],X([0,1,27,28,137,8,29,79,9,4,16,7]),function(z,e,v,t,D,R,M,S,d,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function m(se,ce=y.UNLINK){if((0,M.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return ce===y.UNLINK?b(se):u(se)}async function u(se){try{const ce=(0,M.randomPath)((0,t.tmpdir)());try{await v.promises.rename(se,ce)}catch{return b(se)}b(ce).catch(q=>{})}catch(ce){if(ce.code!=="ENOENT")throw ce}}async function b(se){return(0,D.promisify)(v.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function w(se){if((0,M.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");v.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function E(se,ce){return h(await(ce?I(se):(0,D.promisify)(v.readdir)(se)))}async function I(se){try{return await(0,D.promisify)(v.readdir)(se,{withFileTypes:!0})}catch(ne){console.warn("[node.js fs] readdir with filetypes failed with error: ",ne)}const ce=[],q=await E(se);for(const ne of q){let O=!1,_=!1,B=!1;try{const Q=await e.Promises.lstat((0,d.join)(se,ne));O=Q.isFile(),_=Q.isDirectory(),B=Q.isSymbolicLink()}catch(Q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Q)}ce.push({name:ne,isFile:()=>O,isDirectory:()=>_,isSymbolicLink:()=>B})}return ce}function g(se){return h(v.readdirSync(se))}e.readdirSync=g;function h(se){return se.map(ce=>typeof ce=="string"?p.isMacintosh?(0,S.normalizeNFC)(ce):ce:(ce.name=p.isMacintosh?(0,S.normalizeNFC)(ce.name):ce.name,ce))}async function l(se){const ce=await E(se),q=[];for(const ne of ce)await r.existsDirectory((0,d.join)(se,ne))&&q.push(ne);return q}function n(se,ce=1e3){return new Promise(q=>{let ne=!1;const O=setInterval(()=>{ne||(ne=!0,v.access(se,_=>{ne=!1,_&&(clearInterval(O),q(void 0))}))},ce)})}e.whenDeleted=n;var r;(function(se){async function ce(O){let _;try{if(_=await e.Promises.lstat(O),!_.isSymbolicLink())return{stat:_}}catch{}try{return{stat:await e.Promises.stat(O),symbolicLink:_?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};if(p.isWindows&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(O)),symbolicLink:{dangling:!1}}}catch(Q){if(Q.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};throw Q}throw B}}se.stat=ce;async function q(O){try{const{stat:_,symbolicLink:B}=await se.stat(O);return _.isFile()&&B?.dangling!==!0}catch{}return!1}se.existsFile=q;async function ne(O){try{const{stat:_,symbolicLink:B}=await se.stat(O);return _.isDirectory()&&B?.dangling!==!0}catch{}return!1}se.existsDirectory=ne})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new R.ResourceQueue;function s(se,ce,q){return i.queueFor(k.URI.file(se),C.extUriBiasedIgnorePathCase).queue(()=>{const ne=P(q);return new Promise((O,_)=>c(se,ce,ne,B=>B?_(B):O()))})}let o=!0;function a(se){o=se}e.configureFlushOnWrite=a;function c(se,ce,q,ne){if(!o)return v.writeFile(se,ce,{mode:q.mode,flag:q.flag},ne);v.open(se,q.flag,q.mode,(O,_)=>{if(O)return ne(O);v.writeFile(_,ce,B=>{if(B)return v.close(_,()=>ne(B));v.fdatasync(_,Q=>(Q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Q),a(!1)),v.close(_,H=>ne(H))))})})}function f(se,ce,q){const ne=P(q);if(!o)return v.writeFileSync(se,ce,{mode:ne.mode,flag:ne.flag});const O=v.openSync(se,ne.flag,ne.mode);try{v.writeFileSync(O,ce);try{v.fdatasyncSync(O)}catch(_){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",_),a(!1)}}finally{v.closeSync(O)}}e.writeFileSync=f;function P(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function L(se,ce){if(se!==ce)try{await e.Promises.rename(se,ce)}catch(q){if(se.toLowerCase()!==ce.toLowerCase()&&q.code==="EXDEV"||se.endsWith("."))await T(se,ce,{preserveSymlinks:!1}),await m(se,y.MOVE);else throw q}}async function T(se,ce,q){return $(se,ce,{root:{source:se,target:ce},options:q,handledSourcePaths:new Set})}const W=511;async function $(se,ce,q){if(q.handledSourcePaths.has(se))return;q.handledSourcePaths.add(se);const{stat:ne,symbolicLink:O}=await r.stat(se);if(O){if(q.options.preserveSymlinks)try{return await ie(se,ce,q)}catch(_){console.warn("[node.js fs] copy of symlink failed: ",_)}if(O.dangling)return}return ne.isDirectory()?te(se,ce,ne.mode&W,q):re(se,ce,ne.mode&W)}async function te(se,ce,q,ne){await e.Promises.mkdir(ce,{recursive:!0,mode:q});const O=await E(se);for(const _ of O)await $((0,d.join)(se,_),(0,d.join)(ce,_),ne)}async function re(se,ce,q){await e.Promises.copyFile(se,ce),await e.Promises.chmod(ce,q)}async function ie(se,ce,q){let ne=await e.Promises.readlink(se);(0,M.isEqualOrParent)(ne,q.root.source,!p.isLinux)&&(ne=(0,d.join)(q.root.target,ne.substr(q.root.source.length+1))),await e.Promises.symlink(ne,ce)}e.Promises=new class{get access(){return(0,D.promisify)(v.access)}get stat(){return(0,D.promisify)(v.stat)}get lstat(){return(0,D.promisify)(v.lstat)}get utimes(){return(0,D.promisify)(v.utimes)}get read(){return(se,ce,q,ne,O)=>new Promise((_,B)=>{v.read(se,ce,q,ne,O,(Q,H,G)=>Q?B(Q):_({bytesRead:H,buffer:G}))})}get readFile(){return(0,D.promisify)(v.readFile)}get write(){return(se,ce,q,ne,O)=>new Promise((_,B)=>{v.write(se,ce,q,ne,O,(Q,H,G)=>Q?B(Q):_({bytesWritten:H,buffer:G}))})}get appendFile(){return(0,D.promisify)(v.appendFile)}get fdatasync(){return(0,D.promisify)(v.fdatasync)}get truncate(){return(0,D.promisify)(v.truncate)}get rename(){return(0,D.promisify)(v.rename)}get copyFile(){return(0,D.promisify)(v.copyFile)}get open(){return(0,D.promisify)(v.open)}get close(){return(0,D.promisify)(v.close)}get symlink(){return(0,D.promisify)(v.symlink)}get readlink(){return(0,D.promisify)(v.readlink)}get chmod(){return(0,D.promisify)(v.chmod)}get mkdir(){return(0,D.promisify)(v.mkdir)}get unlink(){return(0,D.promisify)(v.unlink)}get rmdir(){return(0,D.promisify)(v.rmdir)}get realpath(){return(0,D.promisify)(v.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return E}get readDirsInDir(){return l}get writeFile(){return s}get rm(){return m}get move(){return L}get copy(){return T}}}),define(Y[93],X([0,1,27,9,4,31,23]),function(z,e,v,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function S(y){if(D.isLinux)return y;const m=(0,t.dirname)(y);if(y===m)return y;const u=((0,t.basename)(y)||y).toLowerCase();try{const w=(0,M.readdirSync)(m).filter(E=>E.toLowerCase()===u);if(w.length===1){const E=S(m);if(E)return(0,t.join)(E,w[0])}else if(w.length>1){const E=w.indexOf(u);if(E>=0){const I=S(m);if(I)return(0,t.join)(I,w[E])}}}catch{}return null}e.realcaseSync=S;async function d(y){if(D.isLinux)return y;const m=(0,t.dirname)(y);if(y===m)return y;const u=((0,t.basename)(y)||y).toLowerCase();try{const w=(await M.Promises.readdir(m)).filter(E=>E.toLowerCase()===u);if(w.length===1){const E=await d(m);if(E)return(0,t.join)(E,w[0])}else if(w.length>1){const E=w.indexOf(u);if(E>=0){const I=await d(m);if(I)return(0,t.join)(I,w[E])}}}catch{}return null}e.realcase=d;async function p(y){try{return await M.Promises.realpath(y)}catch{const u=k(y);return await M.Promises.access(u,v.constants.R_OK),u}}e.realpath=p;function C(y){try{return v.realpathSync(y)}catch{const u=k(y);return v.accessSync(u,v.constants.R_OK),u}}e.realpathSync=C;function k(y){return(0,R.rtrim)((0,t.normalize)(y),t.sep)}}),define(Y[138],X([0,1,28,9,23]),function(z,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,M=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var d;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(d||(d={}));let p;switch(process.arch){case"ia32":case"x32":p=1;break;case"arm":case"arm64":p=2;break;default:p=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class k{constructor(l,n,r){this.exePath=l,this.displayName=n,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function y({useAlternateBitness:h=!1}={}){return h?p===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:h=!1,findPreview:l=!1}={}){const n=y({useAlternateBitness:h});if(!n)return null;const r=t.join(n,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(r))return null;let i=-1,s=null;for(const c of await D.Promises.readdir(r)){let f=-1;if(l){const L=c.indexOf("-");if(L<0)continue;const T=c.substring(0,L);if(!R.test(T)||c.substring(L+1)!=="preview")continue;f=parseInt(T,10)}else{if(!R.test(c))continue;f=parseInt(c,10)}if(f<=i)continue;const P=t.join(r,c,"pwsh.exe");!await D.SymlinkSupport.existsFile(P)||(s=P,i=f)}if(!s)return null;const o=n.includes("x86")?" (x86)":"",a=l?" Preview":"";return new k(s,`PowerShell${a}${o}`,!0)}async function u({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const l=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=h?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const i of await D.Promises.readdir(l))if(n.test(i)){const s=t.join(l,i,"pwsh.exe");return new k(s,r)}return null}function b(){const h=t.join(v.homedir(),".dotnet","tools","pwsh.exe");return new k(h,".NET Core PowerShell Global Tool")}function w(){const h=t.join(process.env.windir,p===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(h,"Windows PowerShell",!0)}async function*E(){let h=await m();h&&(yield h),h=await m({useAlternateBitness:!0}),h&&(yield h),h=await u(),h&&(yield h),h=b(),h&&(yield h),h=await m({findPreview:!0}),h&&(yield h),h=await u({findPreview:!0}),h&&(yield h),h=await m({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=w(),h&&(yield h)}async function*I(){for await(const h of E())await h.exists()&&(yield h)}e.enumeratePowerShellInstallations=I;async function g(){for await(const h of I())return h;return null}e.getFirstAvailablePowerShellInstallation=g}),define(Y[94],X([0,1,42,12]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(M){return new Promise((S,d)=>{let p;const C=new Map;function k(m,u,b,w,E){const I=C.get(u);if(m===M||I){const g={name:y(b),cmd:b,pid:m,ppid:u,load:w,mem:E};C.set(m,g),m===M&&(p=g),I&&(I.children||(I.children=[]),I.children.push(g),I.children.length>1&&(I.children=I.children.sort((h,l)=>h.pid-l.pid)))}}function y(m){const u=/--vscode-window-kind=shared-process/,b=/--vscode-window-kind=issue-reporter/,w=/--vscode-window-kind=process-explorer/,E=/--utility-sub-type=network/,I=/--utility-sub-type=node.mojom.NodeService/,g=/--crashes-directory/,h=/\\pipe\\winpty-control/,l=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(g.exec(m))return"electron-crash-reporter";if(h.exec(m))return"winpty-process";if(l.exec(m))return"console-window-host (Windows internal process)";let r=n.exec(m);if(r&&r.length===2){if(r[1]==="renderer")return u.exec(m)?"shared-process":b.exec(m)?"issue-reporter":w.exec(m)?"process-explorer":"window";if(r[1]==="utility"){if(E.exec(m))return"utility-network-service";if(I.exec(m))return"extension-host"}return r[1]}const i=/[a-zA-Z-]+\.js/g;let s="";do r=i.exec(m),r&&(s+=r+" ");while(r);return s&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron_node ${s}`:m}if(process.platform==="win32"){const m=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,b)=>{z(["windows-process-tree"],u,b)}).then(u=>{u.getProcessList(M,b=>{if(!b){d(new Error(`Root process ${M} not found`));return}u.getProcessCpuUsage(b,w=>{const E=new Map;w.forEach(I=>{const g=m(I.commandLine||"");E.set(I.pid,{name:y(g),cmd:g,pid:I.pid,ppid:I.ppid,load:I.cpu||0,mem:I.memory||0})}),p=E.get(M),p?(E.forEach(I=>{const g=E.get(I.ppid);g&&(g.children||(g.children=[]),g.children.push(I))}),E.forEach(I=>{I.children&&(I.children=I.children.sort((g,h)=>g.pid-h.pid))}),S(p)):d(new Error(`Root process ${M} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let m=function(){let u=[p];const b=[];for(;u.length;){const E=u.shift();E&&(b.push(E.pid),E.children&&(u=u.concat(E.children)))}let w=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",z).fsPath);w+=" "+b.join(" "),(0,v.exec)(w,{},(E,I,g)=>{if(E||g)d(E||new Error(g.toString()));else{const h=I.toString().split(`
`);for(let l=0;l<b.length;l++){const n=C.get(b[l]);n.load=parseFloat(h[l])}if(!p){d(new Error(`Root process ${M} not found`));return}S(p)}})};(0,v.exec)("which ps",{},(u,b,w)=>{if(u||w)if(process.platform!=="linux")d(u||new Error(w.toString()));else{const E=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",z).fsPath);(0,v.exec)(E,{},(I,g,h)=>{I||h?d(I||new Error(h.toString())):(R(g,k),m())})}else{const E=b.toString().trim(),I="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${E} ${I}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,h,l)=>{g||l&&!l.includes("screen size is bogus")?d(g||new Error(l.toString())):(R(h,k),process.platform==="linux"?m():p?S(p):d(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=D;function R(M,S){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,p=M.toString().split(`
`);for(const C of p){const k=d.exec(C.trim());k&&k.length===6&&S(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}});var fe=this&&this.__decorate||function(z,e,v,t){var D=arguments.length,R=D<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,v):t,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(z,e,v,t);else for(var S=z.length-1;S>=0;S--)(M=z[S])&&(R=(D<3?M(R):D>3?M(e,v,R):M(e,v))||R);return D>3&&R&&Object.defineProperty(e,v,R),R};define(Y[43],X([0,1,25,8,17,21,51,19,3,2,66,31,13]),function(z,e,v,t,D,R,M,S,d,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(O){O[O.Promise=100]="Promise",O[O.PromiseCancel=101]="PromiseCancel",O[O.EventListen=102]="EventListen",O[O.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function u(O){switch(O){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(O){O[O.Initialize=200]="Initialize",O[O.PromiseSuccess=201]="PromiseSuccess",O[O.PromiseError=202]="PromiseError",O[O.PromiseErrorObj=203]="PromiseErrorObj",O[O.EventFire=204]="EventFire"})(b=e.ResponseType||(e.ResponseType={}));function w(O){switch(O){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(O){O[O.Uninitialized=0]="Uninitialized",O[O.Idle=1]="Idle"})(E||(E={}));class I{constructor(_){this.buffer=_,this.pos=0}read(_){const B=this.buffer.slice(this.pos,this.pos+_);return this.pos+=B.byteLength,B}}class g{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(_){this.buffers.push(_)}}var h;(function(O){O[O.Undefined=0]="Undefined",O[O.String=1]="String",O[O.Buffer=2]="Buffer",O[O.VSBuffer=3]="VSBuffer",O[O.Array=4]="Array",O[O.Object=5]="Object"})(h||(h={}));function l(O){const _=D.VSBuffer.alloc(4);return _.writeUInt32BE(O,0),_}function n(O){return O.read(4).readUInt32BE(0)}function r(O){const _=D.VSBuffer.alloc(1);return _.writeUInt8(O,0),_}const i={Undefined:r(h.Undefined),String:r(h.String),Buffer:r(h.Buffer),VSBuffer:r(h.VSBuffer),Array:r(h.Array),Object:r(h.Object)},s=typeof Buffer!="undefined";function o(O,_){if(typeof _=="undefined")O.write(i.Undefined);else if(typeof _=="string"){const B=D.VSBuffer.fromString(_);O.write(i.String),O.write(l(B.byteLength)),O.write(B)}else if(s&&Buffer.isBuffer(_)){const B=D.VSBuffer.wrap(_);O.write(i.Buffer),O.write(l(B.byteLength)),O.write(B)}else if(_ instanceof D.VSBuffer)O.write(i.VSBuffer),O.write(l(_.byteLength)),O.write(_);else if(Array.isArray(_)){O.write(i.Array),O.write(l(_.length));for(const B of _)o(O,B)}else{const B=D.VSBuffer.fromString(JSON.stringify(_));O.write(i.Object),O.write(l(B.byteLength)),O.write(B)}}function a(O){switch(O.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return O.read(n(O)).toString();case h.Buffer:return O.read(n(O)).buffer;case h.VSBuffer:return O.read(n(O));case h.Array:{const B=n(O),Q=[];for(let H=0;H<B;H++)Q.push(a(O));return Q}case h.Object:return JSON.parse(O.read(n(O)).toString())}}class c{constructor(_,B,Q=null,H=1e3){this.protocol=_,this.ctx=B,this.logger=Q,this.timeoutDelay=H,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(G=>this.onRawMessage(G)),this.sendResponse({type:200})}registerChannel(_,B){this.channels.set(_,B),setTimeout(()=>this.flushPendingRequests(_),0)}sendResponse(_){switch(_.type){case 200:{const B=this.send([_.type]);this.logger?.logOutgoing(B,0,1,w(_.type));return}case 201:case 202:case 204:case 203:{const B=this.send([_.type,_.id],_.data);this.logger?.logOutgoing(B,_.id,1,w(_.type),_.data);return}}}send(_,B=void 0){const Q=new g;return o(Q,_),o(Q,B),this.sendBuffer(Q.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch{return 0}}onRawMessage(_){const B=new I(_),Q=a(B),H=a(B),G=Q[0];switch(G){case 100:return this.logger?.logIncoming(_.byteLength,Q[1],1,`${u(G)}: ${Q[2]}.${Q[3]}`,H),this.onPromise({type:G,id:Q[1],channelName:Q[2],name:Q[3],arg:H});case 102:return this.logger?.logIncoming(_.byteLength,Q[1],1,`${u(G)}: ${Q[2]}.${Q[3]}`,H),this.onEventListen({type:G,id:Q[1],channelName:Q[2],name:Q[3],arg:H});case 101:return this.logger?.logIncoming(_.byteLength,Q[1],1,`${u(G)}`),this.disposeActiveRequest({type:G,id:Q[1]});case 103:return this.logger?.logIncoming(_.byteLength,Q[1],1,`${u(G)}`),this.disposeActiveRequest({type:G,id:Q[1]})}}onPromise(_){const B=this.channels.get(_.channelName);if(!B){this.collectPendingRequest(_);return}const Q=new R.CancellationTokenSource;let H;try{H=B.call(this.ctx,_.name,_.arg,Q.token)}catch(A){H=Promise.reject(A)}const G=_.id;H.then(A=>{this.sendResponse({id:G,data:A,type:201}),this.activeRequests.delete(_.id)},A=>{A instanceof Error?this.sendResponse({id:G,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.sendResponse({id:G,data:A,type:203}),this.activeRequests.delete(_.id)});const x=(0,p.toDisposable)(()=>Q.cancel());this.activeRequests.set(_.id,x)}onEventListen(_){const B=this.channels.get(_.channelName);if(!B){this.collectPendingRequest(_);return}const Q=_.id,G=B.listen(this.ctx,_.name,_.arg)(x=>this.sendResponse({id:Q,data:x,type:204}));this.activeRequests.set(_.id,G)}disposeActiveRequest(_){const B=this.activeRequests.get(_.id);B&&(B.dispose(),this.activeRequests.delete(_.id))}collectPendingRequest(_){let B=this.pendingRequests.get(_.channelName);B||(B=[],this.pendingRequests.set(_.channelName,B));const Q=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.sendResponse({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);B.push({request:_,timeoutTimer:Q})}flushPendingRequests(_){const B=this.pendingRequests.get(_);if(B){for(const Q of B)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.onPromise(Q.request);break;case 102:this.onEventListen(Q.request);break}this.pendingRequests.delete(_)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,p.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=c;var f;(function(O){O[O.LocalSide=0]="LocalSide",O[O.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class P{constructor(_,B=null){this.protocol=_,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Q=>this.onBuffer(Q)),this.logger=B}getChannel(_){const B=this;return{call(Q,H,G){return B.isDisposed?Promise.reject(S.canceled()):B.requestPromise(_,Q,H,G)},listen(Q,H){return B.isDisposed?d.Event.None:B.requestEvent(_,Q,H)}}}requestPromise(_,B,Q,H=R.CancellationToken.None){const G=this.lastRequestId++,A={id:G,type:100,channelName:_,name:B,arg:Q};if(H.isCancellationRequested)return Promise.reject(S.canceled());let F;return new Promise((j,J)=>{if(H.isCancellationRequested)return J(S.canceled());const U=()=>{const le=ge=>{switch(ge.type){case 201:this.handlers.delete(G),j(ge.data);break;case 202:{this.handlers.delete(G);const be=new Error(ge.data.message);be.stack=ge.data.stack,be.name=ge.data.name,J(be);break}case 203:this.handlers.delete(G),J(ge.data);break}};this.handlers.set(G,le),this.sendRequest(A)};let K=null;this.state===E.Idle?U():(K=(0,t.createCancelablePromise)(le=>this.whenInitialized()),K.then(()=>{K=null,U()}));const Z=()=>{K?(K.cancel(),K=null):this.sendRequest({id:G,type:101}),J(S.canceled())},ae=H.onCancellationRequested(Z);F=(0,p.combinedDisposable)((0,p.toDisposable)(Z),ae),this.activeRequests.add(F)}).finally(()=>{this.activeRequests.delete(F)})}requestEvent(_,B,Q){const H=this.lastRequestId++,x={id:H,type:102,channelName:_,name:B,arg:Q};let A=null;const F=new d.Emitter({onFirstListenerAdd:()=>{A=(0,t.createCancelablePromise)(j=>this.whenInitialized()),A.then(()=>{A=null,this.activeRequests.add(F),this.sendRequest(x)})},onLastListenerRemove:()=>{A?(A.cancel(),A=null):(this.activeRequests.delete(F),this.sendRequest({id:H,type:103}))}}),N=j=>F.fire(j.data);return this.handlers.set(H,N),F.event}sendRequest(_){switch(_.type){case 100:case 102:{const B=this.send([_.type,_.id,_.channelName,_.name],_.arg);this.logger?.logOutgoing(B,_.id,0,`${u(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const B=this.send([_.type,_.id]);this.logger?.logOutgoing(B,_.id,0,u(_.type));return}}}send(_,B=void 0){const Q=new g;return o(Q,_),o(Q,B),this.sendBuffer(Q.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch{return 0}}onBuffer(_){const B=new I(_),Q=a(B),H=a(B),G=Q[0];switch(G){case 200:return this.logger?.logIncoming(_.byteLength,0,0,w(G)),this.onResponse({type:Q[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(_.byteLength,Q[1],0,w(G),H),this.onResponse({type:Q[0],id:Q[1],data:H})}}onResponse(_){if(_.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}this.handlers.get(_.id)?.(_)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===E.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,p.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}fe([M.memoize],P.prototype,"onDidInitializePromise",null),e.ChannelClient=P;class L{constructor(_){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,_(({protocol:B,onDidClientDisconnect:Q})=>{d.Event.once(B.onMessage)(G=>{const x=new I(G),A=a(x),F=new c(B,A),N=new P(B);this.channels.forEach((J,U)=>F.registerChannel(U,J));const j={channelServer:F,channelClient:N,ctx:A};this._connections.add(j),this._onDidAddConnection.fire(j),Q(()=>{F.dispose(),N.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const _=[];return this._connections.forEach(B=>_.push(B)),_}getChannel(_,B){const Q=this;return{call(H,G,x){let A;if((0,y.isFunction)(B)){const N=(0,v.getRandomElement)(Q.connections.filter(B));A=N?Promise.resolve(N):d.Event.toPromise(d.Event.filter(Q.onDidAddConnection,B))}else A=B.routeCall(Q,H,G);const F=A.then(N=>N.channelClient.getChannel(_));return W(F).call(H,G,x)},listen(H,G){if((0,y.isFunction)(B))return Q.getMulticastEvent(_,B,H,G);const x=B.routeEvent(Q,H,G).then(A=>A.channelClient.getChannel(_));return W(x).listen(H,G)}}}getMulticastEvent(_,B,Q,H){const G=this;let x=new p.DisposableStore;const A=new d.Emitter({onFirstListenerAdd:()=>{x=new p.DisposableStore;const F=new d.EventMultiplexer,N=new Map,j=U=>{const Z=U.channelClient.getChannel(_).listen(Q,H),ae=F.add(Z);N.set(U,ae)},J=U=>{const K=N.get(U);!K||(K.dispose(),N.delete(U))};G.connections.filter(B).forEach(j),d.Event.filter(G.onDidAddConnection,B)(j,void 0,x),G.onDidRemoveConnection(J,void 0,x),F.event(A.fire,A,x),x.add(F)},onLastListenerRemove:()=>{x.dispose()}});return A.event}registerChannel(_,B){this.channels.set(_,B),this._connections.forEach(Q=>{Q.channelServer.registerChannel(_,B)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class T{constructor(_,B,Q=null){const H=new g;o(H,B),_.send(H.buffer),this.channelClient=new P(_,Q),this.channelServer=new c(_,B,Q)}getChannel(_){return this.channelClient.getChannel(_)}registerChannel(_,B){this.channelServer.registerChannel(_,B)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function W(O){return{call(_,B,Q){return O.then(H=>H.call(_,B,Q))},listen(_,B){const Q=new d.Relay;return O.then(H=>Q.input=H.listen(_,B)),Q.event}}}e.getDelayedChannel=W;function $(O){let _=!1;return{call(B,Q,H){return _?O.call(B,Q,H):(0,t.timeout)(0).then(()=>_=!0).then(()=>O.call(B,Q,H))},listen(B,Q){if(_)return O.listen(B,Q);const H=new d.Relay;return(0,t.timeout)(0).then(()=>_=!0).then(()=>H.input=O.listen(B,Q)),H.event}}}e.getNextTickChannel=$;class te{constructor(_){this.fn=_}routeCall(_){return this.route(_)}routeEvent(_){return this.route(_)}async route(_){for(const B of _.connections)if(await Promise.resolve(this.fn(B.ctx)))return Promise.resolve(B);return await d.Event.toPromise(_.onDidAddConnection),await this.route(_)}}e.StaticRouter=te;var re;(function(O){function _(G,x){const A=G,F=x&&x.disableMarshalling,N=new Map;for(const j in A)Q(j)&&N.set(j,d.Event.buffer(A[j],!0));return new class{listen(j,J,U){const K=N.get(J);if(K)return K;if(H(J)){const Z=A[J];if(typeof Z=="function")return Z.call(A,U)}throw new Error(`Event not found: ${J}`)}call(j,J,U){const K=A[J];if(typeof K=="function"){if(!F&&Array.isArray(U))for(let Z=0;Z<U.length;Z++)U[Z]=(0,C.revive)(U[Z]);return K.apply(A,U)}throw new Error(`Method not found: ${J}`)}}}O.fromService=_;function B(G,x){const A=x&&x.disableMarshalling;return new Proxy({},{get(F,N){if(typeof N=="string")return x?.properties?.has(N)?x.properties.get(N):H(N)?function(j){return G.listen(N,j)}:Q(N)?G.listen(N):async function(...j){let J;x&&!(0,y.isUndefinedOrNull)(x.context)?J=[x.context,...j]:J=j;const U=await G.call(N,J);return A?U:(0,C.revive)(U)};throw new Error(`Property not found: ${String(N)}`)}})}O.toService=B;function Q(G){return G[0]==="o"&&G[1]==="n"&&k.isUpperAsciiLetter(G.charCodeAt(2))}function H(G){return/^onDynamic/.test(G)&&k.isUpperAsciiLetter(G.charCodeAt(9))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(O){if(Array.isArray(O))return O;if(O&&typeof O=="object"&&typeof O.toString=="function"){const _=O.toString();if(_!=="[object Object]")return _}return O}function ce(O){return Array.isArray(O)?O.map(se):se(O)}function q(O,_,B,Q,H,G,x){x=ce(x);const A=ie[H],F=A[Q%A.length];let N=[`%c[${O}]%c[${String(_).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${F}`];/\($/.test(G)?(N=N.concat(x),N.push(")")):N.push(x),console.log.apply(console,N)}e.logWithColors=q;class ne{constructor(_,B){this._outgoingPrefix=_,this._incomingPrefix=B,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(_,B,Q,H,G){this._totalOutgoing+=_,q(this._outgoingPrefix,this._totalOutgoing,_,B,Q,H,G)}logIncoming(_,B,Q,H,G){this._totalIncoming+=_,q(this._incomingPrefix,this._totalIncoming,_,B,Q,H,G)}}e.IPCLogger=ne}),define(Y[139],X([0,1,17,3,43]),function(z,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(d){this.port=d,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",p=>v.VSBuffer.wrap(p.data)),d.start()}send(d){this.port.postMessage(d.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class M extends D.IPCClient{constructor(d,p){const C=new R(d);super(C,p);this.protocol=C}dispose(){this.protocol.disconnect()}}e.Client=M}),define(Y[95],X([0,1,17,3,2,43]),function(z,e,v,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(M=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var S;(function(s){s.enableDiagnostics=!1,s.records=[];const o=new WeakMap;let a=0;function c(P,L){if(!o.has(P)){const T=String(++a);o.set(P,T)}return o.get(P)}function f(P,L,T,W){if(!s.enableDiagnostics)return;const $=c(P,L);if(W instanceof v.VSBuffer||W instanceof Uint8Array||W instanceof ArrayBuffer||ArrayBuffer.isView(W)){const te=v.VSBuffer.alloc(W.byteLength);te.set(W),s.records.push({timestamp:Date.now(),id:$,label:L,type:T,buff:te})}else s.records.push({timestamp:Date.now(),id:$,label:L,type:T,data:W})}s.traceSocketEvent=f})(S=e.SocketDiagnostics||(e.SocketDiagnostics={}));var d;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d=e.SocketCloseEventType||(e.SocketCloseEventType={}));let p=null;function C(){return p||(p=v.VSBuffer.alloc(0)),p}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,a){if(o===0)return C();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const L=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=o),L}if(this._chunks[0].byteLength>o){const L=this._chunks[0].slice(0,o);return a&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),L}const c=v.VSBuffer.alloc(o);let f=0,P=0;for(;o>0;){const L=this._chunks[P];if(L.byteLength>o){const T=L.slice(0,o);c.set(T,f),f+=o,a&&(this._chunks[P]=L.slice(o),this._totalLength-=o),o-=o}else c.set(L,f),f+=L.byteLength,a?(this._chunks.shift(),this._totalLength-=L.byteLength):P++,o-=L.byteLength}return c}}e.ChunkStream=k;var y;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume"})(y||(y={}));function m(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var u;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(u=e.ProtocolConstants||(e.ProtocolConstants={}));class b{constructor(o,a,c,f){this.type=o,this.id=a,this.ack=c,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends D.Disposable{constructor(o){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:m(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,f=this._state.id,P=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new b(c,f,P,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class E{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=v.VSBuffer.alloc(13);a.writeUInt8(o.type,0),a.writeUInt32BE(o.id,1),a.writeUInt32BE(o.ack,5),a.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:m(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(a,o.data)}_bufferAdd(o,a){const c=this._totalLength===0;return this._data.push(o,a),this._totalLength+=o.byteLength+a.byteLength,c}_bufferTake(){const o=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,a){this._bufferAdd(o,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class I extends D.Disposable{constructor(o){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new E(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new b(1,0,0,o))}}e.Protocol=I;class g extends R.IPCClient{constructor(o,a,c=null){super(o,a,c);this.protocol=o}static fromSocket(o,a){return new g(new I(o),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=g;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class l{constructor(o){this.data=o,this.next=null}}class n{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){const o=[];let a=0,c=this._first;for(;c;)o[a++]=c.data,c=c.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const a=new l(o);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class r{constructor(){this.lastRuns=[];const o=Date.now();for(let a=0;a<r._HISTORY_LENGTH;a++)this.lastRuns[a]=o-1e3*a;setInterval(()=>{for(let a=r._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}load(){const o=Date.now(),a=(1+r._HISTORY_LENGTH)*1e3;let c=0;for(let f=0;f<r._HISTORY_LENGTH;f++)o-this.lastRuns[f]<=a&&c++;return 1-c/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class i{constructor(o,a=null,c=r.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),a&&this._socketReader.acceptChunk(a)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new b(5,0,0,C());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new b(7,0,0,C());this._socketWriter.write(o)}sendResume(){const o=new b(8,0,0,C());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,a){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new b(3,0,this._incomingAckId,C());this._socketWriter.write(o);const a=this._outgoingUnackMsg.toArray();for(let c=0,f=a.length;c<f;c++)this._socketWriter.write(a[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new b(6,0,0,C())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let c=0,f=a.length;c<f;c++)this._socketWriter.write(a[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new b(1,a,this._incomingAckId,o);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(o){const a=new b(2,0,0,o);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),a=Date.now()-o.writtenTime,c=Date.now()-this._socketReader.lastReadTime,f=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&c>=2e4&&f>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const P=Math.max(2e4-a,2e4-c,2e4-f,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},P)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new b(3,0,this._incomingAckId,C());this._socketWriter.write(o)}}e.PersistentProtocol=i}),define(Y[140],X([0,1,38,17,3,2,43,128]),function(z,e,v,t,D,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function d(C,k){const y=D.Event.fromNodeEventEmitter(v.validatedIpcMain,k,(u,b)=>({event:u,message:b})),m=D.Event.filter(y,({event:u})=>u.sender.id===C);return D.Event.map(m,({message:u})=>u&&t.VSBuffer.wrap(u))}class p extends M.IPCServer{constructor(){super(p.getOnDidClientConnect())}static getOnDidClientConnect(){const k=D.Event.fromNodeEventEmitter(v.validatedIpcMain,"vscode:hello",({sender:y})=>y);return D.Event.map(k,y=>{const m=y.id,u=p.Clients.get(m);u&&u.dispose();const b=new D.Emitter;p.Clients.set(m,(0,R.toDisposable)(()=>b.fire()));const w=d(m,"vscode:message"),E=D.Event.any(D.Event.signal(d(m,"vscode:disconnect")),b.event);return{protocol:new S.Protocol(y,w),onDidClientDisconnect:E}})}}e.Server=p,p.Clients=new Map}),define(Y[96],X([0,1,38,3,30,139]),function(z,e,v,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends R.Client{constructor(p,C){super({addEventListener:(k,y)=>p.addListener(k,y),removeEventListener:(k,y)=>p.removeListener(k,y),postMessage:k=>p.postMessage(k),start:()=>p.start(),close:()=>p.close()},C)}}e.Client=M;async function S(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const p=(0,D.generateUuid)();d.webContents.send("vscode:createMessageChannel",p);const C=t.Event.fromNodeEventEmitter(v.validatedIpcMain,"vscode:createMessageChannelResult",(y,m)=>({nonce:m,port:y.ports[0]})),{port:k}=await t.Event.toPromise(t.Event.once(t.Event.filter(C,y=>y.nonce===p)));return k}e.connect=S}),define(Y[81],X([0,1,17,19,3,2,9,4,30,43,95]),function(z,e,v,t,D,R,M,S,d,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:z.__$__nodeRequire("crypto"),zlib:z.__$__nodeRequire("zlib"),net:z.__$__nodeRequire("net"),os:z.__$__nodeRequire("os")}}class y{constructor(c,f=""){this.debugLabel=f,this.socket=c,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}},this.socket.on("error",this._errorListener)}traceSocketEvent(c,f){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,c,f)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(c){const f=P=>{this.traceSocketEvent("read",P),c(v.VSBuffer.wrap(P))};return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(c){const f=P=>{this.traceSocketEvent("close",{hadError:P}),c({type:0,hadError:P,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(c){const f=()=>{this.traceSocketEvent("nodeEndReceived"),c()};return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(c){if(!this.socket.destroyed)try{this.traceSocketEvent("write",c),this.socket.write(c.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,t.onUnexpectedError)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,t.onUnexpectedError)(f)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((c,f)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),c();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),c()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.NodeSocket=y;var m;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(m||(m={}));var u;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(u||(u={}));class b extends R.Disposable{constructor(c,f,P,L){super();this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=c,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:f,inflateBytesLength:P?.byteLength||0,recordInflateBytes:L}),this._flowManager=this._register(new w(this,f,P,L,this._onData,(T,W)=>this._write(T,W))),this._register(this._flowManager.onError(T=>{console.error(T),(0,t.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})})),this._incomingData=new C.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(T=>this._onClose.fire(T)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(c,f){this.socket.traceSocketEvent(c,f)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(c){return this._onData.event(c)}onClose(c){return this._onClose.event(c)}onEnd(c){return this.socket.onEnd(c)}write(c){this._flowManager.writeMessage(c)}_write(c,f){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",c);let P=2;c.byteLength<126?P+=0:c.byteLength<2**16?P+=2:P+=8;const L=v.VSBuffer.alloc(P);if(f?L.writeUInt8(194,0):L.writeUInt8(130,0),c.byteLength<126)L.writeUInt8(c.byteLength,1);else if(c.byteLength<2**16){L.writeUInt8(126,1);let T=1;L.writeUInt8(c.byteLength>>>8&255,++T),L.writeUInt8(c.byteLength>>>0&255,++T)}else{L.writeUInt8(127,1);let T=1;L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(c.byteLength>>>24&255,++T),L.writeUInt8(c.byteLength>>>16&255,++T),L.writeUInt8(c.byteLength>>>8&255,++T),L.writeUInt8(c.byteLength>>>0&255,++T)}this.socket.write(v.VSBuffer.concat([L,c]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(c){if(c.byteLength!==0){for(this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const f=this._incomingData.peek(this._state.readLen),P=f.readUInt8(0),L=(P&128)>>>7,T=(P&64)>>>6,W=f.readUInt8(1),$=(W&128)>>>7,te=W&127;this._state.state=2,this._state.readLen=2+($?4:0)+(te===126?2:0)+(te===127?8:0),this._state.fin=L,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(T)),this._state.firstFrameOfMessage=Boolean(L),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const f=this._incomingData.read(this._state.readLen),P=f.readUInt8(1),L=(P&128)>>>7;let T=P&127,W=1;T===126?T=f.readUInt8(++W)*2**8+f.readUInt8(++W):T===127&&(T=f.readUInt8(++W)*0+f.readUInt8(++W)*0+f.readUInt8(++W)*0+f.readUInt8(++W)*0+f.readUInt8(++W)*2**24+f.readUInt8(++W)*2**16+f.readUInt8(++W)*2**8+f.readUInt8(++W));let $=0;L&&($=f.readUInt8(++W)*2**24+f.readUInt8(++W)*2**16+f.readUInt8(++W)*2**8+f.readUInt8(++W)),this._state.state=3,this._state.readLen=T,this._state.mask=$,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const f=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",f),g(f,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",f),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(f,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=b;class w extends R.Disposable{constructor(c,f,P,L,T,W){super();this._tracer=c,this._onData=T,this._writeFn=W,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,f?(this._zlibInflateStream=this._register(new E(this._tracer,L,P,{windowBits:15})),this._zlibDeflateStream=this._register(new I(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError($=>this._onError.fire($))),this._register(this._zlibDeflateStream.onError($=>this._onError.fire($)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:v.VSBuffer.alloc(0)}writeMessage(c){this._writeQueue.push(c),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const c=this._writeQueue.shift();if(this._zlibDeflateStream){const f=await this._deflateMessage(this._zlibDeflateStream,c);this._writeFn(f,!0)}else this._writeFn(c,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(c,f){return new Promise((P,L)=>{c.write(f),c.flush(T=>P(T))})}acceptFrame(c,f,P){this._readQueue.push({data:c,isCompressed:f,isLastFrameOfMessage:P}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const c=this._readQueue.shift();if(this._zlibInflateStream&&c.isCompressed){const f=await this._inflateFrame(this._zlibInflateStream,c.data,c.isLastFrameOfMessage);this._onData.fire(f)}else this._onData.fire(c.data)}this._isProcessingReadQueue=!1}}_inflateFrame(c,f,P){return new Promise((L,T)=>{c.write(f),P&&c.write(v.VSBuffer.fromByteArray([0,0,255,255])),c.flush(W=>L(W))})}}class E extends R.Disposable{constructor(c,f,P,L){super();this._tracer=c,this._recordInflateBytes=f,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=k().zlib.createInflateRaw(L),this._zlibInflate.on("error",T=>{this._tracer.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this._onError.fire(T)}),this._zlibInflate.on("data",T=>{this._tracer.traceSocketEvent("zlibInflateData",T),this._pendingInflateData.push(v.VSBuffer.wrap(T))}),P&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this._zlibInflate.write(P.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?v.VSBuffer.concat(this._recordedInflateBytes):v.VSBuffer.alloc(0)}write(c){this._recordInflateBytes&&this._recordedInflateBytes.push(c.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",c),this._zlibInflate.write(c.buffer)}flush(c){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const f=v.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,c(f)})}}class I extends R.Disposable{constructor(c,f){super();this._tracer=c,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=k().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",P=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this._onError.fire(P)}),this._zlibDeflate.on("data",P=>{this._tracer.traceSocketEvent("zlibDeflateData",P),this._pendingDeflateData.push(v.VSBuffer.wrap(P))})}write(c){this._tracer.traceSocketEvent("zlibDeflateWrite",c.buffer),this._zlibDeflate.write(c.buffer)}flush(c){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let f=v.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,f=f.slice(0,f.byteLength-4),c(f)})}}function g(a,c){if(c===0)return;const f=a.byteLength>>>2;for(let te=0;te<f;te++){const re=a.readUInt32BE(te*4);a.writeUInt32BE(re^c,te*4)}const P=f*4,L=a.byteLength-P,T=c>>>24&255,W=c>>>16&255,$=c>>>8&255;L>=1&&a.writeUInt8(a.readUInt8(P)^T,P),L>=2&&a.writeUInt8(a.readUInt8(P+1)^W,P+1),L>=3&&a.writeUInt8(a.readUInt8(P+2)^$,P+2)}e.XDG_RUNTIME_DIR=typeof process!="undefined"?process.env.XDG_RUNTIME_DIR:void 0;const h={[2]:107,[1]:103};function l(){const a=(0,d.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let c;return e.XDG_RUNTIME_DIR?c=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):c=(0,M.join)(k().os.tmpdir(),`vscode-ipc-${a}.sock`),r(c),c}e.createRandomIPCHandle=l;function n(a,c,f){const P=k().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${f}-${c}-sock`;let L;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?L=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-${P.substr(0,8)}-${f}-${c}.sock`):L=(0,M.join)(a,`${f}-${c}.sock`),r(L),L}e.createStaticIPCHandle=n;function r(a){const c=h[S.platform];typeof c=="number"&&a.length>=c&&console.warn(`WARNING: IPC handle "${a}" is longer than ${c} chars, try a shorter --user-data-dir`)}class i extends p.IPCServer{constructor(c){super(i.toClientConnectionEvent(c));this.server=c}static toClientConnectionEvent(c){const f=D.Event.fromNodeEventEmitter(c,"connection");return D.Event.map(f,P=>({protocol:new C.Protocol(new y(P,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(P,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function s(a){return new Promise((c,f)=>{const P=k().net.createServer();P.on("error",f),P.listen(a,()=>{P.removeListener("error",f),c(new i(P))})})}e.serve=s;function o(a,c){return new Promise((f,P)=>{const L=k().net.createConnection(a,()=>{L.removeListener("error",P),f(C.Client.fromSocket(new y(L,`ipc-client${c}`),c))});L.once("error",P)})}e.connect=o}),define(Y[97],X([0,1,8,3,2,13]),function(z,e,v,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var M;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));function S(k){const y=k;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=S;var d;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(d=e.StorageState||(e.StorageState={}));class p extends D.Disposable{constructor(y,m=Object.create(null)){super();this.database=y,this.options=m,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=d.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){y.changed?.forEach((m,u)=>this.accept(u,m)),y.deleted?.forEach(m=>this.accept(m,void 0))}accept(y,m){if(this.state===d.Closed)return;let u=!1;(0,R.isUndefinedOrNull)(m)?u=this.cache.delete(y):this.cache.get(y)!==m&&(this.cache.set(y,m),u=!0),u&&this._onDidChangeStorage.fire(y)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===d.None&&(this.state=d.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,m){const u=this.cache.get(y);return(0,R.isUndefinedOrNull)(u)?m:u}getBoolean(y,m){const u=this.get(y);return(0,R.isUndefinedOrNull)(u)?m:u==="true"}getNumber(y,m){const u=this.get(y);return(0,R.isUndefinedOrNull)(u)?m:parseInt(u,10)}async set(y,m){if(this.state===d.Closed)return;if((0,R.isUndefinedOrNull)(m))return this.delete(y);const u=String(m);if(this.cache.get(y)!==u)return this.cache.set(y,u),this.pendingInserts.set(y,u),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.doFlush()}async delete(y){if(!(this.state===d.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=d.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(y){if(!!this.hasPending)return this.doFlush(y)}async doFlush(y){return this.flushDelayer.trigger(()=>this.flushPending(),y)}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert?.forEach((m,u)=>this.items.set(u,m)),y.delete?.forEach(m=>this.items.delete(m))}async close(){}}e.InMemoryStorageDatabase=C}),define(Y[141],X([0,1,8,3,33,9,23]),function(z,e,v,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class S{constructor(C,k=Object.create(null)){this.path=C,this.options=k,this.name=(0,R.basename)(this.path),this.logger=new d(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return t.Event.None}async getItems(){const C=await this.whenConnected,k=new Map;return(await this.all(C,"SELECT * FROM ItemTable")).forEach(m=>k.set(m.key,m.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${k.size} rows`),k}async updateItems(C){const k=await this.whenConnected;return this.doUpdateItems(k,C)}doUpdateItems(C,k){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${k.insert?(0,D.mapToString)(k.insert):"0"}), delete(${k.delete?(0,D.setToString)(k.delete):"0"})`),this.transaction(C,()=>{const y=k.insert,m=k.delete;if(y&&y.size>0){const u=[];u.push([]);let b=0;y.forEach((w,E)=>{let I=u[b];I.length>S.MAX_HOST_PARAMETERS&&(b++,I=[],u.push(I)),I.push(E,w)}),u.forEach(w=>{this.prepare(C,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,E=>E.run(w),()=>{const E=[];let I=0;return y.forEach((g,h)=>{E.push(h),I+=g.length}),`Keys: ${E.join(", ")} Length: ${I}`})})}if(m&&m.size){const u=[];u.push([]);let b=0;m.forEach(w=>{let E=u[b];E.length>S.MAX_HOST_PARAMETERS&&(b++,E=[],u.push(E)),E.push(w)}),u.forEach(w=>{this.prepare(C,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,E=>E.run(w),()=>{const E=[];return m.forEach(I=>{E.push(I)}),`Keys: ${E.join(", ")}`})})}})}async close(C){this.logger.trace(`[storage ${this.name}] close()`);const k=await this.whenConnected;return this.doClose(k,C)}doClose(C,k){return new Promise((y,m)=>{C.db.close(u=>(u&&this.handleSQLiteError(C,`[storage ${this.name}] close(): ${u}`),this.path===S.IN_MEMORY_PATH?y():!C.isErroneous&&!C.isInMemory?this.backup().then(y,b=>(this.logger.error(`[storage ${this.name}] backup(): ${b}`),y())):typeof k=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(b=>{const w=()=>this.doClose(b,void 0);return this.doUpdateItems(b,{insert:k()}).then(()=>w(),E=>(w(),Promise.reject(E)))})).then(y,m):m(u||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const C=this.toBackupPath(this.path);return M.Promises.copy(this.path,C,{preserveSymlinks:!1})}toBackupPath(C){return`${C}.backup`}async checkIntegrity(C){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${C})`);const k=await this.whenConnected,y=await this.get(k,C?"PRAGMA integrity_check":"PRAGMA quick_check"),m=C?y.integrity_check:y.quick_check;return k.isErroneous?`${m} (last error: ${k.lastError})`:k.isInMemory?`${m} (in-memory!)`:m}async connect(C,k=!0){this.logger.trace(`[storage ${this.name}] open(${C}, retryOnBusy: ${k})`);try{return await this.doConnect(C)}catch(y){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&k)return await(0,v.timeout)(S.BUSY_OPEN_TIMEOUT),this.connect(C,!1);try{await M.Promises.unlink(C);try{await M.Promises.rename(this.toBackupPath(C),C)}catch{}return await this.doConnect(C)}catch(m){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${m}`),this.doConnect(S.IN_MEMORY_PATH)}}}handleSQLiteError(C,k){C.isErroneous=!0,C.lastError=k,this.logger.error(k)}doConnect(C){return new Promise((k,y)=>{new Promise((m,u)=>{z(["@vscode/sqlite3"],m,u)}).then(m=>{const u={db:new(this.logger.isTracing?m.verbose().Database:m.Database)(C,b=>b?u.db&&b.code!=="SQLITE_CANTOPEN"?u.db.close(()=>y(b)):y(b):this.exec(u,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>k(u),w=>u.db.close(()=>y(w)))),isInMemory:C===S.IN_MEMORY_PATH};u.db.on("error",b=>this.handleSQLiteError(u,`[storage ${this.name}] Error (event): ${b}`)),this.logger.isTracing&&u.db.on("trace",b=>this.logger.trace(`[storage ${this.name}] Trace (event): ${b}`))},y)})}exec(C,k){return new Promise((y,m)=>{C.db.exec(k,u=>u?(this.handleSQLiteError(C,`[storage ${this.name}] exec(): ${u}`),m(u)):y())})}get(C,k){return new Promise((y,m)=>{C.db.get(k,(u,b)=>u?(this.handleSQLiteError(C,`[storage ${this.name}] get(): ${u}`),m(u)):y(b))})}all(C,k){return new Promise((y,m)=>{C.db.all(k,(u,b)=>u?(this.handleSQLiteError(C,`[storage ${this.name}] all(): ${u}`),m(u)):y(b))})}transaction(C,k){return new Promise((y,m)=>{C.db.serialize(()=>{C.db.run("BEGIN TRANSACTION"),k(),C.db.run("END TRANSACTION",u=>u?(this.handleSQLiteError(C,`[storage ${this.name}] transaction(): ${u}`),m(u)):y())})})}prepare(C,k,y,m){const u=C.db.prepare(k),b=w=>{this.handleSQLiteError(C,`[storage ${this.name}] prepare(): ${w} (${k}). Details: ${m()}`)};u.on("error",b),y(u),u.finalize(w=>{w&&b(w),u.removeListener("error",b)})}}e.SQLiteStorageDatabase=S,S.IN_MEMORY_PATH=":memory:",S.BUSY_OPEN_TIMEOUT=2e3,S.MAX_HOST_PARAMETERS=256;class d{constructor(C){C&&typeof C.logTrace=="function"&&process.env[d.VSCODE_TRACE_STORAGE]&&(this.logTrace=C.logTrace),C&&typeof C.logError=="function"&&(this.logError=C.logError)}get isTracing(){return!!this.logTrace}trace(C){this.logTrace?.(C)}error(C){this.logError?.(C)}}d.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Y[142],X([11,10]),function(z,e){return z.create("vs/base/node/processes",e)}),define(Y[82],X([0,1,42,29,12,50,9,4,36,77,13,124,23,142]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return p.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return p.TerminateResponseCode}});function u(l){switch(l){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function b(l,n){if(S.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};n&&(r.cwd=n);const i=v.execFile("taskkill",["/T","/F","/PID",l.pid.toString()],r);return new Promise(s=>{i.once("error",o=>{s({success:!1,error:o})}),i.once("exit",(o,a)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?u(r.status):1})}else if(S.isLinux||S.isMacintosh)try{const r=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",z).fsPath;return new Promise(i=>{v.execFile(r,[l.pid.toString()],{encoding:"utf8",shell:!0},(s,o,a)=>{i(s?{success:!1,error:s}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else l.kill("SIGKILL");return Promise.resolve({success:!0})}function w(l=d.env){return l.comspec||"cmd.exe"}e.getWindowsShell=w;class E{constructor(n,r,i,s){if(r!==void 0&&i!==void 0&&s!==void 0)this.cmd=n,this.args=r,this.shell=i,this.options=s;else{const o=n;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(d.env).forEach(a=>{o[a]=d.env[a]}),Object.keys(this.options.env).forEach(a=>{o[a]=this.options.env[a]}),this.options.env=o}}getSanitizedCommand(){let n=this.cmd.toLowerCase();const r=n.lastIndexOf(M.sep);return r!==-1&&(n=n.substring(r+1)),E.WellKnowCommands[n]?n:"other"}start(n){return S.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(d.cwd()))?Promise.reject(new Error(m.localize(0,null))):this.useExec().then(r=>{let i,s;const o=new Promise((a,c)=>{i=a,s=c});if(r){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=v.exec(a,this.options,(c,f,P)=>{this.childProcess=null;const L=c;L&&L.killed?s({killed:this.terminateRequested,stdout:f.toString(),stderr:P.toString()}):this.handleExec(i,n,c,f,P)})}else{let a=null;const c=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,i,n,s);const P={terminated:this.terminateRequested};C.isNumber(f)&&(P.cmdCode=f),i(P)};if(this.shell&&S.isWindows){const f=R.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let P=!1,L=!1;const T=[];let W=this.ensureQuotes(this.cmd);T.push(W.value),P=W.quoted,this.args&&this.args.forEach(te=>{W=this.ensureQuotes(te),T.push(W.value),L=L&&W.quoted});const $=["/s","/c"];P?L?$.push('"'+T.join(" ")+'"'):T.length>1?$.push('"'+T[0]+'" '+T.slice(1).join(" ")):$.push('"'+T[0]+'"'):$.push(T.join(" ")),a=v.spawn(w(),$,f)}else this.cmd&&(a=v.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(C.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",f=>{this.childProcess=null,s({terminated:this.terminateRequested,error:f})}),a.pid&&(this.childProcess.on("close",c),this.handleSpawn(a,i,n,s,!0)))}return o})}handleClose(n,r,i,s){}ensureQuotes(n){return E.regexp.test(n)?{value:'"'+n+'"',quoted:!0}:{value:n,quoted:n.length>0&&n[0]==='"'&&n[n.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(n=>n.pid,n=>-1):new Promise(n=>{this.pidResolve=n})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(n=>(this.terminateRequested=!0,b(n,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),n=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(n=>{if(!this.shell||!S.isWindows)return n(!1);const r=v.spawn(w(),["/s","/c"]);r.on("error",i=>n(!0)),r.on("exit",i=>n(!1))})}}e.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class I extends E{constructor(n,r,i,s){super(n,r,i,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(n,r,i,s,o){[s,o].forEach((a,c)=>{const f=new k.LineDecoder;f.write(a).forEach(T=>{r({line:T,source:c===0?0:1})});const L=f.end();L&&r({line:L,source:c===0?0:1})}),n({terminated:this.terminateRequested,error:i})}handleSpawn(n,r,i,s,o){const a=new k.LineDecoder,c=new k.LineDecoder;n.stdout.on("data",f=>{a.write(f).forEach(L=>i({line:L,source:0}))}),n.stderr.on("data",f=>{c.write(f).forEach(L=>i({line:L,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=c}handleClose(n,r,i,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&i({line:o,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&i({line:a,source:1})}}e.LineProcess=I;function g(l){let n=[],r=!1;const i=function(s){if(r){n.push(s);return}(!l.send(s,a=>{if(a&&console.error(a),r=!1,n.length>0){const c=n.slice(0);n=[],c.forEach(f=>i(f))}})||S.isWindows)&&(r=!0)};return{send:i}}e.createQueuedSender=g;var h;(function(l){async function n(r,i,s){if(M.isAbsolute(r))return r;if(i===void 0&&(i=d.cwd()),M.dirname(r)!=="."||(s===void 0&&C.isString(d.env.PATH)&&(s=d.env.PATH.split(M.delimiter)),s===void 0||s.length===0))return M.join(i,r);async function a(c){if(await y.Promises.exists(c)){let f;try{f=await y.Promises.stat(c)}catch(P){P.message.startsWith("EACCES")&&(f=await y.Promises.lstat(c))}return f?!f.isDirectory():!1}return!1}for(const c of s){let f;if(M.isAbsolute(c)?f=M.join(c,r):f=M.join(i,c,r),await a(f))return f;let P=f+".com";if(await a(P)||(P=f+".exe",await a(P)))return P}return M.join(i,r)}l.findExecutable=n})(h=e.win32||(e.win32={}))}),define(Y[143],X([0,1,28,4,138,82]),function(z,e,v,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(m,u){return m===1?t.isWindows?k():R.getWindowsShell(u):p(m,u)}e.getSystemShell=M;function S(m,u){return m===1?t.isWindows?y(u):R.getWindowsShell(u):p(m,u)}e.getSystemShellSync=S;let d=null;function p(m,u){if(t.isLinux&&m===2||t.isMacintosh&&m===3)return"/bin/bash";if(!d){let b;if(t.isWindows)b="/bin/bash";else{if(b=u.SHELL,!b)try{b=(0,v.userInfo)().shell}catch{}b||(b="sh"),b==="/bin/false"&&(b="/bin/bash")}d=b}return d}let C=null;async function k(){return C||(C=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),C}function y(m){if(C)return C;const u=t.isWindows&&parseFloat((0,v.release)())>=10,b=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${m.windir}\\${b?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?w:R.getWindowsShell(m)}}),define(Y[144],X([0,1,42,8,17,21,135,19,3,2,50,82,77,43]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends m.ChannelServer{constructor(E){super({send:I=>{try{process.send?.(I.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",I=>D.VSBuffer.wrap(Buffer.from(I,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=u;class b{constructor(E,I){this.modulePath=E,this.options=I,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new d.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=I&&I.timeout?I.timeout:6e4;this.disposeDelayer=new t.Delayer(g),this.child=null,this._client=null}getChannel(E){const I=this;return{call(g,h,l){return I.requestPromise(E,g,h,l)},listen(g,h){return I.requestEvent(E,g,h)}}}requestPromise(E,I,g,h=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(S.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(E),n=(0,t.createCancelablePromise)(s=>l.call(I,g,s)),r=h.onCancellationRequested(()=>n.cancel()),i=(0,p.toDisposable)(()=>n.cancel());return this.activeRequests.add(i),n.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(E,I,g){if(!this.disposeDelayer)return d.Event.None;this.disposeDelayer.cancel();let h;const l=new d.Emitter({onFirstListenerAdd:()=>{h=this.getCachedChannel(E).listen(I,g)(l.fire,l),this.activeRequests.add(h)},onLastListenerRemove:()=>{this.activeRequests.delete(h),h.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],I=Object.create(null);I.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(I.env={...I.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(I.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(I.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(I.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),I.execArgv===void 0&&(I.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,y.removeDangerousEnvVariables)(I.env),this.child=(0,v.fork)(this.modulePath,E,I);const g=new d.Emitter;d.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,M.isRemoteConsoleLog)(o)){(0,M.log)(o,`IPC Library: ${this.options.serverName}`);return}g.fire(D.VSBuffer.wrap(Buffer.from(o,"base64")))});const l=this.options.useQueue?(0,k.createQueuedSender)(this.child):this.child,n=o=>this.child&&this.child.connected&&l.send(o.buffer.toString("base64")),r=g.event,i={send:n,onMessage:r};this._client=new m.ChannelClient(i);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,a)=>{process.removeListener("exit",s),this.activeRequests.forEach(c=>(0,p.dispose)(c)),this.activeRequests.clear(),o!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+a),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:a})})}return this._client}getCachedChannel(E){let I=this.channels.get(E);return I||(I=this.client.getChannel(E),this.channels.set(E,I)),I}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=b}),define(Y[145],X([11,10]),function(z,e){return z.create("vs/code/electron-main/app",e)}),define(Y[146],X([11,10]),function(z,e){return z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Y[147],X([11,10]),function(z,e){return z.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Y[148],X([11,10]),function(z,e){return z.create("vs/platform/environment/node/argv",e)}),define(Y[149],X([11,10]),function(z,e){return z.create("vs/platform/environment/node/argvHelper",e)}),define(Y[150],X([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Y[151],X([11,10]),function(z,e){return z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Y[152],X([11,10]),function(z,e){return z.create("vs/platform/files/common/fileService",e)}),define(Y[153],X([11,10]),function(z,e){return z.create("vs/platform/files/common/files",e)}),define(Y[154],X([11,10]),function(z,e){return z.create("vs/platform/files/common/io",e)}),define(Y[155],X([11,10]),function(z,e){return z.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(Y[156],X([11,10]),function(z,e){return z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Y[157],X([11,10]),function(z,e){return z.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Y[158],X([11,10]),function(z,e){return z.create("vs/platform/menubar/electron-main/menubar",e)}),define(Y[159],X([11,10]),function(z,e){return z.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Y[160],X([11,10]),function(z,e){return z.create("vs/platform/request/common/request",e)}),define(Y[161],X([11,10]),function(z,e){return z.create("vs/platform/shell/node/shellEnv",e)}),define(Y[162],X([11,10]),function(z,e){return z.create("vs/platform/telemetry/common/telemetryService",e)}),define(Y[163],X([11,10]),function(z,e){return z.create("vs/platform/update/common/update.config.contribution",e)}),define(Y[164],X([11,10]),function(z,e){return z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Y[165],X([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/window",e)}),define(Y[166],X([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Y[167],X([11,10]),function(z,e){return z.create("vs/platform/workspace/common/workspace",e)}),define(Y[168],X([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Y[169],X([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Y[170],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function v(D){return D&&D.hasOwnProperty("folderUri")}e.isFolderBackupInfo=v;function t(D){return D&&D.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(Y[171],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function v(t){return typeof t?.backupFolder=="string"}e.isEmptyWindowBackupInfo=v}),define(Y[172],X([0,1,3,2]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(S,d,p){switch(d){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:p[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:p[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:p[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:p[0],port:p[1],subId:p[2]}))}throw new Error("Method not implemented.")}listen(S,d,p){switch(d){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(S){super();this.channel=S}reload(S){this.channel.call("reload",[S])}get onReload(){return this.channel.listen("reload")}close(S){this.channel.call("close",[S])}get onClose(){return this.channel.listen("close")}attachSession(S,d,p){this.channel.call("attach",[S,d,p])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(S,d){this.channel.call("terminate",[S,d])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(S,d){return this.channel.call("openExtensionDevelopmentHostWindow",[S,d])}}e.ExtensionHostDebugChannelClient=R}),define(Y[173],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class v{constructor(D){this.machineId=D}encryption(){return new Promise((D,R)=>z(["vscode-encrypt"],D,R))}async encrypt(D){try{return(await this.encryption()).encrypt(this.machineId,D)}catch{return D}}async decrypt(D){try{return(await this.encryption()).decrypt(this.machineId,D)}catch{return D}}}e.EncryptionMainService=v}),define(Y[174],X([0,1,131,51,12,9,36,16,7]),function(z,e,v,t,D,R,M,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class p{constructor(b,w,E){this._args=b,this.paths=w,this.productService=E,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,R.dirname)(D.FileAccess.asFileUri("",z).fsPath)}get userHome(){return d.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return d.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.paths.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,S.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,S.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const b=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",b)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return d.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.joinPath)(d.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const b=M.env.VSCODE_PORTABLE;return b?d.URI.file((0,R.join)(b,"argv.json")):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const b=this.args["builtin-extensions-dir"];return b?(0,R.resolve)(b):(0,R.normalize)((0,R.join)(D.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const b=this.args["extensions-download-dir"];return b?(0,R.resolve)(b):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const b=this.args["extensions-dir"];if(b)return(0,R.resolve)(b);const w=M.env.VSCODE_EXTENSIONS;if(w)return w;const E=M.env.VSCODE_PORTABLE;return E?(0,R.join)(E,"extensions"):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const b=this.args.extensionDevelopmentPath;if(Array.isArray(b))return b.map(w=>/^[^:/?#]+?:\/\//.test(w)?d.URI.parse(w):d.URI.file((0,R.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(b=>b==="ui"||b==="workspace"||b==="web"?b:"workspace")}get extensionTestsLocationURI(){const b=this.args.extensionTestsPath;if(b)return/^[^:/?#]+?:\/\//.test(b)?d.URI.parse(b):d.URI.file((0,R.normalize)(b))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const b=this.args["disable-extension"];if(b){if(typeof b=="string")return[b];if(Array.isArray(b)&&b.length>0)return b}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,S.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return d.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const b=M.env.VSCODE_PORTABLE;return b?d.URI.file((0,R.join)(b,"policy.json")):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}fe([t.memoize],p.prototype,"appRoot",null),fe([t.memoize],p.prototype,"userHome",null),fe([t.memoize],p.prototype,"userDataPath",null),fe([t.memoize],p.prototype,"appSettingsHome",null),fe([t.memoize],p.prototype,"tmpDir",null),fe([t.memoize],p.prototype,"cacheHome",null),fe([t.memoize],p.prototype,"stateResource",null),fe([t.memoize],p.prototype,"userRoamingDataHome",null),fe([t.memoize],p.prototype,"userDataSyncHome",null),fe([t.memoize],p.prototype,"userDataSyncLogResource",null),fe([t.memoize],p.prototype,"editSessionsLogResource",null),fe([t.memoize],p.prototype,"sync",null),fe([t.memoize],p.prototype,"machineSettingsResource",null),fe([t.memoize],p.prototype,"workspaceStorageHome",null),fe([t.memoize],p.prototype,"localHistoryHome",null),fe([t.memoize],p.prototype,"keyboardLayoutResource",null),fe([t.memoize],p.prototype,"argvResource",null),fe([t.memoize],p.prototype,"isExtensionDevelopment",null),fe([t.memoize],p.prototype,"untitledWorkspacesHome",null),fe([t.memoize],p.prototype,"installSourcePath",null),fe([t.memoize],p.prototype,"builtinExtensionsPath",null),fe([t.memoize],p.prototype,"extensionsPath",null),fe([t.memoize],p.prototype,"extensionDevelopmentLocationURI",null),fe([t.memoize],p.prototype,"extensionDevelopmentKind",null),fe([t.memoize],p.prototype,"extensionTestsLocationURI",null),fe([t.memoize],p.prototype,"debugExtensionHost",null),fe([t.memoize],p.prototype,"serviceMachineIdResource",null),fe([t.memoize],p.prototype,"telemetryLogResource",null),fe([t.memoize],p.prototype,"disableWorkspaceTrust",null),fe([t.memoize],p.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=p;function C(u,b){return m(u["inspect-extensions"],u["inspect-brk-extensions"],5870,b,u.debugId,u.extensionEnvironment)}e.parseExtensionHostPort=C;function k(u,b){return m(u["inspect-search"],u["inspect-brk-search"],5876,b,u.extensionEnvironment)}e.parseSearchPort=k;function y(u,b){return m(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,b,u.extensionEnvironment)}e.parsePtyHostPort=y;function m(u,b,w,E,I,g){const l=Number(b||u)||(E?null:w),n=l?Boolean(!!b):!1;let r;if(g)try{r=JSON.parse(g)}catch{}return{port:l,break:n,debugId:I,env:r}}}),define(Y[98],X([0,1,260,4,148]),function(z,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(11,null)},"shell-integration":{type:"string",cat:"o",args:["bash","pwsh","zsh"],description:(0,D.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(16,null)},category:{type:"string",cat:"e",description:(0,D.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(u,b,w=M){const E={},I=["_"],g=[];for(const r in b){const i=b[r];i.alias&&(E[r]=i.alias),i.type==="string"||i.type==="string[]"?(I.push(r),i.deprecates&&I.push(...i.deprecates)):i.type==="boolean"&&(g.push(r),i.deprecates&&g.push(...i.deprecates))}const h=v(u,{string:I,boolean:g,alias:E}),l={},n=h;l._=h._.map(r=>String(r)).filter(r=>r.length>0),delete n._;for(const r in b){const i=b[r];i.alias&&delete n[i.alias];let s=n[r];if(i.deprecates)for(const o of i.deprecates)n.hasOwnProperty(o)&&(s||(s=n[o],s&&w.onDeprecatedOption(o,i.deprecationMessage||(0,D.localize)(35,null,r))),delete n[o]);if(typeof s!="undefined"){if(i.type==="string[]"){if(Array.isArray(s)||(s=[s]),!i.allowEmptyValue){const o=s.filter(a=>a.length>0);o.length!==s.length&&(w.onEmptyValue(r),s=o.length>0?o:void 0)}}else i.type==="string"&&(Array.isArray(s)?(s=s.pop(),w.onMultipleValues(r,s)):!s&&!i.allowEmptyValue&&(w.onEmptyValue(r),s=void 0));l[r]=s,i.deprecationMessage&&w.onDeprecatedOption(r,i.deprecationMessage)}delete n[r]}for(const r in n)w.onUnknownOption(r);return l}e.parseArgs=S;function d(u,b){let w="";return b.args&&(Array.isArray(b.args)?w=` <${b.args.join("> <")}>`:w=` <${b.args}>`),b.alias?`-${b.alias} --${u}${w}`:`--${u}${w}`}function p(u,b){let w=0;const E=[];for(const l in u){const n=u[l],r=d(l,n);w=Math.max(w,r.length),E.push([r,n.description])}const I=w+2+1;if(b-I<25)return E.reduce((l,n)=>l.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const g=b-I-1,h=[];for(const l of E){const n=l[0],r=k(l[1],g),i=C(I-n.length-2);h.push("  "+n+i+r[0]);for(let s=1;s<r.length;s++)h.push(C(I)+r[s])}return h}e.formatOptions=p;function C(u){return" ".repeat(u)}function k(u,b){const w=[];for(;u.length;){const E=u.length<b?u.length:u.lastIndexOf(" ",b),I=u.slice(0,E).trim();u=u.slice(E),w.push(I)}return w}function y(u,b,w,E,I){const g=process.stdout.isTTY&&process.stdout.columns||80,h=I?.noInputFiles!==!0?`[${(0,D.localize)(36,null)}...]`:"",l=[`${u} ${w}`];l.push(""),l.push(`${(0,D.localize)(37,null)}: ${b} [${(0,D.localize)(38,null)}]${h}`),l.push(""),I?.noPipe!==!0&&(t.isWindows?l.push((0,D.localize)(39,null,b)):l.push((0,D.localize)(40,null,b)),l.push(""));const n={};for(const r in E){const i=E[r];if(i.description&&i.cat){let s=n[i.cat];s||(n[i.cat]=s={}),s[r]=i}}for(const r in n){const i=r,s=n[i];s&&(l.push(R[i]),l.push(...p(s,g)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=y;function m(u,b){return`${u||(0,D.localize)(41,null)}
${b||(0,D.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=m}),define(Y[175],X([0,1,76,172,98]),function(z,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(S){super();this.windowsMainService=S}call(S,d,p){return d==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(p[0],p[1]):super.call(S,d,p)}async openExtensionDevelopmentHostWindow(S,d){const p=(0,D.parseArgs)(S,D.OPTIONS);p.debugRenderer=d;const C=p.extensionDevelopmentPath;if(!C)return{success:!1};const[k]=this.windowsMainService.openExtensionDevelopmentHostWindow(C,{context:5,cli:p});if(!d)return{success:!0};const y=k.win;if(!y)return{success:!0};const m=y.webContents.debugger;let u=m.isAttached()?1/0:0;const b=(0,v.createServer)(w=>{u++==0&&m.attach();let E=!1;const I=l=>{E||w.write(JSON.stringify(l)+"\0")},g=(l,n,r,i)=>I({method:n,params:r,sessionId:i});y.on("close",()=>{m.removeListener("message",g),w.end(),E=!0}),m.addListener("message",g);let h=Buffer.alloc(0);w.on("data",l=>{h=Buffer.concat([h,l]);for(let n=h.indexOf(0);n!==-1;n=h.indexOf(0)){let r;try{const i=h.slice(0,n).toString("utf8");h=h.slice(n+1),r=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}m.sendCommand(r.method,r.params,r.sessionId).then(i=>I({id:r.id,sessionId:r.sessionId,result:i})).catch(i=>I({id:r.id,sessionId:r.sessionId,error:{code:0,message:i.message}}))}}),w.on("error",l=>{console.error("error on cdp pipe:",l)}),w.on("close",()=>{E=!0,--u==0&&m.detach()})});return await new Promise(w=>b.listen(0,w)),y.on("close",()=>b.close()),{rendererDebugPort:b.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(Y[56],X([0,1,261,149,98]),function(z,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function M(y,m){const u={onUnknownOption:w=>{console.warn((0,t.localize)(0,null,w))},onMultipleValues:(w,E)=>{console.warn((0,t.localize)(1,null,w,E))},onEmptyValue:w=>{console.warn((0,t.localize)(2,null,w))},onDeprecatedOption:(w,E)=>{console.warn((0,t.localize)(3,null,w,E))}},b=(0,D.parseArgs)(y,D.OPTIONS,m?u:void 0);return b.goto&&b._.forEach(w=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(w),(0,t.localize)(4,null))),b["max-memory"]&&v(parseInt(b["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),b}function S(y){const m=y.findIndex(u=>!/^-/.test(u));if(m>-1)return[...y.slice(0,m),...y.slice(m+1)]}function d(y){let[,...m]=y;process.env.VSCODE_DEV&&(m=S(m)||[]);const u=!k(process.env);return M(m,u)}e.parseMainProcessArgv=d;function p(y){const[,,...m]=y;return M(m,!0)}e.parseCLIProcessArgv=p;function C(y,...m){const u=y.indexOf("--");return u===-1?y.push(...m):y.splice(u,0,...m),y}e.addArg=C;function k(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=k}),function(){"use strict";function z(e,v,t,D){function R(S){const d=M(S),p=[d];return e.isAbsolute(d)||p.unshift(D),e.resolve(...p)}function M(S){const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let p=process.env.VSCODE_APPDATA;if(p)return e.join(p,t);const C=S["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(p=process.env.APPDATA,!p){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");p=e.join(k,"AppData","Roaming")}break;case"darwin":p=e.join(v.homedir(),"Library","Application Support");break;case"linux":p=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(p,t)}return{getUserDataPath:R}}if(typeof define=="function")define(Y[176],X([0,262,28,12,16,36]),function(e,v,t,D,R,M){const S=R.dirname(D.FileAccess.asFileUri("",e)),d=e.__$__nodeRequire(R.joinPath(S,"package.json").fsPath);return z(v,t,d.name,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),t=require("os");module.exports=z(v,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[177],X([0,1,28,174,176]),function(z,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(S,d){super(S,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,D.getUserDataPath)(S)},d)}}e.NativeEnvironmentService=R}),define(Y[178],X([0,1,27,28,29]),function(z,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function R(M){const S=(0,D.randomPath)((0,t.tmpdir)());try{return(0,v.writeFileSync)(S,""),M&&console.log(`Marker file for --wait created: ${S}`),S}catch(d){M&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.createWaitMarkerFile=R}),define(Y[179],X([0,1,17,30]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(R,M,S){let d=S&&S.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const C=(await M.readFile(R.serviceMachineIdResource)).value.toString();d=(0,t.isUUID)(C)?C:null}catch{d=null}if(!d){d=(0,t.generateUuid)();try{await M.writeFile(R.serviceMachineIdResource,v.VSBuffer.fromString(d))}catch{}}return S?.store("storage.serviceMachineId",d,-1,1),d}e.getServiceMachineId=D}),define(Y[67],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(D,R=[],M=!1){this.ctor=D,this.staticArguments=R,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=v}),define(Y[180],X([0,1,67]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function D(M,S,d){S instanceof v.SyncDescriptor||(S=new v.SyncDescriptor(S,[],d)),t.push([M,S])}e.registerSingleton=D;function R(){return t}e.getSingletonServiceDescriptors=R}),define(Y[181],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=v;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const M of this._nodes.values())M.outgoing.size===0&&R.push(M);return R}insertEdge(R,M){const S=this.lookupOrInsertNode(R),d=this.lookupOrInsertNode(M);S.outgoing.set(this._hashFn(M),d),d.incoming.set(this._hashFn(R),S)}removeNode(R){const M=this._hashFn(R);this._nodes.delete(M);for(const S of this._nodes.values())S.outgoing.delete(M),S.incoming.delete(M)}lookupOrInsertNode(R){const M=this._hashFn(R);let S=this._nodes.get(M);return S||(S=new v(R),this._nodes.set(M,S)),S}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[M,S]of this._nodes)R.push(`${M}, (incoming)[${[...S.incoming.keys()].join(", ")}], (outgoing)[${[...S.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(const[R,M]of this._nodes){const S=new Set([R]),d=this._findCycle(M,S);if(d)return d}}_findCycle(R,M){for(const[S,d]of R.outgoing){if(M.has(S))return[...M,S].join(" -> ");M.add(S);const p=this._findCycle(d,M);if(p)return p;M.delete(S)}}}e.Graph=t}),define(Y[5],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function S(d){return d[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=S})(v=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function t(M,S,d){S[v.DI_TARGET]===S?S[v.DI_DEPENDENCIES].push({id:M,index:d}):(S[v.DI_DEPENDENCIES]=[{id:M,index:d}],S[v.DI_TARGET]=S)}function D(M){if(v.serviceIds.has(M))return v.serviceIds.get(M);const S=function(d,p,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(S,d,C)};return S.toString=()=>M,v.serviceIds.set(M,S),S}e.createDecorator=D;function R(M){return M}e.refineServiceDecorator=R}),define(Y[57],X([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService")}),define(Y[18],X([0,1,13,7,5]),function(z,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function R(E){return E&&typeof E=="object"&&(!E.overrideIdentifier||typeof E.overrideIdentifier=="string")&&(!E.resource||E.resource instanceof t.URI)}e.isConfigurationOverrides=R;function M(E){return E&&typeof E=="object"&&(!E.overrideIdentifiers||v.isArray(E.overrideIdentifiers))&&!E.overrideIdentifier&&(!E.resource||E.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=M;var S;(function(E){E[E.USER=1]="USER",E[E.USER_LOCAL=2]="USER_LOCAL",E[E.USER_REMOTE=3]="USER_REMOTE",E[E.WORKSPACE=4]="WORKSPACE",E[E.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",E[E.DEFAULT=6]="DEFAULT",E[E.MEMORY=7]="MEMORY"})(S=e.ConfigurationTarget||(e.ConfigurationTarget={}));function d(E){switch(E){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=d;function p(E,I){const g=Object.create(null);for(const h in E)C(g,h,E[h],I);return g}e.toValuesTree=p;function C(E,I,g,h){const l=I.split("."),n=l.pop();let r=E;for(let i=0;i<l.length;i++){const s=l[i];let o=r[s];switch(typeof o){case"undefined":o=r[s]=Object.create(null);break;case"object":break;default:h(`Ignoring ${I} as ${l.slice(0,i+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[n]=g}catch{h(`Ignoring ${I} as ${l.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${I} as ${l.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=C;function k(E,I){const g=I.split(".");y(E,g)}e.removeFromValueTree=k;function y(E,I){const g=I.shift();if(I.length===0){delete E[g];return}if(Object.keys(E).indexOf(g)!==-1){const h=E[g];typeof h=="object"&&!Array.isArray(h)&&(y(h,I),Object.keys(h).length===0&&delete E[g])}}function m(E,I,g){function h(r,i){let s=r;for(const o of i){if(typeof s!="object"||s===null)return;s=s[o]}return s}const l=I.split("."),n=h(E,l);return typeof n=="undefined"?g:n}e.getConfigurationValue=m;function u(E,I,g){Object.keys(I).forEach(h=>{h!=="__proto__"&&(h in E?v.isObject(E[h])&&v.isObject(I[h])?u(E[h],I[h],g):g&&(E[h]=I[h]):E[h]=I[h])})}e.merge=u;function b(E,I,g){const h=E.inspect(I),l=E.inspect(g);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:h.defaultValue}e.getMigratedSettingValue=b;function w(E){return E.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(Y[68],X([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,v.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,v.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,M){return this.secretVault[R]?.[M]??null}async setPassword(R,M,S){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][M]=S}async deletePassword(R,M){return this.secretVault[R]?.[M]?(delete this.secretVault[R][M],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const M=[];for(const S of Object.keys(this.secretVault[R]||{}))M.push({account:S,password:this.secretVault[R][S]});return M}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(Y[83],X([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class D{async getPerformanceInfo(M,S){return{}}async getSystemInfo(M,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,S){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=D}),define(Y[99],X([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService")}),define(Y[39],X([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(Y[26],X([0,1,51,9,81,39,177,5]),function(z,e,v,t,D,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,S.refineServiceDecorator)(R.IEnvironmentService);class d extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,t.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,D.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}fe([v.memoize],d.prototype,"cachedLanguagesPath",null),fe([v.memoize],d.prototype,"backupHome",null),fe([v.memoize],d.prototype,"backupWorkspacesPath",null),fe([v.memoize],d.prototype,"mainIPCHandle",null),fe([v.memoize],d.prototype,"mainLockfile",null),fe([v.memoize],d.prototype,"disableUpdates",null),fe([v.memoize],d.prototype,"disableKeytar",null),fe([v.memoize],d.prototype,"codeCachePath",null),fe([v.memoize],d.prototype,"useCodeCache",null),e.EnvironmentMainService=d}),define(Y[100],X([0,1,150,5]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDefaultExtensionsProfileInitService=e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(E){switch(E){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function R(E){switch(E){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function M(E,I){switch(E){case 3:return I==="x64"?"win32-x64":I==="ia32"?"win32-ia32":I==="arm64"?"win32-arm64":"unknown";case 2:return I==="x64"?"linux-x64":I==="arm64"?"linux-arm64":I==="arm"?"linux-armhf":"unknown";case"alpine":return I==="x64"?"alpine-x64":I==="arm64"?"alpine-arm64":"unknown";case 1:return I==="x64"?"darwin-x64":I==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=M;function S(E,I){return I==="web"&&!E.includes("web")}e.isNotWebExtensionInWebTargetPlatform=S;function d(E,I,g){return S(I,g)?!1:E==="undefined"||E==="universal"?!0:E==="unknown"?!1:E===g?!0:p(g).includes(E)}e.isTargetPlatformCompatible=d;function p(E){switch(E){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=p;function C(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=C;var k;(function(E){E[E.NoneOrRelevance=0]="NoneOrRelevance",E[E.LastUpdatedDate=1]="LastUpdatedDate",E[E.Title=2]="Title",E[E.PublisherName=3]="PublisherName",E[E.InstallCount=4]="InstallCount",E[E.PublishedDate=10]="PublishedDate",E[E.AverageRating=6]="AverageRating",E[E.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var y;(function(E){E[E.Default=0]="Default",E[E.Ascending=1]="Ascending",E[E.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var m;(function(E){E.Install="install",E.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var u;(function(E){E[E.None=1]="None",E[E.Install=2]="Install",E[E.Update=3]="Update",E[E.Migrate=4]="Migrate"})(u=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var b;(function(E){E.Unsupported="Unsupported",E.Deprecated="Deprecated",E.Malicious="Malicious",E.Incompatible="Incompatible",E.IncompatiblePreRelease="IncompatiblePreRelease",E.IncompatibleTargetPlatform="IncompatibleTargetPlatform",E.ReleaseVersionNotFound="ReleaseVersionNotFound",E.Invalid="Invalid",E.Download="Download",E.Extract="Extract",E.Delete="Delete",E.Rename="Rename",E.CorruptZip="CorruptZip",E.IncompleteZip="IncompleteZip",E.Internal="Internal"})(b=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(I,g){super(I);this.code=g,this.name=g}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService"),e.IDefaultExtensionsProfileInitService=(0,t.createDecorator)("IDefaultExtensionsProfileInitService")}),define(Y[182],X([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(Y[183],X([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,v.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Y[101],X([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(Y[184],X([0,1,42,12,9,4,77,23,82,151,101]),function(z,e,v,t,D,R,M,S,d,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=p.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends y{openTerminal(h,l){return this.spawnTerminal(v,h,d.getWindowsShell(),l)}spawnTerminal(h,l,n,r){const i=l.windowsExec||m.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const s=D.basename(i).toLowerCase();if(s==="cmder"||s==="cmder.exe")return h.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return i.indexOf(" ")>=0&&o.push('""'),o.push(i),(s==="wt"||s==="wt.exe")&&o.push("-d ."),new Promise((a,c)=>{const f=w(process),P=h.spawn(n,o,{cwd:r,env:f});P.on("error",c),P.on("exit",()=>a())})}runInTerminal(h,l,n,r,i){const s="windowsExec"in i&&i.windowsExec?i.windowsExec:m.getDefaultTerminalWindows();return new Promise((o,a)=>{const c=`"${l} - ${k}"`,f=`""${n.join('" "')}" & pause"`,P=["/c","start",c,"/wait",s,"/c",f],L=Object.assign({},w(process),r);Object.keys(L).filter($=>L[$]===null).forEach($=>delete L[$]);const T={cwd:l,env:L,windowsVerbatimArguments:!0};v.spawn(m.CMD,P,T).on("error",$=>{a(E($))}),o(void 0)})}static getDefaultTerminalWindows(){if(!m._DEFAULT_TERMINAL_WINDOWS){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return m._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=m,m.CMD="cmd.exe";class u extends y{openTerminal(h,l){return this.spawnTerminal(v,h,l)}runInTerminal(h,l,n,r,i){const s=i.osxExec||C.DEFAULT_TERMINAL_OSX;return new Promise((o,a)=>{if(s===C.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const c=s===C.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",P=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,z).fsPath,"-t",h||k,"-w",l];for(const W of n)P.push("-a"),P.push(W);if(r){const W=Object.assign({},w(process),r);for(const $ in W){const te=W[$];te===null?(P.push("-u"),P.push($)):(P.push("-e"),P.push(`${$}=${te}`))}}let L="";const T=v.spawn(u.OSASCRIPT,P);T.on("error",W=>{a(E(W))}),T.stderr.on("data",W=>{L+=W.toString()}),T.on("exit",W=>{if(W===0)o(void 0);else if(L){const $=L.split(`
`,1);a(new Error($[0]))}else a(new Error(p.localize(1,null,c,W)))})}else a(new Error(p.localize(2,null,s)))})}spawnTerminal(h,l,n){const r=l.osxExec||C.DEFAULT_TERMINAL_OSX;return new Promise((i,s)=>{const o=["-a",r];n&&o.push(n);const a=w(process),c=h.spawn("/usr/bin/open",o,{cwd:n,env:a});c.on("error",s),c.on("exit",()=>i())})}}e.MacExternalTerminalService=u,u.OSASCRIPT="/usr/bin/osascript";class b extends y{openTerminal(h,l){return this.spawnTerminal(v,h,l)}runInTerminal(h,l,n,r,i){const s=i.linuxExec?Promise.resolve(i.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((o,a)=>{const c=[];s.then(f=>{f.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const P=`${I(n)}; echo; read -p "${b.WAIT_MESSAGE}" -n1;`;c.push(`''${P}''`);const L=Object.assign({},w(process),r);Object.keys(L).filter(te=>L[te]===null).forEach(te=>delete L[te]);const T={cwd:l,env:L};let W="";const $=v.spawn(f,c,T);$.on("error",te=>{a(E(te))}),$.stderr.on("data",te=>{W+=te.toString()}),$.on("exit",te=>{if(te===0)o(void 0);else if(W){const re=W.split(`
`,1);a(new Error(re[0]))}else a(new Error(p.localize(4,null,f,te)))})})})}static async getDefaultTerminalLinuxReady(){if(!b._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)b._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const h=await S.Promises.exists("/etc/debian_version");b._DEFAULT_TERMINAL_LINUX_READY=new Promise(l=>{h?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return b._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(h,l,n){const r=l.linuxExec?Promise.resolve(l.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((i,s)=>{r.then(o=>{const a=w(process),c=h.spawn(o,[],{cwd:n,env:a});c.on("error",s),c.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=b,b.WAIT_MESSAGE=p.localize(3,null);function w(g){const h={...g.env};return(0,M.sanitizeProcessEnvironment)(h),h}function E(g){return"errno"in g&&g.errno==="ENOENT"&&"path"in g&&typeof g.path=="string"?new Error(p.localize(5,null,g.path)):g}function I(g){let h="";for(const l of g)l.indexOf(" ")>=0?h+='"'+l+'"':h+=l,h+=" ";return h}}),define(Y[15],X([0,1,33,9,31,13,7,153,5]),function(z,e,v,t,D,R,M,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,d.createDecorator)("fileService");function p(q){return q.create===!0}e.isFileOpenForWriteOptions=p;var C;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(C=e.FileType||(e.FileType={}));var k;(function(q){q[q.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var y;(function(q){q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(q){return!!(q.capabilities&2)}e.hasReadWriteCapability=m;function u(q){return!!(q.capabilities&8)}e.hasFileFolderCopyCapability=u;function b(q){return!!(q.capabilities&32768)}e.hasFileCloneCapability=b;function w(q){return!!(q.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function E(q){return!!(q.capabilities&16)}e.hasFileReadStreamCapability=E;function I(q){return m(q)?!!(q.capabilities&16384):!1}e.hasFileAtomicReadCapability=I;var g;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(ne,O){super(ne);this.code=O}}e.FileSystemProviderError=h;function l(q,ne){const O=new h(q.toString(),ne);return r(O,ne),O}e.createFileSystemProviderError=l;function n(q){return q||l((0,S.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=n;function r(q,ne){return q.name=ne?`${ne} (FileSystemError)`:"FileSystemError",q}e.markAsFileSystemProviderError=r;function i(q){if(!q)return g.Unknown;if(q instanceof h)return q.code;const ne=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!ne)return g.Unknown;switch(ne[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=i;function s(q){if(q instanceof L)return q.fileOperationResult;switch(i(q)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var o;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class a{constructor(ne,O,_){this.resource=ne,this.operation=O,this.target=_}isOperation(ne){return this.operation===ne}}e.FileOperationEvent=a;var c;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class f{constructor(ne,O){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=ne;const _=new Map;for(const B of ne){const Q=_.get(B.type);switch(Q?Q.push([B.resource,B]):_.set(B.type,[[B.resource,B]]),B.type){case 1:this.rawAdded.push(B.resource);break;case 0:this.rawUpdated.push(B.resource);break;case 2:this.rawDeleted.push(B.resource);break}}for(const[B,Q]of _)switch(B){case 1:this.added=v.TernarySearchTree.forUris(()=>O),this.added.fill(Q);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>O),this.updated.fill(Q);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>O),this.deleted.fill(Q);break}}contains(ne,...O){return this.doContains(ne,{includeChildren:!1},...O)}affects(ne,...O){return this.doContains(ne,{includeChildren:!0},...O)}doContains(ne,O,..._){if(!ne)return!1;const B=_.length>0;return!!((!B||_.includes(1))&&(this.added?.get(ne)||O.includeChildren&&this.added?.findSuperstr(ne))||(!B||_.includes(0))&&(this.updated?.get(ne)||O.includeChildren&&this.updated?.findSuperstr(ne))||(!B||_.includes(2))&&(this.deleted?.findSubstr(ne)||O.includeChildren&&this.deleted?.findSuperstr(ne)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=f;function P(q,ne,O){return!q||!ne||q===ne||ne.length>q.length?!1:(ne.charAt(ne.length-1)!==t.sep&&(ne+=t.sep),O?(0,D.startsWithIgnoreCase)(q,ne):q.indexOf(ne)===0)}e.isParent=P;class L extends Error{constructor(ne,O,_){super(ne);this.fileOperationResult=O,this.options=_}}e.FileOperationError=L;class T extends L{constructor(ne,O,_){super(ne,2,_);this.stat=O}}e.NotModifiedSinceFileOperationError=T;var W;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",q[q.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(W=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var $;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})($=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function te(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.etag=te;async function re(q,ne){if(!ne.hasProvider(M.URI.from({scheme:q.scheme})))return new Promise(O=>{const _=ne.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===q.scheme&&B.added&&(_.dispose(),O())})})}e.whenProviderRegistered=re,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ie{static formatSize(ne){return(0,R.isNumber)(ne)||(ne=0),ne<ie.KB?(0,S.localize)(1,null,ne.toFixed(0)):ne<ie.MB?(0,S.localize)(2,null,(ne/ie.KB).toFixed(2)):ne<ie.GB?(0,S.localize)(3,null,(ne/ie.MB).toFixed(2)):ne<ie.TB?(0,S.localize)(4,null,(ne/ie.GB).toFixed(2)):(0,S.localize)(5,null,(ne/ie.TB).toFixed(2))}}e.ByteSize=ie,ie.KB=1024,ie.MB=ie.KB*ie.KB,ie.GB=ie.MB*ie.KB,ie.TB=ie.GB*ie.KB;var se;(function(q){q[q.IA32=0]="IA32",q[q.OTHER=1]="OTHER"})(se=e.Arch||(e.Arch={}));function ce(q){return{maxFileSize:q===0?300*ie.MB:16*ie.GB,maxHeapSize:q===0?700*ie.MB:2*700*ie.MB}}e.getPlatformLimits=ce}),define(Y[185],X([0,1,17,41,19,3,2,55,7,30,15]),function(z,e,v,t,D,R,M,S,d,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class k extends M.Disposable{constructor(m,u){super();this.channel=m,this.extraCapabilities=u,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,p.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(m){return this.channel.call("stat",[m])}readdir(m){return this.channel.call("readdir",[m])}async readFile(m,u){const{buffer:b}=await this.channel.call("readFile",[m,u]);return b}readFileStream(m,u,b){const w=(0,S.newWriteableStream)(I=>v.VSBuffer.concat(I.map(g=>v.VSBuffer.wrap(g))).buffer),E=this.channel.listen("readFileStream",[m,u])(I=>{if(I instanceof v.VSBuffer)w.write(I.buffer);else{if(I==="end")w.end();else{let g=I;g instanceof Error||(g=(0,C.createFileSystemProviderError)((0,t.toErrorMessage)(g),C.FileSystemProviderErrorCode.Unknown)),w.error(g),w.end()}E.dispose()}});return b.onCancellationRequested(()=>{w.error((0,D.canceled)()),w.end(),E.dispose()}),w}writeFile(m,u,b){return this.channel.call("writeFile",[m,v.VSBuffer.wrap(u),b])}open(m,u){return this.channel.call("open",[m,u])}close(m){return this.channel.call("close",[m])}async read(m,u,b,w,E){const[I,g]=await this.channel.call("read",[m,u,E]);return b.set(I.buffer.slice(0,g),w),g}write(m,u,b,w,E){return this.channel.call("write",[m,u,v.VSBuffer.wrap(b),w,E])}mkdir(m){return this.channel.call("mkdir",[m])}delete(m,u){return this.channel.call("delete",[m,u])}rename(m,u,b){return this.channel.call("rename",[m,u,b])}copy(m,u,b){return this.channel.call("copy",[m,u,b])}cloneFile(m,u){return this.channel.call("cloneFile",[m,u])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(m=>{if(Array.isArray(m)){const u=m;this._onDidChange.fire(u.map(b=>({resource:d.URI.revive(b.resource),type:b.type})))}else{const u=m;this._onDidWatchError.fire(u)}}))}watch(m,u){const b=(0,p.generateUuid)();return this.channel.call("watch",[this.sessionId,b,m,u]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,b]))}}e.DiskFileSystemProviderClient=k}),define(Y[102],X([0,1,17,19,154,15]),function(z,e,v,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(C,k,y,m,u,b){let w;try{await S(C,k,y,m,u,b)}catch(E){w=E}finally{w&&u.errorTransformer&&(w=u.errorTransformer(w)),typeof w!="undefined"&&y.error(w),y.end()}}e.readFileIntoStream=M;async function S(C,k,y,m,u,b){d(b);const w=await C.open(k,{create:!1});try{d(b);let E=0,I=0,g=u&&typeof u.length=="number"?u.length:void 0,h=v.VSBuffer.alloc(Math.min(u.bufferSize,typeof g=="number"?g:u.bufferSize)),l=u&&typeof u.position=="number"?u.position:0,n=0;do I=await C.read(w,l,h.buffer,n,h.byteLength-n),l+=I,n+=I,E+=I,typeof g=="number"&&(g-=I),n===h.byteLength&&(await y.write(m(h)),h=v.VSBuffer.alloc(Math.min(u.bufferSize,typeof g=="number"?g:u.bufferSize)),n=0);while(I>0&&(typeof g!="number"||g>0)&&d(b)&&p(E,u));if(n>0){let r=n;typeof g=="number"&&(r=Math.min(n,g)),y.write(m(h.slice(0,r)))}}catch(E){throw(0,R.ensureFileSystemProviderError)(E)}finally{await C.close(w)}}function d(C){if(C.isCancellationRequested)throw(0,t.canceled)();return!0}function p(C,k){if(k?.limits){if(typeof k.limits.memory=="number"&&C>k.limits.memory)throw(0,R.createFileSystemProviderError)((0,D.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof k.limits.size=="number"&&C>k.limits.size)throw(0,R.createFileSystemProviderError)((0,D.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[69],X([0,1,92,2,9,4,7,15]),function(z,e,v,t,D,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function d(E){return E.recursive===!0}e.isRecursiveWatchRequest=d;class p extends t.Disposable{constructor(I,g,h,l){super();this.onFileChanges=I,this.onLogMessage=g,this.verboseLogging=h,this.options=l,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const I=new t.DisposableStore;this.watcherDisposables.value=I,this.watcher=this.createWatcher(I),this.watcher.setVerboseLogging(this.verboseLogging),I.add(this.watcher.onDidChangeFile(g=>this.onFileChanges(g))),I.add(this.watcher.onDidLogMessage(g=>this.onLogMessage(g))),I.add(this.watcher.onDidError(g=>this.onError(g)))}onError(I){this.options.restartOnError?this.restartCounter<p.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${I}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${I}`):this.error(I)}restart(I){this.restartCounter++,this.init(),this.watch(I)}async watch(I){this.requests=I,await this.watcher?.watch(I)}async setVerboseLogging(I){this.verboseLogging=I,await this.watcher?.setVerboseLogging(I)}error(I){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${I}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=p,p.MAX_RESTARTS=5;class C extends p{constructor(I,g,h){super(I,g,h,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=C;class k extends p{constructor(I,g,h){super(I,g,h,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=k;function y(E){return E.map(I=>({type:I.type,resource:M.URI.file(I.path)}))}e.toFileChanges=y;function m(E){const I=new w;for(const g of E)I.processEvent(g);return I.coalesce()}e.coalesceEvents=m;function u(E,I){return typeof I=="string"&&!I.startsWith(v.GLOBSTAR)&&!(0,D.isAbsolute)(I)?{base:E,pattern:I}:I}e.normalizeWatcherPattern=u;function b(E,I){const g=[];for(const h of I)g.push((0,v.parse)(u(E,h)));return g}e.parseWatcherPatterns=b;class w{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(I){return R.isLinux?I.path:I.path.toLowerCase()}processEvent(I){const g=this.mapPathToChange.get(this.toKey(I));let h=!1;if(g){const l=g.type,n=I.type;g.path!==I.path&&(I.type===2||I.type===1)?h=!0:l===1&&n===2?(this.mapPathToChange.delete(this.toKey(I)),this.coalesced.delete(g)):l===2&&n===1?g.type=0:l===1&&n===0||(g.type=n)}else h=!0;h&&(this.coalesced.add(I),this.mapPathToChange.set(this.toKey(I),I))}coalesce(){const I=[],g=[];return Array.from(this.coalesced).filter(h=>h.type!==2?(I.push(h),!1):!0).sort((h,l)=>h.path.length-l.path.length).filter(h=>g.some(l=>(0,S.isParent)(h.path,l,!R.isLinux))?!1:(g.push(h.path),!0)).concat(I)}}}),define(Y[186],X([0,1,27,8,21,29,2,79,9,4,93,23,69]),function(z,e,v,t,D,R,M,S,d,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class m extends M.Disposable{constructor(w,E,I,g){super();this.request=w,this.onDidFilesChange=E,this.onLogMessage=I,this.verboseLogging=g,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},h=>this.onDidFilesChange(h)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(m.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,y.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,y.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const w=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const E=await k.Promises.stat(w);this._register(await this.doWatch(w,E.isDirectory()))}catch(w){w.code!=="ENOENT"?this.error(w):this.trace(w)}}async normalizePath(w){let E=w.path;try{E=await k.Promises.realpath(w.path),w.path===E&&(E=await(0,C.realcase)(w.path)??w.path),w.path!==E&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${w.path}, real: ${E})`)}catch{}return E}async doWatch(w,E){if(p.isMacintosh&&(0,R.isEqualOrParent)(w,"/Volumes/",!0))return this.error(`Refusing to watch ${w} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const I=new D.CancellationTokenSource(this.cts.token),g=new M.DisposableStore;try{const h=(0,d.basename)(w),l=(0,v.watch)(w);g.add((0,M.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.trace(`Started watching: '${w}'`);const n=new Set;if(E)try{for(const i of await k.Promises.readdir(w))n.add(i)}catch(i){this.error(i)}const r=new Map;g.add((0,M.toDisposable)(()=>{for(const[,i]of r)i.dispose();r.clear()})),l.on("error",(i,s)=>{this.error(`Failed to watch ${w} for changes using fs.watch() (${i}, ${s})`),this.dispose()}),l.on("change",(i,s)=>{if(I.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${s}`);let o="";if(s&&(o=s.toString(),p.isMacintosh&&(o=(0,S.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(E)if(i==="rename"){r.get(o)?.dispose();const a=setTimeout(async()=>{if(r.delete(o),o===h&&!await k.Promises.exists(w)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const c=await this.existsChildStrictCase((0,d.join)(w,o));if(I.token.isCancellationRequested)return;let f;c?n.has(o)?f=0:(f=1,n.add(o)):(n.delete(o),f=2),this.onFileChange({path:(0,d.join)(this.request.path,o),type:f})},m.FILE_DELETE_HANDLER_DELAY);r.set(o,(0,M.toDisposable)(()=>clearTimeout(a)))}else{let a;n.has(o)?a=0:(a=1,n.add(o)),this.onFileChange({path:(0,d.join)(this.request.path,o),type:a})}else if(i==="rename"||o!==h){const a=setTimeout(async()=>{const c=await k.Promises.exists(w);I.token.isCancellationRequested||(c?(this.onFileChange({path:this.request.path,type:0},!0),g.add(await this.doWatch(w,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},m.FILE_DELETE_HANDLER_DELAY);g.clear(),g.add((0,M.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(h){await k.Promises.exists(w)&&!I.token.isCancellationRequested&&this.error(`Failed to watch ${w} for changes using fs.watch() (${h.toString()})`)}return(0,M.toDisposable)(()=>{I.dispose(!0),g.dispose()})}async onFileChange(w,E=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),!E&&this.excludes.some(I=>I(w.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${w.path}`):!E&&this.includes&&this.includes.length>0&&!this.includes.some(I=>I(w.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${w.path}`):this.fileChangesBuffer.push(w);try{await this.fileChangesDelayer.trigger(async()=>{const I=this.fileChangesBuffer;this.fileChangesBuffer=[];const g=(0,y.coalesceEvents)(I);if(g.length>0){if(this.verboseLogging)for(const l of g)this.trace(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);this.throttledFileChangesWorker.work(g)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(w){if(p.isLinux)return k.Promises.exists(w);try{const E=(0,d.basename)(w);return(await k.Promises.readdir((0,d.dirname)(w))).some(g=>g===E)}catch(E){return this.trace(E),!1}}setVerboseLogging(w){this.verboseLogging=w}error(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${w}`})}warn(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${w}`})}trace(w){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=m,m.FILE_DELETE_HANDLER_DELAY=100,m.FILE_CHANGES_HANDLER_DELAY=50;async function u(b,w,E,I,g=512){const h=await k.Promises.open(b,"r"),l=Buffer.allocUnsafe(g),n=new D.CancellationTokenSource(I);let r,i=!1;const s={path:b,excludes:[],recursive:!1},o=new m(s,a=>{(async()=>{for(const{type:c}of a)if(c===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:f}=await k.Promises.read(h,l,0,g,null);if(!f||n.token.isCancellationRequested)break;w(l.slice(0,f))}}catch(f){r=new Error(f),n.dispose(!0)}finally{i=!1}}})()});return await o.ready,E(),new Promise((a,c)=>{n.token.onCancellationRequested(async()=>{o.dispose();try{await k.Promises.close(h)}catch(f){r=new Error(f)}r?c(r):a()})})}e.watchFileContents=u}),define(Y[187],X([0,1,3,92,2,4,186]),function(z,e,v,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class S extends D.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new v.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new v.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=v.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(p){const C=this.normalizeRequests(p),k=C.filter(m=>{const u=this.watchers.get(m.path);return u?!(0,t.patternsEquals)(u.request.excludes,m.excludes)||!(0,t.patternsEquals)(u.request.includes,m.includes):!0}),y=Array.from(this.watchers.values()).filter(({request:m})=>!C.find(u=>u.path===m.path&&(0,t.patternsEquals)(u.excludes,m.excludes)&&(0,t.patternsEquals)(u.includes,m.includes))).map(({request:m})=>m.path);k.length&&this.trace(`Request to start watching: ${k.map(m=>`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"})`).join(",")}`),y.length&&this.trace(`Request to stop watching: ${y.join(",")}`);for(const m of y)this.stopWatching(m);for(const m of k)this.startWatching(m)}startWatching(p){const C=new M.NodeJSFileWatcherLibrary(p,y=>this._onDidChangeFile.fire(y),y=>this._onDidLogMessage.fire(y),this.verboseLogging),k={request:p,instance:C};this.watchers.set(p.path,k)}async stop(){for(const[p]of this.watchers)this.stopWatching(p);this.watchers.clear()}stopWatching(p){const C=this.watchers.get(p);C&&(this.watchers.delete(p),C.instance.dispose())}normalizeRequests(p){const C=new Map;for(const k of p){const y=R.isLinux?k.path:k.path.toLowerCase();C.set(y,k)}return Array.from(C.values())}async setVerboseLogging(p){this.verboseLogging=p;for(const[,C]of this.watchers)C.instance.setVerboseLogging(p)}trace(p){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(p)})}toMessage(p,C){return C?`[File Watcher (node.js)] ${p} (path: ${C.request.path})`:`[File Watcher (node.js)] ${p}`}}e.NodeJSWatcher=S}),define(Y[188],X([0,1,69,187]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends v.AbstractNonRecursiveWatcherClient{constructor(M,S,d){super(M,S,d);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(Y[189],X([0,1,12,43,144,69]),function(z,e,v,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends R.AbstractUniversalWatcherClient{constructor(d,p,C){super(d,p,C);this.init()}createWatcher(d){const p=d.add(new D.Client(v.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(p.onDidProcessExit(({code:C,signal:k})=>this.onError(`terminated by itself with code ${C}, signal: ${k}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(p.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(Y[84],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...D){this._entries=new Map;for(const[R,M]of D)this.set(R,M)}set(D,R){const M=this._entries.get(D);return this._entries.set(D,R),M}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=v}),define(Y[190],X([0,1,8,19,67,181,5,84]),function(z,e,v,t,D,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const d=!1;class p extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class C{constructor(u=new S.ServiceCollection,b=!1,w){this._activeInstantiations=new Set,this._services=u,this._strict=b,this._parent=w,this._services.set(M.IInstantiationService,this)}createChild(u){return new C(u,this._strict,this)}invokeFunction(u,...b){const w=y.traceInvocation(u);let E=!1;try{return u({get:g=>{if(E)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const h=this._getOrCreateServiceInstance(g,w);if(!h)throw new Error(`[invokeFunction] unknown service '${g}'`);return h}},...b)}finally{E=!0,w.stop()}}createInstance(u,...b){let w,E;return u instanceof D.SyncDescriptor?(w=y.traceCreation(u.ctor),E=this._createInstance(u.ctor,u.staticArguments.concat(b),w)):(w=y.traceCreation(u),E=this._createInstance(u,b,w)),w.stop(),E}_createInstance(u,b=[],w){const E=M._util.getServiceDependencies(u).sort((h,l)=>h.index-l.index),I=[];for(const h of E){const l=this._getOrCreateServiceInstance(h.id,w);l||this._throwIfStrict(`[createInstance] ${u.name} depends on UNKNOWN service ${h.id}.`,!1),I.push(l)}const g=E.length>0?E[0].index:b.length;if(b.length!==g){console.trace(`[createInstance] First service dependency of ${u.name} at position ${g+1} conflicts with ${b.length} static arguments`);const h=g-b.length;h>0?b=b.concat(new Array(h)):b=b.slice(0,g)}return new u(...[...b,...I])}_setServiceInstance(u,b){if(this._services.get(u)instanceof D.SyncDescriptor)this._services.set(u,b);else if(this._parent)this._parent._setServiceInstance(u,b);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){const b=this._services.get(u);return!b&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):b}_getOrCreateServiceInstance(u,b){const w=this._getServiceInstanceOrDescriptor(u);return w instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,w,b.branch(u,!0)):(b.branch(u,!1),w)}_safeCreateAndCacheServiceInstance(u,b,w){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,b,w)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,b,w){const E=new R.Graph(h=>h.id.toString());let I=0;const g=[{id:u,desc:b,_trace:w}];for(;g.length;){const h=g.pop();if(E.lookupOrInsertNode(h),I++>1e3)throw new p(E);for(const l of M._util.getServiceDependencies(h.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(l.id);if(n||this._throwIfStrict(`[createInstance] ${u} depends on ${l.id} which is NOT registered.`,!0),n instanceof D.SyncDescriptor){const r={id:l.id,desc:n,_trace:h._trace.branch(l.id,!0)};E.insertEdge(h,r),g.push(r)}}}for(;;){const h=E.roots();if(h.length===0){if(!E.isEmpty())throw new p(E);break}for(const{data:l}of h){if(this._getServiceInstanceOrDescriptor(l.id)instanceof D.SyncDescriptor){const r=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,r)}E.removeNode(l)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,b,w=[],E,I){if(this._services.get(u)instanceof D.SyncDescriptor)return this._createServiceInstance(b,w,E,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,b,w,E,I);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}_createServiceInstance(u,b=[],w,E){if(w){const I=new v.IdleValue(()=>this._createInstance(u,b,E));return new Proxy(Object.create(null),{get(g,h){if(h in g)return g[h];const l=I.value;let n=l[h];return typeof n!="function"||(n=n.bind(l),g[h]=n),n},set(g,h,l){return I.value[h]=l,!0}})}else return this._createInstance(u,b,E)}_throwIfStrict(u,b){if(b&&console.warn(u),this._strict)throw new Error(u)}}e.InstantiationService=C;var k;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(k||(k={}));class y{constructor(u,b){this.type=u,this.name=b,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return d?new y(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):y._None}static traceCreation(u){return d?new y(0,u.name):y._None}branch(u,b){const w=new y(2,u.toString());return this._dep.push([u,b,w]),w}stop(){const u=Date.now()-this._start;y._totals+=u;let b=!1;function w(I,g){const h=[],l=new Array(I+1).join("	");for(const[n,r,i]of g._dep)if(r&&i){b=!0,h.push(`${l}CREATES -> ${n}`);const s=w(I+1,i);s&&h.push(s)}else h.push(`${l}uses -> ${n}`);return h.join(`
`)}const E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(u>2||b)&&console.log(E.join(`
`))}}e.Trace=y,y._None=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y._totals=0}),define(Y[6],X([0,1,41,3,2,4,5]),function(z,e,v,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,M.createDecorator)("logService"),e.ILoggerService=(0,M.createDecorator)("loggerService");function S(){return new Date().toISOString()}var d;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function p(r,i,s){switch(i){case d.Trace:r.trace(s);break;case d.Debug:r.debug(s);break;case d.Info:r.info(s);break;case d.Warning:r.warn(s);break;case d.Error:r.error(s);break;case d.Critical:r.critical(s);break;default:throw new Error("Invalid log level")}}e.log=p;function C(r){let i="";for(let s=0;s<r.length;s++){let o=r[s];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(s>0?" ":"")+o}return i}e.format=C;class k extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class y extends k{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...s){this.checkLogLevel(d.Trace)&&this.log(d.Trace,C([i,...s]))}debug(i,...s){this.checkLogLevel(d.Debug)&&this.log(d.Debug,C([i,...s]))}info(i,...s){this.checkLogLevel(d.Info)&&this.log(d.Info,C([i,...s]))}warn(i,...s){this.checkLogLevel(d.Warning)&&this.log(d.Warning,C([i,...s]))}error(i,...s){if(this.checkLogLevel(d.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(d.Error,C(o))}else this.log(d.Error,C([i,...s]))}critical(i,...s){this.checkLogLevel(d.Critical)&&this.log(d.Critical,C([i,...s]))}flush(){}}e.AbstractMessageLogger=y;class m extends k{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!R.isWindows}trace(i,...s){this.getLevel()<=d.Trace&&(this.useColors?console.log(`[90m[main ${S()}][0m`,i,...s):console.log(`[main ${S()}]`,i,...s))}debug(i,...s){this.getLevel()<=d.Debug&&(this.useColors?console.log(`[90m[main ${S()}][0m`,i,...s):console.log(`[main ${S()}]`,i,...s))}info(i,...s){this.getLevel()<=d.Info&&(this.useColors?console.log(`[90m[main ${S()}][0m`,i,...s):console.log(`[main ${S()}]`,i,...s))}warn(i,...s){this.getLevel()<=d.Warning&&(this.useColors?console.warn(`[93m[main ${S()}][0m`,i,...s):console.warn(`[main ${S()}]`,i,...s))}error(i,...s){this.getLevel()<=d.Error&&(this.useColors?console.error(`[91m[main ${S()}][0m`,i,...s):console.error(`[main ${S()}]`,i,...s))}critical(i,...s){this.getLevel()<=d.Critical&&(this.useColors?console.error(`[90m[main ${S()}][0m`,i,...s):console.error(`[main ${S()}]`,i,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class u extends k{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...s){this.getLevel()<=d.Trace&&console.log("%cTRACE","color: #888",i,...s)}debug(i,...s){this.getLevel()<=d.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...s)}info(i,...s){this.getLevel()<=d.Info&&console.log("%c INFO","color: #33f",i,...s)}warn(i,...s){this.getLevel()<=d.Warning&&console.log("%c WARN","color: #993",i,...s)}error(i,...s){this.getLevel()<=d.Error&&console.log("%c  ERR","color: #f33",i,...s)}critical(i,...s){this.getLevel()<=d.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...s)}dispose(){}flush(){}}e.ConsoleLogger=u;class b extends k{constructor(i,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(s)}trace(i,...s){this.getLevel()<=d.Trace&&this.adapter.log(d.Trace,[this.extractMessage(i),...s])}debug(i,...s){this.getLevel()<=d.Debug&&this.adapter.log(d.Debug,[this.extractMessage(i),...s])}info(i,...s){this.getLevel()<=d.Info&&this.adapter.log(d.Info,[this.extractMessage(i),...s])}warn(i,...s){this.getLevel()<=d.Warning&&this.adapter.log(d.Warning,[this.extractMessage(i),...s])}error(i,...s){this.getLevel()<=d.Error&&this.adapter.log(d.Error,[this.extractMessage(i),...s])}critical(i,...s){this.getLevel()<=d.Critical&&this.adapter.log(d.Critical,[this.extractMessage(i),...s])}extractMessage(i){return typeof i=="string"?i:(0,v.toErrorMessage)(i,this.getLevel()<=d.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class w extends k{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const s of this.logServices)s.setLevel(i);super.setLevel(i)}trace(i,...s){for(const o of this.logServices)o.trace(i,...s)}debug(i,...s){for(const o of this.logServices)o.debug(i,...s)}info(i,...s){for(const o of this.logServices)o.info(i,...s)}warn(i,...s){for(const o of this.logServices)o.warn(i,...s)}error(i,...s){for(const o of this.logServices)o.error(i,...s)}critical(i,...s){for(const o of this.logServices)o.critical(i,...s)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=w;class E extends D.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...s){this.logger.trace(i,...s)}debug(i,...s){this.logger.debug(i,...s)}info(i,...s){this.logger.info(i,...s)}warn(i,...s){this.logger.warn(i,...s)}error(i,...s){this.logger.error(i,...s)}critical(i,...s){this.logger.critical(i,...s)}flush(){this.logger.flush()}}e.LogService=E;class I extends D.Disposable{constructor(i,s){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,s){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,s?.always?d.Trace:this.logLevel,s),this.loggers.set(i.toString(),o),s?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=I;class g{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return d.Info}trace(i,...s){}debug(i,...s){}info(i,...s){}warn(i,...s){}error(i,...s){}critical(i,...s){}dispose(){}flush(){}}e.NullLogService=g;function h(r){if(r.verbose)return d.Trace;if(typeof r.logLevel=="string"){const i=l(r.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=h;function l(r){switch(r){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Critical;case"off":return d.Off}}e.parseLogLevel=l;function n(r){switch(r){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Critical:return"critical";case d.Off:return"off"}}e.LogLevelToString=n});var ee=this&&this.__param||function(z,e){return function(v,t){e(v,t,z)}};define(Y[191],X([0,1,68,3,2,6,4]),function(z,e,v,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let S=class yt extends D.Disposable{constructor(p){super();this.logService=p,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(p,C){let k;try{k=await this.withKeytar()}catch{return null}const y=await k.getPassword(p,C);if(y)try{let{content:m,hasNextChunk:u}=JSON.parse(y);if(!m||!u)return y;let b=1;for(;u;){const w=await k.getPassword(p,`${C}-${b}`),E=JSON.parse(w);m+=E.content,u=E.hasNextChunk,b++}return m}catch{return y}return y}async setPassword(p,C,k){let y;try{y=await this.withKeytar()}catch(b){throw this.surfaceKeytarLoadError?.(b),b}const m=3,u=async(b,w,E)=>{let I=0,g;for(;I<m;)try{await y.setPassword(b,w,E);return}catch(h){g=h,this.logService.warn("Error attempting to set a password: ",h?.message??h),I++,await new Promise(l=>setTimeout(l,200))}throw g};if(M.isWindows&&k.length>yt.MAX_PASSWORD_LENGTH){let b=0,w=0,E=!0;for(;E;){const I=k.substring(b,b+yt.PASSWORD_CHUNK_SIZE);b+=yt.PASSWORD_CHUNK_SIZE,E=k.length-b>0;const g={content:I,hasNextChunk:E};await u(p,w?`${C}-${w}`:C,JSON.stringify(g)),w++}}else await u(p,C,k);this._onDidChangePassword.fire({service:p,account:C})}async deletePassword(p,C){let k;try{k=await this.withKeytar()}catch(u){throw this.surfaceKeytarLoadError?.(u),u}const y=await k.getPassword(p,C);if(!y)return!1;const m=await k.deletePassword(p,C);try{let{content:u,hasNextChunk:b}=JSON.parse(y);if(u&&b){let w=1;for(;b;){const E=`${C}-${w}`,I=await k.getPassword(p,E);await k.deletePassword(p,E),b=JSON.parse(I).hasNextChunk,w++}}}catch{}return m&&this._onDidChangePassword.fire({service:p,account:C}),m}async findPassword(p){let C;try{C=await this.withKeytar()}catch{return null}return C.findPassword(p)}async findCredentials(p){let C;try{C=await this.withKeytar()}catch{return[]}return C.findCredentials(p)}clear(){return this._keytarCache instanceof v.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};S.MAX_PASSWORD_LENGTH=2500,S.PASSWORD_CHUNK_SIZE=S.MAX_PASSWORD_LENGTH-100,S=fe([ee(0,R.ILogService)],S),e.BaseCredentialsMainService=S}),define(Y[192],X([0,1,25,8,19,3,2,9,69,6]),function(z,e,v,t,D,R,M,S,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends M.Disposable{constructor(y,m){super();this.logService=y,this.options=m,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(y,m){return m.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(y,m):this.watchNonRecursive(y,m)}watchUniversal(y,m){const u={path:this.toFilePath(y),excludes:m.excludes,includes:m.includes,recursive:m.recursive},b=(0,v.insert)(this.universalPathsToWatch,u);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{b(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(y=>(0,D.onUnexpectedError)(y))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(m=>this._onDidChangeFile.fire((0,d.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===p.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)})));const y=this.options?.watcher?.recursive?.usePolling;if(y===!0)for(const m of this.universalPathsToWatch)(0,d.isRecursiveWatchRequest)(m)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const m of this.universalPathsToWatch)(0,d.isRecursiveWatchRequest)(m)&&y.includes(m.path)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(y,m){const u={path:this.toFilePath(y),excludes:m.excludes,includes:m.includes,recursive:!1},b=(0,v.insert)(this.nonRecursivePathsToWatch,u);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{b(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(y=>(0,D.onUnexpectedError)(y))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(y=>this._onDidChangeFile.fire((0,d.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===p.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(y){y.type==="error"&&this._onDidWatchError.fire(y.message),this.logService[y.type](y.message)}toFilePath(y){return(0,S.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=C}),define(Y[193],X([0,1,25,8,17,21,3,65,54,2,33,12,70,16,55,152,15,102,6]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u,b,w,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let g=class extends p.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(l,n){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${l}`);const r=new p.DisposableStore;return this.provider.set(l,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:n}),r.add(n.onDidChangeFile(i=>this._onDidFilesChange.fire(new w.FileChangesEvent(i,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&r.add(n.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),r.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:l}))),(0,p.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:n}),this.provider.delete(l),(0,p.dispose)(r)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(r){n.push(r)}}),!this.provider.has(l)&&await t.Promises.settled(n)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,n){const r=this.provider.get(l.scheme);return!!(r&&r.capabilities&n)}listCapabilities(){return d.Iterable.map(this.provider,([l,n])=>({scheme:l,capabilities:n.capabilities}))}async withProvider(l){if(!(0,m.isAbsolutePath)(l))throw new w.FileOperationError((0,b.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const n=this.provider.get(l.scheme);if(!n){const r=new Error;throw r.name="ENOPRO",r.message=(0,b.localize)(1,null,l.toString()),r}return n}async withReadProvider(l){const n=await this.withProvider(l);if((0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n)||(0,w.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const n=await this.withProvider(l);if((0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,n){try{return await this.doResolveFile(l,n)}catch(r){throw(0,w.toFileSystemProviderErrorCode)(r)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,b.localize)(2,null,this.resourceForError(l)),1):(0,w.ensureFileSystemProviderError)(r)}}async doResolveFile(l,n){const r=await this.withProvider(l),i=this.isPathCaseSensitive(r),s=n?.resolveTo,o=n?.resolveSingleChildDescendants,a=n?.resolveMetadata,c=await r.stat(l);let f;return this.toFileStat(r,l,c,void 0,!!a,(P,L)=>(f||(f=C.TernarySearchTree.forUris(()=>!i),f.set(l,!0),s&&f.fill(!0,s)),f.get(P.resource)||f.findSuperstr(P.resource.with({query:null,fragment:null}))?!0:P.isDirectory&&o?L===1:!1))}async toFileStat(l,n,r,i,s,o){const{providerExtUri:a}=this.getExtUri(l),c={resource:n,name:a.basename(n),isFile:(r.type&w.FileType.File)!=0,isDirectory:(r.type&w.FileType.Directory)!=0,isSymbolicLink:(r.type&w.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&w.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,w.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(c.isDirectory&&o(c,i)){try{const f=await l.readdir(n),P=await t.Promises.settled(f.map(async([L,T])=>{try{const W=a.joinPath(n,L),$=s?await l.stat(W):{type:T};return await this.toFileStat(l,W,$,f.length,s,o)}catch(W){return this.logService.trace(W),null}}));c.children=(0,v.coalesce)(P)}catch(f){this.logService.trace(f),c.children=[]}return c}return c}async resolveAll(l){return t.Promises.settled(l.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(l){const n=await this.withProvider(l),r=await n.stat(l);return this.toFileStat(n,l,r,void 0,!0,()=>!1)}async exists(l){const n=await this.withProvider(l);try{return!!await n.stat(l)}catch{return!1}}async canCreateFile(l,n){try{await this.doValidateCreateFile(l,n)}catch(r){return r}return!0}async doValidateCreateFile(l,n){if(!n?.overwrite&&await this.exists(l))throw new w.FileOperationError((0,b.localize)(3,null,this.resourceForError(l)),3,n)}async createFile(l,n=D.VSBuffer.fromString(""),r){await this.doValidateCreateFile(l,r);const i=await this.writeFile(l,n);return this._onDidRunOperation.fire(new w.FileOperationEvent(l,0,i)),i}async writeFile(l,n,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:s}=this.getExtUri(i);try{await this.validateWriteFile(i,l,r)||await this.mkdirp(i,s.dirname(l));let a;if((0,w.hasReadWriteCapability)(i)&&!(n instanceof D.VSBuffer))if((0,u.isReadableStream)(n)){const c=await(0,u.peekStream)(n,3);c.ended?a=D.VSBuffer.concat(c.buffer):a=c}else a=(0,u.peekReadable)(n,c=>D.VSBuffer.concat(c),3);else a=n;!(0,w.hasOpenReadWriteCloseCapability)(i)||(0,w.hasReadWriteCapability)(i)&&a instanceof D.VSBuffer?await this.doWriteUnbuffered(i,l,r,a):await this.doWriteBuffered(i,l,r,a instanceof D.VSBuffer?(0,D.bufferToReadable)(a):a),this._onDidRunOperation.fire(new w.FileOperationEvent(l,4))}catch(o){throw new w.FileOperationError((0,b.localize)(4,null,this.resourceForError(l),(0,w.ensureFileSystemProviderError)(o).toString()),(0,w.toFileOperationResult)(o),r)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,n,r){if(!!r?.unlock&&!(l.capabilities&8192))throw new Error((0,b.localize)(5,null,this.resourceForError(n)));let s;try{s=await l.stat(n)}catch{return}if((s.type&w.FileType.Directory)!=0)throw new w.FileOperationError((0,b.localize)(6,null,this.resourceForError(n)),0,r);if(this.throwIfFileIsReadonly(n,s),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==w.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&r.mtime<s.mtime&&r.etag!==(0,w.etag)({mtime:r.mtime,size:s.size}))throw new w.FileOperationError((0,b.localize)(7,null),3,r);return s}async readFile(l,n,r){const i=await this.withReadProvider(l);return n?.atomic?this.doReadFileAtomic(i,l,n,r):this.doReadFile(i,l,n,r)}async doReadFileAtomic(l,n,r,i){return new Promise((s,o)=>{this.writeQueue.queueFor(n,this.getExtUri(l).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(l,n,r,i);s(a)}catch(a){o(a)}})})}async doReadFile(l,n,r,i){const s=await this.doReadFileStream(l,n,{...r,preferUnbuffered:!0},i);return{...s,value:await(0,D.streamToBuffer)(s.value)}}async readFileStream(l,n,r){const i=await this.withReadProvider(l);return this.doReadFileStream(i,l,n,r)}async doReadFileStream(l,n,r,i){const s=new R.CancellationTokenSource(i),o=this.validateReadFile(n,r).then(c=>c,c=>{throw s.cancel(),c});let a;try{return typeof r?.etag=="string"&&r.etag!==w.ETAG_DISABLED&&await o,r?.atomic&&(0,w.hasFileAtomicReadCapability)(l)||!((0,w.hasOpenReadWriteCloseCapability)(l)||(0,w.hasFileReadStreamCapability)(l))||(0,w.hasReadWriteCapability)(l)&&r?.preferUnbuffered?a=this.readFileUnbuffered(l,n,r):(0,w.hasFileReadStreamCapability)(l)?a=this.readFileStreamed(l,n,s.token,r):a=this.readFileBuffered(l,n,s.token,r),{...await o,value:a}}catch(c){a&&await(0,u.consumeStream)(a);const f=(0,b.localize)(8,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(c).toString());throw c instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(f,c.stat,r):new w.FileOperationError(f,(0,w.toFileOperationResult)(c),r)}}readFileStreamed(l,n,r,i=Object.create(null)){const s=l.readFileStream(n,i,r);return(0,u.transform)(s,{data:o=>o instanceof D.VSBuffer?o:D.VSBuffer.wrap(o),error:o=>new w.FileOperationError((0,b.localize)(9,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(o).toString()),(0,w.toFileOperationResult)(o),i)},o=>D.VSBuffer.concat(o))}readFileBuffered(l,n,r,i=Object.create(null)){const s=(0,D.newWriteableBufferStream)();return(0,E.readFileIntoStream)(l,n,s,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new w.FileOperationError((0,b.localize)(10,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(o).toString()),(0,w.toFileOperationResult)(o),i)},r),s}readFileUnbuffered(l,n,r){const i=(0,u.newWriteableStream)(s=>D.VSBuffer.concat(s));return(async()=>{try{let s;r?.atomic&&(0,w.hasFileAtomicReadCapability)(l)?s=await l.readFile(n,{atomic:!0}):s=await l.readFile(n),typeof r?.position=="number"&&(s=s.slice(r.position)),typeof r?.length=="number"&&(s=s.slice(0,r.length)),this.validateReadFileLimits(n,s.byteLength,r),i.end(D.VSBuffer.wrap(s))}catch(s){i.error(s),i.end()}})(),i}async validateReadFile(l,n){const r=await this.resolve(l,{resolveMetadata:!0});if(r.isDirectory)throw new w.FileOperationError((0,b.localize)(11,null,this.resourceForError(l)),0,n);if(typeof n?.etag=="string"&&n.etag!==w.ETAG_DISABLED&&n.etag===r.etag)throw new w.NotModifiedSinceFileOperationError((0,b.localize)(12,null),r,n);return this.validateReadFileLimits(l,r.size,n),r}validateReadFileLimits(l,n,r){if(r?.limits){let i;if(typeof r.limits.memory=="number"&&n>r.limits.memory&&(i=9),typeof r.limits.size=="number"&&n>r.limits.size&&(i=7),typeof i=="number")throw new w.FileOperationError((0,b.localize)(13,null,this.resourceForError(l)),i)}}async canMove(l,n,r){return this.doCanMoveCopy(l,n,"move",r)}async canCopy(l,n,r){return this.doCanMoveCopy(l,n,"copy",r)}async doCanMoveCopy(l,n,r,i){if(l.toString()!==n.toString())try{const s=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(s,l,o,n,r,i)}catch(s){return s}return!0}async move(l,n,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),o=await this.doMoveCopy(i,l,s,n,"move",!!r),a=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(l,o==="move"?2:3,a)),a}async copy(l,n,r){const i=await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),o=await this.doMoveCopy(i,l,s,n,"copy",!!r),a=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(l,o==="copy"?3:2,a)),a}async doMoveCopy(l,n,r,i,s,o){if(n.toString()===i.toString())return s;const{exists:a,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(l,n,r,i,s,o);if(a&&!c&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(i)),s==="copy"){if(l===r&&(0,w.hasFileFolderCopyCapability)(l))await l.copy(n,i,{overwrite:o});else{const f=await this.resolve(n);f.isDirectory?await this.doCopyFolder(l,f,r,i):await this.doCopyFile(l,n,r,i)}return s}else return l===r?(await l.rename(n,i,{overwrite:o}),s):(await this.doMoveCopy(l,n,r,i,"copy",o),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(l,n,r,i){if((0,w.hasOpenReadWriteCloseCapability)(l)&&(0,w.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(l,n,r,i);if((0,w.hasOpenReadWriteCloseCapability)(l)&&(0,w.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(l,n,r,i);if((0,w.hasReadWriteCapability)(l)&&(0,w.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(l,n,r,i);if((0,w.hasReadWriteCapability)(l)&&(0,w.hasReadWriteCapability)(r))return this.doPipeUnbuffered(l,n,r,i)}async doCopyFolder(l,n,r,i){await r.mkdir(i),Array.isArray(n.children)&&await t.Promises.settled(n.children.map(async s=>{const o=this.getExtUri(r).providerExtUri.joinPath(i,s.name);return s.isDirectory?this.doCopyFolder(l,await this.resolve(s.resource),r,o):this.doCopyFile(l,s.resource,r,o)}))}async doValidateMoveCopy(l,n,r,i,s,o){let a=!1;if(l===r){const{providerExtUri:f,isPathCaseSensitive:P}=this.getExtUri(l);if(P||(a=f.isEqual(n,i)),a&&s==="copy")throw new Error((0,b.localize)(14,null,this.resourceForError(n),this.resourceForError(i)));if(!a&&f.isEqualOrParent(i,n))throw new Error((0,b.localize)(15,null,this.resourceForError(n),this.resourceForError(i)))}const c=await this.exists(i);if(c&&!a){if(!o)throw new w.FileOperationError((0,b.localize)(16,null,this.resourceForError(n),this.resourceForError(i)),4);if(l===r){const{providerExtUri:f}=this.getExtUri(l);if(f.isEqualOrParent(n,i))throw new Error((0,b.localize)(17,null,this.resourceForError(n),this.resourceForError(i)))}}return{exists:c,isSameResourceWithDifferentPathCase:a}}getExtUri(l){const n=this.isPathCaseSensitive(l);return{providerExtUri:n?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(n,l);const r=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(l,0,r)),r}async mkdirp(l,n){const r=[],{providerExtUri:i}=this.getExtUri(l);for(;!i.isEqual(n,i.dirname(n));)try{if(((await l.stat(n)).type&w.FileType.Directory)==0)throw new Error((0,b.localize)(18,null,this.resourceForError(n)));break}catch(s){if((0,w.toFileSystemProviderErrorCode)(s)!==w.FileSystemProviderErrorCode.FileNotFound)throw s;r.push(i.basename(n)),n=i.dirname(n)}for(let s=r.length-1;s>=0;s--){n=i.joinPath(n,r[s]);try{await l.mkdir(n)}catch(o){if((0,w.toFileSystemProviderErrorCode)(o)!==w.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(l,n){try{await this.doValidateDelete(l,n)}catch(r){return r}return!0}async doValidateDelete(l,n){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!n?.useTrash&&!(r.capabilities&4096))throw new Error((0,b.localize)(19,null,this.resourceForError(l)));let s;try{s=await r.stat(l)}catch{}if(s)this.throwIfFileIsReadonly(l,s);else throw new w.FileOperationError((0,b.localize)(20,null,this.resourceForError(l)),1);if(!!!n?.recursive){const a=await this.resolve(l);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,b.localize)(21,null,this.resourceForError(l)))}return r}async del(l,n){const r=await this.doValidateDelete(l,n),i=!!n?.useTrash,s=!!n?.recursive;await r.delete(l,{recursive:s,useTrash:i}),this._onDidRunOperation.fire(new w.FileOperationEvent(l,1))}async cloneFile(l,n){const r=await this.withProvider(l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(r===i&&this.getExtUri(r).providerExtUri.isEqual(l,n))return;if(r===i&&(0,w.hasFileCloneCapability)(r))return r.cloneFile(l,n);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n));const s=this.writeQueue.queueFor(l,this.getExtUri(r).providerExtUri);return r===i&&(0,w.hasFileFolderCopyCapability)(r)?s.queue(()=>r.copy(l,n,{overwrite:!0})):s.queue(()=>this.doCopyFile(r,l,i,n))}watch(l,n={recursive:!1,excludes:[]}){const r=new p.DisposableStore;let i=!1,s=()=>{i=!0};return r.add((0,p.toDisposable)(()=>s())),(async()=>{try{const o=await this.doWatch(l,n);i?(0,p.dispose)(o):s=()=>(0,p.dispose)(o)}catch(o){this.logService.error(o)}})(),r}async doWatch(l,n){const r=await this.withProvider(l),i=(0,S.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(l),n]);let s=this.activeWatchers.get(i);return s||(s={count:0,disposable:r.watch(l,n)},this.activeWatchers.set(i,s)),s.count+=1,(0,p.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,p.dispose)(s.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,p.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,n,r,i){return this.writeQueue.queueFor(n,this.getExtUri(l).providerExtUri).queue(async()=>{const s=await l.open(n,{create:!0,unlock:r?.unlock??!1});try{(0,u.isReadableStream)(i)||(0,u.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(l,s,i):await this.doWriteReadableBufferedQueued(l,s,i)}catch(o){throw(0,w.ensureFileSystemProviderError)(o)}finally{await l.close(s)}})}async doWriteStreamBufferedQueued(l,n,r){let i=0,s;if((0,u.isReadableBufferedStream)(r)){if(r.buffer.length>0){const o=D.VSBuffer.concat(r.buffer);await this.doWriteBuffer(l,n,o,o.byteLength,i,0),i+=o.byteLength}if(r.ended)return;s=r.stream}else s=r;return new Promise((o,a)=>{(0,u.listenStream)(s,{onData:async c=>{s.pause();try{await this.doWriteBuffer(l,n,c,c.byteLength,i,0)}catch(f){return a(f)}i+=c.byteLength,setTimeout(()=>s.resume())},onError:c=>a(c),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(l,n,r){let i=0,s;for(;(s=r.read())!==null;)await this.doWriteBuffer(l,n,s,s.byteLength,i,0),i+=s.byteLength}async doWriteBuffer(l,n,r,i,s,o){let a=0;for(;a<i;)a+=await l.write(n,s+a,r.buffer,o+a,i-a)}async doWriteUnbuffered(l,n,r,i){return this.writeQueue.queueFor(n,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,n,r,i))}async doWriteUnbufferedQueued(l,n,r,i){let s;i instanceof D.VSBuffer?s=i:(0,u.isReadableStream)(i)?s=await(0,D.streamToBuffer)(i):(0,u.isReadableBufferedStream)(i)?s=await(0,D.bufferedStreamToBuffer)(i):s=(0,D.readableToBuffer)(i),await l.writeFile(n,s.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(l,n,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,n,r,i))}async doPipeBufferedQueued(l,n,r,i){let s,o;try{s=await l.open(n,{create:!1}),o=await r.open(i,{create:!0,unlock:!1});const a=D.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,f=0,P=0;do P=await l.read(s,c,a.buffer,f,a.byteLength-f),await this.doWriteBuffer(r,o,a,P,c,f),c+=P,f+=P,f===a.byteLength&&(f=0);while(P>0)}catch(a){throw(0,w.ensureFileSystemProviderError)(a)}finally{await t.Promises.settled([typeof s=="number"?l.close(s):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async doPipeUnbuffered(l,n,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,n,r,i))}async doPipeUnbufferedQueued(l,n,r,i){return r.writeFile(i,await l.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,n,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,n,r,i))}async doPipeUnbufferedToBufferedQueued(l,n,r,i){const s=await r.open(i,{create:!0,unlock:!1});try{const o=await l.readFile(n);await this.doWriteBuffer(r,s,D.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,w.ensureFileSystemProviderError)(o)}finally{await r.close(s)}}async doPipeBufferedToUnbuffered(l,n,r,i){const s=await(0,D.streamToBuffer)(this.readFileBuffered(l,n,R.CancellationToken.None));await this.doWriteUnbuffered(r,i,void 0,s)}throwIfFileSystemIsReadonly(l,n){if(l.capabilities&2048)throw new w.FileOperationError((0,b.localize)(22,null,this.resourceForError(n)),6);return l}throwIfFileIsReadonly(l,n){if((n.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,b.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===k.Schemas.file?l.fsPath:l.toString(!0)}};g=fe([ee(0,I.ILogService)],g),e.FileService=g}),define(Y[85],X([0,1,27,263,8,33,17,3,29,2,9,4,16,55,23,156,15,102,192,41,189,188]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u,b,w,E,I,g,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(v)}catch(r){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(r)}`)}})();class n extends I.AbstractDiskFileSystemProvider{constructor(i,s){super(i,s);this.onDidChangeCapabilities=S.Event.None,this.resourceLocks=new R.ResourceMap(o=>y.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:s,symbolicLink:o}=await u.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(s,o),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(i){try{const s=await u.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(s.map(async a=>{try{let c;a.isSymbolicLink()?c=(await this.stat((0,y.joinPath)(i,a.name))).type:c=this.toType(a),o.push([a.name,c])}catch(c){this.logService.trace(c)}})),o}catch(s){throw this.toFileSystemProviderError(s)}}toType(i,s){let o;return s?.dangling?o=w.FileType.Unknown:i.isFile()?o=w.FileType.File:i.isDirectory()?o=w.FileType.Directory:o=w.FileType.Unknown,s&&(o|=w.FileType.SymbolicLink),o}async createResourceLock(i){const s=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let o;for(;o=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await o.wait();const a=new D.Barrier;return this.resourceLocks.set(i,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,p.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.resourceLocks.get(i)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),a.open()})}async readFile(i,s){let o;try{s?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const a=this.toFilePath(i);return await u.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{o?.dispose()}}readFileStream(i,s,o){const a=(0,m.newWriteableStream)(c=>M.VSBuffer.concat(c.map(f=>M.VSBuffer.wrap(f))).buffer);return(0,E.readFileIntoStream)(this,i,a,c=>c.buffer,{...s,bufferSize:256*1024},o),a}async writeFile(i,s,o){let a;try{const c=this.toFilePath(i);if(!o.create||!o.overwrite){if(await u.Promises.exists(c)){if(!o.overwrite)throw(0,w.createFileSystemProviderError)((0,b.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,w.createFileSystemProviderError)((0,b.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(a,0,s,0,s.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(i,c)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(i){n.canFlush=i}async open(i,s){const o=this.toFilePath(i);let a;(0,w.isFileOpenForWriteOptions)(s)&&(a=await this.createResourceLock(i));let c;try{if((0,w.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:P}=await u.SymlinkSupport.stat(o);P.mode&128||await u.Promises.chmod(o,P.mode|128)}catch(P){this.logService.trace(P)}let f;if((0,w.isFileOpenForWriteOptions)(s)){if(k.isWindows)try{await u.Promises.truncate(o,0),f="r+"}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}f||(f="w")}else f="r";c=await u.Promises.open(o,f)}catch(f){throw a?.dispose(),(0,w.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(i,f):this.toFileSystemProviderError(f)}if(this.mapHandleToPos.set(c,0),(0,w.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(c,i),a){const f=this.mapHandleToLock.get(c);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${o})`),this.mapHandleToLock.set(c,a),f&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${o})`),f.dispose())}return c}async close(i){const s=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&n.canFlush)try{await u.Promises.fdatasync(i)}catch(o){n.configureFlushOnWrite(!1),this.logService.error(o)}return await u.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}finally{s&&(this.mapHandleToLock.get(i)===s&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),s.dispose())}}async read(i,s,o,a,c){const f=this.normalizePos(i,s);let P=null;try{P=(await u.Promises.read(i,o,a,c,f)).bytesRead}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(i,f,P)}return P}normalizePos(i,s){return s===this.mapHandleToPos.get(i)?null:s}updatePos(i,s,o){const a=this.mapHandleToPos.get(i);typeof a=="number"&&(typeof s=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,a+o):this.mapHandleToPos.delete(i)))}async write(i,s,o,a,c){return(0,D.retry)(()=>this.doWrite(i,s,o,a,c),100,3)}async doWrite(i,s,o,a,c){const f=this.normalizePos(i,s);let P=null;try{P=(await u.Promises.write(i,o,a,c,f)).bytesWritten}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),L)}finally{this.updatePos(i,f,P)}return P}async mkdir(i){try{await u.Promises.mkdir(this.toFilePath(i))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(i,s){try{const o=this.toFilePath(i);s.recursive?await u.Promises.rm(o,u.RimRafMode.MOVE):await u.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,s,o){const a=this.toFilePath(i),c=this.toFilePath(s);if(a!==c)try{await this.validateTargetDeleted(i,s,"move",o.overwrite),await u.Promises.move(a,c)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,b.localize)(2,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(c)),f.toString()))),this.toFileSystemProviderError(f)}}async copy(i,s,o){const a=this.toFilePath(i),c=this.toFilePath(s);if(a!==c)try{await this.validateTargetDeleted(i,s,"copy",o.overwrite),await u.Promises.copy(a,c,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,b.localize)(3,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(c)),f.toString()))),this.toFileSystemProviderError(f)}}async validateTargetDeleted(i,s,o,a){const c=this.toFilePath(i),f=this.toFilePath(s);let P=!1;if(!!(this.capabilities&1024)||(P=(0,d.isEqual)(c,f,!0)),P&&o==="copy")throw(0,w.createFileSystemProviderError)((0,b.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!P&&await u.Promises.exists(f)){if(!a)throw(0,w.createFileSystemProviderError)((0,b.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}async cloneFile(i,s){return this.doCloneFile(i,s,!1)}async doCloneFile(i,s,o){const a=this.toFilePath(i),c=this.toFilePath(s),f=!!(this.capabilities&1024);if((0,d.isEqual)(a,c,!f))return;const P=new p.DisposableStore;try{const[L,T]=await Promise.all([this.createResourceLock(i),this.createResourceLock(s)]);P.add(L),P.add(T),o&&await u.Promises.mkdir((0,C.dirname)(c),{recursive:!0}),await u.Promises.copyFile(a,c)}catch(L){if(L.code==="ENOENT"&&!o)return this.doCloneFile(i,s,!0);throw this.toFileSystemProviderError(L)}finally{P.dispose()}}createUniversalWatcher(i,s,o){return new h.UniversalWatcherClient(a=>i(a),a=>s(a),o)}createNonRecursiveWatcher(i,s,o){return new l.NodeJSWatcherClient(a=>i(a),a=>s(a),o)}toFileSystemProviderError(i){if(i instanceof w.FileSystemProviderError)return i;let s;switch(i.code){case"ENOENT":s=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=w.FileSystemProviderErrorCode.NoPermissions;break;default:s=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(i,s)}async toFileSystemProviderWriteError(i,s){let o=this.toFileSystemProviderError(s);if(i&&o.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await u.SymlinkSupport.stat(this.toFilePath(i));a.mode&128||(o=(0,w.createFileSystemProviderError)(s,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return o}}e.DiskFileSystemProvider=n,n.canFlush=!0}),define(Y[194],X([0,1,3,85,2,17,55,21]),function(z,e,v,t,D,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class d extends D.Disposable{constructor(k,y){super();this.provider=k,this.logService=y,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(k,y,m){const u=this.getUriTransformer(k);switch(y){case"stat":return this.stat(u,m[0]);case"readdir":return this.readdir(u,m[0]);case"open":return this.open(u,m[0],m[1]);case"close":return this.close(m[0]);case"read":return this.read(m[0],m[1],m[2]);case"readFile":return this.readFile(u,m[0],m[1]);case"write":return this.write(m[0],m[1],m[2],m[3],m[4]);case"writeFile":return this.writeFile(u,m[0],m[1],m[2]);case"rename":return this.rename(u,m[0],m[1],m[2]);case"copy":return this.copy(u,m[0],m[1],m[2]);case"cloneFile":return this.cloneFile(u,m[0],m[1]);case"mkdir":return this.mkdir(u,m[0]);case"delete":return this.delete(u,m[0],m[1]);case"watch":return this.watch(u,m[0],m[1],m[2],m[3]);case"unwatch":return this.unwatch(m[0],m[1])}throw new Error(`IPC Command ${y} not found`)}listen(k,y,m){const u=this.getUriTransformer(k);switch(y){case"fileChange":return this.onFileChange(u,m[0]);case"readFileStream":return this.onReadFileStream(u,m[0],m[1])}throw new Error(`Unknown event ${y}`)}stat(k,y){const m=this.transformIncoming(k,y,!0);return this.provider.stat(m)}readdir(k,y){const m=this.transformIncoming(k,y);return this.provider.readdir(m)}async readFile(k,y,m){const u=this.transformIncoming(k,y,!0),b=await this.provider.readFile(u,m);return R.VSBuffer.wrap(b)}onReadFileStream(k,y,m){const u=this.transformIncoming(k,y,!0),b=new S.CancellationTokenSource,w=new v.Emitter({onLastListenerRemove:()=>{b.cancel()}}),E=this.provider.readFileStream(u,m,b.token);return(0,M.listenStream)(E,{onData:I=>w.fire(R.VSBuffer.wrap(I)),onError:I=>w.fire(I),onEnd:()=>{w.fire("end"),w.dispose(),b.dispose()}}),w.event}writeFile(k,y,m,u){const b=this.transformIncoming(k,y);return this.provider.writeFile(b,m.buffer,u)}open(k,y,m){const u=this.transformIncoming(k,y,!0);return this.provider.open(u,m)}close(k){return this.provider.close(k)}async read(k,y,m){const u=R.VSBuffer.alloc(m),b=0,w=await this.provider.read(k,y,u.buffer,b,m);return[u,w]}write(k,y,m,u,b){return this.provider.write(k,y,m.buffer,u,b)}mkdir(k,y){const m=this.transformIncoming(k,y);return this.provider.mkdir(m)}delete(k,y,m){const u=this.transformIncoming(k,y);return this.provider.delete(u,m)}rename(k,y,m,u){const b=this.transformIncoming(k,y),w=this.transformIncoming(k,m);return this.provider.rename(b,w,u)}copy(k,y,m,u){const b=this.transformIncoming(k,y),w=this.transformIncoming(k,m);return this.provider.copy(b,w,u)}cloneFile(k,y,m){const u=this.transformIncoming(k,y),b=this.transformIncoming(k,m);return this.provider.cloneFile(u,b)}onFileChange(k,y){const m=new v.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(y,this.createSessionFileWatcher(k,m))},onLastListenerRemove:()=>{(0,D.dispose)(this.sessionToWatcher.get(y)),this.sessionToWatcher.delete(y)}});return m.event}async watch(k,y,m,u,b){const w=this.sessionToWatcher.get(y);if(w){const E=this.transformIncoming(k,u),I=w.watch(m,E,b);this.watchRequests.set(y+m,I)}}async unwatch(k,y){const m=k+y,u=this.watchRequests.get(m);u&&((0,D.dispose)(u),this.watchRequests.delete(m))}dispose(){super.dispose();for(const[,k]of this.watchRequests)k.dispose();this.watchRequests.clear();for(const[,k]of this.sessionToWatcher)k.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=d;class p extends D.Disposable{constructor(k,y,m,u){super();this.uriTransformer=k,this.logService=m,this.environmentService=u,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(y)}registerListeners(k){const y=this._register(new v.Emitter);this._register(y.event(m=>{k.fire(m.map(u=>({resource:this.uriTransformer.transformOutgoingURI(u.resource),type:u.type})))})),this._register(this.fileWatcher.onDidChangeFile(m=>y.fire(m))),this._register(this.fileWatcher.onDidWatchError(m=>k.fire(m)))}getRecursiveWatcherOptions(k){}getExtraExcludes(k){}watch(k,y,m){const u=this.getExtraExcludes(this.environmentService);return Array.isArray(u)&&(m.excludes=[...m.excludes,...u]),this.watcherRequests.set(k,this.fileWatcher.watch(y,m)),(0,D.toDisposable)(()=>{(0,D.dispose)(this.watcherRequests.get(k)),this.watcherRequests.delete(k)})}dispose(){super.dispose();for(const[,k]of this.watcherRequests)k.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=p}),define(Y[195],X([0,1,14,155,4,7,15,9,194,136]),function(z,e,v,t,D,R,M,S,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class C extends d.AbstractDiskFileSystemProviderChannel{constructor(m,u,b){super(m,u);this.environmentService=b}getUriTransformer(m){return p.DefaultURITransformer}transformIncoming(m,u){return R.URI.revive(u)}async delete(m,u,b){if(!b.useTrash)return super.delete(m,u,b);const w=this.transformIncoming(m,u),E=(0,S.normalize)(w.fsPath);try{await v.shell.trashItem(E)}catch{throw(0,M.createFileSystemProviderError)(D.isWindows?(0,t.localize)(0,null,(0,S.basename)(E)):(0,t.localize)(1,null,(0,S.basename)(E)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(m,u){return new k(m,u,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=C;class k extends d.AbstractSessionFileWatcher{watch(m,u,b){if(b.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(m,u,b)}}}),define(Y[103],X([0,1,6]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,M){switch(M){case v.LogLevel.Trace:return R.trace;case v.LogLevel.Debug:return R.debug;case v.LogLevel.Info:return R.info;case v.LogLevel.Warning:return R.warn;case v.LogLevel.Error:return R.error;case v.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class D extends v.AbstractLogger{constructor(M=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(S=>{this._logger?.setLevel(S)}))}set logger(M){this._logger=M;for(const{level:S,args:d}of this.buffer)t(M,S).apply(M,d);this.buffer=[]}_log(M,...S){this._logger?t(this._logger,M).apply(this._logger,S):this.getLevel()<=M&&this.buffer.push({level:M,args:S})}trace(M,...S){this._log(v.LogLevel.Trace,M,...S)}debug(M,...S){this._log(v.LogLevel.Debug,M,...S)}info(M,...S){this._log(v.LogLevel.Info,M,...S)}warn(M,...S){this._log(v.LogLevel.Warning,M,...S)}error(M,...S){this._log(v.LogLevel.Error,M,...S)}critical(M,...S){this._log(v.LogLevel.Critical,M,...S)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(Y[196],X([0,1,8,17,16,15,5,103,6]),function(z,e,v,t,D,R,M,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const p=5*R.ByteSize.MB;let C=class extends d.AbstractLogger{constructor(m,u,b,w,E){super();this.name=m,this.resource=u,this.donotUseFormatters=w,this.fileService=E,this.backupIndex=1,this.setLevel(b),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=d.LogLevel.Trace&&this._log(d.LogLevel.Trace,(0,d.format)(arguments))}debug(){this.getLevel()<=d.LogLevel.Debug&&this._log(d.LogLevel.Debug,(0,d.format)(arguments))}info(){this.getLevel()<=d.LogLevel.Info&&this._log(d.LogLevel.Info,(0,d.format)(arguments))}warn(){this.getLevel()<=d.LogLevel.Warning&&this._log(d.LogLevel.Warning,(0,d.format)(arguments))}error(){if(this.getLevel()<=d.LogLevel.Error){const m=arguments[0];if(m instanceof Error){const u=Array.prototype.slice.call(arguments);u[0]=m.stack,this._log(d.LogLevel.Error,(0,d.format)(u))}else this._log(d.LogLevel.Error,(0,d.format)(arguments))}}critical(){this.getLevel()<=d.LogLevel.Critical&&this._log(d.LogLevel.Critical,(0,d.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(m){if(m.fileOperationResult!==3)throw m}}_log(m,u){this.queue.queue(async()=>{await this.initializePromise;let b=await this.loadContent();b.length>p&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(b)),b=""),this.donotUseFormatters?b+=u:b+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(m)}] ${u}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(b))})}getCurrentTimestamp(){const m=w=>w<10?`0${w}`:w,u=w=>w<10?`00${w}`:w<100?`0${w}`:w,b=new Date;return`${b.getFullYear()}-${m(b.getMonth()+1)}-${m(b.getDate())} ${m(b.getHours())}:${m(b.getMinutes())}:${m(b.getSeconds())}.${u(b.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,D.joinPath)((0,D.dirname)(this.resource),`${(0,D.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(m){switch(m){case d.LogLevel.Critical:return"critical";case d.LogLevel.Debug:return"debug";case d.LogLevel.Error:return"error";case d.LogLevel.Info:return"info";case d.LogLevel.Trace:return"trace";case d.LogLevel.Warning:return"warning"}return""}};C=fe([ee(4,R.IFileService)],C),e.FileLogger=C;let k=class extends d.AbstractLoggerService{constructor(m,u,b){super(m.getLevel(),m.onDidChangeLogLevel);this.instantiationService=u,this.fileService=b}doCreateLogger(m,u,b){const w=new S.BufferLogService(u);return(0,R.whenProviderRegistered)(m,this.fileService).then(()=>w.logger=this.instantiationService.createInstance(C,b?.name||(0,D.basename)(m),m,w.getLevel(),!!b?.donotUseFormatters)),w}};k=fe([ee(0,d.ILogService),ee(1,M.IInstantiationService),ee(2,R.IFileService)],k),e.FileLoggerService=k}),define(Y[197],X([0,1,3,7,6]),function(z,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(y){this.service=y,this.onDidChangeLogLevel=v.Event.buffer(y.onDidChangeLogLevel,!0)}listen(y,m){switch(m){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${m}`)}async call(y,m,u){switch(m){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${m}`)}}e.LogLevelChannel=R;class M{constructor(y){this.channel=y}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(y){M.setLevel(this.channel,y)}static setLevel(y,m){return y.call("setLevel",m)}}e.LogLevelChannelClient=M;class S{constructor(y){this.loggerService=y,this.loggers=new Map}listen(y,m){throw new Error(`Event not found: ${m}`)}async call(y,m,u){switch(m){case"createLogger":this.createLogger(t.URI.revive(u[0]),u[1]);return;case"log":return this.log(t.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${m}`)}createLogger(y,m){this.loggers.set(y.toString(),this.loggerService.createLogger(y,m))}consoleLog(y,m){let u=console.log;switch(y){case D.LogLevel.Error:u=console.error;break;case D.LogLevel.Warning:u=console.warn;break;case D.LogLevel.Info:u=console.info;break}u.call(console,...m)}log(y,m){const u=this.loggers.get(y.toString());if(!u)throw new Error("Create the logger before logging");for(const[b,w]of m)(0,D.log)(u,b,w)}}e.LoggerChannel=S;class d extends D.AbstractLoggerService{constructor(y,m,u){super(y,m);this.channel=u}createConsoleMainLogger(){return new D.AdapterLogger({log:(y,m)=>{this.channel.call("consoleLog",[y,m])}})}doCreateLogger(y,m,u){return new p(this.channel,y,m,u)}}e.LoggerChannelClient=d;class p extends D.AbstractMessageLogger{constructor(y,m,u,b){super(b?.always);this.channel=y,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[m,b]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,m){const u=[[y,m]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(y){this.channel.call("log",[this.file,y])}}class C extends D.LogService{constructor(y,m){super(m);this.parent=y,this._register(y.onDidChangeLogLevel(u=>m.setLevel(u)))}setLevel(y){super.setLevel(y),this.parent.setLevel(y)}}e.FollowerLogService=C}),define(Y[104],X([0,1,15,6]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(S,d,p,C,k){try{const y=await new Promise((u,b)=>{z(["spdlog"],u,b)});y.setFlushOn(t.LogLevel.Trace);const m=await y.createAsyncRotatingLogger(S,d,p,C);return k&&m.clearFormatters(),m}catch(y){console.error(y)}return null}function R(S,d,p){switch(d){case t.LogLevel.Trace:S.trace(p);break;case t.LogLevel.Debug:S.debug(p);break;case t.LogLevel.Info:S.info(p);break;case t.LogLevel.Warning:S.warn(p);break;case t.LogLevel.Error:S.error(p);break;case t.LogLevel.Critical:S.critical(p);break;default:throw new Error("Invalid log level")}}class M extends t.AbstractMessageLogger{constructor(d,p,C,k,y){super();this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(d,p,C,k),this._register(this.onDidChangeLogLevel(m=>{this._logger?.setLevel(m)}))}async _createSpdLogLogger(d,p,C,k){const y=C?6:1,m=30/y*v.ByteSize.MB,u=await D(d,p,m,y,k);if(u){this._logger=u,this._logger.setLevel(this.getLevel());for(const{level:b,message:w}of this.buffer)R(this._logger,b,w);this.buffer=[]}}log(d,p){this._logger?R(this._logger,d,p):this.getLevel()<=d&&this.buffer.push({level:d,message:p})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=M}),define(Y[198],X([0,1,12,16,30,15,196,6,104]),function(z,e,v,t,D,R,M,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let p=class extends S.AbstractLoggerService{constructor(k,y){super(k.getLevel(),k.onDidChangeLogLevel);this.fileService=y}doCreateLogger(k,y,m){return k.scheme===v.Schemas.file?new d.SpdLogLogger(m?.name||(0,D.generateUuid)(),k.fsPath,!m?.donotRotate,!!m?.donotUseFormatters,y):new M.FileLogger(m?.name??(0,t.basename)(k),k,y,!!m?.donotUseFormatters,this.fileService)}};p=fe([ee(0,S.ILogService),ee(1,R.IFileService)],p),e.LoggerService=p}),define(Y[199],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function t(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function D(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function R(M){return!v(M)&&!t(M)&&!D(M)}e.isMenubarMenuItemAction=R}),define(Y[37],X([0,1,3,54,2,5]),function(z,e,v,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class M extends D.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(p){const C=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...p,...this.policyDefinitions},C!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(p),t.Iterable.reduce(this.policies.entries(),(k,[y,m])=>({...k,[y]:m}),{})}getPolicyValue(p){return this.policies.get(p)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(p,[C,k])=>({...p,[C]:{definition:k,value:this.policies.get(C)}}),{})}}e.AbstractPolicyService=M;class S{constructor(){this.onDidChange=v.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=S}),define(Y[200],X([0,1,8,3,54,13,15,6,37]),function(z,e,v,t,D,R,M,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function p(k,y){const m=[];for(const u of D.Iterable.concat(k.keys(),y.keys()))k.get(u)!==y.get(u)&&m.push(u);return m}let C=class extends d.AbstractPolicyService{constructor(y,m,u){super();this.file=y,this.fileService=m,this.logService=u,this.throttledDelayer=this._register(new v.ThrottledDelayer(500));const b=t.Event.filter(m.onDidFilesChange,w=>w.affects(y));this._register(m.watch(y)),this._register(b(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(y){await this.refresh()}async read(){const y=new Map;try{const m=await this.fileService.readFile(this.file),u=JSON.parse(m.value.toString());if(!(0,R.isObject)(u))throw new Error("Policy file isn't a JSON object");for(const b of Object.keys(u))this.policyDefinitions[b]&&y.set(b,u[b])}catch(m){m.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",m)}return y}async refresh(){const y=await this.read(),m=p(this.policies,y);this.policies=y,m.length>0&&this._onDidChange.fire(m)}};C=fe([ee(1,M.IFileService),ee(2,S.ILogService)],C),e.FilePolicyService=C}),define(Y[201],X([0,1,3,2,37]),function(z,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(d){this.service=d,this.disposables=new t.DisposableStore}listen(d,p){switch(p){case"onDidChange":return v.Event.map(this.service.onDidChange,C=>C.reduce((k,y)=>({...k,[y]:this.service.getPolicyValue(y)??null}),{}),this.disposables)}throw new Error(`Event not found: ${p}`)}call(d,p,C){switch(p){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(C)}throw new Error(`Call not found: ${p}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class M extends D.AbstractPolicyService{constructor(d,p){super();this.channel=p;for(const C in d){const{definition:k,value:y}=d[C];this.policyDefinitions[C]=k,y!==void 0&&this.policies.set(C,y)}this.channel.listen("onDidChange")(C=>{for(const k in C){const y=C[k];y===null?this.policies.delete(k):this.policies.set(k,y)}this._onDidChange.fire(Object.keys(C))})}async initializePolicies(d){const p=await this.channel.call("registerPolicyDefinitions",d);for(const C in p)this.policies.set(C,p[C])}}e.PolicyChannelClient=M}),define(Y[58],X([0,1,12,4,36,16]),function(z,e,v,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const S=t.globals.vscode.context.configuration();if(S)M=S.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof z?.__$__nodeRequire=="function"){const S=(0,R.dirname)(v.FileAccess.asFileUri("",z));M=z.__$__nodeRequire((0,R.joinPath)(S,"product.json").fsPath);const d=z.__$__nodeRequire((0,R.joinPath)(S,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`,serverDataFolderName:M.serverDataFolderName?`${M.serverDataFolderName}-dev`:void 0}),Object.assign(M,{version:d.version})}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=M}),define(Y[20],X([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Y[202],X([0,1,75,6,20]),function(z,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(S,d){this.productService=S,this.logService=d,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(S,d){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const p=/^(.*)#([^#]+)$/.exec(d);if(!p)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",d),!1;const[,C,k]=p;let y=this.trustedExtensionUrlPublicKeys.get(S);if(!y){if(y=this.productService.trustedExtensionUrlPublicKeys[S],!y||y.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",S),!1;this.trustedExtensionUrlPublicKeys.set(S,[...y])}const m=Buffer.from(decodeURIComponent(k),"base64");if(m.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",d),!1;const u=m.slice(0,6),b=m.readUIntBE(0,6),w=Date.now()-b;if(w<0||w>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",d),!1;const E=m.slice(6),I=v.createVerify("SHA256");I.write(u),I.write(Buffer.from(C)),I.end();for(let g=0;g<y.length;g++){let h=y[g];if(h!==null){if(typeof h=="string")try{h=v.createPublicKey({key:Buffer.from(h,"base64"),format:"der",type:"spki"}),y[g]=h}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${g+1} for ${S}:`,l),y[g]=null;continue}if(I.verify(h,E))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",d),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",d),!1}};R=fe([ee(0,D.IProductService),ee(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(Y[59],X([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(Y[44],X([0,1,115,13]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(M,S){v.ok(t.isString(M)),v.ok(t.isObject(S)),v.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,S)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new D}),define(Y[203],X([0,1,3,44]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class R{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,p){this.schemasById[D(d)]=p,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new R;t.Registry.add(e.Extensions.JSONContribution,M)}),define(Y[60],X([0,1,25,3,13,146,18,203,44]),function(z,e,v,t,D,R,M,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var p;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(p=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=d.Registry.as(S.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const i=this.doRegisterConfigurations(n,r);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(n){const r=this.doDeregisterConfigurations(n);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:n,remove:r}){const i=[];i.push(...this.doDeregisterConfigurations(r)),i.push(...this.doRegisterConfigurations(n,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,v.distinct)(i)})}registerDefaultConfigurations(n){const r=[],i=[];for(const{overrides:s,source:o}of n)for(const a in s)if(r.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const c=this.configurationDefaultsOverrides.get(a),f=c?.valuesSources??new Map;if(o)for(const W of Object.keys(s[a]))f.set(W,o);const P={...c?.value||{},...s[a]};this.configurationDefaultsOverrides.set(a,{source:o,value:P,valuesSources:f});const L=(0,M.getLanguageTagSettingPlainKey)(a),T={type:"object",default:P,description:R.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:P,source:D.isString(o)?void 0:o,defaultValueSource:o};i.push(...b(a)),this.configurationProperties[a]=T,this.defaultLanguageConfigurationOverridesNode.properties[a]=T}else{this.configurationDefaultsOverrides.set(a,{value:s[a],source:o});const c=this.configurationProperties[a];c&&(this.updatePropertyDefaultValue(a,c),this.updateSchema(a,c))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const r=[];for(const{overrides:i,source:s}of n)for(const o in i){const a=this.configurationDefaultsOverrides.get(o),c=D.isString(s)?s:s?.id,f=D.isString(a?.source)?a?.source:a?.source?.id;if(c===f)if(r.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const P=this.configurationProperties[o];P&&(this.updatePropertyDefaultValue(o,P),this.updateSchema(o,P))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const r of n)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,r){const i=[];return n.forEach(s=>{i.push(...this.validateAndRegisterProperties(s,r,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),i}doDeregisterConfigurations(n){const r=[],i=s=>{if(s.properties)for(const o in s.properties){r.push(o);const a=this.configurationProperties[o];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,s.properties[o])}s.allOf?.forEach(o=>i(o))};for(const s of n){i(s);const o=this.configurationContributors.indexOf(s);o!==-1&&this.configurationContributors.splice(o,1)}return r}validateAndRegisterProperties(n,r=!0,i,s,o=3){o=D.isUndefinedOrNull(n.scope)?o:n.scope;const a=[],c=n.properties;if(c)for(const P in c){const L=c[P];if(r&&g(P,L)){delete c[P];continue}if(L.source=i,L.defaultDefaultValue=c[P].default,this.updatePropertyDefaultValue(P,L),e.OVERRIDE_PROPERTY_REGEX.test(P)?L.scope=void 0:(L.scope=D.isUndefinedOrNull(L.scope)?o:L.scope,L.restricted=D.isUndefinedOrNull(L.restricted)?!!s?.includes(P):L.restricted),c[P].hasOwnProperty("included")&&!c[P].included){this.excludedConfigurationProperties[P]=c[P],delete c[P];continue}else this.configurationProperties[P]=c[P],c[P].policy?.name&&this.policyConfigurations.set(c[P].policy.name,P);!c[P].deprecationMessage&&c[P].markdownDeprecationMessage&&(c[P].deprecationMessage=c[P].markdownDeprecationMessage),a.push(P)}const f=n.allOf;if(f)for(const P of f)a.push(...this.validateAndRegisterProperties(P,r,i,s,o));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const r=i=>{const s=i.properties;if(s)for(const a in s)this.updateSchema(a,s[a]);i.allOf?.forEach(r)};r(n)}updateSchema(n,r){switch(e.allSettings.properties[n]=r,r.scope){case 1:e.applicationSettings.properties[n]=r;break;case 2:e.machineSettings.properties[n]=r;break;case 6:e.machineOverridableSettings.properties[n]=r;break;case 3:e.windowSettings.properties[n]=r;break;case 4:e.resourceSettings.properties[n]=r;break;case 5:e.resourceSettings.properties[n]=r,this.resourceLanguageSettingsSchema.properties[n]=r;break}}removeFromSchema(n,r){switch(delete e.allSettings.properties[n],r.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const r=`[${n}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,i),e.allSettings.properties[r]=i,e.applicationSettings.properties[r]=i,e.machineSettings.properties[r]=i,e.machineOverridableSettings.properties[r]=i,e.windowSettings.properties[r]=i,e.resourceSettings.properties[r]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,r){const i=this.configurationDefaultsOverrides.get(n);let s=i?.value,o=i?.source;D.isUndefined(s)&&(s=r.defaultDefaultValue,o=void 0),D.isUndefined(s)&&(s=E(r.type)),r.default=s,r.defaultValueSource=o}}const m="\\[([^\\]]+)\\]",u=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(l){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let r=u.exec(l);for(;r?.length;){const i=r[1].trim();i&&n.push(i),r=u.exec(l)}}return(0,v.distinct)(n)}e.overrideIdentifiersFromKey=b;function w(l){return l.reduce((n,r)=>`${n}[${r}]`,"")}e.keyFromOverrideIdentifiers=w;function E(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=E;const I=new y;d.Registry.add(e.Extensions.Configuration,I);function g(l,n){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?R.localize(7,null,l):I.getConfigurationProperties()[l]!==void 0?R.localize(8,null,l):n.policy?.name&&I.getPolicyConfigurations().get(n.policy?.name)!==void 0?R.localize(9,null,l,n.policy?.name,I.getPolicyConfigurations().get(n.policy?.name)):null:R.localize(6,null)}e.validateProperty=g;function h(){const l=[],n=I.getConfigurationProperties();for(const r of Object.keys(n))l.push([r,n[r].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=h}),define(Y[105],X([0,1,25,3,49,2,33,50,13,7,18,60,44]),function(z,e,v,t,D,R,M,S,d,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class m{constructor(r={},i=[],s=[]){this._contents=r,this._keys=i,this._overrides=s,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,C.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const s=this.getContentsForOverrideIdentifer(i);return s?r?(0,C.getConfigurationValue)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const s of this.overrides)s.identifiers.includes(r)&&i.push(...s.keys);return v.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return v.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=S.deepClone(this.contents),s=S.deepClone(this.overrides),o=[...this.keys];for(const a of r)if(!a.isEmpty()){this.mergeContents(i,a.contents);for(const c of a.overrides){const[f]=s.filter(P=>v.equals(P.identifiers,c.identifiers));f?(this.mergeContents(f.contents,c.contents),f.keys.push(...c.keys),f.keys=v.distinct(f.keys)):s.push(S.deepClone(c))}for(const c of a.keys)o.indexOf(c)===-1&&o.push(c)}return new m(i,o,s)}freeze(){return this.frozen=!0,this}clone(){return new m(S.deepClone(this.contents),[...this.keys],S.deepClone(this.overrides))}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const o of v.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[o];const c=i[o];c&&(typeof a=="object"&&typeof c=="object"?(a=S.deepClone(a),this.mergeContents(a,c)):a=c),s[o]=a}return new m(s,this.keys,this.overrides)}mergeContents(r,i){for(const s of Object.keys(i)){if(s in r&&d.isObject(r[s])&&d.isObject(i[s])){this.mergeContents(r[s],i[s]);continue}r[s]=S.deepClone(i[s])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?S.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,s=null;const o=a=>{a&&(s?this.mergeContents(s,a):s=S.deepClone(a))};for(const a of this.overrides)v.equals(a.identifiers,[r])?i=a.contents:a.identifiers.includes(r)&&o(a.contents);return o(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,C.addToValueTree)(this.contents,r,i,s=>{throw new Error(s)})}removeValue(r){this.removeKey(r)&&(0,C.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let s=0;s<i;s++)r.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,r)}removeKey(r){const i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=m;class u{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!d.isUndefinedOrNull(r)){const s=this.doParseContent(r);this.parseRaw(s,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:s,keys:o,overrides:a,restricted:c}=this.doParseRaw(r,i);this._configurationModel=new m(s,o,a),this._restrictedConfigurations=c||[]}doParseContent(r){let i={},s=null,o=[];const a=[],c=[];function f(L){Array.isArray(o)?o.push(L):s!==null&&(o[s]=L)}const P={onObjectBegin:()=>{const L={};f(L),a.push(o),o=L,s=null},onObjectProperty:L=>{s=L},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const L=[];f(L),a.push(o),o=L,s=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:f,onError:(L,T,W)=>{c.push({error:L,offset:T,length:W})}};if(r)try{D.visit(r,P),i=o[0]||{}}catch(L){console.error(`Error while parsing settings file ${this._name}: ${L}`),this._parseErrors=[L]}return i}doParseRaw(r,i){const s=y.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),o=this.filter(r,s,!0,i);r=o.raw;const a=(0,C.toValuesTree)(r,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),c=Object.keys(r),f=this.toOverrides(r,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:a,keys:c,overrides:f,restricted:o.restricted}}filter(r,i,s,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:r,restricted:[]};const a={},c=[];for(const f in r)if(k.OVERRIDE_PROPERTY_REGEX.test(f)&&s){const P=this.filter(r[f],i,!1,o);a[f]=P.raw,c.push(...P.restricted)}else{const P=i[f],L=P?typeof P.scope!="undefined"?P.scope:3:void 0;P?.restricted&&c.push(f),(L===void 0||o.scopes===void 0||o.scopes.includes(L))&&(o.skipRestricted&&P?.restricted||(a[f]=r[f]))}return{raw:a,restricted:c}}toOverrides(r,i){const s=[];for(const o of Object.keys(r))if(k.OVERRIDE_PROPERTY_REGEX.test(o)){const a={};for(const c in r[o])a[c]=r[o][c];s.push({identifiers:(0,k.overrideIdentifiersFromKey)(o),keys:Object.keys(a),contents:(0,C.toValuesTree)(a,i)})}return s}}e.ConfigurationModelParser=u;class b extends R.Disposable{constructor(r,i,s,o){super();this.userSettingsResource=r,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&s.isEqual(a.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class w{constructor(r,i,s,o,a=new m,c=new m,f=new M.ResourceMap,P=new m,L=new M.ResourceMap,T=!0){this._defaultConfiguration=r,this._policyConfiguration=i,this._applicationConfiguration=s,this._localUserConfiguration=o,this._remoteUserConfiguration=a,this._workspaceConfiguration=c,this._folderConfigurations=f,this._memoryConfiguration=P,this._memoryConfigurationByResource=L,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(r,i,s){return this.getConsolidatedConfigurationModel(r,i,s).getValue(r)}updateValue(r,i,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new m,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(r):o.setValue(r,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,s){const o=this.getConsolidatedConfigurationModel(r,i,s),a=this.getFolderConfigurationModelForResource(i.resource,s),c=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,f=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),P=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(r),L=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(r),T=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),W=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),$=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),te=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,re=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(r):a.freeze().getValue(r):void 0,ie=i.overrideIdentifier?c.override(i.overrideIdentifier).getValue(r):c.getValue(r),se=o.getValue(r),ce=v.distinct(o.overrides.map(q=>q.identifiers).flat()).filter(q=>o.getOverrideValue(r,q)!==void 0);return{defaultValue:f,policyValue:P,applicationValue:L,userValue:T,userLocalValue:W,userRemoteValue:$,workspaceValue:te,workspaceFolderValue:re,memoryValue:ie,value:se,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,policy:P!==void 0?{value:P}:void 0,application:L!==void 0?{value:L,override:i.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:W!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:$!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:te!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:re!==void 0?{value:a?.freeze().getValue(r),override:i.overrideIdentifier?a?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:ie!==void 0?{value:c.getValue(r),override:i.overrideIdentifier?c.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ce.length?ce:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const s=[];if(!i){const{added:o,updated:a,removed:c}=h(this._defaultConfiguration,r);i=[...o,...a,...c]}for(const o of i)for(const a of(0,k.overrideIdentifiersFromKey)(o)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(a),f=r.getKeysForOverrideIdentifier(a),P=[...f.filter(L=>c.indexOf(L)===-1),...c.filter(L=>f.indexOf(L)===-1),...c.filter(L=>!S.equals(this._defaultConfiguration.override(a).getValue(L),r.override(a).getValue(L)))];s.push([a,P])}return this.updateDefaultConfiguration(r),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:s,removed:o}=h(this._policyConfiguration,r),a=[...i,...s,...o];return a.length&&this.updatePolicyConfiguration(r),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:s,removed:o,overrides:a}=h(this.applicationConfiguration,r),c=[...i,...s,...o];return c.length&&this.updateApplicationConfiguration(r),{keys:c,overrides:a}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:s,removed:o,overrides:a}=h(this.localUserConfiguration,r),c=[...i,...s,...o];return c.length&&this.updateLocalUserConfiguration(r),{keys:c,overrides:a}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:s,removed:o,overrides:a}=h(this.remoteUserConfiguration,r),c=[...i,...s,...o];return c.length&&this.updateRemoteUserConfiguration(r),{keys:c,overrides:a}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:s,removed:o,overrides:a}=h(this.workspaceConfiguration,r),c=[...i,...s,...o];return c.length&&this.updateWorkspaceConfiguration(r),{keys:c,overrides:a}}compareAndUpdateFolderConfiguration(r,i){const s=this.folderConfigurations.get(r),{added:o,updated:a,removed:c,overrides:f}=h(s,i),P=[...o,...a,...c];return(P.length||!s)&&this.updateFolderConfiguration(r,i),{keys:P,overrides:f}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:o,removed:a,overrides:c}=h(i,void 0);return{keys:[...s,...o,...a],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,i,s){let o=this.getConsolidatedConfigurationModelForResource(i,s);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:r},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const o=i.getFolder(r);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const a=this._memoryConfigurationByResource.get(r);a&&(s=s.merge(a))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(r);o?(i=s.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=s}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const s=i.getFolder(r);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:s,overrides:o,keys:a}=this._folderConfigurations.get(i);return r.push([i,{contents:s,overrides:o,keys:a}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>r.add(s))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),s=this.parseConfigurationModel(r.policy),o=this.parseConfigurationModel(r.application),a=this.parseConfigurationModel(r.user),c=this.parseConfigurationModel(r.workspace),f=r.folders.reduce((P,L)=>(P.set(p.URI.revive(L[0]),this.parseConfigurationModel(L[1])),P),new M.ResourceMap);return new w(i,s,o,a,new m,c,f,new m,new M.ResourceMap,!1)}static parseConfigurationModel(r){return new m(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=w;function E(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const r=new Set,i=new Map;for(const o of n)o.keys.forEach(a=>r.add(a)),o.overrides.forEach(([a,c])=>{const f=(0,M.getOrSet)(i,a,new Set);c.forEach(P=>f.add(P))});const s=[];return i.forEach((o,a)=>s.push([a,[...o.values()]])),{keys:[...r.values()],overrides:s}}e.mergeChanges=E;class I{constructor(r,i,s,o){this.change=r,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;r.keys.forEach(f=>a.add(f)),r.overrides.forEach(([,f])=>f.forEach(P=>a.add(P))),this.affectedKeys=[...a.values()];const c=new m;this.affectedKeys.forEach(f=>c.setValue(f,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!S.equals(s,o)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let s=(0,C.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(r=r[o],!r)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=I;class g extends I{constructor(r,i,s,o){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=g;function h(n,r){const{added:i,removed:s,updated:o}=l(r,n),a=[],c=n?.getAllOverrideIdentifiers()||[],f=r?.getAllOverrideIdentifiers()||[];if(r){const P=f.filter(L=>!c.includes(L));for(const L of P)a.push([L,r.getKeysForOverrideIdentifier(L)])}if(n){const P=c.filter(L=>!f.includes(L));for(const L of P)a.push([L,n.getKeysForOverrideIdentifier(L)])}if(r&&n){for(const P of c)if(f.includes(P)){const L=l({contents:n.getOverrideValue(void 0,P)||{},keys:n.getKeysForOverrideIdentifier(P)},{contents:r.getOverrideValue(void 0,P)||{},keys:r.getKeysForOverrideIdentifier(P)});a.push([P,[...L.added,...L.removed,...L.updated]])}}return{added:i,removed:s,updated:o,overrides:a}}function l(n,r){const i=n?r?n.keys.filter(a=>r.keys.indexOf(a)===-1):[...n.keys]:[],s=r?n?r.keys.filter(a=>n.keys.indexOf(a)===-1):[...r.keys]:[],o=[];if(n&&r){for(const a of r.keys)if(n.keys.indexOf(a)!==-1){const c=(0,C.getConfigurationValue)(r.contents,a),f=(0,C.getConfigurationValue)(n.contents,a);S.equals(c,f)||o.push(a)}}return{added:i,removed:s,updated:o}}}),define(Y[204],X([0,1,25,3,2,50,13,18,105,60,6,37,44]),function(z,e,v,t,D,R,M,S,d,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class m extends D.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new u(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(y.Registry.as(p.Extensions.Configuration).onDidUpdateConfiguration(({properties:I,defaultsOverrides:g})=>this.onDidUpdateConfiguration(I,g))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(I,g){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:I})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=m;class u extends d.ConfigurationModel{constructor(I={}){const g=y.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(g),l=Object.create(null),n=[];for(const r in g){const i=I[r],s=i!==void 0?i:g[r].default;(0,S.addToValueTree)(l,r,s,o=>console.error(`Conflict in default settings: ${o}`))}for(const r of Object.keys(l))p.OVERRIDE_PROPERTY_REGEX.test(r)&&n.push({identifiers:(0,p.overrideIdentifiersFromKey)(r),keys:Object.keys(l[r]),contents:(0,S.toValuesTree)(l[r],i=>console.error(`Conflict in default settings file: ${i}`))});super(l,h,n)}}e.DefaultConfigurationModel=u;class b{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new d.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=b;let w=class extends D.Disposable{constructor(I,g,h){super();this.defaultConfiguration=I,this.policyService=g,this.logService=h,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new d.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(I=>this.onDidChangePolicies(I))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:I})=>this.update(await this.registerPolicyDefinitions(I),!0))),this._configurationModel}async registerPolicyDefinitions(I){const g={},h=[],l=y.Registry.as(p.Extensions.Configuration).getConfigurationProperties();for(const n of I){const r=l[n];if(!r){h.push(n);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}h.push(n),g[r.policy.name]={type:r.type}}}return(0,M.isEmptyObject)(g)||await this.policyService.registerPolicyDefinitions(g),h}onDidChangePolicies(I){const g=y.Registry.as(p.Extensions.Configuration).getPolicyConfigurations(),h=(0,v.coalesce)(I.map(l=>g.get(l)));this.update(h,!0)}update(I,g){const h=y.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),l=[],n=this._configurationModel.isEmpty();for(const r of I){const i=h[r]?.policy?.name;if(i){const s=this.policyService.getPolicyValue(i);(n?s!==void 0:!(0,R.equals)(this._configurationModel.getValue(r),s))&&l.push([r,s])}else this._configurationModel.getValue(r)!==void 0&&l.push([r,void 0])}if(l.length){const r=this._configurationModel;this._configurationModel=new d.ConfigurationModel;for(const i of r.keys)this._configurationModel.setValue(i,r.getValue(i));for(const[i,s]of l)s===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,s);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};w=fe([ee(1,k.IPolicyService),ee(2,C.ILogService)],w),e.PolicyConfiguration=w}),define(Y[205],X([0,1,8,3,2,16,18,105,204,37]),function(z,e,v,t,D,R,M,S,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends D.Disposable{constructor(y,m,u,b){super();this.settingsResource=y,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new d.DefaultConfiguration),this.policyConfiguration=u instanceof p.NullPolicyService?new d.NullPolicyConfiguration:this._register(new d.PolicyConfiguration(this.defaultConfiguration,u,b)),this.userConfiguration=this._register(new S.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,m)),this.configuration=new S.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new S.ConfigurationModel,new S.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:w,properties:E})=>this.onDidDefaultConfigurationChange(w,E))),this._register(this.policyConfiguration.onDidChangeConfiguration(w=>this.onDidPolicyConfigurationChange(w))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[y,m,u]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new S.Configuration(y,m,new S.ConfigurationModel,u)}getConfigurationData(){return this.configuration.toData()}getValue(y,m){const u=typeof y=="string"?y:void 0,b=(0,M.isConfigurationOverrides)(y)?y:(0,M.isConfigurationOverrides)(m)?m:{};return this.configuration.getValue(u,b,void 0)}updateValue(y,m,u,b){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const m=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(u,m,1)}onDidDefaultConfigurationChange(y,m){const u=this.configuration.toData(),b=this.configuration.compareAndUpdateDefaultConfiguration(y,m);this.trigger(b,u,6)}onDidPolicyConfigurationChange(y){const m=this.configuration.toData(),u=this.configuration.compareAndUpdatePolicyConfiguration(y);this.trigger(u,m,6)}trigger(y,m,u){const b=new S.ConfigurationChangeEvent(y,{data:m},this.configuration);b.source=u,b.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(b)}getTargetConfiguration(y){switch(y){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(Y[206],X([0,1,19,5]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var D;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends v.ErrorNoTelemetry{constructor(S,d=D.Unknown,p){super(S);this._message=S,this._code=d,this._detail=p,this.isHandled=d===D.NotAvailable&&p===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(S){return S instanceof R&&S._code===D.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof R&&S._code===D.NoResolverFound}static isHandled(S){return S instanceof R&&S.isHandled}}e.RemoteAuthorityResolverError=R}),define(Y[71],X([0,1,12]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(p){return p.scheme===v.Schemas.vscodeRemote?p.authority:void 0}e.getRemoteAuthority=t;function D(p){if(!p)return;const C=p.indexOf("+");return C<0?p:p.substr(0,C)}e.getRemoteName=D;function R(p){return`/${p.quality??"oss"}-${p.commit??"dev"}`}e.getRemoteServerRootPath=R;function M(p){const{host:C,port:k}=d(p);if(typeof k=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:k}}e.parseAuthorityWithPort=M;function S(p,C){let{host:k,port:y}=d(p);return typeof y=="undefined"&&(y=C),{host:k,port:y}}e.parseAuthorityWithOptionalPort=S;function d(p){const C=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const k=p.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const y=p.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:p,port:void 0}}}),define(Y[207],X([0,1,8,17,21,19,3,2,30,95,206,71]),function(z,e,v,t,D,R,M,S,d,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const y=30*1e3;var m;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(m=e.ConnectionType||(e.ConnectionType={}));function u(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function b(H){const G=new D.CancellationTokenSource;return setTimeout(()=>G.cancel(),H),G.token}function w(H,G){if(H.isCancellationRequested||G.isCancellationRequested)return D.CancellationToken.Cancelled;const x=new D.CancellationTokenSource;return H.onCancellationRequested(()=>x.cancel()),G.onCancellationRequested(()=>x.cancel()),x.token}class E{constructor(G){this._state="pending",this._disposables=new S.DisposableStore,this.promise=new Promise((x,A)=>{this._resolvePromise=x,this._rejectPromise=A}),G.isCancellationRequested?this._timeout():this._disposables.add(G.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(G){this._state==="pending"?this._disposables.add(G):G.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const G=new Error("Time limit reached");return G.code="ETIMEDOUT",G.syscall="connect",G}resolve(G){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(G))}reject(G){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(G))}}function I(H,G){const x=new E(G);return x.registerDisposable(H.onControlMessage(A=>{const F=JSON.parse(A.toString()),N=ne(F);N?x.reject(N):x.resolve(F)})),x.promise}function g(H,G,x,A,F,N,j,J){const U=new E(J);return G.connect(x,A,F,N,j,(K,Z)=>{U.didTimeout?(K&&H.error(K),Z?.dispose()):K||!Z?U.reject(K):U.resolve(Z)}),U.promise}function h(H,G){const x=new E(G);return H.then(A=>{x.didTimeout||x.resolve(A)},A=>{x.didTimeout||x.reject(A)}),x.promise}async function l(H,G,x,A){const F=B(H,G);H.logService.trace(`${F} 1/6. invoking socketFactory.connect().`);let N;try{N=await g(H.logService,H.socketFactory,H.host,H.port,(0,k.getRemoteServerRootPath)(H),`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,`renderer-${u(G)}-${H.reconnectionToken}`,A)}catch(Z){throw H.logService.error(`${F} socketFactory.connect() failed or timed out. Error:`),H.logService.error(Z),Z}H.logService.trace(`${F} 2/6. socketFactory.connect() was successful.`);let j,J;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(N,null),j=H.reconnectionProtocol,J=!1):(j=new p.PersistentProtocol(N,null),J=!0),H.logService.trace(`${F} 3/6. sending AuthRequest control message.`);const U=await h(H.signService.createNewMessage((0,d.generateUuid)()),A),K={type:"auth",auth:H.connectionToken||"00000000000000000000",data:U.data};j.sendControl(t.VSBuffer.fromString(JSON.stringify(K)));try{const Z=await I(j,w(A,b(1e4)));if(Z.type!=="sign"||typeof Z.data!="string"){const be=new Error("Unexpected handshake message");throw be.code="VSCODE_CONNECTION_ERROR",be}if(H.logService.trace(`${F} 4/6. received SignRequest control message.`),!await h(H.signService.validate(U,Z.signedData),A)){const be=new Error("Refused to connect to unsupported server");throw be.code="VSCODE_CONNECTION_ERROR",be}const le=await h(H.signService.sign(Z.data),A),ge={type:"connectionType",commit:H.commit,signedData:le,desiredConnectionType:G};return x&&(ge.args=x),H.logService.trace(`${F} 5/6. sending ConnectionTypeRequest control message.`),j.sendControl(t.VSBuffer.fromString(JSON.stringify(ge))),{protocol:j,ownsProtocol:J}}catch(Z){throw Z&&Z.code==="ETIMEDOUT"&&(H.logService.error(`${F} the handshake timed out. Error:`),H.logService.error(Z)),Z&&Z.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${F} received error control message when negotiating connection. Error:`),H.logService.error(Z)),J&&q(j),Z}}async function n(H,G,x,A){const F=Date.now(),N=B(H,G),{protocol:j,ownsProtocol:J}=await l(H,G,x,A),U=new E(A);return U.registerDisposable(j.onControlMessage(K=>{const Z=JSON.parse(K.toString()),ae=ne(Z);ae?(H.logService.error(`${N} received error control message when negotiating connection. Error:`),H.logService.error(ae),J&&q(j),U.reject(ae)):(H.reconnectionProtocol&&H.reconnectionProtocol.endAcceptReconnection(),H.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${Q(F)}!`),U.resolve({protocol:j,firstMessage:Z}))})),U.promise}async function r(H,G){const{protocol:x}=await n(H,1,void 0,G);return{protocol:x}}async function i(H,G,x){const{protocol:A,firstMessage:F}=await n(H,2,G,x),N=F&&F.debugPort;return{protocol:A,debugPort:N}}async function s(H,G,x){const A=Date.now(),F=B(H,3),{protocol:N}=await l(H,3,G,x);return H.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${Q(A)}!`),N}async function o(H,G,x){const{host:A,port:F,connectionToken:N}=await H.addressProvider.getAddress();return{commit:H.commit,quality:H.quality,host:A,port:F,connectionToken:N,reconnectionToken:G,reconnectionProtocol:x,socketFactory:H.socketFactory,signService:H.signService,logService:H.logService}}async function a(H,G,x){try{const A=(0,d.generateUuid)(),F=await o(H,A,null),{protocol:N}=await r(F,D.CancellationToken.None);return new se(H,G,x,A,N)}catch(A){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(A),ie.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(A)),A}}e.connectRemoteAgentManagement=a;async function c(H,G){try{const x=(0,d.generateUuid)(),A=await o(H,x,null),{protocol:F,debugPort:N}=await i(A,G,D.CancellationToken.None);return new ce(H,G,x,F,N)}catch(x){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(x),ie.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(x)),x}}e.connectRemoteAgentExtensionHost=c;async function f(H,G,x){const A=await o(H,(0,d.generateUuid)(),null);return await s(A,{host:G,port:x},D.CancellationToken.None)}e.connectRemoteAgentTunnel=f;function P(H){return(0,v.createCancelablePromise)(G=>new Promise((x,A)=>{const F=setTimeout(x,H*1e3);G.onCancellationRequested(()=>{clearTimeout(F),x()})}))}var L;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(L=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class T{constructor(G,x){this.reconnectionToken=G,this.millisSinceLastIncomingData=x,this.type=0}}e.ConnectionLostEvent=T;class W{constructor(G,x,A,F){this.reconnectionToken=G,this.millisSinceLastIncomingData=x,this.durationSeconds=A,this.cancellableTimer=F,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=W;class ${constructor(G,x,A){this.reconnectionToken=G,this.millisSinceLastIncomingData=x,this.attempt=A,this.type=2}}e.ReconnectionRunningEvent=$;class te{constructor(G,x,A){this.reconnectionToken=G,this.millisSinceLastIncomingData=x,this.attempt=A,this.type=4}}e.ConnectionGainEvent=te;class re{constructor(G,x,A,F){this.reconnectionToken=G,this.millisSinceLastIncomingData=x,this.attempt=A,this.handled=F,this.type=3}}e.ReconnectionPermanentFailureEvent=re;class ie extends S.Disposable{constructor(G,x,A,F,N){super();this._connectionType=G,this._options=x,this.reconnectionToken=A,this.protocol=F,this._reconnectionFailureIsFatal=N,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new te(this.reconnectionToken,0,0)),this._register(F.onSocketClose(j=>{const J=_(this._connectionType,this.reconnectionToken,!0);j?j.type===0?(this._options.logService.info(`${J} received socket close event (hadError: ${j.hadError}).`),j.error&&this._options.logService.error(j.error)):(this._options.logService.info(`${J} received socket close event (wasClean: ${j.wasClean}, code: ${j.code}, reason: ${j.reason}).`),j.event&&this._options.logService.error(j.event)):this._options.logService.info(`${J} received socket close event.`),this._beginReconnecting()})),this._register(F.onSocketTimeout(()=>{const j=_(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${j} received socket timeout event.`),this._beginReconnecting()})),ie._instances.push(this),this._register((0,S.toDisposable)(()=>{const j=ie._instances.indexOf(this);j>=0&&ie._instances.splice(j,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(ie._permanentFailureMillisSinceLastIncomingData,ie._permanentFailureAttempt,ie._permanentFailureHandled)}static triggerPermanentFailure(G,x,A){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=G,this._permanentFailureAttempt=x,this._permanentFailureHandled=A,this._instances.forEach(F=>F._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(G=>G._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(G=>G._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||ie._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const G=_(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${G} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const x=[0,5,5,10,10,10,10,10,30];let A=-1;do{A++;const F=A<x.length?x[A]:x[x.length-1];try{if(F>0){const j=P(F);this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F,j)),this._options.logService.info(`${G} waiting for ${F} seconds before reconnecting...`);try{await j}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${G} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A+1)),this._options.logService.info(`${G} resolving connection...`);const N=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${G} connecting to ${N.host}:${N.port}...`),await this._reconnect(N,b(y)),this._options.logService.info(`${G} reconnected!`),this._onDidStateChange.fire(new te(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A+1));break}catch(N){if(N.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${G} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(N),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}if(A>360){this._options.logService.error(`${G} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(N),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}if(C.RemoteAuthorityResolverError.isTemporarilyNotAvailable(N)){this._options.logService.info(`${G} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if((N.code==="ETIMEDOUT"||N.code==="ENETUNREACH"||N.code==="ECONNREFUSED"||N.code==="ECONNRESET")&&N.syscall==="connect"){this._options.logService.info(`${G} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if((0,R.isCancellationError)(N)){this._options.logService.info(`${G} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if(N instanceof C.RemoteAuthorityResolverError){this._options.logService.error(`${G} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(N),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,C.RemoteAuthorityResolverError.isHandled(N));break}this._options.logService.error(`${G} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(N),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(G,x,A){this._reconnectionFailureIsFatal?ie.triggerPermanentFailure(G,x,A):this._gotoPermanentFailure(G,x,A)}_gotoPermanentFailure(G,x,A){this._onDidStateChange.fire(new re(this.reconnectionToken,G,x,A)),q(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ie,ie._permanentFailure=!1,ie._permanentFailureMillisSinceLastIncomingData=0,ie._permanentFailureAttempt=0,ie._permanentFailureHandled=!1,ie._instances=[];class se extends ie{constructor(G,x,A,F,N){super(1,G,F,N,!0);this.client=this._register(new p.Client(N,{remoteAuthority:x,clientId:A},G.ipcLogger))}async _reconnect(G,x){await r(G,x)}}e.ManagementPersistentConnection=se;class ce extends ie{constructor(G,x,A,F,N){super(2,G,A,F,!1);this._startArguments=x,this.debugPort=N}async _reconnect(G,x){await i(G,this._startArguments,x)}}e.ExtensionHostPersistentConnection=ce;function q(H){try{H.acceptDisconnect();const G=H.getSocket();H.dispose(),G.dispose()}catch(G){(0,R.onUnexpectedError)(G)}}function ne(H){if(H&&H.type==="error"){const G=new Error(`Connection error: ${H.reason}`);return G.code="VSCODE_CONNECTION_ERROR",G}return null}function O(H,G){for(;H.length<G;)H+=" ";return H}function _(H,G,x){return`[remote-connection][${O(u(H),13)}][${G.substr(0,5)}\u2026][${x?"reconnect":"initial"}]`}function B(H,G){return`${_(G,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.host}:${H.port}]`}function Q(H){return`${Date.now()-H} ms`}}),define(Y[208],X([0,1,76,81]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,R,M,S,d,p){const C=y=>p(y,void 0),k=v.createConnection({host:D,port:R},()=>{k.removeListener("error",C);const y=Buffer.alloc(16);for(let w=0;w<16;w++)y[w]=Math.round(Math.random()*256);const m=y.toString("base64"),u=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${R}${M}?${S}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${m}`];k.write(u.join(`\r
`)+`\r
\r
`);const b=w=>{w.toString().indexOf(`\r
\r
`)>=0&&(k.off("data",b),p(void 0,new t.NodeSocket(k,d)))};k.on("data",b)});k.setNoDelay(!0),k.once("error",C)}}}),define(Y[52],X([0,1,17,160,60,5,44]),function(z,e,v,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function S(b){return b.res.statusCode&&b.res.statusCode>=200&&b.res.statusCode<300||b.res.statusCode===1223}e.isSuccess=S;function d(b){return b.res.statusCode===204}async function p(b){return d(b)?null:(await(0,v.streamToBuffer)(b.stream)).toString()}e.asText=p;async function C(b){if(!S(b))throw new Error("Server returned "+b.res.statusCode);return p(b)}e.asTextOrError=C;async function k(b){if(!S(b))throw new Error("Server returned "+b.res.statusCode);if(d(b))return null;const E=(await(0,v.streamToBuffer)(b.stream)).toString();try{return JSON.parse(E)}catch(I){throw I.message+=`:
`+E,I}}e.asJson=k;function y(b){u(b)}e.updateProxyConfigurationsScope=y;let m;function u(b){const w=M.Registry.as(D.Extensions.Configuration),E=m;m={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:b,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[m],remove:E?[E]:[]})}u(2)}),define(Y[209],X([0,1,17,21]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(S){this.service=S}listen(S,d){throw new Error("Invalid listen")}call(S,d,p,C=t.CancellationToken.None){switch(d){case"request":return this.service.request(p[0],C).then(async({res:k,stream:y})=>{const m=await(0,v.streamToBuffer)(y);return[{statusCode:k.statusCode,headers:k.headers},m]});case"resolveProxy":return this.service.resolveProxy(p[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class R{constructor(S){this.channel=S}async request(S,d){const[p,C]=await this.channel.call("request",[S],d);return{res:p,stream:(0,v.bufferToStream)(C)}}async resolveProxy(S){return this.channel.call("resolveProxy",[S])}}e.RequestChannelClient=R}),define(Y[210],X([0,1,211,13]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(M,S){return M.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:M.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function R(M,S,d={}){const p=(0,v.parse)(M),C=d.proxyUrl||D(p,S);if(!C)return null;const k=(0,v.parse)(C);if(!/^https?:$/.test(k.protocol||""))return null;const y={host:k.hostname||"",port:k.port||(k.protocol==="https"?"443":"80"),auth:k.auth,rejectUnauthorized:(0,t.isBoolean)(d.strictSSL)?d.strictSSL:!0};return p.protocol==="http:"?new(await new Promise((m,u)=>{z(["http-proxy-agent"],m,u)}))(y):new(await new Promise((m,u)=>{z(["https-proxy-agent"],m,u)}))(y)}e.getProxyAgent=R}),define(Y[106],X([0,1,42,9,161,21,41,19,4,30,143,56,8]),function(z,e,v,t,D,R,M,S,d,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const m=1e4;let u;async function b(E,I,g){return I["force-disable-user-env"]?(E.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(E.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.isLaunchedFromCli)(g)&&!I["force-user-env"]?(E.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.isLaunchedFromCli)(g)?E.trace("resolveShellEnv(): running (--force-user-env)"):E.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=y.Promises.withAsyncBody(async(h,l)=>{const n=new R.CancellationTokenSource,r=setTimeout(()=>{n.dispose(!0),l(new Error((0,D.localize)(0,null)))},m);try{h(await w(E,n.token))}catch(i){!(0,S.isCancellationError)(i)&&!n.token.isCancellationRequested?l(new Error((0,D.localize)(1,null,(0,M.toErrorMessage)(i)))):h({})}finally{clearTimeout(r),n.dispose()}})),u)}e.getResolvedShellEnv=b;async function w(E,I){const g=process.env.ELECTRON_RUN_AS_NODE;E.trace("getUnixShellEnvironment#runAsNode",g);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;E.trace("getUnixShellEnvironment#noAttach",h);const l=(0,p.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(l+"(.*)"+l),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};E.trace("getUnixShellEnvironment#env",r);const i=await(0,C.getSystemShell)(d.OS,r);return E.trace("getUnixShellEnvironment#shell",i),new Promise((s,o)=>{if(I.isCancellationRequested)return o((0,S.canceled)());const a=(0,t.basename)(i);let c,f;const P=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(c=`& '${process.execPath}' ${P} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,f=["-Login","-Command"]):(c=`'${process.execPath}' ${P} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,a==="tcsh"?f=["-ic"]:f=["-ilc"]),E.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),c);const L=(0,v.spawn)(i,[...f,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});I.onCancellationRequested(()=>(L.kill(),o((0,S.canceled)()))),L.on("error",$=>{E.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)($)),o($)});const T=[];L.stdout.on("data",$=>T.push($));const W=[];L.stderr.on("data",$=>W.push($)),L.on("close",($,te)=>{const re=Buffer.concat(T).toString("utf8");E.trace("getUnixShellEnvironment#raw",re);const ie=Buffer.concat(W).toString("utf8");if(ie.trim()&&E.trace("getUnixShellEnvironment#stderr",ie),$||te)return o(new Error((0,D.localize)(2,null,$,te)));const se=n.exec(re),ce=se?se[1]:"{}";try{const q=JSON.parse(ce);g?q.ELECTRON_RUN_AS_NODE=g:delete q.ELECTRON_RUN_AS_NODE,h?q.ELECTRON_NO_ATTACH_CONSOLE=h:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.XDG_RUNTIME_DIR,E.trace("getUnixShellEnvironment#result",q),s(q)}catch(q){E.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(q)),o(q)}})})}}),define(Y[86],X([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(Y[212],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{constructor(){this.validators=new Map}vsda(){return new Promise((D,R)=>z(["vsda"],D,R))}async createNewMessage(D){try{const R=await this.vsda(),M=new R.validator;if(M){const S=String(v._nextId++);return this.validators.set(S,M),{id:S,data:M.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,R){if(!D.id)return!0;const M=this.validators.get(D.id);if(!M)return!1;this.validators.delete(D.id);try{return M.validate(R)==="ok"}catch{return!1}}async sign(D){try{const R=await this.vsda(),M=new R.signer;if(M)return M.sign(D)}catch{}return D}}e.SignService=v,v._nextId=1}),define(Y[45],X([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(Y[22],X([0,1,14,38,8,3,2,4,36,13,5,6,45]),function(z,e,v,t,D,R,M,S,d,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,C.createDecorator)("lifecycleMainService");var m;(function(w){w[w.QUIT=1]="QUIT",w[w.KILL=2]="KILL"})(m=e.ShutdownReason||(e.ShutdownReason={}));var u;(function(w){w[w.Starting=1]="Starting",w[w.Ready=2]="Ready",w[w.AfterWindowOpen=3]="AfterWindowOpen"})(u=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let b=class bt extends M.Disposable{constructor(E,I){super();this.logService=E,this.stateMainService=I,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(bt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(bt.QUIT_AND_RESTART_KEY)}registerListeners(){const E=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),S.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};v.app.addListener("before-quit",E);const I=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!S.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",I),v.app.once("will-quit",g=>{this.logService.trace("Lifecycle#app.on(will-quit)"),g.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",E),v.app.removeListener("window-all-closed",I),v.app.quit()})})}fireOnWillShutdown(E){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const I=[];return this._onWillShutdown.fire({reason:E,join(g){I.push(g)}}),this.pendingWillShutdownPromise=(async()=>{try{await D.Promises.settled(I)}catch(g){this.logService.error(g)}try{await this.stateMainService.close()}catch(g){this.logService.error(g)}})(),this.pendingWillShutdownPromise}set phase(E){if(E<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===E)return;this.logService.trace(`lifecycle (main): phase changed (value: ${E})`),this._phase=E;const I=this.phaseWhen.get(this._phase);I&&(I.open(),this.phaseWhen.delete(this._phase))}async when(E){if(E<=this._phase)return;let I=this.phaseWhen.get(E);I||(I=new D.Barrier,this.phaseWhen.set(E,I)),await I.wait()}registerWindow(E){const I=new M.DisposableStore;this.windowCounter++,I.add(E.onWillLoad(h=>this._onWillLoadWindow.fire({window:E,workspace:h.workspace,reason:h.reason})));const g=(0,p.assertIsDefined)(E.win);g.on("close",h=>{const l=E.id;if(this.windowToCloseRequest.has(l)){this.windowToCloseRequest.delete(l);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${E.id}`),h.preventDefault(),this.unload(E,1).then(n=>{if(n){this.windowToCloseRequest.delete(l);return}this.windowToCloseRequest.add(l),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this._onBeforeCloseWindow.fire(E),E.close()})}),g.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${E.id}`),this.windowCounter--,I.dispose(),this.windowCounter===0&&(!S.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(E,I){await this.unload(E,3)||E.reload(I)}unload(E,I){const g=this.mapWindowIdToPendingUnload.get(E.id);if(g)return g;const h=this.doUnload(E,I).finally(()=>{this.mapWindowIdToPendingUnload.delete(E.id)});return this.mapWindowIdToPendingUnload.set(E.id,h),h}async doUnload(E,I){if(!E.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${E.id}`);const g=this._quitRequested?2:I,h=await this.onBeforeUnloadWindowInRenderer(E,g);return h?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${E.id})`),this.handleWindowUnloadVeto(h)):(await this.onWillUnloadWindowInRenderer(E,g),!1)}handleWindowUnloadVeto(E){return E?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(E){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(E),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(E,I){return new Promise(g=>{const h=this.oneTimeListenerTokenGenerator++,l=`vscode:ok${h}`,n=`vscode:cancel${h}`;t.validatedIpcMain.once(l,()=>{g(!1)}),t.validatedIpcMain.once(n,()=>{g(!0)}),E.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:n,reason:I})})}onWillUnloadWindowInRenderer(E,I){return new Promise(g=>{const l=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(l,()=>g()),E.send("vscode:onWillUnload",{replyChannel:l,reason:I})})}quit(E){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${E}`),E&&this.stateMainService.setItem(bt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(I=>{this.pendingQuitPromiseResolve=I,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(E){this.logService.trace("Lifecycle#relaunch()");const I=process.argv.slice(1);if(E?.addArgs&&I.push(...E.addArgs),E?.removeArgs)for(const l of E.removeArgs){const n=I.indexOf(l);n>=0&&I.splice(n,1)}const g=()=>{try{if(S.isWindows){const l=(0,d.cwd)();l!==process.cwd()&&process.chdir(l)}}catch(l){this.logService.error(l)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:I})};v.app.once("quit",g),await this.quit(!0)&&v.app.removeListener("quit",g)}async kill(E){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,D.timeout)(1e3),(async()=>{for(const I of v.BrowserWindow.getAllWindows())if(I&&!I.isDestroyed()){let g;I.webContents&&!I.webContents.isDestroyed()?g=new Promise(h=>I.once("closed",h)):g=Promise.resolve(),I.destroy(),await g}})()]),v.app.exit(E)}};b.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",b=fe([ee(0,k.ILogService),ee(1,y.IStateMainService)],b),e.LifecycleMainService=b}),define(Y[213],X([0,1,4,3,2,5,22]),function(z,e,v,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let S=class extends D.Disposable{constructor(C){super();this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,C.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const C=await new Promise((k,y)=>{z(["native-keymap"],k,y)});this._keyboardLayoutData=d(C),v.isCI||C.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=d(C),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};S=fe([ee(0,M.ILifecycleMainService)],S),e.KeyboardLayoutMainService=S;function d(p){const C=p.getKeyMap(),k=p.getCurrentKeyboardLayout();return{keyboardMapping:C,keyboardLayoutInfo:k}}}),define(Y[214],X([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,v.createDecorator)("stateService")}),define(Y[215],X([0,1,8,17,13,39,15,6]),function(z,e,v,t,D,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class d{constructor(k,y,m){this.storagePath=k,this.logService=y,this.fileService=m,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(k){k.fileOperationResult!==1&&this.logService.error(k)}}getItem(k,y){const m=this.storage[k];return(0,D.isUndefinedOrNull)(m)?y:m}setItem(k,y){this.setItems([{key:k,data:y}])}setItems(k){let y=!1;for(const{key:m,data:u}of k)this.storage[m]!==u&&((0,D.isUndefinedOrNull)(u)?(0,D.isUndefined)(this.storage[m])||(this.storage[m]=void 0,y=!0):(this.storage[m]=u,y=!0));y&&this.save()}removeItem(k){(0,D.isUndefined)(this.storage[k])||(this.storage[k]=void 0,this.save())}async save(k){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),k)}async doSave(){if(!this.initializing)return;await this.initializing;const k=JSON.stringify(this.storage,null,4);if(k!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(k)),this.lastSavedStorageContents=k}catch(y){this.logService.error(y)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=d;let p=class{constructor(k,y,m){this.fileStorage=new d(k.stateResource,y,m)}async init(){await this.fileStorage.init()}getItem(k,y){return this.fileStorage.getItem(k,y)}};p=fe([ee(0,R.IEnvironmentService),ee(1,S.ILogService),ee(2,M.IFileService)],p),e.StateService=p}),define(Y[216],X([0,1,215]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends v.StateService{setItem(R,M){this.fileStorage.setItem(R,M)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(Y[217],X([0,1,4,36,7,30]),function(z,e,v,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(p){if(v.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}async function S(p,C,k,y,m,u,b,w,E,I){const g=Object.create(null);g["common.machineId"]=b,g.sessionID=(0,R.generateUuid)()+Date.now(),g.commitHash=m,g.version=u,g["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,v.PlatformToString)(v.platform),g["common.nodePlatform"]=t.platform,g["common.nodeArch"]=y,g["common.product"]=I||"desktop";const h=d(w||[]);h&&(g["common.msftInternal"]=h);let l=0;const n=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),v.isLinuxSnap&&(g["common.snap"]="true");const r=M(k);r&&(g["common.platformDetail"]=r);try{const i=await p.readFile(D.URI.file(E));g["common.source"]=i.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=S;function d(p){const C=t.env.USERDNSDOMAIN;if(!C)return!1;const k=C.toLowerCase();return p.some(y=>k===y)}e.verifyMicrosoftInternalDomain=d}),define(Y[35],X([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Y[218],X([0,1,28,54,8,49,12,9,4,7,80,23,94,83,15,20,35]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const E=new Map;async function I(r,i){const s=`${r}::${i.join(":")}`,o=E.get(s);if(o)return o;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,f=new Map,P=2e4;function L(W,$,te,re){const ie=$.substring(W.length+1);return D.Promises.withAsyncBody(async se=>{let ce;try{ce=await k.Promises.readdir($,{withFileTypes:!0})}catch{se();return}if(re.count>=P){re.count+=ce.length,re.maxReached=!0,se();return}let q=ce.length;if(q===0){se();return}let ne=ce;re.count+ce.length>P&&(re.maxReached=!0,q=P-re.count,ne=ce.slice(0,q)),re.count+=ce.length;for(const O of ne)if(O.isDirectory()){if(te.includes(O.name)||await L(W,(0,S.join)($,O.name),te,re),--q==0){se();return}}else{const _=O.name.lastIndexOf(".");if(_>=0){const B=O.name.substring(_+1);B&&c.set(B,(c.get(B)??0)+1)}for(const B of a)B.relativePathPattern?.test(ie)!==!1&&B.filePattern.test(O.name)&&f.set(B.tag,(f.get(B.tag)??0)+1);if(--q==0){se();return}}})}const T=D.Promises.withAsyncBody(async W=>{const $={count:0,maxReached:!1};await L(r,r,i,$);const te=await l(r);W({configFiles:g(f),fileTypes:g(c),fileCount:$.count,maxFilesReached:$.maxReached,launchConfigFiles:te})});return E.set(s,T),T}e.collectWorkspaceStats=I;function g(r){return[...t.Iterable.map(r.entries(),([i,s])=>({name:i,count:s}))].sort((i,s)=>s.count-i.count)}function h(){const r={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(C.virtualMachineHint.value()*100)}%`},i=v.cpus();return i&&i.length>0&&(r.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),r}e.getMachineInfo=h;async function l(r){try{const i=new Map,s=(0,S.join)(r,".vscode","launch.json"),o=await k.Promises.readFile(s),a=[],c=(0,R.parse)(o.toString(),a);if(a.length)return console.log(`Unable to parse ${s}`),[];if((0,R.getNodeType)(c)==="object"&&c.configurations)for(const f of c.configurations){const P=f.type;P&&(i.has(P)?i.set(P,i.get(P)+1):i.set(P,1))}return g(i)}catch{return[]}}e.collectLaunchConfigs=l;let n=class{constructor(i,s){this.telemetryService=i,this.productService=s}formatMachineInfo(i){const s=[];return s.push(`OS Version:       ${i.os}`),s.push(`CPUs:             ${i.cpus}`),s.push(`Memory (System):  ${i.memory}`),s.push(`VM:               ${i.vmHint}`),s.join(`
`)}formatEnvironment(i){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const o=v.cpus();return o&&o.length>0&&s.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),s.push(`Memory (System):  ${(v.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),d.isWindows||s.push(`Load (avg):       ${v.loadavg().map(a=>Math.round(a)).join(", ")}`),s.push(`VM:               ${Math.round(C.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${i.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(i,s){return Promise.all([(0,y.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async o=>{let[a,c]=o,f=this.formatProcessList(i,a);return s.forEach(P=>{if((0,m.isRemoteDiagnosticError)(P))f+=`
${P.errorMessage}`,c+=`
${P.errorMessage}`;else if(f+=`

Remote: ${P.hostName}`,P.processes&&(f+=`
${this.formatProcessList(i,P.processes)}`),P.workspaceMetadata){c+=`
|  Remote: ${P.hostName}`;for(const L of Object.keys(P.workspaceMetadata)){const T=P.workspaceMetadata[L];let W=`${T.fileCount} files`;T.maxFilesReached&&(W=`more than ${W}`),c+=`|    Folder (${L}): ${W}`,c+=this.formatWorkspaceStats(T)}}}),{processInfo:f,workspaceInfo:c}})}async getSystemInfo(i,s){const{memory:o,vmHint:a,os:c,cpus:f}=h(),P={os:c,memory:o,cpus:f,vmHint:a,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:s};return d.isWindows||(P.load=`${v.loadavg().map(L=>Math.round(L)).join(", ")}`),d.isLinux&&(P.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(P)}async getDiagnostics(i,s){const o=[];return(0,y.listProcesses)(i.mainPID).then(async a=>(o.push(""),o.push(this.formatEnvironment(i)),o.push(""),o.push(this.formatProcessList(i,a)),i.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(i))),s.forEach(c=>{if((0,m.isRemoteDiagnosticError)(c))o.push(`
${c.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${c.hostName}`),o.push(this.formatMachineInfo(c.machineInfo)),c.processes&&o.push(this.formatProcessList(i,c.processes)),c.workspaceMetadata)for(const f of Object.keys(c.workspaceMetadata)){const P=c.workspaceMetadata[f];let L=`${P.fileCount} files`;P.maxFilesReached&&(L=`more than ${L}`),o.push(`Folder (${f}): ${L}`),o.push(this.formatWorkspaceStats(P))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(i){const s=[],o=60;let a=0;const c=(T,W)=>{const $=` ${T}(${W})`;a+$.length>o?(s.push(f),f="|                 ",a=f.length):a+=$.length,f+=$};let f="|      File types:";const P=10,L=i.fileTypes.length>P?P:i.fileTypes.length;for(let T=0;T<L;T++){const W=i.fileTypes[T];c(W.name,W.count)}if(s.push(f),i.configFiles.length>=0&&(f="|      Conf files:",a=0,i.configFiles.forEach(T=>{c(T.name,T.count)}),s.push(f)),i.launchConfigFiles.length>0){let T="|      Launch Configs:";i.launchConfigFiles.forEach(W=>{T+=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`}),s.push(T)}return s.join(`
`)}expandGPUFeatures(i){const s=Math.max(...Object.keys(i).map(o=>o.length));return Object.keys(i).map(o=>`${o}:  ${" ".repeat(s-o.length)}  ${i[o]}`).join(`
                  `)}formatWorkspaceMetadata(i){const s=[],o=[];return i.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(s.push(`|  Window (${a.title})`),a.folderURIs.forEach(c=>{const f=p.URI.revive(c);if(f.scheme===M.Schemas.file){const P=f.fsPath;o.push(I(P,["node_modules",".git"]).then(L=>{let T=`${L.fileCount} files`;L.maxFilesReached&&(T=`more than ${T}`),s.push(`|    Folder (${(0,S.basename)(P)}): ${T}`),s.push(this.formatWorkspaceStats(L))}).catch(L=>{s.push(`|      Error: Unable to collect workspace stats for folder ${P} (${L.toString()})`)}))}else s.push(`|    Folder (${f.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(a=>s.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(i,s){const o=new Map;i.windows.forEach(c=>o.set(c.pid,c.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(i.mainPID,o,a,s,0),a.join(`
`)}formatProcessItem(i,s,o,a,c){const f=c===0;let P;f?P=a.pid===i?`${this.productService.applicationName} main`:"remote agent":(P=`${"  ".repeat(c)} ${a.name}`,a.name==="window"&&(P=`${P} (${s.get(a.pid)})`));const L=process.platform==="win32"?a.mem:v.totalmem()*(a.mem/100);o.push(`${a.load.toFixed(0).padStart(5," ")}	${(L/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${P}`),Array.isArray(a.children)&&a.children.forEach(T=>this.formatProcessItem(i,s,o,T,c+1))}async getWorkspaceFileExtensions(i){const s=new Set;for(const{uri:o}of i.folders){const a=p.URI.revive(o);if(a.scheme!==M.Schemas.file)continue;const c=a.fsPath;try{(await I(c,["node_modules",".git"])).fileTypes.forEach(P=>s.add(P.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(i){for(const{uri:s}of i.folders){const o=p.URI.revive(s);if(o.scheme!==M.Schemas.file)continue;const a=o.fsPath;try{const c=await I(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),c.fileTypes.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:f.name,count:f.count})}),c.launchConfigFiles.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:f.name,count:f.count})}),c.configFiles.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:f.name,count:f.count})})}catch{}}}};n=fe([ee(0,w.ITelemetryService),ee(1,b.IProductService)],n),e.DiagnosticsService=n}),define(Y[219],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(R){this.appenders=R}listen(R,M){throw new Error(`Event not found: ${M}`)}call(R,M,{eventName:S,data:d}){return this.appenders.forEach(p=>p.log(S,d)),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class t{constructor(R){this.channel=R}log(R,M){return this.channel.call("log",{eventName:R,data:M}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(Y[72],X([0,1,50,91,13,18,35]),function(z,e,v,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class S{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(h,l){return Promise.resolve(void 0)}publicLog2(h,l){return this.publicLog(h,l)}publicLogError(h,l){return Promise.resolve(void 0)}publicLogError2(h,l){return this.publicLogError(h,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class d{async publicLog(h,l,n){}async publicLogError(h,l,n){}}e.NullEndpointTelemetryService=d,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(g,h){return h.onDidChangeConfiguration(l=>{l.source!==6&&g.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(l.source),configurationKeys:w(l.sourceConfig)})})}e.configurationTelemetry=p;function C(g,h){return!(h.disableTelemetry||!g.enableTelemetry||h.extensionTestsLocationURI)}e.supportsTelemetry=C;function k(g){const h=g.getValue(M.TELEMETRY_SETTING_ID),l=g.getValue("telemetry.enableCrashReporter");if(g.getValue(M.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(h??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=k;function y(g){const h={},l={},n={};b(g,n);for(let r in n){r=r.length>150?r.substr(r.length-149):r;const i=n[r];typeof i=="number"?l[r]=i:typeof i=="boolean"?l[r]=i?1:0:typeof i=="string"?(i.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${i.length}`),h[r]=i.substring(0,8191)):typeof i!="undefined"&&i!==null&&(h[r]=i)}return{properties:h,measurements:l}}e.validateTelemetryData=y;const m=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function u(g){if(!g)return"none";for(const h of m)if(g.startsWith(`${h}+`))return h;return"other"}e.cleanRemoteAuthority=u;function b(g,h,l=0,n){if(!!g)for(const r of Object.getOwnPropertyNames(g)){const i=g[r],s=n?n+r:r;Array.isArray(i)?h[s]=(0,v.safeStringify)(i):i instanceof Date?h[s]=i.toISOString():(0,D.isObject)(i)?l<2?b(i,h,l+1,s+"."):h[s]=(0,v.safeStringify)(i):h[s]=i}}function w(g){if(!g)return[];const h=[];return E(h,"",g),h}function E(g,h,l){l&&typeof l=="object"&&!Array.isArray(l)?Object.keys(l).forEach(n=>E(g,h?`${h}.${n}`:n,l[n])):g.push(h)}function I(g){return[g.appRoot,g.extensionsPath,g.userHome.fsPath,g.tmpDir.fsPath,g.userDataPath]}e.getPiiPathsFromEnvironment=I}),define(Y[220],X([0,1,179,72]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(R,M,S,d,p,C,k){const y={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${M.nameShort})`},m=await(0,v.getServiceMachineId)(S,p,C),{sessionId:u}=await k.getTelemetryInfo();return(0,t.supportsTelemetry)(M,S)&&(0,t.getTelemetryLevel)(d)===3&&(y["X-Market-User-Id"]=m,y["VSCode-SessionId"]=u),y}e.resolveMarketplaceHeaders=D}),define(Y[221],X([0,1,2,50,91,4,31,162,18,60,58,20,44,35,72]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let b=class{constructor(I,g,h){this._configurationService=g,this._productService=h,this._experimentProperties={},this.telemetryLevel=new D.MutableObservableValue(3),this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=I.appenders,this._commonProperties=I.commonProperties||Promise.resolve({}),this._piiPaths=I.piiPaths||[],this._sendErrorTelemetry=!!I.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const l of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(l),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(I,g){this._experimentProperties[I]=g}_updateTelemetryLevel(){let I=(0,u.getTelemetryLevel)(this._configurationService);const g=this._productService.enabledTelemetryLevels;if(g){this._sendErrorTelemetry=this.sendErrorTelemetry?g.error:!1;const h=g.usage?3:g.error?2:0;I=Math.min(I,h)}this.telemetryLevel.value=I}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const I=await this._commonProperties,g=I.sessionID,h=I["common.machineId"],l=I["common.firstSessionDate"],n=I["common.msftInternal"];return{sessionId:g,machineId:h,firstSessionDate:l,msftInternal:n}}dispose(){this._disposables.dispose()}_log(I,g,h,l){return this.telemetryLevel.value<g?Promise.resolve(void 0):this._commonProperties.then(n=>{h=(0,t.mixin)(h,n),h=(0,t.mixin)(h,this._experimentProperties),h=(0,t.cloneAndChange)(h,r=>{if(typeof r=="string")return this._cleanupInfo(r,l)}),this._appenders.forEach(r=>r.log(I,h))},n=>{console.error(n)})}publicLog(I,g,h){return this._log(I,3,g,h)}publicLog2(I,g,h){return this.publicLog(I,g,h)}publicLogError(I,g){return this._sendErrorTelemetry?this._log(I,2,g,!0):Promise.resolve(void 0)}publicLogError2(I,g){return this.publicLogError(I,g)}_anonymizeFilePaths(I){let g=I;const h=[];for(const i of this._cleanupPatterns)for(;;){const s=i.exec(I);if(!s)break;h.push([s.index,i.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,n=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(g="";;){const i=n.exec(I);if(!i)break;!l.test(i[0])&&h.every(([s,o])=>i.index<s||i.index>=o)&&(g+=I.substring(r,i.index)+"<REDACTED: user-file-path>",r=n.lastIndex)}return r<I.length&&(g+=I.substr(r)),g}_removePropertiesWithPossibleUserInfo(I){if(!I)return I;const g=I.toLowerCase(),h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const l of h)if(l.regex.test(g))return`<REDACTED: ${l.label}>`;return I}_cleanupInfo(I,g){let h=I;g&&(h=this._anonymizeFilePaths(h));for(const l of this._cleanupPatterns)h=h.replace(l,"");return h=this._removePropertiesWithPossibleUserInfo(h),h}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",b=fe([ee(1,d.IConfigurationService),ee(2,k.IProductService)],b),e.TelemetryService=b;function w(){const E=(0,S.localize)(0,null,C.default.nameLong),I=C.default.privacyStatementUrl?(0,S.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,S.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=R.isWeb?"":(0,S.localize)(3,null),h=(0,S.localize)(4,null),l=(0,S.localize)(5,null),n=(0,S.localize)(6,null),r=(0,S.localize)(7,null),i=`
|       | ${h} | ${l} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,S.localize)(8,null);return`
${E} ${I} ${g}

&nbsp;

${r}
${i}

&nbsp;

${s}
`}y.Registry.as(p.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,S.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,S.localize)(10,null),(0,S.localize)(11,null),(0,S.localize)(12,null),(0,S.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(p.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,S.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,S.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,S.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,S.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[222],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var v;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(v=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===v.HIGH_CONTRAST_DARK||R===v.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function D(R){return R===v.DARK||R===v.HIGH_CONTRAST_DARK}e.isDark=D}),define(Y[223],X([0,1,116,3,2,5,44,222]),function(z,e,v,t,D,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var d;(function(w){function E(I){return I&&typeof I=="object"&&typeof I.id=="string"}w.isThemeColor=E})(d=e.ThemeColor||(e.ThemeColor={}));function p(w){return{id:w}}e.themeColorFromId=p;var C;(function(w){function E(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||d.isThemeColor(s.color))}w.isThemeIcon=E;const I=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function g(s){const o=I.exec(s);if(!o)return;const[,a]=o;return{id:a}}w.fromString=g;function h(s){return{id:s}}w.fromId=h;function l(s,o){let a=s.id;const c=a.lastIndexOf("~");return c!==-1&&(a=a.substring(0,c)),o&&(a=`${a}~${o}`),{id:a}}w.modify=l;function n(s){const o=s.id.lastIndexOf("~");if(o!==-1)return s.id.substring(o+1)}w.getModifier=n;function r(s,o){return s.id===o.id&&s.color?.id===o.color?.id}w.isEqual=r;function i(s,o){return{id:s.id,color:o?p(o):void 0}}w.asThemeIcon=i,w.asClassNameArray=v.CSSIcon.asClassNameArray,w.asClassName=v.CSSIcon.asClassName,w.asCSSSelector=v.CSSIcon.asCSSSelector})(C=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function k(w){switch(w){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case S.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class y{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(E){return this.themingParticipants.push(E),this.onThemingParticipantAddedEmitter.fire(E),(0,D.toDisposable)(()=>{const I=this.themingParticipants.indexOf(E);this.themingParticipants.splice(I,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const m=new y;M.Registry.add(e.Extensions.ThemingContribution,m);function u(w){return m.onColorThemeChange(w)}e.registerThemingParticipant=u;class b extends D.Disposable{constructor(E){super();this.themeService=E,this.theme=E.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(I=>this.onThemeChange(I)))}onThemeChange(E){this.theme=E,this.updateStyles()}updateStyles(){}getColor(E,I){let g=this.theme.getColor(E);return g&&I&&(g=I(g,this.theme)),g?g.toString():null}}e.Themable=b}),define(Y[61],X([0,1,14,3,2,4,18,5,45]),function(z,e,v,t,D,R,M,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const p="#FFFFFF",C="#1E1E1E",k="#000000",y="#FFFFFF",m="theme",u="themeBackground",b="windowSplash";e.IThemeMainService=(0,S.createDecorator)("themeMainService");let w=class extends D.Disposable{constructor(I,g){super();this.stateMainService=I,this.configurationService=g,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,v.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(v.nativeTheme.shouldUseHighContrastColors)return{dark:v.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors)return{dark:v.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&v.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:v.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const I=this.getColorScheme();if(I.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return I.dark?k:y;let g=this.stateMainService.getItem(u,null);if(!g)switch(this.stateMainService.getItem(m,"vs-dark").split(" ")[0]){case"vs":g=p;break;case"hc-black":g=k;break;case"hc-light":g=y;break;default:g=C}return R.isMacintosh&&g.toUpperCase()===C&&(g="#171717"),g}saveWindowSplash(I,g){this.stateMainService.setItems([{key:m,data:g.baseTheme},{key:u,data:g.colorInfo.background},{key:b,data:g}]),typeof I=="number"&&this.updateBackgroundColor(I,g)}updateBackgroundColor(I,g){for(const h of v.BrowserWindow.getAllWindows())if(h.id===I){h.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(b)}};w=fe([ee(0,d.IStateMainService),ee(1,M.IConfigurationService)],w),e.ThemeMainService=w}),define(Y[107],X([0,1,3,4,5,6]),function(z,e,v,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var M;(function(b){b.Http="http",b.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var S;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(S=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var d;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(d=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function p(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=p,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(b){return e.LOCALHOST_ADDRESSES.indexOf(b)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(b){return e.ALL_INTERFACES_ADDRESSES.indexOf(b)>=0}e.isAllInterfaces=k;function y(b,w){return w?w!==1&&b<1024:!t.isWindows&&b<1024}e.isPortPrivileged=y;class m{constructor(w,E,I){this.remoteAddress=w,this.localAddress=E,this._dispose=I,this._onDispose=new v.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=m;let u=class{constructor(w){this.logService=w,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w){return this._tunnelProvider=w,w?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(w){this._canElevate=w.elevation,this._privacyOptions=w.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],E=Array.from(this._tunnels.values());for(const I of E){const g=Array.from(I.values());for(const h of g){const l=await h.value;l&&w.push(l)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:E}of w.values())await E.then(I=>I?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,E,I,g,h=!1,l,n){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${E}:${I} on local port ${g}.`),!w)return;if(E||(E="localhost"),this._tunnelProvider&&this._factoryInProgress.has(I)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(w,E,I,g,h,l,n);return r?r.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(E,I);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(i);return(i.tunnelRemoteHost!==E||i.tunnelRemotePort!==I)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const E=this._tunnels.get(w.tunnelRemoteHost);if(E){const I=E.get(w.tunnelRemotePort);I&&(I.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,I))}}}}async tryDisposeTunnel(w,E,I){if(I.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${E}.`);const g=I.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(E),g}}async closeTunnel(w,E){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${E} `);const I=this._tunnels.get(w);if(I&&I.has(E)){const g=I.get(E);g.refcount=0,await this.tryDisposeTunnel(w,E,g)}}addTunnelToMap(w,E,I){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(E,{refcount:1,value:I})}async removeEmptyTunnelFromMap(w,E){const I=this._tunnels.get(w);I&&(await I.get(E)||I.delete(E),I.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,E){const I=[w];C(w)?(I.push(...e.LOCALHOST_ADDRESSES),I.push(...e.ALL_INTERFACES_ADDRESSES)):k(w)&&I.push(...e.ALL_INTERFACES_ADDRESSES);const g=I.map(h=>this._tunnels.get(h));for(const h of g){const l=h?.get(E);if(l)return l}}canTunnel(w){return!!p(w)}createWithProvider(w,E,I,g,h,l,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${E}:${I} on local port ${g}.`);const r=I;this._factoryInProgress.add(r);const s={elevationRequired:h?y(g===void 0?I:g):!1},o={remoteAddress:{host:E,port:I},localAddressPort:g,privacy:l,public:l?l!==S.Private:void 0,protocol:n},a=w.forwardPort(o,s);return a?(this.addTunnelToMap(E,I,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),a}};u=fe([ee(0,R.ILogService)],u),e.AbstractTunnelService=u}),define(Y[224],X([0,1,76,90,208,8,2,18,6,20,207,107,86]),function(z,e,v,t,D,R,M,S,d,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function m(I,g,h,l,n){let r;for(let i=3;i&&(r&&r.dispose(),r=await new u(I,g,h,l,n).waitForReady(),!(n&&t.BROWSER_RESTRICTED_PORTS[n]||!t.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));i--);return r}class u extends M.Disposable{constructor(g,h,l,n,r){super();this.defaultTunnelHost=h,this.suggestedLocalPort=r,this.privacy=k.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=g,this._server=v.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){let g=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),h=null;return this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address(),h||(g=0,this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async _onConnection(g){g.pause();const h=(0,k.isLocalhost)(this.tunnelRemoteHost)||(0,k.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,C.connectRemoteAgentTunnel)(this._options,h,this.tunnelRemotePort),n=l.getSocket().socket,r=l.readEntireBuffer();l.dispose(),r.byteLength>0&&g.write(r.buffer),g.on("end",()=>{g.localAddress&&this._socketsDispose.delete(g.localAddress),n.end()}),g.on("close",()=>n.end()),g.on("error",()=>{g.localAddress&&this._socketsDispose.delete(g.localAddress),n.destroy()}),n.on("end",()=>g.end()),n.on("close",()=>g.end()),n.on("error",()=>{g.destroy()}),g.pipe(n),n.pipe(g),g.localAddress&&this._socketsDispose.set(g.localAddress,()=>{g.end(),n.end()})}}let b=class extends k.AbstractTunnelService{constructor(g,h,l,n,r){super(h);this.socketFactory=g,this.signService=l,this.productService=n,this.configurationService=r}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(g,h,l,n,r,i,s){const o=this.getTunnelFromMap(h,l);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,l,n,r,i,s);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${l} on local port ${n}.`);const a={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:g,signService:this.signService,logService:this.logService,ipcLogger:null},c=m(a,this.defaultTunnelHost,h,l,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,l,c),c}}};b=fe([ee(1,d.ILogService),ee(2,y.ISignService),ee(3,p.IProductService),ee(4,S.IConfigurationService)],b),e.BaseTunnelService=b;let w=class extends b{constructor(g,h,l,n){super(D.nodeSocketFactory,g,h,l,n)}};w=fe([ee(0,d.ILogService),ee(1,y.ISignService),ee(2,p.IProductService),ee(3,S.IConfigurationService)],w),e.TunnelService=w;let E=class extends M.Disposable{constructor(g,h,l,n){super();this.logService=g,this.productService=h,this.signService=l,this.configurationService=n,this._tunnelServices=new Map}async openTunnel(g,h,l,n,r,i,s,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${n} on local port ${r}.`),!this._tunnelServices.has(g)){const a=new w(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(g,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(g))})}return this._tunnelServices.get(g).openTunnel(h,l,n,r,i,s,o)}};E=fe([ee(0,d.ILogService),ee(1,p.IProductService),ee(2,y.ISignService),ee(3,S.IConfigurationService)],E),e.SharedTunnelsService=E}),define(Y[46],X([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var D;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,M)=>({type:"idle",updateType:R,error:M}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(Y[225],X([0,1,4,163,60,44]),function(z,e,v,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Y[226],X([0,1,3,46]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(S){this.service=S}listen(S,d){switch(d){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${d}`)}call(S,d,p){switch(d){case"checkForUpdates":return this.service.checkForUpdates(p);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${d}`)}}e.UpdateChannel=D;class R{constructor(S){this.channel=S,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(d=>this.state=d),this.channel.call("_getInitialState").then(d=>this.state=d)}get state(){return this._state}set state(S){this._state=S,this._onStateChange.fire(S)}checkForUpdates(S){return this.channel.call("checkForUpdates",S)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=R}),define(Y[87],X([0,1,8,21,3,18,26,22,6,20,52,46]),function(z,e,v,t,D,R,M,S,d,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function y(u,b,w){return`${w.updateUrl}/api/update/${u}/${b}/${w.commit}`}e.createUpdateURL=y;let m=class{constructor(b,w,E,I,g,h){this.lifecycleMainService=b,this.configurationService=w,this.environmentMainService=E,this.requestService=I,this.logService=g,this.productService=h,this._state=k.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(b){this.logService.info("update#setState",b.type),this._state=b,this._onStateChange.fire(b)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const b=this.getUpdateMode(),w=this.getProductQuality(b);if(!w){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(w),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(k.State.Idle(this.getUpdateType())),b==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}b==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,E=>this.logService.error(E))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(b){return b==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(b=60*60*1e3){return(0,v.timeout)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(b){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(b)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(b){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(b=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}getUpdateType(){return 1}doQuitAndInstall(){}};m=fe([ee(0,S.ILifecycleMainService),ee(1,R.IConfigurationService),ee(2,M.IEnvironmentMainService),ee(3,C.IRequestService),ee(4,d.ILogService),ee(5,p.IProductService)],m),e.AbstractUpdateService=m}),define(Y[227],X([0,1,14,51,3,2,18,26,22,6,20,52,35,46,87]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let b=class extends u.AbstractUpdateService{constructor(E,I,g,h,l,n,r){super(E,I,h,l,n,r);this.telemetryService=g,this.disposables=new R.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"error",(E,I)=>I)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(E,I,g)=>({url:I,version:g,productVersion:g}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(E,I,g,h)=>({releaseNotes:I,version:g,productVersion:g,date:h}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(E){this.logService.error("UpdateService error:",E);const g=(this.state.type==="checking for updates"?this.state.explicit:!0)?E:void 0;this.setState(m.State.Idle(1,g))}buildUpdateFeedUrl(E){let I;this.productService.darwinUniversalAssetId?I=this.productService.darwinUniversalAssetId:I=process.arch==="x64"?"darwin":"darwin-arm64";const g=(0,u.createUpdateURL)(I,E,this.productService);try{v.autoUpdater.setFeedURL({url:g})}catch(h){this.logService.error("Failed to set update feed URL",h);return}return g}doCheckForUpdates(E){this.setState(m.State.CheckingForUpdates(E)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(E){this.state.type==="checking for updates"&&this.setState(m.State.Downloading(E))}onUpdateDownloaded(E){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:E.version}),this.setState(m.State.Ready(E)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(m.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};fe([t.memoize],b.prototype,"onRawError",null),fe([t.memoize],b.prototype,"onRawUpdateNotAvailable",null),fe([t.memoize],b.prototype,"onRawUpdateAvailable",null),fe([t.memoize],b.prototype,"onRawUpdateDownloaded",null),b=fe([ee(0,d.ILifecycleMainService),ee(1,M.IConfigurationService),ee(2,y.ITelemetryService),ee(3,S.IEnvironmentMainService),ee(4,k.IRequestService),ee(5,p.ILogService),ee(6,C.IProductService)],b),e.DarwinUpdateService=b}),define(Y[228],X([0,1,42,27,8,3,9,26,22,6,35,46]),function(z,e,v,t,D,R,M,S,d,p,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let y=class{constructor(b,w,E){if(this.lifecycleMainService=b,this.logService=E,this._state=k.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,w.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(k.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,I=>this.logService.error(I))}get state(){return this._state}setState(b){this.logService.info("update#setState",b.type),this._state=b,this._onStateChange.fire(b)}scheduleCheckForUpdates(b=60*60*1e3){return(0,D.timeout)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(b){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(b)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(b){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(b=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};y=fe([ee(0,d.ILifecycleMainService),ee(1,S.IEnvironmentMainService),ee(2,p.ILogService)],y);let m=class extends y{constructor(b,w,E,I,g,h){super(E,I,g);this.snap=b,this.snapRevision=w,this.telemetryService=h;const l=(0,t.watch)(M.dirname(this.snap)),n=R.Event.fromNodeEventEmitter(l,"change",(o,a)=>a),r=R.Event.filter(n,o=>o==="current"),s=R.Event.debounce(r,(o,a)=>a,2e3)(()=>this.checkForUpdates(!1));E.onWillShutdown(()=>{s.dispose(),l.close()})}doCheckForUpdates(){this.setState(k.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(b=>{b?this.setState(k.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(k.State.Idle(2)))},b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(k.State.Idle(2,b.message||b))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const b=await new Promise((E,I)=>(0,t.realpath)(`${M.dirname(this.snap)}/current`,(g,h)=>g?I(g):E(h))),w=M.basename(b);return this.snapRevision!==w}isLatestVersion(){return this.isUpdateAvailable().then(void 0,b=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};m=fe([ee(2,d.ILifecycleMainService),ee(3,S.IEnvironmentMainService),ee(4,p.ILogService),ee(5,C.ITelemetryService)],m),e.SnapUpdateService=m}),define(Y[62],X([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,v.createDecorator)("IUriIdentityService")}),define(Y[229],X([0,1,62,180,15,16,122,3,2]),function(z,e,v,t,D,R,M,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class p{constructor(y){this.uri=y,this.time=p._clock++}touch(){return this.time=p._clock++,this}}p._clock=0;let C=class{constructor(y){this._fileService=y,this._dispooables=new d.DisposableStore,this._limit=2**16;const m=new Map,u=b=>{let w=m.get(b.scheme);return w===void 0&&(w=y.hasProvider(b)&&!this._fileService.hasCapability(b,1024),m.set(b.scheme,w)),w};this._dispooables.add(S.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(b=>{m.delete(b.scheme)})),this.extUri=new R.ExtUri(u),this._canonicalUris=new M.SkipList((b,w)=>this.extUri.compare(b,w,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(y){this._fileService.hasProvider(y)&&(y=(0,R.normalizePath)(y));const m=this._canonicalUris.get(y);return m?m.touch().uri.with({fragment:y.fragment}):(this._canonicalUris.set(y,new p(y)),this._checkTrim(),y)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const y=[...this._canonicalUris.entries()].sort((u,b)=>u[1].touch<b[1].touch?1:u[1].touch>b[1].touch?-1:0);p._clock=0,this._canonicalUris.clear();const m=this._limit*.5;for(let u=0;u<m;u++)this._canonicalUris.set(y[u][0],y[u][1].touch())}};C=fe([ee(0,D.IFileService)],C),e.UriIdentityService=C,(0,t.registerSingleton)(v.IUriIdentityService,C,!0)}),define(Y[108],X([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(Y[230],X([0,1,7]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(S){this.handler=S}listen(S,d){throw new Error(`Event not found: ${d}`)}call(S,d,p){switch(d){case"handleURL":return this.handler.handleURL(v.URI.revive(p[0]),p[1])}throw new Error(`Call not found: ${d}`)}}e.URLHandlerChannel=t;class D{constructor(S){this.channel=S}handleURL(S,d){return this.channel.call("handleURL",[S.toJSON(),d])}}e.URLHandlerChannelClient=D;class R{constructor(S){this.next=S}async routeCall(S,d,p,C){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(p){const k=v.URI.revive(p);if(k&&k.query){const y=/\bwindowId=(\d+)/.exec(k.query);if(y){const m=y[1],u=new RegExp(`window:${m}`),b=S.connections.find(w=>u.test(w.ctx));if(b)return b}}}return this.next.routeCall(S,d,p,C)}routeEvent(S,d){throw new Error(`Event not found: ${d}`)}}e.URLHandlerRouter=R}),define(Y[231],X([0,1,8,2,7,20]),function(z,e,v,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends t.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(p,C){const k=[...this.handlers.values()];return(0,v.first)(k.map(y=>()=>y.handleURL(p,C)),void 0,!1).then(y=>y||!1)}registerHandler(p){return this.handlers.add(p),(0,t.toDisposable)(()=>this.handlers.delete(p))}}e.AbstractURLService=M;let S=class extends M{constructor(p){super();this.productService=p}create(p){let{authority:C,path:k,query:y,fragment:m}=p||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return C&&k&&k.indexOf("/")!==0&&(k=`/${k}`),D.URI.from({scheme:this.productService.urlProtocol,authority:C,path:k,query:y,fragment:m})}};S=fe([ee(0,R.IProductService)],S),e.NativeURLService=S}),define(Y[232],X([0,1,14,8,3,2,4,7]),function(z,e,v,t,D,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function d(C){try{return S.URI.parse(C)}catch{return null}}class p{constructor(k,y,m,u,b){if(this.urlService=y,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=k,M.isWindows){const I=u.isBuilt?[]:[`"${u.appRoot}"`];I.push("--open-url","--"),v.app.setAsDefaultProtocolClient(b.urlProtocol,process.execPath,I)}const w=D.Event.map(D.Event.fromNodeEventEmitter(v.app,"open-url",(I,g)=>({event:I,url:g})),({event:I,url:g})=>(I.preventDefault(),g));this.disposables.add(w(I=>{const g=d(I);!g||this.urlService.open(g,{originalUrl:I})})),m.getWindows().filter(I=>I.isReady).length>0?this.flush():D.Event.once(m.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const k=[];for(const y of this.uris)await this.urlService.open(y.uri,{originalUrl:y.url})||k.push(y);k.length!==0&&(this.uris=k,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=p}),define(Y[233],X([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(Y[234],X([0,1,14,2,12,7]),function(z,e,v,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends t.Disposable{constructor(){super();const d=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(D.Schemas.vscodeWebview,d)}handleWebviewRequest(d,p){try{const C=R.URI.parse(d.url),k=M.validWebviewFilePaths.get(C.path);if(typeof k=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${k}`,m=D.FileAccess.asFileUri(y,z);return p(decodeURIComponent(m.fsPath))}else return p({error:-10})}catch{}return p({error:-2})}}e.WebviewProtocolProvider=M,M.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(Y[73],X([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(C){return!!C.workspaceUri}e.isWorkspaceToOpen=t;function D(C){return!!C.folderUri}e.isFolderToOpen=D;function R(C){return!!C.fileUri}e.isFileToOpen=R;function M(C){const k=S(C),y=C.getValue("window.menuBarVisibility");return y==="default"||k==="native"&&y==="compact"||v.isMacintosh&&v.isNative?"classic":y}e.getMenuBarVisibility=M;function S(C){if(v.isWeb)return"custom";const k=C.getValue("window");if(k){if(v.isMacintosh&&k.nativeTabs===!0||v.isMacintosh&&k.nativeFullScreen===!1)return"native";const u=C.getValue("workbench.colorCustomizations");if(u?.["window.activeBorder"]||u?.["window.inactiveBorder"])return"custom";const b=k.titleBarStyle;if(b==="native"||b==="custom")return b}return v.isLinux?"native":"custom"}e.getTitleBarStyle=S;function d(C,k){return!v.isWindows||v.isWeb||!k.isBuilt||S(C)==="native"?!1:C.getValue("window.experimental.windowControlsOverlay.enabled")}e.useWindowControlsOverlay=d;function p(C=0){return Math.pow(1.2,C)}e.zoomLevelToZoomFactor=p}),define(Y[109],X([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var v;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(v=e.LoadReason||(e.LoadReason={}));var t;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const D=function(S=1){return{width:1024,height:768,mode:S}};e.defaultWindowState=D;var R;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var M;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.CRASHED=2]="CRASHED",S[S.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={}))}),define(Y[32],X([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,v.createDecorator)("windowsMainService");var t;(function(D){D[D.CLI=0]="CLI",D[D.DOCK=1]="DOCK",D[D.MENU=2]="MENU",D[D.DIALOG=3]="DIALOG",D[D.DESKTOP=4]="DESKTOP",D[D.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(Y[235],X([0,1,14,21,3,65,2,30,68,99,6,20,32]),function(z,e,v,t,D,R,M,S,d,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var m;(function(b){b[b.Initial=1]="Initial",b[b.StoredCredentialsUsed=2]="StoredCredentialsUsed",b[b.LoginDialogShown=3]="LoginDialogShown"})(m||(m={}));let u=class extends M.Disposable{constructor(w,E,I,g,h){super();this.logService=w,this.windowsMainService=E,this.credentialsService=I,this.encryptionMainService=g,this.productService=h,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=m.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const w=D.Event.fromNodeEventEmitter(v.app,"login",(E,I,g,h,l)=>({event:E,webContents:I,req:g,authInfo:h,callback:l}));this._register(w(this.onLogin,this))}async onLogin({event:w,authInfo:E,req:I,callback:g}){if(!E.isProxy)return;if(!this.pendingProxyResolve&&this.state===m.LoginDialogShown&&I.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}w.preventDefault();let h;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),h=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(E);try{h=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}g(h?.username,h?.password)}async resolveProxyCredentials(w){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const E=await this.doResolveProxyCredentials(w);if(E)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),E;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(w){this.logService.trace("auth#doResolveProxyCredentials - enter",w);const E=String((0,R.hash)({scheme:w.scheme,host:w.host,port:w.port}));let I,g;try{const r=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,E);if(r){const i=JSON.parse(await this.encryptionMainService.decrypt(r));I=i.username,g=i.password}}catch(r){this.logService.error(r)}if(this.state!==m.StoredCredentialsUsed&&typeof I=="string"&&typeof g=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=m.StoredCredentialsUsed,{username:I,password:g};const h=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!h){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${h.id} to handle proxy login`);const l={authInfo:w,username:this.sessionCredentials?.username??I,password:this.sessionCredentials?.password??g,replyChannel:`vscode:proxyAuthResponse:${(0,S.generateUuid)()}`};h.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,l),this.state=m.LoginDialogShown;const n=await new Promise(r=>{const i=async(s,o,a)=>{if(o===l.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${h.id}`),h.win?.webContents.off("ipc-message",i),a){const c={username:a.username,password:a.password};try{if(a.remember){const f=await this.encryptionMainService.encrypt(JSON.stringify(c));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,E,f)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,E)}catch(f){this.logService.error(f)}r({username:c.username,password:c.password})}else r(void 0)};h.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=n,n}};u=fe([ee(0,C.ILogService),ee(1,y.IWindowsMainService),ee(2,d.ICredentialsMainService),ee(3,p.IEncryptionMainService),ee(4,k.IProductService)],u),e.ProxyAuthHandler=u}),define(Y[236],X([0,1,68,6,39,20,32,191]),function(z,e,v,t,D,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let d=class extends S.BaseCredentialsMainService{constructor(C,k,y,m){super(C);this.environmentMainService=k,this.productService=y,this.windowsMainService=m,this.surfaceKeytarLoadError=u=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",u.message??u)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new v.InMemoryCredentialsProvider,this._keytarCache;const C=await new Promise((k,y)=>{z(["keytar"],k,y)});return await C.findCredentials("test-keytar-loads"),this._keytarCache=C,this._keytarCache}};d=fe([ee(0,t.ILogService),ee(1,D.INativeEnvironmentService),ee(2,R.IProductService),ee(3,M.IWindowsMainService)],d),e.CredentialsNativeMainService=d}),define(Y[237],X([0,1,19,2,3,6,22,78,42,125,8,12,50,4,36,14,32]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const E=b.UtilityProcess,I=typeof E!="undefined";let g=class Rt{constructor(r,i,s){this._logService=r,this._windowsMainService=s,this._shutdown=!1,this._extHosts=new Map,i.onWillShutdown(o=>{this._shutdown=!0,o.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(r){const i=this._extHosts.get(r);if(!i)throw new Error("Unknown extension host!");return i}onDynamicStdout(r){return this._getExtHost(r).onStdout}onDynamicStderr(r){return this._getExtHost(r).onStderr}onDynamicMessage(r){return this._getExtHost(r).onMessage}onDynamicError(r){return this._getExtHost(r).onError}onDynamicExit(r){return this._getExtHost(r).onExit}async canUseUtilityProcess(){return I}async createExtensionHost(r){if(this._shutdown)throw(0,v.canceled)();const i=String(++Rt._lastId);let s;if(r){if(!I)throw new Error("Cannot use UtilityProcess!");s=new l(i,this._logService,this._windowsMainService)}else s=new h(i,this._logService);return this._extHosts.set(i,s),s.onExit(({pid:o,code:a,signal:c})=>{this._logService.info(`Extension host with pid ${o} exited with code: ${a}, signal: ${c}.`),setTimeout(()=>{s.dispose(),this._extHosts.delete(i)})}),{id:i}}async start(r,i){if(this._shutdown)throw(0,v.canceled)();return this._getExtHost(r).start(i)}async enableInspectPort(r){if(this._shutdown)throw(0,v.canceled)();const i=this._extHosts.get(r);return i?i.enableInspectPort():!1}async kill(r){if(this._shutdown)throw(0,v.canceled)();const i=this._extHosts.get(r);!i||i.kill()}async _killAllNow(){for(const[,r]of this._extHosts)r.kill()}async _waitForAllExit(r){const i=[];for(const[,s]of this._extHosts)i.push(s.waitForExit(r));return C.Promises.settled(i).then(()=>{})}};g._lastId=0,g=fe([ee(0,R.ILogService),ee(1,M.ILifecycleMainService),ee(2,w.IWindowsMainService)],g),e.ExtensionHostStarter=g;let h=class extends t.Disposable{constructor(r,i){super();this.id=r,this._logService=i,this._onStdout=this._register(new D.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new D.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new D.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._onExit=this._register(new D.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(r){m.isCI&&this._logService.info("Calling fork to start extension host...");const i=S.StopWatch.create(!1);this._process=(0,d.fork)(k.FileAccess.asFileUri("bootstrap-fork",z).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,y.mixin)({cwd:(0,u.cwd)()},r));const s=i.elapsed(),o=this._process.pid;this._logService.info(`Starting extension host with pid ${o} (fork() took ${s} ms).`);const a=new p.StringDecoder("utf-8");this._process.stdout?.on("data",f=>{const P=typeof f=="string"?f:a.write(f);this._onStdout.fire(P)});const c=new p.StringDecoder("utf-8");this._process.stderr?.on("data",f=>{const P=typeof f=="string"?f:c.write(f);this._onStderr.fire(P)}),this._process.on("message",f=>{this._onMessage.fire(f)}),this._process.on("error",f=>{this._onError.fire({error:(0,v.transformErrorForSerialization)(f)})}),this._process.on("exit",(f,P)=>{this._hasExited=!0,this._onExit.fire({pid:o,code:f,signal:P})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):m.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(r){if(!this._process)return;const i=this._process.pid;this._logService.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([D.Event.toPromise(this.onExit),(0,C.timeout)(r)]),this._hasExited||(this._logService.info(`Extension host with pid ${i} did not exit within ${r}ms.`),this._process.kill())}};h=fe([ee(1,R.ILogService)],h);let l=class extends t.Disposable{constructor(r,i,s){super();this.id=r,this._logService=i,this._windowsMainService=s,this.onStdout=D.Event.None,this.onStderr=D.Event.None,this.onError=D.Event.None,this._onMessage=this._register(new D.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new D.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(r){const i=this._windowsMainService.getWindowById(r.responseWindowId);if(!i){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const s=i.win;if(!s||s.isDestroyed()||s.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const o=`extensionHost${this.id}`,a=k.FileAccess.asFileUri("bootstrap-fork.js",z).fsPath,c=["--type=extensionHost","--skipWorkspaceStorageLock"],f=r.execArgv||[],P={...r.env};for(const $ of Object.keys(P))P[$]=String(P[$]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new E(a,c,{serviceName:o,env:P,execArgv:f}),this._register(D.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)})),this._register(D.Event.fromNodeEventEmitter(this._process,"exit")($=>{$=$||0,this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${$}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:$,signal:""})}));const L=($,te)=>{te.type==="Utility"&&te.name===o&&(this._logService.info(`UtilityProcess<${this.id}>: terminated unexpectedly with code ${te.exitCode}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:te.exitCode,signal:""}))};b.app.on("child-process-gone",L),this._register((0,t.toDisposable)(()=>{b.app.off("child-process-gone",L)}));const{port1:T,port2:W}=new b.MessageChannelMain;this._process.postMessage("port",null,[W]),s.webContents.postMessage(r.responseChannel,r.responseNonce,[T])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):m.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(r){if(!this._process)return;const i=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${i} to exit.`),await Promise.race([D.Event.toPromise(this.onExit),(0,C.timeout)(r)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${i} did not exit within ${r}ms, will kill it now.`),this._process.kill())}};l=fe([ee(1,R.ILogService),ee(2,w.IWindowsMainService)],l)}),define(Y[238],X([0,1,14,3,2,234,32]),function(z,e,v,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let S=class extends D.Disposable{constructor(p){super();this.windowsMainService=p,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(p,C){let k;if(typeof p.windowId=="number"){const{windowId:y}=p,m=this.windowsMainService.getWindowById(y);if(!m?.win)throw new Error(`Invalid windowId: ${y}`);k=m.win.webContents}else{const{webContentsId:y}=p;if(k=v.webContents.fromId(y),!k)throw new Error(`Invalid webContentsId: ${y}`)}k.isDestroyed()||k.setIgnoreMenuShortcuts(C)}async findInFrame(p,C,k,y){const u=this.getFrameByName(p,C);if(typeof u.findInFrame=="function"){u.findInFrame(k,{findNext:y.findNext,forward:y.forward});const b=(w,E)=>{E.finalUpdate&&(this._onFoundInFrame.fire(E),u.removeListener("found-in-frame",b))};u.on("found-in-frame",b)}}async stopFindInFrame(p,C,k){const m=this.getFrameByName(p,C);typeof m.stopFindInFrame=="function"&&m.stopFindInFrame(k.keepSelection?"keepSelection":"clearSelection")}getFrameByName(p,C){const k=this.windowsMainService.getWindowById(p.windowId);if(!k?.win)throw new Error(`Invalid windowId: ${p}`);const y=k.win.webContents.mainFrame.framesInSubtree.find(m=>m.name===C);if(!y)throw new Error(`Unknown frame: ${C}`);return y}};S=fe([ee(0,M.IWindowsMainService)],S),e.WebviewMainService=S}),define(Y[239],X([0,1,8,3,2]),function(z,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends D.Disposable{constructor({onDidOpenWindow:S,onDidFocusWindow:d,getActiveWindowId:p}){super();this.disposables=this._register(new D.DisposableStore),t.Event.latch(t.Event.any(S,d))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>p()),(async()=>{try{const k=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:k}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(S){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=S}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(Y[24],X([0,1,167,9,33,16,7,5,12]),function(z,e,v,t,D,R,M,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");function p(i){const s=i;return typeof s?.id=="string"&&M.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=p;function C(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=C;function k(i){const s=i;return typeof s?.id=="string"&&M.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=k;function y(i){const s=i;if(s?.uri)return{id:s.id,uri:M.URI.revive(s.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:M.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=y;var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function u(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=u;function b(i){const s=i;return!!(s&&typeof s=="object"&&M.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=b;class w{constructor(s,o,a,c,f){this._id=s,this._transient=a,this._configuration=c,this._ignorePathCasing=f,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class E{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,R.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=E;function I(i){return new E({uri:i,index:0,name:(0,R.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=I,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,v.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function h(i,s){return R.extUriBiasedIgnorePathCase.isEqualOrParent(i,s.untitledWorkspacesHome)}e.isUntitledWorkspace=h;function l(i){let s;return M.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===d.Schemas.tmp}e.isTemporaryWorkspace=l;function n(i,s){return!h(i,s)&&!l(i)}e.isSavedWorkspace=n;function r(i){return(typeof i=="string"?(0,t.extname)(i):(0,R.extname)(i))===g}e.hasWorkspaceFileExtension=r}),define(Y[240],X([0,1,75,27,29,12,9,4,16,7,23,171,18,26,15,6,170,24]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u,b,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let I=class{constructor(h,l,n){this.configurationService=l,this.logService=n,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=d.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(r,i)=>(0,D.isEqual)(r,i,!S.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await C.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let l=[];try{Array.isArray(h.rootURIWorkspaces)&&(l=h.rootURIWorkspaces.map(r=>({workspace:{id:r.id,configPath:p.URI.parse(r.configURIPath)},remoteAuthority:r.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(l);let n=[];try{Array.isArray(h.folderWorkspaceInfos)?n=h.folderWorkspaceInfos.map(r=>({folderUri:p.URI.parse(r.folderUri),remoteAuthority:r.remoteAuthority})):Array.isArray(h.folderURIWorkspaces)&&(n=h.folderURIWorkspaces.map(r=>({folderUri:p.URI.parse(r),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(n),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==u.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===u.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||u.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,l){this.workspaces.some(r=>h.workspace.id===r.workspace.id)||(this.workspaces.push(h),this.saveSync());const n=this.getBackupPath(h.workspace.id);return l&&this.moveBackupFolderSync(n,l),n}moveBackupFolderSync(h,l){if(t.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),t.existsSync(l))try{t.renameSync(l,h)}catch(n){this.logService.error(`Backup: Could not move backup folder to new location: ${n.toString()}`)}}unregisterWorkspaceBackupSync(h){const l=h.id,n=this.workspaces.findIndex(r=>r.workspace.id===l);n!==-1&&(this.workspaces.splice(n,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(l=>this.backupUriComparer.isEqual(h.folderUri,l.folderUri))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const l=this.folders.findIndex(n=>this.backupUriComparer.isEqual(h,n.folderUri));l!==-1&&(this.folders.splice(l,1),this.saveSync())}registerEmptyWindowBackupSync(h,l){const n=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,n))||(this.emptyWindows.push({backupFolder:n,remoteAuthority:l}),this.saveSync()),this.getBackupPath(n)}unregisterEmptyWindowBackupSync(h){const l=this.emptyWindows.findIndex(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,h));l!==-1&&(this.emptyWindows.splice(l,1),this.saveSync())}getBackupPath(h){return(0,M.join)(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const l=new Set,n=[];for(const r of h){const i=r.workspace;if(!(0,E.isWorkspaceIdentifier)(i))return[];if(!l.has(i.id)){l.add(i.id);const s=this.getBackupPath(i.id);await this.doHasBackups(s)?i.configPath.scheme!==R.Schemas.file||await C.Promises.exists(i.configPath.fsPath)?n.push(r):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return n}async validateFolders(h){if(!Array.isArray(h))return[];const l=[],n=new Set;for(const r of h){const i=r.folderUri,s=this.backupUriComparer.getComparisonKey(i);if(!n.has(s)){n.add(s);const o=this.getBackupPath(this.getFolderHash(r));await this.doHasBackups(o)?i.scheme!==R.Schemas.file||await C.Promises.exists(i.fsPath)?l.push(r):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return l}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const l=[],n=new Set;for(const r of h){const i=r.backupFolder;if(typeof i!="string")return[];if(!n.has(i)){n.add(i);const s=this.getBackupPath(i);await this.doHasBackups(s)?l.push(r):await this.deleteStaleBackup(s)}}return l}async deleteStaleBackup(h){try{await C.Promises.exists(h)&&await C.Promises.rm(h,C.RimRafMode.MOVE)}catch(l){this.logService.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}async convertToEmptyWindowBackup(h){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,l));)l=this.getRandomEmptyWindowId();const n=this.getBackupPath(l);try{await C.Promises.rename(h,n)}catch(r){return this.logService.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}convertToEmptyWindowBackupSync(h){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,l));)l=this.getRandomEmptyWindowId();const n=this.getBackupPath(l);try{t.renameSync(h,n)}catch(r){return this.logService.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}async getDirtyWorkspaces(){const h=[];for(const l of this.workspaces)await this.hasBackups(l)&&h.push(l);for(const l of this.folders)await this.hasBackups(l)&&h.push(l);return h}hasBackups(h){let l;return(0,k.isEmptyWindowBackupInfo)(h)?l=h.backupFolder:(0,w.isFolderBackupInfo)(h)?l=this.getBackupPath(this.getFolderHash(h)):l=this.getBackupPath(h.workspace.id),this.doHasBackups(l)}async doHasBackups(h){try{const l=await C.Promises.readdir(h);for(const n of l)try{if((await C.Promises.readdir((0,M.join)(h,n))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,C.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await C.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderWorkspaceInfos:this.folders.map(h=>({folderUri:h.folderUri.toString(),remoteAuthority:h.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){const l=h.folderUri;let n;return l.scheme===R.Schemas.file?n=S.isLinux?l.fsPath:l.fsPath.toLowerCase():n=l.toString().toLowerCase(),(0,v.createHash)("md5").update(n).digest("hex")}};I=fe([ee(0,m.IEnvironmentMainService),ee(1,y.IConfigurationService),ee(2,b.ILogService)],I),e.BackupMainService=I}),define(Y[53],X([0,1,14,8,65,34,2,79,4,13,23,147,5,6,24]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let b=class{constructor(E){this.logService=E,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(E,I){return this.doPick({...E,pickFolders:!0,pickFiles:!0,title:(0,k.localize)(0,null)},I)}pickFolder(E,I){return this.doPick({...E,pickFolders:!0,title:(0,k.localize)(1,null)},I)}pickFile(E,I){return this.doPick({...E,pickFiles:!0,title:(0,k.localize)(2,null)},I)}pickWorkspace(E,I){const g=(0,k.localize)(3,null),h=(0,R.mnemonicButtonLabel)((0,k.localize)(4,null)),l=u.WORKSPACE_FILTER;return this.doPick({...E,pickFiles:!0,title:g,filters:l,buttonLabel:h},I)}async doPick(E,I){const g={title:E.title,buttonLabel:E.buttonLabel,filters:E.filters,defaultPath:E.defaultPath};(typeof E.pickFiles=="boolean"||typeof E.pickFolders=="boolean")&&(g.properties=void 0,E.pickFiles&&E.pickFolders&&(g.properties=["multiSelections","openDirectory","openFile","createDirectory"])),g.properties||(g.properties=["multiSelections",E.pickFolders?"openDirectory":"openFile","createDirectory"]),d.isMacintosh&&g.properties.push("treatPackageAsDirectory");const h=await this.showOpenDialog(g,(0,p.withNullAsUndefined)(I||v.BrowserWindow.getFocusedWindow()));if(h&&h.filePaths&&h.filePaths.length>0)return h.filePaths}getWindowDialogQueue(E){if(E){let I=this.windowDialogQueues.get(E.id);return I||(I=new t.Queue,this.windowDialogQueues.set(E.id,I)),I}else return this.noWindowDialogueQueue}showMessageBox(E,I){return this.getWindowDialogQueue(I).queue(async()=>I?v.dialog.showMessageBox(I,E):v.dialog.showMessageBox(E))}async showSaveDialog(E,I){const g=this.acquireFileDialogLock(E,I);if(!g)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(I).queue(async()=>{let h;return I?h=await v.dialog.showSaveDialog(I,E):h=await v.dialog.showSaveDialog(E),h.filePath=this.normalizePath(h.filePath),h})}finally{(0,M.dispose)(g)}}normalizePath(E){return E&&d.isMacintosh&&(E=(0,S.normalizeNFC)(E)),E}normalizePaths(E){return E.map(I=>this.normalizePath(I))}async showOpenDialog(E,I){E.defaultPath&&(await C.Promises.exists(E.defaultPath)||(E.defaultPath=void 0));const g=this.acquireFileDialogLock(E,I);if(!g)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(I).queue(async()=>{let h;return I?h=await v.dialog.showOpenDialog(I,E):h=await v.dialog.showOpenDialog(E),h.filePaths=this.normalizePaths(h.filePaths),h})}finally{(0,M.dispose)(g)}}acquireFileDialogLock(E,I){if(!I)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",E);let g=this.windowFileDialogLocks.get(I.id);g||(g=new Set,this.windowFileDialogLocks.set(I.id,g));const h=(0,D.hash)(E);if(!g.has(h))return this.logService.trace("[DialogMainService]: new file dialog lock created",E),g.add(h),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",E),g?.delete(h),g?.size===0&&this.windowFileDialogLocks.delete(I.id)})}};b=fe([ee(0,m.ILogService)],b),e.DialogMainService=b}),define(Y[241],X([0,1,3,2,66,24]),function(z,e,v,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends t.Disposable{constructor(d,p){super();this.logService=d,this.storageMainService=p,this.onDidChangeApplicationStorageEmitter=this._register(new v.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(p.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(d,p){this._register(v.Event.debounce(d.onDidChangeStorage,(C,k)=>(C?C.push(k):C=[k],C),M.STORAGE_CHANGE_DEBOUNCE_TIME)(C=>{C.length&&p.fire(this.serializeStorageChangeEvents(C,d))}))}serializeStorageChangeEvents(d,p){const C=new Map,k=new Set;return d.forEach(y=>{const m=p.get(y.key);typeof m=="string"?C.set(y.key,m):k.add(y.key)}),{changed:Array.from(C.entries()),deleted:Array.from(k.values())}}listen(d,p,C){switch(p){case"onDidChangeStorage":{const k=C.profile?(0,D.revive)(C.profile):void 0;if(!k)return this.onDidChangeApplicationStorageEmitter.event;let y=this.mapProfileToOnDidChangeProfileStorageEmitter.get(k.id);return y||(y=this._register(new v.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(k),y),this.mapProfileToOnDidChangeProfileStorageEmitter.set(k.id,y)),y.event}}throw new Error(`Event not found: ${p}`)}async call(d,p,C){const k=C.profile?(0,D.revive)(C.profile):void 0,y=(0,R.reviveIdentifier)(C.workspace),m=await this.withStorageInitialized(k,y);switch(p){case"getItems":return Array.from(m.items.entries());case"updateItems":{const u=C;if(u.insert)for(const[b,w]of u.insert)m.set(b,w);u.delete?.forEach(b=>m.delete(b));break}default:throw new Error(`Call not found: ${p}`)}}async withStorageInitialized(d,p){let C;p?C=this.storageMainService.workspaceStorage(p):d?C=this.storageMainService.profileStorage(d):C=this.storageMainService.applicationStorage;try{await C.init()}catch(k){this.logService.error(`StorageIPC#init: Unable to init ${p?"workspace":d?"profile":"application"} storage due to ${k}`)}return C}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Y[40],X([0,1,65,3,2,16,13,7,164,39,15,5,6,24,33,62,8]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function E(l){const n=l;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&S.URI.isUri(n.location)&&S.URI.isUri(n.globalStorageHome)&&S.URI.isUri(n.settingsResource)&&S.URI.isUri(n.keybindingsResource)&&S.URI.isUri(n.tasksResource)&&S.URI.isUri(n.snippetsHome)&&((0,M.isUndefined)(n.extensionsResource)||S.URI.isUri(n.extensionsResource)))}e.isUserDataProfile=E,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,k.createDecorator)("IUserDataProfilesService");function I(l,n){return{id:l.id,isDefault:l.isDefault,name:l.name,location:S.URI.revive(l.location).with({scheme:n}),globalStorageHome:S.URI.revive(l.globalStorageHome).with({scheme:n}),settingsResource:S.URI.revive(l.settingsResource).with({scheme:n}),keybindingsResource:S.URI.revive(l.keybindingsResource).with({scheme:n}),tasksResource:S.URI.revive(l.tasksResource).with({scheme:n}),snippetsHome:S.URI.revive(l.snippetsHome).with({scheme:n}),extensionsResource:S.URI.revive(l.extensionsResource)?.with({scheme:n})}}e.reviveProfile=I,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function g(l,n,r){return{id:(0,v.hash)(n.path).toString(16),name:l,location:n,isDefault:!1,globalStorageHome:(0,R.joinPath)(n,"globalStorage"),settingsResource:(0,R.joinPath)(n,"settings.json"),keybindingsResource:(0,R.joinPath)(n,"keybindings.json"),tasksResource:(0,R.joinPath)(n,"tasks.json"),snippetsHome:(0,R.joinPath)(n,"snippets"),extensionsResource:(0,R.joinPath)(n,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:r}}e.toUserDataProfile=g;let h=class extends D.Disposable{constructor(n,r,i,s){super();this.environmentService=n,this.fileService=r,this.uriIdentityService=i,this.logService=s,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return this.profilesObject.profiles}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}get profilesObject(){if(!this._profilesObject){const n=this.enabled?this.getStoredProfiles().map(o=>g(o.name,o.location,o.useDefaultFlags)):[];let r;const i=new u.ResourceMap;if(n.length){const o=this.getStoredProfileAssociations();if(o.workspaces)for(const[a,c]of Object.entries(o.workspaces)){const f=S.URI.parse(a),P=S.URI.parse(c),L=n.find(T=>this.uriIdentityService.extUri.isEqual(T.location,P));L&&i.set(f,L)}if(o.emptyWindow){const a=S.URI.parse(o.emptyWindow);r=n.find(c=>this.uriIdentityService.extUri.isEqual(c.location,a))}}const s=g((0,d.localize)(0,null),this.environmentService.userRoamingDataHome);n.unshift({...s,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||n.length>0?s.extensionsResource:void 0}),this._profilesObject={profiles:n,workspaces:i,emptyWindow:r}}return this._profilesObject}getProfile(n){const r=this.getWorkspace(n);return(S.URI.isUri(r)?this.profilesObject.workspaces.get(r):this.profilesObject.emptyWindow)??this.defaultProfile}getWorkspace(n){return(0,m.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,m.isWorkspaceIdentifier)(n)?n.configPath:"empty-window"}async createProfile(n,r,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(this.getStoredProfiles().some(a=>a.name===n))throw new Error(`Profile with name ${n} already exists`);const s=g(n,(0,R.joinPath)(this.profilesHome,(0,v.hash)(n).toString(16)),r);await this.fileService.createFolder(s.location);const o=[];return this._onWillCreateProfile.fire({profile:s,join(a){o.push(a)}}),await w.Promises.settled(o),this.updateProfiles([s],[]),i&&await this.setProfileForWorkspace(s,i),s}async setProfileForWorkspace(n,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const i=this.profiles.find(s=>s.id===n.id);if(!i)throw new Error(`Profile '${n.name}' does not exist`);this.updateWorkspaceAssociation(r,i)}async unsetWorkspace(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(n)}async removeProfile(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(s=>s.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const i=[];this._onWillRemoveProfile.fire({profile:r,join(s){i.push(s)}}),await w.Promises.settled(i),r.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const s of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(s)?.id&&this.profilesObject.workspaces.delete(s);this.updateStoredProfileAssociations(),this.updateProfiles([],[r]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(s){this.logService.error(s)}}updateProfiles(n,r){const i=[];for(const s of[...this.profilesObject.profiles,...n])s.isDefault||r.some(o=>s.id===o.id)||i.push({location:s.location,name:s.name,useDefaultFlags:s.useDefaultFlags});this.saveStoredProfiles(i),this._profilesObject=void 0,this.triggerProfilesChanges(n,r)}triggerProfilesChanges(n,r){this._onDidChangeProfiles.fire({added:n,removed:r,all:this.profiles})}updateWorkspaceAssociation(n,r){const i=this.getWorkspace(n);S.URI.isUri(i)?(this.profilesObject.workspaces.delete(i),r&&!r.isDefault&&this.profilesObject.workspaces.set(i,r)):this.profilesObject.emptyWindow=r?.isDefault?void 0:r,this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[i,s]of this.profilesObject.workspaces.entries())n[i.toString()]=s.location.toString();const r=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:n,emptyWindow:r}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}};h.PROFILES_KEY="userDataProfiles",h.PROFILE_ASSOCIATIONS_KEY="profileAssociations",h=fe([ee(0,p.IEnvironmentService),ee(1,C.IFileService),ee(2,b.IUriIdentityService),ee(3,y.ILogService)],h),e.UserDataProfilesService=h}),define(Y[242],X([0,1,14,38,2,33,12,9,4,7,30,39,6,40]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let u=class extends D.Disposable{constructor(w,E,I){super();this.logService=I,this.validRoots=R.TernarySearchTree.forPaths(!d.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(w.appRoot),this.addValidFileRoot(w.extensionsPath),this.addValidFileRoot(E.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(w.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:w}=v.session;w.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(E,I)=>this.handleResourceRequest(E,I)),w.protocol.interceptFileProtocol(M.Schemas.file,(E,I)=>this.handleFileRequest(E,I)),this._register((0,D.toDisposable)(()=>{w.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),w.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(w){const E=(0,S.normalize)(w);return this.validRoots.get(E)?D.Disposable.None:(this.validRoots.set(E,!0),(0,D.toDisposable)(()=>this.validRoots.delete(E)))}handleFileRequest(w,E){const I=p.URI.parse(w.url);return this.logService.error(`Refused to load resource ${I.fsPath} from ${M.Schemas.file}: protocol (original URL: ${w.url})`),E({error:-3})}handleResourceRequest(w,E){const I=this.requestToNormalizedFilePath(w);return this.validRoots.findSubstr(I)?E({path:I}):this.validExtensions.has((0,S.extname)(I))?E({path:I}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${I} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${w.url})`),E({error:-3}))}requestToNormalizedFilePath(w){const E=p.URI.parse(w.url),I=M.FileAccess.asFileUri(E);return(0,S.normalize)(I.fsPath)}createIPCObjectUrl(){let w;const E=p.URI.from({scheme:"vscode",path:(0,C.generateUuid)()}),I=E.toString(),g=async()=>w;return t.validatedIpcMain.handle(I,g),this.logService.trace(`IPC Object URL: Registered new channel ${I}.`),{resource:E,update:h=>w=h,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${I}.`),t.validatedIpcMain.removeHandler(I)}}}};u=fe([ee(0,k.INativeEnvironmentService),ee(1,m.IUserDataProfilesService),ee(2,y.ILogService)],u),e.ProtocolMainService=u}),define(Y[243],X([0,1,14,38,8,3,2,12,13,96,26,22,6,58,59,61,41,40,37]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u,b,w,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends M.Disposable{constructor(l,n,r,i,s,o,a,c,f){super();this.machineId=l,this.userEnv=n,this.environmentMainService=r,this.userDataProfilesService=i,this.lifecycleMainService=s,this.logService=o,this.policyService=a,this.themeMainService=c,this.protocolMainService=f,this.firstWindowConnectionBarrier=new D.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(l,n)=>this.onWindowConnection(l,n)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(l,n)=>this.onWorkerConnection(l,n)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(l,n){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const r=await this.connect();if(l.sender.isDestroyed())return r.close();l.sender.postMessage("vscode:createSharedProcessMessageChannelResult",n,[r])}onWorkerConnection(l,n){this.logService.trace("SharedProcess: onWorkerConnection",n);const r=new M.DisposableStore,i=o=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${o}')`,n),r.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",n))},s=v.BrowserWindow.fromId(n.reply.windowId);if(!s||s.isDestroyed()||s.webContents.isDestroyed()||!n.reply.channel){i("unavailable");return}r.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,o=>o.window.win===s)(()=>i("load"))),r.add(R.Event.fromNodeEventEmitter(s,"closed")(()=>i("closed"))),s.webContents.postMessage(n.reply.channel,n.reply.nonce,l.ports)}onWillShutdown(){const l=this.window;!l||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(l.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{l.close()}catch{}this.window=void 0},0))}send(l,...n){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${l}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(l,...n)}catch(r){this.logService.warn(`Error sending IPC message to channel '${l}' of shared process: ${(0,w.toErrorMessage)(r)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),l()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),l()}))})()),this._whenIpcReady}createWindow(){const l=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:S.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),l.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default,policiesData:this.policyService.serialize()}),this.window.loadURL(S.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",z).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=l=>{this.logService.trace("SharedProcess#close prevented"),l.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(l,n)=>this._onDidError.fire({type:2,details:n})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(l,n,r)=>this._onDidError.fire({type:3,details:{reason:r,exitCode:n}})))}async connect(){await this.whenIpcReady;const l=(0,d.assertIsDefined)(this.window);return(0,p.connect)(l)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const l=this.window;return l?!l.isDestroyed()&&!l.webContents.isDestroyed():!1}};g=fe([ee(2,C.IEnvironmentMainService),ee(3,E.IUserDataProfilesService),ee(4,k.ILifecycleMainService),ee(5,y.ILogService),ee(6,I.IPolicyService),ee(7,b.IThemeMainService),ee(8,u.IProtocolMainService)],g),e.SharedProcess=g}),define(Y[110],X([0,1,8,3,2,70,13,97,5,40]),function(z,e,v,t,D,R,M,S,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";e.IStorageService=(0,d.createDecorator)("storageService");var k;(function(I){I[I.NONE=0]="NONE",I[I.SHUTDOWN=1]="SHUTDOWN"})(k=e.WillSaveStateReason||(e.WillSaveStateReason={}));var y;(function(I){I[I.APPLICATION=-1]="APPLICATION",I[I.PROFILE=0]="PROFILE",I[I.WORKSPACE=1]="WORKSPACE"})(y=e.StorageScope||(e.StorageScope={}));var m;(function(I){I[I.USER=0]="USER",I[I.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));class u extends D.Disposable{constructor(g={flushInterval:u.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,h){if(h===C){switch(g){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:g})}else this._onDidChangeValue.fire({scope:g,key:h,target:this.getKeyTargets(g)[h]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,h,l){return this.getStorage(h)?.get(g,l)}getBoolean(g,h,l){return this.getStorage(h)?.getBoolean(g,l)}getNumber(g,h,l){return this.getStorage(h)?.getNumber(g,l)}store(g,h,l,n){if((0,M.isUndefinedOrNull)(h)){this.remove(g,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,l,n),this.getStorage(l)?.set(g,h)})}remove(g,h){this.withPausedEmitters(()=>{this.updateKeyTarget(g,h,void 0),this.getStorage(h)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,h){const l=[],n=this.getKeyTargets(g);for(const r of Object.keys(n))n[r]===h&&l.push(r);return l}updateKeyTarget(g,h,l){const n=this.getKeyTargets(h);typeof l=="number"?n[g]!==l&&(n[g]=l,this.getStorage(h)?.set(C,JSON.stringify(n))):typeof n[g]=="number"&&(delete n[g],this.getStorage(h)?.set(C,JSON.stringify(n)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(g){switch(g){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(g){const h=this.get(C,g);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=k.NONE){this._onWillSaveState.fire({reason:g});const h=this.getStorage(-1),l=this.getStorage(0),n=this.getStorage(1);switch(g){case k.NONE:await v.Promises.settled([h?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case k.SHUTDOWN:await v.Promises.settled([h?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.getStorage(-1)?.items??new Map,h=this.getStorage(0)?.items??new Map,l=this.getStorage(1)?.items??new Map;return E(g,h,l,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(g,h){return this.emitWillSaveState(k.NONE),(0,p.isUserDataProfile)(g)?this.switchToProfile(g,h):this.switchToWorkspace(g,h)}canSwitchProfile(g,h){return!(g.id===h.id||b(h)&&b(g))}switchData(g,h,l,n){this.withPausedEmitters(()=>{if(n)for(const[r,i]of g)h.set(r,i);else{const r=new Set;for(const[i,s]of g)r.add(i),h.get(i)!==s&&this.emitDidChangeValue(l,i);for(const[i]of h.items)r.has(i)||this.emitDidChangeValue(l,i)}})}}e.AbstractStorageService=u,u.DEFAULT_FLUSH_INTERVAL=60*1e3;function b(I){return I.isDefault||!!I.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=b;class w extends u{constructor(){super();this.applicationStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this.profileStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.profileStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),this._register(this.applicationStorage.onDidChangeStorage(g=>this.emitDidChangeValue(-1,g)))}getStorage(g){switch(g){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=w;async function E(I,g,h,l,n,r){const i=W=>{try{return JSON.parse(W)}catch{return W}},s=new Map,o=new Map;I.forEach((W,$)=>{s.set($,W),o.set($,i(W))});const a=new Map,c=new Map;g.forEach((W,$)=>{a.set($,W),c.set($,i(W))});const f=new Map,P=new Map;h.forEach((W,$)=>{f.set($,W),P.set($,i(W))}),console.group(l!==n?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const L=[];if(s.forEach((W,$)=>{L.push({key:$,value:W})}),console.table(L),console.groupEnd(),console.log(o),l!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const W=[];a.forEach(($,te)=>{W.push({key:te,value:$})}),console.table(W),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${r})`);const T=[];f.forEach((W,$)=>{T.push({key:$,value:W})}),console.table(T),console.groupEnd(),console.log(P)}e.logStorage=E}),define(Y[244],X([0,1,25,8,3,2,9,78,7,23,97,141,6,110,35,24]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class w extends R.Disposable{constructor(r,i){super();this.logService=r,this.fileService=i,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new D.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new C.Storage(new C.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=C.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===C.StorageState.None)try{const r=await this.doCreate();this._storage.dispose(),this._storage=r,this._register(r.onDidChangeStorage(s=>this._onDidChangeStorage.fire({key:s}))),await this.doInit(r);const i=r.getBoolean(m.IS_NEW_KEY);i===void 0?r.set(m.IS_NEW_KEY,!0):i&&r.set(m.IS_NEW_KEY,!1)}catch(r){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.state=C.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===y.LogLevel.Trace?r=>this.logService.trace(r):void 0,logError:r=>this.logService.error(r)}}doInit(r){return r.init()}get items(){return this._storage.items}get(r,i){return this._storage.get(r,i)}set(r,i){return this._storage.set(r,i)}delete(r){return this._storage.delete(r)}async close(){const r=new S.StopWatch(!1);await this.doClose(),r.stop(),r.elapsed()>w.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(r),this._onDidCloseStorage.fire()}async logSlowClose(r){if(!!this.path)try{const i=(0,v.top)(Array.from(this._storage.items.entries()).map(([o,a])=>({key:o,length:a.length})),(o,a)=>a.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),s=(await this.fileService.stat(d.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${s}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=C.StorageState.Closed,await this._storage.close()}}w.LOG_SLOW_CLOSE_THRESHOLD=2e3;class E extends w{constructor(r,i,s,o){super(s,o);this.profile=r,this.options=i}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.profile.globalStorageHome.fsPath,E.STORAGE_NAME)}async doCreate(){return new C.Storage(new k.SQLiteStorageDatabase(this.path??k.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}E.STORAGE_NAME="state.vscdb";class I extends E{constructor(r,i,s,o){super(r,i,s,o)}}e.ProfileStorageMain=I;class g extends E{constructor(r,i,s,o){super(i.defaultProfile,r,s,o)}async doInit(r){await super.doInit(r),this.updateTelemetryState(r)}updateTelemetryState(r){r.get(u.firstSessionDateStorageKey,void 0)===void 0&&r.set(u.firstSessionDateStorageKey,new Date().toUTCString());const s=r.get(u.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();r.set(u.lastSessionDateStorageKey,typeof s=="undefined"?null:s),r.set(u.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=g;class h extends w{constructor(r,i,s,o,a){super(s,a);this.workspace=r,this.options=i,this.environmentService=o}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,h.WORKSPACE_STORAGE_NAME)}async doCreate(){const{storageFilePath:r,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new C.Storage(new k.SQLiteStorageDatabase(r,{logging:this.createLoggingOptions()}),{hint:i?C.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:k.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const r=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),i=(0,M.join)(r,h.WORKSPACE_STORAGE_NAME);return await p.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await p.Promises.mkdir(r,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(r),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(r){let i;if((0,b.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,b.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const s=(0,M.join)(r,h.WORKSPACE_META_NAME);await p.Promises.exists(s)||await p.Promises.writeFile(s,JSON.stringify(i,void 0,2))}catch(s){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${s}`)}}}e.WorkspaceStorageMain=h,h.WORKSPACE_STORAGE_NAME="state.vscdb",h.WORKSPACE_META_NAME="workspace.json";class l extends w{get path(){}async doCreate(){return new C.Storage(new C.InMemoryStorageDatabase)}}e.InMemoryStorageMain=l}),define(Y[245],X([0,1,66,39,15,6,214,62,40]),function(z,e,v,t,D,R,M,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let p=class kt extends d.UserDataProfilesService{constructor(k,y,m,u,b){super(m,u,y,b);this.stateService=k}getStoredProfiles(){return(0,v.revive)(this.stateService.getItem(kt.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,v.revive)(this.stateService.getItem(kt.PROFILE_ASSOCIATIONS_KEY,{}))}};p=fe([ee(0,M.IStateService),ee(1,S.IUriIdentityService),ee(2,t.IEnvironmentService),ee(3,D.IFileService),ee(4,R.ILogService)],p),e.UserDataProfilesService=p}),define(Y[63],X([0,1,7,39,15,5,6,45,62,40,245]),function(z,e,v,t,D,R,M,S,d,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(p.IUserDataProfilesService);let k=class Et extends C.UserDataProfilesService{constructor(m,u,b,w,E){super(m,u,b,w,E);this.stateMainService=m}saveStoredProfiles(m){this.stateMainService.setItem(Et.PROFILES_KEY,m)}saveStoredProfileAssociations(m){this.stateMainService.setItem(Et.PROFILE_ASSOCIATIONS_KEY,m)}getStoredProfileAssociations(){const m="workspaceAndProfileInfo",u=this.stateMainService.getItem(m,void 0);if(u){this.stateMainService.removeItem(m);const b=u.reduce((w,{workspace:E,profile:I})=>(w[v.URI.revive(E).toString()]=v.URI.revive(I).toString(),w),{});this.stateMainService.setItem(Et.PROFILE_ASSOCIATIONS_KEY,{workspaces:b})}return super.getStoredProfileAssociations()}};k=fe([ee(0,S.IStateMainService),ee(1,d.IUriIdentityService),ee(2,t.IEnvironmentService),ee(3,D.IFileService),ee(4,M.ILogService)],k),e.UserDataProfilesMainService=k}),define(Y[246],X([0,1,2,100,63]),function(z,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let R=class extends v.Disposable{constructor(S,d){super();this.defaultExtensionsProfileInitService=S,this._register(d.onWillCreateProfile(p=>{d.profiles.length===1&&p.join(this.defaultExtensionsProfileInitService.initialize())})),this._register(d.onDidChangeProfiles(p=>{d.profiles.length===1&&this.defaultExtensionsProfileInitService.uninitialize()}))}};R=fe([ee(0,t.IDefaultExtensionsProfileInitService),ee(1,D.IUserDataProfilesMainService)],R),e.DefaultExtensionsProfileInitHandler=R}),define(Y[88],X([0,1,48,2,39,15,5,22,6,110,244,40,63]),function(z,e,v,t,D,R,M,S,d,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let m=class extends t.Disposable{constructor(w,E,I,g,h){super();this.logService=w,this.environmentService=E,this.userDataProfilesService=I,this.lifecycleMainService=g,this.fileService=h,this.shutdownReason=void 0,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.applicationStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(w=>{w.window.profile&&this.profileStorage(w.window.profile).init(),w.workspace&&this.workspaceStorage(w.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(w=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=w.reason,w.join(this.applicationStorage.close());for(const[,E]of this.mapProfileToStorage)w.join(E.close());for(const[,E]of this.mapWorkspaceToStorage)w.join(E.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(w=>{w.join((async()=>{await this.fileService.exists(w.profile.globalStorageHome)||await this.fileService.createFolder(w.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(w=>{const E=this.mapProfileToStorage.get(w.profile.id);E&&w.join(E.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const w=new C.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,v.once)(w.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),w}profileStorage(w){if((0,p.isProfileUsingDefaultStorage)(w))return this.applicationStorage;let E=this.mapProfileToStorage.get(w.id);return E||(this.logService.trace(`StorageMainService: creating profile storage (${w.name})`),E=this.createProfileStorage(w),this.mapProfileToStorage.set(w.id,E),(0,v.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${w.name})`),this.mapProfileToStorage.delete(w.id)})),E}createProfileStorage(w){return this.shutdownReason===2?new C.InMemoryStorageMain(this.logService,this.fileService):new C.ProfileStorageMain(w,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(w){let E=this.mapWorkspaceToStorage.get(w.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${w.id})`),E=this.createWorkspaceStorage(w),this.mapWorkspaceToStorage.set(w.id,E),(0,v.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${w.id})`),this.mapWorkspaceToStorage.delete(w.id)})),E}createWorkspaceStorage(w){return this.shutdownReason===2?new C.InMemoryStorageMain(this.logService,this.fileService):new C.WorkspaceStorageMain(w,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}};m=fe([ee(0,d.ILogService),ee(1,D.IEnvironmentService),ee(2,y.IUserDataProfilesMainService),ee(3,S.ILifecycleMainService),ee(4,R.IFileService)],m),e.StorageMainService=m,e.IApplicationStorageMainService=(0,M.createDecorator)("applicationStorageMainService");let u=class extends p.AbstractStorageService{constructor(w,E){super();this.userDataProfilesService=w,this.storageMainService=E,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(w){if(w===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(w){if(w===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}};u=fe([ee(0,k.IUserDataProfilesService),ee(1,e.IStorageMainService)],u),e.ApplicationStorageMainService=u}),define(Y[111],X([0,1,16,7,24]),function(z,e,v,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function R(d,p,C){for(const y of d){const m=y.openedWorkspace;if((0,D.isWorkspaceIdentifier)(m)){const u=C(m);if(u){if(u.folders.some(b=>v.extUriBiasedIgnorePathCase.isEqualOrParent(p,b.uri)))return y}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(p,m.configPath))return y}}const k=d.filter(y=>(0,D.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(p,y.openedWorkspace.uri));if(k.length)return k.sort((y,m)=>-(y.openedWorkspace.uri.path.length-m.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function M(d,p){for(const C of d)if((0,D.isWorkspaceIdentifier)(C.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(C.openedWorkspace.configPath,p)||(0,D.isSingleFolderWorkspaceIdentifier)(C.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(C.openedWorkspace.uri,p))return C}e.findWindowOnWorkspaceOrFolder=M;function S(d,p){const C=k=>p.some(y=>v.extUriBiasedIgnorePathCase.isEqual(t.URI.file(y),t.URI.file(k)));for(const k of d)if(k.config?.extensionDevelopmentPath?.some(y=>C(y)))return k}e.findWindowOnExtensionDevelopmentPath=S}),define(Y[247],X([0,1,14,2,4,16,7,18,22,6,45,32,109,24]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let u=class Mt extends t.Disposable{constructor(h,l,n,r,i){super();this.windowsMainService=h,this.stateMainService=l,this.lifecycleMainService=n,this.logService=r,this.configurationService=i,this._state=b(this.stateMainService.getItem(Mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!h.lastActiveWindow){let r=this.windowsMainService.getLastActiveWindow();(!r||r.isExtensionDevelopmentHost)&&(r=this.windowsMainService.getWindows().find(i=>!i.isExtensionDevelopmentHost)),r&&(h.lastActiveWindow=this.toWindowState(r))}const l=this.windowsMainService.getWindows().find(r=>r.isExtensionDevelopmentHost&&!r.isExtensionTestHost);l&&(h.lastPluginDevelopmentHostWindow=this.toWindowState(l)),this.windowsMainService.getWindowCount()>1&&(h.openedWindows=this.windowsMainService.getWindows().filter(r=>!r.isExtensionDevelopmentHost).map(r=>this.toWindowState(r)));const n=E(h);this.stateMainService.setItem(Mt.windowsStateStorageKey,n),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",n)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const l=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=l:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(n=>{const r=(0,m.isWorkspaceIdentifier)(h.openedWorkspace)&&n.workspace?.id===h.openedWorkspace.id,i=(0,m.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&n.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(n.folderUri,h.openedWorkspace.uri);(r||i)&&(n.uiState=l.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=l)}toWindowState(h){return{workspace:(0,m.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,m.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const l=this.doGetNewWindowState(h),n=this.configurationService.getValue("window");let r;return l.hasDefaultState?r=!!(n?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(n.newWindowDimensions)>=0):(r=!!(this.lifecycleMainService.wasRestarted||n?.restoreFullscreen),r&&D.isMacintosh&&this.windowsMainService.getWindows().some(i=>i.isFullScreen)&&(r=!1)),l.mode===3&&!r&&(l.mode=1),l}doGetNewWindowState(h){const l=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=h.workspace;if((0,m.isWorkspaceIdentifier)(a)){const f=this.state.openedWindows.filter(P=>P.workspace&&P.workspace.id===a.id).map(P=>P.uiState);if(f.length)return f[0]}if((0,m.isSingleFolderWorkspaceIdentifier)(a)){const f=this.state.openedWindows.filter(P=>P.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(P.folderUri,a.uri)).map(P=>P.uiState);if(f.length)return f[0]}else if(h.backupPath){const f=this.state.openedWindows.filter(P=>P.backupPath===h.backupPath).map(P=>P.uiState);if(f.length)return f[0]}const c=this.lastClosedState||this.state.lastActiveWindow;if(!l&&c)return c.uiState}let n;const r=v.screen.getAllDisplays();if(r.length===1)n=r[0];else{if(D.isMacintosh){const a=v.screen.getCursorScreenPoint();n=v.screen.getDisplayNearestPoint(a)}!n&&l&&(n=v.screen.getDisplayMatching(l.getBounds())),n||(n=v.screen.getPrimaryDisplay()||r[0])}let i=(0,y.defaultWindowState)();i.x=Math.round(n.bounds.x+n.bounds.width/2-i.width/2),i.y=Math.round(n.bounds.y+n.bounds.height/2-i.height/2);const s=this.configurationService.getValue("window");let o=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(s.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&l){const a=l.serializeWindowState();a.mode===3?i.mode=3:i=a,o=i.mode!==3&&s.newWindowDimensions==="offset"}}return o&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const l=this.windowsMainService.getWindows().map(n=>n.getBounds());for(;l.some(n=>n.x===h.x||n.y===h.y);)h.x+=30,h.y+=30;return h}};u.windowsStateStorageKey="windowsState",u=fe([ee(0,k.IWindowsMainService),ee(1,C.IStateMainService),ee(2,d.ILifecycleMainService),ee(3,p.ILogService),ee(4,S.IConfigurationService)],u),e.WindowsStateHandler=u;function b(g){const h={openedWindows:[]},l=g||{openedWindows:[]};return l.lastActiveWindow&&(h.lastActiveWindow=w(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=w(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(h.openedWindows=l.openedWindows.map(n=>w(n))),h}e.restoreWindowsState=b;function w(g){const h={uiState:g.uiState};return g.backupPath&&(h.backupPath=g.backupPath),g.remoteAuthority&&(h.remoteAuthority=g.remoteAuthority),g.folder&&(h.folderUri=M.URI.parse(g.folder)),g.workspaceIdentifier&&(h.workspace={id:g.workspaceIdentifier.id,configPath:M.URI.parse(g.workspaceIdentifier.configURIPath)}),h}function E(g){return{lastActiveWindow:g.lastActiveWindow&&I(g.lastActiveWindow),lastPluginDevelopmentHostWindow:g.lastPluginDevelopmentHostWindow&&I(g.lastPluginDevelopmentHostWindow),openedWindows:g.openedWindows.map(h=>I(h))}}e.getWindowsStateStoreData=E;function I(g){return{workspaceIdentifier:g.workspace&&{id:g.workspace.id,configURIPath:g.workspace.configPath.toString()},folder:g.folderUri&&g.folderUri.toString(),backupPath:g.backupPath,remoteAuthority:g.remoteAuthority,uiState:g.uiState}}}),define(Y[89],X([0,1,29,49,119,34,12,9,4,16,7,5,71,24]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,k.createDecorator)("workspacesService");function u(P){return P.hasOwnProperty("workspace")}e.isRecentWorkspace=u;function b(P){return P.hasOwnProperty("folderUri")}e.isRecentFolder=b;function w(P){return P.hasOwnProperty("fileUri")}e.isRecentFile=w;function E(P){return I(P)||g(P)}e.isStoredWorkspaceFolder=E;function I(P){const L=P;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function g(P){const L=P;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function h(P,L,T,W,$=!d.isWindows,te){if(P.scheme!==W.scheme)return{name:T,uri:P.toString(!0)};let re=L?void 0:te.relativePath(W,P);if(re!==void 0)re.length===0?re=".":d.isWindows&&P.scheme===M.Schemas.file&&!$&&(re=re.replace(/\//g,"\\"));else if(P.scheme===M.Schemas.file)re=P.fsPath,d.isWindows&&(re=(0,R.normalizeDriveLetter)(re),$&&(re=(0,v.toSlashes)(re)));else{if(!te.isEqualAuthority(P.authority,W.authority))return{name:T,uri:P.toString(!0)};re=P.path}return{name:T,path:re}}e.getStoredWorkspaceFolder=h;function l(P,L,T){const W=[],$=new Set,te=T.dirname(L);for(const re of P){let ie;if(I(re))re.path&&(ie=T.resolvePath(te,re.path));else if(g(re))try{ie=C.URI.parse(re.uri),ie.path[0]!=="/"&&(ie=ie.with({path:"/"+ie.path}))}catch(se){console.warn(se)}if(ie){const se=T.getComparisonKey(ie);if(!$.has(se)){$.add(se);const ce=re.name||T.basenameOrAuthority(ie);W.push(new m.WorkspaceFolder({uri:ie,name:ce,index:W.length},re))}}}return W}e.toWorkspaceFolders=l;function n(P,L,T,W,$){const te=r(L,P),re=$.dirname(L),ie=$.dirname(W),se=[],ce=i(te.folders);for(const _ of te.folders){const B=I(_)?$.resolvePath(re,_.path):C.URI.parse(_.uri);let Q;T?Q=!1:Q=!I(_)||(0,S.isAbsolute)(_.path),se.push(h(B,Q,_.name,ie,ce,$))}const q={insertSpaces:!1,tabSize:4,eol:d.isLinux||d.isMacintosh?`
`:`\r
`},ne=D.setProperty(P,["folders"],se,q);let O=D.applyEdits(P,ne);return(0,p.isEqualAuthority)(te.remoteAuthority,(0,y.getRemoteAuthority)(W))&&(O=D.applyEdits(O,D.removeProperty(O,["remoteAuthority"],q))),O}e.rewriteWorkspaceFileForNewLocation=n;function r(P,L){const T=t.parse(L);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(W=>E(W));else throw new Error(`${P} looks like an invalid workspace file.`);return T}function i(P){return d.isWindows?P.some(L=>I(L)&&L.path.indexOf("/")>=0):!0}e.useSlashForPath=i;function s(P){return P.workspace&&typeof P.workspace=="object"&&typeof P.workspace.id=="string"&&typeof P.workspace.configPath=="string"}function o(P){return typeof P.folderUri=="string"}function a(P){return typeof P.fileUri=="string"}function c(P,L){const T={workspaces:[],files:[]};if(P){const W=function(te,re){for(let ie=0;ie<te.length;ie++)try{re(te[ie],ie)}catch(se){L.warn(`Error restoring recent entry ${JSON.stringify(te[ie])}: ${se.toString()}. Skip entry.`)}},$=P;Array.isArray($.entries)&&W($.entries,te=>{const re=te.label,ie=te.remoteAuthority;s(te)?T.workspaces.push({label:re,remoteAuthority:ie,workspace:{id:te.workspace.id,configPath:C.URI.parse(te.workspace.configPath)}}):o(te)?T.workspaces.push({label:re,remoteAuthority:ie,folderUri:C.URI.parse(te.folderUri)}):a(te)&&T.files.push({label:re,remoteAuthority:ie,fileUri:C.URI.parse(te.fileUri)})})}return T}e.restoreRecentlyOpened=c;function f(P){const L={entries:[]};for(const T of P.workspaces)b(T)?L.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):L.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of P.files)L.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return L}e.toStoreData=f}),define(Y[112],X([0,1,75,27,12,4,16]),function(z,e,v,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function S(p){function C(){let k=p.scheme===D.Schemas.file?(0,M.originalFSPath)(p):p.toString();return R.isLinux||(k=k.toLowerCase()),(0,v.createHash)("md5").update(k).digest("hex")}return{id:C(),configPath:p}}e.getWorkspaceIdentifier=S;function d(p,C){function k(){if(p.scheme!==D.Schemas.file)return(0,v.createHash)("md5").update(p.toString()).digest("hex");if(!C)try{C=(0,t.statSync)(p.fsPath)}catch{return}let m;return R.isLinux?m=C.ino:R.isMacintosh?m=C.birthtime.getTime():R.isWindows&&(typeof C.birthtimeMs=="number"?m=Math.floor(C.birthtimeMs):m=C.birthtime.getTime()),(0,v.createHash)("md5").update(p.fsPath).update(m?String(m):"").digest("hex")}const y=k();if(typeof y=="string")return{id:y,uri:p}}e.getSingleFolderWorkspaceIdentifier=d}),define(Y[47],X([0,1,14,27,3,49,34,2,12,9,4,16,13,23,169,57,53,26,5,6,20,63,111,24,89,112]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u,b,w,E,I,g,h,l,n,r,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,I.createDecorator)("workspacesManagementMainService");let o=class extends S.Disposable{constructor(c,f,P,L,T,W){super();this.environmentMainService=c,this.logService=f,this.userDataProfilesMainService=P,this.backupMainService=L,this.dialogMainService=T,this.productService=W,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(c){return this.doResolveLocalWorkspace(c,f=>(0,t.readFileSync)(f,"utf8"))}resolveLocalWorkspace(c){return this.doResolveLocalWorkspace(c,f=>m.Promises.readFile(f,"utf8"))}doResolveLocalWorkspace(c,f){if(!!this.isWorkspacePath(c)&&c.scheme===d.Schemas.file)try{const P=f(c.fsPath);return P instanceof Promise?P.then(L=>this.doResolveWorkspace(c,L),L=>{}):this.doResolveWorkspace(c,P)}catch{return}}isWorkspacePath(c){return(0,r.isUntitledWorkspace)(c,this.environmentMainService)||(0,r.hasWorkspaceFileExtension)(c)}doResolveWorkspace(c,f){try{const P=this.doParseStoredWorkspace(c,f),L=(0,s.getWorkspaceIdentifier)(c);return{id:L.id,configPath:L.configPath,folders:(0,i.toWorkspaceFolders)(P.folders,L.configPath,k.extUriBiasedIgnorePathCase),remoteAuthority:P.remoteAuthority,transient:P.transient}}catch(P){this.logService.warn(P.toString())}}doParseStoredWorkspace(c,f){const P=(0,R.parse)(f);if(P&&Array.isArray(P.folders))P.folders=P.folders.filter(L=>(0,i.isStoredWorkspaceFolder)(L));else throw new Error(`${c.toString(!0)} looks like an invalid workspace file.`);return P}async createUntitledWorkspace(c,f){const{workspace:P,storedWorkspace:L}=this.newUntitledWorkspace(c,f),T=P.configPath.fsPath;return await m.Promises.mkdir((0,p.dirname)(T),{recursive:!0}),await m.Promises.writeFile(T,JSON.stringify(L,null,"	")),P}createUntitledWorkspaceSync(c,f){const{workspace:P,storedWorkspace:L}=this.newUntitledWorkspace(c,f),T=P.configPath.fsPath;return(0,t.mkdirSync)((0,p.dirname)(T),{recursive:!0}),(0,m.writeFileSync)(T,JSON.stringify(L,null,"	")),P}newUntitledWorkspace(c=[],f){const P=(Date.now()+Math.round(Math.random()*1e3)).toString(),L=(0,k.joinPath)(this.untitledWorkspacesHome,P),T=(0,k.joinPath)(L,r.UNTITLED_WORKSPACE_NAME),W=[];for(const $ of c)W.push((0,i.getStoredWorkspaceFolder)($.uri,!0,$.name,L,!C.isWindows,k.extUriBiasedIgnorePathCase));return{workspace:(0,s.getWorkspaceIdentifier)(T),storedWorkspace:{folders:W,remoteAuthority:f}}}async getWorkspaceIdentifier(c){return(0,s.getWorkspaceIdentifier)(c)}isUntitledWorkspace(c){return(0,r.isUntitledWorkspace)(c.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(c){!this.isUntitledWorkspace(c)||(this.doDeleteUntitledWorkspaceSync(c),this.userDataProfilesMainService.unsetWorkspace(c),this._onDidDeleteUntitledWorkspace.fire(c))}async deleteUntitledWorkspace(c){this.deleteUntitledWorkspaceSync(c)}doDeleteUntitledWorkspaceSync(c){const f=(0,k.originalFSPath)(c.configPath);try{(0,m.rimrafSync)((0,p.dirname)(f));const P=(0,p.join)(this.environmentMainService.workspaceStorageHome.fsPath,c.id);(0,t.existsSync)(P)&&(0,m.writeFileSync)((0,p.join)(P,"obsolete"),"")}catch(P){this.logService.warn(`Unable to delete untitled workspace ${f} (${P}).`)}}getUntitledWorkspacesSync(){const c=[];try{const f=(0,m.readdirSync)(this.untitledWorkspacesHome.fsPath).map(P=>(0,k.joinPath)(this.untitledWorkspacesHome,P,r.UNTITLED_WORKSPACE_NAME));for(const P of f){const L=(0,s.getWorkspaceIdentifier)(P),T=this.resolveLocalWorkspaceSync(P);T?c.push({workspace:L,remoteAuthority:T.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(L)}}catch(f){f.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${f}).`)}return c}async enterWorkspace(c,f,P){if(!c||!c.win||!c.isReady||!await this.isValidTargetWorkspacePath(c,f,P))return;const T=this.doEnterWorkspace(c,(0,s.getWorkspaceIdentifier)(P));if(!!T)return this._onDidEnterWorkspace.fire({window:c,workspace:T.workspace}),T}async isValidTargetWorkspacePath(c,f,P){if(!P)return!0;if((0,r.isWorkspaceIdentifier)(c.openedWorkspace)&&k.extUriBiasedIgnorePathCase.isEqual(c.openedWorkspace.configPath,P))return!1;if((0,n.findWindowOnWorkspaceOrFolder)(f,P)){const L={title:this.productService.nameLong,type:"info",buttons:[(0,M.mnemonicButtonLabel)((0,u.localize)(0,null))],message:(0,u.localize)(1,null,(0,k.basename)(P)),detail:(0,u.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(L,(0,y.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(c,f){if(!c.config)return;c.focus();let P;return c.config.extensionDevelopmentPath||(P=this.backupMainService.registerWorkspaceBackupSync({workspace:f,remoteAuthority:c.remoteAuthority},c.config.backupPath)),(0,r.isWorkspaceIdentifier)(c.openedWorkspace)&&this.isUntitledWorkspace(c.openedWorkspace)&&this.deleteUntitledWorkspaceSync(c.openedWorkspace),c.config.workspace=f,c.config.backupPath=P,{workspace:f,backupPath:P}}};o=fe([ee(0,E.IEnvironmentMainService),ee(1,g.ILogService),ee(2,l.IUserDataProfilesMainService),ee(3,b.IBackupMainService),ee(4,w.IDialogMainService),ee(5,h.IProductService)],o),e.WorkspacesManagementMainService=o}),define(Y[113],X([0,1,38,21,5,32,24,47]),function(z,e,v,t,D,R,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,D.createDecorator)(e.ID);let d=class{constructor(C,k){this.windowsMainService=C,this.workspacesManagementMainService=k}async getRemoteDiagnostics(C){const k=this.windowsMainService.getWindows();return(await Promise.all(k.map(m=>new Promise(u=>{const b=m.remoteAuthority;if(b){const w=`vscode:getDiagnosticInfoResponse${m.id}`,E={includeProcesses:C.includeProcesses,folders:C.includeWorkspaceMetadata?this.getFolderURIs(m):void 0};m.sendWhenReady("vscode:getDiagnosticInfo",t.CancellationToken.None,{replyChannel:w,args:E}),v.validatedIpcMain.once(w,(I,g)=>{g||u({hostName:b,errorMessage:`Unable to resolve connection to '${b}'.`}),u(g)}),setTimeout(()=>{u({hostName:b,errorMessage:`Connection to '${b}' could not be established`})},5e3)}else u(void 0)})))).filter(m=>!!m)}getFolderURIs(C){const k=[],y=C.openedWorkspace;if((0,M.isSingleFolderWorkspaceIdentifier)(y))k.push(y.uri);else if((0,M.isWorkspaceIdentifier)(y)){const m=this.workspacesManagementMainService.resolveLocalWorkspaceSync(y.configPath);m&&m.folders.forEach(b=>{k.push(b.uri)})}return k}};d=fe([ee(0,R.IWindowsMainService),ee(1,S.IWorkspacesManagementMainService)],d),e.DiagnosticsMainService=d}),define(Y[114],X([0,1,14,25,4,13,7,23,18,56,5,6,108,32,24,47]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,C.createDecorator)(e.ID);let w=class{constructor(I,g,h,l,n){this.logService=I,this.windowsMainService=g,this.urlService=h,this.workspacesManagementMainService=l,this.configurationService=n}async start(I,g){this.logService.trace("Received data from other instance: ",I,g),D.isMacintosh&&v.app.focus({steal:!0});const h=this.parseOpenUrl(I);if(h.length){let l=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(l=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),l.then(()=>{for(const{uri:n,url:r}of h)this.urlService.open(n,{originalUrl:r})})}else return this.startOpenWindow(I,g)}parseOpenUrl(I){return I["open-url"]&&I._urls&&I._urls.length>0?(0,t.coalesce)(I._urls.map(g=>{try{return{uri:M.URI.parse(g),url:g}}catch{return null}})):[]}async startOpenWindow(I,g){const h=(0,p.isLaunchedFromCli)(g)?0:4;let l=[];const n=I.wait&&I.waitMarkerFilePath?M.URI.file(I.waitMarkerFilePath):void 0,r=I.remote||void 0,i={context:h,cli:I,userEnv:g,waitMarkerFileURI:n,remoteAuthority:r};if(I.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(I.extensionDevelopmentPath,i);else if(!I._.length&&!I["folder-uri"]&&!I["file-uri"]){let s=!1;if(I["new-window"]||I["unity-launch"])s=!0;else if(I["reuse-window"])s=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":s=!0;break;case"off":s=!1;break;default:s=!D.isMacintosh}if(s)l=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const o=this.windowsMainService.getLastActiveWindow();o?(this.windowsMainService.openExistingWindow(o,i),l=[o]):l=this.windowsMainService.open({...i,forceEmpty:!0})}}else l=this.windowsMainService.open({...i,forceNewWindow:I["new-window"],preferNewWindow:!I["reuse-window"]&&!I.wait,forceReuseWindow:I["reuse-window"],diffMode:I.diff,mergeMode:I.merge,addMode:I.add,noRecentEntry:!!I["skip-add-to-recently-opened"],gotoLineMode:I.goto});if(n&&l.length===1&&l[0])return Promise.race([l[0].whenClosedOrLoaded,(0,S.whenDeleted)(n.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const I=[];return v.BrowserWindow.getAllWindows().forEach(g=>{const h=this.windowsMainService.getWindowById(g.id);h?I.push(this.codeWindowToInfo(h)):I.push(this.browserWindowToInfo(g))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:I,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}getFolderURIs(I){const g=[],h=I.openedWorkspace;if((0,u.isSingleFolderWorkspaceIdentifier)(h))g.push(h.uri);else if((0,u.isWorkspaceIdentifier)(h)){const l=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.configPath);l&&l.folders.forEach(r=>{g.push(r.uri)})}return g}codeWindowToInfo(I){const g=this.getFolderURIs(I),h=(0,R.assertIsDefined)(I.win);return this.browserWindowToInfo(h,g,I.remoteAuthority)}browserWindowToInfo(I,g=[],h){return{pid:I.webContents.getOSProcessId(),title:I.getTitle(),folderURIs:g,remoteAuthority:h}}};w=fe([ee(0,k.ILogService),ee(1,m.IWindowsMainService),ee(2,y.IURLService),ee(3,b.IWorkspacesManagementMainService),ee(4,d.IConfigurationService)],w),e.LaunchMainService=w}),define(Y[64],X([0,1,42,14,28,137,51,3,34,2,12,9,4,7,93,80,23,90,159,53,26,5,22,6,20,61,32,24,47,17]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u,b,w,E,I,g,h,l,n,r,i,s,o,a,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,l.createDecorator)("nativeHostMainService");let P=class extends p.Disposable{constructor(T,W,$,te,re,ie,se,ce,q){super();this.sharedProcess=T,this.windowsMainService=W,this.dialogMainService=$,this.lifecycleMainService=te,this.environmentMainService=re,this.logService=ie,this.productService=se,this.themeMainService=ce,this.workspacesManagementMainService=q,this.onDidOpenWindow=S.Event.map(this.windowsMainService.onDidOpenWindow,ne=>ne.id),this.onDidTriggerSystemContextMenu=S.Event.filter(S.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:ne,x:O,y:_})=>({windowId:ne.id,x:O,y:_})),({windowId:ne})=>!!this.windowsMainService.getWindowById(ne)),this.onDidMaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(ne,O)=>O.id),ne=>!!this.windowsMainService.getWindowById(ne)),this.onDidUnmaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(ne,O)=>O.id),ne=>!!this.windowsMainService.getWindowById(ne)),this.onDidBlurWindow=S.Event.filter(S.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(ne,O)=>O.id),ne=>!!this.windowsMainService.getWindowById(ne)),this.onDidFocusWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),ne=>!!ne),ne=>ne.id),S.Event.filter(S.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(ne,O)=>O.id),ne=>!!this.windowsMainService.getWindowById(ne))),this.onDidResumeOS=S.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new S.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(ne,O,_)=>_),ne=>!(Array.isArray(ne)&&ne.length===1&&ne[0]==="workArea")),S.Event.fromNodeEventEmitter(t.screen,"display-added"),S.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(W=>({id:W.id,workspace:W.openedWorkspace,title:W.win?.getTitle()??"",filename:W.getRepresentedFilename(),dirty:W.isDocumentEdited()}))}async getWindowCount(T){return this.windowsMainService.getWindowCount()}async getActiveWindowId(T){const W=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(W)return W.id}openWindow(T,W,$){return Array.isArray(W)?this.doOpenWindow(T,W,$):this.doOpenEmptyWindow(T,W)}async doOpenWindow(T,W,$=Object.create(null)){W.length>0&&this.windowsMainService.open({context:5,contextWindowId:T,urisToOpen:W,cli:this.environmentMainService.args,forceNewWindow:$.forceNewWindow,forceReuseWindow:$.forceReuseWindow,preferNewWindow:$.preferNewWindow,diffMode:$.diffMode,mergeMode:$.mergeMode,addMode:$.addMode,gotoLineMode:$.gotoLineMode,noRecentEntry:$.noRecentEntry,waitMarkerFileURI:$.waitMarkerFileURI,remoteAuthority:$.remoteAuthority||void 0})}async doOpenEmptyWindow(T,W){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:T},W)}async toggleFullScreen(T){const W=this.windowById(T);W&&W.toggleFullScreen()}async handleTitleDoubleClick(T){const W=this.windowById(T);W&&W.handleTitleDoubleClick()}async isMaximized(T){const W=this.windowById(T);return W?.win?W.win.isMaximized():!1}async maximizeWindow(T){const W=this.windowById(T);W?.win&&W.win.maximize()}async unmaximizeWindow(T){const W=this.windowById(T);W?.win&&W.win.unmaximize()}async minimizeWindow(T){const W=this.windowById(T);W?.win&&W.win.minimize()}async updateTitleBarOverlay(T,W){const $=this.windowById(T);$?.win&&$.win.setTitleBarOverlay({color:W.backgroundColor,symbolColor:W.foregroundColor,height:W.height?W.height-1:void 0})}async focusWindow(T,W){W&&typeof W.windowId=="number"&&(T=W.windowId),this.windowById(T)?.focus({force:W?.force??!1})}async setMinimumSize(T,W,$){const te=this.windowById(T);if(te?.win){const[re,ie]=te.win.getSize(),[se,ce]=te.win.getMinimumSize(),[q,ne]=[W??se,$??ce],[O,_]=[Math.max(re,q),Math.max(ie,ne)];(se!==q||ce!==ne)&&te.win.setMinimumSize(q,ne),(re!==O||ie!==_)&&te.win.setSize(O,_)}}async saveWindowSplash(T,W){this.themeMainService.saveWindowSplash(T,W)}async installShellCommand(T){const{source:W,target:$}=await this.getShellCommandLink();try{const{symbolicLink:te}=await w.SymlinkSupport.stat(W);if(te&&!te.dangling){const re=await(0,u.realpath)(W);if($===re)return}await w.Promises.unlink(W)}catch(te){if(te.code!=="ENOENT")throw te}try{await w.Promises.symlink($,W)}catch(te){if(te.code!=="EACCES"&&te.code!=="ENOENT")throw te;const{response:re}=await this.showMessageBox(T,{title:this.productService.nameLong,type:"info",message:(0,I.localize)(0,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,I.localize)(1,null)),(0,d.mnemonicButtonLabel)((0,I.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(re===0)try{const ie=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${$}' '${W}'\\" with administrator privileges"`;await(0,R.promisify)(v.exec)(ie)}catch{throw new Error((0,I.localize)(3,null,W))}}}async uninstallShellCommand(T){const{source:W}=await this.getShellCommandLink();try{await w.Promises.unlink(W)}catch($){switch($.code){case"EACCES":{const{response:te}=await this.showMessageBox(T,{title:this.productService.nameLong,type:"info",message:(0,I.localize)(4,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,I.localize)(5,null)),(0,d.mnemonicButtonLabel)((0,I.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(te===0)try{const re=`osascript -e "do shell script \\"rm '${W}'\\" with administrator privileges"`;await(0,R.promisify)(v.exec)(re)}catch{throw new Error((0,I.localize)(7,null,W))}break}case"ENOENT":break;default:throw $}}}async getShellCommandLink(){const T=(0,k.resolve)(this.environmentMainService.appRoot,"bin","code"),W=`/usr/local/bin/${this.productService.applicationName}`;if(!await w.Promises.exists(T))throw new Error((0,I.localize)(8,null,T));return{source:W,target:T}}async showMessageBox(T,W){return this.dialogMainService.showMessageBox(W,this.toBrowserWindow(T))}async showSaveDialog(T,W){return this.dialogMainService.showSaveDialog(W,this.toBrowserWindow(T))}async showOpenDialog(T,W){return this.dialogMainService.showOpenDialog(W,this.toBrowserWindow(T))}toBrowserWindow(T){const W=this.windowById(T);if(W?.win)return W.win}async pickFileFolderAndOpen(T,W){const $=await this.dialogMainService.pickFileFolder(W);$&&this.doOpenPicked(await Promise.all($.map(async te=>await w.SymlinkSupport.existsDirectory(te)?{folderUri:m.URI.file(te)}:{fileUri:m.URI.file(te)})),W,T)}async pickFolderAndOpen(T,W){const $=await this.dialogMainService.pickFolder(W);$&&this.doOpenPicked($.map(te=>({folderUri:m.URI.file(te)})),W,T)}async pickFileAndOpen(T,W){const $=await this.dialogMainService.pickFile(W);$&&this.doOpenPicked($.map(te=>({fileUri:m.URI.file(te)})),W,T)}async pickWorkspaceAndOpen(T,W){const $=await this.dialogMainService.pickWorkspace(W);$&&this.doOpenPicked($.map(te=>({workspaceUri:m.URI.file(te)})),W,T)}doOpenPicked(T,W,$){this.windowsMainService.open({context:3,contextWindowId:$,cli:this.environmentMainService.args,urisToOpen:T,forceNewWindow:W.forceNewWindow})}async showItemInFolder(T,W){t.shell.showItemInFolder(W)}async setRepresentedFilename(T,W){this.windowById(T)?.setRepresentedFilename(W)}async setDocumentEdited(T,W){this.windowById(T)?.setDocumentEdited(W)}async openExternal(T,W){return y.isLinuxSnap?this.safeSnapOpenExternal(W):t.shell.openExternal(W),!0}safeSnapOpenExternal(T){const W=process.env.GDK_PIXBUF_MODULE_FILE,$=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(T),process.env.GDK_PIXBUF_MODULE_FILE=W,process.env.GDK_PIXBUF_MODULEDIR=$}moveItemToTrash(T,W){return t.shell.trashItem(W)}async isAdmin(){let T;return y.isWindows?T=(await new Promise((W,$)=>{z(["native-is-elevated"],W,$)}))():T=process.getuid()===0,T}async writeElevated(T,W,$,te){const re=await new Promise((ie,se)=>{z(["@vscode/sudo-prompt"],ie,se)});return new Promise((ie,se)=>{const ce=[`"${this.cliPath}"`];te?.unlock&&ce.push("--file-chmod"),ce.push("--file-write",`"${W.fsPath}"`,`"${$.fsPath}"`);const q={name:this.productService.nameLong.replace("-",""),icns:y.isMacintosh&&this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};re.exec(ce.join(" "),q,(ne,O,_)=>{O&&this.logService.trace(`[sudo-prompt] received stdout: ${O}`),_&&this.logService.trace(`[sudo-prompt] received stderr: ${_}`),ne?se(ne):ie(void 0)})})}get cliPath(){return y.isWindows?this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):y.isLinux?this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,k.join)(this.environmentMainService.appRoot,"bin","code"):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return b.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async killProcess(T,W,$){process.kill(W,$)}async readClipboardText(T,W){return t.clipboard.readText(W)}async writeClipboardText(T,W,$){return t.clipboard.writeText(W,$)}async readClipboardFindText(T){return t.clipboard.readFindText()}async writeClipboardFindText(T,W){return t.clipboard.writeFindText(W)}async writeClipboardBuffer(T,W,$,te){return t.clipboard.writeBuffer(W,Buffer.from($.buffer),te)}async readClipboardBuffer(T,W){return f.VSBuffer.wrap(t.clipboard.readBuffer(W))}async hasClipboard(T,W,$){return t.clipboard.has(W,$)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(T,W){this.windowById(T)?.updateTouchBar(W)}async notifyReady(T){const W=this.windowById(T);W&&W.setReady()}async relaunch(T,W){return this.lifecycleMainService.relaunch(W)}async reload(T,W){const $=this.windowById(T);if($){if((0,a.isWorkspaceIdentifier)($.openedWorkspace)){const te=$.openedWorkspace.configPath;if(te.scheme===C.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(te))?.transient)return this.openWindow($.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload($,W?.disableExtensions!==void 0?{_:[],"disable-extensions":W.disableExtensions}:void 0)}}async closeWindow(T){this.closeWindowById(T,T)}async closeWindowById(T,W){const $=this.windowById(W);if($?.win)return $.win.close()}async quit(T){const W=this.windowsMainService.getLastActiveWindow();W?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&W.win?W.win.close():this.lifecycleMainService.quit()}async exit(T,W){await this.lifecycleMainService.kill(W)}async resolveProxy(T,W){const te=this.windowById(T)?.win?.webContents?.session;if(te)return te.resolveProxy(W)}findFreePort(T,W,$,te,re=1){return(0,E.findFreePort)(W,$,te,re)}async openDevTools(T,W){const $=this.windowById(T);$?.win&&$.win.webContents.openDevTools(W)}async toggleDevTools(T){const W=this.windowById(T);W?.win&&W.win.webContents.toggleDevTools()}async sendInputEvent(T,W){const $=this.windowById(T);$?.win&&(W.type==="mouseDown"||W.type==="mouseUp")&&$.win.webContents.sendInputEvent(W)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(T,W,$,te){if(!y.isWindows)return;const re=await new Promise((ie,se)=>{z(["@vscode/windows-registry"],ie,se)});try{return re.GetStringRegKey(W,$,te)}catch{return}}windowById(T){if(typeof T=="number")return this.windowsMainService.getWindowById(T)}};fe([M.memoize],P.prototype,"cliPath",null),P=fe([ee(1,o.IWindowsMainService),ee(2,g.IDialogMainService),ee(3,n.ILifecycleMainService),ee(4,h.IEnvironmentMainService),ee(5,r.ILogService),ee(6,i.IProductService),ee(7,s.IThemeMainService),ee(8,c.IWorkspacesManagementMainService)],P),e.NativeHostMainService=P}),define(Y[248],X([0,1,14,38,28,34,2,12,4,94,157,83,113,53,26,5,114,6,64,58,20,59,73]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u,b,w,E,I,g,h,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,b.createDecorator)("issueMainService");let r=class Lt{constructor(s,o,a,c,f,P,L,T,W,$){this.userEnv=s,this.environmentMainService=o,this.launchMainService=a,this.logService=c,this.diagnosticsService=f,this.diagnosticsMainService=P,this.dialogMainService=L,this.nativeHostMainService=T,this.protocolMainService=W,this.productService=$,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async s=>{const[o,a]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),c=await this.diagnosticsService.getSystemInfo(o,a);this.safeSend(s,"vscode:issueSystemInfoResponse",c)}),t.validatedIpcMain.on("vscode:listProcesses",async s=>{const o=[];try{const a=await this.launchMainService.getMainProcessId();o.push({name:(0,C.localize)(0,null),rootProcess:await(0,p.listProcesses)(a)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(f=>{(0,k.isRemoteDiagnosticError)(f)?o.push({name:f.hostName,rootProcess:f}):f.processes&&o.push({name:f.hostName,rootProcess:f.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(s,"vscode:listProcessesResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async s=>{const o={title:this.productService.nameLong,message:(0,C.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,C.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,C.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(o,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",a.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const o=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,C.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,C.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,C.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(s,o)=>{const{id:a,from:c,args:f}=o;let P;switch(c){case"issueReporter":P=this.issueReporterParentWindow;break;case"processExplorer":P=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${c}`)}P?.webContents.send("vscode:runAction",{id:a,from:c,args:f})}),t.validatedIpcMain.on("vscode:openExternal",(s,o)=>{this.nativeHostMainService.openExternal(void 0,o)}),t.validatedIpcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async s=>{const o=await this.launchMainService.getMainProcessInfo();this.safeSend(s,"vscode:windowsInfoResponse",o.windows)})}safeSend(s,o,...a){s.sender.isDestroyed()||s.sender.send(o,...a)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const o=new M.DisposableStore,a=o.add(this.protocolMainService.createIPCObjectUrl()),c=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(c,a,{backgroundColor:s.styles.backgroundColor,title:(0,C.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,D.type)(),arch:(0,D.arch)(),release:(0,D.release)()},product:g.default}),this.issueReporterWindow.loadURL(S.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",z).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,o.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,o.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const o=new M.DisposableStore,a=o.add(this.protocolMainService.createIPCObjectUrl()),c=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(c,a,{backgroundColor:s.styles.backgroundColor,title:(0,C.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:g.default}),this.processExplorerWindow.loadURL(S.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",z).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,o.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,o.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(s){s.isMinimized()&&s.restore(),s.focus()}createBrowserWindow(s,o,a,c){const f=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:a.title,backgroundColor:a.backgroundColor||Lt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:S.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${o.resource.toString()}`,`--vscode-window-kind=${c}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,n.zoomLevelToZoomFactor)(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop,experimentalDarkMode:!0});return f.setMenuBarVisibility(!1),f}async getSystemStatus(){const[s,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,o)}getWindowPosition(s,o,a){let c;const f=v.screen.getAllDisplays();if(f.length===1)c=f[0];else{if(d.isMacintosh){const T=v.screen.getCursorScreenPoint();c=v.screen.getDisplayNearestPoint(T)}!c&&s&&(c=v.screen.getDisplayMatching(s.getBounds())),c||(c=v.screen.getPrimaryDisplay()||f[0])}const P={width:o,height:a},L=c.bounds;return P.x=L.x+L.width/2-P.width/2,P.y=L.y+L.height/2-P.height/2,L.width>0&&L.height>0&&(P.x<L.x&&(P.x=L.x),P.y<L.y&&(P.y=L.y),P.x>L.x+L.width&&(P.x=L.x),P.y>L.y+L.height&&(P.y=L.y),P.width>L.width&&(P.width=L.width),P.height>L.height&&(P.height=L.height)),P}async getPerformanceInfo(){try{const[s,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,o)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}};r.DEFAULT_BACKGROUND_COLOR="#1E1E1E",r=fe([ee(1,u.IEnvironmentMainService),ee(2,w.ILaunchMainService),ee(3,E.ILogService),ee(4,k.IDiagnosticsService),ee(5,y.IDiagnosticsMainService),ee(6,m.IDialogMainService),ee(7,I.INativeHostMainService),ee(8,l.IProtocolMainService),ee(9,h.IProductService)],r),e.IssueMainService=r}),define(Y[249],X([0,1,21,18,26,22,6,64,20,52,35,46,87]),function(z,e,v,t,D,R,M,S,d,p,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let m=class extends y.AbstractUpdateService{constructor(b,w,E,I,g,h,l,n){super(b,w,I,g,h,n);this.telemetryService=E,this.nativeHostMainService=l}buildUpdateFeedUrl(b){return(0,y.createUpdateURL)(`linux-${process.arch}`,b,this.productService)}doCheckForUpdates(b){!this.url||(this.setState(k.State.CheckingForUpdates(b)),this.requestService.request({url:this.url},v.CancellationToken.None).then(p.asJson).then(w=>{!w||!w.url||!w.version||!w.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!b}),this.setState(k.State.Idle(1))):this.setState(k.State.AvailableForDownload(w))}).then(void 0,w=>{this.logService.error(w),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!b});const E=b?w.message||w:void 0;this.setState(k.State.Idle(1,E))}))}async doDownloadUpdate(b){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):b.update.url&&this.nativeHostMainService.openExternal(void 0,b.update.url),this.setState(k.State.Idle(1))}};m=fe([ee(0,R.ILifecycleMainService),ee(1,t.IConfigurationService),ee(2,C.ITelemetryService),ee(3,D.IEnvironmentMainService),ee(4,p.IRequestService),ee(5,M.ILogService),ee(6,S.INativeHostMainService),ee(7,d.IProductService)],m),e.LinuxUpdateService=m}),define(Y[250],X([0,1,42,27,28,8,21,51,9,7,123,23,18,26,15,22,6,64,20,52,35,46,87]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u,b,w,E,I,g,h,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(a,c=1e3){for(;!a();)await(0,R.timeout)(c)}let i;function s(){return typeof i=="undefined"&&(i=t.existsSync(d.join(d.dirname(process.execPath),"unins000.exe"))?0:1),i}let o=class extends n.AbstractUpdateService{constructor(c,f,P,L,T,W,$,te,re){super(c,f,L,T,W,re);this.telemetryService=P,this.fileService=$,this.nativeHostMainService=te}get cachePath(){const c=d.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return k.Promises.mkdir(c,{recursive:!0}).then(()=>c)}buildUpdateFeedUrl(c){let f="win32";return process.arch!=="ia32"&&(f+=`-${process.arch}`),s()===1?f+="-archive":this.productService.target==="user"&&(f+="-user"),(0,n.createUpdateURL)(f,c,this.productService)}doCheckForUpdates(c){!this.url||(this.setState(l.State.CheckingForUpdates(c)),this.requestService.request({url:this.url},M.CancellationToken.None).then(g.asJson).then(f=>{const P=s();return!f||!f.url||!f.version||!f.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!c}),this.setState(l.State.Idle(P)),Promise.resolve(null)):P===1?(this.setState(l.State.AvailableForDownload(f)),Promise.resolve(null)):(this.setState(l.State.Downloading(f)),this.cleanup(f.version).then(()=>this.getUpdatePackagePath(f.version).then(L=>k.Promises.exists(L).then(T=>{if(T)return Promise.resolve(L);const W=f.url,$=f.hash,te=`${L}.tmp`;return this.requestService.request({url:W},M.CancellationToken.None).then(re=>this.fileService.writeFile(p.URI.file(te),re.stream)).then($?()=>(0,C.checksum)(te,f.hash):()=>{}).then(()=>k.Promises.rename(te,L)).then(()=>L)})).then(L=>{const T=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:L},T&&f.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(f)):this.setState(l.State.Ready(f))})))}).then(void 0,f=>{this.logService.error(f),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!c});const P=c?f.message||f:void 0;this.setState(l.State.Idle(s(),P))}))}async doDownloadUpdate(c){c.update.url&&this.nativeHostMainService.openExternal(void 0,c.update.url),this.setState(l.State.Idle(s()))}async getUpdatePackagePath(c){const f=await this.cachePath;return d.join(f,`CodeSetup-${this.productService.quality}-${c}.exe`)}async cleanup(c=null){const f=c?W=>!new RegExp(`${this.productService.quality}-${c}\\.exe$`).test(W):()=>!0,P=await this.cachePath,T=(await k.Promises.readdir(P)).filter(f).map(async W=>{try{await k.Promises.unlink(d.join(P,W))}catch{}});await Promise.all(T)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const c=this.state.update;this.setState(l.State.Updating(c));const f=await this.cachePath;this.availableUpdate.updateFilePath=d.join(f,`CodeSetup-${this.productService.quality}-${c.version}.flag`),await k.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(l.State.Idle(s()))});const L=`${this.productService.win32MutexName}-ready`,T=await new Promise((W,$)=>{z(["windows-mutex"],W,$)});r(()=>T.isActive(L)).then(()=>this.setState(l.State.Ready(c)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return s()}};fe([S.memoize],o.prototype,"cachePath",null),o=fe([ee(0,b.ILifecycleMainService),ee(1,y.IConfigurationService),ee(2,h.ITelemetryService),ee(3,m.IEnvironmentMainService),ee(4,g.IRequestService),ee(5,w.ILogService),ee(6,u.IFileService),ee(7,E.INativeHostMainService),ee(8,I.IProductService)],o),e.Win32UpdateService=o}),define(Y[251],X([0,1,14,8,21,41,3,34,2,12,9,70,4,7,165,57,18,53,26,56,15,22,6,20,59,220,88,35,223,61,73,32,24,47,109,117,37,40,66]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u,b,w,E,I,g,h,l,n,r,i,s,o,a,c,f,P,L,T,W,$,te,re,ie,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ce;(function(ne){ne[ne.NONE=0]="NONE",ne[ne.NAVIGATING=1]="NAVIGATING",ne[ne.READY=2]="READY"})(ce||(ce={}));let q=class extends d.Disposable{constructor(O,_,B,Q,H,G,x,A,F,N,j,J,U,K,Z,ae,le,ge){super();this.logService=_,this.environmentMainService=B,this.policyService=Q,this.userDataProfilesService=H,this.fileService=G,this.applicationStorageMainService=x,this.storageMainService=A,this.configurationService=F,this.themeMainService=N,this.workspacesManagementMainService=j,this.backupMainService=J,this.telemetryService=U,this.dialogMainService=K,this.lifecycleMainService=Z,this.productService=ae,this.protocolMainService=le,this.windowsMainService=ge,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new M.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[be,Le]=this.restoreWindowState(O.state);this.windowState=be,this.logService.trace("window#ctor: using window state",be);const Ce=this.windowState.mode===0||this.windowState.mode===3,ke=this.configurationService.getValue("window"),Ae={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:P.WindowMinimumSize.WIDTH,minHeight:P.WindowMinimumSize.HEIGHT,show:!Ce,title:this.productService.nameLong,webPreferences:{preload:p.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,P.zoomLevelToZoomFactor)(ke?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...ke?.experimental?.useSandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};y.isLinux?Ae.icon=(0,C.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):y.isWindows&&!this.environmentMainService.isBuilt&&(Ae.icon=(0,C.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),y.isMacintosh&&!this.useNativeFullScreen()&&(Ae.fullscreenable=!1),y.isMacintosh&&(Ae.acceptFirstMouse=!0,ke?.clickThroughInactive===!1&&(Ae.acceptFirstMouse=!1));const ue=y.isMacintosh&&ke?.nativeTabs===!0;ue&&(Ae.tabbingIdentifier=this.productService.nameShort);const de=(0,P.getTitleBarStyle)(this.configurationService)==="custom";if(de&&(Ae.titleBarStyle="hidden",y.isMacintosh||(Ae.frame=!1),(0,P.useWindowControlsOverlay)(this.configurationService,this.environmentMainService))){const pe=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),Ie=te.Color.fromHex(pe).isDarker()?"#FFFFFF":"#000000";Ae.titleBarOverlay={height:29,color:pe,symbolColor:Ie}}if((0,k.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(Ae),(0,k.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,y.isMacintosh&&de&&this.updateTrafficLightPosition(),y.isMacintosh&&de&&this._win.setSheetOffset(22),y.isWindows&&de){const pe=278;this._win.hookWindowMessage(pe,()=>{const[Ie,De]=this._win.getPosition(),Xe=v.screen.getCursorScreenPoint();return this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Xe.x-Ie,y:Xe.y-De}),0})}if(y.isMacintosh&&Le&&(!ue||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(pe=>typeof pe=="number")){const pe=this.windowState;this._win.setBounds({width:pe.width,height:pe.height,x:pe.x,y:pe.y})}Ce&&((0,k.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,k.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this._profile||(this._profile=(0,se.revive)(this._config?.profiles.current)),this._profile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}setRepresentedFilename(O){y.isMacintosh&&!this.customTrafficLightPosition?this._win.setRepresentedFilename(O):this.representedFilename=O}getRepresentedFilename(){return y.isMacintosh&&!this.customTrafficLightPosition?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(O){y.isMacintosh&&this._win.setDocumentEdited(O),this.documentEdited=O}isDocumentEdited(){return y.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(O){y.isMacintosh&&O?.force&&v.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(O=>{if(this.isReady)return O(this);this.whenReadyCallbacks.push(O)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(O=>{function _(){B.dispose(),Q.dispose(),O()}const B=this.onDidClose(()=>_()),Q=this.onWillLoad(()=>_())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(_,B)=>this.onWindowError(2,B)),this._win.webContents.on("did-fail-load",(_,B,Q)=>this.onWindowError(3,{reason:Q,exitCode:B})),this._win.webContents.on("will-prevent-unload",_=>{_.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",_=>{this._config&&(this._config.maximized=!0),v.app.emit("browser-window-maximize",_,this._win)}),this._win.on("unmaximize",_=>{this._config&&(this._config.maximized=!1),v.app.emit("browser-window-unmaximize",_,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",D.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",D.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(_=>this.onConfigurationUpdated(_))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(_=>this.onDidDeleteUntitledWorkspace(_)));const O=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:O},async(_,B)=>{const Q=await this.getMarketplaceHeaders();B({cancel:!1,requestHeaders:Object.assign(_.requestHeaders,Q)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,s.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(O,_){switch(O){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${_?.reason||"<unknown>"}, code: ${_?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${_?.reason||"<unknown>"}, code: ${_?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:O,reason:_?.reason,code:_?.exitCode}),O){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){this.destroyWindow(!1,!1);return}if(O===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const B=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,S.mnemonicButtonLabel)((0,u.localize)(0,null)),(0,S.mnemonicButtonLabel)((0,u.localize)(1,null)),(0,S.mnemonicButtonLabel)((0,u.localize)(2,null))],message:(0,u.localize)(3,null),detail:(0,u.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,u.localize)(5,null):void 0},this._win);if(B.response!==1){const Q=B.response===0;this.destroyWindow(Q,B.checkboxChecked)}}else if(O===2){let B;_?B=(0,u.localize)(7,null,_.reason,_.exitCode??"<unknown>"):B=(0,u.localize)(6,null);const Q=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,S.mnemonicButtonLabel)((0,u.localize)(8,null)),(0,S.mnemonicButtonLabel)((0,u.localize)(9,null))],message:B,detail:(0,u.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,u.localize)(11,null):void 0},this._win),H=Q.response===0;this.destroyWindow(H,Q.checkboxChecked)}break}}async destroyWindow(O,_){const B=this._config?.workspace;if(_&&B)try{const Q=this.storageMainService.workspaceStorage(B);await Q.init(),Q.delete("memento/workbench.parts.editor"),await Q.close()}catch(Q){this.logService.error(Q)}if(this._onDidDestroy.fire(),this._win?.destroy(),O&&this._config){let Q,H;(0,T.isSingleFolderWorkspaceIdentifier)(B)?Q={folderUri:B.uri}:(0,T.isWorkspaceIdentifier)(B)?Q={workspaceUri:B.configPath}:H=!0;const[G]=this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:Q?[Q]:void 0,forceEmpty:H,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});G.focus()}}onDidDeleteUntitledWorkspace(O){this._config?.workspace?.id===O.id&&this._config&&(this._config.workspace=void 0)}onConfigurationUpdated(O){const _=this.getMenuBarVisibility();_!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=_,this.setMenuBarVisibility(_)),this.updateTrafficLightPosition(O);let B=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;B?.endsWith("/")&&(B=B.substr(0,B.length-1));const Q=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((B||"").indexOf("@")===-1&&(B!==this.currentHttpProxy||Q!==this.currentNoProxy)){this.currentHttpProxy=B,this.currentNoProxy=Q;const H=B||"",G=Q?`${Q},<local>`:"<local>";this.logService.trace(`Setting proxy to '${H}', bypassing '${G}'`),this._win.webContents.session.setProxy({proxyRules:H,proxyBypassRules:G,pacScript:""})}}addTabbedWindow(O){y.isMacintosh&&O.win&&this._win.addTabbedWindow(O.win)}load(O,_=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!_.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),_.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(O,_),this.readyState===0?this._config=O:this.pendingLoadConfig=O,this.readyState=1,this._win.loadURL(p.FileAccess.asBrowserUri("vs/code/electron-sandbox/workbench/workbench.html",z).toString(!0));const B=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:O.workspace,reason:_.isReload?3:B?2:1})}updateConfiguration(O,_){const B=(this._config??this.pendingLoadConfig)?.userEnv;if(B){const Q=(0,g.isLaunchedFromCli)(B)&&!(0,g.isLaunchedFromCli)(O.userEnv),H=this.isExtensionDevelopmentHost;(Q||H)&&(O.userEnv={...B,...O.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(O.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),_.disableExtensions!==void 0&&(O["disable-extensions"]=_.disableExtensions),O.fullscreen=this.isFullScreen,O.maximized=this._win.isMaximized(),O.partsSplash=this.themeMainService.getWindowSplash(),(0,k.mark)("code/willOpenNewWindow"),O.perfMarks=(0,k.getMarks)(),this.configObjectUrl.update(O)}async reload(O){const _=Object.assign({},this._config);_.workspace=await this.validateWorkspaceBeforeReload(_),delete _.filesToOpenOrCreate,delete _.filesToDiff,delete _.filesToMerge,delete _.filesToWait,this.isExtensionDevelopmentHost&&O&&(_.verbose=O.verbose,_.debugId=O.debugId,_.extensionEnvironment=O.extensionEnvironment,_["inspect-extensions"]=O["inspect-extensions"],_["inspect-brk-extensions"]=O["inspect-brk-extensions"],_["extensions-dir"]=O["extensions-dir"]),_.isInitialStartup=!1,_.policiesData=this.policyService.serialize(),_.editSessionId=this.environmentMainService.editSessionId,_.profiles={all:this.userDataProfilesService.profiles,current:this.userDataProfilesService.getProfile(_.workspace??"empty-window")},this.load(_,{isReload:!0,disableExtensions:O?.["disable-extensions"]})}async validateWorkspaceBeforeReload(O){if((0,T.isWorkspaceIdentifier)(O.workspace)){const _=O.workspace.configPath;if(_.scheme===p.Schemas.file&&!await this.fileService.exists(_))return}else if((0,T.isSingleFolderWorkspaceIdentifier)(O.workspace)){const _=O.workspace.uri;if(_.scheme===p.Schemas.file&&!await this.fileService.exists(_))return}return O.workspace}serializeWindowState(){if(!this._win)return(0,$.defaultWindowState)();if(this.isFullScreen){let B;try{B=v.screen.getDisplayMatching(this.getBounds())}catch{}const Q=(0,$.defaultWindowState)();return{mode:3,display:B?B.id:void 0,width:this.windowState.width||Q.width,height:this.windowState.height||Q.height,x:this.windowState.x||0,y:this.windowState.y||0}}const O=Object.create(null);let _;if(!y.isMacintosh&&this._win.isMaximized()?_=0:_=1,_===0?O.mode=0:O.mode=1,_===1||_===0){let B;_===1?B=this.getBounds():B=this._win.getNormalBounds(),O.x=B.x,O.y=B.y,O.width=B.width,O.height=B.height}return O}restoreWindowState(O){(0,k.mark)("code/willRestoreCodeWindowState");let _=!1;if(O)try{const B=v.screen.getAllDisplays();_=B.length>1,O=this.validateWindowState(O,B)}catch(B){this.logService.warn(`Unexpected error validating window state: ${B}
${B.stack}`)}return(0,k.mark)("code/didRestoreCodeWindowState"),[O||(0,$.defaultWindowState)(),_]}validateWindowState(O,_){if(this.logService.trace(`window#validateWindowState: validating window state on ${_.length} display(s)`,O),typeof O.x!="number"||typeof O.y!="number"||typeof O.width!="number"||typeof O.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(O.width<=0||O.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(_.length===1){const H=this.getWorkingArea(_[0]);if(H){let G=function(){!O||typeof O.x!="number"||typeof O.y!="number"||!H||(O.x<H.x&&(O.x=H.x),O.y<H.y&&(O.y=H.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",H),G(),O.width>H.width&&(O.width=H.width),O.height>H.height&&(O.height=H.height),O.x>H.x+H.width-128&&(O.x=H.x+H.width-O.width),O.y>H.y+H.height-128&&(O.y=H.y+H.height-O.height),G()}return O}if(O.display&&O.mode===3){const H=_.find(G=>G.id===O.display);if(H&&typeof H.bounds?.x=="number"&&typeof H.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const G=(0,$.defaultWindowState)(3);return G.x=H.bounds.x,G.y=H.bounds.y,G}}let B,Q;try{B=v.screen.getDisplayMatching({x:O.x,y:O.y,width:O.width,height:O.height}),Q=this.getWorkingArea(B)}catch{}if(B&&Q&&O.x+O.width>Q.x&&O.y+O.height>Q.y&&O.x<Q.x+Q.width&&O.y<Q.y+Q.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",Q),O}getWorkingArea(O){if(O.workArea.width>0&&O.workArea.height>0)return O.workArea;if(O.bounds.width>0&&O.bounds.height>0)return O.bounds}getBounds(){const[O,_]=this._win.getPosition(),[B,Q]=this._win.getSize();return{x:O,y:_,width:B,height:Q}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(O){this.useNativeFullScreen()?this.setNativeFullScreen(O):this.setSimpleFullScreen(O),this.sendWhenReady(O?"vscode:enterFullScreen":"vscode:leaveFullScreen",D.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(O){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(O)}setSimpleFullScreen(O){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(O),this._win.webContents.focus()}useNativeFullScreen(){const O=this.configurationService.getValue("window");return!O||typeof O.nativeFullScreen!="boolean"||O.nativeTabs?!0:O.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let O=(0,P.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(O)<0&&(O="classic"),O}setMenuBarVisibility(O,_=!0){y.isMacintosh||(O==="toggle"&&_&&this.send("vscode:showInfoMessage",(0,u.localize)(12,null)),O==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(O)}):this.doSetMenuBarVisibility(O))}doSetMenuBarVisibility(O){const _=this.isFullScreen;switch(O){case"classic":this._win.setMenuBarVisibility(!_),this._win.autoHideMenuBar=_;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}updateTrafficLightPosition(O){if(!y.isMacintosh)return;const _="window.commandCenter";if(O&&!O.affectsConfiguration(_)||!((0,P.getTitleBarStyle)(this.configurationService)==="custom"))return;const Q=this.configurationService.getValue(_);Q?(this.defaultTrafficLightPosition||(this.defaultTrafficLightPosition=this._win.getTrafficLightPosition()),this._win.setTrafficLightPosition({x:7,y:10})):this.defaultTrafficLightPosition&&this._win.setTrafficLightPosition(this.defaultTrafficLightPosition),this.customTrafficLightPosition=Q}handleTitleDoubleClick(){if(y.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(O,_,...B){this.isReady?this.send(O,...B):this.ready().then(()=>{_.isCancellationRequested||this.send(O,...B)})}send(O,..._){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${O}' for window that is destroyed`);return}try{this._win.webContents.send(O,..._)}catch(B){this.logService.warn(`Error sending IPC message to channel '${O}' of window ${this._id}: ${(0,R.toErrorMessage)(B)}`)}}}updateTouchBar(O){!y.isMacintosh||this.touchBarGroups.forEach((_,B)=>{const Q=O[B];_.segments=this.createTouchBarGroupSegments(Q)})}createTouchBar(){if(!!y.isMacintosh){for(let O=0;O<10;O++){const _=this.createTouchBarGroup();this.touchBarGroups.push(_)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(O=[]){const _=this.createTouchBarGroupSegments(O),B=new v.TouchBar.TouchBarSegmentedControl({segments:_,mode:"buttons",segmentStyle:"automatic",change:Q=>{this.sendWhenReady("vscode:runAction",D.CancellationToken.None,{id:B.segments[Q].id,from:"touchbar"})}});return B}createTouchBarGroupSegments(O=[]){return O.map(B=>{let Q;B.icon&&!c.ThemeIcon.isThemeIcon(B.icon)&&B.icon?.dark?.scheme===p.Schemas.file&&(Q=v.nativeImage.createFromPath(m.URI.revive(B.icon.dark).fsPath),Q.isEmpty()&&(Q=void 0));let H;return typeof B.title=="string"?H=B.title:H=B.title.value,{id:B.id,label:Q?void 0:H,icon:Q}})}dispose(){super.dispose(),this._win=null}};q=fe([ee(1,n.ILogService),ee(2,I.IEnvironmentMainService),ee(3,re.IPolicyService),ee(4,ie.IUserDataProfilesService),ee(5,h.IFileService),ee(6,o.IApplicationStorageMainService),ee(7,o.IStorageMainService),ee(8,w.IConfigurationService),ee(9,f.IThemeMainService),ee(10,W.IWorkspacesManagementMainService),ee(11,b.IBackupMainService),ee(12,a.ITelemetryService),ee(13,E.IDialogMainService),ee(14,l.ILifecycleMainService),ee(15,r.IProductService),ee(16,i.IProtocolMainService),ee(17,L.IWindowsMainService)],q),e.CodeWindow=q}),define(Y[74],X([0,1,14,25,8,3,34,2,12,4,16,7,23,168,5,22,6,88,89,24,47]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u,b,w,E,I,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,u.createDecorator)("workspacesHistoryMainService");let l=class tt extends S.Disposable{constructor(r,i,s,o){super();this.logService=r,this.workspacesManagementMainService=i,this.lifecycleMainService=s,this.applicationStorageMainService=o,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new D.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(r=>this.addRecentlyOpened([{workspace:r.workspace,remoteAuthority:r.window.remoteAuthority}])))}async addRecentlyOpened(r){const i=[],s=[];for(const o of r)if((0,I.isRecentWorkspace)(o))!this.workspacesManagementMainService.isUntitledWorkspace(o.workspace)&&this.indexOfWorkspace(i,o.workspace)===-1&&i.push(o);else if((0,I.isRecentFolder)(o))this.indexOfFolder(i,o.folderUri)===-1&&i.push(o);else{const a=this.indexOfFile(s,o.fileUri)>=0,c=o.fileUri.scheme===d.Schemas.file&&tt.COMMON_FILES_FILTER.indexOf((0,C.basename)(o.fileUri))>=0;!a&&!c&&(s.push(o),p.isWindows&&o.fileUri.scheme===d.Schemas.file&&v.app.addRecentDocument(o.fileUri.fsPath))}await this.addEntriesFromStorage(i,s),i.length>tt.MAX_TOTAL_RECENT_ENTRIES&&(i.length=tt.MAX_TOTAL_RECENT_ENTRIES),s.length>tt.MAX_TOTAL_RECENT_ENTRIES&&(s.length=tt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:s}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(r){const i=c=>{const f=this.location(c);for(const P of r)if(C.extUriBiasedIgnorePathCase.isEqual(P,f))return!1;return!0},s=await this.getRecentlyOpened(),o=s.workspaces.filter(i),a=s.files.filter(i);(o.length!==s.workspaces.length||a.length!==s.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:o}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(r){const i=[],s=[];if(r){const a=r.config?.workspace;(0,g.isWorkspaceIdentifier)(a)&&!this.workspacesManagementMainService.isUntitledWorkspace(a)?i.push({workspace:a,remoteAuthority:r.remoteAuthority}):(0,g.isSingleFolderWorkspaceIdentifier)(a)&&i.push({folderUri:a.uri,remoteAuthority:r.remoteAuthority})}const o=r?.config?.filesToOpenOrCreate;if(o)for(const a of o){const c=a.fileUri;c&&this.indexOfFile(s,c)===-1&&s.push({fileUri:c})}return await this.addEntriesFromStorage(i,s),{workspaces:i,files:s}}async addEntriesFromStorage(r,i){const s=await this.getRecentlyOpenedFromStorage();for(const o of s.workspaces){const a=(0,I.isRecentFolder)(o)?this.indexOfFolder(r,o.folderUri):this.indexOfWorkspace(r,o.workspace);a>=0?r[a].label=r[a].label||o.label:r.push(o)}for(const o of s.files){const a=this.indexOfFile(i,o.fileUri);a>=0?i[a].label=i[a].label||o.label:i.push(o)}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let r;const i=this.applicationStorageMainService.get(tt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof i=="string")try{r=JSON.parse(i)}catch(s){this.logService.error("Unexpected error parsing opened paths list",s)}return(0,I.restoreRecentlyOpened)(r,this.logService)}async saveRecentlyOpened(r){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(tt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,I.toStoreData)(r)),-1,1)}location(r){return(0,I.isRecentFolder)(r)?r.folderUri:(0,I.isRecentFile)(r)?r.fileUri:r.workspace.configPath}indexOfWorkspace(r,i){return r.findIndex(s=>(0,I.isRecentWorkspace)(s)&&s.workspace.id===i.id)}indexOfFolder(r,i){return r.findIndex(s=>(0,I.isRecentFolder)(s)&&C.extUriBiasedIgnorePathCase.isEqual(s.folderUri,i))}indexOfFile(r,i){return r.findIndex(s=>C.extUriBiasedIgnorePathCase.isEqual(s.fileUri,i))}async handleWindowsJumpList(){!p.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!p.isWindows)return;const r=[];if(r.push({type:"tasks",items:[{type:"task",title:(0,m.localize)(0,null),description:(0,m.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const i=[];for(const a of v.app.getJumpListSettings().removedItems){const c=a.args;if(c){const f=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(c);f&&i.push(k.URI.parse(f[2]))}}await this.removeRecentlyOpened(i);let s=!1;const o=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,tt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const c=(0,I.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:f,description:P}=this.getWindowsJumpListLabel(c,a.label);let L;return k.URI.isUri(c)?L=`--folder-uri "${c.toString()}"`:(s=!0,L=`--file-uri "${c.configPath.toString()}"`),{type:"task",title:f.substr(0,255),description:P.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));o.length>0&&r.push({type:"custom",name:s?(0,m.localize)(2,null):(0,m.localize)(3,null),items:o})}r.push({type:"recent"});try{const i=v.app.setJumpList(r);i&&i!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${i}`)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(r,i){if(i)return{title:(0,M.splitName)(i).name,description:i};if(k.URI.isUri(r))return{title:(0,C.basename)(r),description:this.renderJumpListPathDescription(r)};if(this.workspacesManagementMainService.isUntitledWorkspace(r))return{title:(0,m.localize)(4,null),description:""};let s=(0,C.basename)(r.configPath);return s.endsWith(g.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-g.WORKSPACE_EXTENSION.length-1)),{title:(0,m.localize)(5,null,s),description:this.renderJumpListPathDescription(r.configPath)}}renderJumpListPathDescription(r){return r.scheme==="file"?(0,M.normalizeDriveLetter)(r.fsPath):r.toString()}async updateMacOSRecentDocuments(){if(!p.isMacintosh)return;v.app.clearRecentDocuments();const r=await this.getRecentlyOpened(),i=[];let s=0;for(let a=0;a<r.workspaces.length&&s<tt.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const c=this.location(r.workspaces[a]);if(c.scheme===d.Schemas.file){const f=(0,C.originalFSPath)(c);await y.Promises.exists(f)&&(i.push(f),s++)}}const o=[];for(let a=0;a<r.files.length&&s<tt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const c=this.location(r.files[a]);if(c.scheme===d.Schemas.file){const f=(0,C.originalFSPath)(c);if(tt.COMMON_FILES_FILTER.includes((0,C.basename)(c))||i.includes(f))continue;await y.Promises.exists(f)&&(o.push(f),s++)}}o.reverse().forEach(a=>v.app.addRecentDocument(a)),i.reverse().forEach(a=>v.app.addRecentDocument(a))}};l.MAX_TOTAL_RECENT_ENTRIES=500,l.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",l.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,l.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,l.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,l.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],l=fe([ee(0,w.ILogService),ee(1,h.IWorkspacesManagementMainService),ee(2,b.ILifecycleMainService),ee(3,E.IApplicationStorageMainService)],l),e.WorkspacesHistoryMainService=l}),define(Y[252],X([0,1,14,8,21,34,4,7,158,18,26,22,6,199,64,20,45,35,46,73,32,74]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u,b,w,E,I,g,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const n="menu";let r=class Dt{constructor(o,a,c,f,P,L,T,W,$,te,re){this.updateService=o,this.configurationService=a,this.windowsMainService=c,this.environmentMainService=f,this.telemetryService=P,this.workspacesHistoryMainService=L,this.stateMainService=T,this.lifecycleMainService=W,this.logService=$,this.nativeHostMainService=te,this.productService=re,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,g.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateMainService.getItem(Dt.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(L,T,W)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(L,T,W)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(L,T,W)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(W),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(L,T,W)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(W),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(L,T,W)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(W),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const a=this.productService.requestFeatureUrl;a&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(a,"openUserVoiceUrl"));const c=this.productService.reportIssueUrl;c&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(c,"openReportIssues"));const f=this.productService.licenseUrl;f&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const L=f.indexOf("?")>0?"&":"?";this.openUrl(`${f}${L}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(f,"openLicenseUrl")});const P=this.productService.privacyStatementUrl;P&&f&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(P,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;const o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,a){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateMainService.setItem(Dt.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){!M.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!M.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=v.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(M.isMacintosh?new v.Menu:null);return}const a=new v.Menu;let c;if(M.isMacintosh){const P=new v.Menu;c=new v.MenuItem({label:this.productService.nameShort,submenu:P}),this.setMacApplicationMenu(P),a.append(c)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const P=new v.Menu;P.append(new v.MenuItem({label:this.mnemonicLabel(d.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(P)}if(this.shouldDrawMenu("File")){const P=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(d.localize(1,null)),submenu:P});this.setMenuById(P,"File"),a.append(L)}if(this.shouldDrawMenu("Edit")){const P=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(d.localize(2,null)),submenu:P});this.setMenuById(P,"Edit"),a.append(L)}if(this.shouldDrawMenu("Selection")){const P=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(d.localize(3,null)),submenu:P});this.setMenuById(P,"Selection"),a.append(L)}if(this.shouldDrawMenu("View")){const P=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(d.localize(4,null)),submenu:P});this.setMenuById(P,"View"),a.append(L)}if(this.shouldDrawMenu("Go")){const P=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(d.localize(5,null)),submenu:P});this.setMenuById(P,"Go"),a.append(L)}if(this.shouldDrawMenu("Run")){const P=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(d.localize(6,null)),submenu:P});this.setMenuById(P,"Run"),a.append(L)}if(this.shouldDrawMenu("Terminal")){const P=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(d.localize(7,null)),submenu:P});this.setMenuById(P,"Terminal"),a.append(L)}let f;if(this.shouldDrawMenu("Window")){const P=new v.Menu;f=new v.MenuItem({label:this.mnemonicLabel(d.localize(8,null)),submenu:P,role:"window"}),this.setMacWindowMenu(P)}if(f&&a.append(f),this.shouldDrawMenu("Help")){const P=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(d.localize(9,null)),submenu:P,role:"help"});this.setMenuById(P,"Help"),a.append(L)}a.items&&a.items.length>0?v.Menu.setApplicationMenu(a):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const a=this.createMenuItem(d.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),c=this.getUpdateMenuItems();let f;if(this.shouldDrawMenu("Preferences")){const ie=new v.Menu;this.setMenuById(ie,"Preferences"),f=new v.MenuItem({label:this.mnemonicLabel(d.localize(11,null)),submenu:ie})}const P=new v.Menu,L=new v.MenuItem({label:d.localize(12,null),role:"services",submenu:P}),T=new v.MenuItem({label:d.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),W=new v.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),$=new v.MenuItem({label:d.localize(15,null),role:"unhide"}),te=new v.MenuItem(this.likeAction("workbench.action.quit",{label:d.localize(16,null,this.productService.nameLong),click:async(ie,se,ce)=>{const q=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||q?.isMinimized())&&await this.confirmBeforeQuit(ce)&&this.nativeHostMainService.quit(void 0)}})),re=[a];re.push(...c),f&&re.push(i(),f),re.push(i(),L,i(),T,W,$,i(),te),re.forEach(ie=>o.append(ie))}async confirmBeforeQuit(o){if(this.windowsMainService.getWindowCount()===0)return!0;const a=this.configurationService.getValue("window.confirmBeforeClose");if(a==="always"||a==="keyboardOnly"&&this.isKeyboardEvent(o)){const c={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(d.localize(17,null)),(0,R.mnemonicButtonLabel)(d.localize(18,null))],message:d.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:f}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,c);return f===0}return!0}shouldDrawMenu(o){if(!M.isMacintosh&&(0,g.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,a){a.forEach(c=>{if((0,m.isMenubarMenuItemSeparator)(c))o.append(i());else if((0,m.isMenubarMenuItemSubmenu)(c)){const f=new v.Menu,P=new v.MenuItem({label:this.mnemonicLabel(c.label),submenu:f});this.setMenu(f,c.submenu.items),o.append(P)}else(0,m.isMenubarMenuItemRecentAction)(c)?o.append(this.createOpenRecentMenuItem(c)):(0,m.isMenubarMenuItemAction)(c)&&(c.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[c.id]?o.append(new v.MenuItem(this.likeAction(c.id,{label:this.mnemonicLabel(c.label),click:this.fallbackMenuHandlers[c.id]}))):o.append(this.createMenuItem(c.label,c.id,!1,c.checked)):o.append(this.createMenuItem(c.label,c.id,c.enabled!==!1,!!c.checked)):o.append(this.createMenuItem(c.label,c.id,c.enabled!==!1,!!c.checked)))})}setMenuById(o,a){this.menubarMenus&&this.menubarMenus[a]&&this.setMenu(o,this.menubarMenus[a].items)}insertCheckForUpdatesItems(o){const a=this.getUpdateMenuItems();a.length&&(a.forEach(c=>o.append(c)),o.append(i()))}createOpenRecentMenuItem(o){const a=S.URI.revive(o.uri),c=o.id,f=c==="openRecentFile"?{fileUri:a}:c==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new v.MenuItem(this.likeAction(c,{label:o.label,click:(P,L,T)=>{const W=this.isOptionClick(T);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[f],forceNewWindow:W,gotoLineMode:!1,remoteAuthority:o.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([a])}},!1))}isOptionClick(o){return!!(o&&(!M.isMacintosh&&(o.ctrlKey||o.shiftKey)||M.isMacintosh&&(o.metaKey||o.altKey)))}isKeyboardEvent(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}createRoleMenuItem(o,a,c){const f={label:this.mnemonicLabel(o),role:c,enabled:!0};return new v.MenuItem(this.withKeybinding(a,f))}setMacWindowMenu(o){const a=new v.MenuItem({label:d.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),c=new v.MenuItem({label:d.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),f=new v.MenuItem({label:d.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),P=this.createMenuItem(d.localize(23,null),"workbench.action.switchWindow"),L=[];this.currentEnableNativeTabs&&(L.push(i()),L.push(this.createMenuItem(d.localize(24,null),"workbench.action.newWindowTab")),L.push(this.createRoleMenuItem(d.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.createRoleMenuItem(d.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.createRoleMenuItem(d.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.createRoleMenuItem(d.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,c,i(),P,...L,i(),f].forEach(T=>o.append(T))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(d.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:d.localize(30,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(d.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:d.localize(32,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(d.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:d.localize(34,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(d.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,a,c,f){const P=this.mnemonicLabel(o),L=typeof a=="function"?a:(re,ie,se)=>{const ce=re?re.userSettingsLabel:null;let q=a;Array.isArray(a)&&(q=this.isOptionClick(se)?a[1]:a[0]),ce&&se.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:ce}):this.runActionInRenderer({type:"commandId",commandId:q})},T=typeof c=="boolean"?c:this.windowsMainService.getWindowCount()>0,W=typeof f=="boolean"?f:!1,$={label:P,click:L,enabled:T};W&&($.type="checkbox",$.checked=W);let te;return typeof a=="string"?te=a:Array.isArray(a)&&(te=a[0]),M.isMacintosh&&(te==="editor.action.clipboardCutAction"?$.role="cut":te==="editor.action.clipboardCopyAction"?$.role="copy":te==="editor.action.clipboardPasteAction"&&($.role="paste"),te==="undo"?$.click=this.makeContextAwareClickHandler(L,{inDevTools:re=>re.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):te==="redo"?$.click=this.makeContextAwareClickHandler(L,{inDevTools:re=>re.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):te==="editor.action.selectAll"&&($.click=this.makeContextAwareClickHandler(L,{inDevTools:re=>re.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(te,$))}makeContextAwareClickHandler(o,a){return(c,f,P)=>{const L=v.BrowserWindow.getFocusedWindow();if(!L)return a.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return a.inDevTools(L.webContents.devToolsWebContents);o(c,f||L,P)}}runActionInRenderer(o){let a=v.BrowserWindow.getFocusedWindow();if(!a){const f=this.windowsMainService.getLastActiveWindow();f?.isMinimized()&&(a=f.win)}const c=a?this.windowsMainService.getWindowById(a.id):void 0;if(c){if(this.logService.trace("menubar#runActionInRenderer",o),M.isMacintosh&&!this.environmentMainService.isBuilt&&!c.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const f={id:o.commandId,from:"menu"};c.sendWhenReady("vscode:runAction",D.CancellationToken.None,f)}else{const f={userSettingsLabel:o.userSettingsLabel};c.sendWhenReady("vscode:runKeybinding",D.CancellationToken.None,f)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,a){const c=typeof o=="string"?this.keybindings[o]:void 0;if(c?.label){if(c.isNative!==!1)a.accelerator=c.label,a.userSettingsLabel=c.userSettingsLabel;else if(typeof a.label=="string"){const f=a.label.indexOf("[");f>=0?a.label=`${a.label.substr(0,f)} [${c.label}]`:a.label=`${a.label} [${c.label}]`}}else a.accelerator=void 0;return a}likeAction(o,a,c=!a.accelerator){c&&(a=this.withKeybinding(o,a));const f=a.click;return a.click=(P,L,T)=>{this.reportMenuActionTelemetry(o),f?.(P,L,T)},a}openUrl(o,a){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(a)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:n})}mnemonicLabel(o){return(0,R.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=fe([ee(0,I.IUpdateService),ee(1,p.IConfigurationService),ee(2,h.IWindowsMainService),ee(3,C.IEnvironmentMainService),ee(4,E.ITelemetryService),ee(5,l.IWorkspacesHistoryMainService),ee(6,w.IStateMainService),ee(7,k.ILifecycleMainService),ee(8,y.ILogService),ee(9,u.INativeHostMainService),ee(10,b.IProductService)],r),e.Menubar=r;function i(){return new v.MenuItem({type:"separator"})}}),define(Y[253],X([0,1,5,22,6,252]),function(z,e,v,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let M=class{constructor(d,p,C){this.instantiationService=d,this.lifecycleMainService=p,this.logService=C,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(d,p){this.logService.trace("menubarService#updateMenubar",d),(await this.menubar).updateMenu(p,d)}};M=fe([ee(0,v.IInstantiationService),ee(1,t.ILifecycleMainService),ee(2,D.ILogService)],M),e.MenubarMainService=M}),define(Y[254],X([0,1,14,27,28,25,21,3,29,48,34,2,12,9,70,4,36,16,13,7,166,57,18,53,26,15,5,22,6,58,20,59,71,45,73,251,111,247,24,112,74,47,61,40,37]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u,b,w,E,I,g,h,l,n,r,i,s,o,a,c,f,P,L,T,W,$,te,re,ie,se,ce,q,ne,O,_,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function Q(x){return(0,se.isWorkspaceIdentifier)(x?.workspace)}function H(x){return(0,se.isSingleFolderWorkspaceIdentifier)(x?.workspace)}let G=class ht extends k.Disposable{constructor(A,F,N,j,J,U,K,Z,ae,le,ge,be,Le,Ce,ke,Ae,ue,de){super();this.machineId=A,this.initialUserEnv=F,this.logService=N,this.stateMainService=j,this.policyService=J,this.environmentMainService=U,this.userDataProfilesService=K,this.lifecycleMainService=Z,this.backupMainService=ae,this.configurationService=le,this.workspacesHistoryMainService=ge,this.workspacesManagementMainService=be,this.instantiationService=Le,this.dialogMainService=Ce,this.fileService=ke,this.productService=Ae,this.protocolMainService=ue,this.themeMainService=de,this._onDidOpenWindow=this._register(new S.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new S.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new S.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new S.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new S.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ie.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const F=new k.DisposableStore;if(F.add(S.Event.any(A.onDidClose,A.onDidDestroy)(()=>F.dispose())),A.config.extensionDevelopmentPath)for(const N of A.config.extensionDevelopmentPath)F.add(this.protocolMainService.addValidFileRoot(N));A.config.extensionTestsPath&&F.add(this.protocolMainService.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,F){const N=this.environmentMainService.args,j=F?.remoteAuthority||void 0,J=!0,U=F?.forceReuseWindow,K=!U;return this.open({...A,cli:N,forceEmpty:J,forceNewWindow:K,forceReuseWindow:U,remoteAuthority:j})}openExistingWindow(A,F){A.focus(),this.handleWaitMarkerFile(F,[A])}open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const F=[],N=[],j=[],J=[],U=[];let K,Z=0;const ae=this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",ae);for(const Ce of ae)H(Ce)?A.addMode?F.push(Ce):N.push(Ce):Q(Ce)?j.push(Ce):Ce.fileUri?(K||(K={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ce.remoteAuthority}),K.filesToOpenOrCreate.push(Ce)):Ce.backupPath?U.push({backupFolder:(0,m.basename)(Ce.backupPath),remoteAuthority:Ce.remoteAuthority}):Z++;A.diffMode&&K&&K.filesToOpenOrCreate.length>=2&&(K.filesToDiff=K.filesToOpenOrCreate.slice(0,2),K.filesToOpenOrCreate=[]),A.mergeMode&&K&&K.filesToOpenOrCreate.length===4&&(K.filesToMerge=K.filesToOpenOrCreate.slice(0,4),K.filesToOpenOrCreate=[],K.filesToDiff=[]),K&&A.waitMarkerFileURI&&(K.filesToWait={paths:(0,R.coalesce)([...K.filesToDiff,K.filesToMerge[3],...K.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(J.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),j.push(...J),U.push(...this.backupMainService.getEmptyWindowBackupPaths())):U.length=0;const{windows:le,filesOpenedInWindow:ge}=this.doOpen(A,j,N,U,Z,K,F);if(this.logService.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${j.length}, foldersToOpen: ${N.length}, emptyToRestore: ${U.length}, emptyToOpen: ${Z})`),le.length>1)if(ge)ge.focus();else{const Ce=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let ke=!0,Ae=!0;if(Ce){const ue=le.filter(de=>this.windowsStateHandler.state.lastActiveWindow&&de.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ue.length&&(ue[0].focus(),ke=!1,Ae=!1)}if(ke)for(let ue=le.length-1;ue>=0;ue--){const de=le[ue];if(!(de.openedWorkspace&&J.some(pe=>de.openedWorkspace&&pe.workspace.id===de.openedWorkspace.id)||de.backupPath&&U.some(pe=>de.backupPath&&pe.backupFolder===(0,m.basename)(de.backupPath)))){de.focus(),Ae=!1;break}}Ae&&le[le.length-1].focus()}const be=K&&K.filesToDiff.length>0,Le=K&&K.filesToMerge.length>0;if(!le.some(Ce=>Ce.isExtensionDevelopmentHost)&&!be&&!Le&&!A.noRecentEntry){const Ce=[];for(const ke of ae)Q(ke)&&!ke.transient?Ce.push({label:ke.label,workspace:ke.workspace,remoteAuthority:ke.remoteAuthority}):H(ke)?Ce.push({label:ke.label,folderUri:ke.workspace.uri,remoteAuthority:ke.remoteAuthority}):ke.fileUri&&Ce.push({label:ke.label,fileUri:ke.fileUri,remoteAuthority:ke.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Ce)}return this.handleWaitMarkerFile(A,le),le}handleWaitMarkerFile(A,F){const N=A.waitMarkerFileURI;A.context===0&&N&&F.length===1&&F[0]&&(async()=>{await F[0].whenClosedOrLoaded;try{await this.fileService.del(N)}catch{}})()}doOpen(A,F,N,j,J,U,K){const Z=[];let ae;function le(ue,de){Z.push(ue),de&&(ae=ue,U=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:be}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&K.length>0){const ue=K[0].remoteAuthority,de=this.getLastActiveWindowForAuthority(ue);de&&le(this.doAddFoldersToExistingWindow(de,K.map(pe=>pe.workspace.uri)))}const Le=N.length+F.length+j.length;if(U&&Le===0){const ue=U.filesToOpenOrCreate[0]||U.filesToDiff[0]||U.filesToMerge[3],de=this.getWindows().filter(Ie=>U&&(0,E.isEqualAuthority)(Ie.remoteAuthority,U.remoteAuthority));let pe;ue?.fileUri&&!be&&((A.context===4||A.context===0||A.context===1)&&(pe=(0,re.findWindowOnFile)(de,ue.fileUri,Ie=>Ie.configPath.scheme===y.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Ie.configPath):void 0)),pe||(pe=this.doGetLastActiveWindow(de))),pe?(0,se.isWorkspaceIdentifier)(pe.openedWorkspace)?F.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(pe.openedWorkspace)?N.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):le(this.doOpenFilesInExistingWindow(A,pe,U),!0):le(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:U,forceNewWindow:!0,remoteAuthority:U.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow}),!0)}const Ce=(0,R.distinct)(F,ue=>ue.workspace.id);if(Ce.length>0){const ue=(0,R.coalesce)(Ce.map(de=>(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),de.workspace.configPath)));if(ue.length>0){const de=ue[0],pe=(0,E.isEqualAuthority)(U?.remoteAuthority,de.remoteAuthority)?U:void 0;le(this.doOpenFilesInExistingWindow(A,de,pe),!!pe),ge=!0}Ce.forEach(de=>{if(ue.some(De=>De.openedWorkspace&&De.openedWorkspace.id===de.workspace.id))return;const pe=de.remoteAuthority,Ie=(0,E.isEqualAuthority)(U?.remoteAuthority,pe)?U:void 0;le(this.doOpenFolderOrWorkspace(A,de,ge,Ie),!!Ie),ge=!0})}const ke=(0,R.distinct)(N,ue=>E.extUriBiasedIgnorePathCase.getComparisonKey(ue.workspace.uri));if(ke.length>0){const ue=(0,R.coalesce)(ke.map(de=>(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),de.workspace.uri)));if(ue.length>0){const de=ue[0],pe=(0,E.isEqualAuthority)(U?.remoteAuthority,de.remoteAuthority)?U:void 0;le(this.doOpenFilesInExistingWindow(A,de,pe),!!pe),ge=!0}ke.forEach(de=>{if(ue.some(De=>(0,se.isSingleFolderWorkspaceIdentifier)(De.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(De.openedWorkspace.uri,de.workspace.uri)))return;const pe=de.remoteAuthority,Ie=(0,E.isEqualAuthority)(U?.remoteAuthority,pe)?U:void 0;le(this.doOpenFolderOrWorkspace(A,de,ge,Ie),!!Ie),ge=!0})}const Ae=(0,R.distinct)(j,ue=>ue.backupFolder);if(Ae.length>0&&Ae.forEach(ue=>{const de=ue.remoteAuthority,pe=(0,E.isEqualAuthority)(U?.remoteAuthority,de)?U:void 0;le(this.doOpenEmpty(A,!0,de,pe,ue),!!pe),ge=!0}),Z.length===0||U){U&&!J&&J++;const ue=U?U.remoteAuthority:A.remoteAuthority;for(let de=0;de<J;de++)le(this.doOpenEmpty(A,ge,ue,U),!!U),ge=!0}return{windows:(0,R.distinct)(Z),filesOpenedInWindow:ae}}doOpenFilesInExistingWindow(A,F,N){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:N}),F.focus();const j={filesToOpenOrCreate:N?.filesToOpenOrCreate,filesToDiff:N?.filesToDiff,filesToMerge:N?.filesToMerge,filesToWait:N?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",M.CancellationToken.None,j),F}doAddFoldersToExistingWindow(A,F){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:F}),A.focus();const N={foldersToAdd:F};return A.sendWhenReady("vscode:addFolders",M.CancellationToken.None,N),A}doOpenEmpty(A,F,N,j,J){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!J,remoteAuthority:N,filesToOpen:j,forceNewWindow:F});let U;return!F&&typeof A.contextWindowId=="number"&&(U=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:N,forceNewWindow:F,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:j,windowToUse:U,emptyWindowBackupInfo:J})}doOpenFolderOrWorkspace(A,F,N,j,J){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:F,filesToOpen:j}),!N&&!J&&typeof A.contextWindowId=="number"&&(J=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:F.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:N,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:j,windowToUse:J})}getPathsToOpen(A){let F,N=!1,j=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(F=this.doExtractPathsFromAPI(A),N=!0):A.forceEmpty?F=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(F=this.doExtractPathsFromCLI(A.cli),F.length===0&&F.push(Object.create(null)),N=!0):(F=this.doGetPathsFromLastSession(),F.length===0&&F.push(Object.create(null)),j=!0),!A.addMode&&N){const J=F.filter(U=>H(U));if(J.length>1){const U=J[0].remoteAuthority;if(J.every(K=>(0,E.isEqualAuthority)(K.remoteAuthority,U))){const K=this.workspacesManagementMainService.createUntitledWorkspaceSync(J.map(Z=>({uri:Z.workspace.uri})));F.push({workspace:K,remoteAuthority:U}),F=F.filter(Z=>!H(Z))}}}return A.initialStartup&&!j&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&F.unshift(...this.doGetPathsFromLastSession().filter(J=>Q(J)||H(J)||J.backupPath)),F}doExtractPathsFromAPI(A){const F=[],N={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority};for(const j of(0,R.coalesce)(A.urisToOpen||[])){const J=this.resolveOpenable(j,N);if(J)J.label=j.label,F.push(J);else{const U=this.resourceFromOpenable(j),K={title:this.productService.nameLong,type:"info",buttons:[(0,C.mnemonicButtonLabel)((0,h.localize)(0,null))],defaultId:0,message:U.scheme===y.Schemas.file?(0,h.localize)(1,null):(0,h.localize)(2,null),detail:U.scheme===y.Schemas.file?(0,h.localize)(3,null,(0,C.getPathLabel)(U,{os:b.OS,tildify:this.environmentMainService})):(0,h.localize)(4,null,U.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(K,(0,I.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return F}doExtractPathsFromCLI(A){const F=[],N={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},j=A["folder-uri"];if(j)for(const K of j){const Z=this.cliArgToUri(K);if(Z){const ae=this.resolveOpenable({folderUri:Z},N);ae&&F.push(ae)}}const J=A["file-uri"];if(J)for(const K of J){const Z=this.cliArgToUri(K);if(Z){const ae=this.resolveOpenable((0,se.hasWorkspaceFileExtension)(K)?{workspaceUri:Z}:{fileUri:Z},N);ae&&F.push(ae)}}const U=A._;for(const K of U){const Z=N.remoteAuthority?this.doResolvePathRemote(K,N):this.doResolveFilePath(K,N);Z&&F.push(Z)}return F}cliArgToUri(A){try{const F=g.URI.parse(A);if(!F.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return F}catch(F){this.logService.error(`Invalid URI input string: ${A}, ${F.message}`)}}doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const F=[];A!=="one"&&F.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&F.push(this.windowsStateHandler.state.lastActiveWindow);const N=[];for(const j of F)if(j.workspace){const J=this.resolveOpenable({workspaceUri:j.workspace.configPath},{remoteAuthority:j.remoteAuthority,rejectTransientWorkspaces:!0});Q(J)&&N.push(J)}else if(j.folderUri){const J=this.resolveOpenable({folderUri:j.folderUri},{remoteAuthority:j.remoteAuthority});H(J)&&N.push(J)}else A!=="folders"&&j.backupPath&&N.push({backupPath:j.backupPath,remoteAuthority:j.remoteAuthority});return N}}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}resolveOpenable(A,F=Object.create(null)){const N=this.resourceFromOpenable(A);return N.scheme===y.Schemas.file?((0,$.isFileToOpen)(A)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(N.fsPath,F)):this.doResolveRemoteOpenable(A,F)}doResolveRemoteOpenable(A,F){let N=this.resourceFromOpenable(A);const j=(0,T.getRemoteAuthority)(N)||F.remoteAuthority;if(N=(0,E.removeTrailingPathSeparator)((0,E.normalizePath)(N)),(0,$.isFileToOpen)(A)){if(F.gotoLineMode){const{path:J,line:U,column:K}=(0,d.parseLineAndColumnAware)(N.path);return{fileUri:N.with({path:J}),options:{selection:U?{startLineNumber:U,startColumn:K||1}:void 0},remoteAuthority:j}}return{fileUri:N,remoteAuthority:j}}else if((0,$.isWorkspaceToOpen)(A))return{workspace:(0,ce.getWorkspaceIdentifier)(N),remoteAuthority:j};return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(N),remoteAuthority:j}}resourceFromOpenable(A){return(0,$.isWorkspaceToOpen)(A)?A.workspaceUri:(0,$.isFolderToOpen)(A)?A.folderUri:A.fileUri}doResolveFilePath(A,F){let N,j;F.gotoLineMode&&({path:A,line:N,column:j}=(0,d.parseLineAndColumnAware)(A)),A=(0,d.sanitizeFilePath)((0,m.normalize)(A),(0,w.cwd)());try{const J=(0,t.statSync)(A);if(J.isFile()){if(!F.forceOpenWorkspaceAsFile){const U=this.workspacesManagementMainService.resolveLocalWorkspaceSync(g.URI.file(A));if(U)return U.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:U.id,configPath:U.configPath},type:s.FileType.File,exists:!0,remoteAuthority:U.remoteAuthority,transient:U.transient}}return{fileUri:g.URI.file(A),type:s.FileType.File,exists:!0,options:{selection:N?{startLineNumber:N,startColumn:j||1}:void 0}}}else{if(J.isDirectory())return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(g.URI.file(A),J),type:s.FileType.Directory,exists:!0};if(!b.isWindows&&A==="/dev/null")return{fileUri:g.URI.file(A),type:s.FileType.File,exists:!0}}}catch{const U=g.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([U]),F.ignoreFileNotFound)return{fileUri:U,type:s.FileType.File,exists:!1}}}doResolvePathRemote(A,F){const N=A.charCodeAt(0),j=F.remoteAuthority;let J,U;F.gotoLineMode&&({path:A,line:J,column:U}=(0,d.parseLineAndColumnAware)(A)),N!==47&&((0,d.isWindowsDriveLetter)(N)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,d.toSlashes)(A)),A=`/${A}`);const K=g.URI.from({scheme:y.Schemas.vscodeRemote,authority:j,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(A))return F.forceOpenWorkspaceAsFile?{fileUri:K,options:{selection:J?{startLineNumber:J,startColumn:U||1}:void 0},remoteAuthority:F.remoteAuthority}:{workspace:(0,ce.getWorkspaceIdentifier)(K),remoteAuthority:j};if(F.gotoLineMode||m.posix.basename(A).indexOf(".")!==-1)return{fileUri:K,options:{selection:J?{startLineNumber:J,startColumn:U||1}:void 0},remoteAuthority:j}}return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(K),remoteAuthority:j}}shouldOpenNewWindow(A){const F=this.configurationService.getValue("window"),N=F?.openFoldersInNewWindow||"default",j=F?.openFilesInNewWindow||"off";let J=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(N==="on"||N==="off")&&(J=N==="on");let U=!1;return A.forceNewWindow||A.forceReuseWindow?U=!!A.forceNewWindow&&!A.forceReuseWindow:(b.isMacintosh?A.context===1&&(U=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(U=!0),!A.cli.extensionDevelopmentPath&&(j==="on"||j==="off")&&(U=j==="on")),{openFolderInNewWindow:!!J,openFilesInNewWindow:U}}openExtensionDevelopmentHostWindow(A,F){const N=(0,re.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(N)return this.lifecycleMainService.reload(N,F.cli),N.focus(),[N];let j=F.cli["folder-uri"]||[],J=F.cli["file-uri"]||[],U=F.cli._;if(!U.length&&!j.length&&!J.length&&!F.cli.extensionTestsPath){const le=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ge=le&&(le.workspace||le.folderUri);ge&&(g.URI.isUri(ge)?ge.scheme===y.Schemas.file?U=[ge.fsPath]:j=[ge.toString()]:ge.configPath.scheme===y.Schemas.file?U=[(0,E.originalFSPath)(ge.configPath)]:J=[ge.configPath.toString()])}let K=F.remoteAuthority;for(const le of A)if(le.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ge=g.URI.parse(le),be=(0,T.getRemoteAuthority)(ge);be&&(K?(0,E.isEqualAuthority)(be,K)||this.logService.error("more than one extension development path authority"):K=be)}U=U.filter(le=>{const ge=g.URI.file(le);return(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge)?!1:(0,E.isEqualAuthority)((0,T.getRemoteAuthority)(ge),K)}),j=j.filter(le=>{const ge=this.cliArgToUri(le);return ge&&!!(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge)?!1:ge?(0,E.isEqualAuthority)((0,T.getRemoteAuthority)(ge),K):!1}),J=J.filter(le=>{const ge=this.cliArgToUri(le);return ge&&!!(0,re.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge)?!1:ge?(0,E.isEqualAuthority)((0,T.getRemoteAuthority)(ge),K):!1}),F.cli._=U,F.cli["folder-uri"]=j,F.cli["file-uri"]=J;const Z=!U.length&&!j.length&&!J.length,ae={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:Z,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:K};return this.open(ae)}openInBrowserWindow(A){const F=this.configurationService.getValue("window"),N={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,m.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesService.profiles,current:this.userDataProfilesService.getProfile(A.workspace??"empty-window")},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:f.default,isInitialStartup:A.initialStartup,perfMarks:(0,u.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)()},zoomLevel:typeof F?.zoomLevel=="number"?F.zoomLevel:void 0,autoDetectHighContrast:F?.autoDetectHighContrast??!0,autoDetectColorScheme:F?.autoDetectColorScheme??!1,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),editSessionId:this.environmentMainService.editSessionId};let j;if(!A.forceNewWindow&&!A.forceNewTabbedWindow&&(j=A.windowToUse||this.getLastActiveWindow(),j&&j.focus()),j){const J=j.config;!N.extensionDevelopmentPath&&J&&!!J.extensionDevelopmentPath&&(N.extensionDevelopmentPath=J.extensionDevelopmentPath,N.verbose=J.verbose,N["inspect-brk-extensions"]=J["inspect-brk-extensions"],N.debugId=J.debugId,N.extensionEnvironment=J.extensionEnvironment,N["inspect-extensions"]=J["inspect-extensions"],N["extensions-dir"]=J["extensions-dir"])}else{const J=this.windowsStateHandler.getNewWindowState(N);(0,u.mark)("code/willCreateCodeWindow");const U=j=this.instantiationService.createInstance(te.CodeWindow,{state:J,extensionDevelopmentPath:N.extensionDevelopmentPath,isExtensionTestHost:!!N.extensionTestsPath});(0,u.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(U),ht.WINDOWS.push(U),this._onDidOpenWindow.fire(U),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,p.once)(U.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(U)),(0,p.once)(U.onDidClose)(()=>this.onWindowClosed(U)),(0,p.once)(U.onDidDestroy)(()=>this._onDidDestroyWindow.fire(U)),U.onDidTriggerSystemContextMenu(({x:Z,y:ae})=>this._onDidTriggerSystemContextMenu.fire({window:U,x:Z,y:ae}));const K=(0,I.assertIsDefined)(U.win?.webContents);K.removeAllListeners("devtools-reload-page"),K.on("devtools-reload-page",()=>this.lifecycleMainService.reload(U)),this.lifecycleMainService.registerWindow(U)}return N.windowId=j.id,j.isReady?this.lifecycleMainService.unload(j,4).then(J=>{J||this.doOpenInBrowserWindow(j,N,A)}):this.doOpenInBrowserWindow(j,N,A),j}doOpenInBrowserWindow(A,F,N){if(!F.extensionDevelopmentPath)if((0,se.isWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:F.workspace,remoteAuthority:F.remoteAuthority});else if((0,se.isSingleFolderWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:F.workspace.uri,remoteAuthority:F.remoteAuthority});else{const j=N.emptyWindowBackupInfo&&N.emptyWindowBackupInfo.backupFolder;F.backupPath=this.backupMainService.registerEmptyWindowBackupSync(j,F.remoteAuthority)}A.load(F)}onWindowClosed(A){const F=ht.WINDOWS.indexOf(A);ht.WINDOWS.splice(F,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=v.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(F=>(0,E.isEqualAuthority)(F.remoteAuthority,A)))}doGetLastActiveWindow(A){const F=Math.max.apply(Math,A.map(N=>N.lastFocusTime));return A.find(N=>N.lastFocusTime===F)}sendToFocused(A,...F){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,M.CancellationToken.None,...F)}sendToAll(A,F,N){for(const j of this.getWindows())N&&N.indexOf(j.id)>=0||j.sendWhenReady(A,M.CancellationToken.None,F)}getWindows(){return ht.WINDOWS}getWindowCount(){return ht.WINDOWS.length}getWindowById(A){const F=this.getWindows().filter(N=>N.id===A);return(0,R.firstOrDefault)(F)}getWindowByWebContents(A){const F=v.BrowserWindow.fromWebContents(A);if(!!F)return this.getWindowById(F.id)}};G.WINDOWS=[],G=fe([ee(2,c.ILogService),ee(3,W.IStateMainService),ee(4,B.IPolicyService),ee(5,i.IEnvironmentMainService),ee(6,_.IUserDataProfilesService),ee(7,a.ILifecycleMainService),ee(8,l.IBackupMainService),ee(9,n.IConfigurationService),ee(10,q.IWorkspacesHistoryMainService),ee(11,ne.IWorkspacesManagementMainService),ee(12,o.IInstantiationService),ee(13,r.IDialogMainService),ee(14,s.IFileService),ee(15,P.IProductService),ee(16,L.IProtocolMainService),ee(17,O.IThemeMainService)],G),e.WindowsMainService=G}),define(Y[255],X([0,1,57,32,74,47]),function(z,e,v,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(d,p,C,k){this.workspacesManagementMainService=d,this.windowsMainService=p,this.workspacesHistoryMainService=C,this.backupMainService=k,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(d,p){const C=this.windowsMainService.getWindowById(d);if(C)return this.workspacesManagementMainService.enterWorkspace(C,this.windowsMainService.getWindows(),p)}createUntitledWorkspace(d,p,C){return this.workspacesManagementMainService.createUntitledWorkspace(p,C)}deleteUntitledWorkspace(d,p){return this.workspacesManagementMainService.deleteUntitledWorkspace(p)}getWorkspaceIdentifier(d,p){return this.workspacesManagementMainService.getWorkspaceIdentifier(p)}getRecentlyOpened(d){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(d))}addRecentlyOpened(d,p){return this.workspacesHistoryMainService.addRecentlyOpened(p)}removeRecentlyOpened(d,p){return this.workspacesHistoryMainService.removeRecentlyOpened(p)}clearRecentlyOpened(d){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=fe([ee(0,R.IWorkspacesManagementMainService),ee(1,t.IWindowsMainService),ee(2,D.IWorkspacesHistoryMainService),ee(3,v.IBackupMainService)],M),e.WorkspacesMainService=M}),define(Y[256],X([0,1,14,38,27,28,17,41,19,29,48,49,34,2,12,9,4,13,7,30,80,129,43,140,96,235,145,57,240,18,68,175,83,113,53,99,173,26,56,106,182,202,183,237,101,184,185,15,195,85,67,5,84,248,213,114,22,6,197,253,64,20,71,243,86,45,241,88,217,35,219,221,72,46,226,227,249,228,250,108,230,231,232,233,238,32,254,239,24,89,74,255,47,236,37,201,63,100,246,209,52]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u,b,w,E,I,g,h,l,n,r,i,s,o,a,c,f,P,L,T,W,$,te,re,ie,se,ce,q,ne,O,_,B,Q,H,G,x,A,F,N,j,J,U,K,Z,ae,le,ge,be,Le,Ce,ke,Ae,ue,de,pe,Ie,De,Xe,Te,Be,We,Ye,Qe,Ze,$e,je,V,oe,he,me,Ee,Re,qe,nt,et,He,Je,xe,ct,lt,Tt,Wt,Ot,Ft,_t,Ut,Nt,Bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ct=class extends m.Disposable{constructor(we,Se,ye,ve,Me,Fe,Oe,_e,Pe,Ue){super();this.mainProcessNodeIpcServer=we,this.userEnv=Se,this.mainInstantiationService=ye,this.logService=ve,this.environmentMainService=Me,this.lifecycleMainService=Fe,this.configurationService=Oe,this.stateMainService=_e,this.fileService=Pe,this.productService=Ue,this.configureSession(),this.registerListeners()}configureSession(){const we=Pe=>Pe?.startsWith(`${u.Schemas.vscodeWebview}://`),Se=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((Pe,Ue,ze,Ke)=>we(Ke.requestingUrl)?ze(Se.has(Ue)):ze(!1)),v.session.defaultSession.setPermissionCheckHandler((Pe,Ue,ze,Ke)=>we(Ke.requestingUrl)?Se.has(Ue):!1);const ye=new Set([u.Schemas.file,u.Schemas.vscodeFileResource,u.Schemas.vscodeRemoteResource,"devtools"]),ve=Pe=>{for(let Ue=Pe;Ue;Ue=Ue.parent)if(Ue.url.startsWith(`${u.Schemas.vscodeWebview}://`))return!0;return!1},Me=Pe=>Pe.resourceType==="xhr"||ve(Pe.frame),Fe=Pe=>{const Ue=Pe.frame;if(!Ue||!this.windowsMainService)return!1;const ze=v.BrowserWindow.getAllWindows();for(const Ke of ze)if(Ue.processId===Ke.webContents.mainFrame.processId)return!0;return!1},Oe=(Pe,Ue)=>{if(Pe.path!=="/index.html")return!0;const ze=Ue.frame;if(!ze||!this.windowsMainService)return!1;for(const Ke of this.windowsMainService.getWindows())if(Ke.win&&ze.processId===Ke.win.webContents.mainFrame.processId)return!0;return!1};v.session.defaultSession.webRequest.onBeforeRequest((Pe,Ue)=>{const ze=I.URI.parse(Pe.url);return ze.scheme===u.Schemas.vscodeWebview&&!Oe(ze,Pe)?(this.logService.error("Blocked vscode-webview request",Pe.url),Ue({cancel:!0})):ze.scheme===u.Schemas.vscodeFileResource&&!Fe(Pe)?(this.logService.error("Blocked vscode-file request",Pe.url),Ue({cancel:!0})):ze.path.endsWith(".svg")&&!ye.has(ze.scheme)?Ue({cancel:!Me(Pe)}):Ue({cancel:!1})}),v.session.defaultSession.webRequest.onHeadersReceived((Pe,Ue)=>{const ze=Pe.responseHeaders,Ke=ze["content-type"]||ze["Content-Type"];if(Ke&&Array.isArray(Ke)){const rt=I.URI.parse(Pe.url);if(rt.path.endsWith(".svg")&&ye.has(rt.scheme))return ze["Content-Type"]=["image/svg+xml"],Ue({cancel:!1,responseHeaders:ze});if(!rt.path.endsWith(u.Schemas.vscodeRemoteResource)&&Ke.some(dt=>dt.toLowerCase().includes("image/svg")))return Ue({cancel:!Me(Pe)})}return Ue({cancel:!1})});const _e=v.session.defaultSession;typeof _e.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&_e.setCodeCachePath((0,b.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,d.setUnexpectedErrorHandler)(ye=>this.onUnexpectedError(ye)),process.on("uncaughtException",ye=>(0,d.onUnexpectedError)(ye)),process.on("unhandledRejection",ye=>(0,d.onUnexpectedError)(ye)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,l.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(ye,ve)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ve)}),v.app.on("activate",(ye,ve)=>{this.logService.trace("app#activate"),ve||this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(ye,ve)=>{ve.on("will-navigate",Me=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Me.preventDefault()}),ve.setWindowOpenHandler(({url:Me})=>(this.nativeHostMainService?.openExternal(void 0,Me),{action:"deny"}))});let we=[],Se;v.app.on("open-file",(ye,ve)=>{this.logService.trace("app#open-file: ",ve),ye.preventDefault(),we.push(this.getWindowOpenableFromPathSync(ve)),Se!==void 0&&(clearTimeout(Se),Se=void 0),Se=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:we,gotoLineMode:!1,preferNewWindow:!0}),we=[],Se=void 0},100)}),v.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",ye=>{const ve=this.windowsMainService?.getWindowByWebContents(ye.sender);let Me,Fe;return ve?.config?(Me=ve.config,Fe={...process.env,...ve.config.userEnv}):(Me=this.environmentMainService.args,Fe=process.env),this.resolveShellEnvironment(Me,Fe,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(ye,ve,Me)=>{const Fe=this.validateNlsPath([ve]);if(!Fe||typeof Me!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Fe,M.VSBuffer.fromString(Me))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(ye,...ve)=>{const Me=this.validateNlsPath(ve);if(!Me)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Me)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",ye=>ye.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",ye=>ye.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",ye=>ye.sender.reload())}validateNlsPath(we){let Se;for(const ye of we)typeof ye=="string"&&(typeof Se!="string"?Se=ye:Se=(0,b.join)(Se,ye));if(!(typeof Se!="string"||!(0,b.isAbsolute)(Se)||!(0,p.isEqualOrParent)(Se,this.environmentMainService.cachedLanguagesPath,!w.isLinux)))return I.URI.file(Se)}onUnexpectedError(we){if(we){const Se={message:`[uncaught exception in main]: ${we.message}`,stack:we.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Se))}this.logService.error(`[uncaught exception in main]: ${we}`),we.stack&&this.logService.error(we.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const we=this.productService.win32AppUserModelId;w.isWindows&&we&&v.app.setAppUserModelId(we);try{w.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Pe){this.logService.error(Pe)}const Se=new r.Server;this.lifecycleMainService.onWillShutdown(Pe=>{Pe.reason===2&&Se.dispose()}),this.logService.trace("Resolving machine identifier...");const ye=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ye}`);const{sharedProcess:ve,sharedProcessReady:Me,sharedProcessClient:Fe}=this.setupSharedProcess(ye),Oe=await this.initServices(ye,ve,Me);this.setUpHandlers(Oe),Oe.invokeFunction(Pe=>this.initChannels(Pe,Se,Fe));const _e=Oe.invokeFunction(Pe=>this.openFirstWindow(Pe,Se));Oe.invokeFunction(Pe=>this.afterWindowOpen(Pe,ve)),this.environmentMainService.args.trace&&Oe.invokeFunction(Pe=>this.stopTracingEventually(Pe,_e))}setUpHandlers(we){this._register(we.createInstance(s.ProxyAuthHandler)),this._register(we.createInstance(Ut.DefaultExtensionsProfileInitHandler))}async resolveMachineId(){let we=this.stateMainService.getItem(De.machineIdKey);return(!we||w.isMacintosh&&we==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(we=await(0,h.getMachineId)(),this.stateMainService.setItem(De.machineIdKey,we)),we}setupSharedProcess(we){const Se=this._register(this.mainInstantiationService.createInstance(ke.SharedProcess,we,this.userEnv)),ye=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Me=await Se.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new i.Client(Me,"main")})(),ve=(async()=>(await Se.whenReady(),ye))();return{sharedProcess:Se,sharedProcessReady:ve,sharedProcessClient:ye}}async initServices(we,Se,ye){const ve=new j.ServiceCollection;switch(process.platform){case"win32":ve.set(We.IUpdateService,new F.SyncDescriptor(je.Win32UpdateService));break;case"linux":w.isLinuxSnap?ve.set(We.IUpdateService,new F.SyncDescriptor($e.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ve.set(We.IUpdateService,new F.SyncDescriptor(Ze.LinuxUpdateService));break;case"darwin":ve.set(We.IUpdateService,new F.SyncDescriptor(Qe.DarwinUpdateService));break}ve.set(qe.IWindowsMainService,new F.SyncDescriptor(nt.WindowsMainService,[we,this.userEnv])),ve.set($.IDialogMainService,new F.SyncDescriptor($.DialogMainService)),ve.set(K.ILaunchMainService,new F.SyncDescriptor(K.LaunchMainService)),ve.set(W.IDiagnosticsMainService,new F.SyncDescriptor(W.DiagnosticsMainService)),ve.set(T.IDiagnosticsService,n.ProxyChannel.toService((0,n.getDelayedChannel)(ye.then(Fe=>Fe.getChannel("diagnostics"))))),ve.set(J.IIssueMainService,new F.SyncDescriptor(J.IssueMainService,[this.userEnv])),ve.set(te.IEncryptionMainService,new F.SyncDescriptor(re.EncryptionMainService,[we])),ve.set(U.IKeyboardLayoutMainService,new F.SyncDescriptor(U.KeyboardLayoutMainService)),ve.set(be.INativeHostMainService,new F.SyncDescriptor(be.NativeHostMainService,[Se])),ve.set(P.ICredentialsMainService,new F.SyncDescriptor(Tt.CredentialsNativeMainService)),ve.set(Ee.IWebviewManagerService,new F.SyncDescriptor(Re.WebviewMainService)),ve.set(Je.IWorkspacesService,new F.SyncDescriptor(ct.WorkspacesMainService)),ve.set(lt.IWorkspacesManagementMainService,new F.SyncDescriptor(lt.WorkspacesManagementMainService)),ve.set(xe.IWorkspacesHistoryMainService,new F.SyncDescriptor(xe.WorkspacesHistoryMainService)),ve.set(ge.IMenubarMainService,new F.SyncDescriptor(ge.MenubarMainService)),ve.set(q.IExtensionUrlTrustService,new F.SyncDescriptor(ne.ExtensionUrlTrustService)),ve.set(O.IExtensionHostStarter,new F.SyncDescriptor(_.ExtensionHostStarter)),ve.set(pe.IStorageMainService,new F.SyncDescriptor(pe.StorageMainService)),ve.set(pe.IApplicationStorageMainService,new F.SyncDescriptor(pe.ApplicationStorageMainService)),w.isWindows?ve.set(B.IExternalTerminalMainService,new F.SyncDescriptor(Q.WindowsExternalTerminalService)):w.isMacintosh?ve.set(B.IExternalTerminalMainService,new F.SyncDescriptor(Q.MacExternalTerminalService)):w.isLinux&&ve.set(B.IExternalTerminalMainService,new F.SyncDescriptor(Q.LinuxExternalTerminalService));const Me=new c.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ve.set(a.IBackupMainService,Me),ve.set(V.IURLService,new F.SyncDescriptor(he.NativeURLService)),(0,Be.supportsTelemetry)(this.productService,this.environmentMainService)){const Fe=(0,n.getDelayedChannel)(ye.then(ze=>ze.getChannel("telemetryAppender"))),Oe=new Xe.TelemetryAppenderClient(Fe),_e=(0,Ie.resolveCommonProperties)(this.fileService,(0,R.release)(),(0,R.hostname)(),process.arch,this.productService.commit,this.productService.version,we,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Pe=(0,Be.getPiiPathsFromEnvironment)(this.environmentMainService),Ue={appenders:[Oe],commonProperties:_e,piiPaths:Pe,sendErrorTelemetry:!0};ve.set(De.ITelemetryService,new F.SyncDescriptor(Te.TelemetryService,[Ue]))}else ve.set(De.ITelemetryService,Be.NullTelemetryService);return ve.set(_t.IDefaultExtensionsProfileInitService,n.ProxyChannel.toService((0,n.getDelayedChannel)(ye.then(Fe=>Fe.getChannel("IDefaultExtensionsProfileInitService"))))),await Me.initialize(),this.mainInstantiationService.createChild(ve)}initChannels(we,Se,ye){const ve=n.ProxyChannel.fromService(we.get(K.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ve);const Me=n.ProxyChannel.fromService(we.get(W.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Me);const Fe=new Ot.PolicyChannel(we.get(Wt.IPolicyService));Se.registerChannel("policy",Fe),ye.then(Ge=>Ge.registerChannel("policy",Fe));const Oe=this.fileService.getProvider(u.Schemas.file);(0,E.assertType)(Oe instanceof A.DiskFileSystemProvider);const _e=new x.DiskFileSystemProviderChannel(Oe,this.logService,this.environmentMainService);Se.registerChannel(H.LOCAL_FILE_SYSTEM_CHANNEL_NAME,_e),ye.then(Ge=>Ge.registerChannel(H.LOCAL_FILE_SYSTEM_CHANNEL_NAME,_e));const Pe=n.ProxyChannel.fromService(we.get(Ft.IUserDataProfilesMainService));Se.registerChannel("userDataProfiles",Pe),ye.then(Ge=>Ge.registerChannel("userDataProfiles",Pe));const Ue=new Nt.RequestChannel(we.get(Bt.IRequestService));ye.then(Ge=>Ge.registerChannel("request",Ue));const ze=new Ye.UpdateChannel(we.get(We.IUpdateService));Se.registerChannel("update",ze);const Ke=n.ProxyChannel.fromService(we.get(J.IIssueMainService));Se.registerChannel("issue",Ke);const rt=n.ProxyChannel.fromService(we.get(te.IEncryptionMainService));Se.registerChannel("encryption",rt);const dt=n.ProxyChannel.fromService(we.get(P.ICredentialsMainService));Se.registerChannel("credentials",dt);const Pt=n.ProxyChannel.fromService(we.get(Ae.ISignService));Se.registerChannel("sign",Pt);const Ve=n.ProxyChannel.fromService(we.get(U.IKeyboardLayoutMainService));Se.registerChannel("keyboardLayout",Ve),this.nativeHostMainService=we.get(be.INativeHostMainService);const ft=n.ProxyChannel.fromService(this.nativeHostMainService);Se.registerChannel("nativeHost",ft),ye.then(Ge=>Ge.registerChannel("nativeHost",ft));const gt=n.ProxyChannel.fromService(we.get(Je.IWorkspacesService));Se.registerChannel("workspaces",gt);const mt=n.ProxyChannel.fromService(we.get(ge.IMenubarMainService));Se.registerChannel("menubar",mt);const pt=n.ProxyChannel.fromService(we.get(V.IURLService));Se.registerChannel("url",pt);const vt=n.ProxyChannel.fromService(we.get(q.IExtensionUrlTrustService));Se.registerChannel("extensionUrlTrust",vt);const wt=n.ProxyChannel.fromService(we.get(Ee.IWebviewManagerService));Se.registerChannel("webview",wt);const ut=this._register(new de.StorageDatabaseChannel(this.logService,we.get(pe.IStorageMainService)));Se.registerChannel("storage",ut),ye.then(Ge=>Ge.registerChannel("storage",ut));const St=n.ProxyChannel.fromService(we.get(B.IExternalTerminalMainService));Se.registerChannel("externalTerminal",St);const Ne=new le.LogLevelChannel(we.get(ae.ILogService));Se.registerChannel("logLevel",Ne),ye.then(Ge=>Ge.registerChannel("logLevel",Ne));const it=new le.LoggerChannel(we.get(ae.ILoggerService));Se.registerChannel("logger",it),ye.then(Ge=>Ge.registerChannel("logger",it));const at=new L.ElectronExtensionHostDebugBroadcastChannel(we.get(qe.IWindowsMainService));Se.registerChannel("extensionhostdebugservice",at);const st=n.ProxyChannel.fromService(we.get(O.IExtensionHostStarter));Se.registerChannel(O.ipcExtensionHostStarterChannelName,st)}openFirstWindow(we,Se){const ye=this.windowsMainService=we.get(qe.IWindowsMainService),ve=we.get(V.IURLService),Me=we.get(be.INativeHostMainService);this.lifecycleMainService.phase=2;const Fe=[],Oe=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ne=>{try{return{uri:I.URI.parse(Ne),url:Ne}}catch{return}}).filter(Ne=>{if(!Ne||this.shouldBlockURI(Ne.uri))return!1;const it=this.getWindowOpenableFromProtocolLink(Ne.uri);return it?(Fe.push(it),!1):!0}),_e=this,Pe=this.environmentMainService,Ue=this.productService,ze=this.logService;ve.registerHandler({async handleURL(Ne,it){if(ze.trace("app#handleURL: ",Ne.toString(!0),it),Ne.scheme===Ue.urlProtocol&&Ne.path==="workspace"&&(Ne=Ne.with({authority:"file",path:I.URI.parse(Ne.query).path,query:""})),_e.shouldBlockURI(Ne))return!0;let at=!1;const st=new URLSearchParams(Ne.query);st.get("windowId")==="_blank"&&(st.delete("windowId"),Ne=Ne.with({query:st.toString()}),at=!0),at||(at=w.isMacintosh&&ye.getWindowCount()===0),st.get("editSessionId")!==null&&(Pe.editSessionId=st.get("editSessionId")??void 0,st.delete("editSessionId"),Ne=Ne.with({query:st.toString()}));const Ge=_e.getWindowOpenableFromProtocolLink(Ne);if(ze.trace("app#handleURL: windowOpenableFromProtocolLink = ",Ge),Ge){const[It]=ye.open({context:5,cli:{...Pe.args},urisToOpen:[Ge],forceNewWindow:at,gotoLineMode:!0});return It.focus(),!0}if(at){const[It]=ye.open({context:5,cli:{...Pe.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ce.getRemoteAuthority)(Ne)});return await It.ready(),ve.open(Ne,it)}return!1}});const Ke=this._register(new et.ActiveWindowManager({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),rt=new n.StaticRouter(Ne=>Ke.getActiveClientId().then(it=>Ne===it)),dt=new oe.URLHandlerRouter(rt),Pt=Se.getChannel("urlHandler",dt);ve.registerHandler(new oe.URLHandlerChannelClient(Pt)),this._register(new me.ElectronURLListener(Oe,ve,ye,this.environmentMainService,this.productService));const Ve=this.environmentMainService.args,ft=global.macOpenFiles,gt=(0,se.isLaunchedFromCli)(process.env)?0:4,mt=Ve._.length,pt=!!Ve["folder-uri"],vt=!!Ve["file-uri"],wt=Ve["skip-add-to-recently-opened"]===!0,ut=Ve.wait&&Ve.waitMarkerFilePath?I.URI.file(Ve.waitMarkerFilePath):void 0,St=Ve.remote||void 0;return Fe.length>0?ye.open({context:gt,cli:Ve,urisToOpen:Fe,gotoLineMode:!0,initialStartup:!0}):Ve["new-window"]&&!mt&&!pt&&!vt?ye.open({context:gt,cli:Ve,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:wt,waitMarkerFileURI:ut,initialStartup:!0,remoteAuthority:St}):ft.length&&!mt&&!pt&&!vt?ye.open({context:1,cli:Ve,urisToOpen:ft.map(Ne=>this.getWindowOpenableFromPathSync(Ne)),noRecentEntry:wt,waitMarkerFileURI:ut,initialStartup:!0}):ye.open({context:gt,cli:Ve,forceNewWindow:Ve["new-window"]||!mt&&Ve["unity-launch"],diffMode:Ve.diff,mergeMode:Ve.merge,noRecentEntry:wt,waitMarkerFileURI:ut,gotoLineMode:Ve.goto,initialStartup:!0,remoteAuthority:St})}shouldBlockURI(we){return!!(we.authority===u.Schemas.file&&w.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,y.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,y.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,y.getPathLabel)(we,{os:w.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(we){if(!!we.path){if(we.authority===u.Schemas.file){const Se=I.URI.file(we.fsPath);return(0,He.hasWorkspaceFileExtension)(Se)?{workspaceUri:Se}:{fileUri:Se}}else if(we.authority===u.Schemas.vscodeRemote){const Se=we.path.indexOf(b.posix.sep,1);if(Se!==-1){const ye=we.path.substring(1,Se),ve=we.path.substring(Se),Me=I.URI.from({scheme:u.Schemas.vscodeRemote,authority:ye,path:ve,query:we.query,fragment:we.fragment});return(0,He.hasWorkspaceFileExtension)(ve)?{workspaceUri:Me}:/:[\d]+$/.test(ve)?{fileUri:Me}:{folderUri:Me}}}}}getWindowOpenableFromPathSync(we){try{if((0,D.statSync)(we).isDirectory())return{folderUri:I.URI.file(we)};if((0,He.hasWorkspaceFileExtension)(we))return{workspaceUri:I.URI.file(we)}}catch{}return{fileUri:I.URI.file(we)}}async afterWindowOpen(we,Se){this.lifecycleMainService.phase=3;let ye=!1;(0,C.once)(this.lifecycleMainService.onWillShutdown)(()=>ye=!0);const ve=we.get(De.ITelemetryService);this._register(Se.onDidError(({type:Oe,details:_e})=>{let Pe;switch(Oe){case 1:Pe="SharedProcess: detected unresponsive window";break;case 2:Pe=`SharedProcess: crashed (detail: ${_e?.reason??"<unknown>"}, code: ${_e?.exitCode??"<unknown>"})`;break;case 3:Pe=`SharedProcess: failed to load (detail: ${_e?.reason??"<unknown>"}, code: ${_e?.exitCode??"<unknown>"})`;break}(0,d.onUnexpectedError)(new Error(Pe)),ve.publicLog2("sharedprocesserror",{type:Oe,reason:_e?.reason,code:_e?.exitCode,visible:Se.isVisible(),shuttingdown:ye})}));const Me=this.productService.win32MutexName;if(w.isWindows&&Me)try{const Oe=z.__$__nodeRequire("windows-mutex").Mutex,_e=new Oe(Me);(0,C.once)(this.lifecycleMainService.onWillShutdown)(()=>_e.release())}catch(Oe){this.logService.error(Oe)}v.protocol.registerHttpProtocol(u.Schemas.vscodeRemoteResource,(Oe,_e)=>{_e({url:Oe.url.replace(/^vscode-remote-resource:/,"http:"),method:Oe.method})});const Fe=we.get(We.IUpdateService);(Fe instanceof je.Win32UpdateService||Fe instanceof Ze.LinuxUpdateService||Fe instanceof Qe.DarwinUpdateService)&&Fe.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const _e=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,k.stripComments)(_e))["enable-crash-reporter"]===void 0){const ze=(0,Be.getTelemetryLevel)(this.configurationService)>=1,Ke=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${ze},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,g.generateUuid)()}"`,"}"],rt=_e.substring(0,_e.length-2).concat(`,
`,Ke.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(rt))}}catch(Oe){this.logService.error(Oe)}}async resolveShellEnvironment(we,Se,ye){try{return await(0,ce.getResolvedShellEnv)(this.logService,we,Se)}catch(ve){const Me=(0,S.toErrorMessage)(ve);ye?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Me):this.logService.error(Me)}return{}}stopTracingEventually(we,Se){this.logService.info("Tracing: waiting for windows to get ready...");const ye=we.get($.IDialogMainService);let ve=!1;const Me=async Oe=>{if(ve)return;ve=!0;const _e=await v.contentTracing.stopRecording(`${(0,p.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Oe?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${_e}`):ye.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,_e),buttons:[(0,y.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,E.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))},Fe=setTimeout(()=>Me(!0),3e4);Promise.all(Se.map(Oe=>Oe.ready())).then(()=>{clearTimeout(Fe),Me(!1)})}};Ct=fe([ee(2,N.IInstantiationService),ee(3,ae.ILogService),ee(4,ie.IEnvironmentMainService),ee(5,Z.ILifecycleMainService),ee(6,f.IConfigurationService),ee(7,ue.IStateMainService),ee(8,G.IFileService),ee(9,Le.IProductService)],Ct),e.CodeApplication=Ct}),define(Y[257],X([0,1,37,8,264,2]),function(z,e,v,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class M extends v.AbstractPolicyService{constructor(d){super();this.productName=d,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(d){await this.throttler.queue(()=>new Promise((p,C)=>{try{this.watcher.value=(0,D.createWatcher)(this.productName,d,k=>{for(const y in k){const m=k[y];m===void 0?this.policies.delete(y):this.policies.set(y,m)}this._onDidChange.fire(Object.keys(k)),p()})}catch(k){C(k)}}))}}e.NativePolicyService=M}),define(Y[258],X([0,1,211,8,17,19,2,13,18,39,106,6,210,265]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let u=class extends M.Disposable{constructor(w,E,I){super();this.environmentService=E,this.logService=I,this.configure(w.getValue()),this._register(w.onDidChangeConfiguration(()=>this.configure(w.getValue()),this))}configure(w){this.proxyUrl=w.http&&w.http.proxy,this.strictSSL=!!(w.http&&w.http.proxyStrictSSL),this.authorization=w.http&&w.http.proxyAuthorization}async request(w,E){this.logService.trace("RequestService#request (node) - begin",w.url);const{proxyUrl:I,strictSSL:g}=this;let h;try{h=await(0,C.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",r))}const l={...process.env,...h},n=w.agent?w.agent:await(0,y.getProxyAgent)(w.url||"",l,{proxyUrl:I,strictSSL:g});w.agent=n,w.strictSSL=g,this.authorization&&(w.headers={...w.headers||{},"Proxy-Authorization":this.authorization});try{const r=await this._request(w,E);return this.logService.trace("RequestService#request (node) - success",w.url),r}catch(r){throw this.logService.trace("RequestService#request (node) - error",w.url,r),r}}async getNodeRequest(w){return((0,v.parse)(w.url).protocol==="https:"?await new Promise((g,h)=>{z(["https"],g,h)}):await new Promise((g,h)=>{z(["http"],g,h)})).request}_request(w,E){return t.Promises.withAsyncBody(async(I,g)=>{const h=(0,v.parse)(w.url),l=w.getRawRequest?w.getRawRequest(w):await this.getNodeRequest(w),n={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:w.type||"GET",headers:w.headers,agent:w.agent,rejectUnauthorized:(0,S.isBoolean)(w.strictSSL)?w.strictSSL:!0};w.user&&w.password&&(n.auth=w.user+":"+w.password);const r=l(n,i=>{const s=(0,S.isNumber)(w.followRedirects)?w.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)this._request({...w,url:i.headers.location,followRedirects:s-1},E).then(I,g);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,m.createGunzip)())),I({res:i,stream:(0,D.streamToBufferReadableStream)(o)})}});r.on("error",g),w.timeout&&r.setTimeout(w.timeout),w.data&&typeof w.data=="string"&&r.write(w.data),r.end(),E.onCancellationRequested(()=>{r.abort(),g((0,R.canceled)())})})}async resolveProxy(w){}};u=fe([ee(0,d.IConfigurationService),ee(1,p.INativeEnvironmentService),ee(2,k.ILogService)],u),e.RequestService=u}),define(Y[259],X([0,1,14,258]),function(z,e,v,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(M){return v.net.request}class R extends t.RequestService{request(S,d){return super.request({...S||{},getRawRequest:D},d)}}e.RequestMainService=R}),define(Y[266],X([0,1,14,27,7,25,8,41,19,29,48,34,12,9,70,4,36,31,23,43,81,256,10,18,205,218,26,56,178,15,193,85,67,190,84,22,103,6,198,104,58,20,59,242,107,224,52,259,86,212,45,216,72,61,63,37,257,200,2,62,229,40,225]),function(z,e,v,t,D,R,M,S,d,p,C,k,y,m,u,b,w,E,I,g,h,l,n,r,i,s,o,a,c,f,P,L,T,W,$,te,re,ie,se,ce,q,ne,O,_,B,Q,H,G,x,A,F,N,j,J,U,K,Z,ae,le,ge,be,Le){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ce{main(){try{this.startup()}catch(ue){console.error(ue.message),v.app.exit(1)}}async startup(){(0,d.setUnexpectedErrorHandler)(We=>console.error(We));const[ue,de,pe,Ie,De,Xe,Te,Be]=this.createServices();try{try{await this.initServices(pe,Be,Ie,De)}catch(We){throw this.handleStartupDataDirError(pe,Te.nameLong,We),We}await ue.invokeFunction(async We=>{const Ye=We.get(ie.ILogService),Qe=We.get(te.ILifecycleMainService),Ze=We.get(f.IFileService),$e=await this.claimInstance(Ye,pe,Qe,ue,Te,!0);return I.Promises.writeFile(pe.mainLockfile,String(process.pid)).catch(je=>{Ye.warn(`Error writing main lockfile: ${je.stack}`)}),Xe.logger=new ce.SpdLogLogger("main",(0,m.join)(pe.logsPath,"main.log"),!0,!1,Xe.getLevel()),(0,C.once)(Qe.onWillShutdown)(je=>{Ze.dispose(),Ie.dispose(),je.join(I.Promises.unlink(pe.mainLockfile).catch(()=>{}))}),ue.createInstance(l.CodeApplication,$e,de).startup()})}catch(We){ue.invokeFunction(this.quit,We)}}createServices(){const ue=new $.ServiceCollection,de=new le.DisposableStore;process.once("exit",()=>de.dispose());const pe={_serviceBrand:void 0,...q.default};ue.set(ne.IProductService,pe);const Ie=new o.EnvironmentMainService(this.resolveArgs(),pe),De=this.patchEnvironment(Ie);ue.set(o.IEnvironmentMainService,Ie);const Xe=new re.BufferLogService,Te=de.add(new ie.MultiplexLogService([new ie.ConsoleMainLogger((0,ie.getLogLevel)(Ie)),Xe]));ue.set(ie.ILogService,Te);const Be=new P.FileService(Te);ue.set(f.IFileService,Be);const We=new L.DiskFileSystemProvider(Te);Be.registerProvider(y.Schemas.file,We);const Ye=new be.UriIdentityService(Be);ue.set(ge.IUriIdentityService,Ye),ue.set(ie.ILoggerService,new se.LoggerService(Te,Be));const Qe=new N.StateMainService(Ie,Te,Be);ue.set(F.IStateMainService,Qe);const Ze=new U.UserDataProfilesMainService(Qe,Ye,Ie,Be,Te);ue.set(U.IUserDataProfilesMainService,Ze);const $e=b.isWindows&&pe.win32RegValueName?de.add(new Z.NativePolicyService(pe.win32RegValueName)):Ie.policyFile?de.add(new ae.FilePolicyService(Ie.policyFile,Be,Te)):new K.NullPolicyService;ue.set(K.IPolicyService,$e);const je=new i.ConfigurationService(Ze.defaultProfile.settingsResource,Be,$e,Te);return ue.set(r.IConfigurationService,je),ue.set(te.ILifecycleMainService,new T.SyncDescriptor(te.LifecycleMainService)),ue.set(H.IRequestService,new T.SyncDescriptor(G.RequestMainService)),ue.set(J.IThemeMainService,new T.SyncDescriptor(J.ThemeMainService)),ue.set(x.ISignService,new T.SyncDescriptor(A.SignService)),ue.set(B.ITunnelService,new T.SyncDescriptor(Q.TunnelService)),ue.set(O.IProtocolMainService,new T.SyncDescriptor(_.ProtocolMainService)),[new W.InstantiationService(ue,!0),De,Ie,je,Qe,Xe,pe,Ze]}patchEnvironment(ue){const de={VSCODE_IPC_HOOK:ue.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(pe=>{const Ie=process.env[pe];typeof Ie=="string"&&(de[pe]=Ie)}),Object.assign(process.env,de),de}async initServices(ue,de,pe,Ie){await M.Promises.settled([Promise.all([ue.extensionsPath,ue.codeCachePath,ue.logsPath,de.defaultProfile.globalStorageHome.fsPath,ue.workspaceStorageHome.fsPath,ue.localHistoryHome.fsPath,ue.backupHome].map(De=>De?I.Promises.mkdir(De,{recursive:!0}):void 0)),Ie.init(),pe.initialize()]),de.setEnablement(!!pe.getValue(Le.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(ue,de,pe,Ie,De,Xe){let Te;try{(0,u.mark)("code/willStartMainServer"),Te=await(0,h.serve)(de.mainIPCHandle),(0,u.mark)("code/didStartMainServer"),(0,C.once)(pe.onWillShutdown)(()=>Te.dispose())}catch(Be){if(Be.code!=="EADDRINUSE")throw this.handleStartupDataDirError(de,De.nameLong,Be),Be;let We;try{We=await(0,h.connect)(de.mainIPCHandle,"main")}catch($e){if(!Xe||b.isWindows||$e.code!=="ECONNREFUSED")throw $e.code==="EPERM"&&this.showStartupWarningDialog((0,n.localize)(0,null,De.nameShort),(0,n.localize)(1,null),De.nameLong),$e;try{(0,t.unlinkSync)(de.mainIPCHandle)}catch(je){throw ue.warn("Could not delete obsolete instance handle",je),je}return this.claimInstance(ue,de,pe,Ie,De,!1)}if(de.extensionTestsLocationURI&&!de.debugExtensionHost.break){const $e="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ue.error($e),We.dispose(),new Error($e)}let Ye;!de.args.wait&&!de.args.status&&(Ye=setTimeout(()=>{this.showStartupWarningDialog((0,n.localize)(2,null,De.nameShort),(0,n.localize)(3,null),De.nameLong)},1e4));const Qe=g.ProxyChannel.toService(We.getChannel("launch"),{disableMarshalling:!0}),Ze=g.ProxyChannel.toService(We.getChannel("diagnostics"),{disableMarshalling:!0});if(de.args.status)return Ie.invokeFunction(async()=>{const $e=new s.DiagnosticsService(j.NullTelemetryService,De),je=await Qe.getMainProcessInfo(),V=await Ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),oe=await $e.getDiagnostics(je,V);throw console.log(oe),new d.ExpectedError});throw b.isWindows&&await this.windowsAllowSetForegroundWindow(Qe,ue),ue.trace("Sending env to running instance..."),await Qe.start(de.args,process.env),We.dispose(),Ye&&clearTimeout(Ye),new d.ExpectedError("Sent env to running instance. Terminating...")}if(de.args.status)throw ue.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new d.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Te}handleStartupDataDirError(ue,de,pe){if(pe.code==="EACCES"||pe.code==="EPERM"){const Ie=(0,R.coalesce)([ue.userDataPath,ue.extensionsPath,h.XDG_RUNTIME_DIR]).map(De=>(0,k.getPathLabel)(D.URI.file(De),{os:b.OS,tildify:ue}));this.showStartupWarningDialog((0,n.localize)(4,null),(0,n.localize)(5,null,(0,S.toErrorMessage)(pe),Ie.join(`
`)),de)}}showStartupWarningDialog(ue,de,pe){v.dialog.showMessageBoxSync({title:pe,type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,n.localize)(6,null))],message:ue,detail:de,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ue,de){if(b.isWindows){const pe=await ue.getMainProcessId();de.trace("Sending some foreground love to the running instance:",pe);try{(await new Promise((Ie,De)=>{z(["windows-foreground-love"],Ie,De)})).allowSetForegroundWindow(pe)}catch(Ie){de.error(Ie)}}}quit(ue,de){const pe=ue.get(ie.ILogService),Ie=ue.get(te.ILifecycleMainService);let De=0;de&&(de.isExpected?de.message&&pe.trace(de.message):(De=1,de.stack?pe.error(de.stack):pe.error(`Startup error: ${de.toString()}`))),Ie.kill(De)}resolveArgs(){const ue=this.validatePaths((0,a.parseMainProcessArgv)(process.argv));if(ue.wait&&!ue.waitMarkerFilePath){const de=(0,c.createWaitMarkerFile)(ue.verbose);de&&((0,a.addArg)(process.argv,"--waitMarkerFilePath",de),ue.waitMarkerFilePath=de)}return ue}validatePaths(ue){if(ue["open-url"]&&(ue._urls=ue._,ue._=[]),!ue.remote){const de=this.doValidatePaths(ue._,ue.goto);ue._=de}return ue}doValidatePaths(ue,de){const pe=(0,w.cwd)(),Ie=ue.map(Te=>{let Be=String(Te),We;de&&(We=(0,p.parseLineAndColumnAware)(Be),Be=We.path),Be&&(Be=this.preparePath(pe,Be));const Ye=(0,p.sanitizeFilePath)(Be,pe),Qe=(0,m.basename)(Ye);return Qe&&!(0,p.isValidBasename)(Qe)?null:de&&We?(We.path=Ye,this.toPath(We)):Ye}),De=b.isWindows||b.isMacintosh,Xe=(0,R.distinct)(Ie,Te=>Te&&De?Te.toLowerCase():Te||"");return(0,R.coalesce)(Xe)}preparePath(ue,de){return b.isWindows&&(de=(0,E.rtrim)(de,'"')),de=(0,E.trim)((0,E.trim)(de," "),"	"),b.isWindows&&(de=(0,m.resolve)(ue,de),de=(0,E.rtrim)(de,".")),de}toPath(ue){const de=[ue.path];return typeof ue.line=="number"&&de.push(String(ue.line)),typeof ue.column=="number"&&de.push(String(ue.column)),de.join(":")}}new Ce().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/92fd228156aafeb326b23f6604028d342152313b/core/vs/code/electron-main/main.js.map
