/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/async","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/base/common/codicons","vs/nls","vs/base/common/errors","vs/base/common/arrays","vs/base/browser/browser","vs/base/common/uri","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/keyboardEvent","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/common/cancellation","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/color","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/objects","vs/base/parts/sandbox/electron-sandbox/globals","vs/platform/instantiation/common/instantiation","vs/base/common/buffer","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/network","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/numbers","vs/base/common/range","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/map","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/list/listWidget","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/toggle/toggle","vs/platform/instantiation/common/descriptors","vs/platform/theme/common/themeService","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/assert","vs/base/common/collections","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],pe=function(Z){for(var t=[],v=0,i=Z.length;v<i;v++)t[v]=me[Z[v]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function Kt(Z){if(Array.isArray(Z)){for(var t=0,v=Array(Z.length);t<Z.length;t++)v[t]=Z[t];return v}else return Array.from(Z)}var qt=Object.hasOwnProperty,Nt=Object.setPrototypeOf,xt=Object.isFrozen,jt=Object.getPrototypeOf,Gt=Object.getOwnPropertyDescriptor,it=Object.freeze,ot=Object.seal,Yt=Object.create,kt=typeof Reflect!="undefined"&&Reflect,wt=kt.apply,_t=kt.construct;wt||(wt=function(t,v,i){return t.apply(v,i)}),it||(it=function(t){return t}),ot||(ot=function(t){return t}),_t||(_t=function(t,v){return new(Function.prototype.bind.apply(t,[null].concat(Kt(v))))});var Xt=nt(Array.prototype.forEach),Pt=nt(Array.prototype.pop),mt=nt(Array.prototype.push),ct=nt(String.prototype.toLowerCase),Rt=nt(String.prototype.match),lt=nt(String.prototype.replace),Zt=nt(String.prototype.indexOf),Qt=nt(String.prototype.trim),at=nt(RegExp.prototype.test),Mt=Jt(TypeError);function nt(Z){return function(t){for(var v=arguments.length,i=Array(v>1?v-1:0),R=1;R<v;R++)i[R-1]=arguments[R];return wt(Z,t,i)}}function Jt(Z){return function(){for(var t=arguments.length,v=Array(t),i=0;i<t;i++)v[i]=arguments[i];return _t(Z,v)}}function Be(Z,t){Nt&&Nt(Z,null);for(var v=t.length;v--;){var i=t[v];if(typeof i=="string"){var R=ct(i);R!==i&&(xt(t)||(t[v]=R),i=R)}Z[i]=!0}return Z}function ht(Z){var t=Yt(null),v=void 0;for(v in Z)wt(qt,Z,[v])&&(t[v]=Z[v]);return t}function vt(Z,t){for(;Z!==null;){var v=Gt(Z,t);if(v){if(v.get)return nt(v.get);if(typeof v.value=="function")return nt(v.value)}Z=jt(Z)}function i(R){return console.warn("fallback value for",R),null}return i}var Ot=it(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Ct=it(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),St=it(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ei=it(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),At=it(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),ti=it(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Bt=it(["#text"]),Ht=it(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Tt=it(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Wt=it(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Dt=it(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ii=ot(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ni=ot(/<%[\s\S]*|[\s\S]*%>/gm),si=ot(/^data-[\-\w.\u00B7-\uFFFF]/),ri=ot(/^aria-[\-\w]+$/),oi=ot(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),ai=ot(/^(?:\w+script|data):/i),li=ot(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),pt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(Z){return typeof Z}:function(Z){return Z&&typeof Symbol=="function"&&Z.constructor===Symbol&&Z!==Symbol.prototype?"symbol":typeof Z};function rt(Z){if(Array.isArray(Z)){for(var t=0,v=Array(Z.length);t<Z.length;t++)v[t]=Z[t];return v}else return Array.from(Z)}var ui=function(){return typeof window=="undefined"?null:window},ci=function(t,v){if((typeof t=="undefined"?"undefined":pt(t))!=="object"||typeof t.createPolicy!="function")return null;var i=null,R="data-tt-policy-suffix";v.currentScript&&v.currentScript.hasAttribute(R)&&(i=v.currentScript.getAttribute(R));var M="dompurify"+(i?"#"+i:"");try{return t.createPolicy(M,{createHTML:function(w){return w}})}catch{return console.warn("TrustedTypes policy "+M+" could not be created."),null}};function zt(){var Z=arguments.length>0&&arguments[0]!==void 0?arguments[0]:ui(),t=function(ue){return zt(ue)};if(t.version="2.3.1",t.removed=[],!Z||!Z.document||Z.document.nodeType!==9)return t.isSupported=!1,t;var v=Z.document,i=Z.document,R=Z.DocumentFragment,M=Z.HTMLTemplateElement,y=Z.Node,w=Z.Element,m=Z.NodeFilter,f=Z.NamedNodeMap,b=f===void 0?Z.NamedNodeMap||Z.MozNamedAttrMap:f,F=Z.Text,a=Z.Comment,n=Z.DOMParser,e=Z.trustedTypes,d=w.prototype,p=vt(d,"cloneNode"),_=vt(d,"nextSibling"),E=vt(d,"childNodes"),u=vt(d,"parentNode");if(typeof M=="function"){var g=i.createElement("template");g.content&&g.content.ownerDocument&&(i=g.content.ownerDocument)}var D=ci(e,v),A=D&&W?D.createHTML(""):"",N=i,T=N.implementation,s=N.createNodeIterator,l=N.createDocumentFragment,o=N.getElementsByTagName,r=v.importNode,c={};try{c=ht(i).documentMode?i.documentMode:{}}catch{}var C={};t.isSupported=typeof u=="function"&&T&&typeof T.createHTMLDocument!="undefined"&&c!==9;var V=ii,se=ni,ie=si,ae=ri,ne=ai,we=li,de=oi,ge=null,ye=Be({},[].concat(rt(Ot),rt(Ct),rt(St),rt(At),rt(Bt))),J=null,De=Be({},[].concat(rt(Ht),rt(Tt),rt(Wt),rt(Dt))),re=null,te=null,le=!0,Q=!0,S=!1,K=!1,G=!1,k=!1,h=!1,L=!1,U=!1,q=!0,W=!1,O=!0,H=!0,$=!1,I={},z=null,P=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),B=null,j=Be({},["audio","video","img","source","image","track"]),ee=null,he=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),fe="http://www.w3.org/1998/Math/MathML",Ee="http://www.w3.org/2000/svg",_e="http://www.w3.org/1999/xhtml",ke=_e,Ie=!1,ve=null,Pe=i.createElement("form"),Me=function(ue){ve&&ve===ue||((!ue||(typeof ue=="undefined"?"undefined":pt(ue))!=="object")&&(ue={}),ue=ht(ue),ge="ALLOWED_TAGS"in ue?Be({},ue.ALLOWED_TAGS):ye,J="ALLOWED_ATTR"in ue?Be({},ue.ALLOWED_ATTR):De,ee="ADD_URI_SAFE_ATTR"in ue?Be(ht(he),ue.ADD_URI_SAFE_ATTR):he,B="ADD_DATA_URI_TAGS"in ue?Be(ht(j),ue.ADD_DATA_URI_TAGS):j,z="FORBID_CONTENTS"in ue?Be({},ue.FORBID_CONTENTS):P,re="FORBID_TAGS"in ue?Be({},ue.FORBID_TAGS):{},te="FORBID_ATTR"in ue?Be({},ue.FORBID_ATTR):{},I="USE_PROFILES"in ue?ue.USE_PROFILES:!1,le=ue.ALLOW_ARIA_ATTR!==!1,Q=ue.ALLOW_DATA_ATTR!==!1,S=ue.ALLOW_UNKNOWN_PROTOCOLS||!1,K=ue.SAFE_FOR_TEMPLATES||!1,G=ue.WHOLE_DOCUMENT||!1,L=ue.RETURN_DOM||!1,U=ue.RETURN_DOM_FRAGMENT||!1,q=ue.RETURN_DOM_IMPORT!==!1,W=ue.RETURN_TRUSTED_TYPE||!1,h=ue.FORCE_BODY||!1,O=ue.SANITIZE_DOM!==!1,H=ue.KEEP_CONTENT!==!1,$=ue.IN_PLACE||!1,de=ue.ALLOWED_URI_REGEXP||de,ke=ue.NAMESPACE||_e,K&&(Q=!1),U&&(L=!0),I&&(ge=Be({},[].concat(rt(Bt))),J=[],I.html===!0&&(Be(ge,Ot),Be(J,Ht)),I.svg===!0&&(Be(ge,Ct),Be(J,Tt),Be(J,Dt)),I.svgFilters===!0&&(Be(ge,St),Be(J,Tt),Be(J,Dt)),I.mathMl===!0&&(Be(ge,At),Be(J,Wt),Be(J,Dt))),ue.ADD_TAGS&&(ge===ye&&(ge=ht(ge)),Be(ge,ue.ADD_TAGS)),ue.ADD_ATTR&&(J===De&&(J=ht(J)),Be(J,ue.ADD_ATTR)),ue.ADD_URI_SAFE_ATTR&&Be(ee,ue.ADD_URI_SAFE_ATTR),ue.FORBID_CONTENTS&&(z===P&&(z=ht(z)),Be(z,ue.FORBID_CONTENTS)),H&&(ge["#text"]=!0),G&&Be(ge,["html","head","body"]),ge.table&&(Be(ge,["tbody"]),delete re.tbody),it&&it(ue),ve=ue)},Ge=Be({},["mi","mo","mn","ms","mtext"]),He=Be({},["foreignobject","desc","title","annotation-xml"]),Ue=Be({},Ct);Be(Ue,St),Be(Ue,ei);var Je=Be({},At);Be(Je,ti);var je=function(ue){var Se=u(ue);(!Se||!Se.tagName)&&(Se={namespaceURI:_e,tagName:"template"});var Ne=ct(ue.tagName),$e=ct(Se.tagName);if(ue.namespaceURI===Ee)return Se.namespaceURI===_e?Ne==="svg":Se.namespaceURI===fe?Ne==="svg"&&($e==="annotation-xml"||Ge[$e]):Boolean(Ue[Ne]);if(ue.namespaceURI===fe)return Se.namespaceURI===_e?Ne==="math":Se.namespaceURI===Ee?Ne==="math"&&He[$e]:Boolean(Je[Ne]);if(ue.namespaceURI===_e){if(Se.namespaceURI===Ee&&!He[$e]||Se.namespaceURI===fe&&!Ge[$e])return!1;var Xe=Be({},["title","style","font","a","script"]);return!Je[Ne]&&(Xe[Ne]||!Ue[Ne])}return!1},Oe=function(ue){mt(t.removed,{element:ue});try{ue.parentNode.removeChild(ue)}catch{try{ue.outerHTML=A}catch{ue.remove()}}},x=function(ue,Se){try{mt(t.removed,{attribute:Se.getAttributeNode(ue),from:Se})}catch{mt(t.removed,{attribute:null,from:Se})}if(Se.removeAttribute(ue),ue==="is"&&!J[ue])if(L||U)try{Oe(Se)}catch{}else try{Se.setAttribute(ue,"")}catch{}},oe=function(ue){var Se=void 0,Ne=void 0;if(h)ue="<remove></remove>"+ue;else{var $e=Rt(ue,/^[\r\n\t ]+/);Ne=$e&&$e[0]}var Xe=D?D.createHTML(ue):ue;if(ke===_e)try{Se=new n().parseFromString(Xe,"text/html")}catch{}if(!Se||!Se.documentElement){Se=T.createDocument(ke,"template",null);try{Se.documentElement.innerHTML=Ie?"":Xe}catch{}}var Ze=Se.body||Se.documentElement;return ue&&Ne&&Ze.insertBefore(i.createTextNode(Ne),Ze.childNodes[0]||null),ke===_e?o.call(Se,G?"html":"body")[0]:G?Se.documentElement:Ze},be=function(ue){return s.call(ue.ownerDocument||ue,ue,m.SHOW_ELEMENT|m.SHOW_COMMENT|m.SHOW_TEXT,null,!1)},Ce=function(ue){return ue instanceof F||ue instanceof a?!1:typeof ue.nodeName!="string"||typeof ue.textContent!="string"||typeof ue.removeChild!="function"||!(ue.attributes instanceof b)||typeof ue.removeAttribute!="function"||typeof ue.setAttribute!="function"||typeof ue.namespaceURI!="string"||typeof ue.insertBefore!="function"},Fe=function(ue){return(typeof y=="undefined"?"undefined":pt(y))==="object"?ue instanceof y:ue&&(typeof ue=="undefined"?"undefined":pt(ue))==="object"&&typeof ue.nodeType=="number"&&typeof ue.nodeName=="string"},Re=function(ue,Se,Ne){!C[ue]||Xt(C[ue],function($e){$e.call(t,Se,Ne,ve)})},Ve=function(ue){var Se=void 0;if(Re("beforeSanitizeElements",ue,null),Ce(ue)||Rt(ue.nodeName,/[\u0080-\uFFFF]/))return Oe(ue),!0;var Ne=ct(ue.nodeName);if(Re("uponSanitizeElement",ue,{tagName:Ne,allowedTags:ge}),!Fe(ue.firstElementChild)&&(!Fe(ue.content)||!Fe(ue.content.firstElementChild))&&at(/<[/\w]/g,ue.innerHTML)&&at(/<[/\w]/g,ue.textContent)||Ne==="select"&&at(/<template/i,ue.innerHTML))return Oe(ue),!0;if(!ge[Ne]||re[Ne]){if(H&&!z[Ne]){var $e=u(ue)||ue.parentNode,Xe=E(ue)||ue.childNodes;if(Xe&&$e)for(var Ze=Xe.length,et=Ze-1;et>=0;--et)$e.insertBefore(p(Xe[et],!0),_(ue))}return Oe(ue),!0}return ue instanceof w&&!je(ue)||(Ne==="noscript"||Ne==="noembed")&&at(/<\/no(script|embed)/i,ue.innerHTML)?(Oe(ue),!0):(K&&ue.nodeType===3&&(Se=ue.textContent,Se=lt(Se,V," "),Se=lt(Se,se," "),ue.textContent!==Se&&(mt(t.removed,{element:ue.cloneNode()}),ue.textContent=Se)),Re("afterSanitizeElements",ue,null),!1)},tt=function(ue,Se,Ne){if(O&&(Se==="id"||Se==="name")&&(Ne in i||Ne in Pe))return!1;if(!(Q&&!te[Se]&&at(ie,Se))){if(!(le&&at(ae,Se))){if(!J[Se]||te[Se])return!1;if(!ee[Se]){if(!at(de,lt(Ne,we,""))){if(!((Se==="src"||Se==="xlink:href"||Se==="href")&&ue!=="script"&&Zt(Ne,"data:")===0&&B[ue])){if(!(S&&!at(ne,lt(Ne,we,"")))){if(Ne)return!1}}}}}}return!0},Ye=function(ue){var Se=void 0,Ne=void 0,$e=void 0,Xe=void 0;Re("beforeSanitizeAttributes",ue,null);var Ze=ue.attributes;if(!!Ze){var et={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:J};for(Xe=Ze.length;Xe--;){Se=Ze[Xe];var st=Se,dt=st.name,yt=st.namespaceURI;if(Ne=Qt(Se.value),$e=ct(dt),et.attrName=$e,et.attrValue=Ne,et.keepAttr=!0,et.forceKeepAttr=void 0,Re("uponSanitizeAttribute",ue,et),Ne=et.attrValue,!et.forceKeepAttr&&(x(dt,ue),!!et.keepAttr)){if(at(/\/>/i,Ne)){x(dt,ue);continue}K&&(Ne=lt(Ne,V," "),Ne=lt(Ne,se," "));var It=ue.nodeName.toLowerCase();if(!!tt(It,$e,Ne))try{yt?ue.setAttributeNS(yt,dt,Ne):ue.setAttribute(dt,Ne),Pt(t.removed)}catch{}}}Re("afterSanitizeAttributes",ue,null)}},qe=function Le(ue){var Se=void 0,Ne=be(ue);for(Re("beforeSanitizeShadowDOM",ue,null);Se=Ne.nextNode();)Re("uponSanitizeShadowNode",Se,null),!Ve(Se)&&(Se.content instanceof R&&Le(Se.content),Ye(Se));Re("afterSanitizeShadowDOM",ue,null)};return t.sanitize=function(Le,ue){var Se=void 0,Ne=void 0,$e=void 0,Xe=void 0,Ze=void 0;if(Ie=!Le,Ie&&(Le="<!-->"),typeof Le!="string"&&!Fe(Le)){if(typeof Le.toString!="function")throw Mt("toString is not a function");if(Le=Le.toString(),typeof Le!="string")throw Mt("dirty is not a string, aborting")}if(!t.isSupported){if(pt(Z.toStaticHTML)==="object"||typeof Z.toStaticHTML=="function"){if(typeof Le=="string")return Z.toStaticHTML(Le);if(Fe(Le))return Z.toStaticHTML(Le.outerHTML)}return Le}if(k||Me(ue),t.removed=[],typeof Le=="string"&&($=!1),!$)if(Le instanceof y)Se=oe("<!---->"),Ne=Se.ownerDocument.importNode(Le,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?Se=Ne:Se.appendChild(Ne);else{if(!L&&!K&&!G&&Le.indexOf("<")===-1)return D&&W?D.createHTML(Le):Le;if(Se=oe(Le),!Se)return L?null:A}Se&&h&&Oe(Se.firstChild);for(var et=be($?Le:Se);$e=et.nextNode();)$e.nodeType===3&&$e===Xe||Ve($e)||($e.content instanceof R&&qe($e.content),Ye($e),Xe=$e);if(Xe=null,$)return Le;if(L){if(U)for(Ze=l.call(Se.ownerDocument);Se.firstChild;)Ze.appendChild(Se.firstChild);else Ze=Se;return q&&(Ze=r.call(v,Ze,!0)),Ze}var st=G?Se.outerHTML:Se.innerHTML;return K&&(st=lt(st,V," "),st=lt(st,se," ")),D&&W?D.createHTML(st):st},t.setConfig=function(Le){Me(Le),k=!0},t.clearConfig=function(){ve=null,k=!1},t.isValidAttribute=function(Le,ue,Se){ve||Me({});var Ne=ct(Le),$e=ct(ue);return tt(Ne,$e,Se)},t.addHook=function(Le,ue){typeof ue=="function"&&(C[Le]=C[Le]||[],mt(C[Le],ue))},t.removeHook=function(Le){C[Le]&&Pt(C[Le])},t.removeHooks=function(Le){C[Le]&&(C[Le]=[])},t.removeAllHooks=function(){C={}},t}var hi=zt();define("vs/base/browser/dompurify/dompurify",function(){return hi}),define(me[40],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class v{constructor(y){this.domNode=y,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(y){const w=i(y);this._maxWidth!==w&&(this._maxWidth=w,this.domNode.style.maxWidth=this._maxWidth)}setWidth(y){const w=i(y);this._width!==w&&(this._width=w,this.domNode.style.width=this._width)}setHeight(y){const w=i(y);this._height!==w&&(this._height=w,this.domNode.style.height=this._height)}setTop(y){const w=i(y);this._top!==w&&(this._top=w,this.domNode.style.top=this._top)}setLeft(y){const w=i(y);this._left!==w&&(this._left=w,this.domNode.style.left=this._left)}setBottom(y){const w=i(y);this._bottom!==w&&(this._bottom=w,this.domNode.style.bottom=this._bottom)}setRight(y){const w=i(y);this._right!==w&&(this._right=w,this.domNode.style.right=this._right)}setFontFamily(y){this._fontFamily!==y&&(this._fontFamily=y,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(y){this._fontWeight!==y&&(this._fontWeight=y,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(y){const w=i(y);this._fontSize!==w&&(this._fontSize=w,this.domNode.style.fontSize=this._fontSize)}setFontStyle(y){this._fontStyle!==y&&(this._fontStyle=y,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(y){this._fontFeatureSettings!==y&&(this._fontFeatureSettings=y,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setTextDecoration(y){this._textDecoration!==y&&(this._textDecoration=y,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(y){const w=i(y);this._lineHeight!==w&&(this._lineHeight=w,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(y){const w=i(y);this._letterSpacing!==w&&(this._letterSpacing=w,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(y){this._className!==y&&(this._className=y,this.domNode.className=this._className)}toggleClassName(y,w){this.domNode.classList.toggle(y,w),this._className=this.domNode.className}setDisplay(y){this._display!==y&&(this._display=y,this.domNode.style.display=this._display)}setPosition(y){this._position!==y&&(this._position=y,this.domNode.style.position=this._position)}setVisibility(y){this._visibility!==y&&(this._visibility=y,this.domNode.style.visibility=this._visibility)}setColor(y){this._color!==y&&(this._color=y,this.domNode.style.color=this._color)}setBackgroundColor(y){this._backgroundColor!==y&&(this._backgroundColor=y,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(y){this._layerHint!==y&&(this._layerHint=y,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(y){this._boxShadow!==y&&(this._boxShadow=y,this.domNode.style.boxShadow=y)}setContain(y){this._contain!==y&&(this._contain=y,this.domNode.style.contain=this._contain)}setAttribute(y,w){this.domNode.setAttribute(y,w)}removeAttribute(y){this.domNode.removeAttribute(y)}appendChild(y){this.domNode.appendChild(y.domNode)}removeChild(y){this.domNode.removeChild(y.domNode)}}t.FastDomNode=v;function i(M){return typeof M=="number"?`${M}px`:M}function R(M){return new v(M)}t.createFastDomNode=R}),define(me[65],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let v=!1,i=null;function R(y){if(!y.parent||y.parent===y)return null;try{const w=y.location,m=y.parent.location;if(w.origin!=="null"&&m.origin!=="null"&&w.origin!==m.origin)return v=!0,null}catch{return v=!0,null}return y.parent}class M{static getSameOriginWindowChain(){if(!i){i=[];let w=window,m;do m=R(w),m?i.push({window:w,iframeElement:w.frameElement||null}):i.push({window:w,iframeElement:null}),w=m;while(w)}return i.slice(0)}static hasDifferentOriginAncestor(){return i||this.getSameOriginWindowChain(),v}static getPositionOfChildWindowRelativeToAncestorWindow(w,m){if(!m||w===m)return{top:0,left:0};let f=0,b=0;const F=this.getSameOriginWindowChain();for(const a of F){if(f+=a.window.scrollY,b+=a.window.scrollX,a.window===m||!a.iframeElement)break;const n=a.iframeElement.getBoundingClientRect();f+=n.top,b+=n.left}return{top:f,left:b}}}t.IframeUtils=M}),define(me[66],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var v;(function(M){M[M.Copy=0]="Copy",M[M.Move=1]="Move"})(v=t.ListDragOverEffect||(t.ListDragOverEffect={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class i extends Error{constructor(y,w){super(`ListError [${y}] ${w}`)}}t.ListError=i;class R{constructor(){this.cache=new WeakMap}getHeight(y){return this.cache.get(y)??this.estimateHeight(y)}setDynamicHeight(y,w){w>0&&this.cache.set(y,w)}}t.CachedListVirtualDelegate=R}),define(me[67],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class v{constructor(R){this.spliceables=R}splice(R,M,y){this.spliceables.forEach(w=>w.splice(R,M,y))}}t.CombinedSpliceable=v}),define(me[41],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const v=20;class i{constructor(M,y,w,m,f,b){this._scrollbarSize=Math.round(y),this._oppositeScrollbarSize=Math.round(w),this._arrowSize=Math.round(M),this._visibleSize=m,this._scrollSize=f,this._scrollPosition=b,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new i(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(M){const y=Math.round(M);return this._visibleSize!==y?(this._visibleSize=y,this._refreshComputedValues(),!0):!1}setScrollSize(M){const y=Math.round(M);return this._scrollSize!==y?(this._scrollSize=y,this._refreshComputedValues(),!0):!1}setScrollPosition(M){const y=Math.round(M);return this._scrollPosition!==y?(this._scrollPosition=y,this._refreshComputedValues(),!0):!1}setScrollbarSize(M){this._scrollbarSize=Math.round(M)}setOppositeScrollbarSize(M){this._oppositeScrollbarSize=Math.round(M)}static _computeValues(M,y,w,m,f){const b=Math.max(0,w-M),F=Math.max(0,b-2*y),a=m>0&&m>w;if(!a)return{computedAvailableSize:Math.round(b),computedIsNeeded:a,computedSliderSize:Math.round(F),computedSliderRatio:0,computedSliderPosition:0};const n=Math.round(Math.max(v,Math.floor(w*F/m))),e=(F-n)/(m-w),d=f*e;return{computedAvailableSize:Math.round(b),computedIsNeeded:a,computedSliderSize:Math.round(n),computedSliderRatio:e,computedSliderPosition:Math.round(d)}}_refreshComputedValues(){const M=i._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=M.computedAvailableSize,this._computedIsNeeded=M.computedIsNeeded,this._computedSliderSize=M.computedSliderSize,this._computedSliderRatio=M.computedSliderRatio,this._computedSliderPosition=M.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(M){if(!this._computedIsNeeded)return 0;const y=M-this._arrowSize-this._computedSliderSize/2;return Math.round(y/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(M){if(!this._computedIsNeeded)return 0;const y=M-this._arrowSize;let w=this._scrollPosition;return y<this._computedSliderPosition?w-=this._visibleSize:w+=this._visibleSize,w}getDesiredScrollPositionFromDelta(M){if(!this._computedIsNeeded)return 0;const y=this._computedSliderPosition+M;return Math.round(y/this._computedSliderRatio)}}t.ScrollbarState=i}),define(me[24],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.TreeVisibility=void 0;var v;(function(w){w[w.Hidden=0]="Hidden",w[w.Visible=1]="Visible",w[w.Recurse=2]="Recurse"})(v=t.TreeVisibility||(t.TreeVisibility={}));var i;(function(w){w[w.Unknown=0]="Unknown",w[w.Twistie=1]="Twistie",w[w.Element=2]="Element",w[w.Filter=3]="Filter"})(i=t.TreeMouseEventTarget||(t.TreeMouseEventTarget={}));var R;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(R=t.TreeDragOverBubble||(t.TreeDragOverBubble={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(w=!1){return{accept:!0,bubble:0,autoExpand:w}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(w=!1){return{accept:!0,bubble:0,effect:0,autoExpand:w}}};class M extends Error{constructor(m,f){super(`TreeError [${m}] ${f}`)}}t.TreeError=M;class y{constructor(m){this.fn=m,this._map=new WeakMap}map(m){let f=this._map.get(m);return f||(f=this.fn(m),this._map.set(m,f)),f}}t.WeakMapper=y}),define(me[68],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function v(i,R){if(!i)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}t.ok=v}),define(me[11],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CSSIcon=t.getClassNamesArray=t.Codicon=t.getCodiconAriaLabel=void 0;function v(y){return y?y.replace(/\$\((.*?)\)/g,(w,m)=>` ${m} `).trim():""}t.getCodiconAriaLabel=v;class i{constructor(w,m,f){this.id=w,this.definition=m,this.description=f,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}t.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function R(y,w){const m=["codicon","codicon-"+y];return w&&m.push("codicon-modifier-"+w),m}t.getClassNamesArray=R;var M;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function m(F){if(F instanceof i)return["codicon","codicon-"+F.id];const a=w.exec(F.id);if(!a)return m(i.error);const[,n,e]=a,d=["codicon","codicon-"+n];return e&&d.push("codicon-modifier-"+e.substr(1)),d}y.asClassNameArray=m;function f(F){return m(F).join(" ")}y.asClassName=f;function b(F){return"."+m(F).join(".")}y.asCSSSelector=b})(M=t.CSSIcon||(t.CSSIcon={}))}),define(me[69],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function v(y,w){const m=Object.create(null);for(const f of y){const b=w(f);let F=m[b];F||(F=m[b]=[]),F.push(f)}return m}t.groupBy=v;function i(y,w){const m=[],f=[];for(const b of y)w.has(b)||m.push(b);for(const b of w)y.has(b)||f.push(b);return{removed:m,added:f}}t.diffSets=i;function R(y,w){const m=[],f=[];for(const[b,F]of y)w.has(b)||m.push(F);for(const[b,F]of w)y.has(b)||f.push(F);return{removed:m,added:f}}t.diffMaps=R;class M{constructor(){this.map=new Map}add(w,m){let f=this.map.get(w);f||(f=new Set,this.map.set(w,f)),f.add(m)}delete(w,m){const f=this.map.get(w);!f||(f.delete(m),f.size===0&&this.map.delete(w))}forEach(w,m){const f=this.map.get(w);!f||f.forEach(m)}}t.SetMap=M}),define(me[25],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function v(w,m){const f=Math.pow(10,m);return Math.round(w*f)/f}class i{constructor(m,f,b,F=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,m))|0,this.g=Math.min(255,Math.max(0,f))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=v(Math.max(Math.min(1,F),0),3)}static equals(m,f){return m.r===f.r&&m.g===f.g&&m.b===f.b&&m.a===f.a}}t.RGBA=i;class R{constructor(m,f,b,F){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=v(Math.max(Math.min(1,f),0),3),this.l=v(Math.max(Math.min(1,b),0),3),this.a=v(Math.max(Math.min(1,F),0),3)}static equals(m,f){return m.h===f.h&&m.s===f.s&&m.l===f.l&&m.a===f.a}static fromRGBA(m){const f=m.r/255,b=m.g/255,F=m.b/255,a=m.a,n=Math.max(f,b,F),e=Math.min(f,b,F);let d=0,p=0;const _=(e+n)/2,E=n-e;if(E>0){switch(p=Math.min(_<=.5?E/(2*_):E/(2-2*_),1),n){case f:d=(b-F)/E+(b<F?6:0);break;case b:d=(F-f)/E+2;break;case F:d=(f-b)/E+4;break}d*=60,d=Math.round(d)}return new R(d,p,_,a)}static _hue2rgb(m,f,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?m+(f-m)*6*b:b<1/2?f:b<2/3?m+(f-m)*(2/3-b)*6:m}static toRGBA(m){const f=m.h/360,{s:b,l:F,a}=m;let n,e,d;if(b===0)n=e=d=F;else{const p=F<.5?F*(1+b):F+b-F*b,_=2*F-p;n=R._hue2rgb(_,p,f+1/3),e=R._hue2rgb(_,p,f),d=R._hue2rgb(_,p,f-1/3)}return new i(Math.round(n*255),Math.round(e*255),Math.round(d*255),a)}}t.HSLA=R;class M{constructor(m,f,b,F){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=v(Math.max(Math.min(1,f),0),3),this.v=v(Math.max(Math.min(1,b),0),3),this.a=v(Math.max(Math.min(1,F),0),3)}static equals(m,f){return m.h===f.h&&m.s===f.s&&m.v===f.v&&m.a===f.a}static fromRGBA(m){const f=m.r/255,b=m.g/255,F=m.b/255,a=Math.max(f,b,F),n=Math.min(f,b,F),e=a-n,d=a===0?0:e/a;let p;return e===0?p=0:a===f?p=((b-F)/e%6+6)%6:a===b?p=(F-f)/e+2:p=(f-b)/e+4,new M(Math.round(p*60),d,a,m.a)}static toRGBA(m){const{h:f,s:b,v:F,a}=m,n=F*b,e=n*(1-Math.abs(f/60%2-1)),d=F-n;let[p,_,E]=[0,0,0];return f<60?(p=n,_=e):f<120?(p=e,_=n):f<180?(_=n,E=e):f<240?(_=e,E=n):f<300?(p=e,E=n):f<=360&&(p=n,E=e),p=Math.round((p+d)*255),_=Math.round((_+d)*255),E=Math.round((E+d)*255),new i(p,_,E,a)}}t.HSVA=M;class y{constructor(m){if(m)if(m instanceof i)this.rgba=m;else if(m instanceof R)this._hsla=m,this.rgba=R.toRGBA(m);else if(m instanceof M)this._hsva=m,this.rgba=M.toRGBA(m);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(m){return y.Format.CSS.parseHex(m)||y.red}get hsla(){return this._hsla?this._hsla:R.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:M.fromRGBA(this.rgba)}equals(m){return!!m&&i.equals(this.rgba,m.rgba)&&R.equals(this.hsla,m.hsla)&&M.equals(this.hsva,m.hsva)}getRelativeLuminance(){const m=y._relativeLuminanceForComponent(this.rgba.r),f=y._relativeLuminanceForComponent(this.rgba.g),b=y._relativeLuminanceForComponent(this.rgba.b),F=.2126*m+.7152*f+.0722*b;return v(F,4)}static _relativeLuminanceForComponent(m){const f=m/255;return f<=.03928?f/12.92:Math.pow((f+.055)/1.055,2.4)}getContrastRatio(m){const f=this.getRelativeLuminance(),b=m.getRelativeLuminance();return f>b?(f+.05)/(b+.05):(b+.05)/(f+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(m){const f=this.getRelativeLuminance(),b=m.getRelativeLuminance();return f>b}isDarkerThan(m){const f=this.getRelativeLuminance(),b=m.getRelativeLuminance();return f<b}lighten(m){return new y(new R(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*m,this.hsla.a))}darken(m){return new y(new R(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*m,this.hsla.a))}transparent(m){const{r:f,g:b,b:F,a}=this.rgba;return new y(new i(f,b,F,a*m))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new y(new i(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(m){const f=m.rgba,b=this.rgba.a,F=f.a,a=b+F*(1-b);if(a<1e-6)return y.transparent;const n=this.rgba.r*b/a+f.r*F*(1-b)/a,e=this.rgba.g*b/a+f.g*F*(1-b)/a,d=this.rgba.b*b/a+f.b*F*(1-b)/a;return new y(new i(n,e,d,a))}makeOpaque(m){if(this.isOpaque()||m.rgba.a!==1)return this;const{r:f,g:b,b:F,a}=this.rgba;return new y(new i(m.rgba.r-a*(m.rgba.r-f),m.rgba.g-a*(m.rgba.g-b),m.rgba.b-a*(m.rgba.b-F),1))}flatten(...m){const f=m.reduceRight((b,F)=>y._flatten(F,b));return y._flatten(this,f)}static _flatten(m,f){const b=1-m.rgba.a;return new y(new i(b*f.rgba.r+m.rgba.a*m.rgba.r,b*f.rgba.g+m.rgba.a*m.rgba.g,b*f.rgba.b+m.rgba.a*m.rgba.b))}toString(){return this._toString||(this._toString=y.Format.CSS.format(this)),this._toString}static getLighterColor(m,f,b){if(m.isLighterThan(f))return m;b=b||.5;const F=m.getRelativeLuminance(),a=f.getRelativeLuminance();return b=b*(a-F)/a,m.lighten(b)}static getDarkerColor(m,f,b){if(m.isDarkerThan(f))return m;b=b||.5;const F=m.getRelativeLuminance(),a=f.getRelativeLuminance();return b=b*(F-a)/F,m.darken(b)}}t.Color=y,y.white=new y(new i(255,255,255,1)),y.black=new y(new i(0,0,0,1)),y.red=new y(new i(255,0,0,1)),y.blue=new y(new i(0,0,255,1)),y.green=new y(new i(0,255,0,1)),y.cyan=new y(new i(0,255,255,1)),y.lightgrey=new y(new i(211,211,211,1)),y.transparent=new y(new i(0,0,0,0)),function(w){let m;(function(f){let b;(function(F){function a(A){return A.rgba.a===1?`rgb(${A.rgba.r}, ${A.rgba.g}, ${A.rgba.b})`:w.Format.CSS.formatRGBA(A)}F.formatRGB=a;function n(A){return`rgba(${A.rgba.r}, ${A.rgba.g}, ${A.rgba.b}, ${+A.rgba.a.toFixed(2)})`}F.formatRGBA=n;function e(A){return A.hsla.a===1?`hsl(${A.hsla.h}, ${(A.hsla.s*100).toFixed(2)}%, ${(A.hsla.l*100).toFixed(2)}%)`:w.Format.CSS.formatHSLA(A)}F.formatHSL=e;function d(A){return`hsla(${A.hsla.h}, ${(A.hsla.s*100).toFixed(2)}%, ${(A.hsla.l*100).toFixed(2)}%, ${A.hsla.a.toFixed(2)})`}F.formatHSLA=d;function p(A){const N=A.toString(16);return N.length!==2?"0"+N:N}function _(A){return`#${p(A.rgba.r)}${p(A.rgba.g)}${p(A.rgba.b)}`}F.formatHex=_;function E(A,N=!1){return N&&A.rgba.a===1?w.Format.CSS.formatHex(A):`#${p(A.rgba.r)}${p(A.rgba.g)}${p(A.rgba.b)}${p(Math.round(A.rgba.a*255))}`}F.formatHexA=E;function u(A){return A.isOpaque()?w.Format.CSS.formatHex(A):w.Format.CSS.formatRGBA(A)}F.format=u;function g(A){const N=A.length;if(N===0||A.charCodeAt(0)!==35)return null;if(N===7){const T=16*D(A.charCodeAt(1))+D(A.charCodeAt(2)),s=16*D(A.charCodeAt(3))+D(A.charCodeAt(4)),l=16*D(A.charCodeAt(5))+D(A.charCodeAt(6));return new w(new i(T,s,l,1))}if(N===9){const T=16*D(A.charCodeAt(1))+D(A.charCodeAt(2)),s=16*D(A.charCodeAt(3))+D(A.charCodeAt(4)),l=16*D(A.charCodeAt(5))+D(A.charCodeAt(6)),o=16*D(A.charCodeAt(7))+D(A.charCodeAt(8));return new w(new i(T,s,l,o/255))}if(N===4){const T=D(A.charCodeAt(1)),s=D(A.charCodeAt(2)),l=D(A.charCodeAt(3));return new w(new i(16*T+T,16*s+s,16*l+l))}if(N===5){const T=D(A.charCodeAt(1)),s=D(A.charCodeAt(2)),l=D(A.charCodeAt(3)),o=D(A.charCodeAt(4));return new w(new i(16*T+T,16*s+s,16*l+l,(16*o+o)/255))}return null}F.parseHex=g;function D(A){switch(A){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=f.CSS||(f.CSS={}))})(m=w.Format||(w.Format={}))}(y=t.Color||(t.Color={}))}),define(me[26],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function v(y){return(w,m,f)=>{let b=null,F=null;if(typeof f.value=="function"?(b="value",F=f.value):typeof f.get=="function"&&(b="get",F=f.get),!F)throw new Error("not supported");f[b]=y(F,m)}}t.createDecorator=v;function i(y,w,m){let f=null,b=null;if(typeof m.value=="function"?(f="value",b=m.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(f="get",b=m.get),!b)throw new Error("not supported");const F=`$memoize$${w}`;m[f]=function(...a){return this.hasOwnProperty(F)||Object.defineProperty(this,F,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,a)}),this[F]}}t.memoize=i;function R(y,w,m){return v((f,b)=>{const F=`$debounce$${b}`,a=`$debounce$result$${b}`;return function(...n){this[a]||(this[a]=m?m():void 0),clearTimeout(this[F]),w&&(this[a]=w(this[a],...n),n=[this[a]]),this[F]=setTimeout(()=>{f.apply(this,n),this[a]=m?m():void 0},y)}})}t.debounce=R;function M(y,w,m){return v((f,b)=>{const F=`$throttle$timer$${b}`,a=`$throttle$result$${b}`,n=`$throttle$lastRun$${b}`,e=`$throttle$pending$${b}`;return function(...d){if(this[a]||(this[a]=m?m():void 0),(this[n]===null||this[n]===void 0)&&(this[n]=-Number.MAX_VALUE),w&&(this[a]=w(this[a],...d)),this[e])return;const p=this[n]+y;p<=Date.now()?(this[n]=Date.now(),f.apply(this,[this[a]]),this[a]=m?m():void 0):(this[e]=!0,this[F]=setTimeout(()=>{this[e]=!1,this[n]=Date.now(),f.apply(this,[this[a]]),this[a]=m?m():void 0},p-Date.now()))}})}t.throttle=M}),define(me[70],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class v{constructor(R,M,y,w){this.originalStart=R,this.originalLength=M,this.modifiedStart=y,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=v}),define(me[13],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(A){setTimeout(()=>{throw A.stack?u.isErrorNoTelemetry(A)?new u(A.message+`

`+A.stack):new Error(A.message+`

`+A.stack):A},0)}}addListener(A){return this.listeners.push(A),()=>{this._removeListener(A)}}emit(A){this.listeners.forEach(N=>{N(A)})}_removeListener(A){this.listeners.splice(this.listeners.indexOf(A),1)}setUnexpectedErrorHandler(A){this.unexpectedErrorHandler=A}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(A){this.unexpectedErrorHandler(A),this.emit(A)}onUnexpectedExternalError(A){this.unexpectedErrorHandler(A)}}t.ErrorHandler=v,t.errorHandler=new v;function i(D){t.errorHandler.setUnexpectedErrorHandler(D)}t.setUnexpectedErrorHandler=i;function R(D){m(D)||t.errorHandler.onUnexpectedError(D)}t.onUnexpectedError=R;function M(D){m(D)||t.errorHandler.onUnexpectedExternalError(D)}t.onUnexpectedExternalError=M;function y(D){if(D instanceof Error){const{name:A,message:N}=D,T=D.stacktrace||D.stack;return{$isError:!0,name:A,message:N,stack:T,noTelemetry:u.isErrorNoTelemetry(D)}}return D}t.transformErrorForSerialization=y;const w="Canceled";function m(D){return D instanceof f?!0:D instanceof Error&&D.name===w&&D.message===w}t.isCancellationError=m;class f extends Error{constructor(){super(w);this.name=this.message}}t.CancellationError=f;function b(){const D=new Error(w);return D.name=D.message,D}t.canceled=b;function F(D){return D?new Error(`Illegal argument: ${D}`):new Error("Illegal argument")}t.illegalArgument=F;function a(D){return D?new Error(`Illegal state: ${D}`):new Error("Illegal state")}t.illegalState=a;function n(D){return D?new Error(`readonly property '${D} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=n;function e(D){const A=new Error(`${D} has been disposed`);return A.name="DISPOSED",A}t.disposed=e;function d(D){return D?D.message?D.message:D.stack?D.stack.split(`
`)[0]:String(D):"Error"}t.getErrorMessage=d;class p extends Error{constructor(A){super("NotImplemented");A&&(this.message=A)}}t.NotImplementedError=p;class _ extends Error{constructor(A){super("NotSupported");A&&(this.message=A)}}t.NotSupportedError=_;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}t.ExpectedError=E;class u extends Error{constructor(A){super(A);this.name="ErrorNoTelemetry"}static fromError(A){if(A instanceof u)return A;const N=new u;return N.message=A.message,N.stack=A.stack,N}static isErrorNoTelemetry(A){return A.name==="ErrorNoTelemetry"}}t.ErrorNoTelemetry=u;class g extends Error{constructor(A){super(A||"An unexpected bug occurred.");Object.setPrototypeOf(this,g.prototype);debugger}}t.BugIndicatingError=g}),define(me[14],pe([1,0,13]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function i(W,O=0){return W[W.length-(1+O)]}t.tail=i;function R(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}t.tail2=R;function M(W,O,H=($,I)=>$===I){if(W===O)return!0;if(!W||!O||W.length!==O.length)return!1;for(let $=0,I=W.length;$<I;$++)if(!H(W[$],O[$]))return!1;return!0}t.equals=M;function y(W,O){const H=W.length-1;O<H&&(W[O]=W[H]),W.pop()}t.removeFastWithoutKeepingOrder=y;function w(W,O,H){return m(W.length,$=>H(W[$],O))}t.binarySearch=w;function m(W,O){let H=0,$=W-1;for(;H<=$;){const I=(H+$)/2|0,z=O(I);if(z<0)H=I+1;else if(z>0)$=I-1;else return I}return-(H+1)}t.binarySearch2=m;function f(W,O){let H=0,$=W.length;if($===0)return 0;for(;H<$;){const I=Math.floor((H+$)/2);O(W[I])?$=I:H=I+1}return H}t.findFirstInSorted=f;function b(W,O,H){if(W=W|0,W>=O.length)throw new TypeError("invalid index");const $=O[Math.floor(O.length*Math.random())],I=[],z=[],P=[];for(const B of O){const j=H(B,$);j<0?I.push(B):j>0?z.push(B):P.push(B)}return W<I.length?b(W,I,H):W<I.length+P.length?P[0]:b(W-(I.length+P.length),z,H)}t.quickSelect=b;function F(W,O){const H=[];let $;for(const I of W.slice(0).sort(O))!$||O($[0],I)!==0?($=[I],H.push($)):$.push(I);return H}t.groupBy=F;function a(W,O,H){const $=[];function I(B,j,ee){if(j===0&&ee.length===0)return;const he=$[$.length-1];he&&he.start+he.deleteCount===B?(he.deleteCount+=j,he.toInsert.push(...ee)):$.push({start:B,deleteCount:j,toInsert:ee})}let z=0,P=0;for(;;){if(z===W.length){I(z,0,O.slice(P));break}if(P===O.length){I(z,W.length-z,[]);break}const B=W[z],j=O[P],ee=H(B,j);ee===0?(z+=1,P+=1):ee<0?(I(z,1,[]),z+=1):ee>0&&(I(z,0,[j]),P+=1)}return $}t.sortedDiff=a;function n(W,O,H){const $=a(W,O,H),I=[],z=[];for(const P of $)I.push(...W.slice(P.start,P.start+P.deleteCount)),z.push(...P.toInsert);return{removed:I,added:z}}t.delta=n;function e(W,O,H){if(H===0)return[];const $=W.slice(0,H).sort(O);return p(W,O,$,H,W.length),$}t.top=e;function d(W,O,H,$,I){return H===0?Promise.resolve([]):new Promise((z,P)=>{(async()=>{const B=W.length,j=W.slice(0,H).sort(O);for(let ee=H,he=Math.min(H+$,B);ee<B;ee=he,he=Math.min(he+$,B)){if(ee>H&&await new Promise(fe=>setTimeout(fe)),I&&I.isCancellationRequested)throw new v.CancellationError;p(W,O,j,ee,he)}return j})().then(z,P)})}t.topAsync=d;function p(W,O,H,$,I){for(const z=H.length;$<I;$++){const P=W[$];if(O(P,H[z-1])<0){H.pop();const B=f(H,j=>O(P,j)<0);H.splice(B,0,P)}}}function _(W){return W.filter(O=>!!O)}t.coalesce=_;function E(W){let O=0;for(let H=0;H<W.length;H++)W[H]&&(W[O]=W[H],O+=1);W.length=O}t.coalesceInPlace=E;function u(W,O,H){W.splice(H,0,W.splice(O,1)[0])}t.move=u;function g(W){return!Array.isArray(W)||W.length===0}t.isFalsyOrEmpty=g;function D(W){return Array.isArray(W)&&W.length>0}t.isNonEmptyArray=D;function A(W,O=H=>H){const H=new Set;return W.filter($=>{const I=O($);return H.has(I)?!1:(H.add(I),!0)})}t.distinct=A;function N(W){const O=new Set;return H=>{const $=W(H);return O.has($)?!1:(O.add($),!0)}}t.uniqueFilter=N;function T(W,O){const H=s(W,O);if(H!==-1)return W[H]}t.findLast=T;function s(W,O){for(let H=W.length-1;H>=0;H--){const $=W[H];if(O($))return H}return-1}t.lastIndex=s;function l(W,O){return W.length>0?W[0]:O}t.firstOrDefault=l;function o(W,O){return W.length>0?W[W.length-1]:O}t.lastOrDefault=o;function r(W,O,H=($,I)=>$===I){let $=0;for(let I=0,z=Math.min(W.length,O.length);I<z&&H(W[I],O[I]);I++)$++;return $}t.commonPrefixLength=r;function c(W){return[].concat(...W)}t.flatten=c;function C(W,O){let H=typeof O=="number"?W:0;typeof O=="number"?H=W:(H=0,O=W);const $=[];if(H<=O)for(let I=H;I<O;I++)$.push(I);else for(let I=H;I>O;I--)$.push(I);return $}t.range=C;function V(W,O,H){return W.reduce(($,I)=>($[O(I)]=H?H(I):I,$),Object.create(null))}t.index=V;function se(W,O){return W.push(O),()=>ie(W,O)}t.insert=se;function ie(W,O){const H=W.indexOf(O);if(H>-1)return W.splice(H,1),O}t.remove=ie;function ae(W,O,H){const $=W.slice(0,O),I=W.slice(O);return $.concat(H,I)}t.arrayInsert=ae;function ne(W,O){let H;if(typeof O=="number"){let $=O;H=()=>{const I=Math.sin($++)*179426549;return I-Math.floor(I)}}else H=Math.random;for(let $=W.length-1;$>0;$-=1){const I=Math.floor(H()*($+1)),z=W[$];W[$]=W[I],W[I]=z}}t.shuffle=ne;function we(W,O){const H=W.indexOf(O);H>-1&&(W.splice(H,1),W.unshift(O))}t.pushToStart=we;function de(W,O){const H=W.indexOf(O);H>-1&&(W.splice(H,1),W.push(O))}t.pushToEnd=de;function ge(W,O){for(const H of O)W.push(H)}t.pushMany=ge;function ye(W,O){return Array.isArray(W)?W.map(O):O(W)}t.mapArrayOrNot=ye;function J(W){return Array.isArray(W)?W:[W]}t.asArray=J;function De(W){return W[Math.floor(Math.random()*W.length)]}t.getRandomElement=De;function re(W,O){for(const H of W){const $=O(H);if($!==void 0)return $}}t.mapFind=re;function te(W,O,H){const $=Q(W,O),I=W.length,z=H.length;W.length=I+z;for(let P=I-1;P>=$;P--)W[P+z]=W[P];for(let P=0;P<z;P++)W[P+$]=H[P]}t.insertInto=te;function le(W,O,H,$){const I=Q(W,O),z=W.splice(I,H);return te(W,I,$),z}t.splice=le;function Q(W,O){return O<0?Math.max(O+W.length,0):Math.min(O,W.length)}var S;(function(W){function O(I){return I<0}W.isLessThan=O;function H(I){return I>0}W.isGreaterThan=H;function $(I){return I===0}W.isNeitherLessOrGreaterThan=$,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(S=t.CompareResult||(t.CompareResult={}));function K(W,O){return(H,$)=>O(W(H),W($))}t.compareBy=K;function G(...W){return(O,H)=>{for(const $ of W){const I=$(O,H);if(!S.isNeitherLessOrGreaterThan(I))return I}return S.neitherLessOrGreaterThan}}t.tieBreakComparators=G;const k=(W,O)=>W-O;t.numberComparator=k;function h(W,O){if(W.length===0)return;let H=W[0];for(let $=1;$<W.length;$++){const I=W[$];O(I,H)>0&&(H=I)}return H}t.findMaxBy=h;function L(W,O){if(W.length===0)return;let H=W[0];for(let $=1;$<W.length;$++){const I=W[$];O(I,H)>=0&&(H=I)}return H}t.findLastMaxBy=L;function U(W,O){return h(W,(H,$)=>-O(H,$))}t.findMinBy=U;class q{constructor(O){this.items=O,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(O){let H=this.firstIdx;for(;H<this.items.length&&O(this.items[H]);)H++;const $=H===this.firstIdx?null:this.items.slice(this.firstIdx,H);return this.firstIdx=H,$}takeFromEndWhile(O){let H=this.lastIdx;for(;H>=0&&O(this.items[H]);)H--;const $=H===this.lastIdx?null:this.items.slice(H+1,this.lastIdx+1);return this.lastIdx=H,$}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const O=this.items[this.firstIdx];return this.firstIdx++,O}removeLast(){const O=this.items[this.lastIdx];return this.lastIdx--,O}takeCount(O){const H=this.items.slice(this.firstIdx,this.firstIdx+O);return this.firstIdx+=O,H}}t.ArrayQueue=q}),define(me[42],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function v(i){const R=this;let M=!1,y;return function(){return M||(M=!0,y=i.apply(R,arguments)),y}}t.once=v}),define(me[71],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class v{constructor(R){this._prefix=R,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=v,t.defaultGenerator=new v("id#")}),define(me[27],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var v;(function(i){function R(N){return N&&typeof N=="object"&&typeof N[Symbol.iterator]=="function"}i.is=R;const M=Object.freeze([]);function y(){return M}i.empty=y;function*w(N){yield N}i.single=w;function m(N){return N||M}i.from=m;function f(N){return!N||N[Symbol.iterator]().next().done===!0}i.isEmpty=f;function b(N){return N[Symbol.iterator]().next().value}i.first=b;function F(N,T){for(const s of N)if(T(s))return!0;return!1}i.some=F;function a(N,T){for(const s of N)if(T(s))return s}i.find=a;function*n(N,T){for(const s of N)T(s)&&(yield s)}i.filter=n;function*e(N,T){let s=0;for(const l of N)yield T(l,s++)}i.map=e;function*d(...N){for(const T of N)for(const s of T)yield s}i.concat=d;function*p(N){for(const T of N)for(const s of T)yield s}i.concatNested=p;function _(N,T,s){let l=s;for(const o of N)l=T(l,o);return l}i.reduce=_;function E(N,T){let s=0;for(const l of N)T(l,s++)}i.forEach=E;function*u(N,T,s=N.length){for(T<0&&(T+=N.length),s<0?s+=N.length:s>N.length&&(s=N.length);T<s;T++)yield N[T]}i.slice=u;function g(N,T=Number.POSITIVE_INFINITY){const s=[];if(T===0)return[s,N];const l=N[Symbol.iterator]();for(let o=0;o<T;o++){const r=l.next();if(r.done)return[s,i.empty()];s.push(r.value)}return[s,{[Symbol.iterator](){return l}}]}i.consume=g;function D(N){return g(N)[0]}i.collect=D;function A(N,T,s=(l,o)=>l===o){const l=N[Symbol.iterator](),o=T[Symbol.iterator]();for(;;){const r=l.next(),c=o.next();if(r.done!==c.done)return!1;if(r.done)return!0;if(!s(r.value,c.value))return!1}}i.equals=A})(v=t.Iterable||(t.Iterable={}))}),define(me[43],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var v;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(v=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(i=t.ScanCode||(t.ScanCode={}));class R{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(d,p){this._keyCodeToStr[d]=p,this._strToKeyCode[p.toLowerCase()]=d}keyCodeToStr(d){return this._keyCodeToStr[d]}strToKeyCode(d){return this._strToKeyCode[d.toLowerCase()]||0}}const M=new R,y=new R,w=new R;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const m=[],f=Object.create(null),b=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>b[e]||0,toEnum:e=>f[e]||0,toString:e=>m[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",d=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],p=[],_=[];for(const E of d){const[u,g,D,A,N,T,s,l,o,r]=E;if(_[D]||(_[D]=!0,m[D]=A,f[A]=D,b[A.toLowerCase()]=D,g&&(t.IMMUTABLE_CODE_TO_KEY_CODE[D]=N,N!==0&&N!==3&&N!==5&&N!==4&&N!==6&&N!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[N]=D))),!p[N]){if(p[N]=!0,!T)throw new Error(`String representation missing for key code ${N} around scan code ${A}`);M.define(N,T),y.define(N,o||T),w.define(N,r||o||T)}s&&(t.EVENT_KEY_CODE_MAP[s]=N),l&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[l]=N)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var F;(function(e){function d(D){return M.keyCodeToStr(D)}e.toString=d;function p(D){return M.strToKeyCode(D)}e.fromString=p;function _(D){return y.keyCodeToStr(D)}e.toUserSettingsUS=_;function E(D){return w.keyCodeToStr(D)}e.toUserSettingsGeneral=E;function u(D){return y.strToKeyCode(D)||w.strToKeyCode(D)}e.fromUserSettings=u;function g(D){if(D>=93&&D<=108)return null;switch(D){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(D)}e.toElectronAccelerator=g})(F=t.KeyCodeUtils||(t.KeyCodeUtils={}));var a;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(a=t.KeyMod||(t.KeyMod={}));function n(e,d){const p=(d&65535)<<16>>>0;return(e|p)>>>0}t.KeyChord=n}),define(me[72],pe([1,0,13]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ScanCodeBinding=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=void 0;var i;(function(F){F[F.CtrlCmd=2048]="CtrlCmd",F[F.Shift=1024]="Shift",F[F.Alt=512]="Alt",F[F.WinCtrl=256]="WinCtrl",F[F.KeyCode=255]="KeyCode"})(i||(i={}));function R(F,a){if(F===0)return null;const n=(F&65535)>>>0,e=(F&4294901760)>>>16;return e!==0?new w([M(n,a),M(e,a)]):new w([M(n,a)])}t.createKeybinding=R;function M(F,a){const n=!!(F&2048),e=!!(F&256),d=a===2?e:n,p=!!(F&1024),_=!!(F&512),E=a===2?n:e,u=F&255;return new y(d,p,_,E,u)}t.createSimpleKeybinding=M;class y{constructor(a,n,e,d,p){this.ctrlKey=a,this.shiftKey=n,this.altKey=e,this.metaKey=d,this.keyCode=p}equals(a){return this.ctrlKey===a.ctrlKey&&this.shiftKey===a.shiftKey&&this.altKey===a.altKey&&this.metaKey===a.metaKey&&this.keyCode===a.keyCode}getHashCode(){const a=this.ctrlKey?"1":"0",n=this.shiftKey?"1":"0",e=this.altKey?"1":"0",d=this.metaKey?"1":"0";return`${a}${n}${e}${d}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new w([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=y;class w{constructor(a){if(a.length===0)throw(0,v.illegalArgument)("parts");this.parts=a}getHashCode(){let a="";for(let n=0,e=this.parts.length;n<e;n++)n!==0&&(a+=";"),a+=this.parts[n].getHashCode();return a}equals(a){if(a===null||this.parts.length!==a.parts.length)return!1;for(let n=0;n<this.parts.length;n++)if(!this.parts[n].equals(a.parts[n]))return!1;return!0}}t.ChordKeybinding=w;class m{constructor(a,n,e,d,p){this.ctrlKey=a,this.shiftKey=n,this.altKey=e,this.metaKey=d,this.scanCode=p}equals(a){return this.ctrlKey===a.ctrlKey&&this.shiftKey===a.shiftKey&&this.altKey===a.altKey&&this.metaKey===a.metaKey&&this.scanCode===a.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeBinding=m;class f{constructor(a,n,e,d,p,_){this.ctrlKey=a,this.shiftKey=n,this.altKey=e,this.metaKey=d,this.keyLabel=p,this.keyAriaLabel=_}}t.ResolvedKeybindingPart=f;class b{}t.ResolvedKeybinding=b}),define(me[73],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class v{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new v(()=>R(this.getValue()))}}t.Lazy=v}),define(me[2],pe([1,0,42,27]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=t.markAsSingleton=t.setDisposableTracker=void 0;const R=!1;let M=null;function y(l){M=l}if(t.setDisposableTracker=y,R){const l="__is_disposable_tracked__";y(new class{trackDisposable(o){const r=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[l]||console.log(r)},3e3)}setParent(o,r){if(o&&o!==E.None)try{o[l]=!0}catch{}}markAsDisposed(o){if(o&&o!==E.None)try{o[l]=!0}catch{}}markAsSingleton(o){}})}function w(l){return M?.trackDisposable(l),l}function m(l){M?.markAsDisposed(l)}function f(l,o){M?.setParent(l,o)}function b(l,o){if(!!M)for(const r of l)M.setParent(r,o)}function F(l){return M?.markAsSingleton(l),l}t.markAsSingleton=F;class a extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}t.MultiDisposeError=a;function n(l){return typeof l.dispose=="function"&&l.dispose.length===0}t.isDisposable=n;function e(l){if(i.Iterable.is(l)){const o=[];for(const r of l)if(r)try{r.dispose()}catch(c){o.push(c)}if(o.length===1)throw o[0];if(o.length>1)throw new a(o);return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}t.dispose=e;function d(...l){const o=p(()=>e(l));return b(l,o),o}t.combinedDisposable=d;function p(l){const o=w({dispose:(0,v.once)(()=>{m(o),l()})});return o}t.toDisposable=p;class _{constructor(){this._toDispose=new Set,this._isDisposed=!1,w(this)}dispose(){this._isDisposed||(m(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{e(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return f(o,this),this._isDisposed?_.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}t.DisposableStore=_,_.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new _,w(this),f(this._store,this)}dispose(){m(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}t.Disposable=E,E.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&f(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,m(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&f(o,null),o}}t.MutableDisposable=u;class g{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}t.RefCountedDisposable=g;class D{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(o){let r=o;return this.unset=()=>r=void 0,this.isset=()=>r!==void 0,this.dispose=()=>{r&&(r(),r=void 0,m(this))},this}}t.SafeDisposable=D;class A{constructor(){this.references=new Map}acquire(o,...r){let c=this.references.get(o);c||(c={counter:0,object:this.createReferencedObject(o,...r)},this.references.set(o,c));const{object:C}=c,V=(0,v.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(o,c.object),this.references.delete(o))});return c.counter++,{object:C,dispose:V}}}t.ReferenceCollection=A;class N{constructor(o){this.referenceCollection=o}async acquire(o,...r){const c=this.referenceCollection.acquire(o,...r);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(C){throw c.dispose(),C}}}t.AsyncReferenceCollection=N;class T{constructor(o){this.object=o}dispose(){}}t.ImmortalReference=T;function s(l){const o=new _;try{l(o)}finally{o.dispose()}}t.disposeOnReturn=s}),define(me[74],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class v{constructor(M){this.element=M,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class i{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let M=this._first;for(;M!==v.Undefined;){const y=M.next;M.prev=v.Undefined,M.next=v.Undefined,M=y}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,y){const w=new v(M);if(this._first===v.Undefined)this._first=w,this._last=w;else if(y){const f=this._last;this._last=w,w.prev=f,f.next=w}else{const f=this._first;this._first=w,w.next=f,f.prev=w}this._size+=1;let m=!1;return()=>{m||(m=!0,this._remove(w))}}shift(){if(this._first!==v.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==v.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==v.Undefined&&M.next!==v.Undefined){const y=M.prev;y.next=M.next,M.next.prev=y}else M.prev===v.Undefined&&M.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):M.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):M.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==v.Undefined;)yield M.element,M=M.next}}t.LinkedList=i}),function(Z,t){typeof exports=="object"&&typeof module!="undefined"?t(exports):typeof define=="function"&&define.amd?define(me[75],pe([0]),t):(Z=typeof globalThis!="undefined"?globalThis:Z||self,t(Z.marked={}))}(this,function(Z){"use strict";function t(O,H){for(var $=0;$<H.length;$++){var I=H[$];I.enumerable=I.enumerable||!1,I.configurable=!0,"value"in I&&(I.writable=!0),Object.defineProperty(O,I.key,I)}}function v(O,H,$){return H&&t(O.prototype,H),$&&t(O,$),Object.defineProperty(O,"prototype",{writable:!1}),O}function i(O,H){if(!!O){if(typeof O=="string")return R(O,H);var $=Object.prototype.toString.call(O).slice(8,-1);if($==="Object"&&O.constructor&&($=O.constructor.name),$==="Map"||$==="Set")return Array.from(O);if($==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test($))return R(O,H)}}function R(O,H){(H==null||H>O.length)&&(H=O.length);for(var $=0,I=new Array(H);$<H;$++)I[$]=O[$];return I}function M(O,H){var $=typeof Symbol!="undefined"&&O[Symbol.iterator]||O["@@iterator"];if($)return($=$.call(O)).next.bind($);if(Array.isArray(O)||($=i(O))||H&&O&&typeof O.length=="number"){$&&(O=$);var I=0;return function(){return I>=O.length?{done:!0}:{done:!1,value:O[I++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Z.defaults=y();function w(O){Z.defaults=O}var m=/[&<>"']/,f=/[&<>"']/g,b=/[<>"']|&(?!#?\w+;)/,F=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},n=function(H){return a[H]};function e(O,H){if(H){if(m.test(O))return O.replace(f,n)}else if(b.test(O))return O.replace(F,n);return O}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p(O){return O.replace(d,function(H,$){return $=$.toLowerCase(),$==="colon"?":":$.charAt(0)==="#"?$.charAt(1)==="x"?String.fromCharCode(parseInt($.substring(2),16)):String.fromCharCode(+$.substring(1)):""})}var _=/(^|[^\[])\^/g;function E(O,H){O=typeof O=="string"?O:O.source,H=H||"";var $={replace:function(z,P){return P=P.source||P,P=P.replace(_,"$1"),O=O.replace(z,P),$},getRegex:function(){return new RegExp(O,H)}};return $}var u=/[^\w:]/g,g=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function D(O,H,$){if(O){var I;try{I=decodeURIComponent(p($)).replace(u,"").toLowerCase()}catch{return null}if(I.indexOf("javascript:")===0||I.indexOf("vbscript:")===0||I.indexOf("data:")===0)return null}H&&!g.test($)&&($=l(H,$));try{$=encodeURI($).replace(/%25/g,"%")}catch{return null}return $}var A={},N=/^[^:]+:\/*[^/]*$/,T=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(O,H){A[" "+O]||(N.test(O)?A[" "+O]=O+"/":A[" "+O]=C(O,"/",!0)),O=A[" "+O];var $=O.indexOf(":")===-1;return H.substring(0,2)==="//"?$?H:O.replace(T,"$1")+H:H.charAt(0)==="/"?$?H:O.replace(s,"$1")+H:O+H}var o={exec:function(){}};function r(O){for(var H=1,$,I;H<arguments.length;H++){$=arguments[H];for(I in $)Object.prototype.hasOwnProperty.call($,I)&&(O[I]=$[I])}return O}function c(O,H){var $=O.replace(/\|/g,function(P,B,j){for(var ee=!1,he=B;--he>=0&&j[he]==="\\";)ee=!ee;return ee?"|":" |"}),I=$.split(/ \|/),z=0;if(I[0].trim()||I.shift(),I.length>0&&!I[I.length-1].trim()&&I.pop(),I.length>H)I.splice(H);else for(;I.length<H;)I.push("");for(;z<I.length;z++)I[z]=I[z].trim().replace(/\\\|/g,"|");return I}function C(O,H,$){var I=O.length;if(I===0)return"";for(var z=0;z<I;){var P=O.charAt(I-z-1);if(P===H&&!$)z++;else if(P!==H&&$)z++;else break}return O.slice(0,I-z)}function V(O,H){if(O.indexOf(H[1])===-1)return-1;for(var $=O.length,I=0,z=0;z<$;z++)if(O[z]==="\\")z++;else if(O[z]===H[0])I++;else if(O[z]===H[1]&&(I--,I<0))return z;return-1}function se(O){O&&O.sanitize&&!O.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function ie(O,H){if(H<1)return"";for(var $="";H>1;)H&1&&($+=O),H>>=1,O+=O;return $+O}function ae(O,H,$,I){var z=H.href,P=H.title?e(H.title):null,B=O[1].replace(/\\([\[\]])/g,"$1");if(O[0].charAt(0)!=="!"){I.state.inLink=!0;var j={type:"link",raw:$,href:z,title:P,text:B,tokens:I.inlineTokens(B,[])};return I.state.inLink=!1,j}return{type:"image",raw:$,href:z,title:P,text:e(B)}}function ne(O,H){var $=O.match(/^(\s+)(?:```)/);if($===null)return H;var I=$[1];return H.split(`
`).map(function(z){var P=z.match(/^\s+/);if(P===null)return z;var B=P[0];return B.length>=I.length?z.slice(I.length):z}).join(`
`)}var we=function(){function O($){this.options=$||Z.defaults}var H=O.prototype;return H.space=function(I){var z=this.rules.block.newline.exec(I);if(z&&z[0].length>0)return{type:"space",raw:z[0]}},H.code=function(I){var z=this.rules.block.code.exec(I);if(z){var P=z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:z[0],codeBlockStyle:"indented",text:this.options.pedantic?P:C(P,`
`)}}},H.fences=function(I){var z=this.rules.block.fences.exec(I);if(z){var P=z[0],B=ne(P,z[3]||"");return{type:"code",raw:P,lang:z[2]?z[2].trim():z[2],text:B}}},H.heading=function(I){var z=this.rules.block.heading.exec(I);if(z){var P=z[2].trim();if(/#$/.test(P)){var B=C(P,"#");(this.options.pedantic||!B||/ $/.test(B))&&(P=B.trim())}var j={type:"heading",raw:z[0],depth:z[1].length,text:P,tokens:[]};return this.lexer.inline(j.text,j.tokens),j}},H.hr=function(I){var z=this.rules.block.hr.exec(I);if(z)return{type:"hr",raw:z[0]}},H.blockquote=function(I){var z=this.rules.block.blockquote.exec(I);if(z){var P=z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:z[0],tokens:this.lexer.blockTokens(P,[]),text:P}}},H.list=function(I){var z=this.rules.block.list.exec(I);if(z){var P,B,j,ee,he,fe,Ee,_e,ke,Ie,ve,Pe,Me=z[1].trim(),Ge=Me.length>1,He={type:"list",raw:"",ordered:Ge,start:Ge?+Me.slice(0,-1):"",loose:!1,items:[]};Me=Ge?"\\d{1,9}\\"+Me.slice(-1):"\\"+Me,this.options.pedantic&&(Me=Ge?Me:"[*+-]");for(var Ue=new RegExp("^( {0,3}"+Me+")((?:[	 ][^\\n]*)?(?:\\n|$))");I&&(Pe=!1,!(!(z=Ue.exec(I))||this.rules.block.hr.test(I)));){if(P=z[0],I=I.substring(P.length),_e=z[2].split(`
`,1)[0],ke=I.split(`
`,1)[0],this.options.pedantic?(ee=2,ve=_e.trimLeft()):(ee=z[2].search(/[^ ]/),ee=ee>4?1:ee,ve=_e.slice(ee),ee+=z[1].length),fe=!1,!_e&&/^ *$/.test(ke)&&(P+=ke+`
`,I=I.substring(ke.length+1),Pe=!0),!Pe)for(var Je=new RegExp("^ {0,"+Math.min(3,ee-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),je=new RegExp("^ {0,"+Math.min(3,ee-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");I&&(Ie=I.split(`
`,1)[0],_e=Ie,this.options.pedantic&&(_e=_e.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Je.test(_e)||je.test(I)));){if(_e.search(/[^ ]/)>=ee||!_e.trim())ve+=`
`+_e.slice(ee);else if(!fe)ve+=`
`+_e;else break;!fe&&!_e.trim()&&(fe=!0),P+=Ie+`
`,I=I.substring(Ie.length+1)}He.loose||(Ee?He.loose=!0:/\n *\n *$/.test(P)&&(Ee=!0)),this.options.gfm&&(B=/^\[[ xX]\] /.exec(ve),B&&(j=B[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:P,task:!!B,checked:j,loose:!1,text:ve}),He.raw+=P}He.items[He.items.length-1].raw=P.trimRight(),He.items[He.items.length-1].text=ve.trimRight(),He.raw=He.raw.trimRight();var Oe=He.items.length;for(he=0;he<Oe;he++){this.lexer.state.top=!1,He.items[he].tokens=this.lexer.blockTokens(He.items[he].text,[]);var x=He.items[he].tokens.filter(function(be){return be.type==="space"}),oe=x.every(function(be){for(var Ce=be.raw.split(""),Fe=0,Re=M(Ce),Ve;!(Ve=Re()).done;){var tt=Ve.value;if(tt===`
`&&(Fe+=1),Fe>1)return!0}return!1});!He.loose&&x.length&&oe&&(He.loose=!0,He.items[he].loose=!0)}return He}},H.html=function(I){var z=this.rules.block.html.exec(I);if(z){var P={type:"html",raw:z[0],pre:!this.options.sanitizer&&(z[1]==="pre"||z[1]==="script"||z[1]==="style"),text:z[0]};return this.options.sanitize&&(P.type="paragraph",P.text=this.options.sanitizer?this.options.sanitizer(z[0]):e(z[0]),P.tokens=[],this.lexer.inline(P.text,P.tokens)),P}},H.def=function(I){var z=this.rules.block.def.exec(I);if(z){z[3]&&(z[3]=z[3].substring(1,z[3].length-1));var P=z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:P,raw:z[0],href:z[2],title:z[3]}}},H.table=function(I){var z=this.rules.block.table.exec(I);if(z){var P={type:"table",header:c(z[1]).map(function(Ee){return{text:Ee}}),align:z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:z[3]&&z[3].trim()?z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(P.header.length===P.align.length){P.raw=z[0];var B=P.align.length,j,ee,he,fe;for(j=0;j<B;j++)/^ *-+: *$/.test(P.align[j])?P.align[j]="right":/^ *:-+: *$/.test(P.align[j])?P.align[j]="center":/^ *:-+ *$/.test(P.align[j])?P.align[j]="left":P.align[j]=null;for(B=P.rows.length,j=0;j<B;j++)P.rows[j]=c(P.rows[j],P.header.length).map(function(Ee){return{text:Ee}});for(B=P.header.length,ee=0;ee<B;ee++)P.header[ee].tokens=[],this.lexer.inline(P.header[ee].text,P.header[ee].tokens);for(B=P.rows.length,ee=0;ee<B;ee++)for(fe=P.rows[ee],he=0;he<fe.length;he++)fe[he].tokens=[],this.lexer.inline(fe[he].text,fe[he].tokens);return P}}},H.lheading=function(I){var z=this.rules.block.lheading.exec(I);if(z){var P={type:"heading",raw:z[0],depth:z[2].charAt(0)==="="?1:2,text:z[1],tokens:[]};return this.lexer.inline(P.text,P.tokens),P}},H.paragraph=function(I){var z=this.rules.block.paragraph.exec(I);if(z){var P={type:"paragraph",raw:z[0],text:z[1].charAt(z[1].length-1)===`
`?z[1].slice(0,-1):z[1],tokens:[]};return this.lexer.inline(P.text,P.tokens),P}},H.text=function(I){var z=this.rules.block.text.exec(I);if(z){var P={type:"text",raw:z[0],text:z[0],tokens:[]};return this.lexer.inline(P.text,P.tokens),P}},H.escape=function(I){var z=this.rules.inline.escape.exec(I);if(z)return{type:"escape",raw:z[0],text:e(z[1])}},H.tag=function(I){var z=this.rules.inline.tag.exec(I);if(z)return!this.lexer.state.inLink&&/^<a /i.test(z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(z[0]):e(z[0]):z[0]}},H.link=function(I){var z=this.rules.inline.link.exec(I);if(z){var P=z[2].trim();if(!this.options.pedantic&&/^</.test(P)){if(!/>$/.test(P))return;var B=C(P.slice(0,-1),"\\");if((P.length-B.length)%2==0)return}else{var j=V(z[2],"()");if(j>-1){var ee=z[0].indexOf("!")===0?5:4,he=ee+z[1].length+j;z[2]=z[2].substring(0,j),z[0]=z[0].substring(0,he).trim(),z[3]=""}}var fe=z[2],Ee="";if(this.options.pedantic){var _e=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(fe);_e&&(fe=_e[1],Ee=_e[3])}else Ee=z[3]?z[3].slice(1,-1):"";return fe=fe.trim(),/^</.test(fe)&&(this.options.pedantic&&!/>$/.test(P)?fe=fe.slice(1):fe=fe.slice(1,-1)),ae(z,{href:fe&&fe.replace(this.rules.inline._escapes,"$1"),title:Ee&&Ee.replace(this.rules.inline._escapes,"$1")},z[0],this.lexer)}},H.reflink=function(I,z){var P;if((P=this.rules.inline.reflink.exec(I))||(P=this.rules.inline.nolink.exec(I))){var B=(P[2]||P[1]).replace(/\s+/g," ");if(B=z[B.toLowerCase()],!B||!B.href){var j=P[0].charAt(0);return{type:"text",raw:j,text:j}}return ae(P,B,P[0],this.lexer)}},H.emStrong=function(I,z,P){P===void 0&&(P="");var B=this.rules.inline.emStrong.lDelim.exec(I);if(!!B&&!(B[3]&&P.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var j=B[1]||B[2]||"";if(!j||j&&(P===""||this.rules.inline.punctuation.exec(P))){var ee=B[0].length-1,he,fe,Ee=ee,_e=0,ke=B[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ke.lastIndex=0,z=z.slice(-1*I.length+ee);(B=ke.exec(z))!=null;)if(he=B[1]||B[2]||B[3]||B[4]||B[5]||B[6],!!he){if(fe=he.length,B[3]||B[4]){Ee+=fe;continue}else if((B[5]||B[6])&&ee%3&&!((ee+fe)%3)){_e+=fe;continue}if(Ee-=fe,!(Ee>0)){if(fe=Math.min(fe,fe+Ee+_e),Math.min(ee,fe)%2){var Ie=I.slice(1,ee+B.index+fe);return{type:"em",raw:I.slice(0,ee+B.index+fe+1),text:Ie,tokens:this.lexer.inlineTokens(Ie,[])}}var ve=I.slice(2,ee+B.index+fe-1);return{type:"strong",raw:I.slice(0,ee+B.index+fe+1),text:ve,tokens:this.lexer.inlineTokens(ve,[])}}}}}},H.codespan=function(I){var z=this.rules.inline.code.exec(I);if(z){var P=z[2].replace(/\n/g," "),B=/[^ ]/.test(P),j=/^ /.test(P)&&/ $/.test(P);return B&&j&&(P=P.substring(1,P.length-1)),P=e(P,!0),{type:"codespan",raw:z[0],text:P}}},H.br=function(I){var z=this.rules.inline.br.exec(I);if(z)return{type:"br",raw:z[0]}},H.del=function(I){var z=this.rules.inline.del.exec(I);if(z)return{type:"del",raw:z[0],text:z[2],tokens:this.lexer.inlineTokens(z[2],[])}},H.autolink=function(I,z){var P=this.rules.inline.autolink.exec(I);if(P){var B,j;return P[2]==="@"?(B=e(this.options.mangle?z(P[1]):P[1]),j="mailto:"+B):(B=e(P[1]),j=B),{type:"link",raw:P[0],text:B,href:j,tokens:[{type:"text",raw:B,text:B}]}}},H.url=function(I,z){var P;if(P=this.rules.inline.url.exec(I)){var B,j;if(P[2]==="@")B=e(this.options.mangle?z(P[0]):P[0]),j="mailto:"+B;else{var ee;do ee=P[0],P[0]=this.rules.inline._backpedal.exec(P[0])[0];while(ee!==P[0]);B=e(P[0]),P[1]==="www."?j="http://"+B:j=B}return{type:"link",raw:P[0],text:B,href:j,tokens:[{type:"text",raw:B,text:B}]}}},H.inlineText=function(I,z){var P=this.rules.inline.text.exec(I);if(P){var B;return this.lexer.state.inRawBlock?B=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(P[0]):e(P[0]):P[0]:B=e(this.options.smartypants?z(P[0]):P[0]),{type:"text",raw:P[0],text:B}}},O}(),de={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:o,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};de._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,de._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,de.def=E(de.def).replace("label",de._label).replace("title",de._title).getRegex(),de.bullet=/(?:[*+-]|\d{1,9}[.)])/,de.listItemStart=E(/^( *)(bull) */).replace("bull",de.bullet).getRegex(),de.list=E(de.list).replace(/bull/g,de.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+de.def.source+")").getRegex(),de._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",de._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,de.html=E(de.html,"i").replace("comment",de._comment).replace("tag",de._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),de.paragraph=E(de._paragraph).replace("hr",de.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",de._tag).getRegex(),de.blockquote=E(de.blockquote).replace("paragraph",de.paragraph).getRegex(),de.normal=r({},de),de.gfm=r({},de.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),de.gfm.table=E(de.gfm.table).replace("hr",de.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",de._tag).getRegex(),de.gfm.paragraph=E(de._paragraph).replace("hr",de.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",de.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",de._tag).getRegex(),de.pedantic=r({},de.normal,{html:E(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",de._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:o,paragraph:E(de.normal._paragraph).replace("hr",de.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",de.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ge={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:o,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:o,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ge._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ge.punctuation=E(ge.punctuation).replace(/punctuation/g,ge._punctuation).getRegex(),ge.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ge.escapedEmSt=/\\\*|\\_/g,ge._comment=E(de._comment).replace("(?:-->|$)","-->").getRegex(),ge.emStrong.lDelim=E(ge.emStrong.lDelim).replace(/punct/g,ge._punctuation).getRegex(),ge.emStrong.rDelimAst=E(ge.emStrong.rDelimAst,"g").replace(/punct/g,ge._punctuation).getRegex(),ge.emStrong.rDelimUnd=E(ge.emStrong.rDelimUnd,"g").replace(/punct/g,ge._punctuation).getRegex(),ge._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ge._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ge._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ge.autolink=E(ge.autolink).replace("scheme",ge._scheme).replace("email",ge._email).getRegex(),ge._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ge.tag=E(ge.tag).replace("comment",ge._comment).replace("attribute",ge._attribute).getRegex(),ge._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ge._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ge._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ge.link=E(ge.link).replace("label",ge._label).replace("href",ge._href).replace("title",ge._title).getRegex(),ge.reflink=E(ge.reflink).replace("label",ge._label).replace("ref",de._label).getRegex(),ge.nolink=E(ge.nolink).replace("ref",de._label).getRegex(),ge.reflinkSearch=E(ge.reflinkSearch,"g").replace("reflink",ge.reflink).replace("nolink",ge.nolink).getRegex(),ge.normal=r({},ge),ge.pedantic=r({},ge.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:E(/^!?\[(label)\]\((.*?)\)/).replace("label",ge._label).getRegex(),reflink:E(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ge._label).getRegex()}),ge.gfm=r({},ge.normal,{escape:E(ge.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ge.gfm.url=E(ge.gfm.url,"i").replace("email",ge.gfm._extended_email).getRegex(),ge.breaks=r({},ge.gfm,{br:E(ge.br).replace("{2,}","*").getRegex(),text:E(ge.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ye(O){return O.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function J(O){var H="",$,I,z=O.length;for($=0;$<z;$++)I=O.charCodeAt($),Math.random()>.5&&(I="x"+I.toString(16)),H+="&#"+I+";";return H}var De=function(){function O($){this.tokens=[],this.tokens.links=Object.create(null),this.options=$||Z.defaults,this.options.tokenizer=this.options.tokenizer||new we,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var I={block:de.normal,inline:ge.normal};this.options.pedantic?(I.block=de.pedantic,I.inline=ge.pedantic):this.options.gfm&&(I.block=de.gfm,this.options.breaks?I.inline=ge.breaks:I.inline=ge.gfm),this.tokenizer.rules=I}O.lex=function(I,z){var P=new O(z);return P.lex(I)},O.lexInline=function(I,z){var P=new O(z);return P.inlineTokens(I)};var H=O.prototype;return H.lex=function(I){I=I.replace(/\r\n|\r/g,`
`),this.blockTokens(I,this.tokens);for(var z;z=this.inlineQueue.shift();)this.inlineTokens(z.src,z.tokens);return this.tokens},H.blockTokens=function(I,z){var P=this;z===void 0&&(z=[]),this.options.pedantic?I=I.replace(/\t/g,"    ").replace(/^ +$/gm,""):I=I.replace(/^( *)(\t+)/gm,function(Ee,_e,ke){return _e+"    ".repeat(ke.length)});for(var B,j,ee,he;I;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ee){return(B=Ee.call({lexer:P},I,z))?(I=I.substring(B.raw.length),z.push(B),!0):!1}))){if(B=this.tokenizer.space(I)){I=I.substring(B.raw.length),B.raw.length===1&&z.length>0?z[z.length-1].raw+=`
`:z.push(B);continue}if(B=this.tokenizer.code(I)){I=I.substring(B.raw.length),j=z[z.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+B.raw,j.text+=`
`+B.text,this.inlineQueue[this.inlineQueue.length-1].src=j.text):z.push(B);continue}if(B=this.tokenizer.fences(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.heading(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.hr(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.blockquote(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.list(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.html(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.def(I)){I=I.substring(B.raw.length),j=z[z.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+B.raw,j.text+=`
`+B.raw,this.inlineQueue[this.inlineQueue.length-1].src=j.text):this.tokens.links[B.tag]||(this.tokens.links[B.tag]={href:B.href,title:B.title});continue}if(B=this.tokenizer.table(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.lheading(I)){I=I.substring(B.raw.length),z.push(B);continue}if(ee=I,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ee=1/0,_e=I.slice(1),ke=void 0;P.options.extensions.startBlock.forEach(function(Ie){ke=Ie.call({lexer:this},_e),typeof ke=="number"&&ke>=0&&(Ee=Math.min(Ee,ke))}),Ee<1/0&&Ee>=0&&(ee=I.substring(0,Ee+1))}(),this.state.top&&(B=this.tokenizer.paragraph(ee))){j=z[z.length-1],he&&j.type==="paragraph"?(j.raw+=`
`+B.raw,j.text+=`
`+B.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):z.push(B),he=ee.length!==I.length,I=I.substring(B.raw.length);continue}if(B=this.tokenizer.text(I)){I=I.substring(B.raw.length),j=z[z.length-1],j&&j.type==="text"?(j.raw+=`
`+B.raw,j.text+=`
`+B.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):z.push(B);continue}if(I){var fe="Infinite loop on byte: "+I.charCodeAt(0);if(this.options.silent){console.error(fe);break}else throw new Error(fe)}}return this.state.top=!0,z},H.inline=function(I,z){this.inlineQueue.push({src:I,tokens:z})},H.inlineTokens=function(I,z){var P=this;z===void 0&&(z=[]);var B,j,ee,he=I,fe,Ee,_e;if(this.tokens.links){var ke=Object.keys(this.tokens.links);if(ke.length>0)for(;(fe=this.tokenizer.rules.inline.reflinkSearch.exec(he))!=null;)ke.includes(fe[0].slice(fe[0].lastIndexOf("[")+1,-1))&&(he=he.slice(0,fe.index)+"["+ie("a",fe[0].length-2)+"]"+he.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(fe=this.tokenizer.rules.inline.blockSkip.exec(he))!=null;)he=he.slice(0,fe.index)+"["+ie("a",fe[0].length-2)+"]"+he.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(fe=this.tokenizer.rules.inline.escapedEmSt.exec(he))!=null;)he=he.slice(0,fe.index)+"++"+he.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;I;)if(Ee||(_e=""),Ee=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(B=ve.call({lexer:P},I,z))?(I=I.substring(B.raw.length),z.push(B),!0):!1}))){if(B=this.tokenizer.escape(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.tag(I)){I=I.substring(B.raw.length),j=z[z.length-1],j&&B.type==="text"&&j.type==="text"?(j.raw+=B.raw,j.text+=B.text):z.push(B);continue}if(B=this.tokenizer.link(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.reflink(I,this.tokens.links)){I=I.substring(B.raw.length),j=z[z.length-1],j&&B.type==="text"&&j.type==="text"?(j.raw+=B.raw,j.text+=B.text):z.push(B);continue}if(B=this.tokenizer.emStrong(I,he,_e)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.codespan(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.br(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.del(I)){I=I.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.autolink(I,J)){I=I.substring(B.raw.length),z.push(B);continue}if(!this.state.inLink&&(B=this.tokenizer.url(I,J))){I=I.substring(B.raw.length),z.push(B);continue}if(ee=I,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Pe=I.slice(1),Me=void 0;P.options.extensions.startInline.forEach(function(Ge){Me=Ge.call({lexer:this},Pe),typeof Me=="number"&&Me>=0&&(ve=Math.min(ve,Me))}),ve<1/0&&ve>=0&&(ee=I.substring(0,ve+1))}(),B=this.tokenizer.inlineText(ee,ye)){I=I.substring(B.raw.length),B.raw.slice(-1)!=="_"&&(_e=B.raw.slice(-1)),Ee=!0,j=z[z.length-1],j&&j.type==="text"?(j.raw+=B.raw,j.text+=B.text):z.push(B);continue}if(I){var Ie="Infinite loop on byte: "+I.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return z},v(O,null,[{key:"rules",get:function(){return{block:de,inline:ge}}}]),O}(),re=function(){function O($){this.options=$||Z.defaults}var H=O.prototype;return H.code=function(I,z,P){var B=(z||"").match(/\S*/)[0];if(this.options.highlight){var j=this.options.highlight(I,B);j!=null&&j!==I&&(P=!0,I=j)}return I=I.replace(/\n$/,"")+`
`,B?'<pre><code class="'+this.options.langPrefix+e(B,!0)+'">'+(P?I:e(I,!0))+`</code></pre>
`:"<pre><code>"+(P?I:e(I,!0))+`</code></pre>
`},H.blockquote=function(I){return`<blockquote>
`+I+`</blockquote>
`},H.html=function(I){return I},H.heading=function(I,z,P,B){if(this.options.headerIds){var j=this.options.headerPrefix+B.slug(P);return"<h"+z+' id="'+j+'">'+I+"</h"+z+`>
`}return"<h"+z+">"+I+"</h"+z+`>
`},H.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},H.list=function(I,z,P){var B=z?"ol":"ul",j=z&&P!==1?' start="'+P+'"':"";return"<"+B+j+`>
`+I+"</"+B+`>
`},H.listitem=function(I){return"<li>"+I+`</li>
`},H.checkbox=function(I){return"<input "+(I?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},H.paragraph=function(I){return"<p>"+I+`</p>
`},H.table=function(I,z){return z&&(z="<tbody>"+z+"</tbody>"),`<table>
<thead>
`+I+`</thead>
`+z+`</table>
`},H.tablerow=function(I){return`<tr>
`+I+`</tr>
`},H.tablecell=function(I,z){var P=z.header?"th":"td",B=z.align?"<"+P+' align="'+z.align+'">':"<"+P+">";return B+I+("</"+P+`>
`)},H.strong=function(I){return"<strong>"+I+"</strong>"},H.em=function(I){return"<em>"+I+"</em>"},H.codespan=function(I){return"<code>"+I+"</code>"},H.br=function(){return this.options.xhtml?"<br/>":"<br>"},H.del=function(I){return"<del>"+I+"</del>"},H.link=function(I,z,P){if(I=D(this.options.sanitize,this.options.baseUrl,I),I===null)return P;var B='<a href="'+e(I)+'"';return z&&(B+=' title="'+z+'"'),B+=">"+P+"</a>",B},H.image=function(I,z,P){if(I=D(this.options.sanitize,this.options.baseUrl,I),I===null)return P;var B='<img src="'+I+'" alt="'+P+'"';return z&&(B+=' title="'+z+'"'),B+=this.options.xhtml?"/>":">",B},H.text=function(I){return I},O}(),te=function(){function O(){}var H=O.prototype;return H.strong=function(I){return I},H.em=function(I){return I},H.codespan=function(I){return I},H.del=function(I){return I},H.html=function(I){return I},H.text=function(I){return I},H.link=function(I,z,P){return""+P},H.image=function(I,z,P){return""+P},H.br=function(){return""},O}(),le=function(){function O(){this.seen={}}var H=O.prototype;return H.serialize=function(I){return I.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},H.getNextSafeSlug=function(I,z){var P=I,B=0;if(this.seen.hasOwnProperty(P)){B=this.seen[I];do B++,P=I+"-"+B;while(this.seen.hasOwnProperty(P))}return z||(this.seen[I]=B,this.seen[P]=0),P},H.slug=function(I,z){z===void 0&&(z={});var P=this.serialize(I);return this.getNextSafeSlug(P,z.dryrun)},O}(),Q=function(){function O($){this.options=$||Z.defaults,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new te,this.slugger=new le}O.parse=function(I,z){var P=new O(z);return P.parse(I)},O.parseInline=function(I,z){var P=new O(z);return P.parseInline(I)};var H=O.prototype;return H.parse=function(I,z){z===void 0&&(z=!0);var P="",B,j,ee,he,fe,Ee,_e,ke,Ie,ve,Pe,Me,Ge,He,Ue,Je,je,Oe,x,oe=I.length;for(B=0;B<oe;B++){if(ve=I[B],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(x=this.options.extensions.renderers[ve.type].call({parser:this},ve),x!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){P+=x||"";continue}switch(ve.type){case"space":continue;case"hr":{P+=this.renderer.hr();continue}case"heading":{P+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,p(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{P+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(ke="",_e="",he=ve.header.length,j=0;j<he;j++)_e+=this.renderer.tablecell(this.parseInline(ve.header[j].tokens),{header:!0,align:ve.align[j]});for(ke+=this.renderer.tablerow(_e),Ie="",he=ve.rows.length,j=0;j<he;j++){for(Ee=ve.rows[j],_e="",fe=Ee.length,ee=0;ee<fe;ee++)_e+=this.renderer.tablecell(this.parseInline(Ee[ee].tokens),{header:!1,align:ve.align[ee]});Ie+=this.renderer.tablerow(_e)}P+=this.renderer.table(ke,Ie);continue}case"blockquote":{Ie=this.parse(ve.tokens),P+=this.renderer.blockquote(Ie);continue}case"list":{for(Pe=ve.ordered,Me=ve.start,Ge=ve.loose,he=ve.items.length,Ie="",j=0;j<he;j++)Ue=ve.items[j],Je=Ue.checked,je=Ue.task,He="",Ue.task&&(Oe=this.renderer.checkbox(Je),Ge?Ue.tokens.length>0&&Ue.tokens[0].type==="paragraph"?(Ue.tokens[0].text=Oe+" "+Ue.tokens[0].text,Ue.tokens[0].tokens&&Ue.tokens[0].tokens.length>0&&Ue.tokens[0].tokens[0].type==="text"&&(Ue.tokens[0].tokens[0].text=Oe+" "+Ue.tokens[0].tokens[0].text)):Ue.tokens.unshift({type:"text",text:Oe}):He+=Oe),He+=this.parse(Ue.tokens,Ge),Ie+=this.renderer.listitem(He,je,Je);P+=this.renderer.list(Ie,Pe,Me);continue}case"html":{P+=this.renderer.html(ve.text);continue}case"paragraph":{P+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Ie=ve.tokens?this.parseInline(ve.tokens):ve.text;B+1<oe&&I[B+1].type==="text";)ve=I[++B],Ie+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);P+=z?this.renderer.paragraph(Ie):Ie;continue}default:{var be='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(be);return}else throw new Error(be)}}}return P},H.parseInline=function(I,z){z=z||this.renderer;var P="",B,j,ee,he=I.length;for(B=0;B<he;B++){if(j=I[B],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[j.type]&&(ee=this.options.extensions.renderers[j.type].call({parser:this},j),ee!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(j.type))){P+=ee||"";continue}switch(j.type){case"escape":{P+=z.text(j.text);break}case"html":{P+=z.html(j.text);break}case"link":{P+=z.link(j.href,j.title,this.parseInline(j.tokens,z));break}case"image":{P+=z.image(j.href,j.title,j.text);break}case"strong":{P+=z.strong(this.parseInline(j.tokens,z));break}case"em":{P+=z.em(this.parseInline(j.tokens,z));break}case"codespan":{P+=z.codespan(j.text);break}case"br":{P+=z.br();break}case"del":{P+=z.del(this.parseInline(j.tokens,z));break}case"text":{P+=z.text(j.text);break}default:{var fe='Token with "'+j.type+'" type was not found.';if(this.options.silent){console.error(fe);return}else throw new Error(fe)}}}return P},O}();function S(O,H,$){if(typeof O=="undefined"||O===null)throw new Error("marked(): input parameter is undefined or null");if(typeof O!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(O)+", string expected");if(typeof H=="function"&&($=H,H=null),H=r({},S.defaults,H||{}),se(H),$){var I=H.highlight,z;try{z=De.lex(O,H)}catch(ee){return $(ee)}var P=function(he){var fe;if(!he)try{H.walkTokens&&S.walkTokens(z,H.walkTokens),fe=Q.parse(z,H)}catch(Ee){he=Ee}return H.highlight=I,he?$(he):$(null,fe)};if(!I||I.length<3||(delete H.highlight,!z.length))return P();var B=0;S.walkTokens(z,function(ee){ee.type==="code"&&(B++,setTimeout(function(){I(ee.text,ee.lang,function(he,fe){if(he)return P(he);fe!=null&&fe!==ee.text&&(ee.text=fe,ee.escaped=!0),B--,B===0&&P()})},0))}),B===0&&P();return}try{var j=De.lex(O,H);return H.walkTokens&&S.walkTokens(j,H.walkTokens),Q.parse(j,H)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,H.silent)return"<p>An error occurred:</p><pre>"+e(ee.message+"",!0)+"</pre>";throw ee}}S.options=S.setOptions=function(O){return r(S.defaults,O),w(S.defaults),S},S.getDefaults=y,S.defaults=Z.defaults,S.use=function(){for(var O=arguments.length,H=new Array(O),$=0;$<O;$++)H[$]=arguments[$];var I=r.apply(void 0,[{}].concat(H)),z=S.defaults.extensions||{renderers:{},childTokens:{}},P;H.forEach(function(B){if(B.extensions&&(P=!0,B.extensions.forEach(function(ee){if(!ee.name)throw new Error("extension name required");if(ee.renderer){var he=z.renderers?z.renderers[ee.name]:null;he?z.renderers[ee.name]=function(){for(var fe=arguments.length,Ee=new Array(fe),_e=0;_e<fe;_e++)Ee[_e]=arguments[_e];var ke=ee.renderer.apply(this,Ee);return ke===!1&&(ke=he.apply(this,Ee)),ke}:z.renderers[ee.name]=ee.renderer}if(ee.tokenizer){if(!ee.level||ee.level!=="block"&&ee.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");z[ee.level]?z[ee.level].unshift(ee.tokenizer):z[ee.level]=[ee.tokenizer],ee.start&&(ee.level==="block"?z.startBlock?z.startBlock.push(ee.start):z.startBlock=[ee.start]:ee.level==="inline"&&(z.startInline?z.startInline.push(ee.start):z.startInline=[ee.start]))}ee.childTokens&&(z.childTokens[ee.name]=ee.childTokens)})),B.renderer&&function(){var ee=S.defaults.renderer||new re,he=function(_e){var ke=ee[_e];ee[_e]=function(){for(var Ie=arguments.length,ve=new Array(Ie),Pe=0;Pe<Ie;Pe++)ve[Pe]=arguments[Pe];var Me=B.renderer[_e].apply(ee,ve);return Me===!1&&(Me=ke.apply(ee,ve)),Me}};for(var fe in B.renderer)he(fe);I.renderer=ee}(),B.tokenizer&&function(){var ee=S.defaults.tokenizer||new we,he=function(_e){var ke=ee[_e];ee[_e]=function(){for(var Ie=arguments.length,ve=new Array(Ie),Pe=0;Pe<Ie;Pe++)ve[Pe]=arguments[Pe];var Me=B.tokenizer[_e].apply(ee,ve);return Me===!1&&(Me=ke.apply(ee,ve)),Me}};for(var fe in B.tokenizer)he(fe);I.tokenizer=ee}(),B.walkTokens){var j=S.defaults.walkTokens;I.walkTokens=function(ee){B.walkTokens.call(this,ee),j&&j.call(this,ee)}}P&&(I.extensions=z),S.setOptions(I)})},S.walkTokens=function(O,H){for(var $=function(){var B=z.value;switch(H.call(S,B),B.type){case"table":{for(var j=M(B.header),ee;!(ee=j()).done;){var he=ee.value;S.walkTokens(he.tokens,H)}for(var fe=M(B.rows),Ee;!(Ee=fe()).done;)for(var _e=Ee.value,ke=M(_e),Ie;!(Ie=ke()).done;){var ve=Ie.value;S.walkTokens(ve.tokens,H)}break}case"list":{S.walkTokens(B.items,H);break}default:S.defaults.extensions&&S.defaults.extensions.childTokens&&S.defaults.extensions.childTokens[B.type]?S.defaults.extensions.childTokens[B.type].forEach(function(Pe){S.walkTokens(B[Pe],H)}):B.tokens&&S.walkTokens(B.tokens,H)}},I=M(O),z;!(z=I()).done;)$()},S.parseInline=function(O,H){if(typeof O=="undefined"||O===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof O!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(O)+", string expected");H=r({},S.defaults,H||{}),se(H);try{var $=De.lexInline(O,H);return H.walkTokens&&S.walkTokens($,H.walkTokens),Q.parseInline($,H)}catch(I){if(I.message+=`
Please report this to https://github.com/markedjs/marked.`,H.silent)return"<p>An error occurred:</p><pre>"+e(I.message+"",!0)+"</pre>";throw I}},S.Parser=Q,S.parser=Q.parse,S.Renderer=re,S.TextRenderer=te,S.Lexer=De,S.lexer=De.lex,S.Tokenizer=we,S.Slugger=le,S.parse=S;var K=S.options,G=S.setOptions,k=S.use,h=S.walkTokens,L=S.parseInline,U=S,q=Q.parse,W=De.lex;Z.Lexer=De,Z.Parser=Q,Z.Renderer=re,Z.Slugger=le,Z.TextRenderer=te,Z.Tokenizer=we,Z.getDefaults=y,Z.lexer=W,Z.marked=S,Z.options=K,Z.parse=U,Z.parseInline=L,Z.parser=q,Z.setOptions=G,Z.use=k,Z.walkTokens=h,Object.defineProperty(Z,"__esModule",{value:!0})}),define(me[76],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class v{constructor(R,M=0,y=R.length,w=M-1){this.items=R,this.start=M,this.end=y,this.index=w}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}t.ArrayNavigator=v}),define(me[77],pe([1,0,76]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class i{constructor(y=[],w=10){this._initialize(y),this._limit=w,this._onChange()}getHistory(){return this._elements}add(y){this._history.delete(y),this._history.add(y),this._onChange()}next(){return this._currentPosition()!==this._elements.length-1?this._navigator.next():null}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}has(y){return this._history.has(y)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const y=this._elements;this._navigator=new v.ArrayNavigator(y,0,y.length,y.length)}_reduceToLimit(){const y=this._elements;y.length>this._limit&&this._initialize(y.slice(y.length-this._limit))}_currentPosition(){const y=this._navigator.current();return y?this._elements.indexOf(y):-1}_initialize(y){this._history=new Set;for(const w of y)this._history.add(w)}get _elements(){const y=[];return this._history.forEach(w=>y.push(w)),y}}t.HistoryNavigator=i;class R{constructor(y,w=10){if(this.capacity=w,y.length<1)throw new Error("not supported");this.size=1,this.head=this.tail=this.cursor={value:y[0],previous:void 0,next:void 0};for(let m=1;m<y.length;m++)this.add(y[m])}add(y){const w={value:y,previous:this.tail,next:void 0};for(this.tail.next=w,this.tail=w,this.cursor=this.tail,this.size++;this.size>this.capacity;)this.head=this.head.next,this.head.previous=void 0,this.size--}replaceLast(y){const w=this.tail.value;return this.tail.value=y,w}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(y){let w=this.head;for(;w;){if(w.value===y)return!0;w=w.next}return!1}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let y=this.head;for(;y;)yield y.value,y=y.next}}t.HistoryNavigator2=R}),define(me[44],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function v(w,m,f){return Math.min(Math.max(w,m),f)}t.clamp=v;function i(w,m){return(m+w%m)%m}t.rot=i;class R{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=R;class M{constructor(){this._n=1,this._val=0}update(m){return this._val=this._val+(m-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=M;class y{constructor(m){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(m),this._values.fill(0,0,m)}update(m){const f=this._values[this._index];return this._values[this._index]=m,this._index=(this._index+1)%this._values.length,this._sum-=f,this._sum+=m,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=y}),define(me[45],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var v;(function(i){function R(m,f){if(m.start>=f.end||f.start>=m.end)return{start:0,end:0};const b=Math.max(m.start,f.start),F=Math.min(m.end,f.end);return F-b<=0?{start:0,end:0}:{start:b,end:F}}i.intersect=R;function M(m){return m.end-m.start<=0}i.isEmpty=M;function y(m,f){return!M(R(m,f))}i.intersects=y;function w(m,f){const b=[],F={start:m.start,end:Math.min(f.start,m.end)},a={start:Math.max(f.end,m.start),end:m.end};return M(F)||b.push(F),M(a)||b.push(a),b}i.relativeComplement=w})(v=t.Range||(t.Range={}))}),define(me[78],pe([1,0,45]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function i(m,f){const b=[];for(const F of f){if(m.start>=F.range.end)continue;if(m.end<F.range.start)break;const a=v.Range.intersect(m,F.range);v.Range.isEmpty(a)||b.push({range:a,size:F.size})}return b}t.groupIntersect=i;function R({start:m,end:f},b){return{start:m+b,end:f+b}}t.shift=R;function M(m){const f=[];let b=null;for(const F of m){const a=F.range.start,n=F.range.end,e=F.size;if(b&&e===b.size){b.range.end=n;continue}b={range:{start:a,end:n},size:e},f.push(b)}return f}t.consolidate=M;function y(...m){return M(m.reduce((f,b)=>f.concat(b),[]))}class w{constructor(){this.groups=[],this._size=0}splice(f,b,F=[]){const a=F.length-b,n=i({start:0,end:f},this.groups),e=i({start:f+b,end:Number.POSITIVE_INFINITY},this.groups).map(p=>({range:R(p.range,a),size:p.size})),d=F.map((p,_)=>({range:{start:f+_,end:f+_+1},size:p.size}));this.groups=y(n,d,e),this._size=this.groups.reduce((p,_)=>p+_.size*(_.range.end-_.range.start),0)}get count(){const f=this.groups.length;return f?this.groups[f-1].range.end:0}get size(){return this._size}indexAt(f){if(f<0)return-1;let b=0,F=0;for(const a of this.groups){const n=a.range.end-a.range.start,e=F+n*a.size;if(f<e)return b+Math.floor((f-F)/a.size);b+=n,F=e}return b}indexAfter(f){return Math.min(this.indexAt(f)+1,this.count)}positionAt(f){if(f<0)return-1;let b=0,F=0;for(const a of this.groups){const n=a.range.end-a.range.start,e=F+n;if(f<e)return b+(f-F)*a.size;b+=n*a.size,F=e}return-1}}t.RangeMap=w}),define(me[79],pe([1,0,13,2]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function R(g){const D=g;return D?typeof D.read=="function":!1}t.isReadable=R;function M(g){const D=g;return D?[D.on,D.pause,D.resume,D.destroy].every(A=>typeof A=="function"):!1}t.isReadableStream=M;function y(g){const D=g;return D?M(D.stream)&&Array.isArray(D.buffer)&&typeof D.ended=="boolean":!1}t.isReadableBufferedStream=y;function w(g,D){return new m(g,D)}t.newWriteableStream=w;class m{constructor(D,A){this.reducer=D,this.options=A,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(D){if(!this.state.destroyed){if(this.state.flowing)this.emitData(D);else if(this.buffer.data.push(D),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(A=>this.pendingWritePromises.push(A))}}error(D){this.state.destroyed||(this.state.flowing?this.emitError(D):this.buffer.error.push(D))}end(D){this.state.destroyed||(typeof D!="undefined"&&this.write(D),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(D){this.listeners.data.slice(0).forEach(A=>A(D))}emitError(D){this.listeners.error.length===0?(0,v.onUnexpectedError)(D):this.listeners.error.slice(0).forEach(A=>A(D))}emitEnd(){this.listeners.end.slice(0).forEach(D=>D())}on(D,A){if(!this.state.destroyed)switch(D){case"data":this.listeners.data.push(A),this.resume();break;case"end":this.listeners.end.push(A),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(A),this.state.flowing&&this.flowErrors();break}}removeListener(D,A){if(this.state.destroyed)return;let N;switch(D){case"data":N=this.listeners.data;break;case"end":N=this.listeners.end;break;case"error":N=this.listeners.error;break}if(N){const T=N.indexOf(A);T>=0&&N.splice(T,1)}}flowData(){if(this.buffer.data.length>0){const D=this.reducer(this.buffer.data);this.emitData(D),this.buffer.data.length=0;const A=[...this.pendingWritePromises];this.pendingWritePromises.length=0,A.forEach(N=>N())}}flowErrors(){if(this.listeners.error.length>0){for(const D of this.buffer.error)this.emitError(D);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(g,D){const A=[];let N;for(;(N=g.read())!==null;)A.push(N);return D(A)}t.consumeReadable=f;function b(g,D,A){const N=[];let T;for(;(T=g.read())!==null&&N.length<A;)N.push(T);return T===null&&N.length>0?D(N):{read:()=>{if(N.length>0)return N.shift();if(typeof T!="undefined"){const s=T;return T=void 0,s}return g.read()}}}t.peekReadable=b;function F(g,D){return new Promise((A,N)=>{const T=[];a(g,{onData:s=>{D&&T.push(s)},onError:s=>{D?N(s):A(void 0)},onEnd:()=>{A(D?D(T):void 0)}})})}t.consumeStream=F;function a(g,D){let A=!1;return g.on("error",N=>{A||D.onError(N)}),g.on("end",()=>{A||D.onEnd()}),g.on("data",N=>{A||D.onData(N)}),(0,i.toDisposable)(()=>A=!0)}t.listenStream=a;function n(g,D){return new Promise((A,N)=>{const T=new i.DisposableStore,s=[],l=c=>{if(s.push(c),s.length>D)return T.dispose(),g.pause(),A({stream:g,buffer:s,ended:!1})},o=c=>N(c),r=()=>A({stream:g,buffer:s,ended:!0});T.add((0,i.toDisposable)(()=>g.removeListener("error",o))),g.on("error",o),T.add((0,i.toDisposable)(()=>g.removeListener("end",r))),g.on("end",r),T.add((0,i.toDisposable)(()=>g.removeListener("data",l))),g.on("data",l)})}t.peekStream=n;function e(g,D){const A=w(D);return A.end(g),A}t.toStream=e;function d(){const g=w(()=>{throw new Error("not supported")});return g.end(),g}t.emptyStream=d;function p(g){let D=!1;return{read:()=>D?null:(D=!0,g)}}t.toReadable=p;function _(g,D,A){const N=w(A);return a(g,{onData:T=>N.write(D.data(T)),onError:T=>N.error(D.error?D.error(T):T),onEnd:()=>N.end()}),N}t.transform=_;function E(g,D,A){let N=!1;return{read:()=>{const T=D.read();return N?T:(N=!0,T!==null?A([g,T]):g)}}}t.prefixedReadable=E;function u(g,D,A){let N=!1;const T=w(A);return a(D,{onData:s=>N?T.write(s):(N=!0,T.write(A([g,s]))),onError:s=>T.error(s),onEnd:()=>{N||(N=!0,T.write(g)),T.end()}}),T}t.prefixedStream=u}),define(me[31],pe([1,0,79]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const i=typeof Buffer!="undefined";let R,M;class y{constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}static alloc(c){return i?new y(Buffer.allocUnsafe(c)):new y(new Uint8Array(c))}static wrap(c){return i&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new y(c)}static fromString(c,C){return!(C?.dontUseNodeBuffer||!1)&&i?new y(Buffer.from(c)):(R||(R=new TextEncoder),new y(R.encode(c)))}static fromByteArray(c){const C=y.alloc(c.length);for(let V=0,se=c.length;V<se;V++)C.buffer[V]=c[V];return C}static concat(c,C){if(typeof C=="undefined"){C=0;for(let ie=0,ae=c.length;ie<ae;ie++)C+=c[ie].byteLength}const V=y.alloc(C);let se=0;for(let ie=0,ae=c.length;ie<ae;ie++){const ne=c[ie];V.set(ne,se),se+=ne.byteLength}return V}clone(){const c=y.alloc(this.byteLength);return c.set(this),c}toString(){return i?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(c,C){return new y(this.buffer.subarray(c,C))}set(c,C){if(c instanceof y)this.buffer.set(c.buffer,C);else if(c instanceof Uint8Array)this.buffer.set(c,C);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),C);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return f(this.buffer,c)}writeUInt32BE(c,C){b(this.buffer,c,C)}readUInt32LE(c){return F(this.buffer,c)}writeUInt32LE(c,C){a(this.buffer,c,C)}readUInt8(c){return n(this.buffer,c)}writeUInt8(c,C){e(this.buffer,c,C)}}t.VSBuffer=y;function w(r,c){return r[c+0]<<0>>>0|r[c+1]<<8>>>0}t.readUInt16LE=w;function m(r,c,C){r[C+0]=c&255,c=c>>>8,r[C+1]=c&255}t.writeUInt16LE=m;function f(r,c){return r[c]*2**24+r[c+1]*2**16+r[c+2]*2**8+r[c+3]}t.readUInt32BE=f;function b(r,c,C){r[C+3]=c,c=c>>>8,r[C+2]=c,c=c>>>8,r[C+1]=c,c=c>>>8,r[C]=c}t.writeUInt32BE=b;function F(r,c){return r[c+0]<<0>>>0|r[c+1]<<8>>>0|r[c+2]<<16>>>0|r[c+3]<<24>>>0}t.readUInt32LE=F;function a(r,c,C){r[C+0]=c&255,c=c>>>8,r[C+1]=c&255,c=c>>>8,r[C+2]=c&255,c=c>>>8,r[C+3]=c&255}t.writeUInt32LE=a;function n(r,c){return r[c]}t.readUInt8=n;function e(r,c,C){r[C]=c}t.writeUInt8=e;function d(r){return v.consumeReadable(r,c=>y.concat(c))}t.readableToBuffer=d;function p(r){return v.toReadable(r)}t.bufferToReadable=p;function _(r){return v.consumeStream(r,c=>y.concat(c))}t.streamToBuffer=_;async function E(r){return r.ended?y.concat(r.buffer):y.concat([...r.buffer,await _(r.stream)])}t.bufferedStreamToBuffer=E;function u(r){return v.toStream(r,c=>y.concat(c))}t.bufferToStream=u;function g(r){return v.transform(r,{data:c=>typeof c=="string"?y.fromString(c):y.wrap(c)},c=>y.concat(c))}t.streamToBufferReadableStream=g;function D(r){return v.newWriteableStream(c=>y.concat(c),r)}t.newWriteableBufferStream=D;function A(r,c){return v.prefixedReadable(r,c,C=>y.concat(C))}t.prefixedBufferReadable=A;function N(r,c){return v.prefixedStream(r,c,C=>y.concat(C))}t.prefixedBufferStream=N;function T(r){let c=0,C=0,V=0;const se=new Uint8Array(Math.floor(r.length/4*3)),ie=ne=>{switch(C){case 3:se[V++]=c|ne,C=0;break;case 2:se[V++]=c|ne>>>2,c=ne<<6,C=3;break;case 1:se[V++]=c|ne>>>4,c=ne<<4,C=2;break;default:c=ne<<2,C=1}};for(let ne=0;ne<r.length;ne++){const we=r.charCodeAt(ne);if(we>=65&&we<=90)ie(we-65);else if(we>=97&&we<=122)ie(we-97+26);else if(we>=48&&we<=57)ie(we-48+52);else if(we===43||we===45)ie(62);else if(we===47||we===95)ie(63);else{if(we===61)break;throw new SyntaxError(`Unexpected base64 character ${r[ne]}`)}}const ae=V;for(;C>0;)ie(0);return y.wrap(se).slice(0,ae)}t.decodeBase64=T;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:r},c=!0,C=!1){const V=C?l:s;let se="";const ie=r.byteLength%3;let ae=0;for(;ae<r.byteLength-ie;ae+=3){const ne=r[ae+0],we=r[ae+1],de=r[ae+2];se+=V[ne>>>2],se+=V[(ne<<4|we>>>4)&63],se+=V[(we<<2|de>>>6)&63],se+=V[de&63]}if(ie===1){const ne=r[ae+0];se+=V[ne>>>2],se+=V[ne<<4&63],c&&(se+="==")}else if(ie===2){const ne=r[ae+0],we=r[ae+1];se+=V[ne>>>2],se+=V[(ne<<4|we>>>4)&63],se+=V[we<<2&63],c&&(se+="=")}return se}t.encodeBase64=o}),define(me[7],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.assertNever=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=t.isArray=void 0;function v(r){return Array.isArray(r)}t.isArray=v;function i(r){return typeof r=="string"}t.isString=i;function R(r){return Array.isArray(r)&&r.every(c=>i(c))}t.isStringArray=R;function M(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}t.isObject=M;function y(r){const c=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof c}t.isTypedArray=y;function w(r){return typeof r=="number"&&!isNaN(r)}t.isNumber=w;function m(r){return!!r&&typeof r[Symbol.iterator]=="function"}t.isIterable=m;function f(r){return r===!0||r===!1}t.isBoolean=f;function b(r){return typeof r=="undefined"}t.isUndefined=b;function F(r){return!a(r)}t.isDefined=F;function a(r){return b(r)||r===null}t.isUndefinedOrNull=a;function n(r,c){if(!r)throw new Error(c?`Unexpected type, expected '${c}'`:"Unexpected type")}t.assertType=n;function e(r){if(a(r))throw new Error("Assertion Failed: argument is undefined or null");return r}t.assertIsDefined=e;function d(...r){const c=[];for(let C=0;C<r.length;C++){const V=r[C];if(a(V))throw new Error(`Assertion Failed: argument at index ${C} is undefined or null`);c.push(V)}return c}t.assertAllDefined=d;const p=Object.prototype.hasOwnProperty;function _(r){if(!M(r))return!1;for(const c in r)if(p.call(r,c))return!1;return!0}t.isEmptyObject=_;function E(r){return typeof r=="function"}t.isFunction=E;function u(...r){return r.length>0&&r.every(E)}t.areFunctions=u;function g(r,c){const C=Math.min(r.length,c.length);for(let V=0;V<C;V++)D(r[V],c[V])}t.validateConstraints=g;function D(r,c){if(i(c)){if(typeof r!==c)throw new Error(`argument does not match constraint: typeof ${c}`)}else if(E(c)){try{if(r instanceof c)return}catch{}if(!a(r)&&r.constructor===c||c.length===1&&c.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=D;function A(r){let c=[],C=Object.getPrototypeOf(r);for(;Object.prototype!==C;)c=c.concat(Object.getOwnPropertyNames(C)),C=Object.getPrototypeOf(C);return c}t.getAllPropertyNames=A;function N(r){const c=[];for(const C of A(r))typeof r[C]=="function"&&c.push(C);return c}t.getAllMethodNames=N;function T(r,c){const C=se=>function(){const ie=Array.prototype.slice.call(arguments,0);return c(se,ie)},V={};for(const se of r)V[se]=C(se);return V}t.createProxyObject=T;function s(r){return r===null?void 0:r}t.withNullAsUndefined=s;function l(r){return typeof r=="undefined"?null:r}t.withUndefinedAsNull=l;function o(r,c="Unreachable"){throw new Error(c)}t.assertNever=o}),define(me[28],pe([1,0,7]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function i(e){if(!e||typeof e!="object"||e instanceof RegExp)return e;const d=Array.isArray(e)?[]:{};return Object.keys(e).forEach(p=>{e[p]&&typeof e[p]=="object"?d[p]=i(e[p]):d[p]=e[p]}),d}t.deepClone=i;function R(e){if(!e||typeof e!="object")return e;const d=[e];for(;d.length>0;){const p=d.shift();Object.freeze(p);for(const _ in p)if(M.call(p,_)){const E=p[_];typeof E=="object"&&!Object.isFrozen(E)&&!(0,v.isTypedArray)(E)&&d.push(E)}}return e}t.deepFreeze=R;const M=Object.prototype.hasOwnProperty;function y(e,d){return w(e,d,new Set)}t.cloneAndChange=y;function w(e,d,p){if((0,v.isUndefinedOrNull)(e))return e;const _=d(e);if(typeof _!="undefined")return _;if((0,v.isArray)(e)){const E=[];for(const u of e)E.push(w(u,d,p));return E}if((0,v.isObject)(e)){if(p.has(e))throw new Error("Cannot clone recursive data-structure");p.add(e);const E={};for(const u in e)M.call(e,u)&&(E[u]=w(e[u],d,p));return p.delete(e),E}return e}function m(e,d,p=!0){return(0,v.isObject)(e)?((0,v.isObject)(d)&&Object.keys(d).forEach(_=>{_ in e?p&&((0,v.isObject)(e[_])&&(0,v.isObject)(d[_])?m(e[_],d[_],p):e[_]=d[_]):e[_]=d[_]}),e):d}t.mixin=m;function f(e,d){if(e===d)return!0;if(e==null||d===null||d===void 0||typeof e!=typeof d||typeof e!="object"||Array.isArray(e)!==Array.isArray(d))return!1;let p,_;if(Array.isArray(e)){if(e.length!==d.length)return!1;for(p=0;p<e.length;p++)if(!f(e[p],d[p]))return!1}else{const E=[];for(_ in e)E.push(_);E.sort();const u=[];for(_ in d)u.push(_);if(u.sort(),!f(E,u))return!1;for(p=0;p<E.length;p++)if(!f(e[E[p]],d[E[p]]))return!1}return!0}t.equals=f;function b(e){const d=new Set;return JSON.stringify(e,(p,_)=>{if((0,v.isObject)(_)||Array.isArray(_)){if(d.has(_))return"[Circular]";d.add(_)}return _})}t.safeStringify=b;function F(e,d){const p=Object.create(null);return!e||!d||Object.keys(d).forEach(E=>{const u=e[E],g=d[E];f(u,g)||(p[E]=g)}),p}t.distinct=F;function a(e,d){const p=d.toLowerCase(),_=Object.keys(e).find(E=>E.toLowerCase()===p);return _?e[_]:e[d]}t.getCaseInsensitive=a;function n(e,d){const p=Object.create(null);for(const[_,E]of Object.entries(e))d(_,E)&&(p[_]=E);return p}t.filter=n}),define(me[80],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(me[81],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class v{constructor(R,M){this.sender=R,this.onMessage=M}send(R){try{this.sender.send("vscode:message",R.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}t.Protocol=v}),define(me[46],pe([8]),{}),define(me[82],pe([8]),{}),define(me[83],pe([8]),{}),define(me[84],pe([8]),{}),define(me[85],pe([1,0,11,83,84]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.formatRule=void 0;function i(R){let M=R.definition;for(;M instanceof v.Codicon;)M=M.definition;return`.codicon-${R.id}:before { content: '${M.fontCharacter}'; }`}t.formatRule=i}),define(me[86],pe([8]),{}),define(me[87],pe([8]),{}),define(me[88],pe([8]),{}),define(me[89],pe([8]),{}),define(me[90],pe([8]),{}),define(me[91],pe([8]),{}),define(me[92],pe([8]),{}),define(me[93],pe([8]),{}),define(me[94],pe([8]),{}),define(me[95],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(me[96],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/findinput/findInput",t)}),define(me[97],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(me[98],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(me[99],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(me[100],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(me[101],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/tree/abstractTree",t)}),define(me[102],pe([12,9]),function(Z,t){return Z.create("vs/base/common/actions",t)}),define(me[103],pe([12,9]),function(Z,t){return Z.create("vs/base/common/platform",t)}),define(me[5],pe([1,0,103]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=void 0;const i="en";let R=!1,M=!1,y=!1,w=!1,m=!1,f=!1,b=!1,F=!1,a=!1,n,e=i,d,p;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let _;typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.process!="undefined"?_=t.globals.vscode.process:typeof process!="undefined"&&(_=process);const E=typeof _?.versions?.electron=="string",u=E&&_?.type==="renderer";if(typeof navigator=="object"&&!u)p=navigator.userAgent,R=p.indexOf("Windows")>=0,M=p.indexOf("Macintosh")>=0,F=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=p.indexOf("Linux")>=0,f=!0,n=v.getConfiguredDefaultLocale(v.localize(0,null))||i,e=n;else if(typeof _=="object"){R=_.platform==="win32",M=_.platform==="darwin",y=_.platform==="linux",w=y&&!!_.env.SNAP&&!!_.env.SNAP_REVISION,b=E,a=!!_.env.CI||!!_.env.BUILD_ARTIFACTSTAGINGDIRECTORY,n=i,e=i;const r=_.env.VSCODE_NLS_CONFIG;if(r)try{const c=JSON.parse(r),C=c.availableLanguages["*"];n=c.locale,e=C||i,d=c._translationsConfigFile}catch{}m=!0}else console.error("Unable to resolve platform.");var g;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(g=t.Platform||(t.Platform={}));function D(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=D;let A=0;M?A=1:R?A=3:y&&(A=2),t.isWindows=R,t.isMacintosh=M,t.isLinux=y,t.isLinuxSnap=w,t.isNative=m,t.isElectron=b,t.isWeb=f,t.isWebWorker=f&&typeof t.globals.importScripts=="function",t.isIOS=F,t.isCI=a,t.platform=A,t.userAgent=p,t.language=e;var N;(function(r){function c(){return t.language}r.value=c;function C(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}r.isDefaultVariant=C;function V(){return t.language==="en"}r.isDefault=V})(N=t.Language||(t.Language={})),t.locale=n,t.translationsConfigFile=d,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const r=[];t.globals.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let V=0,se=r.length;V<se;V++){const ie=r[V];if(ie.id===C.data.vscodeScheduleAsyncWork){r.splice(V,1),ie.callback();return}}});let c=0;return C=>{const V=++c;r.push({id:V,callback:C}),t.globals.postMessage({vscodeScheduleAsyncWork:V},"*")}}return r=>setTimeout(r)})();var T;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(T=t.OperatingSystem||(t.OperatingSystem={})),t.OS=M||F?2:R?1:3;let s=!0,l=!1;function o(){if(!l){l=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,s=new Uint16Array(r.buffer)[0]===(2<<8)+1}return s}t.isLittleEndian=o,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(me[104],pe([1,0,5]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let i;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const R=v.globals.vscode.process;i={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=i.cwd,t.env=i.env,t.platform=i.platform,t.arch=i.arch}),define(me[21],pe([1,0,104]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const i=65,R=97,M=90,y=122,w=46,m=47,f=92,b=58,F=63;class a extends Error{constructor(g,D,A){let N;typeof D=="string"&&D.indexOf("not ")===0?(N="must not be",D=D.replace(/^not /,"")):N="must be";const T=g.indexOf(".")!==-1?"property":"argument";let s=`The "${g}" ${T} ${N} of type ${D}`;s+=`. Received type ${typeof A}`;super(s);this.code="ERR_INVALID_ARG_TYPE"}}function n(u,g){if(typeof u!="string")throw new a(g,"string",u)}function e(u){return u===m||u===f}function d(u){return u===m}function p(u){return u>=i&&u<=M||u>=R&&u<=y}function _(u,g,D,A){let N="",T=0,s=-1,l=0,o=0;for(let r=0;r<=u.length;++r){if(r<u.length)o=u.charCodeAt(r);else{if(A(o))break;o=m}if(A(o)){if(!(s===r-1||l===1))if(l===2){if(N.length<2||T!==2||N.charCodeAt(N.length-1)!==w||N.charCodeAt(N.length-2)!==w){if(N.length>2){const c=N.lastIndexOf(D);c===-1?(N="",T=0):(N=N.slice(0,c),T=N.length-1-N.lastIndexOf(D)),s=r,l=0;continue}else if(N.length!==0){N="",T=0,s=r,l=0;continue}}g&&(N+=N.length>0?`${D}..`:"..",T=2)}else N.length>0?N+=`${D}${u.slice(s+1,r)}`:N=u.slice(s+1,r),T=r-s-1;s=r,l=0}else o===w&&l!==-1?++l:l=-1}return N}function E(u,g){if(g===null||typeof g!="object")throw new a("pathObject","Object",g);const D=g.dir||g.root,A=g.base||`${g.name||""}${g.ext||""}`;return D?D===g.root?`${D}${A}`:`${D}${u}${A}`:A}t.win32={resolve(...u){let g="",D="",A=!1;for(let N=u.length-1;N>=-1;N--){let T;if(N>=0){if(T=u[N],n(T,"path"),T.length===0)continue}else g.length===0?T=v.cwd():(T=v.env[`=${g}`]||v.cwd(),(T===void 0||T.slice(0,2).toLowerCase()!==g.toLowerCase()&&T.charCodeAt(2)===f)&&(T=`${g}\\`));const s=T.length;let l=0,o="",r=!1;const c=T.charCodeAt(0);if(s===1)e(c)&&(l=1,r=!0);else if(e(c))if(r=!0,e(T.charCodeAt(1))){let C=2,V=C;for(;C<s&&!e(T.charCodeAt(C));)C++;if(C<s&&C!==V){const se=T.slice(V,C);for(V=C;C<s&&e(T.charCodeAt(C));)C++;if(C<s&&C!==V){for(V=C;C<s&&!e(T.charCodeAt(C));)C++;(C===s||C!==V)&&(o=`\\\\${se}\\${T.slice(V,C)}`,l=C)}}}else l=1;else p(c)&&T.charCodeAt(1)===b&&(o=T.slice(0,2),l=2,s>2&&e(T.charCodeAt(2))&&(r=!0,l=3));if(o.length>0)if(g.length>0){if(o.toLowerCase()!==g.toLowerCase())continue}else g=o;if(A){if(g.length>0)break}else if(D=`${T.slice(l)}\\${D}`,A=r,r&&g.length>0)break}return D=_(D,!A,"\\",e),A?`${g}\\${D}`:`${g}${D}`||"."},normalize(u){n(u,"path");const g=u.length;if(g===0)return".";let D=0,A,N=!1;const T=u.charCodeAt(0);if(g===1)return d(T)?"\\":u;if(e(T))if(N=!0,e(u.charCodeAt(1))){let l=2,o=l;for(;l<g&&!e(u.charCodeAt(l));)l++;if(l<g&&l!==o){const r=u.slice(o,l);for(o=l;l<g&&e(u.charCodeAt(l));)l++;if(l<g&&l!==o){for(o=l;l<g&&!e(u.charCodeAt(l));)l++;if(l===g)return`\\\\${r}\\${u.slice(o)}\\`;l!==o&&(A=`\\\\${r}\\${u.slice(o,l)}`,D=l)}}}else D=1;else p(T)&&u.charCodeAt(1)===b&&(A=u.slice(0,2),D=2,g>2&&e(u.charCodeAt(2))&&(N=!0,D=3));let s=D<g?_(u.slice(D),!N,"\\",e):"";return s.length===0&&!N&&(s="."),s.length>0&&e(u.charCodeAt(g-1))&&(s+="\\"),A===void 0?N?`\\${s}`:s:N?`${A}\\${s}`:`${A}${s}`},isAbsolute(u){n(u,"path");const g=u.length;if(g===0)return!1;const D=u.charCodeAt(0);return e(D)||g>2&&p(D)&&u.charCodeAt(1)===b&&e(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let g,D;for(let T=0;T<u.length;++T){const s=u[T];n(s,"path"),s.length>0&&(g===void 0?g=D=s:g+=`\\${s}`)}if(g===void 0)return".";let A=!0,N=0;if(typeof D=="string"&&e(D.charCodeAt(0))){++N;const T=D.length;T>1&&e(D.charCodeAt(1))&&(++N,T>2&&(e(D.charCodeAt(2))?++N:A=!1))}if(A){for(;N<g.length&&e(g.charCodeAt(N));)N++;N>=2&&(g=`\\${g.slice(N)}`)}return t.win32.normalize(g)},relative(u,g){if(n(u,"from"),n(g,"to"),u===g)return"";const D=t.win32.resolve(u),A=t.win32.resolve(g);if(D===A||(u=D.toLowerCase(),g=A.toLowerCase(),u===g))return"";let N=0;for(;N<u.length&&u.charCodeAt(N)===f;)N++;let T=u.length;for(;T-1>N&&u.charCodeAt(T-1)===f;)T--;const s=T-N;let l=0;for(;l<g.length&&g.charCodeAt(l)===f;)l++;let o=g.length;for(;o-1>l&&g.charCodeAt(o-1)===f;)o--;const r=o-l,c=s<r?s:r;let C=-1,V=0;for(;V<c;V++){const ie=u.charCodeAt(N+V);if(ie!==g.charCodeAt(l+V))break;ie===f&&(C=V)}if(V!==c){if(C===-1)return A}else{if(r>c){if(g.charCodeAt(l+V)===f)return A.slice(l+V+1);if(V===2)return A.slice(l+V)}s>c&&(u.charCodeAt(N+V)===f?C=V:V===2&&(C=3)),C===-1&&(C=0)}let se="";for(V=N+C+1;V<=T;++V)(V===T||u.charCodeAt(V)===f)&&(se+=se.length===0?"..":"\\..");return l+=C,se.length>0?`${se}${A.slice(l,o)}`:(A.charCodeAt(l)===f&&++l,A.slice(l,o))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const g=t.win32.resolve(u);if(g.length<=2)return u;if(g.charCodeAt(0)===f){if(g.charCodeAt(1)===f){const D=g.charCodeAt(2);if(D!==F&&D!==w)return`\\\\?\\UNC\\${g.slice(2)}`}}else if(p(g.charCodeAt(0))&&g.charCodeAt(1)===b&&g.charCodeAt(2)===f)return`\\\\?\\${g}`;return u},dirname(u){n(u,"path");const g=u.length;if(g===0)return".";let D=-1,A=0;const N=u.charCodeAt(0);if(g===1)return e(N)?u:".";if(e(N)){if(D=A=1,e(u.charCodeAt(1))){let l=2,o=l;for(;l<g&&!e(u.charCodeAt(l));)l++;if(l<g&&l!==o){for(o=l;l<g&&e(u.charCodeAt(l));)l++;if(l<g&&l!==o){for(o=l;l<g&&!e(u.charCodeAt(l));)l++;if(l===g)return u;l!==o&&(D=A=l+1)}}}}else p(N)&&u.charCodeAt(1)===b&&(D=g>2&&e(u.charCodeAt(2))?3:2,A=D);let T=-1,s=!0;for(let l=g-1;l>=A;--l)if(e(u.charCodeAt(l))){if(!s){T=l;break}}else s=!1;if(T===-1){if(D===-1)return".";T=D}return u.slice(0,T)},basename(u,g){g!==void 0&&n(g,"ext"),n(u,"path");let D=0,A=-1,N=!0,T;if(u.length>=2&&p(u.charCodeAt(0))&&u.charCodeAt(1)===b&&(D=2),g!==void 0&&g.length>0&&g.length<=u.length){if(g===u)return"";let s=g.length-1,l=-1;for(T=u.length-1;T>=D;--T){const o=u.charCodeAt(T);if(e(o)){if(!N){D=T+1;break}}else l===-1&&(N=!1,l=T+1),s>=0&&(o===g.charCodeAt(s)?--s==-1&&(A=T):(s=-1,A=l))}return D===A?A=l:A===-1&&(A=u.length),u.slice(D,A)}for(T=u.length-1;T>=D;--T)if(e(u.charCodeAt(T))){if(!N){D=T+1;break}}else A===-1&&(N=!1,A=T+1);return A===-1?"":u.slice(D,A)},extname(u){n(u,"path");let g=0,D=-1,A=0,N=-1,T=!0,s=0;u.length>=2&&u.charCodeAt(1)===b&&p(u.charCodeAt(0))&&(g=A=2);for(let l=u.length-1;l>=g;--l){const o=u.charCodeAt(l);if(e(o)){if(!T){A=l+1;break}continue}N===-1&&(T=!1,N=l+1),o===w?D===-1?D=l:s!==1&&(s=1):D!==-1&&(s=-1)}return D===-1||N===-1||s===0||s===1&&D===N-1&&D===A+1?"":u.slice(D,N)},format:E.bind(null,"\\"),parse(u){n(u,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return g;const D=u.length;let A=0,N=u.charCodeAt(0);if(D===1)return e(N)?(g.root=g.dir=u,g):(g.base=g.name=u,g);if(e(N)){if(A=1,e(u.charCodeAt(1))){let C=2,V=C;for(;C<D&&!e(u.charCodeAt(C));)C++;if(C<D&&C!==V){for(V=C;C<D&&e(u.charCodeAt(C));)C++;if(C<D&&C!==V){for(V=C;C<D&&!e(u.charCodeAt(C));)C++;C===D?A=C:C!==V&&(A=C+1)}}}}else if(p(N)&&u.charCodeAt(1)===b){if(D<=2)return g.root=g.dir=u,g;if(A=2,e(u.charCodeAt(2))){if(D===3)return g.root=g.dir=u,g;A=3}}A>0&&(g.root=u.slice(0,A));let T=-1,s=A,l=-1,o=!0,r=u.length-1,c=0;for(;r>=A;--r){if(N=u.charCodeAt(r),e(N)){if(!o){s=r+1;break}continue}l===-1&&(o=!1,l=r+1),N===w?T===-1?T=r:c!==1&&(c=1):T!==-1&&(c=-1)}return l!==-1&&(T===-1||c===0||c===1&&T===l-1&&T===s+1?g.base=g.name=u.slice(s,l):(g.name=u.slice(s,T),g.base=u.slice(s,l),g.ext=u.slice(T,l))),s>0&&s!==A?g.dir=u.slice(0,s-1):g.dir=g.root,g},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...u){let g="",D=!1;for(let A=u.length-1;A>=-1&&!D;A--){const N=A>=0?u[A]:v.cwd();n(N,"path"),N.length!==0&&(g=`${N}/${g}`,D=N.charCodeAt(0)===m)}return g=_(g,!D,"/",d),D?`/${g}`:g.length>0?g:"."},normalize(u){if(n(u,"path"),u.length===0)return".";const g=u.charCodeAt(0)===m,D=u.charCodeAt(u.length-1)===m;return u=_(u,!g,"/",d),u.length===0?g?"/":D?"./":".":(D&&(u+="/"),g?`/${u}`:u)},isAbsolute(u){return n(u,"path"),u.length>0&&u.charCodeAt(0)===m},join(...u){if(u.length===0)return".";let g;for(let D=0;D<u.length;++D){const A=u[D];n(A,"path"),A.length>0&&(g===void 0?g=A:g+=`/${A}`)}return g===void 0?".":t.posix.normalize(g)},relative(u,g){if(n(u,"from"),n(g,"to"),u===g||(u=t.posix.resolve(u),g=t.posix.resolve(g),u===g))return"";const D=1,A=u.length,N=A-D,T=1,s=g.length-T,l=N<s?N:s;let o=-1,r=0;for(;r<l;r++){const C=u.charCodeAt(D+r);if(C!==g.charCodeAt(T+r))break;C===m&&(o=r)}if(r===l)if(s>l){if(g.charCodeAt(T+r)===m)return g.slice(T+r+1);if(r===0)return g.slice(T+r)}else N>l&&(u.charCodeAt(D+r)===m?o=r:r===0&&(o=0));let c="";for(r=D+o+1;r<=A;++r)(r===A||u.charCodeAt(r)===m)&&(c+=c.length===0?"..":"/..");return`${c}${g.slice(T+o)}`},toNamespacedPath(u){return u},dirname(u){if(n(u,"path"),u.length===0)return".";const g=u.charCodeAt(0)===m;let D=-1,A=!0;for(let N=u.length-1;N>=1;--N)if(u.charCodeAt(N)===m){if(!A){D=N;break}}else A=!1;return D===-1?g?"/":".":g&&D===1?"//":u.slice(0,D)},basename(u,g){g!==void 0&&n(g,"ext"),n(u,"path");let D=0,A=-1,N=!0,T;if(g!==void 0&&g.length>0&&g.length<=u.length){if(g===u)return"";let s=g.length-1,l=-1;for(T=u.length-1;T>=0;--T){const o=u.charCodeAt(T);if(o===m){if(!N){D=T+1;break}}else l===-1&&(N=!1,l=T+1),s>=0&&(o===g.charCodeAt(s)?--s==-1&&(A=T):(s=-1,A=l))}return D===A?A=l:A===-1&&(A=u.length),u.slice(D,A)}for(T=u.length-1;T>=0;--T)if(u.charCodeAt(T)===m){if(!N){D=T+1;break}}else A===-1&&(N=!1,A=T+1);return A===-1?"":u.slice(D,A)},extname(u){n(u,"path");let g=-1,D=0,A=-1,N=!0,T=0;for(let s=u.length-1;s>=0;--s){const l=u.charCodeAt(s);if(l===m){if(!N){D=s+1;break}continue}A===-1&&(N=!1,A=s+1),l===w?g===-1?g=s:T!==1&&(T=1):g!==-1&&(T=-1)}return g===-1||A===-1||T===0||T===1&&g===A-1&&g===D+1?"":u.slice(g,A)},format:E.bind(null,"/"),parse(u){n(u,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return g;const D=u.charCodeAt(0)===m;let A;D?(g.root="/",A=1):A=0;let N=-1,T=0,s=-1,l=!0,o=u.length-1,r=0;for(;o>=A;--o){const c=u.charCodeAt(o);if(c===m){if(!l){T=o+1;break}continue}s===-1&&(l=!1,s=o+1),c===w?N===-1?N=o:r!==1&&(r=1):N!==-1&&(r=-1)}if(s!==-1){const c=T===0&&D?1:T;N===-1||r===0||r===1&&N===s-1&&N===T+1?g.base=g.name=u.slice(c,s):(g.name=u.slice(c,N),g.base=u.slice(c,s),g.ext=u.slice(N,s))}return T>0?g.dir=u.slice(0,T-1):D&&(g.dir="/"),g},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=v.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=v.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=v.platform==="win32"?t.win32.join:t.posix.join,t.resolve=v.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=v.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=v.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=v.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=v.platform==="win32"?t.win32.extname:t.posix.extname,t.format=v.platform==="win32"?t.win32.format:t.posix.format,t.parse=v.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=v.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=v.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=v.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),define(me[105],pe([1,0,21]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(b){const F=(0,v.extname)(b),a=i[F.toLowerCase()];return a!==void 0?a:y(b)}t.getMediaOrTextMime=M;function y(b){const F=(0,v.extname)(b);return R[F.toLowerCase()]}t.getMediaMime=y;function w(b){for(const F in R)if(R[F]===b)return F}t.getExtensionForMimeType=w;const m=/^(.+)\/(.+?)(;.+)?$/;function f(b,F){const a=m.exec(b);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:F?void 0:b}t.normalizeMimeType=f}),define(me[106],pe([1,0,5]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=v.globals.performance&&typeof v.globals.performance.now=="function";class R{constructor(y){this._highResolution=i&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new R(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}t.StopWatch=R}),define(me[3],pe([1,0,13,42,2,74,106]),function(Z,t,v,i,R,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0;const w=!1,m=!1;var f;(function(o){o.None=()=>R.Disposable.None;function r(h){if(m){const{onListenerDidAdd:L}=h,U=e.create();let q=0;h.onListenerDidAdd=()=>{++q==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),U.print()),L?.()}}}function c(h){return(L,U=null,q)=>{let W=!1,O;return O=h(H=>{if(!W)return O?O.dispose():W=!0,L.call(U,H)},null,q),W&&O.dispose(),O}}o.once=c;function C(h,L,U){return we((q,W=null,O)=>h(H=>q.call(W,L(H)),null,O),U)}o.map=C;function V(h,L,U){return we((q,W=null,O)=>h(H=>{L(H),q.call(W,H)},null,O),U)}o.forEach=V;function se(h,L,U){return we((q,W=null,O)=>h(H=>L(H)&&q.call(W,H),null,O),U)}o.filter=se;function ie(h){return h}o.signal=ie;function ae(...h){return(L,U=null,q)=>(0,R.combinedDisposable)(...h.map(W=>W(O=>L.call(U,O),null,q)))}o.any=ae;function ne(h,L,U,q){let W=U;return C(h,O=>(W=L(W,O),W),q)}o.reduce=ne;function we(h,L){let U;const q={onFirstListenerAdd(){U=h(W.fire,W)},onLastListenerRemove(){U?.dispose()}};L||r(q);const W=new p(q);return L?.add(W),W.event}function de(h,L,U=100,q=!1,W,O){let H,$,I,z=0;const P={leakWarningThreshold:W,onFirstListenerAdd(){H=h(j=>{z++,$=L($,j),q&&!I&&(B.fire($),$=void 0),clearTimeout(I),I=setTimeout(()=>{const ee=$;$=void 0,I=void 0,(!q||z>1)&&B.fire(ee),z=0},U)})},onLastListenerRemove(){H.dispose()}};O||r(P);const B=new p(P);return O?.add(B),B.event}o.debounce=de;function ge(h,L=(q,W)=>q===W,U){let q=!0,W;return se(h,O=>{const H=q||!L(O,W);return q=!1,W=O,H},U)}o.latch=ge;function ye(h,L,U){return[o.filter(h,L,U),o.filter(h,q=>!L(q),U)]}o.split=ye;function J(h,L=!1,U=[]){let q=U.slice(),W=h($=>{q?q.push($):H.fire($)});const O=()=>{q?.forEach($=>H.fire($)),q=null},H=new p({onFirstListenerAdd(){W||(W=h($=>H.fire($)))},onFirstListenerDidAdd(){q&&(L?setTimeout(O):O())},onLastListenerRemove(){W&&W.dispose(),W=null}});return H.event}o.buffer=J;class De{constructor(L){this.event=L,this.disposables=new R.DisposableStore}map(L){return new De(C(this.event,L,this.disposables))}forEach(L){return new De(V(this.event,L,this.disposables))}filter(L){return new De(se(this.event,L,this.disposables))}reduce(L,U){return new De(ne(this.event,L,U,this.disposables))}latch(){return new De(ge(this.event,void 0,this.disposables))}debounce(L,U=100,q=!1,W){return new De(de(this.event,L,U,q,W,this.disposables))}on(L,U,q){return this.event(L,U,q)}once(L,U,q){return c(this.event)(L,U,q)}dispose(){this.disposables.dispose()}}function re(h){return new De(h)}o.chain=re;function te(h,L,U=q=>q){const q=(...$)=>H.fire(U(...$)),W=()=>h.on(L,q),O=()=>h.removeListener(L,q),H=new p({onFirstListenerAdd:W,onLastListenerRemove:O});return H.event}o.fromNodeEventEmitter=te;function le(h,L,U=q=>q){const q=(...$)=>H.fire(U(...$)),W=()=>h.addEventListener(L,q),O=()=>h.removeEventListener(L,q),H=new p({onFirstListenerAdd:W,onLastListenerRemove:O});return H.event}o.fromDOMEventEmitter=le;function Q(h){return new Promise(L=>c(h)(L))}o.toPromise=Q;function S(h,L){return L(void 0),h(U=>L(U))}o.runAndSubscribe=S;function K(h,L){let U=null;function q(O){U?.dispose(),U=new R.DisposableStore,L(O,U)}q(void 0);const W=h(O=>q(O));return(0,R.toDisposable)(()=>{W.dispose(),U?.dispose()})}o.runAndSubscribeWithStore=K;class G{constructor(L,U){this.obs=L,this._counter=0,this._hasChanged=!1;const q={onFirstListenerAdd:()=>{L.addObserver(this)},onLastListenerRemove:()=>{L.removeObserver(this)}};U||r(q),this.emitter=new p(q),U&&U.add(this.emitter)}beginUpdate(L){this._counter++}handleChange(L,U){this._hasChanged=!0}endUpdate(L){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function k(h,L){return new G(h,L).emitter.event}o.fromObservable=k})(f=t.Event||(t.Event={}));class b{constructor(r){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${r}_${b._idPool++}`}start(r){this._stopWatch=new y.StopWatch(!0),this._listenerCount=r}stop(){if(this._stopWatch){const r=this._stopWatch.elapsed();this._elapsedOverall+=r,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${r.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}b._idPool=0;let F=-1;function a(o){const r=F;return F=o,{dispose(){F=r}}}t.setGlobalLeakWarningThreshold=a;class n{constructor(r,c=Math.random().toString(18).slice(2,5)){this.customThreshold=r,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(r,c){let C=F;if(typeof this.customThreshold=="number"&&(C=this.customThreshold),C<=0||c<C)return;this._stacks||(this._stacks=new Map);const V=this._stacks.get(r.value)||0;if(this._stacks.set(r.value,V+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=C*.5;let se,ie=0;for(const[ae,ne]of this._stacks)(!se||ie<ne)&&(se=ae,ie=ne);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${ie}):`),console.warn(se)}return()=>{const se=this._stacks.get(r.value)||0;this._stacks.set(r.value,se-1)}}}class e{constructor(r){this.value=r}static create(){return new e(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d{constructor(r,c,C){this.callback=r,this.callbackThis=c,this.stack=C,this.subscription=new R.SafeDisposable}invoke(r){this.callback.call(this.callbackThis,r)}}class p{constructor(r){this._disposed=!1,this._options=r,this._leakageMon=F>0?new n(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new b(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(w){const r=Array.from(this._listeners);queueMicrotask(()=>{for(const c of r)c.subscription.isset()&&(c.subscription.unset(),c.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(r,c,C)=>{this._listeners||(this._listeners=new M.LinkedList);const V=this._listeners.isEmpty();V&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let se,ie;this._leakageMon&&this._listeners.size>=30&&(ie=e.create(),se=this._leakageMon.check(ie,this._listeners.size+1)),w&&(ie=ie??e.create());const ae=new d(r,c,ie),ne=this._listeners.push(ae);V&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,r,c);const we=ae.subscription.set(()=>{se?.(),this._disposed||(ne(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return C instanceof R.DisposableStore?C.add(we):Array.isArray(C)&&C.push(we),we}),this._event}fire(r){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new E);for(const c of this._listeners)this._deliveryQueue.push(this,c,r);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}t.Emitter=p;class _{constructor(){this._queue=new M.LinkedList}get size(){return this._queue.size}push(r,c,C){this._queue.push(new u(r,c,C))}clear(r){const c=new M.LinkedList;for(const C of this._queue)C.emitter!==r&&c.push(C);this._queue=c}deliver(){for(;this._queue.size>0;){const r=this._queue.shift();try{r.listener.invoke(r.event)}catch(c){(0,v.onUnexpectedError)(c)}}}}t.EventDeliveryQueue=_;class E extends _{clear(r){this._queue.clear()}}class u{constructor(r,c,C){this.emitter=r,this.listener=c,this.event=C}}class g extends p{async fireAsync(r,c,C){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const V of this._listeners)this._asyncDeliveryQueue.push([V,r]);for(;this._asyncDeliveryQueue.size>0&&!c.isCancellationRequested;){const[V,se]=this._asyncDeliveryQueue.shift(),ie=[],ae={...se,token:c,waitUntil:ne=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");C&&(ne=C(ne,V.callback)),ie.push(ne)}};try{V.invoke(ae)}catch(ne){(0,v.onUnexpectedError)(ne);continue}Object.freeze(ie),await Promise.allSettled(ie).then(ne=>{for(const we of ne)we.status==="rejected"&&(0,v.onUnexpectedError)(we.reason)})}}}}t.AsyncEmitter=g;class D extends p{constructor(r){super(r);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=r?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const r=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(r))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(r){this._listeners&&(this._isPaused!==0?this._eventQueue.push(r):super.fire(r))}}t.PauseableEmitter=D;class A extends D{constructor(r){super(r);this._delay=r.delay??100}fire(r){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(r)}}t.DebounceEmitter=A;class N extends p{constructor(r){super(r);this._queuedEvents=[],this._mergeFn=r?.merge}fire(r){this._queuedEvents.push(r),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(c=>super.fire(c)),this._queuedEvents=[]})}}t.MicrotaskEmitter=N;class T{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new p({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(r){const c={event:r,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const C=()=>{this.hasListeners&&this.unhook(c);const V=this.events.indexOf(c);this.events.splice(V,1)};return(0,R.toDisposable)((0,i.once)(C))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(r=>this.hook(r))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(r=>this.unhook(r))}hook(r){r.listener=r.event(c=>this.emitter.fire(c))}unhook(r){r.listener&&r.listener.dispose(),r.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=T;class s{constructor(){this.buffers=[]}wrapEvent(r){return(c,C,V)=>r(se=>{const ie=this.buffers[this.buffers.length-1];ie?ie.push(()=>c.call(C,se)):c.call(C,se)},void 0,V)}bufferEvents(r){const c=[];this.buffers.push(c);const C=r();return this.buffers.pop(),c.forEach(V=>V()),C}}t.EventBufferer=s;class l{constructor(){this.listening=!1,this.inputEvent=f.None,this.inputEventListener=R.Disposable.None,this.emitter=new p({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(r){this.inputEvent=r,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=r(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=l}),define(me[15],pe([1,0,3,2]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class R{constructor(){this._zoomLevel=0,this._zoomFactor=1,this._fullscreen=!1,this._onDidChangeFullscreen=new v.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event}getZoomLevel(){return this._zoomLevel}setZoomLevel(u,g){this._zoomLevel!==u&&(this._zoomLevel=u)}getZoomFactor(){return this._zoomFactor}setZoomFactor(u){this._zoomFactor=u}setFullscreen(u){this._fullscreen!==u&&(this._fullscreen=u,this._onDidChangeFullscreen.fire())}isFullscreen(){return this._fullscreen}}R.INSTANCE=new R;class M extends i.Disposable{constructor(){super();this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this._listener=()=>this._handleChange(!0),this._mediaQueryList=null,this._handleChange(!1)}_handleChange(u){this._mediaQueryList?.removeEventListener("change",this._listener),this._mediaQueryList=matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this._mediaQueryList.addEventListener("change",this._listener),u&&this._onDidChange.fire()}}class y extends i.Disposable{constructor(){super();this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this._value=this._getPixelRatio();const u=this._register(new M);this._register(u.onDidChange(()=>{this._value=this._getPixelRatio(),this._onDidChange.fire(this._value)}))}get value(){return this._value}_getPixelRatio(){const u=document.createElement("canvas").getContext("2d"),g=window.devicePixelRatio||1,D=u.webkitBackingStorePixelRatio||u.mozBackingStorePixelRatio||u.msBackingStorePixelRatio||u.oBackingStorePixelRatio||u.backingStorePixelRatio||1;return g/D}}class w{constructor(){this._pixelRatioMonitor=null}_getOrCreatePixelRatioMonitor(){return this._pixelRatioMonitor||(this._pixelRatioMonitor=(0,i.markAsSingleton)(new y)),this._pixelRatioMonitor}get value(){return this._getOrCreatePixelRatioMonitor().value}get onDidChange(){return this._getOrCreatePixelRatioMonitor().onDidChange}}function m(E,u){typeof E=="string"&&(E=window.matchMedia(E)),E.addEventListener("change",u)}t.addMatchMediaChangeListener=m,t.PixelRatio=new w;function f(E,u){R.INSTANCE.setZoomLevel(E,u)}t.setZoomLevel=f;function b(){return R.INSTANCE.getZoomLevel()}t.getZoomLevel=b;function F(){return R.INSTANCE.getZoomFactor()}t.getZoomFactor=F;function a(E){R.INSTANCE.setZoomFactor(E)}t.setZoomFactor=a;function n(E){R.INSTANCE.setFullscreen(E)}t.setFullscreen=n;function e(){return R.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=R.INSTANCE.onDidChangeFullscreen;const d=navigator.userAgent;t.isFirefox=d.indexOf("Firefox")>=0,t.isWebKit=d.indexOf("AppleWebKit")>=0,t.isChrome=d.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&d.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=d.indexOf("Electron/")>=0,t.isAndroid=d.indexOf("Android")>=0;let p=!1;if(window.matchMedia){const E=window.matchMedia("(display-mode: standalone)");p=E.matches,m(E,({matches:u})=>{p=u})}function _(){return p}t.isStandalone=_}),define(me[107],pe([1,0,15,5]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var R;(function(M){M[M.Always=0]="Always",M[M.FullScreen=1]="FullScreen",M[M.None=2]="None"})(R=t.KeyboardSupport||(t.KeyboardSupport={})),t.BrowserFeatures={clipboard:{writeText:i.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.isNative||v.isStandalone()?0:navigator.keyboard||v.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(me[18],pe([1,0,3]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.stop=t.stopEvent=t.DomEmitter=void 0;class i{constructor(w,m,f){const b=F=>this.emitter.fire(F);this.emitter=new v.Emitter({onFirstListenerAdd:()=>w.addEventListener(m,b,f),onLastListenerRemove:()=>w.removeEventListener(m,b,f)})}get event(){return this.emitter.event}dispose(){this.emitter.dispose()}}t.DomEmitter=i;function R(y){return y.preventDefault(),y.stopPropagation(),y}t.stopEvent=R;function M(y){return v.Event.map(y,R)}t.stop=M}),define(me[19],pe([1,0,15,43,72,5]),function(Z,t,v,i,R,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function y(e){if(e.charCode){const p=String.fromCharCode(e.charCode).toUpperCase();return i.KeyCodeUtils.fromString(p)}const d=e.keyCode;if(d===3)return 7;if(v.isFirefox){if(d===59)return 80;if(d===107)return 81;if(d===109)return 83;if(M.isMacintosh&&d===224)return 57}else if(v.isWebKit){if(d===91)return 57;if(M.isMacintosh&&d===93)return 57;if(!M.isMacintosh&&d===92)return 57}return i.EVENT_KEY_CODE_MAP[d]||0}const w=M.isMacintosh?256:2048,m=512,f=1024,b=M.isMacintosh?2048:256;function F(e){const d=[];return e.ctrlKey&&d.push("ctrl"),e.shiftKey&&d.push("shift"),e.altKey&&d.push("alt"),e.metaKey&&d.push("meta"),`modifiers: [${d.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=F;function a(e){const d=[];return e.ctrlKey&&d.push("ctrl"),e.shiftKey&&d.push("shift"),e.altKey&&d.push("alt"),e.metaKey&&d.push("meta"),`modifiers: [${d.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${i.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=a;class n{constructor(d){this._standardKeyboardEventBrand=!0;const p=d;this.browserEvent=p,this.target=p.target,this.ctrlKey=p.ctrlKey,this.shiftKey=p.shiftKey,this.altKey=p.altKey,this.metaKey=p.metaKey,this.keyCode=y(p),this.code=p.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this._asKeybinding=this._computeKeybinding(),this._asRuntimeKeybinding=this._computeRuntimeKeybinding()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeybinding(){return this._asRuntimeKeybinding}equals(d){return this._asKeybinding===d}_computeKeybinding(){let d=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(d=this.keyCode);let p=0;return this.ctrlKey&&(p|=w),this.altKey&&(p|=m),this.shiftKey&&(p|=f),this.metaKey&&(p|=b),p|=d,p}_computeRuntimeKeybinding(){let d=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(d=this.keyCode),new R.SimpleKeybinding(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,d)}}t.StandardKeyboardEvent=n}),define(me[20],pe([1,0,15,65,5]),function(Z,t,v,i,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class M{constructor(f){this.timestamp=Date.now(),this.browserEvent=f,this.leftButton=f.button===0,this.middleButton=f.button===1,this.rightButton=f.button===2,this.buttons=f.buttons,this.target=f.target,this.detail=f.detail||1,f.type==="dblclick"&&(this.detail=2),this.ctrlKey=f.ctrlKey,this.shiftKey=f.shiftKey,this.altKey=f.altKey,this.metaKey=f.metaKey,typeof f.pageX=="number"?(this.posx=f.pageX,this.posy=f.pageY):(this.posx=f.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=f.clientY+document.body.scrollTop+document.documentElement.scrollTop);const b=i.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(self,f.view);this.posx-=b.left,this.posy-=b.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=M;class y extends M{constructor(f){super(f);this.dataTransfer=f.dataTransfer}}t.DragMouseEvent=y;class w{constructor(f,b=0,F=0){if(this.browserEvent=f||null,this.target=f?f.target||f.targetNode||f.srcElement:null,this.deltaY=F,this.deltaX=b,f){const a=f,n=f;if(typeof a.wheelDeltaY!="undefined")this.deltaY=a.wheelDeltaY/120;else if(typeof n.VERTICAL_AXIS!="undefined"&&n.axis===n.VERTICAL_AXIS)this.deltaY=-n.detail/3;else if(f.type==="wheel"){const e=f;e.deltaMode===e.DOM_DELTA_LINE?v.isFirefox&&!R.isMacintosh?this.deltaY=-f.deltaY/3:this.deltaY=-f.deltaY:this.deltaY=-f.deltaY/40}if(typeof a.wheelDeltaX!="undefined")v.isSafari&&R.isWindows?this.deltaX=-(a.wheelDeltaX/120):this.deltaX=a.wheelDeltaX/120;else if(typeof n.HORIZONTAL_AXIS!="undefined"&&n.axis===n.HORIZONTAL_AXIS)this.deltaX=-f.detail/3;else if(f.type==="wheel"){const e=f;e.deltaMode===e.DOM_DELTA_LINE?v.isFirefox&&!R.isMacintosh?this.deltaX=-f.deltaX/3:this.deltaX=-f.deltaX:this.deltaX=-f.deltaX/40}this.deltaY===0&&this.deltaX===0&&f.wheelDelta&&(this.deltaY=f.wheelDelta/120)}}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation()}}t.StandardWheelEvent=w}),define(me[32],pe([1,0,3,2,102]),function(Z,t,v,i,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class M extends i.Disposable{constructor(a,n="",e="",d=!0,p){super();this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=a,this._label=n,this._cssClass=e,this._enabled=d,this._actionCallback=p}get id(){return this._id}get label(){return this._label}set label(a){this._setLabel(a)}_setLabel(a){this._label!==a&&(this._label=a,this._onDidChange.fire({label:a}))}get tooltip(){return this._tooltip||""}set tooltip(a){this._setTooltip(a)}_setTooltip(a){this._tooltip!==a&&(this._tooltip=a,this._onDidChange.fire({tooltip:a}))}get class(){return this._cssClass}set class(a){this._setClass(a)}_setClass(a){this._cssClass!==a&&(this._cssClass=a,this._onDidChange.fire({class:a}))}get enabled(){return this._enabled}set enabled(a){this._setEnabled(a)}_setEnabled(a){this._enabled!==a&&(this._enabled=a,this._onDidChange.fire({enabled:a}))}get checked(){return this._checked}set checked(a){this._setChecked(a)}_setChecked(a){this._checked!==a&&(this._checked=a,this._onDidChange.fire({checked:a}))}async run(a,n){this._actionCallback&&await this._actionCallback(a)}}t.Action=M;class y extends i.Disposable{constructor(){super(...arguments);this._onBeforeRun=this._register(new v.Emitter),this.onBeforeRun=this._onBeforeRun.event,this._onDidRun=this._register(new v.Emitter),this.onDidRun=this._onDidRun.event}async run(a,n){if(!a.enabled)return;this._onBeforeRun.fire({action:a});let e;try{await this.runAction(a,n)}catch(d){e=d}this._onDidRun.fire({action:a,error:e})}async runAction(a,n){await a.run(n)}}t.ActionRunner=y;class w extends M{constructor(a){super(w.ID,a,a?"separator text":"separator");this.checked=!1,this.enabled=!1}static join(...a){let n=[];for(const e of a)e.length&&(n.length?n=[...n,new w,...e]:n=e);return n}}t.Separator=w,w.ID="vs.actions.separator";class m{constructor(a,n,e,d){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=n,this.class=d,this._actions=e}get actions(){return this._actions}dispose(){}async run(){}}t.SubmenuAction=m;class f extends M{constructor(){super(f.ID,R.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=f,f.ID="vs.actions.empty";function b(F){return{id:F.id,label:F.label,class:void 0,enabled:F.enabled??!0,checked:F.checked??!1,run:async()=>F.run(),tooltip:F.label,dispose:()=>{}}}t.toAction=b}),define(me[22],pe([1,0,3]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const i=Object.freeze(function(w,m){const f=setTimeout(w.bind(m),0);return{dispose(){clearTimeout(f)}}});var R;(function(w){function m(f){return f===w.None||f===w.Cancelled||f instanceof M?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}w.isCancellationToken=m,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(R=t.CancellationToken||(t.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(m){this._token=void 0,this._parentListener=void 0,this._parentListener=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=R.Cancelled}dispose(m=!1){m&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=R.None}}t.CancellationTokenSource=y}),define(me[108],pe([1,0,22]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class i{constructor(w){this.task=w,this.result=null}get(){if(this.result)return this.result;const w=new v.CancellationTokenSource,m=this.task(w.token);return this.result={promise:m,dispose:()=>{this.result=null,w.cancel(),w.dispose()}},this.result}}t.Cache=i;class R{constructor(w){this.fn=w,this.lastCache=void 0,this.lastArgKey=void 0}get(w){const m=JSON.stringify(w);return this.lastArgKey!==m&&(this.lastArgKey=m,this.lastCache=this.fn(w)),this.lastCache}}t.LRUCachedFunction=R;class M{constructor(w){this.fn=w,this._map=new Map}get cachedValues(){return this._map}get(w){if(this._map.has(w))return this._map.get(w);const m=this.fn(w);return this._map.set(w,m),m}}t.CachedFunction=M}),define(me[47],pe([1,0,3,2]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var R;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(R=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));class M{constructor(e,d,p,_,E,u,g){this._forceIntegerValues=e,this._scrollStateBrand=void 0,this._forceIntegerValues&&(d=d|0,p=p|0,_=_|0,E=E|0,u=u|0,g=g|0),this.rawScrollLeft=_,this.rawScrollTop=g,d<0&&(d=0),_+d>p&&(_=p-d),_<0&&(_=0),E<0&&(E=0),g+E>u&&(g=u-E),g<0&&(g=0),this.width=d,this.scrollWidth=p,this.scrollLeft=_,this.height=E,this.scrollHeight=u,this.scrollTop=g}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,d){return new M(this._forceIntegerValues,typeof e.width!="undefined"?e.width:this.width,typeof e.scrollWidth!="undefined"?e.scrollWidth:this.scrollWidth,d?this.rawScrollLeft:this.scrollLeft,typeof e.height!="undefined"?e.height:this.height,typeof e.scrollHeight!="undefined"?e.scrollHeight:this.scrollHeight,d?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new M(this._forceIntegerValues,this.width,this.scrollWidth,typeof e.scrollLeft!="undefined"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop!="undefined"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,d){const p=this.width!==e.width,_=this.scrollWidth!==e.scrollWidth,E=this.scrollLeft!==e.scrollLeft,u=this.height!==e.height,g=this.scrollHeight!==e.scrollHeight,D=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:d,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:p,scrollWidthChanged:_,scrollLeftChanged:E,heightChanged:u,scrollHeightChanged:g,scrollTopChanged:D}}}t.ScrollState=M;class y extends i.Disposable{constructor(e){super();this._scrollableBrand=void 0,this._onScroll=this._register(new v.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=e.smoothScrollDuration,this._scheduleAtNextAnimationFrame=e.scheduleAtNextAnimationFrame,this._state=new M(e.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(e){this._smoothScrollDuration=e}validateScrollPosition(e){return this._state.withScrollPosition(e)}getScrollDimensions(){return this._state}setScrollDimensions(e,d){const p=this._state.withScrollDimensions(e,d);this._setState(p,Boolean(this._smoothScrolling)),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(e){const d=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(d,!1)}setScrollPositionSmooth(e,d){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:typeof e.scrollLeft=="undefined"?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop=="undefined"?this._smoothScrolling.to.scrollTop:e.scrollTop};const p=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===p.scrollLeft&&this._smoothScrolling.to.scrollTop===p.scrollTop)return;let _;d?_=new b(this._smoothScrolling.from,p,this._smoothScrolling.startTime,this._smoothScrolling.duration):_=this._smoothScrolling.combine(this._state,p,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=_}else{const p=this._state.withScrollPosition(e);this._smoothScrolling=b.start(this._state,p,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}_performSmoothScrolling(){if(!this._smoothScrolling)return;const e=this._smoothScrolling.tick(),d=this._state.withScrollPosition(e);if(this._setState(d,!0),!!this._smoothScrolling){if(e.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(e,d){const p=this._state;p.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(p,d)))}}t.Scrollable=y;class w{constructor(e,d,p){this.scrollLeft=e,this.scrollTop=d,this.isDone=p}}t.SmoothScrollingUpdate=w;function m(n,e){const d=e-n;return function(p){return n+d*a(p)}}function f(n,e,d){return function(p){return p<d?n(p/d):e((p-d)/(1-d))}}class b{constructor(e,d,p,_){this.from=e,this.to=d,this.duration=_,this.startTime=p,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(e,d,p){if(Math.abs(e-d)>2.5*p){let E,u;return e<d?(E=e+.75*p,u=d-.75*p):(E=e-.75*p,u=d+.75*p),f(m(e,E),m(u,d),.33)}return m(e,d)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(e){const d=(e-this.startTime)/this.duration;if(d<1){const p=this.scrollLeft(d),_=this.scrollTop(d);return new w(p,_,!1)}return new w(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,d,p){return b.start(e,d,p)}static start(e,d,p){p=p+10;const _=Date.now()-10;return new b(e,d,_,p)}}t.SmoothScrollingOperation=b;function F(n){return Math.pow(n,3)}function a(n){return 1-F(1-n)}}),define(me[10],pe([1,0,108,73]),function(Z,t,v,i){"use strict";var R;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function M(x){return!x||typeof x!="string"?!0:x.trim().length===0}t.isFalsyOrWhitespace=M;const y=/{(\d+)}/g;function w(x,...oe){return oe.length===0?x:x.replace(y,function(be,Ce){const Fe=parseInt(Ce,10);return isNaN(Fe)||Fe<0||Fe>=oe.length?be:oe[Fe]})}t.format=w;const m=/{([^}]+)}/g;function f(x,oe){return x.replace(m,(be,Ce)=>oe[Ce]??be)}t.format2=f;function b(x){return x.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}t.escape=b;function F(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=F;function a(x,oe){let be=0;const Ce=oe.charCodeAt(0);for(let Fe=x.length-1;Fe>=0;Fe--)x.charCodeAt(Fe)===Ce&&be++;return be}t.count=a;function n(x,oe,be="\u2026"){return x.length<=oe?x:`${x.substr(0,oe)}${be}`}t.truncate=n;function e(x,oe=" "){const be=d(x,oe);return p(be,oe)}t.trim=e;function d(x,oe){if(!x||!oe)return x;const be=oe.length;if(be===0||x.length===0)return x;let Ce=0;for(;x.indexOf(oe,Ce)===Ce;)Ce=Ce+be;return x.substring(Ce)}t.ltrim=d;function p(x,oe){if(!x||!oe)return x;const be=oe.length,Ce=x.length;if(be===0||Ce===0)return x;let Fe=Ce,Re=-1;for(;Re=x.lastIndexOf(oe,Fe-1),!(Re===-1||Re+be!==Fe);){if(Re===0)return"";Fe=Re}return x.substring(0,Fe)}t.rtrim=p;function _(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=_;function E(x){return x.replace(/\*/g,"")}t.stripWildcards=E;function u(x,oe,be={}){if(!x)throw new Error("Cannot create regex from empty string");oe||(x=F(x)),be.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let Ce="";return be.global&&(Ce+="g"),be.matchCase||(Ce+="i"),be.multiline&&(Ce+="m"),be.unicode&&(Ce+="u"),new RegExp(x,Ce)}t.createRegExp=u;function g(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}t.regExpLeadsToEndlessLoop=g;function D(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=D;function A(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}t.regExpFlags=A;function N(x){return x.split(/\r\n|\r|\n/)}t.splitLines=N;function T(x){for(let oe=0,be=x.length;oe<be;oe++){const Ce=x.charCodeAt(oe);if(Ce!==32&&Ce!==9)return oe}return-1}t.firstNonWhitespaceIndex=T;function s(x,oe=0,be=x.length){for(let Ce=oe;Ce<be;Ce++){const Fe=x.charCodeAt(Ce);if(Fe!==32&&Fe!==9)return x.substring(oe,Ce)}return x.substring(oe,be)}t.getLeadingWhitespace=s;function l(x,oe=x.length-1){for(let be=oe;be>=0;be--){const Ce=x.charCodeAt(be);if(Ce!==32&&Ce!==9)return be}return-1}t.lastNonWhitespaceIndex=l;function o(x,oe,be){const Ce=[];let Fe=0;for(const Re of x.matchAll(oe)){if(Ce.push(x.slice(Fe,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Fe=Re.index+Re[0].length,Ce.push(be(Re[0],...Re.slice(1),Re.index,x,Re.groups))}return Ce.push(x.slice(Fe)),Promise.all(Ce).then(Re=>Re.join(""))}t.replaceAsync=o;function r(x,oe){return x<oe?-1:x>oe?1:0}t.compare=r;function c(x,oe,be=0,Ce=x.length,Fe=0,Re=oe.length){for(;be<Ce&&Fe<Re;be++,Fe++){const Ye=x.charCodeAt(be),qe=oe.charCodeAt(Fe);if(Ye<qe)return-1;if(Ye>qe)return 1}const Ve=Ce-be,tt=Re-Fe;return Ve<tt?-1:Ve>tt?1:0}t.compareSubstring=c;function C(x,oe){return V(x,oe,0,x.length,0,oe.length)}t.compareIgnoreCase=C;function V(x,oe,be=0,Ce=x.length,Fe=0,Re=oe.length){for(;be<Ce&&Fe<Re;be++,Fe++){let Ye=x.charCodeAt(be),qe=oe.charCodeAt(Fe);if(Ye===qe)continue;if(Ye>=128||qe>=128)return c(x.toLowerCase(),oe.toLowerCase(),be,Ce,Fe,Re);ie(Ye)&&(Ye-=32),ie(qe)&&(qe-=32);const Le=Ye-qe;if(Le!==0)return Le}const Ve=Ce-be,tt=Re-Fe;return Ve<tt?-1:Ve>tt?1:0}t.compareSubstringIgnoreCase=V;function se(x){return x>=48&&x<=57}t.isAsciiDigit=se;function ie(x){return x>=97&&x<=122}t.isLowerAsciiLetter=ie;function ae(x){return x>=65&&x<=90}t.isUpperAsciiLetter=ae;function ne(x,oe){return x.length===oe.length&&V(x,oe)===0}t.equalsIgnoreCase=ne;function we(x,oe){const be=oe.length;return oe.length>x.length?!1:V(x,oe,0,be)===0}t.startsWithIgnoreCase=we;function de(x,oe){const be=Math.min(x.length,oe.length);let Ce;for(Ce=0;Ce<be;Ce++)if(x.charCodeAt(Ce)!==oe.charCodeAt(Ce))return Ce;return be}t.commonPrefixLength=de;function ge(x,oe){const be=Math.min(x.length,oe.length);let Ce;const Fe=x.length-1,Re=oe.length-1;for(Ce=0;Ce<be;Ce++)if(x.charCodeAt(Fe-Ce)!==oe.charCodeAt(Re-Ce))return Ce;return be}t.commonSuffixLength=ge;function ye(x){return 55296<=x&&x<=56319}t.isHighSurrogate=ye;function J(x){return 56320<=x&&x<=57343}t.isLowSurrogate=J;function De(x,oe){return(x-55296<<10)+(oe-56320)+65536}t.computeCodePoint=De;function re(x,oe,be){const Ce=x.charCodeAt(be);if(ye(Ce)&&be+1<oe){const Fe=x.charCodeAt(be+1);if(J(Fe))return De(Ce,Fe)}return Ce}t.getNextCodePoint=re;function te(x,oe){const be=x.charCodeAt(oe-1);if(J(be)&&oe>1){const Ce=x.charCodeAt(oe-2);if(ye(Ce))return De(Ce,be)}return be}class le{constructor(oe,be=0){this._str=oe,this._len=oe.length,this._offset=be}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=te(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=re(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}t.CodePointIterator=le;class Q{constructor(oe,be=0){this._iterator=new le(oe,be)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=Pe.getInstance(),be=this._iterator,Ce=be.offset;let Fe=oe.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Re=be.offset,Ve=oe.getGraphemeBreakType(be.nextCodePoint());if(Ie(Fe,Ve)){be.setOffset(Re);break}Fe=Ve}return be.offset-Ce}prevGraphemeLength(){const oe=Pe.getInstance(),be=this._iterator,Ce=be.offset;let Fe=oe.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Re=be.offset,Ve=oe.getGraphemeBreakType(be.prevCodePoint());if(Ie(Ve,Fe)){be.setOffset(Re);break}Fe=Ve}return Ce-be.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=Q;function S(x,oe){return new Q(x,oe).nextGraphemeLength()}t.nextCharLength=S;function K(x,oe){return new Q(x,oe).prevGraphemeLength()}t.prevCharLength=K;function G(x,oe){oe>0&&J(x.charCodeAt(oe))&&oe--;const be=oe+S(x,oe);return[be-K(x,be),be]}t.getCharContainingOffset=G;const k=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function h(x){return k.test(x)}t.containsRTL=h;const L=/^[\t\n\r\x20-\x7E]*$/;function U(x){return L.test(x)}t.isBasicASCII=U,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function q(x){return t.UNUSUAL_LINE_TERMINATORS.test(x)}t.containsUnusualLineTerminators=q;function W(x){return x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}t.isFullWidthCharacter=W;function O(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129008||x>=129280&&x<=129535||x>=129648&&x<=129782}t.isEmojiImprecise=O;function H(x,oe){if(x.length<oe)return x;const be=/\b/g;let Ce=0;for(;be.test(x)&&!(x.length-be.lastIndex<oe);)Ce=be.lastIndex,be.lastIndex+=1;return x.substring(Ce).replace(/^\s/,"")}t.lcut=H;const $=/\x1B\x5B[12]?K/g,I=/\x1b\[\d+m/g,z=/\x1b\[0?m/g;function P(x){return x&&(x=x.replace($,""),x=x.replace(I,""),x=x.replace(z,"")),x}t.removeAnsiEscapeCodes=P,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function B(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}t.startsWithUTF8BOM=B;function j(x){return B(x)?x.substr(1):x}t.stripUTF8BOM=j;function ee(x,oe){if(!x||!oe||x.length<oe.length)return!1;const be=oe.length,Ce=x.toLowerCase();let Fe=0,Re=-1;for(;Fe<be;){const Ve=Ce.indexOf(oe[Fe],Re+1);if(Ve<0)return!1;Re=Ve,Fe++}return!0}t.fuzzyContains=ee;function he(x,oe=!1){return x?(oe&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}t.containsUppercaseCharacter=he;function fe(x){return x.charAt(0).toUpperCase()+x.slice(1)}t.uppercaseFirstLetter=fe;function Ee(x,oe=1){if(oe===0)return"";let be=-1;do be=x.indexOf(`
`,be+1),oe--;while(oe>0&&be>=0);return be===-1?x:(x[be-1]==="\r"&&be--,x.substr(0,be))}t.getNLines=Ee;function _e(x){const oe=90-65+1;return x=x%(2*oe),x<oe?String.fromCharCode(97+x):String.fromCharCode(65+x-oe)}t.singleLetterHash=_e;function ke(x){return Pe.getInstance().getGraphemeBreakType(x)}t.getGraphemeBreakType=ke;function Ie(x,oe){return x===0?oe!==5&&oe!==7:x===2&&oe===3?!1:x===4||x===2||x===3||oe===4||oe===2||oe===3?!0:!(x===8&&(oe===8||oe===9||oe===11||oe===12)||(x===11||x===9)&&(oe===9||oe===10)||(x===12||x===10)&&oe===10||oe===5||oe===13||oe===7||x===1||x===13&&oe===14||x===6&&oe===6)}var ve;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(ve=t.GraphemeBreakType||(t.GraphemeBreakType={}));class Pe{constructor(){this._data=Me()}static getInstance(){return Pe._INSTANCE||(Pe._INSTANCE=new Pe),Pe._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const be=this._data,Ce=be.length/3;let Fe=1;for(;Fe<=Ce;)if(oe<be[3*Fe])Fe=2*Fe;else if(oe>be[3*Fe+1])Fe=2*Fe+1;else return be[3*Fe+2];return 0}}Pe._INSTANCE=null;function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(x,oe){if(x===0)return 0;const be=He(x,oe);if(be!==void 0)return be;const Ce=new le(oe,x);return Ce.prevCodePoint(),Ce.offset}t.getLeftDeleteOffset=Ge;function He(x,oe){const be=new le(oe,x);let Ce=be.prevCodePoint();for(;Ue(Ce)||Ce===65039||Ce===8419;){if(be.offset===0)return;Ce=be.prevCodePoint()}if(!O(Ce))return;let Fe=be.offset;return Fe>0&&be.prevCodePoint()===8205&&(Fe=be.offset),Fe}function Ue(x){return 127995<=x&&x<=127999}var Je;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(Je||(Je={})),t.noBreakWhitespace="\xA0";class je{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return je.cache.get(Array.from(oe))}static getLocales(){return je._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=je,R=je,je.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.cache=new v.LRUCachedFunction(x=>{function oe(qe){const Le=new Map;for(let ue=0;ue<qe.length;ue+=2)Le.set(qe[ue],qe[ue+1]);return Le}function be(qe,Le){const ue=new Map(qe);for(const[Se,Ne]of Le)ue.set(Se,Ne);return ue}function Ce(qe,Le){if(!qe)return Le;const ue=new Map;for(const[Se,Ne]of qe)Le.has(Se)&&ue.set(Se,Ne);return ue}const Fe=R.ambiguousCharacterData.getValue();let Re=x.filter(qe=>!qe.startsWith("_")&&qe in Fe);Re.length===0&&(Re=["_default"]);let Ve;for(const qe of Re){const Le=oe(Fe[qe]);Ve=Ce(Ve,Le)}const tt=oe(Fe._common),Ye=be(tt,Ve);return new je(Ye)}),je._locales=new i.Lazy(()=>Object.keys(je.ambiguousCharacterData.getValue()).filter(x=>!x.startsWith("_")));class Oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Oe.getRawData())),this._data}static isInvisibleCharacter(oe){return Oe.getData().has(oe)}static get codePoints(){return Oe.getData()}}t.InvisibleCharacters=Oe,Oe._data=void 0}),define(me[109],pe([1,0,21,5,10,7]),function(Z,t,v,i,R,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function y(l){return l===47||l===92}t.isPathSeparator=y;function w(l){return l.replace(/[\\/]/g,v.posix.sep)}t.toSlashes=w;function m(l){return l.indexOf("/")===-1&&(l=w(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}t.toPosixPath=m;function f(l,o=v.posix.sep){if(!l)return"";const r=l.length,c=l.charCodeAt(0);if(y(c)){if(y(l.charCodeAt(1))&&!y(l.charCodeAt(2))){let V=3;const se=V;for(;V<r&&!y(l.charCodeAt(V));V++);if(se!==V&&!y(l.charCodeAt(V+1))){for(V+=1;V<r;V++)if(y(l.charCodeAt(V)))return l.slice(0,V+1).replace(/[\\/]/g,o)}}return o}else if(_(c)&&l.charCodeAt(1)===58)return y(l.charCodeAt(2))?l.slice(0,2)+o:l.slice(0,2);let C=l.indexOf("://");if(C!==-1){for(C+=3;C<r;C++)if(y(l.charCodeAt(C)))return l.slice(0,C+1)}return""}t.getRoot=f;function b(l){if(!i.isWindows||!l||l.length<5)return!1;let o=l.charCodeAt(0);if(o!==92||(o=l.charCodeAt(1),o!==92))return!1;let r=2;const c=r;for(;r<l.length&&(o=l.charCodeAt(r),o!==92);r++);return!(c===r||(o=l.charCodeAt(r+1),isNaN(o)||o===92))}t.isUNC=b;const F=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,n=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(l,o=i.isWindows){const r=o?F:a;return!(!l||l.length===0||/^\s+$/.test(l)||(r.lastIndex=0,r.test(l))||o&&n.test(l)||l==="."||l===".."||o&&l[l.length-1]==="."||o&&l.length!==l.trim().length||l.length>255)}t.isValidBasename=e;function d(l,o,r){const c=l===o;return!r||c?c:!l||!o?!1:(0,R.equalsIgnoreCase)(l,o)}t.isEqual=d;function p(l,o,r,c=v.sep){if(l===o)return!0;if(!l||!o||o.length>l.length)return!1;if(r){if(!(0,R.startsWithIgnoreCase)(l,o))return!1;if(o.length===l.length)return!0;let V=o.length;return o.charAt(o.length-1)===c&&V--,l.charAt(V)===c}return o.charAt(o.length-1)!==c&&(o+=c),l.indexOf(o)===0}t.isEqualOrParent=p;function _(l){return l>=65&&l<=90||l>=97&&l<=122}t.isWindowsDriveLetter=_;function E(l,o){return i.isWindows&&l.endsWith(":")&&(l+=v.sep),(0,v.isAbsolute)(l)||(l=(0,v.join)(o,l)),l=(0,v.normalize)(l),i.isWindows?(l=(0,R.rtrim)(l,v.sep),l.endsWith(":")&&(l+=v.sep)):(l=(0,R.rtrim)(l,v.sep),l||(l=v.sep)),l}t.sanitizeFilePath=E;function u(l){const o=(0,v.normalize)(l);return i.isWindows?l.length>3?!1:g(o)&&(l.length===2||o.charCodeAt(2)===92):o===v.posix.sep}t.isRootOrDriveLetter=u;function g(l,o=i.isWindows){return o?_(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}t.hasDriveLetter=g;function D(l){return g(l)?l[0]:void 0}t.getDriveLetter=D;function A(l,o,r){return o.length>l.length?-1:l===o?0:(r&&(l=l.toLowerCase(),o=o.toLowerCase()),l.indexOf(o))}t.indexOfPath=A;function N(l){const o=l.split(":");let r,c,C;for(const V of o){const se=Number(V);(0,M.isNumber)(se)?c===void 0?c=se:C===void 0&&(C=se):r=r?[r,V].join(":"):V}if(!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:c!==void 0?c:void 0,column:C!==void 0?C:c!==void 0?1:void 0}}t.parseLineAndColumnAware=N;const T="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(l,o,r=8){let c="";for(let V=0;V<r;V++)c+=T.charAt(Math.floor(Math.random()*T.length));let C;return o?C=`${o}-${c}`:C=c,l?(0,v.join)(l,C):C}t.randomPath=s}),define(me[110],pe([1,0,10]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function i(_){return R(_,0)}t.hash=i;function R(_,E){switch(typeof _){case"object":return _===null?M(349,E):Array.isArray(_)?m(_,E):f(_,E);case"string":return w(_,E);case"boolean":return y(_,E);case"number":return M(_,E);case"undefined":return M(937,E);default:return M(617,E)}}t.doHash=R;function M(_,E){return(E<<5)-E+_|0}t.numberHash=M;function y(_,E){return M(_?433:863,E)}function w(_,E){E=M(149417,E);for(let u=0,g=_.length;u<g;u++)E=M(_.charCodeAt(u),E);return E}t.stringHash=w;function m(_,E){return E=M(104579,E),_.reduce((u,g)=>R(g,u),E)}function f(_,E){return E=M(181387,E),Object.keys(_).sort().reduce((u,g)=>(u=w(g,u),R(_[g],u)),E)}class b{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=R(E,this._value),this._value}}t.Hasher=b;var F;(function(_){_[_.BLOCK_SIZE=64]="BLOCK_SIZE",_[_.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(F||(F={}));function a(_,E,u=32){const g=u-E,D=~((1<<g)-1);return(_<<E|(D&_)>>>g)>>>0}function n(_,E=0,u=_.byteLength,g=0){for(let D=0;D<u;D++)_[E+D]=g}function e(_,E,u="0"){for(;_.length<E;)_=u+_;return _}function d(_,E=32){return _ instanceof ArrayBuffer?Array.from(new Uint8Array(_)).map(u=>u.toString(16).padStart(2,"0")).join(""):e((_>>>0).toString(16),E/4)}t.toHexString=d;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const u=E.length;if(u===0)return;const g=this._buff;let D=this._buffLen,A=this._leftoverHighSurrogate,N,T;for(A!==0?(N=A,T=-1,A=0):(N=E.charCodeAt(0),T=0);;){let s=N;if(v.isHighSurrogate(N))if(T+1<u){const l=E.charCodeAt(T+1);v.isLowSurrogate(l)?(T++,s=v.computeCodePoint(N,l)):s=65533}else{A=N;break}else v.isLowSurrogate(N)&&(s=65533);if(D=this._push(g,D,s),T++,T<u)N=E.charCodeAt(T);else break}this._buffLen=D,this._leftoverHighSurrogate=A}_push(E,u,g){return g<128?E[u++]=g:g<2048?(E[u++]=192|(g&1984)>>>6,E[u++]=128|(g&63)>>>0):g<65536?(E[u++]=224|(g&61440)>>>12,E[u++]=128|(g&4032)>>>6,E[u++]=128|(g&63)>>>0):(E[u++]=240|(g&1835008)>>>18,E[u++]=128|(g&258048)>>>12,E[u++]=128|(g&4032)>>>6,E[u++]=128|(g&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,n(this._buff,this._buffLen),this._buffLen>56&&(this._step(),n(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=p._bigBlock32,u=this._buffDV;for(let r=0;r<64;r+=4)E.setUint32(r,u.getUint32(r,!1),!1);for(let r=64;r<320;r+=4)E.setUint32(r,a(E.getUint32(r-12,!1)^E.getUint32(r-32,!1)^E.getUint32(r-56,!1)^E.getUint32(r-64,!1),1),!1);let g=this._h0,D=this._h1,A=this._h2,N=this._h3,T=this._h4,s,l,o;for(let r=0;r<80;r++)r<20?(s=D&A|~D&N,l=1518500249):r<40?(s=D^A^N,l=1859775393):r<60?(s=D&A|D&N|A&N,l=2400959708):(s=D^A^N,l=3395469782),o=a(g,5)+s+T+l+E.getUint32(r*4,!1)&4294967295,T=N,N=A,A=a(D,30),D=g,g=o;this._h0=this._h0+g&4294967295,this._h1=this._h1+D&4294967295,this._h2=this._h2+A&4294967295,this._h3=this._h3+N&4294967295,this._h4=this._h4+T&4294967295}}t.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[111],pe([1,0,70,110]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class R{constructor(a){this.source=a}getElements(){const a=this.source,n=new Int32Array(a.length);for(let e=0,d=a.length;e<d;e++)n[e]=a.charCodeAt(e);return n}}t.StringDiffSequence=R;function M(F,a,n){return new b(new R(F),new R(a)).ComputeDiff(n).changes}t.stringDiff=M;class y{static Assert(a,n){if(!a)throw new Error(n)}}t.Debug=y;class w{static Copy(a,n,e,d,p){for(let _=0;_<p;_++)e[d+_]=a[n+_]}static Copy2(a,n,e,d,p){for(let _=0;_<p;_++)e[d+_]=a[n+_]}}t.MyArray=w;var m;(function(F){F[F.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(m||(m={}));class f{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new v.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(a,n){this.m_originalStart=Math.min(this.m_originalStart,a),this.m_modifiedStart=Math.min(this.m_modifiedStart,n),this.m_originalCount++}AddModifiedElement(a,n){this.m_originalStart=Math.min(this.m_originalStart,a),this.m_modifiedStart=Math.min(this.m_modifiedStart,n),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class b{constructor(a,n,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=a,this._modifiedSequence=n;const[d,p,_]=b._getElements(a),[E,u,g]=b._getElements(n);this._hasStrings=_&&g,this._originalStringElements=d,this._originalElementsOrHash=p,this._modifiedStringElements=E,this._modifiedElementsOrHash=u,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(a){return a.length>0&&typeof a[0]=="string"}static _getElements(a){const n=a.getElements();if(b._isStringArray(n)){const e=new Int32Array(n.length);for(let d=0,p=n.length;d<p;d++)e[d]=(0,i.stringHash)(n[d],0);return[n,e,!0]}return n instanceof Int32Array?[[],n,!1]:[[],new Int32Array(n),!1]}ElementsAreEqual(a,n){return this._originalElementsOrHash[a]!==this._modifiedElementsOrHash[n]?!1:this._hasStrings?this._originalStringElements[a]===this._modifiedStringElements[n]:!0}ElementsAreStrictEqual(a,n){if(!this.ElementsAreEqual(a,n))return!1;const e=b._getStrictElement(this._originalSequence,a),d=b._getStrictElement(this._modifiedSequence,n);return e===d}static _getStrictElement(a,n){return typeof a.getStrictElement=="function"?a.getStrictElement(n):null}OriginalElementsAreEqual(a,n){return this._originalElementsOrHash[a]!==this._originalElementsOrHash[n]?!1:this._hasStrings?this._originalStringElements[a]===this._originalStringElements[n]:!0}ModifiedElementsAreEqual(a,n){return this._modifiedElementsOrHash[a]!==this._modifiedElementsOrHash[n]?!1:this._hasStrings?this._modifiedStringElements[a]===this._modifiedStringElements[n]:!0}ComputeDiff(a){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,a)}_ComputeDiff(a,n,e,d,p){const _=[!1];let E=this.ComputeDiffRecursive(a,n,e,d,_);return p&&(E=this.PrettifyChanges(E)),{quitEarly:_[0],changes:E}}ComputeDiffRecursive(a,n,e,d,p){for(p[0]=!1;a<=n&&e<=d&&this.ElementsAreEqual(a,e);)a++,e++;for(;n>=a&&d>=e&&this.ElementsAreEqual(n,d);)n--,d--;if(a>n||e>d){let A;return e<=d?(y.Assert(a===n+1,"originalStart should only be one more than originalEnd"),A=[new v.DiffChange(a,0,e,d-e+1)]):a<=n?(y.Assert(e===d+1,"modifiedStart should only be one more than modifiedEnd"),A=[new v.DiffChange(a,n-a+1,e,0)]):(y.Assert(a===n+1,"originalStart should only be one more than originalEnd"),y.Assert(e===d+1,"modifiedStart should only be one more than modifiedEnd"),A=[]),A}const _=[0],E=[0],u=this.ComputeRecursionPoint(a,n,e,d,_,E,p),g=_[0],D=E[0];if(u!==null)return u;if(!p[0]){const A=this.ComputeDiffRecursive(a,g,e,D,p);let N=[];return p[0]?N=[new v.DiffChange(g+1,n-(g+1)+1,D+1,d-(D+1)+1)]:N=this.ComputeDiffRecursive(g+1,n,D+1,d,p),this.ConcatenateChanges(A,N)}return[new v.DiffChange(a,n-a+1,e,d-e+1)]}WALKTRACE(a,n,e,d,p,_,E,u,g,D,A,N,T,s,l,o,r,c){let C=null,V=null,se=new f,ie=n,ae=e,ne=T[0]-o[0]-d,we=-1073741824,de=this.m_forwardHistory.length-1;do{const ge=ne+a;ge===ie||ge<ae&&g[ge-1]<g[ge+1]?(A=g[ge+1],s=A-ne-d,A<we&&se.MarkNextChange(),we=A,se.AddModifiedElement(A+1,s),ne=ge+1-a):(A=g[ge-1]+1,s=A-ne-d,A<we&&se.MarkNextChange(),we=A-1,se.AddOriginalElement(A,s+1),ne=ge-1-a),de>=0&&(g=this.m_forwardHistory[de],a=g[0],ie=1,ae=g.length-1)}while(--de>=-1);if(C=se.getReverseChanges(),c[0]){let ge=T[0]+1,ye=o[0]+1;if(C!==null&&C.length>0){const J=C[C.length-1];ge=Math.max(ge,J.getOriginalEnd()),ye=Math.max(ye,J.getModifiedEnd())}V=[new v.DiffChange(ge,N-ge+1,ye,l-ye+1)]}else{se=new f,ie=_,ae=E,ne=T[0]-o[0]-u,we=1073741824,de=r?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const ge=ne+p;ge===ie||ge<ae&&D[ge-1]>=D[ge+1]?(A=D[ge+1]-1,s=A-ne-u,A>we&&se.MarkNextChange(),we=A+1,se.AddOriginalElement(A+1,s+1),ne=ge+1-p):(A=D[ge-1],s=A-ne-u,A>we&&se.MarkNextChange(),we=A,se.AddModifiedElement(A+1,s+1),ne=ge-1-p),de>=0&&(D=this.m_reverseHistory[de],p=D[0],ie=1,ae=D.length-1)}while(--de>=-1);V=se.getChanges()}return this.ConcatenateChanges(C,V)}ComputeRecursionPoint(a,n,e,d,p,_,E){let u=0,g=0,D=0,A=0,N=0,T=0;a--,e--,p[0]=0,_[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const s=n-a+(d-e),l=s+1,o=new Int32Array(l),r=new Int32Array(l),c=d-e,C=n-a,V=a-e,se=n-d,ae=(C-c)%2==0;o[c]=a,r[C]=n,E[0]=!1;for(let ne=1;ne<=s/2+1;ne++){let we=0,de=0;D=this.ClipDiagonalBound(c-ne,ne,c,l),A=this.ClipDiagonalBound(c+ne,ne,c,l);for(let ye=D;ye<=A;ye+=2){ye===D||ye<A&&o[ye-1]<o[ye+1]?u=o[ye+1]:u=o[ye-1]+1,g=u-(ye-c)-V;const J=u;for(;u<n&&g<d&&this.ElementsAreEqual(u+1,g+1);)u++,g++;if(o[ye]=u,u+g>we+de&&(we=u,de=g),!ae&&Math.abs(ye-C)<=ne-1&&u>=r[ye])return p[0]=u,_[0]=g,J<=r[ye]&&1447>0&&ne<=1447+1?this.WALKTRACE(c,D,A,V,C,N,T,se,o,r,u,n,p,g,d,_,ae,E):null}const ge=(we-a+(de-e)-ne)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(we,ge))return E[0]=!0,p[0]=we,_[0]=de,ge>0&&1447>0&&ne<=1447+1?this.WALKTRACE(c,D,A,V,C,N,T,se,o,r,u,n,p,g,d,_,ae,E):(a++,e++,[new v.DiffChange(a,n-a+1,e,d-e+1)]);N=this.ClipDiagonalBound(C-ne,ne,C,l),T=this.ClipDiagonalBound(C+ne,ne,C,l);for(let ye=N;ye<=T;ye+=2){ye===N||ye<T&&r[ye-1]>=r[ye+1]?u=r[ye+1]-1:u=r[ye-1],g=u-(ye-C)-se;const J=u;for(;u>a&&g>e&&this.ElementsAreEqual(u,g);)u--,g--;if(r[ye]=u,ae&&Math.abs(ye-c)<=ne&&u<=o[ye])return p[0]=u,_[0]=g,J>=o[ye]&&1447>0&&ne<=1447+1?this.WALKTRACE(c,D,A,V,C,N,T,se,o,r,u,n,p,g,d,_,ae,E):null}if(ne<=1447){let ye=new Int32Array(A-D+2);ye[0]=c-D+1,w.Copy2(o,D,ye,1,A-D+1),this.m_forwardHistory.push(ye),ye=new Int32Array(T-N+2),ye[0]=C-N+1,w.Copy2(r,N,ye,1,T-N+1),this.m_reverseHistory.push(ye)}}return this.WALKTRACE(c,D,A,V,C,N,T,se,o,r,u,n,p,g,d,_,ae,E)}PrettifyChanges(a){for(let n=0;n<a.length;n++){const e=a[n],d=n<a.length-1?a[n+1].originalStart:this._originalElementsOrHash.length,p=n<a.length-1?a[n+1].modifiedStart:this._modifiedElementsOrHash.length,_=e.originalLength>0,E=e.modifiedLength>0;for(;e.originalStart+e.originalLength<d&&e.modifiedStart+e.modifiedLength<p&&(!_||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!E||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const g=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!g)break;e.originalStart++,e.modifiedStart++}const u=[null];if(n<a.length-1&&this.ChangesOverlap(a[n],a[n+1],u)){a[n]=u[0],a.splice(n+1,1),n--;continue}}for(let n=a.length-1;n>=0;n--){const e=a[n];let d=0,p=0;if(n>0){const A=a[n-1];d=A.originalStart+A.originalLength,p=A.modifiedStart+A.modifiedLength}const _=e.originalLength>0,E=e.modifiedLength>0;let u=0,g=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let A=1;;A++){const N=e.originalStart-A,T=e.modifiedStart-A;if(N<d||T<p||_&&!this.OriginalElementsAreEqual(N,N+e.originalLength)||E&&!this.ModifiedElementsAreEqual(T,T+e.modifiedLength))break;const l=(N===d&&T===p?5:0)+this._boundaryScore(N,e.originalLength,T,e.modifiedLength);l>g&&(g=l,u=A)}e.originalStart-=u,e.modifiedStart-=u;const D=[null];if(n>0&&this.ChangesOverlap(a[n-1],a[n],D)){a[n-1]=D[0],a.splice(n,1),n++;continue}}if(this._hasStrings)for(let n=1,e=a.length;n<e;n++){const d=a[n-1],p=a[n],_=p.originalStart-d.originalStart-d.originalLength,E=d.originalStart,u=p.originalStart+p.originalLength,g=u-E,D=d.modifiedStart,A=p.modifiedStart+p.modifiedLength,N=A-D;if(_<5&&g<20&&N<20){const T=this._findBetterContiguousSequence(E,g,D,N,_);if(T){const[s,l]=T;(s!==d.originalStart+d.originalLength||l!==d.modifiedStart+d.modifiedLength)&&(d.originalLength=s-d.originalStart,d.modifiedLength=l-d.modifiedStart,p.originalStart=s+_,p.modifiedStart=l+_,p.originalLength=u-p.originalStart,p.modifiedLength=A-p.modifiedStart)}}}return a}_findBetterContiguousSequence(a,n,e,d,p){if(n<p||d<p)return null;const _=a+n-p+1,E=e+d-p+1;let u=0,g=0,D=0;for(let A=a;A<_;A++)for(let N=e;N<E;N++){const T=this._contiguousSequenceScore(A,N,p);T>0&&T>u&&(u=T,g=A,D=N)}return u>0?[g,D]:null}_contiguousSequenceScore(a,n,e){let d=0;for(let p=0;p<e;p++){if(!this.ElementsAreEqual(a+p,n+p))return 0;d+=this._originalStringElements[a+p].length}return d}_OriginalIsBoundary(a){return a<=0||a>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[a])}_OriginalRegionIsBoundary(a,n){if(this._OriginalIsBoundary(a)||this._OriginalIsBoundary(a-1))return!0;if(n>0){const e=a+n;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(a){return a<=0||a>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[a])}_ModifiedRegionIsBoundary(a,n){if(this._ModifiedIsBoundary(a)||this._ModifiedIsBoundary(a-1))return!0;if(n>0){const e=a+n;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(a,n,e,d){const p=this._OriginalRegionIsBoundary(a,n)?1:0,_=this._ModifiedRegionIsBoundary(e,d)?1:0;return p+_}ConcatenateChanges(a,n){const e=[];if(a.length===0||n.length===0)return n.length>0?n:a;if(this.ChangesOverlap(a[a.length-1],n[0],e)){const d=new Array(a.length+n.length-1);return w.Copy(a,0,d,0,a.length-1),d[a.length-1]=e[0],w.Copy(n,1,d,a.length,n.length-1),d}else{const d=new Array(a.length+n.length);return w.Copy(a,0,d,0,a.length),w.Copy(n,0,d,a.length,n.length),d}}ChangesOverlap(a,n,e){if(y.Assert(a.originalStart<=n.originalStart,"Left change is not less than or equal to right change"),y.Assert(a.modifiedStart<=n.modifiedStart,"Left change is not less than or equal to right change"),a.originalStart+a.originalLength>=n.originalStart||a.modifiedStart+a.modifiedLength>=n.modifiedStart){const d=a.originalStart;let p=a.originalLength;const _=a.modifiedStart;let E=a.modifiedLength;return a.originalStart+a.originalLength>=n.originalStart&&(p=n.originalStart+n.originalLength-a.originalStart),a.modifiedStart+a.modifiedLength>=n.modifiedStart&&(E=n.modifiedStart+n.modifiedLength-a.modifiedStart),e[0]=new v.DiffChange(d,p,_,E),!0}else return e[0]=null,!1}ClipDiagonalBound(a,n,e,d){if(a>=0&&a<d)return a;const p=e,_=d-e-1,E=n%2==0;if(a<0){const u=p%2==0;return E===u?0:1}else{const u=_%2==0;return E===u?d-1:d-2}}}t.LcsDiff=b});var di=this&&this.__classPrivateFieldSet||function(Z,t,v,i,R){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof t=="function"?Z!==t||!R:!t.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?R.call(Z,v):R?R.value=v:t.set(Z,v),v},ut=this&&this.__classPrivateFieldGet||function(Z,t,v,i){if(v==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof t=="function"?Z!==t||!i:!t.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?i:v==="a"?i.call(Z):i?i.value:t.get(Z)};define(me[48],pe([1,0,14,10]),function(Z,t,v,i){"use strict";var R,M,y,w;Object.defineProperty(t,"__esModule",{value:!0}),t.ReadonlyMapView=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=t.setToString=t.mapToString=t.getOrSet=void 0;function m(l,o,r){let c=l.get(o);return c===void 0&&(c=r,l.set(o,c)),c}t.getOrSet=m;function f(l){const o=[];return l.forEach((r,c)=>{o.push(`${c} => ${r}`)}),`Map(${l.size}) {${o.join(", ")}}`}t.mapToString=f;function b(l){const o=[];return l.forEach(r=>{o.push(r)}),`Set(${l.size}) {${o.join(", ")}}`}t.setToString=b;class F{constructor(){this._value="",this._pos=0}reset(o){return this._value=o,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(o){const r=o.charCodeAt(0),c=this._value.charCodeAt(this._pos);return r-c}value(){return this._value[this._pos]}}t.StringIterator=F;class a{constructor(o=!0){this._caseSensitive=o}reset(o){return this._value=o,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(o)this._from++;else break;else o=!1;return this}cmp(o){return this._caseSensitive?(0,i.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=a;class n{constructor(o=!0,r=!0){this._splitOnBackslash=o,this._caseSensitive=r}reset(o){this._from=0,this._to=0,this._value=o,this._valueLen=o.length;for(let r=o.length-1;r>=0;r--,this._valueLen--){const c=this._value.charCodeAt(r);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let o=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(o)this._from++;else break;else o=!1}return this}cmp(o){return this._caseSensitive?(0,i.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=n;var e;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(e||(e={}));class d{constructor(o,r){this._ignorePathCasing=o,this._ignoreQueryAndFragment=r,this._states=[],this._stateIdx=0}reset(o){return this._value=o,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(o)),this._pathIterator.reset(o.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(o)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(o){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(o,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(o,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(o);if(this._states[this._stateIdx]===4)return(0,i.compare)(o,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(o,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}t.UriIterator=d;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const o=this.right;return this.right=o.left,o.left=this,this.updateHeight(),o.updateHeight(),o}rotateRight(){const o=this.left;return this.left=o.right,o.right=this,this.updateHeight(),o.updateHeight(),o}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var _;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(_||(_={}));class E{constructor(o){this._iter=o}static forUris(o=()=>!1,r=()=>!1){return new E(new d(o,r))}static forPaths(o=!1){return new E(new n(void 0,!o))}static forStrings(){return new E(new F)}static forConfigKeys(){return new E(new a)}clear(){this._root=void 0}fill(o,r){if(r){const c=r.slice(0);(0,v.shuffle)(c);for(const C of c)this.set(C,o)}else{const c=o.slice(0);(0,v.shuffle)(c);for(const C of c)this.set(C[0],C[1])}}set(o,r){const c=this._iter.reset(o);let C;this._root||(this._root=new p,this._root.segment=c.value());const V=[];for(C=this._root;;){const ie=c.cmp(C.segment);if(ie>0)C.left||(C.left=new p,C.left.segment=c.value()),V.push([-1,C]),C=C.left;else if(ie<0)C.right||(C.right=new p,C.right.segment=c.value()),V.push([1,C]),C=C.right;else if(c.hasNext())c.next(),C.mid||(C.mid=new p,C.mid.segment=c.value()),V.push([0,C]),C=C.mid;else break}const se=C.value;C.value=r,C.key=o;for(let ie=V.length-1;ie>=0;ie--){const ae=V[ie][1];ae.updateHeight();const ne=ae.balanceFactor();if(ne<-1||ne>1){const we=V[ie][0],de=V[ie+1][0];if(we===1&&de===1)V[ie][1]=ae.rotateLeft();else if(we===-1&&de===-1)V[ie][1]=ae.rotateRight();else if(we===1&&de===-1)ae.right=V[ie+1][1]=V[ie+1][1].rotateRight(),V[ie][1]=ae.rotateLeft();else if(we===-1&&de===1)ae.left=V[ie+1][1]=V[ie+1][1].rotateLeft(),V[ie][1]=ae.rotateRight();else throw new Error;if(ie>0)switch(V[ie-1][0]){case-1:V[ie-1][1].left=V[ie][1];break;case 1:V[ie-1][1].right=V[ie][1];break;case 0:V[ie-1][1].mid=V[ie][1];break}else this._root=V[0][1]}}return se}get(o){return this._getNode(o)?.value}_getNode(o){const r=this._iter.reset(o);let c=this._root;for(;c;){const C=r.cmp(c.segment);if(C>0)c=c.left;else if(C<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else break}return c}has(o){const r=this._getNode(o);return!(r?.value===void 0&&r?.mid===void 0)}delete(o){return this._delete(o,!1)}deleteSuperstr(o){return this._delete(o,!0)}_delete(o,r){const c=this._iter.reset(o),C=[];let V=this._root;for(;V;){const se=c.cmp(V.segment);if(se>0)C.push([-1,V]),V=V.left;else if(se<0)C.push([1,V]),V=V.right;else if(c.hasNext())c.next(),C.push([0,V]),V=V.mid;else break}if(!!V){if(r?(V.left=void 0,V.mid=void 0,V.right=void 0,V.height=1):(V.key=void 0,V.value=void 0),!V.mid&&!V.value)if(V.left&&V.right){const se=this._min(V.right),{key:ie,value:ae,segment:ne}=se;this._delete(se.key,!1),V.key=ie,V.value=ae,V.segment=ne}else{const se=V.left??V.right;if(C.length>0){const[ie,ae]=C[C.length-1];switch(ie){case-1:ae.left=se;break;case 0:ae.mid=se;break;case 1:ae.right=se;break}}else this._root=se}for(let se=C.length-1;se>=0;se--){const ie=C[se][1];ie.updateHeight();const ae=ie.balanceFactor();if(ae>1?(ie.right.balanceFactor()>=0||(ie.right=ie.right.rotateRight()),C[se][1]=ie.rotateLeft()):ae<-1&&(ie.left.balanceFactor()<=0||(ie.left=ie.left.rotateLeft()),C[se][1]=ie.rotateRight()),se>0)switch(C[se-1][0]){case-1:C[se-1][1].left=C[se][1];break;case 1:C[se-1][1].right=C[se][1];break;case 0:C[se-1][1].mid=C[se][1];break}else this._root=C[0][1]}}}_min(o){for(;o.left;)o=o.left;return o}findSubstr(o){const r=this._iter.reset(o);let c=this._root,C;for(;c;){const V=r.cmp(c.segment);if(V>0)c=c.left;else if(V<0)c=c.right;else if(r.hasNext())r.next(),C=c.value||C,c=c.mid;else break}return c&&c.value||C}findSuperstr(o){const r=this._iter.reset(o);let c=this._root;for(;c;){const C=r.cmp(c.segment);if(C>0)c=c.left;else if(C<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(o){for(const[r,c]of this)o(c,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(o){!o||(o.left&&(yield*this._entries(o.left)),o.value&&(yield[o.key,o.value]),o.mid&&(yield*this._entries(o.mid)),o.right&&(yield*this._entries(o.right)))}_isBalanced(){const o=r=>{if(!r)return!0;const c=r.balanceFactor();return c<-1||c>1?!1:o(r.left)&&o(r.right)};return o(this._root)}}t.TernarySearchTree=E;class u{constructor(o,r){this.uri=o,this.value=r}}class g{constructor(o,r){this[R]="ResourceMap",o instanceof g?(this.map=new Map(o.map),this.toKey=r??g.defaultToKey):(this.map=new Map,this.toKey=o??g.defaultToKey)}set(o,r){return this.map.set(this.toKey(o),new u(o,r)),this}get(o){return this.map.get(this.toKey(o))?.value}has(o){return this.map.has(this.toKey(o))}get size(){return this.map.size}clear(){this.map.clear()}delete(o){return this.map.delete(this.toKey(o))}forEach(o,r){typeof r!="undefined"&&(o=o.bind(r));for(const[c,C]of this.map)o(C.value,C.uri,this)}*values(){for(const o of this.map.values())yield o.value}*keys(){for(const o of this.map.values())yield o.uri}*entries(){for(const o of this.map.values())yield[o.uri,o.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.map)yield[o.uri,o.value]}}t.ResourceMap=g,g.defaultToKey=l=>l.toString();class D{constructor(o,r){this[M]="ResourceSet",!o||typeof o=="function"?this._map=new g(o):(this._map=new g(r),o.forEach(this.add,this))}get size(){return this._map.size}add(o){return this._map.set(o,o),this}clear(){this._map.clear()}delete(o){return this._map.delete(o)}forEach(o,r){this._map.forEach((c,C)=>o.call(r,C,C,this))}has(o){return this._map.has(o)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=D;var A;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(A=t.Touch||(t.Touch={}));class N{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(o){return this._map.has(o)}get(o,r=0){const c=this._map.get(o);if(!!c)return r!==0&&this.touch(c,r),c.value}set(o,r,c=0){let C=this._map.get(o);if(C)C.value=r,c!==0&&this.touch(C,c);else{switch(C={key:o,value:r,next:void 0,previous:void 0},c){case 0:this.addItemLast(C);break;case 1:this.addItemFirst(C);break;case 2:this.addItemLast(C);break;default:this.addItemLast(C);break}this._map.set(o,C),this._size++}return this}delete(o){return!!this.remove(o)}remove(o){const r=this._map.get(o);if(!!r)return this._map.delete(o),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const o=this._head;return this._map.delete(o.key),this.removeItem(o),this._size--,o.value}forEach(o,r){const c=this._state;let C=this._head;for(;C;){if(r?o.bind(r)(C.value,C.key,this):o(C.value,C.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");C=C.next}}keys(){const o=this,r=this._state;let c=this._head;const C={[Symbol.iterator](){return C},next(){if(o._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const V={value:c.key,done:!1};return c=c.next,V}else return{value:void 0,done:!0}}};return C}values(){const o=this,r=this._state;let c=this._head;const C={[Symbol.iterator](){return C},next(){if(o._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const V={value:c.value,done:!1};return c=c.next,V}else return{value:void 0,done:!0}}};return C}entries(){const o=this,r=this._state;let c=this._head;const C={[Symbol.iterator](){return C},next(){if(o._state!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const V={value:[c.key,c.value],done:!1};return c=c.next,V}else return{value:void 0,done:!0}}};return C}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(o){if(o>=this.size)return;if(o===0){this.clear();return}let r=this._head,c=this.size;for(;r&&c>o;)this._map.delete(r.key),r=r.next,c--;this._head=r,this._size=c,r&&(r.previous=void 0),this._state++}addItemFirst(o){if(!this._head&&!this._tail)this._tail=o;else if(this._head)o.next=this._head,this._head.previous=o;else throw new Error("Invalid list");this._head=o,this._state++}addItemLast(o){if(!this._head&&!this._tail)this._head=o;else if(this._tail)o.previous=this._tail,this._tail.next=o;else throw new Error("Invalid list");this._tail=o,this._state++}removeItem(o){if(o===this._head&&o===this._tail)this._head=void 0,this._tail=void 0;else if(o===this._head){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this._head=o.next}else if(o===this._tail){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this._tail=o.previous}else{const r=o.next,c=o.previous;if(!r||!c)throw new Error("Invalid list");r.previous=c,c.next=r}o.next=void 0,o.previous=void 0,this._state++}touch(o,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(o===this._head)return;const c=o.next,C=o.previous;o===this._tail?(C.next=void 0,this._tail=C):(c.previous=C,C.next=c),o.previous=void 0,o.next=this._head,this._head.previous=o,this._head=o,this._state++}else if(r===2){if(o===this._tail)return;const c=o.next,C=o.previous;o===this._head?(c.previous=void 0,this._head=c):(c.previous=C,C.next=c),o.next=void 0,o.previous=this._tail,this._tail.next=o,this._tail=o,this._state++}}}toJSON(){const o=[];return this.forEach((r,c)=>{o.push([c,r])}),o}fromJSON(o){this.clear();for(const[r,c]of o)this.set(r,c)}}t.LinkedMap=N;class T extends N{constructor(o,r=1){super();this._limit=o,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(o){this._limit=o,this.checkTrim()}get ratio(){return this._ratio}set ratio(o){this._ratio=Math.min(Math.max(0,o),1),this.checkTrim()}get(o,r=2){return super.get(o,r)}peek(o){return super.get(o,0)}set(o,r){return super.set(o,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=T;class s{constructor(o){w.set(this,void 0),di(this,w,o,"f")}get size(){return ut(this,w,"f").size}forEach(o,r){ut(this,w,"f").forEach(o,r)}get(o){return ut(this,w,"f").get(o)}has(o){return ut(this,w,"f").has(o)}entries(){return ut(this,w,"f").entries()}keys(){return ut(this,w,"f").keys()}values(){return ut(this,w,"f").values()}[(w=new WeakMap,Symbol.iterator)](){return ut(this,w,"f").entries()}}t.ReadonlyMapView=s}),define(me[33],pe([1,0,48,10]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function R(...P){return function(B,j){for(let ee=0,he=P.length;ee<he;ee++){const fe=P[ee](B,j);if(fe)return fe}return null}}t.or=R,t.matchesStrictPrefix=M.bind(void 0,!1),t.matchesPrefix=M.bind(void 0,!0);function M(P,B,j){if(!j||j.length<B.length)return null;let ee;return P?ee=i.startsWithIgnoreCase(j,B):ee=j.indexOf(B)===0,ee?B.length>0?[{start:0,end:B.length}]:[]:null}function y(P,B){const j=B.toLowerCase().indexOf(P.toLowerCase());return j===-1?null:[{start:j,end:j+P.length}]}t.matchesContiguousSubString=y;function w(P,B){return m(P.toLowerCase(),B.toLowerCase(),0,0)}t.matchesSubString=w;function m(P,B,j,ee){if(j===P.length)return[];if(ee===B.length)return null;if(P[j]===B[ee]){let he=null;return(he=m(P,B,j+1,ee+1))?_({start:ee,end:ee+1},he):null}return m(P,B,j,ee+1)}function f(P){return 97<=P&&P<=122}function b(P){return 65<=P&&P<=90}t.isUpper=b;function F(P){return 48<=P&&P<=57}function a(P){return P===32||P===9||P===10||P===13}const n=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(P=>n.add(P.charCodeAt(0)));function e(P){return a(P)||n.has(P)}function d(P,B){return P===B||e(P)&&e(B)}function p(P){return f(P)||b(P)||F(P)}function _(P,B){return B.length===0?B=[P]:P.end===B[0].start?B[0].start=P.start:B.unshift(P),B}function E(P,B){for(let j=B;j<P.length;j++){const ee=P.charCodeAt(j);if(b(ee)||F(ee)||j>0&&!p(P.charCodeAt(j-1)))return j}return P.length}function u(P,B,j,ee){if(j===P.length)return[];if(ee===B.length)return null;if(P[j]!==B[ee].toLowerCase())return null;{let he=null,fe=ee+1;for(he=u(P,B,j+1,ee+1);!he&&(fe=E(B,fe))<B.length;)he=u(P,B,j+1,fe),fe++;return he===null?null:_({start:ee,end:ee+1},he)}}function g(P){let B=0,j=0,ee=0,he=0,fe=0;for(let ve=0;ve<P.length;ve++)fe=P.charCodeAt(ve),b(fe)&&B++,f(fe)&&j++,p(fe)&&ee++,F(fe)&&he++;const Ee=B/P.length,_e=j/P.length,ke=ee/P.length,Ie=he/P.length;return{upperPercent:Ee,lowerPercent:_e,alphaPercent:ke,numericPercent:Ie}}function D(P){const{upperPercent:B,lowerPercent:j}=P;return j===0&&B>.6}function A(P){const{upperPercent:B,lowerPercent:j,alphaPercent:ee,numericPercent:he}=P;return j>.2&&B<.8&&ee>.6&&he<.2}function N(P){let B=0,j=0,ee=0,he=0;for(let fe=0;fe<P.length;fe++)ee=P.charCodeAt(fe),b(ee)&&B++,f(ee)&&j++,a(ee)&&he++;return(B===0||j===0)&&he===0?P.length<=30:B<=5}function T(P,B){if(!B||(B=B.trim(),B.length===0)||!N(P)||B.length>60)return null;const j=g(B);if(!A(j)){if(!D(j))return null;B=B.toLowerCase()}let ee=null,he=0;for(P=P.toLowerCase();he<B.length&&(ee=u(P,B,0,he))===null;)he=E(B,he+1);return ee}t.matchesCamelCase=T;function s(P,B,j=!1){if(!B||B.length===0)return null;let ee=null,he=0;for(P=P.toLowerCase(),B=B.toLowerCase();he<B.length&&(ee=l(P,B,0,he,j))===null;)he=o(B,he+1);return ee}t.matchesWords=s;function l(P,B,j,ee,he){if(j===P.length)return[];if(ee===B.length)return null;if(d(P.charCodeAt(j),B.charCodeAt(ee))){let fe=null,Ee=ee+1;if(fe=l(P,B,j+1,ee+1,he),!he)for(;!fe&&(Ee=o(B,Ee))<B.length;)fe=l(P,B,j+1,Ee,he),Ee++;return fe===null?null:_({start:ee,end:ee+1},fe)}else return null}function o(P,B){for(let j=B;j<P.length;j++)if(e(P.charCodeAt(j))||j>0&&e(P.charCodeAt(j-1)))return j;return P.length}const r=R(t.matchesPrefix,T,y),c=R(t.matchesPrefix,T,w),C=new v.LRUCache(1e4);function V(P,B,j=!1){if(typeof P!="string"||typeof B!="string")return null;let ee=C.get(P);ee||(ee=new RegExp(i.convertSimple2RegExpPattern(P),"i"),C.set(P,ee));const he=ee.exec(B);return he?[{start:he.index,end:he.index+he[0].length}]:j?c(P,B):r(P,B)}t.matchesFuzzy=V;function se(P,B){const j=q(P,P.toLowerCase(),0,B,B.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return j?ae(j):null}t.matchesFuzzy2=se;function ie(P,B,j,ee,he,fe){const Ee=Math.min(13,P.length);for(;j<Ee;j++){const _e=q(P,B,j,ee,he,fe,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(_e)return _e}return[0,fe]}t.anyScore=ie;function ae(P){if(typeof P=="undefined")return[];const B=[],j=P[1];for(let ee=P.length-1;ee>1;ee--){const he=P[ee]+j,fe=B[B.length-1];fe&&fe.end===he?fe.end=he+1:B.push({start:he,end:he+1})}return B}t.createMatches=ae;const ne=128;function we(){const P=[],B=[];for(let j=0;j<=ne;j++)B[j]=0;for(let j=0;j<=ne;j++)P.push(B.slice(0));return P}function de(P){const B=[];for(let j=0;j<=P;j++)B[j]=0;return B}const ge=de(2*ne),ye=de(2*ne),J=we(),De=we(),re=we(),te=!1;function le(P,B,j,ee,he){function fe(_e,ke,Ie=" "){for(;_e.length<ke;)_e=Ie+_e;return _e}let Ee=` |   |${ee.split("").map(_e=>fe(_e,3)).join("|")}
`;for(let _e=0;_e<=j;_e++)_e===0?Ee+=" |":Ee+=`${B[_e-1]}|`,Ee+=P[_e].slice(0,he+1).map(ke=>fe(ke.toString(),3)).join("|")+`
`;return Ee}function Q(P,B,j,ee){P=P.substr(B),j=j.substr(ee),console.log(le(De,P,P.length,j,j.length)),console.log(le(re,P,P.length,j,j.length)),console.log(le(J,P,P.length,j,j.length))}function S(P,B){if(B<0||B>=P.length)return!1;const j=P.codePointAt(B);switch(j){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(j)}}function K(P,B){if(B<0||B>=P.length)return!1;switch(P.charCodeAt(B)){case 32:case 9:return!0;default:return!1}}function G(P,B,j){return B[P]!==j[P]}function k(P,B,j,ee,he,fe,Ee=!1){for(;B<j&&he<fe;)P[B]===ee[he]&&(Ee&&(ge[B]=he),B+=1),he+=1;return B===j}t.isPatternInWord=k;var h;(function(P){P[P.Diag=1]="Diag",P[P.Left=2]="Left",P[P.LeftLeft=3]="LeftLeft"})(h||(h={}));var L;(function(P){P.Default=[-100,0];function B(j){return!j||j.length===2&&j[0]===-100&&j[1]===0}P.isDefault=B})(L=t.FuzzyScore||(t.FuzzyScore={}));class U{constructor(B,j){this.firstMatchCanBeWeak=B,this.boostFullMatch=j}}t.FuzzyScoreOptions=U,U.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function q(P,B,j,ee,he,fe,Ee=U.default){const _e=P.length>ne?ne:P.length,ke=ee.length>ne?ne:ee.length;if(j>=_e||fe>=ke||_e-j>ke-fe||!k(B,j,_e,he,fe,ke,!0))return;W(_e,ke,j,fe,B,he);let Ie=1,ve=1,Pe=j,Me=fe;const Ge=[!1];for(Ie=1,Pe=j;Pe<_e;Ie++,Pe++){const Oe=ge[Pe],x=ye[Pe],oe=Pe+1<_e?ye[Pe+1]:ke;for(ve=Oe-fe+1,Me=Oe;Me<oe;ve++,Me++){let be=Number.MIN_SAFE_INTEGER,Ce=!1;Me<=x&&(be=O(P,B,Pe,j,ee,he,Me,ke,fe,J[Ie-1][ve-1]===0,Ge));let Fe=0;be!==Number.MAX_SAFE_INTEGER&&(Ce=!0,Fe=be+De[Ie-1][ve-1]);const Re=Me>Oe,Ve=Re?De[Ie][ve-1]+(J[Ie][ve-1]>0?-5:0):0,tt=Me>Oe+1&&J[Ie][ve-1]>0,Ye=tt?De[Ie][ve-2]+(J[Ie][ve-2]>0?-5:0):0;if(tt&&(!Re||Ye>=Ve)&&(!Ce||Ye>=Fe))De[Ie][ve]=Ye,re[Ie][ve]=3,J[Ie][ve]=0;else if(Re&&(!Ce||Ve>=Fe))De[Ie][ve]=Ve,re[Ie][ve]=2,J[Ie][ve]=0;else if(Ce)De[Ie][ve]=Fe,re[Ie][ve]=1,J[Ie][ve]=J[Ie-1][ve-1]+1;else throw new Error("not possible")}}if(te&&Q(P,j,ee,fe),!Ge[0]&&!Ee.firstMatchCanBeWeak)return;Ie--,ve--;const He=[De[Ie][ve],fe];let Ue=0,Je=0;for(;Ie>=1;){let Oe=ve;do{const x=re[Ie][Oe];if(x===3)Oe=Oe-2;else if(x===2)Oe=Oe-1;else break}while(Oe>=1);Ue>1&&B[j+Ie-1]===he[fe+ve-1]&&!G(Oe+fe-1,ee,he)&&Ue+1>J[Ie][Oe]&&(Oe=ve),Oe===ve?Ue++:Ue=1,Je||(Je=Oe),Ie--,ve=Oe-1,He.push(ve)}ke===_e&&Ee.boostFullMatch&&(He[0]+=2);const je=Je-_e;return He[0]-=je,He}t.fuzzyScore=q;function W(P,B,j,ee,he,fe){let Ee=P-1,_e=B-1;for(;Ee>=j&&_e>=ee;)he[Ee]===fe[_e]&&(ye[Ee]=_e,Ee--),_e--}function O(P,B,j,ee,he,fe,Ee,_e,ke,Ie,ve){if(B[j]!==fe[Ee])return Number.MIN_SAFE_INTEGER;let Pe=1,Me=!1;return Ee===j-ee?Pe=P[j]===he[Ee]?7:5:G(Ee,he,fe)&&(Ee===0||!G(Ee-1,he,fe))?(Pe=P[j]===he[Ee]?7:5,Me=!0):S(fe,Ee)&&(Ee===0||!S(fe,Ee-1))?Pe=5:(S(fe,Ee-1)||K(fe,Ee-1))&&(Pe=5,Me=!0),Pe>1&&j===ee&&(ve[0]=!0),Me||(Me=G(Ee,he,fe)||S(fe,Ee-1)||K(fe,Ee-1)),j===ee?Ee>ke&&(Pe-=Me?3:5):Ie?Pe+=Me?2:0:Pe+=Me?0:1,Ee+1===_e&&(Pe-=Me?3:5),Pe}function H(P,B,j,ee,he,fe,Ee){return I(P,B,j,ee,he,fe,!0,Ee)}t.fuzzyScoreGracefulAggressive=H;function $(P,B,j,ee,he,fe,Ee){return I(P,B,j,ee,he,fe,!1,Ee)}t.fuzzyScoreGraceful=$;function I(P,B,j,ee,he,fe,Ee,_e){let ke=q(P,B,j,ee,he,fe,_e);if(ke&&!Ee)return ke;if(P.length>=3){const Ie=Math.min(7,P.length-1);for(let ve=j+1;ve<Ie;ve++){const Pe=z(P,ve);if(Pe){const Me=q(Pe,Pe.toLowerCase(),j,ee,he,fe,_e);Me&&(Me[0]-=3,(!ke||Me[0]>ke[0])&&(ke=Me))}}}return ke}function z(P,B){if(B+1>=P.length)return;const j=P[B],ee=P[B+1];if(j!==ee)return P.slice(0,B)+ee+j+P.slice(B+2)}}),define(me[34],pe([1,0,11,33,10]),function(Z,t,v,i,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=t.iconStartMarker=void 0,t.iconStartMarker="$(";const M=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(v.CSSIcon.iconNameCharacter),w=new RegExp(`(\\\\)?${M.source}`,"g");function m(p){return p.replace(w,(_,E)=>E?_:`\\${_}`)}t.escapeIcons=m;const f=new RegExp(`\\\\${M.source}`,"g");function b(p){return p.replace(f,_=>`\\${_}`)}t.markdownEscapeEscapedIcons=b;const F=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function a(p){return p.indexOf(t.iconStartMarker)===-1?p:p.replace(F,(_,E,u,g)=>u?_:E||g||"")}t.stripIcons=a;function n(p){const _=p.indexOf(t.iconStartMarker);return _===-1?{text:p}:e(p,_)}t.parseLabelWithIcons=n;function e(p,_){const E=[];let u="";function g(r){if(r){u+=r;for(const c of r)E.push(N)}}let D=-1,A="",N=0,T,s,l=_;const o=p.length;for(g(p.substr(0,_));l<o;)T=p[l],s=p[l+1],T===t.iconStartMarker[0]&&s===t.iconStartMarker[1]?(D=l,g(A),A=t.iconStartMarker,l++):T===")"&&D!==-1?(N+=l-D+1,D=-1,A=""):D!==-1?y.test(T)?A+=T:(g(A),D=-1,A=""):g(T),l++;return g(A),{text:u,iconOffsets:E}}function d(p,_,E=!1){const{text:u,iconOffsets:g}=_;if(!g||g.length===0)return(0,i.matchesFuzzy)(p,u,E);const D=(0,R.ltrim)(u," "),A=u.length-D.length,N=(0,i.matchesFuzzy)(p,D,E);if(N)for(const T of N){const s=g[T.start+A]+A;T.start+=s,T.end+=s}return N}t.matchesFuzzyIconAware=d}),define(me[16],pe([1,0,21,5]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const R=/^\w[\w\d+.-]*$/,M=/^\//,y=/^\/\//;function w(T,s){if(!T.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${T.authority}", path: "${T.path}", query: "${T.query}", fragment: "${T.fragment}"}`);if(T.scheme&&!R.test(T.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(T.path){if(T.authority){if(!M.test(T.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(T.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(T,s){return!T&&!s?"file":T}function f(T,s){switch(T){case"https":case"http":case"file":s?s[0]!==F&&(s=F+s):s=F;break}return s}const b="",F="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class n{constructor(s,l,o,r,c,C=!1){typeof s=="object"?(this.scheme=s.scheme||b,this.authority=s.authority||b,this.path=s.path||b,this.query=s.query||b,this.fragment=s.fragment||b):(this.scheme=m(s,C),this.authority=l||b,this.path=f(this.scheme,o||b),this.query=r||b,this.fragment=c||b,w(this,C))}static isUri(s){return s instanceof n?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return u(this,!1)}with(s){if(!s)return this;let{scheme:l,authority:o,path:r,query:c,fragment:C}=s;return l===void 0?l=this.scheme:l===null&&(l=b),o===void 0?o=this.authority:o===null&&(o=b),r===void 0?r=this.path:r===null&&(r=b),c===void 0?c=this.query:c===null&&(c=b),C===void 0?C=this.fragment:C===null&&(C=b),l===this.scheme&&o===this.authority&&r===this.path&&c===this.query&&C===this.fragment?this:new d(l,o,r,c,C)}static parse(s,l=!1){const o=a.exec(s);return o?new d(o[2]||b,N(o[4]||b),N(o[5]||b),N(o[7]||b),N(o[9]||b),l):new d(b,b,b,b,b)}static file(s){let l=b;if(i.isWindows&&(s=s.replace(/\\/g,F)),s[0]===F&&s[1]===F){const o=s.indexOf(F,2);o===-1?(l=s.substring(2),s=F):(l=s.substring(2,o),s=s.substring(o)||F)}return new d("file",l,s,b,b)}static from(s){const l=new d(s.scheme,s.authority,s.path,s.query,s.fragment);return w(l,!0),l}static joinPath(s,...l){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return i.isWindows&&s.scheme==="file"?o=n.file(v.win32.join(u(s,!0),...l)).path:o=v.posix.join(s.path,...l),s.with({path:o})}toString(s=!1){return g(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof n)return s;{const l=new d(s);return l._formatted=s.external,l._fsPath=s._sep===e?s.fsPath:null,l}}else return s}}t.URI=n;const e=i.isWindows?1:void 0;class d extends n{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(s=!1){return s?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=e),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function _(T,s){let l,o=-1;for(let r=0;r<T.length;r++){const c=T.charCodeAt(r);if(c>=97&&c<=122||c>=65&&c<=90||c>=48&&c<=57||c===45||c===46||c===95||c===126||s&&c===47)o!==-1&&(l+=encodeURIComponent(T.substring(o,r)),o=-1),l!==void 0&&(l+=T.charAt(r));else{l===void 0&&(l=T.substr(0,r));const C=p[c];C!==void 0?(o!==-1&&(l+=encodeURIComponent(T.substring(o,r)),o=-1),l+=C):o===-1&&(o=r)}}return o!==-1&&(l+=encodeURIComponent(T.substring(o))),l!==void 0?l:T}function E(T){let s;for(let l=0;l<T.length;l++){const o=T.charCodeAt(l);o===35||o===63?(s===void 0&&(s=T.substr(0,l)),s+=p[o]):s!==void 0&&(s+=T[l])}return s!==void 0?s:T}function u(T,s){let l;return T.authority&&T.path.length>1&&T.scheme==="file"?l=`//${T.authority}${T.path}`:T.path.charCodeAt(0)===47&&(T.path.charCodeAt(1)>=65&&T.path.charCodeAt(1)<=90||T.path.charCodeAt(1)>=97&&T.path.charCodeAt(1)<=122)&&T.path.charCodeAt(2)===58?s?l=T.path.substr(1):l=T.path[1].toLowerCase()+T.path.substr(2):l=T.path,i.isWindows&&(l=l.replace(/\//g,"\\")),l}t.uriToFsPath=u;function g(T,s){const l=s?E:_;let o="",{scheme:r,authority:c,path:C,query:V,fragment:se}=T;if(r&&(o+=r,o+=":"),(c||r==="file")&&(o+=F,o+=F),c){let ie=c.indexOf("@");if(ie!==-1){const ae=c.substr(0,ie);c=c.substr(ie+1),ie=ae.indexOf(":"),ie===-1?o+=l(ae,!1):(o+=l(ae.substr(0,ie),!1),o+=":",o+=l(ae.substr(ie+1),!1)),o+="@"}c=c.toLowerCase(),ie=c.indexOf(":"),ie===-1?o+=l(c,!1):(o+=l(c.substr(0,ie),!1),o+=c.substr(ie))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const ie=C.charCodeAt(1);ie>=65&&ie<=90&&(C=`/${String.fromCharCode(ie+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const ie=C.charCodeAt(0);ie>=65&&ie<=90&&(C=`${String.fromCharCode(ie+32)}:${C.substr(2)}`)}o+=l(C,!0)}return V&&(o+="?",o+=l(V,!1)),se&&(o+="#",o+=s?se:_(se,!1)),o}function D(T){try{return decodeURIComponent(T)}catch{return T.length>3?T.substr(0,3)+D(T.substr(3)):T}}const A=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function N(T){return T.match(A)?T.replace(A,s=>D(s)):T}}),define(me[49],pe([1,0,31,10,16]),function(Z,t,v,i,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function M(f){return JSON.stringify(f,w)}t.stringify=M;function y(f){let b=JSON.parse(f);return b=m(b),b}t.parse=y;function w(f,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,i.regExpFlags)(b)}:b}function m(f,b=0){if(!f||b>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return R.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 14:return new Date(f.source)}if(f instanceof v.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let F=0;F<f.length;++F)f[F]=m(f[F],b+1);else for(const F in f)Object.hasOwnProperty.call(f,F)&&(f[F]=m(f[F],b+1))}return f}t.revive=m}),define(me[35],pe([1,0,5,16]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileAccess=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var R;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebook="vscode-notebook",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls"})(R=t.Schemas||(t.Schemas={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}setServerRootPath(m){this._remoteResourcesPath=`${m}/${R.vscodeRemoteResource}`}set(m,f,b){this._hosts[m]=f,this._ports[m]=b}setConnectionToken(m,f){this._connectionTokens[m]=f}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(m){if(this._delegate)return this._delegate(m);const f=m.authority;let b=this._hosts[f];b&&b.indexOf(":")!==-1&&(b=`[${b}]`);const F=this._ports[f],a=this._connectionTokens[f];let n=`path=${encodeURIComponent(m.path)}`;return typeof a=="string"&&(n+=`&${t.connectionTokenQueryName}=${encodeURIComponent(a)}`),i.URI.from({scheme:v.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${b}:${F}`,path:this._remoteResourcesPath,query:n})}}t.RemoteAuthorities=new M;class y{asBrowserUri(m,f){const b=this.toUri(m,f);return b.scheme===R.vscodeRemote?t.RemoteAuthorities.rewrite(b):b.scheme===R.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${R.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?b.with({scheme:R.vscodeFileResource,authority:b.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(m,f){const b=this.toUri(m,f);return b.scheme===R.vscodeFileResource?b.with({scheme:R.file,authority:b.authority!==y.FALLBACK_AUTHORITY?b.authority:null,query:null,fragment:null}):b}toUri(m,f){return i.URI.isUri(m)?m:i.URI.parse(f.toUrl(m))}}y.FALLBACK_AUTHORITY="vscode-app",t.FileAccess=new y}),define(me[36],pe([1,0,109,35,21,5,10,16]),function(Z,t,v,i,R,M,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function m(n){return(0,w.uriToFsPath)(n,!0)}t.originalFSPath=m;class f{constructor(e){this._ignorePathCasing=e}compare(e,d,p=!1){return e===d?0:(0,y.compare)(this.getComparisonKey(e,p),this.getComparisonKey(d,p))}isEqual(e,d,p=!1){return e===d?!0:!e||!d?!1:this.getComparisonKey(e,p)===this.getComparisonKey(d,p)}getComparisonKey(e,d=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(e){return this._ignorePathCasing(e)}isEqualOrParent(e,d,p=!1){if(e.scheme===d.scheme){if(e.scheme===i.Schemas.file)return v.isEqualOrParent(m(e),m(d),this._ignorePathCasing(e))&&e.query===d.query&&(p||e.fragment===d.fragment);if((0,t.isEqualAuthority)(e.authority,d.authority))return v.isEqualOrParent(e.path,d.path,this._ignorePathCasing(e),"/")&&e.query===d.query&&(p||e.fragment===d.fragment)}return!1}joinPath(e,...d){return w.URI.joinPath(e,...d)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return R.posix.basename(e.path)}extname(e){return R.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let d;return e.scheme===i.Schemas.file?d=w.URI.file(R.dirname(m(e))).path:(d=R.posix.dirname(e.path),e.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),d="/")),e.with({path:d})}normalizePath(e){if(!e.path.length)return e;let d;return e.scheme===i.Schemas.file?d=w.URI.file(R.normalize(m(e))).path:d=R.posix.normalize(e.path),e.with({path:d})}relativePath(e,d){if(e.scheme!==d.scheme||!(0,t.isEqualAuthority)(e.authority,d.authority))return;if(e.scheme===i.Schemas.file){const E=R.relative(m(e),m(d));return M.isWindows?v.toSlashes(E):E}let p=e.path||"/";const _=d.path||"/";if(this._ignorePathCasing(e)){let E=0;for(const u=Math.min(p.length,_.length);E<u&&!(p.charCodeAt(E)!==_.charCodeAt(E)&&p.charAt(E).toLowerCase()!==_.charAt(E).toLowerCase());E++);p=_.substr(0,E)+p.substr(E)}return R.posix.relative(p,_)}resolvePath(e,d){if(e.scheme===i.Schemas.file){const p=w.URI.file(R.resolve(m(e),d));return e.with({authority:p.authority,path:p.path})}return d=v.toPosixPath(d),e.with({path:R.posix.resolve(e.path,d)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,d){return e===d||e!==void 0&&d!==void 0&&(0,y.equalsIgnoreCase)(e,d)}hasTrailingPathSeparator(e,d=R.sep){if(e.scheme===i.Schemas.file){const p=m(e);return p.length>v.getRoot(p).length&&p[p.length-1]===d}else{const p=e.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,d=R.sep){return(0,t.hasTrailingPathSeparator)(e,d)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,d=R.sep){let p=!1;if(e.scheme===i.Schemas.file){const _=m(e);p=_!==void 0&&_.length===v.getRoot(_).length&&_[_.length-1]===d}else{d="/";const _=e.path;p=_.length===1&&_.charCodeAt(_.length-1)===47}return!p&&!(0,t.hasTrailingPathSeparator)(e,d)?e.with({path:e.path+"/"}):e}}t.ExtUri=f,t.extUri=new f(()=>!1),t.extUriBiasedIgnorePathCase=new f(n=>n.scheme===i.Schemas.file?!M.isLinux:!0),t.extUriIgnorePathCase=new f(n=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function b(n,e){const d=[];for(let p=0;p<n.length;p++){const _=e(n[p]);n.some((E,u)=>u===p?!1:(0,t.isEqualOrParent)(_,e(E)))||d.push(n[p])}return d}t.distinctParents=b;var F;(function(n){n.META_DATA_LABEL="label",n.META_DATA_DESCRIPTION="description",n.META_DATA_SIZE="size",n.META_DATA_MIME="mime";function e(d){const p=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(u=>{const[g,D]=u.split(":");g&&D&&p.set(g,D)});const E=d.path.substring(0,d.path.indexOf(";"));return E&&p.set(n.META_DATA_MIME,E),p}n.parseMetaData=e})(F=t.DataUri||(t.DataUri={}));function a(n,e,d){if(e){let p=n.path;return p&&p[0]!==R.posix.sep&&(p=R.posix.sep+p),n.with({scheme:d,authority:e,path:p})}return n.with({scheme:d})}t.toLocalResource=a}),define(me[6],pe([1,0,22,13,3,2,36,5]),function(Z,t,v,i,R,M,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.MicrotaskDelay=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function m(G){return!!G&&typeof G.then=="function"}t.isThenable=m;function f(G){const k=new v.CancellationTokenSource,h=G(k.token),L=new Promise((U,q)=>{const W=k.token.onCancellationRequested(()=>{W.dispose(),k.dispose(),q(new i.CancellationError)});Promise.resolve(h).then(O=>{W.dispose(),k.dispose(),U(O)},O=>{W.dispose(),k.dispose(),q(O)})});return new class{cancel(){k.cancel()}then(U,q){return L.then(U,q)}catch(U){return this.then(void 0,U)}finally(U){return L.finally(U)}}}t.createCancelablePromise=f;function b(G,k,h){return new Promise((L,U)=>{const q=k.onCancellationRequested(()=>{q.dispose(),L(h)});G.then(L,U).finally(()=>q.dispose())})}t.raceCancellation=b;function F(G,k){return new Promise((h,L)=>{const U=k.onCancellationRequested(()=>{U.dispose(),L(new i.CancellationError)});G.then(h,L).finally(()=>U.dispose())})}t.raceCancellationError=F;async function a(G){let k=-1;const h=G.map((U,q)=>U.then(W=>(k=q,W))),L=await Promise.race(h);return G.forEach((U,q)=>{q!==k&&U.cancel()}),L}t.raceCancellablePromises=a;function n(G,k,h){let L;const U=setTimeout(()=>{L?.(void 0),h?.()},k);return Promise.race([G.finally(()=>clearTimeout(U)),new Promise(q=>L=q)])}t.raceTimeout=n;function e(G){return new Promise((k,h)=>{const L=G();m(L)?L.then(k,h):k(L)})}t.asPromise=e;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(k){if(this.activePromise){if(this.queuedPromiseFactory=k,!this.queuedPromise){const h=()=>{this.queuedPromise=null;const L=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,L};this.queuedPromise=new Promise(L=>{this.activePromise.then(h,h).then(L)})}return new Promise((h,L)=>{this.queuedPromise.then(h,L)})}return this.activePromise=k(),new Promise((h,L)=>{this.activePromise.then(U=>{this.activePromise=null,h(U)},U=>{this.activePromise=null,L(U)})})}}t.Throttler=d;class p{constructor(){this.current=Promise.resolve(null)}queue(k){return this.current=this.current.then(()=>k(),()=>k())}}t.Sequencer=p;class _{constructor(){this.promiseMap=new Map}queue(k,h){const U=(this.promiseMap.get(k)??Promise.resolve()).catch(()=>{}).then(h).finally(()=>{this.promiseMap.get(k)===U&&this.promiseMap.delete(k)});return this.promiseMap.set(k,U),U}}t.SequencerByKey=_;const E=(G,k)=>{let h=!0;const L=setTimeout(()=>{h=!1,k()},G);return{isTriggered:()=>h,dispose:()=>{clearTimeout(L),h=!1}}},u=G=>{let k=!0;return queueMicrotask(()=>{k&&(k=!1,G())}),{isTriggered:()=>k,dispose:()=>{k=!1}}};t.MicrotaskDelay=Symbol("MicrotaskDelay");class g{constructor(k){this.defaultDelay=k,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(k,h=this.defaultDelay){this.task=k,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,q)=>{this.doResolve=U,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}}));const L=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=h===t.MicrotaskDelay?u(L):E(h,L),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=g;class D{constructor(k){this.delayer=new g(k),this.throttler=new d}trigger(k,h){return this.delayer.trigger(()=>this.throttler.queue(k),h)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}t.ThrottledDelayer=D;class A{constructor(){this._isOpen=!1,this._promise=new Promise((k,h)=>{this._completePromise=k})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=A;class N extends A{constructor(k){super();this._timeout=setTimeout(()=>this.open(),k)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=N;function T(G,k){return k?new Promise((h,L)=>{const U=setTimeout(()=>{q.dispose(),h()},G),q=k.onCancellationRequested(()=>{clearTimeout(U),q.dispose(),L(new i.CancellationError)})}):f(h=>T(G,h))}t.timeout=T;function s(G,k=0){const h=setTimeout(G,k);return(0,M.toDisposable)(()=>clearTimeout(h))}t.disposableTimeout=s;function l(G){const k=[];let h=0;const L=G.length;function U(){return h<L?G[h++]():null}function q(W){W!=null&&k.push(W);const O=U();return O?O.then(q):Promise.resolve(k)}return Promise.resolve(null).then(q)}t.sequence=l;function o(G,k=L=>!!L,h=null){let L=0;const U=G.length,q=()=>{if(L>=U)return Promise.resolve(h);const W=G[L++];return Promise.resolve(W()).then(H=>k(H)?Promise.resolve(H):q())};return q()}t.first=o;function r(G,k=L=>!!L,h=null){if(G.length===0)return Promise.resolve(h);let L=G.length;const U=()=>{L=-1;for(const q of G)q.cancel?.()};return new Promise((q,W)=>{for(const O of G)O.then(H=>{--L>=0&&k(H)?(U(),q(H)):L===0&&q(h)}).catch(H=>{--L>=0&&(U(),W(H))})})}t.firstParallel=r;class c{constructor(k){this._size=0,this.maxDegreeOfParalellism=k,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new R.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(k){return this._size++,new Promise((h,L)=>{this.outstandingPromises.push({factory:k,c:h,e:L}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const k=this.outstandingPromises.shift();this.runningPromises++;const h=k.factory();h.then(k.c,k.e),h.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}t.Limiter=c;class C extends c{constructor(){super(1)}}t.Queue=C;class V{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const k=new re;return this.drainers.add(k),k.p}isDrained(){for(const[,k]of this.queues)if(k.size>0)return!1;return!0}queueFor(k,h=y.extUri){const L=h.getComparisonKey(k);let U=this.queues.get(L);return U||(U=new C,R.Event.once(U.onDrained)(()=>{U?.dispose(),this.queues.delete(L),this.onDidQueueDrain()}),this.queues.set(L,U)),U}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const k of this.drainers)k.complete();this.drainers.clear()}dispose(){for(const[,k]of this.queues)k.dispose();this.queues.clear(),this.releaseDrainers()}}t.ResourceQueue=V;class se{constructor(k,h){this._token=-1,typeof k=="function"&&typeof h=="number"&&this.setIfNotSet(k,h)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(k,h){this.cancel(),this._token=setTimeout(()=>{this._token=-1,k()},h)}setIfNotSet(k,h){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,k()},h))}}t.TimeoutTimer=se;class ie{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(k,h){this.cancel(),this._token=setInterval(()=>{k()},h)}}t.IntervalTimer=ie;class ae{constructor(k,h){this.timeoutToken=-1,this.runner=k,this.timeout=h,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(k=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,k)}get delay(){return this.timeout}set delay(k){this.timeout=k}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=ae;class ne{constructor(k,h){h%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${h}ms is not a multiple of 1000ms.`),this.runner=k,this.timeout=h,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(k=this.timeout){k%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${k}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(k/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=ne;class we extends ae{constructor(k,h){super(k,h);this.units=[]}work(k){this.units.push(k),this.isScheduled()||this.schedule()}doRun(){const k=this.units;this.units=[],this.runner?.(k)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=we;class de extends M.Disposable{constructor(k,h){super();this.options=k,this.handler=h,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(k){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+k.length>this.options.maxBufferedWork)return!1}else if(this.pending+k.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...k),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ae(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=de,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=G=>{(0,w.setTimeout0)(()=>{if(k)return;const h=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,h-Date.now())}}))});let k=!1;return{dispose(){k||(k=!0)}}}:t.runWhenIdle=(G,k)=>{const h=requestIdleCallback(G,typeof k=="number"?{timeout:k}:void 0);let L=!1;return{dispose(){L||(L=!0,cancelIdleCallback(h))}}}}();class ge{constructor(k){this._didRun=!1,this._executor=()=>{try{this._value=k()}catch(h){this._error=h}finally{this._didRun=!0}},this._handle=(0,t.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.IdleValue=ge;async function ye(G,k,h){let L;for(let U=0;U<h;U++)try{return await G()}catch(q){L=q,await T(k)}throw L}t.retry=ye;class J{hasPending(k){return this._pending?typeof k=="number"?this._pending.taskId===k:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(k,h,L){return this._pending={taskId:k,cancel:()=>L?.(),promise:h},h.then(()=>this.donePending(k),()=>this.donePending(k)),h}donePending(k){this._pending&&k===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const k=this._next;this._next=void 0,k.run().then(k.promiseResolve,k.promiseReject)}}setNext(k){if(this._next)this._next.run=k;else{let h,L;const U=new Promise((q,W)=>{h=q,L=W});this._next={run:k,promise:U,promiseResolve:h,promiseReject:L}}return this._next.promise}}t.TaskSequentializer=J;class De{constructor(k,h=()=>Date.now()){this.interval=k,this.nowFn=h,this.lastIncrementTime=0,this.value=0}increment(){const k=this.nowFn();return k-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=k,this.value=0),this.value++,this.value}}t.IntervalCounter=De;class re{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((k,h)=>{this.completeCallback=k,this.errorCallback=h})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(k){return new Promise(h=>{this.completeCallback(k),this.resolved=!0,h()})}error(k){return new Promise(h=>{this.errorCallback(k),this.rejected=!0,h()})}cancel(){new Promise(k=>{this.errorCallback(new i.CancellationError),this.rejected=!0,k()})}}t.DeferredPromise=re;var te;(function(G){async function k(L){let U;const q=await Promise.all(L.map(W=>W.then(O=>O,O=>{U||(U=O)})));if(typeof U!="undefined")throw U;return q}G.settled=k;function h(L){return new Promise(async(U,q)=>{try{await L(U,q)}catch(W){q(W)}})}G.withAsyncBody=h})(te=t.Promises||(t.Promises={}));var le;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(le||(le={}));class Q{constructor(k){this._state=0,this._results=[],this._error=null,this._onStateChanged=new R.Emitter,queueMicrotask(async()=>{const h={emitOne:L=>this.emitOne(L),emitMany:L=>this.emitMany(L),reject:L=>this.reject(L)};try{await Promise.resolve(k(h)),this.resolve()}catch(L){this.reject(L)}finally{h.emitOne=void 0,h.emitMany=void 0,h.reject=void 0}})}static fromArray(k){return new Q(h=>{h.emitMany(k)})}static fromPromise(k){return new Q(async h=>{h.emitMany(await k)})}static fromPromises(k){return new Q(async h=>{await Promise.all(k.map(async L=>h.emitOne(await L)))})}static merge(k){return new Q(async h=>{await Promise.all(k.map(async L=>{for await(const U of L)h.emitOne(U)}))})}[Symbol.asyncIterator](){let k=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(k<this._results.length)return{done:!1,value:this._results[k++]};if(this._state===1)return{done:!0,value:void 0};await R.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(k,h){return new Q(async L=>{for await(const U of k)L.emitOne(h(U))})}map(k){return Q.map(this,k)}static filter(k,h){return new Q(async L=>{for await(const U of k)h(U)&&L.emitOne(U)})}filter(k){return Q.filter(this,k)}static coalesce(k){return Q.filter(k,h=>!!h)}coalesce(){return Q.coalesce(this)}static async toPromise(k){const h=[];for await(const L of k)h.push(L);return h}toPromise(){return Q.toPromise(this)}emitOne(k){this._state===0&&(this._results.push(k),this._onStateChanged.fire())}emitMany(k){this._state===0&&(this._results=this._results.concat(k),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(k){this._state===0&&(this._state=2,this._error=k,this._onStateChanged.fire())}}t.AsyncIterableObject=Q,Q.EMPTY=Q.fromArray([]);class S extends Q{constructor(k,h){super(h);this._source=k}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=S;function K(G){const k=new v.CancellationTokenSource,h=G(k.token);return new S(k,async L=>{const U=k.token.onCancellationRequested(()=>{U.dispose(),k.dispose(),L.reject(new i.CancellationError)});try{for await(const q of h){if(k.token.isCancellationRequested)return;L.emitOne(q)}U.dispose(),k.dispose()}catch(q){U.dispose(),k.dispose(),L.reject(q)}})}t.createCancelableAsyncIterable=K}),define(me[4],pe([1,0,15,107,19,20,6,13,3,112,2,35,5,7,16]),function(Z,t,v,i,R,M,y,w,m,f,b,F,a,n,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.computeClippingRect=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.getElementsByTagName=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.StandardWindow=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.createEventEmitter=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function d(X){for(;X.firstChild;)X.firstChild.remove()}t.clearNode=d;function p(X){return X?.isConnected??!1}t.isInDOM=p;class _{constructor(Y,ce,Ae,Te){this._node=Y,this._type=ce,this._handler=Ae,this._options=Te||!1,this._node.addEventListener(this._type,this._handler,this._options)}dispose(){!this._handler||(this._node.removeEventListener(this._type,this._handler,this._options),this._node=null,this._handler=null)}}function E(X,Y,ce,Ae){return new _(X,Y,ce,Ae)}t.addDisposableListener=E;function u(X){return function(Y){return X(new M.StandardMouseEvent(Y))}}function g(X){return function(Y){return X(new R.StandardKeyboardEvent(Y))}}const D=function(Y,ce,Ae,Te){let We=Ae;return ce==="click"||ce==="mousedown"?We=u(Ae):(ce==="keydown"||ce==="keypress"||ce==="keyup")&&(We=g(Ae)),E(Y,ce,We,Te)};t.addStandardDisposableListener=D;const A=function(Y,ce,Ae){const Te=u(ce);return T(Y,Te,Ae)};t.addStandardDisposableGenericMouseDownListener=A;const N=function(Y,ce,Ae){const Te=u(ce);return l(Y,Te,Ae)};t.addStandardDisposableGenericMouseUpListener=N;function T(X,Y,ce){return E(X,a.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,Y,ce)}t.addDisposableGenericMouseDownListener=T;function s(X,Y,ce){return E(X,a.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,Y,ce)}t.addDisposableGenericMouseMoveListener=s;function l(X,Y,ce){return E(X,a.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,Y,ce)}t.addDisposableGenericMouseUpListener=l;function o(X,Y,ce){let Ae=null;const Te=Qe=>xe.fire(Qe),We=()=>{Ae||(Ae=new _(X,Y,Te,ce))},ze=()=>{Ae&&(Ae.dispose(),Ae=null)},xe=new m.Emitter({onFirstListenerAdd:We,onLastListenerRemove:ze});return xe}t.createEventEmitter=o;let r=null;function c(X){if(!r){const Y=ce=>setTimeout(()=>ce(new Date().getTime()),0);r=self.requestAnimationFrame||self.msRequestAnimationFrame||self.webkitRequestAnimationFrame||self.mozRequestAnimationFrame||self.oRequestAnimationFrame||Y}return r.call(self,X)}class C{constructor(Y,ce=0){this._runner=Y,this.priority=ce,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(Y){(0,w.onUnexpectedError)(Y)}}static sort(Y,ce){return ce.priority-Y.priority}}(function(){let X=[],Y=null,ce=!1,Ae=!1;const Te=()=>{for(ce=!1,Y=X,X=[],Ae=!0;Y.length>0;)Y.sort(C.sort),Y.shift().execute();Ae=!1};t.scheduleAtNextAnimationFrame=(We,ze=0)=>{const xe=new C(We,ze);return X.push(xe),ce||(ce=!0,c(Te)),xe},t.runAtThisOrScheduleAtNextAnimationFrame=(We,ze)=>{if(Ae){const xe=new C(We,ze);return Y.push(xe),xe}else return(0,t.scheduleAtNextAnimationFrame)(We,ze)}})();function V(X){return(0,t.scheduleAtNextAnimationFrame)(X,1e4)}t.measure=V;function se(X){return(0,t.scheduleAtNextAnimationFrame)(X,-1e4)}t.modify=se;const ie=8,ae=function(X,Y){return Y};class ne extends b.Disposable{constructor(Y,ce,Ae,Te=ae,We=ie){super();let ze=null,xe=0;const Qe=this._register(new y.TimeoutTimer),bt=()=>{xe=new Date().getTime(),Ae(ze),ze=null};this._register(E(Y,ce,Lt=>{ze=Te(ze,Lt);const gt=new Date().getTime()-xe;gt>=We?(Qe.cancel(),bt()):Qe.setIfNotSet(bt,We-gt)}))}}function we(X,Y,ce,Ae,Te){return new ne(X,Y,ce,Ae,Te)}t.addDisposableThrottledListener=we;function de(X){return document.defaultView.getComputedStyle(X,null)}t.getComputedStyle=de;function ge(X){if(X!==document.body)return new J(X.clientWidth,X.clientHeight);if(a.isIOS&&window.visualViewport)return new J(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new J(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new J(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new J(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=ge;class ye{static convertToPixels(Y,ce){return parseFloat(ce)||0}static getDimension(Y,ce,Ae){const Te=de(Y);let We="0";return Te&&(Te.getPropertyValue?We=Te.getPropertyValue(ce):We=Te.getAttribute(Ae)),ye.convertToPixels(Y,We)}static getBorderLeftWidth(Y){return ye.getDimension(Y,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Y){return ye.getDimension(Y,"border-right-width","borderRightWidth")}static getBorderTopWidth(Y){return ye.getDimension(Y,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Y){return ye.getDimension(Y,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Y){return ye.getDimension(Y,"padding-left","paddingLeft")}static getPaddingRight(Y){return ye.getDimension(Y,"padding-right","paddingRight")}static getPaddingTop(Y){return ye.getDimension(Y,"padding-top","paddingTop")}static getPaddingBottom(Y){return ye.getDimension(Y,"padding-bottom","paddingBottom")}static getMarginLeft(Y){return ye.getDimension(Y,"margin-left","marginLeft")}static getMarginTop(Y){return ye.getDimension(Y,"margin-top","marginTop")}static getMarginRight(Y){return ye.getDimension(Y,"margin-right","marginRight")}static getMarginBottom(Y){return ye.getDimension(Y,"margin-bottom","marginBottom")}}class J{constructor(Y,ce){this.width=Y,this.height=ce}with(Y=this.width,ce=this.height){return Y!==this.width||ce!==this.height?new J(Y,ce):this}static is(Y){return typeof Y=="object"&&typeof Y.height=="number"&&typeof Y.width=="number"}static lift(Y){return Y instanceof J?Y:new J(Y.width,Y.height)}static equals(Y,ce){return Y===ce?!0:!Y||!ce?!1:Y.width===ce.width&&Y.height===ce.height}}t.Dimension=J,J.None=new J(0,0);function De(X){let Y=X.offsetParent,ce=X.offsetTop,Ae=X.offsetLeft;for(;(X=X.parentNode)!==null&&X!==document.body&&X!==document.documentElement;){ce-=X.scrollTop;const Te=P(X)?null:de(X);Te&&(Ae-=Te.direction!=="rtl"?X.scrollLeft:-X.scrollLeft),X===Y&&(Ae+=ye.getBorderLeftWidth(X),ce+=ye.getBorderTopWidth(X),ce+=X.offsetTop,Ae+=X.offsetLeft,Y=X.offsetParent)}return{left:Ae,top:ce}}t.getTopLeftOffset=De;function re(X,Y,ce){typeof Y=="number"&&(X.style.width=`${Y}px`),typeof ce=="number"&&(X.style.height=`${ce}px`)}t.size=re;function te(X,Y,ce,Ae,Te,We="absolute"){typeof Y=="number"&&(X.style.top=`${Y}px`),typeof ce=="number"&&(X.style.right=`${ce}px`),typeof Ae=="number"&&(X.style.bottom=`${Ae}px`),typeof Te=="number"&&(X.style.left=`${Te}px`),X.style.position=We}t.position=te;function le(X){const Y=X.getBoundingClientRect();return{left:Y.left+t.StandardWindow.scrollX,top:Y.top+t.StandardWindow.scrollY,width:Y.width,height:Y.height}}t.getDomNodePagePosition=le;function Q(X){let Y=X,ce=1;do{const Ae=de(Y).zoom;Ae!=null&&Ae!=="1"&&(ce*=Ae),Y=Y.parentElement}while(Y!==null&&Y!==document.documentElement);return ce}t.getDomNodeZoomLevel=Q,t.StandardWindow=new class{get scrollX(){return typeof window.scrollX=="number"?window.scrollX:document.body.scrollLeft+document.documentElement.scrollLeft}get scrollY(){return typeof window.scrollY=="number"?window.scrollY:document.body.scrollTop+document.documentElement.scrollTop}};function S(X){const Y=ye.getMarginLeft(X)+ye.getMarginRight(X);return X.offsetWidth+Y}t.getTotalWidth=S;function K(X){const Y=ye.getBorderLeftWidth(X)+ye.getBorderRightWidth(X),ce=ye.getPaddingLeft(X)+ye.getPaddingRight(X);return X.offsetWidth-Y-ce}t.getContentWidth=K;function G(X){const Y=ye.getMarginLeft(X)+ye.getMarginRight(X);return X.scrollWidth+Y}t.getTotalScrollWidth=G;function k(X){const Y=ye.getBorderTopWidth(X)+ye.getBorderBottomWidth(X),ce=ye.getPaddingTop(X)+ye.getPaddingBottom(X);return X.offsetHeight-Y-ce}t.getContentHeight=k;function h(X){const Y=ye.getMarginTop(X)+ye.getMarginBottom(X);return X.offsetHeight+Y}t.getTotalHeight=h;function L(X,Y){if(X===null)return 0;const ce=De(X),Ae=De(Y);return ce.left-Ae.left}function U(X,Y){const ce=Y.map(Te=>Math.max(G(Te),S(Te))+L(Te,X)||0);return Math.max(...ce)}t.getLargestChildWidth=U;function q(X,Y){for(;X;){if(X===Y)return!0;X=X.parentNode}return!1}t.isAncestor=q;const W="parentFlowToElementId";function O(X,Y){X.dataset[W]=Y.id}t.setParentFlowTo=O;function H(X){const Y=X.dataset[W];return typeof Y=="string"?document.getElementById(Y):null}function $(X,Y){let ce=X;for(;ce;){if(ce===Y)return!0;if(ce instanceof HTMLElement){const Ae=H(ce);if(Ae){ce=Ae;continue}}ce=ce.parentNode}return!1}t.isAncestorUsingFlowTo=$;function I(X,Y,ce){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X.classList.contains(Y))return X;if(ce){if(typeof ce=="string"){if(X.classList.contains(ce))return null}else if(X===ce)return null}X=X.parentNode}return null}t.findParentWithClass=I;function z(X,Y,ce){return!!I(X,Y,ce)}t.hasParentWithClass=z;function P(X){return X&&!!X.host&&!!X.mode}t.isShadowRoot=P;function B(X){return!!j(X)}t.isInShadowDOM=B;function j(X){for(;X.parentNode;){if(X===document.body)return null;X=X.parentNode}return P(X)?X:null}t.getShadowRoot=j;function ee(){let X=document.activeElement;for(;X?.shadowRoot;)X=X.shadowRoot.activeElement;return X}t.getActiveElement=ee;function he(X=document.getElementsByTagName("head")[0]){const Y=document.createElement("style");return Y.type="text/css",Y.media="screen",X.appendChild(Y),Y}t.createStyleSheet=he;function fe(X=document.getElementsByTagName("head")[0]){const Y=document.createElement("meta");return X.appendChild(Y),Y}t.createMetaElement=fe;let Ee=null;function _e(){return Ee||(Ee=he()),Ee}function ke(X){return X?.sheet?.rules?X.sheet.rules:X?.sheet?.cssRules?X.sheet.cssRules:[]}function Ie(X,Y,ce=_e()){!ce||!Y||ce.sheet.insertRule(X+"{"+Y+"}",0)}t.createCSSRule=Ie;function ve(X,Y=_e()){if(!Y)return;const ce=ke(Y),Ae=[];for(let Te=0;Te<ce.length;Te++)ce[Te].selectorText.indexOf(X)!==-1&&Ae.push(Te);for(let Te=Ae.length-1;Te>=0;Te--)Y.sheet.deleteRule(Ae[Te])}t.removeCSSRulesContainingSelector=ve;function Pe(X){return typeof HTMLElement=="object"?X instanceof HTMLElement:X&&typeof X=="object"&&X.nodeType===1&&typeof X.nodeName=="string"}t.isHTMLElement=Pe,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:v.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:v.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:v.isWebKit?"webkitAnimationIteration":"animationiteration"},t.EventHelper={stop:function(X,Y){X.preventDefault?X.preventDefault():X.returnValue=!1,Y&&(X.stopPropagation?X.stopPropagation():X.cancelBubble=!0)}};function Me(X){const Y=[];for(let ce=0;X&&X.nodeType===X.ELEMENT_NODE;ce++)Y[ce]=X.scrollTop,X=X.parentNode;return Y}t.saveParentsScrollTop=Me;function Ge(X,Y){for(let ce=0;X&&X.nodeType===X.ELEMENT_NODE;ce++)X.scrollTop!==Y[ce]&&(X.scrollTop=Y[ce]),X=X.parentNode}t.restoreParentsScrollTop=Ge;class He extends b.Disposable{constructor(Y){super();this._onDidFocus=this._register(new m.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new m.Emitter),this.onDidBlur=this._onDidBlur.event;let ce=He.hasFocusWithin(Y),Ae=!1;const Te=()=>{Ae=!1,ce||(ce=!0,this._onDidFocus.fire())},We=()=>{ce&&(Ae=!0,window.setTimeout(()=>{Ae&&(Ae=!1,ce=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{He.hasFocusWithin(Y)!==ce&&(ce?We():Te())},this._register(E(Y,t.EventType.FOCUS,Te,!0)),this._register(E(Y,t.EventType.BLUR,We,!0)),this._register(E(Y,t.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(E(Y,t.EventType.FOCUS_OUT,()=>this._refreshStateHandler()))}static hasFocusWithin(Y){const ce=j(Y),Ae=ce?ce.activeElement:document.activeElement;return q(Ae,Y)}refreshState(){this._refreshStateHandler()}}function Ue(X){return new He(X)}t.trackFocus=Ue;function Je(X,Y){return X.after(Y),Y}t.after=Je;function je(X,...Y){if(X.append(...Y),Y.length===1&&typeof Y[0]!="string")return Y[0]}t.append=je;function Oe(X,Y){return X.insertBefore(Y,X.firstChild),Y}t.prepend=Oe;function x(X,...Y){X.innerText="",je(X,...Y)}t.reset=x;const oe=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var be;(function(X){X.HTML="http://www.w3.org/1999/xhtml",X.SVG="http://www.w3.org/2000/svg"})(be=t.Namespace||(t.Namespace={}));function Ce(X,Y,ce,...Ae){const Te=oe.exec(Y);if(!Te)throw new Error("Bad use of emmet");ce={...ce||{}};const We=Te[1]||"div";let ze;return X!==be.HTML?ze=document.createElementNS(X,We):ze=document.createElement(We),Te[3]&&(ze.id=Te[3]),Te[4]&&(ze.className=Te[4].replace(/\./g," ").trim()),Object.keys(ce).forEach(xe=>{const Qe=ce[xe];typeof Qe!="undefined"&&(/^on\w+$/.test(xe)?ze[xe]=Qe:xe==="selected"?Qe&&ze.setAttribute(xe,"true"):ze.setAttribute(xe,Qe))}),ze.append(...Ae),ze}function Fe(X,Y,...ce){return Ce(be.HTML,X,Y,...ce)}t.$=Fe,Fe.SVG=function(X,Y,...ce){return Ce(be.SVG,X,Y,...ce)};function Re(X,Y){const ce=[];return X.forEach((Ae,Te)=>{Te>0&&(Y instanceof Node?ce.push(Y.cloneNode()):ce.push(document.createTextNode(Y))),ce.push(Ae)}),ce}t.join=Re;function Ve(...X){for(const Y of X)Y.style.display="",Y.removeAttribute("aria-hidden")}t.show=Ve;function tt(...X){for(const Y of X)Y.style.display="none",Y.setAttribute("aria-hidden","true")}t.hide=tt;function Ye(X,Y){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X instanceof HTMLElement&&X.hasAttribute(Y))return X;X=X.parentNode}return null}function qe(X){if(!(!X||!X.hasAttribute("tabIndex"))){if(document.activeElement===X){const Y=Ye(X.parentElement,"tabIndex");Y&&Y.focus()}X.removeAttribute("tabindex")}}t.removeTabIndexAndUpdateFocus=qe;function Le(X){return Array.prototype.slice.call(document.getElementsByTagName(X),0)}t.getElementsByTagName=Le;function ue(X){return Y=>{Y.preventDefault(),Y.stopPropagation(),X(Y)}}t.finalHandler=ue;function Se(){return new Promise(X=>{document.readyState==="complete"||document&&document.body!==null?X(void 0):window.addEventListener("DOMContentLoaded",X,!1)})}t.domContentLoaded=Se;function Ne(X){const Y=window.devicePixelRatio*X;return Math.max(1,Math.floor(Y))/window.devicePixelRatio}t.computeScreenAwareSize=Ne;function $e(X){window.open(X,"_blank","noopener")}t.windowOpenNoOpener=$e;const Xe=780,Ze=640;function et(X){const Y=Math.floor(window.screenLeft+window.innerWidth/2-Xe/2),ce=Math.floor(window.screenTop+window.innerHeight/2-Ze/2);window.open(X,"_blank",`width=${Xe},height=${Ze},top=${ce},left=${Y}`)}t.windowOpenPopup=et;function st(X,Y=!0){const ce=window.open();return ce?(Y&&(ce.opener=null),ce.location.href=X,!0):!1}t.windowOpenWithSuccess=st;function dt(X){const Y=()=>{X(),ce=(0,t.scheduleAtNextAnimationFrame)(Y)};let ce=(0,t.scheduleAtNextAnimationFrame)(Y);return(0,b.toDisposable)(()=>ce.dispose())}t.animate=dt,F.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function yt(X){return X?`url('${F.FileAccess.asBrowserUri(X).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=yt;function It(X){return`'${X.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=It;function Ut(X,Y){let ce;if(e.URI.isUri(X))ce=X.toString(!0);else{const Te=new Blob([X]);ce=URL.createObjectURL(Te),setTimeout(()=>URL.revokeObjectURL(ce))}const Ae=document.createElement("a");document.body.appendChild(Ae),Ae.download=Y,Ae.href=ce,Ae.click(),setTimeout(()=>document.body.removeChild(Ae))}t.triggerDownload=Ut;function fi(){return new Promise(X=>{const Y=document.createElement("input");document.body.appendChild(Y),Y.type="file",Y.multiple=!0,m.Event.once(m.Event.fromDOMEventEmitter(Y,"input"))(()=>{X((0,n.withNullAsUndefined)(Y.files))}),Y.click(),setTimeout(()=>document.body.removeChild(Y))})}t.triggerUpload=fi;var Et;(function(X){X[X.DOCUMENT=1]="DOCUMENT",X[X.BROWSER=2]="BROWSER"})(Et=t.DetectedFullscreenMode||(t.DetectedFullscreenMode={}));function gi(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:Et.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:Et.BROWSER,guess:!1}:(a.isMacintosh||a.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:Et.BROWSER,guess:!0}:null}t.detectFullscreen=gi;function Vt(X,Y=!1){const ce=document.createElement("a");return f.addHook("afterSanitizeAttributes",Ae=>{for(const Te of["href","src"])if(Ae.hasAttribute(Te)){const We=Ae.getAttribute(Te);if(Te==="href"&&We.startsWith("#"))continue;if(ce.href=We,!X.includes(ce.protocol.replace(/:$/,""))){if(Y&&Te==="src"&&ce.href.startsWith("data:"))continue;Ae.removeAttribute(Te)}}}),(0,b.toDisposable)(()=>{f.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=Vt;const mi=[F.Schemas.http,F.Schemas.https,F.Schemas.command];function pi(X,Y){const ce={ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1},Ae=Vt(mi);try{const Te=f.sanitize(Y,{...ce,RETURN_TRUSTED_TYPE:!0});X.innerHTML=Te}finally{Ae.dispose()}}t.safeInnerHtml=pi;function bi(X){const Y=new Uint16Array(X.length);for(let Te=0;Te<Y.length;Te++)Y[Te]=X.charCodeAt(Te);let ce="";const Ae=new Uint8Array(Y.buffer);for(let Te=0;Te<Ae.length;Te++)ce+=String.fromCharCode(Ae[Te]);return ce}function wi(X){return btoa(bi(X))}t.multibyteAwareBtoa=wi;class ft extends m.Emitter{constructor(){super();this._subscriptions=new b.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(E(window,"keydown",Y=>{if(Y.defaultPrevented)return;const ce=new R.StandardKeyboardEvent(Y);if(!(ce.keyCode===6&&Y.repeat)){if(Y.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(Y.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(Y.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(Y.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(ce.keyCode!==6)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=Y.altKey,this._keyStatus.ctrlKey=Y.ctrlKey,this._keyStatus.metaKey=Y.metaKey,this._keyStatus.shiftKey=Y.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=Y,this.fire(this._keyStatus))}},!0)),this._subscriptions.add(E(window,"keyup",Y=>{Y.defaultPrevented||(!Y.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!Y.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!Y.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!Y.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=Y.altKey,this._keyStatus.ctrlKey=Y.ctrlKey,this._keyStatus.metaKey=Y.metaKey,this._keyStatus.shiftKey=Y.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=Y,this.fire(this._keyStatus)))},!0)),this._subscriptions.add(E(document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(E(document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(E(document.body,"mousemove",Y=>{Y.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),this._subscriptions.add(E(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return ft.instance||(ft.instance=new ft),ft.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}t.ModifierKeyEmitter=ft;function vi(X){const Y=document.cookie.match("(^|[^;]+)\\s*"+X+"\\s*=\\s*([^;]+)");return Y?Y.pop():void 0}t.getCookieValue=vi;class Di extends b.Disposable{constructor(Y,ce){super();this.element=Y,this.callbacks=ce,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this._register(E(this.element,t.EventType.DRAG_ENTER,Y=>{this.counter++,this.dragStartTime=Y.timeStamp,this.callbacks.onDragEnter(Y)})),this._register(E(this.element,t.EventType.DRAG_OVER,Y=>{Y.preventDefault(),this.callbacks.onDragOver?.(Y,Y.timeStamp-this.dragStartTime)})),this._register(E(this.element,t.EventType.DRAG_LEAVE,Y=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave(Y))})),this._register(E(this.element,t.EventType.DRAG_END,Y=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd(Y)})),this._register(E(this.element,t.EventType.DROP,Y=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop(Y)}))}}t.DragAndDropObserver=Di;function yi(X,Y){const ce=X instanceof HTMLElement?X.getBoundingClientRect():X,Ae=Y.getBoundingClientRect(),Te=Math.max(Ae.top-ce.top,0),We=Math.max(ce.width-(ce.right-Ae.right),0),ze=Math.max(ce.height-(ce.bottom-Ae.bottom),0),xe=Math.max(Ae.left-ce.left,0);return{top:Te,right:We,bottom:ze,left:xe}}t.computeClippingRect=yi;const Ei=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function _i(X,...Y){let ce,Ae;Array.isArray(Y[0])?(ce={},Ae=Y[0]):(ce=Y[0]||{},Ae=Y[1]);const Te=Ei.exec(X);if(!Te||!Te.groups)throw new Error("Bad use of h");const We=Te.groups.tag||"div",ze=document.createElement(We);Te.groups.id&&(ze.id=Te.groups.id),Te.groups.class&&(ze.className=Te.groups.class.replace(/\./g," ").trim());const xe={};if(Te.groups.name&&(xe[Te.groups.name]=ze),Ae)for(const Qe of Ae)Qe instanceof HTMLElement?ze.appendChild(Qe):typeof Qe=="string"?ze.append(Qe):(Object.assign(xe,Qe),ze.appendChild(Qe.root));for(const[Qe,bt]of Object.entries(ce)){if(Qe==="style"){for(const[Lt,gt]of Object.entries(bt))ze.style.setProperty($t(Lt),typeof gt=="number"?gt+"px":""+gt);continue}ze.setAttribute($t(Qe),bt.toString())}return xe.root=ze,xe}t.h=_i;function $t(X){return X.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(me[50],pe([1,0,4,2,105]),function(Z,t,v,i,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StaticDND=t.DragAndDropData=t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class M extends i.Disposable{constructor(f,b){super();this._register((0,v.addDisposableListener)(f,"dragover",F=>{F.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{b(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(F=>{this._register((0,v.addDisposableListener)(f,F,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}t.DelayedDragHandler=M,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:R.Mimes.text};function y(m,f,b){const F=document.createElement("div");F.className=b,F.textContent=f,m.dataTransfer&&(document.body.appendChild(F),m.dataTransfer.setDragImage(F,-10,-10),setTimeout(()=>document.body.removeChild(F),0))}t.applyDragImage=y;class w{constructor(f){this.data=f}update(){}getData(){return this.data}}t.DragAndDropData=w,t.StaticDND={CurrentDragAndDropData:void 0}}),define(me[51],pe([1,0,4]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function i(a,n={}){const e=M(n);return e.textContent=a,e}t.renderText=i;function R(a,n={}){const e=M(n);return m(e,f(a,!!n.renderCodeSegments),n.actionHandler,n.renderCodeSegments),e}t.renderFormattedText=R;function M(a){const n=a.inline?"span":"div",e=document.createElement(n);return a.className&&(e.className=a.className),e}t.createElement=M;class y{constructor(n){this.source=n,this.index=0}eos(){return this.index>=this.source.length}next(){const n=this.peek();return this.advance(),n}peek(){return this.source[this.index]}advance(){this.index++}}var w;(function(a){a[a.Invalid=0]="Invalid",a[a.Root=1]="Root",a[a.Text=2]="Text",a[a.Bold=3]="Bold",a[a.Italics=4]="Italics",a[a.Action=5]="Action",a[a.ActionClose=6]="ActionClose",a[a.Code=7]="Code",a[a.NewLine=8]="NewLine"})(w||(w={}));function m(a,n,e,d){let p;if(n.type===2)p=document.createTextNode(n.content||"");else if(n.type===3)p=document.createElement("b");else if(n.type===4)p=document.createElement("i");else if(n.type===7&&d)p=document.createElement("code");else if(n.type===5&&e){const _=document.createElement("a");e.disposables.add(v.addStandardDisposableListener(_,"click",E=>{e.callback(String(n.index),E)})),p=_}else n.type===8?p=document.createElement("br"):n.type===1&&(p=a);p&&a!==p&&a.appendChild(p),p&&Array.isArray(n.children)&&n.children.forEach(_=>{m(p,_,e,d)})}function f(a,n){const e={type:1,children:[]};let d=0,p=e;const _=[],E=new y(a);for(;!E.eos();){let u=E.next();const g=u==="\\"&&F(E.peek(),n)!==0;if(g&&(u=E.next()),!g&&b(u,n)&&u===E.peek()){E.advance(),p.type===2&&(p=_.pop());const D=F(u,n);if(p.type===D||p.type===5&&D===6)p=_.pop();else{const A={type:D,children:[]};D===5&&(A.index=d,d++),p.children.push(A),_.push(p),p=A}}else if(u===`
`)p.type===2&&(p=_.pop()),p.children.push({type:8});else if(p.type!==2){const D={type:2,content:u};p.children.push(D),_.push(p),p=D}else p.content+=u}return p.type===2&&(p=_.pop()),_.length,e}function b(a,n){return F(a,n)!==0}function F(a,n){switch(a){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return n?7:0;default:return 0}}}),define(me[52],pe([1,0,4,2]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class R{constructor(){this._hooks=new i.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(y,w){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const m=this._onStopCallback;this._onStopCallback=null,y&&m&&m(w)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(y,w,m,f,b){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=f,this._onStopCallback=b;let F=y;try{y.setPointerCapture(w),this._hooks.add((0,i.toDisposable)(()=>{y.releasePointerCapture(w)}))}catch{F=window}this._hooks.add(v.addDisposableListener(F,v.EventType.POINTER_MOVE,a=>{if(a.buttons!==m){this.stopMonitoring(!0);return}a.preventDefault(),this._pointerMoveCallback(a)})),this._hooks.add(v.addDisposableListener(F,v.EventType.POINTER_UP,a=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=R});var Ke=this&&this.__decorate||function(Z,t,v,i){var R=arguments.length,M=R<3?t:i===null?i=Object.getOwnPropertyDescriptor(t,v):i,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(Z,t,v,i);else for(var w=Z.length-1;w>=0;w--)(y=Z[w])&&(M=(R<3?y(M):R>3?y(t,v,M):y(t,v))||M);return R>3&&M&&Object.defineProperty(t,v,M),M};define(me[23],pe([1,0,4,14,26,2]),function(Z,t,v,i,R,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var y;(function(m){m.Tap="-monaco-gesturetap",m.Change="-monaco-gesturechange",m.Start="-monaco-gesturestart",m.End="-monaco-gesturesend",m.Contextmenu="-monaco-gesturecontextmenu"})(y=t.EventType||(t.EventType={}));class w extends M.Disposable{constructor(){super();this.dispatched=!1,this.activeTouches={},this.handle=null,this.targets=[],this.ignoreTargets=[],this._lastSetTapCountTime=0,this._register(v.addDisposableListener(document,"touchstart",f=>this.onTouchStart(f),{passive:!1})),this._register(v.addDisposableListener(document,"touchend",f=>this.onTouchEnd(f))),this._register(v.addDisposableListener(document,"touchmove",f=>this.onTouchMove(f),{passive:!1}))}static addTarget(f){return w.isTouchDevice()?(w.INSTANCE||(w.INSTANCE=new w),w.INSTANCE.targets.push(f),{dispose:()=>{w.INSTANCE.targets=w.INSTANCE.targets.filter(b=>b!==f)}}):M.Disposable.None}static ignoreTarget(f){return w.isTouchDevice()?(w.INSTANCE||(w.INSTANCE=new w),w.INSTANCE.ignoreTargets.push(f),{dispose:()=>{w.INSTANCE.ignoreTargets=w.INSTANCE.ignoreTargets.filter(b=>b!==f)}}):M.Disposable.None}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(f){const b=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let F=0,a=f.targetTouches.length;F<a;F++){const n=f.targetTouches.item(F);this.activeTouches[n.identifier]={id:n.identifier,initialTarget:n.target,initialTimeStamp:b,initialPageX:n.pageX,initialPageY:n.pageY,rollingTimestamps:[b],rollingPageX:[n.pageX],rollingPageY:[n.pageY]};const e=this.newGestureEvent(y.Start,n.target);e.pageX=n.pageX,e.pageY=n.pageY,this.dispatchEvent(e)}this.dispatched&&(f.preventDefault(),f.stopPropagation(),this.dispatched=!1)}onTouchEnd(f){const b=Date.now(),F=Object.keys(this.activeTouches).length;for(let a=0,n=f.changedTouches.length;a<n;a++){const e=f.changedTouches.item(a);if(!this.activeTouches.hasOwnProperty(String(e.identifier))){console.warn("move of an UNKNOWN touch",e);continue}const d=this.activeTouches[e.identifier],p=Date.now()-d.initialTimeStamp;if(p<w.HOLD_DELAY&&Math.abs(d.initialPageX-i.tail(d.rollingPageX))<30&&Math.abs(d.initialPageY-i.tail(d.rollingPageY))<30){const _=this.newGestureEvent(y.Tap,d.initialTarget);_.pageX=i.tail(d.rollingPageX),_.pageY=i.tail(d.rollingPageY),this.dispatchEvent(_)}else if(p>=w.HOLD_DELAY&&Math.abs(d.initialPageX-i.tail(d.rollingPageX))<30&&Math.abs(d.initialPageY-i.tail(d.rollingPageY))<30){const _=this.newGestureEvent(y.Contextmenu,d.initialTarget);_.pageX=i.tail(d.rollingPageX),_.pageY=i.tail(d.rollingPageY),this.dispatchEvent(_)}else if(F===1){const _=i.tail(d.rollingPageX),E=i.tail(d.rollingPageY),u=i.tail(d.rollingTimestamps)-d.rollingTimestamps[0],g=_-d.rollingPageX[0],D=E-d.rollingPageY[0],A=this.targets.filter(N=>d.initialTarget instanceof Node&&N.contains(d.initialTarget));this.inertia(A,b,Math.abs(g)/u,g>0?1:-1,_,Math.abs(D)/u,D>0?1:-1,E)}this.dispatchEvent(this.newGestureEvent(y.End,d.initialTarget)),delete this.activeTouches[e.identifier]}this.dispatched&&(f.preventDefault(),f.stopPropagation(),this.dispatched=!1)}newGestureEvent(f,b){const F=document.createEvent("CustomEvent");return F.initEvent(f,!1,!0),F.initialTarget=b,F.tapCount=0,F}dispatchEvent(f){if(f.type===y.Tap){const b=new Date().getTime();let F=0;b-this._lastSetTapCountTime>w.CLEAR_TAP_COUNT_TIME?F=1:F=2,this._lastSetTapCountTime=b,f.tapCount=F}else(f.type===y.Change||f.type===y.Contextmenu)&&(this._lastSetTapCountTime=0);for(let b=0;b<this.ignoreTargets.length;b++)if(f.initialTarget instanceof Node&&this.ignoreTargets[b].contains(f.initialTarget))return;this.targets.forEach(b=>{f.initialTarget instanceof Node&&b.contains(f.initialTarget)&&(b.dispatchEvent(f),this.dispatched=!0)})}inertia(f,b,F,a,n,e,d,p){this.handle=v.scheduleAtNextAnimationFrame(()=>{const _=Date.now(),E=_-b;let u=0,g=0,D=!0;F+=w.SCROLL_FRICTION*E,e+=w.SCROLL_FRICTION*E,F>0&&(D=!1,u=a*F*E),e>0&&(D=!1,g=d*e*E);const A=this.newGestureEvent(y.Change);A.translationX=u,A.translationY=g,f.forEach(N=>N.dispatchEvent(A)),D||this.inertia(f,_,F,a,n+u,e,d,p+g)})}onTouchMove(f){const b=Date.now();for(let F=0,a=f.changedTouches.length;F<a;F++){const n=f.changedTouches.item(F);if(!this.activeTouches.hasOwnProperty(String(n.identifier))){console.warn("end of an UNKNOWN touch",n);continue}const e=this.activeTouches[n.identifier],d=this.newGestureEvent(y.Change,e.initialTarget);d.translationX=n.pageX-i.tail(e.rollingPageX),d.translationY=n.pageY-i.tail(e.rollingPageY),d.pageX=n.pageX,d.pageY=n.pageY,this.dispatchEvent(d),e.rollingPageX.length>3&&(e.rollingPageX.shift(),e.rollingPageY.shift(),e.rollingTimestamps.shift()),e.rollingPageX.push(n.pageX),e.rollingPageY.push(n.pageY),e.rollingTimestamps.push(b)}this.dispatched&&(f.preventDefault(),f.stopPropagation(),this.dispatched=!1)}}w.SCROLL_FRICTION=-.005,w.HOLD_DELAY=700,w.CLEAR_TAP_COUNT_TIME=400,Ke([R.memoize],w,"isTouchDevice",null),t.Gesture=w}),define(me[53],pe([1,0,4,5,82]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const R=2e4;let M,y,w,m,f;function b(e){M=document.createElement("div"),M.className="monaco-aria-container";const d=()=>{const _=document.createElement("div");return _.className="monaco-alert",_.setAttribute("role","alert"),_.setAttribute("aria-atomic","true"),M.appendChild(_),_};y=d(),w=d();const p=()=>{const _=document.createElement("div");return _.className="monaco-status",_.setAttribute("role","complementary"),_.setAttribute("aria-live","polite"),_.setAttribute("aria-atomic","true"),M.appendChild(_),_};m=p(),f=p(),e.appendChild(M)}t.setARIAContainer=b;function F(e){!M||(y.textContent!==e?(v.clearNode(w),n(y,e)):(v.clearNode(y),n(w,e)))}t.alert=F;function a(e){!M||(i.isMacintosh?F(e):m.textContent!==e?(v.clearNode(f),n(m,e)):(v.clearNode(m),n(f,e)))}t.status=a;function n(e,d){v.clearNode(e),d.length>R&&(d=d.substr(0,R)),e.textContent=d,e.style.visibility="hidden",e.style.visibility="visible"}}),define(me[113],pe([1,0,4,11]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const R=new RegExp(`(\\\\)?\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)`,"g");function M(w){const m=new Array;let f,b=0,F=0;for(;(f=R.exec(w))!==null;){F=f.index||0,m.push(w.substring(b,F)),b=(f.index||0)+f[0].length;const[,a,n]=f;m.push(a?`$(${n})`:y({id:n}))}return b<w.length&&m.push(w.substring(b)),m}t.renderLabelWithIcons=M;function y(w){const m=v.$("span");return m.classList.add(...i.CSSIcon.asClassNameArray(w)),m}t.renderIcon=y}),define(me[114],pe([1,0,4]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function i(M){try{M.parentElement?.removeChild(M)}catch{}}class R{constructor(y){this.renderers=y,this.cache=new Map}alloc(y){let w=this.getTemplateCache(y).pop();if(!w){const m=(0,v.$)(".monaco-list-row"),b=this.getRenderer(y).renderTemplate(m);w={domNode:m,templateId:y,templateData:b}}return w}release(y){!y||this.releaseRow(y)}releaseRow(y){const{domNode:w,templateId:m}=y;w&&(w.classList.remove("scrolling"),i(w)),this.getTemplateCache(m).push(y)}getTemplateCache(y){let w=this.cache.get(y);return w||(w=[],this.cache.set(y,w)),w}dispose(){this.cache.forEach((y,w)=>{for(const m of y)this.getRenderer(w).disposeTemplate(m.templateData),m.templateData=null}),this.cache.clear()}getRenderer(y){const w=this.renderers.get(y);if(!w)throw new Error(`No renderer found for ${y}`);return w}}t.RowCache=R}),define(me[115],pe([1,0,6,2]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class R extends i.Disposable{constructor(y,w,m){super();this._visibility=y,this._visibleClassName=w,this._invisibleClassName=m,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new v.TimeoutTimer)}setVisibility(y){this._visibility!==y&&(this._visibility=y,this._updateShouldBeVisible())}setShouldBeVisible(y){this._rawShouldBeVisible=y,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===2?!1:this._visibility===3?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const y=this._applyVisibilitySetting();this._shouldBeVisible!==y&&(this._shouldBeVisible=y,this.ensureVisibility())}setIsNeeded(y){this._isNeeded!==y&&(this._isNeeded=y,this.ensureVisibility())}setDomNode(y){this._domNode=y,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(y){this._revealTimer.cancel(),!!this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(y?" fade":"")))}}t.ScrollbarVisibilityController=R}),define(me[116],pe([1,0,4,23,14,3,2,5]),function(Z,t,v,i,R,M,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class m extends y.Disposable{constructor(b,F,a,n){super();this.selected=0,this.selectBoxOptions=n||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new M.Emitter),this.styles=a,this.registerListeners(),this.setOptions(b,F)}registerListeners(){this._register(i.Gesture.addTarget(this.selectElement)),[i.EventType.Tap].forEach(b=>{this._register(v.addDisposableListener(this.selectElement,b,F=>{this.selectElement.focus()}))}),this._register(v.addStandardDisposableListener(this.selectElement,"click",b=>{v.EventHelper.stop(b,!0)})),this._register(v.addStandardDisposableListener(this.selectElement,"change",b=>{this.selectElement.title=b.target.value,this._onDidSelect.fire({index:b.target.selectedIndex,selected:b.target.value})})),this._register(v.addStandardDisposableListener(this.selectElement,"keydown",b=>{let F=!1;w.isMacintosh?(b.keyCode===18||b.keyCode===16||b.keyCode===10)&&(F=!0):(b.keyCode===18&&b.altKey||b.keyCode===10||b.keyCode===3)&&(F=!0),F&&b.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(b,F){(!this.options||!R.equals(this.options,b))&&(this.options=b,this.selectElement.options.length=0,this.options.forEach((a,n)=>{this.selectElement.add(this.createOption(a.text,n,a.isDisabled))})),F!==void 0&&this.select(F)}select(b){this.options.length===0?this.selected=0:b>=0&&b<this.options.length?this.selected=b:b>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(b){this.selectBoxOptions.ariaLabel=b,this.selectElement.setAttribute("aria-label",b)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(b){this.selectElement.tabIndex=b?0:-1}render(b){b.classList.add("select-container"),b.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(b){this.styles=b,this.applyStyles()}applyStyles(){if(this.selectElement){const b=this.styles.selectBackground?this.styles.selectBackground.toString():"",F=this.styles.selectForeground?this.styles.selectForeground.toString():"",a=this.styles.selectBorder?this.styles.selectBorder.toString():"";this.selectElement.style.backgroundColor=b,this.selectElement.style.color=F,this.selectElement.style.borderColor=a}}createOption(b,F,a){const n=document.createElement("option");return n.value=b,n.text=b,n.disabled=!!a,n}}t.SelectBoxNative=m}),define(me[54],pe([1,0,24,14,6,111,3,27]),function(Z,t,v,i,R,M,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function m(a){return typeof a=="object"&&"visibility"in a&&"data"in a}t.isFilterResult=m;function f(a){switch(a){case!0:return 1;case!1:return 0;default:return a}}t.getVisibleState=f;function b(a){return typeof a.collapsible=="boolean"}class F{constructor(n,e,d,p={}){this.user=n,this.list=e,this.rootRef=[],this.eventBufferer=new y.EventBufferer,this._onDidChangeCollapseState=new y.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new y.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new y.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new R.Delayer(R.MicrotaskDelay),this.collapseByDefault=typeof p.collapseByDefault=="undefined"?!1:p.collapseByDefault,this.filter=p.filter,this.autoExpandSingleChildren=typeof p.autoExpandSingleChildren=="undefined"?!1:p.autoExpandSingleChildren,this.root={parent:void 0,element:d,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(n,e,d=w.Iterable.empty(),p={}){if(n.length===0)throw new v.TreeError(this.user,"Invalid tree location");p.diffIdentityProvider?this.spliceSmart(p.diffIdentityProvider,n,e,d,p):this.spliceSimple(n,e,d,p)}spliceSmart(n,e,d,p=w.Iterable.empty(),_,E=_.diffDepth??0){const{parentNode:u}=this.getParentNodeWithListIndex(e);if(!u.lastDiffIds)return this.spliceSimple(e,d,p,_);const g=[...p],D=e[e.length-1],A=new M.LcsDiff({getElements:()=>u.lastDiffIds},{getElements:()=>[...u.children.slice(0,D),...g,...u.children.slice(D+d)].map(o=>n.getId(o.element).toString())}).ComputeDiff(!1);if(A.quitEarly)return u.lastDiffIds=void 0,this.spliceSimple(e,d,g,_);const N=e.slice(0,-1),T=(o,r,c)=>{if(E>0)for(let C=0;C<c;C++)o--,r--,this.spliceSmart(n,[...N,o,0],Number.MAX_SAFE_INTEGER,g[r].children,_,E-1)};let s=Math.min(u.children.length,D+d),l=g.length;for(const o of A.changes.sort((r,c)=>c.originalStart-r.originalStart))T(s,l,s-(o.originalStart+o.originalLength)),s=o.originalStart,l=o.modifiedStart-D,this.spliceSimple([...N,s],o.originalLength,w.Iterable.slice(g,l,l+o.modifiedLength),_);T(s,l,s)}spliceSimple(n,e,d=w.Iterable.empty(),{onDidCreateNode:p,onDidDeleteNode:_,diffIdentityProvider:E}){const{parentNode:u,listIndex:g,revealed:D,visible:A}=this.getParentNodeWithListIndex(n),N=[],T=w.Iterable.map(d,ne=>this.createTreeNode(ne,u,u.visible?1:0,D,N,p)),s=n[n.length-1],l=u.children.length>0;let o=0;for(let ne=s;ne>=0&&ne<u.children.length;ne--){const we=u.children[ne];if(we.visible){o=we.visibleChildIndex;break}}const r=[];let c=0,C=0;for(const ne of T)r.push(ne),C+=ne.renderNodeCount,ne.visible&&(ne.visibleChildIndex=o+c++);const V=(0,i.splice)(u.children,s,e,r);E?u.lastDiffIds?(0,i.splice)(u.lastDiffIds,s,e,r.map(ne=>E.getId(ne.element).toString())):u.lastDiffIds=u.children.map(ne=>E.getId(ne.element).toString()):u.lastDiffIds=void 0;let se=0;for(const ne of V)ne.visible&&se++;if(se!==0)for(let ne=s+r.length;ne<u.children.length;ne++){const we=u.children[ne];we.visible&&(we.visibleChildIndex-=se)}if(u.visibleChildrenCount+=c-se,D&&A){const ne=V.reduce((we,de)=>we+(de.visible?de.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(u,C-ne),this.list.splice(g,ne,N)}if(V.length>0&&_){const ne=we=>{_(we),we.children.forEach(ne)};V.forEach(ne)}this._onDidSplice.fire({insertedNodes:r,deletedNodes:V});const ie=u.children.length>0;l!==ie&&this.setCollapsible(n.slice(0,-1),ie);let ae=u;for(;ae;){if(ae.visibility===2){this.refilterDelayer.trigger(()=>this.refilter());break}ae=ae.parent}}rerender(n){if(n.length===0)throw new v.TreeError(this.user,"Invalid tree location");const{node:e,listIndex:d,revealed:p}=this.getTreeNodeWithListIndex(n);e.visible&&p&&this.list.splice(d,1,[e])}updateElementHeight(n,e){if(n.length===0)throw new v.TreeError(this.user,"Invalid tree location");const{listIndex:d}=this.getTreeNodeWithListIndex(n);this.list.updateElementHeight(d,e)}has(n){return this.hasTreeNode(n)}getListIndex(n){const{listIndex:e,visible:d,revealed:p}=this.getTreeNodeWithListIndex(n);return d&&p?e:-1}getListRenderCount(n){return this.getTreeNode(n).renderNodeCount}isCollapsible(n){return this.getTreeNode(n).collapsible}setCollapsible(n,e){const d=this.getTreeNode(n);typeof e=="undefined"&&(e=!d.collapsible);const p={collapsible:e};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(n,p))}isCollapsed(n){return this.getTreeNode(n).collapsed}setCollapsed(n,e,d){const p=this.getTreeNode(n);typeof e=="undefined"&&(e=!p.collapsed);const _={collapsed:e,recursive:d||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(n,_))}_setCollapseState(n,e){const{node:d,listIndex:p,revealed:_}=this.getTreeNodeWithListIndex(n),E=this._setListNodeCollapseState(d,p,_,e);if(d!==this.root&&this.autoExpandSingleChildren&&E&&!b(e)&&d.collapsible&&!d.collapsed&&!e.recursive){let u=-1;for(let g=0;g<d.children.length;g++)if(d.children[g].visible)if(u>-1){u=-1;break}else u=g;u>-1&&this._setCollapseState([...n,u],e)}return E}_setListNodeCollapseState(n,e,d,p){const _=this._setNodeCollapseState(n,p,!1);if(!d||!n.visible||!_)return _;const E=n.renderNodeCount,u=this.updateNodeAfterCollapseChange(n),g=E-(e===-1?0:1);return this.list.splice(e+1,g,u.slice(1)),_}_setNodeCollapseState(n,e,d){let p;if(n===this.root?p=!1:(b(e)?(p=n.collapsible!==e.collapsible,n.collapsible=e.collapsible):n.collapsible?(p=n.collapsed!==e.collapsed,n.collapsed=e.collapsed):p=!1,p&&this._onDidChangeCollapseState.fire({node:n,deep:d})),!b(e)&&e.recursive)for(const _ of n.children)p=this._setNodeCollapseState(_,e,!0)||p;return p}expandTo(n){this.eventBufferer.bufferEvents(()=>{let e=this.getTreeNode(n);for(;e.parent;)e=e.parent,n=n.slice(0,n.length-1),e.collapsed&&this._setCollapseState(n,{collapsed:!1,recursive:!1})})}refilter(){const n=this.root.renderNodeCount,e=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,n,e),this.refilterDelayer.cancel()}createTreeNode(n,e,d,p,_,E){const u={parent:e,element:n.element,children:[],depth:e.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof n.collapsible=="boolean"?n.collapsible:typeof n.collapsed!="undefined",collapsed:typeof n.collapsed=="undefined"?this.collapseByDefault:n.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},g=this._filterNode(u,d);u.visibility=g,p&&_.push(u);const D=n.children||w.Iterable.empty(),A=p&&g!==0&&!u.collapsed,N=w.Iterable.map(D,l=>this.createTreeNode(l,u,g,A,_,E));let T=0,s=1;for(const l of N)u.children.push(l),s+=l.renderNodeCount,l.visible&&(l.visibleChildIndex=T++);return u.collapsible=u.collapsible||u.children.length>0,u.visibleChildrenCount=T,u.visible=g===2?T>0:g===1,u.visible?u.collapsed||(u.renderNodeCount=s):(u.renderNodeCount=0,p&&_.pop()),E?.(u),u}updateNodeAfterCollapseChange(n){const e=n.renderNodeCount,d=[];return this._updateNodeAfterCollapseChange(n,d),this._updateAncestorsRenderNodeCount(n.parent,d.length-e),d}_updateNodeAfterCollapseChange(n,e){if(n.visible===!1)return 0;if(e.push(n),n.renderNodeCount=1,!n.collapsed)for(const d of n.children)n.renderNodeCount+=this._updateNodeAfterCollapseChange(d,e);return this._onDidChangeRenderNodeCount.fire(n),n.renderNodeCount}updateNodeAfterFilterChange(n){const e=n.renderNodeCount,d=[];return this._updateNodeAfterFilterChange(n,n.visible?1:0,d),this._updateAncestorsRenderNodeCount(n.parent,d.length-e),d}_updateNodeAfterFilterChange(n,e,d,p=!0){let _;if(n!==this.root){if(_=this._filterNode(n,e),_===0)return n.visible=!1,n.renderNodeCount=0,!1;p&&d.push(n)}const E=d.length;n.renderNodeCount=n===this.root?0:1;let u=!1;if(!n.collapsed||_!==0){let g=0;for(const D of n.children)u=this._updateNodeAfterFilterChange(D,_,d,p&&!n.collapsed)||u,D.visible&&(D.visibleChildIndex=g++);n.visibleChildrenCount=g}else n.visibleChildrenCount=0;return n!==this.root&&(n.visible=_===2?u:_===1,n.visibility=_),n.visible?n.collapsed||(n.renderNodeCount+=d.length-E):(n.renderNodeCount=0,p&&d.pop()),this._onDidChangeRenderNodeCount.fire(n),n.visible}_updateAncestorsRenderNodeCount(n,e){if(e!==0)for(;n;)n.renderNodeCount+=e,this._onDidChangeRenderNodeCount.fire(n),n=n.parent}_filterNode(n,e){const d=this.filter?this.filter.filter(n.element,e):1;return typeof d=="boolean"?(n.filterData=void 0,d?1:0):m(d)?(n.filterData=d.data,f(d.visibility)):(n.filterData=void 0,f(d))}hasTreeNode(n,e=this.root){if(!n||n.length===0)return!0;const[d,...p]=n;return d<0||d>e.children.length?!1:this.hasTreeNode(p,e.children[d])}getTreeNode(n,e=this.root){if(!n||n.length===0)return e;const[d,...p]=n;if(d<0||d>e.children.length)throw new v.TreeError(this.user,"Invalid tree location");return this.getTreeNode(p,e.children[d])}getTreeNodeWithListIndex(n){if(n.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:e,listIndex:d,revealed:p,visible:_}=this.getParentNodeWithListIndex(n),E=n[n.length-1];if(E<0||E>e.children.length)throw new v.TreeError(this.user,"Invalid tree location");const u=e.children[E];return{node:u,listIndex:d,revealed:p,visible:_&&u.visible}}getParentNodeWithListIndex(n,e=this.root,d=0,p=!0,_=!0){const[E,...u]=n;if(E<0||E>e.children.length)throw new v.TreeError(this.user,"Invalid tree location");for(let g=0;g<E;g++)d+=e.children[g].renderNodeCount;return p=p&&!e.collapsed,_=_&&e.visible,u.length===0?{parentNode:e,listIndex:d,revealed:p,visible:_}:this.getParentNodeWithListIndex(u,e.children[E],d+1,p,_)}getNode(n=[]){return this.getTreeNode(n)}getNodeLocation(n){const e=[];let d=n;for(;d.parent;)e.push(d.parent.children.indexOf(d)),d=d.parent;return e.reverse()}getParentNodeLocation(n){if(n.length!==0)return n.length===1?[]:(0,i.tail2)(n)[0]}getFirstElementChild(n){const e=this.getTreeNode(n);if(e.children.length!==0)return e.children[0].element}getLastElementAncestor(n=[]){const e=this.getTreeNode(n);if(e.children.length!==0)return this._getLastElementAncestor(e)}_getLastElementAncestor(n){return n.children.length===0?n.element:this._getLastElementAncestor(n.children[n.children.length-1])}}t.IndexTreeModel=F}),define(me[117],pe([1,0,54,24,27]),function(Z,t,v,i,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class M{constructor(w,m,f={}){this.user=w,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new v.IndexTreeModel(w,m,null,f),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,f.sorter&&(this.sorter={compare(b,F){return f.sorter.compare(b.element,F.element)}}),this.identityProvider=f.identityProvider}get size(){return this.nodes.size}setChildren(w,m=R.Iterable.empty(),f={}){const b=this.getElementLocation(w);this._setChildren(b,this.preserveCollapseState(m),f)}_setChildren(w,m=R.Iterable.empty(),f){const b=new Set,F=new Set,a=e=>{if(e.element===null)return;const d=e;if(b.add(d.element),this.nodes.set(d.element,d),this.identityProvider){const p=this.identityProvider.getId(d.element).toString();F.add(p),this.nodesByIdentity.set(p,d)}f.onDidCreateNode?.(d)},n=e=>{if(e.element===null)return;const d=e;if(b.has(d.element)||this.nodes.delete(d.element),this.identityProvider){const p=this.identityProvider.getId(d.element).toString();F.has(p)||this.nodesByIdentity.delete(p)}f.onDidDeleteNode?.(d)};this.model.splice([...w,0],Number.MAX_VALUE,m,{...f,onDidCreateNode:a,onDidDeleteNode:n})}preserveCollapseState(w=R.Iterable.empty()){return this.sorter&&(w=[...w].sort(this.sorter.compare.bind(this.sorter))),R.Iterable.map(w,m=>{let f=this.nodes.get(m.element);if(!f&&this.identityProvider){const a=this.identityProvider.getId(m.element).toString();f=this.nodesByIdentity.get(a)}if(!f)return{...m,children:this.preserveCollapseState(m.children)};const b=typeof m.collapsible=="boolean"?m.collapsible:f.collapsible,F=typeof m.collapsed!="undefined"?m.collapsed:f.collapsed;return{...m,collapsible:b,collapsed:F,children:this.preserveCollapseState(m.children)}})}rerender(w){const m=this.getElementLocation(w);this.model.rerender(m)}updateElementHeight(w,m){const f=this.getElementLocation(w);this.model.updateElementHeight(f,m)}resort(w=null,m=!0){if(!this.sorter)return;const f=this.getElementLocation(w),b=this.model.getNode(f);this._setChildren(f,this.resortChildren(b,m),{})}resortChildren(w,m,f=!0){let b=[...w.children];return(m||f)&&(b=b.sort(this.sorter.compare.bind(this.sorter))),R.Iterable.map(b,F=>({element:F.element,collapsible:F.collapsible,collapsed:F.collapsed,children:this.resortChildren(F,m,!1)}))}getFirstElementChild(w=null){const m=this.getElementLocation(w);return this.model.getFirstElementChild(m)}getLastElementAncestor(w=null){const m=this.getElementLocation(w);return this.model.getLastElementAncestor(m)}has(w){return this.nodes.has(w)}getListIndex(w){const m=this.getElementLocation(w);return this.model.getListIndex(m)}getListRenderCount(w){const m=this.getElementLocation(w);return this.model.getListRenderCount(m)}isCollapsible(w){const m=this.getElementLocation(w);return this.model.isCollapsible(m)}setCollapsible(w,m){const f=this.getElementLocation(w);return this.model.setCollapsible(f,m)}isCollapsed(w){const m=this.getElementLocation(w);return this.model.isCollapsed(m)}setCollapsed(w,m,f){const b=this.getElementLocation(w);return this.model.setCollapsed(b,m,f)}expandTo(w){const m=this.getElementLocation(w);this.model.expandTo(m)}refilter(){this.model.refilter()}getNode(w=null){if(w===null)return this.model.getNode(this.model.rootRef);const m=this.nodes.get(w);if(!m)throw new i.TreeError(this.user,`Tree element not found: ${w}`);return m}getNodeLocation(w){return w.element}getParentNodeLocation(w){if(w===null)throw new i.TreeError(this.user,"Invalid getParentNodeLocation call");const m=this.nodes.get(w);if(!m)throw new i.TreeError(this.user,`Tree element not found: ${w}`);const f=this.model.getNodeLocation(m),b=this.model.getParentNodeLocation(f);return this.model.getNode(b).element}getElementLocation(w){if(w===null)return[];const m=this.nodes.get(w);if(!m)throw new i.TreeError(this.user,`Tree element not found: ${w}`);return this.model.getNodeLocation(m)}}t.ObjectTreeModel=M}),define(me[17],pe([1,0,4,19,20,23,2]),function(Z,t,v,i,R,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class w extends y.Disposable{onclick(f,b){this._register(v.addDisposableListener(f,v.EventType.CLICK,F=>b(new R.StandardMouseEvent(F))))}onmousedown(f,b){this._register(v.addDisposableListener(f,v.EventType.MOUSE_DOWN,F=>b(new R.StandardMouseEvent(F))))}onmouseover(f,b){this._register(v.addDisposableListener(f,v.EventType.MOUSE_OVER,F=>b(new R.StandardMouseEvent(F))))}onmouseleave(f,b){this._register(v.addDisposableListener(f,v.EventType.MOUSE_LEAVE,F=>b(new R.StandardMouseEvent(F))))}onkeydown(f,b){this._register(v.addDisposableListener(f,v.EventType.KEY_DOWN,F=>b(new i.StandardKeyboardEvent(F))))}onkeyup(f,b){this._register(v.addDisposableListener(f,v.EventType.KEY_UP,F=>b(new i.StandardKeyboardEvent(F))))}oninput(f,b){this._register(v.addDisposableListener(f,v.EventType.INPUT,b))}onblur(f,b){this._register(v.addDisposableListener(f,v.EventType.BLUR,b))}onfocus(f,b){this._register(v.addDisposableListener(f,v.EventType.FOCUS,b))}onchange(f,b){this._register(v.addDisposableListener(f,v.EventType.CHANGE,b))}ignoreGesture(f){M.Gesture.ignoreTarget(f)}}t.Widget=w}),define(me[37],pe([1,0,52,17,6,4]),function(Z,t,v,i,R,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class y extends i.Widget{constructor(m){super();this._onActivate=m.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=m.bgWidth+"px",this.bgDomNode.style.height=m.bgHeight+"px",typeof m.top!="undefined"&&(this.bgDomNode.style.top="0px"),typeof m.left!="undefined"&&(this.bgDomNode.style.left="0px"),typeof m.bottom!="undefined"&&(this.bgDomNode.style.bottom="0px"),typeof m.right!="undefined"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=m.className,this.domNode.classList.add(...m.icon.classNamesArray),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof m.top!="undefined"&&(this.domNode.style.top=m.top+"px"),typeof m.left!="undefined"&&(this.domNode.style.left=m.left+"px"),typeof m.bottom!="undefined"&&(this.domNode.style.bottom=m.bottom+"px"),typeof m.right!="undefined"&&(this.domNode.style.right=m.right+"px"),this._pointerMoveMonitor=this._register(new v.GlobalPointerMoveMonitor),this._register(M.addStandardDisposableListener(this.bgDomNode,M.EventType.POINTER_DOWN,f=>this._arrowPointerDown(f))),this._register(M.addStandardDisposableListener(this.domNode,M.EventType.POINTER_DOWN,f=>this._arrowPointerDown(f))),this._pointerdownRepeatTimer=this._register(new R.IntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new R.TimeoutTimer)}_arrowPointerDown(m){if(!m.target||!(m.target instanceof Element))return;const f=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24)};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(f,200),this._pointerMoveMonitor.startMonitoring(m.target,m.pointerId,m.buttons,b=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),m.preventDefault()}}t.ScrollbarArrow=y}),define(me[55],pe([1,0,4,40,52,37,115,17,5]),function(Z,t,v,i,R,M,y,w,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const f=140;class b extends w.Widget{constructor(a){super();this._lazyRender=a.lazyRender,this._host=a.host,this._scrollable=a.scrollable,this._scrollByPage=a.scrollByPage,this._scrollbarState=a.scrollbarState,this._visibilityController=this._register(new y.ScrollbarVisibilityController(a.visibility,"visible scrollbar "+a.extraScrollbarClassName,"invisible scrollbar "+a.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new R.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,i.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(v.addDisposableListener(this.domNode.domNode,v.EventType.POINTER_DOWN,n=>this._domNodePointerDown(n)))}_createArrow(a){const n=this._register(new M.ScrollbarArrow(a));this.domNode.domNode.appendChild(n.bgDomNode),this.domNode.domNode.appendChild(n.domNode)}_createSlider(a,n,e,d){this.slider=(0,i.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(a),this.slider.setLeft(n),typeof e=="number"&&this.slider.setWidth(e),typeof d=="number"&&this.slider.setHeight(d),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(v.addDisposableListener(this.slider.domNode,v.EventType.POINTER_DOWN,p=>{p.button===0&&(p.preventDefault(),this._sliderPointerDown(p))})),this.onclick(this.slider.domNode,p=>{p.leftButton&&p.stopPropagation()})}_onElementSize(a){return this._scrollbarState.setVisibleSize(a)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(a){return this._scrollbarState.setScrollSize(a)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(a){return this._scrollbarState.setScrollPosition(a)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){!this._shouldRender||(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(a){a.target===this.domNode.domNode&&this._onPointerDown(a)}delegatePointerDown(a){const n=this.domNode.domNode.getClientRects()[0].top,e=n+this._scrollbarState.getSliderPosition(),d=n+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),p=this._sliderPointerPosition(a);e<=p&&p<=d?a.button===0&&(a.preventDefault(),this._sliderPointerDown(a)):this._onPointerDown(a)}_onPointerDown(a){let n,e;if(a.target===this.domNode.domNode&&typeof a.offsetX=="number"&&typeof a.offsetY=="number")n=a.offsetX,e=a.offsetY;else{const p=v.getDomNodePagePosition(this.domNode.domNode);n=a.pageX-p.left,e=a.pageY-p.top}const d=this._pointerDownRelativePosition(n,e);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(d):this._scrollbarState.getDesiredScrollPositionFromOffset(d)),a.button===0&&(a.preventDefault(),this._sliderPointerDown(a))}_sliderPointerDown(a){if(!a.target||!(a.target instanceof Element))return;const n=this._sliderPointerPosition(a),e=this._sliderOrthogonalPointerPosition(a),d=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(a.target,a.pointerId,a.buttons,p=>{const _=this._sliderOrthogonalPointerPosition(p),E=Math.abs(_-e);if(m.isWindows&&E>f){this._setDesiredScrollPositionNow(d.getScrollPosition());return}const g=this._sliderPointerPosition(p)-n;this._setDesiredScrollPositionNow(d.getDesiredScrollPositionFromDelta(g))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(a){const n={};this.writeScrollPosition(n,a),this._scrollable.setScrollPositionNow(n)}updateScrollbarSize(a){this._updateScrollbarSize(a),this._scrollbarState.setScrollbarSize(a),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}t.AbstractScrollbar=b}),define(me[118],pe([1,0,20,55,37,41,11]),function(Z,t,v,i,R,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class w extends i.AbstractScrollbar{constructor(f,b,F){const a=f.getScrollDimensions(),n=f.getCurrentScrollPosition();super({lazyRender:b.lazyRender,host:F,scrollbarState:new M.ScrollbarState(b.horizontalHasArrows?b.arrowSize:0,b.horizontal===2?0:b.horizontalScrollbarSize,b.vertical===2?0:b.verticalScrollbarSize,a.width,a.scrollWidth,n.scrollLeft),visibility:b.horizontal,extraScrollbarClassName:"horizontal",scrollable:f,scrollByPage:b.scrollByPage});if(b.horizontalHasArrows){const e=(b.arrowSize-R.ARROW_IMG_SIZE)/2,d=(b.horizontalScrollbarSize-R.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonLeft,top:d,left:e,bottom:void 0,right:void 0,bgWidth:b.arrowSize,bgHeight:b.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new v.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonRight,top:d,left:void 0,bottom:void 0,right:e,bgWidth:b.arrowSize,bgHeight:b.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new v.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((b.horizontalScrollbarSize-b.horizontalSliderSize)/2),0,void 0,b.horizontalSliderSize)}_updateSlider(f,b){this.slider.setWidth(f),this.slider.setLeft(b)}_renderDomNode(f,b){this.domNode.setWidth(f),this.domNode.setHeight(b),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(f){return this._shouldRender=this._onElementScrollSize(f.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(f.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(f.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(f,b){return f}_sliderPointerPosition(f){return f.pageX}_sliderOrthogonalPointerPosition(f){return f.pageY}_updateScrollbarSize(f){this.slider.setHeight(f)}writeScrollPosition(f,b){f.scrollLeft=b}updateOptions(f){this.updateScrollbarSize(f.horizontal===2?0:f.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(f.vertical===2?0:f.verticalScrollbarSize),this._visibilityController.setVisibility(f.horizontal),this._scrollByPage=f.scrollByPage}}t.HorizontalScrollbar=w}),define(me[119],pe([1,0,20,55,37,41,11]),function(Z,t,v,i,R,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class w extends i.AbstractScrollbar{constructor(f,b,F){const a=f.getScrollDimensions(),n=f.getCurrentScrollPosition();super({lazyRender:b.lazyRender,host:F,scrollbarState:new M.ScrollbarState(b.verticalHasArrows?b.arrowSize:0,b.vertical===2?0:b.verticalScrollbarSize,0,a.height,a.scrollHeight,n.scrollTop),visibility:b.vertical,extraScrollbarClassName:"vertical",scrollable:f,scrollByPage:b.scrollByPage});if(b.verticalHasArrows){const e=(b.arrowSize-R.ARROW_IMG_SIZE)/2,d=(b.verticalScrollbarSize-R.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonUp,top:e,left:d,bottom:void 0,right:void 0,bgWidth:b.verticalScrollbarSize,bgHeight:b.arrowSize,onActivate:()=>this._host.onMouseWheel(new v.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonDown,top:void 0,left:d,bottom:e,right:void 0,bgWidth:b.verticalScrollbarSize,bgHeight:b.arrowSize,onActivate:()=>this._host.onMouseWheel(new v.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((b.verticalScrollbarSize-b.verticalSliderSize)/2),b.verticalSliderSize,void 0)}_updateSlider(f,b){this.slider.setHeight(f),this.slider.setTop(b)}_renderDomNode(f,b){this.domNode.setWidth(b),this.domNode.setHeight(f),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(f){return this._shouldRender=this._onElementScrollSize(f.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(f.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(f.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(f,b){return b}_sliderPointerPosition(f){return f.pageY}_sliderOrthogonalPointerPosition(f){return f.pageX}_updateScrollbarSize(f){this.slider.setWidth(f)}writeScrollPosition(f,b){f.scrollTop=b}updateOptions(f){this.updateScrollbarSize(f.vertical===2?0:f.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(f.vertical),this._scrollByPage=f.scrollByPage}}t.VerticalScrollbar=w}),define(me[56],pe([1,0,15,4,40,20,118,119,17,6,3,2,5,47,89]),function(Z,t,v,i,R,M,y,w,m,f,b,F,a,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,d=50,p=!0;class _{constructor(s,l,o){this.timestamp=s,this.deltaX=l,this.deltaY=o,this.score=0}}class E{constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let s=1,l=0,o=1,r=this._rear;do{const c=r===this._front?s:Math.pow(2,-o);if(s-=c,l+=this._memory[r].score*c,r===this._front)break;r=(this._capacity+r-1)%this._capacity,o++}while(!0);return l<=.5}accept(s,l,o){const r=new _(s,l,o);r.score=this._computeScore(r),this._front===-1&&this._rear===-1?(this._memory[0]=r,this._front=0,this._rear=0):(this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=r)}_computeScore(s){if(Math.abs(s.deltaX)>0&&Math.abs(s.deltaY)>0)return 1;let l=.5;const o=this._front===-1&&this._rear===-1?null:this._memory[this._rear];return(!this._isAlmostInt(s.deltaX)||!this._isAlmostInt(s.deltaY))&&(l+=.25),Math.min(Math.max(l,0),1)}_isAlmostInt(s){return Math.abs(Math.round(s)-s)<.01}}t.MouseWheelClassifier=E,E.INSTANCE=new E;class u extends m.Widget{constructor(s,l,o){super();this._onScroll=this._register(new b.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new b.Emitter),this.onWillScroll=this._onWillScroll.event,s.style.overflow="hidden",this._options=N(l),this._scrollable=o,this._register(this._scrollable.onScroll(c=>{this._onWillScroll.fire(c),this._onDidScroll(c),this._onScroll.fire(c)}));const r={onMouseWheel:c=>this._onMouseWheel(c),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new w.VerticalScrollbar(this._scrollable,this._options,r)),this._horizontalScrollbar=this._register(new y.HorizontalScrollbar(this._scrollable,this._options,r)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(s),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,R.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,R.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,R.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,c=>this._onMouseOver(c)),this.onmouseleave(this._listenOnDomNode,c=>this._onMouseLeave(c)),this._hideTimeout=this._register(new f.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}get options(){return this._options}dispose(){this._mouseWheelToDispose=(0,F.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(s){this._verticalScrollbar.delegatePointerDown(s)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(s){this._scrollable.setScrollDimensions(s,!1)}updateClassName(s){this._options.className=s,a.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(s){typeof s.handleMouseWheel!="undefined"&&(this._options.handleMouseWheel=s.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof s.mouseWheelScrollSensitivity!="undefined"&&(this._options.mouseWheelScrollSensitivity=s.mouseWheelScrollSensitivity),typeof s.fastScrollSensitivity!="undefined"&&(this._options.fastScrollSensitivity=s.fastScrollSensitivity),typeof s.scrollPredominantAxis!="undefined"&&(this._options.scrollPredominantAxis=s.scrollPredominantAxis),typeof s.horizontal!="undefined"&&(this._options.horizontal=s.horizontal),typeof s.vertical!="undefined"&&(this._options.vertical=s.vertical),typeof s.horizontalScrollbarSize!="undefined"&&(this._options.horizontalScrollbarSize=s.horizontalScrollbarSize),typeof s.verticalScrollbarSize!="undefined"&&(this._options.verticalScrollbarSize=s.verticalScrollbarSize),typeof s.scrollByPage!="undefined"&&(this._options.scrollByPage=s.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(s){this._revealOnScroll=s}triggerScrollFromMouseWheelEvent(s){this._onMouseWheel(new M.StandardWheelEvent(s))}_setListeningToMouseWheel(s){if(this._mouseWheelToDispose.length>0!==s&&(this._mouseWheelToDispose=(0,F.dispose)(this._mouseWheelToDispose),s)){const o=r=>{this._onMouseWheel(new M.StandardWheelEvent(r))};this._mouseWheelToDispose.push(i.addDisposableListener(this._listenOnDomNode,i.EventType.MOUSE_WHEEL,o,{passive:!1}))}}_onMouseWheel(s){const l=E.INSTANCE;if(p){const c=window.devicePixelRatio/(0,v.getZoomFactor)();a.isWindows||a.isLinux?l.accept(Date.now(),s.deltaX/c,s.deltaY/c):l.accept(Date.now(),s.deltaX,s.deltaY)}let o=!1;if(s.deltaY||s.deltaX){let c=s.deltaY*this._options.mouseWheelScrollSensitivity,C=s.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(Math.abs(c)>=Math.abs(C)?C=0:c=0),this._options.flipAxes&&([c,C]=[C,c]);const V=!a.isMacintosh&&s.browserEvent&&s.browserEvent.shiftKey;(this._options.scrollYToX||V)&&!C&&(C=c,c=0),s.browserEvent&&s.browserEvent.altKey&&(C=C*this._options.fastScrollSensitivity,c=c*this._options.fastScrollSensitivity);const se=this._scrollable.getFutureScrollPosition();let ie={};if(c){const ae=d*c,ne=se.scrollTop-(ae<0?Math.floor(ae):Math.ceil(ae));this._verticalScrollbar.writeScrollPosition(ie,ne)}if(C){const ae=d*C,ne=se.scrollLeft-(ae<0?Math.floor(ae):Math.ceil(ae));this._horizontalScrollbar.writeScrollPosition(ie,ne)}ie=this._scrollable.validateScrollPosition(ie),(se.scrollLeft!==ie.scrollLeft||se.scrollTop!==ie.scrollTop)&&(p&&this._options.mouseWheelSmoothScroll&&l.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(ie):this._scrollable.setScrollPositionNow(ie),o=!0)}let r=o;!r&&this._options.alwaysConsumeMouseWheel&&(r=!0),!r&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(r=!0),r&&(s.preventDefault(),s.stopPropagation())}_onDidScroll(s){this._shouldRender=this._horizontalScrollbar.onDidScroll(s)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(s)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(!!this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const s=this._scrollable.getCurrentScrollPosition(),l=s.scrollTop>0,o=s.scrollLeft>0,r=o?" left":"",c=l?" top":"",C=o||l?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${r}`),this._topShadowDomNode.setClassName(`shadow${c}`),this._topLeftShadowDomNode.setClassName(`shadow${C}${c}${r}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(s){this._mouseIsOver=!1,this._hide()}_onMouseOver(s){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),e)}}t.AbstractScrollableElement=u;class g extends u{constructor(s,l){l=l||{},l.mouseWheelSmoothScroll=!1;const o=new n.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:r=>i.scheduleAtNextAnimationFrame(r)});super(s,l,o);this._register(o)}setScrollPosition(s){this._scrollable.setScrollPositionNow(s)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.ScrollableElement=g;class D extends u{constructor(s,l,o){super(s,l,o)}setScrollPosition(s){s.reuseAnimation?this._scrollable.setScrollPositionSmooth(s,s.reuseAnimation):this._scrollable.setScrollPositionNow(s)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.SmoothScrollableElement=D;class A extends u{constructor(s,l){l=l||{},l.mouseWheelSmoothScroll=!1;const o=new n.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:r=>i.scheduleAtNextAnimationFrame(r)});super(s,l,o);this._register(o),this._element=s,this.onScroll(r=>{r.scrollTopChanged&&(this._element.scrollTop=r.scrollTop),r.scrollLeftChanged&&(this._element.scrollLeft=r.scrollLeft)}),this.scanDomNode()}setScrollPosition(s){this._scrollable.setScrollPositionNow(s)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}t.DomScrollableElement=A;function N(T){const s={lazyRender:typeof T.lazyRender!="undefined"?T.lazyRender:!1,className:typeof T.className!="undefined"?T.className:"",useShadows:typeof T.useShadows!="undefined"?T.useShadows:!0,handleMouseWheel:typeof T.handleMouseWheel!="undefined"?T.handleMouseWheel:!0,flipAxes:typeof T.flipAxes!="undefined"?T.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof T.consumeMouseWheelIfScrollbarIsNeeded!="undefined"?T.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof T.alwaysConsumeMouseWheel!="undefined"?T.alwaysConsumeMouseWheel:!1,scrollYToX:typeof T.scrollYToX!="undefined"?T.scrollYToX:!1,mouseWheelScrollSensitivity:typeof T.mouseWheelScrollSensitivity!="undefined"?T.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof T.fastScrollSensitivity!="undefined"?T.fastScrollSensitivity:5,scrollPredominantAxis:typeof T.scrollPredominantAxis!="undefined"?T.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof T.mouseWheelSmoothScroll!="undefined"?T.mouseWheelSmoothScroll:!0,arrowSize:typeof T.arrowSize!="undefined"?T.arrowSize:11,listenOnDomNode:typeof T.listenOnDomNode!="undefined"?T.listenOnDomNode:null,horizontal:typeof T.horizontal!="undefined"?T.horizontal:1,horizontalScrollbarSize:typeof T.horizontalScrollbarSize!="undefined"?T.horizontalScrollbarSize:10,horizontalSliderSize:typeof T.horizontalSliderSize!="undefined"?T.horizontalSliderSize:0,horizontalHasArrows:typeof T.horizontalHasArrows!="undefined"?T.horizontalHasArrows:!1,vertical:typeof T.vertical!="undefined"?T.vertical:1,verticalScrollbarSize:typeof T.verticalScrollbarSize!="undefined"?T.verticalScrollbarSize:10,verticalHasArrows:typeof T.verticalHasArrows!="undefined"?T.verticalHasArrows:!1,verticalSliderSize:typeof T.verticalSliderSize!="undefined"?T.verticalSliderSize:0,scrollByPage:typeof T.scrollByPage!="undefined"?T.scrollByPage:!1};return s.horizontalSliderSize=typeof T.horizontalSliderSize!="undefined"?T.horizontalSliderSize:s.horizontalScrollbarSize,s.verticalSliderSize=typeof T.verticalSliderSize!="undefined"?T.verticalSliderSize:s.verticalScrollbarSize,a.isMacintosh&&(s.className+=" mac"),s}}),define(me[57],pe([1,0,15,50,4,18,23,56,14,6,26,3,2,45,47,78,114]),function(Z,t,v,i,R,M,y,w,m,f,b,F,a,n,e,d,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const _={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(T){return[T]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class E{constructor(s){this.elements=s}get context(){return this._context}set context(s){this._context=s}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=E;class u{constructor(s){this.elements=s}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=u;class g{constructor(){this.types=[],this.files=[]}update(s){if(s.types&&this.types.splice(0,this.types.length,...s.types),s.files){this.files.splice(0,this.files.length);for(let l=0;l<s.files.length;l++){const o=s.files.item(l);o&&(o.size||o.type)&&this.files.push(o)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=g;function D(T,s){return Array.isArray(T)&&Array.isArray(s)?(0,m.equals)(T,s):T===s}class A{constructor(s){s?.getSetSize?this.getSetSize=s.getSetSize.bind(s):this.getSetSize=(l,o,r)=>r,s?.getPosInSet?this.getPosInSet=s.getPosInSet.bind(s):this.getPosInSet=(l,o)=>o+1,s?.getRole?this.getRole=s.getRole.bind(s):this.getRole=l=>"listitem",s?.isChecked?this.isChecked=s.isChecked.bind(s):this.isChecked=l=>{}}}class N{constructor(s,l,o,r=_){if(this.virtualDelegate=l,this.domId=`list_id_${++N.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new f.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=a.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=a.Disposable.None,this.onDragLeaveTimeout=a.Disposable.None,this.disposables=new a.DisposableStore,this._onDidChangeContentHeight=new F.Emitter,this.onDidChangeContentHeight=F.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this._horizontalScrolling=!1,r.horizontalScrolling&&r.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=new d.RangeMap;for(const C of o)this.renderers.set(C.templateId,C);this.cache=this.disposables.add(new p.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof r.mouseSupport=="boolean"?r.mouseSupport:!0),this._horizontalScrolling=r.horizontalScrolling??_.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.additionalScrollHeight=typeof r.additionalScrollHeight=="undefined"?0:r.additionalScrollHeight,this.accessibilityProvider=new A(r.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(r.transformOptimization??_.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)"),this.disposables.add(y.Gesture.addTarget(this.rowsContainer)),this.scrollable=new e.Scrollable({forceIntegerValues:!0,smoothScrollDuration:r.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:C=>(0,R.scheduleAtNextAnimationFrame)(C)}),this.scrollableElement=this.disposables.add(new w.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:r.alwaysConsumeMouseWheel??_.alwaysConsumeMouseWheel,horizontal:1,vertical:r.verticalScrollMode??_.verticalScrollMode,useShadows:r.useShadows??_.useShadows,mouseWheelScrollSensitivity:r.mouseWheelScrollSensitivity,fastScrollSensitivity:r.fastScrollSensitivity},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),s.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,R.addDisposableListener)(this.rowsContainer,y.EventType.Change,C=>this.onTouchChange(C))),this.disposables.add((0,R.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",C=>C.target.scrollTop=0)),this.disposables.add((0,R.addDisposableListener)(this.domNode,"dragover",C=>this.onDragOver(this.toDragEvent(C)))),this.disposables.add((0,R.addDisposableListener)(this.domNode,"drop",C=>this.onDrop(this.toDragEvent(C)))),this.disposables.add((0,R.addDisposableListener)(this.domNode,"dragleave",C=>this.onDragLeave(this.toDragEvent(C)))),this.disposables.add((0,R.addDisposableListener)(this.domNode,"dragend",C=>this.onDragEnd(C))),this.setRowLineHeight=r.setRowLineHeight??_.setRowLineHeight,this.setRowHeight=r.setRowHeight??_.setRowHeight,this.supportDynamicHeights=r.supportDynamicHeights??_.supportDynamicHeights,this.dnd=r.dnd??_.dnd,this.layout()}get contentHeight(){return this.rangeMap.size}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(s){if(s!==this._horizontalScrolling){if(s&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=s,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const l of this.items)this.measureItemWidth(l);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,R.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}updateOptions(s){s.additionalScrollHeight!==void 0&&(this.additionalScrollHeight=s.additionalScrollHeight,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),s.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(s.smoothScrolling?125:0),s.horizontalScrolling!==void 0&&(this.horizontalScrolling=s.horizontalScrolling),s.mouseWheelScrollSensitivity!==void 0&&this.scrollableElement.updateOptions({mouseWheelScrollSensitivity:s.mouseWheelScrollSensitivity}),s.fastScrollSensitivity!==void 0&&this.scrollableElement.updateOptions({fastScrollSensitivity:s.fastScrollSensitivity})}triggerScrollFromMouseWheelEvent(s){this.scrollableElement.triggerScrollFromMouseWheelEvent(s)}updateElementHeight(s,l,o){if(s<0||s>=this.items.length)return;const r=this.items[s].size;if(typeof l=="undefined"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported");return}this.items[s].lastDynamicHeightWidth=void 0,l=r+this.probeDynamicHeight(s)}if(r===l)return;const c=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let C=0;s<c.start||o!==null&&o>s&&o<=c.end?C=l-r:C=0,this.rangeMap.splice(s,1,[{size:l}]),this.items[s].size=l,this.render(c,Math.max(0,this.lastRenderTop+C),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}splice(s,l,o=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(s,l,o)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(s,l,o=[]){const r=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),c={start:s,end:s+l},C=n.Range.intersect(r,c),V=new Map;for(let S=C.end-1;S>=C.start;S--){const K=this.items[S];if(K.dragStartDisposable.dispose(),K.checkedDisposable.dispose(),K.row){let G=V.get(K.templateId);G||(G=[],V.set(K.templateId,G));const k=this.renderers.get(K.templateId);k&&k.disposeElement&&k.disposeElement(K.element,S,K.row.templateData,K.size),G.push(K.row)}K.row=null}const se={start:s+l,end:this.items.length},ie=n.Range.intersect(se,r),ae=n.Range.relativeComplement(se,r),ne=o.map(S=>({id:String(this.itemId++),element:S,templateId:this.virtualDelegate.getTemplateId(S),size:this.virtualDelegate.getHeight(S),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight(S),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:a.Disposable.None,checkedDisposable:a.Disposable.None}));let we;s===0&&l>=this.items.length?(this.rangeMap=new d.RangeMap,this.rangeMap.splice(0,0,ne),we=this.items,this.items=ne):(this.rangeMap.splice(s,l,ne),we=this.items.splice(s,l,...ne));const de=o.length-l,ge=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),ye=(0,d.shift)(ie,de),J=n.Range.intersect(ge,ye);for(let S=J.start;S<J.end;S++)this.updateItemInDOM(this.items[S],S);const De=n.Range.relativeComplement(ye,ge);for(const S of De)for(let K=S.start;K<S.end;K++)this.removeItemFromDOM(K);const re=ae.map(S=>(0,d.shift)(S,de)),le=[{start:s,end:s+o.length},...re].map(S=>n.Range.intersect(ge,S)),Q=this.getNextToLastElement(le);for(const S of le)for(let K=S.start;K<S.end;K++){const G=this.items[K],h=V.get(G.templateId)?.pop();this.insertItemInDOM(K,Q,h)}for(const S of V.values())for(const K of S)this.cache.release(K);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),we.map(S=>S.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,R.scheduleAtNextAnimationFrame)(()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let s=0;for(const l of this.items)typeof l.width!="undefined"&&(s=Math.max(s,l.width));this.scrollWidth=s,this.scrollableElement.setScrollDimensions({scrollWidth:s===0?0:s+10})}updateWidth(s){if(!this.horizontalScrolling||typeof this.scrollWidth=="undefined")return;const l=this.items[s];this.measureItemWidth(l),typeof l.width!="undefined"&&l.width>this.scrollWidth&&(this.scrollWidth=l.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}))}rerender(){if(!!this.supportDynamicHeights){for(const s of this.items)s.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){const s=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),l=this.rangeMap.positionAt(s.start),o=this.rangeMap.positionAt(s.start+1);return o!==-1&&(o-l)/2+l<this.scrollTop?s.start+1:s.start}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(s){return this.items[s].element}indexOf(s){return this.items.findIndex(l=>l.element===s)}domElement(s){const l=this.items[s].row;return l&&l.domNode}elementHeight(s){return this.items[s].size}elementTop(s){return this.rangeMap.positionAt(s)}indexAt(s){return this.rangeMap.indexAt(s)}indexAfter(s){return this.rangeMap.indexAfter(s)}layout(s,l){const o={height:typeof s=="number"?s:(0,R.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,o.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(o),typeof l!="undefined"&&(this.renderWidth=l,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof l=="number"?l:(0,R.getContentWidth)(this.domNode)})}render(s,l,o,r,c,C=!1){const V=this.getRenderRange(l,o),se=n.Range.relativeComplement(V,s),ie=n.Range.relativeComplement(s,V),ae=this.getNextToLastElement(se);if(C){const ne=n.Range.intersect(s,V);for(let we=ne.start;we<ne.end;we++)this.updateItemInDOM(this.items[we],we)}for(const ne of se)for(let we=ne.start;we<ne.end;we++)this.insertItemInDOM(we,ae);for(const ne of ie)for(let we=ne.start;we<ne.end;we++)this.removeItemFromDOM(we);r!==void 0&&(this.rowsContainer.style.left=`-${r}px`),this.rowsContainer.style.top=`-${l}px`,this.horizontalScrolling&&c!==void 0&&(this.rowsContainer.style.width=`${Math.max(c,this.renderWidth)}px`),this.lastRenderTop=l,this.lastRenderHeight=o}insertItemInDOM(s,l,o){const r=this.items[s];r.row||(r.row=o??this.cache.alloc(r.templateId));const c=this.accessibilityProvider.getRole(r.element)||"listitem";r.row.domNode.setAttribute("role",c);const C=this.accessibilityProvider.isChecked(r.element);if(typeof C=="boolean")r.row.domNode.setAttribute("aria-checked",String(!!C));else if(C){const ie=ae=>r.row.domNode.setAttribute("aria-checked",String(!!ae));ie(C.value),r.checkedDisposable=C.onDidChange(ie)}r.row.domNode.parentElement||(l?this.rowsContainer.insertBefore(r.row.domNode,l):this.rowsContainer.appendChild(r.row.domNode)),this.updateItemInDOM(r,s);const V=this.renderers.get(r.templateId);if(!V)throw new Error(`No renderer found for template id ${r.templateId}`);V?.renderElement(r.element,s,r.row.templateData,r.size);const se=this.dnd.getDragURI(r.element);r.dragStartDisposable.dispose(),r.row.domNode.draggable=!!se,se&&(r.dragStartDisposable=(0,R.addDisposableListener)(r.row.domNode,"dragstart",ie=>this.onDragStart(r.element,se,ie))),this.horizontalScrolling&&(this.measureItemWidth(r),this.eventuallyUpdateScrollWidth())}measureItemWidth(s){if(!s.row||!s.row.domNode)return;s.row.domNode.style.width=v.isFirefox?"-moz-fit-content":"fit-content",s.width=(0,R.getContentWidth)(s.row.domNode);const l=window.getComputedStyle(s.row.domNode);l.paddingLeft&&(s.width+=parseFloat(l.paddingLeft)),l.paddingRight&&(s.width+=parseFloat(l.paddingRight)),s.row.domNode.style.width=""}updateItemInDOM(s,l){s.row.domNode.style.top=`${this.elementTop(l)}px`,this.setRowHeight&&(s.row.domNode.style.height=`${s.size}px`),this.setRowLineHeight&&(s.row.domNode.style.lineHeight=`${s.size}px`),s.row.domNode.setAttribute("data-index",`${l}`),s.row.domNode.setAttribute("data-last-element",l===this.length-1?"true":"false"),s.row.domNode.setAttribute("data-parity",l%2==0?"even":"odd"),s.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(s.element,l,this.length))),s.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(s.element,l))),s.row.domNode.setAttribute("id",this.getElementDomId(l)),s.row.domNode.classList.toggle("drop-target",s.dropTarget)}removeItemFromDOM(s){const l=this.items[s];if(l.dragStartDisposable.dispose(),l.checkedDisposable.dispose(),l.row){const o=this.renderers.get(l.templateId);o&&o.disposeElement&&o.disposeElement(l.element,s,l.row.templateData,l.size),this.cache.release(l.row),l.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(s,l){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:s,reuseAnimation:l})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(s){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:s})}get scrollTop(){return this.getScrollTop()}set scrollTop(s){this.setScrollTop(s)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.additionalScrollHeight}get onMouseClick(){return F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"click")).event,s=>this.toMouseEvent(s),this.disposables)}get onMouseDblClick(){return F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"dblclick")).event,s=>this.toMouseEvent(s),this.disposables)}get onMouseMiddleClick(){return F.Event.filter(F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"auxclick")).event,s=>this.toMouseEvent(s),this.disposables),s=>s.browserEvent.button===1,this.disposables)}get onMouseUp(){return F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mouseup")).event,s=>this.toMouseEvent(s),this.disposables)}get onMouseDown(){return F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mousedown")).event,s=>this.toMouseEvent(s),this.disposables)}get onMouseOver(){return F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mouseover")).event,s=>this.toMouseEvent(s),this.disposables)}get onMouseMove(){return F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mousemove")).event,s=>this.toMouseEvent(s),this.disposables)}get onMouseOut(){return F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mouseout")).event,s=>this.toMouseEvent(s),this.disposables)}get onContextMenu(){return F.Event.any(F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"contextmenu")).event,s=>this.toMouseEvent(s),this.disposables),F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,y.EventType.Contextmenu)).event,s=>this.toGestureEvent(s),this.disposables))}get onTouchStart(){return F.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"touchstart")).event,s=>this.toTouchEvent(s),this.disposables)}get onTap(){return F.Event.map(this.disposables.add(new M.DomEmitter(this.rowsContainer,y.EventType.Tap)).event,s=>this.toGestureEvent(s),this.disposables)}toMouseEvent(s){const l=this.getItemIndexFromEventTarget(s.target||null),o=typeof l=="undefined"?void 0:this.items[l],r=o&&o.element;return{browserEvent:s,index:l,element:r}}toTouchEvent(s){const l=this.getItemIndexFromEventTarget(s.target||null),o=typeof l=="undefined"?void 0:this.items[l],r=o&&o.element;return{browserEvent:s,index:l,element:r}}toGestureEvent(s){const l=this.getItemIndexFromEventTarget(s.initialTarget||null),o=typeof l=="undefined"?void 0:this.items[l],r=o&&o.element;return{browserEvent:s,index:l,element:r}}toDragEvent(s){const l=this.getItemIndexFromEventTarget(s.target||null),o=typeof l=="undefined"?void 0:this.items[l],r=o&&o.element;return{browserEvent:s,index:l,element:r}}onScroll(s){try{const l=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(l,s.scrollTop,s.height,s.scrollLeft,s.scrollWidth),this.supportDynamicHeights&&this._rerender(s.scrollTop,s.height,s.inSmoothScrolling)}catch(l){throw console.error("Got bad scroll event:",s),l}}onTouchChange(s){s.preventDefault(),s.stopPropagation(),this.scrollTop-=s.translationY}onDragStart(s,l,o){if(!o.dataTransfer)return;const r=this.dnd.getDragElements(s);if(o.dataTransfer.effectAllowed="copyMove",o.dataTransfer.setData(i.DataTransfers.TEXT,l),o.dataTransfer.setDragImage){let c;this.dnd.getDragLabel&&(c=this.dnd.getDragLabel(r,o)),typeof c=="undefined"&&(c=String(r.length));const C=(0,R.$)(".monaco-drag-image");C.textContent=c,document.body.appendChild(C),o.dataTransfer.setDragImage(C,-10,-10),setTimeout(()=>document.body.removeChild(C),0)}this.currentDragData=new E(r),i.StaticDND.CurrentDragAndDropData=new u(r),this.dnd.onDragStart?.(this.currentDragData,o)}onDragOver(s){if(s.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),i.StaticDND.CurrentDragAndDropData&&i.StaticDND.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(s.browserEvent),!s.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(i.StaticDND.CurrentDragAndDropData)this.currentDragData=i.StaticDND.CurrentDragAndDropData;else{if(!s.browserEvent.dataTransfer.types)return!1;this.currentDragData=new g}const l=this.dnd.onDragOver(this.currentDragData,s.element,s.index,s.browserEvent);if(this.canDrop=typeof l=="boolean"?l:l.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;s.browserEvent.dataTransfer.dropEffect=typeof l!="boolean"&&l.effect===0?"copy":"move";let o;if(typeof l!="boolean"&&l.feedback?o=l.feedback:typeof s.index=="undefined"?o=[-1]:o=[s.index],o=(0,m.distinct)(o).filter(r=>r>=-1&&r<this.length).sort((r,c)=>r-c),o=o[0]===-1?[-1]:o,D(this.currentDragFeedback,o))return!0;if(this.currentDragFeedback=o,this.currentDragFeedbackDisposable.dispose(),o[0]===-1)this.domNode.classList.add("drop-target"),this.rowsContainer.classList.add("drop-target"),this.currentDragFeedbackDisposable=(0,a.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.rowsContainer.classList.remove("drop-target")});else{for(const r of o){const c=this.items[r];c.dropTarget=!0,c.row?.domNode.classList.add("drop-target")}this.currentDragFeedbackDisposable=(0,a.toDisposable)(()=>{for(const r of o){const c=this.items[r];c.dropTarget=!1,c.row?.domNode.classList.remove("drop-target")}})}return!0}onDragLeave(s){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,f.disposableTimeout)(()=>this.clearDragOverFeedback(),100),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,s.element,s.index,s.browserEvent)}onDrop(s){if(!this.canDrop)return;const l=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.currentDragData=void 0,i.StaticDND.CurrentDragAndDropData=void 0,!(!l||!s.browserEvent.dataTransfer)&&(s.browserEvent.preventDefault(),l.update(s.browserEvent.dataTransfer),this.dnd.drop(l,s.element,s.index,s.browserEvent))}onDragEnd(s){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.currentDragData=void 0,i.StaticDND.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(s)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=a.Disposable.None}setupDragAndDropScrollTopAnimation(s){if(!this.dragOverAnimationDisposable){const l=(0,R.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,R.animate)(this.animateDragAndDropScrollTop.bind(this,l))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,f.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3),this.dragOverMouseY=s.pageY}animateDragAndDropScrollTop(s){if(this.dragOverMouseY===void 0)return;const l=this.dragOverMouseY-s,o=this.renderHeight-35;l<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(l-35))):l>o&&(this.scrollTop+=Math.min(14,Math.floor(.3*(l-o))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getItemIndexFromEventTarget(s){const l=this.scrollableElement.getDomNode();let o=s;for(;o instanceof HTMLElement&&o!==this.rowsContainer&&l.contains(o);){const r=o.getAttribute("data-index");if(r){const c=Number(r);if(!isNaN(c))return c}o=o.parentElement}}getRenderRange(s,l){return{start:this.rangeMap.indexAt(s),end:this.rangeMap.indexAfter(s+l-1)}}_rerender(s,l,o){const r=this.getRenderRange(s,l);let c,C;s===this.elementTop(r.start)?(c=r.start,C=0):r.end-r.start>1&&(c=r.start+1,C=this.elementTop(c)-s);let V=0;for(;;){const se=this.getRenderRange(s,l);let ie=!1;for(let ae=se.start;ae<se.end;ae++){const ne=this.probeDynamicHeight(ae);ne!==0&&this.rangeMap.splice(ae,1,[this.items[ae]]),V+=ne,ie=ie||ne!==0}if(!ie){V!==0&&this.eventuallyUpdateScrollDimensions();const ae=n.Range.relativeComplement(r,se);for(const we of ae)for(let de=we.start;de<we.end;de++)this.items[de].row&&this.removeItemFromDOM(de);const ne=n.Range.relativeComplement(se,r);for(const we of ne)for(let de=we.start;de<we.end;de++){const ge=de+1,ye=ge<this.items.length?this.items[ge].row:null,J=ye?ye.domNode:null;this.insertItemInDOM(de,J)}for(let we=se.start;we<se.end;we++)this.items[we].row&&this.updateItemInDOM(this.items[we],we);if(typeof c=="number"){const we=this.scrollable.getFutureScrollPosition().scrollTop-s,de=this.elementTop(c)-C+we;this.setScrollTop(de,o)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(s){const l=this.items[s];if(this.virtualDelegate.getDynamicHeight){const C=this.virtualDelegate.getDynamicHeight(l.element);if(C!==null){const V=l.size;return l.size=C,l.lastDynamicHeightWidth=this.renderWidth,C-V}}if(!l.hasDynamicHeight||l.lastDynamicHeightWidth===this.renderWidth||!!this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(l.element))return 0;const o=l.size;if(!this.setRowHeight&&l.row){const C=l.row.domNode.offsetHeight;return l.size=C,l.lastDynamicHeightWidth=this.renderWidth,C-o}const r=this.cache.alloc(l.templateId);r.domNode.style.height="",this.rowsContainer.appendChild(r.domNode);const c=this.renderers.get(l.templateId);return c&&(c.renderElement(l.element,s,r.templateData,void 0),c.disposeElement?.(l.element,s,r.templateData,void 0)),l.size=r.domNode.offsetHeight,this.virtualDelegate.setDynamicHeight?.(l.element,l.size),l.lastDynamicHeightWidth=this.renderWidth,this.rowsContainer.removeChild(r.domNode),this.cache.release(r),l.size-o}getNextToLastElement(s){const l=s[s.length-1];if(!l)return null;const o=this.items[l.end];return!o||!o.row?null:o.row.domNode}getElementDomId(s){return`${this.domId}_${s}`}dispose(){if(this.items){for(const s of this.items)if(s.row){const l=this.renderers.get(s.row.templateId);l&&(l.disposeElement?.(s.element,-1,s.row.templateData,void 0),l.disposeTemplate(s.row.templateData))}this.items=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,a.dispose)(this.disposables)}}N.InstanceCount=0,Ke([b.memoize],N.prototype,"onMouseClick",null),Ke([b.memoize],N.prototype,"onMouseDblClick",null),Ke([b.memoize],N.prototype,"onMouseMiddleClick",null),Ke([b.memoize],N.prototype,"onMouseUp",null),Ke([b.memoize],N.prototype,"onMouseDown",null),Ke([b.memoize],N.prototype,"onMouseOver",null),Ke([b.memoize],N.prototype,"onMouseMove",null),Ke([b.memoize],N.prototype,"onMouseOut",null),Ke([b.memoize],N.prototype,"onContextMenu",null),Ke([b.memoize],N.prototype,"onTouchStart",null),Ke([b.memoize],N.prototype,"onTap",null),t.ListView=N}),define(me[58],pe([1,0,4,18,19,23,53,67,14,6,25,26,3,33,2,44,28,5,7,66,57,88]),function(Z,t,v,i,R,M,y,w,m,f,b,F,a,n,e,d,p,_,E,u,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class D{constructor(h){this.trait=h,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(h){return h}renderElement(h,L,U){const q=this.renderedElements.findIndex(W=>W.templateData===U);if(q>=0){const W=this.renderedElements[q];this.trait.unrender(U),W.index=L}else{const W={index:L,templateData:U};this.renderedElements.push(W)}this.trait.renderIndex(L,U)}splice(h,L,U){const q=[];for(const W of this.renderedElements)W.index<h?q.push(W):W.index>=h+L&&q.push({index:W.index+U-L,templateData:W.templateData});this.renderedElements=q}renderIndexes(h){for(const{index:L,templateData:U}of this.renderedElements)h.indexOf(L)>-1&&this.trait.renderIndex(L,U)}disposeTemplate(h){const L=this.renderedElements.findIndex(U=>U.templateData===h);L<0||this.renderedElements.splice(L,1)}}class A{constructor(h){this._trait=h,this.length=0,this.indexes=[],this.sortedIndexes=[],this._onChange=new a.Emitter,this.onChange=this._onChange.event}get name(){return this._trait}get renderer(){return new D(this)}splice(h,L,U){L=Math.max(0,Math.min(L,this.length-h));const q=U.length-L,W=h+L,O=[...this.sortedIndexes.filter($=>$<h),...U.map(($,I)=>$?I+h:-1).filter($=>$!==-1),...this.sortedIndexes.filter($=>$>=W).map($=>$+q)],H=this.length+q;if(this.sortedIndexes.length>0&&O.length===0&&H>0){const $=this.sortedIndexes.find(I=>I>=h)??H-1;O.push(Math.min($,H-1))}this.renderer.splice(h,L,U.length),this._set(O,O),this.length=H}renderIndex(h,L){L.classList.toggle(this._trait,this.contains(h))}unrender(h){h.classList.remove(this._trait)}set(h,L){return this._set(h,[...h].sort(le),L)}_set(h,L,U){const q=this.indexes,W=this.sortedIndexes;this.indexes=h,this.sortedIndexes=L;const O=re(W,h);return this.renderer.renderIndexes(O),this._onChange.fire({indexes:h,browserEvent:U}),q}get(){return this.indexes}contains(h){return(0,m.binarySearch)(this.sortedIndexes,h,le)>=0}dispose(){(0,e.dispose)(this._onChange)}}Ke([F.memoize],A.prototype,"renderer",null);class N extends A{constructor(h){super("selected");this.setAriaSelected=h}renderIndex(h,L){super.renderIndex(h,L),this.setAriaSelected&&(this.contains(h)?L.setAttribute("aria-selected","true"):L.setAttribute("aria-selected","false"))}}class T{constructor(h,L,U){this.trait=h,this.view=L,this.identityProvider=U}splice(h,L,U){if(!this.identityProvider)return this.trait.splice(h,L,U.map(()=>!1));const q=this.trait.get().map(O=>this.identityProvider.getId(this.view.element(O)).toString()),W=U.map(O=>q.indexOf(this.identityProvider.getId(O).toString())>-1);this.trait.splice(h,L,W)}}function s(k){return k.tagName==="INPUT"||k.tagName==="TEXTAREA"}t.isInputElement=s;function l(k){return k.classList.contains("monaco-editor")?!0:k.classList.contains("monaco-list")||!k.parentElement?!1:l(k.parentElement)}t.isMonacoEditor=l;function o(k){return k.tagName==="A"&&k.classList.contains("monaco-button")||k.tagName==="DIV"&&k.classList.contains("monaco-button-dropdown")?!0:k.classList.contains("monaco-list")||!k.parentElement?!1:o(k.parentElement)}t.isButton=o;class r{constructor(h,L,U){this.list=h,this.view=L,this.disposables=new e.DisposableStore,this.multipleSelectionDisposables=new e.DisposableStore,this.onKeyDown.filter(q=>q.keyCode===3).on(this.onEnter,this,this.disposables),this.onKeyDown.filter(q=>q.keyCode===16).on(this.onUpArrow,this,this.disposables),this.onKeyDown.filter(q=>q.keyCode===18).on(this.onDownArrow,this,this.disposables),this.onKeyDown.filter(q=>q.keyCode===11).on(this.onPageUpArrow,this,this.disposables),this.onKeyDown.filter(q=>q.keyCode===12).on(this.onPageDownArrow,this,this.disposables),this.onKeyDown.filter(q=>q.keyCode===9).on(this.onEscape,this,this.disposables),U.multipleSelectionSupport!==!1&&this.onKeyDown.filter(q=>(_.isMacintosh?q.metaKey:q.ctrlKey)&&q.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables)}get onKeyDown(){return this.disposables.add(a.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event).filter(h=>!s(h.target)).map(h=>new R.StandardKeyboardEvent(h)))}updateOptions(h){h.multipleSelectionSupport!==void 0&&(this.multipleSelectionDisposables.clear(),h.multipleSelectionSupport&&this.onKeyDown.filter(L=>(_.isMacintosh?L.metaKey:L.ctrlKey)&&L.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables))}onEnter(h){h.preventDefault(),h.stopPropagation(),this.list.setSelection(this.list.getFocus(),h.browserEvent)}onUpArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusPrevious(1,!1,h.browserEvent);const L=this.list.getFocus()[0];this.list.setAnchor(L),this.list.reveal(L),this.view.domNode.focus()}onDownArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusNext(1,!1,h.browserEvent);const L=this.list.getFocus()[0];this.list.setAnchor(L),this.list.reveal(L),this.view.domNode.focus()}onPageUpArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusPreviousPage(h.browserEvent);const L=this.list.getFocus()[0];this.list.setAnchor(L),this.list.reveal(L),this.view.domNode.focus()}onPageDownArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusNextPage(h.browserEvent);const L=this.list.getFocus()[0];this.list.setAnchor(L),this.list.reveal(L),this.view.domNode.focus()}onCtrlA(h){h.preventDefault(),h.stopPropagation(),this.list.setSelection((0,m.range)(this.list.length),h.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(h){this.list.getSelection().length&&(h.preventDefault(),h.stopPropagation(),this.list.setSelection([],h.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}Ke([F.memoize],r.prototype,"onKeyDown",null);var c;(function(k){k[k.Automatic=0]="Automatic",k[k.Trigger=1]="Trigger"})(c=t.TypeNavigationMode||(t.TypeNavigationMode={}));var C;(function(k){k[k.Idle=0]="Idle",k[k.Typing=1]="Typing"})(C||(C={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(k){return k.ctrlKey||k.metaKey||k.altKey?!1:k.keyCode>=31&&k.keyCode<=56||k.keyCode>=21&&k.keyCode<=30||k.keyCode>=93&&k.keyCode<=102||k.keyCode>=80&&k.keyCode<=90}};class V{constructor(h,L,U,q){this.list=h,this.view=L,this.keyboardNavigationLabelProvider=U,this.delegate=q,this.enabled=!1,this.state=C.Idle,this.mode=c.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new e.DisposableStore,this.disposables=new e.DisposableStore,this.updateOptions(h.options)}updateOptions(h){h.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=h.typeNavigationMode??c.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;const h=this.enabledDisposables.add(a.Event.chain(this.enabledDisposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event)).filter(q=>!s(q.target)).filter(()=>this.mode===c.Automatic||this.triggered).map(q=>new R.StandardKeyboardEvent(q)).filter(q=>this.delegate.mightProducePrintableCharacter(q)).forEach(q=>{q.preventDefault(),q.stopPropagation()}).map(q=>q.browserEvent.key).event,L=a.Event.debounce(h,()=>null,800,void 0,void 0,this.enabledDisposables);a.Event.reduce(a.Event.any(h,L),(q,W)=>W===null?null:(q||"")+W,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),L(this.onClear,this,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){!this.enabled||(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const h=this.list.getFocus();if(h.length>0&&h[0]===this.previouslyFocused){const L=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(h[0]));L&&(0,y.alert)(L)}this.previouslyFocused=-1}onInput(h){if(!h){this.state=C.Idle,this.triggered=!1;return}const L=this.list.getFocus(),U=L.length>0?L[0]:0,q=this.state===C.Idle?1:0;this.state=C.Typing;for(let W=0;W<this.list.length;W++){const O=(U+W+q)%this.list.length,H=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element(O)),$=H&&H.toString();if(typeof $=="undefined"||(0,n.matchesPrefix)(h,$)){this.previouslyFocused=U,this.list.setFocus([O]),this.list.reveal(O);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class se{constructor(h,L){this.list=h,this.view=L,this.disposables=new e.DisposableStore,this.disposables.add(a.Event.chain(this.disposables.add(new i.DomEmitter(L.domNode,"keydown")).event)).filter(q=>!s(q.target)).map(q=>new R.StandardKeyboardEvent(q)).filter(q=>q.keyCode===2&&!q.ctrlKey&&!q.metaKey&&!q.shiftKey&&!q.altKey).on(this.onTab,this,this.disposables)}onTab(h){if(h.target!==this.view.domNode)return;const L=this.list.getFocus();if(L.length===0)return;const U=this.view.domElement(L[0]);if(!U)return;const q=U.querySelector("[tabIndex]");if(!q||!(q instanceof HTMLElement)||q.tabIndex===-1)return;const W=window.getComputedStyle(q);W.visibility==="hidden"||W.display==="none"||(h.preventDefault(),h.stopPropagation(),q.focus())}dispose(){this.disposables.dispose()}}function ie(k){return _.isMacintosh?k.browserEvent.metaKey:k.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=ie;function ae(k){return k.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=ae;function ne(k){return k instanceof MouseEvent&&k.button===2}const we={isSelectionSingleChangeEvent:ie,isSelectionRangeChangeEvent:ae};class de{constructor(h){this.list=h,this.disposables=new e.DisposableStore,this._onPointer=new a.Emitter,this.onPointer=this._onPointer.event,h.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||we),this.mouseSupport=typeof h.options.mouseSupport=="undefined"||!!h.options.mouseSupport,this.mouseSupport&&(h.onMouseDown(this.onMouseDown,this,this.disposables),h.onContextMenu(this.onContextMenu,this,this.disposables),h.onMouseDblClick(this.onDoubleClick,this,this.disposables),h.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(M.Gesture.addTarget(h.getHTMLElement()))),a.Event.any(h.onMouseClick,h.onMouseMiddleClick,h.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(h){h.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,h.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||we))}isSelectionSingleChangeEvent(h){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(h):!1}isSelectionRangeChangeEvent(h){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(h):!1}isSelectionChangeEvent(h){return this.isSelectionSingleChangeEvent(h)||this.isSelectionRangeChangeEvent(h)}onMouseDown(h){l(h.browserEvent.target)||document.activeElement!==h.browserEvent.target&&this.list.domFocus()}onContextMenu(h){if(l(h.browserEvent.target))return;const L=typeof h.index=="undefined"?[]:[h.index];this.list.setFocus(L,h.browserEvent)}onViewPointer(h){if(!this.mouseSupport||s(h.browserEvent.target)||l(h.browserEvent.target))return;const L=h.index;if(typeof L=="undefined"){this.list.setFocus([],h.browserEvent),this.list.setSelection([],h.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionRangeChangeEvent(h))return this.changeSelection(h);if(this.isSelectionChangeEvent(h))return this.changeSelection(h);this.list.setFocus([L],h.browserEvent),this.list.setAnchor(L),ne(h.browserEvent)||this.list.setSelection([L],h.browserEvent),this._onPointer.fire(h)}onDoubleClick(h){if(s(h.browserEvent.target)||l(h.browserEvent.target)||this.isSelectionChangeEvent(h))return;const L=this.list.getFocus();this.list.setSelection(L,h.browserEvent)}changeSelection(h){const L=h.index;let U=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(h)){typeof U=="undefined"&&(U=this.list.getFocus()[0]??L,this.list.setAnchor(U));const q=Math.min(U,L),W=Math.max(U,L),O=(0,m.range)(q,W+1),H=this.list.getSelection(),$=De(re(H,[U]),U);if($.length===0)return;const I=re(O,te(H,$));this.list.setSelection(I,h.browserEvent),this.list.setFocus([L],h.browserEvent)}else if(this.isSelectionSingleChangeEvent(h)){const q=this.list.getSelection(),W=q.filter(O=>O!==L);this.list.setFocus([L]),this.list.setAnchor(L),q.length===W.length?this.list.setSelection([...W,L],h.browserEvent):this.list.setSelection(W,h.browserEvent)}}dispose(){this.disposables.dispose()}}t.MouseController=de;class ge{constructor(h,L){this.styleElement=h,this.selectorSuffix=L}style(h){const L=this.selectorSuffix&&`.${this.selectorSuffix}`,U=[];h.listBackground&&(h.listBackground.isOpaque()?U.push(`.monaco-list${L} .monaco-list-rows { background: ${h.listBackground}; }`):_.isMacintosh||console.warn(`List with id '${this.selectorSuffix}' was styled with a non-opaque background color. This will break sub-pixel antialiasing.`)),h.listFocusBackground&&(U.push(`.monaco-list${L}:focus .monaco-list-row.focused { background-color: ${h.listFocusBackground}; }`),U.push(`.monaco-list${L}:focus .monaco-list-row.focused:hover { background-color: ${h.listFocusBackground}; }`)),h.listFocusForeground&&U.push(`.monaco-list${L}:focus .monaco-list-row.focused { color: ${h.listFocusForeground}; }`),h.listActiveSelectionBackground&&(U.push(`.monaco-list${L}:focus .monaco-list-row.selected { background-color: ${h.listActiveSelectionBackground}; }`),U.push(`.monaco-list${L}:focus .monaco-list-row.selected:hover { background-color: ${h.listActiveSelectionBackground}; }`)),h.listActiveSelectionForeground&&U.push(`.monaco-list${L}:focus .monaco-list-row.selected { color: ${h.listActiveSelectionForeground}; }`),h.listActiveSelectionIconForeground&&U.push(`.monaco-list${L}:focus .monaco-list-row.selected .codicon { color: ${h.listActiveSelectionIconForeground}; }`),h.listFocusAndSelectionOutline&&U.push(`.monaco-list${L}:focus .monaco-list-row.selected { outline-color: ${h.listFocusAndSelectionOutline} !important; }`),h.listFocusAndSelectionBackground&&U.push(`
				.monaco-drag-image,
				.monaco-list${L}:focus .monaco-list-row.selected.focused { background-color: ${h.listFocusAndSelectionBackground}; }
			`),h.listFocusAndSelectionForeground&&U.push(`
				.monaco-drag-image,
				.monaco-list${L}:focus .monaco-list-row.selected.focused { color: ${h.listFocusAndSelectionForeground}; }
			`),h.listInactiveFocusForeground&&(U.push(`.monaco-list${L} .monaco-list-row.focused { color:  ${h.listInactiveFocusForeground}; }`),U.push(`.monaco-list${L} .monaco-list-row.focused:hover { color:  ${h.listInactiveFocusForeground}; }`)),h.listInactiveSelectionIconForeground&&U.push(`.monaco-list${L} .monaco-list-row.focused .codicon { color:  ${h.listInactiveSelectionIconForeground}; }`),h.listInactiveFocusBackground&&(U.push(`.monaco-list${L} .monaco-list-row.focused { background-color:  ${h.listInactiveFocusBackground}; }`),U.push(`.monaco-list${L} .monaco-list-row.focused:hover { background-color:  ${h.listInactiveFocusBackground}; }`)),h.listInactiveSelectionBackground&&(U.push(`.monaco-list${L} .monaco-list-row.selected { background-color:  ${h.listInactiveSelectionBackground}; }`),U.push(`.monaco-list${L} .monaco-list-row.selected:hover { background-color:  ${h.listInactiveSelectionBackground}; }`)),h.listInactiveSelectionForeground&&U.push(`.monaco-list${L} .monaco-list-row.selected { color: ${h.listInactiveSelectionForeground}; }`),h.listHoverBackground&&U.push(`.monaco-list${L}:not(.drop-target) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${h.listHoverBackground}; }`),h.listHoverForeground&&U.push(`.monaco-list${L} .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${h.listHoverForeground}; }`),h.listSelectionOutline&&U.push(`.monaco-list${L} .monaco-list-row.selected { outline: 1px dotted ${h.listSelectionOutline}; outline-offset: -1px; }`),h.listFocusOutline&&U.push(`
				.monaco-drag-image,
				.monaco-list${L}:focus .monaco-list-row.focused { outline: 1px solid ${h.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${L}.last-focused .monaco-list-row.focused { outline: 1px solid ${h.listFocusOutline}; outline-offset: -1px; }
			`),h.listInactiveFocusOutline&&U.push(`.monaco-list${L} .monaco-list-row.focused { outline: 1px dotted ${h.listInactiveFocusOutline}; outline-offset: -1px; }`),h.listHoverOutline&&U.push(`.monaco-list${L} .monaco-list-row:hover { outline: 1px dashed ${h.listHoverOutline}; outline-offset: -1px; }`),h.listDropBackground&&U.push(`
				.monaco-list${L}.drop-target,
				.monaco-list${L} .monaco-list-rows.drop-target,
				.monaco-list${L} .monaco-list-row.drop-target { background-color: ${h.listDropBackground} !important; color: inherit !important; }
			`),h.tableColumnsBorder&&U.push(`
				.monaco-table:hover > .monaco-split-view2,
				.monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${h.tableColumnsBorder};
			}`),h.tableOddRowsBackgroundColor&&U.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${h.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=U.join(`
`)}}t.DefaultStyleController=ge;const ye={listFocusBackground:b.Color.fromHex("#7FB0D0"),listActiveSelectionBackground:b.Color.fromHex("#0E639C"),listActiveSelectionForeground:b.Color.fromHex("#FFFFFF"),listActiveSelectionIconForeground:b.Color.fromHex("#FFFFFF"),listFocusAndSelectionOutline:b.Color.fromHex("#90C2F9"),listFocusAndSelectionBackground:b.Color.fromHex("#094771"),listFocusAndSelectionForeground:b.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:b.Color.fromHex("#3F3F46"),listInactiveSelectionIconForeground:b.Color.fromHex("#FFFFFF"),listHoverBackground:b.Color.fromHex("#2A2D2E"),listDropBackground:b.Color.fromHex("#383B3D"),treeIndentGuidesStroke:b.Color.fromHex("#a9a9a9"),tableColumnsBorder:b.Color.fromHex("#cccccc").transparent(.2),tableOddRowsBackgroundColor:b.Color.fromHex("#cccccc").transparent(.04)},J={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function De(k,h){const L=k.indexOf(h);if(L===-1)return[];const U=[];let q=L-1;for(;q>=0&&k[q]===h-(L-q);)U.push(k[q--]);for(U.reverse(),q=L;q<k.length&&k[q]===h+(q-L);)U.push(k[q++]);return U}function re(k,h){const L=[];let U=0,q=0;for(;U<k.length||q<h.length;)if(U>=k.length)L.push(h[q++]);else if(q>=h.length)L.push(k[U++]);else if(k[U]===h[q]){L.push(k[U]),U++,q++;continue}else k[U]<h[q]?L.push(k[U++]):L.push(h[q++]);return L}function te(k,h){const L=[];let U=0,q=0;for(;U<k.length||q<h.length;)if(U>=k.length)L.push(h[q++]);else if(q>=h.length)L.push(k[U++]);else if(k[U]===h[q]){U++,q++;continue}else k[U]<h[q]?L.push(k[U++]):q++;return L}const le=(k,h)=>k-h;class Q{constructor(h,L){this._templateId=h,this.renderers=L}get templateId(){return this._templateId}renderTemplate(h){return this.renderers.map(L=>L.renderTemplate(h))}renderElement(h,L,U,q){let W=0;for(const O of this.renderers)O.renderElement(h,L,U[W++],q)}disposeElement(h,L,U,q){let W=0;for(const O of this.renderers)O.disposeElement?.(h,L,U[W],q),W+=1}disposeTemplate(h){let L=0;for(const U of this.renderers)U.disposeTemplate(h[L++])}}class S{constructor(h){this.accessibilityProvider=h,this.templateId="a18n"}renderTemplate(h){return h}renderElement(h,L,U){const q=this.accessibilityProvider.getAriaLabel(h);q?U.setAttribute("aria-label",q):U.removeAttribute("aria-label");const W=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(h);typeof W=="number"?U.setAttribute("aria-level",`${W}`):U.removeAttribute("aria-level")}disposeTemplate(h){}}class K{constructor(h,L){this.list=h,this.dnd=L}getDragElements(h){const L=this.list.getSelectedElements();return L.indexOf(h)>-1?L:[h]}getDragURI(h){return this.dnd.getDragURI(h)}getDragLabel(h,L){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(h,L)}onDragStart(h,L){this.dnd.onDragStart?.(h,L)}onDragOver(h,L,U,q){return this.dnd.onDragOver(h,L,U,q)}onDragLeave(h,L,U,q){this.dnd.onDragLeave?.(h,L,U,q)}onDragEnd(h){this.dnd.onDragEnd?.(h)}drop(h,L,U,q){this.dnd.drop(h,L,U,q)}}class G{constructor(h,L,U,q,W=J){this.user=h,this._options=W,this.focus=new A("focused"),this.anchor=new A("anchor"),this.eventBufferer=new a.EventBufferer,this._ariaLabel="",this.disposables=new e.DisposableStore,this._onDidDispose=new a.Emitter,this.onDidDispose=this._onDidDispose.event;const O=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new N(O!=="listbox"),(0,p.mixin)(W,ye,!1);const H=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=W.accessibilityProvider,this.accessibilityProvider&&(H.push(new S(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),q=q.map(I=>new Q(I.templateId,[...H,I]));const $={...W,dnd:W.dnd&&new K(this,W.dnd)};if(this.view=new g.ListView(L,U,q,$),this.view.domNode.setAttribute("role",O),W.styleController)this.styleController=W.styleController(this.view.domId);else{const I=(0,v.createStyleSheet)(this.view.domNode);this.styleController=new ge(I,this.view.domId)}if(this.spliceable=new w.CombinedSpliceable([new T(this.focus,this.view,W.identityProvider),new T(this.selection,this.view,W.identityProvider),new T(this.anchor,this.view,W.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new se(this,this.view)),(typeof W.keyboardSupport!="boolean"||W.keyboardSupport)&&(this.keyboardController=new r(this,this.view,W),this.disposables.add(this.keyboardController)),W.keyboardNavigationLabelProvider){const I=W.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new V(this,this.view,W.keyboardNavigationLabelProvider,I),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(W),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}get onDidChangeFocus(){return a.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),h=>this.toListEvent(h),this.disposables)}get onDidChangeSelection(){return a.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),h=>this.toListEvent(h),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let h=!1;const L=this.disposables.add(a.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event)).map(W=>new R.StandardKeyboardEvent(W)).filter(W=>h=W.keyCode===58||W.shiftKey&&W.keyCode===68).map(i.stopEvent).filter(()=>!1).event,U=this.disposables.add(a.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keyup")).event)).forEach(()=>h=!1).map(W=>new R.StandardKeyboardEvent(W)).filter(W=>W.keyCode===58||W.shiftKey&&W.keyCode===68).map(i.stopEvent).map(({browserEvent:W})=>{const O=this.getFocus(),H=O.length?O[0]:void 0,$=typeof H!="undefined"?this.view.element(H):void 0,I=typeof H!="undefined"?this.view.domElement(H):this.view.domNode;return{index:H,element:$,anchor:I,browserEvent:W}}).event,q=this.disposables.add(a.Event.chain(this.view.onContextMenu)).filter(W=>!h).map(({element:W,index:O,browserEvent:H})=>({element:W,index:O,anchor:{x:H.pageX+1,y:H.pageY},browserEvent:H})).event;return a.Event.any(L,U,q)}get onKeyDown(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return a.Event.signal(this.disposables.add(new i.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return a.Event.signal(this.disposables.add(new i.DomEmitter(this.view.domNode,"blur",!0)).event)}createMouseController(h){return new de(this)}updateOptions(h={}){this._options={...this._options,...h},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(h),this.keyboardController?.updateOptions(h),this.view.updateOptions(h)}get options(){return this._options}splice(h,L,U=[]){if(h<0||h>this.view.length)throw new u.ListError(this.user,`Invalid start index: ${h}`);if(L<0)throw new u.ListError(this.user,`Invalid delete count: ${L}`);L===0&&U.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(h,L,U))}updateWidth(h){this.view.updateWidth(h)}updateElementHeight(h,L){this.view.updateElementHeight(h,L,null)}rerender(){this.view.rerender()}element(h){return this.view.element(h)}indexOf(h){return this.view.indexOf(h)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.getScrollTop()}set scrollTop(h){this.view.setScrollTop(h)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(h){this.view.setScrollLeft(h)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(h){this._ariaLabel=h,this.view.domNode.setAttribute("aria-label",h)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(h,L){this.view.layout(h,L)}triggerTypeNavigation(){this.typeNavigationController&&this.typeNavigationController.trigger()}setSelection(h,L){for(const U of h)if(U<0||U>=this.length)throw new u.ListError(this.user,`Invalid index ${U}`);this.selection.set(h,L)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(h=>this.view.element(h))}setAnchor(h){if(typeof h=="undefined"){this.anchor.set([]);return}if(h<0||h>=this.length)throw new u.ListError(this.user,`Invalid index ${h}`);this.anchor.set([h])}getAnchor(){return(0,m.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const h=this.getAnchor();return typeof h=="undefined"?void 0:this.element(h)}setFocus(h,L){for(const U of h)if(U<0||U>=this.length)throw new u.ListError(this.user,`Invalid index ${U}`);this.focus.set(h,L)}focusNext(h=1,L=!1,U,q){if(this.length===0)return;const W=this.focus.get(),O=this.findNextIndex(W.length>0?W[0]+h:0,L,q);O>-1&&this.setFocus([O],U)}focusPrevious(h=1,L=!1,U,q){if(this.length===0)return;const W=this.focus.get(),O=this.findPreviousIndex(W.length>0?W[0]-h:0,L,q);O>-1&&this.setFocus([O],U)}async focusNextPage(h,L){let U=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);U=U===0?0:U-1;const q=this.getFocus()[0];if(q!==U&&(q===void 0||U>q)){const W=this.findPreviousIndex(U,!1,L);W>-1&&q!==W?this.setFocus([W],h):this.setFocus([U],h)}else{const W=this.view.getScrollTop();let O=W+this.view.renderHeight;U>q&&(O-=this.view.elementHeight(U)),this.view.setScrollTop(O),this.view.getScrollTop()!==W&&(this.setFocus([]),await(0,f.timeout)(0),await this.focusNextPage(h,L))}}async focusPreviousPage(h,L){let U;const q=this.view.getScrollTop();q===0?U=this.view.indexAt(q):U=this.view.indexAfter(q-1);const W=this.getFocus()[0];if(W!==U&&(W===void 0||W>=U)){const O=this.findNextIndex(U,!1,L);O>-1&&W!==O?this.setFocus([O],h):this.setFocus([U],h)}else{const O=q;this.view.setScrollTop(q-this.view.renderHeight),this.view.getScrollTop()!==O&&(this.setFocus([]),await(0,f.timeout)(0),await this.focusPreviousPage(h,L))}}focusLast(h,L){if(this.length===0)return;const U=this.findPreviousIndex(this.length-1,!1,L);U>-1&&this.setFocus([U],h)}focusFirst(h,L){this.focusNth(0,h,L)}focusNth(h,L,U){if(this.length===0)return;const q=this.findNextIndex(h,!1,U);q>-1&&this.setFocus([q],L)}findNextIndex(h,L=!1,U){for(let q=0;q<this.length;q++){if(h>=this.length&&!L)return-1;if(h=h%this.length,!U||U(this.element(h)))return h;h++}return-1}findPreviousIndex(h,L=!1,U){for(let q=0;q<this.length;q++){if(h<0&&!L)return-1;if(h=(this.length+h%this.length)%this.length,!U||U(this.element(h)))return h;h--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(h=>this.view.element(h))}reveal(h,L){if(h<0||h>=this.length)throw new u.ListError(this.user,`Invalid index ${h}`);const U=this.view.getScrollTop(),q=this.view.elementTop(h),W=this.view.elementHeight(h);if((0,E.isNumber)(L)){const O=W-this.view.renderHeight;this.view.setScrollTop(O*(0,d.clamp)(L,0,1)+q)}else{const O=q+W,H=U+this.view.renderHeight;q<U&&O>=H||(q<U||O>=H&&W>=this.view.renderHeight?this.view.setScrollTop(q):O>=H&&this.view.setScrollTop(O-this.view.renderHeight))}}getRelativeTop(h){if(h<0||h>=this.length)throw new u.ListError(this.user,`Invalid index ${h}`);const L=this.view.getScrollTop(),U=this.view.elementTop(h),q=this.view.elementHeight(h);if(U<L||U+q>L+this.view.renderHeight)return null;const W=q-this.view.renderHeight;return Math.abs((L-U)/W)}isDOMFocused(){return this.view.domNode===document.activeElement}getHTMLElement(){return this.view.domNode}style(h){this.styleController.style(h)}toListEvent({indexes:h,browserEvent:L}){return{indexes:h,elements:h.map(U=>this.view.element(U)),browserEvent:L}}_onFocusChange(){const h=this.focus.get();this.view.domNode.classList.toggle("element-focused",h.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const h=this.focus.get();if(h.length>0){let L;this.accessibilityProvider?.getActiveDescendantId&&(L=this.accessibilityProvider.getActiveDescendantId(this.view.element(h[0]))),this.view.domNode.setAttribute("aria-activedescendant",L||this.view.getElementDomId(h[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const h=this.selection.get();this.view.domNode.classList.toggle("selection-none",h.length===0),this.view.domNode.classList.toggle("selection-single",h.length===1),this.view.domNode.classList.toggle("selection-multiple",h.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}Ke([F.memoize],G.prototype,"onDidChangeFocus",null),Ke([F.memoize],G.prototype,"onDidChangeSelection",null),Ke([F.memoize],G.prototype,"onContextMenu",null),Ke([F.memoize],G.prototype,"onKeyDown",null),Ke([F.memoize],G.prototype,"onKeyUp",null),Ke([F.memoize],G.prototype,"onKeyPress",null),Ke([F.memoize],G.prototype,"onDidFocus",null),Ke([F.memoize],G.prototype,"onDidBlur",null),t.List=G}),define(me[59],pe([1,0,13,34,36,10,16]),function(Z,t,v,i,R,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var w;(function(p){p[p.Paragraph=0]="Paragraph",p[p.Break=1]="Break"})(w=t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class m{constructor(_="",E=!1){if(this.value=_,typeof this.value!="string")throw(0,v.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=E.isTrusted??void 0,this.supportThemeIcons=E.supportThemeIcons??!1,this.supportHtml=E.supportHtml??!1)}appendText(_,E=0){return this.value+=a(this.supportThemeIcons?(0,i.escapeIcons)(_):_).replace(/([ \t]+)/g,(u,g)=>"&nbsp;".repeat(g.length)).replace(/\>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(_){return this.value+=_,this}appendCodeblock(_,E){return this.value+="\n```",this.value+=_,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}appendLink(_,E,u){return this.value+="[",this.value+=this._escape(E,"]"),this.value+="](",this.value+=this._escape(String(_),")"),u&&(this.value+=` "${this._escape(this._escape(u,'"'),")")}"`),this.value+=")",this}_escape(_,E){const u=new RegExp((0,M.escapeRegExpCharacters)(E),"g");return _.replace(u,(g,D)=>_.charAt(D-1)!=="\\"?`\\${g}`:g)}}t.MarkdownString=m;function f(p){return b(p)?!p.value:Array.isArray(p)?p.every(f):!0}t.isEmptyMarkdownString=f;function b(p){return p instanceof m?!0:p&&typeof p=="object"?typeof p.value=="string"&&(typeof p.isTrusted=="boolean"||p.isTrusted===void 0)&&(typeof p.supportThemeIcons=="boolean"||p.supportThemeIcons===void 0):!1}t.isMarkdownString=b;function F(p,_){return p===_?!0:!p||!_?!1:p.value===_.value&&p.isTrusted===_.isTrusted&&p.supportThemeIcons===_.supportThemeIcons&&p.supportHtml===_.supportHtml&&(p.baseUri===_.baseUri||!!p.baseUri&&!!_.baseUri&&(0,R.isEqual)(y.URI.from(p.baseUri),y.URI.from(_.baseUri)))}t.markdownStringEqual=F;function a(p){return p.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=a;function n(p){return p.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=n;function e(p){return p&&p.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}t.removeMarkdownEscapes=e;function d(p){const _=[],E=p.split("|").map(g=>g.trim());p=E[0];const u=E[1];if(u){const g=/height=(\d+)/.exec(u),D=/width=(\d+)/.exec(u),A=g?g[1]:"",N=D?D[1]:"",T=isFinite(parseInt(N)),s=isFinite(parseInt(A));T&&_.push(`width="${N}"`),s&&_.push(`height="${A}"`)}return{href:p,dimensions:_}}t.parseHrefAndDimensions=d}),define(me[120],pe([1,0,4,112,18,51,20,113,6,22,13,3,59,34,71,2,75,49,35,28,36,10,16]),function(Z,t,v,i,R,M,y,w,m,f,b,F,a,n,e,d,p,_,E,u,g,D,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.renderMarkdown=void 0;function N(c,C={},V={}){const se=new d.DisposableStore;let ie=!1;const ae=se.add(new f.CancellationTokenSource),ne=(0,M.createElement)(C),we=function(Q){let S;try{S=(0,_.parse)(decodeURIComponent(Q))}catch{}return S?(S=(0,u.cloneAndChange)(S,K=>{if(c.uris&&c.uris[K])return A.URI.revive(c.uris[K])}),encodeURIComponent(JSON.stringify(S))):Q},de=function(Q,S){const K=c.uris&&c.uris[Q];let G=A.URI.revive(K);return S?Q.startsWith(E.Schemas.data+":")?Q:(G||(G=A.URI.parse(Q)),E.FileAccess.asBrowserUri(G).toString(!0)):!G||A.URI.parse(Q).toString()===G.toString()?Q:(G.query&&(G=G.with({query:we(G.query)})),G.toString())};let ge;const ye=new Promise(Q=>ge=Q),J=new p.marked.Renderer;if(J.image=(Q,S,K)=>{let G=[],k=[];return Q&&({href:Q,dimensions:G}=(0,a.parseHrefAndDimensions)(Q),k.push(`src="${(0,a.escapeDoubleQuotes)(Q)}"`)),K&&k.push(`alt="${(0,a.escapeDoubleQuotes)(K)}"`),S&&k.push(`title="${(0,a.escapeDoubleQuotes)(S)}"`),G.length&&(k=k.concat(G)),"<img "+k.join(" ")+">"},J.link=(Q,S,K)=>typeof Q!="string"?"":(Q===K&&(K=(0,a.removeMarkdownEscapes)(K)),S=typeof S=="string"?(0,a.escapeDoubleQuotes)((0,a.removeMarkdownEscapes)(S)):"",Q=(0,a.removeMarkdownEscapes)(Q),Q=Q.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Q}" title="${S||Q}">${K}</a>`),J.paragraph=Q=>`<p>${Q}</p>`,C.codeBlockRenderer&&(J.code=(Q,S)=>{const K=C.codeBlockRenderer(S??"",Q),G=e.defaultGenerator.nextId();return(0,m.raceCancellation)(Promise.all([K,ye]),ae.token).then(k=>{if(!ie&&k){const h=ne.querySelector(`div[data-code="${G}"]`);h&&v.reset(h,k[0]),C.asyncRenderCallback?.()}}).catch(()=>{}),`<div class="code" data-code="${G}">${(0,D.escape)(Q)}</div>`}),C.actionHandler){const Q=C.actionHandler.disposables.add(new R.DomEmitter(ne,"click")),S=C.actionHandler.disposables.add(new R.DomEmitter(ne,"auxclick"));C.actionHandler.disposables.add(F.Event.any(Q.event,S.event)(K=>{const G=new y.StandardMouseEvent(K);if(!G.leftButton&&!G.middleButton)return;let k=G.target;if(!(k.tagName!=="A"&&(k=k.parentElement,!k||k.tagName!=="A")))try{let h=k.dataset.href;h&&(c.baseUri&&(h=T(A.URI.from(c.baseUri),h)),C.actionHandler.callback(h,G))}catch(h){(0,b.onUnexpectedError)(h)}finally{G.preventDefault()}}))}c.supportHtml||(V.sanitizer=Q=>(c.isTrusted?Q.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?Q:"",V.sanitize=!0,V.silent=!0),V.renderer=J;let De=c.value??"";De.length>1e5&&(De=`${De.substr(0,1e5)}\u2026`),c.supportThemeIcons&&(De=(0,n.markdownEscapeEscapedIcons)(De));let re=p.marked.parse(De,V);c.supportThemeIcons&&(re=(0,w.renderLabelWithIcons)(re).map(S=>typeof S=="string"?S:S.outerHTML).join(""));const le=new DOMParser().parseFromString(s(c,re),"text/html");if(le.body.querySelectorAll("img").forEach(Q=>{const S=Q.getAttribute("src");if(S){let K=S;try{c.baseUri&&(K=T(A.URI.from(c.baseUri),K))}catch{}Q.src=de(K,!0)}}),le.body.querySelectorAll("a").forEach(Q=>{const S=Q.getAttribute("href");if(Q.setAttribute("href",""),!S||/^data:|javascript:/i.test(S)||/^command:/i.test(S)&&!c.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(S))Q.replaceWith(...Q.childNodes);else{let K=de(S,!1);c.baseUri&&(K=T(A.URI.from(c.baseUri),S)),Q.dataset.href=K}}),ne.innerHTML=s(c,le.body.innerHTML),ge(),C.asyncRenderCallback)for(const Q of ne.getElementsByTagName("img")){const S=se.add(v.addDisposableListener(Q,"load",()=>{S.dispose(),C.asyncRenderCallback()}))}return{element:ne,dispose:()=>{ie=!0,ae.cancel(),se.dispose()}}}t.renderMarkdown=N;function T(c,C){return/^\w[\w\d+.-]*:/.test(C)?C:c.path.endsWith("/")?(0,g.resolvePath)(c,C).toString():(0,g.resolvePath)((0,g.dirname)(c),C).toString()}function s(c,C){const{config:V,allowedSchemes:se}=l(c);i.addHook("uponSanitizeAttribute",(ae,ne)=>{if(ne.attrName==="style"||ne.attrName==="class"){if(ae.tagName==="SPAN"){if(ne.attrName==="style"){ne.keepAttr=/^(color\:#[0-9a-fA-F]+;)?(background-color\:#[0-9a-fA-F]+;)?$/.test(ne.attrValue);return}else if(ne.attrName==="class"){ne.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(ne.attrValue);return}}ne.keepAttr=!1;return}});const ie=v.hookDomPurifyHrefAndSrcSanitizer(se);try{return i.sanitize(C,{...V,RETURN_TRUSTED_TYPE:!0})}finally{i.removeHook("uponSanitizeAttribute"),ie.dispose()}}function l(c){const C=[E.Schemas.http,E.Schemas.https,E.Schemas.mailto,E.Schemas.data,E.Schemas.file,E.Schemas.vscodeFileResource,E.Schemas.vscodeRemote,E.Schemas.vscodeRemoteResource];return c.isTrusted&&C.push(E.Schemas.command),{config:{ALLOWED_TAGS:["ul","li","p","b","i","code","blockquote","ol","h1","h2","h3","h4","h5","h6","hr","em","pre","table","thead","tbody","tr","th","td","div","del","a","strong","br","img","span"],ALLOWED_ATTR:["href","data-href","target","title","src","alt","class","style","data-code","width","height","align"],ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:C}}function o(c){return typeof c=="string"?c:r(c)}t.renderStringAsPlaintext=o;function r(c){const C=new p.marked.Renderer;C.code=ae=>ae,C.blockquote=ae=>ae,C.html=ae=>"",C.heading=(ae,ne,we)=>ae+`
`,C.hr=()=>"",C.list=(ae,ne)=>ae,C.listitem=ae=>ae+`
`,C.paragraph=ae=>ae+`
`,C.table=(ae,ne)=>ae+ne+`
`,C.tablerow=ae=>ae,C.tablecell=(ae,ne)=>ae+" ",C.strong=ae=>ae,C.em=ae=>ae,C.codespan=ae=>ae,C.br=()=>`
`,C.del=ae=>ae,C.image=(ae,ne,we)=>"",C.text=ae=>ae,C.link=(ae,ne,we)=>we;let V=c.value??"";V.length>1e5&&(V=`${V.substr(0,1e5)}\u2026`);const se=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),ie=p.marked.parse(V,{renderer:C}).replace(/&(#\d+|[a-zA-Z]+);/g,ae=>se.get(ae)??ae);return s({isTrusted:!1},ie).toString()}t.renderMarkdownAsPlaintext=r}),define(me[121],pe([1,0,4,6,22,59,34,2,7,98]),function(Z,t,v,i,R,M,y,w,m,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function b(n,e){(0,m.isString)(e)?n.title=(0,y.stripIcons)(e):e?.markdownNotSupportedFallback?n.title=e.markdownNotSupportedFallback:n.removeAttribute("title")}t.setupNativeHover=b;class F{constructor(e,d,p){this.hoverDelegate=e,this.target=d,this.fadeInAnimation=p}async update(e,d,p){if(this._cancellationTokenSource&&(this._cancellationTokenSource.dispose(!0),this._cancellationTokenSource=void 0),this.isDisposed)return;let _;if(e===void 0||(0,m.isString)(e)||e instanceof HTMLElement)_=e;else if(!(0,m.isFunction)(e.markdown))_=e.markdown??e.markdownNotSupportedFallback;else{this._hoverWidget||this.show((0,f.localize)(0,null),d),this._cancellationTokenSource=new R.CancellationTokenSource;const E=this._cancellationTokenSource.token;if(_=await e.markdown(E),_===void 0&&(_=e.markdownNotSupportedFallback),this.isDisposed||E.isCancellationRequested)return}this.show(_,d,p)}show(e,d,p){const _=this._hoverWidget;if(this.hasContent(e)){const E={content:e,target:this.target,showPointer:this.hoverDelegate.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.fadeInAnimation||!!_,...p};this._hoverWidget=this.hoverDelegate.showHover(E,d)}_?.dispose()}hasContent(e){return e?(0,M.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this._hoverWidget?.isDisposed}dispose(){this._hoverWidget?.dispose(),this._cancellationTokenSource?.dispose(!0),this._cancellationTokenSource=void 0}}function a(n,e,d,p){let _,E;const u=(T,s)=>{T&&(E?.dispose(),E=void 0),s&&(_?.dispose(),_=void 0),n.onDidHideHover?.()},g=(T,s,l)=>new i.TimeoutTimer(async()=>{(!E||E.isDisposed)&&(E=new F(n,l||e,T>0),await E.update(d,s,p))},T),D=()=>{if(_)return;const T=new w.DisposableStore,s=r=>u(!1,r.fromElement===e);T.add(v.addDisposableListener(e,v.EventType.MOUSE_LEAVE,s,!0));const l=()=>u(!0,!0);T.add(v.addDisposableListener(e,v.EventType.MOUSE_DOWN,l,!0));const o={targetElements:[e],dispose:()=>{}};if(n.placement===void 0||n.placement==="mouse"){const r=c=>{o.x=c.x+10,c.target instanceof HTMLElement&&c.target.classList.contains("action-label")&&u(!0,!0)};T.add(v.addDisposableListener(e,v.EventType.MOUSE_MOVE,r,!0))}T.add(g(n.delay,!1,o)),_=T},A=v.addDisposableListener(e,v.EventType.MOUSE_OVER,D,!0);return{show:T=>{u(!1,!0),g(0,T)},hide:()=>{u(!0,!0)},update:async(T,s)=>{d=T,await E?.update(d,void 0,s)},dispose:()=>{A.dispose(),u(!0,!0)}}}t.setupCustomHover=a}),define(me[122],pe([1,0,4,18,19,120,58,14,3,43,2,5,100,91]),function(Z,t,v,i,R,M,y,w,m,f,b,F,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const n=v.$,e="selectOption.entry.template";class d{get templateId(){return e}renderTemplate(E){const u=Object.create(null);return u.disposables=[],u.root=E,u.text=v.append(E,n(".option-text")),u.detail=v.append(E,n(".option-detail")),u.decoratorRight=v.append(E,n(".option-decorator-right")),u}renderElement(E,u,g){const D=g,A=E.text,N=E.detail,T=E.decoratorRight,s=E.isDisabled;D.text.textContent=A,D.detail.textContent=N||"",D.decoratorRight.innerText=T||"",s?D.root.classList.add("option-disabled"):D.root.classList.remove("option-disabled")}disposeTemplate(E){E.disposables=(0,b.dispose)(E.disposables)}}class p extends b.Disposable{constructor(E,u,g,D,A){super();this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.selectBoxOptions=A||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=p.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=new m.Emitter,this._register(this._onDidSelect),this.styles=D,this.registerListeners(),this.constructSelectDropDown(g),this.selected=u||0,E&&this.setOptions(E,u)}getHeight(){return 18}getTemplateId(){return e}constructSelectDropDown(E){this.contextViewProvider=E,this.selectDropDownContainer=v.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=v.append(this.selectDropDownContainer,n(".select-box-details-pane"));const u=v.append(this.selectDropDownContainer,n(".select-box-dropdown-container-width-control")),g=v.append(u,n(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",v.append(g,this.widthControlElement),this._dropDownPosition=0,this.styleElement=v.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(v.addDisposableListener(this.selectDropDownContainer,v.EventType.DRAG_START,D=>{v.EventHelper.stop(D,!0)}))}registerListeners(){this._register(v.addStandardDisposableListener(this.selectElement,"change",u=>{this.selected=u.target.selectedIndex,this._onDidSelect.fire({index:u.target.selectedIndex,selected:u.target.value}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)})),this._register(v.addDisposableListener(this.selectElement,v.EventType.CLICK,u=>{v.EventHelper.stop(u),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(v.addDisposableListener(this.selectElement,v.EventType.MOUSE_DOWN,u=>{v.EventHelper.stop(u)}));let E;this._register(v.addDisposableListener(this.selectElement,"touchstart",u=>{E=this._isVisible})),this._register(v.addDisposableListener(this.selectElement,"touchend",u=>{v.EventHelper.stop(u),E?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(v.addDisposableListener(this.selectElement,v.EventType.KEY_DOWN,u=>{const g=new R.StandardKeyboardEvent(u);let D=!1;F.isMacintosh?(g.keyCode===18||g.keyCode===16||g.keyCode===10||g.keyCode===3)&&(D=!0):(g.keyCode===18&&g.altKey||g.keyCode===16&&g.altKey||g.keyCode===10||g.keyCode===3)&&(D=!0),D&&(this.showSelectDropDown(),v.EventHelper.stop(u,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(E,u){w.equals(this.options,E)||(this.options=E,this.selectElement.options.length=0,this._hasDetails=!1,this.options.forEach((g,D)=>{this.selectElement.add(this.createOption(g.text,D,g.isDisabled)),typeof g.description=="string"&&(this._hasDetails=!0)})),u!==void 0&&(this.select(u),this._currentSelection=this.selected)}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(E){E>=0&&E<this.options.length?this.selected=E:E>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)}setAriaLabel(E){this.selectBoxOptions.ariaLabel=E,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(E){this.selectElement.tabIndex=E?0:-1}render(E){this.container=E,E.classList.add("select-container"),E.appendChild(this.selectElement),this.applyStyles()}style(E){const u=[];this.styles=E,this.styles.listFocusBackground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&!this.styles.selectBorder.equals(this.styles.selectBackground)?(u.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),u.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),u.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=u.join(`
`),this.applyStyles()}applyStyles(){if(this.selectElement){const E=this.styles.selectBackground?this.styles.selectBackground.toString():"",u=this.styles.selectForeground?this.styles.selectForeground.toString():"",g=this.styles.selectBorder?this.styles.selectBorder.toString():"";this.selectElement.style.backgroundColor=E,this.selectElement.style.color=u,this.selectElement.style.borderColor=g}this.selectList&&this.styleList()}styleList(){if(this.selectList){const E=this.styles.selectBackground?this.styles.selectBackground.toString():"";this.selectList.style({});const u=this.styles.selectListBackground?this.styles.selectListBackground.toString():E;this.selectDropDownListContainer.style.backgroundColor=u,this.selectionDetailsPane.style.backgroundColor=u;const g=this.styles.focusBorder?this.styles.focusBorder.toString():"";this.selectDropDownContainer.style.outlineColor=g,this.selectDropDownContainer.style.outlineOffset="-1px"}}createOption(E,u,g){const D=document.createElement("option");return D.value=E,D.text=E,D.disabled=!!g,D}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:E=>this.renderSelectDropDown(E,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:E=>this.renderSelectDropDown(E),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(E){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),E&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(E,u){return E.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(u),{dispose:()=>{try{E.removeChild(this.selectDropDownContainer)}catch{}}}}measureMaxDetailsHeight(){let E=0;return this.options.forEach((u,g)=>{this.updateDetail(g),this.selectionDetailsPane.offsetHeight>E&&(E=this.selectionDetailsPane.offsetHeight)}),E}layoutSelectDropDown(E){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const u=v.getDomNodePagePosition(this.selectElement),g=getComputedStyle(this.selectElement),D=parseFloat(g.getPropertyValue("--dropdown-padding-top"))+parseFloat(g.getPropertyValue("--dropdown-padding-bottom")),A=window.innerHeight-u.top-u.height-(this.selectBoxOptions.minBottomMargin||0),N=u.top-p.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,T=this.selectElement.offsetWidth,s=this.setWidthControlElement(this.widthControlElement),l=Math.max(s,Math.round(T)).toString()+"px";this.selectDropDownContainer.style.width=l,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let o=this.selectList.contentHeight;const r=this._hasDetails?this.measureMaxDetailsHeight():0,c=o+D+r,C=Math.floor((A-D-r)/this.getHeight()),V=Math.floor((N-D-r)/this.getHeight());if(E)return u.top+u.height>window.innerHeight-22||u.top<p.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||C<1&&V<1?!1:(C<p.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&V>C&&this.options.length>C?(this._dropDownPosition=1,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=0,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(u.top+u.height>window.innerHeight-22||u.top<p.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===0&&C<1||this._dropDownPosition===1&&V<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===0){if(this._isVisible&&C+V<1)return this.hideSelectDropDown(!0),!1;c>A&&(o=C*this.getHeight())}else c>N&&(o=V*this.getHeight());return this.selectList.layout(o),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=o+D+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=o+D+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=l,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(E){let u=0;if(E){let g=0,D=0;this.options.forEach((A,N)=>{const T=A.detail?A.detail.length:0,s=A.decoratorRight?A.decoratorRight.length:0,l=A.text.length+T+s;l>D&&(g=N,D=l)}),E.textContent=this.options[g].text+(this.options[g].decoratorRight?this.options[g].decoratorRight+" ":""),u=v.getTotalWidth(E)}return u}createSelectList(E){if(this.selectList)return;this.selectDropDownListContainer=v.append(E,n(".select-box-dropdown-list-container")),this.listRenderer=new d,this.selectList=new y.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:D=>{let A=D.text;return D.detail&&(A+=`. ${D.detail}`),D.decoratorRight&&(A+=`. ${D.decoratorRight}`),D.description&&(A+=`. ${D.description}`),A},getWidgetAriaLabel:()=>(0,a.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const u=this._register(new i.DomEmitter(this.selectDropDownListContainer,"keydown")),g=m.Event.chain(u.event).filter(()=>this.selectList.length>0).map(D=>new R.StandardKeyboardEvent(D));this._register(g.filter(D=>D.keyCode===3).on(D=>this.onEnter(D),this)),this._register(g.filter(D=>D.keyCode===2).on(D=>this.onEnter(D),this)),this._register(g.filter(D=>D.keyCode===9).on(D=>this.onEscape(D),this)),this._register(g.filter(D=>D.keyCode===16).on(D=>this.onUpArrow(D),this)),this._register(g.filter(D=>D.keyCode===18).on(D=>this.onDownArrow(D),this)),this._register(g.filter(D=>D.keyCode===12).on(this.onPageDown,this)),this._register(g.filter(D=>D.keyCode===11).on(this.onPageUp,this)),this._register(g.filter(D=>D.keyCode===14).on(this.onHome,this)),this._register(g.filter(D=>D.keyCode===13).on(this.onEnd,this)),this._register(g.filter(D=>D.keyCode>=21&&D.keyCode<=56||D.keyCode>=80&&D.keyCode<=108).on(this.onCharacter,this)),this._register(v.addDisposableListener(this.selectList.getHTMLElement(),v.EventType.POINTER_UP,D=>this.onPointerUp(D))),this._register(this.selectList.onMouseOver(D=>typeof D.index!="undefined"&&this.selectList.setFocus([D.index]))),this._register(this.selectList.onDidChangeFocus(D=>this.onListFocus(D))),this._register(v.addDisposableListener(this.selectDropDownContainer,v.EventType.FOCUS_OUT,D=>{!this._isVisible||v.isAncestor(D.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(E){if(!this.selectList.length)return;v.EventHelper.stop(E);const u=E.target;if(!u||u.classList.contains("slider"))return;const g=u.closest(".monaco-list-row");if(!g)return;const D=Number(g.getAttribute("data-index")),A=g.classList.contains("option-disabled");D>=0&&D<this.options.length&&!A&&(this.selected=D,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(E,u){const g=A=>{for(let N=0;N<A.childNodes.length;N++){const T=A.childNodes.item(N);(T.tagName&&T.tagName.toLowerCase())==="img"?A.removeChild(T):g(T)}},D=(0,M.renderMarkdown)({value:E},{actionHandler:u});return D.element.classList.add("select-box-description-markdown"),g(D.element),D.element}onListFocus(E){!this._isVisible||!this._hasDetails||this.updateDetail(E.indexes[0])}updateDetail(E){this.selectionDetailsPane.innerText="";const u=this.options[E],g=u?.description??"",D=u?.descriptionIsMarkdown??!1;if(g){if(D){const A=u.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(g,A))}else this.selectionDetailsPane.innerText=g;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(E){v.EventHelper.stop(E),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(E){v.EventHelper.stop(E),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(E){if(this.selected<this.options.length-1){v.EventHelper.stop(E,!0);const u=this.options[this.selected+1].isDisabled;if(u&&this.options.length>this.selected+2)this.selected+=2;else{if(u)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(E){this.selected>0&&(v.EventHelper.stop(E,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(E){v.EventHelper.stop(E),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(E){v.EventHelper.stop(E),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(E){v.EventHelper.stop(E),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(E){v.EventHelper.stop(E),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(E){const u=f.KeyCodeUtils.toString(E.keyCode);let g=-1;for(let D=0;D<this.options.length-1;D++)if(g=(D+this.selected+1)%this.options.length,this.options[g].text.charAt(0).toUpperCase()===u&&!this.options[g].isDisabled){this.select(g),this.selectList.setFocus([g]),this.selectList.reveal(this.selectList.getFocus()[0]),v.EventHelper.stop(E);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}t.SelectBoxList=p,p.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32,p.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2,p.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3}),define(me[123],pe([1,0,122,116,17,25,28,5,90]),function(Z,t,v,i,R,M,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.defaultStyles=void 0,t.defaultStyles={selectBackground:M.Color.fromHex("#3C3C3C"),selectForeground:M.Color.fromHex("#F0F0F0"),selectBorder:M.Color.fromHex("#3C3C3C")};class m extends R.Widget{constructor(b,F,a,n=(0,y.deepClone)(t.defaultStyles),e){super();w.isMacintosh&&!e?.useCustomDrawn?this.selectBoxDelegate=new i.SelectBoxNative(b,F,n,e):this.selectBoxDelegate=new v.SelectBoxList(b,F,a,n,e),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(b,F){this.selectBoxDelegate.setOptions(b,F)}select(b){this.selectBoxDelegate.select(b)}setAriaLabel(b){this.selectBoxDelegate.setAriaLabel(b)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(b){this.selectBoxDelegate.setFocusable(b)}render(b){this.selectBoxDelegate.render(b)}style(b){this.selectBoxDelegate.style(b)}applyStyles(){this.selectBoxDelegate.applyStyles()}}t.SelectBox=m}),define(me[60],pe([1,0,15,50,4,23,121,123,32,2,5,7,95,46]),function(Z,t,v,i,R,M,y,w,m,f,b,F,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class n extends f.Disposable{constructor(_,E,u={}){super();this.options=u,this._context=_||this,this._action=E,E instanceof m.Action&&this._register(E.onDidChange(g=>{!this.element||this.handleActionChangeEvent(g)}))}get action(){return this._action}handleActionChangeEvent(_){_.enabled!==void 0&&this.updateEnabled(),_.checked!==void 0&&this.updateChecked(),_.class!==void 0&&this.updateClass(),_.label!==void 0&&(this.updateLabel(),this.updateTooltip()),_.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new m.ActionRunner)),this._actionRunner}set actionRunner(_){this._actionRunner=_}getAction(){return this._action}isEnabled(){return this._action.enabled}setActionContext(_){this._context=_}render(_){const E=this.element=_;this._register(M.Gesture.addTarget(_));const u=this.options&&this.options.draggable;u&&(_.draggable=!0,v.isFirefox&&this._register((0,R.addDisposableListener)(_,R.EventType.DRAG_START,g=>g.dataTransfer?.setData(i.DataTransfers.TEXT,this._action.label)))),this._register((0,R.addDisposableListener)(E,M.EventType.Tap,g=>this.onClick(g,!0))),this._register((0,R.addDisposableListener)(E,R.EventType.MOUSE_DOWN,g=>{u||R.EventHelper.stop(g,!0),this._action.enabled&&g.button===0&&E.classList.add("active")})),b.isMacintosh&&this._register((0,R.addDisposableListener)(E,R.EventType.CONTEXT_MENU,g=>{g.button===0&&g.ctrlKey===!0&&this.onClick(g)})),this._register((0,R.addDisposableListener)(E,R.EventType.CLICK,g=>{R.EventHelper.stop(g,!0),this.options&&this.options.isMenu||this.onClick(g)})),this._register((0,R.addDisposableListener)(E,R.EventType.DBLCLICK,g=>{R.EventHelper.stop(g,!0)})),[R.EventType.MOUSE_UP,R.EventType.MOUSE_OUT].forEach(g=>{this._register((0,R.addDisposableListener)(E,g,D=>{R.EventHelper.stop(D),E.classList.remove("active")}))})}onClick(_,E=!1){R.EventHelper.stop(_,!0);const u=F.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?_:{preserveFocus:E}:this._context;this.actionRunner.run(this._action,u)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(_){this.element&&(this.element.tabIndex=_?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getTooltip(){return this.getAction().tooltip}updateTooltip(){if(!this.element)return;const _=this.getTooltip()??"";this.element.setAttribute("aria-label",_),this.options.hoverDelegate?(this.element.title="",this.customHover?this.customHover.update(_):(this.customHover=(0,y.setupCustomHover)(this.options.hoverDelegate,this.element,_),this._store.add(this.customHover))):this.element.title=_}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),super.dispose()}}t.BaseActionViewItem=n;class e extends n{constructor(_,E,u={}){super(_,E,u);this.options=u,this.options.icon=u.icon!==void 0?u.icon:!1,this.options.label=u.label!==void 0?u.label:!0,this.cssClass=""}render(_){super.render(_),this.element&&(this.label=(0,R.append)(this.element,(0,R.$)("a.action-label"))),this.label&&(this._action.id===m.Separator.ID?this.label.setAttribute("role","presentation"):this.options.isMenu?this.label.setAttribute("role","menuitem"):this.label.setAttribute("role","button")),this.options.label&&this.options.keybinding&&this.element&&((0,R.append)(this.element,(0,R.$)("span.keybinding")).textContent=this.options.keybinding),this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(_){this.label&&(this.label.tabIndex=_?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.getAction().label)}getTooltip(){let _=null;return this.getAction().tooltip?_=this.getAction().tooltip:!this.options.label&&this.getAction().label&&this.options.icon&&(_=this.getAction().label,this.options.keybinding&&(_=a.localize(0,null,_,this.options.keybinding))),_??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.getAction().class,this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.getAction().enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateChecked(){this.label&&(this.getAction().checked?this.label.classList.add("checked"):this.label.classList.remove("checked"))}}t.ActionViewItem=e;class d extends n{constructor(_,E,u,g,D,A){super(_,E);this.selectBox=new w.SelectBox(u,g,D,void 0,A),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(_,E){this.selectBox.setOptions(_,E)}select(_){this.selectBox.select(_)}registerListeners(){this._register(this.selectBox.onDidSelect(_=>{this.actionRunner.run(this._action,this.getActionContext(_.selected,_.index))}))}getActionContext(_,E){return _}setFocusable(_){this.selectBox.setFocusable(_)}focus(){this.selectBox&&this.selectBox.focus()}blur(){this.selectBox&&this.selectBox.blur()}render(_){this.selectBox.render(_)}}t.SelectActionViewItem=d}),define(me[61],pe([1,0,4,19,60,32,3,2,7,46]),function(Z,t,v,i,R,M,y,w,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var f;(function(a){a[a.HORIZONTAL=0]="HORIZONTAL",a[a.VERTICAL=1]="VERTICAL"})(f=t.ActionsOrientation||(t.ActionsOrientation={}));class b extends w.Disposable{constructor(n,e={}){super();this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new y.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new y.Emitter({onFirstListenerAdd:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new y.Emitter),this.onDidRun=this._onDidRun.event,this._onBeforeRun=this._register(new y.Emitter),this.onBeforeRun=this._onBeforeRun.event,this.options=e,this._context=e.context??null,this._orientation=this.options.orientation??0,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[3,10]},this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new M.ActionRunner,this._register(this._actionRunner)),this._register(this._actionRunner.onDidRun(_=>this._onDidRun.fire(_))),this._register(this._actionRunner.onBeforeRun(_=>this._onBeforeRun.fire(_))),this._actionIds=[],this.viewItems=[],this.viewItemDisposables=new Map,this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let d,p;switch(this._orientation){case 0:d=[15],p=[17];break;case 1:d=[16],p=[18],this.domNode.className+=" vertical";break}this._register(v.addDisposableListener(this.domNode,v.EventType.KEY_DOWN,_=>{const E=new i.StandardKeyboardEvent(_);let u=!0;const g=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;d&&(E.equals(d[0])||E.equals(d[1]))?u=this.focusPrevious():p&&(E.equals(p[0])||E.equals(p[1]))?u=this.focusNext():E.equals(9)&&this.cancelHasListener?this._onDidCancel.fire():E.equals(14)?u=this.focusFirst():E.equals(13)?u=this.focusLast():E.equals(2)&&g instanceof R.BaseActionViewItem&&g.trapsArrowNavigation?u=this.focusNext():this.isTriggerKeyEvent(E)?this._triggerKeys.keyDown?this.doTrigger(E):this.triggerKeyDown=!0:u=!1,u&&(E.preventDefault(),E.stopPropagation())})),this._register(v.addDisposableListener(this.domNode,v.EventType.KEY_UP,_=>{const E=new i.StandardKeyboardEvent(_);this.isTriggerKeyEvent(E)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(E)),E.preventDefault(),E.stopPropagation()):(E.equals(2)||E.equals(1024|2))&&this.updateFocusedItem()})),this.focusTracker=this._register(v.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(v.getActiveElement()===this.domNode||!v.isAncestor(v.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.focusedItem=void 0,this.previouslyFocusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),n.appendChild(this.domNode)}refreshRole(){this.length()>=2?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(n){n?this.actionsList.setAttribute("aria-label",n):this.actionsList.removeAttribute("aria-label")}setFocusable(n){if(this.focusable=n,this.focusable){const e=this.viewItems.find(d=>d instanceof R.BaseActionViewItem&&d.isEnabled());e instanceof R.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof R.BaseActionViewItem&&e.setFocusable(!1)})}isTriggerKeyEvent(n){let e=!1;return this._triggerKeys.keys.forEach(d=>{e=e||n.equals(d)}),e}updateFocusedItem(){for(let n=0;n<this.actionsList.children.length;n++){const e=this.actionsList.children[n];if(v.isAncestor(v.getActiveElement(),e)){this.focusedItem=n;break}}}get context(){return this._context}set context(n){this._context=n,this.viewItems.forEach(e=>e.setActionContext(n))}get actionRunner(){return this._actionRunner}set actionRunner(n){n&&(this._actionRunner=n,this.viewItems.forEach(e=>e.actionRunner=n))}getContainer(){return this.domNode}hasAction(n){return this._actionIds.includes(n.id)}getAction(n){return this.viewItems[n].action}push(n,e={}){const d=Array.isArray(n)?n:[n];let p=m.isNumber(e.index)?e.index:null;d.forEach(_=>{const E=document.createElement("li");E.className="action-item",E.setAttribute("role","presentation");let u;this.options.actionViewItemProvider&&(u=this.options.actionViewItemProvider(_)),u||(u=new R.ActionViewItem(this.context,_,{hoverDelegate:this.options.hoverDelegate,...e})),this.options.allowContextMenu||this.viewItemDisposables.set(u,v.addDisposableListener(E,v.EventType.CONTEXT_MENU,g=>{v.EventHelper.stop(g,!0)})),u.actionRunner=this._actionRunner,u.setActionContext(this.context),u.render(E),this.focusable&&u instanceof R.BaseActionViewItem&&this.viewItems.length===0&&u.setFocusable(!0),p===null||p<0||p>=this.actionsList.children.length?(this.actionsList.appendChild(E),this.viewItems.push(u),this._actionIds.push(_.id)):(this.actionsList.insertBefore(E,this.actionsList.children[p]),this.viewItems.splice(p,0,u),this._actionIds.splice(p,0,_.id),p++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(n){if(n>=0&&n<this.actionsList.children.length){const e=this.actionsList.children.item(n);if(e)return e.clientWidth}return 0}getHeight(n){if(n>=0&&n<this.actionsList.children.length){const e=this.actionsList.children.item(n);if(e)return e.clientHeight}return 0}pull(n){n>=0&&n<this.viewItems.length&&(this.actionsList.removeChild(this.actionsList.childNodes[n]),this.viewItemDisposables.get(this.viewItems[n])?.dispose(),this.viewItemDisposables.delete(this.viewItems[n]),(0,w.dispose)(this.viewItems.splice(n,1)),this._actionIds.splice(n,1),this.refreshRole())}clear(){(0,w.dispose)(this.viewItems),this.viewItemDisposables.forEach(n=>n.dispose()),this.viewItemDisposables.clear(),this.viewItems=[],this._actionIds=[],v.clearNode(this.actionsList),this.refreshRole()}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(n){let e=!1,d;if(n===void 0?e=!0:typeof n=="number"?d=n:typeof n=="boolean"&&(e=n),e&&typeof this.focusedItem=="undefined"){const p=this.viewItems.findIndex(_=>_.isEnabled());this.focusedItem=p===-1?void 0:p,this.updateFocus(void 0,void 0,!0)}else d!==void 0&&(this.focusedItem=d),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(n){if(typeof this.focusedItem=="undefined")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let d;do{if(!n&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=e,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,d=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!d.isEnabled()||d.action.id===M.Separator.ID));return this.updateFocus(),!0}focusPrevious(n){if(typeof this.focusedItem=="undefined")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let d;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!n&&this.options.preventLoopNavigation)return this.focusedItem=e,!1;this.focusedItem=this.viewItems.length-1}d=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!d.isEnabled()||d.action.id===M.Separator.ID));return this.updateFocus(!0),!0}updateFocus(n,e,d=!1){typeof this.focusedItem=="undefined"&&this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const p=this.focusedItem!==void 0&&this.viewItems[this.focusedItem];if(p){let _=!0;m.isFunction(p.focus)||(_=!1),this.options.focusOnlyEnabledItems&&m.isFunction(p.isEnabled)&&!p.isEnabled()&&(_=!1),p.action.id===M.Separator.ID&&(_=!1),_?(d||this.previouslyFocusedItem!==this.focusedItem)&&(p.focus(n),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem=void 0)}}doTrigger(n){if(typeof this.focusedItem=="undefined")return;const e=this.viewItems[this.focusedItem];if(e instanceof R.BaseActionViewItem){const d=e._context===null||e._context===void 0?n:e._context;this.run(e._action,d)}}async run(n,e){await this._actionRunner.run(n,e)}dispose(){(0,w.dispose)(this.viewItems),this.viewItems=[],this._actionIds=[],this.getContainer().remove(),super.dispose()}}t.ActionBar=b;function F(a){if(!a.length)return a;let n=-1;for(let d=0;d<a.length;d++)if(a[d].id!==M.Separator.ID){n=d;break}if(n===-1)return[];a=a.slice(n);for(let d=a.length-1;d>=0&&a[d].id===M.Separator.ID;d--)a.splice(d,1);let e=!1;for(let d=a.length-1;d>=0;d--){const p=a[d].id===M.Separator.ID;p&&!e?a.splice(d,1):p?p&&(e=!1):e=!0}return a}t.prepareActions=F}),define(me[124],pe([1,0,4,18,51,61,53,56,17,25,3,77,28,99,87]),function(Z,t,v,i,R,M,y,w,m,f,b,F,a,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.MessageType=void 0;const e=v.$;var d;(function(u){u[u.INFO=1]="INFO",u[u.WARNING=2]="WARNING",u[u.ERROR=3]="ERROR"})(d=t.MessageType||(t.MessageType={}));const p={inputBackground:f.Color.fromHex("#3C3C3C"),inputForeground:f.Color.fromHex("#CCCCCC"),inputValidationInfoBorder:f.Color.fromHex("#55AAFF"),inputValidationInfoBackground:f.Color.fromHex("#063B49"),inputValidationWarningBorder:f.Color.fromHex("#B89500"),inputValidationWarningBackground:f.Color.fromHex("#352A05"),inputValidationErrorBorder:f.Color.fromHex("#BE1100"),inputValidationErrorBackground:f.Color.fromHex("#5A1D1D")};class _ extends m.Widget{constructor(g,D,A){super();this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new b.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=D,this.options=A||Object.create(null),(0,a.mixin)(this.options,p,!1),this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.inputBackground=this.options.inputBackground,this.inputForeground=this.options.inputForeground,this.inputBorder=this.options.inputBorder,this.inputValidationInfoBorder=this.options.inputValidationInfoBorder,this.inputValidationInfoBackground=this.options.inputValidationInfoBackground,this.inputValidationInfoForeground=this.options.inputValidationInfoForeground,this.inputValidationWarningBorder=this.options.inputValidationWarningBorder,this.inputValidationWarningBackground=this.options.inputValidationWarningBackground,this.inputValidationWarningForeground=this.options.inputValidationWarningForeground,this.inputValidationErrorBorder=this.options.inputValidationErrorBorder,this.inputValidationErrorBackground=this.options.inputValidationErrorBackground,this.inputValidationErrorForeground=this.options.inputValidationErrorForeground,this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=v.append(g,e(".monaco-inputbox.idle"));const N=this.options.flexibleHeight?"textarea":"input",T=v.append(this.element,e(".ibwrapper"));if(this.input=v.append(T,e(N+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=v.append(T,e("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new w.ScrollableElement(this.element,{vertical:1}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),v.append(g,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll(o=>this.input.scrollTop=o.scrollTop));const s=this._register(new i.DomEmitter(document,"selectionchange")),l=b.Event.filter(s.event,()=>document.getSelection()?.anchorNode===T);this._register(l(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this.ignoreGesture(this.input),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new M.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(g){this.placeholder=g,this.input.setAttribute("placeholder",g)}setTooltip(g){this.tooltip=g,this.input.title=g}setAriaLabel(g){this.ariaLabel=g,g?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(g){this.input.value!==g&&(this.input.value=g,this.onValueChange())}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:v.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return document.activeElement===this.input}select(g=null){this.input.select(),g&&(this.input.setSelectionRange(g.start,g.end),g.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(g){g?this.enable():this.disable()}get width(){return v.getTotalWidth(this.input)}set width(g){if(this.options.flexibleHeight&&this.options.flexibleWidth){let D=0;if(this.mirror){const A=parseFloat(this.mirror.style.paddingLeft||"")||0,N=parseFloat(this.mirror.style.paddingRight||"")||0;D=A+N}this.input.style.width=g-D+"px"}else this.input.style.width=g+"px";this.mirror&&(this.mirror.style.width=g+"px")}set paddingRight(g){this.input.style.width=`calc(100% - ${g}px)`,this.mirror&&(this.mirror.style.paddingRight=g+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const g=this.cachedContentHeight,D=this.cachedHeight,A=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:g,height:D}),this.scrollableElement.setScrollPosition({scrollTop:A})}showMessage(g,D){this.message=g,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(g.type));const A=this.stylesForType(this.message.type);this.element.style.border=A.border?`1px solid ${A.border}`:"",(this.hasFocus()||D)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let g=null;return this.validation&&(g=this.validation(this.value),g?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(g)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),g?.type}stylesForType(g){switch(g){case 1:return{border:this.inputValidationInfoBorder,background:this.inputValidationInfoBackground,foreground:this.inputValidationInfoForeground};case 2:return{border:this.inputValidationWarningBorder,background:this.inputValidationWarningBackground,foreground:this.inputValidationWarningForeground};default:return{border:this.inputValidationErrorBorder,background:this.inputValidationErrorBackground,foreground:this.inputValidationErrorForeground}}}classForType(g){switch(g){case 1:return"info";case 2:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let g;const D=()=>g.style.width=v.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:N=>{if(!this.message)return null;g=v.append(N,e(".monaco-inputbox-container")),D();const T={inline:!0,className:"monaco-inputbox-message"},s=this.message.formatContent?(0,R.renderFormattedText)(this.message.content,T):(0,R.renderText)(this.message.content,T);s.classList.add(this.classForType(this.message.type));const l=this.stylesForType(this.message.type);return s.style.backgroundColor=l.background?l.background.toString():"",s.style.color=l.foreground?l.foreground.toString():"",s.style.border=l.border?`1px solid ${l.border}`:"",v.append(g,s),null},onHide:()=>{this.state="closed"},layout:D});let A;this.message.type===3?A=n.localize(0,null,this.message.content):this.message.type===2?A=n.localize(1,null,this.message.content):A=n.localize(2,null,this.message.content),y.alert(A),this.state="open"}_hideMessage(){!this.contextViewProvider||(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const g=this.value,A=g.charCodeAt(g.length-1)===10?" ":"";(g+A).replace(/\u000c/g,"")?this.mirror.textContent=g+A:this.mirror.innerText="\xA0",this.layout()}style(g){this.inputBackground=g.inputBackground,this.inputForeground=g.inputForeground,this.inputBorder=g.inputBorder,this.inputValidationInfoBackground=g.inputValidationInfoBackground,this.inputValidationInfoForeground=g.inputValidationInfoForeground,this.inputValidationInfoBorder=g.inputValidationInfoBorder,this.inputValidationWarningBackground=g.inputValidationWarningBackground,this.inputValidationWarningForeground=g.inputValidationWarningForeground,this.inputValidationWarningBorder=g.inputValidationWarningBorder,this.inputValidationErrorBackground=g.inputValidationErrorBackground,this.inputValidationErrorForeground=g.inputValidationErrorForeground,this.inputValidationErrorBorder=g.inputValidationErrorBorder,this.applyStyles()}applyStyles(){const g=this.inputBackground?this.inputBackground.toString():"",D=this.inputForeground?this.inputForeground.toString():"",A=this.inputBorder?this.inputBorder.toString():"";this.element.style.backgroundColor=g,this.element.style.color=D,this.input.style.backgroundColor="inherit",this.input.style.color=D,this.element.style.borderWidth=A?"1px":"",this.element.style.borderStyle=A?"solid":"",this.element.style.borderColor=A}layout(){if(!this.mirror)return;const g=this.cachedContentHeight;this.cachedContentHeight=v.getTotalHeight(this.mirror),g!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(g){const D=this.inputElement,A=D.selectionStart,N=D.selectionEnd,T=D.value;A!==null&&N!==null&&(this.value=T.substr(0,A)+g+T.substr(N),D.setSelectionRange(A+1,A+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar&&this.actionbar.dispose(),super.dispose()}}t.InputBox=_;class E extends _{constructor(g,D,A){const N=n.localize(3,null),T=` or \u21C5 ${N}`,s=` (\u21C5 ${N})`;super(g,D,A);this._onDidFocus=this._register(new b.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new b.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new F.HistoryNavigator(A.history,100);const l=()=>{if(A.showHistoryHint&&A.showHistoryHint()&&!this.placeholder.endsWith(T)&&!this.placeholder.endsWith(s)&&this.history.getHistory().length){const o=this.placeholder.endsWith(")")?T:s,r=this.placeholder+o;A.showPlaceholderOnFocus&&document.activeElement!==this.input?this.placeholder=r:this.setPlaceHolder(r)}};this.observer=new MutationObserver((o,r)=>{o.forEach(c=>{c.target.textContent||l()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>l()),this.onblur(this.input,()=>{const o=r=>{if(this.placeholder.endsWith(r)){const c=this.placeholder.slice(0,this.placeholder.length-r.length);return A.showPlaceholderOnFocus?this.placeholder=c:this.setPlaceHolder(c),!0}else return!1};o(s)||o(T)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(){this.value&&this.value!==this.getCurrentValue()&&this.history.add(this.value)}getHistory(){return this.history.getHistory()}showNextValue(){this.history.has(this.value)||this.addToHistory();let g=this.getNextValue();g&&(g=g===this.value?this.getNextValue():g),g&&(this.value=g,y.status(this.value))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let g=this.getPreviousValue();g&&(g=g===this.value?this.getPreviousValue():g),g&&(this.value=g,y.status(this.value))}clearHistory(){this.history.clear()}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let g=this.history.current();return g||(g=this.history.last(),this.history.next()),g}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()||this.history.last()}}t.HistoryInputBox=E}),define(me[62],pe([1,0,60,17,11,25,3,92]),function(Z,t,v,i,R,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=void 0;const w={inputActiveOptionBorder:M.Color.fromHex("#007ACC00"),inputActiveOptionForeground:M.Color.fromHex("#FFFFFF"),inputActiveOptionBackground:M.Color.fromHex("#0E639C50")};class m extends v.BaseActionViewItem{constructor(a,n,e){super(a,n,e);this.toggle=this._register(new f({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(a){this.element=a,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(a){this.toggle.domNode.tabIndex=a?0:-1}}t.ToggleActionViewItem=m;class f extends i.Widget{constructor(a){super();this._onChange=this._register(new y.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new y.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts={...w,...a},this._checked=this._opts.isChecked;const n=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,n.push(...R.CSSIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&n.push(...this._opts.actionClassName.split(" ")),this._checked&&n.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this._opts.title,this.domNode.classList.add(...n),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,e=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),e.preventDefault())}),this.ignoreGesture(this.domNode),this.onkeydown(this.domNode,e=>{if(e.keyCode===10||e.keyCode===3){this.checked=!this._checked,this._onChange.fire(!0),e.preventDefault(),e.stopPropagation();return}this._onKeyDown.fire(e)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(a){this._checked=a,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(a){this._icon&&this.domNode.classList.remove(...R.CSSIcon.asClassNameArray(this._icon)),this._icon=a,this._icon&&this.domNode.classList.add(...R.CSSIcon.asClassNameArray(this._icon))}width(){return 2+2+2+16}style(a){a.inputActiveOptionBorder&&(this._opts.inputActiveOptionBorder=a.inputActiveOptionBorder),a.inputActiveOptionForeground&&(this._opts.inputActiveOptionForeground=a.inputActiveOptionForeground),a.inputActiveOptionBackground&&(this._opts.inputActiveOptionBackground=a.inputActiveOptionBackground),this.applyStyles()}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder?this._opts.inputActiveOptionBorder.toString():"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground?this._opts.inputActiveOptionForeground.toString():"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground?this._opts.inputActiveOptionBackground.toString():"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(a){this.domNode.title=a,this.domNode.setAttribute("aria-label",a)}}t.Toggle=f;class b extends i.Widget{constructor(a,n){super();this.title=a,this.isChecked=n,this.checkbox=new f({title:this.title,isChecked:this.isChecked,icon:R.Codicon.check,actionClassName:"monaco-checkbox"}),this.domNode=this.checkbox.domNode,this.styles={},this.checkbox.onChange(()=>{this.applyStyles()})}get checked(){return this.checkbox.checked}set checked(a){this.checkbox.checked=a,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}style(a){this.styles=a,this.applyStyles()}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground?this.styles.checkboxForeground.toString():"",this.domNode.style.backgroundColor=this.styles.checkboxBackground?this.styles.checkboxBackground.toString():"",this.domNode.style.borderColor=this.styles.checkboxBorder?this.styles.checkboxBorder.toString():""}}t.Checkbox=b}),define(me[125],pe([1,0,62,11,97]),function(Z,t,v,i,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const M=R.localize(0,null),y=R.localize(1,null),w=R.localize(2,null);class m extends v.Toggle{constructor(a){super({icon:i.Codicon.caseSensitive,title:M+a.appendTitle,isChecked:a.isChecked,inputActiveOptionBorder:a.inputActiveOptionBorder,inputActiveOptionForeground:a.inputActiveOptionForeground,inputActiveOptionBackground:a.inputActiveOptionBackground})}}t.CaseSensitiveToggle=m;class f extends v.Toggle{constructor(a){super({icon:i.Codicon.wholeWord,title:y+a.appendTitle,isChecked:a.isChecked,inputActiveOptionBorder:a.inputActiveOptionBorder,inputActiveOptionForeground:a.inputActiveOptionForeground,inputActiveOptionBackground:a.inputActiveOptionBackground})}}t.WholeWordsToggle=f;class b extends v.Toggle{constructor(a){super({icon:i.Codicon.regex,title:w+a.appendTitle,isChecked:a.isChecked,inputActiveOptionBorder:a.inputActiveOptionBorder,inputActiveOptionForeground:a.inputActiveOptionForeground,inputActiveOptionBackground:a.inputActiveOptionBackground})}}t.RegexToggle=b}),define(me[126],pe([1,0,4,125,124,17,3,96,86]),function(Z,t,v,i,R,M,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const m=w.localize(0,null);class f extends M.Widget{constructor(F,a,n,e){super();this._showOptionButtons=n,this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalToggles=[],this._onDidOptionChange=this._register(new y.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new y.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new y.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new y.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new y.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new y.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new y.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.contextViewProvider=a,this.placeholder=e.placeholder||"",this.validation=e.validation,this.label=e.label||m,this.inputActiveOptionBorder=e.inputActiveOptionBorder,this.inputActiveOptionForeground=e.inputActiveOptionForeground,this.inputActiveOptionBackground=e.inputActiveOptionBackground,this.inputBackground=e.inputBackground,this.inputForeground=e.inputForeground,this.inputBorder=e.inputBorder,this.inputValidationInfoBorder=e.inputValidationInfoBorder,this.inputValidationInfoBackground=e.inputValidationInfoBackground,this.inputValidationInfoForeground=e.inputValidationInfoForeground,this.inputValidationWarningBorder=e.inputValidationWarningBorder,this.inputValidationWarningBackground=e.inputValidationWarningBackground,this.inputValidationWarningForeground=e.inputValidationWarningForeground,this.inputValidationErrorBorder=e.inputValidationErrorBorder,this.inputValidationErrorBackground=e.inputValidationErrorBackground,this.inputValidationErrorForeground=e.inputValidationErrorForeground;const d=e.appendCaseSensitiveLabel||"",p=e.appendWholeWordsLabel||"",_=e.appendRegexLabel||"",E=e.history||[],u=!!e.flexibleHeight,g=!!e.flexibleWidth,D=e.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new R.HistoryInputBox(this.domNode,this.contextViewProvider,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder,history:E,showHistoryHint:e.showHistoryHint,flexibleHeight:u,flexibleWidth:g,flexibleMaxHeight:D})),this.regex=this._register(new i.RegexToggle({appendTitle:_,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.regex.onChange(N=>{this._onDidOptionChange.fire(N),!N&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(N=>{this._onRegexKeyDown.fire(N)})),this.wholeWords=this._register(new i.WholeWordsToggle({appendTitle:p,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.wholeWords.onChange(N=>{this._onDidOptionChange.fire(N),!N&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new i.CaseSensitiveToggle({appendTitle:d,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.caseSensitive.onChange(N=>{this._onDidOptionChange.fire(N),!N&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(N=>{this._onCaseSensitiveKeyDown.fire(N)}));const A=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,N=>{if(N.equals(15)||N.equals(17)||N.equals(9)){const T=A.indexOf(document.activeElement);if(T>=0){let s=-1;N.equals(17)?s=(T+1)%A.length:N.equals(15)&&(T===0?s=A.length-1:s=T-1),N.equals(9)?(A[T].blur(),this.inputBox.focus()):s>=0&&A[s].focus(),v.EventHelper.stop(N,!0)}}}),this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this._showOptionButtons?"block":"none",this.controls.appendChild(this.caseSensitive.domNode),this.controls.appendChild(this.wholeWords.domNode),this.controls.appendChild(this.regex.domNode),this._showOptionButtons||(this.caseSensitive.domNode.style.display="none",this.wholeWords.domNode.style.display="none",this.regex.domNode.style.display="none");for(const N of e?.additionalToggles??[])this._register(N),this.controls.appendChild(N.domNode),this._register(N.onChange(T=>{this._onDidOptionChange.fire(T),!T&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(N);this.additionalToggles.length>0&&(this.controls.style.display="block"),this.inputBox.paddingRight=(this._showOptionButtons?this.caseSensitive.width()+this.wholeWords.width()+this.regex.width():0)+this.additionalToggles.reduce((N,T)=>N+T.width(),0),this.domNode.appendChild(this.controls),F?.appendChild(this.domNode),this._register(v.addDisposableListener(this.inputBox.inputElement,"compositionstart",N=>{this.imeSessionInProgress=!0})),this._register(v.addDisposableListener(this.inputBox.inputElement,"compositionend",N=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,N=>this._onKeyDown.fire(N)),this.onkeyup(this.inputBox.inputElement,N=>this._onKeyUp.fire(N)),this.oninput(this.inputBox.inputElement,N=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,N=>this._onMouseDown.fire(N))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex.enable(),this.wholeWords.enable(),this.caseSensitive.enable();for(const F of this.additionalToggles)F.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex.disable(),this.wholeWords.disable(),this.caseSensitive.disable();for(const F of this.additionalToggles)F.disable()}setFocusInputOnOptionClick(F){this.fixFocusOnOptionClickEnabled=F}setEnabled(F){F?this.enable():this.disable()}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(F){this.inputBox.value!==F&&(this.inputBox.value=F)}onSearchSubmit(){this.inputBox.addToHistory()}style(F){this.inputActiveOptionBorder=F.inputActiveOptionBorder,this.inputActiveOptionForeground=F.inputActiveOptionForeground,this.inputActiveOptionBackground=F.inputActiveOptionBackground,this.inputBackground=F.inputBackground,this.inputForeground=F.inputForeground,this.inputBorder=F.inputBorder,this.inputValidationInfoBackground=F.inputValidationInfoBackground,this.inputValidationInfoForeground=F.inputValidationInfoForeground,this.inputValidationInfoBorder=F.inputValidationInfoBorder,this.inputValidationWarningBackground=F.inputValidationWarningBackground,this.inputValidationWarningForeground=F.inputValidationWarningForeground,this.inputValidationWarningBorder=F.inputValidationWarningBorder,this.inputValidationErrorBackground=F.inputValidationErrorBackground,this.inputValidationErrorForeground=F.inputValidationErrorForeground,this.inputValidationErrorBorder=F.inputValidationErrorBorder,this.applyStyles()}applyStyles(){if(this.domNode){const F={inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground};this.regex.style(F),this.wholeWords.style(F),this.caseSensitive.style(F);for(const n of this.additionalToggles)n.style(F);const a={inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder};this.inputBox.style(a)}}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive.checked}setCaseSensitive(F){this.caseSensitive.checked=F}getWholeWords(){return this.wholeWords.checked}setWholeWords(F){this.wholeWords.checked=F}getRegex(){return this.regex.checked}setRegex(F){this.regex.checked=F,this.validate()}focusOnCaseSensitive(){this.caseSensitive.focus()}focusOnRegex(){this.regex.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(F){this.inputBox.showMessage(F)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}t.FindInput=f,f.OPTION_CHANGE="optionChange"}),define(me[127],pe([1,0,4,18,19,61,126,57,58,62,54,24,32,14,6,11,69,3,33,2,44,7,101,93]),function(Z,t,v,i,R,M,y,w,m,f,b,F,a,n,e,d,p,_,E,u,g,D,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMode=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class N extends w.ElementsDragAndDropData{constructor(S){super(S.elements.map(K=>K.element));this.data=S}set context(S){this.data.context=S}get context(){return this.data.context}}function T(Q){return Q instanceof w.ElementsDragAndDropData?new N(Q):Q}class s{constructor(S,K){this.modelProvider=S,this.dnd=K,this.autoExpandDisposable=u.Disposable.None}getDragURI(S){return this.dnd.getDragURI(S.element)}getDragLabel(S,K){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(S.map(G=>G.element),K)}onDragStart(S,K){this.dnd.onDragStart?.(T(S),K)}onDragOver(S,K,G,k,h=!0){const L=this.dnd.onDragOver(T(S),K&&K.element,G,k),U=this.autoExpandNode!==K;if(U&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=K),typeof K=="undefined")return L;if(U&&typeof L!="boolean"&&L.autoExpand&&(this.autoExpandDisposable=(0,e.disposableTimeout)(()=>{const $=this.modelProvider(),I=$.getNodeLocation(K);$.isCollapsed(I)&&$.setCollapsed(I,!1),this.autoExpandNode=void 0},500)),typeof L=="boolean"||!L.accept||typeof L.bubble=="undefined"||L.feedback){if(!h){const $=typeof L=="boolean"?L:L.accept,I=typeof L=="boolean"?void 0:L.effect;return{accept:$,effect:I,feedback:[G]}}return L}if(L.bubble===1){const $=this.modelProvider(),I=$.getNodeLocation(K),z=$.getParentNodeLocation(I),P=$.getNode(z),B=z&&$.getListIndex(z);return this.onDragOver(S,P,B,k,!1)}const q=this.modelProvider(),W=q.getNodeLocation(K),O=q.getListIndex(W),H=q.getListRenderCount(W);return{...L,feedback:(0,n.range)(O,O+H)}}drop(S,K,G,k){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(T(S),K&&K.element,G,k)}onDragEnd(S){this.dnd.onDragEnd?.(S)}}function l(Q,S){return S&&{...S,identityProvider:S.identityProvider&&{getId(K){return S.identityProvider.getId(K.element)}},dnd:S.dnd&&new s(Q,S.dnd),multipleSelectionController:S.multipleSelectionController&&{isSelectionSingleChangeEvent(K){return S.multipleSelectionController.isSelectionSingleChangeEvent({...K,element:K.element})},isSelectionRangeChangeEvent(K){return S.multipleSelectionController.isSelectionRangeChangeEvent({...K,element:K.element})}},accessibilityProvider:S.accessibilityProvider&&{...S.accessibilityProvider,getSetSize(K){const G=Q(),k=G.getNodeLocation(K),h=G.getParentNodeLocation(k);return G.getNode(h).visibleChildrenCount},getPosInSet(K){return K.visibleChildIndex+1},isChecked:S.accessibilityProvider&&S.accessibilityProvider.isChecked?K=>S.accessibilityProvider.isChecked(K.element):void 0,getRole:S.accessibilityProvider&&S.accessibilityProvider.getRole?K=>S.accessibilityProvider.getRole(K.element):()=>"treeitem",getAriaLabel(K){return S.accessibilityProvider.getAriaLabel(K.element)},getWidgetAriaLabel(){return S.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:S.accessibilityProvider&&S.accessibilityProvider.getWidgetRole?()=>S.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:S.accessibilityProvider&&S.accessibilityProvider.getAriaLevel?K=>S.accessibilityProvider.getAriaLevel(K.element):K=>K.depth,getActiveDescendantId:S.accessibilityProvider.getActiveDescendantId&&(K=>S.accessibilityProvider.getActiveDescendantId(K.element))},keyboardNavigationLabelProvider:S.keyboardNavigationLabelProvider&&{...S.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(K){return S.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(K.element)}}}}class o{constructor(S){this.delegate=S}getHeight(S){return this.delegate.getHeight(S.element)}getTemplateId(S){return this.delegate.getTemplateId(S.element)}hasDynamicHeight(S){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(S.element)}setDynamicHeight(S,K){this.delegate.setDynamicHeight?.(S.element,K)}}t.ComposedTreeDelegate=o;class r{constructor(S){if(this.focus=new Set(S.focus),this.selection=new Set(S.selection),S.expanded instanceof Array){this.expanded=Object.create(null);for(const K of S.expanded)this.expanded[K]=1}else this.expanded=S.expanded;this.expanded=S.expanded,this.scrollTop=S.scrollTop}static lift(S){return S instanceof r?S:new r(S)}static empty(S=0){return new r({focus:[],selection:[],expanded:Object.create(null),scrollTop:S})}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=r;var c;(function(Q){Q.None="none",Q.OnHover="onHover",Q.Always="always"})(c=t.RenderIndentGuides||(t.RenderIndentGuides={}));class C{constructor(S,K=[]){this._elements=K,this.disposables=new u.DisposableStore,this.onDidChange=_.Event.forEach(S,G=>this._elements=G,this.disposables)}get elements(){return this._elements}dispose(){this.disposables.dispose()}}class V{constructor(S,K,G,k,h={}){this.renderer=S,this.modelProvider=K,this.activeNodes=k,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=V.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.renderedIndentGuides=new p.SetMap,this.activeIndentNodes=new Set,this.indentGuidesDisposable=u.Disposable.None,this.disposables=new u.DisposableStore,this.templateId=S.templateId,this.updateOptions(h),_.Event.map(G,L=>L.node)(this.onDidChangeNodeTwistieState,this,this.disposables),S.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(S={}){if(typeof S.indent!="undefined"&&(this.indent=(0,g.clamp)(S.indent,0,40)),typeof S.renderIndentGuides!="undefined"){const K=S.renderIndentGuides!==c.None;if(K!==this.shouldRenderIndentGuides&&(this.shouldRenderIndentGuides=K,this.indentGuidesDisposable.dispose(),K)){const G=new u.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,G),this.indentGuidesDisposable=G,this._onDidChangeActiveNodes(this.activeNodes.elements)}}typeof S.hideTwistiesOfChildlessElements!="undefined"&&(this.hideTwistiesOfChildlessElements=S.hideTwistiesOfChildlessElements)}renderTemplate(S){const K=(0,v.append)(S,(0,v.$)(".monaco-tl-row")),G=(0,v.append)(K,(0,v.$)(".monaco-tl-indent")),k=(0,v.append)(K,(0,v.$)(".monaco-tl-twistie")),h=(0,v.append)(K,(0,v.$)(".monaco-tl-contents")),L=this.renderer.renderTemplate(h);return{container:S,indent:G,twistie:k,indentGuidesDisposable:u.Disposable.None,templateData:L}}renderElement(S,K,G,k){typeof k=="number"&&(this.renderedNodes.set(S,{templateData:G,height:k}),this.renderedElements.set(S.element,S));const h=V.DefaultIndent+(S.depth-1)*this.indent;G.twistie.style.paddingLeft=`${h}px`,G.indent.style.width=`${h+this.indent-16}px`,this.renderTwistie(S,G),typeof k=="number"&&this.renderIndentGuides(S,G),this.renderer.renderElement(S,K,G.templateData,k)}disposeElement(S,K,G,k){G.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(S,K,G.templateData,k),typeof k=="number"&&(this.renderedNodes.delete(S),this.renderedElements.delete(S.element))}disposeTemplate(S){this.renderer.disposeTemplate(S.templateData)}onDidChangeTwistieState(S){const K=this.renderedElements.get(S);!K||this.onDidChangeNodeTwistieState(K)}onDidChangeNodeTwistieState(S){const K=this.renderedNodes.get(S);!K||(this.renderTwistie(S,K.templateData),this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderIndentGuides(S,K.templateData))}renderTwistie(S,K){K.twistie.classList.remove(...d.Codicon.treeItemExpanded.classNamesArray);let G=!1;this.renderer.renderTwistie&&(G=this.renderer.renderTwistie(S.element,K.twistie)),S.collapsible&&(!this.hideTwistiesOfChildlessElements||S.visibleChildrenCount>0)?(G||K.twistie.classList.add(...d.Codicon.treeItemExpanded.classNamesArray),K.twistie.classList.add("collapsible"),K.twistie.classList.toggle("collapsed",S.collapsed)):K.twistie.classList.remove("collapsible","collapsed"),S.collapsible?K.container.setAttribute("aria-expanded",String(!S.collapsed)):K.container.removeAttribute("aria-expanded")}renderIndentGuides(S,K){if((0,v.clearNode)(K.indent),K.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const G=new u.DisposableStore,k=this.modelProvider();let h=S;for(;;){const L=k.getNodeLocation(h),U=k.getParentNodeLocation(L);if(!U)break;const q=k.getNode(U),W=(0,v.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(q)&&W.classList.add("active"),K.indent.childElementCount===0?K.indent.appendChild(W):K.indent.insertBefore(W,K.indent.firstElementChild),this.renderedIndentGuides.add(q,W),G.add((0,u.toDisposable)(()=>this.renderedIndentGuides.delete(q,W))),h=q}K.indentGuidesDisposable=G}_onDidChangeActiveNodes(S){if(!this.shouldRenderIndentGuides)return;const K=new Set,G=this.modelProvider();S.forEach(k=>{const h=G.getNodeLocation(k);try{const L=G.getParentNodeLocation(h);k.collapsible&&k.children.length>0&&!k.collapsed?K.add(k):L&&K.add(G.getNode(L))}catch{}}),this.activeIndentNodes.forEach(k=>{K.has(k)||this.renderedIndentGuides.forEach(k,h=>h.classList.remove("active"))}),K.forEach(k=>{this.activeIndentNodes.has(k)||this.renderedIndentGuides.forEach(k,h=>h.classList.add("active"))}),this.activeIndentNodes=K}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,u.dispose)(this.disposables)}}V.DefaultIndent=8;class se{constructor(S,K,G){this.tree=S,this.keyboardNavigationLabelProvider=K,this._filter=G,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new u.DisposableStore,S.onWillRefilter(this.reset,this,this.disposables)}get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(S){this._pattern=S,this._lowercasePattern=S.toLowerCase()}filter(S,K){if(this._filter){const h=this._filter.filter(S,K);let L;if(typeof h=="boolean"?L=h?1:0:(0,b.isFilterResult)(h)?L=(0,b.getVisibleState)(h.visibility):L=h,L===0)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:E.FuzzyScore.Default,visibility:!0};const G=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(S),k=Array.isArray(G)?G:[G];for(const h of k){const L=h&&h.toString();if(typeof L=="undefined")return{data:E.FuzzyScore.Default,visibility:!0};const U=(0,E.fuzzyScore)(this._pattern,this._lowercasePattern,0,L,L.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(U)return this._matchCount++,k.length===1?{data:U,visibility:!0}:{data:{label:L,score:U},visibility:!0}}return this.tree.findMode===ae.Filter?2:{data:E.FuzzyScore.Default,visibility:!0}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,u.dispose)(this.disposables)}}class ie extends f.Toggle{constructor(S){super({icon:d.Codicon.filter,title:(0,A.localize)(0,null),isChecked:S?.isChecked??!1,inputActiveOptionBorder:S?.inputActiveOptionBorder,inputActiveOptionForeground:S?.inputActiveOptionForeground,inputActiveOptionBackground:S?.inputActiveOptionBackground})}}t.ModeToggle=ie;var ae;(function(Q){Q[Q.Highlight=0]="Highlight",Q[Q.Filter=1]="Filter"})(ae=t.TreeFindMode||(t.TreeFindMode={}));class ne extends u.Disposable{constructor(S,K,G,k,h){super();this.tree=K,this.elements=(0,v.h)(".monaco-tree-type-filter",[(0,v.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab"),(0,v.h)(".monaco-tree-type-filter-input@findInput"),(0,v.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=4,this._onDidDisable=new _.Emitter,this.onDidDisable=this._onDidDisable.event,S.appendChild(this.elements.root),this._register((0,u.toDisposable)(()=>S.removeChild(this.elements.root))),this.modeToggle=this._register(new ie({...h,isChecked:k===ae.Filter})),this.onDidChangeMode=_.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?ae.Filter:ae.Highlight,this._store),this.findInput=this._register(new y.FindInput(this.elements.findInput,G,!1,{label:(0,A.localize)(3,null),additionalToggles:[this.modeToggle]})),this.actionbar=this._register(new M.ActionBar(this.elements.actionbar)),this.mode=k;const L=this._register(new i.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),U=this._register(_.Event.chain(L.event)).map(O=>new R.StandardKeyboardEvent(O)).event;this._register(U(O=>{switch(O.keyCode){case 18:O.preventDefault(),O.stopPropagation(),this.tree.domFocus();return}}));const q=this._register(new a.Action("close",(0,A.localize)(4,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push(q,{icon:!0,label:!1});const W=this._register(new i.DomEmitter(this.elements.grab,"mousedown"));this._register(W.event(O=>{const H=new u.DisposableStore,$=H.add(new i.DomEmitter(window,"mousemove")),I=H.add(new i.DomEmitter(window,"mouseup")),z=this.right,P=O.pageX;this.elements.grab.classList.add("grabbing");const B=j=>{const ee=j.pageX-P;this.right=z-ee,this.layout()};H.add($.event(B)),H.add(I.event(j=>{B(j),this.elements.grab.classList.remove("grabbing"),H.dispose()}))})),this.onDidChangeValue=this.findInput.onDidChange,this.style(h??{})}set mode(S){this.modeToggle.checked=S===ae.Filter,this.findInput.inputBox.setPlaceHolder(S===ae.Filter?(0,A.localize)(1,null):(0,A.localize)(2,null))}style(S){this.findInput.style(S),S.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=S.listFilterWidgetBackground.toString()),S.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${S.listFilterWidgetShadow}`)}focus(){this.findInput.focus()}select(){this.findInput.select()}layout(S=this.width){this.width=S,this.right=Math.min(Math.max(20,this.right),Math.max(20,S-170)),this.elements.root.style.right=`${this.right}px`}showMessage(S){this.findInput.showMessage(S)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,e.timeout)(300),super.dispose()}}class we{constructor(S,K,G,k,h){this.tree=S,this.view=G,this.filter=k,this.contextViewProvider=h,this._pattern="",this.width=0,this._onDidChangeMode=new _.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangePattern=new _.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new _.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new u.DisposableStore,this.disposables=new u.DisposableStore,this._mode=S.options.defaultFindMode??ae.Highlight,K.onDidSplice(this.onDidSpliceModel,this,this.disposables)}get pattern(){return this._pattern}get mode(){return this._mode}set mode(S){S!==this._mode&&(this._mode=S,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(S))}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.widget=new ne(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this._mode,this.styles),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(S=>this.mode=S,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this._onDidChangeOpenState.fire(!0)}close(){!this.widget||(this.widget=void 0,this.enabledDisposables.dispose(),this.enabledDisposables=new u.DisposableStore,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(S){this._pattern=S,this._onDidChangePattern.fire(S),this.filter.pattern=S,this.tree.refilter(),S&&this.tree.focusNext(0,!0,void 0,G=>!E.FuzzyScore.isDefault(G.filterData));const K=this.tree.getFocus();if(K.length>0){const G=K[0];this.tree.getRelativeTop(G)===null&&this.tree.reveal(G,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const S=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&S?this.widget?.showMessage({type:2,content:(0,A.localize)(5,null)}):this.widget?.clearMessage()}shouldAllowFocus(S){return!this.widget||!this.pattern||this._mode===ae.Filter||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!E.FuzzyScore.isDefault(S.filterData)}style(S){this.styles=S,this.widget?.style(S)}layout(S){this.width=S,this.widget?.layout(S)}dispose(){this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function de(Q){let S=F.TreeMouseEventTarget.Unknown;return(0,v.hasParentWithClass)(Q.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?S=F.TreeMouseEventTarget.Twistie:(0,v.hasParentWithClass)(Q.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?S=F.TreeMouseEventTarget.Element:(0,v.hasParentWithClass)(Q.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(S=F.TreeMouseEventTarget.Filter),{browserEvent:Q.browserEvent,element:Q.element?Q.element.element:null,target:S}}function ge(Q){return{element:Q.element?Q.element.element:null,browserEvent:Q.browserEvent,anchor:Q.anchor}}function ye(Q,S){S(Q),Q.children.forEach(K=>ye(K,S))}class J{constructor(S,K){this.getFirstViewElementWithTrait=S,this.identityProvider=K,this.nodes=[],this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event}get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}set(S,K){!K?.__forceEvent&&(0,n.equals)(this.nodes,S)||this._set(S,!1,K)}_set(S,K,G){if(this.nodes=[...S],this.elements=void 0,this._nodeSet=void 0,!K){const k=this;this._onDidChange.fire({get elements(){return k.get()},browserEvent:G})}}get(){return this.elements||(this.elements=this.nodes.map(S=>S.element)),[...this.elements]}getNodes(){return this.nodes}has(S){return this.nodeSet.has(S)}onDidModelSplice({insertedNodes:S,deletedNodes:K}){if(!this.identityProvider){const q=this.createNodeSet(),W=O=>q.delete(O);K.forEach(O=>ye(O,W)),this.set([...q.values()]);return}const G=new Set,k=q=>G.add(this.identityProvider.getId(q.element).toString());K.forEach(q=>ye(q,k));const h=new Map,L=q=>h.set(this.identityProvider.getId(q.element).toString(),q);S.forEach(q=>ye(q,L));const U=[];for(const q of this.nodes){const W=this.identityProvider.getId(q.element).toString();if(!G.has(W))U.push(q);else{const H=h.get(W);H&&U.push(H)}}if(this.nodes.length>0&&U.length===0){const q=this.getFirstViewElementWithTrait();q&&U.push(q)}this._set(U,!0)}createNodeSet(){const S=new Set;for(const K of this.nodes)S.add(K);return S}}class De extends m.MouseController{constructor(S,K){super(S);this.tree=K}onViewPointer(S){if((0,m.isButton)(S.browserEvent.target)||(0,m.isInputElement)(S.browserEvent.target)||(0,m.isMonacoEditor)(S.browserEvent.target))return;const K=S.element;if(!K)return super.onViewPointer(S);if(this.isSelectionRangeChangeEvent(S)||this.isSelectionSingleChangeEvent(S))return super.onViewPointer(S);const G=S.browserEvent.target,k=G.classList.contains("monaco-tl-twistie")||G.classList.contains("monaco-icon-label")&&G.classList.contains("folder-icon")&&S.browserEvent.offsetX<16;let h=!1;if(typeof this.tree.expandOnlyOnTwistieClick=="function"?h=this.tree.expandOnlyOnTwistieClick(K.element):h=!!this.tree.expandOnlyOnTwistieClick,h&&!k&&S.browserEvent.detail!==2)return super.onViewPointer(S);if(!this.tree.expandOnDoubleClick&&S.browserEvent.detail===2)return super.onViewPointer(S);if(K.collapsible){const L=this.tree.model,U=L.getNodeLocation(K),q=S.browserEvent.altKey;if(this.tree.setFocus([U]),L.setCollapsed(U,void 0,q),h&&k)return}super.onViewPointer(S)}onDoubleClick(S){S.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||super.onDoubleClick(S)}}class re extends m.List{constructor(S,K,G,k,h,L,U,q){super(S,K,G,k,q);this.focusTrait=h,this.selectionTrait=L,this.anchorTrait=U}createMouseController(S){return new De(this,S.tree)}splice(S,K,G=[]){if(super.splice(S,K,G),G.length===0)return;const k=[],h=[];let L;G.forEach((U,q)=>{this.focusTrait.has(U)&&k.push(S+q),this.selectionTrait.has(U)&&h.push(S+q),this.anchorTrait.has(U)&&(L=S+q)}),k.length>0&&super.setFocus((0,n.distinct)([...super.getFocus(),...k])),h.length>0&&super.setSelection((0,n.distinct)([...super.getSelection(),...h])),typeof L=="number"&&super.setAnchor(L)}setFocus(S,K,G=!1){super.setFocus(S,K),G||this.focusTrait.set(S.map(k=>this.element(k)),K)}setSelection(S,K,G=!1){super.setSelection(S,K),G||this.selectionTrait.set(S.map(k=>this.element(k)),K)}setAnchor(S,K=!1){super.setAnchor(S),K||(typeof S=="undefined"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(S)]))}}class te{constructor(S,K,G,k,h={}){this._user=S,this._options=h,this.eventBufferer=new _.EventBufferer,this.onDidChangeFindOpenState=_.Event.None,this.disposables=new u.DisposableStore,this._onWillRefilter=new _.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new _.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event;const L=new o(G),U=new _.Relay,q=new _.Relay,W=this.disposables.add(new C(q.event));this.renderers=k.map($=>new V($,()=>this.model,U.event,W,h));for(const $ of this.renderers)this.disposables.add($);let O;h.keyboardNavigationLabelProvider&&(O=new se(this,h.keyboardNavigationLabelProvider,h.filter),h={...h,filter:O},this.disposables.add(O)),this.focus=new J(()=>this.view.getFocusedElements()[0],h.identityProvider),this.selection=new J(()=>this.view.getSelectedElements()[0],h.identityProvider),this.anchor=new J(()=>this.view.getAnchorElement(),h.identityProvider),this.view=new re(S,K,L,this.renderers,this.focus,this.selection,this.anchor,{...l(()=>this.model,h),tree:this}),this.model=this.createModel(S,this.view,h),U.input=this.model.onDidChangeCollapseState;const H=_.Event.forEach(this.model.onDidSplice,$=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice($),this.selection.onDidModelSplice($)})},this.disposables);if(H(()=>null,null,this.disposables),q.input=_.Event.chain(_.Event.any(H,this.focus.onDidChange,this.selection.onDidChange)).debounce(()=>null,0).map(()=>{const $=new Set;for(const I of this.focus.getNodes())$.add(I);for(const I of this.selection.getNodes())$.add(I);return[...$.values()]}).event,h.keyboardSupport!==!1){const $=_.Event.chain(this.view.onKeyDown).filter(I=>!(0,m.isInputElement)(I.target)).map(I=>new R.StandardKeyboardEvent(I));$.filter(I=>I.keyCode===15).on(this.onLeftArrow,this,this.disposables),$.filter(I=>I.keyCode===17).on(this.onRightArrow,this,this.disposables),$.filter(I=>I.keyCode===10).on(this.onSpace,this,this.disposables)}h.keyboardNavigationLabelProvider&&h.contextViewProvider?(this.findController=new we(this,this.model,this.view,O,h.contextViewProvider),this.focusNavigationFilter=$=>this.findController.shouldAllowFocus($),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode):this.onDidChangeFindMode=_.Event.None,this.styleElement=(0,v.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===c.Always)}get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return _.Event.map(this.view.onMouseClick,de)}get onMouseDblClick(){return _.Event.filter(_.Event.map(this.view.onMouseDblClick,de),S=>S.target!==F.TreeMouseEventTarget.Filter)}get onContextMenu(){return _.Event.map(this.view.onContextMenu,ge)}get onTap(){return _.Event.map(this.view.onTap,de)}get onPointer(){return _.Event.map(this.view.onPointer,de)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return _.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??ae.Highlight}set findMode(S){this.findController&&(this.findController.mode=S)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:_.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick=="undefined"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick=="undefined"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}updateOptions(S={}){this._options={...this._options,...S};for(const K of this.renderers)K.updateOptions(S);this.view.updateOptions(this._options),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===c.Always)}get options(){return this._options}updateWidth(S){const K=this.model.getListIndex(S);K!==-1&&this.view.updateWidth(K)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.scrollTop}set scrollTop(S){this.view.scrollTop=S}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(S){this.view.scrollLeft=S}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){const S=this.view.firstVisibleIndex;return S<0||S>=this.view.length?void 0:this.view.element(S).element}get lastVisibleElement(){const S=this.view.lastVisibleIndex;return this.view.element(S).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(S){this.view.ariaLabel=S}domFocus(){this.view.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(S,K){this.view.layout(S,K),(0,D.isNumber)(K)&&this.findController?.layout(K)}style(S){const K=`.${this.view.domId}`,G=[];S.treeIndentGuidesStroke&&(G.push(`.monaco-list${K}:hover .monaco-tl-indent > .indent-guide, .monaco-list${K}.always .monaco-tl-indent > .indent-guide  { border-color: ${S.treeIndentGuidesStroke.transparent(.4)}; }`),G.push(`.monaco-list${K} .monaco-tl-indent > .indent-guide.active { border-color: ${S.treeIndentGuidesStroke}; }`)),this.styleElement.textContent=G.join(`
`),this.findController?.style(S),this.view.style(S)}getParentElement(S){const K=this.model.getParentNodeLocation(S);return this.model.getNode(K).element}getFirstElementChild(S){return this.model.getFirstElementChild(S)}getNode(S){return this.model.getNode(S)}collapse(S,K=!1){return this.model.setCollapsed(S,!0,K)}expand(S,K=!1){return this.model.setCollapsed(S,!1,K)}toggleCollapsed(S,K=!1){return this.model.setCollapsed(S,void 0,K)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(S){return this.model.isCollapsible(S)}setCollapsible(S,K){return this.model.setCollapsible(S,K)}isCollapsed(S){return this.model.isCollapsed(S)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(S){if(typeof S=="undefined")return this.view.setAnchor(void 0);const K=this.model.getNode(S);this.anchor.set([K]);const G=this.model.getListIndex(S);G>-1&&this.view.setAnchor(G,!0)}getAnchor(){return(0,n.firstOrDefault)(this.anchor.get(),void 0)}setSelection(S,K){const G=S.map(h=>this.model.getNode(h));this.selection.set(G,K);const k=S.map(h=>this.model.getListIndex(h)).filter(h=>h>-1);this.view.setSelection(k,K,!0)}getSelection(){return this.selection.get()}setFocus(S,K){const G=S.map(h=>this.model.getNode(h));this.focus.set(G,K);const k=S.map(h=>this.model.getListIndex(h)).filter(h=>h>-1);this.view.setFocus(k,K,!0)}focusNext(S=1,K=!1,G,k=this.focusNavigationFilter){this.view.focusNext(S,K,G,k)}focusPrevious(S=1,K=!1,G,k=this.focusNavigationFilter){this.view.focusPrevious(S,K,G,k)}focusNextPage(S,K=this.focusNavigationFilter){return this.view.focusNextPage(S,K)}focusPreviousPage(S,K=this.focusNavigationFilter){return this.view.focusPreviousPage(S,K)}focusLast(S,K=this.focusNavigationFilter){this.view.focusLast(S,K)}focusFirst(S,K=this.focusNavigationFilter){this.view.focusFirst(S,K)}getFocus(){return this.focus.get()}reveal(S,K){this.model.expandTo(S);const G=this.model.getListIndex(S);G!==-1&&this.view.reveal(G,K)}getRelativeTop(S){const K=this.model.getListIndex(S);return K===-1?null:this.view.getRelativeTop(K)}getViewState(S=this.options.identityProvider){if(!S)throw new F.TreeError(this._user,"Can't get tree view state without an identity provider");const K=L=>S.getId(L).toString(),G=r.empty(this.scrollTop);for(const L of this.getFocus())G.focus.add(K(L));for(const L of this.getSelection())G.selection.add(K(L));const k=this.model.getNode(),h=[k];for(;h.length>0;){const L=h.shift();L!==k&&L.collapsible&&(G.expanded[K(L.element)]=L.collapsed?0:1),h.push(...L.children)}return G}onLeftArrow(S){S.preventDefault(),S.stopPropagation();const K=this.view.getFocusedElements();if(K.length===0)return;const G=K[0],k=this.model.getNodeLocation(G);if(!this.model.setCollapsed(k,!0)){const L=this.model.getParentNodeLocation(k);if(!L)return;const U=this.model.getListIndex(L);this.view.reveal(U),this.view.setFocus([U])}}onRightArrow(S){S.preventDefault(),S.stopPropagation();const K=this.view.getFocusedElements();if(K.length===0)return;const G=K[0],k=this.model.getNodeLocation(G);if(!this.model.setCollapsed(k,!1)){if(!G.children.some(q=>q.visible))return;const[L]=this.view.getFocus(),U=L+1;this.view.reveal(U),this.view.setFocus([U])}}onSpace(S){S.preventDefault(),S.stopPropagation();const K=this.view.getFocusedElements();if(K.length===0)return;const G=K[0],k=this.model.getNodeLocation(G),h=S.browserEvent.altKey;this.model.setCollapsed(k,void 0,h)}navigate(S){return new le(this.view,this.model,S)}dispose(){(0,u.dispose)(this.disposables),this.view.dispose()}}t.AbstractTree=te;class le{constructor(S,K,G){this.view=S,this.model=K,G?this.index=this.model.getListIndex(G):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(me[128],pe([1,0,127,117,24,27]),function(Z,t,v,i,R,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class y extends v.AbstractTree{constructor(m,f,b,F,a,n={}){super(m,f,b,F,n);this.user=m,this.dataSource=a,this.nodesByIdentity=new Map,this.identityProvider=n.identityProvider}getInput(){return this.input}setInput(m,f){if(f&&!this.identityProvider)throw new R.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=m,!m){this.nodesByIdentity.clear(),this.model.setChildren(null,M.Iterable.empty());return}if(!f){this._refresh(m);return}const b=[],F=[],a=e=>{const d=this.identityProvider.getId(e).toString();return!f.expanded[d]},n=e=>{const d=this.identityProvider.getId(e.element).toString();f.focus.has(d)&&b.push(e.element),f.selection.has(d)&&F.push(e.element)};this._refresh(m,a,n),this.setFocus(b),this.setSelection(F),f&&typeof f.scrollTop=="number"&&(this.scrollTop=f.scrollTop)}updateChildren(m=this.input){if(typeof this.input=="undefined")throw new R.TreeError(this.user,"Tree input not set");let f;this.identityProvider&&(f=b=>{const F=this.identityProvider.getId(b).toString(),a=this.nodesByIdentity.get(F);if(!!a)return a.collapsed}),this._refresh(m,f)}resort(m=this.input,f=!0){this.model.resort(m===this.input?null:m,f)}refresh(m){if(m===void 0){this.view.rerender();return}this.model.rerender(m)}_refresh(m,f,b){let F;if(this.identityProvider){const a=new Set,n=b;b=e=>{const d=this.identityProvider.getId(e.element).toString();a.add(d),this.nodesByIdentity.set(d,e),n?.(e)},F=e=>{const d=this.identityProvider.getId(e.element).toString();a.has(d)||this.nodesByIdentity.delete(d)}}this.model.setChildren(m===this.input?null:m,this.iterate(m,f).elements,{onDidCreateNode:b,onDidDeleteNode:F})}iterate(m,f){const b=[...this.dataSource.getChildren(m)];return{elements:M.Iterable.map(b,a=>{const{elements:n,size:e}=this.iterate(a,f),d=this.dataSource.hasChildren?this.dataSource.hasChildren(a):void 0,p=e===0?void 0:f&&f(a);return{element:a,children:n,collapsible:d,collapsed:p}}),size:b.length}}createModel(m,f,b){return new i.ObjectTreeModel(m,f,b)}}t.DataTree=y}),define(me[38],pe([1,0,14,6,31,22,26,13,3,2,49,10,7]),function(Z,t,v,i,R,M,y,w,m,f,b,F,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var n;(function(re){re[re.Promise=100]="Promise",re[re.PromiseCancel=101]="PromiseCancel",re[re.EventListen=102]="EventListen",re[re.EventDispose=103]="EventDispose"})(n=t.RequestType||(t.RequestType={}));function e(re){switch(re){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(re){re[re.Initialize=200]="Initialize",re[re.PromiseSuccess=201]="PromiseSuccess",re[re.PromiseError=202]="PromiseError",re[re.PromiseErrorObj=203]="PromiseErrorObj",re[re.EventFire=204]="EventFire"})(d=t.ResponseType||(t.ResponseType={}));function p(re){switch(re){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var _;(function(re){re[re.Uninitialized=0]="Uninitialized",re[re.Idle=1]="Idle"})(_||(_={}));class E{constructor(te){this.buffer=te,this.pos=0}read(te){const le=this.buffer.slice(this.pos,this.pos+te);return this.pos+=le.byteLength,le}}class u{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(te){this.buffers.push(te)}}var g;(function(re){re[re.Undefined=0]="Undefined",re[re.String=1]="String",re[re.Buffer=2]="Buffer",re[re.VSBuffer=3]="VSBuffer",re[re.Array=4]="Array",re[re.Object=5]="Object"})(g||(g={}));function D(re){const te=R.VSBuffer.alloc(4);return te.writeUInt32BE(re,0),te}function A(re){return re.read(4).readUInt32BE(0)}function N(re){const te=R.VSBuffer.alloc(1);return te.writeUInt8(re,0),te}const T={Undefined:N(g.Undefined),String:N(g.String),Buffer:N(g.Buffer),VSBuffer:N(g.VSBuffer),Array:N(g.Array),Object:N(g.Object)},s=typeof Buffer!="undefined";function l(re,te){if(typeof te=="undefined")re.write(T.Undefined);else if(typeof te=="string"){const le=R.VSBuffer.fromString(te);re.write(T.String),re.write(D(le.byteLength)),re.write(le)}else if(s&&Buffer.isBuffer(te)){const le=R.VSBuffer.wrap(te);re.write(T.Buffer),re.write(D(le.byteLength)),re.write(le)}else if(te instanceof R.VSBuffer)re.write(T.VSBuffer),re.write(D(te.byteLength)),re.write(te);else if(Array.isArray(te)){re.write(T.Array),re.write(D(te.length));for(const le of te)l(re,le)}else{const le=R.VSBuffer.fromString(JSON.stringify(te));re.write(T.Object),re.write(D(le.byteLength)),re.write(le)}}function o(re){switch(re.read(1).readUInt8(0)){case g.Undefined:return;case g.String:return re.read(A(re)).toString();case g.Buffer:return re.read(A(re)).buffer;case g.VSBuffer:return re.read(A(re));case g.Array:{const le=A(re),Q=[];for(let S=0;S<le;S++)Q.push(o(re));return Q}case g.Object:return JSON.parse(re.read(A(re)).toString())}}class r{constructor(te,le,Q=null,S=1e3){this.protocol=te,this.ctx=le,this.logger=Q,this.timeoutDelay=S,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(te,le){this.channels.set(te,le),setTimeout(()=>this.flushPendingRequests(te),0)}sendResponse(te){switch(te.type){case 200:{const le=this.send([te.type]);this.logger?.logOutgoing(le,0,1,p(te.type));return}case 201:case 202:case 204:case 203:{const le=this.send([te.type,te.id],te.data);this.logger?.logOutgoing(le,te.id,1,p(te.type),te.data);return}}}send(te,le=void 0){const Q=new u;return l(Q,te),l(Q,le),this.sendBuffer(Q.buffer)}sendBuffer(te){try{return this.protocol.send(te),te.byteLength}catch{return 0}}onRawMessage(te){const le=new E(te),Q=o(le),S=o(le),K=Q[0];switch(K){case 100:return this.logger?.logIncoming(te.byteLength,Q[1],1,`${e(K)}: ${Q[2]}.${Q[3]}`,S),this.onPromise({type:K,id:Q[1],channelName:Q[2],name:Q[3],arg:S});case 102:return this.logger?.logIncoming(te.byteLength,Q[1],1,`${e(K)}: ${Q[2]}.${Q[3]}`,S),this.onEventListen({type:K,id:Q[1],channelName:Q[2],name:Q[3],arg:S});case 101:return this.logger?.logIncoming(te.byteLength,Q[1],1,`${e(K)}`),this.disposeActiveRequest({type:K,id:Q[1]});case 103:return this.logger?.logIncoming(te.byteLength,Q[1],1,`${e(K)}`),this.disposeActiveRequest({type:K,id:Q[1]})}}onPromise(te){const le=this.channels.get(te.channelName);if(!le){this.collectPendingRequest(te);return}const Q=new M.CancellationTokenSource;let S;try{S=le.call(this.ctx,te.name,te.arg,Q.token)}catch(k){S=Promise.reject(k)}const K=te.id;S.then(k=>{this.sendResponse({id:K,data:k,type:201}),this.activeRequests.delete(te.id)},k=>{k instanceof Error?this.sendResponse({id:K,data:{message:k.message,name:k.name,stack:k.stack?k.stack.split?k.stack.split(`
`):k.stack:void 0},type:202}):this.sendResponse({id:K,data:k,type:203}),this.activeRequests.delete(te.id)});const G=(0,f.toDisposable)(()=>Q.cancel());this.activeRequests.set(te.id,G)}onEventListen(te){const le=this.channels.get(te.channelName);if(!le){this.collectPendingRequest(te);return}const Q=te.id,K=le.listen(this.ctx,te.name,te.arg)(G=>this.sendResponse({id:Q,data:G,type:204}));this.activeRequests.set(te.id,K)}disposeActiveRequest(te){const le=this.activeRequests.get(te.id);le&&(le.dispose(),this.activeRequests.delete(te.id))}collectPendingRequest(te){let le=this.pendingRequests.get(te.channelName);le||(le=[],this.pendingRequests.set(te.channelName,le));const Q=setTimeout(()=>{console.error(`Unknown channel: ${te.channelName}`),te.type===100&&this.sendResponse({id:te.id,data:{name:"Unknown channel",message:`Channel name '${te.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);le.push({request:te,timeoutTimer:Q})}flushPendingRequests(te){const le=this.pendingRequests.get(te);if(le){for(const Q of le)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.onPromise(Q.request);break;case 102:this.onEventListen(Q.request);break}this.pendingRequests.delete(te)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,f.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=r;var c;(function(re){re[re.LocalSide=0]="LocalSide",re[re.OtherSide=1]="OtherSide"})(c=t.RequestInitiator||(t.RequestInitiator={}));class C{constructor(te,le=null){this.protocol=te,this.isDisposed=!1,this.state=_.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Q=>this.onBuffer(Q)),this.logger=le}getChannel(te){const le=this;return{call(Q,S,K){return le.isDisposed?Promise.reject(w.canceled()):le.requestPromise(te,Q,S,K)},listen(Q,S){return le.isDisposed?m.Event.None:le.requestEvent(te,Q,S)}}}requestPromise(te,le,Q,S=M.CancellationToken.None){const K=this.lastRequestId++,k={id:K,type:100,channelName:te,name:le,arg:Q};if(S.isCancellationRequested)return Promise.reject(w.canceled());let h;return new Promise((U,q)=>{if(S.isCancellationRequested)return q(w.canceled());const W=()=>{const I=z=>{switch(z.type){case 201:this.handlers.delete(K),U(z.data);break;case 202:{this.handlers.delete(K);const P=new Error(z.data.message);P.stack=z.data.stack,P.name=z.data.name,q(P);break}case 203:this.handlers.delete(K),q(z.data);break}};this.handlers.set(K,I),this.sendRequest(k)};let O=null;this.state===_.Idle?W():(O=(0,i.createCancelablePromise)(I=>this.whenInitialized()),O.then(()=>{O=null,W()}));const H=()=>{O?(O.cancel(),O=null):this.sendRequest({id:K,type:101}),q(w.canceled())},$=S.onCancellationRequested(H);h=(0,f.combinedDisposable)((0,f.toDisposable)(H),$),this.activeRequests.add(h)}).finally(()=>{this.activeRequests.delete(h)})}requestEvent(te,le,Q){const S=this.lastRequestId++,G={id:S,type:102,channelName:te,name:le,arg:Q};let k=null;const h=new m.Emitter({onFirstListenerAdd:()=>{k=(0,i.createCancelablePromise)(U=>this.whenInitialized()),k.then(()=>{k=null,this.activeRequests.add(h),this.sendRequest(G)})},onLastListenerRemove:()=>{k?(k.cancel(),k=null):(this.activeRequests.delete(h),this.sendRequest({id:S,type:103}))}}),L=U=>h.fire(U.data);return this.handlers.set(S,L),h.event}sendRequest(te){switch(te.type){case 100:case 102:{const le=this.send([te.type,te.id,te.channelName,te.name],te.arg);this.logger?.logOutgoing(le,te.id,0,`${e(te.type)}: ${te.channelName}.${te.name}`,te.arg);return}case 101:case 103:{const le=this.send([te.type,te.id]);this.logger?.logOutgoing(le,te.id,0,e(te.type));return}}}send(te,le=void 0){const Q=new u;return l(Q,te),l(Q,le),this.sendBuffer(Q.buffer)}sendBuffer(te){try{return this.protocol.send(te),te.byteLength}catch{return 0}}onBuffer(te){const le=new E(te),Q=o(le),S=o(le),K=Q[0];switch(K){case 200:return this.logger?.logIncoming(te.byteLength,0,0,p(K)),this.onResponse({type:Q[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(te.byteLength,Q[1],0,p(K),S),this.onResponse({type:Q[0],id:Q[1],data:S})}}onResponse(te){if(te.type===200){this.state=_.Idle,this._onDidInitialize.fire();return}this.handlers.get(te.id)?.(te)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===_.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,f.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ke([y.memoize],C.prototype,"onDidInitializePromise",null),t.ChannelClient=C;class V{constructor(te){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,te(({protocol:le,onDidClientDisconnect:Q})=>{m.Event.once(le.onMessage)(K=>{const G=new E(K),k=o(G),h=new r(le,k),L=new C(le);this.channels.forEach((q,W)=>h.registerChannel(W,q));const U={channelServer:h,channelClient:L,ctx:k};this._connections.add(U),this._onDidAddConnection.fire(U),Q(()=>{h.dispose(),L.dispose(),this._connections.delete(U),this._onDidRemoveConnection.fire(U)})})})}get connections(){const te=[];return this._connections.forEach(le=>te.push(le)),te}getChannel(te,le){const Q=this;return{call(S,K,G){let k;if((0,a.isFunction)(le)){const L=(0,v.getRandomElement)(Q.connections.filter(le));k=L?Promise.resolve(L):m.Event.toPromise(m.Event.filter(Q.onDidAddConnection,le))}else k=le.routeCall(Q,S,K);const h=k.then(L=>L.channelClient.getChannel(te));return ie(h).call(S,K,G)},listen(S,K){if((0,a.isFunction)(le))return Q.getMulticastEvent(te,le,S,K);const G=le.routeEvent(Q,S,K).then(k=>k.channelClient.getChannel(te));return ie(G).listen(S,K)}}}getMulticastEvent(te,le,Q,S){const K=this;let G=new f.DisposableStore;const k=new m.Emitter({onFirstListenerAdd:()=>{G=new f.DisposableStore;const h=new m.EventMultiplexer,L=new Map,U=W=>{const H=W.channelClient.getChannel(te).listen(Q,S),$=h.add(H);L.set(W,$)},q=W=>{const O=L.get(W);!O||(O.dispose(),L.delete(W))};K.connections.filter(le).forEach(U),m.Event.filter(K.onDidAddConnection,le)(U,void 0,G),K.onDidRemoveConnection(q,void 0,G),h.event(k.fire,k,G),G.add(h)},onLastListenerRemove:()=>{G.dispose()}});return k.event}registerChannel(te,le){this.channels.set(te,le),this._connections.forEach(Q=>{Q.channelServer.registerChannel(te,le)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=V;class se{constructor(te,le,Q=null){const S=new u;l(S,le),te.send(S.buffer),this.channelClient=new C(te,Q),this.channelServer=new r(te,le,Q)}getChannel(te){return this.channelClient.getChannel(te)}registerChannel(te,le){this.channelServer.registerChannel(te,le)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=se;function ie(re){return{call(te,le,Q){return re.then(S=>S.call(te,le,Q))},listen(te,le){const Q=new m.Relay;return re.then(S=>Q.input=S.listen(te,le)),Q.event}}}t.getDelayedChannel=ie;function ae(re){let te=!1;return{call(le,Q,S){return te?re.call(le,Q,S):(0,i.timeout)(0).then(()=>te=!0).then(()=>re.call(le,Q,S))},listen(le,Q){if(te)return re.listen(le,Q);const S=new m.Relay;return(0,i.timeout)(0).then(()=>te=!0).then(()=>S.input=re.listen(le,Q)),S.event}}}t.getNextTickChannel=ae;class ne{constructor(te){this.fn=te}routeCall(te){return this.route(te)}routeEvent(te){return this.route(te)}async route(te){for(const le of te.connections)if(await Promise.resolve(this.fn(le.ctx)))return Promise.resolve(le);return await m.Event.toPromise(te.onDidAddConnection),await this.route(te)}}t.StaticRouter=ne;var we;(function(re){function te(K,G){const k=K,h=G&&G.disableMarshalling,L=new Map;for(const U in k)Q(U)&&L.set(U,m.Event.buffer(k[U],!0));return new class{listen(U,q,W){const O=L.get(q);if(O)return O;if(S(q)){const H=k[q];if(typeof H=="function")return H.call(k,W)}throw new Error(`Event not found: ${q}`)}call(U,q,W){const O=k[q];if(typeof O=="function"){if(!h&&Array.isArray(W))for(let H=0;H<W.length;H++)W[H]=(0,b.revive)(W[H]);return O.apply(k,W)}throw new Error(`Method not found: ${q}`)}}}re.fromService=te;function le(K,G){const k=G&&G.disableMarshalling;return new Proxy({},{get(h,L){if(typeof L=="string")return G?.properties?.has(L)?G.properties.get(L):S(L)?function(U){return K.listen(L,U)}:Q(L)?K.listen(L):async function(...U){let q;G&&!(0,a.isUndefinedOrNull)(G.context)?q=[G.context,...U]:q=U;const W=await K.call(L,q);return k?W:(0,b.revive)(W)};throw new Error(`Property not found: ${String(L)}`)}})}re.toService=le;function Q(K){return K[0]==="o"&&K[1]==="n"&&F.isUpperAsciiLetter(K.charCodeAt(2))}function S(K){return/^onDynamic/.test(K)&&F.isUpperAsciiLetter(K.charCodeAt(9))}})(we=t.ProxyChannel||(t.ProxyChannel={}));const de=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(re){if(Array.isArray(re))return re;if(re&&typeof re=="object"&&typeof re.toString=="function"){const te=re.toString();if(te!=="[object Object]")return te}return re}function ye(re){return Array.isArray(re)?re.map(ge):ge(re)}function J(re,te,le,Q,S,K,G){G=ye(G);const k=de[S],h=k[Q%k.length];let L=[`%c[${re}]%c[${String(te).padStart(7," ")}]%c[len: ${String(le).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${h}`];/\($/.test(K)?(L=L.concat(G),L.push(")")):L.push(G),console.log.apply(console,L)}t.logWithColors=J;class De{constructor(te,le){this._outgoingPrefix=te,this._incomingPrefix=le,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(te,le,Q,S,K){this._totalOutgoing+=te,J(this._outgoingPrefix,this._totalOutgoing,te,le,Q,S,K)}logIncoming(te,le,Q,S,K){this._totalIncoming+=te,J(this._incomingPrefix,this._totalIncoming,te,le,Q,S,K)}}t.IPCLogger=De}),define(me[29],pe([1,0,5]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=v.globals.vscode.ipcRenderer,t.ipcMessagePort=v.globals.vscode.ipcMessagePort,t.webFrame=v.globals.vscode.webFrame,t.process=v.globals.vscode.process,t.context=v.globals.vscode.context}),define(me[129],pe([1,0,80,29]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let R=0;function M(w,m,f){const b=[],F=R++,a=`vscode:onContextMenu${F}`,n=(e,d,p)=>{b[d].click?.(p)};i.ipcRenderer.once(a,n),i.ipcRenderer.once(v.CONTEXT_MENU_CLOSE_CHANNEL,(e,d)=>{d===F&&(i.ipcRenderer.removeListener(a,n),f?.())}),i.ipcRenderer.send(v.CONTEXT_MENU_CHANNEL,F,w.map(e=>y(e,b)),a,m)}t.popup=M;function y(w,m){const f={id:m.length,label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:typeof w.enabled=="boolean"?w.enabled:!0,visible:typeof w.visible=="boolean"?w.visible:!0};return m.push(w),Array.isArray(w.submenu)&&(f.submenu=w.submenu.map(b=>y(b,m))),f}}),define(me[130],pe([1,0,31,3,38,81,29]),function(Z,t,v,i,R,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class w extends R.IPCClient{constructor(f){const b=w.createProtocol();super(b,f);this.protocol=b}static createProtocol(){const f=i.Event.fromNodeEventEmitter(y.ipcRenderer,"vscode:message",(b,F)=>v.VSBuffer.wrap(F));return y.ipcRenderer.send("vscode:hello"),new M.Protocol(y.ipcRenderer,f)}dispose(){this.protocol.disconnect()}}t.Client=w}),define(me[131],pe([12,9]),function(Z,t){return Z.create("vs/platform/files/common/files",t)}),define(me[132],pe([12,9]),function(Z,t){return Z.create("vs/platform/theme/common/iconRegistry",t)}),define(me[63],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class v{constructor(R,M=[],y=!1){this.ctor=R,this.staticArguments=M,this.supportsDelayedInstantiation=y}}t.SyncDescriptor=v}),define(me[133],pe([1,0,63]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const i=[];function R(y,w,m){w instanceof v.SyncDescriptor||(w=new v.SyncDescriptor(w,[],m)),i.push([y,w])}t.registerSingleton=R;function M(){return i}t.getSingletonServiceDescriptors=M}),define(me[30],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var v;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function w(m){return m[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=w})(v=t._util||(t._util={})),t.IInstantiationService=R("instantiationService");function i(y,w,m){w[v.DI_TARGET]===w?w[v.DI_DEPENDENCIES].push({id:y,index:m}):(w[v.DI_DEPENDENCIES]=[{id:y,index:m}],w[v.DI_TARGET]=w)}function R(y){if(v.serviceIds.has(y))return v.serviceIds.get(y);const w=function(m,f,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(w,m,b)};return w.toString=()=>y,v.serviceIds.set(y,w),w}t.createDecorator=R;function M(y){return y}t.refineServiceDecorator=M}),define(me[134],pe([1,0,30]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,v.createDecorator)(t.ID);function i(M){return!!M.hostName&&!!M.errorMessage}t.isRemoteDiagnosticError=i;class R{async getPerformanceInfo(y,w){return{}}async getSystemInfo(y,w){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(y,w){return""}async getWorkspaceFileExtensions(y){return{extensions:[]}}async reportWorkspaceStats(y){}}t.NullDiagnosticsService=R}),define(me[135],pe([1,0,48,21,10,7,16,131,30]),function(Z,t,v,i,R,M,y,w,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPlatformLimits=t.Arch=t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,m.createDecorator)("fileService");function f(J){return J.create===!0}t.isFileOpenForWriteOptions=f;var b;(function(J){J[J.Unknown=0]="Unknown",J[J.File=1]="File",J[J.Directory=2]="Directory",J[J.SymbolicLink=64]="SymbolicLink"})(b=t.FileType||(t.FileType={}));var F;(function(J){J[J.Readonly=1]="Readonly"})(F=t.FilePermission||(t.FilePermission={}));var a;(function(J){J[J.FileReadWrite=2]="FileReadWrite",J[J.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",J[J.FileReadStream=16]="FileReadStream",J[J.FileFolderCopy=8]="FileFolderCopy",J[J.PathCaseSensitive=1024]="PathCaseSensitive",J[J.Readonly=2048]="Readonly",J[J.Trash=4096]="Trash",J[J.FileWriteUnlock=8192]="FileWriteUnlock",J[J.FileAtomicRead=16384]="FileAtomicRead",J[J.FileClone=32768]="FileClone"})(a=t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={}));function n(J){return!!(J.capabilities&2)}t.hasReadWriteCapability=n;function e(J){return!!(J.capabilities&8)}t.hasFileFolderCopyCapability=e;function d(J){return!!(J.capabilities&32768)}t.hasFileCloneCapability=d;function p(J){return!!(J.capabilities&4)}t.hasOpenReadWriteCloseCapability=p;function _(J){return!!(J.capabilities&16)}t.hasFileReadStreamCapability=_;function E(J){return n(J)?!!(J.capabilities&16384):!1}t.hasFileAtomicReadCapability=E;var u;(function(J){J.FileExists="EntryExists",J.FileNotFound="EntryNotFound",J.FileNotADirectory="EntryNotADirectory",J.FileIsADirectory="EntryIsADirectory",J.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",J.FileTooLarge="EntryTooLarge",J.FileWriteLocked="EntryWriteLocked",J.NoPermissions="NoPermissions",J.Unavailable="Unavailable",J.Unknown="Unknown"})(u=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class g extends Error{constructor(De,re){super(De);this.code=re}}t.FileSystemProviderError=g;function D(J,De){const re=new g(J.toString(),De);return N(re,De),re}t.createFileSystemProviderError=D;function A(J){return J||D((0,w.localize)(0,null),u.Unknown)}t.ensureFileSystemProviderError=A;function N(J,De){return J.name=De?`${De} (FileSystemError)`:"FileSystemError",J}t.markAsFileSystemProviderError=N;function T(J){if(!J)return u.Unknown;if(J instanceof g)return J.code;const De=/^(.+) \(FileSystemError\)$/.exec(J.name);if(!De)return u.Unknown;switch(De[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}t.toFileSystemProviderErrorCode=T;function s(J){if(J instanceof V)return J.fileOperationResult;switch(T(J)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}t.toFileOperationResult=s;var l;(function(J){J[J.CREATE=0]="CREATE",J[J.DELETE=1]="DELETE",J[J.MOVE=2]="MOVE",J[J.COPY=3]="COPY",J[J.WRITE=4]="WRITE"})(l=t.FileOperation||(t.FileOperation={}));class o{constructor(De,re,te){this.resource=De,this.operation=re,this.target=te}isOperation(De){return this.operation===De}}t.FileOperationEvent=o;var r;(function(J){J[J.UPDATED=0]="UPDATED",J[J.ADDED=1]="ADDED",J[J.DELETED=2]="DELETED"})(r=t.FileChangeType||(t.FileChangeType={}));class c{constructor(De,re){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=De;const te=new Map;for(const le of De){const Q=te.get(le.type);switch(Q?Q.push([le.resource,le]):te.set(le.type,[[le.resource,le]]),le.type){case 1:this.rawAdded.push(le.resource);break;case 0:this.rawUpdated.push(le.resource);break;case 2:this.rawDeleted.push(le.resource);break}}for(const[le,Q]of te)switch(le){case 1:this.added=v.TernarySearchTree.forUris(()=>re),this.added.fill(Q);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>re),this.updated.fill(Q);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>re),this.deleted.fill(Q);break}}contains(De,...re){return this.doContains(De,{includeChildren:!1},...re)}affects(De,...re){return this.doContains(De,{includeChildren:!0},...re)}doContains(De,re,...te){if(!De)return!1;const le=te.length>0;return!!((!le||te.includes(1))&&(this.added?.get(De)||re.includeChildren&&this.added?.findSuperstr(De))||(!le||te.includes(0))&&(this.updated?.get(De)||re.includeChildren&&this.updated?.findSuperstr(De))||(!le||te.includes(2))&&(this.deleted?.findSubstr(De)||re.includeChildren&&this.deleted?.findSuperstr(De)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}t.FileChangesEvent=c;function C(J,De,re){return!J||!De||J===De||De.length>J.length?!1:(De.charAt(De.length-1)!==i.sep&&(De+=i.sep),re?(0,R.startsWithIgnoreCase)(J,De):J.indexOf(De)===0)}t.isParent=C;class V extends Error{constructor(De,re,te){super(De);this.fileOperationResult=re,this.options=te}}t.FileOperationError=V;class se extends V{constructor(De,re,te){super(De,2,te);this.stat=re}}t.NotModifiedSinceFileOperationError=se;var ie;(function(J){J[J.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",J[J.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",J[J.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",J[J.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",J[J.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",J[J.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",J[J.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",J[J.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",J[J.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",J[J.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",J[J.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",J[J.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(ie=t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var ae;(function(J){J[J.FILE=0]="FILE",J[J.FOLDER=1]="FOLDER",J[J.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae=t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="";function ne(J){if(!(typeof J.size!="number"||typeof J.mtime!="number"))return J.mtime.toString(29)+J.size.toString(31)}t.etag=ne;async function we(J,De){if(!De.hasProvider(y.URI.from({scheme:J.scheme})))return new Promise(re=>{const te=De.onDidChangeFileSystemProviderRegistrations(le=>{le.scheme===J.scheme&&le.added&&(te.dispose(),re())})})}t.whenProviderRegistered=we,t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class de{static formatSize(De){return(0,M.isNumber)(De)||(De=0),De<de.KB?(0,w.localize)(1,null,De.toFixed(0)):De<de.MB?(0,w.localize)(2,null,(De/de.KB).toFixed(2)):De<de.GB?(0,w.localize)(3,null,(De/de.MB).toFixed(2)):De<de.TB?(0,w.localize)(4,null,(De/de.GB).toFixed(2)):(0,w.localize)(5,null,(De/de.TB).toFixed(2))}}t.ByteSize=de,de.KB=1024,de.MB=de.KB*de.KB,de.GB=de.MB*de.KB,de.TB=de.GB*de.KB;var ge;(function(J){J[J.IA32=0]="IA32",J[J.OTHER=1]="OTHER"})(ge=t.Arch||(t.Arch={}));function ye(J){return{maxFileSize:J===0?300*de.MB:16*de.GB,maxHeapSize:J===0?700*de.MB:2*700*de.MB}}t.getPlatformLimits=ye}),define(me[136],pe([1,0,2,130]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class R extends v.Disposable{constructor(y){super();this.mainProcessConnection=this._register(new i.Client(`window:${y}`))}getChannel(y){return this.mainProcessConnection.getChannel(y)}registerChannel(y,w){this.mainProcessConnection.registerChannel(y,w)}}t.ElectronIPCMainProcessService=R});var Ft=this&&this.__param||function(Z,t){return function(v,i){t(v,i,Z)}};define(me[137],pe([1,0,38,63,133,30]),function(Z,t,v,i,R,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.registerSharedProcessRemoteService=t.ISharedProcessService=t.registerMainProcessRemoteService=t.IMainProcessService=void 0;class y{constructor(n,e,d){const p=d.getChannel(n);return w(e)?new e.channelClientCtor(p):v.ProxyChannel.toService(p,e?.proxyOptions)}}function w(a){return!!a?.channelClientCtor}t.IMainProcessService=(0,M.createDecorator)("mainProcessService");let m=class extends y{constructor(n,e,d){super(n,e,d)}};m=Ke([Ft(2,t.IMainProcessService)],m);function f(a,n,e){(0,R.registerSingleton)(a,new i.SyncDescriptor(m,[n,e],e?.supportsDelayedInstantiation))}t.registerMainProcessRemoteService=f,t.ISharedProcessService=(0,M.createDecorator)("sharedProcessService");let b=class extends y{constructor(n,e,d){super(n,e,d)}};b=Ke([Ft(2,t.ISharedProcessService)],b);function F(a,n,e){(0,R.registerSingleton)(a,new i.SyncDescriptor(b,[n,e],e?.supportsDelayedInstantiation))}t.registerSharedProcessRemoteService=F}),define(me[138],pe([1,0,38,137]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let R=class{constructor(y,w){return this.windowId=y,v.ProxyChannel.toService(w.getChannel("nativeHost"),{context:y,properties:(()=>{const m=new Map;return m.set("windowId",y),m})()})}};R=Ke([Ft(1,i.IMainProcessService)],R),t.NativeHostService=R}),define(me[39],pe([1,0,68,7]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class R{constructor(){this.data=new Map}add(y,w){v.ok(i.isString(y)),v.ok(i.isObject(w)),v.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,w)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}t.Registry=new R}),define(me[139],pe([1,0,3,39]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function R(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class M{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(m,f){this.schemasById[R(m)]=f,this._onDidChangeSchema.fire(m)}notifySchemaChanged(m){this._onDidChangeSchema.fire(m)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new M;i.Registry.add(t.Extensions.JSONContribution,y)}),define(me[140],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isDark=t.isHighContrast=t.ColorScheme=void 0;var v;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(v=t.ColorScheme||(t.ColorScheme={}));function i(M){return M===v.HIGH_CONTRAST_DARK||M===v.HIGH_CONTRAST_LIGHT}t.isHighContrast=i;function R(M){return M===v.DARK||M===v.HIGH_CONTRAST_DARK}t.isDark=R}),define(me[64],pe([1,0,11,3,2,30,39,140]),function(Z,t,v,i,R,M,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Themable=t.registerThemingParticipant=t.Extensions=t.getThemeTypeSelector=t.FolderThemeIcon=t.FileThemeIcon=t.ThemeIcon=t.themeColorFromId=t.ThemeColor=t.IThemeService=void 0,t.IThemeService=(0,M.createDecorator)("themeService");var m;(function(p){function _(E){return E&&typeof E=="object"&&typeof E.id=="string"}p.isThemeColor=_})(m=t.ThemeColor||(t.ThemeColor={}));function f(p){return{id:p}}t.themeColorFromId=f;var b;(function(p){function _(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||m.isThemeColor(s.color))}p.isThemeIcon=_;const E=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function u(s){const l=E.exec(s);if(!l)return;const[,o]=l;return{id:o}}p.fromString=u;function g(s){return{id:s}}p.fromId=g;function D(s,l){let o=s.id;const r=o.lastIndexOf("~");return r!==-1&&(o=o.substring(0,r)),l&&(o=`${o}~${l}`),{id:o}}p.modify=D;function A(s){const l=s.id.lastIndexOf("~");if(l!==-1)return s.id.substring(l+1)}p.getModifier=A;function N(s,l){return s.id===l.id&&s.color?.id===l.color?.id}p.isEqual=N;function T(s,l){return{id:s.id,color:l?f(l):void 0}}p.asThemeIcon=T,p.asClassNameArray=v.CSSIcon.asClassNameArray,p.asClassName=v.CSSIcon.asClassName,p.asCSSSelector=v.CSSIcon.asCSSSelector})(b=t.ThemeIcon||(t.ThemeIcon={})),t.FileThemeIcon=v.Codicon.file,t.FolderThemeIcon=v.Codicon.folder;function F(p){switch(p){case w.ColorScheme.DARK:return"vs-dark";case w.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case w.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}t.getThemeTypeSelector=F,t.Extensions={ThemingContribution:"base.contributions.theming"};class a{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(_){return this.themingParticipants.push(_),this.onThemingParticipantAddedEmitter.fire(_),(0,R.toDisposable)(()=>{const E=this.themingParticipants.indexOf(_);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const n=new a;y.Registry.add(t.Extensions.ThemingContribution,n);function e(p){return n.onColorThemeChange(p)}t.registerThemingParticipant=e;class d extends R.Disposable{constructor(_){super();this.themeService=_,this.theme=_.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(_){this.theme=_,this.updateStyles()}updateStyles(){}getColor(_,E){let u=this.theme.getColor(_);return u&&E&&(u=E(u,this.theme)),u?u.toString():null}}t.Themable=d}),define(me[141],pe([1,0,6,11,3,7,16,132,139,39,64]),function(Z,t,v,i,R,M,y,w,m,f,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var F;(function(g){function D(A,N){let T=A.defaults;for(;b.ThemeIcon.isThemeIcon(T);){const s=e.getIcon(T.id);if(!s)return;T=s.defaults}return T}g.getDefinition=D})(F=t.IconContribution||(t.IconContribution={}));var a;(function(g){function D(N){return{weight:N.weight,style:N.style,src:N.src.map(T=>({format:T.format,location:T.location.toString()}))}}g.toJSONObject=D;function A(N){const T=s=>(0,M.isString)(s)?s:void 0;if(N&&Array.isArray(N.src)&&N.src.every(s=>(0,M.isString)(s.format)&&(0,M.isString)(s.location)))return{weight:T(N.weight),style:T(N.style),src:N.src.map(s=>({format:s.format,location:y.URI.parse(s.location)}))}}g.fromJSONObject=A})(a=t.IconFontDefinition||(t.IconFontDefinition={}));class n{constructor(){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,w.localize)(0,null)},fontCharacter:{type:"string",description:(0,w.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${i.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(D,A,N,T){const s=this.iconsById[D];if(s){if(N&&!s.description){s.description=N,this.iconSchema.properties[D].markdownDescription=`${N} $(${D})`;const r=this.iconReferenceSchema.enum.indexOf(D);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=N),this._onDidChange.fire()}return s}const l={id:D,description:N,defaults:A,deprecationMessage:T};this.iconsById[D]=l;const o={$ref:"#/definitions/icons"};return T&&(o.deprecationMessage=T),N&&(o.markdownDescription=`${N}: $(${D})`),this.iconSchema.properties[D]=o,this.iconReferenceSchema.enum.push(D),this.iconReferenceSchema.enumDescriptions.push(N||""),this._onDidChange.fire(),{id:D}}deregisterIcon(D){delete this.iconsById[D],delete this.iconSchema.properties[D];const A=this.iconReferenceSchema.enum.indexOf(D);A!==-1&&(this.iconReferenceSchema.enum.splice(A,1),this.iconReferenceSchema.enumDescriptions.splice(A,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(D=>this.iconsById[D])}getIcon(D){return this.iconsById[D]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(D,A){const N=this.iconFontsById[D];return N||(this.iconFontsById[D]=A,this._onDidChange.fire(),A)}deregisterIconFont(D){delete this.iconFontsById[D]}getIconFont(D){return this.iconFontsById[D]}toString(){const D=(s,l)=>s.id.localeCompare(l.id),A=s=>{for(;b.ThemeIcon.isThemeIcon(s.defaults);)s=this.iconsById[s.defaults.id];return`codicon codicon-${s?s.id:""}`},N=[];N.push("| preview     | identifier                        | default codicon ID                | description"),N.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const T=Object.keys(this.iconsById).map(s=>this.iconsById[s]);for(const s of T.filter(l=>!!l.description).sort(D))N.push(`|<i class="${A(s)}"></i>|${s.id}|${b.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);N.push("| preview     | identifier                        "),N.push("| ----------- | --------------------------------- |");for(const s of T.filter(l=>!b.ThemeIcon.isThemeIcon(l.defaults)).sort(D))N.push(`|<i class="${A(s)}"></i>|${s.id}|`);return N.join(`
`)}}const e=new n;f.Registry.add(t.Extensions.IconContribution,e);function d(g,D,A,N){return e.registerIcon(g,D,A,N)}t.registerIcon=d;function p(){return e}t.getIconRegistry=p;function _(){for(const g of i.Codicon.getAll())e.registerIcon(g.id,g.definition,g.description)}_(),t.iconsSchemaId="vscode://schemas/icons";const E=f.Registry.as(m.Extensions.JSONContribution);E.registerSchema(t.iconsSchemaId,e.getIconSchema());const u=new v.RunOnceScheduler(()=>E.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{u.isScheduled()||u.schedule()}),t.widgetClose=d("widget-close",i.Codicon.close,(0,w.localize)(2,null)),t.gotoPreviousLocation=d("goto-previous-location",i.Codicon.arrowUp,(0,w.localize)(3,null)),t.gotoNextLocation=d("goto-next-location",i.Codicon.arrowDown,(0,w.localize)(4,null)),t.syncing=b.ThemeIcon.modify(i.Codicon.sync,"spin"),t.spinningLoading=b.ThemeIcon.modify(i.Codicon.loading,"spin")}),define(me[142],pe([1,0,4,3,141,64]),function(Z,t,v,i,R,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function y(m){const f=new i.Emitter,b=(0,R.getIconRegistry)();return b.onDidChange(()=>f.fire()),m?.onDidProductIconThemeChange(()=>f.fire()),{onDidChange:f.event,getCSS(){const F=m?m.getProductIconTheme():new w,a={},n=d=>{const p=F.getIcon(d);if(!p)return;const _=p.font;return _?(a[_.id]=_.definition,`.codicon-${d.id}:before { content: '${p.fontCharacter}'; font-family: ${(0,v.asCSSPropertyValue)(_.id)}; }`):`.codicon-${d.id}:before { content: '${p.fontCharacter}'; }`},e=[];for(const d of b.getIcons()){const p=n(d);p&&e.push(p)}for(const d in a){const p=a[d],_=p.weight?`font-weight: ${p.weight};`:"",E=p.style?`font-style: ${p.style};`:"",u=p.src.map(g=>`${(0,v.asCSSUrl)(g.location)} format('${g.format}')`).join(", ");e.push(`@font-face { src: ${u}; font-family: ${(0,v.asCSSPropertyValue)(d)};${_}${E} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=y;class w{getIcon(f){const b=(0,R.getIconRegistry)();let F=f.defaults;for(;M.ThemeIcon.isThemeIcon(F);){const a=b.getIcon(F.id);if(!a)return;F=a.defaults}return F}}t.UnthemedProductIconTheme=w}),define(me[143],pe([1,0,5]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function i(b){return!!b.workspaceUri}t.isWorkspaceToOpen=i;function R(b){return!!b.folderUri}t.isFolderToOpen=R;function M(b){return!!b.fileUri}t.isFileToOpen=M;function y(b){const F=w(b),a=b.getValue("window.menuBarVisibility");return a==="default"||F==="native"&&a==="compact"||v.isMacintosh&&v.isNative?"classic":a}t.getMenuBarVisibility=y;function w(b){if(v.isWeb)return"custom";const F=b.getValue("window");if(F){if(v.isMacintosh&&F.nativeTabs===!0||v.isMacintosh&&F.nativeFullScreen===!1)return"native";const e=b.getValue("workbench.colorCustomizations");if(e?.["window.activeBorder"]||e?.["window.inactiveBorder"])return"custom";const d=F.titleBarStyle;if(d==="native"||d==="custom")return d}return v.isLinux?"native":"custom"}t.getTitleBarStyle=w;function m(b,F){return!v.isWindows||v.isWeb||!F.isBuilt||w(b)==="native"?!1:b.getValue("window.experimental.windowControlsOverlay.enabled")}t.useWindowControlsOverlay=m;function f(b=0){return Math.pow(1.2,b)}t.zoomLevelToZoomFactor=f}),define(me[144],pe([1,0,15,29,143]),function(Z,t,v,i,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function M(m){i.webFrame.setZoomLevel(m),(0,v.setZoomFactor)((0,R.zoomLevelToZoomFactor)(m)),(0,v.setZoomLevel)(m,!1)}t.applyZoom=M;function y(){M((0,v.getZoomLevel)()+1)}t.zoomIn=y;function w(){M((0,v.getZoomLevel)()-1)}t.zoomOut=w}),define(me[145],pe([1,0,9,4,128,6,129,29,134,135,136,138,142,144,94,85]),function(Z,t,v,i,R,M,y,w,m,f,b,F,a,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const e=/\s--(inspect|debug)(-brk|port)?=(\d+)?/,d=/\s--(inspect|debug)-port=(\d+)/;class p{getHeight(c){return 22}getTemplateId(c){return T(c)?"process":A(c)?"machine":(0,m.isRemoteDiagnosticError)(c)?"error":N(c)?"header":""}}class _{hasChildren(c){return(0,m.isRemoteDiagnosticError)(c)?!1:T(c)?!!c.children?.length:!0}getChildren(c){return T(c)?c.children?c.children:[]:(0,m.isRemoteDiagnosticError)(c)?[]:N(c)?c.processRoots.length>1?c.processRoots:[c.processRoots[0].rootProcess]:A(c)?[c.rootProcess]:[c.processes]}}class E{constructor(){this.templateId="header"}renderTemplate(c){const C=Object.create(null),V=(0,i.append)(c,(0,i.$)(".row"));return C.name=(0,i.append)(V,(0,i.$)(".nameLabel")),C.CPU=(0,i.append)(V,(0,i.$)(".cpu")),C.memory=(0,i.append)(V,(0,i.$)(".memory")),C.PID=(0,i.append)(V,(0,i.$)(".pid")),C}renderElement(c,C,V,se){V.name.textContent=(0,v.localize)(0,null),V.CPU.textContent=(0,v.localize)(1,null),V.PID.textContent=(0,v.localize)(2,null),V.memory.textContent=(0,v.localize)(3,null)}disposeTemplate(c){}}class u{constructor(){this.templateId="machine"}renderTemplate(c){const C=Object.create(null),V=(0,i.append)(c,(0,i.$)(".row"));return C.name=(0,i.append)(V,(0,i.$)(".nameLabel")),C}renderElement(c,C,V,se){V.name.textContent=c.element.name}disposeTemplate(c){}}class g{constructor(){this.templateId="error"}renderTemplate(c){const C=Object.create(null),V=(0,i.append)(c,(0,i.$)(".row"));return C.name=(0,i.append)(V,(0,i.$)(".nameLabel")),C}renderElement(c,C,V,se){V.name.textContent=c.element.errorMessage}disposeTemplate(c){}}class D{constructor(c,C,V){this.platform=c,this.totalMem=C,this.mapPidToWindowTitle=V,this.templateId="process"}renderTemplate(c){const C=Object.create(null),V=(0,i.append)(c,(0,i.$)(".row"));return C.name=(0,i.append)(V,(0,i.$)(".nameLabel")),C.CPU=(0,i.append)(V,(0,i.$)(".cpu")),C.memory=(0,i.append)(V,(0,i.$)(".memory")),C.PID=(0,i.append)(V,(0,i.$)(".pid")),C}renderElement(c,C,V,se){const{element:ie}=c;let ae=ie.name;ae==="window"&&(ae=this.mapPidToWindowTitle.get(ie.pid)!==void 0?`${ae} (${this.mapPidToWindowTitle.get(ie.pid)})`:ae);const ne=ie.pid.toFixed(0);V.name.textContent=ae,V.name.title=ie.cmd,V.CPU.textContent=ie.load.toFixed(0),V.PID.textContent=ne,V.PID.parentElement.id=`pid-${ne}`;const we=this.platform==="win32"?ie.mem:this.totalMem*(ie.mem/100);V.memory.textContent=(we/f.ByteSize.MB).toFixed(0)}disposeTemplate(c){}}function A(r){return!!r.name&&!!r.rootProcess}function N(r){return!!r.processRoots}function T(r){return!!r.pid}class s{constructor(c,C){this.data=C,this.mapPidToWindowTitle=new Map;const V=new b.ElectronIPCMainProcessService(c);this.nativeHostService=new F.NativeHostService(c,V),this.applyStyles(C.styles),this.setEventHandlers(C),w.ipcRenderer.on("vscode:windowsInfoResponse",(se,ie)=>{this.mapPidToWindowTitle=new Map,ie.forEach(ae=>this.mapPidToWindowTitle.set(ae.pid,ae.title))}),w.ipcRenderer.on("vscode:listProcessesResponse",async(se,ie)=>{ie.forEach((ae,ne)=>{T(ae.rootProcess)&&(ae.rootProcess.name=ne===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?this.tree.setInput({processes:{processRoots:ie}}):await this.createProcessTree(ie),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(c){document.onkeydown=C=>{const V=c.platform==="darwin"?C.metaKey:C.ctrlKey;V&&C.keyCode===87&&(C.stopPropagation(),C.preventDefault(),w.ipcRenderer.send("vscode:closeProcessExplorer")),V&&C.keyCode===187&&(0,n.zoomIn)(),V&&C.keyCode===189&&(0,n.zoomOut)()}}async createProcessTree(c){const C=document.getElementById("process-list");if(!C)return;const{totalmem:V}=await this.nativeHostService.getOSStatistics(),se=[new D(this.data.platform,V,this.mapPidToWindowTitle),new E,new u,new g];this.tree=new R.DataTree("processExplorer",C,new p,se,new _,{identityProvider:{getId:ie=>T(ie)?ie.pid.toString():(0,m.isRemoteDiagnosticError)(ie)?ie.hostName:N(ie)?"processes":A(ie)?ie.name:"header"}}),this.tree.setInput({processes:{processRoots:c}}),this.tree.layout(window.innerHeight,window.innerWidth),this.tree.onContextMenu(ie=>{T(ie.element)&&this.showContextMenu(ie.element,!0)})}isDebuggable(c){const C=e.exec(c);return C&&C.length>=2||c.indexOf("node ")>=0||c.indexOf("node.exe")>=0}attachTo(c){const C={type:"node",request:"attach",name:`process ${c.pid}`};let V=e.exec(c.cmd);V&&V.length>=2?(V.length===4&&V[3]&&(C.port=parseInt(V[3])),C.protocol=V[1]==="debug"?"legacy":"inspector"):C.processId=String(c.pid),V=d.exec(c.cmd),V&&V.length===3&&(C.port=parseInt(V[2])),w.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[C]})}applyStyles(c){const C=(0,i.createStyleSheet)(),V=[];c.listFocusBackground&&(V.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${c.listFocusBackground}; }`),V.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${c.listFocusBackground}; }`)),c.listFocusForeground&&V.push(`.monaco-list:focus .monaco-list-row.focused { color: ${c.listFocusForeground}; }`),c.listActiveSelectionBackground&&(V.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${c.listActiveSelectionBackground}; }`),V.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${c.listActiveSelectionBackground}; }`)),c.listActiveSelectionForeground&&V.push(`.monaco-list:focus .monaco-list-row.selected { color: ${c.listActiveSelectionForeground}; }`),c.listHoverBackground&&V.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${c.listHoverBackground}; }`),c.listHoverForeground&&V.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${c.listHoverForeground}; }`),c.listFocusOutline&&V.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${c.listFocusOutline}; outline-offset: -1px; }`),c.listHoverOutline&&V.push(`.monaco-list-row:hover { outline: 1px dashed ${c.listHoverOutline}; outline-offset: -1px; }`),C.textContent=V.join(`
`),c.color&&(document.body.style.color=c.color)}showContextMenu(c,C){const V=[],se=Number(c.pid);C&&(V.push({label:(0,v.localize)(4,null),click:()=>{this.nativeHostService.killProcess(se,"SIGTERM")}}),V.push({label:(0,v.localize)(5,null),click:()=>{this.nativeHostService.killProcess(se,"SIGKILL")}}),V.push({type:"separator"})),V.push({label:(0,v.localize)(6,null),click:()=>{const ie=this.tree?.getSelection()?.map(ne=>{if(!(!ne||!("pid"in ne)))return ne.pid}).filter(ne=>!!ne);ie?.includes(se)||(ie.length=0,ie.push(se));const ae=ie?.map(ne=>document.getElementById(`pid-${ne}`)).filter(ne=>!!ne);if(ae){const ne=ae.map(we=>we.innerText).filter(we=>!!we);this.nativeHostService.writeClipboardText(ne.join(`
`))}}}),V.push({label:(0,v.localize)(7,null),click:()=>{const ie=document.getElementById("process-list");ie&&this.nativeHostService.writeClipboardText(ie.innerText)}}),c&&C&&this.isDebuggable(c.cmd)&&(V.push({type:"separator"}),V.push({label:(0,v.localize)(8,null),click:()=>{this.attachTo(c)}})),(0,y.popup)(V)}requestProcessList(c){setTimeout(()=>{const C=Date.now(),V=c+C-this.lastRequestTime;this.lastRequestTime=C,V>1e3?(w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList(V)},200)}}function l(){const r=(0,i.createStyleSheet)();r.id="codiconStyles";const c=(0,a.getIconsStyleSheet)(void 0);function C(){r.textContent=c.getCSS()}const V=new M.RunOnceScheduler(C,0);c.onDidChange(()=>V.schedule()),V.schedule()}function o(r){const c=r.data.platform==="win32"?"windows":r.data.platform==="linux"?"linux":"mac";document.body.classList.add(c),l(),(0,n.applyZoom)(r.data.zoomLevel),new s(r.windowId,r.data)}t.startup=o})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/92fd228156aafeb326b23f6604028d342152313b/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
