/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/types","vs/base/common/network","vs/base/common/errors","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/uuid","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/base/common/severity","child_process","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/editor/common/core/position","vs/base/common/errorMessage","vs/base/common/stopwatch","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/assert","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","vs/editor/common/languages","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","os","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","string_decoder","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/mime","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/node/decoder","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],ke=function(Y){for(var e=[],u=0,t=Y.length;u<t;u++)e[u]=Ie[Y[u]];return e};define(Ie[56],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function u(t,D){if(!t)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=u}),define(Ie[76],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function u(y){return y?y.replace(/\$\((.*?)\)/g,(C,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=u;class t{constructor(C,E,I){this.id=C,this.definition=E,this.description=I,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function D(y,C){const E=["codicon","codicon-"+y];return C&&E.push("codicon-modifier-"+C),E}e.getClassNamesArray=D;var P;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const C=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function E(k){if(k instanceof t)return["codicon","codicon-"+k.id];const _=C.exec(k.id);if(!_)return E(t.error);const[,T,w]=_,b=["codicon","codicon-"+T];return w&&b.push("codicon-modifier-"+w.substr(1)),b}y.asClassNameArray=E;function I(k){return E(k).join(" ")}y.asClassName=I;function R(k){return"."+E(k).join(".")}y.asCSSSelector=R})(P=e.CSSIcon||(e.CSSIcon={}))}),define(Ie[77],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function u(y,C){const E=Object.create(null);for(const I of y){const R=C(I);let k=E[R];k||(k=E[R]=[]),k.push(I)}return E}e.groupBy=u;function t(y,C){const E=[],I=[];for(const R of y)C.has(R)||E.push(R);for(const R of C)y.has(R)||I.push(R);return{removed:E,added:I}}e.diffSets=t;function D(y,C){const E=[],I=[];for(const[R,k]of y)C.has(R)||E.push(k);for(const[R,k]of C)y.has(R)||I.push(k);return{removed:E,added:I}}e.diffMaps=D;class P{constructor(){this.map=new Map}add(C,E){let I=this.map.get(C);I||(I=new Set,this.map.set(C,I)),I.add(E)}delete(C,E){const I=this.map.get(C);!I||(I.delete(E),I.size===0&&this.map.delete(C))}forEach(C,E){const I=this.map.get(C);!I||I.forEach(E)}}e.SetMap=P}),define(Ie[57],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function u(y){return(C,E,I)=>{let R=null,k=null;if(typeof I.value=="function"?(R="value",k=I.value):typeof I.get=="function"&&(R="get",k=I.get),!k)throw new Error("not supported");I[R]=y(k,E)}}e.createDecorator=u;function t(y,C,E){let I=null,R=null;if(typeof E.value=="function"?(I="value",R=E.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(I="get",R=E.get),!R)throw new Error("not supported");const k=`$memoize$${C}`;E[I]=function(..._){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,_)}),this[k]}}e.memoize=t;function D(y,C,E){return u((I,R)=>{const k=`$debounce$${R}`,_=`$debounce$result$${R}`;return function(...T){this[_]||(this[_]=E?E():void 0),clearTimeout(this[k]),C&&(this[_]=C(this[_],...T),T=[this[_]]),this[k]=setTimeout(()=>{I.apply(this,T),this[_]=E?E():void 0},y)}})}e.debounce=D;function P(y,C,E){return u((I,R)=>{const k=`$throttle$timer$${R}`,_=`$throttle$result$${R}`,T=`$throttle$lastRun$${R}`,w=`$throttle$pending$${R}`;return function(...b){if(this[_]||(this[_]=E?E():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),C&&(this[_]=C(this[_],...b)),this[w])return;const g=this[T]+y;g<=Date.now()?(this[T]=Date.now(),I.apply(this,[this[_]]),this[_]=E?E():void 0):(this[w]=!0,this[k]=setTimeout(()=>{this[w]=!1,this[T]=Date.now(),I.apply(this,[this[_]]),this[_]=E?E():void 0},g-Date.now()))}})}e.throttle=P}),define(Ie[12],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class u{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(a){setTimeout(()=>{throw a.stack?v.isErrorNoTelemetry(a)?new v(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.listeners.push(a),()=>{this._removeListener(a)}}emit(a){this.listeners.forEach(d=>{d(a)})}_removeListener(a){this.listeners.splice(this.listeners.indexOf(a),1)}setUnexpectedErrorHandler(a){this.unexpectedErrorHandler=a}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(a){this.unexpectedErrorHandler(a),this.emit(a)}onUnexpectedExternalError(a){this.unexpectedErrorHandler(a)}}e.ErrorHandler=u,e.errorHandler=new u;function t(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=t;function D(m){E(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=D;function P(m){E(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=P;function y(m){if(m instanceof Error){const{name:a,message:d}=m,r=m.stacktrace||m.stack;return{$isError:!0,name:a,message:d,stack:r,noTelemetry:v.isErrorNoTelemetry(m)}}return m}e.transformErrorForSerialization=y;const C="Canceled";function E(m){return m instanceof I?!0:m instanceof Error&&m.name===C&&m.message===C}e.isCancellationError=E;class I extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=I;function R(){const m=new Error(C);return m.name=m.message,m}e.canceled=R;function k(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=k;function _(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=_;function T(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=T;function w(m){const a=new Error(`${m} has been disposed`);return a.name="DISPOSED",a}e.disposed=w;function b(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=b;class g extends Error{constructor(a){super("NotImplemented");a&&(this.message=a)}}e.NotImplementedError=g;class f extends Error{constructor(a){super("NotSupported");a&&(this.message=a)}}e.NotSupportedError=f;class p extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=p;class v extends Error{constructor(a){super(a);this.name="ErrorNoTelemetry"}static fromError(a){if(a instanceof v)return a;const d=new v;return d.message=a.message,d.stack=a.stack,d}static isErrorNoTelemetry(a){return a.name==="ErrorNoTelemetry"}}e.ErrorNoTelemetry=v;class c extends Error{constructor(a){super(a||"An unexpected bug occurred.");Object.setPrototypeOf(this,c.prototype);debugger}}e.BugIndicatingError=c}),define(Ie[16],ke([1,0,12]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(ve,ue=0){return ve[ve.length-(1+ue)]}e.tail=t;function D(ve){if(ve.length===0)throw new Error("Invalid tail call");return[ve.slice(0,ve.length-1),ve[ve.length-1]]}e.tail2=D;function P(ve,ue,de=(we,ie)=>we===ie){if(ve===ue)return!0;if(!ve||!ue||ve.length!==ue.length)return!1;for(let we=0,ie=ve.length;we<ie;we++)if(!de(ve[we],ue[we]))return!1;return!0}e.equals=P;function y(ve,ue){const de=ve.length-1;ue<de&&(ve[ue]=ve[de]),ve.pop()}e.removeFastWithoutKeepingOrder=y;function C(ve,ue,de){return E(ve.length,we=>de(ve[we],ue))}e.binarySearch=C;function E(ve,ue){let de=0,we=ve-1;for(;de<=we;){const ie=(de+we)/2|0,me=ue(ie);if(me<0)de=ie+1;else if(me>0)we=ie-1;else return ie}return-(de+1)}e.binarySearch2=E;function I(ve,ue){let de=0,we=ve.length;if(we===0)return 0;for(;de<we;){const ie=Math.floor((de+we)/2);ue(ve[ie])?we=ie:de=ie+1}return de}e.findFirstInSorted=I;function R(ve,ue,de){if(ve=ve|0,ve>=ue.length)throw new TypeError("invalid index");const we=ue[Math.floor(ue.length*Math.random())],ie=[],me=[],J=[];for(const re of ue){const O=de(re,we);O<0?ie.push(re):O>0?me.push(re):J.push(re)}return ve<ie.length?R(ve,ie,de):ve<ie.length+J.length?J[0]:R(ve-(ie.length+J.length),me,de)}e.quickSelect=R;function k(ve,ue){const de=[];let we;for(const ie of ve.slice(0).sort(ue))!we||ue(we[0],ie)!==0?(we=[ie],de.push(we)):we.push(ie);return de}e.groupBy=k;function _(ve,ue,de){const we=[];function ie(re,O,H){if(O===0&&H.length===0)return;const G=we[we.length-1];G&&G.start+G.deleteCount===re?(G.deleteCount+=O,G.toInsert.push(...H)):we.push({start:re,deleteCount:O,toInsert:H})}let me=0,J=0;for(;;){if(me===ve.length){ie(me,0,ue.slice(J));break}if(J===ue.length){ie(me,ve.length-me,[]);break}const re=ve[me],O=ue[J],H=de(re,O);H===0?(me+=1,J+=1):H<0?(ie(me,1,[]),me+=1):H>0&&(ie(me,0,[O]),J+=1)}return we}e.sortedDiff=_;function T(ve,ue,de){const we=_(ve,ue,de),ie=[],me=[];for(const J of we)ie.push(...ve.slice(J.start,J.start+J.deleteCount)),me.push(...J.toInsert);return{removed:ie,added:me}}e.delta=T;function w(ve,ue,de){if(de===0)return[];const we=ve.slice(0,de).sort(ue);return g(ve,ue,we,de,ve.length),we}e.top=w;function b(ve,ue,de,we,ie){return de===0?Promise.resolve([]):new Promise((me,J)=>{(async()=>{const re=ve.length,O=ve.slice(0,de).sort(ue);for(let H=de,G=Math.min(de+we,re);H<re;H=G,G=Math.min(G+we,re)){if(H>de&&await new Promise(X=>setTimeout(X)),ie&&ie.isCancellationRequested)throw new u.CancellationError;g(ve,ue,O,H,G)}return O})().then(me,J)})}e.topAsync=b;function g(ve,ue,de,we,ie){for(const me=de.length;we<ie;we++){const J=ve[we];if(ue(J,de[me-1])<0){de.pop();const re=I(de,O=>ue(J,O)<0);de.splice(re,0,J)}}}function f(ve){return ve.filter(ue=>!!ue)}e.coalesce=f;function p(ve){let ue=0;for(let de=0;de<ve.length;de++)ve[de]&&(ve[ue]=ve[de],ue+=1);ve.length=ue}e.coalesceInPlace=p;function v(ve,ue,de){ve.splice(de,0,ve.splice(ue,1)[0])}e.move=v;function c(ve){return!Array.isArray(ve)||ve.length===0}e.isFalsyOrEmpty=c;function m(ve){return Array.isArray(ve)&&ve.length>0}e.isNonEmptyArray=m;function a(ve,ue=de=>de){const de=new Set;return ve.filter(we=>{const ie=ue(we);return de.has(ie)?!1:(de.add(ie),!0)})}e.distinct=a;function d(ve){const ue=new Set;return de=>{const we=ve(de);return ue.has(we)?!1:(ue.add(we),!0)}}e.uniqueFilter=d;function r(ve,ue){const de=o(ve,ue);if(de!==-1)return ve[de]}e.findLast=r;function o(ve,ue){for(let de=ve.length-1;de>=0;de--){const we=ve[de];if(ue(we))return de}return-1}e.lastIndex=o;function i(ve,ue){return ve.length>0?ve[0]:ue}e.firstOrDefault=i;function n(ve,ue){return ve.length>0?ve[ve.length-1]:ue}e.lastOrDefault=n;function s(ve,ue,de=(we,ie)=>we===ie){let we=0;for(let ie=0,me=Math.min(ve.length,ue.length);ie<me&&de(ve[ie],ue[ie]);ie++)we++;return we}e.commonPrefixLength=s;function l(ve){return[].concat(...ve)}e.flatten=l;function h(ve,ue){let de=typeof ue=="number"?ve:0;typeof ue=="number"?de=ve:(de=0,ue=ve);const we=[];if(de<=ue)for(let ie=de;ie<ue;ie++)we.push(ie);else for(let ie=de;ie>ue;ie--)we.push(ie);return we}e.range=h;function S(ve,ue,de){return ve.reduce((we,ie)=>(we[ue(ie)]=de?de(ie):ie,we),Object.create(null))}e.index=S;function L(ve,ue){return ve.push(ue),()=>M(ve,ue)}e.insert=L;function M(ve,ue){const de=ve.indexOf(ue);if(de>-1)return ve.splice(de,1),ue}e.remove=M;function F(ve,ue,de){const we=ve.slice(0,ue),ie=ve.slice(ue);return we.concat(de,ie)}e.arrayInsert=F;function A(ve,ue){let de;if(typeof ue=="number"){let we=ue;de=()=>{const ie=Math.sin(we++)*179426549;return ie-Math.floor(ie)}}else de=Math.random;for(let we=ve.length-1;we>0;we-=1){const ie=Math.floor(de()*(we+1)),me=ve[we];ve[we]=ve[ie],ve[ie]=me}}e.shuffle=A;function B(ve,ue){const de=ve.indexOf(ue);de>-1&&(ve.splice(de,1),ve.unshift(ue))}e.pushToStart=B;function $(ve,ue){const de=ve.indexOf(ue);de>-1&&(ve.splice(de,1),ve.push(ue))}e.pushToEnd=$;function U(ve,ue){for(const de of ue)ve.push(de)}e.pushMany=U;function K(ve,ue){return Array.isArray(ve)?ve.map(ue):ue(ve)}e.mapArrayOrNot=K;function W(ve){return Array.isArray(ve)?ve:[ve]}e.asArray=W;function N(ve){return ve[Math.floor(Math.random()*ve.length)]}e.getRandomElement=N;function V(ve,ue){for(const de of ve){const we=ue(de);if(we!==void 0)return we}}e.mapFind=V;function x(ve,ue,de){const we=te(ve,ue),ie=ve.length,me=de.length;ve.length=ie+me;for(let J=ie-1;J>=we;J--)ve[J+me]=ve[J];for(let J=0;J<me;J++)ve[J+we]=de[J]}e.insertInto=x;function q(ve,ue,de,we){const ie=te(ve,ue),me=ve.splice(ie,de);return x(ve,ie,we),me}e.splice=q;function te(ve,ue){return ue<0?Math.max(ue+ve.length,0):Math.min(ue,ve.length)}var Q;(function(ve){function ue(ie){return ie<0}ve.isLessThan=ue;function de(ie){return ie>0}ve.isGreaterThan=de;function we(ie){return ie===0}ve.isNeitherLessOrGreaterThan=we,ve.greaterThan=1,ve.lessThan=-1,ve.neitherLessOrGreaterThan=0})(Q=e.CompareResult||(e.CompareResult={}));function le(ve,ue){return(de,we)=>ue(ve(de),ve(we))}e.compareBy=le;function pe(...ve){return(ue,de)=>{for(const we of ve){const ie=we(ue,de);if(!Q.isNeitherLessOrGreaterThan(ie))return ie}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=pe;const Z=(ve,ue)=>ve-ue;e.numberComparator=Z;function ge(ve,ue){if(ve.length===0)return;let de=ve[0];for(let we=1;we<ve.length;we++){const ie=ve[we];ue(ie,de)>0&&(de=ie)}return de}e.findMaxBy=ge;function Ee(ve,ue){if(ve.length===0)return;let de=ve[0];for(let we=1;we<ve.length;we++){const ie=ve[we];ue(ie,de)>=0&&(de=ie)}return de}e.findLastMaxBy=Ee;function Te(ve,ue){return ge(ve,(de,we)=>-ue(de,we))}e.findMinBy=Te;class Oe{constructor(ue){this.items=ue,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ue){let de=this.firstIdx;for(;de<this.items.length&&ue(this.items[de]);)de++;const we=de===this.firstIdx?null:this.items.slice(this.firstIdx,de);return this.firstIdx=de,we}takeFromEndWhile(ue){let de=this.lastIdx;for(;de>=0&&ue(this.items[de]);)de--;const we=de===this.lastIdx?null:this.items.slice(de+1,this.lastIdx+1);return this.lastIdx=de,we}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ue=this.items[this.firstIdx];return this.firstIdx++,ue}removeLast(){const ue=this.items[this.lastIdx];return this.lastIdx--,ue}takeCount(ue){const de=this.items.slice(this.firstIdx,this.firstIdx+ue);return this.firstIdx+=ue,de}}e.ArrayQueue=Oe}),define(Ie[58],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function u(t){const D=this;let P=!1,y;return function(){return P||(P=!0,y=t.apply(D,arguments)),y}}e.once=u}),define(Ie[93],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class u{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=u,e.defaultGenerator=new u("id#")}),define(Ie[59],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var u;(function(t){function D(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}t.is=D;const P=Object.freeze([]);function y(){return P}t.empty=y;function*C(d){yield d}t.single=C;function E(d){return d||P}t.from=E;function I(d){return!d||d[Symbol.iterator]().next().done===!0}t.isEmpty=I;function R(d){return d[Symbol.iterator]().next().value}t.first=R;function k(d,r){for(const o of d)if(r(o))return!0;return!1}t.some=k;function _(d,r){for(const o of d)if(r(o))return o}t.find=_;function*T(d,r){for(const o of d)r(o)&&(yield o)}t.filter=T;function*w(d,r){let o=0;for(const i of d)yield r(i,o++)}t.map=w;function*b(...d){for(const r of d)for(const o of r)yield o}t.concat=b;function*g(d){for(const r of d)for(const o of r)yield o}t.concatNested=g;function f(d,r,o){let i=o;for(const n of d)i=r(i,n);return i}t.reduce=f;function p(d,r){let o=0;for(const i of d)r(i,o++)}t.forEach=p;function*v(d,r,o=d.length){for(r<0&&(r+=d.length),o<0?o+=d.length:o>d.length&&(o=d.length);r<o;r++)yield d[r]}t.slice=v;function c(d,r=Number.POSITIVE_INFINITY){const o=[];if(r===0)return[o,d];const i=d[Symbol.iterator]();for(let n=0;n<r;n++){const s=i.next();if(s.done)return[o,t.empty()];o.push(s.value)}return[o,{[Symbol.iterator](){return i}}]}t.consume=c;function m(d){return c(d)[0]}t.collect=m;function a(d,r,o=(i,n)=>i===n){const i=d[Symbol.iterator](),n=r[Symbol.iterator]();for(;;){const s=i.next(),l=n.next();if(s.done!==l.done)return!1;if(s.done)return!0;if(!o(s.value,l.value))return!1}}t.equals=a})(u=e.Iterable||(e.Iterable={}))}),define(Ie[142],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var u;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(u=e.ScanError||(e.ScanError={}));var t;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(a){a.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function y(a,d=!1){let r=0;const o=a.length;let i="",n=0,s=16,l=0;function h($){let U=0,K=0;for(;U<$;){const W=a.charCodeAt(r);if(W>=48&&W<=57)K=K*16+W-48;else if(W>=65&&W<=70)K=K*16+W-65+10;else if(W>=97&&W<=102)K=K*16+W-97+10;else break;r++,U++}return U<$&&(K=-1),K}function S($){r=$,i="",n=0,s=16,l=0}function L(){const $=r;if(a.charCodeAt(r)===48)r++;else for(r++;r<a.length&&I(a.charCodeAt(r));)r++;if(r<a.length&&a.charCodeAt(r)===46)if(r++,r<a.length&&I(a.charCodeAt(r)))for(r++;r<a.length&&I(a.charCodeAt(r));)r++;else return l=3,a.substring($,r);let U=r;if(r<a.length&&(a.charCodeAt(r)===69||a.charCodeAt(r)===101))if(r++,(r<a.length&&a.charCodeAt(r)===43||a.charCodeAt(r)===45)&&r++,r<a.length&&I(a.charCodeAt(r))){for(r++;r<a.length&&I(a.charCodeAt(r));)r++;U=r}else l=3;return a.substring($,U)}function M(){let $="",U=r;for(;;){if(r>=o){$+=a.substring(U,r),l=2;break}const K=a.charCodeAt(r);if(K===34){$+=a.substring(U,r),r++;break}if(K===92){if($+=a.substring(U,r),r++,r>=o){l=2;break}switch(a.charCodeAt(r++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const N=h(4);N>=0?$+=String.fromCharCode(N):l=4;break}default:l=5}U=r;continue}if(K>=0&&K<=31)if(E(K)){$+=a.substring(U,r),l=2;break}else l=6;r++}return $}function F(){if(i="",l=0,n=r,r>=o)return n=o,s=17;let $=a.charCodeAt(r);if(C($)){do r++,i+=String.fromCharCode($),$=a.charCodeAt(r);while(C($));return s=15}if(E($))return r++,i+=String.fromCharCode($),$===13&&a.charCodeAt(r)===10&&(r++,i+=`
`),s=14;switch($){case 123:return r++,s=1;case 125:return r++,s=2;case 91:return r++,s=3;case 93:return r++,s=4;case 58:return r++,s=6;case 44:return r++,s=5;case 34:return r++,i=M(),s=10;case 47:{const U=r-1;if(a.charCodeAt(r+1)===47){for(r+=2;r<o&&!E(a.charCodeAt(r));)r++;return i=a.substring(U,r),s=12}if(a.charCodeAt(r+1)===42){r+=2;const K=o-1;let W=!1;for(;r<K;){if(a.charCodeAt(r)===42&&a.charCodeAt(r+1)===47){r+=2,W=!0;break}r++}return W||(r++,l=1),i=a.substring(U,r),s=13}return i+=String.fromCharCode($),r++,s=16}case 45:if(i+=String.fromCharCode($),r++,r===o||!I(a.charCodeAt(r)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=L(),s=11;default:for(;r<o&&A($);)r++,$=a.charCodeAt(r);if(n!==r){switch(i=a.substring(n,r),i){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return i+=String.fromCharCode($),r++,s=16}}function A($){if(C($)||E($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function B(){let $;do $=F();while($>=12&&$<=15);return $}return{setPosition:S,getPosition:()=>r,scan:d?B:F,getToken:()=>s,getTokenValue:()=>i,getTokenOffset:()=>n,getTokenLength:()=>r-n,getTokenError:()=>l}}e.createScanner=y;function C(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function E(a){return a===10||a===13||a===8232||a===8233}function I(a){return a>=48&&a<=57}var R;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(R||(R={}));function k(a,d){const r=[],o=new Object;let i;const n={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function l(h,S,L,M){n.value=h,n.offset=S,n.length=L,n.type=M,n.colonOffset=void 0,i=n}try{v(a,{onObjectBegin:(h,S)=>{if(d<=h)throw o;i=void 0,s=d>h,r.push("")},onObjectProperty:(h,S,L)=>{if(d<S||(l(h,S,L,"property"),r[r.length-1]=h,d<=S+L))throw o},onObjectEnd:(h,S)=>{if(d<=h)throw o;i=void 0,r.pop()},onArrayBegin:(h,S)=>{if(d<=h)throw o;i=void 0,r.push(0)},onArrayEnd:(h,S)=>{if(d<=h)throw o;i=void 0,r.pop()},onLiteralValue:(h,S,L)=>{if(d<S||(l(h,S,L,m(h)),d<=S+L))throw o},onSeparator:(h,S,L)=>{if(d<=S)throw o;if(h===":"&&i&&i.type==="property")i.colonOffset=S,s=!1,i=void 0;else if(h===","){const M=r[r.length-1];typeof M=="number"?r[r.length-1]=M+1:(s=!0,r[r.length-1]=""),i=void 0}}})}catch(h){if(h!==o)throw h}return{path:r,previousNode:i,isAtPropertyKey:s,matches:h=>{let S=0;for(let L=0;S<h.length&&L<r.length;L++)if(h[S]===r[L]||h[S]==="*")S++;else if(h[S]!=="**")return!1;return S===h.length}}}e.getLocation=k;function _(a,d=[],r=P.DEFAULT){let o=null,i=[];const n=[];function s(h){Array.isArray(i)?i.push(h):o!==null&&(i[o]=h)}return v(a,{onObjectBegin:()=>{const h={};s(h),n.push(i),i=h,o=null},onObjectProperty:h=>{o=h},onObjectEnd:()=>{i=n.pop()},onArrayBegin:()=>{const h=[];s(h),n.push(i),i=h,o=null},onArrayEnd:()=>{i=n.pop()},onLiteralValue:s,onError:(h,S,L)=>{d.push({error:h,offset:S,length:L})}},r),i[0]}e.parse=_;function T(a,d=[],r=P.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(h){o.type==="property"&&(o.length=h-o.offset,o=o.parent)}function n(h){return o.children.push(h),h}v(a,{onObjectBegin:h=>{o=n({type:"object",offset:h,length:-1,parent:o,children:[]})},onObjectProperty:(h,S,L)=>{o=n({type:"property",offset:S,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:h,offset:S,length:L,parent:o})},onObjectEnd:(h,S)=>{o.length=h+S-o.offset,o=o.parent,i(h+S)},onArrayBegin:(h,S)=>{o=n({type:"array",offset:h,length:-1,parent:o,children:[]})},onArrayEnd:(h,S)=>{o.length=h+S-o.offset,o=o.parent,i(h+S)},onLiteralValue:(h,S,L)=>{n({type:m(h),offset:S,length:L,parent:o,value:h}),i(S+L)},onSeparator:(h,S,L)=>{o.type==="property"&&(h===":"?o.colonOffset=S:h===","&&i(S))},onError:(h,S,L)=>{d.push({error:h,offset:S,length:L})}},r);const l=o.children[0];return l&&delete l.parent,l}e.parseTree=T;function w(a,d){if(!a)return;let r=a;for(const o of d)if(typeof o=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let i=!1;for(const n of r.children)if(Array.isArray(n.children)&&n.children[0].value===o){r=n.children[1],i=!0;break}if(!i)return}else{const i=o;if(r.type!=="array"||i<0||!Array.isArray(r.children)||i>=r.children.length)return;r=r.children[i]}return r}e.findNodeAtLocation=w;function b(a){if(!a.parent||!a.parent.children)return[];const d=b(a.parent);if(a.parent.type==="property"){const r=a.parent.children[0].value;d.push(r)}else if(a.parent.type==="array"){const r=a.parent.children.indexOf(a);r!==-1&&d.push(r)}return d}e.getNodePath=b;function g(a){switch(a.type){case"array":return a.children.map(g);case"object":{const d=Object.create(null);for(const r of a.children){const o=r.children[1];o&&(d[r.children[0].value]=g(o))}return d}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=g;function f(a,d,r=!1){return d>=a.offset&&d<a.offset+a.length||r&&d===a.offset+a.length}e.contains=f;function p(a,d,r=!1){if(f(a,d,r)){const o=a.children;if(Array.isArray(o))for(let i=0;i<o.length&&o[i].offset<=d;i++){const n=p(o[i],d,r);if(n)return n}return a}}e.findNodeAtOffset=p;function v(a,d,r=P.DEFAULT){const o=y(a,!1);function i(le){return le?()=>le(o.getTokenOffset(),o.getTokenLength()):()=>!0}function n(le){return le?pe=>le(pe,o.getTokenOffset(),o.getTokenLength()):()=>!0}const s=i(d.onObjectBegin),l=n(d.onObjectProperty),h=i(d.onObjectEnd),S=i(d.onArrayBegin),L=i(d.onArrayEnd),M=n(d.onLiteralValue),F=n(d.onSeparator),A=i(d.onComment),B=n(d.onError),$=r&&r.disallowComments,U=r&&r.allowTrailingComma;function K(){for(;;){const le=o.scan();switch(o.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:$||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(le){case 12:case 13:$?W(10):A();break;case 16:W(1);break;case 15:case 14:break;default:return le}}}function W(le,pe=[],Z=[]){if(B(le),pe.length+Z.length>0){let ge=o.getToken();for(;ge!==17;){if(pe.indexOf(ge)!==-1){K();break}else if(Z.indexOf(ge)!==-1)break;ge=K()}}}function N(le){const pe=o.getTokenValue();return le?M(pe):l(pe),K(),!0}function V(){switch(o.getToken()){case 11:{let le=0;try{le=JSON.parse(o.getTokenValue()),typeof le!="number"&&(W(2),le=0)}catch{W(2)}M(le);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return K(),!0}function x(){return o.getToken()!==10?(W(3,[],[2,5]),!1):(N(!1),o.getToken()===6?(F(":"),K(),Q()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function q(){s(),K();let le=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(le||W(4,[],[]),F(","),K(),o.getToken()===2&&U)break}else le&&W(6,[],[]);x()||W(4,[],[2,5]),le=!0}return h(),o.getToken()!==2?W(7,[2],[]):K(),!0}function te(){S(),K();let le=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(le||W(4,[],[]),F(","),K(),o.getToken()===4&&U)break}else le&&W(6,[],[]);Q()||W(4,[],[4,5]),le=!0}return L(),o.getToken()!==4?W(8,[4],[]):K(),!0}function Q(){switch(o.getToken()){case 3:return te();case 1:return q();case 10:return N(!0);default:return V()}}return K(),o.getToken()===17?r.allowEmptyContent?!0:(W(4,[],[]),!1):Q()?(o.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=v;function c(a,d){const r=y(a),o=[];let i,n=0,s;do switch(s=r.getPosition(),i=r.scan(),i){case 12:case 13:case 17:n!==s&&o.push(a.substring(n,s)),d!==void 0&&o.push(r.getTokenValue().replace(/[^\r\n]/g,d)),n=r.getPosition();break}while(i!==17);return o.join("")}e.stripComments=c;function m(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(Ie[78],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class u{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new u(()=>D(this.getValue()))}}e.Lazy=u}),define(Ie[6],ke([1,0,58,59]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let P=null;function y(i){P=i}if(e.setDisposableTracker=y,D){const i="__is_disposable_tracked__";y(new class{trackDisposable(n){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[i]||console.log(s)},3e3)}setParent(n,s){if(n&&n!==p.None)try{n[i]=!0}catch{}}markAsDisposed(n){if(n&&n!==p.None)try{n[i]=!0}catch{}}markAsSingleton(n){}})}function C(i){return P?.trackDisposable(i),i}function E(i){P?.markAsDisposed(i)}function I(i,n){P?.setParent(i,n)}function R(i,n){if(!!P)for(const s of i)P.setParent(s,n)}function k(i){return P?.markAsSingleton(i),i}e.markAsSingleton=k;class _ extends Error{constructor(n){super(`Encountered errors while disposing of store. Errors: [${n.join(", ")}]`);this.errors=n}}e.MultiDisposeError=_;function T(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=T;function w(i){if(t.Iterable.is(i)){const n=[];for(const s of i)if(s)try{s.dispose()}catch(l){n.push(l)}if(n.length===1)throw n[0];if(n.length>1)throw new _(n);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=w;function b(...i){const n=g(()=>w(i));return R(i,n),n}e.combinedDisposable=b;function g(i){const n=C({dispose:(0,u.once)(()=>{E(n),i()})});return n}e.toDisposable=g;class f{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{w(this._toDispose.values())}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return I(n,this),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new f,C(this),I(this._store,this)}dispose(){E(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class v{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&I(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&I(n,null),n}}e.MutableDisposable=v;class c{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(n){let s=n;return this.unset=()=>s=void 0,this.isset=()=>s!==void 0,this.dispose=()=>{s&&(s(),s=void 0,E(this))},this}}e.SafeDisposable=m;class a{constructor(){this.references=new Map}acquire(n,...s){let l=this.references.get(n);l||(l={counter:0,object:this.createReferencedObject(n,...s)},this.references.set(n,l));const{object:h}=l,S=(0,u.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(n,l.object),this.references.delete(n))});return l.counter++,{object:h,dispose:S}}}e.ReferenceCollection=a;class d{constructor(n){this.referenceCollection=n}async acquire(n,...s){const l=this.referenceCollection.acquire(n,...s);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(h){throw l.dispose(),h}}}e.AsyncReferenceCollection=d;class r{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=r;function o(i){const n=new f;try{i(n)}finally{n.dispose()}}e.disposeOnReturn=o}),define(Ie[79],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class u{constructor(P){this.element=P,this.next=u.Undefined,this.prev=u.Undefined}}u.Undefined=new u(void 0);class t{constructor(){this._first=u.Undefined,this._last=u.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===u.Undefined}clear(){let P=this._first;for(;P!==u.Undefined;){const y=P.next;P.prev=u.Undefined,P.next=u.Undefined,P=y}this._first=u.Undefined,this._last=u.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,y){const C=new u(P);if(this._first===u.Undefined)this._first=C,this._last=C;else if(y){const I=this._last;this._last=C,C.prev=I,I.next=C}else{const I=this._first;this._first=C,C.next=I,I.prev=C}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(C))}}shift(){if(this._first!==u.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==u.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==u.Undefined&&P.next!==u.Undefined){const y=P.prev;y.next=P.next,P.next.prev=y}else P.prev===u.Undefined&&P.next===u.Undefined?(this._first=u.Undefined,this._last=u.Undefined):P.next===u.Undefined?(this._last=this._last.prev,this._last.next=u.Undefined):P.prev===u.Undefined&&(this._first=this._first.next,this._first.prev=u.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==u.Undefined;)yield P.element,P=P.next}}e.LinkedList=t}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(Ie[143],ke([0]),e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,e(Y.marked={}))}(this,function(Y){"use strict";function e(ue,de){for(var we=0;we<de.length;we++){var ie=de[we];ie.enumerable=ie.enumerable||!1,ie.configurable=!0,"value"in ie&&(ie.writable=!0),Object.defineProperty(ue,ie.key,ie)}}function u(ue,de,we){return de&&e(ue.prototype,de),we&&e(ue,we),Object.defineProperty(ue,"prototype",{writable:!1}),ue}function t(ue,de){if(!!ue){if(typeof ue=="string")return D(ue,de);var we=Object.prototype.toString.call(ue).slice(8,-1);if(we==="Object"&&ue.constructor&&(we=ue.constructor.name),we==="Map"||we==="Set")return Array.from(ue);if(we==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(we))return D(ue,de)}}function D(ue,de){(de==null||de>ue.length)&&(de=ue.length);for(var we=0,ie=new Array(de);we<de;we++)ie[we]=ue[we];return ie}function P(ue,de){var we=typeof Symbol!="undefined"&&ue[Symbol.iterator]||ue["@@iterator"];if(we)return(we=we.call(ue)).next.bind(we);if(Array.isArray(ue)||(we=t(ue))||de&&ue&&typeof ue.length=="number"){we&&(ue=we);var ie=0;return function(){return ie>=ue.length?{done:!0}:{done:!1,value:ue[ie++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Y.defaults=y();function C(ue){Y.defaults=ue}var E=/[&<>"']/,I=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,_={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(de){return _[de]};function w(ue,de){if(de){if(E.test(ue))return ue.replace(I,T)}else if(R.test(ue))return ue.replace(k,T);return ue}var b=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(ue){return ue.replace(b,function(de,we){return we=we.toLowerCase(),we==="colon"?":":we.charAt(0)==="#"?we.charAt(1)==="x"?String.fromCharCode(parseInt(we.substring(2),16)):String.fromCharCode(+we.substring(1)):""})}var f=/(^|[^\[])\^/g;function p(ue,de){ue=typeof ue=="string"?ue:ue.source,de=de||"";var we={replace:function(me,J){return J=J.source||J,J=J.replace(f,"$1"),ue=ue.replace(me,J),we},getRegex:function(){return new RegExp(ue,de)}};return we}var v=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(ue,de,we){if(ue){var ie;try{ie=decodeURIComponent(g(we)).replace(v,"").toLowerCase()}catch{return null}if(ie.indexOf("javascript:")===0||ie.indexOf("vbscript:")===0||ie.indexOf("data:")===0)return null}de&&!c.test(we)&&(we=i(de,we));try{we=encodeURI(we).replace(/%25/g,"%")}catch{return null}return we}var a={},d=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(ue,de){a[" "+ue]||(d.test(ue)?a[" "+ue]=ue+"/":a[" "+ue]=h(ue,"/",!0)),ue=a[" "+ue];var we=ue.indexOf(":")===-1;return de.substring(0,2)==="//"?we?de:ue.replace(r,"$1")+de:de.charAt(0)==="/"?we?de:ue.replace(o,"$1")+de:ue+de}var n={exec:function(){}};function s(ue){for(var de=1,we,ie;de<arguments.length;de++){we=arguments[de];for(ie in we)Object.prototype.hasOwnProperty.call(we,ie)&&(ue[ie]=we[ie])}return ue}function l(ue,de){var we=ue.replace(/\|/g,function(J,re,O){for(var H=!1,G=re;--G>=0&&O[G]==="\\";)H=!H;return H?"|":" |"}),ie=we.split(/ \|/),me=0;if(ie[0].trim()||ie.shift(),ie.length>0&&!ie[ie.length-1].trim()&&ie.pop(),ie.length>de)ie.splice(de);else for(;ie.length<de;)ie.push("");for(;me<ie.length;me++)ie[me]=ie[me].trim().replace(/\\\|/g,"|");return ie}function h(ue,de,we){var ie=ue.length;if(ie===0)return"";for(var me=0;me<ie;){var J=ue.charAt(ie-me-1);if(J===de&&!we)me++;else if(J!==de&&we)me++;else break}return ue.slice(0,ie-me)}function S(ue,de){if(ue.indexOf(de[1])===-1)return-1;for(var we=ue.length,ie=0,me=0;me<we;me++)if(ue[me]==="\\")me++;else if(ue[me]===de[0])ie++;else if(ue[me]===de[1]&&(ie--,ie<0))return me;return-1}function L(ue){ue&&ue.sanitize&&!ue.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(ue,de){if(de<1)return"";for(var we="";de>1;)de&1&&(we+=ue),de>>=1,ue+=ue;return we+ue}function F(ue,de,we,ie){var me=de.href,J=de.title?w(de.title):null,re=ue[1].replace(/\\([\[\]])/g,"$1");if(ue[0].charAt(0)!=="!"){ie.state.inLink=!0;var O={type:"link",raw:we,href:me,title:J,text:re,tokens:ie.inlineTokens(re,[])};return ie.state.inLink=!1,O}return{type:"image",raw:we,href:me,title:J,text:w(re)}}function A(ue,de){var we=ue.match(/^(\s+)(?:```)/);if(we===null)return de;var ie=we[1];return de.split(`
`).map(function(me){var J=me.match(/^\s+/);if(J===null)return me;var re=J[0];return re.length>=ie.length?me.slice(ie.length):me}).join(`
`)}var B=function(){function ue(we){this.options=we||Y.defaults}var de=ue.prototype;return de.space=function(ie){var me=this.rules.block.newline.exec(ie);if(me&&me[0].length>0)return{type:"space",raw:me[0]}},de.code=function(ie){var me=this.rules.block.code.exec(ie);if(me){var J=me[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:me[0],codeBlockStyle:"indented",text:this.options.pedantic?J:h(J,`
`)}}},de.fences=function(ie){var me=this.rules.block.fences.exec(ie);if(me){var J=me[0],re=A(J,me[3]||"");return{type:"code",raw:J,lang:me[2]?me[2].trim():me[2],text:re}}},de.heading=function(ie){var me=this.rules.block.heading.exec(ie);if(me){var J=me[2].trim();if(/#$/.test(J)){var re=h(J,"#");(this.options.pedantic||!re||/ $/.test(re))&&(J=re.trim())}var O={type:"heading",raw:me[0],depth:me[1].length,text:J,tokens:[]};return this.lexer.inline(O.text,O.tokens),O}},de.hr=function(ie){var me=this.rules.block.hr.exec(ie);if(me)return{type:"hr",raw:me[0]}},de.blockquote=function(ie){var me=this.rules.block.blockquote.exec(ie);if(me){var J=me[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:me[0],tokens:this.lexer.blockTokens(J,[]),text:J}}},de.list=function(ie){var me=this.rules.block.list.exec(ie);if(me){var J,re,O,H,G,X,he,be,ae,De,Ce,ze,Ke=me[1].trim(),Ne=Ke.length>1,Ye={type:"list",raw:"",ordered:Ne,start:Ne?+Ke.slice(0,-1):"",loose:!1,items:[]};Ke=Ne?"\\d{1,9}\\"+Ke.slice(-1):"\\"+Ke,this.options.pedantic&&(Ke=Ne?Ke:"[*+-]");for(var ee=new RegExp("^( {0,3}"+Ke+")((?:[	 ][^\\n]*)?(?:\\n|$))");ie&&(ze=!1,!(!(me=ee.exec(ie))||this.rules.block.hr.test(ie)));){if(J=me[0],ie=ie.substring(J.length),be=me[2].split(`
`,1)[0],ae=ie.split(`
`,1)[0],this.options.pedantic?(H=2,Ce=be.trimLeft()):(H=me[2].search(/[^ ]/),H=H>4?1:H,Ce=be.slice(H),H+=me[1].length),X=!1,!be&&/^ *$/.test(ae)&&(J+=ae+`
`,ie=ie.substring(ae.length+1),ze=!0),!ze)for(var oe=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ye=new RegExp("^ {0,"+Math.min(3,H-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");ie&&(De=ie.split(`
`,1)[0],be=De,this.options.pedantic&&(be=be.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(oe.test(be)||ye.test(ie)));){if(be.search(/[^ ]/)>=H||!be.trim())Ce+=`
`+be.slice(H);else if(!X)Ce+=`
`+be;else break;!X&&!be.trim()&&(X=!0),J+=De+`
`,ie=ie.substring(De.length+1)}Ye.loose||(he?Ye.loose=!0:/\n *\n *$/.test(J)&&(he=!0)),this.options.gfm&&(re=/^\[[ xX]\] /.exec(Ce),re&&(O=re[0]!=="[ ] ",Ce=Ce.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:J,task:!!re,checked:O,loose:!1,text:Ce}),Ye.raw+=J}Ye.items[Ye.items.length-1].raw=J.trimRight(),Ye.items[Ye.items.length-1].text=Ce.trimRight(),Ye.raw=Ye.raw.trimRight();var We=Ye.items.length;for(G=0;G<We;G++){this.lexer.state.top=!1,Ye.items[G].tokens=this.lexer.blockTokens(Ye.items[G].text,[]);var ce=Ye.items[G].tokens.filter(function(Be){return Be.type==="space"}),Ae=ce.every(function(Be){for(var qe=Be.raw.split(""),je=0,Ve=P(qe),nt;!(nt=Ve()).done;){var ot=nt.value;if(ot===`
`&&(je+=1),je>1)return!0}return!1});!Ye.loose&&ce.length&&Ae&&(Ye.loose=!0,Ye.items[G].loose=!0)}return Ye}},de.html=function(ie){var me=this.rules.block.html.exec(ie);if(me){var J={type:"html",raw:me[0],pre:!this.options.sanitizer&&(me[1]==="pre"||me[1]==="script"||me[1]==="style"),text:me[0]};return this.options.sanitize&&(J.type="paragraph",J.text=this.options.sanitizer?this.options.sanitizer(me[0]):w(me[0]),J.tokens=[],this.lexer.inline(J.text,J.tokens)),J}},de.def=function(ie){var me=this.rules.block.def.exec(ie);if(me){me[3]&&(me[3]=me[3].substring(1,me[3].length-1));var J=me[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:J,raw:me[0],href:me[2],title:me[3]}}},de.table=function(ie){var me=this.rules.block.table.exec(ie);if(me){var J={type:"table",header:l(me[1]).map(function(he){return{text:he}}),align:me[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:me[3]&&me[3].trim()?me[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(J.header.length===J.align.length){J.raw=me[0];var re=J.align.length,O,H,G,X;for(O=0;O<re;O++)/^ *-+: *$/.test(J.align[O])?J.align[O]="right":/^ *:-+: *$/.test(J.align[O])?J.align[O]="center":/^ *:-+ *$/.test(J.align[O])?J.align[O]="left":J.align[O]=null;for(re=J.rows.length,O=0;O<re;O++)J.rows[O]=l(J.rows[O],J.header.length).map(function(he){return{text:he}});for(re=J.header.length,H=0;H<re;H++)J.header[H].tokens=[],this.lexer.inline(J.header[H].text,J.header[H].tokens);for(re=J.rows.length,H=0;H<re;H++)for(X=J.rows[H],G=0;G<X.length;G++)X[G].tokens=[],this.lexer.inline(X[G].text,X[G].tokens);return J}}},de.lheading=function(ie){var me=this.rules.block.lheading.exec(ie);if(me){var J={type:"heading",raw:me[0],depth:me[2].charAt(0)==="="?1:2,text:me[1],tokens:[]};return this.lexer.inline(J.text,J.tokens),J}},de.paragraph=function(ie){var me=this.rules.block.paragraph.exec(ie);if(me){var J={type:"paragraph",raw:me[0],text:me[1].charAt(me[1].length-1)===`
`?me[1].slice(0,-1):me[1],tokens:[]};return this.lexer.inline(J.text,J.tokens),J}},de.text=function(ie){var me=this.rules.block.text.exec(ie);if(me){var J={type:"text",raw:me[0],text:me[0],tokens:[]};return this.lexer.inline(J.text,J.tokens),J}},de.escape=function(ie){var me=this.rules.inline.escape.exec(ie);if(me)return{type:"escape",raw:me[0],text:w(me[1])}},de.tag=function(ie){var me=this.rules.inline.tag.exec(ie);if(me)return!this.lexer.state.inLink&&/^<a /i.test(me[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(me[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(me[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(me[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:me[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):w(me[0]):me[0]}},de.link=function(ie){var me=this.rules.inline.link.exec(ie);if(me){var J=me[2].trim();if(!this.options.pedantic&&/^</.test(J)){if(!/>$/.test(J))return;var re=h(J.slice(0,-1),"\\");if((J.length-re.length)%2==0)return}else{var O=S(me[2],"()");if(O>-1){var H=me[0].indexOf("!")===0?5:4,G=H+me[1].length+O;me[2]=me[2].substring(0,O),me[0]=me[0].substring(0,G).trim(),me[3]=""}}var X=me[2],he="";if(this.options.pedantic){var be=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(X);be&&(X=be[1],he=be[3])}else he=me[3]?me[3].slice(1,-1):"";return X=X.trim(),/^</.test(X)&&(this.options.pedantic&&!/>$/.test(J)?X=X.slice(1):X=X.slice(1,-1)),F(me,{href:X&&X.replace(this.rules.inline._escapes,"$1"),title:he&&he.replace(this.rules.inline._escapes,"$1")},me[0],this.lexer)}},de.reflink=function(ie,me){var J;if((J=this.rules.inline.reflink.exec(ie))||(J=this.rules.inline.nolink.exec(ie))){var re=(J[2]||J[1]).replace(/\s+/g," ");if(re=me[re.toLowerCase()],!re||!re.href){var O=J[0].charAt(0);return{type:"text",raw:O,text:O}}return F(J,re,J[0],this.lexer)}},de.emStrong=function(ie,me,J){J===void 0&&(J="");var re=this.rules.inline.emStrong.lDelim.exec(ie);if(!!re&&!(re[3]&&J.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var O=re[1]||re[2]||"";if(!O||O&&(J===""||this.rules.inline.punctuation.exec(J))){var H=re[0].length-1,G,X,he=H,be=0,ae=re[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ae.lastIndex=0,me=me.slice(-1*ie.length+H);(re=ae.exec(me))!=null;)if(G=re[1]||re[2]||re[3]||re[4]||re[5]||re[6],!!G){if(X=G.length,re[3]||re[4]){he+=X;continue}else if((re[5]||re[6])&&H%3&&!((H+X)%3)){be+=X;continue}if(he-=X,!(he>0)){if(X=Math.min(X,X+he+be),Math.min(H,X)%2){var De=ie.slice(1,H+re.index+X);return{type:"em",raw:ie.slice(0,H+re.index+X+1),text:De,tokens:this.lexer.inlineTokens(De,[])}}var Ce=ie.slice(2,H+re.index+X-1);return{type:"strong",raw:ie.slice(0,H+re.index+X+1),text:Ce,tokens:this.lexer.inlineTokens(Ce,[])}}}}}},de.codespan=function(ie){var me=this.rules.inline.code.exec(ie);if(me){var J=me[2].replace(/\n/g," "),re=/[^ ]/.test(J),O=/^ /.test(J)&&/ $/.test(J);return re&&O&&(J=J.substring(1,J.length-1)),J=w(J,!0),{type:"codespan",raw:me[0],text:J}}},de.br=function(ie){var me=this.rules.inline.br.exec(ie);if(me)return{type:"br",raw:me[0]}},de.del=function(ie){var me=this.rules.inline.del.exec(ie);if(me)return{type:"del",raw:me[0],text:me[2],tokens:this.lexer.inlineTokens(me[2],[])}},de.autolink=function(ie,me){var J=this.rules.inline.autolink.exec(ie);if(J){var re,O;return J[2]==="@"?(re=w(this.options.mangle?me(J[1]):J[1]),O="mailto:"+re):(re=w(J[1]),O=re),{type:"link",raw:J[0],text:re,href:O,tokens:[{type:"text",raw:re,text:re}]}}},de.url=function(ie,me){var J;if(J=this.rules.inline.url.exec(ie)){var re,O;if(J[2]==="@")re=w(this.options.mangle?me(J[0]):J[0]),O="mailto:"+re;else{var H;do H=J[0],J[0]=this.rules.inline._backpedal.exec(J[0])[0];while(H!==J[0]);re=w(J[0]),J[1]==="www."?O="http://"+re:O=re}return{type:"link",raw:J[0],text:re,href:O,tokens:[{type:"text",raw:re,text:re}]}}},de.inlineText=function(ie,me){var J=this.rules.inline.text.exec(ie);if(J){var re;return this.lexer.state.inRawBlock?re=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):w(J[0]):J[0]:re=w(this.options.smartypants?me(J[0]):J[0]),{type:"text",raw:J[0],text:re}}},ue}(),$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:n,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=p($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.listItemStart=p(/^( *)(bull) */).replace("bull",$.bullet).getRegex(),$.list=p($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=p($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=p($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.blockquote=p($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=s({},$),$.gfm=s({},$.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.table=p($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.gfm.paragraph=p($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",$.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.pedantic=s({},$.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:n,paragraph:p($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:n,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:n,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=p(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=p($._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=p(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=p(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=p(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=p(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=p(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=p(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=p(U.reflink).replace("label",U._label).replace("ref",$._label).getRegex(),U.nolink=p(U.nolink).replace("ref",$._label).getRegex(),U.reflinkSearch=p(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=s({},U),U.pedantic=s({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=s({},U.normal,{escape:p(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=p(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=s({},U.gfm,{br:p(U.br).replace("{2,}","*").getRegex(),text:p(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(ue){return ue.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(ue){var de="",we,ie,me=ue.length;for(we=0;we<me;we++)ie=ue.charCodeAt(we),Math.random()>.5&&(ie="x"+ie.toString(16)),de+="&#"+ie+";";return de}var N=function(){function ue(we){this.tokens=[],this.tokens.links=Object.create(null),this.options=we||Y.defaults,this.options.tokenizer=this.options.tokenizer||new B,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ie={block:$.normal,inline:U.normal};this.options.pedantic?(ie.block=$.pedantic,ie.inline=U.pedantic):this.options.gfm&&(ie.block=$.gfm,this.options.breaks?ie.inline=U.breaks:ie.inline=U.gfm),this.tokenizer.rules=ie}ue.lex=function(ie,me){var J=new ue(me);return J.lex(ie)},ue.lexInline=function(ie,me){var J=new ue(me);return J.inlineTokens(ie)};var de=ue.prototype;return de.lex=function(ie){ie=ie.replace(/\r\n|\r/g,`
`),this.blockTokens(ie,this.tokens);for(var me;me=this.inlineQueue.shift();)this.inlineTokens(me.src,me.tokens);return this.tokens},de.blockTokens=function(ie,me){var J=this;me===void 0&&(me=[]),this.options.pedantic?ie=ie.replace(/\t/g,"    ").replace(/^ +$/gm,""):ie=ie.replace(/^( *)(\t+)/gm,function(he,be,ae){return be+"    ".repeat(ae.length)});for(var re,O,H,G;ie;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(he){return(re=he.call({lexer:J},ie,me))?(ie=ie.substring(re.raw.length),me.push(re),!0):!1}))){if(re=this.tokenizer.space(ie)){ie=ie.substring(re.raw.length),re.raw.length===1&&me.length>0?me[me.length-1].raw+=`
`:me.push(re);continue}if(re=this.tokenizer.code(ie)){ie=ie.substring(re.raw.length),O=me[me.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+re.raw,O.text+=`
`+re.text,this.inlineQueue[this.inlineQueue.length-1].src=O.text):me.push(re);continue}if(re=this.tokenizer.fences(ie)){ie=ie.substring(re.raw.length),me.push(re);continue}if(re=this.tokenizer.heading(ie)){ie=ie.substring(re.raw.length),me.push(re);continue}if(re=this.tokenizer.hr(ie)){ie=ie.substring(re.raw.length),me.push(re);continue}if(re=this.tokenizer.blockquote(ie)){ie=ie.substring(re.raw.length),me.push(re);continue}if(re=this.tokenizer.list(ie)){ie=ie.substring(re.raw.length),me.push(re);continue}if(re=this.tokenizer.html(ie)){ie=ie.substring(re.raw.length),me.push(re);continue}if(re=this.tokenizer.def(ie)){ie=ie.substring(re.raw.length),O=me[me.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+re.raw,O.text+=`
`+re.raw,this.inlineQueue[this.inlineQueue.length-1].src=O.text):this.tokens.links[re.tag]||(this.tokens.links[re.tag]={href:re.href,title:re.title});continue}if(re=this.tokenizer.table(ie)){ie=ie.substring(re.raw.length),me.push(re);continue}if(re=this.tokenizer.lheading(ie)){ie=ie.substring(re.raw.length),me.push(re);continue}if(H=ie,this.options.extensions&&this.options.extensions.startBlock&&function(){var he=1/0,be=ie.slice(1),ae=void 0;J.options.extensions.startBlock.forEach(function(De){ae=De.call({lexer:this},be),typeof ae=="number"&&ae>=0&&(he=Math.min(he,ae))}),he<1/0&&he>=0&&(H=ie.substring(0,he+1))}(),this.state.top&&(re=this.tokenizer.paragraph(H))){O=me[me.length-1],G&&O.type==="paragraph"?(O.raw+=`
`+re.raw,O.text+=`
`+re.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):me.push(re),G=H.length!==ie.length,ie=ie.substring(re.raw.length);continue}if(re=this.tokenizer.text(ie)){ie=ie.substring(re.raw.length),O=me[me.length-1],O&&O.type==="text"?(O.raw+=`
`+re.raw,O.text+=`
`+re.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):me.push(re);continue}if(ie){var X="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return this.state.top=!0,me},de.inline=function(ie,me){this.inlineQueue.push({src:ie,tokens:me})},de.inlineTokens=function(ie,me){var J=this;me===void 0&&(me=[]);var re,O,H,G=ie,X,he,be;if(this.tokens.links){var ae=Object.keys(this.tokens.links);if(ae.length>0)for(;(X=this.tokenizer.rules.inline.reflinkSearch.exec(G))!=null;)ae.includes(X[0].slice(X[0].lastIndexOf("[")+1,-1))&&(G=G.slice(0,X.index)+"["+M("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(X=this.tokenizer.rules.inline.blockSkip.exec(G))!=null;)G=G.slice(0,X.index)+"["+M("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(X=this.tokenizer.rules.inline.escapedEmSt.exec(G))!=null;)G=G.slice(0,X.index)+"++"+G.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ie;)if(he||(be=""),he=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ce){return(re=Ce.call({lexer:J},ie,me))?(ie=ie.substring(re.raw.length),me.push(re),!0):!1}))){if(re=this.tokenizer.escape(ie)){ie=ie.substring(re.raw.length),me.push(re);continue}if(re=this.tokenizer.tag(ie)){ie=ie.substring(re.raw.length),O=me[me.length-1],O&&re.type==="text"&&O.type==="text"?(O.raw+=re.raw,O.text+=re.text):me.push(re);continue}if(re=this.tokenizer.link(ie)){ie=ie.substring(re.raw.length),me.push(re);continue}if(re=this.tokenizer.reflink(ie,this.tokens.links)){ie=ie.substring(re.raw.length),O=me[me.length-1],O&&re.type==="text"&&O.type==="text"?(O.raw+=re.raw,O.text+=re.text):me.push(re);continue}if(re=this.tokenizer.emStrong(ie,G,be)){ie=ie.substring(re.raw.length),me.push(re);continue}if(re=this.tokenizer.codespan(ie)){ie=ie.substring(re.raw.length),me.push(re);continue}if(re=this.tokenizer.br(ie)){ie=ie.substring(re.raw.length),me.push(re);continue}if(re=this.tokenizer.del(ie)){ie=ie.substring(re.raw.length),me.push(re);continue}if(re=this.tokenizer.autolink(ie,W)){ie=ie.substring(re.raw.length),me.push(re);continue}if(!this.state.inLink&&(re=this.tokenizer.url(ie,W))){ie=ie.substring(re.raw.length),me.push(re);continue}if(H=ie,this.options.extensions&&this.options.extensions.startInline&&function(){var Ce=1/0,ze=ie.slice(1),Ke=void 0;J.options.extensions.startInline.forEach(function(Ne){Ke=Ne.call({lexer:this},ze),typeof Ke=="number"&&Ke>=0&&(Ce=Math.min(Ce,Ke))}),Ce<1/0&&Ce>=0&&(H=ie.substring(0,Ce+1))}(),re=this.tokenizer.inlineText(H,K)){ie=ie.substring(re.raw.length),re.raw.slice(-1)!=="_"&&(be=re.raw.slice(-1)),he=!0,O=me[me.length-1],O&&O.type==="text"?(O.raw+=re.raw,O.text+=re.text):me.push(re);continue}if(ie){var De="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return me},u(ue,null,[{key:"rules",get:function(){return{block:$,inline:U}}}]),ue}(),V=function(){function ue(we){this.options=we||Y.defaults}var de=ue.prototype;return de.code=function(ie,me,J){var re=(me||"").match(/\S*/)[0];if(this.options.highlight){var O=this.options.highlight(ie,re);O!=null&&O!==ie&&(J=!0,ie=O)}return ie=ie.replace(/\n$/,"")+`
`,re?'<pre><code class="'+this.options.langPrefix+w(re,!0)+'">'+(J?ie:w(ie,!0))+`</code></pre>
`:"<pre><code>"+(J?ie:w(ie,!0))+`</code></pre>
`},de.blockquote=function(ie){return`<blockquote>
`+ie+`</blockquote>
`},de.html=function(ie){return ie},de.heading=function(ie,me,J,re){if(this.options.headerIds){var O=this.options.headerPrefix+re.slug(J);return"<h"+me+' id="'+O+'">'+ie+"</h"+me+`>
`}return"<h"+me+">"+ie+"</h"+me+`>
`},de.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},de.list=function(ie,me,J){var re=me?"ol":"ul",O=me&&J!==1?' start="'+J+'"':"";return"<"+re+O+`>
`+ie+"</"+re+`>
`},de.listitem=function(ie){return"<li>"+ie+`</li>
`},de.checkbox=function(ie){return"<input "+(ie?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},de.paragraph=function(ie){return"<p>"+ie+`</p>
`},de.table=function(ie,me){return me&&(me="<tbody>"+me+"</tbody>"),`<table>
<thead>
`+ie+`</thead>
`+me+`</table>
`},de.tablerow=function(ie){return`<tr>
`+ie+`</tr>
`},de.tablecell=function(ie,me){var J=me.header?"th":"td",re=me.align?"<"+J+' align="'+me.align+'">':"<"+J+">";return re+ie+("</"+J+`>
`)},de.strong=function(ie){return"<strong>"+ie+"</strong>"},de.em=function(ie){return"<em>"+ie+"</em>"},de.codespan=function(ie){return"<code>"+ie+"</code>"},de.br=function(){return this.options.xhtml?"<br/>":"<br>"},de.del=function(ie){return"<del>"+ie+"</del>"},de.link=function(ie,me,J){if(ie=m(this.options.sanitize,this.options.baseUrl,ie),ie===null)return J;var re='<a href="'+w(ie)+'"';return me&&(re+=' title="'+me+'"'),re+=">"+J+"</a>",re},de.image=function(ie,me,J){if(ie=m(this.options.sanitize,this.options.baseUrl,ie),ie===null)return J;var re='<img src="'+ie+'" alt="'+J+'"';return me&&(re+=' title="'+me+'"'),re+=this.options.xhtml?"/>":">",re},de.text=function(ie){return ie},ue}(),x=function(){function ue(){}var de=ue.prototype;return de.strong=function(ie){return ie},de.em=function(ie){return ie},de.codespan=function(ie){return ie},de.del=function(ie){return ie},de.html=function(ie){return ie},de.text=function(ie){return ie},de.link=function(ie,me,J){return""+J},de.image=function(ie,me,J){return""+J},de.br=function(){return""},ue}(),q=function(){function ue(){this.seen={}}var de=ue.prototype;return de.serialize=function(ie){return ie.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},de.getNextSafeSlug=function(ie,me){var J=ie,re=0;if(this.seen.hasOwnProperty(J)){re=this.seen[ie];do re++,J=ie+"-"+re;while(this.seen.hasOwnProperty(J))}return me||(this.seen[ie]=re,this.seen[J]=0),J},de.slug=function(ie,me){me===void 0&&(me={});var J=this.serialize(ie);return this.getNextSafeSlug(J,me.dryrun)},ue}(),te=function(){function ue(we){this.options=we||Y.defaults,this.options.renderer=this.options.renderer||new V,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new q}ue.parse=function(ie,me){var J=new ue(me);return J.parse(ie)},ue.parseInline=function(ie,me){var J=new ue(me);return J.parseInline(ie)};var de=ue.prototype;return de.parse=function(ie,me){me===void 0&&(me=!0);var J="",re,O,H,G,X,he,be,ae,De,Ce,ze,Ke,Ne,Ye,ee,oe,ye,We,ce,Ae=ie.length;for(re=0;re<Ae;re++){if(Ce=ie[re],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ce.type]&&(ce=this.options.extensions.renderers[Ce.type].call({parser:this},Ce),ce!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ce.type))){J+=ce||"";continue}switch(Ce.type){case"space":continue;case"hr":{J+=this.renderer.hr();continue}case"heading":{J+=this.renderer.heading(this.parseInline(Ce.tokens),Ce.depth,g(this.parseInline(Ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{J+=this.renderer.code(Ce.text,Ce.lang,Ce.escaped);continue}case"table":{for(ae="",be="",G=Ce.header.length,O=0;O<G;O++)be+=this.renderer.tablecell(this.parseInline(Ce.header[O].tokens),{header:!0,align:Ce.align[O]});for(ae+=this.renderer.tablerow(be),De="",G=Ce.rows.length,O=0;O<G;O++){for(he=Ce.rows[O],be="",X=he.length,H=0;H<X;H++)be+=this.renderer.tablecell(this.parseInline(he[H].tokens),{header:!1,align:Ce.align[H]});De+=this.renderer.tablerow(be)}J+=this.renderer.table(ae,De);continue}case"blockquote":{De=this.parse(Ce.tokens),J+=this.renderer.blockquote(De);continue}case"list":{for(ze=Ce.ordered,Ke=Ce.start,Ne=Ce.loose,G=Ce.items.length,De="",O=0;O<G;O++)ee=Ce.items[O],oe=ee.checked,ye=ee.task,Ye="",ee.task&&(We=this.renderer.checkbox(oe),Ne?ee.tokens.length>0&&ee.tokens[0].type==="paragraph"?(ee.tokens[0].text=We+" "+ee.tokens[0].text,ee.tokens[0].tokens&&ee.tokens[0].tokens.length>0&&ee.tokens[0].tokens[0].type==="text"&&(ee.tokens[0].tokens[0].text=We+" "+ee.tokens[0].tokens[0].text)):ee.tokens.unshift({type:"text",text:We}):Ye+=We),Ye+=this.parse(ee.tokens,Ne),De+=this.renderer.listitem(Ye,ye,oe);J+=this.renderer.list(De,ze,Ke);continue}case"html":{J+=this.renderer.html(Ce.text);continue}case"paragraph":{J+=this.renderer.paragraph(this.parseInline(Ce.tokens));continue}case"text":{for(De=Ce.tokens?this.parseInline(Ce.tokens):Ce.text;re+1<Ae&&ie[re+1].type==="text";)Ce=ie[++re],De+=`
`+(Ce.tokens?this.parseInline(Ce.tokens):Ce.text);J+=me?this.renderer.paragraph(De):De;continue}default:{var Be='Token with "'+Ce.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return J},de.parseInline=function(ie,me){me=me||this.renderer;var J="",re,O,H,G=ie.length;for(re=0;re<G;re++){if(O=ie[re],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[O.type]&&(H=this.options.extensions.renderers[O.type].call({parser:this},O),H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(O.type))){J+=H||"";continue}switch(O.type){case"escape":{J+=me.text(O.text);break}case"html":{J+=me.html(O.text);break}case"link":{J+=me.link(O.href,O.title,this.parseInline(O.tokens,me));break}case"image":{J+=me.image(O.href,O.title,O.text);break}case"strong":{J+=me.strong(this.parseInline(O.tokens,me));break}case"em":{J+=me.em(this.parseInline(O.tokens,me));break}case"codespan":{J+=me.codespan(O.text);break}case"br":{J+=me.br();break}case"del":{J+=me.del(this.parseInline(O.tokens,me));break}case"text":{J+=me.text(O.text);break}default:{var X='Token with "'+O.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return J},ue}();function Q(ue,de,we){if(typeof ue=="undefined"||ue===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");if(typeof de=="function"&&(we=de,de=null),de=s({},Q.defaults,de||{}),L(de),we){var ie=de.highlight,me;try{me=N.lex(ue,de)}catch(H){return we(H)}var J=function(G){var X;if(!G)try{de.walkTokens&&Q.walkTokens(me,de.walkTokens),X=te.parse(me,de)}catch(he){G=he}return de.highlight=ie,G?we(G):we(null,X)};if(!ie||ie.length<3||(delete de.highlight,!me.length))return J();var re=0;Q.walkTokens(me,function(H){H.type==="code"&&(re++,setTimeout(function(){ie(H.text,H.lang,function(G,X){if(G)return J(G);X!=null&&X!==H.text&&(H.text=X,H.escaped=!0),re--,re===0&&J()})},0))}),re===0&&J();return}try{var O=N.lex(ue,de);return de.walkTokens&&Q.walkTokens(O,de.walkTokens),te.parse(O,de)}catch(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+w(H.message+"",!0)+"</pre>";throw H}}Q.options=Q.setOptions=function(ue){return s(Q.defaults,ue),C(Q.defaults),Q},Q.getDefaults=y,Q.defaults=Y.defaults,Q.use=function(){for(var ue=arguments.length,de=new Array(ue),we=0;we<ue;we++)de[we]=arguments[we];var ie=s.apply(void 0,[{}].concat(de)),me=Q.defaults.extensions||{renderers:{},childTokens:{}},J;de.forEach(function(re){if(re.extensions&&(J=!0,re.extensions.forEach(function(H){if(!H.name)throw new Error("extension name required");if(H.renderer){var G=me.renderers?me.renderers[H.name]:null;G?me.renderers[H.name]=function(){for(var X=arguments.length,he=new Array(X),be=0;be<X;be++)he[be]=arguments[be];var ae=H.renderer.apply(this,he);return ae===!1&&(ae=G.apply(this,he)),ae}:me.renderers[H.name]=H.renderer}if(H.tokenizer){if(!H.level||H.level!=="block"&&H.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");me[H.level]?me[H.level].unshift(H.tokenizer):me[H.level]=[H.tokenizer],H.start&&(H.level==="block"?me.startBlock?me.startBlock.push(H.start):me.startBlock=[H.start]:H.level==="inline"&&(me.startInline?me.startInline.push(H.start):me.startInline=[H.start]))}H.childTokens&&(me.childTokens[H.name]=H.childTokens)})),re.renderer&&function(){var H=Q.defaults.renderer||new V,G=function(be){var ae=H[be];H[be]=function(){for(var De=arguments.length,Ce=new Array(De),ze=0;ze<De;ze++)Ce[ze]=arguments[ze];var Ke=re.renderer[be].apply(H,Ce);return Ke===!1&&(Ke=ae.apply(H,Ce)),Ke}};for(var X in re.renderer)G(X);ie.renderer=H}(),re.tokenizer&&function(){var H=Q.defaults.tokenizer||new B,G=function(be){var ae=H[be];H[be]=function(){for(var De=arguments.length,Ce=new Array(De),ze=0;ze<De;ze++)Ce[ze]=arguments[ze];var Ke=re.tokenizer[be].apply(H,Ce);return Ke===!1&&(Ke=ae.apply(H,Ce)),Ke}};for(var X in re.tokenizer)G(X);ie.tokenizer=H}(),re.walkTokens){var O=Q.defaults.walkTokens;ie.walkTokens=function(H){re.walkTokens.call(this,H),O&&O.call(this,H)}}J&&(ie.extensions=me),Q.setOptions(ie)})},Q.walkTokens=function(ue,de){for(var we=function(){var re=me.value;switch(de.call(Q,re),re.type){case"table":{for(var O=P(re.header),H;!(H=O()).done;){var G=H.value;Q.walkTokens(G.tokens,de)}for(var X=P(re.rows),he;!(he=X()).done;)for(var be=he.value,ae=P(be),De;!(De=ae()).done;){var Ce=De.value;Q.walkTokens(Ce.tokens,de)}break}case"list":{Q.walkTokens(re.items,de);break}default:Q.defaults.extensions&&Q.defaults.extensions.childTokens&&Q.defaults.extensions.childTokens[re.type]?Q.defaults.extensions.childTokens[re.type].forEach(function(ze){Q.walkTokens(re[ze],de)}):re.tokens&&Q.walkTokens(re.tokens,de)}},ie=P(ue),me;!(me=ie()).done;)we()},Q.parseInline=function(ue,de){if(typeof ue=="undefined"||ue===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");de=s({},Q.defaults,de||{}),L(de);try{var we=N.lexInline(ue,de);return de.walkTokens&&Q.walkTokens(we,de.walkTokens),te.parseInline(we,de)}catch(ie){if(ie.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+w(ie.message+"",!0)+"</pre>";throw ie}},Q.Parser=te,Q.parser=te.parse,Q.Renderer=V,Q.TextRenderer=x,Q.Lexer=N,Q.lexer=N.lex,Q.Tokenizer=B,Q.Slugger=q,Q.parse=Q;var le=Q.options,pe=Q.setOptions,Z=Q.use,ge=Q.walkTokens,Ee=Q.parseInline,Te=Q,Oe=te.parse,ve=N.lex;Y.Lexer=N,Y.Parser=te,Y.Renderer=V,Y.Slugger=q,Y.TextRenderer=x,Y.Tokenizer=B,Y.getDefaults=y,Y.lexer=ve,Y.marked=Q,Y.options=le,Y.parse=Te,Y.parseInline=Ee,Y.parser=Oe,Y.setOptions=pe,Y.use=Z,Y.walkTokens=ge,Object.defineProperty(Y,"__esModule",{value:!0})}),define(Ie[94],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function u(C,E,I){return Math.min(Math.max(C,E),I)}e.clamp=u;function t(C,E){return(E+C%E)%E}e.rot=t;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class P{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=P;class y{constructor(E){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(E),this._values.fill(0,0,E)}update(E){const I=this._values[this._index];return this._values[this._index]=E,this._index=(this._index+1)%this._values.length,this._sum-=I,this._sum+=E,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=y}),function(){function Y(D){const P=[];typeof D=="number"&&P.push("code/timeOrigin",D);function y(E){P.push(E,Date.now())}function C(){const E=[];for(let I=0;I<P.length;I+=2)E.push({name:P[I],startTime:P[I+1]});return E}return{mark:y,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const y of performance.getEntriesByType("mark"))P.push({name:y.name,startTime:Math.round(D+y.startTime)});return P}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function u(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=u(t))}(),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var u=e();for(var t in u)(typeof exports=="object"?exports:Y)[t]=u[t]}}(typeof self!="undefined"?self:this,function(){return function(Y){var e={};function u(t){if(e[t])return e[t].exports;var D=e[t]={i:t,l:!1,exports:{}};return Y[t].call(D.exports,D,D.exports,u),D.l=!0,D.exports}return u.m=Y,u.c=e,u.d=function(t,D,P){u.o(t,D)||Object.defineProperty(t,D,{enumerable:!0,get:P})},u.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},u.t=function(t,D){if(1&D&&(t=u(t)),8&D||4&D&&typeof t=="object"&&t&&t.__esModule)return t;var P=Object.create(null);if(u.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:t}),2&D&&typeof t!="string")for(var y in t)u.d(P,y,function(C){return t[C]}.bind(null,y));return P},u.n=function(t){var D=t&&t.__esModule?function(){return t.default}:function(){return t};return u.d(D,"a",D),D},u.o=function(t,D){return Object.prototype.hasOwnProperty.call(t,D)},u.p="",u(u.s=0)}([function(Y,e,u){(function(t){var D;e=Y.exports=Z,D=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,y=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],E=e.src=[],I=0,R=I++;E[R]="0|[1-9]\\d*";var k=I++;E[k]="[0-9]+";var _=I++;E[_]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=I++;E[T]="("+E[R]+")\\.("+E[R]+")\\.("+E[R]+")";var w=I++;E[w]="("+E[k]+")\\.("+E[k]+")\\.("+E[k]+")";var b=I++;E[b]="(?:"+E[R]+"|"+E[_]+")";var g=I++;E[g]="(?:"+E[k]+"|"+E[_]+")";var f=I++;E[f]="(?:-("+E[b]+"(?:\\."+E[b]+")*))";var p=I++;E[p]="(?:-?("+E[g]+"(?:\\."+E[g]+")*))";var v=I++;E[v]="[0-9A-Za-z-]+";var c=I++;E[c]="(?:\\+("+E[v]+"(?:\\."+E[v]+")*))";var m=I++,a="v?"+E[T]+E[f]+"?"+E[c]+"?";E[m]="^"+a+"$";var d="[v=\\s]*"+E[w]+E[p]+"?"+E[c]+"?",r=I++;E[r]="^"+d+"$";var o=I++;E[o]="((?:<|>)?=?)";var i=I++;E[i]=E[k]+"|x|X|\\*";var n=I++;E[n]=E[R]+"|x|X|\\*";var s=I++;E[s]="[v=\\s]*("+E[n]+")(?:\\.("+E[n]+")(?:\\.("+E[n]+")(?:"+E[f]+")?"+E[c]+"?)?)?";var l=I++;E[l]="[v=\\s]*("+E[i]+")(?:\\.("+E[i]+")(?:\\.("+E[i]+")(?:"+E[p]+")?"+E[c]+"?)?)?";var h=I++;E[h]="^"+E[o]+"\\s*"+E[s]+"$";var S=I++;E[S]="^"+E[o]+"\\s*"+E[l]+"$";var L=I++;E[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=I++;E[M]="(?:~>?)";var F=I++;E[F]="(\\s*)"+E[M]+"\\s+",C[F]=new RegExp(E[F],"g");var A=I++;E[A]="^"+E[M]+E[s]+"$";var B=I++;E[B]="^"+E[M]+E[l]+"$";var $=I++;E[$]="(?:\\^)";var U=I++;E[U]="(\\s*)"+E[$]+"\\s+",C[U]=new RegExp(E[U],"g");var K=I++;E[K]="^"+E[$]+E[s]+"$";var W=I++;E[W]="^"+E[$]+E[l]+"$";var N=I++;E[N]="^"+E[o]+"\\s*("+d+")$|^$";var V=I++;E[V]="^"+E[o]+"\\s*("+a+")$|^$";var x=I++;E[x]="(\\s*)"+E[o]+"\\s*("+d+"|"+E[s]+")",C[x]=new RegExp(E[x],"g");var q=I++;E[q]="^\\s*("+E[s]+")\\s+-\\s+("+E[s]+")\\s*$";var te=I++;E[te]="^\\s*("+E[l]+")\\s+-\\s+("+E[l]+")\\s*$";var Q=I++;E[Q]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)D(le,E[le]),C[le]||(C[le]=new RegExp(E[le]));function pe(ae,De){if(ae instanceof Z)return ae;if(typeof ae!="string"||ae.length>P||!(De?C[r]:C[m]).test(ae))return null;try{return new Z(ae,De)}catch{return null}}function Z(ae,De){if(ae instanceof Z){if(ae.loose===De)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof Z))return new Z(ae,De);D("SemVer",ae,De),this.loose=De;var Ce=ae.trim().match(De?C[r]:C[m]);if(!Ce)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+Ce[1],this.minor=+Ce[2],this.patch=+Ce[3],this.major>y||this.major<0)throw new TypeError("Invalid major version");if(this.minor>y||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>y||this.patch<0)throw new TypeError("Invalid patch version");Ce[4]?this.prerelease=Ce[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var Ke=+ze;if(Ke>=0&&Ke<y)return Ke}return ze}):this.prerelease=[],this.build=Ce[5]?Ce[5].split("."):[],this.format()}e.parse=pe,e.valid=function(ae,De){var Ce=pe(ae,De);return Ce?Ce.version:null},e.clean=function(ae,De){var Ce=pe(ae.trim().replace(/^[=v]+/,""),De);return Ce?Ce.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ae){return D("SemVer.compare",this.version,this.loose,ae),ae instanceof Z||(ae=new Z(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},Z.prototype.compareMain=function(ae){return ae instanceof Z||(ae=new Z(ae,this.loose)),Ee(this.major,ae.major)||Ee(this.minor,ae.minor)||Ee(this.patch,ae.patch)},Z.prototype.comparePre=function(ae){if(ae instanceof Z||(ae=new Z(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var De=0;do{var Ce=this.prerelease[De],ze=ae.prerelease[De];if(D("prerelease compare",De,Ce,ze),Ce===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(Ce===void 0)return-1;if(Ce!==ze)return Ee(Ce,ze)}while(++De)},Z.prototype.inc=function(ae,De){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ce=this.prerelease.length;--Ce>=0;)typeof this.prerelease[Ce]=="number"&&(this.prerelease[Ce]++,Ce=-2);Ce===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,De,Ce,ze){typeof Ce=="string"&&(ze=Ce,Ce=void 0);try{return new Z(ae,Ce).inc(De,ze).version}catch{return null}},e.diff=function(ae,De){if(ue(ae,De))return null;var Ce=pe(ae),ze=pe(De);if(Ce.prerelease.length||ze.prerelease.length){for(var Ke in Ce)if((Ke==="major"||Ke==="minor"||Ke==="patch")&&Ce[Ke]!==ze[Ke])return"pre"+Ke;return"prerelease"}for(var Ke in Ce)if((Ke==="major"||Ke==="minor"||Ke==="patch")&&Ce[Ke]!==ze[Ke])return Ke},e.compareIdentifiers=Ee;var ge=/^[0-9]+$/;function Ee(ae,De){var Ce=ge.test(ae),ze=ge.test(De);return Ce&&ze&&(ae=+ae,De=+De),Ce&&!ze?-1:ze&&!Ce?1:ae<De?-1:ae>De?1:0}function Te(ae,De,Ce){return new Z(ae,Ce).compare(new Z(De,Ce))}function Oe(ae,De,Ce){return Te(ae,De,Ce)>0}function ve(ae,De,Ce){return Te(ae,De,Ce)<0}function ue(ae,De,Ce){return Te(ae,De,Ce)===0}function de(ae,De,Ce){return Te(ae,De,Ce)!==0}function we(ae,De,Ce){return Te(ae,De,Ce)>=0}function ie(ae,De,Ce){return Te(ae,De,Ce)<=0}function me(ae,De,Ce,ze){var Ke;switch(De){case"===":typeof ae=="object"&&(ae=ae.version),typeof Ce=="object"&&(Ce=Ce.version),Ke=ae===Ce;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof Ce=="object"&&(Ce=Ce.version),Ke=ae!==Ce;break;case"":case"=":case"==":Ke=ue(ae,Ce,ze);break;case"!=":Ke=de(ae,Ce,ze);break;case">":Ke=Oe(ae,Ce,ze);break;case">=":Ke=we(ae,Ce,ze);break;case"<":Ke=ve(ae,Ce,ze);break;case"<=":Ke=ie(ae,Ce,ze);break;default:throw new TypeError("Invalid operator: "+De)}return Ke}function J(ae,De){if(ae instanceof J){if(ae.loose===De)return ae;ae=ae.value}if(!(this instanceof J))return new J(ae,De);D("comparator",ae,De),this.loose=De,this.parse(ae),this.semver===re?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ae,De){return Ee(De,ae)},e.major=function(ae,De){return new Z(ae,De).major},e.minor=function(ae,De){return new Z(ae,De).minor},e.patch=function(ae,De){return new Z(ae,De).patch},e.compare=Te,e.compareLoose=function(ae,De){return Te(ae,De,!0)},e.rcompare=function(ae,De,Ce){return Te(De,ae,Ce)},e.sort=function(ae,De){return ae.sort(function(Ce,ze){return e.compare(Ce,ze,De)})},e.rsort=function(ae,De){return ae.sort(function(Ce,ze){return e.rcompare(Ce,ze,De)})},e.gt=Oe,e.lt=ve,e.eq=ue,e.neq=de,e.gte=we,e.lte=ie,e.cmp=me,e.Comparator=J;var re={};function O(ae,De){if(ae instanceof O)return ae.loose===De?ae:new O(ae.raw,De);if(ae instanceof J)return new O(ae.value,De);if(!(this instanceof O))return new O(ae,De);if(this.loose=De,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(Ce){return this.parseRange(Ce.trim())},this).filter(function(Ce){return Ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function H(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function G(ae,De,Ce,ze,Ke,Ne,Ye,ee,oe,ye,We,ce,Ae){return((De=H(Ce)?"":H(ze)?">="+Ce+".0.0":H(Ke)?">="+Ce+"."+ze+".0":">="+De)+" "+(ee=H(oe)?"":H(ye)?"<"+(+oe+1)+".0.0":H(We)?"<"+oe+"."+(+ye+1)+".0":ce?"<="+oe+"."+ye+"."+We+"-"+ce:"<="+ee)).trim()}function X(ae,De){for(var Ce=0;Ce<ae.length;Ce++)if(!ae[Ce].test(De))return!1;if(De.prerelease.length){for(Ce=0;Ce<ae.length;Ce++)if(D(ae[Ce].semver),ae[Ce].semver!==re&&ae[Ce].semver.prerelease.length>0){var ze=ae[Ce].semver;if(ze.major===De.major&&ze.minor===De.minor&&ze.patch===De.patch)return!0}return!1}return!0}function he(ae,De,Ce){try{De=new O(De,Ce)}catch{return!1}return De.test(ae)}function be(ae,De,Ce,ze){var Ke,Ne,Ye,ee,oe;switch(ae=new Z(ae,ze),De=new O(De,ze),Ce){case">":Ke=Oe,Ne=ie,Ye=ve,ee=">",oe=">=";break;case"<":Ke=ve,Ne=we,Ye=Oe,ee="<",oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(he(ae,De,ze))return!1;for(var ye=0;ye<De.set.length;++ye){var We=De.set[ye],ce=null,Ae=null;if(We.forEach(function(Be){Be.semver===re&&(Be=new J(">=0.0.0")),ce=ce||Be,Ae=Ae||Be,Ke(Be.semver,ce.semver,ze)?ce=Be:Ye(Be.semver,Ae.semver,ze)&&(Ae=Be)}),ce.operator===ee||ce.operator===oe||(!Ae.operator||Ae.operator===ee)&&Ne(ae,Ae.semver)||Ae.operator===oe&&Ye(ae,Ae.semver))return!1}return!0}J.prototype.parse=function(ae){var De=this.loose?C[N]:C[V],Ce=ae.match(De);if(!Ce)throw new TypeError("Invalid comparator: "+ae);this.operator=Ce[1],this.operator==="="&&(this.operator=""),Ce[2]?this.semver=new Z(Ce[2],this.loose):this.semver=re},J.prototype.toString=function(){return this.value},J.prototype.test=function(ae){return D("Comparator.test",ae,this.loose),this.semver===re||(typeof ae=="string"&&(ae=new Z(ae,this.loose)),me(ae,this.operator,this.semver,this.loose))},J.prototype.intersects=function(ae,De){if(!(ae instanceof J))throw new TypeError("a Comparator is required");var Ce;if(this.operator==="")return Ce=new O(ae.value,De),he(this.value,Ce,De);if(ae.operator==="")return Ce=new O(this.value,De),he(ae.semver,Ce,De);var ze=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Ke=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Ne=this.semver.version===ae.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),ee=me(this.semver,"<",ae.semver,De)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),oe=me(this.semver,">",ae.semver,De)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return ze||Ke||Ne&&Ye||ee||oe},e.Range=O,O.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},O.prototype.toString=function(){return this.range},O.prototype.parseRange=function(ae){var De=this.loose;ae=ae.trim(),D("range",ae,De);var Ce=De?C[te]:C[q];ae=ae.replace(Ce,G),D("hyphen replace",ae),ae=ae.replace(C[x],"$1$2$3"),D("comparator trim",ae,C[x]),ae=(ae=(ae=ae.replace(C[F],"$1~")).replace(C[U],"$1^")).split(/\s+/).join(" ");var ze=De?C[N]:C[V],Ke=ae.split(" ").map(function(Ne){return function(Ye,ee){return D("comp",Ye),Ye=function(oe,ye){return oe.trim().split(/\s+/).map(function(We){return function(ce,Ae){D("caret",ce,Ae);var Be=Ae?C[W]:C[K];return ce.replace(Be,function(qe,je,Ve,nt,ot){var st;return D("caret",ce,qe,je,Ve,nt,ot),H(je)?st="":H(Ve)?st=">="+je+".0.0 <"+(+je+1)+".0.0":H(nt)?st=je==="0"?">="+je+"."+Ve+".0 <"+je+"."+(+Ve+1)+".0":">="+je+"."+Ve+".0 <"+(+je+1)+".0.0":ot?(D("replaceCaret pr",ot),ot.charAt(0)!=="-"&&(ot="-"+ot),st=je==="0"?Ve==="0"?">="+je+"."+Ve+"."+nt+ot+" <"+je+"."+Ve+"."+(+nt+1):">="+je+"."+Ve+"."+nt+ot+" <"+je+"."+(+Ve+1)+".0":">="+je+"."+Ve+"."+nt+ot+" <"+(+je+1)+".0.0"):(D("no pr"),st=je==="0"?Ve==="0"?">="+je+"."+Ve+"."+nt+" <"+je+"."+Ve+"."+(+nt+1):">="+je+"."+Ve+"."+nt+" <"+je+"."+(+Ve+1)+".0":">="+je+"."+Ve+"."+nt+" <"+(+je+1)+".0.0"),D("caret return",st),st})}(We,ye)}).join(" ")}(Ye,ee),D("caret",Ye),Ye=function(oe,ye){return oe.trim().split(/\s+/).map(function(We){return function(ce,Ae){var Be=Ae?C[B]:C[A];return ce.replace(Be,function(qe,je,Ve,nt,ot){var st;return D("tilde",ce,qe,je,Ve,nt,ot),H(je)?st="":H(Ve)?st=">="+je+".0.0 <"+(+je+1)+".0.0":H(nt)?st=">="+je+"."+Ve+".0 <"+je+"."+(+Ve+1)+".0":ot?(D("replaceTilde pr",ot),ot.charAt(0)!=="-"&&(ot="-"+ot),st=">="+je+"."+Ve+"."+nt+ot+" <"+je+"."+(+Ve+1)+".0"):st=">="+je+"."+Ve+"."+nt+" <"+je+"."+(+Ve+1)+".0",D("tilde return",st),st})}(We,ye)}).join(" ")}(Ye,ee),D("tildes",Ye),Ye=function(oe,ye){return D("replaceXRanges",oe,ye),oe.split(/\s+/).map(function(We){return function(ce,Ae){ce=ce.trim();var Be=Ae?C[S]:C[h];return ce.replace(Be,function(qe,je,Ve,nt,ot,st){D("xRange",ce,qe,je,Ve,nt,ot,st);var it=H(Ve),at=it||H(nt),vt=at||H(ot);return je==="="&&vt&&(je=""),it?qe=je===">"||je==="<"?"<0.0.0":"*":je&&vt?(at&&(nt=0),vt&&(ot=0),je===">"?(je=">=",at?(Ve=+Ve+1,nt=0,ot=0):vt&&(nt=+nt+1,ot=0)):je==="<="&&(je="<",at?Ve=+Ve+1:nt=+nt+1),qe=je+Ve+"."+nt+"."+ot):at?qe=">="+Ve+".0.0 <"+(+Ve+1)+".0.0":vt&&(qe=">="+Ve+"."+nt+".0 <"+Ve+"."+(+nt+1)+".0"),D("xRange return",qe),qe})}(We,ye)}).join(" ")}(Ye,ee),D("xrange",Ye),Ye=function(oe,ye){return D("replaceStars",oe,ye),oe.trim().replace(C[Q],"")}(Ye,ee),D("stars",Ye),Ye}(Ne,De)}).join(" ").split(/\s+/);return this.loose&&(Ke=Ke.filter(function(Ne){return!!Ne.match(ze)})),Ke=Ke.map(function(Ne){return new J(Ne,De)})},O.prototype.intersects=function(ae,De){if(!(ae instanceof O))throw new TypeError("a Range is required");return this.set.some(function(Ce){return Ce.every(function(ze){return ae.set.some(function(Ke){return Ke.every(function(Ne){return ze.intersects(Ne,De)})})})})},e.toComparators=function(ae,De){return new O(ae,De).set.map(function(Ce){return Ce.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},O.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new Z(ae,this.loose));for(var De=0;De<this.set.length;De++)if(X(this.set[De],ae))return!0;return!1},e.satisfies=he,e.maxSatisfying=function(ae,De,Ce){var ze=null,Ke=null;try{var Ne=new O(De,Ce)}catch{return null}return ae.forEach(function(Ye){Ne.test(Ye)&&(ze&&Ke.compare(Ye)!==-1||(Ke=new Z(ze=Ye,Ce)))}),ze},e.minSatisfying=function(ae,De,Ce){var ze=null,Ke=null;try{var Ne=new O(De,Ce)}catch{return null}return ae.forEach(function(Ye){Ne.test(Ye)&&(ze&&Ke.compare(Ye)!==1||(Ke=new Z(ze=Ye,Ce)))}),ze},e.validRange=function(ae,De){try{return new O(ae,De).range||"*"}catch{return null}},e.ltr=function(ae,De,Ce){return be(ae,De,"<",Ce)},e.gtr=function(ae,De,Ce){return be(ae,De,">",Ce)},e.outside=be,e.prerelease=function(ae,De){var Ce=pe(ae,De);return Ce&&Ce.prerelease.length?Ce.prerelease:null},e.intersects=function(ae,De,Ce){return ae=new O(ae,Ce),De=new O(De,Ce),ae.intersects(De)},e.coerce=function(ae){if(ae instanceof Z)return ae;if(typeof ae!="string")return null;var De=ae.match(C[L]);return De==null?null:pe((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,u(1))},function(Y,e){var u,t,D=Y.exports={};function P(){throw new Error("setTimeout has not been defined")}function y(){throw new Error("clearTimeout has not been defined")}function C(g){if(u===setTimeout)return setTimeout(g,0);if((u===P||!u)&&setTimeout)return u=setTimeout,setTimeout(g,0);try{return u(g,0)}catch{try{return u.call(null,g,0)}catch{return u.call(this,g,0)}}}(function(){try{u=typeof setTimeout=="function"?setTimeout:P}catch{u=P}try{t=typeof clearTimeout=="function"?clearTimeout:y}catch{t=y}})();var E,I=[],R=!1,k=-1;function _(){R&&E&&(R=!1,E.length?I=E.concat(I):k=-1,I.length&&T())}function T(){if(!R){var g=C(_);R=!0;for(var f=I.length;f;){for(E=I,I=[];++k<f;)E&&E[k].run();k=-1,f=I.length}E=null,R=!1,function(p){if(t===clearTimeout)return clearTimeout(p);if((t===y||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(p);try{t(p)}catch{try{return t.call(null,p)}catch{return t.call(this,p)}}}(g)}}function w(g,f){this.fun=g,this.array=f}function b(){}D.nextTick=function(g){var f=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)f[p-1]=arguments[p];I.push(new w(g,f)),I.length!==1||R||C(T)},w.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=b,D.addListener=b,D.once=b,D.off=b,D.removeListener=b,D.removeAllListeners=b,D.emit=b,D.prependListener=b,D.prependOnceListener=b,D.listeners=function(g){return[]},D.binding=function(g){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(g){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Ie[95],ke([1,0,12,6]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(c){const m=c;return m?typeof m.read=="function":!1}e.isReadable=D;function P(c){const m=c;return m?[m.on,m.pause,m.resume,m.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=P;function y(c){const m=c;return m?P(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=y;function C(c,m){return new E(c,m)}e.newWriteableStream=C;class E{constructor(m,a){this.reducer=m,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(a=>a(m))}emitError(m){this.listeners.error.length===0?(0,u.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(a=>a(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,a){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(m,a){if(this.state.destroyed)return;let d;switch(m){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const r=d.indexOf(a);r>=0&&d.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function I(c,m){const a=[];let d;for(;(d=c.read())!==null;)a.push(d);return m(a)}e.consumeReadable=I;function R(c,m,a){const d=[];let r;for(;(r=c.read())!==null&&d.length<a;)d.push(r);return r===null&&d.length>0?m(d):{read:()=>{if(d.length>0)return d.shift();if(typeof r!="undefined"){const o=r;return r=void 0,o}return c.read()}}}e.peekReadable=R;function k(c,m){return new Promise((a,d)=>{const r=[];_(c,{onData:o=>{m&&r.push(o)},onError:o=>{m?d(o):a(void 0)},onEnd:()=>{a(m?m(r):void 0)}})})}e.consumeStream=k;function _(c,m){let a=!1;return c.on("error",d=>{a||m.onError(d)}),c.on("end",()=>{a||m.onEnd()}),c.on("data",d=>{a||m.onData(d)}),(0,t.toDisposable)(()=>a=!0)}e.listenStream=_;function T(c,m){return new Promise((a,d)=>{const r=new t.DisposableStore,o=[],i=l=>{if(o.push(l),o.length>m)return r.dispose(),c.pause(),a({stream:c,buffer:o,ended:!1})},n=l=>d(l),s=()=>a({stream:c,buffer:o,ended:!0});r.add((0,t.toDisposable)(()=>c.removeListener("error",n))),c.on("error",n),r.add((0,t.toDisposable)(()=>c.removeListener("end",s))),c.on("end",s),r.add((0,t.toDisposable)(()=>c.removeListener("data",i))),c.on("data",i)})}e.peekStream=T;function w(c,m){const a=C(m);return a.end(c),a}e.toStream=w;function b(){const c=C(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=b;function g(c){let m=!1;return{read:()=>m?null:(m=!0,c)}}e.toReadable=g;function f(c,m,a){const d=C(a);return _(c,{onData:r=>d.write(m.data(r)),onError:r=>d.error(m.error?m.error(r):r),onEnd:()=>d.end()}),d}e.transform=f;function p(c,m,a){let d=!1;return{read:()=>{const r=m.read();return d?r:(d=!0,r!==null?a([c,r]):c)}}}e.prefixedReadable=p;function v(c,m,a){let d=!1;const r=C(a);return _(m,{onData:o=>d?r.write(o):(d=!0,r.write(a([c,o]))),onError:o=>r.error(o),onEnd:()=>{d||(d=!0,r.write(c)),r.end()}}),r}e.prefixedStream=v}),define(Ie[23],ke([1,0,95]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let D,P;class y{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return t?new y(Buffer.allocUnsafe(l)):new y(new Uint8Array(l))}static wrap(l){return t&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new y(l)}static fromString(l,h){return!(h?.dontUseNodeBuffer||!1)&&t?new y(Buffer.from(l)):(D||(D=new TextEncoder),new y(D.encode(l)))}static fromByteArray(l){const h=y.alloc(l.length);for(let S=0,L=l.length;S<L;S++)h.buffer[S]=l[S];return h}static concat(l,h){if(typeof h=="undefined"){h=0;for(let M=0,F=l.length;M<F;M++)h+=l[M].byteLength}const S=y.alloc(h);let L=0;for(let M=0,F=l.length;M<F;M++){const A=l[M];S.set(A,L),L+=A.byteLength}return S}clone(){const l=y.alloc(this.byteLength);return l.set(this),l}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(l,h){return new y(this.buffer.subarray(l,h))}set(l,h){if(l instanceof y)this.buffer.set(l.buffer,h);else if(l instanceof Uint8Array)this.buffer.set(l,h);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),h);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return I(this.buffer,l)}writeUInt32BE(l,h){R(this.buffer,l,h)}readUInt32LE(l){return k(this.buffer,l)}writeUInt32LE(l,h){_(this.buffer,l,h)}readUInt8(l){return T(this.buffer,l)}writeUInt8(l,h){w(this.buffer,l,h)}}e.VSBuffer=y;function C(s,l){return s[l+0]<<0>>>0|s[l+1]<<8>>>0}e.readUInt16LE=C;function E(s,l,h){s[h+0]=l&255,l=l>>>8,s[h+1]=l&255}e.writeUInt16LE=E;function I(s,l){return s[l]*2**24+s[l+1]*2**16+s[l+2]*2**8+s[l+3]}e.readUInt32BE=I;function R(s,l,h){s[h+3]=l,l=l>>>8,s[h+2]=l,l=l>>>8,s[h+1]=l,l=l>>>8,s[h]=l}e.writeUInt32BE=R;function k(s,l){return s[l+0]<<0>>>0|s[l+1]<<8>>>0|s[l+2]<<16>>>0|s[l+3]<<24>>>0}e.readUInt32LE=k;function _(s,l,h){s[h+0]=l&255,l=l>>>8,s[h+1]=l&255,l=l>>>8,s[h+2]=l&255,l=l>>>8,s[h+3]=l&255}e.writeUInt32LE=_;function T(s,l){return s[l]}e.readUInt8=T;function w(s,l,h){s[h]=l}e.writeUInt8=w;function b(s){return u.consumeReadable(s,l=>y.concat(l))}e.readableToBuffer=b;function g(s){return u.toReadable(s)}e.bufferToReadable=g;function f(s){return u.consumeStream(s,l=>y.concat(l))}e.streamToBuffer=f;async function p(s){return s.ended?y.concat(s.buffer):y.concat([...s.buffer,await f(s.stream)])}e.bufferedStreamToBuffer=p;function v(s){return u.toStream(s,l=>y.concat(l))}e.bufferToStream=v;function c(s){return u.transform(s,{data:l=>typeof l=="string"?y.fromString(l):y.wrap(l)},l=>y.concat(l))}e.streamToBufferReadableStream=c;function m(s){return u.newWriteableStream(l=>y.concat(l),s)}e.newWriteableBufferStream=m;function a(s,l){return u.prefixedReadable(s,l,h=>y.concat(h))}e.prefixedBufferReadable=a;function d(s,l){return u.prefixedStream(s,l,h=>y.concat(h))}e.prefixedBufferStream=d;function r(s){let l=0,h=0,S=0;const L=new Uint8Array(Math.floor(s.length/4*3)),M=A=>{switch(h){case 3:L[S++]=l|A,h=0;break;case 2:L[S++]=l|A>>>2,l=A<<6,h=3;break;case 1:L[S++]=l|A>>>4,l=A<<4,h=2;break;default:l=A<<2,h=1}};for(let A=0;A<s.length;A++){const B=s.charCodeAt(A);if(B>=65&&B<=90)M(B-65);else if(B>=97&&B<=122)M(B-97+26);else if(B>=48&&B<=57)M(B-48+52);else if(B===43||B===45)M(62);else if(B===47||B===95)M(63);else{if(B===61)break;throw new SyntaxError(`Unexpected base64 character ${s[A]}`)}}const F=S;for(;h>0;)M(0);return y.wrap(L).slice(0,F)}e.decodeBase64=r;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function n({buffer:s},l=!0,h=!1){const S=h?i:o;let L="";const M=s.byteLength%3;let F=0;for(;F<s.byteLength-M;F+=3){const A=s[F+0],B=s[F+1],$=s[F+2];L+=S[A>>>2],L+=S[(A<<4|B>>>4)&63],L+=S[(B<<2|$>>>6)&63],L+=S[$&63]}if(M===1){const A=s[F+0];L+=S[A>>>2],L+=S[A<<4&63],l&&(L+="==")}else if(M===2){const A=s[F+0],B=s[F+1];L+=S[A>>>2],L+=S[(A<<4|B>>>4)&63],L+=S[B<<2&63],l&&(L+="=")}return L}e.encodeBase64=n}),define(Ie[10],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function u(s){return Array.isArray(s)}e.isArray=u;function t(s){return typeof s=="string"}e.isString=t;function D(s){return Array.isArray(s)&&s.every(l=>t(l))}e.isStringArray=D;function P(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=P;function y(s){const l=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof l}e.isTypedArray=y;function C(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=C;function E(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=E;function I(s){return s===!0||s===!1}e.isBoolean=I;function R(s){return typeof s=="undefined"}e.isUndefined=R;function k(s){return!_(s)}e.isDefined=k;function _(s){return R(s)||s===null}e.isUndefinedOrNull=_;function T(s,l){if(!s)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=T;function w(s){if(_(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=w;function b(...s){const l=[];for(let h=0;h<s.length;h++){const S=s[h];if(_(S))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);l.push(S)}return l}e.assertAllDefined=b;const g=Object.prototype.hasOwnProperty;function f(s){if(!P(s))return!1;for(const l in s)if(g.call(s,l))return!1;return!0}e.isEmptyObject=f;function p(s){return typeof s=="function"}e.isFunction=p;function v(...s){return s.length>0&&s.every(p)}e.areFunctions=v;function c(s,l){const h=Math.min(s.length,l.length);for(let S=0;S<h;S++)m(s[S],l[S])}e.validateConstraints=c;function m(s,l){if(t(l)){if(typeof s!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(p(l)){try{if(s instanceof l)return}catch{}if(!_(s)&&s.constructor===l||l.length===1&&l.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=m;function a(s){let l=[],h=Object.getPrototypeOf(s);for(;Object.prototype!==h;)l=l.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return l}e.getAllPropertyNames=a;function d(s){const l=[];for(const h of a(s))typeof s[h]=="function"&&l.push(h);return l}e.getAllMethodNames=d;function r(s,l){const h=L=>function(){const M=Array.prototype.slice.call(arguments,0);return l(L,M)},S={};for(const L of s)S[L]=h(L);return S}e.createProxyObject=r;function o(s){return s===null?void 0:s}e.withNullAsUndefined=o;function i(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=i;function n(s,l="Unreachable"){throw new Error(l)}e.assertNever=n}),define(Ie[24],ke([1,0,10]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const b=Array.isArray(w)?[]:{};return Object.keys(w).forEach(g=>{w[g]&&typeof w[g]=="object"?b[g]=t(w[g]):b[g]=w[g]}),b}e.deepClone=t;function D(w){if(!w||typeof w!="object")return w;const b=[w];for(;b.length>0;){const g=b.shift();Object.freeze(g);for(const f in g)if(P.call(g,f)){const p=g[f];typeof p=="object"&&!Object.isFrozen(p)&&!(0,u.isTypedArray)(p)&&b.push(p)}}return w}e.deepFreeze=D;const P=Object.prototype.hasOwnProperty;function y(w,b){return C(w,b,new Set)}e.cloneAndChange=y;function C(w,b,g){if((0,u.isUndefinedOrNull)(w))return w;const f=b(w);if(typeof f!="undefined")return f;if((0,u.isArray)(w)){const p=[];for(const v of w)p.push(C(v,b,g));return p}if((0,u.isObject)(w)){if(g.has(w))throw new Error("Cannot clone recursive data-structure");g.add(w);const p={};for(const v in w)P.call(w,v)&&(p[v]=C(w[v],b,g));return g.delete(w),p}return w}function E(w,b,g=!0){return(0,u.isObject)(w)?((0,u.isObject)(b)&&Object.keys(b).forEach(f=>{f in w?g&&((0,u.isObject)(w[f])&&(0,u.isObject)(b[f])?E(w[f],b[f],g):w[f]=b[f]):w[f]=b[f]}),w):b}e.mixin=E;function I(w,b){if(w===b)return!0;if(w==null||b===null||b===void 0||typeof w!=typeof b||typeof w!="object"||Array.isArray(w)!==Array.isArray(b))return!1;let g,f;if(Array.isArray(w)){if(w.length!==b.length)return!1;for(g=0;g<w.length;g++)if(!I(w[g],b[g]))return!1}else{const p=[];for(f in w)p.push(f);p.sort();const v=[];for(f in b)v.push(f);if(v.sort(),!I(p,v))return!1;for(g=0;g<p.length;g++)if(!I(w[p[g]],b[p[g]]))return!1}return!0}e.equals=I;function R(w){const b=new Set;return JSON.stringify(w,(g,f)=>{if((0,u.isObject)(f)||Array.isArray(f)){if(b.has(f))return"[Circular]";b.add(f)}return f})}e.safeStringify=R;function k(w,b){const g=Object.create(null);return!w||!b||Object.keys(b).forEach(p=>{const v=w[p],c=b[p];I(v,c)||(g[p]=c)}),g}e.distinct=k;function _(w,b){const g=b.toLowerCase(),f=Object.keys(w).find(p=>p.toLowerCase()===g);return f?w[f]:w[b]}e.getCaseInsensitive=_;function T(w,b){const g=Object.create(null);for(const[f,p]of Object.entries(w))b(f,p)&&(g[f]=p);return g}e.filter=T}),define(Ie[96],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var u;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(u=e.Constants||(e.Constants={}));function t(P){return P<0?0:P>255?255:P|0}e.toUint8=t;function D(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=D}),define(Ie[34],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return u.test(D)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(C){for(let E=0;E<C.length;E++)C[E]=Math.floor(Math.random()*256);return C};const P=new Uint8Array(16),y=[];for(let C=0;C<256;C++)y.push(C.toString(16).padStart(2,"0"));return function(){D(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let E=0,I="";return I+=y[P[E++]],I+=y[P[E++]],I+=y[P[E++]],I+=y[P[E++]],I+="-",I+=y[P[E++]],I+=y[P[E++]],I+="-",I+=y[P[E++]],I+=y[P[E++]],I+="-",I+=y[P[E++]],I+=y[P[E++]],I+="-",I+=y[P[E++]],I+=y[P[E++]],I+=y[P[E++]],I+=y[P[E++]],I+=y[P[E++]],I+=y[P[E++]],I}}()}),define(Ie[144],ke([1,0,97]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(P="utf8"){this.stringDecoder=new u.StringDecoder(P),this.remaining=null}write(P){const y=[],C=this.remaining?this.remaining+this.stringDecoder.write(P):this.stringDecoder.write(P);if(C.length<1)return y;let E=0,I,R=E;for(;R<C.length;)if(I=C.charCodeAt(R),I===13||I===10){if(y.push(C.substring(E,R)),R++,R<C.length){const k=I;I=C.charCodeAt(R),(k===13&&I===10||k===10&&I===13)&&R++}E=R}else R++;return this.remaining=E<C.length?C.substr(E):null,y}end(){return this.remaining}}e.LineDecoder=t}),define(Ie[98],ke([1,0,96]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(C){const E=(0,u.toUint8)(C);this._defaultValue=E,this._asciiMap=t._createAsciiMap(E),this._map=new Map}static _createAsciiMap(C){const E=new Uint8Array(256);for(let I=0;I<256;I++)E[I]=C;return E}set(C,E){const I=(0,u.toUint8)(E);C>=0&&C<256?this._asciiMap[C]=I:this._map.set(C,I)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=t;var D;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(D||(D={}));class P{constructor(){this._actual=new t(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=P}),define(Ie[48],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class u{constructor(D,P){this.lineNumber=D,this.column=P}with(D=this.lineNumber,P=this.column){return D===this.lineNumber&&P===this.column?this:new u(D,P)}delta(D=0,P=0){return this.with(this.lineNumber+D,this.column+P)}equals(D){return u.equals(this,D)}static equals(D,P){return!D&&!P?!0:!!D&&!!P&&D.lineNumber===P.lineNumber&&D.column===P.column}isBefore(D){return u.isBefore(this,D)}static isBefore(D,P){return D.lineNumber<P.lineNumber?!0:P.lineNumber<D.lineNumber?!1:D.column<P.column}isBeforeOrEqual(D){return u.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,P){return D.lineNumber<P.lineNumber?!0:P.lineNumber<D.lineNumber?!1:D.column<=P.column}static compare(D,P){const y=D.lineNumber|0,C=P.lineNumber|0;if(y===C){const E=D.column|0,I=P.column|0;return E-I}return y-C}clone(){return new u(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new u(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=u}),define(Ie[35],ke([1,0,48]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(P,y,C,E){P>C||P===C&&y>E?(this.startLineNumber=C,this.startColumn=E,this.endLineNumber=P,this.endColumn=y):(this.startLineNumber=P,this.startColumn=y,this.endLineNumber=C,this.endColumn=E)}isEmpty(){return t.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return t.containsPosition(this,P)}static containsPosition(P,y){return!(y.lineNumber<P.startLineNumber||y.lineNumber>P.endLineNumber||y.lineNumber===P.startLineNumber&&y.column<P.startColumn||y.lineNumber===P.endLineNumber&&y.column>P.endColumn)}static strictContainsPosition(P,y){return!(y.lineNumber<P.startLineNumber||y.lineNumber>P.endLineNumber||y.lineNumber===P.startLineNumber&&y.column<=P.startColumn||y.lineNumber===P.endLineNumber&&y.column>=P.endColumn)}containsRange(P){return t.containsRange(this,P)}static containsRange(P,y){return!(y.startLineNumber<P.startLineNumber||y.endLineNumber<P.startLineNumber||y.startLineNumber>P.endLineNumber||y.endLineNumber>P.endLineNumber||y.startLineNumber===P.startLineNumber&&y.startColumn<P.startColumn||y.endLineNumber===P.endLineNumber&&y.endColumn>P.endColumn)}strictContainsRange(P){return t.strictContainsRange(this,P)}static strictContainsRange(P,y){return!(y.startLineNumber<P.startLineNumber||y.endLineNumber<P.startLineNumber||y.startLineNumber>P.endLineNumber||y.endLineNumber>P.endLineNumber||y.startLineNumber===P.startLineNumber&&y.startColumn<=P.startColumn||y.endLineNumber===P.endLineNumber&&y.endColumn>=P.endColumn)}plusRange(P){return t.plusRange(this,P)}static plusRange(P,y){let C,E,I,R;return y.startLineNumber<P.startLineNumber?(C=y.startLineNumber,E=y.startColumn):y.startLineNumber===P.startLineNumber?(C=y.startLineNumber,E=Math.min(y.startColumn,P.startColumn)):(C=P.startLineNumber,E=P.startColumn),y.endLineNumber>P.endLineNumber?(I=y.endLineNumber,R=y.endColumn):y.endLineNumber===P.endLineNumber?(I=y.endLineNumber,R=Math.max(y.endColumn,P.endColumn)):(I=P.endLineNumber,R=P.endColumn),new t(C,E,I,R)}intersectRanges(P){return t.intersectRanges(this,P)}static intersectRanges(P,y){let C=P.startLineNumber,E=P.startColumn,I=P.endLineNumber,R=P.endColumn;const k=y.startLineNumber,_=y.startColumn,T=y.endLineNumber,w=y.endColumn;return C<k?(C=k,E=_):C===k&&(E=Math.max(E,_)),I>T?(I=T,R=w):I===T&&(R=Math.min(R,w)),C>I||C===I&&E>R?null:new t(C,E,I,R)}equalsRange(P){return t.equalsRange(this,P)}static equalsRange(P,y){return!!P&&!!y&&P.startLineNumber===y.startLineNumber&&P.startColumn===y.startColumn&&P.endLineNumber===y.endLineNumber&&P.endColumn===y.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(P){return new u.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(P){return new u.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,y){return new t(this.startLineNumber,this.startColumn,P,y)}setStartPosition(P,y){return new t(P,y,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(P){return new t(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,y=P){return new t(P.lineNumber,P.column,y.lineNumber,y.column)}static lift(P){return P?new t(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,y){return!(P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<y.startColumn||y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<P.startColumn)}static areIntersecting(P,y){return!(P.endLineNumber<y.startLineNumber||P.endLineNumber===y.startLineNumber&&P.endColumn<=y.startColumn||y.endLineNumber<P.startLineNumber||y.endLineNumber===P.startLineNumber&&y.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,y){if(P&&y){const I=P.startLineNumber|0,R=y.startLineNumber|0;if(I===R){const k=P.startColumn|0,_=y.startColumn|0;if(k===_){const T=P.endLineNumber|0,w=y.endLineNumber|0;if(T===w){const b=P.endColumn|0,g=y.endColumn|0;return b-g}return T-w}return k-_}return I-R}return(P?1:0)-(y?1:0)}static compareRangesUsingEnds(P,y){return P.endLineNumber===y.endLineNumber?P.endColumn===y.endColumn?P.startLineNumber===y.startLineNumber?P.startColumn-y.startColumn:P.startLineNumber-y.startLineNumber:P.endColumn-y.endColumn:P.endLineNumber-y.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=t}),define(Ie[145],ke([1,0,48,35]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class P extends t.Range{constructor(C,E,I,R){super(C,E,I,R);this.selectionStartLineNumber=C,this.selectionStartColumn=E,this.positionLineNumber=I,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return P.selectionsEqual(this,C)}static selectionsEqual(C,E){return C.selectionStartLineNumber===E.selectionStartLineNumber&&C.selectionStartColumn===E.selectionStartColumn&&C.positionLineNumber===E.positionLineNumber&&C.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,E){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,C,E):new P(C,E,this.startLineNumber,this.startColumn)}getPosition(){return new u.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new u.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(C,E){return this.getDirection()===0?new P(C,E,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,C,E)}static fromPositions(C,E=C){return new P(C.lineNumber,C.column,E.lineNumber,E.column)}static fromRange(C,E){return E===0?new P(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):new P(C.endLineNumber,C.endColumn,C.startLineNumber,C.startColumn)}static liftSelection(C){return new P(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,E){if(C&&!E||!C&&E)return!1;if(!C&&!E)return!0;if(C.length!==E.length)return!1;for(let I=0,R=C.length;I<R;I++)if(!this.selectionsEqual(C[I],E[I]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,E,I,R,k){return k===0?new P(C,E,I,R):new P(I,R,C,E)}}e.Selection=P}),define(Ie[146],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[147],ke([1,0,98]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends u.CharacterClassifier{constructor(C){super(0);for(let E=0,I=C.length;E<I;E++)this.set(C.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function P(y){const C={};return E=>(C.hasOwnProperty(E)||(C[E]=y(E)),C[E])}e.getMapForWordSeparators=P(y=>new D(y))}),define(Ie[99],ke([1,0,59,6,79]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(k=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)k.indexOf(T)>=0||(_+="\\"+T);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=P();function y(k){let _=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)_=k;else{let T="g";k.ignoreCase&&(T+="i"),k.multiline&&(T+="m"),k.unicode&&(T+="u"),_=new RegExp(k.source,T)}return _.lastIndex=0,_}e.ensureValidWordDefinition=y;const C=new D.LinkedList;C.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(k){const _=C.unshift(k);return(0,t.toDisposable)(_)}e.setDefaultGetWordAtTextConfig=E;function I(k,_,T,w,b){if(b||(b=u.Iterable.first(C)),T.length>b.maxLen){let c=k-b.maxLen/2;return c<0?c=0:w+=c,T=T.substring(c,k+b.maxLen/2),I(k,_,T,w,b)}const g=Date.now(),f=k-1-w;let p=-1,v=null;for(let c=1;!(Date.now()-g>=b.timeBudget);c++){const m=f-b.windowSize*c;_.lastIndex=Math.max(0,m);const a=R(_,T,f,p);if(!a&&v||(v=a,m<=0))break;p=m}if(v){const c={word:v[0],startColumn:w+1+v.index,endColumn:w+1+v.index+v[0].length};return _.lastIndex=0,c}return null}e.getWordAtText=I;function R(k,_,T,w){let b;for(;b=k.exec(_);){const g=b.index||0;if(g<=T&&k.lastIndex>=T)return b;if(w>0&&g>w)return null}return null}}),define(Ie[148],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var u;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(u=e.IndentAction||(e.IndentAction={}));class t{constructor(C){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=C.open,this.close=C.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(C.notIn))for(let E=0,I=C.notIn.length;E<I;E++)switch(C.notIn[E]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(C){switch(C){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(C,E){if(C.getTokenCount()===0)return!0;const I=C.findTokenIndexAtOffset(E-2),R=C.getStandardTokenType(I);return this.isOK(R)}_findNeutralCharacterInRange(C,E){for(let I=C;I<=E;I++){const R=String.fromCharCode(I);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class D{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of C)P(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),P(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),P(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),P(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&P(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=D;function P(y,C,E){y.has(C)?y.get(C).push(E):y.set(C,[E])}}),define(Ie[149],ke([1,0,98]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(T){T[T.Invalid=0]="Invalid",T[T.Start=1]="Start",T[T.H=2]="H",T[T.HT=3]="HT",T[T.HTT=4]="HTT",T[T.HTTP=5]="HTTP",T[T.F=6]="F",T[T.FI=7]="FI",T[T.FIL=8]="FIL",T[T.BeforeColon=9]="BeforeColon",T[T.AfterColon=10]="AfterColon",T[T.AlmostThere=11]="AlmostThere",T[T.End=12]="End",T[T.Accept=13]="Accept",T[T.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class D{constructor(w,b,g){const f=new Uint8Array(w*b);for(let p=0,v=w*b;p<v;p++)f[p]=g;this._data=f,this.rows=w,this.cols=b}get(w,b){return this._data[w*this.cols+b]}set(w,b,g){this._data[w*this.cols+b]=g}}e.Uint8Matrix=D;class P{constructor(w){let b=0,g=0;for(let p=0,v=w.length;p<v;p++){const[c,m,a]=w[p];m>b&&(b=m),c>g&&(g=c),a>g&&(g=a)}b++,g++;const f=new D(g,b,0);for(let p=0,v=w.length;p<v;p++){const[c,m,a]=w[p];f.set(c,m,a)}this._states=f,this._maxCharCode=b}nextState(w,b){return b<0||b>=this._maxCharCode?0:this._states.get(w,b)}}e.StateMachine=P;let y=null;function C(){return y===null&&(y=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var E;(function(T){T[T.None=0]="None",T[T.ForceTermination=1]="ForceTermination",T[T.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let I=null;function R(){if(I===null){I=new u.CharacterClassifier(0);const T=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let b=0;b<T.length;b++)I.set(T.charCodeAt(b),1);const w=".,;:";for(let b=0;b<w.length;b++)I.set(w.charCodeAt(b),2)}return I}class k{static _createLink(w,b,g,f,p){let v=p-1;do{const c=b.charCodeAt(v);if(w.get(c)!==2)break;v--}while(v>f);if(f>0){const c=b.charCodeAt(f-1),m=b.charCodeAt(v);(c===40&&m===41||c===91&&m===93||c===123&&m===125)&&v--}return{range:{startLineNumber:g,startColumn:f+1,endLineNumber:g,endColumn:v+2},url:b.substring(f,v+1)}}static computeLinks(w,b=C()){const g=R(),f=[];for(let p=1,v=w.getLineCount();p<=v;p++){const c=w.getLineContent(p),m=c.length;let a=0,d=0,r=0,o=1,i=!1,n=!1,s=!1,l=!1;for(;a<m;){let h=!1;const S=c.charCodeAt(a);if(o===13){let L;switch(S){case 40:i=!0,L=0;break;case 41:L=i?0:1;break;case 91:s=!0,n=!0,L=0;break;case 93:s=!1,L=n?0:1;break;case 123:l=!0,L=0;break;case 125:L=l?0:1;break;case 39:L=r===39?1:0;break;case 34:L=r===34?1:0;break;case 96:L=r===96?1:0;break;case 42:L=r===42?1:0;break;case 124:L=r===124?1:0;break;case 32:L=s?0:1;break;default:L=g.get(S)}L===1&&(f.push(k._createLink(g,c,p,d,a)),h=!0)}else if(o===12){let L;S===91?(n=!0,L=0):L=g.get(S),L===1?h=!0:o=13}else o=b.nextState(o,S),o===0&&(h=!0);h&&(o=1,i=!1,n=!1,l=!1,d=a+1,r=S),a++}o===13&&f.push(k._createLink(g,c,p,d,m))}return f}}e.LinkComputer=k;function _(T){return!T||typeof T.getLineCount!="function"||typeof T.getLineContent!="function"?[]:k.computeLinks(T)}e.computeLinks=_}),define(Ie[100],ke([1,0,24]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var D;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(D=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(p){p[p.Both=0]="Both",p[p.Right=1]="Right",p[p.Left=2]="Left",p[p.None=3]="None"})(P=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var y;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(y=e.EndOfLinePreference||(e.EndOfLinePreference={}));var C;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(C=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var E;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(E=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{constructor(v){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,v.tabSize|0),this.indentSize=v.tabSize|0,this.insertSpaces=Boolean(v.insertSpaces),this.defaultEOL=v.defaultEOL|0,this.trimAutoWhitespace=Boolean(v.trimAutoWhitespace),this.bracketPairColorizationOptions=v.bracketPairColorizationOptions}equals(v){return this.tabSize===v.tabSize&&this.indentSize===v.indentSize&&this.insertSpaces===v.insertSpaces&&this.defaultEOL===v.defaultEOL&&this.trimAutoWhitespace===v.trimAutoWhitespace&&(0,u.equals)(this.bracketPairColorizationOptions,v.bracketPairColorizationOptions)}createChangeEvent(v){return{tabSize:this.tabSize!==v.tabSize,indentSize:this.indentSize!==v.indentSize,insertSpaces:this.insertSpaces!==v.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==v.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class R{constructor(v,c){this._findMatchBrand=void 0,this.range=v,this.matches=c}}e.FindMatch=R;var k;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var _;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None",p[p.LeftOfInjectedText=3]="LeftOfInjectedText",p[p.RightOfInjectedText=4]="RightOfInjectedText"})(_=e.PositionAffinity||(e.PositionAffinity={}));var T;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(T=e.ModelConstants||(e.ModelConstants={}));class w{constructor(v,c,m,a,d,r){this.identifier=v,this.range=c,this.text=m,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=d,this._isTracked=r}}e.ValidAnnotatedEditOperation=w;class b{constructor(v,c,m){this.regex=v,this.wordSeparators=c,this.simpleSearch=m}}e.SearchData=b;class g{constructor(v,c,m){this.reverseEdits=v,this.changes=c,this.trimAutoWhitespaceLineNumbers=m}}e.ApplyEditsResult=g;function f(p){return!p.isTooLargeForSyncing()&&!p.isForSimpleWidget}e.shouldSynchronizeModel=f}),define(Ie[150],ke([1,0,16,96]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class D{constructor(E){this.values=E,this.prefixSum=new Uint32Array(E.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(E,I){E=(0,t.toUint32)(E);const R=this.values,k=this.prefixSum,_=I.length;return _===0?!1:(this.values=new Uint32Array(R.length+_),this.values.set(R.subarray(0,E),0),this.values.set(R.subarray(E),E+_),this.values.set(I,E),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(E,I){return E=(0,t.toUint32)(E),I=(0,t.toUint32)(I),this.values[E]===I?!1:(this.values[E]=I,E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),!0)}removeValues(E,I){E=(0,t.toUint32)(E),I=(0,t.toUint32)(I);const R=this.values,k=this.prefixSum;if(E>=R.length)return!1;const _=R.length-E;return I>=_&&(I=_),I===0?!1:(this.values=new Uint32Array(R.length-I),this.values.set(R.subarray(0,E),0),this.values.set(R.subarray(E+I),E),this.prefixSum=new Uint32Array(this.values.length),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(E){return E<0?0:(E=(0,t.toUint32)(E),this._getPrefixSum(E))}_getPrefixSum(E){if(E<=this.prefixSumValidIndex[0])return this.prefixSum[E];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),E>=this.values.length&&(E=this.values.length-1);for(let R=I;R<=E;R++)this.prefixSum[R]=this.prefixSum[R-1]+this.values[R];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],E),this.prefixSum[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let I=0,R=this.values.length-1,k=0,_=0,T=0;for(;I<=R;)if(k=I+(R-I)/2|0,_=this.prefixSum[k],T=_-this.values[k],E<T)R=k-1;else if(E>=_)I=k+1;else break;return new y(k,E-T)}}e.PrefixSumComputer=D;class P{constructor(E){this._values=E,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(E){return this._ensureValid(),E===0?0:this._prefixSum[E-1]}getIndexOf(E){this._ensureValid();const I=this._indexBySum[E],R=I>0?this._prefixSum[I-1]:0;return new y(I,E-R)}removeValues(E,I){this._values.splice(E,I),this._invalidate(E)}insertValues(E,I){this._values=(0,u.arrayInsert)(this._values,E,I),this._invalidate(E)}_invalidate(E){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,E-1)}_ensureValid(){if(!this._isValid){for(let E=this._validEndIndex+1,I=this._values.length;E<I;E++){const R=this._values[E],k=E>0?this._prefixSum[E-1]:0;this._prefixSum[E]=k+R;for(let _=0;_<R;_++)this._indexBySum[k+_]=E}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(E,I){this._values[E]!==I&&(this._values[E]=I,this._invalidate(E))}}e.ConstantTimePrefixSumComputer=P;class y{constructor(E,I){this.index=E,this.remainder=I,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=I}}e.PrefixSumIndexOfResult=y}),define(Ie[151],ke([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(Ie[152],ke([1,0,151]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,D=t*60,P=D*24,y=P*7,C=P*30,E=P*365;function I(k,_,T){typeof k!="number"&&(k=k.getTime());const w=Math.round((new Date().getTime()-k)/1e3);if(w<-30)return(0,u.localize)(0,null,I(new Date().getTime()+w*1e3,!1));if(w<30)return(0,u.localize)(1,null);let b;return w<t?(b=w,_?b===1?T?(0,u.localize)(2,null,b):(0,u.localize)(3,null,b):T?(0,u.localize)(4,null,b):(0,u.localize)(5,null,b):b===1?T?(0,u.localize)(6,null,b):(0,u.localize)(7,null,b):T?(0,u.localize)(8,null,b):(0,u.localize)(9,null,b)):w<D?(b=Math.floor(w/t),_?b===1?T?(0,u.localize)(10,null,b):(0,u.localize)(11,null,b):T?(0,u.localize)(12,null,b):(0,u.localize)(13,null,b):b===1?T?(0,u.localize)(14,null,b):(0,u.localize)(15,null,b):T?(0,u.localize)(16,null,b):(0,u.localize)(17,null,b)):w<P?(b=Math.floor(w/D),_?b===1?T?(0,u.localize)(18,null,b):(0,u.localize)(19,null,b):T?(0,u.localize)(20,null,b):(0,u.localize)(21,null,b):b===1?T?(0,u.localize)(22,null,b):(0,u.localize)(23,null,b):T?(0,u.localize)(24,null,b):(0,u.localize)(25,null,b)):w<y?(b=Math.floor(w/P),_?b===1?(0,u.localize)(26,null,b):(0,u.localize)(27,null,b):b===1?(0,u.localize)(28,null,b):(0,u.localize)(29,null,b)):w<C?(b=Math.floor(w/y),_?b===1?T?(0,u.localize)(30,null,b):(0,u.localize)(31,null,b):T?(0,u.localize)(32,null,b):(0,u.localize)(33,null,b):b===1?T?(0,u.localize)(34,null,b):(0,u.localize)(35,null,b):T?(0,u.localize)(36,null,b):(0,u.localize)(37,null,b)):w<E?(b=Math.floor(w/C),_?b===1?T?(0,u.localize)(38,null,b):(0,u.localize)(39,null,b):T?(0,u.localize)(40,null,b):(0,u.localize)(41,null,b):b===1?T?(0,u.localize)(42,null,b):(0,u.localize)(43,null,b):T?(0,u.localize)(44,null,b):(0,u.localize)(45,null,b)):(b=Math.floor(w/E),_?b===1?T?(0,u.localize)(46,null,b):(0,u.localize)(47,null,b):T?(0,u.localize)(48,null,b):(0,u.localize)(49,null,b):b===1?T?(0,u.localize)(50,null,b):(0,u.localize)(51,null,b):T?(0,u.localize)(52,null,b):(0,u.localize)(53,null,b))}e.fromNow=I;function R(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Ie[153],ke([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(Ie[49],ke([1,0,16,10,153]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(k,_){return _&&(k.stack||k.stacktrace)?D.localize(0,null,C(k),y(k.stack)||y(k.stacktrace)):C(k)}function y(k){return Array.isArray(k)?k.join(`
`):k}function C(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?D.localize(1,null,k.message):k.message||D.localize(2,null)}function E(k=null,_=!1){if(!k)return D.localize(3,null);if(Array.isArray(k)){const T=u.coalesce(k),w=E(T[0],_);return T.length>1?D.localize(4,null,w,T.length):w}if(t.isString(k))return k;if(k.detail){const T=k.detail;if(T.error)return P(T.error,_);if(T.exception)return P(T.exception,_)}return k.stack?P(k,_):k.message?k.message:D.localize(5,null)}e.toErrorMessage=E;function I(k){const _=k;return _ instanceof Error&&Array.isArray(_.actions)}e.isErrorWithActions=I;function R(k,_){let T;return typeof k=="string"?T=new Error(k):T=k,T.actions=_,T}e.createErrorWithActions=R}),define(Ie[154],ke([19,20]),function(Y,e){return Y.create("vs/base/common/platform",e)}),define(Ie[13],ke([1,0,154]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let D=!1,P=!1,y=!1,C=!1,E=!1,I=!1,R=!1,k=!1,_=!1,T,w=t,b,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const p=typeof f?.versions?.electron=="string",v=p&&f?.type==="renderer";if(typeof navigator=="object"&&!v)g=navigator.userAgent,D=g.indexOf("Windows")>=0,P=g.indexOf("Macintosh")>=0,k=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=g.indexOf("Linux")>=0,I=!0,T=u.getConfiguredDefaultLocale(u.localize(0,null))||t,w=T;else if(typeof f=="object"){D=f.platform==="win32",P=f.platform==="darwin",y=f.platform==="linux",C=y&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,R=p,_=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,T=t,w=t;const s=f.env.VSCODE_NLS_CONFIG;if(s)try{const l=JSON.parse(s),h=l.availableLanguages["*"];T=l.locale,w=h||t,b=l._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var c;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(c=e.Platform||(e.Platform={}));function m(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let a=0;P?a=1:D?a=3:y&&(a=2),e.isWindows=D,e.isMacintosh=P,e.isLinux=y,e.isLinuxSnap=C,e.isNative=E,e.isElectron=R,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=k,e.isCI=_,e.platform=a,e.userAgent=g,e.language=w;var d;(function(s){function l(){return e.language}s.value=l;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=h;function S(){return e.language==="en"}s.isDefault=S})(d=e.Language||(e.Language={})),e.locale=T,e.translationsConfigFile=b,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let S=0,L=s.length;S<L;S++){const M=s[S];if(M.id===h.data.vscodeScheduleAsyncWork){s.splice(S,1),M.callback();return}}});let l=0;return h=>{const S=++l;s.push({id:S,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:S},"*")}}return s=>setTimeout(s)})();var r;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||k?2:D?1:3;let o=!0,i=!1;function n(){if(!i){i=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,o=new Uint16Array(s.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=n,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Ie[40],ke([1,0,13]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof u.globals.vscode!="undefined"&&typeof u.globals.vscode.process!="undefined"){const D=u.globals.vscode.process;t={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return u.isWindows?"win32":u.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Ie[9],ke([1,0,40]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,D=97,P=90,y=122,C=46,E=47,I=92,R=58,k=63;class _ extends Error{constructor(c,m,a){let d;typeof m=="string"&&m.indexOf("not ")===0?(d="must not be",m=m.replace(/^not /,"")):d="must be";const r=c.indexOf(".")!==-1?"property":"argument";let o=`The "${c}" ${r} ${d} of type ${m}`;o+=`. Received type ${typeof a}`;super(o);this.code="ERR_INVALID_ARG_TYPE"}}function T(v,c){if(typeof v!="string")throw new _(c,"string",v)}function w(v){return v===E||v===I}function b(v){return v===E}function g(v){return v>=t&&v<=P||v>=D&&v<=y}function f(v,c,m,a){let d="",r=0,o=-1,i=0,n=0;for(let s=0;s<=v.length;++s){if(s<v.length)n=v.charCodeAt(s);else{if(a(n))break;n=E}if(a(n)){if(!(o===s-1||i===1))if(i===2){if(d.length<2||r!==2||d.charCodeAt(d.length-1)!==C||d.charCodeAt(d.length-2)!==C){if(d.length>2){const l=d.lastIndexOf(m);l===-1?(d="",r=0):(d=d.slice(0,l),r=d.length-1-d.lastIndexOf(m)),o=s,i=0;continue}else if(d.length!==0){d="",r=0,o=s,i=0;continue}}c&&(d+=d.length>0?`${m}..`:"..",r=2)}else d.length>0?d+=`${m}${v.slice(o+1,s)}`:d=v.slice(o+1,s),r=s-o-1;o=s,i=0}else n===C&&i!==-1?++i:i=-1}return d}function p(v,c){if(c===null||typeof c!="object")throw new _("pathObject","Object",c);const m=c.dir||c.root,a=c.base||`${c.name||""}${c.ext||""}`;return m?m===c.root?`${m}${a}`:`${m}${v}${a}`:a}e.win32={resolve(...v){let c="",m="",a=!1;for(let d=v.length-1;d>=-1;d--){let r;if(d>=0){if(r=v[d],T(r,"path"),r.length===0)continue}else c.length===0?r=u.cwd():(r=u.env[`=${c}`]||u.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==c.toLowerCase()&&r.charCodeAt(2)===I)&&(r=`${c}\\`));const o=r.length;let i=0,n="",s=!1;const l=r.charCodeAt(0);if(o===1)w(l)&&(i=1,s=!0);else if(w(l))if(s=!0,w(r.charCodeAt(1))){let h=2,S=h;for(;h<o&&!w(r.charCodeAt(h));)h++;if(h<o&&h!==S){const L=r.slice(S,h);for(S=h;h<o&&w(r.charCodeAt(h));)h++;if(h<o&&h!==S){for(S=h;h<o&&!w(r.charCodeAt(h));)h++;(h===o||h!==S)&&(n=`\\\\${L}\\${r.slice(S,h)}`,i=h)}}}else i=1;else g(l)&&r.charCodeAt(1)===R&&(n=r.slice(0,2),i=2,o>2&&w(r.charCodeAt(2))&&(s=!0,i=3));if(n.length>0)if(c.length>0){if(n.toLowerCase()!==c.toLowerCase())continue}else c=n;if(a){if(c.length>0)break}else if(m=`${r.slice(i)}\\${m}`,a=s,s&&c.length>0)break}return m=f(m,!a,"\\",w),a?`${c}\\${m}`:`${c}${m}`||"."},normalize(v){T(v,"path");const c=v.length;if(c===0)return".";let m=0,a,d=!1;const r=v.charCodeAt(0);if(c===1)return b(r)?"\\":v;if(w(r))if(d=!0,w(v.charCodeAt(1))){let i=2,n=i;for(;i<c&&!w(v.charCodeAt(i));)i++;if(i<c&&i!==n){const s=v.slice(n,i);for(n=i;i<c&&w(v.charCodeAt(i));)i++;if(i<c&&i!==n){for(n=i;i<c&&!w(v.charCodeAt(i));)i++;if(i===c)return`\\\\${s}\\${v.slice(n)}\\`;i!==n&&(a=`\\\\${s}\\${v.slice(n,i)}`,m=i)}}}else m=1;else g(r)&&v.charCodeAt(1)===R&&(a=v.slice(0,2),m=2,c>2&&w(v.charCodeAt(2))&&(d=!0,m=3));let o=m<c?f(v.slice(m),!d,"\\",w):"";return o.length===0&&!d&&(o="."),o.length>0&&w(v.charCodeAt(c-1))&&(o+="\\"),a===void 0?d?`\\${o}`:o:d?`${a}\\${o}`:`${a}${o}`},isAbsolute(v){T(v,"path");const c=v.length;if(c===0)return!1;const m=v.charCodeAt(0);return w(m)||c>2&&g(m)&&v.charCodeAt(1)===R&&w(v.charCodeAt(2))},join(...v){if(v.length===0)return".";let c,m;for(let r=0;r<v.length;++r){const o=v[r];T(o,"path"),o.length>0&&(c===void 0?c=m=o:c+=`\\${o}`)}if(c===void 0)return".";let a=!0,d=0;if(typeof m=="string"&&w(m.charCodeAt(0))){++d;const r=m.length;r>1&&w(m.charCodeAt(1))&&(++d,r>2&&(w(m.charCodeAt(2))?++d:a=!1))}if(a){for(;d<c.length&&w(c.charCodeAt(d));)d++;d>=2&&(c=`\\${c.slice(d)}`)}return e.win32.normalize(c)},relative(v,c){if(T(v,"from"),T(c,"to"),v===c)return"";const m=e.win32.resolve(v),a=e.win32.resolve(c);if(m===a||(v=m.toLowerCase(),c=a.toLowerCase(),v===c))return"";let d=0;for(;d<v.length&&v.charCodeAt(d)===I;)d++;let r=v.length;for(;r-1>d&&v.charCodeAt(r-1)===I;)r--;const o=r-d;let i=0;for(;i<c.length&&c.charCodeAt(i)===I;)i++;let n=c.length;for(;n-1>i&&c.charCodeAt(n-1)===I;)n--;const s=n-i,l=o<s?o:s;let h=-1,S=0;for(;S<l;S++){const M=v.charCodeAt(d+S);if(M!==c.charCodeAt(i+S))break;M===I&&(h=S)}if(S!==l){if(h===-1)return a}else{if(s>l){if(c.charCodeAt(i+S)===I)return a.slice(i+S+1);if(S===2)return a.slice(i+S)}o>l&&(v.charCodeAt(d+S)===I?h=S:S===2&&(h=3)),h===-1&&(h=0)}let L="";for(S=d+h+1;S<=r;++S)(S===r||v.charCodeAt(S)===I)&&(L+=L.length===0?"..":"\\..");return i+=h,L.length>0?`${L}${a.slice(i,n)}`:(a.charCodeAt(i)===I&&++i,a.slice(i,n))},toNamespacedPath(v){if(typeof v!="string")return v;if(v.length===0)return"";const c=e.win32.resolve(v);if(c.length<=2)return v;if(c.charCodeAt(0)===I){if(c.charCodeAt(1)===I){const m=c.charCodeAt(2);if(m!==k&&m!==C)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(g(c.charCodeAt(0))&&c.charCodeAt(1)===R&&c.charCodeAt(2)===I)return`\\\\?\\${c}`;return v},dirname(v){T(v,"path");const c=v.length;if(c===0)return".";let m=-1,a=0;const d=v.charCodeAt(0);if(c===1)return w(d)?v:".";if(w(d)){if(m=a=1,w(v.charCodeAt(1))){let i=2,n=i;for(;i<c&&!w(v.charCodeAt(i));)i++;if(i<c&&i!==n){for(n=i;i<c&&w(v.charCodeAt(i));)i++;if(i<c&&i!==n){for(n=i;i<c&&!w(v.charCodeAt(i));)i++;if(i===c)return v;i!==n&&(m=a=i+1)}}}}else g(d)&&v.charCodeAt(1)===R&&(m=c>2&&w(v.charCodeAt(2))?3:2,a=m);let r=-1,o=!0;for(let i=c-1;i>=a;--i)if(w(v.charCodeAt(i))){if(!o){r=i;break}}else o=!1;if(r===-1){if(m===-1)return".";r=m}return v.slice(0,r)},basename(v,c){c!==void 0&&T(c,"ext"),T(v,"path");let m=0,a=-1,d=!0,r;if(v.length>=2&&g(v.charCodeAt(0))&&v.charCodeAt(1)===R&&(m=2),c!==void 0&&c.length>0&&c.length<=v.length){if(c===v)return"";let o=c.length-1,i=-1;for(r=v.length-1;r>=m;--r){const n=v.charCodeAt(r);if(w(n)){if(!d){m=r+1;break}}else i===-1&&(d=!1,i=r+1),o>=0&&(n===c.charCodeAt(o)?--o==-1&&(a=r):(o=-1,a=i))}return m===a?a=i:a===-1&&(a=v.length),v.slice(m,a)}for(r=v.length-1;r>=m;--r)if(w(v.charCodeAt(r))){if(!d){m=r+1;break}}else a===-1&&(d=!1,a=r+1);return a===-1?"":v.slice(m,a)},extname(v){T(v,"path");let c=0,m=-1,a=0,d=-1,r=!0,o=0;v.length>=2&&v.charCodeAt(1)===R&&g(v.charCodeAt(0))&&(c=a=2);for(let i=v.length-1;i>=c;--i){const n=v.charCodeAt(i);if(w(n)){if(!r){a=i+1;break}continue}d===-1&&(r=!1,d=i+1),n===C?m===-1?m=i:o!==1&&(o=1):m!==-1&&(o=-1)}return m===-1||d===-1||o===0||o===1&&m===d-1&&m===a+1?"":v.slice(m,d)},format:p.bind(null,"\\"),parse(v){T(v,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return c;const m=v.length;let a=0,d=v.charCodeAt(0);if(m===1)return w(d)?(c.root=c.dir=v,c):(c.base=c.name=v,c);if(w(d)){if(a=1,w(v.charCodeAt(1))){let h=2,S=h;for(;h<m&&!w(v.charCodeAt(h));)h++;if(h<m&&h!==S){for(S=h;h<m&&w(v.charCodeAt(h));)h++;if(h<m&&h!==S){for(S=h;h<m&&!w(v.charCodeAt(h));)h++;h===m?a=h:h!==S&&(a=h+1)}}}}else if(g(d)&&v.charCodeAt(1)===R){if(m<=2)return c.root=c.dir=v,c;if(a=2,w(v.charCodeAt(2))){if(m===3)return c.root=c.dir=v,c;a=3}}a>0&&(c.root=v.slice(0,a));let r=-1,o=a,i=-1,n=!0,s=v.length-1,l=0;for(;s>=a;--s){if(d=v.charCodeAt(s),w(d)){if(!n){o=s+1;break}continue}i===-1&&(n=!1,i=s+1),d===C?r===-1?r=s:l!==1&&(l=1):r!==-1&&(l=-1)}return i!==-1&&(r===-1||l===0||l===1&&r===i-1&&r===o+1?c.base=c.name=v.slice(o,i):(c.name=v.slice(o,r),c.base=v.slice(o,i),c.ext=v.slice(r,i))),o>0&&o!==a?c.dir=v.slice(0,o-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...v){let c="",m=!1;for(let a=v.length-1;a>=-1&&!m;a--){const d=a>=0?v[a]:u.cwd();T(d,"path"),d.length!==0&&(c=`${d}/${c}`,m=d.charCodeAt(0)===E)}return c=f(c,!m,"/",b),m?`/${c}`:c.length>0?c:"."},normalize(v){if(T(v,"path"),v.length===0)return".";const c=v.charCodeAt(0)===E,m=v.charCodeAt(v.length-1)===E;return v=f(v,!c,"/",b),v.length===0?c?"/":m?"./":".":(m&&(v+="/"),c?`/${v}`:v)},isAbsolute(v){return T(v,"path"),v.length>0&&v.charCodeAt(0)===E},join(...v){if(v.length===0)return".";let c;for(let m=0;m<v.length;++m){const a=v[m];T(a,"path"),a.length>0&&(c===void 0?c=a:c+=`/${a}`)}return c===void 0?".":e.posix.normalize(c)},relative(v,c){if(T(v,"from"),T(c,"to"),v===c||(v=e.posix.resolve(v),c=e.posix.resolve(c),v===c))return"";const m=1,a=v.length,d=a-m,r=1,o=c.length-r,i=d<o?d:o;let n=-1,s=0;for(;s<i;s++){const h=v.charCodeAt(m+s);if(h!==c.charCodeAt(r+s))break;h===E&&(n=s)}if(s===i)if(o>i){if(c.charCodeAt(r+s)===E)return c.slice(r+s+1);if(s===0)return c.slice(r+s)}else d>i&&(v.charCodeAt(m+s)===E?n=s:s===0&&(n=0));let l="";for(s=m+n+1;s<=a;++s)(s===a||v.charCodeAt(s)===E)&&(l+=l.length===0?"..":"/..");return`${l}${c.slice(r+n)}`},toNamespacedPath(v){return v},dirname(v){if(T(v,"path"),v.length===0)return".";const c=v.charCodeAt(0)===E;let m=-1,a=!0;for(let d=v.length-1;d>=1;--d)if(v.charCodeAt(d)===E){if(!a){m=d;break}}else a=!1;return m===-1?c?"/":".":c&&m===1?"//":v.slice(0,m)},basename(v,c){c!==void 0&&T(c,"ext"),T(v,"path");let m=0,a=-1,d=!0,r;if(c!==void 0&&c.length>0&&c.length<=v.length){if(c===v)return"";let o=c.length-1,i=-1;for(r=v.length-1;r>=0;--r){const n=v.charCodeAt(r);if(n===E){if(!d){m=r+1;break}}else i===-1&&(d=!1,i=r+1),o>=0&&(n===c.charCodeAt(o)?--o==-1&&(a=r):(o=-1,a=i))}return m===a?a=i:a===-1&&(a=v.length),v.slice(m,a)}for(r=v.length-1;r>=0;--r)if(v.charCodeAt(r)===E){if(!d){m=r+1;break}}else a===-1&&(d=!1,a=r+1);return a===-1?"":v.slice(m,a)},extname(v){T(v,"path");let c=-1,m=0,a=-1,d=!0,r=0;for(let o=v.length-1;o>=0;--o){const i=v.charCodeAt(o);if(i===E){if(!d){m=o+1;break}continue}a===-1&&(d=!1,a=o+1),i===C?c===-1?c=o:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||a===-1||r===0||r===1&&c===a-1&&c===m+1?"":v.slice(c,a)},format:p.bind(null,"/"),parse(v){T(v,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return c;const m=v.charCodeAt(0)===E;let a;m?(c.root="/",a=1):a=0;let d=-1,r=0,o=-1,i=!0,n=v.length-1,s=0;for(;n>=a;--n){const l=v.charCodeAt(n);if(l===E){if(!i){r=n+1;break}continue}o===-1&&(i=!1,o=n+1),l===C?d===-1?d=n:s!==1&&(s=1):d!==-1&&(s=-1)}if(o!==-1){const l=r===0&&m?1:r;d===-1||s===0||s===1&&d===o-1&&d===r+1?c.base=c.name=v.slice(l,o):(c.name=v.slice(l,d),c.base=v.slice(l,o),c.ext=v.slice(d,o))}return r>0?c.dir=v.slice(0,r-1):m&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=u.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=u.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=u.platform==="win32"?e.win32.join:e.posix.join,e.resolve=u.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=u.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=u.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=u.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=u.platform==="win32"?e.win32.extname:e.posix.extname,e.format=u.platform==="win32"?e.win32.format:e.posix.format,e.parse=u.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=u.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=u.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=u.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Ie[101],ke([1,0,9]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(R){const k=(0,u.extname)(R),_=t[k.toLowerCase()];return _!==void 0?_:y(R)}e.getMediaOrTextMime=P;function y(R){const k=(0,u.extname)(R);return D[k.toLowerCase()]}e.getMediaMime=y;function C(R){for(const k in D)if(D[k]===R)return k}e.getExtensionForMimeType=C;const E=/^(.+)\/(.+?)(;.+)?$/;function I(R,k){const _=E.exec(R);return _?`${_[1].toLowerCase()}/${_[2].toLowerCase()}${_[3]??""}`:k?void 0:R}e.normalizeMimeType=I}),define(Ie[102],ke([1,0,13]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var D;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(C,...E){const I=E.reduce((_,T)=>(_[T]=!0,_),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(_=>!I[_]).forEach(_=>{for(let T=0;T<R.length;T++)if(_.search(R[T])!==-1){delete C[_];break}})}e.sanitizeProcessEnvironment=P;function y(C){!C||(delete C.DEBUG,u.isMacintosh&&delete C.DYLD_LIBRARY_PATH,u.isLinux&&delete C.LD_PRELOAD)}e.removeDangerousEnvVariables=y}),define(Ie[50],ke([1,0,13]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=u.globals.performance&&typeof u.globals.performance.now=="function";class D{constructor(y){this._highResolution=t&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new D(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?u.globals.performance.now():Date.now()}}e.StopWatch=D}),define(Ie[3],ke([1,0,12,58,6,79,50]),function(Y,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const C=!1,E=!1;var I;(function(n){n.None=()=>D.Disposable.None;function s(ge){if(E){const{onListenerDidAdd:Ee}=ge,Te=w.create();let Oe=0;ge.onListenerDidAdd=()=>{++Oe==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Te.print()),Ee?.()}}}function l(ge){return(Ee,Te=null,Oe)=>{let ve=!1,ue;return ue=ge(de=>{if(!ve)return ue?ue.dispose():ve=!0,Ee.call(Te,de)},null,Oe),ve&&ue.dispose(),ue}}n.once=l;function h(ge,Ee,Te){return B((Oe,ve=null,ue)=>ge(de=>Oe.call(ve,Ee(de)),null,ue),Te)}n.map=h;function S(ge,Ee,Te){return B((Oe,ve=null,ue)=>ge(de=>{Ee(de),Oe.call(ve,de)},null,ue),Te)}n.forEach=S;function L(ge,Ee,Te){return B((Oe,ve=null,ue)=>ge(de=>Ee(de)&&Oe.call(ve,de),null,ue),Te)}n.filter=L;function M(ge){return ge}n.signal=M;function F(...ge){return(Ee,Te=null,Oe)=>(0,D.combinedDisposable)(...ge.map(ve=>ve(ue=>Ee.call(Te,ue),null,Oe)))}n.any=F;function A(ge,Ee,Te,Oe){let ve=Te;return h(ge,ue=>(ve=Ee(ve,ue),ve),Oe)}n.reduce=A;function B(ge,Ee){let Te;const Oe={onFirstListenerAdd(){Te=ge(ve.fire,ve)},onLastListenerRemove(){Te?.dispose()}};Ee||s(Oe);const ve=new g(Oe);return Ee?.add(ve),ve.event}function $(ge,Ee,Te=100,Oe=!1,ve,ue){let de,we,ie,me=0;const J={leakWarningThreshold:ve,onFirstListenerAdd(){de=ge(O=>{me++,we=Ee(we,O),Oe&&!ie&&(re.fire(we),we=void 0),clearTimeout(ie),ie=setTimeout(()=>{const H=we;we=void 0,ie=void 0,(!Oe||me>1)&&re.fire(H),me=0},Te)})},onLastListenerRemove(){de.dispose()}};ue||s(J);const re=new g(J);return ue?.add(re),re.event}n.debounce=$;function U(ge,Ee=(Oe,ve)=>Oe===ve,Te){let Oe=!0,ve;return L(ge,ue=>{const de=Oe||!Ee(ue,ve);return Oe=!1,ve=ue,de},Te)}n.latch=U;function K(ge,Ee,Te){return[n.filter(ge,Ee,Te),n.filter(ge,Oe=>!Ee(Oe),Te)]}n.split=K;function W(ge,Ee=!1,Te=[]){let Oe=Te.slice(),ve=ge(we=>{Oe?Oe.push(we):de.fire(we)});const ue=()=>{Oe?.forEach(we=>de.fire(we)),Oe=null},de=new g({onFirstListenerAdd(){ve||(ve=ge(we=>de.fire(we)))},onFirstListenerDidAdd(){Oe&&(Ee?setTimeout(ue):ue())},onLastListenerRemove(){ve&&ve.dispose(),ve=null}});return de.event}n.buffer=W;class N{constructor(Ee){this.event=Ee,this.disposables=new D.DisposableStore}map(Ee){return new N(h(this.event,Ee,this.disposables))}forEach(Ee){return new N(S(this.event,Ee,this.disposables))}filter(Ee){return new N(L(this.event,Ee,this.disposables))}reduce(Ee,Te){return new N(A(this.event,Ee,Te,this.disposables))}latch(){return new N(U(this.event,void 0,this.disposables))}debounce(Ee,Te=100,Oe=!1,ve){return new N($(this.event,Ee,Te,Oe,ve,this.disposables))}on(Ee,Te,Oe){return this.event(Ee,Te,Oe)}once(Ee,Te,Oe){return l(this.event)(Ee,Te,Oe)}dispose(){this.disposables.dispose()}}function V(ge){return new N(ge)}n.chain=V;function x(ge,Ee,Te=Oe=>Oe){const Oe=(...we)=>de.fire(Te(...we)),ve=()=>ge.on(Ee,Oe),ue=()=>ge.removeListener(Ee,Oe),de=new g({onFirstListenerAdd:ve,onLastListenerRemove:ue});return de.event}n.fromNodeEventEmitter=x;function q(ge,Ee,Te=Oe=>Oe){const Oe=(...we)=>de.fire(Te(...we)),ve=()=>ge.addEventListener(Ee,Oe),ue=()=>ge.removeEventListener(Ee,Oe),de=new g({onFirstListenerAdd:ve,onLastListenerRemove:ue});return de.event}n.fromDOMEventEmitter=q;function te(ge){return new Promise(Ee=>l(ge)(Ee))}n.toPromise=te;function Q(ge,Ee){return Ee(void 0),ge(Te=>Ee(Te))}n.runAndSubscribe=Q;function le(ge,Ee){let Te=null;function Oe(ue){Te?.dispose(),Te=new D.DisposableStore,Ee(ue,Te)}Oe(void 0);const ve=ge(ue=>Oe(ue));return(0,D.toDisposable)(()=>{ve.dispose(),Te?.dispose()})}n.runAndSubscribeWithStore=le;class pe{constructor(Ee,Te){this.obs=Ee,this._counter=0,this._hasChanged=!1;const Oe={onFirstListenerAdd:()=>{Ee.addObserver(this)},onLastListenerRemove:()=>{Ee.removeObserver(this)}};Te||s(Oe),this.emitter=new g(Oe),Te&&Te.add(this.emitter)}beginUpdate(Ee){this._counter++}handleChange(Ee,Te){this._hasChanged=!0}endUpdate(Ee){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function Z(ge,Ee){return new pe(ge,Ee).emitter.event}n.fromObservable=Z})(I=e.Event||(e.Event={}));class R{constructor(s){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${s}_${R._idPool++}`}start(s){this._stopWatch=new y.StopWatch(!0),this._listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this._elapsedOverall+=s,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${s.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}R._idPool=0;let k=-1;function _(n){const s=k;return k=n,{dispose(){k=s}}}e.setGlobalLeakWarningThreshold=_;class T{constructor(s,l=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s,l){let h=k;if(typeof this.customThreshold=="number"&&(h=this.customThreshold),h<=0||l<h)return;this._stacks||(this._stacks=new Map);const S=this._stacks.get(s.value)||0;if(this._stacks.set(s.value,S+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=h*.5;let L,M=0;for(const[F,A]of this._stacks)(!L||M<A)&&(L=F,M=A);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${M}):`),console.warn(L)}return()=>{const L=this._stacks.get(s.value)||0;this._stacks.set(s.value,L-1)}}}class w{constructor(s){this.value=s}static create(){return new w(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(s,l,h){this.callback=s,this.callbackThis=l,this.stack=h,this.subscription=new D.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class g{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=k>0?new T(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new R(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(C){const s=Array.from(this._listeners);queueMicrotask(()=>{for(const l of s)l.subscription.isset()&&(l.subscription.unset(),l.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(s,l,h)=>{this._listeners||(this._listeners=new P.LinkedList);const S=this._listeners.isEmpty();S&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let L,M;this._leakageMon&&this._listeners.size>=30&&(M=w.create(),L=this._leakageMon.check(M,this._listeners.size+1)),C&&(M=M??w.create());const F=new b(s,l,M),A=this._listeners.push(F);S&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,l);const B=F.subscription.set(()=>{L?.(),this._disposed||(A(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return h instanceof D.DisposableStore?h.add(B):Array.isArray(h)&&h.push(B),B}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new p);for(const l of this._listeners)this._deliveryQueue.push(this,l,s);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=g;class f{constructor(){this._queue=new P.LinkedList}get size(){return this._queue.size}push(s,l,h){this._queue.push(new v(s,l,h))}clear(s){const l=new P.LinkedList;for(const h of this._queue)h.emitter!==s&&l.push(h);this._queue=l}deliver(){for(;this._queue.size>0;){const s=this._queue.shift();try{s.listener.invoke(s.event)}catch(l){(0,u.onUnexpectedError)(l)}}}}e.EventDeliveryQueue=f;class p extends f{clear(s){this._queue.clear()}}class v{constructor(s,l,h){this.emitter=s,this.listener=l,this.event=h}}class c extends g{async fireAsync(s,l,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const S of this._listeners)this._asyncDeliveryQueue.push([S,s]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[S,L]=this._asyncDeliveryQueue.shift(),M=[],F={...L,token:l,waitUntil:A=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");h&&(A=h(A,S.callback)),M.push(A)}};try{S.invoke(F)}catch(A){(0,u.onUnexpectedError)(A);continue}Object.freeze(M),await Promise.allSettled(M).then(A=>{for(const B of A)B.status==="rejected"&&(0,u.onUnexpectedError)(B.reason)})}}}}e.AsyncEmitter=c;class m extends g{constructor(s){super(s);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}e.PauseableEmitter=m;class a extends m{constructor(s){super(s);this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}e.DebounceEmitter=a;class d extends g{constructor(s){super(s);this._queuedEvents=[],this._mergeFn=s?.merge}fire(s){this._queuedEvents.push(s),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(l=>super.fire(l)),this._queuedEvents=[]})}}e.MicrotaskEmitter=d;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const l={event:s,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const h=()=>{this.hasListeners&&this.unhook(l);const S=this.events.indexOf(l);this.events.splice(S,1)};return(0,D.toDisposable)((0,t.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(l=>this.emitter.fire(l))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class o{constructor(){this.buffers=[]}wrapEvent(s){return(l,h,S)=>s(L=>{const M=this.buffers[this.buffers.length-1];M?M.push(()=>l.call(h,L)):l.call(h,L)},void 0,S)}bufferEvents(s){const l=[];this.buffers.push(l);const h=s();return this.buffers.pop(),l.forEach(S=>S()),h}}e.EventBufferer=o;class i{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=D.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=i}),define(Ie[21],ke([1,0,3]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(C,E){const I=setTimeout(C.bind(E),0);return{dispose(){clearTimeout(I)}}});var D;(function(C){function E(I){return I===C.None||I===C.Cancelled||I instanceof P?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}C.isCancellationToken=E,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:u.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(D=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new u.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=D.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=y}),define(Ie[155],ke([1,0,21]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(C){this.task=C,this.result=null}get(){if(this.result)return this.result;const C=new u.CancellationTokenSource,E=this.task(C.token);return this.result={promise:E,dispose:()=>{this.result=null,C.cancel(),C.dispose()}},this.result}}e.Cache=t;class D{constructor(C){this.fn=C,this.lastCache=void 0,this.lastArgKey=void 0}get(C){const E=JSON.stringify(C);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.fn(C)),this.lastCache}}e.LRUCachedFunction=D;class P{constructor(C){this.fn=C,this._map=new Map}get cachedValues(){return this._map}get(C){if(this._map.has(C))return this._map.get(C);const E=this.fn(C);return this._map.set(C,E),E}}e.CachedFunction=P}),define(Ie[8],ke([1,0,155,78]),function(Y,e,u,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(ce){return!ce||typeof ce!="string"?!0:ce.trim().length===0}e.isFalsyOrWhitespace=P;const y=/{(\d+)}/g;function C(ce,...Ae){return Ae.length===0?ce:ce.replace(y,function(Be,qe){const je=parseInt(qe,10);return isNaN(je)||je<0||je>=Ae.length?Be:Ae[je]})}e.format=C;const E=/{([^}]+)}/g;function I(ce,Ae){return ce.replace(E,(Be,qe)=>Ae[qe]??Be)}e.format2=I;function R(ce){return ce.replace(/[<>&]/g,function(Ae){switch(Ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ae}})}e.escape=R;function k(ce){return ce.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function _(ce,Ae){let Be=0;const qe=Ae.charCodeAt(0);for(let je=ce.length-1;je>=0;je--)ce.charCodeAt(je)===qe&&Be++;return Be}e.count=_;function T(ce,Ae,Be="\u2026"){return ce.length<=Ae?ce:`${ce.substr(0,Ae)}${Be}`}e.truncate=T;function w(ce,Ae=" "){const Be=b(ce,Ae);return g(Be,Ae)}e.trim=w;function b(ce,Ae){if(!ce||!Ae)return ce;const Be=Ae.length;if(Be===0||ce.length===0)return ce;let qe=0;for(;ce.indexOf(Ae,qe)===qe;)qe=qe+Be;return ce.substring(qe)}e.ltrim=b;function g(ce,Ae){if(!ce||!Ae)return ce;const Be=Ae.length,qe=ce.length;if(Be===0||qe===0)return ce;let je=qe,Ve=-1;for(;Ve=ce.lastIndexOf(Ae,je-1),!(Ve===-1||Ve+Be!==je);){if(Ve===0)return"";je=Ve}return ce.substring(0,je)}e.rtrim=g;function f(ce){return ce.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function p(ce){return ce.replace(/\*/g,"")}e.stripWildcards=p;function v(ce,Ae,Be={}){if(!ce)throw new Error("Cannot create regex from empty string");Ae||(ce=k(ce)),Be.wholeWord&&(/\B/.test(ce.charAt(0))||(ce="\\b"+ce),/\B/.test(ce.charAt(ce.length-1))||(ce=ce+"\\b"));let qe="";return Be.global&&(qe+="g"),Be.matchCase||(qe+="i"),Be.multiline&&(qe+="m"),Be.unicode&&(qe+="u"),new RegExp(ce,qe)}e.createRegExp=v;function c(ce){return ce.source==="^"||ce.source==="^$"||ce.source==="$"||ce.source==="^\\s*$"?!1:!!(ce.exec("")&&ce.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function m(ce){return!!ce.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function a(ce){return(ce.global?"g":"")+(ce.ignoreCase?"i":"")+(ce.multiline?"m":"")+(ce.unicode?"u":"")}e.regExpFlags=a;function d(ce){return ce.split(/\r\n|\r|\n/)}e.splitLines=d;function r(ce){for(let Ae=0,Be=ce.length;Ae<Be;Ae++){const qe=ce.charCodeAt(Ae);if(qe!==32&&qe!==9)return Ae}return-1}e.firstNonWhitespaceIndex=r;function o(ce,Ae=0,Be=ce.length){for(let qe=Ae;qe<Be;qe++){const je=ce.charCodeAt(qe);if(je!==32&&je!==9)return ce.substring(Ae,qe)}return ce.substring(Ae,Be)}e.getLeadingWhitespace=o;function i(ce,Ae=ce.length-1){for(let Be=Ae;Be>=0;Be--){const qe=ce.charCodeAt(Be);if(qe!==32&&qe!==9)return Be}return-1}e.lastNonWhitespaceIndex=i;function n(ce,Ae,Be){const qe=[];let je=0;for(const Ve of ce.matchAll(Ae)){if(qe.push(ce.slice(je,Ve.index)),Ve.index===void 0)throw new Error("match.index should be defined");je=Ve.index+Ve[0].length,qe.push(Be(Ve[0],...Ve.slice(1),Ve.index,ce,Ve.groups))}return qe.push(ce.slice(je)),Promise.all(qe).then(Ve=>Ve.join(""))}e.replaceAsync=n;function s(ce,Ae){return ce<Ae?-1:ce>Ae?1:0}e.compare=s;function l(ce,Ae,Be=0,qe=ce.length,je=0,Ve=Ae.length){for(;Be<qe&&je<Ve;Be++,je++){const st=ce.charCodeAt(Be),it=Ae.charCodeAt(je);if(st<it)return-1;if(st>it)return 1}const nt=qe-Be,ot=Ve-je;return nt<ot?-1:nt>ot?1:0}e.compareSubstring=l;function h(ce,Ae){return S(ce,Ae,0,ce.length,0,Ae.length)}e.compareIgnoreCase=h;function S(ce,Ae,Be=0,qe=ce.length,je=0,Ve=Ae.length){for(;Be<qe&&je<Ve;Be++,je++){let st=ce.charCodeAt(Be),it=Ae.charCodeAt(je);if(st===it)continue;if(st>=128||it>=128)return l(ce.toLowerCase(),Ae.toLowerCase(),Be,qe,je,Ve);M(st)&&(st-=32),M(it)&&(it-=32);const at=st-it;if(at!==0)return at}const nt=qe-Be,ot=Ve-je;return nt<ot?-1:nt>ot?1:0}e.compareSubstringIgnoreCase=S;function L(ce){return ce>=48&&ce<=57}e.isAsciiDigit=L;function M(ce){return ce>=97&&ce<=122}e.isLowerAsciiLetter=M;function F(ce){return ce>=65&&ce<=90}e.isUpperAsciiLetter=F;function A(ce,Ae){return ce.length===Ae.length&&S(ce,Ae)===0}e.equalsIgnoreCase=A;function B(ce,Ae){const Be=Ae.length;return Ae.length>ce.length?!1:S(ce,Ae,0,Be)===0}e.startsWithIgnoreCase=B;function $(ce,Ae){const Be=Math.min(ce.length,Ae.length);let qe;for(qe=0;qe<Be;qe++)if(ce.charCodeAt(qe)!==Ae.charCodeAt(qe))return qe;return Be}e.commonPrefixLength=$;function U(ce,Ae){const Be=Math.min(ce.length,Ae.length);let qe;const je=ce.length-1,Ve=Ae.length-1;for(qe=0;qe<Be;qe++)if(ce.charCodeAt(je-qe)!==Ae.charCodeAt(Ve-qe))return qe;return Be}e.commonSuffixLength=U;function K(ce){return 55296<=ce&&ce<=56319}e.isHighSurrogate=K;function W(ce){return 56320<=ce&&ce<=57343}e.isLowSurrogate=W;function N(ce,Ae){return(ce-55296<<10)+(Ae-56320)+65536}e.computeCodePoint=N;function V(ce,Ae,Be){const qe=ce.charCodeAt(Be);if(K(qe)&&Be+1<Ae){const je=ce.charCodeAt(Be+1);if(W(je))return N(qe,je)}return qe}e.getNextCodePoint=V;function x(ce,Ae){const Be=ce.charCodeAt(Ae-1);if(W(Be)&&Ae>1){const qe=ce.charCodeAt(Ae-2);if(K(qe))return N(qe,Be)}return Be}class q{constructor(Ae,Be=0){this._str=Ae,this._len=Ae.length,this._offset=Be}get offset(){return this._offset}setOffset(Ae){this._offset=Ae}prevCodePoint(){const Ae=x(this._str,this._offset);return this._offset-=Ae>=65536?2:1,Ae}nextCodePoint(){const Ae=V(this._str,this._len,this._offset);return this._offset+=Ae>=65536?2:1,Ae}eol(){return this._offset>=this._len}}e.CodePointIterator=q;class te{constructor(Ae,Be=0){this._iterator=new q(Ae,Be)}get offset(){return this._iterator.offset}nextGraphemeLength(){const Ae=ze.getInstance(),Be=this._iterator,qe=Be.offset;let je=Ae.getGraphemeBreakType(Be.nextCodePoint());for(;!Be.eol();){const Ve=Be.offset,nt=Ae.getGraphemeBreakType(Be.nextCodePoint());if(De(je,nt)){Be.setOffset(Ve);break}je=nt}return Be.offset-qe}prevGraphemeLength(){const Ae=ze.getInstance(),Be=this._iterator,qe=Be.offset;let je=Ae.getGraphemeBreakType(Be.prevCodePoint());for(;Be.offset>0;){const Ve=Be.offset,nt=Ae.getGraphemeBreakType(Be.prevCodePoint());if(De(nt,je)){Be.setOffset(Ve);break}je=nt}return qe-Be.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=te;function Q(ce,Ae){return new te(ce,Ae).nextGraphemeLength()}e.nextCharLength=Q;function le(ce,Ae){return new te(ce,Ae).prevGraphemeLength()}e.prevCharLength=le;function pe(ce,Ae){Ae>0&&W(ce.charCodeAt(Ae))&&Ae--;const Be=Ae+Q(ce,Ae);return[Be-le(ce,Be),Be]}e.getCharContainingOffset=pe;const Z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ge(ce){return Z.test(ce)}e.containsRTL=ge;const Ee=/^[\t\n\r\x20-\x7E]*$/;function Te(ce){return Ee.test(ce)}e.isBasicASCII=Te,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Oe(ce){return e.UNUSUAL_LINE_TERMINATORS.test(ce)}e.containsUnusualLineTerminators=Oe;function ve(ce){return ce>=11904&&ce<=55215||ce>=63744&&ce<=64255||ce>=65281&&ce<=65374}e.isFullWidthCharacter=ve;function ue(ce){return ce>=127462&&ce<=127487||ce===8986||ce===8987||ce===9200||ce===9203||ce>=9728&&ce<=10175||ce===11088||ce===11093||ce>=127744&&ce<=128591||ce>=128640&&ce<=128764||ce>=128992&&ce<=129008||ce>=129280&&ce<=129535||ce>=129648&&ce<=129782}e.isEmojiImprecise=ue;function de(ce,Ae){if(ce.length<Ae)return ce;const Be=/\b/g;let qe=0;for(;Be.test(ce)&&!(ce.length-Be.lastIndex<Ae);)qe=Be.lastIndex,Be.lastIndex+=1;return ce.substring(qe).replace(/^\s/,"")}e.lcut=de;const we=/\x1B\x5B[12]?K/g,ie=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function J(ce){return ce&&(ce=ce.replace(we,""),ce=ce.replace(ie,""),ce=ce.replace(me,"")),ce}e.removeAnsiEscapeCodes=J,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function re(ce){return!!(ce&&ce.length>0&&ce.charCodeAt(0)===65279)}e.startsWithUTF8BOM=re;function O(ce){return re(ce)?ce.substr(1):ce}e.stripUTF8BOM=O;function H(ce,Ae){if(!ce||!Ae||ce.length<Ae.length)return!1;const Be=Ae.length,qe=ce.toLowerCase();let je=0,Ve=-1;for(;je<Be;){const nt=qe.indexOf(Ae[je],Ve+1);if(nt<0)return!1;Ve=nt,je++}return!0}e.fuzzyContains=H;function G(ce,Ae=!1){return ce?(Ae&&(ce=ce.replace(/\\./g,"")),ce.toLowerCase()!==ce):!1}e.containsUppercaseCharacter=G;function X(ce){return ce.charAt(0).toUpperCase()+ce.slice(1)}e.uppercaseFirstLetter=X;function he(ce,Ae=1){if(Ae===0)return"";let Be=-1;do Be=ce.indexOf(`
`,Be+1),Ae--;while(Ae>0&&Be>=0);return Be===-1?ce:(ce[Be-1]==="\r"&&Be--,ce.substr(0,Be))}e.getNLines=he;function be(ce){const Ae=90-65+1;return ce=ce%(2*Ae),ce<Ae?String.fromCharCode(97+ce):String.fromCharCode(65+ce-Ae)}e.singleLetterHash=be;function ae(ce){return ze.getInstance().getGraphemeBreakType(ce)}e.getGraphemeBreakType=ae;function De(ce,Ae){return ce===0?Ae!==5&&Ae!==7:ce===2&&Ae===3?!1:ce===4||ce===2||ce===3||Ae===4||Ae===2||Ae===3?!0:!(ce===8&&(Ae===8||Ae===9||Ae===11||Ae===12)||(ce===11||ce===9)&&(Ae===9||Ae===10)||(ce===12||ce===10)&&Ae===10||Ae===5||Ae===13||Ae===7||ce===1||ce===13&&Ae===14||ce===6&&Ae===6)}var Ce;(function(ce){ce[ce.Other=0]="Other",ce[ce.Prepend=1]="Prepend",ce[ce.CR=2]="CR",ce[ce.LF=3]="LF",ce[ce.Control=4]="Control",ce[ce.Extend=5]="Extend",ce[ce.Regional_Indicator=6]="Regional_Indicator",ce[ce.SpacingMark=7]="SpacingMark",ce[ce.L=8]="L",ce[ce.V=9]="V",ce[ce.T=10]="T",ce[ce.LV=11]="LV",ce[ce.LVT=12]="LVT",ce[ce.ZWJ=13]="ZWJ",ce[ce.Extended_Pictographic=14]="Extended_Pictographic"})(Ce=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=Ke()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(Ae){if(Ae<32)return Ae===10?3:Ae===13?2:4;if(Ae<127)return 0;const Be=this._data,qe=Be.length/3;let je=1;for(;je<=qe;)if(Ae<Be[3*je])je=2*je;else if(Ae>Be[3*je+1])je=2*je+1;else return Be[3*je+2];return 0}}ze._INSTANCE=null;function Ke(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(ce,Ae){if(ce===0)return 0;const Be=Ye(ce,Ae);if(Be!==void 0)return Be;const qe=new q(Ae,ce);return qe.prevCodePoint(),qe.offset}e.getLeftDeleteOffset=Ne;function Ye(ce,Ae){const Be=new q(Ae,ce);let qe=Be.prevCodePoint();for(;ee(qe)||qe===65039||qe===8419;){if(Be.offset===0)return;qe=Be.prevCodePoint()}if(!ue(qe))return;let je=Be.offset;return je>0&&Be.prevCodePoint()===8205&&(je=Be.offset),je}function ee(ce){return 127995<=ce&&ce<=127999}var oe;(function(ce){ce[ce.zwj=8205]="zwj",ce[ce.emojiVariantSelector=65039]="emojiVariantSelector",ce[ce.enclosingKeyCap=8419]="enclosingKeyCap"})(oe||(oe={})),e.noBreakWhitespace="\xA0";class ye{constructor(Ae){this.confusableDictionary=Ae}static getInstance(Ae){return ye.cache.get(Array.from(Ae))}static getLocales(){return ye._locales.getValue()}isAmbiguous(Ae){return this.confusableDictionary.has(Ae)}getPrimaryConfusable(Ae){return this.confusableDictionary.get(Ae)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ye,D=ye,ye.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ye.cache=new u.LRUCachedFunction(ce=>{function Ae(it){const at=new Map;for(let vt=0;vt<it.length;vt+=2)at.set(it[vt],it[vt+1]);return at}function Be(it,at){const vt=new Map(it);for(const[Pt,yt]of at)vt.set(Pt,yt);return vt}function qe(it,at){if(!it)return at;const vt=new Map;for(const[Pt,yt]of it)at.has(Pt)&&vt.set(Pt,yt);return vt}const je=D.ambiguousCharacterData.getValue();let Ve=ce.filter(it=>!it.startsWith("_")&&it in je);Ve.length===0&&(Ve=["_default"]);let nt;for(const it of Ve){const at=Ae(je[it]);nt=qe(nt,at)}const ot=Ae(je._common),st=Be(ot,nt);return new ye(st)}),ye._locales=new t.Lazy(()=>Object.keys(ye.ambiguousCharacterData.getValue()).filter(ce=>!ce.startsWith("_")));class We{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(We.getRawData())),this._data}static isInvisibleCharacter(Ae){return We.getData().has(Ae)}static get codePoints(){return We.getData()}}e.InvisibleCharacters=We,We._data=void 0}),define(Ie[30],ke([1,0,9,13,8,10]),function(Y,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(i){return i===47||i===92}e.isPathSeparator=y;function C(i){return i.replace(/[\\/]/g,u.posix.sep)}e.toSlashes=C;function E(i){return i.indexOf("/")===-1&&(i=C(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=E;function I(i,n=u.posix.sep){if(!i)return"";const s=i.length,l=i.charCodeAt(0);if(y(l)){if(y(i.charCodeAt(1))&&!y(i.charCodeAt(2))){let S=3;const L=S;for(;S<s&&!y(i.charCodeAt(S));S++);if(L!==S&&!y(i.charCodeAt(S+1))){for(S+=1;S<s;S++)if(y(i.charCodeAt(S)))return i.slice(0,S+1).replace(/[\\/]/g,n)}}return n}else if(f(l)&&i.charCodeAt(1)===58)return y(i.charCodeAt(2))?i.slice(0,2)+n:i.slice(0,2);let h=i.indexOf("://");if(h!==-1){for(h+=3;h<s;h++)if(y(i.charCodeAt(h)))return i.slice(0,h+1)}return""}e.getRoot=I;function R(i){if(!t.isWindows||!i||i.length<5)return!1;let n=i.charCodeAt(0);if(n!==92||(n=i.charCodeAt(1),n!==92))return!1;let s=2;const l=s;for(;s<i.length&&(n=i.charCodeAt(s),n!==92);s++);return!(l===s||(n=i.charCodeAt(s+1),isNaN(n)||n===92))}e.isUNC=R;const k=/[\\/:\*\?"<>\|]/g,_=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(i,n=t.isWindows){const s=n?k:_;return!(!i||i.length===0||/^\s+$/.test(i)||(s.lastIndex=0,s.test(i))||n&&T.test(i)||i==="."||i===".."||n&&i[i.length-1]==="."||n&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=w;function b(i,n,s){const l=i===n;return!s||l?l:!i||!n?!1:(0,D.equalsIgnoreCase)(i,n)}e.isEqual=b;function g(i,n,s,l=u.sep){if(i===n)return!0;if(!i||!n||n.length>i.length)return!1;if(s){if(!(0,D.startsWithIgnoreCase)(i,n))return!1;if(n.length===i.length)return!0;let S=n.length;return n.charAt(n.length-1)===l&&S--,i.charAt(S)===l}return n.charAt(n.length-1)!==l&&(n+=l),i.indexOf(n)===0}e.isEqualOrParent=g;function f(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=f;function p(i,n){return t.isWindows&&i.endsWith(":")&&(i+=u.sep),(0,u.isAbsolute)(i)||(i=(0,u.join)(n,i)),i=(0,u.normalize)(i),t.isWindows?(i=(0,D.rtrim)(i,u.sep),i.endsWith(":")&&(i+=u.sep)):(i=(0,D.rtrim)(i,u.sep),i||(i=u.sep)),i}e.sanitizeFilePath=p;function v(i){const n=(0,u.normalize)(i);return t.isWindows?i.length>3?!1:c(n)&&(i.length===2||n.charCodeAt(2)===92):n===u.posix.sep}e.isRootOrDriveLetter=v;function c(i,n=t.isWindows){return n?f(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function m(i){return c(i)?i[0]:void 0}e.getDriveLetter=m;function a(i,n,s){return n.length>i.length?-1:i===n?0:(s&&(i=i.toLowerCase(),n=n.toLowerCase()),i.indexOf(n))}e.indexOfPath=a;function d(i){const n=i.split(":");let s,l,h;for(const S of n){const L=Number(S);(0,P.isNumber)(L)?l===void 0?l=L:h===void 0&&(h=L):s=s?[s,S].join(":"):S}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:l!==void 0?l:void 0,column:h!==void 0?h:l!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(i,n,s=8){let l="";for(let S=0;S<s;S++)l+=r.charAt(Math.floor(Math.random()*r.length));let h;return n?h=`${n}-${l}`:h=l,i?(0,u.join)(i,h):h}e.randomPath=o}),define(Ie[60],ke([1,0,8]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(f){return D(f,0)}e.hash=t;function D(f,p){switch(typeof f){case"object":return f===null?P(349,p):Array.isArray(f)?E(f,p):I(f,p);case"string":return C(f,p);case"boolean":return y(f,p);case"number":return P(f,p);case"undefined":return P(937,p);default:return P(617,p)}}e.doHash=D;function P(f,p){return(p<<5)-p+f|0}e.numberHash=P;function y(f,p){return P(f?433:863,p)}function C(f,p){p=P(149417,p);for(let v=0,c=f.length;v<c;v++)p=P(f.charCodeAt(v),p);return p}e.stringHash=C;function E(f,p){return p=P(104579,p),f.reduce((v,c)=>D(c,v),p)}function I(f,p){return p=P(181387,p),Object.keys(f).sort().reduce((v,c)=>(v=C(c,v),D(f[c],v)),p)}class R{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=D(p,this._value),this._value}}e.Hasher=R;var k;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function _(f,p,v=32){const c=v-p,m=~((1<<c)-1);return(f<<p|(m&f)>>>c)>>>0}function T(f,p=0,v=f.byteLength,c=0){for(let m=0;m<v;m++)f[p+m]=c}function w(f,p,v="0"){for(;f.length<p;)f=v+f;return f}function b(f,p=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(v=>v.toString(16).padStart(2,"0")).join(""):w((f>>>0).toString(16),p/4)}e.toHexString=b;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const v=p.length;if(v===0)return;const c=this._buff;let m=this._buffLen,a=this._leftoverHighSurrogate,d,r;for(a!==0?(d=a,r=-1,a=0):(d=p.charCodeAt(0),r=0);;){let o=d;if(u.isHighSurrogate(d))if(r+1<v){const i=p.charCodeAt(r+1);u.isLowSurrogate(i)?(r++,o=u.computeCodePoint(d,i)):o=65533}else{a=d;break}else u.isLowSurrogate(d)&&(o=65533);if(m=this._push(c,m,o),r++,r<v)d=p.charCodeAt(r);else break}this._buffLen=m,this._leftoverHighSurrogate=a}_push(p,v,c){return c<128?p[v++]=c:c<2048?(p[v++]=192|(c&1984)>>>6,p[v++]=128|(c&63)>>>0):c<65536?(p[v++]=224|(c&61440)>>>12,p[v++]=128|(c&4032)>>>6,p[v++]=128|(c&63)>>>0):(p[v++]=240|(c&1835008)>>>18,p[v++]=128|(c&258048)>>>12,p[v++]=128|(c&4032)>>>6,p[v++]=128|(c&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,T(this._buff,this._buffLen),this._buffLen>56&&(this._step(),T(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=g._bigBlock32,v=this._buffDV;for(let s=0;s<64;s+=4)p.setUint32(s,v.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)p.setUint32(s,_(p.getUint32(s-12,!1)^p.getUint32(s-32,!1)^p.getUint32(s-56,!1)^p.getUint32(s-64,!1),1),!1);let c=this._h0,m=this._h1,a=this._h2,d=this._h3,r=this._h4,o,i,n;for(let s=0;s<80;s++)s<20?(o=m&a|~m&d,i=1518500249):s<40?(o=m^a^d,i=1859775393):s<60?(o=m&a|m&d|a&d,i=2400959708):(o=m^a^d,i=3395469782),n=_(c,5)+o+r+i+p.getUint32(s*4,!1)&4294967295,r=d,d=a,a=_(m,30),m=c,c=n;this._h0=this._h0+c&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+d&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))});var tt=this&&this.__classPrivateFieldSet||function(Y,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Y,u):D?D.value=u:e.set(Y,u),u},Me=this&&this.__classPrivateFieldGet||function(Y,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!t:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Y):t?t.value:e.get(Y)};define(Ie[25],ke([1,0,16,8]),function(Y,e,u,t){"use strict";var D,P,y,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(i,n,s){let l=i.get(n);return l===void 0&&(l=s,i.set(n,l)),l}e.getOrSet=E;function I(i){const n=[];return i.forEach((s,l)=>{n.push(`${l} => ${s}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.mapToString=I;function R(i){const n=[];return i.forEach(s=>{n.push(s)}),`Set(${i.size}) {${n.join(", ")}}`}e.setToString=R;class k{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),l=this._value.charCodeAt(this._pos);return s-l}value(){return this._value[this._pos]}}e.StringIterator=k;class _{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class T{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let s=n.length-1;s>=0;s--,this._valueLen--){const l=this._value.charCodeAt(s);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var w;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(w||(w={}));class b{constructor(n,s){this._ignorePathCasing=n,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=b;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(f||(f={}));class p{constructor(n){this._iter=n}static forUris(n=()=>!1,s=()=>!1){return new p(new b(n,s))}static forPaths(n=!1){return new p(new T(void 0,!n))}static forStrings(){return new p(new k)}static forConfigKeys(){return new p(new _)}clear(){this._root=void 0}fill(n,s){if(s){const l=s.slice(0);(0,u.shuffle)(l);for(const h of l)this.set(h,n)}else{const l=n.slice(0);(0,u.shuffle)(l);for(const h of l)this.set(h[0],h[1])}}set(n,s){const l=this._iter.reset(n);let h;this._root||(this._root=new g,this._root.segment=l.value());const S=[];for(h=this._root;;){const M=l.cmp(h.segment);if(M>0)h.left||(h.left=new g,h.left.segment=l.value()),S.push([-1,h]),h=h.left;else if(M<0)h.right||(h.right=new g,h.right.segment=l.value()),S.push([1,h]),h=h.right;else if(l.hasNext())l.next(),h.mid||(h.mid=new g,h.mid.segment=l.value()),S.push([0,h]),h=h.mid;else break}const L=h.value;h.value=s,h.key=n;for(let M=S.length-1;M>=0;M--){const F=S[M][1];F.updateHeight();const A=F.balanceFactor();if(A<-1||A>1){const B=S[M][0],$=S[M+1][0];if(B===1&&$===1)S[M][1]=F.rotateLeft();else if(B===-1&&$===-1)S[M][1]=F.rotateRight();else if(B===1&&$===-1)F.right=S[M+1][1]=S[M+1][1].rotateRight(),S[M][1]=F.rotateLeft();else if(B===-1&&$===1)F.left=S[M+1][1]=S[M+1][1].rotateLeft(),S[M][1]=F.rotateRight();else throw new Error;if(M>0)switch(S[M-1][0]){case-1:S[M-1][1].left=S[M][1];break;case 1:S[M-1][1].right=S[M][1];break;case 0:S[M-1][1].mid=S[M][1];break}else this._root=S[0][1]}}return L}get(n){return this._getNode(n)?.value}_getNode(n){const s=this._iter.reset(n);let l=this._root;for(;l;){const h=s.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else break}return l}has(n){const s=this._getNode(n);return!(s?.value===void 0&&s?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const l=this._iter.reset(n),h=[];let S=this._root;for(;S;){const L=l.cmp(S.segment);if(L>0)h.push([-1,S]),S=S.left;else if(L<0)h.push([1,S]),S=S.right;else if(l.hasNext())l.next(),h.push([0,S]),S=S.mid;else break}if(!!S){if(s?(S.left=void 0,S.mid=void 0,S.right=void 0,S.height=1):(S.key=void 0,S.value=void 0),!S.mid&&!S.value)if(S.left&&S.right){const L=this._min(S.right),{key:M,value:F,segment:A}=L;this._delete(L.key,!1),S.key=M,S.value=F,S.segment=A}else{const L=S.left??S.right;if(h.length>0){const[M,F]=h[h.length-1];switch(M){case-1:F.left=L;break;case 0:F.mid=L;break;case 1:F.right=L;break}}else this._root=L}for(let L=h.length-1;L>=0;L--){const M=h[L][1];M.updateHeight();const F=M.balanceFactor();if(F>1?(M.right.balanceFactor()>=0||(M.right=M.right.rotateRight()),h[L][1]=M.rotateLeft()):F<-1&&(M.left.balanceFactor()<=0||(M.left=M.left.rotateLeft()),h[L][1]=M.rotateRight()),L>0)switch(h[L-1][0]){case-1:h[L-1][1].left=h[L][1];break;case 1:h[L-1][1].right=h[L][1];break;case 0:h[L-1][1].mid=h[L][1];break}else this._root=h[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const s=this._iter.reset(n);let l=this._root,h;for(;l;){const S=s.cmp(l.segment);if(S>0)l=l.left;else if(S<0)l=l.right;else if(s.hasNext())s.next(),h=l.value||h,l=l.mid;else break}return l&&l.value||h}findSuperstr(n){const s=this._iter.reset(n);let l=this._root;for(;l;){const h=s.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(n){for(const[s,l]of this)n(l,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=s=>{if(!s)return!0;const l=s.balanceFactor();return l<-1||l>1?!1:n(s.left)&&n(s.right)};return n(this._root)}}e.TernarySearchTree=p;class v{constructor(n,s){this.uri=n,this.value=s}}class c{constructor(n,s){this[D]="ResourceMap",n instanceof c?(this.map=new Map(n.map),this.toKey=s??c.defaultToKey):(this.map=new Map,this.toKey=n??c.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),new v(n,s)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(const[l,h]of this.map)n(h.value,h.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=c,c.defaultToKey=i=>i.toString();class m{constructor(n,s){this[P]="ResourceSet",!n||typeof n=="function"?this._map=new c(n):(this._map=new c(s),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,s){this._map.forEach((l,h)=>n.call(s,h,h,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=m;var a;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class d{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,s=0){const l=this._map.get(n);if(!!l)return s!==0&&this.touch(l,s),l.value}set(n,s,l=0){let h=this._map.get(n);if(h)h.value=s,l!==0&&this.touch(h,l);else{switch(h={key:n,value:s,next:void 0,previous:void 0},l){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(n,h),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const l=this._state;let h=this._head;for(;h;){if(s?n.bind(s)(h.value,h.key,this):n(h.value,h.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const n=this,s=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:l.key,done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return h}values(){const n=this,s=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:l.value,done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return h}entries(){const n=this,s=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:[l.key,l.value],done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return h}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,l=this.size;for(;s&&l>n;)this._map.delete(s.key),s=s.next,l--;this._head=s,this._size=l,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,l=n.previous;if(!s||!l)throw new Error("Invalid list");s.previous=l,l.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const l=n.next,h=n.previous;n===this._tail?(h.next=void 0,this._tail=h):(l.previous=h,h.next=l),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const l=n.next,h=n.previous;n===this._head?(l.previous=void 0,this._head=l):(l.previous=h,h.next=l),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,l)=>{n.push([l,s])}),n}fromJSON(n){this.clear();for(const[s,l]of n)this.set(s,l)}}e.LinkedMap=d;class r extends d{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class o{constructor(n){C.set(this,void 0),tt(this,C,n,"f")}get size(){return Me(this,C,"f").size}forEach(n,s){Me(this,C,"f").forEach(n,s)}get(n){return Me(this,C,"f").get(n)}has(n){return Me(this,C,"f").has(n)}entries(){return Me(this,C,"f").entries()}keys(){return Me(this,C,"f").keys()}values(){return Me(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return Me(this,C,"f").entries()}}e.ReadonlyMapView=o}),define(Ie[103],ke([1,0,25,8]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...J){return function(re,O){for(let H=0,G=J.length;H<G;H++){const X=J[H](re,O);if(X)return X}return null}}e.or=D,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(J,re,O){if(!O||O.length<re.length)return null;let H;return J?H=t.startsWithIgnoreCase(O,re):H=O.indexOf(re)===0,H?re.length>0?[{start:0,end:re.length}]:[]:null}function y(J,re){const O=re.toLowerCase().indexOf(J.toLowerCase());return O===-1?null:[{start:O,end:O+J.length}]}e.matchesContiguousSubString=y;function C(J,re){return E(J.toLowerCase(),re.toLowerCase(),0,0)}e.matchesSubString=C;function E(J,re,O,H){if(O===J.length)return[];if(H===re.length)return null;if(J[O]===re[H]){let G=null;return(G=E(J,re,O+1,H+1))?f({start:H,end:H+1},G):null}return E(J,re,O,H+1)}function I(J){return 97<=J&&J<=122}function R(J){return 65<=J&&J<=90}e.isUpper=R;function k(J){return 48<=J&&J<=57}function _(J){return J===32||J===9||J===10||J===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>T.add(J.charCodeAt(0)));function w(J){return _(J)||T.has(J)}function b(J,re){return J===re||w(J)&&w(re)}function g(J){return I(J)||R(J)||k(J)}function f(J,re){return re.length===0?re=[J]:J.end===re[0].start?re[0].start=J.start:re.unshift(J),re}function p(J,re){for(let O=re;O<J.length;O++){const H=J.charCodeAt(O);if(R(H)||k(H)||O>0&&!g(J.charCodeAt(O-1)))return O}return J.length}function v(J,re,O,H){if(O===J.length)return[];if(H===re.length)return null;if(J[O]!==re[H].toLowerCase())return null;{let G=null,X=H+1;for(G=v(J,re,O+1,H+1);!G&&(X=p(re,X))<re.length;)G=v(J,re,O+1,X),X++;return G===null?null:f({start:H,end:H+1},G)}}function c(J){let re=0,O=0,H=0,G=0,X=0;for(let Ce=0;Ce<J.length;Ce++)X=J.charCodeAt(Ce),R(X)&&re++,I(X)&&O++,g(X)&&H++,k(X)&&G++;const he=re/J.length,be=O/J.length,ae=H/J.length,De=G/J.length;return{upperPercent:he,lowerPercent:be,alphaPercent:ae,numericPercent:De}}function m(J){const{upperPercent:re,lowerPercent:O}=J;return O===0&&re>.6}function a(J){const{upperPercent:re,lowerPercent:O,alphaPercent:H,numericPercent:G}=J;return O>.2&&re<.8&&H>.6&&G<.2}function d(J){let re=0,O=0,H=0,G=0;for(let X=0;X<J.length;X++)H=J.charCodeAt(X),R(H)&&re++,I(H)&&O++,_(H)&&G++;return(re===0||O===0)&&G===0?J.length<=30:re<=5}function r(J,re){if(!re||(re=re.trim(),re.length===0)||!d(J)||re.length>60)return null;const O=c(re);if(!a(O)){if(!m(O))return null;re=re.toLowerCase()}let H=null,G=0;for(J=J.toLowerCase();G<re.length&&(H=v(J,re,0,G))===null;)G=p(re,G+1);return H}e.matchesCamelCase=r;function o(J,re,O=!1){if(!re||re.length===0)return null;let H=null,G=0;for(J=J.toLowerCase(),re=re.toLowerCase();G<re.length&&(H=i(J,re,0,G,O))===null;)G=n(re,G+1);return H}e.matchesWords=o;function i(J,re,O,H,G){if(O===J.length)return[];if(H===re.length)return null;if(b(J.charCodeAt(O),re.charCodeAt(H))){let X=null,he=H+1;if(X=i(J,re,O+1,H+1,G),!G)for(;!X&&(he=n(re,he))<re.length;)X=i(J,re,O+1,he,G),he++;return X===null?null:f({start:H,end:H+1},X)}else return null}function n(J,re){for(let O=re;O<J.length;O++)if(w(J.charCodeAt(O))||O>0&&w(J.charCodeAt(O-1)))return O;return J.length}const s=D(e.matchesPrefix,r,y),l=D(e.matchesPrefix,r,C),h=new u.LRUCache(1e4);function S(J,re,O=!1){if(typeof J!="string"||typeof re!="string")return null;let H=h.get(J);H||(H=new RegExp(t.convertSimple2RegExpPattern(J),"i"),h.set(J,H));const G=H.exec(re);return G?[{start:G.index,end:G.index+G[0].length}]:O?l(J,re):s(J,re)}e.matchesFuzzy=S;function L(J,re){const O=Oe(J,J.toLowerCase(),0,re,re.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return O?F(O):null}e.matchesFuzzy2=L;function M(J,re,O,H,G,X){const he=Math.min(13,J.length);for(;O<he;O++){const be=Oe(J,re,O,H,G,X,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(be)return be}return[0,X]}e.anyScore=M;function F(J){if(typeof J=="undefined")return[];const re=[],O=J[1];for(let H=J.length-1;H>1;H--){const G=J[H]+O,X=re[re.length-1];X&&X.end===G?X.end=G+1:re.push({start:G,end:G+1})}return re}e.createMatches=F;const A=128;function B(){const J=[],re=[];for(let O=0;O<=A;O++)re[O]=0;for(let O=0;O<=A;O++)J.push(re.slice(0));return J}function $(J){const re=[];for(let O=0;O<=J;O++)re[O]=0;return re}const U=$(2*A),K=$(2*A),W=B(),N=B(),V=B(),x=!1;function q(J,re,O,H,G){function X(be,ae,De=" "){for(;be.length<ae;)be=De+be;return be}let he=` |   |${H.split("").map(be=>X(be,3)).join("|")}
`;for(let be=0;be<=O;be++)be===0?he+=" |":he+=`${re[be-1]}|`,he+=J[be].slice(0,G+1).map(ae=>X(ae.toString(),3)).join("|")+`
`;return he}function te(J,re,O,H){J=J.substr(re),O=O.substr(H),console.log(q(N,J,J.length,O,O.length)),console.log(q(V,J,J.length,O,O.length)),console.log(q(W,J,J.length,O,O.length))}function Q(J,re){if(re<0||re>=J.length)return!1;const O=J.codePointAt(re);switch(O){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(O)}}function le(J,re){if(re<0||re>=J.length)return!1;switch(J.charCodeAt(re)){case 32:case 9:return!0;default:return!1}}function pe(J,re,O){return re[J]!==O[J]}function Z(J,re,O,H,G,X,he=!1){for(;re<O&&G<X;)J[re]===H[G]&&(he&&(U[re]=G),re+=1),G+=1;return re===O}e.isPatternInWord=Z;var ge;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var Ee;(function(J){J.Default=[-100,0];function re(O){return!O||O.length===2&&O[0]===-100&&O[1]===0}J.isDefault=re})(Ee=e.FuzzyScore||(e.FuzzyScore={}));class Te{constructor(re,O){this.firstMatchCanBeWeak=re,this.boostFullMatch=O}}e.FuzzyScoreOptions=Te,Te.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Oe(J,re,O,H,G,X,he=Te.default){const be=J.length>A?A:J.length,ae=H.length>A?A:H.length;if(O>=be||X>=ae||be-O>ae-X||!Z(re,O,be,G,X,ae,!0))return;ve(be,ae,O,X,re,G);let De=1,Ce=1,ze=O,Ke=X;const Ne=[!1];for(De=1,ze=O;ze<be;De++,ze++){const We=U[ze],ce=K[ze],Ae=ze+1<be?K[ze+1]:ae;for(Ce=We-X+1,Ke=We;Ke<Ae;Ce++,Ke++){let Be=Number.MIN_SAFE_INTEGER,qe=!1;Ke<=ce&&(Be=ue(J,re,ze,O,H,G,Ke,ae,X,W[De-1][Ce-1]===0,Ne));let je=0;Be!==Number.MAX_SAFE_INTEGER&&(qe=!0,je=Be+N[De-1][Ce-1]);const Ve=Ke>We,nt=Ve?N[De][Ce-1]+(W[De][Ce-1]>0?-5:0):0,ot=Ke>We+1&&W[De][Ce-1]>0,st=ot?N[De][Ce-2]+(W[De][Ce-2]>0?-5:0):0;if(ot&&(!Ve||st>=nt)&&(!qe||st>=je))N[De][Ce]=st,V[De][Ce]=3,W[De][Ce]=0;else if(Ve&&(!qe||nt>=je))N[De][Ce]=nt,V[De][Ce]=2,W[De][Ce]=0;else if(qe)N[De][Ce]=je,V[De][Ce]=1,W[De][Ce]=W[De-1][Ce-1]+1;else throw new Error("not possible")}}if(x&&te(J,O,H,X),!Ne[0]&&!he.firstMatchCanBeWeak)return;De--,Ce--;const Ye=[N[De][Ce],X];let ee=0,oe=0;for(;De>=1;){let We=Ce;do{const ce=V[De][We];if(ce===3)We=We-2;else if(ce===2)We=We-1;else break}while(We>=1);ee>1&&re[O+De-1]===G[X+Ce-1]&&!pe(We+X-1,H,G)&&ee+1>W[De][We]&&(We=Ce),We===Ce?ee++:ee=1,oe||(oe=We),De--,Ce=We-1,Ye.push(Ce)}ae===be&&he.boostFullMatch&&(Ye[0]+=2);const ye=oe-be;return Ye[0]-=ye,Ye}e.fuzzyScore=Oe;function ve(J,re,O,H,G,X){let he=J-1,be=re-1;for(;he>=O&&be>=H;)G[he]===X[be]&&(K[he]=be,he--),be--}function ue(J,re,O,H,G,X,he,be,ae,De,Ce){if(re[O]!==X[he])return Number.MIN_SAFE_INTEGER;let ze=1,Ke=!1;return he===O-H?ze=J[O]===G[he]?7:5:pe(he,G,X)&&(he===0||!pe(he-1,G,X))?(ze=J[O]===G[he]?7:5,Ke=!0):Q(X,he)&&(he===0||!Q(X,he-1))?ze=5:(Q(X,he-1)||le(X,he-1))&&(ze=5,Ke=!0),ze>1&&O===H&&(Ce[0]=!0),Ke||(Ke=pe(he,G,X)||Q(X,he-1)||le(X,he-1)),O===H?he>ae&&(ze-=Ke?3:5):De?ze+=Ke?2:0:ze+=Ke?0:1,he+1===be&&(ze-=Ke?3:5),ze}function de(J,re,O,H,G,X,he){return ie(J,re,O,H,G,X,!0,he)}e.fuzzyScoreGracefulAggressive=de;function we(J,re,O,H,G,X,he){return ie(J,re,O,H,G,X,!1,he)}e.fuzzyScoreGraceful=we;function ie(J,re,O,H,G,X,he,be){let ae=Oe(J,re,O,H,G,X,be);if(ae&&!he)return ae;if(J.length>=3){const De=Math.min(7,J.length-1);for(let Ce=O+1;Ce<De;Ce++){const ze=me(J,Ce);if(ze){const Ke=Oe(ze,ze.toLowerCase(),O,H,G,X,be);Ke&&(Ke[0]-=3,(!ae||Ke[0]>ae[0])&&(ae=Ke))}}}return ae}function me(J,re){if(re+1>=J.length)return;const O=J[re],H=J[re+1];if(O!==H)return J.slice(0,re)+H+O+J.slice(re+2)}}),define(Ie[156],ke([1,0,76,103,8]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(u.CSSIcon.iconNameCharacter),C=new RegExp(`(\\\\)?${P.source}`,"g");function E(g){return g.replace(C,(f,p)=>p?f:`\\${f}`)}e.escapeIcons=E;const I=new RegExp(`\\\\${P.source}`,"g");function R(g){return g.replace(I,f=>`\\${f}`)}e.markdownEscapeEscapedIcons=R;const k=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function _(g){return g.indexOf(e.iconStartMarker)===-1?g:g.replace(k,(f,p,v,c)=>v?f:p||c||"")}e.stripIcons=_;function T(g){const f=g.indexOf(e.iconStartMarker);return f===-1?{text:g}:w(g,f)}e.parseLabelWithIcons=T;function w(g,f){const p=[];let v="";function c(s){if(s){v+=s;for(const l of s)p.push(d)}}let m=-1,a="",d=0,r,o,i=f;const n=g.length;for(c(g.substr(0,f));i<n;)r=g[i],o=g[i+1],r===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(m=i,c(a),a=e.iconStartMarker,i++):r===")"&&m!==-1?(d+=i-m+1,m=-1,a=""):m!==-1?y.test(r)?a+=r:(c(a),m=-1,a=""):c(r),i++;return c(a),{text:v,iconOffsets:p}}function b(g,f,p=!1){const{text:v,iconOffsets:c}=f;if(!c||c.length===0)return(0,t.matchesFuzzy)(g,v,p);const m=(0,D.ltrim)(v," "),a=v.length-m.length,d=(0,t.matchesFuzzy)(g,m,p);if(d)for(const r of d){const o=c[r.start+a]+a;r.start+=o,r.end+=o}return d}e.matchesFuzzyIconAware=b}),define(Ie[80],ke([1,0,25]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new u.LRUCache(1e4);function D(I){return E(I,"NFC",t)}e.normalizeNFC=D;const P=new u.LRUCache(1e4);function y(I){return E(I,"NFD",P)}e.normalizeNFD=y;const C=/[^\u0000-\u0080]/;function E(I,R,k){if(!I)return I;const _=k.get(I);if(_)return _;let T;return C.test(I)?T=I.normalize(R):T=I,k.set(I,T),T}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(R){return y(R).replace(I,"")}}()}),define(Ie[41],ke([1,0,8]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(t||(t={})),function(D){const P="error",y="warning",C="warn",E="info",I="ignore";function R(_){return _?u.equalsIgnoreCase(P,_)?D.Error:u.equalsIgnoreCase(y,_)||u.equalsIgnoreCase(C,_)?D.Warning:u.equalsIgnoreCase(E,_)?D.Info:D.Ignore:D.Ignore}D.fromValue=R;function k(_){switch(_){case D.Error:return P;case D.Warning:return y;case D.Info:return E;default:return I}}D.toString=k}(t||(t={})),e.default=t}),define(Ie[2],ke([1,0,9,13]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,P=/^\//,y=/^\/\//;function C(r,o){if(!r.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!D.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!P.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(r,o){return!r&&!o?"file":r}function I(r,o){switch(r){case"https":case"http":case"file":o?o[0]!==k&&(o=k+o):o=k;break}return o}const R="",k="/",_=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class T{constructor(o,i,n,s,l,h=!1){typeof o=="object"?(this.scheme=o.scheme||R,this.authority=o.authority||R,this.path=o.path||R,this.query=o.query||R,this.fragment=o.fragment||R):(this.scheme=E(o,h),this.authority=i||R,this.path=I(this.scheme,n||R),this.query=s||R,this.fragment=l||R,C(this,h))}static isUri(o){return o instanceof T?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return v(this,!1)}with(o){if(!o)return this;let{scheme:i,authority:n,path:s,query:l,fragment:h}=o;return i===void 0?i=this.scheme:i===null&&(i=R),n===void 0?n=this.authority:n===null&&(n=R),s===void 0?s=this.path:s===null&&(s=R),l===void 0?l=this.query:l===null&&(l=R),h===void 0?h=this.fragment:h===null&&(h=R),i===this.scheme&&n===this.authority&&s===this.path&&l===this.query&&h===this.fragment?this:new b(i,n,s,l,h)}static parse(o,i=!1){const n=_.exec(o);return n?new b(n[2]||R,d(n[4]||R),d(n[5]||R),d(n[7]||R),d(n[9]||R),i):new b(R,R,R,R,R)}static file(o){let i=R;if(t.isWindows&&(o=o.replace(/\\/g,k)),o[0]===k&&o[1]===k){const n=o.indexOf(k,2);n===-1?(i=o.substring(2),o=k):(i=o.substring(2,n),o=o.substring(n)||k)}return new b("file",i,o,R,R)}static from(o){const i=new b(o.scheme,o.authority,o.path,o.query,o.fragment);return C(i,!0),i}static joinPath(o,...i){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let n;return t.isWindows&&o.scheme==="file"?n=T.file(u.win32.join(v(o,!0),...i)).path:n=u.posix.join(o.path,...i),o.with({path:n})}toString(o=!1){return c(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof T)return o;{const i=new b(o);return i._formatted=o.external,i._fsPath=o._sep===w?o.fsPath:null,i}}else return o}}e.URI=T;const w=t.isWindows?1:void 0;class b extends T{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(o=!1){return o?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=w),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(r,o){let i,n=-1;for(let s=0;s<r.length;s++){const l=r.charCodeAt(s);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||o&&l===47)n!==-1&&(i+=encodeURIComponent(r.substring(n,s)),n=-1),i!==void 0&&(i+=r.charAt(s));else{i===void 0&&(i=r.substr(0,s));const h=g[l];h!==void 0?(n!==-1&&(i+=encodeURIComponent(r.substring(n,s)),n=-1),i+=h):n===-1&&(n=s)}}return n!==-1&&(i+=encodeURIComponent(r.substring(n))),i!==void 0?i:r}function p(r){let o;for(let i=0;i<r.length;i++){const n=r.charCodeAt(i);n===35||n===63?(o===void 0&&(o=r.substr(0,i)),o+=g[n]):o!==void 0&&(o+=r[i])}return o!==void 0?o:r}function v(r,o){let i;return r.authority&&r.path.length>1&&r.scheme==="file"?i=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?o?i=r.path.substr(1):i=r.path[1].toLowerCase()+r.path.substr(2):i=r.path,t.isWindows&&(i=i.replace(/\//g,"\\")),i}e.uriToFsPath=v;function c(r,o){const i=o?p:f;let n="",{scheme:s,authority:l,path:h,query:S,fragment:L}=r;if(s&&(n+=s,n+=":"),(l||s==="file")&&(n+=k,n+=k),l){let M=l.indexOf("@");if(M!==-1){const F=l.substr(0,M);l=l.substr(M+1),M=F.indexOf(":"),M===-1?n+=i(F,!1):(n+=i(F.substr(0,M),!1),n+=":",n+=i(F.substr(M+1),!1)),n+="@"}l=l.toLowerCase(),M=l.indexOf(":"),M===-1?n+=i(l,!1):(n+=i(l.substr(0,M),!1),n+=l.substr(M))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const M=h.charCodeAt(1);M>=65&&M<=90&&(h=`/${String.fromCharCode(M+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const M=h.charCodeAt(0);M>=65&&M<=90&&(h=`${String.fromCharCode(M+32)}:${h.substr(2)}`)}n+=i(h,!0)}return S&&(n+="?",n+=i(S,!1)),L&&(n+="#",n+=o?L:f(L,!1)),n}function m(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+m(r.substr(3)):r}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(r){return r.match(a)?r.replace(a,o=>m(o)):r}}),define(Ie[61],ke([1,0,23,8,2]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(I){return JSON.stringify(I,C)}e.stringify=P;function y(I){let R=JSON.parse(I);return R=E(R),R}e.parse=y;function C(I,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,t.regExpFlags)(R)}:R}function E(I,R=0){if(!I||R>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return D.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 14:return new Date(I.source)}if(I instanceof u.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let k=0;k<I.length;++k)I[k]=E(I[k],R+1);else for(const k in I)Object.hasOwnProperty.call(I,k)&&(I[k]=E(I[k],R+1))}return I}e.revive=E}),define(Ie[11],ke([1,0,13,2]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.vscodeUserData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp",C.vsls="vsls"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}setServerRootPath(E){this._remoteResourcesPath=`${E}/${D.vscodeRemoteResource}`}set(E,I,R){this._hosts[E]=I,this._ports[E]=R}setConnectionToken(E,I){this._connectionTokens[E]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(E){if(this._delegate)return this._delegate(E);const I=E.authority;let R=this._hosts[I];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const k=this._ports[I],_=this._connectionTokens[I];let T=`path=${encodeURIComponent(E.path)}`;return typeof _=="string"&&(T+=`&${e.connectionTokenQueryName}=${encodeURIComponent(_)}`),t.URI.from({scheme:u.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${R}:${k}`,path:this._remoteResourcesPath,query:T})}}e.RemoteAuthorities=new P;class y{asBrowserUri(E,I){const R=this.toUri(E,I);return R.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===D.file&&(u.isNative||u.isWebWorker&&u.globals.origin===`${D.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?R.with({scheme:D.vscodeFileResource,authority:R.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(E,I){const R=this.toUri(E,I);return R.scheme===D.vscodeFileResource?R.with({scheme:D.file,authority:R.authority!==y.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(E,I){return t.URI.isUri(E)?E:t.URI.parse(I.toUrl(E))}}y.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new y}),define(Ie[22],ke([1,0,30,11,9,13,8,2]),function(Y,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(T){return(0,C.uriToFsPath)(T,!0)}e.originalFSPath=E;class I{constructor(w){this._ignorePathCasing=w}compare(w,b,g=!1){return w===b?0:(0,y.compare)(this.getComparisonKey(w,g),this.getComparisonKey(b,g))}isEqual(w,b,g=!1){return w===b?!0:!w||!b?!1:this.getComparisonKey(w,g)===this.getComparisonKey(b,g)}getComparisonKey(w,b=!1){return w.with({path:this._ignorePathCasing(w)?w.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(w){return this._ignorePathCasing(w)}isEqualOrParent(w,b,g=!1){if(w.scheme===b.scheme){if(w.scheme===t.Schemas.file)return u.isEqualOrParent(E(w),E(b),this._ignorePathCasing(w))&&w.query===b.query&&(g||w.fragment===b.fragment);if((0,e.isEqualAuthority)(w.authority,b.authority))return u.isEqualOrParent(w.path,b.path,this._ignorePathCasing(w),"/")&&w.query===b.query&&(g||w.fragment===b.fragment)}return!1}joinPath(w,...b){return C.URI.joinPath(w,...b)}basenameOrAuthority(w){return(0,e.basename)(w)||w.authority}basename(w){return D.posix.basename(w.path)}extname(w){return D.posix.extname(w.path)}dirname(w){if(w.path.length===0)return w;let b;return w.scheme===t.Schemas.file?b=C.URI.file(D.dirname(E(w))).path:(b=D.posix.dirname(w.path),w.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),b="/")),w.with({path:b})}normalizePath(w){if(!w.path.length)return w;let b;return w.scheme===t.Schemas.file?b=C.URI.file(D.normalize(E(w))).path:b=D.posix.normalize(w.path),w.with({path:b})}relativePath(w,b){if(w.scheme!==b.scheme||!(0,e.isEqualAuthority)(w.authority,b.authority))return;if(w.scheme===t.Schemas.file){const p=D.relative(E(w),E(b));return P.isWindows?u.toSlashes(p):p}let g=w.path||"/";const f=b.path||"/";if(this._ignorePathCasing(w)){let p=0;for(const v=Math.min(g.length,f.length);p<v&&!(g.charCodeAt(p)!==f.charCodeAt(p)&&g.charAt(p).toLowerCase()!==f.charAt(p).toLowerCase());p++);g=f.substr(0,p)+g.substr(p)}return D.posix.relative(g,f)}resolvePath(w,b){if(w.scheme===t.Schemas.file){const g=C.URI.file(D.resolve(E(w),b));return w.with({authority:g.authority,path:g.path})}return b=u.toPosixPath(b),w.with({path:D.posix.resolve(w.path,b)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,b){return w===b||w!==void 0&&b!==void 0&&(0,y.equalsIgnoreCase)(w,b)}hasTrailingPathSeparator(w,b=D.sep){if(w.scheme===t.Schemas.file){const g=E(w);return g.length>u.getRoot(g).length&&g[g.length-1]===b}else{const g=w.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,b=D.sep){return(0,e.hasTrailingPathSeparator)(w,b)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,b=D.sep){let g=!1;if(w.scheme===t.Schemas.file){const f=E(w);g=f!==void 0&&f.length===u.getRoot(f).length&&f[f.length-1]===b}else{b="/";const f=w.path;g=f.length===1&&f.charCodeAt(f.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(w,b)?w.with({path:w.path+"/"}):w}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(T=>T.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new I(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(T,w){const b=[];for(let g=0;g<T.length;g++){const f=w(T[g]);T.some((p,v)=>v===g?!1:(0,e.isEqualOrParent)(f,w(p)))||b.push(T[g])}return b}e.distinctParents=R;var k;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function w(b){const g=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(v=>{const[c,m]=v.split(":");c&&m&&g.set(c,m)});const p=b.path.substring(0,b.path.indexOf(";"));return p&&g.set(T.META_DATA_MIME,p),g}T.parseMetaData=w})(k=e.DataUri||(e.DataUri={}));function _(T,w,b){if(w){let g=T.path;return g&&g[0]!==D.posix.sep&&(g=D.posix.sep+g),T.with({scheme:b,authority:w,path:g})}return T.with({scheme:b})}e.toLocalResource=_}),define(Ie[18],ke([1,0,21,12,3,6,22,13]),function(Y,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(pe){return!!pe&&typeof pe.then=="function"}e.isThenable=E;function I(pe){const Z=new u.CancellationTokenSource,ge=pe(Z.token),Ee=new Promise((Te,Oe)=>{const ve=Z.token.onCancellationRequested(()=>{ve.dispose(),Z.dispose(),Oe(new t.CancellationError)});Promise.resolve(ge).then(ue=>{ve.dispose(),Z.dispose(),Te(ue)},ue=>{ve.dispose(),Z.dispose(),Oe(ue)})});return new class{cancel(){Z.cancel()}then(Te,Oe){return Ee.then(Te,Oe)}catch(Te){return this.then(void 0,Te)}finally(Te){return Ee.finally(Te)}}}e.createCancelablePromise=I;function R(pe,Z,ge){return new Promise((Ee,Te)=>{const Oe=Z.onCancellationRequested(()=>{Oe.dispose(),Ee(ge)});pe.then(Ee,Te).finally(()=>Oe.dispose())})}e.raceCancellation=R;function k(pe,Z){return new Promise((ge,Ee)=>{const Te=Z.onCancellationRequested(()=>{Te.dispose(),Ee(new t.CancellationError)});pe.then(ge,Ee).finally(()=>Te.dispose())})}e.raceCancellationError=k;async function _(pe){let Z=-1;const ge=pe.map((Te,Oe)=>Te.then(ve=>(Z=Oe,ve))),Ee=await Promise.race(ge);return pe.forEach((Te,Oe)=>{Oe!==Z&&Te.cancel()}),Ee}e.raceCancellablePromises=_;function T(pe,Z,ge){let Ee;const Te=setTimeout(()=>{Ee?.(void 0),ge?.()},Z);return Promise.race([pe.finally(()=>clearTimeout(Te)),new Promise(Oe=>Ee=Oe)])}e.raceTimeout=T;function w(pe){return new Promise((Z,ge)=>{const Ee=pe();E(Ee)?Ee.then(Z,ge):Z(Ee)})}e.asPromise=w;class b{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Z){if(this.activePromise){if(this.queuedPromiseFactory=Z,!this.queuedPromise){const ge=()=>{this.queuedPromise=null;const Ee=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Ee};this.queuedPromise=new Promise(Ee=>{this.activePromise.then(ge,ge).then(Ee)})}return new Promise((ge,Ee)=>{this.queuedPromise.then(ge,Ee)})}return this.activePromise=Z(),new Promise((ge,Ee)=>{this.activePromise.then(Te=>{this.activePromise=null,ge(Te)},Te=>{this.activePromise=null,Ee(Te)})})}}e.Throttler=b;class g{constructor(){this.current=Promise.resolve(null)}queue(Z){return this.current=this.current.then(()=>Z(),()=>Z())}}e.Sequencer=g;class f{constructor(){this.promiseMap=new Map}queue(Z,ge){const Te=(this.promiseMap.get(Z)??Promise.resolve()).catch(()=>{}).then(ge).finally(()=>{this.promiseMap.get(Z)===Te&&this.promiseMap.delete(Z)});return this.promiseMap.set(Z,Te),Te}}e.SequencerByKey=f;const p=(pe,Z)=>{let ge=!0;const Ee=setTimeout(()=>{ge=!1,Z()},pe);return{isTriggered:()=>ge,dispose:()=>{clearTimeout(Ee),ge=!1}}},v=pe=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,pe())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(Z){this.defaultDelay=Z,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Z,ge=this.defaultDelay){this.task=Z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Te,Oe)=>{this.doResolve=Te,this.doReject=Oe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Te=this.task;return this.task=null,Te()}}));const Ee=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ge===e.MicrotaskDelay?v(Ee):p(ge,Ee),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class m{constructor(Z){this.delayer=new c(Z),this.throttler=new b}trigger(Z,ge){return this.delayer.trigger(()=>this.throttler.queue(Z),ge)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=m;class a{constructor(){this._isOpen=!1,this._promise=new Promise((Z,ge)=>{this._completePromise=Z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class d extends a{constructor(Z){super();this._timeout=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function r(pe,Z){return Z?new Promise((ge,Ee)=>{const Te=setTimeout(()=>{Oe.dispose(),ge()},pe),Oe=Z.onCancellationRequested(()=>{clearTimeout(Te),Oe.dispose(),Ee(new t.CancellationError)})}):I(ge=>r(pe,ge))}e.timeout=r;function o(pe,Z=0){const ge=setTimeout(pe,Z);return(0,P.toDisposable)(()=>clearTimeout(ge))}e.disposableTimeout=o;function i(pe){const Z=[];let ge=0;const Ee=pe.length;function Te(){return ge<Ee?pe[ge++]():null}function Oe(ve){ve!=null&&Z.push(ve);const ue=Te();return ue?ue.then(Oe):Promise.resolve(Z)}return Promise.resolve(null).then(Oe)}e.sequence=i;function n(pe,Z=Ee=>!!Ee,ge=null){let Ee=0;const Te=pe.length,Oe=()=>{if(Ee>=Te)return Promise.resolve(ge);const ve=pe[Ee++];return Promise.resolve(ve()).then(de=>Z(de)?Promise.resolve(de):Oe())};return Oe()}e.first=n;function s(pe,Z=Ee=>!!Ee,ge=null){if(pe.length===0)return Promise.resolve(ge);let Ee=pe.length;const Te=()=>{Ee=-1;for(const Oe of pe)Oe.cancel?.()};return new Promise((Oe,ve)=>{for(const ue of pe)ue.then(de=>{--Ee>=0&&Z(de)?(Te(),Oe(de)):Ee===0&&Oe(ge)}).catch(de=>{--Ee>=0&&(Te(),ve(de))})})}e.firstParallel=s;class l{constructor(Z){this._size=0,this.maxDegreeOfParalellism=Z,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Z){return this._size++,new Promise((ge,Ee)=>{this.outstandingPromises.push({factory:Z,c:ge,e:Ee}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Z=this.outstandingPromises.shift();this.runningPromises++;const ge=Z.factory();ge.then(Z.c,Z.e),ge.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=l;class h extends l{constructor(){super(1)}}e.Queue=h;class S{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Z=new V;return this.drainers.add(Z),Z.p}isDrained(){for(const[,Z]of this.queues)if(Z.size>0)return!1;return!0}queueFor(Z,ge=y.extUri){const Ee=ge.getComparisonKey(Z);let Te=this.queues.get(Ee);return Te||(Te=new h,D.Event.once(Te.onDrained)(()=>{Te?.dispose(),this.queues.delete(Ee),this.onDidQueueDrain()}),this.queues.set(Ee,Te)),Te}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Z of this.drainers)Z.complete();this.drainers.clear()}dispose(){for(const[,Z]of this.queues)Z.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=S;class L{constructor(Z,ge){this._token=-1,typeof Z=="function"&&typeof ge=="number"&&this.setIfNotSet(Z,ge)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Z,ge){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Z()},ge)}setIfNotSet(Z,ge){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Z()},ge))}}e.TimeoutTimer=L;class M{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Z,ge){this.cancel(),this._token=setInterval(()=>{Z()},ge)}}e.IntervalTimer=M;class F{constructor(Z,ge){this.timeoutToken=-1,this.runner=Z,this.timeout=ge,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Z)}get delay(){return this.timeout}set delay(Z){this.timeout=Z}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=F;class A{constructor(Z,ge){ge%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ge}ms is not a multiple of 1000ms.`),this.runner=Z,this.timeout=ge,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Z=this.timeout){Z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Z/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=A;class B extends F{constructor(Z,ge){super(Z,ge);this.units=[]}work(Z){this.units.push(Z),this.isScheduled()||this.schedule()}doRun(){const Z=this.units;this.units=[],this.runner?.(Z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=B;class $ extends P.Disposable{constructor(Z,ge){super();this.options=Z,this.handler=ge,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Z){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Z.length>this.options.maxBufferedWork)return!1}else if(this.pending+Z.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Z),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new F(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=pe=>{(0,C.setTimeout0)(()=>{if(Z)return;const ge=Date.now()+15;pe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.runWhenIdle=(pe,Z)=>{const ge=requestIdleCallback(pe,typeof Z=="number"?{timeout:Z}:void 0);let Ee=!1;return{dispose(){Ee||(Ee=!0,cancelIdleCallback(ge))}}}}();class U{constructor(Z){this._didRun=!1,this._executor=()=>{try{this._value=Z()}catch(ge){this._error=ge}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=U;async function K(pe,Z,ge){let Ee;for(let Te=0;Te<ge;Te++)try{return await pe()}catch(Oe){Ee=Oe,await r(Z)}throw Ee}e.retry=K;class W{hasPending(Z){return this._pending?typeof Z=="number"?this._pending.taskId===Z:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Z,ge,Ee){return this._pending={taskId:Z,cancel:()=>Ee?.(),promise:ge},ge.then(()=>this.donePending(Z),()=>this.donePending(Z)),ge}donePending(Z){this._pending&&Z===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Z=this._next;this._next=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}setNext(Z){if(this._next)this._next.run=Z;else{let ge,Ee;const Te=new Promise((Oe,ve)=>{ge=Oe,Ee=ve});this._next={run:Z,promise:Te,promiseResolve:ge,promiseReject:Ee}}return this._next.promise}}e.TaskSequentializer=W;class N{constructor(Z,ge=()=>Date.now()){this.interval=Z,this.nowFn=ge,this.lastIncrementTime=0,this.value=0}increment(){const Z=this.nowFn();return Z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Z,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Z,ge)=>{this.completeCallback=Z,this.errorCallback=ge})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Z){return new Promise(ge=>{this.completeCallback(Z),this.resolved=!0,ge()})}error(Z){return new Promise(ge=>{this.errorCallback(Z),this.rejected=!0,ge()})}cancel(){new Promise(Z=>{this.errorCallback(new t.CancellationError),this.rejected=!0,Z()})}}e.DeferredPromise=V;var x;(function(pe){async function Z(Ee){let Te;const Oe=await Promise.all(Ee.map(ve=>ve.then(ue=>ue,ue=>{Te||(Te=ue)})));if(typeof Te!="undefined")throw Te;return Oe}pe.settled=Z;function ge(Ee){return new Promise(async(Te,Oe)=>{try{await Ee(Te,Oe)}catch(ve){Oe(ve)}})}pe.withAsyncBody=ge})(x=e.Promises||(e.Promises={}));var q;(function(pe){pe[pe.Initial=0]="Initial",pe[pe.DoneOK=1]="DoneOK",pe[pe.DoneError=2]="DoneError"})(q||(q={}));class te{constructor(Z){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const ge={emitOne:Ee=>this.emitOne(Ee),emitMany:Ee=>this.emitMany(Ee),reject:Ee=>this.reject(Ee)};try{await Promise.resolve(Z(ge)),this.resolve()}catch(Ee){this.reject(Ee)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}static fromArray(Z){return new te(ge=>{ge.emitMany(Z)})}static fromPromise(Z){return new te(async ge=>{ge.emitMany(await Z)})}static fromPromises(Z){return new te(async ge=>{await Promise.all(Z.map(async Ee=>ge.emitOne(await Ee)))})}static merge(Z){return new te(async ge=>{await Promise.all(Z.map(async Ee=>{for await(const Te of Ee)ge.emitOne(Te)}))})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Z<this._results.length)return{done:!1,value:this._results[Z++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Z,ge){return new te(async Ee=>{for await(const Te of Z)Ee.emitOne(ge(Te))})}map(Z){return te.map(this,Z)}static filter(Z,ge){return new te(async Ee=>{for await(const Te of Z)ge(Te)&&Ee.emitOne(Te)})}filter(Z){return te.filter(this,Z)}static coalesce(Z){return te.filter(Z,ge=>!!ge)}coalesce(){return te.coalesce(this)}static async toPromise(Z){const ge=[];for await(const Ee of Z)ge.push(Ee);return ge}toPromise(){return te.toPromise(this)}emitOne(Z){this._state===0&&(this._results.push(Z),this._onStateChanged.fire())}emitMany(Z){this._state===0&&(this._results=this._results.concat(Z),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Z){this._state===0&&(this._state=2,this._error=Z,this._onStateChanged.fire())}}e.AsyncIterableObject=te,te.EMPTY=te.fromArray([]);class Q extends te{constructor(Z,ge){super(ge);this._source=Z}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Q;function le(pe){const Z=new u.CancellationTokenSource,ge=pe(Z.token);return new Q(Z,async Ee=>{const Te=Z.token.onCancellationRequested(()=>{Te.dispose(),Z.dispose(),Ee.reject(new t.CancellationError)});try{for await(const Oe of ge){if(Z.token.isCancellationRequested)return;Ee.emitOne(Oe)}Te.dispose(),Z.dispose()}catch(Oe){Te.dispose(),Z.dispose(),Ee.reject(Oe)}})}e.createCancelableAsyncIterable=le}),define(Ie[104],ke([1,0,18,9]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new u.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),P=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(h,S,L=!1){const M=h||"",F=S||"",A=D.value.collator.compare(M,F);return D.value.collatorIsNumeric&&A===0&&M!==F?M<F?-1:1:A}e.compareFileNames=C;function E(h,S){const L=P.value.collator;return h=h||"",S=S||"",m(L,h,S)}e.compareFileNamesDefault=E;function I(h,S){const L=P.value.collator;return h=h||"",S=S||"",o(h,S)||m(L,h,S)}e.compareFileNamesUpper=I;function R(h,S){const L=P.value.collator;return h=h||"",S=S||"",r(h,S)||m(L,h,S)}e.compareFileNamesLower=R;function k(h,S){return h=h||"",S=S||"",h===S?0:h<S?-1:1}e.compareFileNamesUnicode=k;function _(h,S,L=!1){L||(h=h&&h.toLowerCase(),S=S&&S.toLowerCase());const[M,F]=v(h),[A,B]=v(S);return M!==A?M<A?-1:1:F===B?0:F<B?-1:1}e.noIntlCompareFileNames=_;function T(h,S){const[L,M]=v(h),[F,A]=v(S);let B=D.value.collator.compare(M,A);if(B===0){if(D.value.collatorIsNumeric&&M!==A)return M<A?-1:1;if(B=D.value.collator.compare(L,F),D.value.collatorIsNumeric&&B===0&&L!==F)return L<F?-1:1}return B}e.compareFileExtensions=T;function w(h,S){h=h||"",S=S||"";const L=c(h),M=c(S),F=P.value.collator,A=y.value.collator;return m(A,L,M)||m(F,h,S)}e.compareFileExtensionsDefault=w;function b(h,S){h=h||"",S=S||"";const L=c(h),M=c(S),F=P.value.collator,A=y.value.collator;return m(A,L,M)||o(h,S)||m(F,h,S)}e.compareFileExtensionsUpper=b;function g(h,S){h=h||"",S=S||"";const L=c(h),M=c(S),F=P.value.collator,A=y.value.collator;return m(A,L,M)||r(h,S)||m(F,h,S)}e.compareFileExtensionsLower=g;function f(h,S){h=h||"",S=S||"";const L=c(h).toLowerCase(),M=c(S).toLowerCase();return L!==M?L<M?-1:1:h!==S?h<S?-1:1:0}e.compareFileExtensionsUnicode=f;const p=/^(.*?)(\.([^.]*))?$/;function v(h,S=!1){const L=h?p.exec(h):[];let M=[L&&L[1]||"",L&&L[3]||""];return S&&(!M[0]&&M[1]||M[0]&&M[0].charAt(0)===".")&&(M=[M[0]+"."+M[1],""]),M}function c(h){const S=h?p.exec(h):[];return S&&S[1]&&S[1].charAt(0)!=="."&&S[3]||""}function m(h,S,L){const M=h.compare(S,L);return M!==0?M:S.length!==L.length?S.length<L.length?-1:1:0}function a(h){const S=h.charAt(0);return S.toLocaleUpperCase()!==S}function d(h){const S=h.charAt(0);return S.toLocaleLowerCase()!==S}function r(h,S){return a(h)&&d(S)?-1:d(h)&&a(S)?1:0}function o(h,S){return d(h)&&a(S)?-1:a(h)&&d(S)?1:0}function i(h,S,L=!1){return L||(h=h&&h.toLowerCase(),S=S&&S.toLowerCase()),h===S?0:h<S?-1:1}function n(h,S,L=!1){const M=h.split(t.sep),F=S.split(t.sep),A=M.length-1,B=F.length-1;let $,U;for(let K=0;;K++){if($=A===K,U=B===K,$&&U)return C(M[K],F[K],L);if($)return-1;if(U)return 1;const W=i(M[K],F[K],L);if(W!==0)return W}}e.comparePaths=n;function s(h,S,L){const M=h.toLowerCase(),F=S.toLowerCase(),A=l(h,S,L);if(A)return A;const B=M.endsWith(L),$=F.endsWith(L);if(B!==$)return B?-1:1;const U=C(M,F);return U!==0?U:M.localeCompare(F)}e.compareAnything=s;function l(h,S,L){const M=h.toLowerCase(),F=S.toLowerCase(),A=M.startsWith(L),B=F.startsWith(L);if(A!==B)return A?-1:1;if(A&&B){if(M.length<F.length)return-1;if(M.length>F.length)return 1}return 0}e.compareByPrefix=l}),define(Ie[105],ke([1,0,104,103,60,9,13,8]),function(Y,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const E=0,I=[E,[]];function R(W,N,V,x){if(!W||!N)return I;const q=W.length,te=N.length;if(q<te)return I;const Q=W.toLowerCase();return k(N,V,te,W,Q,q,x)}e.scoreFuzzy=R;function k(W,N,V,x,q,te,Q){const le=[],pe=[];for(let Te=0;Te<V;Te++){const Oe=Te*te,ve=Oe-te,ue=Te>0,de=W[Te],we=N[Te];for(let ie=0;ie<te;ie++){const me=ie>0,J=Oe+ie,re=J-1,O=ve+ie-1,H=me?le[re]:0,G=ue&&me?le[O]:0,X=ue&&me?pe[O]:0;let he;!G&&ue?he=0:he=_(de,we,x,q,ie,X),he&&G+he>=H&&(Q||ue||q.startsWith(N,ie))?(pe[J]=X+1,le[J]=G+he):(pe[J]=E,le[J]=H)}}const Z=[];let ge=V-1,Ee=te-1;for(;ge>=0&&Ee>=0;){const Te=ge*te+Ee;pe[Te]===E||(Z.push(Ee),ge--),Ee--}return[le[V*te-1],Z.reverse()]}function _(W,N,V,x,q,te){let Q=0;if(!T(N,x[q]))return Q;if(Q+=1,te>0&&(Q+=te*5),W===V[q]&&(Q+=1),q===0)Q+=8;else{const le=w(V.charCodeAt(q-1));le?Q+=le:(0,t.isUpper)(V.charCodeAt(q))&&te===0&&(Q+=2)}return Q}function T(W,N){return W===N?!0:W==="/"||W==="\\"?N==="/"||N==="\\":!1}function w(W){switch(W){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const b=[void 0,[]];function g(W,N,V=0,x=0){const q=N;return q.values&&q.values.length>1?f(W,q.values,V,x):p(W,N,V,x)}e.scoreFuzzy2=g;function f(W,N,V,x){let q=0;const te=[];for(const Q of N){const[le,pe]=p(W,Q,V,x);if(typeof le!="number")return b;q+=le,te.push(...pe)}return[q,l(te)]}function p(W,N,V,x){const q=(0,t.fuzzyScore)(N.original,N.originalLowercase,V,W,W.toLowerCase(),x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?[q[0],(0,t.createMatches)(q)]:b}const v=Object.freeze({score:0}),c=1<<18,m=1<<17,a=1<<16;function d(W,N,V,x){const q=x.values?x.values:[x];return(0,D.hash)({[x.normalized]:{values:q.map(Q=>({value:Q.normalized,expectContiguousMatch:Q.expectContiguousMatch})),label:W,description:N,allowNonContiguousMatches:V}})}function r(W,N,V,x,q){if(!W||!N.normalized)return v;const te=x.getItemLabel(W);if(!te)return v;const Q=x.getItemDescription(W),le=d(te,Q,V,N),pe=q[le];if(pe)return pe;const Z=o(te,Q,x.getItemPath(W),N,V);return q[le]=Z,Z}e.scoreItemFuzzy=r;function o(W,N,V,x,q){const te=!V||!x.containsPathSeparator;return V&&(y.isLinux?x.pathNormalized===V:(0,C.equalsIgnoreCase)(x.pathNormalized,V))?{score:c,labelMatch:[{start:0,end:W.length}],descriptionMatch:N?[{start:0,end:N.length}]:void 0}:x.values&&x.values.length>1?i(W,N,V,x.values,te,q):n(W,N,V,x,te,q)}function i(W,N,V,x,q,te){let Q=0;const le=[],pe=[];for(const Z of x){const{score:ge,labelMatch:Ee,descriptionMatch:Te}=n(W,N,V,Z,q,te);if(ge===E)return v;Q+=ge,Ee&&le.push(...Ee),Te&&pe.push(...Te)}return{score:Q,labelMatch:l(le),descriptionMatch:l(pe)}}function n(W,N,V,x,q,te){if(q||!N){const[Q,le]=R(W,x.normalized,x.normalizedLowercase,te&&!x.expectContiguousMatch);if(Q){const pe=(0,t.matchesPrefix)(x.normalized,W);let Z;return pe?(Z=m,Z+=Math.round(x.normalized.length/W.length*100)):Z=a,{score:Z+Q,labelMatch:pe||s(le)}}}if(N){let Q=N;V&&(Q=`${N}${P.sep}`);const le=Q.length,pe=`${Q}${W}`,[Z,ge]=R(pe,x.normalized,x.normalizedLowercase,te&&!x.expectContiguousMatch);if(Z){const Ee=s(ge),Te=[],Oe=[];return Ee.forEach(ve=>{ve.start<le&&ve.end>le?(Te.push({start:0,end:ve.end-le}),Oe.push({start:ve.start,end:le})):ve.start>=le?Te.push({start:ve.start-le,end:ve.end-le}):Oe.push(ve)}),{score:Z,labelMatch:Te,descriptionMatch:Oe}}}return v}function s(W){const N=[];if(!W)return N;let V;for(const x of W)V&&V.end===x?V.end+=1:(V={start:x,end:x+1},N.push(V));return N}function l(W){const N=W.sort((q,te)=>q.start-te.start),V=[];let x;for(const q of N)!x||!h(x,q)?(x=q,V.push(q)):(x.start=Math.min(x.start,q.start),x.end=Math.max(x.end,q.end));return V}function h(W,N){return!(W.end<N.start||N.end<W.start)}function S(W,N,V,x,q,te){const Q=r(W,V,x,q,te),le=r(N,V,x,q,te),pe=Q.score,Z=le.score;if((pe===c||Z===c)&&pe!==Z)return pe===c?-1:1;if(pe>a||Z>a){if(pe!==Z)return pe>Z?-1:1;if(pe<m&&Z<m){const de=M(Q.labelMatch,le.labelMatch);if(de!==0)return de}const ve=q.getItemLabel(W)||"",ue=q.getItemLabel(N)||"";if(ve.length!==ue.length)return ve.length-ue.length}if(pe!==Z)return pe>Z?-1:1;const ge=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0,Ee=Array.isArray(le.labelMatch)&&le.labelMatch.length>0;if(ge&&!Ee)return-1;if(Ee&&!ge)return 1;const Te=L(W,Q,q),Oe=L(N,le,q);return Te&&Oe&&Te!==Oe?Oe>Te?-1:1:F(W,N,V,q)}e.compareItemsByFuzzyScore=S;function L(W,N,V){let x=-1,q=-1;if(N.descriptionMatch&&N.descriptionMatch.length?x=N.descriptionMatch[0].start:N.labelMatch&&N.labelMatch.length&&(x=N.labelMatch[0].start),N.labelMatch&&N.labelMatch.length){if(q=N.labelMatch[N.labelMatch.length-1].end,N.descriptionMatch&&N.descriptionMatch.length){const te=V.getItemDescription(W);te&&(q+=te.length)}}else N.descriptionMatch&&N.descriptionMatch.length&&(q=N.descriptionMatch[N.descriptionMatch.length-1].end);return q-x}function M(W,N){if(!W&&!N||(!W||!W.length)&&(!N||!N.length))return 0;if(!N||!N.length)return-1;if(!W||!W.length)return 1;const V=W[0].start,q=W[W.length-1].end-V,te=N[0].start,le=N[N.length-1].end-te;return q===le?0:le<q?1:-1}function F(W,N,V,x){const q=x.getItemLabel(W)||"",te=x.getItemLabel(N)||"",Q=x.getItemDescription(W),le=x.getItemDescription(N),pe=q.length+(Q?Q.length:0),Z=te.length+(le?le.length:0);if(pe!==Z)return pe-Z;const ge=x.getItemPath(W),Ee=x.getItemPath(N);return ge&&Ee&&ge.length!==Ee.length?ge.length-Ee.length:q!==te?(0,u.compareAnything)(q,te,V.normalized):Q&&le&&Q!==le?(0,u.compareAnything)(Q,le,V.normalized):ge&&Ee&&ge!==Ee?(0,u.compareAnything)(ge,Ee,V.normalized):0}function A(W){return W.startsWith('"')&&W.endsWith('"')}const B=" ";function $(W){typeof W!="string"&&(W="");const N=W.toLowerCase(),{pathNormalized:V,normalized:x,normalizedLowercase:q}=U(W),te=V.indexOf(P.sep)>=0,Q=A(W);let le;const pe=W.split(B);if(pe.length>1)for(const Z of pe){const ge=A(Z),{pathNormalized:Ee,normalized:Te,normalizedLowercase:Oe}=U(Z);Te&&(le||(le=[]),le.push({original:Z,originalLowercase:Z.toLowerCase(),pathNormalized:Ee,normalized:Te,normalizedLowercase:Oe,expectContiguousMatch:ge}))}return{original:W,originalLowercase:N,pathNormalized:V,normalized:x,normalizedLowercase:q,values:le,containsPathSeparator:te,expectContiguousMatch:Q}}e.prepareQuery=$;function U(W){let N;y.isWindows?N=W.replace(/\//g,P.sep):N=W.replace(/\\/g,P.sep);const V=(0,C.stripWildcards)(N).replace(/\s|"/g,"");return{pathNormalized:N,normalized:V,normalizedLowercase:V.toLowerCase()}}function K(W){return Array.isArray(W)?$(W.map(N=>N.original).join(B)):$(W.original)}e.pieceToQuery=K}),define(Ie[36],ke([1,0,16,18,30,25,9,13,8]),function(Y,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",k="[^/\\\\]",_=/\//g;function T(V,x){switch(V){case 0:return"";case 1:return`${k}*?`;default:return`(?:${R}|${k}+${R}${x?`|${R}${k}+`:""})*?`}}function w(V,x){if(!V)return[];const q=[];let te=!1,Q=!1,le="";for(const pe of V){switch(pe){case x:if(!te&&!Q){q.push(le),le="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}le+=pe}return le&&q.push(le),q}e.splitGlobAware=w;function b(V){if(!V)return"";let x="";const q=w(V,e.GLOB_SPLIT);if(q.every(te=>te===e.GLOBSTAR))x=".*";else{let te=!1;q.forEach((Q,le)=>{if(Q===e.GLOBSTAR){if(te)return;x+=T(2,le===q.length-1)}else{let pe=!1,Z="",ge=!1,Ee="";for(const Te of Q){if(Te!=="}"&&pe){Z+=Te;continue}if(ge&&(Te!=="]"||!Ee)){let Oe;Te==="-"?Oe=Te:(Te==="^"||Te==="!")&&!Ee?Oe="^":Te===e.GLOB_SPLIT?Oe="":Oe=(0,E.escapeRegExpCharacters)(Te),Ee+=Oe;continue}switch(Te){case"{":pe=!0;continue;case"[":ge=!0;continue;case"}":{x+=`(?:${w(Z,",").map(ue=>b(ue)).join("|")})`,pe=!1,Z="";break}case"]":{x+="["+Ee+"]",ge=!1,Ee="";break}case"?":x+=k;continue;case"*":x+=T(1);continue;default:x+=(0,E.escapeRegExpCharacters)(Te)}}le<q.length-1&&(q[le+1]!==e.GLOBSTAR||le+2<q.length)&&(x+=R)}te=Q===e.GLOBSTAR})}return x}const g=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,a=new P.LRUCache(1e4),d=function(){return!1},r=function(){return null};function o(V,x){if(!V)return r;let q;typeof V!="string"?q=V.pattern:q=V,q=q.trim();const te=`${q}_${!!x.trimForExclusions}`;let Q=a.get(te);if(Q)return i(Q,V);let le;return g.test(q)?Q=s(q.substr(4),q):(le=f.exec(n(q,x)))?Q=l(le[1],q):(x.trimForExclusions?v:p).test(q)?Q=h(q,x):(le=c.exec(n(q,x)))?Q=S(le[1].substr(1),q,!0):(le=m.exec(n(q,x)))?Q=S(le[1],q,!1):Q=L(q),a.set(te,Q),i(Q,V)}function i(V,x){if(typeof x=="string")return V;const q=function(te,Q){return(0,D.isEqualOrParent)(te,x.base,!C.isLinux)?V(te.substr(x.base.length+1),Q):null};return q.allBasenames=V.allBasenames,q.allPaths=V.allPaths,q.basenames=V.basenames,q.patterns=V.patterns,q}function n(V,x){return x.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function s(V,x){return function(q,te){return typeof q=="string"&&q.endsWith(V)?x:null}}function l(V,x){const q=`/${V}`,te=`\\${V}`,Q=function(pe,Z){return typeof pe!="string"?null:Z?Z===V?x:null:pe===V||pe.endsWith(q)||pe.endsWith(te)?x:null},le=[V];return Q.basenames=le,Q.patterns=[x],Q.allBasenames=le,Q}function h(V,x){const q=W(V.slice(1,-1).split(",").map(Z=>o(Z,x)).filter(Z=>Z!==r),V),te=q.length;if(!te)return r;if(te===1)return q[0];const Q=function(Z,ge){for(let Ee=0,Te=q.length;Ee<Te;Ee++)if(q[Ee](Z,ge))return V;return null},le=q.find(Z=>!!Z.allBasenames);le&&(Q.allBasenames=le.allBasenames);const pe=q.reduce((Z,ge)=>ge.allPaths?Z.concat(ge.allPaths):Z,[]);return pe.length&&(Q.allPaths=pe),Q}function S(V,x,q){const te=y.sep===y.posix.sep,Q=te?V:V.replace(_,y.sep),le=y.sep+Q,pe=y.posix.sep+V;let Z;return q?Z=function(ge,Ee){return typeof ge=="string"&&(ge===Q||ge.endsWith(le)||!te&&(ge===V||ge.endsWith(pe)))?x:null}:Z=function(ge,Ee){return typeof ge=="string"&&(ge===Q||!te&&ge===V)?x:null},Z.allPaths=[(q?"*/":"./")+V],Z}function L(V){try{const x=new RegExp(`^${b(V)}$`);return function(q){return x.lastIndex=0,typeof q=="string"&&x.test(q)?V:null}}catch{return r}}function M(V,x,q){return!V||typeof x!="string"?!1:F(V)(x,void 0,q)}e.match=M;function F(V,x={}){if(!V)return d;if(typeof V=="string"||A(V)){const q=o(V,x);if(q===r)return d;const te=function(Q,le){return!!q(Q,le)};return q.allBasenames&&(te.allBasenames=q.allBasenames),q.allPaths&&(te.allPaths=q.allPaths),te}return U(V,x)}e.parse=F;function A(V){const x=V;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=A;function B(V){return V.allBasenames||[]}e.getBasenameTerms=B;function $(V){return V.allPaths||[]}e.getPathTerms=$;function U(V,x){const q=W(Object.getOwnPropertyNames(V).map(Z=>K(Z,V[Z],x)).filter(Z=>Z!==r)),te=q.length;if(!te)return r;if(!q.some(Z=>!!Z.requiresSiblings)){if(te===1)return q[0];const Z=function(Te,Oe){let ve;for(let ue=0,de=q.length;ue<de;ue++){const we=q[ue](Te,Oe);if(typeof we=="string")return we;(0,t.isThenable)(we)&&(ve||(ve=[]),ve.push(we))}return ve?(async()=>{for(const ue of ve){const de=await ue;if(typeof de=="string")return de}return null})():null},ge=q.find(Te=>!!Te.allBasenames);ge&&(Z.allBasenames=ge.allBasenames);const Ee=q.reduce((Te,Oe)=>Oe.allPaths?Te.concat(Oe.allPaths):Te,[]);return Ee.length&&(Z.allPaths=Ee),Z}const Q=function(Z,ge,Ee){let Te,Oe;for(let ve=0,ue=q.length;ve<ue;ve++){const de=q[ve];de.requiresSiblings&&Ee&&(ge||(ge=(0,y.basename)(Z)),Te||(Te=ge.substr(0,ge.length-(0,y.extname)(Z).length)));const we=de(Z,ge,Te,Ee);if(typeof we=="string")return we;(0,t.isThenable)(we)&&(Oe||(Oe=[]),Oe.push(we))}return Oe?(async()=>{for(const ve of Oe){const ue=await ve;if(typeof ue=="string")return ue}return null})():null},le=q.find(Z=>!!Z.allBasenames);le&&(Q.allBasenames=le.allBasenames);const pe=q.reduce((Z,ge)=>ge.allPaths?Z.concat(ge.allPaths):Z,[]);return pe.length&&(Q.allPaths=pe),Q}function K(V,x,q){if(x===!1)return r;const te=o(V,q);if(te===r)return r;if(typeof x=="boolean")return te;if(x){const Q=x.when;if(typeof Q=="string"){const le=(pe,Z,ge,Ee)=>{if(!Ee||!te(pe,Z))return null;const Te=Q.replace("$(basename)",ge),Oe=Ee(Te);return(0,t.isThenable)(Oe)?Oe.then(ve=>ve?V:null):Oe?V:null};return le.requiresSiblings=!0,le}}return te}function W(V,x){const q=V.filter(Z=>!!Z.basenames);if(q.length<2)return V;const te=q.reduce((Z,ge)=>{const Ee=ge.basenames;return Ee?Z.concat(Ee):Z},[]);let Q;if(x){Q=[];for(let Z=0,ge=te.length;Z<ge;Z++)Q.push(x)}else Q=q.reduce((Z,ge)=>{const Ee=ge.patterns;return Ee?Z.concat(Ee):Z},[]);const le=function(Z,ge){if(typeof Z!="string")return null;if(!ge){let Te;for(Te=Z.length;Te>0;Te--){const Oe=Z.charCodeAt(Te-1);if(Oe===47||Oe===92)break}ge=Z.substr(Te)}const Ee=te.indexOf(ge);return Ee!==-1?Q[Ee]:null};le.basenames=te,le.patterns=Q,le.allBasenames=te;const pe=V.filter(Z=>!Z.basenames);return pe.push(le),pe}function N(V,x){return(0,u.equals)(V,x,(q,te)=>typeof q=="string"&&typeof te=="string"?q===te:typeof q!="string"&&typeof te!="string"?q.base===te.base&&q.pattern===te.pattern:!1)}e.patternsEquals=N}),define(Ie[106],ke([1,0,12,156,22,8,2]),function(Y,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var C;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(C=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(f="",p=!1){if(this.value=f,typeof this.value!="string")throw(0,u.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(f,p=0){return this.value+=_(this.supportThemeIcons?(0,t.escapeIcons)(f):f).replace(/([ \t]+)/g,(v,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,p){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(f,p,v){return this.value+="[",this.value+=this._escape(p,"]"),this.value+="](",this.value+=this._escape(String(f),")"),v&&(this.value+=` "${this._escape(this._escape(v,'"'),")")}"`),this.value+=")",this}_escape(f,p){const v=new RegExp((0,P.escapeRegExpCharacters)(p),"g");return f.replace(v,(c,m)=>f.charAt(m-1)!=="\\"?`\\${c}`:c)}}e.MarkdownString=E;function I(g){return R(g)?!g.value:Array.isArray(g)?g.every(I):!0}e.isEmptyMarkdownString=I;function R(g){return g instanceof E?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function k(g,f){return g===f?!0:!g||!f?!1:g.value===f.value&&g.isTrusted===f.isTrusted&&g.supportThemeIcons===f.supportThemeIcons&&g.supportHtml===f.supportHtml&&(g.baseUri===f.baseUri||!!g.baseUri&&!!f.baseUri&&(0,D.isEqual)(y.URI.from(g.baseUri),y.URI.from(f.baseUri)))}e.markdownStringEqual=k;function _(g){return g.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=_;function T(g){return g.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=T;function w(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=w;function b(g){const f=[],p=g.split("|").map(c=>c.trim());g=p[0];const v=p[1];if(v){const c=/height=(\d+)/.exec(v),m=/width=(\d+)/.exec(v),a=c?c[1]:"",d=m?m[1]:"",r=isFinite(parseInt(d)),o=isFinite(parseInt(a));r&&f.push(`width="${d}"`),o&&f.push(`height="${a}"`)}return{href:g,dimensions:f}}e.parseHrefAndDimensions=b}),define(Ie[107],ke([1,0,16,30,9,13,22,8]),function(Y,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function E(r,o){const{os:i,tildify:n,relative:s}=o;if(s){const S=I(r,s,i);if(typeof S=="string")return S}let l=r.fsPath;if(i===1&&!P.isWindows?l=l.replace(/\//g,"\\"):i!==1&&P.isWindows&&(l=l.replace(/\\/g,"/")),i!==1&&n?.userHome){const S=n.userHome.fsPath;let L;r.scheme!==n.userHome.scheme&&r.path.startsWith(D.posix.sep)?L=n.userHome.with({path:r.path}).fsPath:L=r.fsPath,l=_(L,S,i)}return(i===1?D.win32:D.posix).normalize(R(l,i===1))}e.getPathLabel=E;function I(r,o,i){const n=i===1?D.win32:D.posix,s=i===3?y.extUri:y.extUriIgnorePathCase,l=o.getWorkspace(),h=(0,u.firstOrDefault)(l.folders);if(!h)return;r.scheme!==h.uri.scheme&&r.path.startsWith(D.posix.sep)&&(r=h.uri.with({path:r.path}));const S=o.getWorkspaceFolder(r);if(!S)return;let L;if(s.isEqual(S.uri,r)?L="":L=s.relativePath(S.uri,r)??"",L&&(L=n.normalize(L)),l.folders.length>1&&!o.noPrefix){const M=S.name?S.name:s.basenameOrAuthority(S.uri);L=L?`${M} \u2022 ${L}`:M}return L}function R(r,o=P.isWindows){return(0,t.hasDriveLetter)(r,o)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=R;let k=Object.create(null);function _(r,o,i=P.OS){if(i===1||!r||!o)return r;let n=k.original===o?k.normalized:void 0;n||(n=o,P.isWindows&&(n=(0,t.toSlashes)(n)),n=`${(0,C.rtrim)(n,D.posix.sep)}${D.posix.sep}`,k={original:o,normalized:n});let s=r;return P.isWindows&&(s=(0,t.toSlashes)(s)),(i===3?s.startsWith(n):(0,C.startsWithIgnoreCase)(s,n))?`~/${s.substr(n.length)}`:r}e.tildify=_;function T(r,o){return r.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=T;const w="\u2026",b="\\\\",g="~";function f(r,o=D.sep){const i=new Array(r.length);let n=!1;for(let s=0;s<r.length;s++){const l=r[s];if(l===""){i[s]=`.${o}`;continue}if(!l){i[s]=l;continue}n=!0;let h="",S=l;S.indexOf(b)===0?(h=S.substr(0,S.indexOf(b)+b.length),S=S.substr(S.indexOf(b)+b.length)):S.indexOf(o)===0?(h=S.substr(0,S.indexOf(o)+o.length),S=S.substr(S.indexOf(o)+o.length)):S.indexOf(g)===0&&(h=S.substr(0,S.indexOf(g)+g.length),S=S.substr(S.indexOf(g)+g.length));const L=S.split(o);for(let M=1;n&&M<=L.length;M++)for(let F=L.length-M;n&&F>=0;F--){n=!1;let A=L.slice(F,F+M).join(o);for(let B=0;!n&&B<r.length;B++)if(B!==s&&r[B]&&r[B].indexOf(A)>-1){const $=F+M===L.length,U=F>0&&r[B].indexOf(o)>-1?o+A:A,K=r[B].endsWith(U);n=!$||K}if(!n){let B="";(L[0].endsWith(":")||h!=="")&&(F===1&&(F=0,M++,A=L[0]+o+A),F>0&&(B=L[0]+o),B=h+B),F>0&&(B=B+w+o),B=B+A,F+M<L.length&&(B=B+o+w),i[s]=B}}n&&(i[s]=l)}return i}e.shorten=f;var p;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function v(r,o=Object.create(null)){const i=[];let n=!1,s="";for(const l of r)if(l==="$"||n&&l==="{")s&&i.push({value:s,type:p.TEXT}),s="",n=!0;else if(l==="}"&&n){const h=o[s];if(typeof h=="string")h.length&&i.push({value:h,type:p.VARIABLE});else if(h){const S=i[i.length-1];(!S||S.type!==p.SEPARATOR)&&i.push({value:h.label,type:p.SEPARATOR})}s="",n=!1}else s+=l;return s&&!n&&i.push({value:s,type:p.TEXT}),i.filter((l,h)=>{if(l.type===p.SEPARATOR){const S=i[h-1],L=i[h+1];return[S,L].every(M=>M&&(M.type===p.VARIABLE||M.type===p.TEXT)&&M.value.length>0)}return!0}).map(l=>l.value).join("")}e.template=v;function c(r,o){return P.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):r.replace(/&&|&/g,i=>i==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function m(r,o){return P.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,""):P.isWindows?r.replace(/&&|&/g,i=>i==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=m;function a(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=a;function d(r){const o=r.indexOf("/")!==-1?D.posix:D.win32,i=o.basename(r),n=o.dirname(r);return i.length?{name:i,parentPath:n}:{name:n,parentPath:""}}e.splitName=d}),define(Ie[108],ke([1,0,2]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class D{constructor(k){this._uriTransformer=k}transformIncoming(k){const _=this._uriTransformer.transformIncoming(k);return _===k?k:t(u.URI.from(_))}transformOutgoing(k){const _=this._uriTransformer.transformOutgoing(k);return _===k?k:t(u.URI.from(_))}transformOutgoingURI(k){const _=this._uriTransformer.transformOutgoing(k);return _===k?k:u.URI.from(_)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function P(R,k,_){if(!R||_>200)return null;if(typeof R=="object"){if(R instanceof u.URI)return k.transformOutgoing(R);for(const T in R)if(Object.hasOwnProperty.call(R,T)){const w=P(R[T],k,_+1);w!==null&&(R[T]=w)}}return null}function y(R,k){const _=P(R,k,0);return _===null?R:_}e.transformOutgoingURIs=y;function C(R,k,_,T){if(!R||T>200)return null;if(typeof R=="object"){if(R.$mid===1)return _?u.URI.revive(k.transformIncoming(R)):k.transformIncoming(R);for(const w in R)if(Object.hasOwnProperty.call(R,w)){const b=C(R[w],k,_,T+1);b!==null&&(R[w]=b)}}return null}function E(R,k){const _=C(R,k,!1,0);return _===null?R:_}e.transformIncomingURIs=E;function I(R,k){const _=C(R,k,!0,0);return _===null?R:_}e.transformAndReviveIncomingURIs=I}),define(Ie[29],ke([1,0,62,81,302,18,30,80,9,13,22,2]),function(Y,e,u,t,D,P,y,C,E,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var _;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(_=e.RimRafMode||(e.RimRafMode={}));async function T(U,K=_.UNLINK){if((0,y.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return K===_.UNLINK?b(U):w(U)}async function w(U){try{const K=(0,y.randomPath)((0,t.tmpdir)());try{await u.promises.rename(U,K)}catch{return b(U)}b(K).catch(W=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function b(U){return(0,D.promisify)(u.rm)(U,{recursive:!0,force:!0,maxRetries:3})}function g(U){if((0,y.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");u.rmSync(U,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function f(U,K){return c(await(K?p(U):(0,D.promisify)(u.readdir)(U)))}async function p(U){try{return await(0,D.promisify)(u.readdir)(U,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const K=[],W=await f(U);for(const N of W){let V=!1,x=!1,q=!1;try{const te=await e.Promises.lstat((0,E.join)(U,N));V=te.isFile(),x=te.isDirectory(),q=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}K.push({name:N,isFile:()=>V,isDirectory:()=>x,isSymbolicLink:()=>q})}return K}function v(U){return c(u.readdirSync(U))}e.readdirSync=v;function c(U){return U.map(K=>typeof K=="string"?I.isMacintosh?(0,C.normalizeNFC)(K):K:(K.name=I.isMacintosh?(0,C.normalizeNFC)(K.name):K.name,K))}async function m(U){const K=await f(U),W=[];for(const N of K)await d.existsDirectory((0,E.join)(U,N))&&W.push(N);return W}function a(U,K=1e3){return new Promise(W=>{let N=!1;const V=setInterval(()=>{N||(N=!0,u.access(U,x=>{N=!1,x&&(clearInterval(V),W(void 0))}))},K)})}e.whenDeleted=a;var d;(function(U){async function K(V){let x;try{if(x=await e.Promises.lstat(V),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(I.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw te}throw q}}U.stat=K;async function W(V){try{const{stat:x,symbolicLink:q}=await U.stat(V);return x.isFile()&&q?.dangling!==!0}catch{}return!1}U.existsFile=W;async function N(V){try{const{stat:x,symbolicLink:q}=await U.stat(V);return x.isDirectory()&&q?.dangling!==!0}catch{}return!1}U.existsDirectory=N})(d=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new P.ResourceQueue;function o(U,K,W){return r.queueFor(k.URI.file(U),R.extUriBiasedIgnorePathCase).queue(()=>{const N=h(W);return new Promise((V,x)=>s(U,K,N,q=>q?x(q):V()))})}let i=!0;function n(U){i=U}e.configureFlushOnWrite=n;function s(U,K,W,N){if(!i)return u.writeFile(U,K,{mode:W.mode,flag:W.flag},N);u.open(U,W.flag,W.mode,(V,x)=>{if(V)return N(V);u.writeFile(x,K,q=>{if(q)return u.close(x,()=>N(q));u.fdatasync(x,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),n(!1)),u.close(x,Q=>N(Q))))})})}function l(U,K,W){const N=h(W);if(!i)return u.writeFileSync(U,K,{mode:N.mode,flag:N.flag});const V=u.openSync(U,N.flag,N.mode);try{u.writeFileSync(V,K);try{u.fdatasyncSync(V)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),n(!1)}}finally{u.closeSync(V)}}e.writeFileSync=l;function h(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function S(U,K){if(U!==K)try{await e.Promises.rename(U,K)}catch(W){if(U.toLowerCase()!==K.toLowerCase()&&W.code==="EXDEV"||U.endsWith("."))await L(U,K,{preserveSymlinks:!1}),await T(U,_.MOVE);else throw W}}async function L(U,K,W){return F(U,K,{root:{source:U,target:K},options:W,handledSourcePaths:new Set})}const M=511;async function F(U,K,W){if(W.handledSourcePaths.has(U))return;W.handledSourcePaths.add(U);const{stat:N,symbolicLink:V}=await d.stat(U);if(V){if(W.options.preserveSymlinks)try{return await $(U,K,W)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(V.dangling)return}return N.isDirectory()?A(U,K,N.mode&M,W):B(U,K,N.mode&M)}async function A(U,K,W,N){await e.Promises.mkdir(K,{recursive:!0,mode:W});const V=await f(U);for(const x of V)await F((0,E.join)(U,x),(0,E.join)(K,x),N)}async function B(U,K,W){await e.Promises.copyFile(U,K),await e.Promises.chmod(K,W)}async function $(U,K,W){let N=await e.Promises.readlink(U);(0,y.isEqualOrParent)(N,W.root.source,!I.isLinux)&&(N=(0,E.join)(W.root.target,N.substr(W.root.source.length+1))),await e.Promises.symlink(N,K)}e.Promises=new class{get access(){return(0,D.promisify)(u.access)}get stat(){return(0,D.promisify)(u.stat)}get lstat(){return(0,D.promisify)(u.lstat)}get utimes(){return(0,D.promisify)(u.utimes)}get read(){return(U,K,W,N,V)=>new Promise((x,q)=>{u.read(U,K,W,N,V,(te,Q,le)=>te?q(te):x({bytesRead:Q,buffer:le}))})}get readFile(){return(0,D.promisify)(u.readFile)}get write(){return(U,K,W,N,V)=>new Promise((x,q)=>{u.write(U,K,W,N,V,(te,Q,le)=>te?q(te):x({bytesWritten:Q,buffer:le}))})}get appendFile(){return(0,D.promisify)(u.appendFile)}get fdatasync(){return(0,D.promisify)(u.fdatasync)}get truncate(){return(0,D.promisify)(u.truncate)}get rename(){return(0,D.promisify)(u.rename)}get copyFile(){return(0,D.promisify)(u.copyFile)}get open(){return(0,D.promisify)(u.open)}get close(){return(0,D.promisify)(u.close)}get symlink(){return(0,D.promisify)(u.symlink)}get readlink(){return(0,D.promisify)(u.readlink)}get chmod(){return(0,D.promisify)(u.chmod)}get mkdir(){return(0,D.promisify)(u.mkdir)}get unlink(){return(0,D.promisify)(u.unlink)}get rmdir(){return(0,D.promisify)(u.rmdir)}get realpath(){return(0,D.promisify)(u.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return m}get writeFile(){return o}get rm(){return T}get move(){return S}get copy(){return L}}}),define(Ie[109],ke([1,0,62,9,13,8,29]),function(Y,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function C(_){if(D.isLinux)return _;const T=(0,t.dirname)(_);if(_===T)return _;const w=((0,t.basename)(_)||_).toLowerCase();try{const g=(0,y.readdirSync)(T).filter(f=>f.toLowerCase()===w);if(g.length===1){const f=C(T);if(f)return(0,t.join)(f,g[0])}else if(g.length>1){const f=g.indexOf(w);if(f>=0){const p=C(T);if(p)return(0,t.join)(p,g[f])}}}catch{}return null}e.realcaseSync=C;async function E(_){if(D.isLinux)return _;const T=(0,t.dirname)(_);if(_===T)return _;const w=((0,t.basename)(_)||_).toLowerCase();try{const g=(await y.Promises.readdir(T)).filter(f=>f.toLowerCase()===w);if(g.length===1){const f=await E(T);if(f)return(0,t.join)(f,g[0])}else if(g.length>1){const f=g.indexOf(w);if(f>=0){const p=await E(T);if(p)return(0,t.join)(p,g[f])}}}catch{}return null}e.realcase=E;async function I(_){try{return await y.Promises.realpath(_)}catch{const w=k(_);return await y.Promises.access(w,u.constants.R_OK),w}}e.realpath=I;function R(_){try{return u.realpathSync(_)}catch{const w=k(_);return u.accessSync(w,u.constants.R_OK),w}}e.realpathSync=R;function k(_){return(0,P.rtrim)((0,t.normalize)(_),t.sep)}});var Ge=this&&this.__decorate||function(Y,e,u,t){var D=arguments.length,P=D<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,u):t,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(Y,e,u,t);else for(var C=Y.length-1;C>=0;C--)(y=Y[C])&&(P=(D<3?y(P):D>3?y(e,u,P):y(e,u))||P);return D>3&&P&&Object.defineProperty(e,u,P),P};define(Ie[110],ke([1,0,16,18,23,21,57,12,3,6,61,8,10]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var T;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(T=e.RequestType||(e.RequestType={}));function w(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(b=e.ResponseType||(e.ResponseType={}));function g(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(f||(f={}));class p{constructor(x){this.buffer=x,this.pos=0}read(x){const q=this.buffer.slice(this.pos,this.pos+x);return this.pos+=q.byteLength,q}}class v{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}var c;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object"})(c||(c={}));function m(V){const x=D.VSBuffer.alloc(4);return x.writeUInt32BE(V,0),x}function a(V){return V.read(4).readUInt32BE(0)}function d(V){const x=D.VSBuffer.alloc(1);return x.writeUInt8(V,0),x}const r={Undefined:d(c.Undefined),String:d(c.String),Buffer:d(c.Buffer),VSBuffer:d(c.VSBuffer),Array:d(c.Array),Object:d(c.Object)},o=typeof Buffer!="undefined";function i(V,x){if(typeof x=="undefined")V.write(r.Undefined);else if(typeof x=="string"){const q=D.VSBuffer.fromString(x);V.write(r.String),V.write(m(q.byteLength)),V.write(q)}else if(o&&Buffer.isBuffer(x)){const q=D.VSBuffer.wrap(x);V.write(r.Buffer),V.write(m(q.byteLength)),V.write(q)}else if(x instanceof D.VSBuffer)V.write(r.VSBuffer),V.write(m(x.byteLength)),V.write(x);else if(Array.isArray(x)){V.write(r.Array),V.write(m(x.length));for(const q of x)i(V,q)}else{const q=D.VSBuffer.fromString(JSON.stringify(x));V.write(r.Object),V.write(m(q.byteLength)),V.write(q)}}function n(V){switch(V.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return V.read(a(V)).toString();case c.Buffer:return V.read(a(V)).buffer;case c.VSBuffer:return V.read(a(V));case c.Array:{const q=a(V),te=[];for(let Q=0;Q<q;Q++)te.push(n(V));return te}case c.Object:return JSON.parse(V.read(a(V)).toString())}}class s{constructor(x,q,te=null,Q=1e3){this.protocol=x,this.ctx=q,this.logger=te,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(le=>this.onRawMessage(le)),this.sendResponse({type:200})}registerChannel(x,q){this.channels.set(x,q),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case 200:{const q=this.send([x.type]);this.logger?.logOutgoing(q,0,1,g(x.type));return}case 201:case 202:case 204:case 203:{const q=this.send([x.type,x.id],x.data);this.logger?.logOutgoing(q,x.id,1,g(x.type),x.data);return}}}send(x,q=void 0){const te=new v;return i(te,x),i(te,q),this.sendBuffer(te.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onRawMessage(x){const q=new p(x),te=n(q),Q=n(q),le=te[0];switch(le){case 100:return this.logger?.logIncoming(x.byteLength,te[1],1,`${w(le)}: ${te[2]}.${te[3]}`,Q),this.onPromise({type:le,id:te[1],channelName:te[2],name:te[3],arg:Q});case 102:return this.logger?.logIncoming(x.byteLength,te[1],1,`${w(le)}: ${te[2]}.${te[3]}`,Q),this.onEventListen({type:le,id:te[1],channelName:te[2],name:te[3],arg:Q});case 101:return this.logger?.logIncoming(x.byteLength,te[1],1,`${w(le)}`),this.disposeActiveRequest({type:le,id:te[1]});case 103:return this.logger?.logIncoming(x.byteLength,te[1],1,`${w(le)}`),this.disposeActiveRequest({type:le,id:te[1]})}}onPromise(x){const q=this.channels.get(x.channelName);if(!q){this.collectPendingRequest(x);return}const te=new P.CancellationTokenSource;let Q;try{Q=q.call(this.ctx,x.name,x.arg,te.token)}catch(Z){Q=Promise.reject(Z)}const le=x.id;Q.then(Z=>{this.sendResponse({id:le,data:Z,type:201}),this.activeRequests.delete(x.id)},Z=>{Z instanceof Error?this.sendResponse({id:le,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:le,data:Z,type:203}),this.activeRequests.delete(x.id)});const pe=(0,I.toDisposable)(()=>te.cancel());this.activeRequests.set(x.id,pe)}onEventListen(x){const q=this.channels.get(x.channelName);if(!q){this.collectPendingRequest(x);return}const te=x.id,le=q.listen(this.ctx,x.name,x.arg)(pe=>this.sendResponse({id:te,data:pe,type:204}));this.activeRequests.set(x.id,le)}disposeActiveRequest(x){const q=this.activeRequests.get(x.id);q&&(q.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let q=this.pendingRequests.get(x.channelName);q||(q=[],this.pendingRequests.set(x.channelName,q));const te=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:x,timeoutTimer:te})}flushPendingRequests(x){const q=this.pendingRequests.get(x);if(q){for(const te of q)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.onPromise(te.request);break;case 102:this.onEventListen(te.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=s;var l;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));class h{constructor(x,q=null){this.protocol=x,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(te=>this.onBuffer(te)),this.logger=q}getChannel(x){const q=this;return{call(te,Q,le){return q.isDisposed?Promise.reject(C.canceled()):q.requestPromise(x,te,Q,le)},listen(te,Q){return q.isDisposed?E.Event.None:q.requestEvent(x,te,Q)}}}requestPromise(x,q,te,Q=P.CancellationToken.None){const le=this.lastRequestId++,Z={id:le,type:100,channelName:x,name:q,arg:te};if(Q.isCancellationRequested)return Promise.reject(C.canceled());let ge;return new Promise((Te,Oe)=>{if(Q.isCancellationRequested)return Oe(C.canceled());const ve=()=>{const ie=me=>{switch(me.type){case 201:this.handlers.delete(le),Te(me.data);break;case 202:{this.handlers.delete(le);const J=new Error(me.data.message);J.stack=me.data.stack,J.name=me.data.name,Oe(J);break}case 203:this.handlers.delete(le),Oe(me.data);break}};this.handlers.set(le,ie),this.sendRequest(Z)};let ue=null;this.state===f.Idle?ve():(ue=(0,t.createCancelablePromise)(ie=>this.whenInitialized()),ue.then(()=>{ue=null,ve()}));const de=()=>{ue?(ue.cancel(),ue=null):this.sendRequest({id:le,type:101}),Oe(C.canceled())},we=Q.onCancellationRequested(de);ge=(0,I.combinedDisposable)((0,I.toDisposable)(de),we),this.activeRequests.add(ge)}).finally(()=>{this.activeRequests.delete(ge)})}requestEvent(x,q,te){const Q=this.lastRequestId++,pe={id:Q,type:102,channelName:x,name:q,arg:te};let Z=null;const ge=new E.Emitter({onFirstListenerAdd:()=>{Z=(0,t.createCancelablePromise)(Te=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(ge),this.sendRequest(pe)})},onLastListenerRemove:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(ge),this.sendRequest({id:Q,type:103}))}}),Ee=Te=>ge.fire(Te.data);return this.handlers.set(Q,Ee),ge.event}sendRequest(x){switch(x.type){case 100:case 102:{const q=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger?.logOutgoing(q,x.id,0,`${w(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const q=this.send([x.type,x.id]);this.logger?.logOutgoing(q,x.id,0,w(x.type));return}}}send(x,q=void 0){const te=new v;return i(te,x),i(te,q),this.sendBuffer(te.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch{return 0}}onBuffer(x){const q=new p(x),te=n(q),Q=n(q),le=te[0];switch(le){case 200:return this.logger?.logIncoming(x.byteLength,0,0,g(le)),this.onResponse({type:te[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(x.byteLength,te[1],0,g(le),Q),this.onResponse({type:te[0],id:te[1],data:Q})}}onResponse(x){if(x.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}this.handlers.get(x.id)?.(x)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ge([y.memoize],h.prototype,"onDidInitializePromise",null),e.ChannelClient=h;class S{constructor(x){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,x(({protocol:q,onDidClientDisconnect:te})=>{E.Event.once(q.onMessage)(le=>{const pe=new p(le),Z=n(pe),ge=new s(q,Z),Ee=new h(q);this.channels.forEach((Oe,ve)=>ge.registerChannel(ve,Oe));const Te={channelServer:ge,channelClient:Ee,ctx:Z};this._connections.add(Te),this._onDidAddConnection.fire(Te),te(()=>{ge.dispose(),Ee.dispose(),this._connections.delete(Te),this._onDidRemoveConnection.fire(Te)})})})}get connections(){const x=[];return this._connections.forEach(q=>x.push(q)),x}getChannel(x,q){const te=this;return{call(Q,le,pe){let Z;if((0,_.isFunction)(q)){const Ee=(0,u.getRandomElement)(te.connections.filter(q));Z=Ee?Promise.resolve(Ee):E.Event.toPromise(E.Event.filter(te.onDidAddConnection,q))}else Z=q.routeCall(te,Q,le);const ge=Z.then(Ee=>Ee.channelClient.getChannel(x));return M(ge).call(Q,le,pe)},listen(Q,le){if((0,_.isFunction)(q))return te.getMulticastEvent(x,q,Q,le);const pe=q.routeEvent(te,Q,le).then(Z=>Z.channelClient.getChannel(x));return M(pe).listen(Q,le)}}}getMulticastEvent(x,q,te,Q){const le=this;let pe=new I.DisposableStore;const Z=new E.Emitter({onFirstListenerAdd:()=>{pe=new I.DisposableStore;const ge=new E.EventMultiplexer,Ee=new Map,Te=ve=>{const de=ve.channelClient.getChannel(x).listen(te,Q),we=ge.add(de);Ee.set(ve,we)},Oe=ve=>{const ue=Ee.get(ve);!ue||(ue.dispose(),Ee.delete(ve))};le.connections.filter(q).forEach(Te),E.Event.filter(le.onDidAddConnection,q)(Te,void 0,pe),le.onDidRemoveConnection(Oe,void 0,pe),ge.event(Z.fire,Z,pe),pe.add(ge)},onLastListenerRemove:()=>{pe.dispose()}});return Z.event}registerChannel(x,q){this.channels.set(x,q),this._connections.forEach(te=>{te.channelServer.registerChannel(x,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=S;class L{constructor(x,q,te=null){const Q=new v;i(Q,q),x.send(Q.buffer),this.channelClient=new h(x,te),this.channelServer=new s(x,q,te)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,q){this.channelServer.registerChannel(x,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=L;function M(V){return{call(x,q,te){return V.then(Q=>Q.call(x,q,te))},listen(x,q){const te=new E.Relay;return V.then(Q=>te.input=Q.listen(x,q)),te.event}}}e.getDelayedChannel=M;function F(V){let x=!1;return{call(q,te,Q){return x?V.call(q,te,Q):(0,t.timeout)(0).then(()=>x=!0).then(()=>V.call(q,te,Q))},listen(q,te){if(x)return V.listen(q,te);const Q=new E.Relay;return(0,t.timeout)(0).then(()=>x=!0).then(()=>Q.input=V.listen(q,te)),Q.event}}}e.getNextTickChannel=F;class A{constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const q of x.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await E.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=A;var B;(function(V){function x(le,pe){const Z=le,ge=pe&&pe.disableMarshalling,Ee=new Map;for(const Te in Z)te(Te)&&Ee.set(Te,E.Event.buffer(Z[Te],!0));return new class{listen(Te,Oe,ve){const ue=Ee.get(Oe);if(ue)return ue;if(Q(Oe)){const de=Z[Oe];if(typeof de=="function")return de.call(Z,ve)}throw new Error(`Event not found: ${Oe}`)}call(Te,Oe,ve){const ue=Z[Oe];if(typeof ue=="function"){if(!ge&&Array.isArray(ve))for(let de=0;de<ve.length;de++)ve[de]=(0,R.revive)(ve[de]);return ue.apply(Z,ve)}throw new Error(`Method not found: ${Oe}`)}}}V.fromService=x;function q(le,pe){const Z=pe&&pe.disableMarshalling;return new Proxy({},{get(ge,Ee){if(typeof Ee=="string")return pe?.properties?.has(Ee)?pe.properties.get(Ee):Q(Ee)?function(Te){return le.listen(Ee,Te)}:te(Ee)?le.listen(Ee):async function(...Te){let Oe;pe&&!(0,_.isUndefinedOrNull)(pe.context)?Oe=[pe.context,...Te]:Oe=Te;const ve=await le.call(Ee,Oe);return Z?ve:(0,R.revive)(ve)};throw new Error(`Property not found: ${String(Ee)}`)}})}V.toService=q;function te(le){return le[0]==="o"&&le[1]==="n"&&k.isUpperAsciiLetter(le.charCodeAt(2))}function Q(le){return/^onDynamic/.test(le)&&k.isUpperAsciiLetter(le.charCodeAt(9))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const x=V.toString();if(x!=="[object Object]")return x}return V}function K(V){return Array.isArray(V)?V.map(U):U(V)}function W(V,x,q,te,Q,le,pe){pe=K(pe);const Z=$[Q],ge=Z[te%Z.length];let Ee=[`%c[${V}]%c[${String(x).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${ge}`];/\($/.test(le)?(Ee=Ee.concat(pe),Ee.push(")")):Ee.push(pe),console.log.apply(console,Ee)}e.logWithColors=W;class N{constructor(x,q){this._outgoingPrefix=x,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,q,te,Q,le){this._totalOutgoing+=x,W(this._outgoingPrefix,this._totalOutgoing,x,q,te,Q,le)}logIncoming(x,q,te,Q,le){this._totalIncoming+=x,W(this._incomingPrefix,this._totalIncoming,x,q,te,Q,le)}}e.IPCLogger=N}),define(Ie[111],ke([1,0,23,3,6,110]),function(Y,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var y;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(y=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var C;(function(o){o.enableDiagnostics=!1,o.records=[];const i=new WeakMap;let n=0;function s(h,S){if(!i.has(h)){const L=String(++n);i.set(h,L)}return i.get(h)}function l(h,S,L,M){if(!o.enableDiagnostics)return;const F=s(h,S);if(M instanceof u.VSBuffer||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const A=u.VSBuffer.alloc(M.byteLength);A.set(M),o.records.push({timestamp:Date.now(),id:F,label:S,type:L,buff:A})}else o.records.push({timestamp:Date.now(),id:F,label:S,type:L,data:M})}o.traceSocketEvent=l})(C=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function R(){return I||(I=u.VSBuffer.alloc(0)),I}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,n){if(i===0)return R();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const S=this._chunks[0];return n&&(this._chunks.shift(),this._totalLength-=i),S}if(this._chunks[0].byteLength>i){const S=this._chunks[0].slice(0,i);return n&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),S}const s=u.VSBuffer.alloc(i);let l=0,h=0;for(;i>0;){const S=this._chunks[h];if(S.byteLength>i){const L=S.slice(0,i);s.set(L,l),l+=i,n&&(this._chunks[h]=S.slice(i),this._totalLength-=i),i-=i}else s.set(S,l),l+=S.byteLength,n?(this._chunks.shift(),this._totalLength-=S.byteLength):h++,i-=S.byteLength}return s}}e.ChunkStream=k;var _;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume"})(_||(_={}));function T(o){switch(o){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var w;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class b{constructor(i,n,s,l){this.type=i,this.id=n,this.ack=s,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends D.Disposable{constructor(i){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(n=>this.acceptChunk(n))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const n=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=n.readUInt32BE(9),this._state.messageType=n.readUInt8(0),this._state.id=n.readUInt32BE(1),this._state.ack=n.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:T(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const s=this._state.messageType,l=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",n),this._onMessage.fire(new b(s,l,h,n)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(i){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const n=u.VSBuffer.alloc(13);n.writeUInt8(i.type,0),n.writeUInt32BE(i.id,1),n.writeUInt32BE(i.ack,5),n.writeUInt32BE(i.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:T(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",i.data),this._writeSoon(n,i.data)}_bufferAdd(i,n){const s=this._totalLength===0;return this._data.push(i,n),this._totalLength+=i.byteLength+n.byteLength,s}_bufferTake(){const i=u.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,n){this._bufferAdd(i,n)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const i=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this._socket.write(i)}}class p extends D.Disposable{constructor(i){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(n=>{n.type===1&&this._onMessage.fire(n.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new b(1,0,0,i))}}e.Protocol=p;class v extends P.IPCClient{constructor(i,n,s=null){super(i,n,s);this.protocol=i}static fromSocket(i,n){return new v(new p(i),n)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=v;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class m{constructor(i){this.data=i,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){const i=[];let n=0,s=this._first;for(;s;)i[n++]=s.data,s=s.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const n=new m(i);if(!this._first){this._first=n,this._last=n;return}this._last.next=n,this._last=n}}class d{constructor(){this.lastRuns=[];const i=Date.now();for(let n=0;n<d._HISTORY_LENGTH;n++)this.lastRuns[n]=i-1e3*n;setInterval(()=>{for(let n=d._HISTORY_LENGTH;n>=1;n--)this.lastRuns[n]=this.lastRuns[n-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return d._INSTANCE||(d._INSTANCE=new d),d._INSTANCE}load(){const i=Date.now(),n=(1+d._HISTORY_LENGTH)*1e3;let s=0;for(let l=0;l<d._HISTORY_LENGTH;l++)i-this.lastRuns[l]<=n&&s++;return 1-s/d._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}d._HISTORY_LENGTH=10,d._INSTANCE=null;class r{constructor(i,n=null,s=d.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=s,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=i,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),n&&this._socketReader.acceptChunk(n)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new b(5,0,0,R());this._socketWriter.write(i),this._socketWriter.flush()}sendPause(){const i=new b(7,0,0,R());this._socketWriter.write(i)}sendResume(){const i=new b(8,0,0,R());this._socketWriter.write(i)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,n){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=i,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(s=>this._onSocketClose.fire(s))),this._socketReader.acceptChunk(n)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const i=new b(3,0,this._incomingAckId,R());this._socketWriter.write(i);const n=this._outgoingUnackMsg.toArray();for(let s=0,l=n.length;s<l;s++)this._socketWriter.write(n[s]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const n=this._outgoingUnackMsg.peek();if(n&&n.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const n=Date.now();n-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=n,this._socketWriter.write(new b(6,0,0,R())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data);break}case 2:{this._onControlMessage.fire(i.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const n=this._outgoingUnackMsg.toArray();for(let s=0,l=n.length;s<l;s++)this._socketWriter.write(n[s]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const n=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const s=new b(1,n,this._incomingAckId,i);this._outgoingUnackMsg.push(s),this._isReconnecting||(this._socketWriter.write(s),this._recvAckCheck())}sendControl(i){const n=new b(2,0,0,i);this._socketWriter.write(n)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),n=Date.now()-i.writtenTime,s=Date.now()-this._socketReader.lastReadTime,l=Date.now()-this._lastSocketTimeoutTime;if(n>=2e4&&s>=2e4&&l>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const h=Math.max(2e4-n,2e4-s,2e4-l,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},h)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new b(3,0,this._incomingAckId,R());this._socketWriter.write(i)}}e.PersistentProtocol=r}),define(Ie[112],ke([1,0,23,12,3,6,9,13,34,110,111]),function(Y,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:Y.__$__nodeRequire("crypto"),zlib:Y.__$__nodeRequire("zlib"),net:Y.__$__nodeRequire("net"),os:Y.__$__nodeRequire("os")}}class _{constructor(s,l=""){this.debugLabel=l,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=h=>{if(this.traceSocketEvent("error",{code:h?.code,message:h?.message}),h){if(h.code==="EPIPE")return;(0,t.onUnexpectedError)(h)}},this.socket.on("error",this._errorListener)}traceSocketEvent(s,l){R.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,l)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(s){const l=h=>{this.traceSocketEvent("read",h),s(u.VSBuffer.wrap(h))};return this.socket.on("data",l),{dispose:()=>this.socket.off("data",l)}}onClose(s){const l=h=>{this.traceSocketEvent("close",{hadError:h}),s({type:0,hadError:h,error:void 0})};return this.socket.on("close",l),{dispose:()=>this.socket.off("close",l)}}onEnd(s){const l=()=>{this.traceSocketEvent("nodeEndReceived"),s()};return this.socket.on("end",l),{dispose:()=>this.socket.off("end",l)}}write(s){if(!this.socket.destroyed)try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,l=>{if(l){if(l.code==="EPIPE")return;(0,t.onUnexpectedError)(l)}})}catch(l){if(l.code==="EPIPE")return;(0,t.onUnexpectedError)(l)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,l)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const h=()=>{this.socket.off("close",h),this.socket.off("end",h),this.socket.off("error",h),this.socket.off("timeout",h),this.socket.off("drain",h),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",h),this.socket.on("end",h),this.socket.on("error",h),this.socket.on("timeout",h),this.socket.on("drain",h)})}}e.NodeSocket=_;var T;(function(n){n[n.MinHeaderByteSize=2]="MinHeaderByteSize"})(T||(T={}));var w;(function(n){n[n.PeekHeader=1]="PeekHeader",n[n.ReadHeader=2]="ReadHeader",n[n.ReadBody=3]="ReadBody",n[n.Fin=4]="Fin"})(w||(w={}));class b extends P.Disposable{constructor(s,l,h,S){super();this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:l,inflateBytesLength:h?.byteLength||0,recordInflateBytes:S}),this._flowManager=this._register(new g(this,l,h,S,this._onData,(L,M)=>this._write(L,M))),this._register(this._flowManager.onError(L=>{console.error(L),(0,t.onUnexpectedError)(L),this._onClose.fire({type:0,hadError:!0,error:L})})),this._incomingData=new R.ChunkStream,this._register(this.socket.onData(L=>this._acceptChunk(L))),this._register(this.socket.onClose(L=>this._onClose.fire(L)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(s,l){this.socket.traceSocketEvent(s,l)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this._onData.event(s)}onClose(s){return this._onClose.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){this._flowManager.writeMessage(s)}_write(s,l){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let h=2;s.byteLength<126?h+=0:s.byteLength<2**16?h+=2:h+=8;const S=u.VSBuffer.alloc(h);if(l?S.writeUInt8(194,0):S.writeUInt8(130,0),s.byteLength<126)S.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){S.writeUInt8(126,1);let L=1;S.writeUInt8(s.byteLength>>>8&255,++L),S.writeUInt8(s.byteLength>>>0&255,++L)}else{S.writeUInt8(127,1);let L=1;S.writeUInt8(0,++L),S.writeUInt8(0,++L),S.writeUInt8(0,++L),S.writeUInt8(0,++L),S.writeUInt8(s.byteLength>>>24&255,++L),S.writeUInt8(s.byteLength>>>16&255,++L),S.writeUInt8(s.byteLength>>>8&255,++L),S.writeUInt8(s.byteLength>>>0&255,++L)}this.socket.write(u.VSBuffer.concat([S,s]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(s){if(s.byteLength!==0){for(this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const l=this._incomingData.peek(this._state.readLen),h=l.readUInt8(0),S=(h&128)>>>7,L=(h&64)>>>6,M=l.readUInt8(1),F=(M&128)>>>7,A=M&127;this._state.state=2,this._state.readLen=2+(F?4:0)+(A===126?2:0)+(A===127?8:0),this._state.fin=S,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(L)),this._state.firstFrameOfMessage=Boolean(S),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const l=this._incomingData.read(this._state.readLen),h=l.readUInt8(1),S=(h&128)>>>7;let L=h&127,M=1;L===126?L=l.readUInt8(++M)*2**8+l.readUInt8(++M):L===127&&(L=l.readUInt8(++M)*0+l.readUInt8(++M)*0+l.readUInt8(++M)*0+l.readUInt8(++M)*0+l.readUInt8(++M)*2**24+l.readUInt8(++M)*2**16+l.readUInt8(++M)*2**8+l.readUInt8(++M));let F=0;S&&(F=l.readUInt8(++M)*2**24+l.readUInt8(++M)*2**16+l.readUInt8(++M)*2**8+l.readUInt8(++M)),this._state.state=3,this._state.readLen=L,this._state.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const l=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",l),v(l,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",l),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(l,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=b;class g extends P.Disposable{constructor(s,l,h,S,L,M){super();this._tracer=s,this._onData=L,this._writeFn=M,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,l?(this._zlibInflateStream=this._register(new f(this._tracer,S,h,{windowBits:15})),this._zlibDeflateStream=this._register(new p(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(F=>this._onError.fire(F))),this._register(this._zlibDeflateStream.onError(F=>this._onError.fire(F)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:u.VSBuffer.alloc(0)}writeMessage(s){this._writeQueue.push(s),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const s=this._writeQueue.shift();if(this._zlibDeflateStream){const l=await this._deflateMessage(this._zlibDeflateStream,s);this._writeFn(l,!0)}else this._writeFn(s,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(s,l){return new Promise((h,S)=>{s.write(l),s.flush(L=>h(L))})}acceptFrame(s,l,h){this._readQueue.push({data:s,isCompressed:l,isLastFrameOfMessage:h}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const s=this._readQueue.shift();if(this._zlibInflateStream&&s.isCompressed){const l=await this._inflateFrame(this._zlibInflateStream,s.data,s.isLastFrameOfMessage);this._onData.fire(l)}else this._onData.fire(s.data)}this._isProcessingReadQueue=!1}}_inflateFrame(s,l,h){return new Promise((S,L)=>{s.write(l),h&&s.write(u.VSBuffer.fromByteArray([0,0,255,255])),s.flush(M=>S(M))})}}class f extends P.Disposable{constructor(s,l,h,S){super();this._tracer=s,this._recordInflateBytes=l,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=k().zlib.createInflateRaw(S),this._zlibInflate.on("error",L=>{this._tracer.traceSocketEvent("zlibInflateError",{message:L?.message,code:L?.code}),this._onError.fire(L)}),this._zlibInflate.on("data",L=>{this._tracer.traceSocketEvent("zlibInflateData",L),this._pendingInflateData.push(u.VSBuffer.wrap(L))}),h&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",h.buffer),this._zlibInflate.write(h.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?u.VSBuffer.concat(this._recordedInflateBytes):u.VSBuffer.alloc(0)}write(s){this._recordInflateBytes&&this._recordedInflateBytes.push(s.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",s),this._zlibInflate.write(s.buffer)}flush(s){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const l=u.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,s(l)})}}class p extends P.Disposable{constructor(s,l){super();this._tracer=s,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=k().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",h=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:h?.message,code:h?.code}),this._onError.fire(h)}),this._zlibDeflate.on("data",h=>{this._tracer.traceSocketEvent("zlibDeflateData",h),this._pendingDeflateData.push(u.VSBuffer.wrap(h))})}write(s){this._tracer.traceSocketEvent("zlibDeflateWrite",s.buffer),this._zlibDeflate.write(s.buffer)}flush(s){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let l=u.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,l=l.slice(0,l.byteLength-4),s(l)})}}function v(n,s){if(s===0)return;const l=n.byteLength>>>2;for(let A=0;A<l;A++){const B=n.readUInt32BE(A*4);n.writeUInt32BE(B^s,A*4)}const h=l*4,S=n.byteLength-h,L=s>>>24&255,M=s>>>16&255,F=s>>>8&255;S>=1&&n.writeUInt8(n.readUInt8(h)^L,h),S>=2&&n.writeUInt8(n.readUInt8(h+1)^M,h+1),S>=3&&n.writeUInt8(n.readUInt8(h+2)^F,h+2)}e.XDG_RUNTIME_DIR=typeof process!="undefined"?process.env.XDG_RUNTIME_DIR:void 0;const c={[2]:107,[1]:103};function m(){const n=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${n}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${n}.sock`):s=(0,y.join)(k().os.tmpdir(),`vscode-ipc-${n}.sock`),d(s),s}e.createRandomIPCHandle=m;function a(n,s,l){const h=k().crypto.createHash("md5").update(n).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${h}-${l}-${s}-sock`;let S;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?S=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-${h.substr(0,8)}-${l}-${s}.sock`):S=(0,y.join)(n,`${l}-${s}.sock`),d(S),S}e.createStaticIPCHandle=a;function d(n){const s=c[C.platform];typeof s=="number"&&n.length>=s&&console.warn(`WARNING: IPC handle "${n}" is longer than ${s} chars, try a shorter --user-data-dir`)}class r extends I.IPCServer{constructor(s){super(r.toClientConnectionEvent(s));this.server=s}static toClientConnectionEvent(s){const l=D.Event.fromNodeEventEmitter(s,"connection");return D.Event.map(l,h=>({protocol:new R.Protocol(new _(h,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(h,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function o(n){return new Promise((s,l)=>{const h=k().net.createServer();h.on("error",l),h.listen(n,()=>{h.removeListener("error",l),s(new r(h))})})}e.serve=o;function i(n,s){return new Promise((l,h)=>{const S=k().net.createConnection(n,()=>{S.removeListener("error",h),l(R.Client.fromSocket(new _(S,`ipc-client${s}`),s))});S.once("error",h)})}e.connect=i}),define(Ie[157],ke([1,0,36,9]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(P,y,C,E,I,R){if(Array.isArray(P)){let k=0;for(const _ of P){const T=D(_,y,C,E,I,R);if(T===10)return T;T>k&&(k=T)}return k}else{if(typeof P=="string")return E?P==="*"?5:P===C?10:0:0;if(P){const{language:k,pattern:_,scheme:T,hasAccessToAllModels:w,notebookType:b}=P;if(!E&&!w)return 0;b&&I&&(y=I);let g=0;if(T)if(T===y.scheme)g=10;else if(T==="*")g=5;else return 0;if(k)if(k===C)g=10;else if(k==="*")g=Math.max(g,5);else return 0;if(b)if(b===R)g=10;else if(b==="*"&&R!==void 0)g=Math.max(g,5);else return 0;if(_){let f;if(typeof _=="string"?f=_:f={..._,base:(0,t.normalize)(_.base)},f===y.fsPath||(0,u.match)(f,y.fsPath))g=10;else return 0}return g}else return 0}}e.score=D}),define(Ie[158],ke([1,0,8,48,150]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(C,E,I,R){this._uri=C,this._lines=E,this._eol=I,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const E=C.changes;for(const I of E)this._acceptDeleteRange(I.range),this._acceptInsertText(new t.Position(I.range.startLineNumber,I.range.startColumn),I.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,E=this._lines.length,I=new Uint32Array(E);for(let R=0;R<E;R++)I[R]=this._lines[R].length+C;this._lineStarts=new D.PrefixSumComputer(I)}}_setLineText(C,E){this._lines[C]=E,this._lineStarts&&this._lineStarts.setValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,E){if(E.length===0)return;const I=(0,u.splitLines)(E);if(I.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+I[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}I[I.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+I[0]);const R=new Uint32Array(I.length-1);for(let k=1;k<I.length;k++)this._lines.splice(C.lineNumber+k-1,0,I[k]),R[k-1]=I[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,R)}}e.MirrorTextModel=P}),define(Ie[159],ke([1,0,8,147,48,35,100]),function(Y,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class E{constructor(p,v,c,m){this.searchString=p,this.isRegex=v,this.matchCase=c,this.wordSeparators=m}parseSearchRequest(){if(this.searchString==="")return null;let p;this.isRegex?p=I(this.searchString):p=this.searchString.indexOf(`
`)>=0;let v=null;try{v=u.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:p,global:!0,unicode:!0})}catch{return null}if(!v)return null;let c=!this.isRegex&&!p;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new y.SearchData(v,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,c?this.searchString:null)}}e.SearchParams=E;function I(f){if(!f||f.length===0)return!1;for(let p=0,v=f.length;p<v;p++)if(f.charCodeAt(p)===92){if(p++,p>=v)break;const m=f.charCodeAt(p);if(m===110||m===114||m===87)return!0}return!1}e.isMultilineRegexSource=I;function R(f,p,v){if(!v)return new y.FindMatch(f,null);const c=[];for(let m=0,a=p.length;m<a;m++)c[m]=p[m];return new y.FindMatch(f,c)}e.createFindMatch=R;class k{constructor(p){const v=[];let c=0;for(let m=0,a=p.length;m<a;m++)p.charCodeAt(m)===10&&(v[c++]=m);this._lineFeedsOffsets=v}findLineFeedCountBeforeOffset(p){const v=this._lineFeedsOffsets;let c=0,m=v.length-1;if(m===-1||p<=v[0])return 0;for(;c<m;){const a=c+((m-c)/2>>0);v[a]>=p?m=a-1:v[a+1]>=p?(c=a,m=a):c=a+1}return c+1}}class _{static findMatches(p,v,c,m,a){const d=v.parseSearchRequest();return d?d.regex.multiline?this._doFindMatchesMultiline(p,c,new g(d.wordSeparators,d.regex),m,a):this._doFindMatchesLineByLine(p,c,d,m,a):[]}static _getMultilineMatchRange(p,v,c,m,a,d){let r,o=0;m?(o=m.findLineFeedCountBeforeOffset(a),r=v+a+o):r=v+a;let i;if(m){const h=m.findLineFeedCountBeforeOffset(a+d.length)-o;i=r+d.length+h}else i=r+d.length;const n=p.getPositionAt(r),s=p.getPositionAt(i);return new P.Range(n.lineNumber,n.column,s.lineNumber,s.column)}static _doFindMatchesMultiline(p,v,c,m,a){const d=p.getOffsetAt(v.getStartPosition()),r=p.getValueInRange(v,1),o=p.getEOL()===`\r
`?new k(r):null,i=[];let n=0,s;for(c.reset(0);s=c.next(r);)if(i[n++]=R(this._getMultilineMatchRange(p,d,r,o,s.index,s[0]),s,m),n>=a)return i;return i}static _doFindMatchesLineByLine(p,v,c,m,a){const d=[];let r=0;if(v.startLineNumber===v.endLineNumber){const i=p.getLineContent(v.startLineNumber).substring(v.startColumn-1,v.endColumn-1);return r=this._findMatchesInLine(c,i,v.startLineNumber,v.startColumn-1,r,d,m,a),d}const o=p.getLineContent(v.startLineNumber).substring(v.startColumn-1);r=this._findMatchesInLine(c,o,v.startLineNumber,v.startColumn-1,r,d,m,a);for(let i=v.startLineNumber+1;i<v.endLineNumber&&r<a;i++)r=this._findMatchesInLine(c,p.getLineContent(i),i,0,r,d,m,a);if(r<a){const i=p.getLineContent(v.endLineNumber).substring(0,v.endColumn-1);r=this._findMatchesInLine(c,i,v.endLineNumber,0,r,d,m,a)}return d}static _findMatchesInLine(p,v,c,m,a,d,r,o){const i=p.wordSeparators;if(!r&&p.simpleSearch){const l=p.simpleSearch,h=l.length,S=v.length;let L=-h;for(;(L=v.indexOf(l,L+h))!==-1;)if((!i||b(i,v,S,L,h))&&(d[a++]=new y.FindMatch(new P.Range(c,L+1+m,c,L+1+h+m),null),a>=o))return a;return a}const n=new g(p.wordSeparators,p.regex);let s;n.reset(0);do if(s=n.next(v),s&&(d[a++]=R(new P.Range(c,s.index+1+m,c,s.index+1+s[0].length+m),s,r),a>=o))return a;while(s);return a}static findNextMatch(p,v,c,m){const a=v.parseSearchRequest();if(!a)return null;const d=new g(a.wordSeparators,a.regex);return a.regex.multiline?this._doFindNextMatchMultiline(p,c,d,m):this._doFindNextMatchLineByLine(p,c,d,m)}static _doFindNextMatchMultiline(p,v,c,m){const a=new D.Position(v.lineNumber,1),d=p.getOffsetAt(a),r=p.getLineCount(),o=p.getValueInRange(new P.Range(a.lineNumber,a.column,r,p.getLineMaxColumn(r)),1),i=p.getEOL()===`\r
`?new k(o):null;c.reset(v.column-1);const n=c.next(o);return n?R(this._getMultilineMatchRange(p,d,o,i,n.index,n[0]),n,m):v.lineNumber!==1||v.column!==1?this._doFindNextMatchMultiline(p,new D.Position(1,1),c,m):null}static _doFindNextMatchLineByLine(p,v,c,m){const a=p.getLineCount(),d=v.lineNumber,r=p.getLineContent(d),o=this._findFirstMatchInLine(c,r,d,v.column,m);if(o)return o;for(let i=1;i<=a;i++){const n=(d+i-1)%a,s=p.getLineContent(n+1),l=this._findFirstMatchInLine(c,s,n+1,1,m);if(l)return l}return null}static _findFirstMatchInLine(p,v,c,m,a){p.reset(m-1);const d=p.next(v);return d?R(new P.Range(c,d.index+1,c,d.index+1+d[0].length),d,a):null}static findPreviousMatch(p,v,c,m){const a=v.parseSearchRequest();if(!a)return null;const d=new g(a.wordSeparators,a.regex);return a.regex.multiline?this._doFindPreviousMatchMultiline(p,c,d,m):this._doFindPreviousMatchLineByLine(p,c,d,m)}static _doFindPreviousMatchMultiline(p,v,c,m){const a=this._doFindMatchesMultiline(p,new P.Range(1,1,v.lineNumber,v.column),c,m,10*C);if(a.length>0)return a[a.length-1];const d=p.getLineCount();return v.lineNumber!==d||v.column!==p.getLineMaxColumn(d)?this._doFindPreviousMatchMultiline(p,new D.Position(d,p.getLineMaxColumn(d)),c,m):null}static _doFindPreviousMatchLineByLine(p,v,c,m){const a=p.getLineCount(),d=v.lineNumber,r=p.getLineContent(d).substring(0,v.column-1),o=this._findLastMatchInLine(c,r,d,m);if(o)return o;for(let i=1;i<=a;i++){const n=(a+d-i-1)%a,s=p.getLineContent(n+1),l=this._findLastMatchInLine(c,s,n+1,m);if(l)return l}return null}static _findLastMatchInLine(p,v,c,m){let a=null,d;for(p.reset(0);d=p.next(v);)a=R(new P.Range(c,d.index+1,c,d.index+1+d[0].length),d,m);return a}}e.TextModelSearch=_;function T(f,p,v,c,m){if(c===0)return!0;const a=p.charCodeAt(c-1);if(f.get(a)!==0||a===13||a===10)return!0;if(m>0){const d=p.charCodeAt(c);if(f.get(d)!==0)return!0}return!1}function w(f,p,v,c,m){if(c+m===v)return!0;const a=p.charCodeAt(c+m);if(f.get(a)!==0||a===13||a===10)return!0;if(m>0){const d=p.charCodeAt(c+m-1);if(f.get(d)!==0)return!0}return!1}function b(f,p,v,c,m){return T(f,p,v,c,m)&&w(f,p,v,c,m)}e.isValidMatch=b;class g{constructor(p,v){this._wordSeparators=p,this._searchRegex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(p){this._searchRegex.lastIndex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(p){const v=p.length;let c;do{if(this._prevMatchStartIndex+this._prevMatchLength===v||(c=this._searchRegex.exec(p),!c))return null;const m=c.index,a=c[0].length;if(m===this._prevMatchStartIndex&&a===this._prevMatchLength){if(a===0){u.getNextCodePoint(p,v,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=m,this._prevMatchLength=a,!this._wordSeparators||b(this._wordSeparators,p,v,m,a))return c}while(c);return null}}e.Searcher=g}),define(Ie[113],ke([1,0,23,13]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(D||(D={}));function P(k){for(let _=0,T=k.length;_<T;_+=4){const w=k[_+0],b=k[_+1],g=k[_+2],f=k[_+3];k[_+0]=f,k[_+1]=g,k[_+2]=b,k[_+3]=w}}function y(k){const _=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return t.isLittleEndian()||P(_),u.VSBuffer.wrap(_)}function C(k){const _=k.buffer;if(t.isLittleEndian()||P(_),_.byteOffset%4==0)return new Uint32Array(_.buffer,_.byteOffset,_.length/4);{const T=new Uint8Array(_.byteLength);return T.set(_),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function E(k){const _=new Uint32Array(I(k));let T=0;if(_[T++]=k.id,k.type==="full")_[T++]=1,_[T++]=k.data.length,_.set(k.data,T),T+=k.data.length;else{_[T++]=2,_[T++]=k.deltas.length;for(const w of k.deltas)_[T++]=w.start,_[T++]=w.deleteCount,w.data?(_[T++]=w.data.length,_.set(w.data,T),T+=w.data.length):_[T++]=0}return y(_)}e.encodeSemanticTokensDto=E;function I(k){let _=0;if(_+=1+1,k.type==="full")_+=1+k.data.length;else{_+=1,_+=(1+1+1)*k.deltas.length;for(const T of k.deltas)T.data&&(_+=T.data.length)}return _}function R(k){const _=C(k);let T=0;const w=_[T++];if(_[T++]===1){const p=_[T++],v=_.subarray(T,T+p);return T+=p,{id:w,type:"full",data:v}}const g=_[T++],f=[];for(let p=0;p<g;p++){const v=_[T++],c=_[T++],m=_[T++];let a;m>0&&(a=_.subarray(T,T+m),T+=m),f[p]={start:v,deleteCount:c,data:a}}return{id:w,type:"delta",deltas:f}}e.decodeSemanticTokensDto=R}),define(Ie[160],ke([1,0,3,6]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class D{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new u.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(C){this._onDidChange.fire({changedLanguages:C,changedColorMap:!1})}register(C,E){return this._map.set(C,E),this.fire([C]),(0,t.toDisposable)(()=>{this._map.get(C)===E&&(this._map.delete(C),this.fire([C]))})}registerFactory(C,E){this._factories.get(C)?.dispose();const I=new P(this,C,E);return this._factories.set(C,I),(0,t.toDisposable)(()=>{const R=this._factories.get(C);!R||R!==I||(this._factories.delete(C),R.dispose())})}async getOrCreate(C){const E=this.get(C);if(E)return E;const I=this._factories.get(C);return!I||I.isResolved?null:(await I.resolve(),this.get(C))}get(C){return this._map.get(C)||null}isResolved(C){if(this.get(C))return!0;const I=this._factories.get(C);return!!(!I||I.isResolved)}setColorMap(C){this._colorMap=C,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=D;class P extends t.Disposable{constructor(C,E,I){super();this._registry=C,this._languageId=E,this._factory=I,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const C=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,C&&!this._isDisposed&&this._register(this._registry.register(this._languageId,C))}}}),define(Ie[63],ke([1,0,76,2,35,160]),function(Y,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class y{constructor(h,S,L){this._tokenBrand=void 0,this.offset=h,this.type=S,this.language=L}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=y;class C{constructor(h,S){this._tokenizationResultBrand=void 0,this.tokens=h,this.endState=S}}e.TokenizationResult=C;class E{constructor(h,S){this._encodedTokenizationResultBrand=void 0,this.tokens=h,this.endState=S}}e.EncodedTokenizationResult=E;var I;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(I=e.CompletionItemKind||(e.CompletionItemKind={}));var R;(function(l){const h=new Map;h.set(0,u.Codicon.symbolMethod),h.set(1,u.Codicon.symbolFunction),h.set(2,u.Codicon.symbolConstructor),h.set(3,u.Codicon.symbolField),h.set(4,u.Codicon.symbolVariable),h.set(5,u.Codicon.symbolClass),h.set(6,u.Codicon.symbolStruct),h.set(7,u.Codicon.symbolInterface),h.set(8,u.Codicon.symbolModule),h.set(9,u.Codicon.symbolProperty),h.set(10,u.Codicon.symbolEvent),h.set(11,u.Codicon.symbolOperator),h.set(12,u.Codicon.symbolUnit),h.set(13,u.Codicon.symbolValue),h.set(15,u.Codicon.symbolEnum),h.set(14,u.Codicon.symbolConstant),h.set(15,u.Codicon.symbolEnum),h.set(16,u.Codicon.symbolEnumMember),h.set(17,u.Codicon.symbolKeyword),h.set(27,u.Codicon.symbolSnippet),h.set(18,u.Codicon.symbolText),h.set(19,u.Codicon.symbolColor),h.set(20,u.Codicon.symbolFile),h.set(21,u.Codicon.symbolReference),h.set(22,u.Codicon.symbolCustomColor),h.set(23,u.Codicon.symbolFolder),h.set(24,u.Codicon.symbolTypeParameter),h.set(25,u.Codicon.account),h.set(26,u.Codicon.issues);function S(F){let A=h.get(F);return A||(console.info("No codicon found for CompletionItemKind "+F),A=u.Codicon.symbolProperty),A}l.toIcon=S;const L=new Map;L.set("method",0),L.set("function",1),L.set("constructor",2),L.set("field",3),L.set("variable",4),L.set("class",5),L.set("struct",6),L.set("interface",7),L.set("module",8),L.set("property",9),L.set("event",10),L.set("operator",11),L.set("unit",12),L.set("value",13),L.set("constant",14),L.set("enum",15),L.set("enum-member",16),L.set("enumMember",16),L.set("keyword",17),L.set("snippet",27),L.set("text",18),L.set("color",19),L.set("file",20),L.set("reference",21),L.set("customcolor",22),L.set("folder",23),L.set("type-parameter",24),L.set("typeParameter",24),L.set("account",25),L.set("issue",26);function M(F,A){let B=L.get(F);return typeof B=="undefined"&&!A&&(B=9),B}l.fromString=M})(R=e.CompletionItemKinds||(e.CompletionItemKinds={}));var k;(function(l){l[l.Deprecated=1]="Deprecated"})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(l){l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var T;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(T=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(l){l[l.Automatic=0]="Automatic",l[l.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var b;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var g;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(g=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function p(l){return l&&t.URI.isUri(l.uri)&&D.Range.isIRange(l.range)&&(D.Range.isIRange(l.originSelectionRange)||D.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=p;var v;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(v=e.SymbolKind||(e.SymbolKind={}));var c;(function(l){l[l.Deprecated=1]="Deprecated"})(c=e.SymbolTag||(e.SymbolTag={}));var m;(function(l){const h=new Map;h.set(0,u.Codicon.symbolFile),h.set(1,u.Codicon.symbolModule),h.set(2,u.Codicon.symbolNamespace),h.set(3,u.Codicon.symbolPackage),h.set(4,u.Codicon.symbolClass),h.set(5,u.Codicon.symbolMethod),h.set(6,u.Codicon.symbolProperty),h.set(7,u.Codicon.symbolField),h.set(8,u.Codicon.symbolConstructor),h.set(9,u.Codicon.symbolEnum),h.set(10,u.Codicon.symbolInterface),h.set(11,u.Codicon.symbolFunction),h.set(12,u.Codicon.symbolVariable),h.set(13,u.Codicon.symbolConstant),h.set(14,u.Codicon.symbolString),h.set(15,u.Codicon.symbolNumber),h.set(16,u.Codicon.symbolBoolean),h.set(17,u.Codicon.symbolArray),h.set(18,u.Codicon.symbolObject),h.set(19,u.Codicon.symbolKey),h.set(20,u.Codicon.symbolNull),h.set(21,u.Codicon.symbolEnumMember),h.set(22,u.Codicon.symbolStruct),h.set(23,u.Codicon.symbolEvent),h.set(24,u.Codicon.symbolOperator),h.set(25,u.Codicon.symbolTypeParameter);function S(L){let M=h.get(L);return M||(console.info("No codicon found for SymbolKind "+L),M=u.Codicon.symbolProperty),M}l.toIcon=S})(m=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(h){this.value=h}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var d;(function(l){function h(S){return!S||typeof S!="object"?!1:typeof S.id=="string"&&typeof S.title=="string"}l.is=h})(d=e.Command||(e.Command={}));var r;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var o;(function(l){l[l.Unresolved=0]="Unresolved",l[l.Resolved=1]="Resolved"})(o=e.CommentThreadState||(e.CommentThreadState={}));var i;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(i=e.CommentMode||(e.CommentMode={}));var n;(function(l){l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(n=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new P.TokenizationRegistry;var s;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(s=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ie[161],ke([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(Ie[114],ke([1,0,42,30,11,24,9,13,40,102,10,144,29,161]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function w(m){switch(m){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function b(m,a){if(C.isWindows)try{const d={stdio:["pipe","pipe","ignore"]};a&&(d.cwd=a);const r=u.execFile("taskkill",["/T","/F","/PID",m.pid.toString()],d);return new Promise(o=>{r.once("error",i=>{o({success:!1,error:i})}),r.once("exit",(i,n)=>{o(i===0?{success:!0}:{success:!1,code:i!==null?i:1})})})}catch(d){return Promise.resolve({success:!1,error:d,code:d.status?w(d.status):1})}else if(C.isLinux||C.isMacintosh)try{const d=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(r=>{u.execFile(d,[m.pid.toString()],{encoding:"utf8",shell:!0},(o,i,n)=>{r(o?{success:!1,error:o}:{success:!0})})})}catch(d){return Promise.resolve({success:!1,error:d})}else m.kill("SIGKILL");return Promise.resolve({success:!0})}function g(m=E.env){return m.comspec||"cmd.exe"}e.getWindowsShell=g;class f{constructor(a,d,r,o){if(d!==void 0&&r!==void 0&&o!==void 0)this.cmd=a,this.args=d,this.shell=r,this.options=o;else{const i=a;this.cmd=i.command,this.shell=i.isShellCommand,this.args=i.args.slice(0),this.options=i.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const i=Object.create(null);Object.keys(E.env).forEach(n=>{i[n]=E.env[n]}),Object.keys(this.options.env).forEach(n=>{i[n]=this.options.env[n]}),this.options.env=i}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const d=a.lastIndexOf(y.sep);return d!==-1&&(a=a.substring(d+1)),f.WellKnowCommands[a]?a:"other"}start(a){return C.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(E.cwd()))?Promise.reject(new Error(T.localize(0,null))):this.useExec().then(d=>{let r,o;const i=new Promise((n,s)=>{r=n,o=s});if(d){let n=this.cmd;this.args&&(n=n+" "+this.args.join(" ")),this.childProcess=u.exec(n,this.options,(s,l,h)=>{this.childProcess=null;const S=s;S&&S.killed?o({killed:this.terminateRequested,stdout:l.toString(),stderr:h.toString()}):this.handleExec(r,a,s,l,h)})}else{let n=null;const s=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,r,a,o);const h={terminated:this.terminateRequested};R.isNumber(l)&&(h.cmdCode=l),r(h)};if(this.shell&&C.isWindows){const l=P.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let h=!1,S=!1;const L=[];let M=this.ensureQuotes(this.cmd);L.push(M.value),h=M.quoted,this.args&&this.args.forEach(A=>{M=this.ensureQuotes(A),L.push(M.value),S=S&&M.quoted});const F=["/s","/c"];h?S?F.push('"'+L.join(" ")+'"'):L.length>1?F.push('"'+L[0]+'" '+L.slice(1).join(" ")):F.push('"'+L[0]+'"'):F.push(L.join(" ")),n=u.spawn(g(),F,l)}else this.cmd&&(n=u.spawn(this.cmd,this.args,this.options));n&&(this.childProcess=n,this.childProcessPromise=Promise.resolve(n),this.pidResolve&&(this.pidResolve(R.isNumber(n.pid)?n.pid:-1),this.pidResolve=void 0),n.on("error",l=>{this.childProcess=null,o({terminated:this.terminateRequested,error:l})}),n.pid&&(this.childProcess.on("close",s),this.handleSpawn(n,r,a,o,!0)))}return i})}handleClose(a,d,r,o){}ensureQuotes(a){return f.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,b(a,this.options.cwd).then(d=>(d.success&&(this.childProcess=null),d))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!C.isWindows)return a(!1);const d=u.spawn(g(),["/s","/c"]);d.on("error",r=>a(!0)),d.on("exit",r=>a(!1))})}}e.AbstractProcess=f,f.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},f.regexp=/^[^"].* .*[^"]/;class p extends f{constructor(a,d,r,o){super(a,d,r,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,d,r,o,i){[o,i].forEach((n,s)=>{const l=new k.LineDecoder;l.write(n).forEach(L=>{d({line:L,source:s===0?0:1})});const S=l.end();S&&d({line:S,source:s===0?0:1})}),a({terminated:this.terminateRequested,error:r})}handleSpawn(a,d,r,o,i){const n=new k.LineDecoder,s=new k.LineDecoder;a.stdout.on("data",l=>{n.write(l).forEach(S=>r({line:S,source:0}))}),a.stderr.on("data",l=>{s.write(l).forEach(S=>r({line:S,source:1}))}),this.stdoutLineDecoder=n,this.stderrLineDecoder=s}handleClose(a,d,r,o){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&r({line:i,source:0});const n=this.stderrLineDecoder?this.stderrLineDecoder.end():null;n&&r({line:n,source:1})}}e.LineProcess=p;function v(m){let a=[],d=!1;const r=function(o){if(d){a.push(o);return}(!m.send(o,n=>{if(n&&console.error(n),d=!1,a.length>0){const s=a.slice(0);a=[],s.forEach(l=>r(l))}})||C.isWindows)&&(d=!0)};return{send:r}}e.createQueuedSender=v;var c;(function(m){async function a(d,r,o){if(y.isAbsolute(d))return d;if(r===void 0&&(r=E.cwd()),y.dirname(d)!=="."||(o===void 0&&R.isString(E.env.PATH)&&(o=E.env.PATH.split(y.delimiter)),o===void 0||o.length===0))return y.join(r,d);async function n(s){if(await _.Promises.exists(s)){let l;try{l=await _.Promises.stat(s)}catch(h){h.message.startsWith("EACCES")&&(l=await _.Promises.lstat(s))}return l?!l.isDirectory():!1}return!1}for(const s of o){let l;if(y.isAbsolute(s)?l=y.join(s,d):l=y.join(r,s,d),await n(l))return l;let h=l+".com";if(await n(h)||(h=l+".exe",await n(h)))return h}return y.join(r,d)}m.findExecutable=a})(c=e.win32||(e.win32={}))}),define(Ie[162],ke([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(Ie[115],ke([1,0,162,13,99,16,24,146]),function(Y,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class I{constructor(oe){this._values=oe}hasChanged(oe){return this._values[oe]}}e.ConfigurationChangedEvent=I;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class k{constructor(oe,ye,We,ce){this.id=oe,this.name=ye,this.defaultValue=We,this.schema=ce}applyUpdate(oe,ye){return T(oe,ye)}compute(oe,ye,We){return We}}class _{constructor(oe,ye){this.newValue=oe,this.didChange=ye}}e.ApplyUpdateResult=_;function T(ee,oe){if(typeof ee!="object"||typeof oe!="object"||!ee||!oe)return new _(oe,ee!==oe);if(Array.isArray(ee)||Array.isArray(oe)){const We=Array.isArray(ee)&&Array.isArray(oe)&&P.equals(ee,oe);return new _(oe,We)}let ye=!1;for(const We in oe)if(oe.hasOwnProperty(We)){const ce=T(ee[We],oe[We]);ce.didChange&&(ee[We]=ce.newValue,ye=!0)}return new _(ee,ye)}class w{constructor(oe){this.schema=void 0,this.id=oe,this.name="_never_",this.defaultValue=void 0}applyUpdate(oe,ye){return T(oe,ye)}validate(oe){return this.defaultValue}}class b{constructor(oe,ye,We,ce){this.id=oe,this.name=ye,this.defaultValue=We,this.schema=ce}applyUpdate(oe,ye){return T(oe,ye)}validate(oe){return typeof oe=="undefined"?this.defaultValue:oe}compute(oe,ye,We){return We}}function g(ee,oe){return typeof ee=="undefined"?oe:ee==="false"?!1:Boolean(ee)}e.boolean=g;class f extends b{constructor(oe,ye,We,ce=void 0){typeof ce!="undefined"&&(ce.type="boolean",ce.default=We);super(oe,ye,We,ce)}validate(oe){return g(oe,this.defaultValue)}}function p(ee,oe,ye,We){if(typeof ee=="undefined")return oe;let ce=parseInt(ee,10);return isNaN(ce)?oe:(ce=Math.max(ye,ce),ce=Math.min(We,ce),ce|0)}e.clampedInt=p;class v extends b{constructor(oe,ye,We,ce,Ae,Be=void 0){typeof Be!="undefined"&&(Be.type="integer",Be.default=We,Be.minimum=ce,Be.maximum=Ae);super(oe,ye,We,Be);this.minimum=ce,this.maximum=Ae}static clampedInt(oe,ye,We,ce){return p(oe,ye,We,ce)}validate(oe){return v.clampedInt(oe,this.defaultValue,this.minimum,this.maximum)}}class c extends b{constructor(oe,ye,We,ce,Ae){typeof Ae!="undefined"&&(Ae.type="number",Ae.default=We);super(oe,ye,We,Ae);this.validationFn=ce}static clamp(oe,ye,We){return oe<ye?ye:oe>We?We:oe}static float(oe,ye){if(typeof oe=="number")return oe;if(typeof oe=="undefined")return ye;const We=parseFloat(oe);return isNaN(We)?ye:We}validate(oe){return this.validationFn(c.float(oe,this.defaultValue))}}class m extends b{static string(oe,ye){return typeof oe!="string"?ye:oe}constructor(oe,ye,We,ce=void 0){typeof ce!="undefined"&&(ce.type="string",ce.default=We);super(oe,ye,We,ce)}validate(oe){return m.string(oe,this.defaultValue)}}function a(ee,oe,ye){return typeof ee!="string"||ye.indexOf(ee)===-1?oe:ee}e.stringSet=a;class d extends b{constructor(oe,ye,We,ce,Ae=void 0){typeof Ae!="undefined"&&(Ae.type="string",Ae.enum=ce,Ae.default=We);super(oe,ye,We,Ae);this._allowedValues=ce}validate(oe){return a(oe,this.defaultValue,this._allowedValues)}}class r extends k{constructor(oe,ye,We,ce,Ae,Be,qe=void 0){typeof qe!="undefined"&&(qe.type="string",qe.enum=Ae,qe.default=ce);super(oe,ye,We,qe);this._allowedValues=Ae,this._convert=Be}validate(oe){return typeof oe!="string"?this.defaultValue:this._allowedValues.indexOf(oe)===-1?this.defaultValue:this._convert(oe)}}function o(ee){switch(ee){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[u.localize(0,null),u.localize(1,null),u.localize(2,null)],default:"auto",description:u.localize(3,null)})}validate(oe){switch(oe){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(oe,ye,We){return We===0?oe.accessibilitySupport:We}}class n extends k{constructor(){const oe={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",oe,{"editor.comments.insertSpace":{type:"boolean",default:oe.insertSpace,description:u.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:oe.ignoreEmptyLines,description:u.localize(5,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const ye=oe;return{insertSpace:g(ye.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(ye.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function l(ee){switch(ee){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function S(ee){switch(ee){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=S;function L(ee){switch(ee){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class M extends w{constructor(){super(129)}compute(oe,ye,We){const ce=["monaco-editor"];return ye.get(34)&&ce.push(ye.get(34)),oe.extraEditorClassName&&ce.push(oe.extraEditorClassName),ye.get(67)==="default"?ce.push("mouse-default"):ye.get(67)==="copy"&&ce.push("mouse-copy"),ye.get(101)&&ce.push("showUnused"),ye.get(127)&&ce.push("showDeprecated"),ce.join(" ")}}class F extends f{constructor(){super(33,"emptySelectionClipboard",!0,{description:u.localize(6,null)})}compute(oe,ye,We){return We&&oe.emptySelectionClipboard}}class A extends k{constructor(){const oe={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",oe,{"editor.find.cursorMoveOnType":{type:"boolean",default:oe.cursorMoveOnType,description:u.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:oe.seedSearchStringFromSelection,enumDescriptions:[u.localize(8,null),u.localize(9,null),u.localize(10,null)],description:u.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:oe.autoFindInSelection,enumDescriptions:[u.localize(12,null),u.localize(13,null),u.localize(14,null)],description:u.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:oe.globalFindClipboard,description:u.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:oe.addExtraSpaceOnTop,description:u.localize(17,null)},"editor.find.loop":{type:"boolean",default:oe.loop,description:u.localize(18,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const ye=oe;return{cursorMoveOnType:g(ye.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof oe.seedSearchStringFromSelection=="boolean"?oe.seedSearchStringFromSelection?"always":"never":a(ye.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof oe.autoFindInSelection=="boolean"?oe.autoFindInSelection?"always":"never":a(ye.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(ye.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(ye.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(ye.loop,this.defaultValue.loop)}}}class B extends k{constructor(){super(46,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:u.localize(19,null)},{type:"string",description:u.localize(20,null)}],description:u.localize(21,null),default:!1})}validate(oe){return typeof oe=="undefined"?this.defaultValue:typeof oe=="string"?oe==="false"?B.OFF:oe==="true"?B.ON:oe:Boolean(oe)?B.ON:B.OFF}}e.EditorFontLigatures=B,B.OFF='"liga" off, "calt" off',B.ON='"liga" on, "calt" on';class $ extends w{constructor(){super(45)}compute(oe,ye,We){return oe.fontInfo}}class U extends b{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:u.localize(22,null)})}validate(oe){const ye=c.float(oe,this.defaultValue);return ye===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(ye,6,100)}compute(oe,ye,We){return oe.fontInfo.fontSize}}class K extends k{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.MINIMUM_VALUE,maximum:K.MAXIMUM_VALUE,errorMessage:u.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:u.localize(24,null)})}validate(oe){return oe==="normal"||oe==="bold"?oe:String(v.clampedInt(oe,e.EDITOR_FONT_DEFAULTS.fontWeight,K.MINIMUM_VALUE,K.MAXIMUM_VALUE))}}K.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],K.MINIMUM_VALUE=1,K.MAXIMUM_VALUE=1e3;class W extends k{constructor(){const oe={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ye={type:"string",enum:["peek","gotoAndPeek","goto"],default:oe.multiple,enumDescriptions:[u.localize(25,null),u.localize(26,null),u.localize(27,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",oe,{"editor.gotoLocation.multiple":{deprecationMessage:u.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:u.localize(29,null),...ye},"editor.gotoLocation.multipleTypeDefinitions":{description:u.localize(30,null),...ye},"editor.gotoLocation.multipleDeclarations":{description:u.localize(31,null),...ye},"editor.gotoLocation.multipleImplementations":{description:u.localize(32,null),...ye},"editor.gotoLocation.multipleReferences":{description:u.localize(33,null),...ye},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:oe.alternativeDefinitionCommand,enum:We,description:u.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:oe.alternativeTypeDefinitionCommand,enum:We,description:u.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:oe.alternativeDeclarationCommand,enum:We,description:u.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:oe.alternativeImplementationCommand,enum:We,description:u.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:oe.alternativeReferenceCommand,enum:We,description:u.localize(38,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const ye=oe;return{multiple:a(ye.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ye.multipleDefinitions??a(ye.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ye.multipleTypeDefinitions??a(ye.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ye.multipleDeclarations??a(ye.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ye.multipleImplementations??a(ye.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ye.multipleReferences??a(ye.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(ye.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(ye.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(ye.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(ye.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(ye.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class N extends k{constructor(){const oe={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",oe,{"editor.hover.enabled":{type:"boolean",default:oe.enabled,description:u.localize(39,null)},"editor.hover.delay":{type:"number",default:oe.delay,minimum:0,maximum:1e4,description:u.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:oe.sticky,description:u.localize(41,null)},"editor.hover.above":{type:"boolean",default:oe.above,description:u.localize(42,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const ye=oe;return{enabled:g(ye.enabled,this.defaultValue.enabled),delay:v.clampedInt(ye.delay,this.defaultValue.delay,0,1e4),sticky:g(ye.sticky,this.defaultValue.sticky),above:g(ye.above,this.defaultValue.above)}}}var V;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class x extends w{constructor(){super(132)}compute(oe,ye,We){return x.computeLayout(ye,{memory:oe.memory,outerWidth:oe.outerWidth,outerHeight:oe.outerHeight,isDominatedByLongLines:oe.isDominatedByLongLines,lineHeight:oe.fontInfo.lineHeight,viewLineCount:oe.viewLineCount,lineNumbersDigitCount:oe.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:oe.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:oe.fontInfo.maxDigitWidth,pixelRatio:oe.pixelRatio})}static computeContainedMinimapLineCount(oe){const ye=oe.height/oe.lineHeight,We=oe.scrollBeyondLastLine?ye-1:0,ce=(oe.viewLineCount+We)/(oe.pixelRatio*oe.height),Ae=Math.floor(oe.viewLineCount/ce);return{typicalViewportLineCount:ye,extraLinesBeyondLastLine:We,desiredRatio:ce,minimapLineCount:Ae}}static _computeMinimapLayout(oe,ye){const We=oe.outerWidth,ce=oe.outerHeight,Ae=oe.pixelRatio;if(!oe.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ae*ce),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ce};const Be=ye.stableMinimapLayoutInput,qe=Be&&oe.outerHeight===Be.outerHeight&&oe.lineHeight===Be.lineHeight&&oe.typicalHalfwidthCharacterWidth===Be.typicalHalfwidthCharacterWidth&&oe.pixelRatio===Be.pixelRatio&&oe.scrollBeyondLastLine===Be.scrollBeyondLastLine&&oe.minimap.enabled===Be.minimap.enabled&&oe.minimap.side===Be.minimap.side&&oe.minimap.size===Be.minimap.size&&oe.minimap.showSlider===Be.minimap.showSlider&&oe.minimap.renderCharacters===Be.minimap.renderCharacters&&oe.minimap.maxColumn===Be.minimap.maxColumn&&oe.minimap.scale===Be.minimap.scale&&oe.verticalScrollbarWidth===Be.verticalScrollbarWidth&&oe.isViewportWrapping===Be.isViewportWrapping,je=oe.lineHeight,Ve=oe.typicalHalfwidthCharacterWidth,nt=oe.scrollBeyondLastLine,ot=oe.minimap.renderCharacters;let st=Ae>=2?Math.round(oe.minimap.scale*2):oe.minimap.scale;const it=oe.minimap.maxColumn,at=oe.minimap.size,vt=oe.minimap.side,Pt=oe.verticalScrollbarWidth,yt=oe.viewLineCount,ft=oe.remainingWidth,kt=oe.isViewportWrapping,Mt=ot?2:3;let Lt=Math.floor(Ae*ce);const Xe=Lt/Ae;let At=!1,Nt=!1,Ot=Mt*st,gt=st/Ae,Dt=1;if(at==="fill"||at==="fit"){const{typicalViewportLineCount:et,extraLinesBeyondLastLine:Ze,desiredRatio:Je,minimapLineCount:bt}=x.computeContainedMinimapLineCount({viewLineCount:yt,scrollBeyondLastLine:nt,height:ce,lineHeight:je,pixelRatio:Ae});if(yt/bt>1)At=!0,Nt=!0,st=1,Ot=1,gt=st/Ae;else{let St=!1,mt=st+1;if(at==="fit"){const ht=Math.ceil((yt+Ze)*Ot);kt&&qe&&ft<=ye.stableFitRemainingWidth?(St=!0,mt=ye.stableFitMaxMinimapScale):St=ht>Lt}if(at==="fill"||St){At=!0;const ht=st;Ot=Math.min(je*Ae,Math.max(1,Math.floor(1/Je))),kt&&qe&&ft<=ye.stableFitRemainingWidth&&(mt=ye.stableFitMaxMinimapScale),st=Math.min(mt,Math.max(1,Math.floor(Ot/Mt))),st>ht&&(Dt=Math.min(2,st/ht)),gt=st/Ae/Dt,Lt=Math.ceil(Math.max(et,yt+Ze)*Ot),kt?(ye.stableMinimapLayoutInput=oe,ye.stableFitRemainingWidth=ft,ye.stableFitMaxMinimapScale=st):(ye.stableMinimapLayoutInput=null,ye.stableFitRemainingWidth=0)}}}const Pe=Math.floor(it*gt),Le=Math.min(Pe,Math.max(0,Math.floor((ft-Pt-2)*gt/(Ve+gt)))+e.MINIMAP_GUTTER_WIDTH);let Se=Math.floor(Ae*Le);const ne=Se/Ae;Se=Math.floor(Se*Dt);const Fe=ot?1:2,He=vt==="left"?0:We-Le-Pt;return{renderMinimap:Fe,minimapLeft:He,minimapWidth:Le,minimapHeightIsEditorHeight:At,minimapIsSampling:Nt,minimapScale:st,minimapLineHeight:Ot,minimapCanvasInnerWidth:Se,minimapCanvasInnerHeight:Lt,minimapCanvasOuterWidth:ne,minimapCanvasOuterHeight:Xe}}static computeLayout(oe,ye){const We=ye.outerWidth|0,ce=ye.outerHeight|0,Ae=ye.lineHeight|0,Be=ye.lineNumbersDigitCount|0,qe=ye.typicalHalfwidthCharacterWidth,je=ye.maxDigitWidth,Ve=ye.pixelRatio,nt=ye.viewLineCount,ot=oe.get(124),st=ot==="inherit"?oe.get(123):ot,it=st==="inherit"?oe.get(119):st,at=oe.get(122),vt=oe.get(2),Pt=ye.isDominatedByLongLines,yt=oe.get(51),ft=oe.get(61).renderType!==0,kt=oe.get(62),Mt=oe.get(95),Lt=oe.get(66),Xe=oe.get(93),At=Xe.verticalScrollbarSize,Nt=Xe.verticalHasArrows,Ot=Xe.arrowSize,gt=Xe.horizontalScrollbarSize,Dt=oe.get(59),Pe=oe.get(38),Le=oe.get(100)!=="never";let Se;if(typeof Dt=="string"&&/^\d+(\.\d+)?ch$/.test(Dt)){const $t=parseFloat(Dt.substr(0,Dt.length-2));Se=v.clampedInt($t*qe,0,0,1e3)}else Se=v.clampedInt(Dt,0,0,1e3);Pe&&Le&&(Se+=16);let ne=0;if(ft){const $t=Math.max(Be,kt);ne=Math.round($t*je)}let Fe=0;yt&&(Fe=Ae);let He=0,et=He+Fe,Ze=et+ne,Je=Ze+Se;const bt=We-Fe-ne-Se;let Et=!1,St=!1,mt=-1;vt!==2&&(st==="inherit"&&Pt?(Et=!0,St=!0):it==="on"||it==="bounded"?St=!0:it==="wordWrapColumn"&&(mt=at));const ht=x._computeMinimapLayout({outerWidth:We,outerHeight:ce,lineHeight:Ae,typicalHalfwidthCharacterWidth:qe,pixelRatio:Ve,scrollBeyondLastLine:Mt,minimap:Lt,verticalScrollbarWidth:At,viewLineCount:nt,remainingWidth:bt,isViewportWrapping:St},ye.memory||new R);ht.renderMinimap!==0&&ht.minimapLeft===0&&(He+=ht.minimapWidth,et+=ht.minimapWidth,Ze+=ht.minimapWidth,Je+=ht.minimapWidth);const Yt=bt-ht.minimapWidth,qt=Math.max(1,Math.floor((Yt-At-2)/qe)),wt=Nt?Ot:0;return St&&(mt=Math.max(1,qt),it==="bounded"&&(mt=Math.min(mt,at))),{width:We,height:ce,glyphMarginLeft:He,glyphMarginWidth:Fe,lineNumbersLeft:et,lineNumbersWidth:ne,decorationsLeft:Ze,decorationsWidth:Se,contentLeft:Je,contentWidth:Yt,minimap:ht,viewportColumn:qt,isWordWrapMinified:Et,isViewportWrapping:St,wrappingColumn:mt,verticalScrollbarWidth:At,horizontalScrollbarHeight:gt,overviewRuler:{top:wt,width:At,height:ce-2*wt,right:0}}}}e.EditorLayoutInfoComputer=x;class q extends k{constructor(){const oe={enabled:!0};super(58,"lightbulb",oe,{"editor.lightbulb.enabled":{type:"boolean",default:oe.enabled,description:u.localize(43,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:g(oe.enabled,this.defaultValue.enabled)}}}class te extends k{constructor(){const oe={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(128,"inlayHints",oe,{"editor.inlayHints.enabled":{type:"string",default:oe.enabled,description:u.localize(44,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[u.localize(45,null),u.localize(46,null),u.localize(47,null),u.localize(48,null)]},"editor.inlayHints.fontSize":{type:"number",default:oe.fontSize,markdownDescription:u.localize(49,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:oe.fontFamily,markdownDescription:u.localize(50,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:oe.padding,description:u.localize(51,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const ye=oe;return typeof ye.enabled=="boolean"&&(ye.enabled=ye.enabled?"on":"off"),{enabled:a(ye.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:v.clampedInt(ye.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(ye.fontFamily,this.defaultValue.fontFamily),padding:g(ye.padding,this.defaultValue.padding)}}}class Q extends c{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,oe=>c.clamp(oe,0,150),{markdownDescription:u.localize(52,null)})}compute(oe,ye,We){return oe.fontInfo.lineHeight}}class le extends k{constructor(){const oe={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",oe,{"editor.minimap.enabled":{type:"boolean",default:oe.enabled,description:u.localize(53,null)},"editor.minimap.autohide":{type:"boolean",default:oe.autohide,description:u.localize(54,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[u.localize(55,null),u.localize(56,null),u.localize(57,null)],default:oe.size,description:u.localize(58,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:oe.side,description:u.localize(59,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:oe.showSlider,description:u.localize(60,null)},"editor.minimap.scale":{type:"number",default:oe.scale,minimum:1,maximum:3,enum:[1,2,3],description:u.localize(61,null)},"editor.minimap.renderCharacters":{type:"boolean",default:oe.renderCharacters,description:u.localize(62,null)},"editor.minimap.maxColumn":{type:"number",default:oe.maxColumn,description:u.localize(63,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const ye=oe;return{enabled:g(ye.enabled,this.defaultValue.enabled),autohide:g(ye.autohide,this.defaultValue.autohide),size:a(ye.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(ye.side,this.defaultValue.side,["right","left"]),showSlider:a(ye.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(ye.renderCharacters,this.defaultValue.renderCharacters),scale:v.clampedInt(ye.scale,1,1,3),maxColumn:v.clampedInt(ye.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function pe(ee){return ee==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Z extends k{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(64,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(65,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const ye=oe;return{top:v.clampedInt(ye.top,0,0,1e3),bottom:v.clampedInt(ye.bottom,0,0,1e3)}}}class ge extends k{constructor(){const oe={enabled:!0,cycle:!1};super(77,"parameterHints",oe,{"editor.parameterHints.enabled":{type:"boolean",default:oe.enabled,description:u.localize(66,null)},"editor.parameterHints.cycle":{type:"boolean",default:oe.cycle,description:u.localize(67,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const ye=oe;return{enabled:g(ye.enabled,this.defaultValue.enabled),cycle:g(ye.cycle,this.defaultValue.cycle)}}}class Ee extends w{constructor(){super(130)}compute(oe,ye,We){return oe.pixelRatio}}class Te extends k{constructor(){const oe={other:"on",comments:"off",strings:"off"},ye=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[u.localize(68,null),u.localize(69,null),u.localize(70,null)]}];super(80,"quickSuggestions",oe,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ye,default:oe.strings,description:u.localize(71,null)},comments:{anyOf:ye,default:oe.comments,description:u.localize(72,null)},other:{anyOf:ye,default:oe.other,description:u.localize(73,null)}},default:oe,markdownDescription:u.localize(74,null,"#editor.suggestOnTriggerCharacters#")});this.defaultValue=oe}validate(oe){if(typeof oe=="boolean"){const Ve=oe?"on":"off";return{comments:Ve,strings:Ve,other:Ve}}if(!oe||typeof oe!="object")return this.defaultValue;const{other:ye,comments:We,strings:ce}=oe,Ae=["on","inline","off"];let Be,qe,je;return typeof ye=="boolean"?Be=ye?"on":"off":Be=a(ye,this.defaultValue.other,Ae),typeof We=="boolean"?qe=We?"on":"off":qe=a(We,this.defaultValue.comments,Ae),typeof ce=="boolean"?je=ce?"on":"off":je=a(ce,this.defaultValue.strings,Ae),{other:Be,comments:qe,strings:je}}}var Oe;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(Oe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ve extends k{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[u.localize(75,null),u.localize(76,null),u.localize(77,null),u.localize(78,null)],default:"on",description:u.localize(79,null)})}validate(oe){let ye=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof oe!="undefined"&&(typeof oe=="function"?(ye=4,We=oe):oe==="interval"?ye=3:oe==="relative"?ye=2:oe==="on"?ye=1:ye=0),{renderType:ye,renderFn:We}}}function ue(ee){const oe=ee.get(88);return oe==="editable"?ee.get(82):oe!=="on"}e.filterValidationDecorations=ue;class de extends k{constructor(){const oe=[],ye={type:"number",description:u.localize(80,null)};super(92,"rulers",oe,{type:"array",items:{anyOf:[ye,{type:["object"],properties:{column:ye,color:{type:"string",description:u.localize(81,null),format:"color-hex"}}}]},default:oe,description:u.localize(82,null)})}validate(oe){if(Array.isArray(oe)){const ye=[];for(const We of oe)if(typeof We=="number")ye.push({column:v.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const ce=We;ye.push({column:v.clampedInt(ce.column,0,0,1e4),color:ce.color})}return ye.sort((We,ce)=>We.column-ce.column),ye}return this.defaultValue}}function we(ee,oe){if(typeof ee!="string")return oe;switch(ee){case"hidden":return 2;case"visible":return 3;default:return 1}}class ie extends k{constructor(){const oe={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",oe,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(83,null),u.localize(84,null),u.localize(85,null)],default:"auto",description:u.localize(86,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(87,null),u.localize(88,null),u.localize(89,null)],default:"auto",description:u.localize(90,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:oe.verticalScrollbarSize,description:u.localize(91,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:oe.horizontalScrollbarSize,description:u.localize(92,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:oe.scrollByPage,description:u.localize(93,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const ye=oe,We=v.clampedInt(ye.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ce=v.clampedInt(ye.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:v.clampedInt(ye.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:we(ye.vertical,this.defaultValue.vertical),horizontal:we(ye.horizontal,this.defaultValue.horizontal),useShadows:g(ye.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(ye.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(ye.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(ye.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(ye.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:v.clampedInt(ye.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:ce,verticalSliderSize:v.clampedInt(ye.verticalSliderSize,ce,0,1e3),scrollByPage:g(ye.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class me extends k{constructor(){const oe={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(114,"unicodeHighlight",oe,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.nonBasicASCII,description:u.localize(94,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:oe.invisibleCharacters,description:u.localize(95,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:oe.ambiguousCharacters,description:u.localize(96,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeComments,description:u.localize(97,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeStrings,description:u.localize(98,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:oe.allowedCharacters,description:u.localize(99,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:oe.allowedLocales,description:u.localize(100,null)}})}applyUpdate(oe,ye){let We=!1;ye.allowedCharacters&&oe&&(y.equals(oe.allowedCharacters,ye.allowedCharacters)||(oe={...oe,allowedCharacters:ye.allowedCharacters},We=!0)),ye.allowedLocales&&oe&&(y.equals(oe.allowedLocales,ye.allowedLocales)||(oe={...oe,allowedLocales:ye.allowedLocales},We=!0));const ce=super.applyUpdate(oe,ye);return We?new _(ce.newValue,!0):ce}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const ye=oe;return{nonBasicASCII:H(ye.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(ye.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(ye.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:H(ye.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:H(ye.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(oe.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(oe.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(oe,ye){if(typeof oe!="object"||!oe)return ye;const We={};for(const[ce,Ae]of Object.entries(oe))Ae===!0&&(We[ce]=!0);return We}}class J extends k{constructor(){const oe={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",oe,{"editor.inlineSuggest.enabled":{type:"boolean",default:oe.enabled,description:u.localize(101,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const ye=oe;return{enabled:g(ye.enabled,this.defaultValue.enabled),mode:a(ye.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class re extends k{constructor(){const oe={enabled:C.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:C.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",oe,{"editor.bracketPairColorization.enabled":{type:"boolean",default:oe.enabled,markdownDescription:u.localize(102,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:oe.independentColorPoolPerBracketType,description:u.localize(103,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const ye=oe;return{enabled:g(ye.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(ye.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class O extends k{constructor(){const oe={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",oe,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(104,null),u.localize(105,null),u.localize(106,null)],default:oe.bracketPairs,description:u.localize(107,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(108,null),u.localize(109,null),u.localize(110,null)],default:oe.bracketPairsHorizontal,description:u.localize(111,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:oe.highlightActiveBracketPair,description:u.localize(112,null)},"editor.guides.indentation":{type:"boolean",default:oe.indentation,description:u.localize(113,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[u.localize(114,null),u.localize(115,null),u.localize(116,null)],default:oe.highlightActiveIndentation,description:u.localize(117,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const ye=oe;return{bracketPairs:H(ye.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:H(ye.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(ye.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(ye.indentation,this.defaultValue.indentation),highlightActiveIndentation:H(ye.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function H(ee,oe,ye){const We=ye.indexOf(ee);return We===-1?oe:ye[We]}class G extends k{constructor(){const oe={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(107,"suggest",oe,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[u.localize(118,null),u.localize(119,null)],default:oe.insertMode,description:u.localize(120,null)},"editor.suggest.filterGraceful":{type:"boolean",default:oe.filterGraceful,description:u.localize(121,null)},"editor.suggest.localityBonus":{type:"boolean",default:oe.localityBonus,description:u.localize(122,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:oe.shareSuggestSelections,markdownDescription:u.localize(123,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:oe.snippetsPreventQuickSuggestions,description:u.localize(124,null)},"editor.suggest.showIcons":{type:"boolean",default:oe.showIcons,description:u.localize(125,null)},"editor.suggest.showStatusBar":{type:"boolean",default:oe.showStatusBar,description:u.localize(126,null)},"editor.suggest.preview":{type:"boolean",default:oe.preview,description:u.localize(127,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:oe.showInlineDetails,description:u.localize(128,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:u.localize(129,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:u.localize(130,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:u.localize(131,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:u.localize(132,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:u.localize(133,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:u.localize(134,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:u.localize(135,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:u.localize(136,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:u.localize(137,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:u.localize(138,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:u.localize(139,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:u.localize(140,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:u.localize(141,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:u.localize(142,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:u.localize(143,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:u.localize(144,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:u.localize(145,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:u.localize(146,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:u.localize(147,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:u.localize(148,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:u.localize(149,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:u.localize(150,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:u.localize(151,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:u.localize(152,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:u.localize(153,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:u.localize(154,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:u.localize(155,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:u.localize(156,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:u.localize(157,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:u.localize(158,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:u.localize(159,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const ye=oe;return{insertMode:a(ye.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(ye.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(ye.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(ye.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(ye.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:g(ye.showIcons,this.defaultValue.showIcons),showStatusBar:g(ye.showStatusBar,this.defaultValue.showStatusBar),preview:g(ye.preview,this.defaultValue.preview),previewMode:a(ye.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(ye.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(ye.showMethods,this.defaultValue.showMethods),showFunctions:g(ye.showFunctions,this.defaultValue.showFunctions),showConstructors:g(ye.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(ye.showDeprecated,this.defaultValue.showDeprecated),showFields:g(ye.showFields,this.defaultValue.showFields),showVariables:g(ye.showVariables,this.defaultValue.showVariables),showClasses:g(ye.showClasses,this.defaultValue.showClasses),showStructs:g(ye.showStructs,this.defaultValue.showStructs),showInterfaces:g(ye.showInterfaces,this.defaultValue.showInterfaces),showModules:g(ye.showModules,this.defaultValue.showModules),showProperties:g(ye.showProperties,this.defaultValue.showProperties),showEvents:g(ye.showEvents,this.defaultValue.showEvents),showOperators:g(ye.showOperators,this.defaultValue.showOperators),showUnits:g(ye.showUnits,this.defaultValue.showUnits),showValues:g(ye.showValues,this.defaultValue.showValues),showConstants:g(ye.showConstants,this.defaultValue.showConstants),showEnums:g(ye.showEnums,this.defaultValue.showEnums),showEnumMembers:g(ye.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(ye.showKeywords,this.defaultValue.showKeywords),showWords:g(ye.showWords,this.defaultValue.showWords),showColors:g(ye.showColors,this.defaultValue.showColors),showFiles:g(ye.showFiles,this.defaultValue.showFiles),showReferences:g(ye.showReferences,this.defaultValue.showReferences),showFolders:g(ye.showFolders,this.defaultValue.showFolders),showTypeParameters:g(ye.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(ye.showSnippets,this.defaultValue.showSnippets),showUsers:g(ye.showUsers,this.defaultValue.showUsers),showIssues:g(ye.showIssues,this.defaultValue.showIssues)}}}class X extends k{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:u.localize(160,null),default:!0,type:"boolean"}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(oe.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class he extends w{constructor(){super(131)}compute(oe,ye,We){return ye.get(82)?!0:oe.tabFocusMode}}var be;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(be=e.WrappingIndent||(e.WrappingIndent={}));function ae(ee){switch(ee){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class De extends w{constructor(){super(133)}compute(oe,ye,We){const ce=ye.get(132);return{isDominatedByLongLines:oe.isDominatedByLongLines,isWordWrapMinified:ce.isWordWrapMinified,isViewportWrapping:ce.isViewportWrapping,wrappingColumn:ce.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",ze="Menlo, Monaco, 'Courier New', monospace",Ke="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?ze:t.isLinux?Ke:Ce,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var Ye;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.autoClosingBrackets=5]="autoClosingBrackets",ee[ee.autoClosingDelete=6]="autoClosingDelete",ee[ee.autoClosingOvertype=7]="autoClosingOvertype",ee[ee.autoClosingQuotes=8]="autoClosingQuotes",ee[ee.autoIndent=9]="autoIndent",ee[ee.automaticLayout=10]="automaticLayout",ee[ee.autoSurround=11]="autoSurround",ee[ee.bracketPairColorization=12]="bracketPairColorization",ee[ee.guides=13]="guides",ee[ee.codeLens=14]="codeLens",ee[ee.codeLensFontFamily=15]="codeLensFontFamily",ee[ee.codeLensFontSize=16]="codeLensFontSize",ee[ee.colorDecorators=17]="colorDecorators",ee[ee.columnSelection=18]="columnSelection",ee[ee.comments=19]="comments",ee[ee.contextmenu=20]="contextmenu",ee[ee.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=22]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=24]="cursorStyle",ee[ee.cursorSurroundingLines=25]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=27]="cursorWidth",ee[ee.disableLayerHinting=28]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ee[ee.domReadOnly=30]="domReadOnly",ee[ee.dragAndDrop=31]="dragAndDrop",ee[ee.enableDropIntoEditor=32]="enableDropIntoEditor",ee[ee.emptySelectionClipboard=33]="emptySelectionClipboard",ee[ee.extraEditorClassName=34]="extraEditorClassName",ee[ee.fastScrollSensitivity=35]="fastScrollSensitivity",ee[ee.find=36]="find",ee[ee.fixedOverflowWidgets=37]="fixedOverflowWidgets",ee[ee.folding=38]="folding",ee[ee.foldingStrategy=39]="foldingStrategy",ee[ee.foldingHighlight=40]="foldingHighlight",ee[ee.foldingImportsByDefault=41]="foldingImportsByDefault",ee[ee.foldingMaximumRegions=42]="foldingMaximumRegions",ee[ee.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=44]="fontFamily",ee[ee.fontInfo=45]="fontInfo",ee[ee.fontLigatures=46]="fontLigatures",ee[ee.fontSize=47]="fontSize",ee[ee.fontWeight=48]="fontWeight",ee[ee.formatOnPaste=49]="formatOnPaste",ee[ee.formatOnType=50]="formatOnType",ee[ee.glyphMargin=51]="glyphMargin",ee[ee.gotoLocation=52]="gotoLocation",ee[ee.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",ee[ee.hover=54]="hover",ee[ee.inDiffEditor=55]="inDiffEditor",ee[ee.inlineSuggest=56]="inlineSuggest",ee[ee.letterSpacing=57]="letterSpacing",ee[ee.lightbulb=58]="lightbulb",ee[ee.lineDecorationsWidth=59]="lineDecorationsWidth",ee[ee.lineHeight=60]="lineHeight",ee[ee.lineNumbers=61]="lineNumbers",ee[ee.lineNumbersMinChars=62]="lineNumbersMinChars",ee[ee.linkedEditing=63]="linkedEditing",ee[ee.links=64]="links",ee[ee.matchBrackets=65]="matchBrackets",ee[ee.minimap=66]="minimap",ee[ee.mouseStyle=67]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=69]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=71]="multiCursorModifier",ee[ee.multiCursorPaste=72]="multiCursorPaste",ee[ee.occurrencesHighlight=73]="occurrencesHighlight",ee[ee.overviewRulerBorder=74]="overviewRulerBorder",ee[ee.overviewRulerLanes=75]="overviewRulerLanes",ee[ee.padding=76]="padding",ee[ee.parameterHints=77]="parameterHints",ee[ee.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",ee[ee.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=80]="quickSuggestions",ee[ee.quickSuggestionsDelay=81]="quickSuggestionsDelay",ee[ee.readOnly=82]="readOnly",ee[ee.renameOnType=83]="renameOnType",ee[ee.renderControlCharacters=84]="renderControlCharacters",ee[ee.renderFinalNewline=85]="renderFinalNewline",ee[ee.renderLineHighlight=86]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=88]="renderValidationDecorations",ee[ee.renderWhitespace=89]="renderWhitespace",ee[ee.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",ee[ee.roundedSelection=91]="roundedSelection",ee[ee.rulers=92]="rulers",ee[ee.scrollbar=93]="scrollbar",ee[ee.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=95]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=96]="scrollPredominantAxis",ee[ee.selectionClipboard=97]="selectionClipboard",ee[ee.selectionHighlight=98]="selectionHighlight",ee[ee.selectOnLineNumbers=99]="selectOnLineNumbers",ee[ee.showFoldingControls=100]="showFoldingControls",ee[ee.showUnused=101]="showUnused",ee[ee.snippetSuggestions=102]="snippetSuggestions",ee[ee.smartSelect=103]="smartSelect",ee[ee.smoothScrolling=104]="smoothScrolling",ee[ee.stickyTabStops=105]="stickyTabStops",ee[ee.stopRenderingLineAfter=106]="stopRenderingLineAfter",ee[ee.suggest=107]="suggest",ee[ee.suggestFontSize=108]="suggestFontSize",ee[ee.suggestLineHeight=109]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=110]="suggestOnTriggerCharacters",ee[ee.suggestSelection=111]="suggestSelection",ee[ee.tabCompletion=112]="tabCompletion",ee[ee.tabIndex=113]="tabIndex",ee[ee.unicodeHighlighting=114]="unicodeHighlighting",ee[ee.unusualLineTerminators=115]="unusualLineTerminators",ee[ee.useShadowDOM=116]="useShadowDOM",ee[ee.useTabStops=117]="useTabStops",ee[ee.wordSeparators=118]="wordSeparators",ee[ee.wordWrap=119]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=120]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=121]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=122]="wordWrapColumn",ee[ee.wordWrapOverride1=123]="wordWrapOverride1",ee[ee.wordWrapOverride2=124]="wordWrapOverride2",ee[ee.wrappingIndent=125]="wrappingIndent",ee[ee.wrappingStrategy=126]="wrappingStrategy",ee[ee.showDeprecated=127]="showDeprecated",ee[ee.inlayHints=128]="inlayHints",ee[ee.editorClassName=129]="editorClassName",ee[ee.pixelRatio=130]="pixelRatio",ee[ee.tabFocusMode=131]="tabFocusMode",ee[ee.layoutInfo=132]="layoutInfo",ee[ee.wrappingInfo=133]="wrappingInfo"})(Ye=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:u.localize(161,null)})),acceptSuggestionOnEnter:Ne(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",u.localize(162,null),""],markdownDescription:u.localize(163,null)})),accessibilitySupport:Ne(new i),accessibilityPageSize:Ne(new v(3,"accessibilityPageSize",10,1,1073741824,{description:u.localize(164,null)})),ariaLabel:Ne(new m(4,"ariaLabel",u.localize(165,null))),autoClosingBrackets:Ne(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(166,null),u.localize(167,null),""],description:u.localize(168,null)})),autoClosingDelete:Ne(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",u.localize(169,null),""],description:u.localize(170,null)})),autoClosingOvertype:Ne(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",u.localize(171,null),""],description:u.localize(172,null)})),autoClosingQuotes:Ne(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(173,null),u.localize(174,null),""],description:u.localize(175,null)})),autoIndent:Ne(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],o,{enumDescriptions:[u.localize(176,null),u.localize(177,null),u.localize(178,null),u.localize(179,null),u.localize(180,null)],description:u.localize(181,null)})),automaticLayout:Ne(new f(10,"automaticLayout",!1)),autoSurround:Ne(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[u.localize(182,null),u.localize(183,null),u.localize(184,null),""],description:u.localize(185,null)})),bracketPairColorization:Ne(new re),bracketPairGuides:Ne(new O),stickyTabStops:Ne(new f(105,"stickyTabStops",!1,{description:u.localize(186,null)})),codeLens:Ne(new f(14,"codeLens",!0,{description:u.localize(187,null)})),codeLensFontFamily:Ne(new m(15,"codeLensFontFamily","",{description:u.localize(188,null)})),codeLensFontSize:Ne(new v(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:u.localize(189,null)})),colorDecorators:Ne(new f(17,"colorDecorators",!0,{description:u.localize(190,null)})),columnSelection:Ne(new f(18,"columnSelection",!1,{description:u.localize(191,null)})),comments:Ne(new n),contextmenu:Ne(new f(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new f(21,"copyWithSyntaxHighlighting",!0,{description:u.localize(192,null)})),cursorBlinking:Ne(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:u.localize(193,null)})),cursorSmoothCaretAnimation:Ne(new f(23,"cursorSmoothCaretAnimation",!1,{description:u.localize(194,null)})),cursorStyle:Ne(new r(24,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:u.localize(195,null)})),cursorSurroundingLines:Ne(new v(25,"cursorSurroundingLines",0,0,1073741824,{description:u.localize(196,null)})),cursorSurroundingLinesStyle:Ne(new d(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[u.localize(197,null),u.localize(198,null)],description:u.localize(199,null)})),cursorWidth:Ne(new v(27,"cursorWidth",0,0,1073741824,{markdownDescription:u.localize(200,null)})),disableLayerHinting:Ne(new f(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new f(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new f(30,"domReadOnly",!1)),dragAndDrop:Ne(new f(31,"dragAndDrop",!0,{description:u.localize(201,null)})),emptySelectionClipboard:Ne(new F),enableDropIntoEditor:Ne(new f(32,"enableDropIntoEditor",!0)),extraEditorClassName:Ne(new m(34,"extraEditorClassName","")),fastScrollSensitivity:Ne(new c(35,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:u.localize(202,null)})),find:Ne(new A),fixedOverflowWidgets:Ne(new f(37,"fixedOverflowWidgets",!1)),folding:Ne(new f(38,"folding",!0,{description:u.localize(203,null)})),foldingStrategy:Ne(new d(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[u.localize(204,null),u.localize(205,null)],description:u.localize(206,null)})),foldingHighlight:Ne(new f(40,"foldingHighlight",!0,{description:u.localize(207,null)})),foldingImportsByDefault:Ne(new f(41,"foldingImportsByDefault",!1,{description:u.localize(208,null)})),foldingMaximumRegions:Ne(new v(42,"foldingMaximumRegions",5e3,10,65e3,{description:u.localize(209,null)})),unfoldOnClickAfterEndOfLine:Ne(new f(43,"unfoldOnClickAfterEndOfLine",!1,{description:u.localize(210,null)})),fontFamily:Ne(new m(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:u.localize(211,null)})),fontInfo:Ne(new $),fontLigatures2:Ne(new B),fontSize:Ne(new U),fontWeight:Ne(new K),formatOnPaste:Ne(new f(49,"formatOnPaste",!1,{description:u.localize(212,null)})),formatOnType:Ne(new f(50,"formatOnType",!1,{description:u.localize(213,null)})),glyphMargin:Ne(new f(51,"glyphMargin",!0,{description:u.localize(214,null)})),gotoLocation:Ne(new W),hideCursorInOverviewRuler:Ne(new f(53,"hideCursorInOverviewRuler",!1,{description:u.localize(215,null)})),hover:Ne(new N),inDiffEditor:Ne(new f(55,"inDiffEditor",!1)),letterSpacing:Ne(new c(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>c.clamp(ee,-5,20),{description:u.localize(216,null)})),lightbulb:Ne(new q),lineDecorationsWidth:Ne(new b(59,"lineDecorationsWidth",10)),lineHeight:Ne(new Q),lineNumbers:Ne(new ve),lineNumbersMinChars:Ne(new v(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new f(63,"linkedEditing",!1,{description:u.localize(217,null)})),links:Ne(new f(64,"links",!0,{description:u.localize(218,null)})),matchBrackets:Ne(new d(65,"matchBrackets","always",["always","near","never"],{description:u.localize(219,null)})),minimap:Ne(new le),mouseStyle:Ne(new d(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new c(68,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:u.localize(220,null)})),mouseWheelZoom:Ne(new f(69,"mouseWheelZoom",!1,{markdownDescription:u.localize(221,null)})),multiCursorMergeOverlapping:Ne(new f(70,"multiCursorMergeOverlapping",!0,{description:u.localize(222,null)})),multiCursorModifier:Ne(new r(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],pe,{markdownEnumDescriptions:[u.localize(223,null),u.localize(224,null)],markdownDescription:u.localize(225,null)})),multiCursorPaste:Ne(new d(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[u.localize(226,null),u.localize(227,null)],markdownDescription:u.localize(228,null)})),occurrencesHighlight:Ne(new f(73,"occurrencesHighlight",!0,{description:u.localize(229,null)})),overviewRulerBorder:Ne(new f(74,"overviewRulerBorder",!0,{description:u.localize(230,null)})),overviewRulerLanes:Ne(new v(75,"overviewRulerLanes",3,0,3)),padding:Ne(new Z),parameterHints:Ne(new ge),peekWidgetDefaultFocus:Ne(new d(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[u.localize(231,null),u.localize(232,null)],description:u.localize(233,null)})),definitionLinkOpensInPeek:Ne(new f(79,"definitionLinkOpensInPeek",!1,{description:u.localize(234,null)})),quickSuggestions:Ne(new Te),quickSuggestionsDelay:Ne(new v(81,"quickSuggestionsDelay",10,0,1073741824,{description:u.localize(235,null)})),readOnly:Ne(new f(82,"readOnly",!1)),renameOnType:Ne(new f(83,"renameOnType",!1,{description:u.localize(236,null),markdownDeprecationMessage:u.localize(237,null)})),renderControlCharacters:Ne(new f(84,"renderControlCharacters",!0,{description:u.localize(238,null),restricted:!0})),renderFinalNewline:Ne(new f(85,"renderFinalNewline",!0,{description:u.localize(239,null)})),renderLineHighlight:Ne(new d(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",u.localize(240,null)],description:u.localize(241,null)})),renderLineHighlightOnlyWhenFocus:Ne(new f(87,"renderLineHighlightOnlyWhenFocus",!1,{description:u.localize(242,null)})),renderValidationDecorations:Ne(new d(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new d(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",u.localize(243,null),u.localize(244,null),u.localize(245,null),""],description:u.localize(246,null)})),revealHorizontalRightPadding:Ne(new v(90,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ne(new f(91,"roundedSelection",!0,{description:u.localize(247,null)})),rulers:Ne(new de),scrollbar:Ne(new ie),scrollBeyondLastColumn:Ne(new v(94,"scrollBeyondLastColumn",4,0,1073741824,{description:u.localize(248,null)})),scrollBeyondLastLine:Ne(new f(95,"scrollBeyondLastLine",!0,{description:u.localize(249,null)})),scrollPredominantAxis:Ne(new f(96,"scrollPredominantAxis",!0,{description:u.localize(250,null)})),selectionClipboard:Ne(new f(97,"selectionClipboard",!0,{description:u.localize(251,null),included:t.isLinux})),selectionHighlight:Ne(new f(98,"selectionHighlight",!0,{description:u.localize(252,null)})),selectOnLineNumbers:Ne(new f(99,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new d(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[u.localize(253,null),u.localize(254,null),u.localize(255,null)],description:u.localize(256,null)})),showUnused:Ne(new f(101,"showUnused",!0,{description:u.localize(257,null)})),showDeprecated:Ne(new f(127,"showDeprecated",!0,{description:u.localize(258,null)})),inlayHints:Ne(new te),snippetSuggestions:Ne(new d(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[u.localize(259,null),u.localize(260,null),u.localize(261,null),u.localize(262,null)],description:u.localize(263,null)})),smartSelect:Ne(new X),smoothScrolling:Ne(new f(104,"smoothScrolling",!1,{description:u.localize(264,null)})),stopRenderingLineAfter:Ne(new v(106,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new G),inlineSuggest:Ne(new J),suggestFontSize:Ne(new v(108,"suggestFontSize",0,0,1e3,{markdownDescription:u.localize(265,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new v(109,"suggestLineHeight",0,0,1e3,{markdownDescription:u.localize(266,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new f(110,"suggestOnTriggerCharacters",!0,{description:u.localize(267,null)})),suggestSelection:Ne(new d(111,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[u.localize(268,null),u.localize(269,null),u.localize(270,null)],description:u.localize(271,null)})),tabCompletion:Ne(new d(112,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[u.localize(272,null),u.localize(273,null),u.localize(274,null)],description:u.localize(275,null)})),tabIndex:Ne(new v(113,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new me),unusualLineTerminators:Ne(new d(115,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[u.localize(276,null),u.localize(277,null),u.localize(278,null)],description:u.localize(279,null)})),useShadowDOM:Ne(new f(116,"useShadowDOM",!0)),useTabStops:Ne(new f(117,"useTabStops",!0,{description:u.localize(280,null)})),wordSeparators:Ne(new m(118,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:u.localize(281,null)})),wordWrap:Ne(new d(119,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[u.localize(282,null),u.localize(283,null),u.localize(284,null),u.localize(285,null)],description:u.localize(286,null)})),wordWrapBreakAfterCharacters:Ne(new m(120,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new m(121,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new v(122,"wordWrapColumn",80,1,1073741824,{markdownDescription:u.localize(287,null)})),wordWrapOverride1:Ne(new d(123,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new d(124,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ne(new r(125,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ae,{enumDescriptions:[u.localize(288,null),u.localize(289,null),u.localize(290,null),u.localize(291,null)],description:u.localize(292,null)})),wrappingStrategy:Ne(new d(126,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[u.localize(293,null),u.localize(294,null)],description:u.localize(295,null)})),editorClassName:Ne(new M),pixelRatio:Ne(new Ee),tabFocusMode:Ne(new he),layoutInfo:Ne(new x),wrappingInfo:Ne(new De)}}),define(Ie[163],ke([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[164],ke([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[165],ke([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[166],ke([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ie[167],ke([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(Ie[168],ke([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(Ie[169],ke([19,20]),function(Y,e){return Y.create("vs/platform/workspace/common/workspace",e)}),define(Ie[170],ke([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[171],ke([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[172],ke([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[173],ke([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[174],ke([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[175],ke([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[176],ke([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[177],ke([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ie[178],ke([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Ie[179],ke([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(Ie[180],ke([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[181],ke([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[182],ke([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ie[183],ke([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[184],ke([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[185],ke([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[186],ke([19,20]),function(Y,e){return Y.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[187],ke([19,20]),function(Y,e){return Y.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[188],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var u;(function(C){C[C.ACTIVATE=1]="ACTIVATE",C[C.RESTORE=2]="RESTORE",C[C.PRESERVE=3]="PRESERVE"})(u=e.EditorActivation||(e.EditorActivation={}));var t;(function(C){C[C.PICK=0]="PICK",C[C.DISABLED=1]="DISABLED",C[C.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var D;(function(C){C[C.API=0]="API",C[C.USER=1]="USER"})(D=e.EditorOpenSource||(e.EditorOpenSource={}));var P;(function(C){C[C.Center=0]="Center",C[C.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",C[C.NearTop=2]="NearTop",C[C.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var y;(function(C){C.PROGRAMMATIC="api",C.NAVIGATION="code.navigation",C.JUMP="code.jump"})(y=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(Ie[189],ke([1,0,22,41,165,303]),function(Y,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const y=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function E(f){return f=f.trim(),f==="*"||y.test(f)}e.isValidVersionStr=E;function I(f){if(!E(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=f.match(y);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=I;function R(f){if(!f)return null;const p=f.majorBase,v=f.majorMustEqual,c=f.minorBase;let m=f.minorMustEqual;const a=f.patchBase;let d=f.patchMustEqual;f.hasCaret&&(p===0||(m=!1),d=!1);let r=0;if(f.preRelease){const o=C.exec(f.preRelease);if(o){const[,i,n,s]=o;r=Date.UTC(Number(i),Number(n)-1,Number(s))}}return{majorBase:p,majorMustEqual:v,minorBase:c,minorMustEqual:m,patchBase:a,patchMustEqual:d,isMinimum:f.hasGreaterEquals,notBefore:r}}e.normalizeVersion=R;function k(f,p,v){let c;typeof f=="string"?c=R(I(f)):c=f;let m;p instanceof Date?m=p.getTime():typeof p=="string"&&(m=new Date(p).getTime());let a;if(typeof v=="string"?a=R(I(v)):a=v,!c||!a)return!1;const d=c.majorBase,r=c.minorBase,o=c.patchBase;let i=a.majorBase,n=a.minorBase,s=a.patchBase;const l=a.notBefore;let h=a.majorMustEqual,S=a.minorMustEqual,L=a.patchMustEqual;return a.isMinimum?d>i?!0:d<i?!1:r>n?!0:r<n||m&&m<l?!1:o>=s:(d===1&&i===0&&(!h||!S||!L)&&(i=1,n=0,s=0,h=!0,S=!1,L=!1),d<i?!1:d>i?!h:r<n?!1:r>n?!S:o<s?!1:o>s?!L:!(m&&m<l))}e.isValidVersion=k;function _(f,p,v,c,m){const a=[];if(typeof c.publisher!="undefined"&&typeof c.publisher!="string")return a.push([t.default.Error,D.localize(0,null)]),a;if(typeof c.name!="string")return a.push([t.default.Error,D.localize(1,null,"name")]),a;if(typeof c.version!="string")return a.push([t.default.Error,D.localize(2,null,"version")]),a;if(!c.engines)return a.push([t.default.Error,D.localize(3,null,"engines")]),a;if(typeof c.engines.vscode!="string")return a.push([t.default.Error,D.localize(4,null,"engines.vscode")]),a;if(typeof c.extensionDependencies!="undefined"&&!g(c.extensionDependencies))return a.push([t.default.Error,D.localize(5,null,"extensionDependencies")]),a;if(typeof c.activationEvents!="undefined"){if(!g(c.activationEvents))return a.push([t.default.Error,D.localize(6,null,"activationEvents")]),a;if(typeof c.main=="undefined"&&typeof c.browser=="undefined")return a.push([t.default.Error,D.localize(7,null,"activationEvents","main")]),a}if(typeof c.extensionKind!="undefined"&&typeof c.main=="undefined"&&a.push([t.default.Warning,D.localize(8,null,"extensionKind")]),typeof c.main!="undefined"){if(typeof c.main!="string")return a.push([t.default.Error,D.localize(9,null,"main")]),a;{const o=(0,u.joinPath)(v,c.main);(0,u.isEqualOrParent)(o,v)||a.push([t.default.Warning,D.localize(10,null,o.path,v.path)])}if(typeof c.activationEvents=="undefined")return a.push([t.default.Error,D.localize(11,null,"activationEvents","main")]),a}if(typeof c.browser!="undefined"){if(typeof c.browser!="string")return a.push([t.default.Error,D.localize(12,null,"browser")]),a;{const o=(0,u.joinPath)(v,c.browser);(0,u.isEqualOrParent)(o,v)||a.push([t.default.Warning,D.localize(13,null,o.path,v.path)])}if(typeof c.activationEvents=="undefined")return a.push([t.default.Error,D.localize(14,null,"activationEvents","browser")]),a}if(!P.valid(c.version))return a.push([t.default.Error,D.localize(15,null)]),a;const d=[];if(!T(f,p,c,m,d))for(const o of d)a.push([t.default.Error,o]);return a}e.validateExtensionManifest=_;function T(f,p,v,c,m){return c||typeof v.main=="undefined"&&typeof v.browser=="undefined"?!0:b(f,p,v.engines.vscode,m)}e.isValidExtensionVersion=T;function w(f,p,v){return f==="*"||b(p,v,f)}e.isEngineValid=w;function b(f,p,v,c=[]){const m=R(I(v));if(!m)return c.push(D.localize(16,null,v)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return c.push(D.localize(17,null,v)),!1}else if(!m.majorMustEqual)return c.push(D.localize(18,null,v)),!1;return k(f,p,m)?!0:(c.push(D.localize(19,null,f,v)),!1)}function g(f){if(!Array.isArray(f))return!1;for(let p=0,v=f.length;p<v;p++)if(typeof f[p]!="string")return!1;return!0}}),define(Ie[116],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class u{constructor(D,P=[],y=!1){this.ctor=D,this.staticArguments=P,this.supportsDelayedInstantiation=y}}e.SyncDescriptor=u}),define(Ie[82],ke([1,0,116]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function D(y,C,E){C instanceof u.SyncDescriptor||(C=new u.SyncDescriptor(C,[],E)),t.push([y,C])}e.registerSingleton=D;function P(){return t}e.getSingletonServiceDescriptors=P}),define(Ie[190],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class u{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=u;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(const y of this._nodes.values())y.outgoing.size===0&&P.push(y);return P}insertEdge(P,y){const C=this.lookupOrInsertNode(P),E=this.lookupOrInsertNode(y);C.outgoing.set(this._hashFn(y),E),E.incoming.set(this._hashFn(P),C)}removeNode(P){const y=this._hashFn(P);this._nodes.delete(y);for(const C of this._nodes.values())C.outgoing.delete(y),C.incoming.delete(y)}lookupOrInsertNode(P){const y=this._hashFn(P);let C=this._nodes.get(y);return C||(C=new u(P),this._nodes.set(y,C)),C}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){const P=[];for(const[y,C]of this._nodes)P.push(`${y}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(const[P,y]of this._nodes){const C=new Set([P]),E=this._findCycle(y,C);if(E)return E}}_findCycle(P,y){for(const[C,E]of P.outgoing){if(y.has(C))return[...y,C].join(" -> ");y.add(C);const I=this._findCycle(E,y);if(I)return I;y.delete(C)}}}e.Graph=t}),define(Ie[4],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var u;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function C(E){return E[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=C})(u=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function t(y,C,E){C[u.DI_TARGET]===C?C[u.DI_DEPENDENCIES].push({id:y,index:E}):(C[u.DI_DEPENDENCIES]=[{id:y,index:E}],C[u.DI_TARGET]=C)}function D(y){if(u.serviceIds.has(y))return u.serviceIds.get(y);const C=function(E,I,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(C,E,R)};return C.toString=()=>y,u.serviceIds.set(y,C),C}e.createDecorator=D;function P(y){return y}e.refineServiceDecorator=P}),define(Ie[83],ke([1,0,10,2,4]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function P(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationOverrides=P;function y(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||u.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=y;var C;(function(f){f[f.USER=1]="USER",f[f.USER_LOCAL=2]="USER_LOCAL",f[f.USER_REMOTE=3]="USER_REMOTE",f[f.WORKSPACE=4]="WORKSPACE",f[f.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",f[f.DEFAULT=6]="DEFAULT",f[f.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(f){switch(f){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=E;function I(f,p){const v=Object.create(null);for(const c in f)R(v,c,f[c],p);return v}e.toValuesTree=I;function R(f,p,v,c){const m=p.split("."),a=m.pop();let d=f;for(let r=0;r<m.length;r++){const o=m[r];let i=d[o];switch(typeof i){case"undefined":i=d[o]=Object.create(null);break;case"object":break;default:c(`Ignoring ${p} as ${m.slice(0,r+1).join(".")} is ${JSON.stringify(i)}`);return}d=i}if(typeof d=="object"&&d!==null)try{d[a]=v}catch{c(`Ignoring ${p} as ${m.join(".")} is ${JSON.stringify(d)}`)}else c(`Ignoring ${p} as ${m.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=R;function k(f,p){const v=p.split(".");_(f,v)}e.removeFromValueTree=k;function _(f,p){const v=p.shift();if(p.length===0){delete f[v];return}if(Object.keys(f).indexOf(v)!==-1){const c=f[v];typeof c=="object"&&!Array.isArray(c)&&(_(c,p),Object.keys(c).length===0&&delete f[v])}}function T(f,p,v){function c(d,r){let o=d;for(const i of r){if(typeof o!="object"||o===null)return;o=o[i]}return o}const m=p.split("."),a=c(f,m);return typeof a=="undefined"?v:a}e.getConfigurationValue=T;function w(f,p,v){Object.keys(p).forEach(c=>{c!=="__proto__"&&(c in f?u.isObject(f[c])&&u.isObject(p[c])?w(f[c],p[c],v):v&&(f[c]=p[c]):f[c]=p[c])})}e.merge=w;function b(f,p,v){const c=f.inspect(p),m=f.inspect(v);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:c.defaultValue}e.getMigratedSettingValue=b;function g(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=g}),define(Ie[51],ke([1,0,13,8,4]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",u.isMacintosh),P.set("isLinux",u.isLinux),P.set("isWindows",u.isWindows),P.set("isWeb",u.isWeb),P.set("isMacNative",u.isMacintosh&&!u.isWeb),P.set("isEdge",u.isEdge),P.set("isFirefox",u.isFirefox),P.set("isChrome",u.isChrome),P.set("isSafari",u.isSafari);const y=Object.prototype.hasOwnProperty;var C;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return k.INSTANCE}static true(){return _.INSTANCE}static has(A){return T.create(A)}static equals(A,B){return w.create(A,B)}static notEquals(A,B){return f.create(A,B)}static regex(A,B){return r.create(A,B)}static in(A,B){return b.create(A,B)}static notIn(A,B){return g.create(A,B)}static not(A){return p.create(A)}static and(...A){return n.create(A,null)}static or(...A){return s.create(A,null,!0)}static greater(A,B){return c.create(A,B)}static greaterEquals(A,B){return m.create(A,B)}static smaller(A,B){return a.create(A,B)}static smallerEquals(A,B){return d.create(A,B)}static deserialize(A,B=!1){if(!!A)return this._deserializeOrExpression(A,B)}static _deserializeOrExpression(A,B){const $=A.split("||");return s.create($.map(U=>this._deserializeAndExpression(U,B)),null,!0)}static _deserializeAndExpression(A,B){const $=A.split("&&");return n.create($.map(U=>this._deserializeOne(U,B)),null)}static _deserializeOne(A,B){if(A=A.trim(),A.indexOf("!=")>=0){const $=A.split("!=");return f.create($[0].trim(),this._deserializeValue($[1],B))}if(A.indexOf("==")>=0){const $=A.split("==");return w.create($[0].trim(),this._deserializeValue($[1],B))}if(A.indexOf("=~")>=0){const $=A.split("=~");return r.create($[0].trim(),this._deserializeRegexValue($[1],B))}if(A.indexOf(" not in ")>=0){const $=A.split(" not in ");return g.create($[0].trim(),$[1].trim())}if(A.indexOf(" in ")>=0){const $=A.split(" in ");return b.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(A)){const $=A.split(">=");return m.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(A)){const $=A.split(">");return c.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(A)){const $=A.split("<=");return d.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(A)){const $=A.split("<");return a.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(A)?p.create(A.substr(1).trim()):T.create(A)}static _deserializeValue(A,B){if(A=A.trim(),A==="true")return!0;if(A==="false")return!1;const $=/^'([^']*)'$/.exec(A);return $?$[1].trim():A}static _deserializeRegexValue(A,B){if((0,t.isFalsyOrWhitespace)(A)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=A.indexOf("/"),U=A.lastIndexOf("/");if($===U||$<0){if(B)throw new Error(`bad regexp-value '${A}', missing /-enclosure`);return console.warn(`bad regexp-value '${A}', missing /-enclosure`),null}const K=A.slice($+1,U),W=A[U+1]==="i"?"i":"";try{return new RegExp(K,W)}catch(N){if(B)throw new Error(`bad regexp-value '${A}', parse error: ${N}`);return console.warn(`bad regexp-value '${A}', parse error: ${N}`),null}}}e.ContextKeyExpr=E;function I(F,A){const B=F?F.substituteConstants():void 0,$=A?A.substituteConstants():void 0;return!B&&!$?!0:!B||!$?!1:B.equals($)}e.expressionsAreEqualWithConstantSubstitution=I;function R(F,A){return F.cmp(A)}class k{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return _.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class _{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=_,_.INSTANCE=new _;class T{constructor(A,B){this.key=A,this.negated=B,this.type=2}static create(A,B=null){const $=P.get(A);return typeof $=="boolean"?$?_.INSTANCE:k.INSTANCE:new T(A,B)}cmp(A){return A.type!==this.type?this.type-A.type:h(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=P.get(this.key);return typeof A=="boolean"?A?_.INSTANCE:k.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=T;class w{constructor(A,B,$){this.key=A,this.value=B,this.negated=$,this.type=4}static create(A,B,$=null){if(typeof B=="boolean")return B?T.create(A,$):p.create(A,$);const U=P.get(A);return typeof U=="boolean"?B===(U?"true":"false")?_.INSTANCE:k.INSTANCE:new w(A,B,$)}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=P.get(this.key);if(typeof A=="boolean"){const B=A?"true":"false";return this.value===B?_.INSTANCE:k.INSTANCE}return this}evaluate(A){return A.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(A){return A.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class b{constructor(A,B){this.key=A,this.valueKey=B,this.type=10,this.negated=null}static create(A,B){return new b(A,B)}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.valueKey,A.key,A.valueKey)}equals(A){return A.type===this.type?this.key===A.key&&this.valueKey===A.valueKey:!1}substituteConstants(){return this}evaluate(A){const B=A.getValue(this.valueKey),$=A.getValue(this.key);return Array.isArray(B)?B.includes($):typeof $=="string"&&typeof B=="object"&&B!==null?y.call(B,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(A){return A.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=g.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=b;class g{constructor(A,B){this.key=A,this.valueKey=B,this.type=11,this._negated=b.create(A,B)}static create(A,B){return new g(A,B)}cmp(A){return A.type!==this.type?this.type-A.type:this._negated.cmp(A._negated)}equals(A){return A.type===this.type?this._negated.equals(A._negated):!1}substituteConstants(){return this}evaluate(A){return!this._negated.evaluate(A)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(A){return A.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=g;class f{constructor(A,B,$){this.key=A,this.value=B,this.negated=$,this.type=5}static create(A,B,$=null){if(typeof B=="boolean")return B?p.create(A,$):T.create(A,$);const U=P.get(A);return typeof U=="boolean"?B===(U?"true":"false")?k.INSTANCE:_.INSTANCE:new f(A,B,$)}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=P.get(this.key);if(typeof A=="boolean"){const B=A?"true":"false";return this.value===B?k.INSTANCE:_.INSTANCE}return this}evaluate(A){return A.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(A){return A.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=f;class p{constructor(A,B){this.key=A,this.negated=B,this.type=3}static create(A,B=null){const $=P.get(A);return typeof $=="boolean"?$?k.INSTANCE:_.INSTANCE:new p(A,B)}cmp(A){return A.type!==this.type?this.type-A.type:h(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=P.get(this.key);return typeof A=="boolean"?A?k.INSTANCE:_.INSTANCE:this}evaluate(A){return!A.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(A){return A.mapNot(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=p;function v(F,A){if(typeof F=="string"){const B=parseFloat(F);isNaN(B)||(F=B)}return typeof F=="string"||typeof F=="number"?A(F):k.INSTANCE}class c{constructor(A,B,$){this.key=A,this.value=B,this.negated=$,this.type=12}static create(A,B,$=null){return v(B,U=>new c(A,U,$))}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class m{constructor(A,B,$){this.key=A,this.value=B,this.negated=$,this.type=13}static create(A,B,$=null){return v(B,U=>new m(A,U,$))}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=m;class a{constructor(A,B,$){this.key=A,this.value=B,this.negated=$,this.type=14}static create(A,B,$=null){return v(B,U=>new a(A,U,$))}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class d{constructor(A,B,$){this.key=A,this.value=B,this.negated=$,this.type=15}static create(A,B,$=null){return v(B,U=>new d(A,U,$))}cmp(A){return A.type!==this.type?this.type-A.type:S(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=d;class r{constructor(A,B){this.key=A,this.regexp=B,this.type=7,this.negated=null}static create(A,B){return new r(A,B)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.key<A.key)return-1;if(this.key>A.key)return 1;const B=this.regexp?this.regexp.source:"",$=A.regexp?A.regexp.source:"";return B<$?-1:B>$?1:0}equals(A){if(A.type===this.type){const B=this.regexp?this.regexp.source:"",$=A.regexp?A.regexp.source:"";return this.key===A.key&&B===$}return!1}substituteConstants(){return this}evaluate(A){const B=A.getValue(this.key);return this.regexp?this.regexp.test(B):!1}serialize(){const A=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${A}`}keys(){return[this.key]}map(A){return A.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=o.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class o{constructor(A){this._actual=A,this.type=8}static create(A){return new o(A)}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(A){return new o(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;function i(F){let A=null;for(let B=0,$=F.length;B<$;B++){const U=F[B].substituteConstants();if(F[B]!==U&&A===null){A=[];for(let K=0;K<B;K++)A[K]=F[K]}A!==null&&(A[B]=U)}return A===null?F:A}class n{constructor(A,B){this.expr=A,this.negated=B,this.type=6}static create(A,B){return n._normalizeArr(A,B)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let B=0,$=this.expr.length;B<$;B++){const U=R(this.expr[B],A.expr[B]);if(U!==0)return U}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let B=0,$=this.expr.length;B<$;B++)if(!this.expr[B].equals(A.expr[B]))return!1;return!0}return!1}substituteConstants(){const A=i(this.expr);return A===this.expr?this:n.create(A,this.negated)}evaluate(A){for(let B=0,$=this.expr.length;B<$;B++)if(!this.expr[B].evaluate(A))return!1;return!0}static _normalizeArr(A,B){const $=[];let U=!1;for(const K of A)if(!!K){if(K.type===1){U=!0;continue}if(K.type===0)return k.INSTANCE;if(K.type===6){$.push(...K.expr);continue}$.push(K)}if($.length===0&&U)return _.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(R);for(let K=1;K<$.length;K++)$[K-1].equals($[K])&&($.splice(K,1),K--);if($.length===1)return $[0];for(;$.length>1;){const K=$[$.length-1];if(K.type!==9)break;$.pop();const W=$.pop(),N=$.length===0,V=s.create(K.expr.map(x=>n.create([x,W],null)),null,N);V&&($.push(V),$.sort(R))}return $.length===1?$[0]:new n($,B)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const B of this.expr)A.push(...B.keys());return A}map(A){return new n(this.expr.map(B=>B.map(A)),null)}negate(){if(!this.negated){const A=[];for(const B of this.expr)A.push(B.negate());this.negated=s.create(A,this,!0)}return this.negated}}class s{constructor(A,B){this.expr=A,this.negated=B,this.type=9}static create(A,B,$){return s._normalizeArr(A,B,$)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let B=0,$=this.expr.length;B<$;B++){const U=R(this.expr[B],A.expr[B]);if(U!==0)return U}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let B=0,$=this.expr.length;B<$;B++)if(!this.expr[B].equals(A.expr[B]))return!1;return!0}return!1}substituteConstants(){const A=i(this.expr);return A===this.expr?this:s.create(A,this.negated,!1)}evaluate(A){for(let B=0,$=this.expr.length;B<$;B++)if(this.expr[B].evaluate(A))return!0;return!1}static _normalizeArr(A,B,$){let U=[],K=!1;if(A){for(let W=0,N=A.length;W<N;W++){const V=A[W];if(!!V){if(V.type===0){K=!0;continue}if(V.type===1)return _.INSTANCE;if(V.type===9){U=U.concat(V.expr);continue}U.push(V)}}if(U.length===0&&K)return k.INSTANCE;U.sort(R)}if(U.length!==0){if(U.length===1)return U[0];for(let W=1;W<U.length;W++)U[W-1].equals(U[W])&&(U.splice(W,1),W--);if(U.length===1)return U[0];if($){for(let W=0;W<U.length;W++)for(let N=W+1;N<U.length;N++)L(U[W],U[N])&&(U.splice(N,1),N--);if(U.length===1)return U[0]}return new s(U,B)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const B of this.expr)A.push(...B.keys());return A}map(A){return new s(this.expr.map(B=>B.map(A)),null)}negate(){if(!this.negated){const A=[];for(const B of this.expr)A.push(B.negate());for(;A.length>1;){const B=A.shift(),$=A.shift(),U=[];for(const W of M(B))for(const N of M($))U.push(n.create([W,N],null));const K=A.length===0;A.unshift(s.create(U,null,K))}this.negated=A[0]}return this.negated}}class l extends T{constructor(A,B,$){super(A,null);this._defaultValue=B,typeof $=="object"?l._info.push({...$,key:A}):$!==!0&&l._info.push({key:A,description:$,type:B!=null?typeof B:void 0})}static all(){return l._info.values()}bindTo(A){return A.createKey(this.key,this._defaultValue)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return w.create(this.key,A)}notEqualsTo(A){return f.create(this.key,A)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(F,A){return F<A?-1:F>A?1:0}function S(F,A,B,$){return F<B?-1:F>B?1:A<$?-1:A>$?1:0}function L(F,A){if(A.type===6&&F.type!==9&&F.type!==6){for(const U of A.expr)if(F.equals(U))return!0}const B=F.negate(),$=M(B).concat(M(A));$.sort(R);for(let U=0;U<$.length;U++){const W=$[U].negate();for(let N=U+1;N<$.length;N++){const V=$[N];if(W.equals(V))return!0}}return!1}e.implies=L;function M(F){return F.type===9?F.expr:[F]}}),define(Ie[191],ke([1,0,4]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,u.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,u.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[84],ke([1,0,164,4]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDefaultExtensionsProfileInitService=e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function P(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function y(f,p){switch(f){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function C(f,p){return p==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=C;function E(f,p,v){return C(p,v)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===v?!0:I(v).includes(f)}e.isTargetPlatformCompatible=E;function I(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function R(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=R;var k;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var _;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(_=e.SortOrder||(e.SortOrder={}));var T;(function(f){f.Install="install",f.Uninstall="uninstall"})(T=e.StatisticType||(e.StatisticType={}));var w;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var b;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(b=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class g extends Error{constructor(p,v){super(p);this.code=v,this.name=v}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,u.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,u.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService"),e.IDefaultExtensionsProfileInitService=(0,t.createDecorator)("IDefaultExtensionsProfileInitService")}),define(Ie[192],ke([1,0,4]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,u.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,u.createDecorator)("externalTerminal")}),define(Ie[193],ke([1,0,42,11,9,13,102,29,114,166,192]),function(Y,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=I.localize(0,null);class _{async getDefaultTerminalForPlatforms(){return{windows:T.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class T extends _{openTerminal(c,m){return this.spawnTerminal(u,c,E.getWindowsShell(),m)}spawnTerminal(c,m,a,d){const r=m.windowsExec||T.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const o=D.basename(r).toLowerCase();if(o==="cmder"||o==="cmder.exe")return c.spawn(r,d?[d]:void 0),Promise.resolve(void 0);const i=["/c","start","/wait"];return r.indexOf(" ")>=0&&i.push('""'),i.push(r),(o==="wt"||o==="wt.exe")&&i.push("-d ."),new Promise((n,s)=>{const l=g(process),h=c.spawn(a,i,{cwd:d,env:l});h.on("error",s),h.on("exit",()=>n())})}runInTerminal(c,m,a,d,r){const o="windowsExec"in r&&r.windowsExec?r.windowsExec:T.getDefaultTerminalWindows();return new Promise((i,n)=>{const s=`"${m} - ${k}"`,l=`""${a.join('" "')}" & pause"`,h=["/c","start",s,"/wait",o,"/c",l],S=Object.assign({},g(process),d);Object.keys(S).filter(F=>S[F]===null).forEach(F=>delete S[F]);const L={cwd:m,env:S,windowsVerbatimArguments:!0};u.spawn(T.CMD,h,L).on("error",F=>{n(f(F))}),i(void 0)})}static getDefaultTerminalWindows(){if(!T._DEFAULT_TERMINAL_WINDOWS){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");T._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return T._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=T,T.CMD="cmd.exe";class w extends _{openTerminal(c,m){return this.spawnTerminal(u,c,m)}runInTerminal(c,m,a,d,r){const o=r.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((i,n)=>{if(o===R.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const s=o===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",h=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${s}.scpt`,Y).fsPath,"-t",c||k,"-w",m];for(const M of a)h.push("-a"),h.push(M);if(d){const M=Object.assign({},g(process),d);for(const F in M){const A=M[F];A===null?(h.push("-u"),h.push(F)):(h.push("-e"),h.push(`${F}=${A}`))}}let S="";const L=u.spawn(w.OSASCRIPT,h);L.on("error",M=>{n(f(M))}),L.stderr.on("data",M=>{S+=M.toString()}),L.on("exit",M=>{if(M===0)i(void 0);else if(S){const F=S.split(`
`,1);n(new Error(F[0]))}else n(new Error(I.localize(1,null,s,M)))})}else n(new Error(I.localize(2,null,o)))})}spawnTerminal(c,m,a){const d=m.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((r,o)=>{const i=["-a",d];a&&i.push(a);const n=g(process),s=c.spawn("/usr/bin/open",i,{cwd:a,env:n});s.on("error",o),s.on("exit",()=>r())})}}e.MacExternalTerminalService=w,w.OSASCRIPT="/usr/bin/osascript";class b extends _{openTerminal(c,m){return this.spawnTerminal(u,c,m)}runInTerminal(c,m,a,d,r){const o=r.linuxExec?Promise.resolve(r.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{const s=[];o.then(l=>{l.indexOf("gnome-terminal")>=0?s.push("-x"):s.push("-e"),s.push("bash"),s.push("-c");const h=`${p(a)}; echo; read -p "${b.WAIT_MESSAGE}" -n1;`;s.push(`''${h}''`);const S=Object.assign({},g(process),d);Object.keys(S).filter(A=>S[A]===null).forEach(A=>delete S[A]);const L={cwd:m,env:S};let M="";const F=u.spawn(l,s,L);F.on("error",A=>{n(f(A))}),F.stderr.on("data",A=>{M+=A.toString()}),F.on("exit",A=>{if(A===0)i(void 0);else if(M){const B=M.split(`
`,1);n(new Error(B[0]))}else n(new Error(I.localize(4,null,l,A)))})})})}static async getDefaultTerminalLinuxReady(){if(!b._DEFAULT_TERMINAL_LINUX_READY)if(!P.isLinux)b._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const c=await C.Promises.exists("/etc/debian_version");b._DEFAULT_TERMINAL_LINUX_READY=new Promise(m=>{c?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm")})}return b._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(c,m,a){const d=m.linuxExec?Promise.resolve(m.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((r,o)=>{d.then(i=>{const n=g(process),s=c.spawn(i,[],{cwd:a,env:n});s.on("error",o),s.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=b,b.WAIT_MESSAGE=I.localize(3,null);function g(v){const c={...v.env};return(0,y.sanitizeProcessEnvironment)(c),c}function f(v){return"errno"in v&&v.errno==="ENOENT"&&"path"in v&&typeof v.path=="string"?new Error(I.localize(5,null,v.path)):v}function p(v){let c="";for(const m of v)m.indexOf(" ")>=0?c+='"'+m+'"':c+=m,c+=" ";return c}}),define(Ie[43],ke([1,0,25,9,8,10,2,167,4]),function(Y,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function I(W){return W.create===!0}e.isFileOpenForWriteOptions=I;var R;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var k;(function(W){W[W.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var _;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileClone=32768]="FileClone"})(_=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function T(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=T;function w(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=w;function b(W){return!!(W.capabilities&32768)}e.hasFileCloneCapability=b;function g(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function f(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=f;function p(W){return T(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var v;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(N,V){super(N);this.code=V}}e.FileSystemProviderError=c;function m(W,N){const V=new c(W.toString(),N);return d(V,N),V}e.createFileSystemProviderError=m;function a(W){return W||m((0,C.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=a;function d(W,N){return W.name=N?`${N} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=d;function r(W){if(!W)return v.Unknown;if(W instanceof c)return W.code;const N=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!N)return v.Unknown;switch(N[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=r;function o(W){if(W instanceof S)return W.fileOperationResult;switch(r(W)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var i;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class n{constructor(N,V,x){this.resource=N,this.operation=V,this.target=x}isOperation(N){return this.operation===N}}e.FileOperationEvent=n;var s;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class l{constructor(N,V){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=N;const x=new Map;for(const q of N){const te=x.get(q.type);switch(te?te.push([q.resource,q]):x.set(q.type,[[q.resource,q]]),q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}}for(const[q,te]of x)switch(q){case 1:this.added=u.TernarySearchTree.forUris(()=>V),this.added.fill(te);break;case 0:this.updated=u.TernarySearchTree.forUris(()=>V),this.updated.fill(te);break;case 2:this.deleted=u.TernarySearchTree.forUris(()=>V),this.deleted.fill(te);break}}contains(N,...V){return this.doContains(N,{includeChildren:!1},...V)}affects(N,...V){return this.doContains(N,{includeChildren:!0},...V)}doContains(N,V,...x){if(!N)return!1;const q=x.length>0;return!!((!q||x.includes(1))&&(this.added?.get(N)||V.includeChildren&&this.added?.findSuperstr(N))||(!q||x.includes(0))&&(this.updated?.get(N)||V.includeChildren&&this.updated?.findSuperstr(N))||(!q||x.includes(2))&&(this.deleted?.findSubstr(N)||V.includeChildren&&this.deleted?.findSuperstr(N)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=l;function h(W,N,V){return!W||!N||W===N||N.length>W.length?!1:(N.charAt(N.length-1)!==t.sep&&(N+=t.sep),V?(0,D.startsWithIgnoreCase)(W,N):W.indexOf(N)===0)}e.isParent=h;class S extends Error{constructor(N,V,x){super(N);this.fileOperationResult=V,this.options=x}}e.FileOperationError=S;class L extends S{constructor(N,V,x){super(N,2,x);this.stat=V}}e.NotModifiedSinceFileOperationError=L;var M;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function A(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=A;async function B(W,N){if(!N.hasProvider(y.URI.from({scheme:W.scheme})))return new Promise(V=>{const x=N.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===W.scheme&&q.added&&(x.dispose(),V())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(N){return(0,P.isNumber)(N)||(N=0),N<$.KB?(0,C.localize)(1,null,N.toFixed(0)):N<$.MB?(0,C.localize)(2,null,(N/$.KB).toFixed(2)):N<$.GB?(0,C.localize)(3,null,(N/$.MB).toFixed(2)):N<$.TB?(0,C.localize)(4,null,(N/$.GB).toFixed(2)):(0,C.localize)(5,null,(N/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var U;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(U=e.Arch||(e.Arch={}));function K(W){return{maxFileSize:W===0?300*$.MB:16*$.GB,maxHeapSize:W===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=K}),define(Ie[85],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class u{constructor(...D){this._entries=new Map;for(const[P,y]of D)this.set(P,y)}set(D,P){const y=this._entries.get(D);return this._entries.set(D,P),y}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=u}),define(Ie[194],ke([1,0,18,12,116,190,4,85]),function(Y,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class I extends Error{constructor(w){super("cyclic dependency between services");this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class R{constructor(w=new C.ServiceCollection,b=!1,g){this._activeInstantiations=new Set,this._services=w,this._strict=b,this._parent=g,this._services.set(y.IInstantiationService,this)}createChild(w){return new R(w,this._strict,this)}invokeFunction(w,...b){const g=_.traceInvocation(w);let f=!1;try{return w({get:v=>{if(f)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(v,g);if(!c)throw new Error(`[invokeFunction] unknown service '${v}'`);return c}},...b)}finally{f=!0,g.stop()}}createInstance(w,...b){let g,f;return w instanceof D.SyncDescriptor?(g=_.traceCreation(w.ctor),f=this._createInstance(w.ctor,w.staticArguments.concat(b),g)):(g=_.traceCreation(w),f=this._createInstance(w,b,g)),g.stop(),f}_createInstance(w,b=[],g){const f=y._util.getServiceDependencies(w).sort((c,m)=>c.index-m.index),p=[];for(const c of f){const m=this._getOrCreateServiceInstance(c.id,g);m||this._throwIfStrict(`[createInstance] ${w.name} depends on UNKNOWN service ${c.id}.`,!1),p.push(m)}const v=f.length>0?f[0].index:b.length;if(b.length!==v){console.trace(`[createInstance] First service dependency of ${w.name} at position ${v+1} conflicts with ${b.length} static arguments`);const c=v-b.length;c>0?b=b.concat(new Array(c)):b=b.slice(0,v)}return new w(...[...b,...p])}_setServiceInstance(w,b){if(this._services.get(w)instanceof D.SyncDescriptor)this._services.set(w,b);else if(this._parent)this._parent._setServiceInstance(w,b);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(w){const b=this._services.get(w);return!b&&this._parent?this._parent._getServiceInstanceOrDescriptor(w):b}_getOrCreateServiceInstance(w,b){const g=this._getServiceInstanceOrDescriptor(w);return g instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(w,g,b.branch(w,!0)):(b.branch(w,!1),g)}_safeCreateAndCacheServiceInstance(w,b,g){if(this._activeInstantiations.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this._activeInstantiations.add(w);try{return this._createAndCacheServiceInstance(w,b,g)}finally{this._activeInstantiations.delete(w)}}_createAndCacheServiceInstance(w,b,g){const f=new P.Graph(c=>c.id.toString());let p=0;const v=[{id:w,desc:b,_trace:g}];for(;v.length;){const c=v.pop();if(f.lookupOrInsertNode(c),p++>1e3)throw new I(f);for(const m of y._util.getServiceDependencies(c.desc.ctor)){const a=this._getServiceInstanceOrDescriptor(m.id);if(a||this._throwIfStrict(`[createInstance] ${w} depends on ${m.id} which is NOT registered.`,!0),a instanceof D.SyncDescriptor){const d={id:m.id,desc:a,_trace:c._trace.branch(m.id,!0)};f.insertEdge(c,d),v.push(d)}}}for(;;){const c=f.roots();if(c.length===0){if(!f.isEmpty())throw new I(f);break}for(const{data:m}of c){if(this._getServiceInstanceOrDescriptor(m.id)instanceof D.SyncDescriptor){const d=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,d)}f.removeNode(m)}}return this._getServiceInstanceOrDescriptor(w)}_createServiceInstanceWithOwner(w,b,g=[],f,p){if(this._services.get(w)instanceof D.SyncDescriptor)return this._createServiceInstance(b,g,f,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(w,b,g,f,p);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}_createServiceInstance(w,b=[],g,f){if(g){const p=new u.IdleValue(()=>this._createInstance(w,b,f));return new Proxy(Object.create(null),{get(v,c){if(c in v)return v[c];const m=p.value;let a=m[c];return typeof a!="function"||(a=a.bind(m),v[c]=a),a},set(v,c,m){return p.value[c]=m,!0}})}else return this._createInstance(w,b,f)}_throwIfStrict(w,b){if(b&&console.warn(w),this._strict)throw new Error(w)}}e.InstantiationService=R;var k;(function(T){T[T.Creation=0]="Creation",T[T.Invocation=1]="Invocation",T[T.Branch=2]="Branch"})(k||(k={}));class _{constructor(w,b){this.type=w,this.name=b,this._start=Date.now(),this._dep=[]}static traceInvocation(w){return E?new _(1,w.name||w.toString().substring(0,42).replace(/\n/g,"")):_._None}static traceCreation(w){return E?new _(0,w.name):_._None}branch(w,b){const g=new _(2,w.toString());return this._dep.push([w,b,g]),g}stop(){const w=Date.now()-this._start;_._totals+=w;let b=!1;function g(p,v){const c=[],m=new Array(p+1).join("	");for(const[a,d,r]of v._dep)if(d&&r){b=!0,c.push(`${m}CREATES -> ${a}`);const o=g(p+1,r);o&&c.push(o)}else c.push(`${m}uses -> ${a}`);return c.join(`
`)}const f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${_._totals.toFixed(2)}ms)`];(w>2||b)&&console.log(f.join(`
`))}}e.Trace=_,_._None=new class extends _{constructor(){super(-1,null)}stop(){}branch(){return this}},_._totals=0}),define(Ie[14],ke([1,0,49,3,6,13,4]),function(Y,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function C(){return new Date().toISOString()}var E;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function I(d,r,o){switch(r){case E.Trace:d.trace(o);break;case E.Debug:d.debug(o);break;case E.Info:d.info(o);break;case E.Warning:d.warn(o);break;case E.Error:d.error(o);break;case E.Critical:d.critical(o);break;default:throw new Error("Invalid log level")}}e.log=I;function R(d){let r="";for(let o=0;o<d.length;o++){let i=d[o];if(typeof i=="object")try{i=JSON.stringify(i)}catch{}r+=(o>0?" ":"")+i}return r}e.format=R;class k extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class _ extends k{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...o){this.checkLogLevel(E.Trace)&&this.log(E.Trace,R([r,...o]))}debug(r,...o){this.checkLogLevel(E.Debug)&&this.log(E.Debug,R([r,...o]))}info(r,...o){this.checkLogLevel(E.Info)&&this.log(E.Info,R([r,...o]))}warn(r,...o){this.checkLogLevel(E.Warning)&&this.log(E.Warning,R([r,...o]))}error(r,...o){if(this.checkLogLevel(E.Error))if(r instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=r.stack,this.log(E.Error,R(i))}else this.log(E.Error,R([r,...o]))}critical(r,...o){this.checkLogLevel(E.Critical)&&this.log(E.Critical,R([r,...o]))}flush(){}}e.AbstractMessageLogger=_;class T extends k{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!P.isWindows}trace(r,...o){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,r,...o):console.log(`[main ${C()}]`,r,...o))}debug(r,...o){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,r,...o):console.log(`[main ${C()}]`,r,...o))}info(r,...o){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,r,...o):console.log(`[main ${C()}]`,r,...o))}warn(r,...o){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,r,...o):console.warn(`[main ${C()}]`,r,...o))}error(r,...o){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,r,...o):console.error(`[main ${C()}]`,r,...o))}critical(r,...o){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,r,...o):console.error(`[main ${C()}]`,r,...o))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class w extends k{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...o){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",r,...o)}debug(r,...o){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...o)}info(r,...o){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",r,...o)}warn(r,...o){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",r,...o)}error(r,...o){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",r,...o)}critical(r,...o){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...o)}dispose(){}flush(){}}e.ConsoleLogger=w;class b extends k{constructor(r,o=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(o)}trace(r,...o){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(r),...o])}debug(r,...o){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(r),...o])}info(r,...o){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(r),...o])}warn(r,...o){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(r),...o])}error(r,...o){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(r),...o])}critical(r,...o){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(r),...o])}extractMessage(r){return typeof r=="string"?r:(0,u.toErrorMessage)(r,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class g extends k{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const o of this.logServices)o.setLevel(r);super.setLevel(r)}trace(r,...o){for(const i of this.logServices)i.trace(r,...o)}debug(r,...o){for(const i of this.logServices)i.debug(r,...o)}info(r,...o){for(const i of this.logServices)i.info(r,...o)}warn(r,...o){for(const i of this.logServices)i.warn(r,...o)}error(r,...o){for(const i of this.logServices)i.error(r,...o)}critical(r,...o){for(const i of this.logServices)i.critical(r,...o)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=g;class f extends D.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...o){this.logger.trace(r,...o)}debug(r,...o){this.logger.debug(r,...o)}info(r,...o){this.logger.info(r,...o)}warn(r,...o){this.logger.warn(r,...o)}error(r,...o){this.logger.error(r,...o)}critical(r,...o){this.logger.critical(r,...o)}flush(){this.logger.flush()}}e.LogService=f;class p extends D.Disposable{constructor(r,o){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(o(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(i))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,o){let i=this.loggers.get(r.toString());return i||(i=this.doCreateLogger(r,o?.always?E.Trace:this.logLevel,o),this.loggers.set(r.toString(),i),o?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class v{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(r){}getLevel(){return E.Info}trace(r,...o){}debug(r,...o){}info(r,...o){}warn(r,...o){}error(r,...o){}critical(r,...o){}dispose(){}flush(){}}e.NullLogService=v;function c(d){if(d.verbose)return E.Trace;if(typeof d.logLevel=="string"){const r=m(d.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function m(d){switch(d){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=m;function a(d){switch(d){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=a}),define(Ie[195],ke([1,0,43,14]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(C,E,I,R,k){try{const _=await new Promise((w,b)=>{Y(["spdlog"],w,b)});_.setFlushOn(t.LogLevel.Trace);const T=await _.createAsyncRotatingLogger(C,E,I,R);return k&&T.clearFormatters(),T}catch(_){console.error(_)}return null}function P(C,E,I){switch(E){case t.LogLevel.Trace:C.trace(I);break;case t.LogLevel.Debug:C.debug(I);break;case t.LogLevel.Info:C.info(I);break;case t.LogLevel.Warning:C.warn(I);break;case t.LogLevel.Error:C.error(I);break;case t.LogLevel.Critical:C.critical(I);break;default:throw new Error("Invalid log level")}}class y extends t.AbstractMessageLogger{constructor(E,I,R,k,_){super();this.buffer=[],this.setLevel(_),this._loggerCreationPromise=this._createSpdLogLogger(E,I,R,k),this._register(this.onDidChangeLogLevel(T=>{this._logger?.setLevel(T)}))}async _createSpdLogLogger(E,I,R,k){const _=R?6:1,T=30/_*u.ByteSize.MB,w=await D(E,I,T,_,k);if(w){this._logger=w,this._logger.setLevel(this.getLevel());for(const{level:b,message:g}of this.buffer)P(this._logger,b,g);this.buffer=[]}}log(E,I){this._logger?P(this._logger,E,I):this.getLevel()<=E&&this.buffer.push({level:E,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=y}),define(Ie[117],ke([1,0,41,168,4]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var y;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function I(w,b){return b-w}E.compare=I;const R=Object.create(null);R[E.Error]=(0,t.localize)(0,null),R[E.Warning]=(0,t.localize)(1,null),R[E.Info]=(0,t.localize)(2,null);function k(w){return R[w]||""}E.toString=k;function _(w){switch(w){case u.default.Error:return E.Error;case u.default.Warning:return E.Warning;case u.default.Info:return E.Info;case u.default.Ignore:return E.Hint}}E.fromSeverity=_;function T(w){switch(w){case E.Error:return u.default.Error;case E.Warning:return u.default.Warning;case E.Info:return u.default.Info;case E.Hint:return u.default.Ignore}}E.toSeverity=T}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(E){const I="";function R(_){return k(_,!0)}E.makeKey=R;function k(_,T){const w=[I];return _.source?w.push(_.source.replace("\xA6","\\\xA6")):w.push(I),_.code?typeof _.code=="string"?w.push(_.code.replace("\xA6","\\\xA6")):w.push(_.code.value.replace("\xA6","\\\xA6")):w.push(I),_.severity!==void 0&&_.severity!==null?w.push(y.toString(_.severity)):w.push(I),_.message&&T?w.push(_.message.replace("\xA6","\\\xA6")):w.push(I),_.startLineNumber!==void 0&&_.startLineNumber!==null?w.push(_.startLineNumber.toString()):w.push(I),_.startColumn!==void 0&&_.startColumn!==null?w.push(_.startColumn.toString()):w.push(I),_.endLineNumber!==void 0&&_.endLineNumber!==null?w.push(_.endLineNumber.toString()):w.push(I),_.endColumn!==void 0&&_.endColumn!==null?w.push(_.endColumn.toString()):w.push(I),w.push(I),w.join("\xA6")}E.makeKeyOptionalMessage=k})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(Ie[196],ke([1,0,3,41,4]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,D.createDecorator)("notificationService");var P;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new E,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=C;class E{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=E}),define(Ie[118],ke([1,0,6,8,2,4]),function(Y,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return u.Disposable.None},registerValidator(){return u.Disposable.None},registerExternalUriResolver(){return u.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return u.Disposable.None},async open(){return!1},async resolveExternalUri(R){return{resolved:R,dispose(){}}}});function y(R,k){return D.URI.isUri(R)?(0,t.equalsIgnoreCase)(R.scheme,k):(0,t.startsWithIgnoreCase)(R,k+":")}e.matchesScheme=y;function C(R,...k){return k.some(_=>y(R,_))}e.matchesSomeScheme=C;function E(R,k){return R.with({fragment:`${k.startLineNumber},${k.startColumn}${k.endLineNumber?`-${k.endLineNumber}${k.endColumn?`,${k.endColumn}`:""}`:""}`})}e.withSelection=E;function I(R){let k;const _=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(R.fragment);return _&&(k={startLineNumber:parseInt(_[1]),startColumn:_[2]?parseInt(_[2]):1,endLineNumber:_[4]?parseInt(_[4]):void 0,endColumn:_[4]?_[5]?parseInt(_[5]):1:void 0},R=R.with({fragment:""})),{selection:k,uri:R}}e.extractSelection=I}),define(Ie[197],ke([1,0,11,13,40,22]),function(Y,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const C=t.globals.vscode.context.configuration();if(C)y=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const C=(0,P.dirname)(u.FileAccess.asFileUri("",Y));y=Y.__$__nodeRequire((0,P.joinPath)(C,"product.json").fsPath);const E=Y.__$__nodeRequire((0,P.joinPath)(C,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`,serverDataFolderName:y.serverDataFolderName?`${y.serverDataFolderName}-dev`:void 0}),Object.assign(y,{version:E.version})}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=y}),define(Ie[198],ke([1,0,4]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,u.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var xe=this&&this.__param||function(Y,e){return function(u,t){e(u,t,Y)}};define(Ie[119],ke([1,0,18,21,6,4]),function(Y,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var y;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let E=class extends D.Disposable{constructor(k,_){super();this.deferred=new u.DeferredPromise,_.withProgress(k,T=>(this.reporter=T,this.lastStep&&T.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};E=Ge([xe(1,e.IProgressService)],E),e.UnmanagedProgress=E;class I extends D.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(k){this.stop();const _=++this.currentOperationId,T=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{_===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>T.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:_,token:T.token,stop:()=>this.doStop(_),isCurrent:()=>this.currentOperationId===_}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(Ie[44],ke([1,0,56,10]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(y,C){u.ok(t.isString(y)),u.ok(t.isObject(C)),u.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,C)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new D}),define(Ie[120],ke([1,0,3,44]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class P{constructor(){this._onDidChangeSchema=new u.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,I){this.schemasById[D(E)]=I,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new P;t.Registry.add(e.Extensions.JSONContribution,y)}),define(Ie[121],ke([1,0,16,3,10,163,83,120,44]),function(Y,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=E.Registry.as(C.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(a,d=!0){this.registerConfigurations([a],d)}registerConfigurations(a,d=!0){const r=this.doRegisterConfigurations(a,d);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(a){const d=this.doDeregisterConfigurations(a);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d})}updateConfigurations({add:a,remove:d}){const r=[];r.push(...this.doDeregisterConfigurations(d)),r.push(...this.doRegisterConfigurations(a,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,u.distinct)(r)})}registerDefaultConfigurations(a){const d=[],r=[];for(const{overrides:o,source:i}of a)for(const n in o)if(d.push(n),e.OVERRIDE_PROPERTY_REGEX.test(n)){const s=this.configurationDefaultsOverrides.get(n),l=s?.valuesSources??new Map;if(i)for(const M of Object.keys(o[n]))l.set(M,i);const h={...s?.value||{},...o[n]};this.configurationDefaultsOverrides.set(n,{source:i,value:h,valuesSources:l});const S=(0,y.getLanguageTagSettingPlainKey)(n),L={type:"object",default:h,description:P.localize(1,null,S),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:D.isString(i)?void 0:i,defaultValueSource:i};r.push(...b(n)),this.configurationProperties[n]=L,this.defaultLanguageConfigurationOverridesNode.properties[n]=L}else{this.configurationDefaultsOverrides.set(n,{value:o[n],source:i});const s=this.configurationProperties[n];s&&(this.updatePropertyDefaultValue(n,s),this.updateSchema(n,s))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}deregisterDefaultConfigurations(a){const d=[];for(const{overrides:r,source:o}of a)for(const i in r){const n=this.configurationDefaultsOverrides.get(i),s=D.isString(o)?o:o?.id,l=D.isString(n?.source)?n?.source:n?.source?.id;if(s===l)if(d.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const h=this.configurationProperties[i];h&&(this.updatePropertyDefaultValue(i,h),this.updateSchema(i,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){for(const d of a)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,d){const r=[];return a.forEach(o=>{r.push(...this.validateAndRegisterProperties(o,d,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),r}doDeregisterConfigurations(a){const d=[],r=o=>{if(o.properties)for(const i in o.properties){d.push(i);const n=this.configurationProperties[i];n?.policy?.name&&this.policyConfigurations.delete(n.policy.name),delete this.configurationProperties[i],this.removeFromSchema(i,o.properties[i])}o.allOf?.forEach(i=>r(i))};for(const o of a){r(o);const i=this.configurationContributors.indexOf(o);i!==-1&&this.configurationContributors.splice(i,1)}return d}validateAndRegisterProperties(a,d=!0,r,o,i=3){i=D.isUndefinedOrNull(a.scope)?i:a.scope;const n=[],s=a.properties;if(s)for(const h in s){const S=s[h];if(d&&v(h,S)){delete s[h];continue}if(S.source=r,S.defaultDefaultValue=s[h].default,this.updatePropertyDefaultValue(h,S),e.OVERRIDE_PROPERTY_REGEX.test(h)?S.scope=void 0:(S.scope=D.isUndefinedOrNull(S.scope)?i:S.scope,S.restricted=D.isUndefinedOrNull(S.restricted)?!!o?.includes(h):S.restricted),s[h].hasOwnProperty("included")&&!s[h].included){this.excludedConfigurationProperties[h]=s[h],delete s[h];continue}else this.configurationProperties[h]=s[h],s[h].policy?.name&&this.policyConfigurations.set(s[h].policy.name,h);!s[h].deprecationMessage&&s[h].markdownDeprecationMessage&&(s[h].deprecationMessage=s[h].markdownDeprecationMessage),n.push(h)}const l=a.allOf;if(l)for(const h of l)n.push(...this.validateAndRegisterProperties(h,d,r,o,i));return n}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(a){const d=r=>{const o=r.properties;if(o)for(const n in o)this.updateSchema(n,o[n]);r.allOf?.forEach(d)};d(a)}updateSchema(a,d){switch(e.allSettings.properties[a]=d,d.scope){case 1:e.applicationSettings.properties[a]=d;break;case 2:e.machineSettings.properties[a]=d;break;case 6:e.machineOverridableSettings.properties[a]=d;break;case 3:e.windowSettings.properties[a]=d;break;case 4:e.resourceSettings.properties[a]=d;break;case 5:e.resourceSettings.properties[a]=d,this.resourceLanguageSettingsSchema.properties[a]=d;break}}removeFromSchema(a,d){switch(delete e.allSettings.properties[a],d.scope){case 1:delete e.applicationSettings.properties[a];break;case 2:delete e.machineSettings.properties[a];break;case 6:delete e.machineOverridableSettings.properties[a];break;case 3:delete e.windowSettings.properties[a];break;case 4:case 5:delete e.resourceSettings.properties[a],delete this.resourceLanguageSettingsSchema.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const d=`[${a}]`,r={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,r),e.allSettings.properties[d]=r,e.applicationSettings.properties[d]=r,e.machineSettings.properties[d]=r,e.machineOverridableSettings.properties[d]=r,e.windowSettings.properties[d]=r,e.resourceSettings.properties[d]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const a={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=a,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,d){const r=this.configurationDefaultsOverrides.get(a);let o=r?.value,i=r?.source;D.isUndefined(o)&&(o=d.defaultDefaultValue,i=void 0),D.isUndefined(o)&&(o=f(d.type)),d.default=o,d.defaultValueSource=i}}const T="\\[([^\\]]+)\\]",w=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(m){const a=[];if(e.OVERRIDE_PROPERTY_REGEX.test(m)){let d=w.exec(m);for(;d?.length;){const r=d[1].trim();r&&a.push(r),d=w.exec(m)}}return(0,u.distinct)(a)}e.overrideIdentifiersFromKey=b;function g(m){return m.reduce((a,d)=>`${a}[${d}]`,"")}e.keyFromOverrideIdentifiers=g;function f(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const p=new _;E.Registry.add(e.Extensions.Configuration,p);function v(m,a){return m.trim()?e.OVERRIDE_PROPERTY_REGEX.test(m)?P.localize(7,null,m):p.getConfigurationProperties()[m]!==void 0?P.localize(8,null,m):a.policy?.name&&p.getPolicyConfigurations().get(a.policy?.name)!==void 0?P.localize(9,null,m,a.policy?.name,p.getPolicyConfigurations().get(a.policy?.name)):null:P.localize(6,null)}e.validateProperty=v;function c(){const m=[],a=p.getConfigurationProperties();for(const d of Object.keys(a))m.push([d,a[d].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.getScopes=c}),define(Ie[199],ke([1,0,16,3,142,6,25,24,10,2,83,121,44]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class T{constructor(d={},r=[],o=[]){this._contents=d,this._keys=r,this._overrides=o,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(d){return d?(0,R.getConfigurationValue)(this.contents,d):this.contents}getOverrideValue(d,r){const o=this.getContentsForOverrideIdentifer(r);return o?d?(0,R.getConfigurationValue)(o,d):o:void 0}getKeysForOverrideIdentifier(d){const r=[];for(const o of this.overrides)o.identifiers.includes(d)&&r.push(...o.keys);return u.distinct(r)}getAllOverrideIdentifiers(){const d=[];for(const r of this.overrides)d.push(...r.identifiers);return u.distinct(d)}override(d){let r=this.overrideConfigurations.get(d);return r||(r=this.createOverrideConfigurationModel(d),this.overrideConfigurations.set(d,r)),r}merge(...d){const r=C.deepClone(this.contents),o=C.deepClone(this.overrides),i=[...this.keys];for(const n of d)if(!n.isEmpty()){this.mergeContents(r,n.contents);for(const s of n.overrides){const[l]=o.filter(h=>u.equals(h.identifiers,s.identifiers));l?(this.mergeContents(l.contents,s.contents),l.keys.push(...s.keys),l.keys=u.distinct(l.keys)):o.push(C.deepClone(s))}for(const s of n.keys)i.indexOf(s)===-1&&i.push(s)}return new T(r,i,o)}freeze(){return this.frozen=!0,this}clone(){return new T(C.deepClone(this.contents),[...this.keys],C.deepClone(this.overrides))}createOverrideConfigurationModel(d){const r=this.getContentsForOverrideIdentifer(d);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const o={};for(const i of u.distinct([...Object.keys(this.contents),...Object.keys(r)])){let n=this.contents[i];const s=r[i];s&&(typeof n=="object"&&typeof s=="object"?(n=C.deepClone(n),this.mergeContents(n,s)):n=s),o[i]=n}return new T(o,this.keys,this.overrides)}mergeContents(d,r){for(const o of Object.keys(r)){if(o in d&&E.isObject(d[o])&&E.isObject(r[o])){this.mergeContents(d[o],r[o]);continue}d[o]=C.deepClone(r[o])}}checkAndFreeze(d){return this.frozen&&!Object.isFrozen(d)?C.deepFreeze(d):d}getContentsForOverrideIdentifer(d){let r=null,o=null;const i=n=>{n&&(o?this.mergeContents(o,n):o=C.deepClone(n))};for(const n of this.overrides)u.equals(n.identifiers,[d])?r=n.contents:n.identifiers.includes(d)&&i(n.contents);return i(r),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(d,r){this.addKey(d),(0,R.addToValueTree)(this.contents,d,r,o=>{throw new Error(o)})}removeValue(d){this.removeKey(d)&&(0,R.removeFromValueTree)(this.contents,d)}addKey(d){let r=this.keys.length;for(let o=0;o<r;o++)d.indexOf(this.keys[o])===0&&(r=o);this.keys.splice(r,1,d)}removeKey(d){const r=this.keys.indexOf(d);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=T;class w{constructor(d){this._name=d,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new T}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(d,r){if(!E.isUndefinedOrNull(d)){const o=this.doParseContent(d);this.parseRaw(o,r)}}reparse(d){this._raw&&this.parseRaw(this._raw,d)}parseRaw(d,r){this._raw=d;const{contents:o,keys:i,overrides:n,restricted:s}=this.doParseRaw(d,r);this._configurationModel=new T(o,i,n),this._restrictedConfigurations=s||[]}doParseContent(d){let r={},o=null,i=[];const n=[],s=[];function l(S){Array.isArray(i)?i.push(S):o!==null&&(i[o]=S)}const h={onObjectBegin:()=>{const S={};l(S),n.push(i),i=S,o=null},onObjectProperty:S=>{o=S},onObjectEnd:()=>{i=n.pop()},onArrayBegin:()=>{const S=[];l(S),n.push(i),i=S,o=null},onArrayEnd:()=>{i=n.pop()},onLiteralValue:l,onError:(S,L,M)=>{s.push({error:S,offset:L,length:M})}};if(d)try{D.visit(d,h),r=i[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return r}doParseRaw(d,r){const o=_.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),i=this.filter(d,o,!0,r);d=i.raw;const n=(0,R.toValuesTree)(d,h=>console.error(`Conflict in settings file ${this._name}: ${h}`)),s=Object.keys(d),l=this.toOverrides(d,h=>console.error(`Conflict in settings file ${this._name}: ${h}`));return{contents:n,keys:s,overrides:l,restricted:i.restricted}}filter(d,r,o,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:d,restricted:[]};const n={},s=[];for(const l in d)if(k.OVERRIDE_PROPERTY_REGEX.test(l)&&o){const h=this.filter(d[l],r,!1,i);n[l]=h.raw,s.push(...h.restricted)}else{const h=r[l],S=h?typeof h.scope!="undefined"?h.scope:3:void 0;h?.restricted&&s.push(l),(S===void 0||i.scopes===void 0||i.scopes.includes(S))&&(i.skipRestricted&&h?.restricted||(n[l]=d[l]))}return{raw:n,restricted:s}}toOverrides(d,r){const o=[];for(const i of Object.keys(d))if(k.OVERRIDE_PROPERTY_REGEX.test(i)){const n={};for(const s in d[i])n[s]=d[i][s];o.push({identifiers:(0,k.overrideIdentifiersFromKey)(i),keys:Object.keys(n),contents:(0,R.toValuesTree)(n,r)})}return o}}e.ConfigurationModelParser=w;class b extends P.Disposable{constructor(d,r,o,i){super();this.userSettingsResource=d,this.scopes=r,this.fileService=i,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,n=>n.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,n=>(n.isOperation(0)||n.isOperation(3)||n.isOperation(1)||n.isOperation(4))&&o.isEqual(n.resource,d)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const d=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(d.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new T}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class g{constructor(d,r,o,i,n=new T,s=new T,l=new y.ResourceMap,h=new T,S=new y.ResourceMap,L=!0){this._defaultConfiguration=d,this._policyConfiguration=r,this._applicationConfiguration=o,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=s,this._folderConfigurations=l,this._memoryConfiguration=h,this._memoryConfigurationByResource=S,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new y.ResourceMap,this._userConfiguration=null}getValue(d,r,o){return this.getConsolidatedConfigurationModel(d,r,o).getValue(d)}updateValue(d,r,o={}){let i;o.resource?(i=this._memoryConfigurationByResource.get(o.resource),i||(i=new T,this._memoryConfigurationByResource.set(o.resource,i))):i=this._memoryConfiguration,r===void 0?i.removeValue(d):i.setValue(d,r),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(d,r,o){const i=this.getConsolidatedConfigurationModel(d,r,o),n=this.getFolderConfigurationModelForResource(r.resource,o),s=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,l=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(d):this._defaultConfiguration.freeze().getValue(d),h=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(d),S=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(d),L=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(d):this.userConfiguration.freeze().getValue(d),M=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(d):this.localUserConfiguration.freeze().getValue(d),F=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(d):this.remoteUserConfiguration.freeze().getValue(d),A=o?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(d):this._workspaceConfiguration.freeze().getValue(d):void 0,B=n?r.overrideIdentifier?n.freeze().override(r.overrideIdentifier).getValue(d):n.freeze().getValue(d):void 0,$=r.overrideIdentifier?s.override(r.overrideIdentifier).getValue(d):s.getValue(d),U=i.getValue(d),K=u.distinct(i.overrides.map(W=>W.identifiers).flat()).filter(W=>i.getOverrideValue(d,W)!==void 0);return{defaultValue:l,policyValue:h,applicationValue:S,userValue:L,userLocalValue:M,userRemoteValue:F,workspaceValue:A,workspaceFolderValue:B,memoryValue:$,value:U,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(d),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,policy:h!==void 0?{value:h}:void 0,application:S!==void 0?{value:S,override:r.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(d),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,userLocal:M!==void 0?{value:this.localUserConfiguration.freeze().getValue(d),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,userRemote:F!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(d),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(d),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,workspaceFolder:B!==void 0?{value:n?.freeze().getValue(d),override:r.overrideIdentifier?n?.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:s.getValue(d),override:r.overrideIdentifier?s.getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:K.length?K:void 0}}keys(d){const r=this.getFolderConfigurationModelForResource(void 0,d);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(d){this._defaultConfiguration=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(d){this._policyConfiguration=d}updateApplicationConfiguration(d){this._applicationConfiguration=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(d){this._localUserConfiguration=d,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(d){this._remoteUserConfiguration=d,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(d){this._workspaceConfiguration=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(d,r){this._folderConfigurations.set(d,r),this._foldersConsolidatedConfigurations.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this._foldersConsolidatedConfigurations.delete(d)}compareAndUpdateDefaultConfiguration(d,r){const o=[];if(!r){const{added:i,updated:n,removed:s}=c(this._defaultConfiguration,d);r=[...i,...n,...s]}for(const i of r)for(const n of(0,k.overrideIdentifiersFromKey)(i)){const s=this._defaultConfiguration.getKeysForOverrideIdentifier(n),l=d.getKeysForOverrideIdentifier(n),h=[...l.filter(S=>s.indexOf(S)===-1),...s.filter(S=>l.indexOf(S)===-1),...s.filter(S=>!C.equals(this._defaultConfiguration.override(n).getValue(S),d.override(n).getValue(S)))];o.push([n,h])}return this.updateDefaultConfiguration(d),{keys:r,overrides:o}}compareAndUpdatePolicyConfiguration(d){const{added:r,updated:o,removed:i}=c(this._policyConfiguration,d),n=[...r,...o,...i];return n.length&&this.updatePolicyConfiguration(d),{keys:n,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:r,updated:o,removed:i,overrides:n}=c(this.applicationConfiguration,d),s=[...r,...o,...i];return s.length&&this.updateApplicationConfiguration(d),{keys:s,overrides:n}}compareAndUpdateLocalUserConfiguration(d){const{added:r,updated:o,removed:i,overrides:n}=c(this.localUserConfiguration,d),s=[...r,...o,...i];return s.length&&this.updateLocalUserConfiguration(d),{keys:s,overrides:n}}compareAndUpdateRemoteUserConfiguration(d){const{added:r,updated:o,removed:i,overrides:n}=c(this.remoteUserConfiguration,d),s=[...r,...o,...i];return s.length&&this.updateRemoteUserConfiguration(d),{keys:s,overrides:n}}compareAndUpdateWorkspaceConfiguration(d){const{added:r,updated:o,removed:i,overrides:n}=c(this.workspaceConfiguration,d),s=[...r,...o,...i];return s.length&&this.updateWorkspaceConfiguration(d),{keys:s,overrides:n}}compareAndUpdateFolderConfiguration(d,r){const o=this.folderConfigurations.get(d),{added:i,updated:n,removed:s,overrides:l}=c(o,r),h=[...i,...n,...s];return(h.length||!o)&&this.updateFolderConfiguration(d,r),{keys:h,overrides:l}}compareAndDeleteFolderConfiguration(d){const r=this.folderConfigurations.get(d);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:o,updated:i,removed:n,overrides:s}=c(r,void 0);return{keys:[...o,...i,...n],overrides:s}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(d,r,o){let i=this.getConsolidatedConfigurationModelForResource(r,o);return r.overrideIdentifier&&(i=i.override(r.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(d)!==void 0&&(i=i.merge(this._policyConfiguration)),i}getConsolidatedConfigurationModelForResource({resource:d},r){let o=this.getWorkspaceConsolidatedConfiguration();if(r&&d){const i=r.getFolder(d);i&&(o=this.getFolderConsolidatedConfiguration(i.uri)||o);const n=this._memoryConfigurationByResource.get(d);n&&(o=o.merge(n))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(d){let r=this._foldersConsolidatedConfigurations.get(d);if(!r){const o=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(d);i?(r=o.merge(i),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(d,r)):r=o}return r}getFolderConfigurationModelForResource(d,r){if(r&&d){const o=r.getFolder(d);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((d,r)=>{const{contents:o,overrides:i,keys:n}=this._folderConfigurations.get(r);return d.push([r,{contents:o,overrides:i,keys:n}]),d},[])}}allKeys(){const d=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>d.add(r)),this.userConfiguration.freeze().keys.forEach(r=>d.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>d.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(o=>d.add(o))),[...d.values()]}allOverrideIdentifiers(){const d=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>d.add(r)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>d.add(r)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>d.add(r)),this._folderConfigurations.forEach(r=>r.freeze().getAllOverrideIdentifiers().forEach(o=>d.add(o))),[...d.values()]}getAllKeysForOverrideIdentifier(d){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(d).forEach(o=>r.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(o=>r.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(d).forEach(o=>r.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(d).forEach(i=>r.add(i))),[...r.values()]}static parse(d){const r=this.parseConfigurationModel(d.defaults),o=this.parseConfigurationModel(d.policy),i=this.parseConfigurationModel(d.application),n=this.parseConfigurationModel(d.user),s=this.parseConfigurationModel(d.workspace),l=d.folders.reduce((h,S)=>(h.set(I.URI.revive(S[0]),this.parseConfigurationModel(S[1])),h),new y.ResourceMap);return new g(r,o,i,n,new T,s,l,new T,new y.ResourceMap,!1)}static parseConfigurationModel(d){return new T(d.contents,d.keys,d.overrides).freeze()}}e.Configuration=g;function f(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const d=new Set,r=new Map;for(const i of a)i.keys.forEach(n=>d.add(n)),i.overrides.forEach(([n,s])=>{const l=(0,y.getOrSet)(r,n,new Set);s.forEach(h=>l.add(h))});const o=[];return r.forEach((i,n)=>o.push([n,[...i.values()]])),{keys:[...d.values()],overrides:o}}e.mergeChanges=f;class p{constructor(d,r,o,i){this.change=d,this.previous=r,this.currentConfiguraiton=o,this.currentWorkspace=i,this._previousConfiguration=void 0;const n=new Set;d.keys.forEach(l=>n.add(l)),d.overrides.forEach(([,l])=>l.forEach(h=>n.add(h))),this.affectedKeys=[...n.values()];const s=new T;this.affectedKeys.forEach(l=>s.setValue(l,{})),this.affectedKeysTree=s.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(d,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,d)){if(r){const o=this.previousConfiguration?this.previousConfiguration.getValue(d,r,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(d,r,this.currentWorkspace);return!C.equals(o,i)}return!0}return!1}doesAffectedKeysTreeContains(d,r){let o=(0,R.toValuesTree)({[r]:!0},()=>{}),i;for(;typeof o=="object"&&(i=Object.keys(o)[0]);){if(d=d[i],!d)return!1;o=o[i]}return!0}}e.ConfigurationChangeEvent=p;class v extends p{constructor(d,r,o,i){super({keys:d.allKeys(),overrides:[]},void 0,d,r);this.source=o,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=v;function c(a,d){const{added:r,removed:o,updated:i}=m(d,a),n=[],s=a?.getAllOverrideIdentifiers()||[],l=d?.getAllOverrideIdentifiers()||[];if(d){const h=l.filter(S=>!s.includes(S));for(const S of h)n.push([S,d.getKeysForOverrideIdentifier(S)])}if(a){const h=s.filter(S=>!l.includes(S));for(const S of h)n.push([S,a.getKeysForOverrideIdentifier(S)])}if(d&&a){for(const h of s)if(l.includes(h)){const S=m({contents:a.getOverrideValue(void 0,h)||{},keys:a.getKeysForOverrideIdentifier(h)},{contents:d.getOverrideValue(void 0,h)||{},keys:d.getKeysForOverrideIdentifier(h)});n.push([h,[...S.added,...S.removed,...S.updated]])}}return{added:r,removed:o,updated:i,overrides:n}}function m(a,d){const r=a?d?a.keys.filter(n=>d.keys.indexOf(n)===-1):[...a.keys]:[],o=d?a?d.keys.filter(n=>a.keys.indexOf(n)===-1):[...d.keys]:[],i=[];if(a&&d){for(const n of d.keys)if(a.keys.indexOf(n)!==-1){const s=(0,R.getConfigurationValue)(d.contents,n),l=(0,R.getConfigurationValue)(a.contents,n);C.equals(s,l)||i.push(n)}}return{added:r,removed:o,updated:i}}}),define(Ie[122],ke([1,0,12,4]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var D;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends u.ErrorNoTelemetry{constructor(C,E=D.Unknown,I){super(C);this._message=C,this._code=E,this._detail=I,this.isHandled=E===D.NotAvailable&&I===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}static isTemporarilyNotAvailable(C){return C instanceof P&&C._code===D.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof P&&C._code===D.NoResolverFound}static isHandled(C){return C instanceof P&&C.isHandled}}e.RemoteAuthorityResolverError=P}),define(Ie[123],ke([1,0,11]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(I){return I.scheme===u.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=t;function D(I){if(!I)return;const R=I.indexOf("+");return R<0?I:I.substr(0,R)}e.getRemoteName=D;function P(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=P;function y(I){const{host:R,port:k}=E(I);if(typeof k=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:k}}e.parseAuthorityWithPort=y;function C(I,R){let{host:k,port:_}=E(I);return typeof _=="undefined"&&(_=R),{host:k,port:_}}e.parseAuthorityWithOptionalPort=C;function E(I){const R=I.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const k=I.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const _=I.match(/(.*):(\d+)$/);return _?{host:_[1],port:parseInt(_[2],10)}:{host:I,port:void 0}}}),define(Ie[28],ke([1,0,8,4,123]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=P;function y(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));var E;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,g){if(typeof b=="undefined"||b===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof b=="string"||typeof g=="string"){const f=typeof b=="string"?b:b.value,p=typeof g=="string"?g:g.value;return u.equalsIgnoreCase(f,p)}return b._lower===g._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=I;function R(w){return k(w)}e.isApplicationScopedExtension=R;function k(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function _(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=_;function T(w,b){if(b){const g=`onResolveRemoteAuthority:${(0,D.getRemoteName)(b)}`;return w.activationEvents?.indexOf(g)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[200],ke([1,0,8,84,28,13,2,12,40]),function(Y,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(d,r){return d.uuid&&r.uuid?d.uuid===r.uuid:d.id===r.id?!0:(0,u.compareIgnoreCase)(d.id,r.id)===0}e.areSameExtensions=I;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{constructor(r,o,i="undefined"){this.version=o,this.targetPlatform=i,this.id=r.id}static create(r){const o=r.manifest?r.manifest.version:r.version,i=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new k(r.identifier,o,i)}static parse(r){const o=R.exec(r);return o&&o[1]&&o[2]?new k({id:o[1]},o[2],o[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof k?I(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.ExtensionKey=k;const _=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function T(d){const r=_.exec(d);return r&&r[1]?[b(r[1]),r[2]]:[b(d),void 0]}e.getIdAndVersion=T;function w(d,r){return`${d}.${r}`}e.getExtensionId=w;function b(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=b;function g(d,r){return b(w(d,r))}e.getGalleryExtensionId=g;function f(d,r){const o=[],i=n=>{for(const s of o)if(s.some(l=>I(r(l),r(n))))return s;return null};for(const n of d){const s=i(n);s?s.push(n):o.push([n])}return o}e.groupByExtension=f;function p(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function v(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function c(d,r){const o=[],i=r.manifest.extensionDependencies?.slice(0)??[];for(;i.length;){const n=i.shift();if(n&&o.every(s=>!I(s.identifier,{id:n}))){const s=d.filter(l=>I(l.identifier,{id:n}));s.length===1&&(o.push(s[0]),i.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=c;async function m(d,r){if(!P.isLinux)return!1;let o;try{o=(await d.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await d.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){r.debug("Error while getting the os-release file.",(0,C.getErrorMessage)(n))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=m;async function a(d,r){const o=await m(d,r),i=(0,t.getTargetPlatform)(o?"alpine":P.platform,E.arch);return r.debug("ComputeTargetPlatform:",i),i}e.computeTargetPlatform=a}),define(Ie[201],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class u{constructor(){this.validators=new Map}vsda(){return new Promise((D,P)=>Y(["vsda"],D,P))}async createNewMessage(D){try{const P=await this.vsda(),y=new P.validator;if(y){const C=String(u._nextId++);return this.validators.set(C,y),{id:C,data:y.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,P){if(!D.id)return!0;const y=this.validators.get(D.id);if(!y)return!1;this.validators.delete(D.id);try{return y.validate(P)==="ok"}catch{return!1}}async sign(D){try{const P=await this.vsda(),y=new P.signer;if(y)return y.sign(D)}catch{}return D}}e.SignService=u,u._nextId=1}),define(Ie[202],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class u{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,P,y=5){const C=P(E=>{const I=typeof E=="string"?E:E.data;let R=this._terminalBufferMap.get(D);if(R){R.data.push(I);return}const k=setTimeout(()=>this.flushBuffer(D),y);R={data:[I],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(D),C.dispose()}},this._terminalBufferMap.set(D,R)});return C}stopBuffering(D){const P=this._terminalBufferMap.get(D);P&&P.dispose()}flushBuffer(D){const P=this._terminalBufferMap.get(D);P&&(this._terminalBufferMap.delete(D),this._callback(D,P.data.join("")))}}e.TerminalDataBufferer=u}),define(Ie[203],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var u;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST_DARK="hcDark",P.HIGH_CONTRAST_LIGHT="hcLight"})(u=e.ColorScheme||(e.ColorScheme={}));function t(P){return P===u.HIGH_CONTRAST_DARK||P===u.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function D(P){return P===u.DARK||P===u.HIGH_CONTRAST_DARK}e.isDark=D}),define(Ie[86],ke([1,0,76,3,6,4,44,203]),function(Y,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var E;(function(g){function f(p){return p&&typeof p=="object"&&typeof p.id=="string"}g.isThemeColor=f})(E=e.ThemeColor||(e.ThemeColor={}));function I(g){return{id:g}}e.themeColorFromId=I;var R;(function(g){function f(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color=="undefined"||E.isThemeColor(o.color))}g.isThemeIcon=f;const p=new RegExp(`^\\$\\((${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?)\\)$`);function v(o){const i=p.exec(o);if(!i)return;const[,n]=i;return{id:n}}g.fromString=v;function c(o){return{id:o}}g.fromId=c;function m(o,i){let n=o.id;const s=n.lastIndexOf("~");return s!==-1&&(n=n.substring(0,s)),i&&(n=`${n}~${i}`),{id:n}}g.modify=m;function a(o){const i=o.id.lastIndexOf("~");if(i!==-1)return o.id.substring(i+1)}g.getModifier=a;function d(o,i){return o.id===i.id&&o.color?.id===i.color?.id}g.isEqual=d;function r(o,i){return{id:o.id,color:i?I(i):void 0}}g.asThemeIcon=r,g.asClassNameArray=u.CSSIcon.asClassNameArray,g.asClassName=u.CSSIcon.asClassName,g.asCSSSelector=u.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=u.Codicon.file,e.FolderThemeIcon=u.Codicon.folder;function k(g){switch(g){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case C.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class _{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(f){return this.themingParticipants.push(f),this.onThemingParticipantAddedEmitter.fire(f),(0,D.toDisposable)(()=>{const p=this.themingParticipants.indexOf(f);this.themingParticipants.splice(p,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const T=new _;y.Registry.add(e.Extensions.ThemingContribution,T);function w(g){return T.onColorThemeChange(g)}e.registerThemingParticipant=w;class b extends D.Disposable{constructor(f){super();this.themeService=f,this.theme=f.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(p=>this.onThemeChange(p)))}onThemeChange(f){this.theme=f,this.updateStyles()}updateStyles(){}getColor(f,p){let v=this.theme.getColor(f);return v&&p&&(v=p(v,this.theme)),v?v.toString():null}}e.Themable=b}),define(Ie[124],ke([1,0,3,13,4,14]),function(Y,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var y;(function(b){b.Http="http",b.Https="https"})(y=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(C=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(b){return e.LOCALHOST_ADDRESSES.indexOf(b)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(b){return e.ALL_INTERFACES_ADDRESSES.indexOf(b)>=0}e.isAllInterfaces=k;function _(b,g){return g?g!==1&&b<1024:!t.isWindows&&b<1024}e.isPortPrivileged=_;class T{constructor(g,f,p){this.remoteAddress=g,this.localAddress=f,this._dispose=p,this._onDispose=new u.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=T;let w=class{constructor(g){this.logService=g,this._onTunnelOpened=new u.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new u.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new u.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g){return this._tunnelProvider=g,g?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this._canElevate=g.elevation,this._privacyOptions=g.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],f=Array.from(this._tunnels.values());for(const p of f){const v=Array.from(p.values());for(const c of v){const m=await c.value;m&&g.push(m)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:f}of g.values())await f.then(p=>p?.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,f,p,v,c=!1,m,a){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${p} on local port ${v}.`),!g)return;if(f||(f="localhost"),this._tunnelProvider&&this._factoryInProgress.has(p)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const d=this.retainOrCreateTunnel(g,f,p,v,c,m,a);return d?d.then(r=>{if(!r){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,p);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(r);return(r.tunnelRemoteHost!==f||r.tunnelRemotePort!==p)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),d)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const f=this._tunnels.get(g.tunnelRemoteHost);if(f){const p=f.get(g.tunnelRemotePort);p&&(p.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,p))}}}}async tryDisposeTunnel(g,f,p){if(p.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${f}.`);const v=p.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(f),v}}async closeTunnel(g,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${f} `);const p=this._tunnels.get(g);if(p&&p.has(f)){const v=p.get(f);v.refcount=0,await this.tryDisposeTunnel(g,f,v)}}addTunnelToMap(g,f,p){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(f,{refcount:1,value:p})}async removeEmptyTunnelFromMap(g,f){const p=this._tunnels.get(g);p&&(await p.get(f)||p.delete(f),p.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,f){const p=[g];R(g)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):k(g)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const v=p.map(c=>this._tunnels.get(c));for(const c of v){const m=c?.get(f);if(m)return m}}canTunnel(g){return!!I(g)}createWithProvider(g,f,p,v,c,m,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${p} on local port ${v}.`);const d=p;this._factoryInProgress.add(d);const o={elevationRequired:c?_(v===void 0?p:v):!1},i={remoteAddress:{host:f,port:p},localAddressPort:v,privacy:m,public:m?m!==C.Private:void 0,protocol:a},n=g.forwardPort(i,o);return n?(this.addTunnelToMap(f,p,n),n.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(d)})):this._factoryInProgress.delete(d),n}};w=Ge([xe(0,P.ILogService)],w),e.AbstractTunnelService=w}),define(Ie[204],ke([1,0,11]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(E){return E.scheme!==u.Schemas.file&&E.scheme!==u.Schemas.vscodeRemote}e.isVirtualResource=t;function D(E){if(E.folders.length)return E.folders.every(I=>t(I.uri))?E.folders[0].uri:void 0;if(E.configuration&&t(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=D;function P(E){return D(E)?.scheme}e.getVirtualWorkspaceScheme=P;function y(E){return D(E)?.authority}e.getVirtualWorkspaceAuthority=y;function C(E){return D(E)!==void 0}e.isVirtualWorkspace=C}),define(Ie[45],ke([1,0,169,9,25,22,2,4,11]),function(Y,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");function I(r){const o=r;return typeof o?.id=="string"&&y.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=I;function R(r){if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=R;function k(r){const o=r;return typeof o?.id=="string"&&y.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=k;function _(r){const o=r;if(o?.uri)return{id:o.id,uri:y.URI.revive(o.uri)};const i=r;if(i?.configPath)return{id:i.id,configPath:y.URI.revive(i.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=_;var T;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function w(r){const o=r;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=w;function b(r){const o=r;return!!(o&&typeof o=="object"&&y.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=b;class g{constructor(o,i,n,s,l){this._id=o,this._transient=n,this._configuration=s,this._ignorePathCasing=l,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=i}update(o){this._id=o.id,this._configuration=o.configuration,this._transient=o.transient,this._ignorePathCasing=o._ignorePathCasing,this.folders=o.folders}get folders(){return this._folders}set folders(o){this._folders=o,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(o){this._configuration=o}getFolder(o){return o&&this._foldersMap.findSubstr(o)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const o of this.folders)this._foldersMap.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class f{constructor(o,i){this.raw=i,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,P.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function p(r){return new f({uri:r,index:0,name:(0,P.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,u.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(r,o){return P.extUriBiasedIgnorePathCase.isEqualOrParent(r,o.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function m(r){let o;return y.URI.isUri(r)?o=r:o=r.configuration,o?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=m;function a(r,o){return!c(r,o)&&!m(r)}e.isSavedWorkspace=a;function d(r){return(typeof r=="string"?(0,t.extname)(r):(0,P.extname)(r))===v}e.hasWorkspaceFileExtension=d}),define(Ie[87],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class u{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const P=this._idPool++;return this._data.set(P,D),this.logDebugInfo(),P}get(D,P){return this._data.has(D)?this._data.get(D)[P]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!u.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=u,u.enableDebugLogging=!1}),define(Ie[46],ke([1,0,11,22,4]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(u.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(C=>{const E=this._providerInfo.get(C.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(C,E){E===null?this._providerInfo.delete(C.scheme):this._providerInfo.set(C.scheme,E)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[26],ke([1,0,4]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,u.createDecorator)("IExtHostInitDataService")}),define(Ie[205],ke([1,0,18]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(y,C,E){this._deferredPromises=new Map,this._id=y,this._shared=C,this._storage=E,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new u.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of I.values())R.complete()}catch(R){for(const k of I.values())k.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,y])=>y!==void 0).map(([y])=>y)}get whenReady(){return this._init}get(y,C){let E=this._value[y];return typeof E=="undefined"&&(E=C),E}update(y,C){this._value[y]=C;const E=this._deferredPromises.get(y);if(E!==void 0)return E.p;const I=new u.DeferredPromise;return this._deferredPromises.set(y,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class D extends t{constructor(y,C){super(y.identifier.value,!0,C);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=D}),define(Ie[206],ke([1,0,3,2]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(y){this._notebooksAndEditors=y,this._onDidSaveNotebookDocument=new u.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new u.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(y,C,E,I){const k=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y)).acceptModelChanged(C.value,E,I);this._onDidChangeNotebookDocument.fire(k)}$acceptDirtyStateChanged(y,C){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y)).acceptDirty(C)}$acceptModelSaved(y){const C=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(y));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(Ie[17],ke([1,0,4]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,u.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t});var tt=this&&this.__classPrivateFieldSet||function(Y,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Y,u):D?D.value=u:e.set(Y,u),u},Me=this&&this.__classPrivateFieldGet||function(Y,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!t:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Y):t?t.value:e.get(Y)};define(Ie[207],ke([1,0,28,3]),function(Y,e,u,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(C,E){D.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=u.ExtensionIdentifier.toKey(C.identifier),tt(this,D,E,"f"),Me(this,D,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(C){return Me(this,D,"f").get(this._id,C)}store(C,E){return Me(this,D,"f").store(this._id,C,E)}delete(C){return Me(this,D,"f").delete(this._id,C)}}e.ExtensionSecrets=P,D=new WeakMap}),define(Ie[125],ke([1,0,4,3]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(y,C){this._level=y,this._productConfig=C||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(y){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=y,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,u.createDecorator)("IExtHostTelemetry")}),define(Ie[52],ke([1,0,4,124,3,17]),function(Y,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var y;(function(E){function I(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:k.protocol}}E.fromApiTunnel=I;function R(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==t.TunnelPrivacyId.ConstantPrivate&&k.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}E.fromServiceTunnel=R})(y=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,u.createDecorator)("IExtHostTunnelService");let C=class{constructor(I){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,R){}async getTunnels(){return[]}async setTunnelFactory(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,R){return{dispose:()=>{}}}async $providePortAttributes(I,R,k,_,T){return[]}async $forwardPort(I,R){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};C=Ge([xe(0,P.IExtHostRpcService)],C),e.ExtHostTunnelService=C});var tt=this&&this.__classPrivateFieldSet||function(Y,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Y,u):D?D.value=u:e.set(Y,u),u},Me=this&&this.__classPrivateFieldGet||function(Y,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!t:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Y):t?t.value:e.get(Y)};define(Ie[7],ke([1,0,16,12,106,25,101,8,10,2,34,43,122]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_){"use strict";var T,w,b,g,f,p,v,c,m,a,d,r,o,i,n,s,l,h,S,L,M,F,A;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function B(j){function z(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(z,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(z,j),Object.setPrototypeOf(z.prototype,j.prototype),z}let $=p=class{constructor(z){T.set(this,void 0),tt(this,T,z,"f")}static from(...z){let se=z;return new p(function(){if(se){for(const Re of se)Re&&typeof Re.dispose=="function"&&Re.dispose();se=void 0}})}dispose(){typeof Me(this,T,"f")=="function"&&(Me(this,T,"f").call(this),tt(this,T,void 0,"f"))}};T=new WeakMap,$=p=Ge([B],$),e.Disposable=$;let U=v=class{constructor(z,se){if(z<0)throw(0,t.illegalArgument)("line must be non-negative");if(se<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=z,this._character=se}static Min(...z){if(z.length===0)throw new TypeError;let se=z[0];for(let Re=1;Re<z.length;Re++){const Qe=z[Re];Qe.isBefore(se)&&(se=Qe)}return se}static Max(...z){if(z.length===0)throw new TypeError;let se=z[0];for(let Re=1;Re<z.length;Re++){const Qe=z[Re];Qe.isAfter(se)&&(se=Qe)}return se}static isPosition(z){if(!z)return!1;if(z instanceof v)return!0;const{line:se,character:Re}=z;return typeof se=="number"&&typeof Re=="number"}static of(z){if(z instanceof v)return z;if(this.isPosition(z))return new v(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<z._character}isBeforeOrEqual(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<=z._character}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this._line===z._line&&this._character===z._character}compareTo(z){return this._line<z._line?-1:this._line>z.line?1:this._character<z._character?-1:this._character>z._character?1:0}translate(z,se=0){if(z===null||se===null)throw(0,t.illegalArgument)();let Re;return typeof z=="undefined"?Re=0:typeof z=="number"?Re=z:(Re=typeof z.lineDelta=="number"?z.lineDelta:0,se=typeof z.characterDelta=="number"?z.characterDelta:0),Re===0&&se===0?this:new v(this.line+Re,this.character+se)}with(z,se=this.character){if(z===null||se===null)throw(0,t.illegalArgument)();let Re;return typeof z=="undefined"?Re=this.line:typeof z=="number"?Re=z:(Re=typeof z.line=="number"?z.line:this.line,se=typeof z.character=="number"?z.character:this.character),Re===this.line&&se===this.character?this:new v(Re,se)}toJSON(){return{line:this.line,character:this.character}}};U=v=Ge([B],U),e.Position=U;let K=c=class{constructor(z,se,Re,Qe){let rt,lt;if(typeof z=="number"&&typeof se=="number"&&typeof Re=="number"&&typeof Qe=="number"?(rt=new U(z,se),lt=new U(Re,Qe)):U.isPosition(z)&&U.isPosition(se)&&(rt=U.of(z),lt=U.of(se)),!rt||!lt)throw new Error("Invalid arguments");rt.isBefore(lt)?(this._start=rt,this._end=lt):(this._start=lt,this._end=rt)}static isRange(z){return z instanceof c?!0:z?U.isPosition(z.start)&&U.isPosition(z.end):!1}static of(z){if(z instanceof c)return z;if(this.isRange(z))return new c(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(z){return c.isRange(z)?this.contains(z.start)&&this.contains(z.end):U.isPosition(z)?!(U.of(z).isBefore(this._start)||this._end.isBefore(z)):!1}isEqual(z){return this._start.isEqual(z._start)&&this._end.isEqual(z._end)}intersection(z){const se=U.Max(z.start,this._start),Re=U.Min(z.end,this._end);if(!se.isAfter(Re))return new c(se,Re)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const se=U.Min(z.start,this._start),Re=U.Max(z.end,this.end);return new c(se,Re)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(z,se=this.end){if(z===null||se===null)throw(0,t.illegalArgument)();let Re;return z?U.isPosition(z)?Re=z:(Re=z.start||this.start,se=z.end||this.end):Re=this.start,Re.isEqual(this._start)&&se.isEqual(this.end)?this:new c(Re,se)}toJSON(){return[this.start,this.end]}};K=c=Ge([B],K),e.Range=K;let W=m=class extends K{constructor(z,se,Re,Qe){let rt,lt;if(typeof z=="number"&&typeof se=="number"&&typeof Re=="number"&&typeof Qe=="number"?(rt=new U(z,se),lt=new U(Re,Qe)):U.isPosition(z)&&U.isPosition(se)&&(rt=U.of(z),lt=U.of(se)),!rt||!lt)throw new Error("Invalid arguments");super(rt,lt);this._anchor=rt,this._active=lt}static isSelection(z){return z instanceof m?!0:z?K.isRange(z)&&U.isPosition(z.anchor)&&U.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};W=m=Ge([B],W),e.Selection=W;class N{constructor(z,se,Re){if(typeof z!="string"||z.length===0)throw(0,t.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,t.illegalArgument)("port");if(typeof Re!="undefined"&&(typeof Re!="string"||Re.length===0||!/^[0-9A-Za-z\-]+$/.test(Re)))throw(0,t.illegalArgument)("connectionToken");this.host=z,this.port=Math.round(se),this.connectionToken=Re}}e.ResolvedAuthority=N;class V extends Error{constructor(z,se=_.RemoteAuthorityResolverErrorCode.Unknown,Re){super(z);this._message=z,this._code=se,this._detail=Re,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(z,se){return new V(z,_.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(z){return new V(z,_.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var x;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(x=e.EndOfLine||(e.EndOfLine={}));var q;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(q=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let te=a=class{constructor(z,se){this._range=z,this._newText=se}static isTextEdit(z){return z instanceof a?!0:z?K.isRange(z)&&typeof z.newText=="string":!1}static replace(z,se){return new a(z,se)}static insert(z,se){return a.replace(new K(z,z),se)}static delete(z){return a.replace(z,"")}static setEndOfLine(z){const se=new a(new K(new U(0,0),new U(0,0)),"");return se.newEol=z,se}get range(){return this._range}set range(z){if(z&&!K.isRange(z))throw(0,t.illegalArgument)("range");this._range=z}get newText(){return this._newText||""}set newText(z){if(z&&typeof z!="string")throw(0,t.illegalArgument)("newText");this._newText=z}get newEol(){return this._newEol}set newEol(z){if(z&&typeof z!="number")throw(0,t.illegalArgument)("newEol");this._newEol=z}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};te=a=Ge([B],te),e.TextEdit=te;let Q=d=class{constructor(z,se){this.range=z,this.newCells=se}static isNotebookCellEdit(z){return z instanceof d?!0:z?zt.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,se){return new d(z,se)}static insertCells(z,se){return new d(new zt(z,z),se)}static deleteCells(z){return new d(z,[])}static updateCellMetadata(z,se){const Re=new d(new zt(z,z),[]);return Re.newCellMetadata=se,Re}static updateNotebookMetadata(z){const se=new d(new zt(0,0),[]);return se.newNotebookMetadata=z,se}};Q=d=Ge([B],Q),e.NotebookEdit=Q;var le;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(le=e.FileEditType||(e.FileEditType={}));let pe=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(z,se,Re,Qe){this._edits.push({_type:1,from:z,to:se,options:Re,metadata:Qe})}createFile(z,se,Re){this._edits.push({_type:1,from:void 0,to:z,options:se,metadata:Re})}deleteFile(z,se,Re){this._edits.push({_type:1,from:z,to:void 0,options:se,metadata:Re})}replaceNotebookMetadata(z,se,Re){this._edits.push({_type:3,metadata:Re,uri:z,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(z,se,Re,Qe,rt){let lt,ut,Ct=[],Rt;if(zt.isNotebookRange(se)&&Vt.isNotebookCellDataArray(Re)&&!Vt.isNotebookCellDataArray(Qe)?(lt=se.start,ut=se.end,Ct=Re,Rt=Qe):typeof se=="number"&&typeof Re=="number"&&Vt.isNotebookCellDataArray(Qe)&&(lt=se,ut=Re,Ct=Qe,Rt=rt),lt===void 0||ut===void 0)throw new Error("Invalid arguments");(lt!==ut||Ct.length>0)&&this._edits.push({_type:5,uri:z,index:lt,count:ut-lt,cells:Ct,metadata:Rt})}replaceNotebookCellMetadata(z,se,Re,Qe){this._edits.push({_type:3,metadata:Qe,uri:z,edit:{editType:8,index:se,metadata:Re}})}replace(z,se,Re,Qe){typeof Re=="string"?this._edits.push({_type:2,uri:z,edit:new te(se,Re),metadata:Qe}):this._edits.push({_type:6,uri:z,range:se,edit:Re,metadata:Qe})}insert(z,se,Re,Qe){this.replace(z,new K(se,se),Re,Qe)}delete(z,se,Re){this.replace(z,se,"",Re)}has(z){return this._edits.some(se=>se._type===2&&se.uri.toString()===z.toString())}set(z,se){if(se)for(const Re of se)Re&&(Q.isNotebookCellEdit(Re)?Re.newCellMetadata?this.replaceNotebookCellMetadata(z,Re.range.start,Re.newCellMetadata):Re.newNotebookMetadata?this.replaceNotebookMetadata(z,Re.newNotebookMetadata):this.replaceNotebookCells(z,Re.range,Re.newCells):this._edits.push({_type:2,uri:z,edit:Re}));else{for(let Re=0;Re<this._edits.length;Re++){const Qe=this._edits[Re];Qe._type===2&&Qe.uri.toString()===z.toString()&&(this._edits[Re]=void 0)}(0,u.coalesceInPlace)(this._edits)}}get(z){const se=[];for(const Re of this._edits)Re._type===2&&Re.uri.toString()===z.toString()&&se.push(Re.edit);return se}entries(){const z=new P.ResourceMap;for(const se of this._edits)if(se._type===2){let Re=z.get(se.uri);Re||(Re=[se.uri,[]],z.set(se.uri,Re)),Re[1].push(se.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};pe=Ge([B],pe),e.WorkspaceEdit=pe;let Z=r=class{constructor(z){this._tabstop=1,this.value=z||""}static isSnippetString(z){return z instanceof r?!0:z?typeof z.value=="string":!1}static _escape(z){return z.replace(/\$|}|\\/g,"\\$&")}appendText(z){return this.value+=r._escape(z),this}appendTabstop(z=this._tabstop++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,se=this._tabstop++){if(typeof z=="function"){const Re=new r;Re._tabstop=this._tabstop,z(Re),this._tabstop=Re._tabstop,z=Re.value}else z=r._escape(z);return this.value+="${",this.value+=se,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,se=this._tabstop++){const Re=z.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(z,se){if(typeof se=="function"){const Re=new r;Re._tabstop=this._tabstop,se(Re),this._tabstop=Re._tabstop,se=Re.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,se&&(this.value+=":",this.value+=se),this.value+="}",this}};Z=r=Ge([B],Z),e.SnippetString=Z;var ge;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(ge=e.DiagnosticTag||(e.DiagnosticTag={}));var Ee;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(Ee=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Te=o=class{constructor(z,se){if(this.uri=z,se)if(K.isRange(se))this.range=K.of(se);else if(U.isPosition(se))this.range=new K(se,se);else throw new Error("Illegal argument")}static isLocation(z){return z instanceof o?!0:z?K.isRange(z.range)&&I.URI.isUri(z.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Te=o=Ge([B],Te),e.Location=Te;let Oe=class{constructor(z,se){this.location=z,this.message=se}static is(z){return z?typeof z.message=="string"&&z.location&&K.isRange(z.location.range)&&I.URI.isUri(z.location.uri):!1}static isEqual(z,se){return z===se?!0:!z||!se?!1:z.message===se.message&&z.location.range.isEqual(se.location.range)&&z.location.uri.toString()===se.location.uri.toString()}};Oe=Ge([B],Oe),e.DiagnosticRelatedInformation=Oe;let ve=class{constructor(z,se,Re=Ee.Error){if(!K.isRange(z))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=z,this.message=se,this.severity=Re}toJSON(){return{severity:Ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,se){return z===se?!0:!z||!se?!1:z.message===se.message&&z.severity===se.severity&&z.code===se.code&&z.severity===se.severity&&z.source===se.source&&z.range.isEqual(se.range)&&(0,u.equals)(z.tags,se.tags)&&(0,u.equals)(z.relatedInformation,se.relatedInformation,Oe.isEqual)}};ve=Ge([B],ve),e.Diagnostic=ve;let ue=class{constructor(z,se){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=se}};ue=Ge([B],ue),e.Hover=ue;var de;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(de=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let we=class{constructor(z,se=de.Text){this.range=z,this.kind=se}toJSON(){return{range:this.range,kind:de[this.kind]}}};we=Ge([B],we),e.DocumentHighlight=we;var ie;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(ie=e.SymbolKind||(e.SymbolKind={}));var me;(function(j){j[j.Deprecated=1]="Deprecated"})(me=e.SymbolTag||(e.SymbolTag={}));let J=i=class{constructor(z,se,Re,Qe,rt){this.name=z,this.kind=se,this.containerName=rt,typeof Re=="string"&&(this.containerName=Re),Qe instanceof Te?this.location=Qe:Re instanceof K&&(this.location=new Te(Qe,Re)),i.validate(this)}static validate(z){if(!z.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ie[this.kind],location:this.location,containerName:this.containerName}}};J=i=Ge([B],J),e.SymbolInformation=J;let re=n=class{constructor(z,se,Re,Qe,rt){this.name=z,this.detail=se,this.kind=Re,this.range=Qe,this.selectionRange=rt,this.children=[],n.validate(this)}static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(n.validate)}};re=n=Ge([B],re),e.DocumentSymbol=re;var O;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(O=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let H=class{constructor(z,se){this.title=z,this.kind=se}};H=Ge([B],H),e.CodeAction=H;let G=s=class{constructor(z){this.value=z}append(z){return new s(this.value?this.value+s.sep+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+s.sep)}};G.sep=".",G=s=Ge([B],G),e.CodeActionKind=G,G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll");let X=class{constructor(z,se){if(this.range=z,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};X=Ge([B],X),e.SelectionRange=X;class he{constructor(z,se,Re,Qe,rt,lt){this.kind=z,this.name=se,this.detail=Re,this.uri=Qe,this.range=rt,this.selectionRange=lt}}e.CallHierarchyItem=he;class be{constructor(z,se){this.fromRanges=se,this.from=z}}e.CallHierarchyIncomingCall=be;class ae{constructor(z,se){this.fromRanges=se,this.to=z}}e.CallHierarchyOutgoingCall=ae;var De;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(De=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ce=class{constructor(z,se){this.range=z,this.command=se}get isResolved(){return!!this.command}};Ce=Ge([B],Ce),e.CodeLens=Ce;let ze=l=class{constructor(z,se=!1){w.set(this,void 0),tt(this,w,new D.MarkdownString(z,{supportThemeIcons:se}),"f")}static isMarkdownString(z){return z instanceof l?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}get value(){return Me(this,w,"f").value}set value(z){Me(this,w,"f").value=z}get isTrusted(){return Me(this,w,"f").isTrusted}set isTrusted(z){Me(this,w,"f").isTrusted=z}get supportThemeIcons(){return Me(this,w,"f").supportThemeIcons}set supportThemeIcons(z){Me(this,w,"f").supportThemeIcons=z}get supportHtml(){return Me(this,w,"f").supportHtml}set supportHtml(z){Me(this,w,"f").supportHtml=z}get baseUri(){return Me(this,w,"f").baseUri}set baseUri(z){Me(this,w,"f").baseUri=z}appendText(z){return Me(this,w,"f").appendText(z),this}appendMarkdown(z){return Me(this,w,"f").appendMarkdown(z),this}appendCodeblock(z,se){return Me(this,w,"f").appendCodeblock(se??"",z),this}};w=new WeakMap,ze=l=Ge([B],ze),e.MarkdownString=ze;let Ke=class{constructor(z,se){this.label=z,this.documentation=se}};Ke=Ge([B],Ke),e.ParameterInformation=Ke;let Ne=class{constructor(z,se){this.label=z,this.documentation=se,this.parameters=[]}};Ne=Ge([B],Ne),e.SignatureInformation=Ne;let Ye=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ye=Ge([B],Ye),e.SignatureHelp=Ye;var ee;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(ee=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var oe;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(oe=e.InlayHintKind||(e.InlayHintKind={}));let ye=class{constructor(z){this.value=z}};ye=Ge([B],ye),e.InlayHintLabelPart=ye;let We=class{constructor(z,se,Re){this.position=z,this.label=se,this.kind=Re}};We=Ge([B],We),e.InlayHint=We;var ce;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ae;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Ae=e.CompletionItemKind||(e.CompletionItemKind={}));var Be;(function(j){j[j.Deprecated=1]="Deprecated"})(Be=e.CompletionItemTag||(e.CompletionItemTag={}));let qe=class{constructor(z,se){this.label=z,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&Ae[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};qe=Ge([B],qe),e.CompletionItem=qe;let je=class{constructor(z=[],se=!1){this.items=z,this.isIncomplete=se}};je=Ge([B],je),e.CompletionList=je;let Ve=class{constructor(z,se,Re){this.insertText=z,this.range=se,this.command=Re}};Ve=Ge([B],Ve),e.InlineSuggestion=Ve;let nt=class{constructor(z){this.commands=void 0,this.items=z}};nt=Ge([B],nt),e.InlineSuggestionList=nt;let ot=class{constructor(z,se,Re){this.insertText=z,this.range=se,this.command=Re}};ot=Ge([B],ot),e.InlineSuggestionNew=ot;let st=class{constructor(z,se){this.items=z,this.commands=se}};st=Ge([B],st),e.InlineSuggestionsNew=st;var it;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(it=e.ViewColumn||(e.ViewColumn={}));var at;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(at=e.StatusBarAlignment||(e.StatusBarAlignment={}));var vt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(vt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Pt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var yt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(yt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ft;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var kt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(kt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Mt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Mt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function z(se){switch(se){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=z}(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Lt=class{constructor(z,se){if(se&&!I.URI.isUri(se))throw(0,t.illegalArgument)("target");if(!K.isRange(z)||z.isEmpty)throw(0,t.illegalArgument)("range");this.range=z,this.target=se}};Lt=Ge([B],Lt),e.DocumentLink=Lt;let Xe=class{constructor(z,se,Re,Qe){this.red=z,this.green=se,this.blue=Re,this.alpha=Qe}};Xe=Ge([B],Xe),e.Color=Xe;let At=class{constructor(z,se){if(se&&!(se instanceof Xe))throw(0,t.illegalArgument)("color");if(!K.isRange(z)||z.isEmpty)throw(0,t.illegalArgument)("range");this.range=z,this.color=se}};At=Ge([B],At),e.ColorInformation=At;let Nt=class{constructor(z){if(!z||typeof z!="string")throw(0,t.illegalArgument)("label");this.label=z}};Nt=Ge([B],Nt),e.ColorPresentation=Nt;var Ot;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Ot=e.ColorFormat||(e.ColorFormat={}));var gt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(gt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Dt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(Dt=e.TerminalExitReason||(e.TerminalExitReason={}));class Pe{constructor(z,se,Re){if(this.startIndex=z,this.length=se,this.tooltip=Re,typeof z!="number"||z<0)throw(0,t.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,t.illegalArgument)("length");if(Re!==void 0&&typeof Re!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Pe;var Le;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Le=e.TerminalLocation||(e.TerminalLocation={}));class Se{constructor(z){if(this.options=z,typeof z!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Se;var ne;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ne=e.TaskRevealKind||(e.TaskRevealKind={}));var Fe;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Fe=e.TaskPanelKind||(e.TaskPanelKind={}));let He=h=class{constructor(z,se){if(this.label=se,typeof z!="string"||typeof se!="string")throw(0,t.illegalArgument)("name");this._id=z}static from(z){switch(z){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}get id(){return this._id}};He.Clean=new h("clean","Clean"),He.Build=new h("build","Build"),He.Rebuild=new h("rebuild","Rebuild"),He.Test=new h("test","Test"),He=h=Ge([B],He),e.TaskGroup=He;function et(j){let z="";for(let se=0;se<j.length;se++)z+=j[se].replace(/,/g,",,")+",";return z}let Ze=class{constructor(z,se,Re){if(typeof z!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=z,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=Re):this._options=se)}get process(){return this._process}set process(z){if(typeof z!="string")throw(0,t.illegalArgument)("process");this._process=z}get args(){return this._args}set args(z){Array.isArray(z)||(z=[]),this._args=z}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("process"),this._process!==void 0&&z.push(this._process),this._args&&this._args.length>0)for(const se of this._args)z.push(se);return et(z)}};Ze=Ge([B],Ze),e.ProcessExecution=Ze;let Je=class{constructor(z,se,Re){if(this._args=[],Array.isArray(se)){if(!z)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,t.illegalArgument)("command");this._command=z,this._args=se,this._options=Re}else{if(typeof z!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=z,this._options=se}}get commandLine(){return this._commandLine}set commandLine(z){if(typeof z!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=z}get command(){return this._command?this._command:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,t.illegalArgument)("command");this._command=z}get args(){return this._args}set args(z){this._args=z||[]}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("shell"),this._commandLine!==void 0&&z.push(this._commandLine),this._command!==void 0&&z.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const se of this._args)z.push(typeof se=="string"?se:se.value);return et(z)}};Je=Ge([B],Je),e.ShellExecution=Je;var bt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(bt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class St{constructor(z){this._callback=z}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(z){this._callback=z}get callback(){return this._callback}}e.CustomExecution=St;let mt=S=class{constructor(z,se,Re,Qe,rt,lt){this.__deprecated=!1,this._definition=this.definition=z;let ut;typeof se=="string"?(this._name=this.name=se,this._source=this.source=Re,this.execution=Qe,ut=rt,this.__deprecated=!0):se===Et.Global||se===Et.Workspace?(this.target=se,this._name=this.name=Re,this._source=this.source=Qe,this.execution=rt,ut=lt):(this.target=se,this._name=this.name=Re,this._source=this.source=Qe,this.execution=rt,ut=lt),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(z){this.__id=z}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ze?this._definition={type:S.ProcessType,id:this._execution.computeId()}:this._execution instanceof Je?this._definition={type:S.ShellType,id:this._execution.computeId()}:this._execution instanceof St?this._definition={type:S.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:S.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(z){if(z==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=z}get scope(){return this._scope}set target(z){this.clear(),this._scope=z}get name(){return this._name}set name(z){if(typeof z!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=z}get execution(){return this._execution}set execution(z){z===null&&(z=void 0),this.clear(),this._execution=z;const se=this._definition.type;(S.EmptyType===se||S.ProcessType===se||S.ShellType===se||S.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(z){if(Array.isArray(z))this.clear(),this._problemMatchers=z,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.clear(),this._isBackground=z}get source(){return this._source}set source(z){if(typeof z!="string"||z.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=z}get group(){return this._group}set group(z){z===null&&(z=void 0),this.clear(),this._group=z}get detail(){return this._detail}set detail(z){z===null&&(z=void 0),this._detail=z}get presentationOptions(){return this._presentationOptions}set presentationOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._presentationOptions=z}get runOptions(){return this._runOptions}set runOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._runOptions=z}};mt.ExtensionCallbackType="customExecution",mt.ProcessType="process",mt.ShellType="shell",mt.EmptyType="$empty",mt=S=Ge([B],mt),e.Task=mt;var ht;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(ht=e.ProgressLocation||(e.ProgressLocation={}));let Yt=L=class{constructor(z,se=qt.None){this.collapsibleState=se,I.URI.isUri(z)?this.resourceUri=z:this.label=z}static isTreeItem(z){if(z instanceof L)return!0;const se=z;return se.label!==void 0&&!(0,E.isString)(se.label)&&!se.label.label?(console.log("INVALID tree item, invalid label",se.label),!1):se.id!==void 0&&!(0,E.isString)(se.id)?(console.log("INVALID tree item, invalid id",se.id),!1):se.iconPath!==void 0&&!(0,E.isString)(se.iconPath)&&!I.URI.isUri(se.iconPath)&&!(0,E.isString)(se.iconPath.id)?(console.log("INVALID tree item, invalid iconPath",se.iconPath),!1):se.description!==void 0&&!(0,E.isString)(se.description)&&typeof se.description!="boolean"?(console.log("INVALID tree item, invalid description",se.description),!1):se.resourceUri!==void 0&&!I.URI.isUri(se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",se.resourceUri),!1):se.tooltip!==void 0&&!(0,E.isString)(se.tooltip)&&!(se.tooltip instanceof ze)?(console.log("INVALID tree item, invalid tooltip",se.tooltip),!1):se.command!==void 0&&!se.command.command?(console.log("INVALID tree item, invalid command",se.command),!1):se.collapsibleState!==void 0&&se.collapsibleState<qt.None&&se.collapsibleState>qt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",se.collapsibleState),!1):se.contextValue!==void 0&&!(0,E.isString)(se.contextValue)?(console.log("INVALID tree item, invalid contextValue",se.contextValue),!1):se.accessibilityInformation!==void 0&&!se.accessibilityInformation.label?(console.log("INVALID tree item, invalid accessibilityInformation",se.accessibilityInformation),!1):!0}};Yt=L=Ge([B],Yt),e.TreeItem=Yt;var qt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(qt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let wt=class{constructor(z){this.value=z}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};wt=Ge([B],wt),e.DataTransferItem=wt;let $t=class{constructor(z){b.set(this,new Map);for(const[se,Re]of z??[]){const Qe=Me(this,b,"f").get(se);Qe?Qe.push(Re):Me(this,b,"f").set(se,[Re])}}get(z){return Me(this,b,"f").get(z)?.[0]}set(z,se){Me(this,b,"f").set(z,[se])}forEach(z,se){for(const[Re,Qe]of Me(this,b,"f"))for(const rt of Qe)z.call(se,rt,Re,this)}*[(b=new WeakMap,Symbol.iterator)](){for(const[z,se]of Me(this,b,"f"))for(const Re of se)yield[z,Re]}};$t=Ge([B],$t),e.DataTransfer=$t;let nn=class{constructor(z){this.insertText=z}};nn=Ge([B],nn),e.DocumentDropEdit=nn;let rn=class{constructor(z){this.insertText=z}};rn=Ge([B],rn),e.DocumentPasteEdit=rn;let Ht=class{constructor(z,se){this.id=z,this.color=se}};Ht=Ge([B],Ht),e.ThemeIcon=Ht,Ht.File=new Ht("file"),Ht.Folder=new Ht("folder");let Tt=class{constructor(z){this.id=z}};Tt=Ge([B],Tt),e.ThemeColor=Tt;var Sn;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Sn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let fn=class{constructor(z,se){if(typeof z!="string"&&(!z||!I.URI.isUri(z)&&!I.URI.isUri(z.uri)))throw(0,t.illegalArgument)("base");if(typeof se!="string")throw(0,t.illegalArgument)("pattern");typeof z=="string"?this.baseUri=I.URI.file(z):I.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=se}get base(){return this._base}set base(z){this._base=z,this._baseUri=I.URI.file(z)}get baseUri(){return this._baseUri}set baseUri(z){this._baseUri=z,this._base=z.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};fn=Ge([B],fn),e.RelativePattern=fn;let Ut=class{constructor(z,se,Re,Qe){this.enabled=typeof z=="boolean"?z:!0,typeof se=="string"&&(this.condition=se),typeof Re=="string"&&(this.hitCondition=Re),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Ut=Ge([B],Ut),e.Breakpoint=Ut;let Jt=class extends Ut{constructor(z,se,Re,Qe,rt){super(se,Re,Qe,rt);if(z===null)throw(0,t.illegalArgument)("location");this.location=z}};Jt=Ge([B],Jt),e.SourceBreakpoint=Jt;let dt=class extends Ut{constructor(z,se,Re,Qe,rt){super(se,Re,Qe,rt);this.functionName=z}};dt=Ge([B],dt),e.FunctionBreakpoint=dt;let mn=class extends Ut{constructor(z,se,Re,Qe,rt,lt,ut){super(Qe,rt,lt,ut);if(!se)throw(0,t.illegalArgument)("dataId");this.label=z,this.dataId=se,this.canPersist=Re}};mn=Ge([B],mn),e.DataBreakpoint=mn;let Bt=class{constructor(z,se,Re){this.command=z,this.args=se||[],this.options=Re}};Bt=Ge([B],Bt),e.DebugAdapterExecutable=Bt;let Gt=class{constructor(z,se){this.port=z,this.host=se}};Gt=Ge([B],Gt),e.DebugAdapterServer=Gt;let sn=class{constructor(z){this.path=z}};sn=Ge([B],sn),e.DebugAdapterNamedPipeServer=sn;let gn=class{constructor(z){this.implementation=z}};gn=Ge([B],gn),e.DebugAdapterInlineImplementation=gn;let on=class{constructor(z,se){this.range=z,this.expression=se}};on=Ge([B],on),e.EvaluatableExpression=on;var Pn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Pn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var yn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(yn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let Zt=class{constructor(z,se){this.range=z,this.text=se}};Zt=Ge([B],Zt),e.InlineValueText=Zt;let pn=class{constructor(z,se,Re=!0){this.range=z,this.variableName=se,this.caseSensitiveLookup=Re}};pn=Ge([B],pn),e.InlineValueVariableLookup=pn;let en=class{constructor(z,se){this.range=z,this.expression=se}};en=Ge([B],en),e.InlineValueEvaluatableExpression=en;let tn=class{constructor(z,se){this.frameId=z,this.stoppedLocation=se}};tn=Ge([B],tn),e.InlineValueContext=tn;var An;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(An=e.FileChangeType||(e.FileChangeType={}));let vn=M=class extends Error{constructor(z,se=k.FileSystemProviderErrorCode.Unknown,Re){super(I.URI.isUri(z)?z.toString(!0):z);this.code=Re?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}static FileExists(z){return new M(z,k.FileSystemProviderErrorCode.FileExists,M.FileExists)}static FileNotFound(z){return new M(z,k.FileSystemProviderErrorCode.FileNotFound,M.FileNotFound)}static FileNotADirectory(z){return new M(z,k.FileSystemProviderErrorCode.FileNotADirectory,M.FileNotADirectory)}static FileIsADirectory(z){return new M(z,k.FileSystemProviderErrorCode.FileIsADirectory,M.FileIsADirectory)}static NoPermissions(z){return new M(z,k.FileSystemProviderErrorCode.NoPermissions,M.NoPermissions)}static Unavailable(z){return new M(z,k.FileSystemProviderErrorCode.Unavailable,M.Unavailable)}};vn=M=Ge([B],vn),e.FileSystemError=vn;let Kt=class{constructor(z,se,Re){this.start=z,this.end=se,this.kind=Re}};Kt=Ge([B],Kt),e.FoldingRange=Kt;var Rn;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Rn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ln;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Ln=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var On;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(On=e.CommentMode||(e.CommentMode={}));var Nn;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Nn=e.CommentThreadState||(e.CommentThreadState={}));class wn{constructor(z,se=[]){this.tokenTypes=z,this.tokenModifiers=se}}e.SemanticTokensLegend=wn;function Cn(j){return typeof j=="undefined"||(0,E.isStringArray)(j)}class an{constructor(z){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,z){this._hasLegend=!0;for(let se=0,Re=z.tokenTypes.length;se<Re;se++)this._tokenTypeStrToInt.set(z.tokenTypes[se],se);for(let se=0,Re=z.tokenModifiers.length;se<Re;se++)this._tokenModifierStrToInt.set(z.tokenModifiers[se],se)}}push(z,se,Re,Qe,rt){if(typeof z=="number"&&typeof se=="number"&&typeof Re=="number"&&typeof Qe=="number"&&(typeof rt=="number"||typeof rt=="undefined"))return typeof rt=="undefined"&&(rt=0),this._pushEncoded(z,se,Re,Qe,rt);if(K.isRange(z)&&typeof se=="string"&&Cn(Re))return this._push(z,se,Re);throw(0,t.illegalArgument)()}_push(z,se,Re){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Qe=z.start.line,rt=z.start.character,lt=z.end.character-z.start.character,ut=this._tokenTypeStrToInt.get(se);let Ct=0;if(Re)for(const Rt of Re){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(Rt);Ct|=1<<Wt>>>0}this._pushEncoded(Qe,rt,lt,ut,Ct)}_pushEncoded(z,se,Re,Qe,rt){if(this._dataIsSortedAndDeltaEncoded&&(z<this._prevLine||z===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ct=this._data.length/5|0;let Rt=0,Wt=0;for(let jt=0;jt<Ct;jt++){let Xt=this._data[5*jt],En=this._data[5*jt+1];Xt===0?(Xt=Rt,En+=Wt):Xt+=Rt,this._data[5*jt]=Xt,this._data[5*jt+1]=En,Rt=Xt,Wt=En}}let lt=z,ut=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=Re,this._data[this._dataLen++]=Qe,this._data[this._dataLen++]=rt,this._prevLine=z,this._prevChar=se}static _sortAndDeltaEncode(z){const se=[],Re=z.length/5|0;for(let ut=0;ut<Re;ut++)se[ut]=ut;se.sort((ut,Ct)=>{const Rt=z[5*ut],Wt=z[5*Ct];if(Rt===Wt){const jt=z[5*ut+1],Xt=z[5*Ct+1];return jt-Xt}return Rt-Wt});const Qe=new Uint32Array(z.length);let rt=0,lt=0;for(let ut=0;ut<Re;ut++){const Ct=5*se[ut],Rt=z[Ct+0],Wt=z[Ct+1],jt=z[Ct+2],Xt=z[Ct+3],En=z[Ct+4],Xn=Rt-rt,bi=Xn===0?Wt-lt:Wt,_n=5*ut;Qe[_n+0]=Xn,Qe[_n+1]=bi,Qe[_n+2]=jt,Qe[_n+3]=Xt,Qe[_n+4]=En,rt=Rt,lt=Wt}return Qe}build(z){return this._dataIsSortedAndDeltaEncoded?new $e(new Uint32Array(this._data),z):new $e(an._sortAndDeltaEncode(this._data),z)}}e.SemanticTokensBuilder=an;class $e{constructor(z,se){this.resultId=se,this.data=z}}e.SemanticTokens=$e;class xt{constructor(z,se,Re){this.start=z,this.deleteCount=se,this.data=Re}}e.SemanticTokensEdit=xt;class Dn{constructor(z,se){this.resultId=se,this.edits=z}}e.SemanticTokensEdits=Dn;var pt;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(pt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let cn=class{constructor(){}};cn.Back={iconPath:new Ht("arrow-left")},cn=Ge([B],cn),e.QuickInputButtons=cn;var Fn;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Fn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var In;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(In=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Mn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Mn=e.ExtensionKind||(e.ExtensionKind={}));class ln{constructor(z,se,Re){this.badge=z,this.tooltip=se,this.color=Re}static validate(z){if(z.badge){let se=(0,C.nextCharLength)(z.badge,0);if(se<z.badge.length&&(se+=(0,C.nextCharLength)(z.badge,se)),z.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ln;let bn=class{constructor(z){this.kind=z}};bn=Ge([B],bn),e.ColorTheme=bn;var Un;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Un=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(z,se){if(z<0)throw(0,t.illegalArgument)("start must be positive");if(se<0)throw(0,t.illegalArgument)("end must be positive");z<=se?(this._start=z,this._end=se):(this._start=se,this._end=z)}static isNotebookRange(z){return z instanceof zt?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(z){let se=this._start,Re=this._end;return z.start!==void 0&&(se=z.start),z.end!==void 0&&(Re=z.end),se===this._start&&Re===this._end?this:new zt(se,Re)}}e.NotebookRange=zt;class Vt{constructor(z,se,Re,Qe,rt,lt,ut){this.kind=z,this.value=se,this.languageId=Re,this.mime=Qe,this.outputs=rt??[],this.metadata=lt,this.executionSummary=ut,Vt.validate(this)}static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(se=>Vt.isNotebookCellData(se))}static isNotebookCellData(z){return!0}}e.NotebookCellData=Vt;class Bn{constructor(z){this.cells=z}}e.NotebookData=Bn;class Ft{constructor(z,se){this.data=z,this.mime=se;const Re=(0,y.normalizeMimeType)(se,!0);if(!Re)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}static isNotebookCellOutputItem(z){return z instanceof Ft?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const se={name:z.name,message:z.message,stack:z.stack};return Ft.json(se,"application/vnd.code.notebook.error")}static stdout(z){return Ft.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return Ft.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,se="application/octet-stream"){return new Ft(z,se)}static text(z,se=y.Mimes.text){const Re=Me(Ft,g,"f",f).encode(String(z));return new Ft(Re,se)}static json(z,se="text/x-json"){const Re=JSON.stringify(z,void 0,"	");return Ft.text(Re,se)}}e.NotebookCellOutputItem=Ft,g=Ft,f={value:new TextEncoder};class un{constructor(z,se,Re){this.items=un.ensureUniqueMimeTypes(z,!0),typeof se=="string"?(this.id=se,this.metadata=Re):(this.id=(0,R.generateUuid)(),this.metadata=se??Re)}static isNotebookCellOutput(z){return z instanceof un?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&(0,E.isArray)(z.items)}static ensureUniqueMimeTypes(z,se=!1){const Re=new Set,Qe=new Set;for(let rt=0;rt<z.length;rt++){const lt=z[rt],ut=(0,y.normalizeMimeType)(lt.mime);if(!Re.has(ut)){Re.add(ut);continue}Qe.add(rt),se&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Qe.size===0?z:z.filter((rt,lt)=>!Qe.has(lt))}}e.NotebookCellOutput=un;var zn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(zn=e.NotebookCellKind||(e.NotebookCellKind={}));var Wn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Wn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var fe;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(fe=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var _e;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(_e=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ue{constructor(z,se){this.text=z,this.alignment=se}}e.NotebookCellStatusBarItem=Ue;var ct;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(ct=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class _t{constructor(z,se=[]){this.uri=z,this.provides=(0,u.asArray)(se)}}e.NotebookRendererScript=_t;let It=class{constructor(z,se){this.label=z,this.timestamp=se}};It=Ge([B],It),e.TimelineItem=It;var Zn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Zn=e.ExtensionMode||(e.ExtensionMode={}));var ei;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(ei=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ti;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(ti=e.StandardTokenType||(e.StandardTokenType={}));class ni{constructor(z,se){this.ranges=z,this.wordPattern=se}}e.LinkedEditingRanges=ni;class ii{constructor(z,se){this._port=z,this._autoForwardAction=se}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ii;var ri;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(ri=e.TestResultState||(e.TestResultState={}));var si;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(si=e.TestRunProfileKind||(e.TestRunProfileKind={}));let $n=class{constructor(z=void 0,se=void 0,Re=void 0){this.include=z,this.exclude=se,this.profile=Re}};$n=Ge([B],$n),e.TestRunRequest=$n;let Hn=F=class{constructor(z){this.message=z}static diff(z,se,Re){const Qe=new F(z);return Qe.expectedOutput=se,Qe.actualOutput=Re,Qe}};Hn=F=Ge([B],Hn),e.TestMessage=Hn;let xn=class{constructor(z){this.id=z}};xn=Ge([B],xn),e.TestTag=xn;let dn=class{constructor(z,se){this.covered=z,this.total=se}};dn=Ge([B],dn),e.CoveredCount=dn;let Vn=A=class{constructor(z,se,Re,Qe){this.uri=z,this.statementCoverage=se,this.branchCoverage=Re,this.functionCoverage=Qe}static fromDetails(z,se){const Re=new dn(0,0),Qe=new dn(0,0),rt=new dn(0,0);for(const ut of se)if("branches"in ut){Re.total+=1,Re.covered+=ut.executionCount>0?1:0;for(const Ct of ut.branches)Qe.total+=1,Qe.covered+=Ct.executionCount>0?1:0}else rt.total+=1,rt.covered+=ut.executionCount>0?1:0;const lt=new A(z,Re,Qe.total>0?Qe:void 0,rt.total>0?rt:void 0);return lt.detailedCoverage=se,lt}};Vn=A=Ge([B],Vn),e.FileCoverage=Vn;let jn=class{constructor(z,se,Re=[]){this.executionCount=z,this.location=se,this.branches=Re}};jn=Ge([B],jn),e.StatementCoverage=jn;let qn=class{constructor(z,se){this.executionCount=z,this.location=se}};qn=Ge([B],qn),e.BranchCoverage=qn;let Gn=class{constructor(z,se){this.executionCount=z,this.location=se}};Gn=Ge([B],Gn),e.FunctionCoverage=Gn;var oi;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(oi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ai;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(ai=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ci;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(ci=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class li{constructor(z,se,Re,Qe,rt,lt){this.kind=z,this.name=se,this.detail=Re,this.uri=Qe,this.range=rt,this.selectionRange=lt}}e.TypeHierarchyItem=li;class ui{constructor(z){this.uri=z}}e.TextTabInput=ui;class di{constructor(z,se){this.original=z,this.modified=se}}e.TextDiffTabInput=di;class hi{constructor(z,se,Re,Qe){this.base=z,this.input1=se,this.input2=Re,this.result=Qe}}e.TextMergeTabInput=hi;class fi{constructor(z,se){this.uri=z,this.viewType=se}}e.CustomEditorTabInput=fi;class mi{constructor(z){this.viewType=z}}e.WebviewEditorTabInput=mi;class gi{constructor(z,se){this.uri=z,this.notebookType=se}}e.NotebookEditorTabInput=gi;class pi{constructor(z,se,Re){this.original=z,this.modified=se,this.notebookType=Re}}e.NotebookDiffEditorTabInput=pi;class vi{constructor(){}}e.TerminalEditorTabInput=vi;class wi{constructor(z,se){this.uri=z,this.inputBoxUri=se}}e.InteractiveWindowInput=wi}),define(Ie[126],ke([1,0,56,11,8,158,99,7,16]),function(Y,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function R(w,b){b?I.set(w,b):I.delete(w)}e.setWordDefinitionFor=R;function k(w){return I.get(w)}e.getWordDefinitionFor=k;class _ extends P.MirrorTextModel{constructor(b,g,f,p,v,c,m,a){super(g,f,p,v);this._proxy=b,this._languageId=c,this._isDirty=m,this.notebook=a,this._isDisposed=!1}dispose(){(0,u.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(b){return(0,E.equals)(this._lines,b)}get document(){if(!this._document){const b=this;this._document={get uri(){return b._uri},get fileName(){return b._uri.fsPath},get isUntitled(){return b._uri.scheme===t.Schemas.untitled},get languageId(){return b._languageId},get version(){return b._versionId},get isClosed(){return b._isDisposed},get isDirty(){return b._isDirty},save(){return b._save()},getText(g){return g?b._getTextInRange(g):b.getText()},get eol(){return b._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return b._lines.length},lineAt(g){return b._lineAt(g)},offsetAt(g){return b._offsetAt(g)},positionAt(g){return b._positionAt(g)},validateRange(g){return b._validateRange(g)},validatePosition(g){return b._validatePosition(g)},getWordRangeAtPosition(g,f){return b._getWordRangeAtPosition(g,f)}}}return Object.freeze(this._document)}_acceptLanguageId(b){(0,u.ok)(!this._isDisposed),this._languageId=b}_acceptIsDirty(b){(0,u.ok)(!this._isDisposed),this._isDirty=b}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(b){const g=this._validateRange(b);if(g.isEmpty)return"";if(g.isSingleLine)return this._lines[g.start.line].substring(g.start.character,g.end.character);const f=this._eol,p=g.start.line,v=g.end.line,c=[];c.push(this._lines[p].substring(g.start.character));for(let m=p+1;m<v;m++)c.push(this._lines[m]);return c.push(this._lines[v].substring(0,g.end.character)),c.join(f)}_lineAt(b){let g;if(b instanceof C.Position?g=b.line:typeof b=="number"&&(g=b),typeof g!="number"||g<0||g>=this._lines.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new T(g,this._lines[g],g===this._lines.length-1)}_offsetAt(b){return b=this._validatePosition(b),this._ensureLineStarts(),this._lineStarts.getPrefixSum(b.line-1)+b.character}_positionAt(b){b=Math.floor(b),b=Math.max(0,b),this._ensureLineStarts();const g=this._lineStarts.getIndexOf(b),f=this._lines[g.index].length;return new C.Position(g.index,Math.min(g.remainder,f))}_validateRange(b){if(!(b instanceof C.Range))throw new Error("Invalid argument");const g=this._validatePosition(b.start),f=this._validatePosition(b.end);return g===b.start&&f===b.end?b:new C.Range(g.line,g.character,f.line,f.character)}_validatePosition(b){if(!(b instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return b.with(0,0);let{line:g,character:f}=b,p=!1;if(g<0)g=0,f=0,p=!0;else if(g>=this._lines.length)g=this._lines.length-1,f=this._lines[g].length,p=!0;else{const v=this._lines[g].length;f<0?(f=0,p=!0):f>v&&(f=v,p=!0)}return p?new C.Position(g,f):b}_getWordRangeAtPosition(b,g){const f=this._validatePosition(b);if(!g)g=k(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const p=(0,y.getWordAtText)(f.character+1,(0,y.ensureValidWordDefinition)(g),this._lines[f.line],0);if(p)return new C.Range(f.line,p.startColumn-1,f.line,p.endColumn-1)}}e.ExtHostDocumentData=_;class T{constructor(b,g,f){this._line=b,this._text=g,this._isLastLine=f}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(Ie[208],ke([1,0,7,17,3]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(C){this._actual=new u.ColorTheme(u.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let E;switch(C){case"light":E=u.ColorThemeKind.Light;break;case"hcDark":E=u.ColorThemeKind.HighContrast;break;case"hcLight":E=u.ColorThemeKind.HighContrastLight;break;default:E=u.ColorThemeKind.Dark}this._actual=new u.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=Ge([xe(0,t.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(Ie[64],ke([1,0,4]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,u.createDecorator)("IURITransformerService");class t{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=t}),define(Ie[209],ke([1,0,23]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(E){let I=this.buffers.indexOf(E);return I<0&&(I=this.buffers.length,this.buffers.push(E)),I}}function D(C,E){if(E.serializeBuffersForPostMessage){const I=new t,R=(T,w)=>{if(w instanceof ArrayBuffer){const b=I.add(w);return{$$vscode_array_buffer_reference$$:!0,index:b}}else if(ArrayBuffer.isView(w)){const b=P(w);if(b){const g=I.add(w.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:b,byteLength:w.byteLength,byteOffset:w.byteOffset}}}}return w},k=JSON.stringify(C,R),_=I.buffers.map(T=>{const w=new Uint8Array(T);return u.VSBuffer.wrap(w)});return{message:k,buffers:_}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=D;function P(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(C,E){const I=E.map(_=>{const T=new ArrayBuffer(_.byteLength);return new Uint8Array(T).set(_.buffer),T}),R=E.length?(_,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const w=T,{index:b}=w,g=I[b];if(w.view)switch(w.view.type){case 1:return new Int8Array(g,w.view.byteOffset,w.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,w.view.byteOffset,w.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,w.view.byteOffset,w.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,w.view.byteOffset,w.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,w.view.byteOffset,w.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,w.view.byteOffset,w.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,w.view.byteOffset,w.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,w.view.byteOffset,w.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,w.view.byteOffset,w.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,w.view.byteOffset,w.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,w.view.byteOffset,w.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return T}:void 0;return{message:JSON.parse(C,R),arrayBuffers:I}}e.deserializeWebviewMessage=y}),define(Ie[210],ke([1,0,108]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(P){return{transformIncoming:y=>y.scheme==="vscode-remote"?{scheme:"file",path:y.path,query:y.query,fragment:y.fragment}:y.scheme==="file"?{scheme:"vscode-local",path:y.path,query:y.query,fragment:y.fragment}:y,transformOutgoing:y=>y.scheme==="file"?{scheme:"vscode-remote",authority:P,path:y.path,query:y.query,fragment:y.fragment}:y.scheme==="vscode-local"?{scheme:"file",path:y.path,query:y.query,fragment:y.fragment}:y,transformOutgoingScheme:y=>y==="file"?"vscode-remote":y==="vscode-local"?"file":y}}function D(P){return new u.URITransformer(t(P))}e.createURITransformer=D}),define(Ie[211],ke([1,0,179,10,2,6,4,44,43,16,11]),function(Y,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var k;(function(N){N[N.PROGRAMMATIC=1]="PROGRAMMATIC",N[N.USER=2]="USER",N[N.EDIT=3]="EDIT",N[N.NAVIGATION=4]="NAVIGATION",N[N.JUMP=5]="JUMP"})(k=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var _;(function(N){N[N.IDENTICAL=1]="IDENTICAL",N[N.SIMILAR=2]="SIMILAR",N[N.DIFFERENT=3]="DIFFERENT"})(_=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function T(N){const V=N;return!!V&&typeof V.getSelection=="function"&&!!V.onDidChangeSelection}e.isEditorPaneWithSelection=T;function w(N,V,x){for(const q of x.visibleEditorPanes)if(q.group.id===V&&N.matches(q.input))return q.getViewState()}e.findViewStateForEditor=w;function b(N){if(o(N))return!1;const V=N;return D.URI.isUri(V?.resource)}e.isResourceEditorInput=b;function g(N){if(o(N))return!1;const V=N;return V?.original!==void 0&&V.modified!==void 0}e.isResourceDiffEditorInput=g;function f(N){if(o(N)||g(N))return!1;const V=N;return V?.primary!==void 0&&V.secondary!==void 0}e.isResourceSideBySideEditorInput=f;function p(N){if(o(N))return!1;const V=N;return V?V.resource===void 0||V.resource.scheme===R.Schemas.untitled||V.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=p;function v(N){if(o(N))return!1;const V=N;return D.URI.isUri(V?.base?.resource)&&D.URI.isUri(V?.input1?.resource)&&D.URI.isUri(V?.input2?.resource)&&D.URI.isUri(V?.result?.resource)}e.isResourceMergeEditorInput=v;var c;(function(N){N[N.SHORT=0]="SHORT",N[N.MEDIUM=1]="MEDIUM",N[N.LONG=2]="LONG"})(c=e.Verbosity||(e.Verbosity={}));var m;(function(N){N[N.EXPLICIT=1]="EXPLICIT",N[N.AUTO=2]="AUTO",N[N.FOCUS_CHANGE=3]="FOCUS_CHANGE",N[N.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(m=e.SaveReason||(e.SaveReason={}));class a{constructor(){this.mapIdToSaveSource=new Map}registerSource(V,x){let q=this.mapIdToSaveSource.get(V);return q||(q={source:V,label:x},this.mapIdToSaveSource.set(V,q)),q.source}getSourceLabel(V){return this.mapIdToSaveSource.get(V)?.label??V}}e.SaveSourceRegistry=new a;var d;(function(N){N[N.None=0]="None",N[N.Readonly=2]="Readonly",N[N.Untitled=4]="Untitled",N[N.Singleton=8]="Singleton",N[N.RequiresTrust=16]="RequiresTrust",N[N.CanSplitInGroup=32]="CanSplitInGroup",N[N.ForceDescription=64]="ForceDescription",N[N.CanDropIntoEditor=128]="CanDropIntoEditor",N[N.MultipleEditors=256]="MultipleEditors"})(d=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends P.Disposable{}e.AbstractEditorInput=r;function o(N){return N instanceof r}e.isEditorInput=o;function i(N){const V=N;return D.URI.isUri(V?.preferredResource)}function n(N){const V=N;return o(V?.primary)&&o(V?.secondary)}e.isSideBySideEditorInput=n;function s(N){const V=N;return o(V?.modified)&&o(V?.original)}e.isDiffEditorInput=s;function l(N){return o(N?.editor)}e.isEditorInputWithOptions=l;function h(N){const V=N;return l(N)&&V?.group!==void 0}e.isEditorInputWithOptionsAndGroup=h;function S(N){const V=N;return typeof V?.groupId=="number"&&o(V.editor)}e.isEditorIdentifier=S;var L;(function(N){N[N.UNKNOWN=0]="UNKNOWN",N[N.REPLACE=1]="REPLACE",N[N.MOVE=2]="MOVE",N[N.UNPIN=3]="UNPIN"})(L=e.EditorCloseContext||(e.EditorCloseContext={}));var M;(function(N){N[N.GROUP_ACTIVE=0]="GROUP_ACTIVE",N[N.GROUP_INDEX=1]="GROUP_INDEX",N[N.GROUP_LOCKED=2]="GROUP_LOCKED",N[N.EDITOR_OPEN=3]="EDITOR_OPEN",N[N.EDITOR_CLOSE=4]="EDITOR_CLOSE",N[N.EDITOR_MOVE=5]="EDITOR_MOVE",N[N.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",N[N.EDITOR_LABEL=7]="EDITOR_LABEL",N[N.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",N[N.EDITOR_PIN=9]="EDITOR_PIN",N[N.EDITOR_STICKY=10]="EDITOR_STICKY",N[N.EDITOR_DIRTY=11]="EDITOR_DIRTY",N[N.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(M=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var F;(function(N){N[N.PRIMARY=1]="PRIMARY",N[N.SECONDARY=2]="SECONDARY",N[N.BOTH=3]="BOTH",N[N.ANY=4]="ANY"})(F=e.SideBySideEditor||(e.SideBySideEditor={}));class A{getOriginalUri(V,x){if(!V)return;if(v(V))return e.EditorResourceAccessor.getOriginalUri(V.result,x);if(x?.supportSideBySide){const{primary:te,secondary:Q}=this.getSideEditors(V);if(te&&Q){if(x?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(te,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(Q,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===F.ANY)return this.getOriginalUri(te,{filterByScheme:x.filterByScheme})??this.getOriginalUri(Q,{filterByScheme:x.filterByScheme});V=x.supportSideBySide===F.PRIMARY?te:Q}}if(g(V)||f(V)||v(V))return;const q=i(V)?V.preferredResource:V.resource;return!q||!x||!x.filterByScheme?q:this.filterUri(q,x.filterByScheme)}getSideEditors(V){return n(V)||f(V)?{primary:V.primary,secondary:V.secondary}:s(V)||g(V)?{primary:V.modified,secondary:V.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(V,x){if(!V)return;if(v(V))return e.EditorResourceAccessor.getCanonicalUri(V.result,x);if(x?.supportSideBySide){const{primary:te,secondary:Q}=this.getSideEditors(V);if(te&&Q){if(x?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(te,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(Q,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===F.ANY)return this.getCanonicalUri(te,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(Q,{filterByScheme:x.filterByScheme});V=x.supportSideBySide===F.PRIMARY?te:Q}}if(g(V)||f(V)||v(V))return;const q=V.resource;return!q||!x||!x.filterByScheme?q:this.filterUri(q,x.filterByScheme)}filterUri(V,x){if(Array.isArray(x)){if(x.some(q=>V.scheme===q))return V}else if(x===V.scheme)return V}}e.EditorResourceAccessor=new A;var B;(function(N){N[N.LEFT=0]="LEFT",N[N.RIGHT=1]="RIGHT"})(B=e.CloseDirection||(e.CloseDirection={}));class ${constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(V){const x=this.instantiationService=V.get(y.IInstantiationService);for(const[q,te]of this.editorSerializerConstructors)this.createEditorSerializer(q,te,x);this.editorSerializerConstructors.clear()}createEditorSerializer(V,x,q){const te=q.createInstance(x);this.editorSerializerInstances.set(V,te)}registerFileEditorFactory(V){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=V}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(V,x){if(this.editorSerializerConstructors.has(V)||this.editorSerializerInstances.has(V))throw new Error(`A editor serializer with type ID '${V}' was already registered.`);return this.instantiationService?this.createEditorSerializer(V,x,this.instantiationService):this.editorSerializerConstructors.set(V,x),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(V),this.editorSerializerInstances.delete(V)})}getEditorSerializer(V){return this.editorSerializerInstances.get(typeof V=="string"?V:V.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new $);async function U(N,V){if(!N||!N.length)return[];const x=await Promise.all(N.map(async q=>{const te=D.URI.revive(q.fileUri);if(!te||!await V.canHandleResource(te))return;let le=q.exists,pe=q.type;if(typeof le!="boolean"||typeof pe!="number")try{pe=(await V.stat(te)).isDirectory?E.FileType.Directory:E.FileType.Unknown,le=!0}catch{le=!1}if(!le&&q.openOnlyIfExists||pe===E.FileType.Directory)return;const Z={...q.options,pinned:!0};let ge;return le?ge={resource:te,options:Z}:ge={resource:te,options:Z,forceUntitled:!0},ge}));return(0,I.coalesce)(x)}e.pathsToEditors=U;var K;(function(N){N[N.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",N[N.SEQUENTIAL=1]="SEQUENTIAL"})(K=e.EditorsOrder||(e.EditorsOrder={}));function W(N){const V=N;if(!V)return!1;const x=V;if(x.modified)return W(x.modified);const q=V;return!!(q.contributionsState&&q.viewState&&Array.isArray(q.cursorState))}e.isTextEditorViewState=W}),define(Ie[88],ke([1,0,11,2]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function D(C,E){return C.scheme===u.Schemas.http||C.scheme===u.Schemas.https?C:(E&&E.authority&&E.isRemote&&C.scheme===u.Schemas.file&&(C=t.URI.from({scheme:u.Schemas.vscodeRemote,authority:E.authority,path:C.path})),t.URI.from({scheme:u.Schemas.https,authority:`${C.scheme}+${P(C.authority)}.${e.webviewRootResourceAuthority}`,path:C.path,fragment:C.fragment,query:C.query}))}e.asWebviewUri=D;function P(C){return C.replace(/./g,E=>{const I=E.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?E:"-"+I.toString(16).padStart(4,"0")})}function y(C){return C.replace(/-([0-9a-f]{4})/g,(E,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=y}),define(Ie[212],ke([1,0,3,6,88]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(C,E,I){this._proxy=C,this._editors=E,this._remoteInfo=I,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const R=E.getVisibleTextEditors();for(const k of this._insets.values())R.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,E,I,R,k){let _;for(const v of this._editors.getVisibleTextEditors(!0))if(v.value===C){_=v;break}if(!_)throw new Error("not a visible editor");const T=this,w=this._handlePool++,b=new u.Emitter,g=new u.Emitter,f=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(v){return(0,D.asWebviewUri)(v,T._remoteInfo)}get cspSource(){return D.webviewGenericCspSource}set options(v){this._options=v,T._proxy.$setOptions(w,v)}get options(){return this._options}set html(v){this._html=v,T._proxy.$setHtml(w,v)}get html(){return this._html}get onDidReceiveMessage(){return b.event}postMessage(v){return T._proxy.$postMessage(w,v)}},p=new class{constructor(){this.editor=C,this.line=E,this.height=I,this.webview=f,this.onDidDispose=g.event}dispose(){T._insets.has(w)&&(T._insets.delete(w),T._proxy.$disposeEditorInset(w),g.fire(),g.dispose(),b.dispose())}};return this._proxy.$createEditorInset(w,_.id,_.value.document.uri,E+1,I,R||{},k.identifier,k.extensionLocation),this._insets.set(w,{editor:C,inset:p,onDidReceiveMessage:b}),p}$onDidDispose(C){const E=this._insets.get(C);E&&E.inset.dispose()}$onDidReceiveMessage(C,E){this._insets.get(C)?.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=P}),define(Ie[127],ke([1,0,3,18,180]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new u.Emitter,this._onExit=new u.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,E,I,R){const k={command:C};if(E&&Object.keys(E).length>0&&(k.arguments=E),this.internalSend("request",k),typeof R=="number"){const _=setTimeout(()=>{clearTimeout(_);const T=this.pendingRequests.get(k.seq);if(T){this.pendingRequests.delete(k.seq);const w={type:"response",seq:0,request_seq:k.seq,success:!1,command:C,message:(0,D.localize)(0,null,R,C)};T(w)}},R)}return I&&this.pendingRequests.set(k.seq,I),k.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,E){return C.type!=="event"||E.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,t.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback?.(C);break;case"request":this.requestCallback?.(C);break;case"response":{const E=C,I=this.pendingRequests.get(E.request_seq);I&&(this.pendingRequests.delete(E.request_seq),I(E));break}}}}internalSend(C,E){E.type=C,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((E,I)=>C.set(I,E)),await(0,t.timeout)(500),C.forEach((E,I)=>{E({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(Ie[213],ke([1,0,181,51,4]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:u.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:u.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:u.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:u.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:u.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:u.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:u.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:u.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:u.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:u.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:u.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:u.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:u.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:u.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:u.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:u.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:u.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:u.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:u.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:u.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:u.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new t.RawContextKey("breakpointAccessType",void 0,{type:"string",description:u.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:u.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:u.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:u.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:u.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:u.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:u.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:u.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:u.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:u.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:u.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:u.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:u.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:u.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:u.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:u.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:u.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:u.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:u.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:u.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:u.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:u.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:u.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:u.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:u.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:u.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:u.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:u.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:u.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:u.localize(50,null)});const P=_=>u.localize(51,null,_);e.debuggerDisabledMessage=P,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:u.localize(52,null)};var y;(function(_){_[_.Inactive=0]="Inactive",_[_.Initializing=1]="Initializing",_[_.Stopped=2]="Stopped",_[_.Running=3]="Running"})(y=e.State||(e.State={}));function C(_){switch(_){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=C;var E;(function(_){_[_.Valid=0]="Valid",_[_.Unreadable=1]="Unreadable",_[_.Error=2]="Error"})(E=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var I;(function(_){_[_.Initial=1]="Initial",_[_.Dynamic=2]="Dynamic"})(I=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(_){_.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,D.createDecorator)(e.DEBUG_SERVICE_ID);var k;(function(_){_[_.CONDITION=0]="CONDITION",_[_.HIT_COUNT=1]="HIT_COUNT",_[_.LOG_MESSAGE=2]="LOG_MESSAGE"})(k=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ie[214],ke([1,0,8,2,9,24,11]),function(Y,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function E(r,o,i){return r.replace(C,function(n,s){return o&&s.length>0&&s[0]!=="_"?n:i&&i.hasOwnProperty(s)?i[s]:n})}e.formatPII=E;function I(r){const o={};for(const i of Object.keys(r))i.startsWith("!")||(o[i]=r[i]);return o}e.filterExceptionsFromTelemetry=I;function R(r){return r.configuration.request==="attach"&&!k(r)&&(!r.parentSession||R(r.parentSession))}e.isSessionAttach=R;function k(r){let o=r.configuration.type;if(!!o)return o==="vslsShare"&&(o=r.configuration.adapterProxy.configuration.type),(0,u.equalsIgnoreCase)(o,"extensionhost")||(0,u.equalsIgnoreCase)(o,"pwa-extensionhost")?r:r.parentSession?k(r.parentSession):void 0}e.getExtensionHostDebugSession=k;function _(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=_;function T(r,o,i){let n,s=0;const l=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let h=null;for(;h=l.exec(r);){const S=h.index+1,L=S+h[0].length;if(S<=o&&L>=i){n=h[0],s=S;break}}if(n){const S=/\w+/g;let L=null;for(;(L=S.exec(n))&&!(L.index+1+s+L[0].length>=i););L&&(n=n.substring(0,S.lastIndex))}return n?{start:s,end:s+n.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=T;const w=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(r){return!!(r&&r.match(w))}e.isUri=b;function g(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(b(r.path))return t.URI.parse(r.path);if((0,D.isAbsolute)(r.path))return t.URI.file(r.path)}return r.path}function f(r){if(typeof r.path=="object"){const o=t.URI.revive(r.path);if(o)return o.scheme===y.Schemas.file?o.fsPath:o.toString()}return r.path}function p(r,o){const i=o?g:f,n=(0,P.deepClone)(r);return c(n,(s,l)=>{s&&l&&(l.path=i(l))}),n}e.convertToDAPaths=p;function v(r,o){const i=o?g:f,n=(0,P.deepClone)(r);return c(n,(s,l)=>{!s&&l&&(l.path=i(l))}),n}e.convertToVSCPaths=v;function c(r,o){switch(r.type){case"event":{const i=r;switch(i.event){case"output":o(!1,i.body.source);break;case"loadedSource":o(!1,i.body.source);break;case"breakpoint":o(!1,i.body.breakpoint.source);break;default:break}break}case"request":{const i=r;switch(i.command){case"setBreakpoints":o(!0,i.arguments.source);break;case"breakpointLocations":o(!0,i.arguments.source);break;case"source":o(!0,i.arguments.source);break;case"gotoTargets":o(!0,i.arguments.source);break;case"launchVSCode":i.arguments.args.forEach(n=>o(!1,n));break;default:break}break}case"response":{const i=r;if(i.success&&i.body)switch(i.command){case"stackTrace":i.body.stackFrames.forEach(n=>o(!1,n.source));break;case"loadedSources":i.body.sources.forEach(n=>o(!1,n));break;case"scopes":i.body.scopes.forEach(n=>o(!1,n.source));break;case"setFunctionBreakpoints":i.body.breakpoints.forEach(n=>o(!1,n.source));break;case"setBreakpoints":i.body.breakpoints.forEach(n=>o(!1,n.source));break;case"disassemble":i.body?.instructions.forEach(s=>o(!1,s.location));break;default:break}break}}}function m(r){return r.filter(o=>!o.presentation?.hidden).sort((o,i)=>o.presentation?i.presentation?o.presentation.group?i.presentation.group?o.presentation.group!==i.presentation.group?o.presentation.group.localeCompare(i.presentation.group):a(o.presentation.order,i.presentation.order):-1:i.presentation.group?1:a(o.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=m;function a(r,o){return typeof r!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:r-o}async function d(r,o){const i=r.getValue("debug.saveBeforeStart",{overrideIdentifier:o.activeTextEditorLanguageId});if(i!=="none"&&(await o.saveAll(),i==="allEditorsInActiveGroup")){const n=o.activeEditorPane;n&&n.input.resource?.scheme===y.Schemas.untitled&&await o.save({editor:n.input,groupId:n.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=d}),define(Ie[215],ke([1,0,29,42,182,216,9,8,24,13,84,127]),function(Y,e,u,t,D,P,y,C,E,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class _ extends k.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(p,v){this.outputStream=v,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,p.on("data",c=>this.handleData(c))}sendMessage(p){if(this.outputStream){const v=JSON.stringify(p);this.outputStream.write(`Content-Length: ${Buffer.byteLength(v,"utf8")}${_.TWO_CRLF}${v}`,"utf8")}}handleData(p){for(this.rawData=Buffer.concat([this.rawData,p]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const v=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,v.length>0)try{this.acceptMessage(JSON.parse(v))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+v))}continue}}else{const v=this.rawData.indexOf(_.TWO_CRLF);if(v!==-1){const m=this.rawData.toString("utf8",0,v).split(_.HEADER_LINESEPARATOR);for(const a of m){const d=a.split(_.HEADER_FIELDSEPARATOR);d[0]==="Content-Length"&&(this.contentLength=Number(d[1]))}this.rawData=this.rawData.slice(v+_.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=_,_.TWO_CRLF=`\r
\r
`,_.HEADER_LINESEPARATOR=/\r?\n/,_.HEADER_FIELDSEPARATOR=/: */;class T extends _{startSession(){return new Promise((p,v)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),p(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):v(new Error("connection closed"))}),this.socket.on("error",m=>{c?this._onError.fire(m):v(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=T;class w extends T{constructor(p){super();this.adapterServer=p}createConnection(p){return P.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",p)}}e.SocketDebugAdapter=w;class b extends T{constructor(p){super();this.adapterServer=p}createConnection(p){return P.createConnection(this.adapterServer.path,p)}}e.NamedPipeDebugAdapter=b;class g extends _{constructor(p,v,c){super();this.adapterExecutable=p,this.debugType=v,this.outputService=c}async startSession(){const p=this.adapterExecutable.command,v=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(p)if(y.isAbsolute(p)){if(!await u.Promises.exists(p))throw new Error(D.localize(0,null,p))}else p.indexOf("/")<0&&p.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.debugType));let m=process.env;if(c.env&&Object.keys(c.env).length>0&&(m=E.mixin(E.deepClone(process.env),c.env)),p==="node")if(Array.isArray(v)&&v.length>0){const d=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:m,execArgv:d?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(r.cwd=c.cwd);const o=t.fork(v[0],v.slice(1),r);if(!o.pid)throw new Error(D.localize(2,null,v[0]));this.serverProcess=o}else throw new Error(D.localize(3,null));else{const d={env:m};c.cwd&&(d.cwd=c.cwd),this.serverProcess=t.spawn(p,v,d)}this.serverProcess.on("error",d=>{this._onError.fire(d)}),this.serverProcess.on("exit",(d,r)=>{this._onExit.fire(d)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",d=>{this._onError.fire(d)}),this.serverProcess.stdin.on("error",d=>{this._onError.fire(d)});const a=this.outputService;if(a){const d=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{a.getChannel(R.ExtensionsChannelId)?.append(d(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),I.isWindows?new Promise((p,v)=>{const c=t.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,a,d){if(m)return v(m)});c.on("exit",p),c.on("error",v)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(p,v){if(!p)return;const c=Object.create(null);p.runtime&&(p.runtime.indexOf("./")===0?c.runtime=y.join(v,p.runtime):c.runtime=p.runtime),p.runtimeArgs&&(c.runtimeArgs=p.runtimeArgs),p.program&&(y.isAbsolute(p.program)?c.program=p.program:c.program=y.join(v,p.program)),p.args&&(c.args=p.args);const m=p;return m.win&&(c.win=g.extract(m.win,v)),m.winx86&&(c.winx86=g.extract(m.winx86,v)),m.windows&&(c.windows=g.extract(m.windows,v)),m.osx&&(c.osx=g.extract(m.osx,v)),m.linux&&(c.linux=g.extract(m.linux,v)),c}static platformAdapterExecutable(p,v){let c=Object.create(null);v=v.toLowerCase();for(const i of p)if(i.contributes){const n=i.contributes.debuggers;n&&n.length>0&&n.filter(s=>typeof s.type=="string"&&C.equalsIgnoreCase(s.type,v)).forEach(s=>{const l=g.extract(s,i.extensionLocation.fsPath);c=E.mixin(c,l,i.isBuiltin)})}let m;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=c.winx86||c.win||c.windows:I.isWindows?m=c.win||c.windows:I.isMacintosh?m=c.osx:I.isLinux&&(m=c.linux),m=m||c;const a=m.program||c.program,d=m.args||c.args,r=m.runtime||c.runtime,o=m.runtimeArgs||c.runtimeArgs;if(r)return{type:"executable",command:r,args:(o||[]).concat(typeof a=="string"?[a]:[]).concat(d||[])};if(a)return{type:"executable",command:a,args:d||[]}}}e.ExecutableDebugAdapter=g}),define(Ie[217],ke([1,0,42,30,13]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function P(I,R){return new Promise((k,_)=>{let T="";const w=u.spawn(I,R);w.pid&&w.stdout.on("data",b=>{T+=b.toString()}),w.on("error",b=>{_(b)}),w.on("close",b=>{k(T)})})}async function y(I){if(I)if(D.isWindows){const R=await new Promise((k,_)=>{Y(["windows-process-tree"],k,_)});return new Promise(k=>{R.getProcessTree(I,_=>{k(!!_&&_.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(I)]).then(R=>{const k=R.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.hasChildProcesses=y;var C;(function(I){I[I.cmd=0]="cmd",I[I.powershell=1]="powershell",I[I.bash=2]="bash"})(C||(C={}));function E(I,R,k,_){I=I.trim().toLowerCase();let T;I.indexOf("powershell")>=0||I.indexOf("pwsh")>=0?T=1:I.indexOf("cmd.exe")>=0?T=0:I.indexOf("bash")>=0?T=2:D.isWindows?T=0:T=2;let w,b=" ";switch(T){case 1:if(w=g=>(g=g.replace(/\'/g,"''"),g.length>0&&g.charAt(g.length-1)==="\\"?`'${g}\\'`:`'${g}'`),k){const g=(0,t.getDriveLetter)(k);g&&(b+=`${g}:; `),b+=`cd ${w(k)}; `}if(_)for(const g in _){const f=_[g];f===null?b+=`Remove-Item env:${g}; `:b+=`\${env:${g}}='${f}'; `}if(R.length>0){const g=w(R.shift());b+=g[0]==="'"?`& ${g} `:`${g} `;for(const f of R)b+=f==="<"||f===">"?f:w(f),b+=" "}break;case 0:if(w=g=>(g=g.replace(/\"/g,'""'),g=g.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(f=>g.includes(f))||g.length===0?`"${g}"`:g),k){const g=(0,t.getDriveLetter)(k);g&&(b+=`${g}: && `),b+=`cd ${w(k)} && `}if(_){b+='cmd /C "';for(const g in _){let f=_[g];f===null?b+=`set "${g}=" && `:(f=f.replace(/[&^|<>]/g,p=>`^${p}`),b+=`set "${g}=${f}" && `)}}for(const g of R)b+=g==="<"||g===">"?g:w(g),b+=" ";_&&(b+='"');break;case 2:{w=f=>(f=f.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),f.length===0?'""':f);const g=f=>/[^\w@%\/+=,.:^-]/.test(f)?`'${f.replace(/'/g,"'\\''")}'`:f;if(k&&(b+=`cd ${w(k)} ; `),_){b+="/usr/bin/env";for(const f in _){const p=_[f];p===null?b+=` -u ${g(f)}`:b+=` ${g(`${f}=${p}`)}`}b+=" "}for(const f of R)b+=f==="<"||f===">"?f:w(f),b+=" ";break}}return b}e.prepareCommand=E}),define(Ie[128],ke([1,0,36,59,101,11,9,13,51]),function(Y,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var I;(function(i){i[i.Markup=1]="Markup",i[i.Code=2]="Code"})(I=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",D.Mimes.latex,D.Mimes.markdown,"image/png","image/jpeg",D.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[D.Mimes.latex,D.Mimes.markdown,"application/json",D.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(i){i[i.Running=1]="Running",i[i.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var k;(function(i){i[i.Unconfirmed=1]="Unconfirmed",i[i.Pending=2]="Pending",i[i.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var _;(function(i){i[i.WithHardKernelDependency=0]="WithHardKernelDependency",i[i.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",i[i.Pure=2]="Pure",i[i.Never=3]="Never"})(_=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var T;(function(i){i.Always="always",i.Never="never",i.Optional="optional"})(T=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var w;(function(i){i[i.ModelChange=1]="ModelChange",i[i.Move=2]="Move",i[i.ChangeCellLanguage=5]="ChangeCellLanguage",i[i.Initialize=6]="Initialize",i[i.ChangeCellMetadata=7]="ChangeCellMetadata",i[i.Output=8]="Output",i[i.OutputItem=9]="OutputItem",i[i.ChangeCellContent=10]="ChangeCellContent",i[i.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",i[i.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",i[i.ChangeCellMime=13]="ChangeCellMime",i[i.Unknown=100]="Unknown"})(w=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var b;(function(i){i[i.Handle=0]="Handle",i[i.Index=1]="Index"})(b=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(i){i[i.Replace=1]="Replace",i[i.Output=2]="Output",i[i.Metadata=3]="Metadata",i[i.CellLanguage=4]="CellLanguage",i[i.DocumentMetadata=5]="DocumentMetadata",i[i.Move=6]="Move",i[i.OutputItems=7]="OutputItems",i[i.PartialMetadata=8]="PartialMetadata",i[i.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));var f;(function(i){i.scheme=P.Schemas.vscodeNotebookCell;const n=/^ch(\d{7,})/;function s(F,A){return F.with({scheme:i.scheme,fragment:`ch${A.toString().padStart(7,"0")}${F.scheme!==P.Schemas.file?F.scheme:""}`})}i.generate=s;function l(F){if(F.scheme!==i.scheme)return;const A=n.exec(F.fragment);return A?{handle:Number(A[1]),notebook:F.with({scheme:F.fragment.substring(A[0].length)||P.Schemas.file,fragment:null})}:void 0}i.parse=l;function h(F,A){return F.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`op${A??""},${F.scheme!==P.Schemas.file?F.scheme:""}`})}i.generateCellOutputUri=h;function S(F){if(F.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const A=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(F.fragment);if(!A)return;const B=A[1]&&A[1]!==""?A[1]:void 0,$=A[2];return{outputId:B,notebook:F.with({scheme:$||P.Schemas.file,fragment:null})}}i.parseCellOutputUri=S;function L(F,A,B){return F.with({scheme:B,fragment:`ch${A.toString().padStart(7,"0")}${F.scheme!==P.Schemas.file?F.scheme:""}`})}i.generateCellUri=L;function M(F,A){if(F.scheme!==A)return;const B=n.exec(F.fragment);return B?{handle:Number(B[1]),notebook:F.with({scheme:F.fragment.substring(B[0].length)||P.Schemas.file,fragment:null})}:void 0}i.parseCellUri=M})(f=e.CellUri||(e.CellUri={}));const p=i=>C.isWindows?i.replace(/\//g,"\\"):i;class v{constructor(n=[],s=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=s,this.order=[...new Set(n)].map(l=>({pattern:l,matches:u.parse(p(l))}))}sort(n){const s=new Map(t.Iterable.map(n,h=>[h,p(h)]));let l=[];for(const{matches:h}of this.order)for(const[S,L]of s)if(h(L)){l.push(S),s.delete(S);break}return s.size&&(l=l.concat([...s.keys()].sort((h,S)=>this.defaultOrder.indexOf(h)-this.defaultOrder.indexOf(S)))),l}prioritize(n,s){const l=this.findIndex(n);if(l===-1){this.order.unshift({pattern:n,matches:u.parse(p(n))});return}const h=new Set(s.map(L=>this.findIndex(L,l)));h.delete(-1);const S=Array.from(h).sort();this.order.splice(l+1,0,...S.map(L=>this.order[L]));for(let L=S.length-1;L>=0;L--)this.order.splice(S[L],1)}toArray(){return this.order.map(n=>n.pattern)}findIndex(n,s=this.order.length){const l=p(n);for(let h=0;h<s;h++)if(this.order[h].matches(l))return h;return-1}}e.MimeTypeDisplayOrder=v;function c(i,n,s,l=(h,S)=>h===S){const h=[];function S(F,A,B){if(A===0&&B.length===0)return;const $=h[h.length-1];$&&$.start+$.deleteCount===F?($.deleteCount+=A,$.toInsert.push(...B)):h.push({start:F,deleteCount:A,toInsert:B})}let L=0,M=0;for(;;){if(L===i.length){S(L,0,n.slice(M));break}if(M===n.length){S(L,i.length-L,[]);break}const F=i[L],A=n[M];if(l(F,A)){L+=1,M+=1;continue}s(A)?(S(L,1,[]),L+=1):(S(L,0,[A]),M+=1)}return h}e.diff=c,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new E.RawContextKey("notebookEditorCursorAtBoundary","none");var m;(function(i){i.default="default",i.option="option"})(m=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(i){const n=i;return!!((typeof n.include=="string"||u.isRelativePattern(n.include))&&(typeof n.exclude=="string"||u.isRelativePattern(n.exclude)))}e.isDocumentExcludePattern=a;function d(i,n,s){if(Array.isArray(i.viewType)&&i.viewType.indexOf(n)>=0||i.viewType===n)return!0;if(i.filenamePattern){const l=a(i.filenamePattern)?i.filenamePattern.include:i.filenamePattern,h=a(i.filenamePattern)?i.filenamePattern.exclude:void 0;if(u.match(l,(0,y.basename)(s.fsPath).toLowerCase()))return!(h&&u.match(h,(0,y.basename)(s.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var r;(function(i){i[i.Left=1]="Left",i[i.Right=2]="Right"})(r=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(n){return`${o._prefix}${n}`}static parse(n){if(n.startsWith(o._prefix))return n.substring(o._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=o,o._prefix="notebook/"}),define(Ie[218],ke([1,0,4]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,u.createDecorator)("INotebookExecutionService")}),define(Ie[219],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function u(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=u;function t(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=t;function D(y){return Array.from(y.entries()).map(C=>[C[0],u(C[1].map)])}e.serializeEnvironmentVariableCollections=D;function P(y){return new Map(y.map(C=>[C[0],{map:t(C[1])}]))}e.deserializeEnvironmentVariableCollections=P}),define(Ie[65],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(P){P.Delimiter="\0"})(u=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class D{constructor(y,C=y.length){if(this.path=y,this.viewEnd=C,y.length===0||C<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(y,C,E=y.parent){if(y.id===C)return new D([C]);const I=[y.id];for(let R=E;R&&R.id!==C;R=R.parent)I.push(R.id);return I.push(C),new D(I.reverse())}static isRoot(y){return!y.includes("\0")}static root(y){const C=y.indexOf("\0");return C===-1?y:y.slice(0,C)}static fromString(y){return new D(y.split("\0"))}static join(y,C){return new D([...y.path,C])}static joinToString(y,C){return y.toString()+"\0"+C}static compare(y,C){return y===C?0:C.startsWith(y+"\0")?2:y.startsWith(C+"\0")?3:1}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let y=1;y<=this.viewEnd;y++)yield new D(this.path,y)}compare(y){if(typeof y=="string")return D.compare(this.toString(),y);for(let C=0;C<y.viewEnd&&C<this.viewEnd;C++)if(y.path[C]!==this.path[C])return 1;return y.viewEnd>this.viewEnd?2:y.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let y=1;y<this.viewEnd;y++)this.stringifed+="\0",this.stringifed+=this.path[y]}return this.stringifed}}e.TestId=D}),define(Ie[66],ke([1,0,2,35]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var D;(function(i){i[i.Unset=0]="Unset",i[i.Queued=1]="Queued",i[i.Running=2]="Running",i[i.Passed=3]="Passed",i[i.Failed=4]="Failed",i[i.Skipped=5]="Skipped",i[i.Errored=6]="Errored"})(D=e.TestResultState||(e.TestResultState={}));var P;(function(i){i[i.Run=2]="Run",i[i.Debug=4]="Debug",i[i.Coverage=8]="Coverage",i[i.HasNonDefaultProfile=16]="HasNonDefaultProfile",i[i.HasConfigurable=32]="HasConfigurable"})(P=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var y;(function(i){i.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),i.deserialize=n=>({range:t.Range.lift(n.range),uri:u.URI.revive(n.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var C;(function(i){i[i.Error=0]="Error",i[i.Output=1]="Output"})(C=e.TestMessageType||(e.TestMessageType={}));var E;(function(i){i.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&y.serialize(n.location)}),i.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&y.deserialize(n.location)})})(E=e.ITestErrorMessage||(e.ITestErrorMessage={}));var I;(function(i){i.serialize=n=>({message:n.message,type:1,offset:n.offset,location:n.location&&y.serialize(n.location)}),i.deserialize=n=>({message:n.message,type:1,offset:n.offset,location:n.location&&y.deserialize(n.location)})})(I=e.ITestOutputMessage||(e.ITestOutputMessage={}));var R;(function(i){i.serialize=n=>n.type===0?E.serialize(n):I.serialize(n),i.deserialize=n=>n.type===0?E.deserialize(n):I.deserialize(n)})(R=e.ITestMessage||(e.ITestMessage={}));var k;(function(i){i.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(R.serialize)}),i.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(R.deserialize)})})(k=e.ITestTaskState||(e.ITestTaskState={}));const _="\0",T=(i,n)=>i+_+n;e.namespaceTestTag=T;const w=i=>{const n=i.indexOf(_);return{ctrlId:i.slice(0,n),tagId:i.slice(n+1)}};e.denamespaceTestTag=w;var b;(function(i){i.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),i.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?u.URI.revive(n.uri):void 0,range:n.range?t.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(b=e.ITestItem||(e.ITestItem={}));var g;(function(i){i[i.NotExpandable=0]="NotExpandable",i[i.Expandable=1]="Expandable",i[i.BusyExpanding=2]="BusyExpanding",i[i.Expanded=3]="Expanded"})(g=e.TestItemExpandState||(e.TestItemExpandState={}));var f;(function(i){i.serialize=n=>({controllerId:n.controllerId,expand:n.expand,parent:n.parent,item:b.serialize(n.item)}),i.deserialize=n=>({controllerId:n.controllerId,expand:n.expand,parent:n.parent,item:b.deserialize(n.item)})})(f=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(i){i.serialize=n=>{let s;return n.item&&(s={},n.item.label!==void 0&&(s.label=n.item.label),n.item.tags!==void 0&&(s.tags=n.item.tags),n.item.busy!==void 0&&(s.busy=n.item.busy),n.item.uri!==void 0&&(s.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(s.range=n.item.range?.toJSON()),n.item.description!==void 0&&(s.description=n.item.description),n.item.error!==void 0&&(s.error=n.item.error),n.item.sortText!==void 0&&(s.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:s}},i.deserialize=n=>{let s;return n.item&&(s={},n.item.label!==void 0&&(s.label=n.item.label),n.item.tags!==void 0&&(s.tags=n.item.tags),n.item.busy!==void 0&&(s.busy=n.item.busy),n.item.range!==void 0&&(s.range=n.item.range?t.Range.lift(n.item.range):null),n.item.description!==void 0&&(s.description=n.item.description),n.item.error!==void 0&&(s.error=n.item.error),n.item.sortText!==void 0&&(s.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:s}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const v=(i,n)=>{n.expand!==void 0&&(i.expand=n.expand),n.item!==void 0&&(i.item=i.item?Object.assign(i.item,n.item):n.item)};e.applyTestItemUpdate=v;var c;(function(i){i.serialize=(n,s)=>({...f.serialize(n),children:s,ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(k.serialize)})})(c=e.TestResultItem||(e.TestResultItem={}));var m;(function(i){i[i.Function=0]="Function",i[i.Statement=1]="Statement"})(m=e.DetailType||(e.DetailType={}));var a;(function(i){i[i.Add=0]="Add",i[i.Update=1]="Update",i[i.Remove=2]="Remove",i[i.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",i[i.Retire=4]="Retire",i[i.AddTag=5]="AddTag",i[i.RemoveTag=6]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var d;(function(i){i.deserialize=n=>n.op===0?{op:n.op,item:f.deserialize(n.item)}:n.op===1?{op:n.op,item:p.deserialize(n.item)}:n,i.serialize=n=>n.op===0?{op:n.op,item:f.serialize(n.item)}:n.op===1?{op:n.op,item:p.serialize(n.item)}:n})(d=e.TestsDiffOp||(e.TestsDiffOp={}));class r{add(n){}update(n){}remove(n,s){}complete(){}}e.IncrementalChangeCollector=r;class o{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const s=this.createChangeCollector();for(const l of n)switch(l.op){case 0:{const h=f.deserialize(l.item);if(h.parent){if(this.items.has(h.parent)){const S=this.items.get(h.parent);S.children.add(h.item.extId);const L=this.createItem(h,S);this.items.set(h.item.extId,L),s.add(L)}}else{const S=this.createItem(h);this.roots.add(S),this.items.set(h.item.extId,S),s.add(S)}h.expand===2&&this.busyControllerCount++;break}case 1:{const h=p.deserialize(l.item),S=this.items.get(h.extId);if(!S)break;h.expand!==void 0&&(S.expand===2&&this.busyControllerCount--,h.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(S,h),s.update(S);break}case 2:{const h=this.items.get(l.itemId);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h);const S=[[l.itemId]];for(;S.length;)for(const L of S.pop()){const M=this.items.get(L);M&&(S.push(M.children),this.items.delete(L),s.remove(M,M!==h),M.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(l.itemId);break;case 3:this.updatePendingRoots(l.amount);break;case 5:this._tags.set(l.tag.id,l.tag);break;case 6:this._tags.delete(l.id);break}s.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new r}}e.AbstractIncrementalTestCollection=o}),define(Ie[89],ke([1,0,18,3,6,10,66,65]),function(Y,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk"})(E=e.TestItemEventOp||(e.TestItemEventOp={}));const I=(f,p)=>f===p,R={range:(f,p)=>f===p?!0:!f||!p?!1:f.equalsRange(p),busy:I,label:I,description:I,error:I,tags:(f,p)=>!(f.length!==p.length||f.some(v=>!p.includes(v)))},k=(f,p)=>{let v;for(const[c,m]of Object.entries(R))m(f[c],p[c])||(v?v[c]=p[c]:v={[c]:p[c]});return v};class _ extends D.Disposable{constructor(p){super();this.options=p,this.debounceSendDiff=this._register(new u.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(p){this._resolveHandler=p;for(const v of this.tree.values())this.updateExpandability(v)}collectDiff(){const p=this.diff;return this.diff=[],p}pushDiff(p){const v=this.diff[this.diff.length-1];if(v&&p.op===1){if(v.op===1&&v.item.extId===p.item.extId){(0,y.applyTestItemUpdate)(v.item,p.item);return}if(v.op===0&&v.item.item.extId===p.item.extId){(0,y.applyTestItemUpdate)(v.item,p.item);return}}this.diff.push(p),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(p,v){const c=this.tree.get(p);if(!!c){if((c.expandLevels===void 0||v>c.expandLevels)&&(c.expandLevels=v),c.expand===1){const m=this.resolveChildren(c);return m.isOpen()?this.expandChildren(c,v-1):m.wait().then(()=>this.expandChildren(c,v-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.expandChildren(c,v-1)):this.expandChildren(c,v-1)}}dispose(){for(const p of this.tree.values())this.options.getApiFor(p.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(p,v){switch(v.op){case 3:this.removeItem(C.TestId.joinToString(p.fullId,v.id));break;case 0:this.upsertItem(v.item,p);break;case 5:for(const c of v.ops)this.onTestItemEvent(p,c);break;case 1:this.diffTagRefs(v.new,v.old,p.fullId.toString());break;case 2:this.updateExpandability(p);break;case 4:this.pushDiff({op:1,item:{extId:p.fullId.toString(),item:v.update}});break;default:(0,P.assertNever)(v)}}upsertItem(p,v){const c=C.TestId.fromExtHostTestItem(p,this.root.id,v?.actual),m=this.options.getApiFor(p);m.parent&&m.parent!==v?.actual&&this.options.getChildren(m.parent).delete(p.id);let a=this.tree.get(c.toString());if(!a){a={fullId:c,actual:p,parent:v?c.parentId:null,expandLevels:v?.expandLevels?v.expandLevels-1:void 0,expand:0},p.tags.forEach(this.incrementTagRefs,this),this.tree.set(a.fullId.toString(),a),this.setItemParent(p,v),this.pushDiff({op:0,item:{parent:a.parent&&a.parent.toString(),controllerId:this.options.controllerId,expand:a.expand,item:this.options.toITestItem(p)}}),this.connectItemAndChildren(p,a,v);return}if(a.actual===p){this.connectItem(p,a,v);return}const d=this.options.getChildren(a.actual),r=a.actual,o=k(this.options.toITestItem(r),this.options.toITestItem(p));this.options.getApiFor(r).listener=void 0,a.actual=p,a.expand=0,o&&(o.hasOwnProperty("tags")&&(this.diffTagRefs(p.tags,r.tags,c.toString()),delete o.tags),this.onTestItemEvent(a,{op:4,update:o})),this.connectItemAndChildren(p,a,v);for(const[i,n]of d)this.options.getChildren(p).get(n.id)||this.removeItem(C.TestId.joinToString(c,n.id))}diffTagRefs(p,v,c){const m=new Set(v.map(a=>a.id));for(const a of p)m.delete(a.id)||this.incrementTagRefs(a);this.pushDiff({op:1,item:{extId:c,item:{tags:p.map(a=>(0,y.namespaceTestTag)(this.options.controllerId,a.id))}}}),m.forEach(this.decrementTagRefs,this)}incrementTagRefs(p){const v=this.tags.get(p.id);v?v.refCount++:(this.tags.set(p.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,y.namespaceTestTag)(this.options.controllerId,p.id)}}))}decrementTagRefs(p){const v=this.tags.get(p);v&&!--v.refCount&&(this.tags.delete(p),this.pushDiff({op:6,id:(0,y.namespaceTestTag)(this.options.controllerId,p)}))}setItemParent(p,v){this.options.getApiFor(p).parent=v&&v.actual!==this.root?v.actual:void 0}connectItem(p,v,c){this.setItemParent(p,c);const m=this.options.getApiFor(p);m.parent=c?.actual,m.listener=a=>this.onTestItemEvent(v,a),this.updateExpandability(v)}connectItemAndChildren(p,v,c){this.connectItem(p,v,c);for(const[m,a]of this.options.getChildren(p))this.upsertItem(a,v)}updateExpandability(p){let v;this._resolveHandler?p.resolveBarrier?v=p.resolveBarrier.isOpen()?3:2:v=p.actual.canResolveChildren?1:0:v=0,v!==p.expand&&(p.expand=v,this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:v}}),v===1&&p.expandLevels!==void 0&&this.resolveChildren(p))}expandChildren(p,v){if(v<0)return;const c=[];for(const[m,a]of this.options.getChildren(p.actual)){const d=this.expand(C.TestId.joinToString(p.fullId,a.id),v);(0,u.isThenable)(d)&&c.push(d)}if(c.length)return Promise.all(c).then(()=>{})}resolveChildren(p){if(p.resolveBarrier)return p.resolveBarrier;if(!this._resolveHandler){const a=new u.Barrier;return a.open(),a}p.expand=2,this.pushExpandStateUpdate(p);const v=p.resolveBarrier=new u.Barrier,c=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,a)};let m;try{m=this._resolveHandler(p.actual===this.root?void 0:p.actual)}catch(a){c(a)}return(0,u.isThenable)(m)?m.catch(c).then(()=>{v.open(),this.updateExpandability(p)}):(v.open(),this.updateExpandability(p)),p.resolveBarrier}pushExpandStateUpdate(p){this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:p.expand}})}removeItem(p){const v=this.tree.get(p);if(!v)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:p});const c=[v];for(;c.length;){const m=c.pop();if(!!m){this.options.getApiFor(m.actual).listener=void 0;for(const a of m.actual.tags)this.decrementTagRefs(a.id);this.tree.delete(m.fullId.toString());for(const[a,d]of this.options.getChildren(m.actual))c.push(this.tree.get(C.TestId.joinToString(m.fullId,d.id)))}}}flushDiff(){const p=this.collectDiff();p.length&&this.diffOpEmitter.fire(p)}}e.TestItemCollection=_;class T extends Error{constructor(p){super(`Attempted to insert a duplicate test item ID ${p}`)}}e.DuplicateTestItemError=T;class w extends Error{constructor(p){super(`TestItem with ID "${p}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=w;class b extends Error{constructor(p,v,c){super(`TestItem with ID "${p}" is from controller "${v}" and cannot be added as a child of an item from controller "${c}".`)}}e.MixedTestItemController=b;const g=(f,p,v)=>{let c=new Map;return{get size(){return c.size},forEach(m,a){for(const d of c.values())m.call(a,d,this)},[Symbol.iterator](){return c.entries()},replace(m){const a=new Map,d=new Set(c.keys()),r={op:5,ops:[]};for(const o of m){if(!(o instanceof v))throw new w(o.id);const i=p(o).controllerId;if(i!==f.controllerId)throw new b(o.id,i,f.controllerId);if(a.has(o.id))throw new T(o.id);a.set(o.id,o),d.delete(o.id),r.ops.push({op:0,item:o})}for(const o of d.keys())r.ops.push({op:3,id:o});f.listener?.(r),c=a},add(m){if(!(m instanceof v))throw new w(m.id);c.set(m.id,m),f.listener?.({op:0,item:m})},delete(m){c.delete(m)&&f.listener?.({op:3,id:m})},get(m){return c.get(m)},toJSON(){return Array.from(c.values())}}};e.createTestItemChildren=g}),define(Ie[129],ke([1,0,89]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,D=(y,C)=>{const E={controllerId:C};return t.set(y,E),E};e.createPrivateApiFor=D;const P=y=>{const C=t.get(y);if(!C)throw new u.InvalidTestItemError(y?.id||"<unknown>");return C};e.getPrivateApiFor=P}),define(Ie[220],ke([1,0,9,40,10,24,13,107,185,8]),function(Y,e,u,t,D,P,y,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(_,T,w,b){this._contributedVariables=new Map,this._context=_,this._labelService=T,this._userHomePromise=w,b&&(this._envVariablesPromise=b.then(g=>this.prepareEnv(g)))}prepareEnv(_){if(y.isWindows){const T=Object.create(null);return Object.keys(_).forEach(w=>{T[w.toLowerCase()]=_[w]}),T}return _}resolveWithEnvironment(_,T,w){return this.recursiveResolve({env:this.prepareEnv(_),userHome:void 0},T?T.uri:void 0,w)}async resolveAsync(_,T){const w={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(w,_?_.uri:void 0,T)}async resolveAnyBase(_,T,w,b){const g=P.deepClone(T);y.isWindows&&g.windows?Object.keys(g.windows).forEach(p=>g[p]=g.windows[p]):y.isMacintosh&&g.osx?Object.keys(g.osx).forEach(p=>g[p]=g.osx[p]):y.isLinux&&g.linux&&Object.keys(g.linux).forEach(p=>g[p]=g.linux[p]),delete g.windows,delete g.osx,delete g.linux;const f={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(f,_?_.uri:void 0,g,w,b)}async resolveAnyAsync(_,T,w){return this.resolveAnyBase(_,T,w)}async resolveAnyMap(_,T,w){const b=new Map;return{newConfig:await this.resolveAnyBase(_,T,w,b),resolvedVariables:b}}resolveWithInteractionReplace(_,T,w,b){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,T,w,b){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,T){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,T)}async recursiveResolve(_,T,w,b,g){if(D.isString(w))return this.resolveString(_,T,w,b,g);if(D.isArray(w))return Promise.all(w.map(f=>this.recursiveResolve(_,T,f,b,g)));if(D.isObject(w)){const f=Object.create(null),p=await Promise.all(Object.keys(w).map(async v=>[await this.resolveString(_,T,v,b,g),await this.recursiveResolve(_,T,w[v],b,g)]));for(const[v,c]of p)f[v]=c;return f}return w}resolveString(_,T,w,b,g){return(0,I.replaceAsync)(w,R.VARIABLE_REGEXP,async(f,p)=>{if(p.includes(R.VARIABLE_LHS))return f;let v=await this.evaluateSingleVariable(_,f,p,T,b);return g?.set(p,v),v!==f&&D.isString(v)&&v.match(R.VARIABLE_REGEXP)&&(v=await this.resolveString(_,T,v,b,g)),v})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}async evaluateSingleVariable(_,T,w,b,g){let f;const p=w.split(":");p.length>1&&(w=p[0],f=p[1]);const v=()=>{const a=this._context.getFilePath();if(a)return a;throw new Error((0,E.localize)(0,null,T))},c=()=>{const a=v();if(this._context.getWorkspaceFolderPathForFile){const d=this._context.getWorkspaceFolderPathForFile();if(d)return d}throw new Error((0,E.localize)(1,null,T,u.basename(a)))},m=()=>{if(f){const a=this._context.getFolderUri(f);if(a)return a;throw new Error((0,E.localize)(2,null,T,f))}if(b)return b;throw this._context.getWorkspaceFolderCount()>1?new Error((0,E.localize)(3,null,T)):new Error((0,E.localize)(4,null,T))};switch(w){case"env":if(f){if(_.env){const a=_.env[y.isWindows?f.toLowerCase():f];if(D.isString(a))return a}return""}throw new Error((0,E.localize)(5,null,T));case"config":if(f){const a=this._context.getConfigurationValue(b,f);if(D.isUndefinedOrNull(a))throw new Error((0,E.localize)(6,null,T,f));if(D.isObject(a))throw new Error((0,E.localize)(7,null,T,f));return a}throw new Error((0,E.localize)(8,null,T));case"command":return this.resolveFromMap(T,f,g,"command");case"input":return this.resolveFromMap(T,f,g,"input");case"extensionInstallFolder":if(f){const a=await this._context.getExtension(f);if(!a)throw new Error((0,E.localize)(9,null,T,f));return this.fsPath(a.extensionLocation)}throw new Error((0,E.localize)(10,null,T));default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(m()));case"cwd":return b||f?(0,C.normalizeDriveLetter)(this.fsPath(m())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return u.basename(this.fsPath(m()));case"userHome":{if(_.userHome)return _.userHome;throw new Error((0,E.localize)(11,null,T))}case"lineNumber":{const a=this._context.getLineNumber();if(a)return a;throw new Error((0,E.localize)(12,null,T))}case"selectedText":{const a=this._context.getSelectedText();if(a)return a;throw new Error((0,E.localize)(13,null,T))}case"file":return v();case"fileWorkspaceFolder":return c();case"relativeFile":return b||f?u.relative(this.fsPath(m()),v()):v();case"relativeFileDirname":{const a=u.dirname(v());if(b||f){const d=u.relative(this.fsPath(m()),a);return d.length===0?".":d}return a}case"fileDirname":return u.dirname(v());case"fileExtname":return u.extname(v());case"fileBasename":return u.basename(v());case"fileBasenameNoExtension":{const a=u.basename(v());return a.slice(0,a.length-u.extname(a).length)}case"fileDirnameBasename":return u.basename(u.dirname(v()));case"execPath":{const a=this._context.getExecPath();return a||T}case"execInstallFolder":{const a=this._context.getAppRoot();return a||T}case"pathSeparator":return u.sep;default:try{const a=f?`${w}:${f}`:w;return this.resolveFromMap(T,a,g,void 0)}catch{return T}}}}resolveFromMap(_,T,w,b){if(T&&w){const g=b===void 0?w[T]:w[b+":"+T];if(typeof g=="string")return g;throw new Error((0,E.localize)(14,null,_))}return _}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ie[130],ke([1,0,4,211]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,u.createDecorator)("editorGroupsService");var D;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var P;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var C;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function I(w){const b=w;return(0,t.isEditorInput)(b?.editor)&&(0,t.isEditorInput)(b?.replacement)}e.isEditorReplacement=I;var R;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function _(w){const b=w;return!!b&&typeof b.id=="number"&&Array.isArray(b.editors)}e.isEditorGroup=_;function T(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(Ie[221],ke([1,0,4,130]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,u.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(P){const y=P;return typeof P=="number"||(0,t.isEditorGroup)(y)}e.isPreferredGroup=D}),define(Ie[15],ke([1,0,16,23,106,25,143,61,24,10,2,35,63,188,117,129,128,65,66,221,7,58]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g,f,p,v,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(Pe){function Le(ne){const{selectionStartLineNumber:Fe,selectionStartColumn:He,positionLineNumber:et,positionColumn:Ze}=ne,Je=new c.Position(Fe-1,He-1),bt=new c.Position(et-1,Ze-1);return new c.Selection(Je,bt)}Pe.to=Le;function Se(ne){const{anchor:Fe,active:He}=ne;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Pe.from=Se})(a=e.Selection||(e.Selection={}));var d;(function(Pe){function Le(ne){if(!ne)return;const{start:Fe,end:He}=ne;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Pe.from=Le;function Se(ne){if(!ne)return;const{startLineNumber:Fe,startColumn:He,endLineNumber:et,endColumn:Ze}=ne;return new c.Range(Fe-1,He-1,et-1,Ze-1)}Pe.to=Se})(d=e.Range||(e.Range={}));var r;(function(Pe){function Le(Se){switch(Se){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 3:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}Pe.to=Le})(r=e.TokenType||(e.TokenType={}));var o;(function(Pe){function Le(ne){return new c.Position(ne.lineNumber-1,ne.column-1)}Pe.to=Le;function Se(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Pe.from=Se})(o=e.Position||(e.Position={}));var i;(function(Pe){function Le(Fe,He){return(0,u.coalesce)((0,u.asArray)(Fe).map(et=>Se(et,He)))}Pe.from=Le;function Se(Fe,He){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ne(Fe.scheme,He),pattern:ce.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function ne(Fe,He){return He&&typeof Fe=="string"?He.transformOutgoingScheme(Fe):Fe}})(i=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(Pe){function Le(ne){switch(ne){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}Pe.from=Le;function Se(ne){switch(ne){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}Pe.to=Se})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(Pe){function Le(ne){let Fe;return ne.code&&((0,I.isString)(ne.code)||(0,I.isNumber)(ne.code)?Fe=String(ne.code):Fe={value:String(ne.code.value),target:ne.code.target}),{...d.from(ne.range),message:ne.message,source:ne.source,code:Fe,severity:h.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(l.from),tags:Array.isArray(ne.tags)?(0,u.coalesce)(ne.tags.map(n.from)):void 0}}Pe.from=Le;function Se(ne){const Fe=new c.Diagnostic(d.to(ne),ne.message,h.to(ne.severity));return Fe.source=ne.source,Fe.code=(0,I.isString)(ne.code)?ne.code:ne.code?.value,Fe.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(l.to),Fe.tags=ne.tags&&(0,u.coalesce)(ne.tags.map(n.to)),Fe}Pe.to=Se})(s=e.Diagnostic||(e.Diagnostic={}));var l;(function(Pe){function Le(ne){return{...d.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Pe.from=Le;function Se(ne){return new c.DiagnosticRelatedInformation(new c.Location(ne.resource,d.to(ne)),ne.message)}Pe.to=Se})(l=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var h;(function(Pe){function Le(ne){switch(ne){case c.DiagnosticSeverity.Error:return w.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return w.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return w.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return w.MarkerSeverity.Hint}return w.MarkerSeverity.Error}Pe.from=Le;function Se(ne){switch(ne){case w.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case w.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case w.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case w.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}Pe.to=Se})(h=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var S;(function(Pe){function Le(ne){return typeof ne=="number"&&ne>=c.ViewColumn.One?ne-1:ne===c.ViewColumn.Beside?v.SIDE_GROUP:v.ACTIVE_GROUP}Pe.from=Le;function Se(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=Se})(S=e.ViewColumn||(e.ViewColumn={}));function L(Pe){return typeof Pe.range!="undefined"}function M(Pe){return Pe.length===0?!0:!!L(Pe[0])}e.isDecorationOptionsArr=M;var F;(function(Pe){function Le(Ze){return Ze.map(Pe.from)}Pe.fromMany=Le;function Se(Ze){return Ze&&typeof Ze=="object"&&typeof Ze.language=="string"&&typeof Ze.value=="string"}function ne(Ze){let Je;if(Se(Ze)){const{language:mt,value:ht}=Ze;Je={value:"```"+mt+`
`+ht+"\n```\n"}}else c.MarkdownString.isMarkdownString(Ze)?Je={value:Ze.value,isTrusted:Ze.isTrusted,supportThemeIcons:Ze.supportThemeIcons,supportHtml:Ze.supportHtml,baseUri:Ze.baseUri}:typeof Ze=="string"?Je={value:Ze}:Je={value:""};const bt=Object.create(null);Je.uris=bt;const Et=mt=>{try{let ht=R.URI.parse(mt,!0);ht=ht.with({query:Fe(ht.query,bt)}),bt[mt]=ht}catch{}return""},St=new y.marked.Renderer;return St.link=Et,St.image=mt=>typeof mt=="string"?Et(D.parseHrefAndDimensions(mt).href):"",(0,y.marked)(Je.value,{renderer:St}),Je}Pe.from=ne;function Fe(Ze,Je){if(!Ze)return Ze;let bt;try{bt=(0,C.parse)(Ze)}catch{}if(!bt)return Ze;let Et=!1;return bt=(0,E.cloneAndChange)(bt,St=>{if(R.URI.isUri(St)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Je[mt]=St,Et=!0,mt}else return}),Et?JSON.stringify(bt):Ze}function He(Ze){const Je=new c.MarkdownString(Ze.value,Ze.supportThemeIcons);return Je.isTrusted=Ze.isTrusted,Je.supportHtml=Ze.supportHtml,Je.baseUri=Ze.baseUri?R.URI.from(Ze.baseUri):void 0,Je}Pe.to=He;function et(Ze){if(!!Ze)return typeof Ze=="string"?Ze:Pe.from(Ze)}Pe.fromStrict=et})(F=e.MarkdownString||(e.MarkdownString={}));function A(Pe){return M(Pe)?Pe.map(Le=>({range:d.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?F.fromMany(Le.hoverMessage):Le.hoverMessage?F.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Pe.map(Le=>({range:d.from(Le)}))}e.fromRangeOrRangeWithMessage=A;function B(Pe){return typeof Pe=="undefined"?Pe:typeof Pe=="string"?R.URI.file(Pe):Pe}e.pathOrURIToURI=B;var $;(function(Pe){function Le(Se){return typeof Se=="undefined"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?B(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Pe.from=Le})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var U;(function(Pe){function Le(Se){return typeof Se=="undefined"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?B(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?$.from(Se.before):void 0,after:Se.after?$.from(Se.after):void 0}}Pe.from=Le})(U=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var K;(function(Pe){function Le(Se){if(typeof Se=="undefined")return Se;switch(Se){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=Le})(K=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var W;(function(Pe){function Le(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?K.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?U.from(Se.light):void 0,dark:Se.dark?U.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?B(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?$.from(Se.before):void 0,after:Se.after?$.from(Se.after):void 0}}Pe.from=Le})(W=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(Pe){function Le(ne){return{text:ne.newText,eol:ne.newEol&&Ye.from(ne.newEol),range:d.from(ne.range)}}Pe.from=Le;function Se(ne){const Fe=new c.TextEdit(d.to(ne.range),ne.text);return Fe.newEol=typeof ne.eol=="undefined"?void 0:Ye.to(ne.eol),Fe}Pe.to=Se})(N=e.TextEdit||(e.TextEdit={}));var V;(function(Pe){function Le(ne,Fe,He){const et={edits:[]};if(ne instanceof c.WorkspaceEdit){const Ze=new P.ResourceSet;for(const Je of ne._allEntries())Je._type===1&&R.URI.isUri(Je.to)&&Je.from===void 0&&Ze.add(Je.to);for(const Je of ne._allEntries())if(Je._type===1)et.edits.push({oldResource:Je.from,newResource:Je.to,options:Je.options,metadata:Je.metadata});else if(Je._type===2)et.edits.push({resource:Je.uri,textEdit:N.from(Je.edit),versionId:Ze.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata});else if(Je._type===6){if(!He){console.warn("DROPPING snippet text edit because proposal IS NOT ENABLED",Je);continue}et.edits.push({resource:Je.uri,textEdit:{range:d.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:Ze.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata})}else Je._type===3?et.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&et.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(ot.from)}})}return et}Pe.from=Le;function Se(ne){const Fe=new c.WorkspaceEdit;for(const He of ne.edits)He.textEdit?Fe.replace(R.URI.revive(He.resource),d.to(He.textEdit.range),He.textEdit.text):Fe.renameFile(R.URI.revive(He.oldResource),R.URI.revive(He.newResource),He.options);return Fe}Pe.to=Se})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var x;(function(Pe){const Le=Object.create(null);Le[c.SymbolKind.File]=0,Le[c.SymbolKind.Module]=1,Le[c.SymbolKind.Namespace]=2,Le[c.SymbolKind.Package]=3,Le[c.SymbolKind.Class]=4,Le[c.SymbolKind.Method]=5,Le[c.SymbolKind.Property]=6,Le[c.SymbolKind.Field]=7,Le[c.SymbolKind.Constructor]=8,Le[c.SymbolKind.Enum]=9,Le[c.SymbolKind.Interface]=10,Le[c.SymbolKind.Function]=11,Le[c.SymbolKind.Variable]=12,Le[c.SymbolKind.Constant]=13,Le[c.SymbolKind.String]=14,Le[c.SymbolKind.Number]=15,Le[c.SymbolKind.Boolean]=16,Le[c.SymbolKind.Array]=17,Le[c.SymbolKind.Object]=18,Le[c.SymbolKind.Key]=19,Le[c.SymbolKind.Null]=20,Le[c.SymbolKind.EnumMember]=21,Le[c.SymbolKind.Struct]=22,Le[c.SymbolKind.Event]=23,Le[c.SymbolKind.Operator]=24,Le[c.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Le[Fe]=="number"?Le[Fe]:6}Pe.from=Se;function ne(Fe){for(const He in Le)if(Le[He]===Fe)return Number(He);return c.SymbolKind.Property}Pe.to=ne})(x=e.SymbolKind||(e.SymbolKind={}));var q;(function(Pe){function Le(ne){switch(ne){case c.SymbolTag.Deprecated:return 1}}Pe.from=Le;function Se(ne){switch(ne){case 1:return c.SymbolTag.Deprecated}}Pe.to=Se})(q=e.SymbolTag||(e.SymbolTag={}));var te;(function(Pe){function Le(ne){return{name:ne.name,kind:x.from(ne.kind),tags:ne.tags&&ne.tags.map(q.from),containerName:ne.containerName,location:ge.from(ne.location)}}Pe.from=Le;function Se(ne){const Fe=new c.SymbolInformation(ne.name,x.to(ne.kind),ne.containerName,ge.to(ne.location));return Fe.tags=ne.tags&&ne.tags.map(q.to),Fe}Pe.to=Se})(te=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Q;(function(Pe){function Le(ne){const Fe={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:d.from(ne.range),selectionRange:d.from(ne.selectionRange),kind:x.from(ne.kind),tags:ne.tags?.map(q.from)??[]};return ne.children&&(Fe.children=ne.children.map(Le)),Fe}Pe.from=Le;function Se(ne){const Fe=new c.DocumentSymbol(ne.name,ne.detail,x.to(ne.kind),d.to(ne.range),d.to(ne.selectionRange));return(0,u.isNonEmptyArray)(ne.tags)&&(Fe.tags=ne.tags.map(q.to)),ne.children&&(Fe.children=ne.children.map(Se)),Fe}Pe.to=Se})(Q=e.DocumentSymbol||(e.DocumentSymbol={}));var le;(function(Pe){function Le(ne){const Fe=new c.CallHierarchyItem(x.to(ne.kind),ne.name,ne.detail||"",R.URI.revive(ne.uri),d.to(ne.range),d.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Pe.to=Le;function Se(ne,Fe,He){if(Fe=Fe??ne._sessionId,He=He??ne._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,name:ne.name,detail:ne.detail,kind:x.from(ne.kind),uri:ne.uri,range:d.from(ne.range),selectionRange:d.from(ne.selectionRange),tags:ne.tags?.map(q.from)}}Pe.from=Se})(le=e.CallHierarchyItem||(e.CallHierarchyItem={}));var pe;(function(Pe){function Le(Se){return new c.CallHierarchyIncomingCall(le.to(Se.from),Se.fromRanges.map(ne=>d.to(ne)))}Pe.to=Le})(pe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Z;(function(Pe){function Le(Se){return new c.CallHierarchyOutgoingCall(le.to(Se.to),Se.fromRanges.map(ne=>d.to(ne)))}Pe.to=Le})(Z=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ge;(function(Pe){function Le(ne){return{range:ne.range&&d.from(ne.range),uri:ne.uri}}Pe.from=Le;function Se(ne){return new c.Location(R.URI.revive(ne.uri),d.to(ne.range))}Pe.to=Se})(ge=e.location||(e.location={}));var Ee;(function(Pe){function Le(ne){const Fe=ne,He=ne;return{originSelectionRange:Fe.originSelectionRange?d.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:He.uri,range:d.from(Fe.targetRange?Fe.targetRange:He.range),targetSelectionRange:Fe.targetSelectionRange?d.from(Fe.targetSelectionRange):void 0}}Pe.from=Le;function Se(ne){return{targetUri:R.URI.revive(ne.uri),targetRange:d.to(ne.range),targetSelectionRange:ne.targetSelectionRange?d.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?d.to(ne.originSelectionRange):void 0}}Pe.to=Se})(Ee=e.DefinitionLink||(e.DefinitionLink={}));var Te;(function(Pe){function Le(ne){return{range:d.from(ne.range),contents:F.fromMany(ne.contents)}}Pe.from=Le;function Se(ne){return new c.Hover(ne.contents.map(F.to),d.to(ne.range))}Pe.to=Se})(Te=e.Hover||(e.Hover={}));var Oe;(function(Pe){function Le(ne){return{range:d.from(ne.range),expression:ne.expression}}Pe.from=Le;function Se(ne){return new c.EvaluatableExpression(d.to(ne.range),ne.expression)}Pe.to=Se})(Oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ve;(function(Pe){function Le(ne){if(ne instanceof c.InlineValueText)return{type:"text",range:d.from(ne.range),text:ne.text};if(ne instanceof c.InlineValueVariableLookup)return{type:"variable",range:d.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof c.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=Le;function Se(ne){switch(ne.type){case"text":return{range:d.to(ne.range),text:ne.text};case"variable":return{range:d.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:d.to(ne.range),expression:ne.expression}}}Pe.to=Se})(ve=e.InlineValue||(e.InlineValue={}));var ue;(function(Pe){function Le(ne){return{frameId:ne.frameId,stoppedLocation:d.from(ne.stoppedLocation)}}Pe.from=Le;function Se(ne){return new c.InlineValueContext(ne.frameId,d.to(ne.stoppedLocation))}Pe.to=Se})(ue=e.InlineValueContext||(e.InlineValueContext={}));var de;(function(Pe){function Le(ne){return{range:d.from(ne.range),kind:ne.kind}}Pe.from=Le;function Se(ne){return new c.DocumentHighlight(d.to(ne.range),ne.kind)}Pe.to=Se})(de=e.DocumentHighlight||(e.DocumentHighlight={}));var we;(function(Pe){function Le(Se){switch(Se){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}Pe.to=Le})(we=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ie;(function(Pe){function Le(Se){return{triggerKind:we.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Pe.to=Le})(ie=e.CompletionContext||(e.CompletionContext={}));var me;(function(Pe){function Le(ne){switch(ne){case c.CompletionItemTag.Deprecated:return 1}}Pe.from=Le;function Se(ne){switch(ne){case 1:return c.CompletionItemTag.Deprecated}}Pe.to=Se})(me=e.CompletionItemTag||(e.CompletionItemTag={}));var J;(function(Pe){const Le=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function Se(He){return Le.get(He)??9}Pe.from=Se;const ne=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Fe(He){return ne.get(He)??c.CompletionItemKind.Property}Pe.to=Fe})(J=e.CompletionItemKind||(e.CompletionItemKind={}));var re;(function(Pe){function Le(Se,ne){const Fe=new c.CompletionItem(Se.label);return Fe.insertText=Se.insertText,Fe.kind=J.to(Se.kind),Fe.tags=Se.tags?.map(me.to),Fe.detail=Se.detail,Fe.documentation=D.isMarkdownString(Se.documentation)?F.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,k.Range.isIRange(Se.range)?Fe.range=d.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:d.to(Se.range.insert),replacing:d.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules=="undefined"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules!="undefined"&&Se.insertTextRules&4?Fe.insertText=new c.SnippetString(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof c.Range?new c.TextEdit(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map(He=>N.to(He))),Fe.command=ne&&Se.command?ne.fromInternal(Se.command):void 0,Fe}Pe.to=Le})(re=e.CompletionItem||(e.CompletionItem={}));var O;(function(Pe){function Le(ne){return{label:ne.label,documentation:F.fromStrict(ne.documentation)}}Pe.from=Le;function Se(ne){return{label:ne.label,documentation:D.isMarkdownString(ne.documentation)?F.to(ne.documentation):ne.documentation}}Pe.to=Se})(O=e.ParameterInformation||(e.ParameterInformation={}));var H;(function(Pe){function Le(ne){return{label:ne.label,documentation:F.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map(O.from):[],activeParameter:ne.activeParameter}}Pe.from=Le;function Se(ne){return{label:ne.label,documentation:D.isMarkdownString(ne.documentation)?F.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map(O.to):[],activeParameter:ne.activeParameter}}Pe.to=Se})(H=e.SignatureInformation||(e.SignatureInformation={}));var G;(function(Pe){function Le(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(H.from):[]}}Pe.from=Le;function Se(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(H.to):[]}}Pe.to=Se})(G=e.SignatureHelp||(e.SignatureHelp={}));var X;(function(Pe){function Le(Se,ne){const Fe=new c.InlayHint(o.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(he.to.bind(void 0,Se)),ne.kind&&be.to(ne.kind));return Fe.textEdits=ne.textEdits&&ne.textEdits.map(N.to),Fe.tooltip=D.isMarkdownString(ne.tooltip)?F.to(ne.tooltip):ne.tooltip,Fe.paddingLeft=ne.paddingLeft,Fe.paddingRight=ne.paddingRight,Fe}Pe.to=Le})(X=e.InlayHint||(e.InlayHint={}));var he;(function(Pe){function Le(Se,ne){const Fe=new c.InlayHintLabelPart(ne.label);return Fe.tooltip=D.isMarkdownString(ne.tooltip)?F.to(ne.tooltip):ne.tooltip,_.Command.is(ne.command)&&(Fe.command=Se.fromInternal(ne.command)),ne.location&&(Fe.location=ge.to(ne.location)),Fe}Pe.to=Le})(he=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var be;(function(Pe){function Le(ne){return ne}Pe.from=Le;function Se(ne){return ne}Pe.to=Se})(be=e.InlayHintKind||(e.InlayHintKind={}));var ae;(function(Pe){function Le(ne){return{range:d.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Pe.from=Le;function Se(ne){let Fe;if(ne.url)try{Fe=typeof ne.url=="string"?R.URI.parse(ne.url,!0):R.URI.revive(ne.url)}catch{}return new c.DocumentLink(d.to(ne.range),Fe)}Pe.to=Se})(ae=e.DocumentLink||(e.DocumentLink={}));var De;(function(Pe){function Le(ne){const Fe=new c.ColorPresentation(ne.label);return ne.textEdit&&(Fe.textEdit=N.to(ne.textEdit)),ne.additionalTextEdits&&(Fe.additionalTextEdits=ne.additionalTextEdits.map(He=>N.to(He))),Fe}Pe.to=Le;function Se(ne){return{label:ne.label,textEdit:ne.textEdit?N.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Fe=>N.from(Fe)):void 0}}Pe.from=Se})(De=e.ColorPresentation||(e.ColorPresentation={}));var Ce;(function(Pe){function Le(ne){return new c.Color(ne[0],ne[1],ne[2],ne[3])}Pe.to=Le;function Se(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Pe.from=Se})(Ce=e.Color||(e.Color={}));var ze;(function(Pe){function Le(ne){return{range:d.from(ne.range)}}Pe.from=Le;function Se(ne){return new c.SelectionRange(d.to(ne.range))}Pe.to=Se})(ze=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(Pe){function Le(Se){switch(Se){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}Pe.to=Le})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ne;(function(Pe){function Le(ne){switch(ne){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=Le;function Se(ne){switch(ne){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 1:default:return c.TextEditorLineNumbersStyle.On}}Pe.to=Se})(Ne=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ye;(function(Pe){function Le(ne){if(ne===c.EndOfLine.CRLF)return 1;if(ne===c.EndOfLine.LF)return 0}Pe.from=Le;function Se(ne){if(ne===1)return c.EndOfLine.CRLF;if(ne===0)return c.EndOfLine.LF}Pe.to=Se})(Ye=e.EndOfLine||(e.EndOfLine={}));var ee;(function(Pe){function Le(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=Le})(ee=e.ProgressLocation||(e.ProgressLocation={}));var oe;(function(Pe){function Le(Se){const ne={start:Se.start+1,end:Se.end+1};return Se.kind&&(ne.kind=ye.from(Se.kind)),ne}Pe.from=Le})(oe=e.FoldingRange||(e.FoldingRange={}));var ye;(function(Pe){function Le(Se){if(Se)switch(Se){case c.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}Pe.from=Le})(ye=e.FoldingRangeKind||(e.FoldingRangeKind={}));var We;(function(Pe){function Le(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?d.from(Se.selection):void 0,override:typeof Se.override=="boolean"?T.EditorResolution.DISABLED:void 0}}Pe.from=Le})(We=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ce;(function(Pe){function Le(He){return He instanceof c.RelativePattern?He.toJSON():typeof He=="string"?He:Se(He)||ne(He)?new c.RelativePattern(He.baseUri??He.base,He.pattern).toJSON():He}Pe.from=Le;function Se(He){const et=He;return et?R.URI.isUri(et.baseUri)&&typeof et.pattern=="string":!1}function ne(He){const et=He;return et?typeof et.base=="string"&&typeof et.pattern=="string":!1}function Fe(He){return typeof He=="string"?He:new c.RelativePattern(R.URI.revive(He.baseUri),He.pattern)}Pe.to=Fe})(ce=e.GlobPattern||(e.GlobPattern={}));var Ae;(function(Pe){function Le(Se){if(Se){if(Array.isArray(Se))return Se.map(Le);if(typeof Se=="string")return Se;{const ne=Se;return{language:ne.language,scheme:ne.scheme,pattern:ce.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Pe.from=Le})(Ae=e.LanguageSelector||(e.LanguageSelector={}));var Be;(function(Pe){function Le(ne){return{start:ne.start,end:ne.end}}Pe.from=Le;function Se(ne){return new c.NotebookRange(ne.start,ne.end)}Pe.to=Se})(Be=e.NotebookRange||(e.NotebookRange={}));var qe;(function(Pe){function Le(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Pe.to=Le;function Se(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Pe.from=Se})(qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(Pe){function Le(Se){if(Se===g.NotebookCellExecutionState.Executing)return c.NotebookCellExecutionState.Executing;if(Se===g.NotebookCellExecutionState.Pending)return c.NotebookCellExecutionState.Pending;if(Se===g.NotebookCellExecutionState.Unconfirmed)return c.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${Se}`)}Pe.to=Le})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ve;(function(Pe){function Le(ne){switch(ne){case c.NotebookCellKind.Markup:return g.CellKind.Markup;case c.NotebookCellKind.Code:default:return g.CellKind.Code}}Pe.from=Le;function Se(ne){switch(ne){case g.CellKind.Markup:return c.NotebookCellKind.Markup;case g.CellKind.Code:default:return c.NotebookCellKind.Code}}Pe.to=Se})(Ve=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(Pe){function Le(ne){const Fe={metadata:ne.metadata??Object.create(null),cells:[]};for(const He of ne.cells)c.NotebookCellData.validate(He),Fe.cells.push(ot.from(He));return Fe}Pe.from=Le;function Se(ne){const Fe=new c.NotebookData(ne.cells.map(ot.to));return(0,I.isEmptyObject)(ne.metadata)||(Fe.metadata=ne.metadata),Fe}Pe.to=Se})(nt=e.NotebookData||(e.NotebookData={}));var ot;(function(Pe){function Le(ne){return{cellKind:Ve.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:qe.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(it.from):[]}}Pe.from=Le;function Se(ne){return new c.NotebookCellData(Ve.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(it.to):void 0,ne.metadata,ne.internalMetadata?qe.to(ne.internalMetadata):void 0)}Pe.to=Se})(ot=e.NotebookCellData||(e.NotebookCellData={}));var st;(function(Pe){function Le(ne){return{mime:ne.mime,valueBytes:t.VSBuffer.wrap(ne.data)}}Pe.from=Le;function Se(ne){return new c.NotebookCellOutputItem(ne.valueBytes.buffer,ne.mime)}Pe.to=Se})(st=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var it;(function(Pe){function Le(ne){return{outputId:ne.id,items:ne.items.map(st.from),metadata:ne.metadata}}Pe.from=Le;function Se(ne){const Fe=ne.items.map(st.to);return new c.NotebookCellOutput(Fe,ne.outputId,ne.metadata)}Pe.to=Se})(it=e.NotebookCellOutput||(e.NotebookCellOutput={}));var at;(function(Pe){function Le(Fe){return ne(Fe)?{include:(0,I.withNullAsUndefined)(ce.from(Fe.include)),exclude:(0,I.withNullAsUndefined)(ce.from(Fe.exclude))}:(0,I.withNullAsUndefined)(ce.from(Fe))}Pe.from=Le;function Se(Fe){return ne(Fe)?{include:ce.to(Fe.include),exclude:ce.to(Fe.exclude)}:ce.to(Fe)}Pe.to=Se;function ne(Fe){const He=Fe;return He?!(0,I.isUndefinedOrNull)(He.include)&&!(0,I.isUndefinedOrNull)(He.exclude):!1}})(at=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var vt;(function(Pe){function Le(Se,ne,Fe){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(He,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Pe.from=Le})(vt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Pt;(function(Pe){function Le(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{}}}Pe.from=Le})(Pt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var yt;(function(Pe){function Le(ne){return{uri:ne.uri,provides:ne.provides}}Pe.from=Le;function Se(ne){return new c.NotebookRendererScript(R.URI.revive(ne.uri),ne.provides)}Pe.to=Se})(yt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(Pe){function Le(ne){return{message:F.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,location:ne.location&&{range:d.from(ne.location.range),uri:ne.location.uri}}}Pe.from=Le;function Se(ne){const Fe=new c.TestMessage(typeof ne.message=="string"?ne.message:F.to(ne.message));return Fe.actualOutput=ne.actual,Fe.expectedOutput=ne.expected,Fe.location=ne.location?ge.to(ne.location):void 0,Fe}Pe.to=Se})(ft=e.TestMessage||(e.TestMessage={}));var kt;(function(Pe){Pe.namespace=p.namespaceTestTag,Pe.denamespace=p.denamespaceTestTag})(kt=e.TestTag||(e.TestTag={}));var Mt;(function(Pe){function Le(ne){const Fe=(0,b.getPrivateApiFor)(ne).controllerId;return{extId:f.TestId.fromExtHostTestItem(ne,Fe).toString(),label:ne.label,uri:R.URI.revive(ne.uri),busy:!1,tags:ne.tags.map(He=>kt.namespace(Fe,He.id)),range:k.Range.lift(d.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&F.fromStrict(ne.error)||null}}Pe.from=Le;function Se(ne){return{parent:void 0,error:void 0,id:f.TestId.fromString(ne.extId).localId,label:ne.label,uri:R.URI.revive(ne.uri),tags:(ne.tags||[]).map(Fe=>{const{tagId:He}=kt.denamespace(Fe);return new c.TestTag(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(ne.range||void 0),canResolveChildren:!1,busy:!1,description:ne.description||void 0,sortText:ne.sortText||void 0}}Pe.toPlain=Se})(Mt=e.TestItem||(e.TestItem={})),function(Pe){function Le(ne){return{id:ne.id}}Pe.from=Le;function Se(ne){return new c.TestTag(ne.id)}Pe.to=Se}(kt=e.TestTag||(e.TestTag={}));var Lt;(function(Pe){const Le=(ne,Fe)=>{const He={...Mt.toPlain(ne.item),parent:void 0,taskStates:ne.tasks.map(et=>({state:et.state,duration:et.duration,messages:et.messages.filter(Ze=>Ze.type===0).map(ft.to)})),children:ne.children.map(et=>Fe.get(et)).filter(I.isDefined).map(et=>Le(et,Fe))};for(const et of He.children)et.parent=He;return He};function Se(ne){const Fe=[],He=new Map;for(const et of ne.items)He.set(et.item.extId,et),ne.request.targets.some(Ze=>Ze.controllerId===et.controllerId&&Ze.testIds.includes(et.item.extId))&&Fe.push(et);return{completedAt:ne.completedAt,results:Fe.map(et=>Le(et,He))}}Pe.to=Se})(Lt=e.TestResults||(e.TestResults={}));var Xe;(function(Pe){function Le(He){return{covered:He.covered,total:He.covered}}function Se(He){return"line"in He?o.from(He):d.from(He)}function ne(He){return"branches"in He?{count:He.executionCount,location:Se(He.location),type:1,branches:He.branches.length?He.branches.map(et=>({count:et.executionCount,location:et.location&&Se(et.location)})):void 0}:{type:0,count:He.executionCount,location:Se(He.location)}}Pe.fromDetailed=ne;function Fe(He){return{uri:He.uri,statement:Le(He.statementCoverage),branch:He.branchCoverage&&Le(He.branchCoverage),function:He.functionCoverage&&Le(He.functionCoverage),details:He.detailedCoverage?.map(ne)}}Pe.fromFile=Fe})(Xe=e.TestCoverage||(e.TestCoverage={}));var At;(function(Pe){function Le(Se){switch(Se){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}Pe.to=Le})(At=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Nt;(function(Pe){function Le(ne){const Fe=new c.TypeHierarchyItem(x.to(ne.kind),ne.name,ne.detail||"",R.URI.revive(ne.uri),d.to(ne.range),d.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Pe.to=Le;function Se(ne,Fe,He){if(Fe=Fe??ne._sessionId,He=He??ne._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,kind:x.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:d.from(ne.range),selectionRange:d.from(ne.selectionRange),tags:ne.tags?.map(q.from)}}Pe.from=Se})(Nt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ot;(function(Pe){function Le(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Pe.from=Le})(Ot=e.ViewBadge||(e.ViewBadge={}));var gt;(function(Pe){function Le(Se,ne){const Fe=Se.fileData;return Fe?new class extends c.DataTransferItem{asFile(){return{name:Fe.name,uri:R.URI.revive(Fe.uri),data:(0,m.once)(()=>ne())}}}(""):new c.DataTransferItem(Se.asString)}Pe.toDataTransferItem=Le})(gt=e.DataTransferItem||(e.DataTransferItem={}));var Dt;(function(Pe){function Le(ne,Fe){const He=ne.items.map(([et,Ze],Je)=>[et,gt.toDataTransferItem(Ze,()=>Fe(Je))]);return new c.DataTransfer(He)}Pe.toDataTransfer=Le;async function Se(ne){const Fe={items:[]},He=[];return ne.forEach((et,Ze)=>{He.push((async()=>{const Je=await et.asString(),bt=et.asFile();Fe.items.push([Ze,{asString:Je,fileData:bt?{name:bt.name,uri:bt.uri}:void 0}])})())}),await Promise.all(He),Fe}Pe.toDataTransferDTO=Se})(Dt=e.DataTransfer||(e.DataTransfer={}))}),define(Ie[222],ke([1,0,2,12,7,15,79]),function(Y,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(I,R,k,_={timeout:1500,errors:3}){this._logService=I,this._documents=R,this._mainThreadBulkEdits=k,this._thresholds=_,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(R,k,_)=>{const w={dispose:this._callbacks.push([R,k,I])};return Array.isArray(_)&&_.push(w),w}}async $participateInSave(I,R){const k=u.URI.revive(I);let _=!1;const T=setTimeout(()=>_=!0,this._thresholds.timeout),w=[];try{for(const b of[...this._callbacks]){if(_)break;const g=this._documents.getDocument(k),f=await this._deliverEventAsyncAndBlameBadListeners(b,{document:g,reason:P.TextDocumentSaveReason.to(R)});w.push(f)}}finally{clearTimeout(T)}return w}_deliverEventAsyncAndBlameBadListeners([I,R,k],_){const T=this._badListeners.get(I);return typeof T=="number"&&T>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,I,R,_).then(()=>!0,w=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(w),!(w instanceof Error)||w.message!=="concurrent_edits"){const b=this._badListeners.get(I);this._badListeners.set(I,b?b+1:1),typeof b=="number"&&b>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,R,k,_){const T=[],w=Date.now(),{document:b,reason:g}=_,{version:f}=b,p=Object.freeze({document:b,reason:g,waitUntil(v){if(Object.isFrozen(T))throw(0,t.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(v))}});try{R.apply(k,[p])}catch(v){return Promise.reject(v)}return Object.freeze(T),new Promise((v,c)=>{const m=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(T).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-w}ms`),clearTimeout(m),v(a)}).catch(a=>{clearTimeout(m),c(a)})}).then(v=>{const c={edits:[]};for(const m of v)if(Array.isArray(m)&&m.every(a=>a instanceof D.TextEdit))for(const{newText:a,newEol:d,range:r}of m)c.edits.push({resource:b.uri,versionId:void 0,textEdit:{range:r&&P.Range.from(r),text:a,eol:d&&P.EndOfLine.from(d)}});if(c.edits.length!==0)return f===b.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(Ie[223],ke([1,0,11,2,15,7,128]),function(Y,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class C{constructor(k,_,T,w){this.start=k,this.deletedCount=_,this.deletedItems=T,this.items=w}asApiEvent(){return{range:new P.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class E{constructor(k,_,T){this.notebook=k,this._extHostDocument=_,this._cellData=T,this.handle=T.handle,this.uri=t.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(D.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}static asModelAddData(k,_){return{EOL:_.eol,lines:_.source,languageId:_.language,uri:_.uri,isDirty:!1,versionId:1,notebook:k}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const k=this,_=this._extHostDocument.getDocument(this.uri);if(!_)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:D.NotebookCellKind.to(this._cellData.cellKind),document:_.document,get mime(){return k._mime},set mime(w){k._mime=w},get outputs(){return k._outputs.slice(0)},get metadata(){return k._metadata},get executionSummary(){return k._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(k){this._outputs=k.map(D.NotebookCellOutput.to)}setOutputItems(k,_,T){const w=T.map(D.NotebookCellOutputItem.to),b=this._outputs.find(g=>g.id===k);b&&(_||(b.items.length=0),b.items.push(...w))}setMetadata(k){this._metadata=Object.freeze(k)}setInternalMetadata(k){this._internalMetadata=k,this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=E;class I{constructor(k,_,T,w,b){this._proxy=k,this._textDocumentsAndEditors=_,this._textDocuments=T,this.uri=w,this.handle=I._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=b.viewType,this._metadata=Object.freeze(b.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,b.cells]],!0,void 0),this._versionId=b.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const k=this,_={get uri(){return k.uri},get version(){return k._versionId},get notebookType(){return k._notebookType},get isDirty(){return k._isDirty},get isUntitled(){return k.uri.scheme===u.Schemas.untitled},get isClosed(){return k._disposed},get metadata(){return k._metadata},get cellCount(){return k._cells.length},cellAt(T){return T=k._validateIndex(T),k._cells[T].apiCell},getCells(T){return(T?k._getCells(T):k._cells).map(b=>b.apiCell)},save(){return k._save()}};this._notebook=Object.freeze(_)}return this._notebook}updateBackup(k){this._backup?.delete(),this._backup=k}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(k){k.metadata&&(this._metadata=Object.freeze({...this._metadata,...k.metadata}))}acceptDirty(k){this._isDirty=k}acceptModelChanged(k,_,T){this._versionId=k.versionId,this._isDirty=_,this.acceptDocumentPropertiesChanged({metadata:T});const w={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},b=[];for(const f of k.rawEvents)f.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(f.changes,!1,w.contentChanges):f.kind===y.NotebookCellsChangeType.Move?this._moveCell(f.index,f.newIdx,w.contentChanges):f.kind===y.NotebookCellsChangeType.Output?(this._setCellOutputs(f.index,f.outputs),b.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===y.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(f.index,f.outputId,f.append,f.outputItems),b.push({cell:this._cells[f.index].apiCell,outputs:this._cells[f.index].apiCell.outputs})):f.kind===y.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(f.index,f.language),b.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document})):f.kind===y.NotebookCellsChangeType.ChangeCellContent?b.push({cell:this._cells[f.index].apiCell,document:this._cells[f.index].apiCell.document}):f.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(f.index,f.mime):f.kind===y.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(f.index,f.metadata),b.push({cell:this._cells[f.index].apiCell,metadata:this._cells[f.index].apiCell.metadata})):f.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(f.index,f.internalMetadata),b.push({cell:this._cells[f.index].apiCell,executionSummary:this._cells[f.index].apiCell.executionSummary}));const g=new Map;for(let f=0;f<b.length;f++){const p=b[f],v=g.get(p.cell);if(v===void 0){const c=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...p});g.set(p.cell,c-1)}else w.cellChanges[v]={...w.cellChanges[v],...p}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}_validateIndex(k){return k=k|0,k<0?0:k>=this._cells.length?this._cells.length-1:k}_validateRange(k){let _=k.start|0,T=k.end|0;return _<0&&(_=0),T>this._cells.length&&(T=this._cells.length),k.with({start:_,end:T})}_getCells(k){k=this._validateRange(k);const _=[];for(let T=k.start;T<k.end;T++)_.push(this._cells[T]);return _}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(k,_,T){if(this._disposed)return;const w=[],b=[],g=[];if(k.reverse().forEach(f=>{const v=f[2].map(a=>{const d=new E(this,this._textDocumentsAndEditors,a);return _||b.push(E.asModelAddData(this.apiNotebook,a)),d}),c=new C(f[0],f[1],[],v),m=this._cells.splice(f[0],f[1],...v);for(const a of m)g.push(a.uri),c.deletedItems.push(a.apiCell);w.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:b,removedDocuments:g}),T)for(const f of w)T.push(f.asApiEvent())}_moveCell(k,_,T){const w=this._cells.splice(k,1);this._cells.splice(_,0,...w);const b=[new C(k,1,w.map(g=>g.apiCell),[]),new C(_,0,[],w)];for(const g of b)T.push(g.asApiEvent())}_setCellOutputs(k,_){this._cells[k].setOutputs(_)}_setCellOutputItems(k,_,T,w){this._cells[k].setOutputItems(_,T,w)}_changeCellLanguage(k,_){const T=this._cells[k];T.apiCell.document.languageId!==_&&this._textDocuments.$acceptModelLanguageChanged(T.uri,_)}_changeCellMime(k,_){const T=this._cells[k];T.apiCell.mime=_}_changeCellMetadata(k,_){this._cells[k].setMetadata(_)}_changeCellInternalMetadata(k,_){this._cells[k].setInternalMetadata(_)}getCellFromApiCell(k){return this._cells.find(_=>_.apiCell===k)}getCellFromIndex(k){return this._cells[k]}getCell(k){return this._cells.find(_=>_.handle===k)}getCellIndex(k){return this._cells.indexOf(k)}}e.ExtHostNotebookDocument=I,I._handlePool=0}),define(Ie[131],ke([1,0,7,15,12]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(E){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=E}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(E){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:E})}replaceCellMetadata(E,I){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:E,metadata:I})}replaceCells(E,I,R){this._throwIfFinalized(),!(E===I&&R.length===0)&&this._collectedEdits.push({editType:1,index:E,count:I-E,cells:R.map(t.NotebookCellData.from)})}}class y{constructor(E,I,R,k,_,T){this.id=E,this._proxy=I,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=_,this._visibleRanges=k,this._viewColumn=T}get apiEditor(){if(!this._editor){const E=this;this._editor={get document(){return E.notebookData.apiNotebook},get notebook(){return E.notebookData.apiNotebook},get selection(){return E._selections[0]},set selection(I){this.selections=[I]},get selections(){return E._selections},set selections(I){if(!Array.isArray(I)||!I.every(u.NotebookRange.isNotebookRange))throw(0,D.illegalArgument)("selections");E._selections=I,E._trySetSelections(I)},get visibleRanges(){return E._visibleRanges},revealRange(I,R){E._proxy.$tryRevealRange(E.id,t.NotebookRange.from(I),R??u.NotebookEditorRevealType.Default)},get viewColumn(){return E._viewColumn},edit(I){const R=new P(this.document.version);return I(R),E._applyEdit(R.finalize())}},y.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(E){this._visible=E}_acceptVisibleRanges(E){this._visibleRanges=E}_acceptSelections(E){this._selections=E}_trySetSelections(E){this._proxy.$trySetSelections(this.id,E.map(t.NotebookRange.from))}_acceptViewColumn(E){this._viewColumn=E}_applyEdit(E){if(E.cellEdits.length===0)return Promise.resolve(!0);const I=[];let R=-1;for(let k=0;k<E.cellEdits.length;k++){if(R<0){I.push(E.cellEdits[k]),R++;continue}const T=I[R],w=E.cellEdits[k];if(T.editType===1&&w.editType===1&&T.index===w.index){T.cells.push(...E.cellEdits[k].cells),T.count+=E.cellEdits[k].count;continue}I.push(E.cellEdits[k]),R++}return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,I)}}e.ExtHostNotebookEditor=y,y.apiEditorsToExtHost=new WeakMap}),define(Ie[224],ke([1,0,3,14,15]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let P=class{constructor(C,E){this._logService=C,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new u.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new u.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(C,E){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",C,E);const I=this._notebooksAndEditors.getEditorById(C);E.visibleRanges&&I._acceptVisibleRanges(E.visibleRanges.ranges.map(D.NotebookRange.to)),E.selections&&I._acceptSelections(E.selections.selections.map(D.NotebookRange.to)),E.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:I.apiEditor,visibleRanges:I.apiEditor.visibleRanges}),E.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:I.apiEditor,selections:I.apiEditor.selections}))}$acceptEditorViewColumns(C){for(const E in C)this._notebooksAndEditors.getEditorById(E)._acceptViewColumn(D.ViewColumn.to(C[E]))}};P=Ge([xe(0,t.ILogService)],P),e.ExtHostNotebookEditors=P}),define(Ie[225],ke([1,0,15,119,172,21,57,12]),function(Y,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(_){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=_}async withProgress(_,T,w){const b=this._handles++,{title:g,location:f,cancellable:p}=T,v={label:(0,D.localize)(0,null,_.displayName||_.name),id:_.identifier.value};return this._proxy.$startProgress(b,{location:u.ProgressLocation.from(f),title:g,source:v,cancellable:p},_.isUnderDevelopment?void 0:_.identifier.value).catch(C.onUnexpectedExternalError),this._withProgress(b,w,!!p)}_withProgress(_,T,w){let b;w&&(b=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(_,b));const g=p=>{this._proxy.$progressEnd(p),this._mapHandleToCancellationSource.delete(p),b&&b.dispose()};let f;try{f=T(new R(this._proxy,_),w&&b?b.token:P.CancellationToken.None)}catch(p){throw g(_),p}return f.then(p=>g(_),p=>g(_)),f}$acceptProgressCanceled(_){const T=this._mapHandleToCancellationSource.get(_);T&&(T.cancel(),this._mapHandleToCancellationSource.delete(_))}}e.ExtHostProgress=E;function I(k,_){return k.message=_.message,typeof _.increment=="number"&&(typeof k.increment=="number"?k.increment+=_.increment:k.increment=_.increment),k}class R extends t.Progress{constructor(_,T){super(w=>this.throttledReport(w));this._proxy=_,this._handle=T}throttledReport(_){this._proxy.$progressReport(this._handle,_)}}Ge([(0,y.throttle)(100,(k,_)=>I(k,_),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ie[132],ke([1,0,35,129,65,89,66,15,2]),function(Y,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const I=(v,c,m,a)=>{let d=c;return{enumerable:!0,configurable:!1,get(){return d},set(r){if(!m(d,r)){const o=d;d=r,v.listener?.(a(r,o))}}}},R=(v,c)=>v===c,k={range:(v,c)=>v===c?!0:!v||!c?!1:v.isEqual(c),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(v,c)=>!(v.length!==c.length||v.some(m=>!c.find(a=>m.id===a.id)))},_=v=>c=>({op:4,update:v(c)}),T=(v,c)=>({range:I(v,void 0,k.range,_(m=>({range:u.Range.lift(C.Range.from(m))}))),label:I(v,c,k.label,_(m=>({label:m}))),description:I(v,void 0,k.description,_(m=>({description:m}))),sortText:I(v,void 0,k.sortText,_(m=>({sortText:m}))),canResolveChildren:I(v,!1,k.canResolveChildren,m=>({op:2,state:m})),busy:I(v,!1,k.busy,_(m=>({busy:m}))),error:I(v,void 0,k.error,_(m=>({error:C.MarkdownString.fromStrict(m)||null}))),tags:I(v,[],k.tags,(m,a)=>({op:1,new:m.map(C.TestTag.from),old:a.map(C.TestTag.from)}))}),w=v=>{const c=D.TestId.fromString(v.extId),m=new g(c.controllerId,c.localId,v.label,E.URI.revive(v.uri)||void 0);return m.range=C.Range.to(v.range||void 0),m.description=v.description||void 0,m.sortText=v.sortText||void 0,m.tags=v.tags.map(a=>C.TestTag.to({id:(0,y.denamespaceTestTag)(a).tagId})),m},b=v=>{let c;for(const m of v.tests){const a=w(m.item);(0,t.getPrivateApiFor)(a).parent=c,c=a}return c};e.toItemFromContext=b;class g{constructor(c,m,a,d){if(m.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(m)} symbol`);const r=(0,t.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:m,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof f?void 0:r.parent}},children:{value:(0,P.createTestItemChildren)(r,t.getPrivateApiFor,g),enumerable:!0,writable:!1},...T(r,a)})}}e.TestItemImpl=g;class f extends g{constructor(c,m){super(c,c,m,void 0)}}e.TestItemRootImpl=f;class p extends P.TestItemCollection{constructor(c,m){super({controllerId:c,getApiFor:t.getPrivateApiFor,getChildren:a=>a.children,root:new f(c,m),toITestItem:C.TestItem.from})}}e.ExtHostTestItemCollection=p}),define(Ie[133],ke([1,0,56,12,93,15,7]),function(Y,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(_,T,w){const b=C._Keys.nextId();_.$registerTextEditorDecorationType(T.identifier,b,P.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:b,dispose(){_.$removeTextEditorDecorationType(b)}})}}e.TextEditorDecorationType=C,C._Keys=new D.IdGenerator("TextEditorDecorationType");class E{constructor(_,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=_,this._documentVersionId=_.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(_,T){this._throwIfFinalized();let w=null;if(_ instanceof y.Position)w=new y.Range(_,_);else if(_ instanceof y.Range)w=_;else throw new Error("Unrecognized location");this._pushEdit(w,T,!1)}insert(_,T){this._throwIfFinalized(),this._pushEdit(new y.Range(_,_),T,!0)}delete(_){this._throwIfFinalized();let T=null;if(_ instanceof y.Range)T=_;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(_,T,w){const b=this._document.validateRange(_);this._collectedEdits.push({range:b,text:T,forceMoveMarkers:w})}setEndOfLine(_){if(this._throwIfFinalized(),_!==y.EndOfLine.LF&&_!==y.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=_}}e.TextEditorEdit=E;class I{constructor(_,T,w,b){this._proxy=_,this._id=T,this._accept(w),this._logService=b;const g=this;this.value={get tabSize(){return g._tabSize},set tabSize(f){g._setTabSize(f)},get insertSpaces(){return g._insertSpaces},set insertSpaces(f){g._setInsertSpaces(f)},get cursorStyle(){return g._cursorStyle},set cursorStyle(f){g._setCursorStyle(f)},get lineNumbers(){return g._lineNumbers},set lineNumbers(f){g._setLineNumbers(f)}}}_accept(_){this._tabSize=_.tabSize,this._insertSpaces=_.insertSpaces,this._cursorStyle=_.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(_.lineNumbers)}_validateTabSize(_){if(_==="auto")return"auto";if(typeof _=="number"){const T=Math.floor(_);return T>0?T:null}if(typeof _=="string"){const T=parseInt(_,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(_){const T=this._validateTabSize(_);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateInsertSpaces(_){return _==="auto"?"auto":_==="false"?!1:Boolean(_)}_setInsertSpaces(_){const T=this._validateInsertSpaces(_);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(_){this._cursorStyle!==_&&(this._cursorStyle=_,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:_})))}_setLineNumbers(_){this._lineNumbers!==_&&(this._lineNumbers=_,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(_)})))}assign(_){const T={};let w=!1;if(typeof _.tabSize!="undefined"){const b=this._validateTabSize(_.tabSize);b==="auto"?(w=!0,T.tabSize=b):typeof b=="number"&&this._tabSize!==b&&(this._tabSize=b,w=!0,T.tabSize=b)}if(typeof _.insertSpaces!="undefined"){const b=this._validateInsertSpaces(_.insertSpaces);b==="auto"?(w=!0,T.insertSpaces=b):this._insertSpaces!==b&&(this._insertSpaces=b,w=!0,T.insertSpaces=b)}typeof _.cursorStyle!="undefined"&&this._cursorStyle!==_.cursorStyle&&(this._cursorStyle=_.cursorStyle,w=!0,T.cursorStyle=_.cursorStyle),typeof _.lineNumbers!="undefined"&&this._lineNumbers!==_.lineNumbers&&(this._lineNumbers=_.lineNumbers,w=!0,T.lineNumbers=P.TextEditorLineNumbersStyle.from(_.lineNumbers)),w&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(_,T){T.catch(w=>{this._logService.warn(`ExtHostTextEditorOptions '${_}' failed:'`),this._logService.warn(w)})}}e.ExtHostTextEditorOptions=I;class R{constructor(_,T,w,b,g,f,p,v){this.id=_,this._proxy=T,this._logService=w,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=g,this._options=new I(this._proxy,this.id,f,w),this._visibleRanges=p,this._viewColumn=v;const c=this;this.value=Object.freeze({get document(){return b.getValue()},set document(m){throw(0,t.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(m){if(!(m instanceof y.Selection))throw(0,t.illegalArgument)("selection");c._selections=[m],c._trySetSelection()},get selections(){return c._selections},set selections(m){if(!Array.isArray(m)||m.some(a=>!(a instanceof y.Selection)))throw(0,t.illegalArgument)("selections");c._selections=m,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(m){throw(0,t.readonly)("visibleRanges")},get options(){return c._options.value},set options(m){c._disposed||c._options.assign(m)},get viewColumn(){return c._viewColumn},set viewColumn(m){throw(0,t.readonly)("viewColumn")},edit(m,a={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new E(b.getValue(),a);return m(d),c._applyEdit(d)},insertSnippet(m,a,d={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!a||Array.isArray(a)&&a.length===0)r=c._selections.map(o=>P.Range.from(o));else if(a instanceof y.Position){const{lineNumber:o,column:i}=P.Position.from(a);r=[{startLineNumber:o,startColumn:i,endLineNumber:o,endColumn:i}]}else if(a instanceof y.Range)r=[P.Range.from(a)];else{r=[];for(const o of a)if(o instanceof y.Range)r.push(P.Range.from(o));else{const{lineNumber:i,column:n}=P.Position.from(o);r.push({startLineNumber:i,startColumn:n,endLineNumber:i,endColumn:n})}}return T.$tryInsertSnippet(_,b.getValue().version,m.value,r,d)},setDecorations(m,a){const d=a.length===0;d&&!c._hasDecorationsForKey.has(m.key)||(d?c._hasDecorationsForKey.delete(m.key):c._hasDecorationsForKey.add(m.key),c._runOnProxy(()=>{if(P.isDecorationOptionsArr(a))return T.$trySetDecorations(_,m.key,P.fromRangeOrRangeWithMessage(a));{const r=new Array(4*a.length);for(let o=0,i=a.length;o<i;o++){const n=a[o];r[4*o]=n.start.line+1,r[4*o+1]=n.start.character+1,r[4*o+2]=n.end.line+1,r[4*o+3]=n.end.character+1}return T.$trySetDecorationsFast(_,m.key,r)}}))},revealRange(m,a){c._runOnProxy(()=>T.$tryRevealRange(_,P.Range.from(m),a||y.TextEditorRevealType.Default))},show(m){T.$tryShowEditor(_,P.ViewColumn.from(m))},hide(){T.$tryHideEditor(_)}})}dispose(){(0,u.ok)(!this._disposed),this._disposed=!0}_acceptOptions(_){(0,u.ok)(!this._disposed),this._options._accept(_)}_acceptVisibleRanges(_){(0,u.ok)(!this._disposed),this._visibleRanges=_}_acceptViewColumn(_){(0,u.ok)(!this._disposed),this._viewColumn=_}_acceptSelections(_){(0,u.ok)(!this._disposed),this._selections=_}async _trySetSelection(){const _=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,_)),this.value}_applyEdit(_){const T=_.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const w=T.edits.map(g=>g.range);w.sort((g,f)=>g.end.line===f.end.line?g.end.character===f.end.character?g.start.line===f.start.line?g.start.character-f.start.character:g.start.line-f.start.line:g.end.character-f.end.character:g.end.line-f.end.line);for(let g=0,f=w.length-1;g<f;g++){const p=w[g].end;if(w[g+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const b=T.edits.map(g=>({range:P.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,b,{setEndOfLine:typeof T.setEndOfLine=="number"?P.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(_){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):_().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=R}),define(Ie[226],ke([1,0,4,191]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,u.refineServiceDecorator)(t.IEnvironmentService)}),define(Ie[227],ke([1,0,28,3,9]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(k){this.removedDueToLooping=k}}e.DeltaExtensionsResult=P;class y{constructor(k){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=k,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const k of this._extensionDescriptions){if(this._extensionsMap.has(u.ExtensionIdentifier.toKey(k.identifier))){console.error("Extension `"+k.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(u.ExtensionIdentifier.toKey(k.identifier),k),this._extensionsArr.push(k),Array.isArray(k.activationEvents))for(let _ of k.activationEvents)_==="onUri"&&(_=`onUri:${u.ExtensionIdentifier.toKey(k.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(k)}}set(k){this._extensionDescriptions=k,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(k,_){this._extensionDescriptions=I(this._extensionDescriptions,_),this._extensionDescriptions=this._extensionDescriptions.concat(k);const T=y._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=I(this._extensionDescriptions,T.map(w=>w.identifier)),this._initialize(),this._onDidChange.fire(void 0),new P(T)}static _findLoopingExtensions(k){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(f){this._nodesSet.has(f)||(this._nodesSet.add(f),this._nodesArr.push(f))}addArc(f,p){this.addNode(f),this.addNode(p),this._arcs.has(f)?this._arcs.get(f).push(p):this._arcs.set(f,[p])}getArcs(f){return this._arcs.has(f)?this._arcs.get(f):[]}hasOnlyGoodArcs(f,p){const v=_.getArcs(f);for(let c=0;c<v.length;c++)if(!p.has(v[c]))return!1;return!0}getNodes(){return this._nodesArr}},T=new Map;for(const f of k){const p=u.ExtensionIdentifier.toKey(f.identifier);if(T.set(p,f),f.extensionDependencies)for(const v of f.extensionDependencies){const c=u.ExtensionIdentifier.toKey(v);_.addArc(p,c)}}const w=new Set;_.getNodes().filter(f=>_.getArcs(f).length===0).forEach(f=>w.add(f));const b=_.getNodes().filter(f=>!w.has(f));let g;do{g=!1;for(let f=0;f<b.length;f++){const p=b[f];_.hasOnlyGoodArcs(p,w)&&(b.splice(f,1),f--,w.add(p),g=!0)}}while(g);return b.map(f=>T.get(f))}containsActivationEvent(k){return this._activationMap.has(k)}containsExtension(k){return this._extensionsMap.has(u.ExtensionIdentifier.toKey(k))}getExtensionDescriptionsForActivationEvent(k){const _=this._activationMap.get(k);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(k){const _=this._extensionsMap.get(u.ExtensionIdentifier.toKey(k));return _||void 0}getExtensionDescriptionByUUID(k){for(const _ of this._extensionsArr)if(_.uuid===k)return _}getExtensionDescriptionByIdOrUUID(k,_){return this.getExtensionDescription(k)??(_?this.getExtensionDescriptionByUUID(_):void 0)}}e.ExtensionDescriptionRegistry=y;var C;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(C||(C={}));function E(R,k){const _=R.isBuiltin?0:R.isUnderDevelopment?2:1,T=k.isBuiltin?0:k.isUnderDevelopment?2:1;if(_!==T)return _-T;const w=D.posix.basename(R.extensionLocation.path),b=D.posix.basename(k.extensionLocation.path);return w<b?-1:w>b?1:0}function I(R,k){const _=new Set;return k.forEach(T=>_.add(u.ExtensionIdentifier.toKey(T))),R.filter(T=>!_.has(u.ExtensionIdentifier.toKey(T.identifier)))}}),define(Ie[228],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var u;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(u=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class D{constructor(){this.type=2}serialize(k){k[D.ENV_KEY]="1"}}e.SocketExtHostConnection=D,D.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class P{constructor(){this.type=3}serialize(k){k[P.ENV_KEY]="1"}}e.MessagePortExtHostConnection=P,P.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function y(R){delete R[t.ENV_KEY],delete R[D.ENV_KEY],delete R[P.ENV_KEY]}function C(R,k){y(k),R.serialize(k)}e.writeExtHostConnection=C;function E(R){if(R[t.ENV_KEY])return I(R,new t(R[t.ENV_KEY]));if(R[D.ENV_KEY])return I(R,new D);if(R[P.ENV_KEY])return I(R,new P);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=E;function I(R,k){return y(R),k}}),define(Ie[134],ke([1,0,23]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(I){I[I.Desktop=1]="Desktop",I[I.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var D;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(D=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function y(I){const R=u.VSBuffer.alloc(1);switch(I){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=y;function C(I,R){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=C;var E;(function(I){I.Start="START_NATIVE_LOG",I.End="END_NATIVE_LOG"})(E=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ie[27],ke([1,0,3,2,4,28,200]),function(Y,e,u,t,D,P,y){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class E{constructor(n){this.affinity=n,this.kind=1}equals(n){return this.kind===n.kind&&this.affinity===n.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=E;class I{constructor(){this.kind=2,this.affinity=0}equals(n){return this.kind===n.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=I;class R{constructor(){this.kind=3,this.affinity=0}equals(n){return this.kind===n.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class k{constructor(n){this.dependency=n}}e.MissingExtensionDependency=k;var _;(function(i){i[i.LocalProcess=1]="LocalProcess",i[i.LocalWebWorker=2]="LocalWebWorker",i[i.Remote=3]="Remote"})(_=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(i){if(i===null)return"None";switch(i){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=T;class w{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(n,s){const l=[],h=[],S=[],L=[],M=f(this._allExtensions),F=f(n),A=(K,W)=>K.extensionLocation.toString()===W.extensionLocation.toString()||K.isBuiltin===W.isBuiltin||K.isUserBuiltin===W.isUserBuiltin||K.isUnderDevelopment===W.isUnderDevelopment;for(const K of this._allExtensions){const W=F.get(P.ExtensionIdentifier.toKey(K.identifier));if(!W){l.push(K.identifier),M.delete(P.ExtensionIdentifier.toKey(K.identifier));continue}if(!A(K,W)){l.push(K.identifier),M.delete(P.ExtensionIdentifier.toKey(K.identifier));continue}}for(const K of n){const W=M.get(P.ExtensionIdentifier.toKey(K.identifier));if(!W){h.push(K);continue}if(!A(W,K)){l.push(W.identifier),M.delete(P.ExtensionIdentifier.toKey(W.identifier));continue}}const B=g(this._myExtensions),$=g(s);for(const K of this._myExtensions)$.has(P.ExtensionIdentifier.toKey(K))||S.push(K);for(const K of s)B.has(P.ExtensionIdentifier.toKey(K))||L.push(K);const U={toRemove:l,toAdd:h,myToRemove:S,myToAdd:L};return this.delta(U),U}delta(n){const{toRemove:s,toAdd:l,myToRemove:h,myToAdd:S}=n,L=g(s),M=g(h);for(let F=0;F<this._allExtensions.length;F++)L.has(P.ExtensionIdentifier.toKey(this._allExtensions[F].identifier))&&(this._allExtensions.splice(F,1),F--);for(let F=0;F<this._myExtensions.length;F++)M.has(P.ExtensionIdentifier.toKey(this._myExtensions[F]))&&(this._myExtensions.splice(F,1),F--);for(const F of l)this._allExtensions.push(F);for(const F of S)this._myExtensions.push(F)}containsExtension(n){for(const s of this._myExtensions)if(P.ExtensionIdentifier.equals(s,n))return!0;return!1}}e.ExtensionHostExtensions=w;class b{constructor(n){if(this[C]="ExtensionIdentifierSet",this._map=new Map,this._toKey=P.ExtensionIdentifier.toKey,n)for(const s of n)this.add(s)}get size(){return this._map.size}add(n){return this._map.set(this._toKey(n),n),this}clear(){this._map.clear()}delete(n){return this._map.delete(this._toKey(n))}has(n){return this._map.has(this._toKey(n))}forEach(n,s){this._map.forEach(l=>n.call(s,l,l,this))}*entries(){for(const[n,s]of this._map)yield[s,s]}keys(){return this._map.values()}values(){return this._map.values()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=b;function g(i){const n=new Set;for(const s of i)n.add(P.ExtensionIdentifier.toKey(s));return n}e.extensionIdentifiersArrayToSet=g;function f(i){const n=new Map;for(const s of i)n.set(P.ExtensionIdentifier.toKey(s.identifier),s);return n}function p(i,n){return i.enabledApiProposals?i.enabledApiProposals.includes(n):!1}e.isProposedApiEnabled=p;function v(i,n){if(!p(i,n))throw new Error(`Extension '${i.identifier.value}' CANNOT use API proposal: ${n}.
Its package.json#enabledApiProposals-property declares: ${i.enabledApiProposals?.join(", ")??"[]"} but NOT ${n}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${i.identifier.value}`)}e.checkProposedApiEnabled=v;class c{constructor(n,s,l,h){this.codeLoadingTime=n,this.activateCallTime=s,this.activateResolvedTime=l,this.activationReason=h}}e.ActivationTimes=c;class m{constructor(n,s){this.description=n,this.value=s}}e.ExtensionPointContribution=m,e.ExtensionHostLogFileName="exthost";var a;(function(i){i[i.Normal=0]="Normal",i[i.Immediate=1]="Immediate"})(a=e.ActivationKind||(e.ActivationKind={}));function d(i){return{type:i.isBuiltin?0:1,isBuiltin:i.isBuiltin||i.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(i.publisher,i.name),uuid:i.uuid},manifest:i,location:i.extensionLocation,targetPlatform:i.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function r(i,n){return{identifier:new P.ExtensionIdentifier((0,y.getExtensionId)(i.manifest.publisher,i.manifest.name)),isBuiltin:i.type===0,isUserBuiltin:i.type===1&&i.isBuiltin,isUnderDevelopment:!!n,extensionLocation:i.location,...i.manifest,uuid:i.identifier.uuid,targetPlatform:i.targetPlatform}}e.toExtensionDescription=r;class o{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None}activateByEvent(n){return Promise.resolve(void 0)}activationEventIsDone(n){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(n){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(n,s){return Promise.resolve(0)}getInspectPorts(n,s){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(n){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(n,s){return Promise.resolve()}}e.NullExtensionService=o}),define(Ie[229],ke([1,0,12,28,27,14,18]),function(Y,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class C{constructor(g,f,p,v){this.startup=g,this.codeLoadingTime=f,this.activateCallTime=p,this.activateResolvedTime=v}}e.ExtensionActivationTimes=C,C.NONE=new C(!1,-1,-1,-1);class E{constructor(g){this._startup=g,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(g,f){return g===-1||f===-1?-1:f-g}build(){return new C(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class I{constructor(g,f,p,v,c,m){this.activationFailed=g,this.activationFailedError=f,this.activationTimes=p,this.module=v,this.exports=c,this.subscriptions=m}}e.ActivatedExtension=I;class R extends I{constructor(g){super(!1,null,g,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class k extends I{constructor(){super(!1,null,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class _ extends I{constructor(g){super(!0,g,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=_;let T=class{constructor(g,f,p,v,c){this._logService=c,this._registry=g,this._resolvedExtensionsSet=new Set,f.forEach(m=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(m))),this._externalExtensionsMap=new Map,p.forEach(m=>this._externalExtensionsMap.set(t.ExtensionIdentifier.toKey(m),m)),this._host=v,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[g,f]of this._operations)f.dispose()}isActivated(g){const f=this._operations.get(t.ExtensionIdentifier.toKey(g));return Boolean(f&&f.value)}getActivatedExtension(g){const f=this._operations.get(t.ExtensionIdentifier.toKey(g));if(!f||!f.value)throw new Error(`Extension '${g.value}' is not known or not activated`);return f.value}async activateByEvent(g,f){if(this._alreadyActivatedEvents[g])return;const p=this._registry.getExtensionDescriptionsForActivationEvent(g);await this._activateExtensions(p.map(v=>({id:v.identifier,reason:{startup:f,extensionId:v.identifier,activationEvent:g}}))),this._alreadyActivatedEvents[g]=!0}activateById(g,f){const p=this._registry.getExtensionDescription(g);if(!p)throw new Error(`Extension '${g}' is not known`);return this._activateExtensions([{id:p.identifier,reason:f}])}async _activateExtensions(g){const f=g.filter(p=>!this.isActivated(p.id)).map(p=>this._handleActivationRequest(p));await Promise.all(f.map(p=>p.wait()))}_handleActivationRequest(g){if(this._operations.has(t.ExtensionIdentifier.toKey(g.id)))return this._operations.get(t.ExtensionIdentifier.toKey(g.id));if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(g.id)))return this._createAndSaveOperation(g,null,[],null);const f=this._registry.getExtensionDescription(g.id);if(!f){const c=new Error(`Cannot activate unknown extension '${g.id.value}'`),m=this._createAndSaveOperation(g,null,[],new _(c));return this._host.onExtensionActivationError(g.id,c,new D.MissingExtensionDependency(g.id.value)),m}const p=[],v=typeof f.extensionDependencies=="undefined"?[]:f.extensionDependencies;for(const c of v){if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(c)))continue;const m=this._operations.get(t.ExtensionIdentifier.toKey(c));if(m){p.push(m);continue}if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(c))){p.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(t.ExtensionIdentifier.toKey(c)),reason:g.reason}));continue}const a=this._registry.getExtensionDescription(c);if(a){if(!a.main&&!a.browser)continue;p.push(this._handleActivationRequest({id:a.identifier,reason:g.reason}));continue}const d=f.displayName||f.identifier.value,r=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${c}'`),o=this._createAndSaveOperation(g,f.displayName,[],new _(r));return this._host.onExtensionActivationError(f.identifier,r,new D.MissingExtensionDependency(c)),o}return this._createAndSaveOperation(g,f.displayName,p,null)}_createAndSaveOperation(g,f,p,v){const c=new w(g.id,f,g.reason,p,v,this._host,this._logService);return this._operations.set(t.ExtensionIdentifier.toKey(g.id),c),c}};T=Ge([xe(4,P.ILogService)],T),e.ExtensionsActivator=T;let w=class{constructor(g,f,p,v,c,m,a){this._id=g,this._displayName=f,this._reason=p,this._deps=v,this._value=c,this._host=m,this._logService=a,this._barrier=new y.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let g=0;g<this._deps.length;g++){const f=this._deps[g];if(f.value&&!f.value.activationFailed){this._deps.splice(g,1),g--;continue}if(f.value&&f.value.activationFailed){const p=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${f.friendlyName}' failed to activate`);p.detail=f.value.activationFailedError,this._value=new _(p),this._host.onExtensionActivationError(this._id,p,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(g=>g.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(g){const f=new Error;if(g&&g.name&&(f.name=g.name),g&&g.message?f.message=`Activating extension '${this._id.value}' failed: ${g.message}.`:f.message=`Activating extension '${this._id.value}' failed: ${g}.`,g&&g.stack&&(f.stack=g.stack),this._value=new _(f),this._isDisposed&&u.isCancellationError(g))return;this._host.onExtensionActivationError(this._id,f,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(g)}}};w=Ge([xe(6,P.ILogService)],w)}),define(Ie[230],ke([1,0,14,26,27]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends u.LogService{constructor(C,E){super(C.createLogger(E.logFile,{name:D.ExtensionHostLogFileName}))}};P=Ge([xe(0,u.ILoggerService),xe(1,t.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(Ie[231],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",badges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.badges.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorToolbar:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorToolbar.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookEditorEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditorEdit.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookWorkspaceEdit.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",snippetWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.snippetWorkspaceEdit.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExitReason:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExitReason.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[232],ke([1,0,186,12,41,84,120,44,28,231,198]),function(Y,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const k=C.Registry.as(y.Extensions.JSONContribution);class _{constructor(c,m,a){this._messageHandler=c,this._extension=m,this._extensionPointId=a}_msg(c,m){this._messageHandler({type:c,message:m,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(c){this._msg(D.default.Error,c)}warn(c){this._msg(D.default.Warning,c)}info(c){this._msg(D.default.Info,c)}}e.ExtensionMessageCollector=_;class T{constructor(c,m){this.added=c,this.removed=m}static _toSet(c){const m=new Set;for(let a=0,d=c.length;a<d;a++)m.add(E.ExtensionIdentifier.toKey(c[a].description.identifier));return m}static compute(c,m){if(!c||!c.length)return new T(m,[]);if(!m||!m.length)return new T([],c);const a=this._toSet(c),d=this._toSet(m),r=m.filter(i=>!a.has(E.ExtensionIdentifier.toKey(i.description.identifier))),o=c.filter(i=>!d.has(E.ExtensionIdentifier.toKey(i.description.identifier)));return new T(r,o)}}e.ExtensionPointUserDelta=T;class w{constructor(c,m){this.name=c,this.defaultExtensionKind=m,this._handler=null,this._users=null,this._delta=null}setHandler(c){if(this._handler!==null)throw new Error("Handler already set!");this._handler=c,this._handle()}acceptUsers(c){this._delta=T.compute(this._users,c),this._users=c,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(c){(0,t.onUnexpectedError)(c)}}}e.ExtensionPoint=w;const b={type:"string",enum:["ui","workspace"],enumDescriptions:[u.localize(0,null),u.localize(1,null)]},g="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:u.localize(2,null),properties:{vscode:{type:"string",description:u.localize(3,null),default:"^1.22.0"}}},publisher:{description:u.localize(4,null),type:"string"},displayName:{description:u.localize(5,null),type:"string"},categories:{description:u.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:u.localize(7,null)}]}},galleryBanner:{type:"object",description:u.localize(8,null),properties:{color:{description:u.localize(9,null),type:"string"},theme:{description:u.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:u.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:u.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:u.localize(13,null)},enabledApiProposals:{markdownDescription:u.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}},activationEvents:{description:u.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:u.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:u.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:u.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:u.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:u.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:u.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:u.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:u.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:u.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:u.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:u.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:u.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onSearch",description:u.localize(28,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:u.localize(29,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:u.localize(30,null)},{label:"onUri",body:"onUri",description:u.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:u.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:u.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:u.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:u.localize(35,null)},{label:"onRenderer",description:u.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:u.localize(37,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:u.localize(38,null)},{label:"*",description:u.localize(39,null),body:"*"}]}},badges:{type:"array",description:u.localize(40,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:u.localize(41,null)},href:{type:"string",description:u.localize(42,null)},description:{type:"string",description:u.localize(43,null)}}}},markdown:{type:"string",description:u.localize(44,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:u.localize(45,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:u.localize(46,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:u.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:u.localize(48,null),type:"array",items:b,default:["workspace"],defaultSnippets:[{body:["ui"],description:u.localize(49,null)},{body:["workspace"],description:u.localize(50,null)},{body:["ui","workspace"],description:u.localize(51,null)},{body:["workspace","ui"],description:u.localize(52,null)},{body:[],description:u.localize(53,null)}]},capabilities:{description:u.localize(54,null),type:"object",properties:{virtualWorkspaces:{description:u.localize(55,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:u.localize(56,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(57,null),u.localize(58,null),u.localize(59,null)]},description:{type:"string",markdownDescription:u.localize(60,null)}}},untrustedWorkspaces:{description:u.localize(61,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:u.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(63,null),u.localize(64,null),u.localize(65,null)]},restrictedConfigurations:{description:u.localize(66,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:u.localize(67,null)}}}}},sponsor:{description:u.localize(68,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:u.localize(69,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:u.localize(70,null),type:"string"},"vscode:uninstall":{description:u.localize(71,null),type:"string"}}},icon:{type:"string",description:u.localize(72,null)}}};class f{constructor(){this._extensionPoints=new Map}registerExtensionPoint(c){if(this._extensionPoints.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const m=new w(c.extensionPoint,c.defaultExtensionKind);return this._extensionPoints.set(c.extensionPoint,m),e.schema.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,k.registerSchema(g,e.schema),m}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=f;const p={ExtensionsRegistry:"ExtensionsRegistry"};C.Registry.add(p.ExtensionsRegistry,new f),e.ExtensionsRegistry=C.Registry.as(p.ExtensionsRegistry),k.registerSchema(g,e.schema),k.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:u.localize(73,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}}]}}}})}),define(Ie[233],ke([1,0,183,10,24,232,51,3]),function(Y,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:u.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:u.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:u.localize(2,null),default:""}}};var I;(function(_){function T(w,b,g){if(!w)return;const f=t.isString(w.type)?w.type:void 0;if(!f||f.length===0){g.error(u.localize(3,null));return}const p=[];if(Array.isArray(w.required))for(const v of w.required)t.isString(v)&&p.push(v);return{extensionId:b.value,taskType:f,required:p,properties:w.properties?D.deepClone(w.properties):{},when:w.when?y.ContextKeyExpr.deserialize(w.when):void 0}}_.from=T})(I||(I={}));const R=P.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:u.localize(4,null),type:"array",items:E}});class k{constructor(){this._onDefinitionsChanged=new C.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((T,w)=>{R.setHandler((b,g)=>{this._schema=void 0;try{for(const f of g.removed){const p=f.value;for(const v of p)this.taskTypes&&v.type&&this.taskTypes[v.type]&&delete this.taskTypes[v.type]}for(const f of g.added){const p=f.value;for(const v of p){const c=I.from(v,f.description.identifier,f.collector);c&&(this.taskTypes[c.taskType]=c)}}(g.removed.length>0||g.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}T(void 0)})})}onReady(){return this.readyPromise}get(T){return this.taskTypes[T]}all(){return Object.keys(this.taskTypes).map(T=>this.taskTypes[T])}getJsonSchema(){if(this._schema===void 0){const T=[];for(const w of this.all()){const b={type:"object",additionalProperties:!1};w.required.length>0&&(b.required=w.required.slice(0)),w.properties!==void 0?b.properties=D.deepClone(w.properties):b.properties=Object.create(null),b.properties.type={type:"string",enum:[w.taskType]},T.push(b)}this._schema={oneOf:T}}return this._schema}}e.TaskDefinitionRegistryImpl=k,e.TaskDefinitionRegistry=new k}),define(Ie[234],ke([1,0,184,10,22,24,51,233]),function(Y,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new y.RawContextKey("taskRunning",!1,u.localize(0,null)),e.TASKS_CATEGORY={value:u.localize(1,null),original:"Tasks"};var E;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(E=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(U){function K(W){if(!W)return U.Strong;switch(W.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=K}(E=e.ShellQuoting||(e.ShellQuoting={}));var I;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(I=e.CommandOptions||(e.CommandOptions={}));var R;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(U){function K(W){switch(W.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=K}(R=e.RevealKind||(e.RevealKind={}));var k;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(k=e.RevealProblemKind||(e.RevealProblemKind={})),function(U){function K(W){switch(W.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=K}(k=e.RevealProblemKind||(e.RevealProblemKind={}));var _;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(_=e.PanelKind||(e.PanelKind={})),function(U){function K(W){switch(W.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=K}(_=e.PanelKind||(e.PanelKind={}));var T;(function(U){U.defaults={echo:!0,reveal:R.Always,revealProblems:k.Never,focus:!1,panel:_.Shared,showReuseMessage:!0,clear:!1}})(T=e.PresentationOptions||(e.PresentationOptions={}));var w;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(w=e.RuntimeType||(e.RuntimeType={})),function(U){function K(N){switch(N.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=K;function W(N){switch(N){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=W}(w=e.RuntimeType||(e.RuntimeType={}));var b;(function(U){function K(W){return t.isString(W)?W:W.value}U.value=K})(b=e.CommandString||(e.CommandString={}));var g;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function K(N){return N===U.Clean._id||N===U.Build._id||N===U.Rebuild._id||N===U.Test._id}U.is=K;function W(N){if(N!==void 0)return t.isString(N)?K(N)?{_id:N,isDefault:!1}:void 0:N}U.from=W})(g=e.TaskGroup||(e.TaskGroup={}));var f;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(f=e.TaskScope||(e.TaskScope={}));var p;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function K(W){switch(W){case U.User:return 1;case U.WorkspaceFile:return 4;default:return 5}}U.toConfigurationTarget=K})(p=e.TaskSourceKind||(e.TaskSourceKind={}));var v;(function(U){U.parallel="parallel",U.sequence="sequence"})(v=e.DependsOrder||(e.DependsOrder={}));var c;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(c=e.RunOnOptions||(e.RunOnOptions={}));var m;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(m=e.RunOptions||(e.RunOptions={}));class a{constructor(K,W,N,V,x,q){this._label="",this._id=K,W&&(this._label=W),N&&(this.type=N),this.runOptions=V,this.configurationProperties=x,this._source=q}getDefinition(K){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const K={folder:this.getFolderId(),id:this._id};return JSON.stringify(K)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(K,W=!1){if(K===void 0)return!1;if(t.isString(K))return K===this._label||K===this.configurationProperties.identifier||W&&K===this._id;const N=this.getDefinition(!0);return N!==void 0&&N._key===K._key}getQualifiedLabel(){const K=this.getWorkspaceFolder();return K?`${this._label} (${K.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(K){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),K&&(this._taskLoadMessages=this._taskLoadMessages.concat(K))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=a;class d extends a{constructor(K,W,N,V,x,q,te,Q){super(K,N,void 0,te,Q,W);this.command={},this._source=W,this.hasDefinedMatchers=q,x&&(this.command=x)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(K=!1){if(K&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case w.Shell:W="shell";break;case w.Process:W="process";break;case w.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(K){return K instanceof d}getMapKey(){const K=this._source.config.workspaceFolder;return K?`${K.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let W=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(W+=this._source.kind);const N={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:W};return JSON.stringify(N)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(K){return new d(K._id,K._source,K._label,K.type,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.CustomTask=d;class r extends a{constructor(K,W,N,V,x,q,te){super(K,N,V,q,te,W);this._source=W,this.configures=x}static is(K){return K instanceof r}fromObject(K){return K}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let W=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(W+=this._source.kind);const N={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:W};return JSON.stringify(N)}}e.ConfiguringTask=r;class o extends a{constructor(K,W,N,V,x,q,te,Q,le){super(K,N,V,Q,le,W);this.defines=x,this.hasDefinedMatchers=te,this.command=q,this.icon=le.icon,this.hide=le.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(K){return K instanceof o}getMapKey(){const K=this._source.workspaceFolder;return K?`${this._source.scope.toString()}|${K.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const K={type:"contributed",scope:this._source.scope,id:this._id};return K.folder=this.getFolderId(),JSON.stringify(K)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(K){return new o(K._id,K._source,K._label,K.type,K.defines,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.ContributedTask=o;class i extends a{constructor(K,W,N,V,x,q){super(K,N,V,x,q,W);this._source=W}clone(){return new i(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(K){return K instanceof i}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(K){return new i(K._id,K._source,K._label,K.type,K.runOptions,K.configurationProperties)}}e.InMemoryTask=i;var n;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(n=e.ExecutionEngine||(e.ExecutionEngine={})),function(U){U._default=U.Terminal}(n=e.ExecutionEngine||(e.ExecutionEngine={}));var s;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(s=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class l{constructor(K){this._order=new Map;for(let W=0;W<K.length;W++)this._order.set(K[W].uri.toString(),W)}compare(K,W){const N=K.getWorkspaceFolder(),V=W.getWorkspaceFolder();if(N&&V){let x=this._order.get(N.uri.toString());x=x===void 0?0:x+1;let q=this._order.get(V.uri.toString());return q=q===void 0?0:q+1,x===q?K._label.localeCompare(W._label):x-q}else return!N&&V?-1:N&&!V?1:0}}e.TaskSorter=l;var h;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(h=e.TaskEventKind||(e.TaskEventKind={}));var S;(function(U){U.SingleRun="singleRun",U.Background="background"})(S=e.TaskRunType||(e.TaskRunType={}));var L;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(L=e.TaskRunSource||(e.TaskRunSource={}));var M;(function(U){function K(W,N,V,x){if(N){const q={kind:W,taskId:N._id,taskName:N.configurationProperties.name,runType:N.configurationProperties.isBackground?"background":"singleRun",group:N.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:N};return W==="start"?(q.terminalId=V,q.resolvedVariables=x):W==="processStarted"?q.processId=V:W==="processEnded"&&(q.exitCode=V),Object.freeze(q)}else return Object.freeze({kind:"changed"})}U.create=K})(M=e.TaskEvent||(e.TaskEvent={}));var F;(function(U){function K(N){const V=Object.keys(N).sort();let x="";for(const q of V){let te=N[q];te instanceof Object?te=K(te):typeof te=="string"&&(te=te.replace(/,/g,",,")),x+=q+","+te+","}return x}function W(N){const x={_key:K(N),type:N.taskType};return Object.assign(x,N),x}U.create=W})(F=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var A;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks"})(A=e.TaskSettingId||(e.TaskSettingId={}));var B;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(B=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var $;(function(U){function K(W,N){const V=C.TaskDefinitionRegistry.get(W.type);if(V===void 0){const Q=P.deepClone(W);return delete Q._key,F.create(Q)}const x=Object.create(null);x.type=V.taskType;const q=new Set;V.required.forEach(Q=>q.add(Q));const te=V.properties;for(const Q of Object.keys(te)){const le=W[Q];if(le!=null)x[Q]=le;else if(q.has(Q)){const pe=te[Q];if(pe.default!==void 0)x[Q]=P.deepClone(pe.default);else switch(pe.type){case"boolean":x[Q]=!1;break;case"number":case"integer":x[Q]=0;break;case"string":x[Q]="";break;default:N.error(u.localize(2,null,JSON.stringify(W,void 0,0),Q));return}}}return F.create(x)}U.createTaskIdentifier=K})($=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ie[235],ke([1,0,12]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,C)=>{this._actualOk=y,this._actualErr=C,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,u.onUnexpectedError)(y))}then(y,C){return this._ensureActual().then(y,C)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=t;class D extends t{constructor(){super();this._hasErr=!0,this._err=new u.CancellationError}}e.CanceledLazyPromise=D}),define(Ie[53],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class u{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++u.count}}e.ProxyIdentifier=u,u.count=0;const t=[];function D(C){const E=new u(C);return t[E.nid]=E,E}e.createProxyIdentifier=D;function P(C){return t[C].sid}e.getStringIdentifierForProxy=P;class y{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=y}),define(Ie[5],ke([1,0,61,53]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var D;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(D=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(P=e.TabInputKind||(e.TabInputKind={}));var y;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(y=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var E;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(E=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));class _{static mixin(p){return p._id=_._n++,p}}e.IdObject=_,_._n=0;var T;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.command="m",f.kindModifier="n"})(T=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));function b(f){return f&&f.edits&&(0,u.revive)(f),f}e.reviveWorkspaceEditDto=b;var g;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(g=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,t.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,t.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,t.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,t.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,t.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,t.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,t.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,t.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,t.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,t.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,t.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,t.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,t.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,t.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,t.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,t.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,t.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,t.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,t.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,t.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,t.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,t.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,t.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,t.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,t.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,t.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,t.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,t.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,t.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,t.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,t.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,t.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,t.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,t.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,t.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,t.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,t.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,t.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,t.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,t.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,t.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,t.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,t.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,t.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,t.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,t.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,t.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,t.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,t.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,t.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,t.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,t.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,t.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,t.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,t.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,t.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,t.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,t.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,t.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,t.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,t.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,t.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,t.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,t.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,t.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,t.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,t.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,t.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,t.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,t.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,t.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,t.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,t.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,t.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,t.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,t.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,t.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,t.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,t.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,t.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,t.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,t.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,t.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,t.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,t.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,t.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,t.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,t.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,t.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,t.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,t.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,t.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,t.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,t.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,t.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,t.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,t.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,t.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,t.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,t.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,t.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,t.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,t.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,t.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,t.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,t.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,t.createProxyIdentifier)("ExtHostTelemetry")}}),define(Ie[90],ke([1,0,5,3,4]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(C){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(u.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,E){return this._proxy.$getPassword(C,E)}store(C,E,I){return this._proxy.$setPassword(C,E,I)}delete(C,E){return this._proxy.$deletePassword(C,E)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(Ie[67],ke([1,0,4,14,5,17]),function(Y,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,u.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(E,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(D.MainContext.MainThreadTelemetry)}report(E,I,R){const k=this.getUsageKey(E,I);this._reportedUsages.has(k)||(this._reportedUsages.add(k),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:E}))}getUsageKey(E,I){return`${E}-${I.identifier.value}`}};y=Ge([xe(0,P.IExtHostRpcService),xe(1,t.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(C,E,I){}})}),define(Ie[236],ke([1,0,3,5,7,28]),function(Y,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new u.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}async getSession(E,I,R,k={}){const _=P.ExtensionIdentifier.toKey(E.identifier),T=this._inFlightRequests.get(_)||[],w=[...R].sort().join(" ");let b=T.find(g=>g.providerId===I&&g.scopes===w);if(b)return b.result;{const g=this._getSession(E,_,I,R,k);b={providerId:I,scopes:w,result:g},T.push(b),this._inFlightRequests.set(_,T);try{await g}finally{const f=T.findIndex(p=>p.providerId===I&&p.scopes===w);f>-1&&(T.splice(f),this._inFlightRequests.set(_,T))}return g}}async _getSession(E,I,R,k,_={}){await this._proxy.$ensureProvider(R);const T=E.displayName||E.name;return this._proxy.$getSession(R,k,I,T,_)}async removeSession(E,I){const R=this._authenticationProviders.get(E);return R?R.provider.removeSession(I):this._proxy.$removeSession(E,I)}registerAuthenticationProvider(E,I,R,k){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:I,provider:R,options:k??{supportsMultipleAccounts:!1}}),this._providers.find(T=>T.id===E)||this._providers.push({id:E,label:I});const _=R.onDidChangeSessions(T=>{this._proxy.$sendDidChangeSessions(E,{added:T.added??[],changed:T.changed??[],removed:T.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,I,k?.supportsMultipleAccounts??!1),new D.Disposable(()=>{_.dispose(),this._authenticationProviders.delete(E);const T=this._providers.findIndex(w=>w.id===E);T>-1&&this._providers.splice(T),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,I){const R=this._authenticationProviders.get(E);if(R)return Promise.resolve(R.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,I){const R=this._authenticationProviders.get(E);if(R)return Promise.resolve(R.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,I){const R=this._authenticationProviders.get(E);if(R)return Promise.resolve(R.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,I){return this._onDidChangeSessions.fire({provider:{id:E,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(Ie[237],ke([1,0,5,17,15,27]),function(Y,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(E,I){this._proxy=E.getProxy(u.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:R=>I.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(E,I){const R=(0,P.isProposedApiEnabled)(I,"snippetWorkspaceEdit"),k=D.WorkspaceEdit.from(E,this._versionInformationProvider,R);return this._proxy.$tryApplyWorkspaceEdit(k)}};y=Ge([xe(0,t.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(Ie[238],ke([1,0,5]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(P){const y=P.getProxy(u.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(C){return y.$writeText(C)}})}}e.ExtHostClipboard=t});var tt=this&&this.__classPrivateFieldSet||function(Y,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Y,u):D?D.value=u:e.set(Y,u),u},Me=this&&this.__classPrivateFieldGet||function(Y,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!t:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Y):t?t.value:e.get(Y)};define(Ie[37],ke([1,0,10,7,15,24,5,16,14,61,35,48,2,6,4,17,132,23,53,49]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g,f,p,v){"use strict";var c,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=class{constructor(s,l){c.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,m.set(this,void 0),tt(this,c,s.getProxy(y.MainContext.MainThreadCommands),"f"),this._logService=l,tt(this,m,s.getProxy(y.MainContext.MainThreadTelemetry),"f"),this.converter=new d(this,h=>{const S=this._apiCommands.get(h);return S?.result===o.Void?S:void 0},l),this._argumentProcessors=[{processArgument(h){return(0,I.revive)(h)}},{processArgument(h){return(0,P.cloneAndChange)(h,function(S){if(R.Range.isIRange(S))return D.Range.to(S);if(k.Position.isIPosition(S))return D.Position.to(S);if(R.Range.isIRange(S.range)&&_.URI.isUri(S.uri))return D.location.to(S);if(S instanceof f.VSBuffer)return S.buffer.buffer;if(!Array.isArray(S))return S})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const l=this.registerCommand(!1,s.id,async(...h)=>{const S=s.args.map((M,F)=>{if(!M.validate(h[F]))throw new Error(`Invalid argument '${M.name}' when running '${s.id}', received: ${h[F]}`);return M.convert(h[F])}),L=await this.executeCommand(s.internalId,...S);return s.result.convert(L,h,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new t.Disposable(()=>{l.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,l,h,S,L,M){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:h,thisArg:S,description:L,extension:M}),s&&Me(this,c,"f").$registerCommand(l),new t.Disposable(()=>{this._commands.delete(l)&&s&&Me(this,c,"f").$unregisterCommand(l)})}executeCommand(s,...l){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,l,!0)}async _doExecuteCommand(s,l,h){if(this._commands.has(s))return Me(this,c,"f").$fireCommandActivationEvent(s),this._executeContributedCommand(s,l,!1);{let S=!1;const L=(0,P.cloneAndChange)(l,function(M){if(M instanceof t.Position)return D.Position.from(M);if(M instanceof t.Range)return D.Range.from(M);if(M instanceof t.Location)return D.location.from(M);if(t.NotebookRange.isNotebookRange(M))return D.NotebookRange.from(M);if(M instanceof ArrayBuffer)return S=!0,f.VSBuffer.wrap(new Uint8Array(M));if(M instanceof Uint8Array)return S=!0,f.VSBuffer.wrap(M);if(M instanceof f.VSBuffer)return S=!0,M;if(!Array.isArray(M))return M});try{const M=await Me(this,c,"f").$executeCommand(s,S?new p.SerializableObjectWithBuffers(L):L,h);return(0,I.revive)(M)}catch(M){if(M instanceof Error&&M.message==="$executeCommand:retry")return this._doExecuteCommand(s,l,!1);throw M}}}async _executeContributedCommand(s,l,h){const S=this._commands.get(s);if(!S)throw new Error("Unknown command");this._reportTelemetry(S,s);const{callback:L,thisArg:M,description:F}=S;if(F)for(let A=0;A<F.args.length;A++)try{(0,u.validateConstraint)(l[A],F.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${F.args[A].name}' - ${F.args[A].description}`)}try{return await L.apply(M,l)}catch(A){if(s===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...l);B&&(s=B.command)}throw this._logService.error(A,s,S.extension?.identifier),h?new class extends Error{constructor(){super((0,v.toErrorMessage)(A));this.id=s,this.source=S.extension?.displayName??S.extension?.name}}:A}}_reportTelemetry(s,l){!s.extension||s.extension.isBuiltin||Me(this,m,"f").$publicLog2("Extension:ActionExecuted",{extensionId:s.extension.identifier.value,id:l})}$executeContributedCommand(s,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(l=l.map(h=>this._argumentProcessors.reduce((S,L)=>L.processArgument(S),h)),this._executeContributedCommand(s,l,!0)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),Me(this,c,"f").$getCommands().then(l=>(s&&(l=l.filter(h=>h[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(const[l,h]of this._commands){const{description:S}=h;S&&(s[l]=S)}return Promise.resolve(s)}};c=new WeakMap,m=new WeakMap,a=Ge([xe(0,b.IExtHostRpcService),xe(1,E.ILogService)],a),e.ExtHostCommands=a,e.IExtHostCommands=(0,w.createDecorator)("IExtHostCommands");class d{constructor(s,l,h){this._commands=s,this._lookupApiCommand=l,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,l){if(!s)return;const h={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return h;const S=this._lookupApiCommand(s.command);if(S)h.id=S.internalId,h.arguments=S.args.map((L,M)=>L.convert(s.arguments&&s.arguments[M]));else if((0,C.isNonEmptyArray)(s.arguments)){const L=++this._cachIdPool;this._cache.set(L,s),l.add((0,T.toDisposable)(()=>{this._cache.delete(L),this._logService.trace("CommandsConverter#DISPOSE",L)})),h.$ident=L,h.id=this.delegatingCommandId,h.arguments=[L],this._logService.trace("CommandsConverter#CREATE",s.command,L)}return h}fromInternal(s){return typeof s.$ident=="number"?this._cache.get(s.$ident):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const l=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=d;class r{constructor(s,l,h,S){this.name=s,this.description=l,this.validate=h,this.convert=S}optional(){return new r(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,l){return new r(s??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=r,r.Uri=new r("uri","Uri of a text document",n=>_.URI.isUri(n),n=>n),r.Position=new r("position","A position in a text document",n=>t.Position.isPosition(n),D.Position.from),r.Range=new r("range","A range in a text document",n=>t.Range.isRange(n),D.Range.from),r.Selection=new r("selection","A selection in a text document",n=>t.Selection.isSelection(n),D.Selection.from),r.Number=new r("number","",n=>typeof n=="number",n=>n),r.String=new r("string","",n=>typeof n=="string",n=>n),r.CallHierarchyItem=new r("item","A call hierarchy item",n=>n instanceof t.CallHierarchyItem,D.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",n=>n instanceof t.TypeHierarchyItem,D.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",n=>n instanceof g.TestItemImpl,D.TestItem.from);class o{constructor(s,l){this.description=s,this.convert=l}}e.ApiCommandResult=o,o.Void=new o("no result",n=>n);class i{constructor(s,l,h,S,L){this.id=s,this.internalId=l,this.description=h,this.args=S,this.result=L}}e.ApiCommand=i}),define(Ie[239],ke([1,0,2,15,7,63,37,16,113,118,11]),function(Y,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const k=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(t.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(b,g)=>{if((0,C.isFalsyOrEmpty)(b))return;class f extends D.SymbolInformation{static to(v){const c=new f(v.name,t.SymbolKind.to(v.kind),v.containerName||"",new D.Location(g[0],t.Range.to(v.range)));return c.detail=v.detail,c.range=c.location.range,c.selectionRange=t.Range.to(v.selectionRange),c.children=v.children?v.children.map(f.to):[],c}}return b.map(f.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",b=>!0,b=>b)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",b=>!0,b=>b)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",b=>typeof b=="string",b=>b),new y.ApiCommandArgument("options","Formatting options",b=>!0,b=>b)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(t.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(t.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",b=>Array.isArray(b)&&b.every(g=>D.Position.isPosition(g)),b=>b.map(t.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",b=>b.map(g=>{let f;for(const p of g.reverse())f=new D.SelectionRange(t.Range.to(p),f);return f}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",b=>b.map(t.WorkspaceSymbol.to))),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",b=>b.map(t.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",b=>b.map(t.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",b=>b.map(t.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",b=>{if(!!b)return{range:t.Range.to(b.range),placeholder:b.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",b=>{if(!!b){if(b.rejectReason)throw new Error(b.rejectReason);return t.WorkspaceEdit.to(b)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",b=>b.map(t.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",b=>{if(!!b)return new D.SemanticTokensLegend(b.tokenTypes,b.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",b=>{if(!b)return;const g=(0,E.decodeSemanticTokensDto)(b);if(g.type==="full")return new D.SemanticTokens(g.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range.optional()],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",b=>{if(!!b)return new D.SemanticTokensLegend(b.tokenTypes,b.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",b=>{if(!b)return;const g=(0,E.decodeSemanticTokensDto)(b);if(g.type==="full")return new D.SemanticTokens(g.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(b,g,f)=>{if(!b)return new D.CompletionList([]);const p=b.suggestions.map(v=>t.CompletionItem.to(v,f));return new D.CompletionList(p,b.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",b=>{if(b)return t.SignatureHelp.to(b)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(b,g,f)=>T(p=>new D.CodeLens(t.Range.to(p.range),p.command&&f.fromInternal(p.command)))(b))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",b=>D.Range.isRange(b),b=>D.Selection.isSelection(b)?t.Selection.from(b):t.Range.from(b)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(b,g,f)=>T(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(p.command)}else{const v=new D.CodeAction(p.title,p.kind?new D.CodeActionKind(p.kind):void 0);return p.edit&&(v.edit=t.WorkspaceEdit.to(p.edit)),p.command&&(v.command=f.fromInternal(p.command)),v.isPreferred=p.isPreferred,v}})(b))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",b=>b?b.map(g=>new D.ColorInformation(t.Range.to(g.range),t.Color.to(g.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",b=>b instanceof D.Color,t.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",b=>!0,b=>({uri:b.uri,range:t.Range.from(b.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",b=>b?b.map(t.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",(b,g,f)=>b.map(t.InlayHint.to.bind(void 0,f)))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(b=>({viewType:b.viewType,displayName:b.displayName,options:{transientOutputs:b.options.transientOutputs,transientCellMetadata:b.options.transientCellMetadata,transientDocumentMetadata:b.options.transientDocumentMetadata},filenamePattern:b.filenamePattern.map(g=>t.NotebookExclusiveDocumentPattern.to(g))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",b=>b.map(t.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new y.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",b=>u.URI.isUri(b)||typeof b=="string"&&(0,I.matchesSomeScheme)(b,R.Schemas.http,R.Schemas.https),b=>b),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",b=>b===void 0||typeof b=="number"||typeof b=="object",b=>b&&(typeof b=="number"?[t.ViewColumn.from(b),void 0]:[t.ViewColumn.from(b.viewColumn),t.TextEditorOpenOptions.from(b)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",b=>b===void 0||typeof b=="number"||typeof b=="object",b=>b&&(typeof b=="number"?[t.ViewColumn.from(b),void 0]:[t.ViewColumn.from(b.viewColumn),t.TextEditorOpenOptions.from(b)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",b=>b===void 0||typeof b=="object",b=>b&&[t.ViewColumn.from(b.viewColumn),t.TextEditorOpenOptions.from(b)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",b=>b.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",b=>b.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",b=>b.map(t.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void),new y.ApiCommand("vscode.experimental.editSession.continue","_workbench.experimental.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[y.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],y.ApiCommandResult.Void)];class _{static register(g){k.forEach(g.registerApiCommand,g)}}e.ExtHostApiCommands=_;function T(b){return g=>{if(Array.isArray(g))return g.map(b)}}function w(b){if(!Array.isArray(b))return;const g=[];for(const f of b)P.isLocationLink(f)?g.push(t.DefinitionLink.to(f)):g.push(t.location.to(f));return g}}),define(Ie[240],ke([1,0,18,57,3,6,2,63,28,15,7,27,5]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function T(w,b,g){const f=w.getProxy(_.MainContext.MainThreadComments);class p{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,b.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const s=this._commentControllers.get(n.handle);return s?s.value:n}else if(n&&n.$mid===7){const s=this._commentControllers.get(n.commentControlHandle);if(!s)return n;const l=s.getCommentThread(n.commentThreadHandle);return l?l.value:n}else if(n&&n.$mid===8){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const l=s.getCommentThread(n.thread.commentThreadHandle);return l?{thread:l.value,text:n.text}:n}else if(n&&n.$mid===9){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const l=s.getCommentThread(n.thread.commentThreadHandle);if(!l)return n;const h=n.commentUniqueId,S=l.getCommentByUniqueId(h);return S||n}else if(n&&n.$mid===10){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const l=s.getCommentThread(n.thread.commentThreadHandle);if(!l)return n;const h=n.text,S=n.commentUniqueId,L=l.getCommentByUniqueId(S);return L?(L.body=h,L):n}return n}})}createCommentController(n,s,l){const h=p.handlePool++,S=new c(n,h,s,l);this._commentControllers.set(S.handle,S);const L=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(n.identifier))||[];return L.push(S),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(n.identifier),L),S.value}$createCommentThreadTemplate(n,s,l){const h=this._commentControllers.get(n);!h||h.$createCommentThreadTemplate(s,l)}async $updateCommentThreadTemplate(n,s,l){const h=this._commentControllers.get(n);!h||h.$updateCommentThreadTemplate(s,l)}$deleteCommentThread(n,s){this._commentControllers.get(n)?.$deleteCommentThread(s)}$provideCommentingRanges(n,s,l){const h=this._commentControllers.get(n);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const S=g.getDocument(y.URI.revive(s));return(0,u.asPromise)(()=>h.commentingRangeProvider.provideCommentingRanges(S,l)).then(L=>L?L.map(M=>I.Range.from(M)):void 0)}$toggleReaction(n,s,l,h,S){const L=this._commentControllers.get(n);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,u.asPromise)(()=>{const M=L.getCommentThread(s);if(M){const F=M.getCommentByUniqueId(h.uniqueIdInThread);if(L!==void 0&&F&&L.reactionHandler)return L.reactionHandler(F,d(S))}return Promise.resolve(void 0)})}dispose(){}}p.handlePool=0;class v{constructor(n,s,l,h,S,L,M,F){this._commentControllerHandle=s,this._id=l,this._uri=h,this._range=S,this._comments=L,this.extensionDescription=M,this._isTemplate=F,this.handle=v._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),f.$createCommentThread(s,this.handle,this._id,this._uri,I.Range.from(this._range),M.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this._localDisposables.push({dispose:()=>{f.$deleteCommentThread(s,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(B){A.range=B},get comments(){return A.comments},set comments(B){A.comments=B},get collapsibleState(){return A.collapsibleState},set collapsibleState(B){A.collapsibleState=B},get canReply(){return A.canReply},set canReply(B){A.canReply=B},get contextValue(){return A.contextValue},set contextValue(B){A.contextValue=B},get label(){return A.label},set label(B){A.label=B},get state(){return A.state},set state(B){A.state=B},dispose:()=>{A.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get state(){return(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(n){(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=n,this.modifications.state=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const n=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),s={};n("range")&&(s.range=I.Range.from(this._range)),n("label")&&(s.label=this.label),n("contextValue")&&(s.contextValue=this.contextValue??null),n("comments")&&(s.comments=this._comments.map(l=>m(this,l,this._commentsMap))),n("collapsibleState")&&(s.collapseState=r(this._collapseState)),n("canReply")&&(s.canReply=this.canReply),n("state")&&(s.state=o(this._state)),n("isTemplate")&&(s.isTemplate=this._isTemplate),this.modifications={},f.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,s)}getCommentByUniqueId(n){for(const s of this._commentsMap){const l=s[0],h=s[1];if(n===h)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}v._handlePool=0,Ge([(0,t.debounce)(100)],v.prototype,"eventuallyUpdateCommentThread",null);class c{constructor(n,s,l,h){this._extension=n,this._handle=s,this._id=l,this._label=h,this._threads=new Map,f.$registerCommentController(this.handle,l,h);const S=this;this.value=Object.freeze({id:S.id,label:S.label,get options(){return S.options},set options(L){S.options=L},get commentingRangeProvider(){return S.commentingRangeProvider},set commentingRangeProvider(L){S.commentingRangeProvider=L},get reactionHandler(){return S.reactionHandler},set reactionHandler(L){S.reactionHandler=L},createCommentThread(L,M,F){return S.createCommentThread(L,M,F).value},dispose:()=>{S.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(n){this._commentingRangeProvider=n,f.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,f.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,s,l,h){if(typeof n=="string"){const S=new v(this.id,this.handle,n,s,l,h,this._extension,!1);return this._threads.set(S.handle,S),S}else{const S=new v(this.id,this.handle,void 0,n,s,l,this._extension,!1);return this._threads.set(S.handle,S),S}}$createCommentThreadTemplate(n,s){const l=new v(this.id,this.handle,void 0,y.URI.revive(n),I.Range.to(s),[],this._extension,!0);return l.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(n,s){const l=this._threads.get(n);l&&(l.range=I.Range.to(s))}$deleteCommentThread(n){const s=this._threads.get(n);s&&s.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function m(i,n,s){let l=s.get(n);l||(l=++i.commentHandle,s.set(n,l));const h=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:l,body:typeof n.body=="string"?n.body:I.MarkdownString.from(n.body),userName:n.author.name,userIconPath:h,label:n.label,commentReactions:n.reactions?n.reactions.map(S=>a(S)):void 0,timestamp:n.timestamp?.toJSON()}}function a(i){return{label:i.label,iconPath:i.iconPath?I.pathOrURIToURI(i.iconPath):void 0,count:i.count,hasReacted:i.authorHasReacted}}function d(i){return{label:i.label||"",count:i.count||0,iconPath:i.iconPath?y.URI.revive(i.iconPath):"",authorHasReacted:i.hasReacted||!1}}function r(i){if(i!==void 0)switch(i){case R.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}function o(i){if(i!==void 0)switch(i){case R.CommentThreadState.Unresolved:return C.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return C.CommentThreadState.Resolved}return C.CommentThreadState.Unresolved}return new p}e.createExtHostComments=T}),define(Ie[241],ke([1,0,24,5,26,17]),function(Y,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let y=class{constructor(R,k){this._mainThreadConsole=R.getProxy(t.MainContext.MainThreadConsole),this._includeStack=k.consoleForward.includeStack,this._logNative=k.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,k){const _=this,T=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){_._handleConsoleCall(R,k,T,arguments)}})}_handleConsoleCall(R,k,_,T){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:k,arguments:E(T,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,_,T)}};y=Ge([xe(0,P.IExtHostRpcService),xe(1,D.IExtHostInitDataService)],y),e.AbstractExtHostConsoleForwarder=y;const C=1e5;function E(I,R){const k=[];if(I.length)for(let _=0;_<I.length;_++){let T=I[_];if(typeof T=="undefined")T="undefined";else if(T instanceof Error){const w=T;w.stack?T=w.stack:T=w.toString()}k.push(T)}if(R){const _=new Error().stack;_&&k.push({__$stack:_.split(`
`).slice(3).join(`
`)})}try{const _=(0,u.safeStringify)(k);return _.length>C?"Output omitted for a large object that exceeds the limits":_}catch(_){return`Output omitted for an object that cannot be inspected ('${_.toString()}')`}}}),define(Ie[135],ke([1,0,2,5,7,4,17,14,16,8,9]),function(Y,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class kn{constructor(T,w){this._logService=w,this._provider=new Map,this._proxy=T.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(T,w){const b=kn._handlePool++;this._provider.set(b,{provider:T,extensionId:w}),this._proxy.$registerDecorationProvider(b,w.value);const g=T.onDidChangeFileDecorations&&T.onDidChangeFileDecorations(f=>{if(!f){this._proxy.$onDidChange(b,null);return}const p=(0,E.asArray)(f);if(p.length<=kn._maxEventSize){this._proxy.$onDidChange(b,p);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",w.value,p.length);const v=p.map(a=>({uri:a,rank:(0,I.count)(a.path,"/")})),c=(0,E.groupBy)(v,(a,d)=>a.rank-d.rank||(0,I.compare)(a.uri.path,d.uri.path)),m=[];e:for(const a of c){let d;for(const r of a){const o=(0,R.dirname)(r.uri.path);if(d!==o&&(d=o,m.push(r.uri)>=kn._maxEventSize))break e}}this._proxy.$onDidChange(b,m)});return new D.Disposable(()=>{g?.dispose(),this._proxy.$unregisterDecorationProvider(b),this._provider.delete(b)})}async $provideDecorations(T,w,b){if(!this._provider.has(T))return Object.create(null);const g=Object.create(null),{provider:f,extensionId:p}=this._provider.get(T);return await Promise.all(w.map(async v=>{try{const{uri:c,id:m}=v,a=await Promise.resolve(f.provideFileDecoration(u.URI.revive(c),b));if(!a)return;try{D.FileDecoration.validate(a),g[m]=[a.propagate,a.tooltip,a.badge,a.color]}catch(d){this._logService.warn(`INVALID decoration from extension '${p.value}': ${d}`)}}catch(c){this._logService.error(c)}})),g}};k._handlePool=0,k._maxEventSize=250,k=Ge([xe(0,y.IExtHostRpcService),xe(1,C.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var tt=this&&this.__classPrivateFieldSet||function(Y,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Y,u):D?D.value=u:e.set(Y,u),u},Me=this&&this.__classPrivateFieldGet||function(Y,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!t:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Y):t?t.value:e.get(Y)};define(Ie[242],ke([1,0,170,117,2,5,7,15,3,14,25,46]),function(Y,e,u,t,D,P,y,C,E,I,R,k){"use strict";var _,T,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class b{constructor(p,v,c,m,a,d){this._name=p,this._owner=v,this._maxDiagnosticsPerFile=c,_.set(this,void 0),T.set(this,void 0),w.set(this,void 0),this._isDisposed=!1,tt(this,w,new R.ResourceMap(r=>m.getComparisonKey(r)),"f"),tt(this,_,a,"f"),tt(this,T,d,"f")}dispose(){this._isDisposed||(Me(this,T,"f").fire([...Me(this,w,"f").keys()]),Me(this,_,"f")?.$clear(this._owner),Me(this,w,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(p,v){if(!p){this.clear();return}this._checkDisposed();let c=[];if(D.URI.isUri(p)){if(!v){this.delete(p);return}Me(this,w,"f").set(p,v.slice()),c=[p]}else if(Array.isArray(p)){c=[];let a;p=[...p].sort(b._compareIndexedTuplesByUri);for(const d of p){const[r,o]=d;if((!a||r.toString()!==a.toString())&&(a&&Me(this,w,"f").get(a).length===0&&Me(this,w,"f").delete(a),a=r,c.push(r),Me(this,w,"f").set(r,[])),o)Me(this,w,"f").get(r)?.push(...o);else{const i=Me(this,w,"f").get(r);i&&(i.length=0)}}}if(Me(this,T,"f").fire(c),!Me(this,_,"f"))return;const m=[];for(const a of c){let d=[];const r=Me(this,w,"f").get(a);if(r)if(r.length>this._maxDiagnosticsPerFile){d=[];const o=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const n of r)if(n.severity===o[i]&&d.push(C.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;d.push({severity:t.MarkerSeverity.Info,message:(0,u.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=r.map(o=>C.Diagnostic.from(o));m.push([a,d])}Me(this,_,"f").$changeMany(this._owner,m)}delete(p){this._checkDisposed(),Me(this,T,"f").fire([p]),Me(this,w,"f").delete(p),Me(this,_,"f")?.$changeMany(this._owner,[[p,void 0]])}clear(){this._checkDisposed(),Me(this,T,"f").fire([...Me(this,w,"f").keys()]),Me(this,w,"f").clear(),Me(this,_,"f")?.$clear(this._owner)}forEach(p,v){this._checkDisposed();for(const[c,m]of this)p.call(v,c,m,this)}*[(_=new WeakMap,T=new WeakMap,w=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const p of Me(this,w,"f").keys())yield[p,this.get(p)]}get(p){this._checkDisposed();const v=Me(this,w,"f").get(p);return Array.isArray(v)?Object.freeze(v.slice(0)):[]}has(p){return this._checkDisposed(),Array.isArray(Me(this,w,"f").get(p))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(p,v){return p[0].toString()<v[0].toString()?-1:p[0].toString()>v[0].toString()?1:0}}e.DiagnosticCollection=b;let g=class hn{constructor(p,v,c){this._logService=v,this._fileSystemInfoService=c,this._collections=new Map,this._onDidChangeDiagnostics=new E.DebounceEmitter({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this._onDidChangeDiagnostics.event,hn._mapper),this._proxy=p.getProxy(P.MainContext.MainThreadDiagnostics)}static _mapper(p){const v=new R.ResourceMap;for(const c of p)v.set(c,c);return{uris:Object.freeze(Array.from(v.values()))}}createDiagnosticCollection(p,v){const{_collections:c,_proxy:m,_onDidChangeDiagnostics:a,_logService:d,_fileSystemInfoService:r}=this,o=new class{$changeMany(s,l){m.$changeMany(s,l),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,s,l.length===0?"CLEARING":l)}$clear(s){m.$clear(s),d.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,s)}dispose(){m.dispose()}};let i;if(!v)v="_generated_diagnostic_collection_name_#"+hn._idPool++,i=v;else if(!c.has(v))i=v;else{this._logService.warn(`DiagnosticCollection with name '${v}' does already exist.`);do i=v+hn._idPool++;while(c.has(i))}return new class extends b{constructor(){super(v,i,hn._maxDiagnosticsPerFile,r.extUri,o,a);c.set(i,this)}dispose(){super.dispose(),c.delete(i)}}}getDiagnostics(p){if(p)return this._getDiagnostics(p);{const v=new Map,c=[];for(const m of this._collections.values())m.forEach((a,d)=>{let r=v.get(a.toString());typeof r=="undefined"&&(r=c.length,v.set(a.toString(),r),c.push([a,[]])),c[r][1]=c[r][1].concat(...d)});return c}}_getDiagnostics(p){let v=[];for(const c of this._collections.values())c.has(p)&&(v=v.concat(c.get(p)));return v}$acceptMarkersChange(p){if(!this._mirrorCollection){const v="_generated_mirror",c=new b(v,v,hn._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(v,c),this._mirrorCollection=c}for(const[v,c]of p)this._mirrorCollection.set(D.URI.revive(v),c.map(C.Diagnostic.to))}};g._idPool=0,g._maxDiagnosticsPerFile=1e3,g=Ge([xe(1,I.ILogService),xe(2,k.IExtHostFileSystemInfo)],g),e.ExtHostDiagnostics=g}),define(Ie[243],ke([1,0,2,5]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(y){this._proxy=y.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(C=>C?C.map(E=>u.URI.revive(E)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(C=>C?u.URI.revive(C):void 0)}}e.ExtHostDialogs=D}),define(Ie[244],ke([1,0,12,2,7,5,11,21,8]),function(Y,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(k,_,T){this._documentsAndEditors=_,this._logService=T,this._documentContentProviders=new Map,this._proxy=k.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,_){if(Object.keys(y.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const T=I._handlePool++;this._documentContentProviders.set(T,_),this._proxy.$registerTextContentProvider(T,k);let w;return typeof _.onDidChange=="function"&&(w=_.onDidChange(b=>{if(b.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${b.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(b)&&this.$provideTextDocumentContent(T,b).then(g=>{if(!g&&typeof g!="string")return;const f=this._documentsAndEditors.getDocument(b);if(!f)return;const p=(0,E.splitLines)(g);if(!f.equalLines(p))return this._proxy.$onVirtualDocumentChange(b,g)},u.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(k,_){const T=this._documentContentProviders.get(k);return T?Promise.resolve(T.provideTextDocumentContent(t.URI.revive(_),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${_.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(Ie[245],ke([1,0,3,6,2,5,126,15,10,24,7]),function(Y,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(T,w){this._onDidAddDocument=new u.Emitter,this._onDidRemoveDocument=new u.Emitter,this._onDidChangeDocument=new u.Emitter,this._onDidSaveDocument=new u.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=w,this._documentsAndEditors.onDidRemoveDocuments(b=>{for(const g of b)this._onDidRemoveDocument.fire(g.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(b=>{for(const g of b)this._onDidAddDocument.fire(g.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const w=this._documentsAndEditors.getDocument(T);if(w)return w}getDocument(T){const w=this.getDocumentData(T);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return w.document}ensureDocumentData(T){const w=this._documentsAndEditors.getDocument(T);if(w)return Promise.resolve(w);let b=this._documentLoader.get(T.toString());return b||(b=this._proxy.$tryOpenDocument(T).then(g=>{this._documentLoader.delete(T.toString());const f=D.URI.revive(g);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(f))},g=>(this._documentLoader.delete(T.toString()),Promise.reject(g))),this._documentLoader.set(T.toString(),b)),b}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(w=>D.URI.revive(w))}$acceptModelLanguageChanged(T,w){const b=D.URI.revive(T),g=this._documentsAndEditors.getDocument(b);if(!g)throw new Error("unknown document");this._onDidRemoveDocument.fire(g.document),g._acceptLanguageId(w),this._onDidAddDocument.fire(g.document)}$acceptModelSaved(T){const w=D.URI.revive(T),b=this._documentsAndEditors.getDocument(w);if(!b)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(b.document)}$acceptDirtyStateChanged(T,w){const b=D.URI.revive(T),g=this._documentsAndEditors.getDocument(b);if(!g)throw new Error("unknown document");g._acceptIsDirty(w),this._onDidChangeDocument.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,w,b){const g=D.URI.revive(T),f=this._documentsAndEditors.getDocument(g);if(!f)throw new Error("unknown document");f._acceptIsDirty(b),f.onEvents(w);let p;w.isUndoing?p=R.TextDocumentChangeReason.Undo:w.isRedoing&&(p=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:f.document,contentChanges:w.changes.map(v=>({range:C.Range.to(v.range),rangeOffset:v.rangeOffset,rangeLength:v.rangeLength,text:v.text})),reason:p}))}setWordDefinitionFor(T,w){(0,y.setWordDefinitionFor)(T,w)}}e.ExtHostDocuments=k}),define(Ie[54],ke([1,0,56,3,6,2,4,5,126,17,133,15,14,25,11,59,78]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class f{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let p=class{constructor(c,m){this._extHostRpc=c,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const m=[],a=[],d=[];if(c.removedDocuments)for(const r of c.removedDocuments){const o=P.URI.revive(r),i=this._documents.get(o);i?.unref()&&(this._documents.delete(o),m.push(i.value))}if(c.addedDocuments)for(const r of c.addedDocuments){const o=P.URI.revive(r.uri);let i=this._documents.get(o);if(i&&o.scheme!==w.Schemas.vscodeNotebookCell&&o.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);i||(i=new f(new E.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),o,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(o,i),a.push(i.value)),i.ref()}if(c.removedEditors)for(const r of c.removedEditors){const o=this._editors.get(r);this._editors.delete(r),o&&d.push(o)}if(c.addedEditors)for(const r of c.addedEditors){const o=P.URI.revive(r.documentUri);u.ok(this._documents.has(o),`document '${o}' does not exist`),u.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const i=this._documents.get(o).value,n=new R.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new g.Lazy(()=>i.document),r.selections.map(k.Selection.to),r.options,r.visibleRanges.map(s=>k.Range.to(s)),typeof r.editorPosition=="number"?k.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,n)}c.newActiveEditor!==void 0&&(u.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,D.dispose)(m),(0,D.dispose)(d),c.removedDocuments&&this._onDidRemoveDocuments.fire(m),c.addedDocuments&&this._onDidAddDocuments.fire(a),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return b.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return c?m:m?.value}allEditors(){return[...this._editors.values()]}};p=Ge([xe(0,I.IExtHostRpcService),xe(1,_.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[55],ke([1,0,15,5,2,3,4,7,17,10,77]),function(Y,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,y.createDecorator)("IExtHostEditorTabs");class k{constructor(g,f,p){this._activeTabIdGetter=p,this._parentGroup=f,this.acceptDtoUpdate(g)}get apiObject(){if(!this._apiObject){const g=this,f={get isActive(){return g._dto.id===g._activeTabIdGetter()},get label(){return g._dto.label},get input(){return g._input},get isDirty(){return g._dto.isDirty},get isPinned(){return g._dto.isPinned},get isPreview(){return g._dto.isPreview},get group(){return g._parentGroup.apiObject}};this._apiObject=Object.freeze(f)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(g){this._dto=g,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new C.TextTabInput(D.URI.revive(this._dto.input.uri));case 2:return new C.TextDiffTabInput(D.URI.revive(this._dto.input.original),D.URI.revive(this._dto.input.modified));case 3:return new C.TextMergeTabInput(D.URI.revive(this._dto.input.base),D.URI.revive(this._dto.input.input1),D.URI.revive(this._dto.input.input2),D.URI.revive(this._dto.input.result));case 6:return new C.CustomEditorTabInput(D.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new C.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new C.NotebookEditorTabInput(D.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new C.NotebookDiffEditorTabInput(D.URI.revive(this._dto.input.original),D.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new C.TerminalEditorTabInput;case 9:return new C.InteractiveWindowInput(D.URI.revive(this._dto.input.uri),D.URI.revive(this._dto.input.inputBoxUri));default:return}}}class _{constructor(g,f){this._tabs=[],this._activeTabId="",this._dto=g,this._activeGroupIdGetter=f;for(const p of g.tabs)p.isActive&&(this._activeTabId=p.id),this._tabs.push(new k(p,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const g=this,f={get isActive(){return g._dto.groupId===g._activeGroupIdGetter()},get viewColumn(){return u.ViewColumn.to(g._dto.viewColumn)},get activeTab(){return g._tabs.find(p=>p.tabId===g._activeTabId)?.apiObject},get tabs(){return Object.freeze(g._tabs.map(p=>p.apiObject))}};this._apiObject=Object.freeze(f)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(g){this._dto=g}acceptTabOperation(g){if(g.kind===0){const p=new k(g.tabDto,this,()=>this.activeTabId());return this._tabs.splice(g.index,0,p),g.tabDto.isActive&&(this._activeTabId=p.tabId),p}else if(g.kind===1){const p=this._tabs.splice(g.index,1)[0];if(!p)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return p.tabId===this._activeTabId&&(this._activeTabId=""),p}else if(g.kind===3){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const p=this._tabs.splice(g.oldIndex,1)[0];if(!p)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this._tabs.splice(g.index,0,p),p}const f=this._tabs.find(p=>p.tabId===g.tabDto.id);if(!f)throw new Error("INVALID tab");return g.tabDto.isActive?this._activeTabId=g.tabDto.id:this._activeTabId===g.tabDto.id&&!g.tabDto.isActive&&(this._activeTabId=""),f.acceptDtoUpdate(g.tabDto),f}activeTabId(){return this._activeTabId}}let T=class{constructor(g){this._onDidChangeTabs=new P.Emitter,this._onDidChangeTabGroups=new P.Emitter,this._extHostTabGroups=[],this._proxy=g.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const g=this,f={onDidChangeTabGroups:g._onDidChangeTabGroups.event,onDidChangeTabs:g._onDidChangeTabs.event,get all(){return Object.freeze(g._extHostTabGroups.map(p=>p.apiObject))},get activeTabGroup(){const p=g._activeGroupId;return(0,I.assertIsDefined)(g._extHostTabGroups.find(c=>c.groupId===p)?.apiObject)},close:async(p,v)=>{const c=Array.isArray(p)?p:[p];return c.length?w(c[0])?this._closeGroups(c,v):this._closeTabs(c,v):!0}};this._apiObject=Object.freeze(f)}return this._apiObject}$acceptEditorTabModel(g){const f=new Set(this._extHostTabGroups.map(r=>r.groupId)),p=new Set(g.map(r=>r.groupId)),v=(0,R.diffSets)(f,p),c=this._extHostTabGroups.filter(r=>v.removed.includes(r.groupId)).map(r=>r.apiObject),m=[],a=[];this._extHostTabGroups=g.map(r=>{const o=new _(r,()=>this._activeGroupId);return v.added.includes(o.groupId)?m.push(o.apiObject):a.push(o.apiObject),o});const d=(0,I.assertIsDefined)(g.find(r=>r.isActive===!0)?.groupId);d!==void 0&&this._activeGroupId!==d&&(this._activeGroupId=d),this._onDidChangeTabGroups.fire(Object.freeze({opened:m,closed:c,changed:a}))}$acceptTabGroupUpdate(g){const f=this._extHostTabGroups.find(p=>p.groupId===g.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(g),g.isActive&&(this._activeGroupId=g.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const f=this._extHostTabGroups.find(v=>v.groupId===g.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const p=f.acceptTabOperation(g);switch(g.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[p.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[p.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[p.apiObject]}));return}}_findExtHostTabFromApi(g){for(const f of this._extHostTabGroups)for(const p of f.tabs)if(p.apiObject===g)return p}_findExtHostTabGroupFromApi(g){return this._extHostTabGroups.find(f=>f.apiObject===g)}async _closeTabs(g,f){const p=[];for(const v of g){const c=this._findExtHostTabFromApi(v);if(!c)throw new Error("Tab close: Invalid tab not found!");p.push(c.tabId)}return this._proxy.$closeTab(p,f)}async _closeGroups(g,f){const p=[];for(const v of g){const c=this._findExtHostTabGroupFromApi(v);if(!c)throw new Error("Group close: Invalid group not found!");p.push(c.groupId)}return this._proxy.$closeGroup(p,f)}};T=Ge([xe(0,E.IExtHostRpcService)],T),e.ExtHostEditorTabs=T;function w(b){return b.tabs!==void 0}}),define(Ie[246],ke([1,0,2,5,6,7,15,149,8,23,27]),function(Y,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class k{constructor(){this._schemes=[]}add(w){this._stateMachine=void 0,this._schemes.push(w)}delete(w){const b=this._schemes.indexOf(w);b>=0&&(this._schemes.splice(b,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const w=this._schemes.sort(),b=[];let g,f,p=14,v=14;for(const c of w){let m=g?(0,E.commonPrefixLength)(g,c):0;for(m===0?f=1:f=v;m<c.length;m++)m+1===c.length?(p=v,v=9):v+=1,b.push([f,c.toUpperCase().charCodeAt(m),v]),b.push([f,c.toLowerCase().charCodeAt(m),v]),f=v;g=c,v=p}b.push([9,58,10]),b.push([10,47,12]),this._stateMachine=new C.StateMachine(b)}}provideDocumentLinks(w){this._initStateMachine();const b=[],g=C.LinkComputer.computeLinks({getLineContent(f){return w.lineAt(f-1).text},getLineCount(){return w.lineCount}},this._stateMachine);for(const f of g){const p=y.DocumentLink.to(f);p.target&&b.push(p)}return b}}class _{constructor(w,b){this._extHostLanguageFeatures=b,this._linkProvider=new k,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=w.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(w,b,g,f={}){if(this._registeredSchemes.has(b))throw new Error(`a provider for the scheme '${b}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(w,"*",this._linkProvider));const p=this._handlePool++;this._linkProvider.add(b),this._registeredSchemes.add(b),this._fsProvider.set(p,g);let v=2;f.isCaseSensitive&&(v+=1024),f.isReadonly&&(v+=2048),typeof g.copy=="function"&&(v+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&((0,R.checkProposedApiEnabled)(w,"fsChunks"),v+=4),this._proxy.$registerFileSystemProvider(p,b,v).catch(m=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${b}`),console.error(m)});const c=g.onDidChangeFile(m=>{const a=[];for(const d of m){const{uri:r,type:o}=d;if(r.scheme!==b)continue;let i;switch(o){case P.FileChangeType.Changed:i=0;break;case P.FileChangeType.Created:i=1;break;case P.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:r,type:i})}this._proxy.$onFileSystemChange(p,a)});return(0,D.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(b),this._registeredSchemes.delete(b),this._fsProvider.delete(p),this._proxy.$unregisterProvider(p)})}static _asIStat(w){const{type:b,ctime:g,mtime:f,size:p,permissions:v}=w;return{type:b,ctime:g,mtime:f,size:p,permissions:v}}$stat(w,b){return Promise.resolve(this._getFsProvider(w).stat(u.URI.revive(b))).then(g=>_._asIStat(g))}$readdir(w,b){return Promise.resolve(this._getFsProvider(w).readDirectory(u.URI.revive(b)))}$readFile(w,b){return Promise.resolve(this._getFsProvider(w).readFile(u.URI.revive(b))).then(g=>I.VSBuffer.wrap(g))}$writeFile(w,b,g,f){return Promise.resolve(this._getFsProvider(w).writeFile(u.URI.revive(b),g.buffer,f))}$delete(w,b,g){return Promise.resolve(this._getFsProvider(w).delete(u.URI.revive(b),g))}$rename(w,b,g,f){return Promise.resolve(this._getFsProvider(w).rename(u.URI.revive(b),u.URI.revive(g),f))}$copy(w,b,g,f){const p=this._getFsProvider(w);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(u.URI.revive(b),u.URI.revive(g),f))}$mkdir(w,b){return Promise.resolve(this._getFsProvider(w).createDirectory(u.URI.revive(b)))}$watch(w,b,g,f){const p=this._getFsProvider(w).watch(u.URI.revive(g),f);this._watches.set(b,p)}$unwatch(w,b){const g=this._watches.get(b);g&&(g.dispose(),this._watches.delete(b))}$open(w,b,g){const f=this._getFsProvider(w);if(!f.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(f.open(u.URI.revive(b),g))}$close(w,b){const g=this._getFsProvider(w);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(b))}$read(w,b,g,f){const p=this._getFsProvider(w);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const v=I.VSBuffer.alloc(f);return Promise.resolve(p.read(b,g,v.buffer,0,f)).then(c=>v.slice(0,c))}$write(w,b,g,f){const p=this._getFsProvider(w);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(b,g,f.buffer,0,f.byteLength))}_getFsProvider(w){const b=this._fsProvider.get(w);if(!b){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return b}}e.ExtHostFileSystem=_}),define(Ie[68],ke([1,0,5,43,7,23,4,17,46,6]),function(Y,e,u,t,D,P,y,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Qt{constructor(_,T){this._fileSystemProvider=new Map,this._proxy=_.getProxy(u.MainContext.MainThreadFileSystem);const w=this;this.value=Object.freeze({async stat(b){try{const g=w._fileSystemProvider.get(b.scheme);if(!g)return await w._proxy.$stat(b);await w._proxy.$ensureActivation(b.scheme);const f=await g.stat(b);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions}}catch(g){Qt._handleError(g)}},async readDirectory(b){try{const g=w._fileSystemProvider.get(b.scheme);return g?(await w._proxy.$ensureActivation(b.scheme),(await g.readDirectory(b)).slice()):await w._proxy.$readdir(b)}catch(g){return Qt._handleError(g)}},async createDirectory(b){try{return await w._proxy.$mkdir(b)}catch(g){return Qt._handleError(g)}},async readFile(b){try{const g=w._fileSystemProvider.get(b.scheme);return g?(await w._proxy.$ensureActivation(b.scheme),(await g.readFile(b)).slice()):(await w._proxy.$readFile(b)).buffer}catch(g){return Qt._handleError(g)}},async writeFile(b,g){try{return await w._proxy.$writeFile(b,P.VSBuffer.wrap(g))}catch(f){return Qt._handleError(f)}},async delete(b,g){try{const f=w._fileSystemProvider.get(b.scheme);return f?(await w._proxy.$ensureActivation(b.scheme),await f.delete(b,{recursive:!1,...g})):await w._proxy.$delete(b,{recursive:!1,useTrash:!1,...g})}catch(f){return Qt._handleError(f)}},async rename(b,g,f){try{return await w._proxy.$rename(b,g,{overwrite:!1,...f})}catch(p){return Qt._handleError(p)}},async copy(b,g,f){try{return await w._proxy.$copy(b,g,{overwrite:!1,...f})}catch(p){return Qt._handleError(p)}},isWritableFileSystem(b){const g=T.getCapabilities(b);if(typeof g=="number")return!(g&2048)}})}static _handleError(_){if(_ instanceof D.FileSystemError)throw _;if(!(_ instanceof Error))throw new D.FileSystemError(String(_));if(_.name==="ENOPRO")throw D.FileSystemError.Unavailable(_.message);switch(_.name){case t.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(_.message);case t.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(_.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(_.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(_.message);case t.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(_.message);case t.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(_.message);default:throw new D.FileSystemError(_.message,_.name)}}addFileSystemProvider(_,T){return this._fileSystemProvider.set(_,T),(0,I.toDisposable)(()=>this._fileSystemProvider.delete(_))}};R=Ge([xe(0,C.IExtHostRpcService),xe(1,E.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[247],ke([1,0,3,36,2,5,15,7,27]),function(Y,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{constructor(_,T,w,b,g,f,p,v){this._onDidCreate=new u.Emitter,this._onDidChange=new u.Emitter,this._onDidDelete=new u.Emitter;const c=this.ensureWatching(_,w,g);this._config=0,f&&(this._config+=1),p&&(this._config+=2),v&&(this._config+=4);const m=(0,t.parse)(g),a=typeof g=="string",d=b(r=>{if(!f)for(const o of r.created){const i=D.URI.revive(o);m(i.fsPath)&&(!a||T.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!p)for(const o of r.changed){const i=D.URI.revive(o);m(i.fsPath)&&(!a||T.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!v)for(const o of r.deleted){const i=D.URI.revive(o);m(i.fsPath)&&(!a||T.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=C.Disposable.from(c,this._onDidCreate,this._onDidChange,this._onDidDelete,d)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(_,T,w){const b=C.Disposable.from();if(typeof w=="string")return b;const g=_.getProxy(P.MainContext.MainThreadFileSystem);let f=!1;(w.pattern.includes(t.GLOBSTAR)||w.pattern.includes(t.GLOB_SPLIT))&&(f=!0);const p=Math.random();return g.$watch(T.identifier.value,p,w.baseUri,{recursive:f,excludes:[]}),C.Disposable.from({dispose:()=>g.$unwatch(p)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class R{constructor(_,T,w){this._mainContext=_,this._logService=T,this._extHostDocumentsAndEditors=w,this._onFileSystemEvent=new u.Emitter,this._onDidRenameFile=new u.Emitter,this._onDidCreateFile=new u.Emitter,this._onDidDeleteFile=new u.Emitter,this._onWillRenameFile=new u.AsyncEmitter,this._onWillCreateFile=new u.AsyncEmitter,this._onWillDeleteFile=new u.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(_,T,w,b,g,f){return new I(this._mainContext,_,T,this._onFileSystemEvent.event,y.GlobPattern.from(w),b,g,f)}$onFileEvent(_){this._onFileSystemEvent.fire(_)}$onDidRunFileOperation(_,T){switch(_){case 2:this._onDidRenameFile.fire(Object.freeze({files:T.map(w=>({oldUri:D.URI.revive(w.source),newUri:D.URI.revive(w.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:T.map(w=>D.URI.revive(w.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:T.map(w=>D.URI.revive(w.target))}));break;default:}}getOnWillRenameFileEvent(_){return this._createWillExecuteEvent(_,this._onWillRenameFile)}getOnWillCreateFileEvent(_){return this._createWillExecuteEvent(_,this._onWillCreateFile)}getOnWillDeleteFileEvent(_){return this._createWillExecuteEvent(_,this._onWillDeleteFile)}_createWillExecuteEvent(_,T){return(w,b,g)=>{const f=function(v){w.call(b,v)};return f.extension=_,T.event(f,void 0,g)}}async $onWillRunFileOperation(_,T,w,b){switch(_){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:T.map(g=>({oldUri:D.URI.revive(g.source),newUri:D.URI.revive(g.target)}))},w,b);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:T.map(g=>D.URI.revive(g.target))},w,b);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:T.map(g=>D.URI.revive(g.target))},w,b)}}async _fireWillEvent(_,T,w,b){const g=new Set,f=[];if(await _.fireAsync(T,b,async(v,c)=>{const m=Date.now(),a=await Promise.resolve(v);a instanceof C.WorkspaceEdit&&(f.push([c.extension,a]),g.add(c.extension.displayName??c.extension.identifier.value)),Date.now()-m>w&&this._logService.warn("SLOW file-participant",c.extension.identifier)}),b.isCancellationRequested||f.length===0)return;const p={edits:[]};for(const[v,c]of f){const{edits:m}=y.WorkspaceEdit.from(c,{getTextDocumentVersion:a=>this._extHostDocumentsAndEditors.getDocument(a)?.version,getNotebookDocumentVersion:()=>{}},(0,E.isProposedApiEnabled)(v,"snippetWorkspaceEdit"));p.edits=p.edits.concat(m)}return{edit:p,extensionNames:Array.from(g)}}}e.ExtHostFileSystemEventService=R}),define(Ie[248],ke([1,0,2,37]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(y,C,E,I,R){this._extHostNotebooks=C,this._textDocumentsAndEditors=E,this._commands=I;const k=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new t.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new t.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new t.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new t.ApiCommandResult("Notebook and input URI",_=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",_.notebookEditorId),_.notebookEditorId!==void 0){const T=this._extHostNotebooks.getEditorById(_.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:u.URI.revive(_.notebookUri),inputUri:u.URI.revive(_.inputUri),notebookEditor:T.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",_.notebookUri,_.inputUri),{notebookUri:u.URI.revive(_.notebookUri),inputUri:u.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(k)}$willAddInteractiveDocument(y,C,E,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:C,lines:[""],languageId:E,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(u.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=D}),define(Ie[249],ke([1,0,6,5]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(y){this._handlePool=0,this._proxy=y.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,y),(0,u.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=D}),define(Ie[250],ke([1,0,2,24,15,7,63,5,8,35,16,10,145,21,6,113,93,87,50,12,18,27]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g,f,p,v,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor(O,H){this._documents=O,this._provider=H}async provideDocumentSymbols(O,H){const G=this._documents.getDocument(O),X=await this._provider.provideDocumentSymbols(G,H);if(!(0,R.isFalsyOrEmpty)(X))return X[0]instanceof P.DocumentSymbol?X.map(D.DocumentSymbol.from):a._asDocumentSymbolTree(X)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((X,he)=>{let be=X.location.range.start.compareTo(he.location.range.start);return be===0&&(be=he.location.range.end.compareTo(X.location.range.end)),be});const H=[],G=[];for(const X of O){const he={name:X.name||"!!MISSING: name!!",kind:D.SymbolKind.from(X.kind),tags:X.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:D.Range.from(X.location.range),selectionRange:D.Range.from(X.location.range),children:[]};for(;;){if(G.length===0){G.push(he),H.push(he);break}const be=G[G.length-1];if(I.Range.containsRange(be.range,he.range)&&!I.Range.equalsRange(be.range,he.range)){be.children?.push(he),G.push(he);break}G.pop()}}return H}}class d{constructor(O,H,G){this._documents=O,this._commands=H,this._provider=G,this._cache=new f.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,H){const G=this._documents.getDocument(O),X=await this._provider.provideCodeLenses(G,H);if(!X||H.isCancellationRequested)return;const he=this._cache.add(X),be=new w.DisposableStore;this._disposables.set(he,be);const ae={cacheId:he,lenses:[]};for(let De=0;De<X.length;De++)ae.lenses.push({cacheId:[he,De],range:D.Range.from(X[De].range),command:this._commands.toInternal(X[De].command,be)});return ae}async resolveCodeLens(O,H){const G=O.cacheId&&this._cache.get(...O.cacheId);if(!G)return;let X;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?X=G:X=await this._provider.resolveCodeLens(G,H),X||(X=G),H.isCancellationRequested)return;const he=O.cacheId&&this._disposables.get(O.cacheId[0]);if(!!he)return O.command=this._commands.toInternal(X.command??d._badCmd,he),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function r(re){return Array.isArray(re)?re.map(D.DefinitionLink.from):re?[D.DefinitionLink.from(re)]:[]}class o{constructor(O,H){this._documents=O,this._provider=H}async provideDefinition(O,H,G){const X=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.provideDefinition(X,he,G);return r(be)}}class i{constructor(O,H){this._documents=O,this._provider=H}async provideDeclaration(O,H,G){const X=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.provideDeclaration(X,he,G);return r(be)}}class n{constructor(O,H){this._documents=O,this._provider=H}async provideImplementation(O,H,G){const X=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.provideImplementation(X,he,G);return r(be)}}class s{constructor(O,H){this._documents=O,this._provider=H}async provideTypeDefinition(O,H,G){const X=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.provideTypeDefinition(X,he,G);return r(be)}}class l{constructor(O,H){this._documents=O,this._provider=H}async provideHover(O,H,G){const X=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.provideHover(X,he,G);if(!(!be||(0,R.isFalsyOrEmpty)(be.contents)))return be.range||(be.range=X.getWordRangeAtPosition(he)),be.range||(be.range=new P.Range(he,he)),D.Hover.from(be)}}class h{constructor(O,H){this._documents=O,this._provider=H}async provideEvaluatableExpression(O,H,G){const X=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.provideEvaluatableExpression(X,he,G);if(be)return D.EvaluatableExpression.from(be)}}class S{constructor(O,H){this._documents=O,this._provider=H}async provideInlineValues(O,H,G,X){const he=this._documents.getDocument(O),be=await this._provider.provideInlineValues(he,D.Range.to(H),D.InlineValueContext.to(G),X);if(Array.isArray(be))return be.map(ae=>D.InlineValue.from(ae))}}class L{constructor(O,H){this._documents=O,this._provider=H}async provideDocumentHighlights(O,H,G){const X=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.provideDocumentHighlights(X,he,G);if(Array.isArray(be))return be.map(D.DocumentHighlight.from)}}class M{constructor(O,H){this._documents=O,this._provider=H}async provideLinkedEditingRanges(O,H,G){const X=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.provideLinkedEditingRanges(X,he,G);if(be&&Array.isArray(be.ranges))return{ranges:(0,R.coalesce)(be.ranges.map(D.Range.from)),wordPattern:be.wordPattern}}}class F{constructor(O,H){this._documents=O,this._provider=H}async provideReferences(O,H,G,X){const he=this._documents.getDocument(O),be=D.Position.to(H),ae=await this._provider.provideReferences(he,be,G,X);if(Array.isArray(ae))return ae.map(D.location.from)}}class A{constructor(O,H,G,X,he,be,ae){this._documents=O,this._commands=H,this._diagnostics=G,this._provider=X,this._logService=he,this._extension=be,this._apiDeprecation=ae,this._cache=new f.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,H,G,X){const he=this._documents.getDocument(O),be=_.Selection.isISelection(H)?D.Selection.to(H):D.Range.to(H),ae=[];for(const Ye of this._diagnostics.getDiagnostics(O))if(be.intersection(Ye.range)&&ae.push(Ye)>A._maxCodeActionsPerFile)break;const De={diagnostics:ae,only:G.only?new P.CodeActionKind(G.only):void 0,triggerKind:D.CodeActionTriggerKind.to(G.trigger)},Ce=await this._provider.provideCodeActions(he,be,De,X);if(!(0,R.isNonEmptyArray)(Ce)||X.isCancellationRequested)return;const ze=this._cache.add(Ce),Ke=new w.DisposableStore;this._disposables.set(ze,Ke);const Ne=[];for(let Ye=0;Ye<Ce.length;Ye++){const ee=Ce[Ye];!ee||(A._isCommand(ee)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ne.push({_isSynthetic:!0,title:ee.title,command:this._commands.toInternal(ee,Ke)})):(De.only&&(ee.kind?De.only.contains(ee.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${De.only.value} 'requested but returned code action is of kind '${ee.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${De.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ne.push({cacheId:[ze,Ye],title:ee.title,command:ee.command&&this._commands.toInternal(ee.command,Ke),diagnostics:ee.diagnostics&&ee.diagnostics.map(D.Diagnostic.from),edit:ee.edit&&D.WorkspaceEdit.from(ee.edit,void 0,(0,m.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")),kind:ee.kind&&ee.kind.value,isPreferred:ee.isPreferred,disabled:ee.disabled?.reason})))}return{cacheId:ze,actions:Ne}}async resolveCodeAction(O,H){const[G,X]=O,he=this._cache.get(G,X);if(!he||A._isCommand(he)||!this._provider.resolveCodeAction)return;const be=await this._provider.resolveCodeAction(he,H)??he;return be?.edit?D.WorkspaceEdit.from(be.edit,void 0,(0,m.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")):void 0}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}A._maxCodeActionsPerFile=1e3;class B{constructor(O,H,G,X){this._proxy=O,this._documents=H,this._provider=G,this._handle=X}async prepareDocumentPaste(O,H,G,X){if(!this._provider.prepareDocumentPaste)return;const he=this._documents.getDocument(O),be=H.map(De=>D.Range.to(De)),ae=D.DataTransfer.toDataTransfer(G,()=>{throw new v.NotImplementedError});return await this._provider.prepareDocumentPaste(he,be,ae,X),D.DataTransfer.toDataTransferDTO(ae)}async providePasteEdits(O,H,G,X,he){const be=this._documents.getDocument(H),ae=G.map(ze=>D.Range.to(ze)),De=D.DataTransfer.toDataTransfer(X,async ze=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,O,ze)).buffer),Ce=await this._provider.provideDocumentPasteEdits(be,ae,De,he);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?D.WorkspaceEdit.from(Ce.additionalEdit,void 0,!0):void 0}}}class ${constructor(O,H){this._documents=O,this._provider=H}async provideDocumentFormattingEdits(O,H,G){const X=this._documents.getDocument(O),he=await this._provider.provideDocumentFormattingEdits(X,H,G);if(Array.isArray(he))return he.map(D.TextEdit.from)}}class U{constructor(O,H){this._documents=O,this._provider=H}async provideDocumentRangeFormattingEdits(O,H,G,X){const he=this._documents.getDocument(O),be=D.Range.to(H),ae=await this._provider.provideDocumentRangeFormattingEdits(he,be,G,X);if(Array.isArray(ae))return ae.map(D.TextEdit.from)}}class K{constructor(O,H){this._documents=O,this._provider=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,H,G,X,he){const be=this._documents.getDocument(O),ae=D.Position.to(H),De=await this._provider.provideOnTypeFormattingEdits(be,ae,G,X,he);if(Array.isArray(De))return De.map(D.TextEdit.from)}}class W{constructor(O,H){this._provider=O,this._logService=H,this._cache=new f.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,H){const G=await this._provider.provideWorkspaceSymbols(O,H);if(!(0,R.isNonEmptyArray)(G))return{symbols:[]};const X=this._cache.add(G),he={cacheId:X,symbols:[]};for(let be=0;be<G.length;be++){const ae=G[be];if(!ae||!ae.name){this._logService.warn("INVALID SymbolInformation",ae);continue}he.symbols.push({...D.WorkspaceSymbol.from(ae),cacheId:[X,be]})}return he}async resolveWorkspaceSymbol(O,H){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const G=this._cache.get(...O.cacheId);if(G){const X=await this._provider.resolveWorkspaceSymbol(G,H);return X&&(0,t.mixin)(O,D.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(O){this._cache.delete(O)}}class N{constructor(O,H,G){this._documents=O,this._provider=H,this._logService=G}static supportsResolving(O){return typeof O.prepareRename=="function"}async provideRenameEdits(O,H,G,X){const he=this._documents.getDocument(O),be=D.Position.to(H);try{const ae=await this._provider.provideRenameEdits(he,be,G,X);return ae?D.WorkspaceEdit.from(ae):void 0}catch(ae){const De=N._asMessage(ae);return De?{rejectReason:De,edits:void 0}:Promise.reject(ae)}}async resolveRenameLocation(O,H,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const X=this._documents.getDocument(O),he=D.Position.to(H);try{const be=await this._provider.prepareRename(X,he,G);let ae,De;if(P.Range.isRange(be)?(ae=be,De=X.getText(be)):(0,k.isObject)(be)&&(ae=be.range,De=be.placeholder),!ae||!De)return;if(ae.start.line>he.line||ae.end.line<he.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(ae),text:De}}catch(be){const ae=N._asMessage(be);return ae?{rejectReason:ae,range:void 0,text:void 0}:Promise.reject(be)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class V{constructor(O,H){this.resultId=O,this.tokens=H}}class x{constructor(O,H){this._documents=O,this._provider=H,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,H,G){const X=this._documents.getDocument(O),he=H!==0?this._previousResults.get(H):null;let be=typeof he?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(X,he.resultId,G):await this._provider.provideDocumentSemanticTokens(X,G);return he&&this._previousResults.delete(H),be?(be=x._fixProvidedSemanticTokens(be),this._send(x._convertToEdits(he,be),be)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return x._isSemanticTokens(O)?x._isCorrectSemanticTokens(O)?O:new P.SemanticTokens(new Uint32Array(O.data),O.resultId):x._isSemanticTokensEdits(O)?x._isCorrectSemanticTokensEdits(O)?O:new P.SemanticTokensEdits(O.edits.map(H=>new P.SemanticTokensEdit(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const H of O.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,H){if(!x._isSemanticTokens(H)||!O||!O.tokens)return H;const G=O.tokens,X=G.length,he=H.data,be=he.length;let ae=0;const De=Math.min(X,be);for(;ae<De&&G[ae]===he[ae];)ae++;if(ae===X&&ae===be)return new P.SemanticTokensEdits([],H.resultId);let Ce=0;const ze=De-ae;for(;Ce<ze&&G[X-Ce-1]===he[be-Ce-1];)Ce++;return new P.SemanticTokensEdits([{start:ae,deleteCount:X-ae-Ce,data:he.subarray(ae,be-Ce)}],H.resultId)}_send(O,H){if(x._isSemanticTokens(O)){const G=this._nextResultId++;return this._previousResults.set(G,new V(O.resultId,O.data)),(0,b.encodeSemanticTokensDto)({id:G,type:"full",data:O.data})}if(x._isSemanticTokensEdits(O)){const G=this._nextResultId++;return x._isSemanticTokens(H)?this._previousResults.set(G,new V(H.resultId,H.data)):this._previousResults.set(G,new V(O.resultId)),(0,b.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(O.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class q{constructor(O,H){this._documents=O,this._provider=H}async provideDocumentRangeSemanticTokens(O,H,G){const X=this._documents.getDocument(O),he=await this._provider.provideDocumentRangeSemanticTokens(X,D.Range.to(H),G);return he?this._send(he):null}_send(O){return(0,b.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}e.DocumentRangeSemanticTokensAdapter=q;class te{constructor(O,H,G,X,he){this._documents=O,this._commands=H,this._provider=G,this._apiDeprecation=X,this._extension=he,this._cache=new f.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}async provideCompletionItems(O,H,G,X){const he=this._documents.getDocument(O),be=D.Position.to(H),ae=he.getWordRangeAtPosition(be)||new P.Range(be,be),De=ae.with({end:be}),Ce=new p.StopWatch(!0),ze=await this._provider.provideCompletionItems(he,be,X,D.CompletionContext.to(G));if(!ze||X.isCancellationRequested)return;const Ke=Array.isArray(ze)?new P.CompletionList(ze):ze,Ne=te.supportsResolving(this._provider)?this._cache.add(Ke.items):this._cache.add([]),Ye=new w.DisposableStore;this._disposables.set(Ne,Ye);const ee=[],oe={x:Ne,b:ee,a:{replace:D.Range.from(ae),insert:D.Range.from(De)},c:Ke.isIncomplete||void 0,d:Ce.elapsed()};for(let ye=0;ye<Ke.items.length;ye++){const We=Ke.items[ye],ce=this._convertCompletionItem(We,[Ne,ye],De,ae);ee.push(ce)}return oe}async resolveCompletionItem(O,H){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...O);if(!G)return;const X=await this._provider.resolveCompletionItem(G,H);if(!!X)return this._convertCompletionItem(X,O)}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,H,G,X){const he=this._disposables.get(H[0]);if(!he)throw Error("DisposableStore is missing...");const be={x:H,a:O.label,b:O.kind!==void 0?D.CompletionItemKind.from(O.kind):void 0,n:O.tags&&O.tags.map(D.CompletionItemTag.from),c:O.detail,d:typeof O.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters,l:O.additionalTextEdits&&O.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(O.command,he)};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),be.h=O.textEdit.newText):typeof O.insertText=="string"?be.h=O.insertText:O.insertText instanceof P.SnippetString&&(be.h=O.insertText.value,be.i|=4);let ae;return O.textEdit?ae=O.textEdit.range:O.range&&(ae=O.range),P.Range.isRange(ae)?be.j=D.Range.from(ae):ae&&(!G?.isEqual(ae.inserting)||!X?.isEqual(ae.replacing))&&(be.j={insert:D.Range.from(ae.inserting),replace:D.Range.from(ae.replacing)}),be}}class Q{async provideInlineCompletions(O,H,G,X){}disposeCompletions(O){}handleDidShowCompletionItem(O,H){}}class le extends Q{constructor(O,H,G,X){super();this._extension=O,this._documents=H,this._provider=G,this._commands=X,this._references=new Z,this._isAdditionsProposedApiEnabled=(0,m.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[y.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,m.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(O,H,G,X){const he=this._documents.getDocument(O),be=D.Position.to(H),ae=await this._provider.provideInlineCompletionItems(he,be,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:D.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!ae||X.isCancellationRequested)return;const De=(0,k.isArray)(ae)?ae:ae.items,Ce=this._isAdditionsProposedApiEnabled?(0,k.isArray)(ae)?[]:ae.commands||[]:[];let ze;return{pid:this._references.createReferenceId({dispose(){ze&&ze.dispose()},items:De}),items:De.map((Ne,Ye)=>{let ee;Ne.command&&(ze||(ze=new w.DisposableStore),ee=this._commands.toInternal(Ne.command,ze));const oe=Ne.insertText;return{insertText:typeof oe=="string"?oe:{snippet:oe.value},filterText:Ne.filterText,range:Ne.range?D.Range.from(Ne.range):void 0,command:ee,idx:Ye,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ne.completeBracketPairs:!1}}),commands:Ce.map(Ne=>(ze||(ze=new w.DisposableStore),this._commands.toInternal(Ne,ze)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,H){const G=this._references.get(O)?.items[H];G&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class pe extends Q{constructor(O,H,G,X){super();this.extension=O,this._documents=H,this._provider=G,this._commands=X,this._references=new Z,this.isAdditionProposedApiEnabled=(0,m.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKindNew.Automatic,[y.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(O,H,G,X){const he=this._documents.getDocument(O),be=D.Position.to(H),ae=await this._provider.provideInlineCompletionItems(he,be,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:D.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!ae||X.isCancellationRequested)return;const De=(0,k.isArray)(ae)?ae:ae.items,Ce=(0,k.isArray)(ae)?[]:ae.commands||[];let ze;return{pid:this._references.createReferenceId({dispose(){ze&&ze.dispose()},items:De}),items:De.map((Ne,Ye)=>{let ee;Ne.command&&(ze||(ze=new w.DisposableStore),ee=this._commands.toInternal(Ne.command,ze));const oe=Ne.insertText;return{insertText:typeof oe=="string"?oe:{snippet:oe.value},filterText:Ne.filterText,range:Ne.range?D.Range.from(Ne.range):void 0,command:ee,idx:Ye,completeBracketPairs:this.isAdditionProposedApiEnabled?Ne.completeBracketPairs:!1}}),commands:Ce.map(Ne=>(ze||(ze=new w.DisposableStore),this._commands.toInternal(Ne,ze)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,H){const G=this._references.get(O)?.items[H];G&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class Z{constructor(){this._references=new Map,this._idPool=1}createReferenceId(O){const H=this._idPool++;return this._references.set(H,O),H}disposeReferenceId(O){const H=this._references.get(O);return this._references.delete(O),H}get(O){return this._references.get(O)}}class ge{constructor(O,H){this._documents=O,this._provider=H,this._cache=new f.Cache("SignatureHelp")}async provideSignatureHelp(O,H,G,X){const he=this._documents.getDocument(O),be=D.Position.to(H),ae=this.reviveContext(G),De=await this._provider.provideSignatureHelp(he,be,X,ae);if(De){const Ce=this._cache.add([De]);return{...D.SignatureHelp.from(De),id:Ce}}}reviveContext(O){let H;if(O.activeSignatureHelp){const G=D.SignatureHelp.to(O.activeSignatureHelp),X=this._cache.get(O.activeSignatureHelp.id,0);X?(H=X,H.activeSignature=G.activeSignature,H.activeParameter=G.activeParameter):H=G}return{...O,activeSignatureHelp:H}}releaseSignatureHelp(O){this._cache.delete(O)}}class Ee{constructor(O,H,G,X,he){this._documents=O,this._commands=H,this._provider=G,this._logService=X,this._extension=he,this._cache=new f.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(O,H,G){const X=this._documents.getDocument(O),he=D.Range.to(H),be=await this._provider.provideInlayHints(X,he,G);if(!Array.isArray(be)||be.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${H}`);return}if(G.isCancellationRequested)return;const ae=this._cache.add(be);this._disposables.set(ae,new w.DisposableStore);const De={hints:[],cacheId:ae};for(let Ce=0;Ce<be.length;Ce++)this._isValidInlayHint(be[Ce],he)&&De.hints.push(this._convertInlayHint(be[Ce],[ae,Ce]));return this._logService.trace(`[InlayHints] ${De.hints.length} inlay hints from '${this._extension.identifier.value}' for ${H}`),De}async resolveInlayHint(O,H){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...O);if(!G)return;const X=await this._provider.resolveInlayHint(G,H);if(!!X&&!!this._isValidInlayHint(X))return this._convertInlayHint(X,O)}releaseHints(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_isValidInlayHint(O,H){return O.label.length===0||Array.isArray(O.label)&&O.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(H&&!H.contains(O.position))}_convertInlayHint(O,H){const G=this._disposables.get(H[0]);if(!G)throw Error("DisposableStore is missing...");const X={label:"",cacheId:H,tooltip:D.MarkdownString.fromStrict(O.tooltip),position:D.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(D.TextEdit.from),kind:O.kind&&D.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?X.label=O.label:X.label=O.label.map(he=>{const be={label:he.value};return be.tooltip=D.MarkdownString.fromStrict(he.tooltip),P.Location.isLocation(he.location)&&(be.location=D.location.from(he.location)),he.command&&(be.command=this._commands.toInternal(he.command,G)),be}),X}}class Te{constructor(O,H){this._documents=O,this._provider=H,this._cache=new f.Cache("DocumentLink")}async provideLinks(O,H){const G=this._documents.getDocument(O),X=await this._provider.provideDocumentLinks(G,H);if(!(!Array.isArray(X)||X.length===0)&&!H.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:X.filter(Te._validateLink).map(D.DocumentLink.from)};{const he=this._cache.add(X),be={links:[],cacheId:he};for(let ae=0;ae<X.length;ae++){if(!Te._validateLink(X[ae]))continue;const De=D.DocumentLink.from(X[ae]);De.cacheId=[he,ae],be.links.push(De)}return be}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,H){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...O);if(!G)return;const X=await this._provider.resolveDocumentLink(G,H);if(!(!X||!Te._validateLink(X)))return D.DocumentLink.from(X)}releaseLinks(O){this._cache.delete(O)}}class Oe{constructor(O,H){this._documents=O,this._provider=H}async provideColors(O,H){const G=this._documents.getDocument(O),X=await this._provider.provideDocumentColors(G,H);return Array.isArray(X)?X.map(be=>({color:D.Color.from(be.color),range:D.Range.from(be.range)})):[]}async provideColorPresentations(O,H,G){const X=this._documents.getDocument(O),he=D.Range.to(H.range),be=D.Color.to(H.color),ae=await this._provider.provideColorPresentations(be,{document:X,range:he},G);if(!!Array.isArray(ae))return ae.map(D.ColorPresentation.from)}}class ve{constructor(O,H){this._documents=O,this._provider=H}async provideFoldingRanges(O,H,G){const X=this._documents.getDocument(O),he=await this._provider.provideFoldingRanges(X,H,G);if(!!Array.isArray(he))return he.map(D.FoldingRange.from)}}class ue{constructor(O,H,G){this._documents=O,this._provider=H,this._logService=G}async provideSelectionRanges(O,H,G){const X=this._documents.getDocument(O),he=H.map(D.Position.to),be=await this._provider.provideSelectionRanges(X,he,G);if(!(0,R.isNonEmptyArray)(be))return[];if(be.length!==he.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ae=[];for(let De=0;De<he.length;De++){const Ce=[];ae.push(Ce);let ze=he[De],Ke=be[De];for(;;){if(!Ke.range.contains(ze))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(D.SelectionRange.from(Ke)),!Ke.parent)break;ze=Ke.range,Ke=Ke.parent}}return ae}}class de{constructor(O,H){this._documents=O,this._provider=H,this._idPool=new g.IdGenerator(""),this._cache=new Map}async prepareSession(O,H,G){const X=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.prepareCallHierarchy(X,he,G);if(!be)return;const ae=this._idPool.nextId();return this._cache.set(ae,new Map),Array.isArray(be)?be.map(De=>this._cacheAndConvertItem(ae,De)):[this._cacheAndConvertItem(ae,be)]}async provideCallsTo(O,H,G){const X=this._itemFromCache(O,H);if(!X)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyIncomingCalls(X,G);if(!!he)return he.map(be=>({from:this._cacheAndConvertItem(O,be.from),fromRanges:be.fromRanges.map(ae=>D.Range.from(ae))}))}async provideCallsFrom(O,H,G){const X=this._itemFromCache(O,H);if(!X)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyOutgoingCalls(X,G);if(!!he)return he.map(be=>({to:this._cacheAndConvertItem(O,be.to),fromRanges:be.fromRanges.map(ae=>D.Range.from(ae))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,H){const G=this._cache.get(O),X=D.CallHierarchyItem.from(H,O,G.size.toString(36));return G.set(X._itemId,H),X}_itemFromCache(O,H){return this._cache.get(O)?.get(H)}}class we{constructor(O,H){this._documents=O,this._provider=H,this._idPool=new g.IdGenerator(""),this._cache=new Map}async prepareSession(O,H,G){const X=this._documents.getDocument(O),he=D.Position.to(H),be=await this._provider.prepareTypeHierarchy(X,he,G);if(!be)return;const ae=this._idPool.nextId();return this._cache.set(ae,new Map),Array.isArray(be)?be.map(De=>this._cacheAndConvertItem(ae,De)):[this._cacheAndConvertItem(ae,be)]}async provideSupertypes(O,H,G){const X=this._itemFromCache(O,H);if(!X)throw new Error("missing type hierarchy item");const he=await this._provider.provideTypeHierarchySupertypes(X,G);if(!!he)return he.map(be=>this._cacheAndConvertItem(O,be))}async provideSubtypes(O,H,G){const X=this._itemFromCache(O,H);if(!X)throw new Error("missing type hierarchy item");const he=await this._provider.provideTypeHierarchySubtypes(X,G);if(!!he)return he.map(be=>this._cacheAndConvertItem(O,be))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,H){const G=this._cache.get(O),X=D.TypeHierarchyItem.from(H,O,G.size.toString(36));return G.set(X._itemId,H),X}_itemFromCache(O,H){return this._cache.get(O)?.get(H)}}class ie{constructor(O,H,G,X){this._proxy=O,this._documents=H,this._provider=G,this._handle=X}async provideDocumentOnDropEdits(O,H,G,X,he){const be=this._documents.getDocument(H),ae=D.Position.to(G),De=D.DataTransfer.toDataTransfer(X,async ze=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,O,ze)).buffer),Ce=await this._provider.provideDocumentDropEdits(be,ae,De,he);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?D.WorkspaceEdit.from(Ce.additionalEdit,void 0,!0):void 0}}}class me{constructor(O,H){this.adapter=O,this.extension=H}}class J{constructor(O,H,G,X,he,be,ae){this._adapter=new Map,this._uriTransformer=H,this._proxy=O.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=G,this._commands=X,this._diagnostics=he,this._logService=be,this._apiDeprecation=ae}_transformDocumentSelector(O){return D.DocumentSelector.from(O,this._uriTransformer)}_createDisposable(O){return new P.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return J._handlePool++}async _withAdapter(O,H,G,X,he,be=!1){const ae=this._adapter.get(O);if(!ae||!(ae.adapter instanceof H))return X;const De=Date.now();be||this._logService.trace(`[${ae.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ce=G(ae.adapter,ae.extension);return Promise.resolve(Ce).catch(ze=>{(0,v.isCancellationError)(ze)||(this._logService.error(`[${ae.extension.identifier.value}] provider FAILED`),this._logService.error(ze))}).finally(()=>{be||this._logService.trace(`[${ae.extension.identifier.value}] provider DONE after ${Date.now()-De}ms`)}),T.CancellationToken.isCancellationToken(he)?(0,c.raceCancellationError)(Ce,he):Ce}_addNewAdapter(O,H){const G=this._nextHandle();return this._adapter.set(G,new me(O,H)),G}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,H,G,X){const he=this._addNewAdapter(new a(this._documents,G),O),be=X&&X.label||J._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(he,this._transformDocumentSelector(H),be),this._createDisposable(he)}$provideDocumentSymbols(O,H,G){return this._withAdapter(O,a,X=>X.provideDocumentSymbols(u.URI.revive(H),G),void 0,G)}registerCodeLensProvider(O,H,G){const X=this._nextHandle(),he=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(X,new me(new d(this._documents,this._commands.converter,G),O)),this._proxy.$registerCodeLensSupport(X,this._transformDocumentSelector(H),he);let be=this._createDisposable(X);if(he!==void 0){const ae=G.onDidChangeCodeLenses(De=>this._proxy.$emitCodeLensEvent(he));be=P.Disposable.from(be,ae)}return be}$provideCodeLenses(O,H,G){return this._withAdapter(O,d,X=>X.provideCodeLenses(u.URI.revive(H),G),void 0,G)}$resolveCodeLens(O,H,G){return this._withAdapter(O,d,X=>X.resolveCodeLens(H,G),void 0,void 0)}$releaseCodeLenses(O,H){this._withAdapter(O,d,G=>Promise.resolve(G.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(O,H,G){const X=this._addNewAdapter(new o(this._documents,G),O);return this._proxy.$registerDefinitionSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDefinition(O,H,G,X){return this._withAdapter(O,o,he=>he.provideDefinition(u.URI.revive(H),G,X),[],X)}registerDeclarationProvider(O,H,G){const X=this._addNewAdapter(new i(this._documents,G),O);return this._proxy.$registerDeclarationSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDeclaration(O,H,G,X){return this._withAdapter(O,i,he=>he.provideDeclaration(u.URI.revive(H),G,X),[],X)}registerImplementationProvider(O,H,G){const X=this._addNewAdapter(new n(this._documents,G),O);return this._proxy.$registerImplementationSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideImplementation(O,H,G,X){return this._withAdapter(O,n,he=>he.provideImplementation(u.URI.revive(H),G,X),[],X)}registerTypeDefinitionProvider(O,H,G){const X=this._addNewAdapter(new s(this._documents,G),O);return this._proxy.$registerTypeDefinitionSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideTypeDefinition(O,H,G,X){return this._withAdapter(O,s,he=>he.provideTypeDefinition(u.URI.revive(H),G,X),[],X)}registerHoverProvider(O,H,G,X){const he=this._addNewAdapter(new l(this._documents,G),O);return this._proxy.$registerHoverProvider(he,this._transformDocumentSelector(H)),this._createDisposable(he)}$provideHover(O,H,G,X){return this._withAdapter(O,l,he=>he.provideHover(u.URI.revive(H),G,X),void 0,X)}registerEvaluatableExpressionProvider(O,H,G,X){const he=this._addNewAdapter(new h(this._documents,G),O);return this._proxy.$registerEvaluatableExpressionProvider(he,this._transformDocumentSelector(H)),this._createDisposable(he)}$provideEvaluatableExpression(O,H,G,X){return this._withAdapter(O,h,he=>he.provideEvaluatableExpression(u.URI.revive(H),G,X),void 0,X)}registerInlineValuesProvider(O,H,G,X){const he=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,be=this._addNewAdapter(new S(this._documents,G),O);this._proxy.$registerInlineValuesProvider(be,this._transformDocumentSelector(H),he);let ae=this._createDisposable(be);if(he!==void 0){const De=G.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(he));ae=P.Disposable.from(ae,De)}return ae}$provideInlineValues(O,H,G,X,he){return this._withAdapter(O,S,be=>be.provideInlineValues(u.URI.revive(H),G,X,he),void 0,he)}registerDocumentHighlightProvider(O,H,G){const X=this._addNewAdapter(new L(this._documents,G),O);return this._proxy.$registerDocumentHighlightProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDocumentHighlights(O,H,G,X){return this._withAdapter(O,L,he=>he.provideDocumentHighlights(u.URI.revive(H),G,X),void 0,X)}registerLinkedEditingRangeProvider(O,H,G){const X=this._addNewAdapter(new M(this._documents,G),O);return this._proxy.$registerLinkedEditingRangeProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideLinkedEditingRanges(O,H,G,X){return this._withAdapter(O,M,async he=>{const be=await he.provideLinkedEditingRanges(u.URI.revive(H),G,X);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?J._serializeRegExp(be.wordPattern):void 0}},void 0,X)}registerReferenceProvider(O,H,G){const X=this._addNewAdapter(new F(this._documents,G),O);return this._proxy.$registerReferenceSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideReferences(O,H,G,X,he){return this._withAdapter(O,F,be=>be.provideReferences(u.URI.revive(H),G,X,he),void 0,he)}registerCodeActionProvider(O,H,G,X){const he=new w.DisposableStore,be=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,G,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(be,this._transformDocumentSelector(H),{providedKinds:X?.providedCodeActionKinds?.map(ae=>ae.value),documentation:X?.documentation?.map(ae=>({kind:ae.kind.value,command:this._commands.converter.toInternal(ae.command,he)}))},J._extLabel(O),Boolean(G.resolveCodeAction)),he.add(this._createDisposable(be)),he}$provideCodeActions(O,H,G,X,he){return this._withAdapter(O,A,be=>be.provideCodeActions(u.URI.revive(H),G,X,he),void 0,he)}$resolveCodeAction(O,H,G){return this._withAdapter(O,A,X=>X.resolveCodeAction(H,G),void 0,void 0)}$releaseCodeActions(O,H){this._withAdapter(O,A,G=>Promise.resolve(G.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(O,H,G){const X=this._addNewAdapter(new $(this._documents,G),O);return this._proxy.$registerDocumentFormattingSupport(X,this._transformDocumentSelector(H),O.identifier,O.displayName||O.name),this._createDisposable(X)}$provideDocumentFormattingEdits(O,H,G,X){return this._withAdapter(O,$,he=>he.provideDocumentFormattingEdits(u.URI.revive(H),G,X),void 0,X)}registerDocumentRangeFormattingEditProvider(O,H,G){const X=this._addNewAdapter(new U(this._documents,G),O);return this._proxy.$registerRangeFormattingSupport(X,this._transformDocumentSelector(H),O.identifier,O.displayName||O.name),this._createDisposable(X)}$provideDocumentRangeFormattingEdits(O,H,G,X,he){return this._withAdapter(O,U,be=>be.provideDocumentRangeFormattingEdits(u.URI.revive(H),G,X,he),void 0,he)}registerOnTypeFormattingEditProvider(O,H,G,X){const he=this._addNewAdapter(new K(this._documents,G),O);return this._proxy.$registerOnTypeFormattingSupport(he,this._transformDocumentSelector(H),X,O.identifier),this._createDisposable(he)}$provideOnTypeFormattingEdits(O,H,G,X,he,be){return this._withAdapter(O,K,ae=>ae.provideOnTypeFormattingEdits(u.URI.revive(H),G,X,he,be),void 0,be)}registerWorkspaceSymbolProvider(O,H){const G=this._addNewAdapter(new W(H,this._logService),O);return this._proxy.$registerNavigateTypeSupport(G,typeof H.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(O,H,G){return this._withAdapter(O,W,X=>X.provideWorkspaceSymbols(H,G),{symbols:[]},G)}$resolveWorkspaceSymbol(O,H,G){return this._withAdapter(O,W,X=>X.resolveWorkspaceSymbol(H,G),void 0,void 0)}$releaseWorkspaceSymbols(O,H){this._withAdapter(O,W,G=>G.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(O,H,G){const X=this._addNewAdapter(new N(this._documents,G,this._logService),O);return this._proxy.$registerRenameSupport(X,this._transformDocumentSelector(H),N.supportsResolving(G)),this._createDisposable(X)}$provideRenameEdits(O,H,G,X,he){return this._withAdapter(O,N,be=>be.provideRenameEdits(u.URI.revive(H),G,X,he),void 0,he)}$resolveRenameLocation(O,H,G,X){return this._withAdapter(O,N,he=>he.resolveRenameLocation(u.URI.revive(H),G,X),void 0,X)}registerDocumentSemanticTokensProvider(O,H,G,X){const he=this._addNewAdapter(new x(this._documents,G),O),be=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(he,this._transformDocumentSelector(H),X,be);let ae=this._createDisposable(he);if(be){const De=G.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(be));ae=P.Disposable.from(ae,De)}return ae}$provideDocumentSemanticTokens(O,H,G,X){return this._withAdapter(O,x,he=>he.provideDocumentSemanticTokens(u.URI.revive(H),G,X),null,X)}$releaseDocumentSemanticTokens(O,H){this._withAdapter(O,x,G=>G.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,H,G,X){const he=this._addNewAdapter(new q(this._documents,G),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(he,this._transformDocumentSelector(H),X),this._createDisposable(he)}$provideDocumentRangeSemanticTokens(O,H,G,X){return this._withAdapter(O,q,he=>he.provideDocumentRangeSemanticTokens(u.URI.revive(H),G,X),null,X)}registerCompletionItemProvider(O,H,G,X){const he=this._addNewAdapter(new te(this._documents,this._commands.converter,G,this._apiDeprecation,O),O);return this._proxy.$registerCompletionsProvider(he,this._transformDocumentSelector(H),X,te.supportsResolving(G),`${O.identifier.value}(${X.join("")})`),this._createDisposable(he)}$provideCompletionItems(O,H,G,X,he){return this._withAdapter(O,te,be=>be.provideCompletionItems(u.URI.revive(H),G,X,he),void 0,he)}$resolveCompletionItem(O,H,G){return this._withAdapter(O,te,X=>X.resolveCompletionItem(H,G),void 0,G)}$releaseCompletionItems(O,H){this._withAdapter(O,te,G=>G.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(O,H,G){const X=new le(O,this._documents,G,this._commands.converter),he=this._addNewAdapter(X,O);return this._proxy.$registerInlineCompletionsSupport(he,this._transformDocumentSelector(H),X.supportsHandleDidShowCompletionItem),this._createDisposable(he)}registerInlineCompletionsProviderNew(O,H,G){const X=this._addNewAdapter(new pe(O,this._documents,G,this._commands.converter),O);return this._proxy.$registerInlineCompletionsSupport(X,this._transformDocumentSelector(H),!0),this._createDisposable(X)}$provideInlineCompletions(O,H,G,X,he){return this._withAdapter(O,Q,be=>be.provideInlineCompletions(u.URI.revive(H),G,X,he),void 0,he)}$handleInlineCompletionDidShow(O,H,G){this._withAdapter(O,Q,async X=>{X.handleDidShowCompletionItem(H,G)},void 0,void 0)}$freeInlineCompletionsList(O,H){this._withAdapter(O,Q,async G=>{G.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(O,H,G,X){const he=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,be=this._addNewAdapter(new ge(this._documents,G),O);return this._proxy.$registerSignatureHelpProvider(be,this._transformDocumentSelector(H),he),this._createDisposable(be)}$provideSignatureHelp(O,H,G,X,he){return this._withAdapter(O,ge,be=>be.provideSignatureHelp(u.URI.revive(H),G,X,he),void 0,he)}$releaseSignatureHelp(O,H){this._withAdapter(O,ge,G=>G.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(O,H,G){const X=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,he=this._addNewAdapter(new Ee(this._documents,this._commands.converter,G,this._logService,O),O);this._proxy.$registerInlayHintsProvider(he,this._transformDocumentSelector(H),typeof G.resolveInlayHint=="function",X,J._extLabel(O));let be=this._createDisposable(he);if(X!==void 0){const ae=G.onDidChangeInlayHints(De=>this._proxy.$emitInlayHintsEvent(X));be=P.Disposable.from(be,ae)}return be}$provideInlayHints(O,H,G,X){return this._withAdapter(O,Ee,he=>he.provideInlayHints(u.URI.revive(H),G,X),void 0,X)}$resolveInlayHint(O,H,G){return this._withAdapter(O,Ee,X=>X.resolveInlayHint(H,G),void 0,G)}$releaseInlayHints(O,H){this._withAdapter(O,Ee,G=>G.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(O,H,G){const X=this._addNewAdapter(new Te(this._documents,G),O);return this._proxy.$registerDocumentLinkProvider(X,this._transformDocumentSelector(H),typeof G.resolveDocumentLink=="function"),this._createDisposable(X)}$provideDocumentLinks(O,H,G){return this._withAdapter(O,Te,X=>X.provideLinks(u.URI.revive(H),G),void 0,G,H.scheme==="output")}$resolveDocumentLink(O,H,G){return this._withAdapter(O,Te,X=>X.resolveLink(H,G),void 0,void 0,!0)}$releaseDocumentLinks(O,H){this._withAdapter(O,Te,G=>G.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(O,H,G){const X=this._addNewAdapter(new Oe(this._documents,G),O);return this._proxy.$registerDocumentColorProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDocumentColors(O,H,G){return this._withAdapter(O,Oe,X=>X.provideColors(u.URI.revive(H),G),[],G)}$provideColorPresentations(O,H,G,X){return this._withAdapter(O,Oe,he=>he.provideColorPresentations(u.URI.revive(H),G,X),void 0,X)}registerFoldingRangeProvider(O,H,G){const X=this._nextHandle(),he=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(X,new me(new ve(this._documents,G),O)),this._proxy.$registerFoldingRangeProvider(X,this._transformDocumentSelector(H),he);let be=this._createDisposable(X);if(he!==void 0){const ae=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(he));be=P.Disposable.from(be,ae)}return be}$provideFoldingRanges(O,H,G,X){return this._withAdapter(O,ve,he=>he.provideFoldingRanges(u.URI.revive(H),G,X),void 0,X)}registerSelectionRangeProvider(O,H,G){const X=this._addNewAdapter(new ue(this._documents,G,this._logService),O);return this._proxy.$registerSelectionRangeProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideSelectionRanges(O,H,G,X){return this._withAdapter(O,ue,he=>he.provideSelectionRanges(u.URI.revive(H),G,X),[],X)}registerCallHierarchyProvider(O,H,G){const X=this._addNewAdapter(new de(this._documents,G),O);return this._proxy.$registerCallHierarchyProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$prepareCallHierarchy(O,H,G,X){return this._withAdapter(O,de,he=>Promise.resolve(he.prepareSession(u.URI.revive(H),G,X)),void 0,X)}$provideCallHierarchyIncomingCalls(O,H,G,X){return this._withAdapter(O,de,he=>he.provideCallsTo(H,G,X),void 0,X)}$provideCallHierarchyOutgoingCalls(O,H,G,X){return this._withAdapter(O,de,he=>he.provideCallsFrom(H,G,X),void 0,X)}$releaseCallHierarchy(O,H){this._withAdapter(O,de,G=>Promise.resolve(G.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(O,H,G){const X=this._addNewAdapter(new we(this._documents,G),O);return this._proxy.$registerTypeHierarchyProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$prepareTypeHierarchy(O,H,G,X){return this._withAdapter(O,we,he=>Promise.resolve(he.prepareSession(u.URI.revive(H),G,X)),void 0,X)}$provideTypeHierarchySupertypes(O,H,G,X){return this._withAdapter(O,we,he=>he.provideSupertypes(H,G,X),void 0,X)}$provideTypeHierarchySubtypes(O,H,G,X){return this._withAdapter(O,we,he=>he.provideSubtypes(H,G,X),void 0,X)}$releaseTypeHierarchy(O,H){this._withAdapter(O,we,G=>Promise.resolve(G.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(O,H,G){const X=this._nextHandle();return this._adapter.set(X,new me(new ie(this._proxy,this._documents,G,X),O)),this._proxy.$registerDocumentOnDropEditProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDocumentOnDropEdits(O,H,G,X,he,be){return this._withAdapter(O,ie,ae=>Promise.resolve(ae.provideDocumentOnDropEdits(H,u.URI.revive(G),X,he,be)),void 0,void 0)}registerDocumentPasteEditProvider(O,H,G,X){const he=this._nextHandle();return this._adapter.set(he,new me(new B(this._proxy,this._documents,G,he),O)),this._proxy.$registerPasteEditProvider(he,this._transformDocumentSelector(H),!!G.prepareDocumentPaste,X.pasteMimeTypes),this._createDisposable(he)}$prepareDocumentPaste(O,H,G,X,he){return this._withAdapter(O,B,be=>be.prepareDocumentPaste(u.URI.revive(H),G,X,he),void 0,he)}$providePasteEdits(O,H,G,X,he){return this._withAdapter(O,B,be=>be.providePasteEdits(0,u.URI.revive(H),G,X,he),void 0,he)}static _serializeRegExp(O){return{pattern:O.source,flags:(0,E.regExpFlags)(O)}}static _serializeIndentationRule(O){return{decreaseIndentPattern:J._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:J._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?J._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?J._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:J._serializeRegExp(O.beforeText),afterText:O.afterText?J._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?J._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(J._serializeOnEnterRule)}setLanguageConfiguration(O,H,G){const{wordPattern:X}=G;if(X&&(0,E.regExpLeadsToEndlessLoop)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this._documents.setWordDefinitionFor(H,X):this._documents.setWordDefinitionFor(H,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const he=this._nextHandle(),be={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?J._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?J._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?J._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(he,H,be),this._createDisposable(he)}$setWordDefinitions(O){for(const H of O)this._documents.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.ExtHostLanguageFeatures=J,J._handlePool=0}),define(Ie[251],ke([1,0,5,15,7,41,18,6]),function(Y,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(R,k,_,T){this._documents=k,this._commands=_,this._uriTransformer=T,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(u.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,k){await this._proxy.$changeLanguage(R,k);const _=this._documents.getDocumentData(R);if(!_)throw new Error(`document '${R.toString()}' NOT found`);return _.document}async tokenAtPosition(R,k){const _=R.version,T=t.Position.from(k),w=await this._proxy.$tokensAtPosition(R.uri,T),b={type:D.StandardTokenType.Other,range:R.getWordRangeAtPosition(k)??new D.Range(k.line,k.character,k.line,k.character)};if(!w)return b;const g={range:t.Range.to(w.range),type:t.TokenType.to(w.type)};return!g.range.contains(k)||_!==R.version?b:g}createLanguageStatusItem(R,k,_){const T=this._handlePool++,w=this._proxy,b=this._ids,g=`${R.identifier.value}/${k}`;if(b.has(g))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);b.add(g);const f={selector:_,id:k,name:R.displayName??R.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p;const v=new C.DisposableStore,c=()=>{p?.dispose(),p=(0,y.disposableTimeout)(()=>{v.clear(),this._proxy.$setLanguageStatus(T,{id:g,name:f.name??R.displayName??R.name,source:R.displayName??R.name,selector:t.DocumentSelector.from(f.selector,this._uriTransformer),label:f.text,detail:f.detail??"",severity:f.severity===D.LanguageStatusSeverity.Error?P.default.Error:f.severity===D.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:f.command&&this._commands.toInternal(f.command,v),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},m={dispose(){v.dispose(),p?.dispose(),w.$removeLanguageStatus(T),b.delete(g)},get id(){return f.id},get name(){return f.name},set name(a){f.name=a,c()},get selector(){return f.selector},set selector(a){f.selector=a,c()},get text(){return f.text},set text(a){f.text=a,c()},get detail(){return f.detail},set detail(a){f.detail=a,c()},get severity(){return f.severity},set severity(a){f.severity=a,c()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(a){f.accessibilityInformation=a,c()},get command(){return f.command},set command(a){f.command=a,c()},get busy(){return f.busy},set busy(a){f.busy=a,c()}};return c(),m}}e.ExtHostLanguages=E}),define(Ie[136],ke([1,0,14,5,26,17,3]),function(Y,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let C=class extends u.AbstractLoggerService{constructor(R,k){const _=new y.Emitter;super(k.logLevel,_.event);this._proxy=R.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(_)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,k,_){return new E(this._proxy,R,k,_)}};C=Ge([xe(0,P.IExtHostRpcService),xe(1,D.IExtHostInitDataService)],C),e.ExtHostLoggerService=C;class E extends u.AbstractMessageLogger{constructor(R,k,_,T){super(T?.always);this.proxy=R,this.file=k,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(_),this.proxy.$createLogger(k,T).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,k){const _=[[R,k]];this.isLoggerCreated?this.doLog(_):this.buffer.push(..._)}doLog(R){this.proxy.$log(this.file,R)}}}),define(Ie[252],ke([1,0,5,14,27]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(C){return C&&C.title}let y=class{constructor(E,I){this._logService=I,this._proxy=E.getProxy(u.MainContext.MainThreadMessageService)}showMessage(E,I,R,k,_){const T={source:{identifier:E.identifier,label:E.displayName||E.name}};let w;typeof k=="string"||P(k)?w=[k,..._]:(T.modal=k?.modal,T.useCustom=k?.useCustom,T.detail=k?.detail,w=_),T.useCustom&&(0,D.checkProposedApiEnabled)(E,"resolvers");const b=[];for(let g=0;g<w.length;g++){const f=w[g];if(typeof f=="string")b.push({title:f,handle:g,isCloseAffordance:!1});else if(typeof f=="object"){const{title:p,isCloseAffordance:v}=f;b.push({title:p,isCloseAffordance:!!v,handle:g})}else this._logService.warn("Invalid message item:",f)}return this._proxy.$showMessage(I,R,T,b).then(g=>{if(typeof g=="number")return w[g]})}};y=Ge([xe(1,t.ILogService)],y),e.ExtHostMessageService=y}),define(Ie[253],ke([1,0,23,3,60,6,25,8,10,2,87,5,37,15,7,53,223,131]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class p{constructor(c,m,a,d,r){this._textDocumentsAndEditors=a,this._textDocuments=d,this._extensionStoragePaths=r,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new y.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=c.getProxy(k.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=c.getProxy(k.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=c.getProxy(k.MainContext.MainThreadNotebookEditors),this._commandsConverter=m.converter,m.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===12){const i=o.notebookEditor?.notebookUri,n=o.cell.handle,l=this._documents.get(i)?.getCell(n);if(l)return l.apiCell}return o}}),p._registerApiCommands(m)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(c=>c.apiEditor)}getEditorById(c){const m=this._editors.get(c);if(!m)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);return m}getIdByEditor(c){for(const[m,a]of this._editors)if(a.apiEditor===c)return m}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(c,m){const a=this._documents.get(c);if(!a&&!m)throw new Error(`NO notebook document for '${c}'`);return a}_getProviderData(c){const m=this._notebookContentProviders.get(c);if(!m)throw new Error(`NO provider for '${c}'`);return m}registerNotebookContentProvider(c,m,a,d,r){if((0,C.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(m))throw new Error(`Notebook provider for '${m}' already registered`);this._notebookContentProviders.set(m,{extension:c,provider:a});let o;return a.onDidChangeNotebookContentOptions&&(o=a.onDidChangeNotebookContentOptions(()=>{const i=T.NotebookDocumentContentOptions.from(a.options);this._notebookProxy.$updateNotebookProviderOptions(m,i)})),this._notebookProxy.$registerNotebookProvider({id:c.identifier,location:c.extensionLocation},m,T.NotebookDocumentContentOptions.from(d),p._convertNotebookRegistrationData(c,r)),new w.Disposable(()=>{o?.dispose(),this._notebookContentProviders.delete(m),this._notebookProxy.$unregisterNotebookProvider(m)})}static _convertNotebookRegistrationData(c,m){if(!m)return;const a=m.filenamePattern.map(d=>T.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(m.filenamePattern&&!a){console.warn(`Notebook content provider view options file name pattern is invalid ${m.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:m.displayName,filenamePattern:a,exclusive:m.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,m,a){const d=p._notebookStatusBarItemProviderHandlePool++,r=typeof a.onDidChangeCellStatusBarItems=="function"?p._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(d,a),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(d,r,m);let o;return r!==void 0&&(o=a.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(r))),new w.Disposable(()=>{this._notebookStatusBarItemProviders.delete(d),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(d,r),o&&o.dispose()})}async createNotebookDocument(c){const m=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:c.viewType,content:c.content&&T.NotebookData.from(c.content)});return I.URI.revive(m)}async openNotebookDocument(c){const m=this._documents.get(c);if(m)return m.apiNotebook;const a=await this._notebookDocumentsProxy.$tryOpenNotebook(c),d=this._documents.get(I.URI.revive(a));return(0,E.assertIsDefined)(d?.apiNotebook)}async showNotebookDocument(c,m){I.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let a;typeof m=="object"?a={position:T.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selections:m.selections&&m.selections.map(T.NotebookRange.from),pinned:typeof m.preview=="boolean"?!m.preview:void 0}:a={preserveFocus:!1};const d=await this._notebookEditorsProxy.$tryShowNotebookDocument(c.uri,c.notebookType,a),r=d&&this._editors.get(d)?.apiEditor;if(r)return r;throw d?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,m,a,d){const r=this._notebookStatusBarItemProviders.get(c),o=I.URI.revive(m),i=this._documents.get(o);if(!i||!r)return;const n=i.getCellFromIndex(a);if(!n)return;const s=await r.provideCellStatusBarItems(n.apiCell,d);if(!s)return;const l=new P.DisposableStore,h=this._statusBarCache.add([l]),L=(Array.isArray(s)?s:[s]).map(M=>T.NotebookStatusBarItem.from(M,this._commandsConverter,l));return{cacheId:h,items:L}}$releaseNotebookCellStatusBarItems(c){this._statusBarCache.delete(c)}registerNotebookSerializer(c,m,a,d,r){if((0,C.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,a),this._notebookProxy.$registerNotebookSerializer(o,{id:c.identifier,location:c.extensionLocation},m,T.NotebookDocumentContentOptions.from(d),p._convertNotebookRegistrationData(c,r)),(0,P.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(c,m,a){const d=this._notebookSerializer.get(c);if(!d)throw new Error("NO serializer found");const r=await d.deserializeNotebook(m.buffer,a);return new b.SerializableObjectWithBuffers(T.NotebookData.from(r))}async $notebookToData(c,m,a){const d=this._notebookSerializer.get(c);if(!d)throw new Error("NO serializer found");const r=await d.serializeNotebook(T.NotebookData.to(m.value),a);return u.VSBuffer.wrap(r)}async $openNotebook(c,m,a,d,r){const{provider:o}=this._getProviderData(c),i=await o.openNotebook(I.URI.revive(m),{backupId:a,untitledDocumentData:d?.buffer},r);return new b.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(T.NotebookCellData.from)})}async $saveNotebook(c,m,a){const d=this.getNotebookDocument(I.URI.revive(m)),{provider:r}=this._getProviderData(c);return await r.saveNotebook(d.apiNotebook,a),!0}async $saveNotebookAs(c,m,a,d){const r=this.getNotebookDocument(I.URI.revive(m)),{provider:o}=this._getProviderData(c);return await o.saveNotebookAs(I.URI.revive(a),r.apiNotebook,d),!0}async $backupNotebook(c,m,a){const d=this.getNotebookDocument(I.URI.revive(m)),r=this._getProviderData(c),o=this._extensionStoragePaths.workspaceValue(r.extension)??this._extensionStoragePaths.globalValue(r.extension),i=String((0,D.hash)([d.uri.toString(),this._backupIdPool++])),n=I.URI.joinPath(o,i),s=await r.provider.backupNotebook(d.apiNotebook,{destination:n},a);return d.updateBackup(s),s.id}_createExtHostEditor(c,m,a){if(this._editors.has(m))throw new Error(`editor with id ALREADY EXSIST: ${m}`);const d=new f.ExtHostNotebookEditor(m,this._notebookEditorsProxy,c,a.visibleRanges.map(T.NotebookRange.to),a.selections.map(T.NotebookRange.to),typeof a.viewColumn=="number"?T.ViewColumn.to(a.viewColumn):void 0);this._editors.set(m,d)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const a of c.value.removedDocuments){const d=I.URI.revive(a),r=this._documents.get(d);r&&(r.dispose(),this._documents.delete(d),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===d.toString()&&this._editors.delete(o.id)}if(c.value.addedDocuments){const a=[];for(const d of c.value.addedDocuments){const r=I.URI.revive(d.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const o=new g.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,r,d);a.push(...d.cells.map(i=>g.ExtHostCell.asModelAddData(o.apiNotebook,i))),this._documents.get(r)?.dispose(),this._documents.set(r,o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:a}),this._onDidOpenNotebookDocument.fire(o.apiNotebook)}}if(c.value.addedEditors)for(const a of c.value.addedEditors){if(this._editors.has(a.id))return;const d=I.URI.revive(a.documentUri),r=this._documents.get(d);r&&this._createExtHostEditor(r,a.id,a)}const m=[];if(c.value.removedEditors)for(const a of c.value.removedEditors){const d=this._editors.get(a);d&&(this._editors.delete(a),this._activeNotebookEditor?.id===d.id&&(this._activeNotebookEditor=void 0),m.push(d))}if(c.value.visibleEditors){this._visibleNotebookEditors=c.value.visibleEditors.map(d=>this._editors.get(d)).filter(d=>!!d);const a=new Set;this._visibleNotebookEditors.forEach(d=>a.add(d.id));for(const d of this._editors.values()){const r=a.has(d.id);d._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(d=>d).filter(d=>d.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this._activeNotebookEditor=void 0:c.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(c){const m=_.ApiCommandArgument.String.with("notebookType","A notebook type"),a=new _.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[m,new _.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>u.VSBuffer.wrap(r))],new _.ApiCommandResult("Notebook Data",r=>T.NotebookData.to(r.value))),d=new _.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[m,new _.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new b.SerializableObjectWithBuffers(T.NotebookData.from(r)))],new _.ApiCommandResult("Bytes",r=>r.buffer));c.registerApiCommand(a),c.registerApiCommand(d)}}e.ExtHostNotebookController=p,p._notebookStatusBarItemProviderHandlePool=0}),define(Ie[254],ke([1,0,16,18,21,3,6,25,2,28,14,5,37,15,7,88,218,27,53]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let v=class{constructor(o,i,n,s,l){this._initData=i,this._extHostNotebook=n,this._commands=s,this._logService=l,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=o.getProxy(k.MainContext.MainThreadNotebookKernels);const h=new _.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new _.ApiCommandArgument("options","Select kernel options",S=>!0,S=>{if(S&&"notebookEditor"in S&&"id"in S){const L=this._extHostNotebook.getIdByEditor(S.notebookEditor);return{id:S.id,extension:S.extension,notebookEditorId:L}}else if(S&&"notebookEditor"in S){const L=this._extHostNotebook.getIdByEditor(S.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${S.notebookEditor.document.uri.toString()}`);return{notebookEditorId:L}}return S})],_.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(o,i,n,s,l,h){for(const te of this._kernelData.values())if(te.controller.id===i&&I.ExtensionIdentifier.equals(o.identifier,te.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const S=this._handlePool++,L=this;this._logService.trace(`NotebookController[${S}], CREATED by ${o.identifier.value}, ${i}`);const M=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${o.identifier}'`);let F=!1;const A=new y.DisposableStore,B=new P.Emitter,$=new P.Emitter,U={id:d(o.identifier,i),notebookType:n,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:s||o.identifier.value,preloads:h?h.map(T.NotebookRendererScript.from):[]};let K=l??M,W;this._proxy.$addKernel(S,U).catch(te=>{console.log(te),F=!0});let N=0;const V=()=>{if(F)return;const te=++N;Promise.resolve().then(()=>{te===N&&this._proxy.$updateKernel(S,U)})},x=new C.ResourceMap,q={get id(){return i},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return U.label},set label(te){U.label=te??o.displayName??o.name,V()},get detail(){return U.detail??""},set detail(te){U.detail=te,V()},get description(){return U.description??""},set description(te){U.description=te,V()},get kind(){return(0,f.checkProposedApiEnabled)(o,"notebookControllerKind"),U.kind??""},set kind(te){(0,f.checkProposedApiEnabled)(o,"notebookControllerKind"),U.kind=te,V()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(te){U.supportedLanguages=te,V()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(te){U.supportsExecutionOrder=te,V()},get rendererScripts(){return U.preloads?U.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(te){K=te??M},get interruptHandler(){return W},set interruptHandler(te){W=te,U.supportsInterrupt=Boolean(te),V()},createNotebookCellExecution(te){if(F)throw new Error("notebook controller is DISPOSED");if(!x.has(te.notebook.uri))throw L._logService.trace(`NotebookController[${S}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(Q=>Q.toString())),new Error(`notebook controller is NOT associated to notebook: ${te.notebook.uri.toString()}`);return L._createNotebookCellExecution(te,d(o.identifier,this.id))},dispose:()=>{F||(this._logService.trace(`NotebookController[${S}], DISPOSED`),F=!0,this._kernelData.delete(S),A.dispose(),B.dispose(),$.dispose(),this._proxy.$removeKernel(S))},updateNotebookAffinity(te,Q){L._proxy.$updateNotebookPriority(S,te.uri,Q)},onDidReceiveMessage:$.event,postMessage(te,Q){return(0,f.checkProposedApiEnabled)(o,"notebookMessaging"),L._proxy.$postMessage(S,Q&&L._extHostNotebook.getIdByEditor(Q),te)},asWebviewUri(te){return(0,f.checkProposedApiEnabled)(o,"notebookMessaging"),(0,b.asWebviewUri)(te,L._initData.remote)}};return this._kernelData.set(S,{extensionId:o.identifier,controller:q,onDidReceiveMessage:$,onDidChangeSelection:B,associatedNotebooks:x}),q}getIdByController(o){for(const[i,n]of this._kernelData)if(n.controller===o)return d(n.extensionId,o.id);return null}$acceptNotebookAssociation(o,i,n){const s=this._kernelData.get(o);if(s){const l=this._extHostNotebook.getNotebookDocument(E.URI.revive(i));n?s.associatedNotebooks.set(l.uri,!0):s.associatedNotebooks.delete(l.uri),this._logService.trace(`NotebookController[${o}] ASSOCIATE notebook`,l.uri.toString(),n),s.onDidChangeSelection.fire({selected:n,notebook:l.apiNotebook})}}async $executeCells(o,i,n){const s=this._kernelData.get(o);if(!s)return;const l=this._extHostNotebook.getNotebookDocument(E.URI.revive(i)),h=[];for(const S of n){const L=l.getCell(S);L&&h.push(L.apiCell)}try{this._logService.trace(`NotebookController[${o}] EXECUTE cells`,l.uri.toString(),h.length),await s.controller.executeHandler.call(s.controller,h,l.apiNotebook,s.controller)}catch(S){this._logService.error(`NotebookController[${o}] execute cells FAILED`,S),console.error(S)}}async $cancelCells(o,i,n){const s=this._kernelData.get(o);if(!s)return;const l=this._extHostNotebook.getNotebookDocument(E.URI.revive(i));if(s.controller.interruptHandler)await s.controller.interruptHandler.call(s.controller,l.apiNotebook);else for(const h of n){const S=l.getCell(h);S&&this._activeExecutions.get(S.uri)?.cancel()}}$acceptKernelMessageFromRenderer(o,i,n){const s=this._kernelData.get(o);if(!s)return;const l=this._extHostNotebook.getEditorById(i);s.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:n}))}$cellExecutionChanged(o,i,n){const l=this._extHostNotebook.getNotebookDocument(E.URI.revive(o)).getCell(i);l&&this._onDidChangeCellExecutionState.fire({cell:l.apiCell,state:n?T.NotebookCellExecutionState.to(n):w.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(o,i){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const l=new m(i,s,this._proxy);this._activeExecutions.set(s.uri,l);const h=l.onDidChangeState(()=>{l.state===c.Resolved&&(l.dispose(),h.dispose(),this._activeExecutions.delete(s.uri))});return l.asApiObject()}};v=Ge([xe(4,R.ILogService)],v),e.ExtHostNotebookKernels=v;var c;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(c||(c={}));class m extends y.Disposable{constructor(o,i,n){super();this._cell=i,this._proxy=n,this._handle=m.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new a(10,s=>this.update(s)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,o,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(o){await this._collector.addItem(o)}async update(o){const i=Array.isArray(o)?o:[o];return this._proxy.$updateExecution(this._handle,new p.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(o){let i=this._cell;if(o&&(i=this._cell.notebook.getCellFromApiCell(o)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(o){return o.map(i=>{const n=w.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return n===i.items?T.NotebookCellOutput.from(i):T.NotebookCellOutput.from({items:n,id:i.id,metadata:i.metadata})})}async updateOutputs(o,i,n){const s=this.cellIndexToHandle(i),l=this.validateAndConvertOutputs((0,u.asArray)(o));return this.updateSoon({editType:g.CellExecutionUpdateType.Output,cellHandle:s,append:n,outputs:l})}async updateOutputItems(o,i,n){return o=w.NotebookCellOutput.ensureUniqueMimeTypes((0,u.asArray)(o),!0),this.updateSoon({editType:g.CellExecutionUpdateType.OutputItems,items:o.map(T.NotebookCellOutputItem.from),outputId:i.id,append:n})}asApiObject(){const o=this;return Object.freeze({get token(){return o._tokenSource.token},get cell(){return o._cell.apiCell},get executionOrder(){return o._executionOrder},set executionOrder(n){o._executionOrder=n,o.update([{editType:g.CellExecutionUpdateType.ExecutionState,executionOrder:o._executionOrder}])},start(n){if(o._state===c.Resolved||o._state===c.Started)throw new Error("Cannot call start again");o._state=c.Started,o._onDidChangeState.fire(),o.update({editType:g.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,s){if(o._state===c.Resolved)throw new Error("Cannot call resolve twice");o._state=c.Resolved,o._onDidChangeState.fire(),o._collector.flush(),o._proxy.$completeExecution(o._handle,new p.SerializableObjectWithBuffers({runEndTime:s,lastRunSuccess:n}))},clearOutput(n){return o.verifyStateForOutput(),o.updateOutputs([],n,!1)},appendOutput(n,s){return o.verifyStateForOutput(),o.updateOutputs(n,s,!0)},replaceOutput(n,s){return o.verifyStateForOutput(),o.updateOutputs(n,s,!1)},appendOutputItems(n,s){return o.verifyStateForOutput(),o.updateOutputItems(n,s,!0)},replaceOutputItems(n,s){return o.verifyStateForOutput(),o.updateOutputItems(n,s,!1)}})}}m.HANDLE=0;class a{constructor(o,i){this.delay=o,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(o){return this.batch.push(o),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const o=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>o.complete())}}function d(r,o){return`${r.value}/${o}`}e.createKernelId=d}),define(Ie[255],ke([1,0,3,5,131]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(C,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,E,I){const R=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(E)?.fire({editor:R.apiEditor,message:I})}createRendererMessaging(C,E){if(!C.contributes?.notebookRenderer?.some(R=>R.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(R,k,_)=>this.getOrCreateEmitterFor(E).event(R,k,_),postMessage:(R,k)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,k]=[k,R]);const _=k&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.proxy.$postMessage(_?.id,E,R)}}}getOrCreateEmitterFor(C){let E=this._rendererMessageEmitters.get(C);return E||(E=new u.Emitter({onLastListenerRemove:()=>{E?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,E),E)}}e.ExtHostNotebookRenderers=P}),define(Ie[256],ke([1,0,21,3,6,5,2,7,12,16,41,86]),function(Y,e,u,t,D,P,y,C,E,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function _(T,w,b){const g=T.getProxy(P.MainContext.MainThreadQuickOpen);class f{constructor(i,n){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=n}showQuickPick(i,n,s=u.CancellationToken.None){this._onDidSelectItem=void 0;const l=Promise.resolve(i),h=++this._instances,S=g.$show(h,{title:n?.title,placeHolder:n?.placeHolder,matchOnDescription:n?.matchOnDescription,matchOnDetail:n?.matchOnDetail,ignoreFocusLost:n?.ignoreFocusOut,canPickMany:n?.canPickMany},s),L={},M=S.then(()=>L);return Promise.race([M,l]).then(F=>{if(F!==L)return l.then(A=>{const B=[];for(let $=0;$<A.length;$++){const U=A[$];typeof U=="string"?B.push({label:U,handle:$}):U.kind===C.QuickPickItemKind.Separator?B.push({type:"separator",label:U.label}):B.push({label:U.label,description:U.description,detail:U.detail,picked:U.picked,alwaysShow:U.alwaysShow,handle:$})}return n&&typeof n.onDidSelectItem=="function"&&(this._onDidSelectItem=$=>{n.onDidSelectItem(A[$])}),g.$setItems(h,B),S.then($=>{if(typeof $=="number")return A[$];if(Array.isArray($))return $.map(U=>A[U])})})}).then(void 0,F=>{if(!(0,E.isCancellationError)(F))return g.$setError(h,F),Promise.reject(F)})}$onItemSelected(i){this._onDidSelectItem?.(i)}showInput(i,n=u.CancellationToken.None){return this._validateInput=i?.validateInput,g.$input(i,typeof this._validateInput=="function",n).then(void 0,s=>{if(!(0,E.isCancellationError)(s))return Promise.reject(s)})}async $validateInput(i){if(!this._validateInput)return;const n=await this._validateInput(i);if(!n||typeof n=="string")return n;let s;switch(n.severity){case C.InputBoxValidationSeverity.Info:s=R.default.Info;break;case C.InputBoxValidationSeverity.Warning:s=R.default.Warning;break;case C.InputBoxValidationSeverity.Error:s=R.default.Error;break;default:s=n.message?R.default.Error:R.default.Ignore;break}return{content:n.message,severity:s}}async showWorkspaceFolderPick(i,n=u.CancellationToken.None){const s=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!s)return;const l=await this._workspace.getWorkspaceFolders2();if(!!l)return l.find(h=>h.uri.toString()===s.uri.toString())}createQuickPick(i){const n=new d(i,()=>this._sessions.delete(n._id));return this._sessions.set(n._id,n),n}createInputBox(i){const n=new r(i,()=>this._sessions.delete(n._id));return this._sessions.set(n._id,n),n}$onDidChangeValue(i,n){this._sessions.get(i)?._fireDidChangeValue(n)}$onDidAccept(i){const n=this._sessions.get(i);n&&n._fireDidAccept()}$onDidChangeActive(i,n){const s=this._sessions.get(i);s instanceof d&&s._fireDidChangeActive(n)}$onDidChangeSelection(i,n){const s=this._sessions.get(i);s instanceof d&&s._fireDidChangeSelection(n)}$onDidTriggerButton(i,n){this._sessions.get(i)?._fireDidTriggerButton(n)}$onDidTriggerItemButton(i,n,s){const l=this._sessions.get(i);l instanceof d&&l._fireDidTriggerItemButton(n,s)}$onDidHide(i){const n=this._sessions.get(i);n&&n._fireDidHide()}}class p{constructor(i,n){this._extensionId=i,this._onDidDispose=n,this._id=d._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new t.Emitter,this._onDidChangeValueEmitter=new t.Emitter,this._onDidTriggerButtonEmitter=new t.Emitter,this._onDidHideEmitter=new t.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((n,s)=>{const l=n===C.QuickInputButtons.Back?-1:s;this._handlesToButtons.set(l,n)}),this.update({buttons:i.map((n,s)=>({...a(n),tooltip:n.tooltip,handle:n===C.QuickInputButtons.Back?-1:s}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const n=this._handlesToButtons.get(i);n&&this._onDidTriggerButtonEmitter.fire(n)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,D.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),g.$dispose(this._id))}update(i){if(!this._disposed){for(const n of Object.keys(i)){const s=i[n];this._pendingUpdate[n]=s===void 0?null:s}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){g.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}p._nextId=1;function v(o){if(o instanceof C.ThemeIcon)return{id:o.id};const i=m(o),n=c(o);return{dark:typeof i=="string"?y.URI.file(i):i,light:typeof n=="string"?y.URI.file(n):n}}function c(o){return typeof o=="object"&&"light"in o?o.light:o}function m(o){return typeof o=="object"&&"dark"in o?o.dark:o}function a(o){const i=v(o.iconPath);let n,s;return"id"in i?s=k.ThemeIcon.asClassName(i):n=i,{iconPath:n,iconClass:s}}class d extends p{constructor(i,n){super(i.identifier,n);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new t.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new t.Emitter,this._onDidTriggerItemButtonEmitter=new t.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((s,l)=>{this._handlesToItems.set(l,s),this._itemsToHandles.set(s,l)});const n=[];for(let s=0;s<i.length;s++){const l=i[s];l.kind===C.QuickPickItemKind.Separator?n.push({type:"separator",label:l.label}):n.push({handle:s,label:l.label,description:l.description,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow,buttons:l.buttons?.map((h,S)=>({...a(h),tooltip:h.tooltip,handle:S}))})}this.update({items:n})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(i){this._keepScrollPosition=i,this.update({keepScrollPosition:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(n=>this._itemsToHandles.has(n)),this.update({activeItems:this._activeItems.map(n=>this._itemsToHandles.get(n))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(n=>this._itemsToHandles.has(n)),this.update({selectedItems:this._selectedItems.map(n=>this._itemsToHandles.get(n))})}_fireDidChangeActive(i){const n=(0,I.coalesce)(i.map(s=>this._handlesToItems.get(s)));this._activeItems=n,this._onDidChangeActiveEmitter.fire(n)}_fireDidChangeSelection(i){const n=(0,I.coalesce)(i.map(s=>this._handlesToItems.get(s)));this._selectedItems=n,this._onDidChangeSelectionEmitter.fire(n)}_fireDidTriggerItemButton(i,n){const s=this._handlesToItems.get(i);if(!s||!s.buttons||!s.buttons.length)return;const l=s.buttons[n];l&&this._onDidTriggerItemButtonEmitter.fire({button:l,item:s})}}class r extends p{constructor(i,n){super(i.identifier,n);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,i?typeof i=="string"?this.update({validationMessage:i,severity:R.default.Error}):this.update({validationMessage:i.message,severity:i.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new f(w,b)}e.createExtHostQuickOpen=_});var tt=this&&this.__classPrivateFieldSet||function(Y,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Y,u):D?D.value=u:e.set(Y,u),u},Me=this&&this.__classPrivateFieldGet||function(Y,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!t:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Y):t?t.value:e.get(Y)};define(Ie[257],ke([1,0,2,3,57,6,18,5,16,104,14,28,86,15,27]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w){"use strict";var b,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(l){if(l)return typeof l.iconPath=="string"?u.URI.file(l.iconPath):u.URI.isUri(l.iconPath)||_.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function p(l,h){if(!l.iconPath&&!h.iconPath)return 0;if(l.iconPath){if(!h.iconPath)return 1}else return-1;const S=typeof l.iconPath=="string"?l.iconPath:u.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,L=typeof h.iconPath=="string"?h.iconPath:u.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,I.comparePaths)(S,L)}function v(l,h){let S=0;if(l.strikeThrough!==h.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==h.faded)return l.faded?1:-1;if(l.tooltip!==h.tooltip)return(l.tooltip||"").localeCompare(h.tooltip||"");if(S=p(l,h),S!==0)return S;if(l.light&&h.light)S=p(l.light,h.light);else{if(l.light)return 1;if(h.light)return-1}if(S!==0)return S;if(l.dark&&h.dark)S=p(l.dark,h.dark);else{if(l.dark)return 1;if(h.dark)return-1}return S}function c(l,h){if(l.command!==h.command)return l.command<h.command?-1:1;if(l.title!==h.title)return l.title<h.title?-1:1;if(l.tooltip!==h.tooltip){if(l.tooltip!==void 0&&h.tooltip!==void 0)return l.tooltip<h.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(l.arguments===h.arguments)return 0;if(l.arguments)if(h.arguments){if(l.arguments.length!==h.arguments.length)return l.arguments.length-h.arguments.length}else return 1;else return-1;for(let S=0;S<l.arguments.length;S++){const L=l.arguments[S],M=h.arguments[S];if(L!==M)return L<M?-1:1}return 0}function m(l,h){let S=(0,I.comparePaths)(l.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(S!==0)return S;if(l.command&&h.command)S=c(l.command,h.command);else{if(l.command)return 1;if(h.command)return-1}if(S!==0)return S;if(l.decorations&&h.decorations)S=v(l.decorations,h.decorations);else{if(l.decorations)return 1;if(h.decorations)return-1}return S}function a(l,h){for(let S=0;S<l.length;S++)if(l[S]!==h[S])return!1;return!0}function d(l,h){return l.command===h.command&&l.title===h.title&&l.tooltip===h.tooltip&&(l.arguments&&h.arguments?a(l.arguments,h.arguments):l.arguments===h.arguments)}function r(l,h){return(0,E.equals)(l,h,d)}class o{constructor(h,S,L){this._extension=h,this._sourceControlHandle=L,b.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,tt(this,b,S,"f")}get value(){return this._value}set value(h){h=h??"",Me(this,b,"f").$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){Me(this,b,"f").$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(h){if((0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,Me(this,b,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get enabled(){return this._enabled}set enabled(h){h=!!h,this._enabled!==h&&(this._enabled=h,Me(this,b,"f").$setInputBoxEnablement(this._sourceControlHandle,h))}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,Me(this,b,"f").$setInputBoxVisibility(this._sourceControlHandle,h))}showValidationMessage(h,S){(0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),Me(this,b,"f").$showValidationMessage(this._sourceControlHandle,h,S)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=o,b=new WeakMap;class i{constructor(h,S,L,M,F){this._proxy=h,this._commands=S,this._sourceControlHandle=L,this._id=M,this._label=F,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=i._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,S){const L=this._resourceStatesCommandsMap.get(h);return L?(0,y.asPromise)(()=>this._commands.executeCommand(L.command,...L.arguments||[],S)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(m),L=(0,E.sortedDiff)(this._resourceSnapshot,h,m).map(A=>{const B=A.toInsert.map($=>{const U=this._resourceHandlePool++;this._resourceStatesMap.set(U,$);const K=$.resourceUri;let W;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const ge=new P.DisposableStore;W=this._commands.converter.toInternal($.command,ge),this._resourceStatesDisposablesMap.set(U,ge)}else this._resourceStatesCommandsMap.set(U,$.command);const N=f($.decorations),V=$.decorations&&f($.decorations.light)||N,x=$.decorations&&f($.decorations.dark)||N,q=[V,x],te=$.decorations&&$.decorations.tooltip||"",Q=$.decorations&&!!$.decorations.strikeThrough,le=$.decorations&&!!$.decorations.faded,pe=$.contextValue||"";return{rawResource:[U,K,q,te,Q,le,pe,W],handle:U}});return{start:A.start,deleteCount:A.deleteCount,toInsert:B}}),M=L.map(({start:A,deleteCount:B,toInsert:$})=>[A,B,$.map(U=>U.rawResource)]),F=L.reverse();for(const{start:A,deleteCount:B,toInsert:$}of F){const U=$.map(W=>W.handle),K=this._handlesSnapshot.splice(A,B,...U);for(const W of K)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),this._resourceStatesDisposablesMap.get(W)?.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=h,M}dispose(){this._disposed=!0,this._onDidDispose.fire()}}i._handlePool=0;class n{constructor(h,S,L,M,F,A){this._extension=h,this._commands=L,this._id=M,this._label=F,this._rootUri=A,g.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,tt(this,g,S,"f"),this._inputBox=new o(h,Me(this,g,"f"),this.handle),Me(this,g,"f").$registerSourceControl(this.handle,M,F,A)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,Me(this,g,"f").$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,Me(this,g,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,Me(this,g,"f").$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=h;const S=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);Me(this,g,"f").$updateSourceControl(this.handle,{acceptInputCommand:S})}get actionButton(){return(0,w.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(h){(0,w.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=h;const S=h!==void 0?{command:this._commands.converter.toInternal(h.command,this._actionButtonDisposables.value),secondaryCommands:h.secondaryCommands?.map(L=>L.map(M=>this._commands.converter.toInternal(M,this._actionButtonDisposables.value))),description:h.description,enabled:h.enabled}:void 0;Me(this,g,"f").$updateSourceControl(this.handle,{actionButton:S??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&r(this._statusBarCommands,h))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=h;const S=(h||[]).map(L=>this._commands.converter.toInternal(L,this._statusBarDisposables.value));Me(this,g,"f").$updateSourceControl(this.handle,{statusBarCommands:S})}get selected(){return this._selected}createResourceGroup(h,S){const L=new i(Me(this,g,"f"),this._commands,this.handle,h,S),M=t.Event.once(L.onDidDispose)(()=>this.createdResourceGroups.delete(L));return this.createdResourceGroups.set(L,M),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const h=[],S=[];for(const[L,M]of this.createdResourceGroups){M.dispose();const F=L.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(L),this.eventuallyUpdateResourceStates()});t.Event.once(L.onDidDispose)(()=>{this.updatedResourceGroups.delete(L),F.dispose(),this._groups.delete(L.handle),Me(this,g,"f").$unregisterGroup(this.handle,L.handle)}),h.push([L.handle,L.id,L.label,L.features]);const A=L._takeResourceStateSnapshot();A.length>0&&S.push([L.handle,A]),this._groups.set(L.handle,L)}Me(this,g,"f").$registerGroups(this.handle,h,S),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(S=>{const L=S._takeResourceStateSnapshot();L.length!==0&&h.push([S.handle,L])}),h.length>0&&Me(this,g,"f").$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),Me(this,g,"f").$unregisterSourceControl(this.handle)}}g=new WeakMap,n._handlePool=0,Ge([(0,D.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),Ge([(0,D.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let s=class Qn{constructor(h,S,L){this._commands=S,this.logService=L,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=h.getProxy(C.MainContext.MainThreadSCM),this._telemetry=h.getProxy(C.MainContext.MainThreadTelemetry),S.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const F=this._sourceControls.get(M.sourceControlHandle);if(!F)return M;const A=F.getResourceGroup(M.groupHandle);return A?A.getResourceState(M.handle):M}else if(M&&M.$mid===4){const F=this._sourceControls.get(M.sourceControlHandle);return F?F.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const F=this._sourceControls.get(M.handle);return F||M}return M}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(h,S,L,M){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,S,L,M),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const F=Qn._handlePool++,A=new n(h,this._proxy,this._commands,S,L,M);this._sourceControls.set(F,A);const B=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(h.identifier))||[];return B.push(A),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(h.identifier),B),A}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const S=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(h.identifier)),L=S&&S[S.length-1];return L&&L.inputBox}$provideOriginalResource(h,S,L){const M=u.URI.revive(S);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,M.toString());const F=this._sourceControls.get(h);return!F||!F.quickDiffProvider||!F.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>F.quickDiffProvider.provideOriginalResource(M,L)).then(A=>A||null)}$onInputBoxValueChange(h,S){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const L=this._sourceControls.get(h);return L&&L.inputBox.$onInputBoxValueChange(S),Promise.resolve(void 0)}$executeResourceCommand(h,S,L,M){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,S,L);const F=this._sourceControls.get(h);if(!F)return Promise.resolve(void 0);const A=F.getResourceGroup(S);return A?A.$executeResourceCommand(L,M):Promise.resolve(void 0)}$validateInput(h,S,L){this.logService.trace("ExtHostSCM#$validateInput",h);const M=this._sourceControls.get(h);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>M.inputBox.validateInput(S,L)).then(F=>{if(!F)return Promise.resolve(void 0);const A=T.MarkdownString.fromStrict(F.message);return A?Promise.resolve([A,F.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};s._handlePool=0,s=Ge([xe(2,R.ILogService)],s),e.ExtHostSCM=s});var tt=this&&this.__classPrivateFieldSet||function(Y,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Y,u):D?D.value=u:e.set(Y,u),u},Me=this&&this.__classPrivateFieldGet||function(Y,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!t:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Y):t?t.value:e.get(Y)};define(Ie[258],ke([1,0,7,5,173,6,15,10]),function(Y,e,u,t,D,P,y,C){"use strict";var E,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(w,b,g,f,p=u.StatusBarAlignment.Left,v){E.set(this,void 0),I.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,E,w,"f"),tt(this,I,b,"f"),this._entryId=R.ID_GEN++,this._extension=g,this._id=f,this._alignment=p,this._priority=this.validatePriority(v)}validatePriority(w){if(!!(0,C.isNumber)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(w){this._text=w,this.update()}set name(w){this._name=w,this.update()}set tooltip(w){this._tooltip=w,this.update()}set color(w){this._color=w,this.update()}set backgroundColor(w){w&&!R.ALLOWED_BACKGROUND_COLORS.has(w.id)&&(w=void 0),this._backgroundColor=w,this.update()}set command(w){this._command?.fromApi!==w&&(this._internalCommandRegistration.clear(),typeof w=="string"?this._command={fromApi:w,internal:Me(this,I,"f").toInternal({title:"",command:w},this._internalCommandRegistration)}:w?this._command={fromApi:w,internal:Me(this,I,"f").toInternal(w,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(w){this._accessibilityInformation=w,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Me(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let w;this._extension?this._id?w=`${this._extension.identifier.value}.${this._id}`:w=this._extension.identifier.value:w=this._id;let b;this._name?b=this._name:b=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let g=this._color;this._backgroundColor&&(g=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const f=y.MarkdownString.fromStrict(this._tooltip);Me(this,E,"f").$setEntry(this._entryId,w,b,this._text,f,this._command?.internal,g,this._backgroundColor,this._alignment===u.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,E=new WeakMap,I=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new u.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.ThemeColor("statusBarItem.warningForeground")]]);class k{constructor(w){this._messages=[],this._item=w.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(w){const b={message:w};return this._messages.unshift(b),this._update(),new u.Disposable(()=>{const g=this._messages.indexOf(b);g>=0&&(this._messages.splice(g,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class _{constructor(w,b){this._proxy=w.getProxy(t.MainContext.MainThreadStatusBar),this._commands=b,this._statusMessage=new k(this)}createStatusBarEntry(w,b,g,f){return new R(this._proxy,this._commands,w,b,g,f)}setStatusBarMessage(w,b){const g=this._statusMessage.setMessage(w);let f;return typeof b=="number"?f=setTimeout(()=>g.dispose(),b):typeof b!="undefined"&&b.then(()=>g.dispose(),()=>g.dispose()),new u.Disposable(()=>{g.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=_}),define(Ie[91],ke([1,0,5,3,4]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(C){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(u.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,E){this._proxy.$registerExtensionStorageKeysToSync(C,E)}initializeExtensionStorage(C,E,I){return this._proxy.$initializeExtensionStorage(C,E).then(R=>R||I)}setValue(C,E,I){return this._proxy.$setValue(C,E,I)}$acceptValue(C,E,I){this._onDidChangeStorage.fire({shared:C,key:E,value:I})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(Ie[69],ke([1,0,4,26,14,68,2]),function(Y,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,u.createDecorator)("IExtensionStoragePaths");let C=class{constructor(I,R,k){this._logService=R,this._extHostFileSystem=k,this._workspace=I.workspace??void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(_=>this._value=_)}async _getWorkspaceStorageURI(I){return y.URI.joinPath(this._environment.workspaceStorageHome,I)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const I=this._workspace.id,R=await this._getWorkspaceStorageURI(I);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:y.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(I){if(this._value)return y.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return y.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};C=Ge([xe(0,t.IExtHostInitDataService),xe(1,D.ILogService),xe(2,P.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(Ie[38],ke([1,0,3,5,4,2,17,6,7,174,12,219,21,34,202,86,10,18]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class p{constructor(n,s,l,h){this._proxy=n,this._id=s,this._creationOptions=l,this._name=h,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(L=>this._pidPromiseComplete=L);const S=this;this.value={get name(){return S._name||""},get processId(){return S._pidPromise},get creationOptions(){return S._creationOptions},get exitStatus(){return S._exitStatus},get state(){return S._state},sendText(L,M=!0){S._checkDisposed(),S._proxy.$sendText(S._id,L,M)},show(L){S._checkDisposed(),S._proxy.$show(S._id,L)},hide(){S._checkDisposed(),S._proxy.$hide(S._id)},dispose(){S._disposed||(S._disposed=!0,S._proxy.$dispose(S._id))},get dimensions(){if(!(S._cols===void 0||S._rows===void 0))return{columns:S._cols,rows:S._rows}}}}async create(n,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:(0,g.withNullAsUndefined)(n.shellPath),shellArgs:(0,g.withNullAsUndefined)(n.shellArgs),cwd:(0,g.withNullAsUndefined)(n.cwd),env:(0,g.withNullAsUndefined)(n.env),icon:(0,g.withNullAsUndefined)(r(n.iconPath)),color:b.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,g.withNullAsUndefined)(n.message),strictEnv:(0,g.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,g.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,g.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,g.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this._serializeParentTerminal(n.location,s?.resolvedExtHostIdentifier),isTransient:(0,g.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,s,l,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:l,color:b.ThemeColor.isThemeColor(h)?h.id:void 0,location:this._serializeParentTerminal(n,s),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(n,s){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in n?{viewColumn:n.viewColumn,preserveFocus:n.preserveFocus}:void 0:n}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitStatus(n,s){this._exitStatus=Object.freeze({code:n,reason:s})}setDimensions(n,s){return n===this._cols&&s===this._rows||n===0||s===0?!1:(this._cols=n,this._rows=s,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=p;class v{constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new u.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new u.Emitter,this._onDidChangeProperty=new u.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new u.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${s}`)}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput?.(n)}resize(n,s){this._pty.setDimensions?.({columns:n,rows:s})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose?.((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions?.(s=>{s&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this._pty.onDidChangeName?.(s=>{this._onDidChangeProperty.fire({type:"title",value:s})}),this._pty.open(n||void 0),n&&this._pty.setDimensions?.(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=v;let c=1,m=class extends C.Disposable{constructor(n,s){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new u.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new u.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new u.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new u.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new u.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=s.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new w.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new u.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[l,h]of this._terminalProcesses)h.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(n,s){const l=new p(this._proxy,(0,T.generateUuid)(),n,n.name),h=new v(n.pty);return l.createExtensionTerminal(n.location,this._serializeParentTerminal(n,s).resolvedExtHostIdentifier,r(n.iconPath),o(n.color)).then(S=>{const L=this._setupExtHostProcessListeners(S,h);this._terminalProcessDisposables[S]=L}),this._terminals.push(l),l.value}_serializeParentTerminal(n,s){if(s=s||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const l=n.location.parentTerminal;if(l){const h=this._terminals.find(S=>S.value===l);h&&(s.resolvedExtHostIdentifier=h._id)}}else n.location&&typeof n.location!="object"?s.location=n.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(n,s){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const h=new v(s),S=this._setupExtHostProcessListeners(n,h);this._terminalProcessDisposables[n]=S}async $acceptActiveTerminalChanged(n){const s=this._activeTerminal;if(n===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const l=this._getTerminalById(n);l&&(this._activeTerminal=l,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,s){const l=this._getTerminalById(n);l&&this._onDidWriteTerminalData.fire({terminal:l.value,data:s})}async $acceptTerminalDimensions(n,s,l){const h=this._getTerminalById(n);h&&h.setDimensions(s,l)&&this._onDidChangeTerminalDimensions.fire({terminal:h.value,dimensions:h.value.dimensions})}async $acceptTerminalMaximumDimensions(n,s,l){this._terminalProcesses.get(n)?.resize(s,l)}async $acceptTerminalTitleChange(n,s){const l=this._getTerminalById(n);l&&(l.name=s)}async $acceptTerminalClosed(n,s,l){const h=this._getTerminalObjectIndexById(this._terminals,n);if(h!==null){const S=this._terminals.splice(h,1)[0];S.setExitStatus(s,l),this._onDidCloseTerminal.fire(S.value)}}$acceptTerminalOpened(n,s,l,h){if(s){const M=this._getTerminalObjectIndexById(this._terminals,s);if(M!==null){this._terminals[M]._id=n,this._onDidOpenTerminal.fire(this.terminals[M]),this._terminals[M].isOpen=!0;return}}const S={name:h.name,shellPath:h.executable,shellArgs:h.args,cwd:typeof h.cwd=="string"?h.cwd:P.URI.revive(h.cwd),env:h.env,hideFromUser:h.hideFromUser},L=new p(this._proxy,n,S,l);this._terminals.push(L),this._onDidOpenTerminal.fire(L.value),L.isOpen=!0}async $acceptTerminalProcessId(n,s){this._getTerminalById(n)?._setProcessId(s)}async $startExtensionTerminal(n,s){const l=this._getTerminalById(n);if(!l)return{message:(0,I.localize)(0,null,n)};l.isOpen||await new Promise(S=>{const L=this.onDidOpenTerminal(async M=>{M===l.value&&(L.dispose(),S())})});const h=this._terminalProcesses.get(n);h?h.startSendingEvents(s):this._extensionTerminalAwaitingStart[n]={initialDimensions:s}}_setupExtHostProcessListeners(n,s){const l=new C.DisposableStore;l.add(s.onProcessReady(S=>this._proxy.$sendProcessReady(n,S.pid,S.cwd))),l.add(s.onDidChangeProperty(S=>this._proxy.$sendProcessProperty(n,S))),this._bufferer.startBuffering(n,s.onProcessData),l.add(s.onProcessExit(S=>this._onProcessExit(n,S))),this._terminalProcesses.set(n,s);const h=this._extensionTerminalAwaitingStart[n];return h&&s instanceof v&&(s.startSendingEvents(h.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),l}$acceptProcessAckDataEvent(n,s){this._terminalProcesses.get(n)?.acknowledgeDataEvent(s)}$acceptProcessInput(n,s){this._terminalProcesses.get(n)?.input(s)}$acceptTerminalInteraction(n){const s=this._getTerminalById(n);s?.setInteractedWith()&&this._onDidChangeTerminalState.fire(s.value)}$acceptProcessResize(n,s,l){try{this._terminalProcesses.get(n)?.resize(s,l)}catch(h){if(h.code!=="EPIPE"&&h.code!=="ERR_IPC_CHANNEL_CLOSED")throw h}}$acceptProcessShutdown(n,s){this._terminalProcesses.get(n)?.shutdown(s)}$acceptProcessRequestInitialCwd(n){this._terminalProcesses.get(n)?.getInitialCwd().then(s=>this._proxy.$sendProcessProperty(n,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(n){this._terminalProcesses.get(n)?.getCwd().then(s=>this._proxy.$sendProcessProperty(n,{type:"cwd",value:s}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,s,l){if(this._profileProviders.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this._profileProviders.set(s,l),this._proxy.$registerProfileProvider(s,n.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(s),this._proxy.$unregisterProfileProvider(s)})}async $createContributedProfileTerminal(n,s){const l=new _.CancellationTokenSource().token;let h=await this._profileProviders.get(n)?.provideTerminalProfile(l);if(!l.isCancellationRequested){if(h&&!("options"in h)&&(h={options:h}),!h||!("options"in h))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in h.options){this.createExtensionTerminal(h.options,s);return}this.createTerminalFromOptions(h.options,s)}}async $provideLinks(n,s){const l=this._getTerminalById(n);if(!l)return[];this._terminalLinkCache.delete(n),this._terminalLinkCancellationSource.get(n)?.dispose(!0);const S=new _.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,S);const L=[],M={terminal:l.value,line:s},F=[];for(const $ of this._linkProviders)F.push(f.Promises.withAsyncBody(async U=>{S.token.onCancellationRequested(()=>U({provider:$,links:[]}));const K=await $.provideTerminalLinks(M,S.token)||[];S.token.isCancellationRequested||U({provider:$,links:K})}));const A=await Promise.all(F);if(S.token.isCancellationRequested)return[];const B=new Map;for(const $ of A)$&&$.links.length>0&&L.push(...$.links.map(U=>{const K={id:c++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return B.set(K.id,{provider:$.provider,link:U}),K}));return this._terminalLinkCache.set(n,B),L}$activateLink(n,s){const l=this._terminalLinkCache.get(n)?.get(s);!l||l.provider.handleTerminalLink(l.link)}_onProcessExit(n,s){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const l=this._terminalProcessDisposables[n];l&&(l.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,s)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,s){const l=this._getTerminalObjectIndexById(n,s);return l!==null?n[l]:null}_getTerminalObjectIndexById(n,s){let l=null;return n.some((h,S)=>h._id===s?(l=S,!0):!1),l}getEnvironmentVariableCollection(n){let s=this._environmentVariableCollections.get(n.identifier.value);return s||(s=new a,this._setEnvironmentVariableCollection(n.identifier.value,s)),s}_syncEnvironmentVariableCollection(n,s){const l=(0,k.serializeEnvironmentVariableCollection)(s.map);this._proxy.$setEnvironmentVariableCollection(n,s.persistent,l.length===0?void 0:l)}$initEnvironmentVariableCollections(n){n.forEach(s=>{const l=s[0],h=new a(s[1]);this._setEnvironmentVariableCollection(l,h)})}$acceptDefaultProfile(n,s){this._defaultProfile=n,this._defaultAutomationProfile=s}_setEnvironmentVariableCollection(n,s){this._environmentVariableCollections.set(n,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,s)})}};m=Ge([xe(1,y.IExtHostRpcService)],m),e.BaseExtHostTerminalService=m;class a{constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new u.Emitter,this.map=new Map(n)}get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(n,s){this._setIfDiffers(n,{value:s,type:E.EnvironmentVariableMutatorType.Replace})}append(n,s){this._setIfDiffers(n,{value:s,type:E.EnvironmentVariableMutatorType.Append})}prepend(n,s){this._setIfDiffers(n,{value:s,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,s){const l=this.map.get(n);(!l||l.value!==s.value||l.type!==s.type)&&(this.map.set(n,s),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,s){this.map.forEach((l,h)=>n.call(s,h,l,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let d=class extends m{constructor(n){super(!1,n)}createTerminal(n,s,l){throw new R.NotSupportedError}createTerminalFromOptions(n,s){throw new R.NotSupportedError}};d=Ge([xe(0,y.IExtHostRpcService)],d),e.WorkerExtHostTerminalService=d;function r(i){if(!(!i||typeof i=="string"))return"id"in i?{id:i.id,color:i.color}:i}function o(i){return b.ThemeColor.isThemeColor(i)?i:void 0}});var tt=this&&this.__classPrivateFieldSet||function(Y,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Y,u):D?D.value=u:e.set(Y,u),u},Me=this&&this.__classPrivateFieldGet||function(Y,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!t:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Y):t?t.value:e.get(Y)};define(Ie[259],ke([1,0,16,23,21,3,58,60,6,24,10,34,5,17,132,15,7,65,89,66]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g,f,p,v){"use strict";var c,m;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let a=class{constructor(F,A){this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(_.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new r(this.proxy),A.registerArgumentProcessor({processArgument:B=>B?.$mid===13?(0,w.toItemFromContext)(B):B})}createTestController(F,A,B){if(this.controllers.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const $=new E.DisposableStore,U=$.add(new w.ExtHostTestItemCollection(F,A));U.root.label=A;const K=new Map,W=this.proxy,N={items:U.root.children,get label(){return A},set label(x){A=x,U.root.label=x,W.$updateController(F,{label:A})},get refreshHandler(){return B},set refreshHandler(x){B=x,W.$updateController(F,{canRefresh:!!x})},get id(){return F},createRunProfile:(x,q,te,Q,le)=>{let pe=(0,C.hash)(x);for(;K.has(pe);)pe++;return new S(this.proxy,K,F,pe,x,q,te,Q,le)},createTestItem(x,q,te){return new w.TestItemImpl(F,x,q,te)},createTestRun:(x,q,te=!0)=>this.runTracker.createTestRun(F,U,x,q,te),set resolveHandler(x){U.resolveHandler=x},get resolveHandler(){return U.resolveHandler},dispose:()=>{$.dispose()}};W.$registerTestController(F,A,!!B),$.add((0,E.toDisposable)(()=>W.$unregisterTestController(F)));const V={controller:N,collection:U,profiles:K};return this.controllers.set(F,V),$.add((0,E.toDisposable)(()=>this.controllers.delete(F))),$.add(U.onDidGenerateDiff(x=>W.$publishDiff(F,x.map(v.TestsDiffOp.serialize)))),N}createTestObserver(){return this.observer.checkout()}async runTests(F,A=D.CancellationToken.None){const B=o(F);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const $=this.controllers.get(B.controllerId);if(!$)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:F.include?.map(U=>f.TestId.fromExtHostTestItem(U,$.collection.root.id).toString())??[$.collection.root.id],profileGroup:L[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:F.exclude?.map(U=>U.id)},A)}$provideFileCoverage(F,A,B){return(0,u.mapFind)(this.runTracker.trackers,U=>U.id===F?U.getCoverage(A):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(F,A,B,$){return(0,u.mapFind)(this.runTracker.trackers,K=>K.id===F?K.getCoverage(A):void 0)?.resolveFileCoverage(B,$)??Promise.resolve([])}$configureRunProfile(F,A){this.controllers.get(F)?.profiles.get(A)?.configureHandler?.()}async $refreshTests(F,A){await this.controllers.get(F)?.controller.refreshHandler?.(A)}$publishTestResults(F){this.results=Object.freeze(F.map(A=>(0,I.deepFreeze)(b.TestResults.to(A))).concat(this.results).sort((A,B)=>B.completedAt-A.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(F,A){const B=this.controllers.get(f.TestId.fromString(F).controllerId)?.collection;B&&(await B.expand(F,A<0?1/0:A),B.flushDiff())}$acceptDiff(F){this.observer.applyDiff(F.map(v.TestsDiffOp.deserialize))}async $runControllerTests(F,A){const B=this.controllers.get(F.controllerId);if(!B)return;const{collection:$,profiles:U}=B,K=U.get(F.profileId);if(!K)return;const W=F.testIds.map(q=>$.tree.get(q)).filter(R.isDefined),N=F.excludeExtIds.map(q=>B.collection.tree.get(q)).filter(R.isDefined).filter(q=>W.some(te=>te.fullId.compare(q.fullId)===2));if(!W.length)return;const V=new g.TestRunRequest(W.some(q=>q.actual instanceof w.TestItemRootImpl)?void 0:W.map(q=>q.actual),N.map(q=>q.actual),K),x=this.runTracker.prepareForMainThreadTestRun(V,i.fromInternal(F,B.collection),A);try{await K.runHandler(V,A)}finally{x.isRunning&&!A.isCancellationRequested&&await P.Event.toPromise(x.onEnd),x.dispose()}}$cancelExtensionTestRun(F){F===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(F)}};a=Ge([xe(0,T.IExtHostRpcService)],a),e.ExtHostTesting=a;class d extends E.Disposable{constructor(F,A,B){super();this.dto=F,this.proxy=A,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new D.CancellationTokenSource(B)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:$}of this.tasks.values())$.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(F){return this.tasks.get(F)?.coverage}createRun(F){const A=this.dto.id,B=this.dto.controllerId,$=(0,k.generateUuid)(),U=new n(this.proxy,A,$),K=x=>(q,...te)=>{if(N){console.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(q)||(this.ensureTestIsKnown(q),x(q,...te))},W=(x,q)=>{const te=q instanceof Array?q.map(b.TestMessage.from):[b.TestMessage.from(q)];if(x.uri&&x.range){const Q={range:b.Range.from(x.range),uri:x.uri};for(const le of te)le.location=le.location||Q}this.proxy.$appendTestMessagesInRun(A,$,f.TestId.fromExtHostTestItem(x,B).toString(),te)};let N=!1;const V={isPersisted:this.dto.isPersisted,token:this.cts.token,name:F,get coverageProvider(){return U.coverageProvider},set coverageProvider(x){U.coverageProvider=x},enqueued:K(x=>{this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(x,B).toString(),1)}),skipped:K(x=>{this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(x,B).toString(),5)}),started:K(x=>{this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(x,B).toString(),2)}),errored:K((x,q,te)=>{W(x,q),this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(x,B).toString(),6,te)}),failed:K((x,q,te)=>{W(x,q),this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(x,B).toString(),4,te)}),passed:K((x,q)=>{this.proxy.$updateTestStateInRun(A,$,f.TestId.fromExtHostTestItem(x,this.dto.controllerId).toString(),3,q)}),appendOutput:(x,q,te)=>{N||(te&&(this.dto.isIncluded(te)?this.ensureTestIsKnown(te):te=void 0),this.proxy.$appendOutputToRun(A,$,t.VSBuffer.fromString(x),q&&b.location.from(q),te&&f.TestId.fromExtHostTestItem(te,B).toString()))},end:()=>{N||(N=!0,this.proxy.$finishedTestRunTask(A,$),this.tasks.delete($),this.isRunning||this.dispose())}};return this.tasks.set($,{run:V,coverage:U}),this.proxy.$startedTestRunTask(A,{id:$,name:F,running:!0}),V}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(F){if(!(F instanceof w.TestItemImpl))throw new p.InvalidTestItemError(F.id);if(this.sharedTestIds.has(f.TestId.fromExtHostTestItem(F,this.dto.controllerId).toString()))return;const A=[],B=this.dto.colllection.root;for(;;){const $=b.TestItem.from(F);if(A.unshift($),this.sharedTestIds.has($.extId)||(this.sharedTestIds.add($.extId),F===B))break;F=F.parent||B}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,A)}}class r{constructor(F){this.proxy=F,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(F,A,B){return this.getTracker(F,A,B)}cancelRunById(F){for(const A of this.tracked.values())if(A.id===F){A.dispose();return}}cancelAllRuns(){for(const F of this.tracked.values())F.dispose()}createTestRun(F,A,B,$,U){const K=this.tracked.get(B);if(K)return K.createRun($);const W=i.fromPublic(F,A,B,U),N=o(B);this.proxy.$startedExtensionTestRun({controllerId:F,profile:N&&{group:L[N.kind],id:N.profileId},exclude:B.exclude?.map(x=>f.TestId.fromExtHostTestItem(x,A.root.id).toString())??[],id:W.id,include:B.include?.map(x=>f.TestId.fromExtHostTestItem(x,A.root.id).toString())??[A.root.id],persist:U});const V=this.getTracker(B,W);return V.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),V.createRun($)}getTracker(F,A,B){const $=new d(A,this.proxy,B);return this.tracked.set(F,$),$.onEnd(()=>this.tracked.delete(F)),$}}e.TestRunCoordinator=r;const o=M=>{if(!!M.profile){if(!(M.profile instanceof S))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return M.profile}};class i{constructor(F,A,B,$,U,K){this.controllerId=F,this.id=A,this.isPersisted=U,this.colllection=K,this.includePrefix=B.map(W=>W+"\0"),this.excludePrefix=$.map(W=>W+"\0")}static fromPublic(F,A,B,$){return new i(F,(0,k.generateUuid)(),B.include?.map(U=>f.TestId.fromExtHostTestItem(U,F).toString())??[F],B.exclude?.map(U=>f.TestId.fromExtHostTestItem(U,F).toString())??[],$,A)}static fromInternal(F,A){return new i(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,A)}isIncluded(F){const A=f.TestId.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const B of this.excludePrefix)if(A===B||A.startsWith(B))return!1;for(const B of this.includePrefix)if(A===B||A.startsWith(B))return!0;return!1}}e.TestRunDto=i;class n{constructor(F,A,B){this.proxy=F,this.runId=A,this.taskId=B}set coverageProvider(F){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!F||(this._coverageProvider=F,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(F){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(F))());try{return(await this.fileCoverage)?.map(b.TestCoverage.fromFile)??[]}catch(A){throw this.fileCoverage=void 0,A}}async resolveFileCoverage(F,A){const B=await this.fileCoverage;let $=B?.[F];return!this._coverageProvider||!B||!$?[]:($.detailedCoverage||($=B[F]=await this._coverageProvider.resolveFileCoverage?.($,A)??$),$.detailedCoverage?.map(b.TestCoverage.fromDetailed)??[])}}class s extends v.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,b.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:A,removed:B}=this;return{get added(){return[...F].map($=>$.revived)},get updated(){return[...A].map($=>$.revived)},get removed(){return[...B].map($=>$.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends v.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,A){return{...F,revived:b.TestItem.toPlain(F.item),depth:A?A.depth+1:0,children:new Set}}createChangeCollector(){return new s(this.changeEmitter)}}e.MirroredTestCollection=l;class h{constructor(F){this.proxy=F}checkout(){this.current||(this.current=this.createObserverData());const F=this.current;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(A=>A.revived)},dispose:(0,y.once)(()=>{--F.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(F){return this.current?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.current?.tests.apply(F)}createObserverData(){const F=new l;return this.proxy.$subscribeToDiffs(),{observers:0,tests:F}}}class S{constructor(F,A,B,$,U,K,W,N=!1,V=void 0){this.controllerId=B,this.profileId=$,this._label=U,this.kind=K,this.runHandler=W,this._isDefault=N,this._tag=V,c.set(this,void 0),m.set(this,void 0),tt(this,c,F,"f"),tt(this,m,A,"f"),A.set($,this);const x=L[K];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Me(this,c,"f").$publishTestRunProfile({profileId:$,controllerId:B,tag:V?b.TestTag.namespace(this.controllerId,V.id):null,label:U,group:x,isDefault:N,hasConfigurationHandler:!1})}get label(){return this._label}set label(F){F!==this._label&&(this._label=F,Me(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:F}))}get isDefault(){return this._isDefault}set isDefault(F){F!==this._isDefault&&(this._isDefault=F,Me(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,Me(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:F?b.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(F){F!==this._configureHandler&&(this._configureHandler=F,Me(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!F}))}dispose(){Me(this,m,"f")?.delete(this.profileId)&&(tt(this,m,void 0,"f"),Me(this,c,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=S,c=new WeakMap,m=new WeakMap;const L={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(Ie[260],ke([1,0,16,3,5,133,15,7]),function(Y,e,u,t,D,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(R,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new t.Emitter,this._onDidChangeTextEditorOptions=new t.Emitter,this._onDidChangeTextEditorVisibleRanges=new t.Emitter,this._onDidChangeTextEditorViewColumn=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(_=>this._onDidChangeVisibleTextEditors.fire(_)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(_=>this._onDidChangeActiveTextEditor.fire(_))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const k=this._extHostDocumentsAndEditors.allEditors();return R?k:k.map(_=>_.value)}async showTextDocument(R,k,_){let T;typeof k=="number"?T={position:y.ViewColumn.from(k),preserveFocus:_}:typeof k=="object"?T={position:y.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?y.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:T={preserveFocus:!1};const w=await this._proxy.$tryShowTextDocument(R.uri,T),b=w&&this._extHostDocumentsAndEditors.getEditor(w);if(b)return b.value;throw w?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,k){return new P.TextEditorDecorationType(this._proxy,R,k).value}$acceptEditorPropertiesChanged(R,k){const _=this._extHostDocumentsAndEditors.getEditor(R);if(!_)throw new Error("unknown text editor");if(k.options&&_._acceptOptions(k.options),k.selections){const T=k.selections.selections.map(y.Selection.to);_._acceptSelections(T)}if(k.visibleRanges){const T=u.coalesce(k.visibleRanges.map(y.Range.to));_._acceptVisibleRanges(T)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:_.value,options:{...k.options,lineNumbers:y.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const T=C.TextEditorSelectionChangeKind.fromValue(k.selections.source),w=k.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:_.value,selections:w,kind:T})}if(k.visibleRanges){const T=u.coalesce(k.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:_.value,visibleRanges:T})}}$acceptEditorPositionData(R){for(const k in R){const _=this._extHostDocumentsAndEditors.getEditor(k);if(!_)throw new Error("Unknown text editor");const T=y.ViewColumn.to(R[k]);_.value.viewColumn!==T&&(_._acceptViewColumn(T),this._onDidChangeTextEditorViewColumn.fire({textEditor:_.value,viewColumn:T}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=E}),define(Ie[261],ke([1,0,2,4,5,6,7,15,10]),function(Y,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class I{constructor(_,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=_.getProxy(D.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===11){const b=w.uri===void 0?void 0:u.URI.revive(w.uri);return this._itemsBySourceAndUriMap.get(w.source)?.get(R(b))?.get(w.handle)}return w}})}async $getTimeline(_,T,w,b){return this._providers.get(_)?.provideTimeline(u.URI.revive(T),w,b)}registerTimelineProvider(_,T,w,b){const g=new P.DisposableStore,f=this.convertTimelineItem(T.id,b,g).bind(this);let p;T.onDidChange&&(p=T.onDidChange(c=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:T.id}),this));const v=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:_,onDidChange:void 0,async provideTimeline(c,m,a){m?.resetCache&&(g.clear(),v.get(T.id)?.clear());const d=await T.provideTimeline(c,m,a);if(d==null)return;const r=f(c,m);return{...d,source:T.id,items:d.items.map(r)}},dispose(){for(const c of v.values())c.get(T.id)?.clear();p?.dispose(),g.dispose()}})}convertTimelineItem(_,T,w){return(b,g)=>{let f;if(g?.cacheResults){let p=this._itemsBySourceAndUriMap.get(_);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(_,p));const v=R(b);f=p.get(v),f===void 0&&(f=new Map,p.set(v,f))}return p=>{const{iconPath:v,...c}=p,m=`${_}|${p.id??p.timestamp}`;f?.set(m,p);let a,d,r;p.iconPath&&(v instanceof y.ThemeIcon?r={id:v.id,color:v.color}:u.URI.isUri(v)?(a=v,d=v):{light:a,dark:d}=v);let o;return y.MarkdownString.isMarkdownString(c.tooltip)?o=C.MarkdownString.from(c.tooltip):(0,E.isString)(c.tooltip)?o=c.tooltip:y.MarkdownString.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=C.MarkdownString.from(c.detail)):(0,E.isString)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=c.detail),{...c,id:c.id??void 0,handle:m,source:_,command:p.command?T.toInternal(p.command,w):void 0,icon:a,iconDark:d,themeIcon:r,tooltip:o,accessibilityInformation:p.accessibilityInformation}}}}registerTimelineProviderCore(_){if(this._providers.get(_.id))throw new Error(`Timeline Provider ${_.id} already exists.`);return this._proxy.$registerTimelineProvider({id:_.id,label:_.label,scheme:_.scheme}),this._providers.set(_.id,_),(0,P.toDisposable)(()=>{for(const w of this._itemsBySourceAndUriMap.values())w.get(_.id)?.clear();this._providers.delete(_.id),this._proxy.$unregisterTimelineProvider(_.id),_.dispose()})}}e.ExtHostTimeline=I;function R(k){return k?.toString()}}),define(Ie[262],ke([1,0,6,11,2,5]),function(Y,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(E){this._openers=new Map,this._proxy=E.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,I,R,k){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const _=k.schemes.find(T=>!y.supportedSchemes.has(T));if(_)throw new Error(`Scheme '${_}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,R),this._proxy.$registerUriOpener(I,k.schemes,E,k.label),(0,u.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(E,I,R){const k=this._openers.get(E);if(!k)throw new Error(`Unknown opener with id: ${E}`);const _=D.URI.revive(I);return k.canOpenExternalUri(_,R)}async $openUri(E,I,R){const k=this._openers.get(E);if(!k)throw new Error(`Unknown opener id: '${E}'`);return k.openExternalUri(D.URI.revive(I.resolvedUri),{sourceUri:D.URI.revive(I.sourceUri)},R)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(Ie[263],ke([1,0,5,2,6,12,28]),function(Y,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(u.MainContext.MainThreadUrls)}registerUriHandler(I,R){if(this.handles.has(y.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const k=C.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(I)),this.handlers.set(k,R),this._proxy.$registerUriHandler(k,I),(0,D.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(I)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(I,R){const k=this.handlers.get(I);if(!k)return Promise.resolve(void 0);try{k.handleUri(t.URI.revive(R))}catch(_){(0,P.onUnexpectedError)(_)}return Promise.resolve(void 0)}async createAppUri(I){return t.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=C,C.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(Y,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Y,u):D?D.value=u:e.set(Y,u),u},Me=this&&this.__classPrivateFieldGet||function(Y,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!t:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Y):t?t.value:e.get(Y)};define(Ie[70],ke([1,0,3,11,2,189,209,88,5]),function(Y,e,u,t,D,P,y,C,E){"use strict";var I,R,k,_,T,w,b,g,f,p,v,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(l,h,S,L,M,F,A){I.set(this,void 0),R.set(this,void 0),k.set(this,void 0),_.set(this,void 0),T.set(this,void 0),w.set(this,void 0),b.set(this,""),g.set(this,void 0),f.set(this,!1),p.set(this,!1),v.set(this,!1),this._onMessageEmitter=new u.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new u.Emitter),this._onDidDispose=Me(this,c,"f").event,tt(this,I,l,"f"),tt(this,R,h,"f"),tt(this,g,S,"f"),tt(this,_,L,"f"),tt(this,T,M,"f"),tt(this,w,F,"f"),tt(this,v,a(F),"f"),tt(this,k,A,"f")}dispose(){tt(this,f,!0,"f"),Me(this,c,"f").fire(),Me(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(l){return tt(this,p,!0,"f"),(0,C.asWebviewUri)(l,Me(this,_,"f"))}get cspSource(){const l=Me(this,w,"f").extensionLocation;if(l.scheme===t.Schemas.https||l.scheme===t.Schemas.http){let h=l.toString();return h.endsWith("/")||(h+="/"),h+" "+C.webviewGenericCspSource}return C.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Me(this,b,"f")}set html(l){this.assertNotDisposed(),Me(this,b,"f")!==l&&(tt(this,b,l,"f"),!Me(this,p,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(l)&&(tt(this,p,!0,"f"),Me(this,k,"f").report("Webview vscode-resource: uris",Me(this,w,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,R,"f").$setHtml(Me(this,I,"f"),l))}get options(){return this.assertNotDisposed(),Me(this,g,"f")}set options(l){this.assertNotDisposed(),Me(this,R,"f").$setOptions(Me(this,I,"f"),o(Me(this,w,"f"),Me(this,T,"f"),l)),tt(this,g,l,"f")}async postMessage(l){if(Me(this,f,"f"))return!1;const h=(0,y.serializeWebviewMessage)(l,{serializeBuffersForPostMessage:Me(this,v,"f")});return Me(this,R,"f").$postMessage(Me(this,I,"f"),h.message,...h.buffers)}assertNotDisposed(){if(Me(this,f,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,I=new WeakMap,R=new WeakMap,k=new WeakMap,_=new WeakMap,T=new WeakMap,w=new WeakMap,b=new WeakMap,g=new WeakMap,f=new WeakMap,p=new WeakMap,v=new WeakMap,c=new WeakMap;function a(s){try{const l=(0,P.normalizeVersion)((0,P.parseVersion)(s.engines.vscode));return!!l&&l.majorBase>=1&&l.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class d{constructor(l,h,S,L,M){this.remoteInfo=h,this.workspace=S,this._logService=L,this._deprecationService=M,this._webviews=new Map,this._webviewProxy=l.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(l,h,S){const L=this.getWebview(l);if(L){const{message:M}=(0,y.deserializeWebviewMessage)(h,S.value);L._onMessageEmitter.fire(M)}}$onMissingCsp(l,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(l,h,S){const L=new m(l,this._webviewProxy,i(h),this.remoteInfo,this.workspace,S,this._deprecationService);return this._webviews.set(l,L),L._onDidDispose(()=>{this._webviews.delete(l)}),L}deleteWebview(l){this._webviews.delete(l)}getWebview(l){return this._webviews.get(l)}}e.ExtHostWebviews=d;function r(s){return{id:s.identifier,location:s.extensionLocation}}e.toExtensionData=r;function o(s,l,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(s,l)}}e.serializeWebviewOptions=o;function i(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(l=>D.URI.from(l))}}e.reviveOptions=i;function n(s,l){return[...(l?.getWorkspaceFolders()||[]).map(h=>h.uri),s.extensionLocation]}}),define(Ie[264],ke([1,0,21,60,6,11,22,2,15,70,87,5,7]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(a,d){this.document=a,this._storagePath=d,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,d){await this.getEdit(a).undo(),d||this.disposeBackup()}async redo(a,d){await this.getEdit(a).redo(),d||this.disposeBackup()}disposeEdits(a){for(const d of a)this._edits.delete(d)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=c(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const d=this._edits.get(a,0);if(!d)throw new Error("No edit found");return d}}class w{constructor(){this._documents=new Map}get(a,d){return this._documents.get(this.key(a,d))}add(a,d,r){const o=this.key(a,d.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${a} resource:${d.uri}`);const i=new T(d,r);return this._documents.set(o,i),i}delete(a,d){const r=this.key(a,d.uri);this._documents.delete(r)}key(a,d){return`${a}@@@${d}`}}var b;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(b||(b={}));class g{constructor(){this._providers=new Map}addTextProvider(a,d,r){return this.add(0,a,d,r)}addCustomProvider(a,d,r){return this.add(1,a,d,r)}get(a){return this._providers.get(a)}add(a,d,r,o){if(this._providers.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this._providers.set(d,{type:a,extension:r,provider:o}),new _.Disposable(()=>this._providers.delete(d))}}class f{constructor(a,d,r,o,i){this._extHostDocuments=d,this._extensionStoragePaths=r,this._extHostWebview=o,this._extHostWebviewPanels=i,this._editorProviders=new g,this._documents=new w,this._proxy=a.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,d,r,o){const i=new D.DisposableStore;return p(r)?(i.add(this._editorProviders.addTextProvider(d,a,r)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(a),d,o.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(a))):(i.add(this._editorProviders.addCustomProvider(d,a,r)),this.supportEditing(r)&&i.add(r.onDidChangeCustomDocument(n=>{const s=this.getCustomDocumentEntry(d,n.document.uri);if(v(n)){const l=s.addEdit(n);this._proxy.$onDidEdit(n.document.uri,d,l,n.label)}else this._proxy.$onContentChange(n.document.uri,d)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(a),d,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(a))),_.Disposable.from(i,new _.Disposable(()=>{this._proxy.$unregisterEditorProvider(d)}))}async $createCustomDocument(a,d,r,o,i){const n=this._editorProviders.get(d);if(!n)throw new Error(`No provider found for '${d}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${d}'`);const s=C.URI.revive(a),l=await n.provider.openCustomDocument(s,{backupId:r,untitledDocumentData:o?.buffer},i);let h;return this.supportEditing(n.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension)),this._documents.add(d,l,h),{editable:this.supportEditing(n.provider)}}async $disposeCustomDocument(a,d){const r=this._editorProviders.get(d);if(!r)throw new Error(`No provider found for '${d}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${d}'`);const o=C.URI.revive(a),{document:i}=this.getCustomDocumentEntry(d,o);this._documents.delete(d,i),i.dispose()}async $resolveWebviewEditor(a,d,r,o,i,n){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);const l=E.ViewColumn.to(i),h=this._extHostWebview.createNewWebview(d,o.webviewOptions,s.extension),S=this._extHostWebviewPanels.createNewWebviewPanel(d,r,o.title,l,o.panelOptions,h,!0),L=C.URI.revive(a);switch(s.type){case 1:{const{document:M}=this.getCustomDocumentEntry(r,L);return s.provider.resolveCustomEditor(M,S,n)}case 0:{const M=this._extHostDocuments.getDocument(L);return s.provider.resolveCustomTextEditor(M,S,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,d,r){this.getCustomDocumentEntry(d,a).disposeEdits(r)}async $onMoveCustomEditor(a,d,r){const o=this._editorProviders.get(r);if(!o)throw new Error(`No provider found for '${r}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const i=this._extHostWebviewPanels.getWebviewPanel(a);if(!i)throw new Error("No webview found");const n=C.URI.revive(d),s=this._extHostDocuments.getDocument(n);await o.provider.moveCustomTextEditor(s,i,u.CancellationToken.None)}async $undo(a,d,r,o){return this.getCustomDocumentEntry(d,a).undo(r,o)}async $redo(a,d,r,o){return this.getCustomDocumentEntry(d,a).redo(r,o)}async $revert(a,d,r){const o=this.getCustomDocumentEntry(d,a);await this.getCustomEditorProvider(d).revertCustomDocument(o.document,r),o.disposeBackup()}async $onSave(a,d,r){const o=this.getCustomDocumentEntry(d,a);await this.getCustomEditorProvider(d).saveCustomDocument(o.document,r),o.disposeBackup()}async $onSaveAs(a,d,r,o){const i=this.getCustomDocumentEntry(d,a);return this.getCustomEditorProvider(d).saveCustomDocumentAs(i.document,C.URI.revive(r),o)}async $backup(a,d,r){const o=this.getCustomDocumentEntry(d,a),n=await this.getCustomEditorProvider(d).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},r);return o.updateBackup(n),n.id}getCustomDocumentEntry(a,d){const r=this._documents.get(a,C.URI.revive(d));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(a){const r=this._editorProviders.get(a)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=f;function p(m){return typeof m.resolveCustomTextEditor=="function"}function v(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function c(m){const a=m.scheme===P.Schemas.file||m.scheme===P.Schemas.untitled?m.fsPath:m.toString();return(0,t.hash)(a)+""}});var tt=this&&this.__classPrivateFieldSet||function(Y,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Y,u):D?D.value=u:e.set(Y,u),u},Me=this&&this.__classPrivateFieldGet||function(Y,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!t:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Y):t?t.value:e.get(Y)};define(Ie[265],ke([1,0,3,6,2,34,15,70,5,7]),function(Y,e,u,t,D,P,y,C,E,I){"use strict";var R,k,_,T,w,b,g,f,p,v,c,m,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends t.Disposable{constructor(n,s,l,h){super();R.set(this,void 0),k.set(this,void 0),_.set(this,void 0),T.set(this,void 0),w.set(this,void 0),b.set(this,void 0),g.set(this,void 0),f.set(this,void 0),p.set(this,!0),v.set(this,void 0),c.set(this,!1),m.set(this,this._register(new u.Emitter)),this.onDidDispose=Me(this,m,"f").event,a.set(this,this._register(new u.Emitter)),this.onDidChangeViewState=Me(this,a,"f").event,tt(this,R,n,"f"),tt(this,k,s,"f"),tt(this,T,l,"f"),tt(this,_,h.viewType,"f"),tt(this,w,h.panelOptions,"f"),tt(this,f,h.viewColumn,"f"),tt(this,b,h.title,"f"),tt(this,v,h.active,"f")}dispose(){Me(this,c,"f")||(tt(this,c,!0,"f"),Me(this,m,"f").fire(),Me(this,k,"f").$disposeWebview(Me(this,R,"f")),Me(this,T,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Me(this,T,"f")}get viewType(){return this.assertNotDisposed(),Me(this,_,"f")}get title(){return this.assertNotDisposed(),Me(this,b,"f")}set title(n){this.assertNotDisposed(),Me(this,b,"f")!==n&&(tt(this,b,n,"f"),Me(this,k,"f").$setTitle(Me(this,R,"f"),n))}get iconPath(){return this.assertNotDisposed(),Me(this,g,"f")}set iconPath(n){this.assertNotDisposed(),Me(this,g,"f")!==n&&(tt(this,g,n,"f"),Me(this,k,"f").$setIconPath(Me(this,R,"f"),D.URI.isUri(n)?{light:n,dark:n}:n))}get options(){return Me(this,w,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Me(this,f,"f")=="number"&&Me(this,f,"f")<0))return Me(this,f,"f")}get active(){return this.assertNotDisposed(),Me(this,v,"f")}get visible(){return this.assertNotDisposed(),Me(this,p,"f")}_updateViewState(n){Me(this,c,"f")||(this.active!==n.active||this.visible!==n.visible||this.viewColumn!==n.viewColumn)&&(tt(this,v,n.active,"f"),tt(this,p,n.visible,"f"),tt(this,f,n.viewColumn,"f"),Me(this,a,"f").fire({webviewPanel:this}))}reveal(n,s){this.assertNotDisposed(),Me(this,k,"f").$reveal(Me(this,R,"f"),{viewColumn:typeof n=="undefined"?void 0:y.ViewColumn.from(n),preserveFocus:!!s})}assertNotDisposed(){if(Me(this,c,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,k=new WeakMap,_=new WeakMap,T=new WeakMap,w=new WeakMap,b=new WeakMap,g=new WeakMap,f=new WeakMap,p=new WeakMap,v=new WeakMap,c=new WeakMap,m=new WeakMap,a=new WeakMap;class r{constructor(n,s,l){this.webviews=s,this.workspace=l,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=n.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(n,s,l,h,S={}){const L=typeof h=="object"?h.viewColumn:h,M={viewColumn:y.ViewColumn.from(L),preserveFocus:typeof h=="object"&&!!h.preserveFocus},F=(0,C.shouldSerializeBuffersForPostMessage)(n),A=r.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(n),A,s,{title:l,panelOptions:o(S),webviewOptions:(0,C.serializeWebviewOptions)(n,this.workspace,S),serializeBuffersForPostMessage:F},M);const B=this.webviews.createNewWebview(A,S,n);return this.createNewWebviewPanel(A,s,l,L,S,B,!0)}$onDidChangeWebviewPanelViewStates(n){const s=Object.keys(n);s.sort((l,h)=>{const S=n[l],L=n[h];return S.active?1:L.active?-1:+S.visible-+L.visible});for(const l of s){const h=this.getWebviewPanel(l);if(!h)continue;const S=n[l];h._updateViewState({active:S.active,visible:S.visible,viewColumn:y.ViewColumn.to(S.position)})}}async $onDidDisposeWebviewPanel(n){this.getWebviewPanel(n)?.dispose(),this._webviewPanels.delete(n),this.webviews.deleteWebview(n)}registerWebviewPanelSerializer(n,s,l){if(this._serializers.has(s))throw new Error(`Serializer for '${s}' already registered`);return this._serializers.set(s,{serializer:l,extension:n}),this._proxy.$registerSerializer(s,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(n)}),new I.Disposable(()=>{this._serializers.delete(s),this._proxy.$unregisterSerializer(s)})}async $deserializeWebviewPanel(n,s,l,h){const S=this._serializers.get(s);if(!S)throw new Error(`No serializer found for '${s}'`);const{serializer:L,extension:M}=S,F=this.webviews.createNewWebview(n,l.webviewOptions,M),A=this.createNewWebviewPanel(n,s,l.title,h,l.panelOptions,F,l.active);await L.deserializeWebviewPanel(A,l.state)}createNewWebviewPanel(n,s,l,h,S,L,M){const F=new d(n,this._proxy,L,{viewType:s,title:l,viewColumn:h,panelOptions:S,active:M});return this._webviewPanels.set(n,F),F}getWebviewPanel(n){return this._webviewPanels.get(n)}}e.ExtHostWebviewPanels=r;function o(i){return{enableFindWidget:i.enableFindWidget,retainContextWhenHidden:i.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(Y,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Y,u):D?D.value=u:e.set(Y,u),u},Me=this&&this.__classPrivateFieldGet||function(Y,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!t:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Y):t?t.value:e.get(Y)};define(Ie[266],ke([1,0,3,6,70,27,15,5,7]),function(Y,e,u,t,D,P,y,C,E){"use strict";var I,R,k,_,T,w,b,g,f,p,v,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends t.Disposable{constructor(r,o,i,n,s,l,h){super();I.set(this,void 0),R.set(this,void 0),k.set(this,void 0),_.set(this,void 0),T.set(this,void 0),w.set(this,!1),b.set(this,void 0),g.set(this,void 0),f.set(this,void 0),p.set(this,void 0),v.set(this,this._register(new u.Emitter)),this.onDidChangeVisibility=Me(this,v,"f").event,c.set(this,this._register(new u.Emitter)),this.onDidDispose=Me(this,c,"f").event,tt(this,k,i,"f"),tt(this,g,n,"f"),tt(this,I,r,"f"),tt(this,R,o,"f"),tt(this,_,s,"f"),tt(this,T,l,"f"),tt(this,b,h,"f")}dispose(){Me(this,w,"f")||(tt(this,w,!0,"f"),Me(this,c,"f").fire(),Me(this,_,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Me(this,g,"f")}set title(r){this.assertNotDisposed(),Me(this,g,"f")!==r&&(tt(this,g,r,"f"),Me(this,R,"f").$setWebviewViewTitle(Me(this,I,"f"),r))}get description(){return this.assertNotDisposed(),Me(this,f,"f")}set description(r){this.assertNotDisposed(),Me(this,f,"f")!==r&&(tt(this,f,r,"f"),Me(this,R,"f").$setWebviewViewDescription(Me(this,I,"f"),r))}get visible(){return Me(this,b,"f")}get webview(){return Me(this,_,"f")}get viewType(){return Me(this,k,"f")}_setVisible(r){r===Me(this,b,"f")||Me(this,w,"f")||(tt(this,b,r,"f"),Me(this,v,"f").fire())}get badge(){return this.assertNotDisposed(),(0,P.checkProposedApiEnabled)(Me(this,T,"f"),"badges"),Me(this,p,"f")}set badge(r){this.assertNotDisposed(),(0,P.checkProposedApiEnabled)(Me(this,T,"f"),"badges"),!(r?.value===Me(this,p,"f")?.value&&r?.tooltip===Me(this,p,"f")?.tooltip)&&(tt(this,p,y.ViewBadge.from(r),"f"),Me(this,R,"f").$setWebviewViewBadge(Me(this,I,"f"),r))}show(r){this.assertNotDisposed(),Me(this,R,"f").$show(Me(this,I,"f"),!!r)}assertNotDisposed(){if(Me(this,w,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,R=new WeakMap,k=new WeakMap,_=new WeakMap,T=new WeakMap,w=new WeakMap,b=new WeakMap,g=new WeakMap,f=new WeakMap,p=new WeakMap,v=new WeakMap,c=new WeakMap;class a{constructor(r,o){this._extHostWebview=o,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,o,i,n){if(this._viewProviders.has(o))throw new Error(`View provider for '${o}' already registered`);return this._viewProviders.set(o,{provider:i,extension:r}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(r),o,{retainContextWhenHidden:n?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(r)}),new E.Disposable(()=>{this._viewProviders.delete(o),this._proxy.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(r,o,i,n,s){const l=this._viewProviders.get(o);if(!l)throw new Error(`No view provider found for '${o}'`);const{provider:h,extension:S}=l,L=this._extHostWebview.createNewWebview(r,{},S),M=new m(r,this._proxy,o,i,L,S,!0);this._webviewViews.set(r,M),await h.resolveWebviewView(M,{state:n},s)}async $onDidChangeWebviewViewVisibility(r,o){this.getWebviewView(r)._setVisible(o)}async $disposeWebviewView(r){const o=this.getWebviewView(r);this._webviewViews.delete(r),o.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const o=this._webviewViews.get(r);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=a}),define(Ie[137],ke([1,0,3,5,2,11,8,4,17]),function(Y,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class Yn{constructor(k){this._onDidChangeWindowState=new u.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Yn.InitialState,this._proxy=k.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(_=>this.$onDidChangeWindowFocus(_))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state={...this._state,focused:k},this._onDidChangeWindowState.fire(this._state))}openUri(k,_){let T;if(typeof k=="string"){T=k;try{k=D.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,y.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,T,_)}async asExternalUri(k,_){if((0,y.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this._proxy.$asExternalUri(k,_);return D.URI.from(T)}};I.InitialState={focused:!0},I=Ge([xe(0,E.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(Ie[267],ke([1,0,112,268,62,37,2,14,45]),function(Y,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(_,T,w){this._commands=_,this.logService=T,this._ipcHandlePath=w,this._server=t.createServer((b,g)=>this.onRequest(b,g)),this.setup().catch(b=>(T.error(b),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",_=>this.logService.error(_))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(_,T){const w=(g,f)=>{T.writeHead(g,{"content-type":"application/json"}),T.end(JSON.stringify(f||null),p=>p&&this.logService.error(p))},b=[];_.setEncoding("utf8"),_.on("data",g=>b.push(g)),_.on("end",async()=>{try{const g=JSON.parse(b.join(""));let f;switch(g.type){case"open":f=await this.open(g);break;case"openExternal":f=await this.openExternal(g);break;case"status":f=await this.getStatus(g);break;case"extensionManagement":f=await this.manageExtensions(g);break;default:w(404,`Unknown message type: ${g.type}`);break}w(200,f)}catch(g){const f=g instanceof Error?g.message:JSON.stringify(g);w(500,f),this.logService.error("Error while processing pipe request",g)}})}async open(_){const{fileURIs:T,folderURIs:w,forceNewWindow:b,diffMode:g,mergeMode:f,addMode:p,forceReuseWindow:v,gotoLineMode:c,waitMarkerFilePath:m,remoteAuthority:a}=_,d=[];if(Array.isArray(w))for(const n of w)try{d.push({folderUri:y.URI.parse(n)})}catch{}if(Array.isArray(T))for(const n of T)try{(0,E.hasWorkspaceFileExtension)(n)?d.push({workspaceUri:y.URI.parse(n)}):d.push({fileUri:y.URI.parse(n)})}catch{}const r=m?y.URI.file(m):void 0,i={forceNewWindow:b,diffMode:g,mergeMode:f,addMode:p,gotoLineMode:c,forceReuseWindow:v,preferNewWindow:!v&&!r&&!p,waitMarkerFileURI:r,remoteAuthority:a};return this._commands.executeCommand("_remoteCLI.windowOpen",d,i),""}async openExternal(_){for(const T of _.uris){const w=y.URI.parse(T),b=w.scheme==="file"?w:T;await this._commands.executeCommand("_remoteCLI.openExternal",b)}}async manageExtensions(_){const T=b=>b?.map(g=>/\.vsix$/i.test(g)?y.URI.parse(g):g),w={list:_.list,install:T(_.install),uninstall:T(_.uninstall),force:_.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",w)}async getStatus(_){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=I;let R=class extends I{constructor(_,T){super(_,T,(0,u.createRandomIPCHandle)())}};R=Ge([xe(0,P.IExtHostCommands),xe(1,C.ILogService)],R),e.CLIServer=R}),define(Ie[269],ke([1,0,241,26,17]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const P=1024*1024;let y=class extends u.AbstractExtHostConsoleForwarder{constructor(E,I){super(E,I);this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(E,I,R){const k=E==="error"||E==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,k.write(`
START_NATIVE_LOG
`),I.apply(console,R),k.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(E,I){const R=process[E],k=R.write;let _="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(T,w,b)=>{if(!this._isMakingConsoleCall){_+=T.toString(w);const g=_.length>P?_.length:_.lastIndexOf(`
`);g!==-1&&(console[I](_.slice(0,g)),_=_.slice(g+1))}k.call(R,T,w,b)}})}};y=Ge([xe(0,D.IExtHostRpcService),xe(1,t.IExtHostInitDataService)],y),e.ExtHostConsoleForwarder=y}),define(Ie[270],ke([1,0,9,81,34,37,6,5,2,17]),function(Y,e,u,t,D,P,y,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends y.Disposable{constructor(_,T){super();const w=_.getProxy(C.MainContext.MainThreadDownloadService);T.registerCommand(!1,"_workbench.downloadResource",async b=>{const g=E.URI.file((0,u.join)((0,t.tmpdir)(),(0,D.generateUuid)()));return await w.$download(b,g),g})}};R=Ge([xe(0,I.IExtHostRpcService),xe(1,P.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(Ie[271],ke([1,0,136,11,195,34]),function(Y,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class y extends u.ExtHostLoggerService{doCreateLogger(E,I,R){return E.scheme===t.Schemas.file?new D.SpdLogLogger(R?.name||(0,P.generateUuid)(),E.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,I):super.doCreateLogger(E,I,R)}}e.ExtHostLoggerService=y}),define(Ie[272],ke([1,0,62,9,2,69,6,11,18,29]),function(Y,e,u,t,D,P,y,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends P.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(a){const d=await super._getWorkspaceStorageURI(a);if(d.scheme!==C.Schemas.file)return d;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${d.fsPath}.`),d;const r=d.fsPath;let o=0;do{let i;o===0?i=r:i=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${o}`:`${r}-${o}`,await k(i);const n=t.join(i,"vscode.lock"),s=await b(this._logService,n,!1);if(s)return this._workspaceStorageLock=s,process.on("exit",()=>{s.dispose()}),D.URI.file(i);o++}while(o<10);return d}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function k(m){try{await I.Promises.stat(m);return}catch{}try{await I.Promises.mkdir(m,{recursive:!0})}catch{}}const _=1e3,T=10*60*1e3;class w extends y.Disposable{constructor(a,d){super();this.logService=a,this.filename=d,this._timer=this._register(new E.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await g(a,d);(!r||r.pid!==process.pid)&&(a.info(`Lock '${d}': The lock was lost unexpectedly.`),this._timer.cancel());try{await I.Promises.utimes(d,new Date,new Date)}catch(o){a.error(o),a.info(`Lock '${d}': Could not update mtime.`)}},_)}dispose(){super.dispose();try{u.unlinkSync(this.filename)}catch{}}async setWillRelease(a){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${a} ms.`);try{const d={pid:process.pid,willReleaseAt:Date.now()+a};await I.Promises.writeFile(this.filename,JSON.stringify(d),{flag:"w"})}catch(d){this.logService.error(d)}}}async function b(m,a,d){try{const o={pid:process.pid,willReleaseAt:0};await I.Promises.writeFile(a,JSON.stringify(o),{flag:"wx"})}catch(o){m.error(o)}const r=await g(m,a);return!r||r.pid!==process.pid?d?(m.info(`Lock '${a}': Could not acquire lock, giving up.`),null):(m.info(`Lock '${a}': Could not acquire lock, checking if the file is stale.`),v(m,a)):(m.info(`Lock '${a}': Lock acquired.`),new w(m,a))}async function g(m,a){let d;try{d=await I.Promises.readFile(a)}catch(r){return m.error(r),null}try{return JSON.parse(String(d))}catch(r){return m.error(r),null}}async function f(m,a){let d;try{d=await I.Promises.stat(a)}catch(r){return m.error(r),0}return d.mtime.getTime()}function p(m){try{return process.kill(m,0),!0}catch{return!1}}async function v(m,a){const d=await g(m,a);if(!d)return m.info(`Lock '${a}': Could not read pid of lock holder.`),c(m,a);if(d.willReleaseAt){let s=d.willReleaseAt-Date.now();if(s<5e3){for(s>0?m.info(`Lock '${a}': The lockfile is scheduled to be released in ${s} ms.`):m.info(`Lock '${a}': The lockfile is scheduled to have been released.`);s>0;){if(await(0,E.timeout)(Math.min(100,s)),await f(m,a)===0)return c(m,a);s=d.willReleaseAt-Date.now()}return c(m,a)}}if(!p(d.pid))return m.info(`Lock '${a}': The pid ${d.pid} appears to be gone.`),c(m,a);const r=await f(m,a),o=Date.now()-r;if(o<=T)return m.info(`Lock '${a}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null;m.info(`Lock '${a}': The lock looks stale, waiting for 2s.`),await(0,E.timeout)(2e3);const i=await f(m,a),n=Date.now()-i;return n<=T?(m.info(`Lock '${a}': The lock does not look stale, elapsed: ${n} ms, giving up.`),null):(m.info(`Lock '${a}': The lock looks stale even after waiting for 2s.`),c(m,a))}async function c(m,a){m.info(`Lock '${a}': Deleting a stale lock.`);try{await I.Promises.unlink(a)}catch{}return b(m,a,!0)}}),define(Ie[273],ke([1,0,34,17,38]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let P=class extends D.BaseExtHostTerminalService{constructor(C){super(!0,C)}createTerminal(C,E,I){return this.createTerminalFromOptions({name:C,shellPath:E,shellArgs:I})}createTerminalFromOptions(C,E){const I=new D.ExtHostTerminal(this._proxy,(0,u.generateUuid)(),C,C.name);return this._terminals.push(I),I.create(C,this._serializeParentTerminal(C,E)),I.value}};P=Ge([xe(0,t.IExtHostRpcService)],P),e.ExtHostTerminalService=P}),define(Ie[274],ke([1,0,5,17,178,6,26,2,42,22,29,7,13,52,3,124,94,14]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class p extends b.DisposableTunnel{}function v(s){const l=s.trim().split(`
`),h=[];return l.forEach(L=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(L);M&&M.length>=3&&h.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),h.reduce((L,M)=>(L[M.socket]=M,L),{})}e.getSockets=v;function c(...s){const l=[].concat(...s.map(a));return[...new Map(l.filter(h=>h.st==="0A").map(h=>{const S=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:m(S[0]),port:parseInt(S[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=c;function m(s){let l="";if(s.length===8)for(let h=s.length-2;h>=0;h-=2)l+=parseInt(s.substr(h,2),16),h!==0&&(l+=".");else for(let h=s.length-4;h>=0;h-=4)l+=parseInt(s.substr(h,4),16).toString(16),h!==0&&(l+=":");return l}e.parseIpAddress=m;function a(s){const l=s.trim().split(`
`),h=l.shift().trim().split(/\s+/).filter(L=>L!=="rx_queue"&&L!=="tm->when");return l.map(L=>L.trim().split(/\s+/).reduce((M,F,A)=>(M[h[A]||A]=F,M),{}))}e.loadConnectionTable=a;function d(s){return!!s.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||s.indexOf("out/server-main.js")!==-1||s.indexOf("_productName=VSCode")!==-1}function r(s){const l=s.trim().split(`
`),h=[];return l.forEach(S=>{const L=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(S);L&&L.length>=4&&h.push({pid:parseInt(L[1],10),ppid:parseInt(L[2]),cmd:L[3]})}),h}e.getRootProcesses=r;async function o(s,l,h){const S=h.reduce((M,F)=>(M[F.pid]=F,M),{}),L=[];return s.forEach(({socket:M,ip:F,port:A})=>{const B=l[M]?l[M].pid:void 0,$=B?S[B]?.cmd:void 0;B&&$&&!d($)&&L.push({host:F,port:A,detail:$,pid:B})}),L}e.findPorts=o;function i(s,l,h){const S=new Map,L=r(l);for(const M of s){const F=h.get(M.port);if(F){S.set(M.port,F);continue}const A=L.find(B=>B.cmd.includes(`${M.port}`));if(A){let B=A,$;do $=L.find(U=>U.ppid===B.pid),$&&(B=$);while($);S.set(M.port,{host:M.ip,port:M.port,pid:B.pid,detail:B.cmd,ppid:B.ppid})}else S.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return S}e.tryFindRootPorts=i;let n=class extends P.Disposable{constructor(l,h,S){super();this.logService=S,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new w.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=l.getProxy(u.MainContext.MainThreadTunnelService),_.isLinux&&h.remote.isRemote&&h.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(l,h){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${l.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const S=await this._proxy.$openTunnel(h,l.displayName);if(S){const L=new p(S.remoteAddress,S.localAddress,()=>this._proxy.$closeTunnel(S.remoteAddress));return this._register(L),L}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(l){return Math.max(l*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(l,h){const S=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(S,{selector:l,provider:h}),this._proxy.$registerPortsAttributesProvider(l,S),new k.Disposable(()=>{this._portAttributesProviders.delete(S),this._proxy.$unregisterPortsAttributesProvider(S)})}async $providePortAttributes(l,h,S,L,M){const F=[];for(const B of l){const $=this._portAttributesProviders.get(B);if(!$)return[];F.push(...await Promise.all(h.map(async U=>$.provider.providePortAttributes(U,S,L,M))))}const A=F.filter(B=>!!B);return A.length>0?A.map(B=>({autoForwardAction:B.autoForwardAction,port:B.port})):[]}async $registerCandidateFinder(l){if(l&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=l;const h=new g.MovingAverage;let S;for(;this._candidateFindingEnabled;){const L=new Date().getTime(),M=(await this.findCandidatePorts()).filter(A=>(0,b.isLocalhost)(A.host)||(0,b.isAllInterfaces)(A.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(A=>A.port).join(", ")}`);const F=new Date().getTime()-L;h.update(F),(!S||JSON.stringify(S)!==JSON.stringify(M))&&(S=M,await this._proxy.$onFoundNewCandidates(S)),await new Promise(A=>setTimeout(()=>A(),this.calculateDelay(h.value)))}}async setTunnelFactory(l){if(l){if(l.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(l.candidatePortSource),l.showCandidatePort&&(this._showCandidatePort=l.showCandidatePort,this._proxy.$setCandidateFilter()),l.tunnelFactory){this._forwardPortProvider=l.tunnelFactory;let h=l.tunnelFeatures?.privacyOptions??[];l.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:D.localize(0,null),themeIcon:"lock"},{id:"public",label:D.localize(1,null),themeIcon:"eye"}]);const S=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,public:!!l.tunnelFeatures?.public,privacyOptions:h}:void 0;this._proxy.$setTunnelProvider(S)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(l,h){if(this._extensionTunnels.has(l.host)){const S=this._extensionTunnels.get(l.host);S.has(l.port)&&(h&&S.get(l.port).disposeListener.dispose(),await S.get(l.port).tunnel.dispose(),S.delete(l.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(l,h){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const S=this._forwardPortProvider(l,h);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),S!==void 0){const L=await S;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(l.remoteAddress.host)||this._extensionTunnels.set(l.remoteAddress.host,new Map);const M=this._register(L.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(L.remoteAddress))));return this._extensionTunnels.get(l.remoteAddress.host).set(l.remoteAddress.port,{tunnel:L,disposeListener:M}),T.TunnelDtoConverter.fromApiTunnel(L)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(l){const h=await Promise.all(l.map(L=>this._showCandidatePort(L.host,L.port,L.detail??""))),S=l.filter((L,M)=>h[M]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${l.map(L=>L.port).join(", ")} to ${S.map(L=>L.port).join(", ")}`),S}async findCandidatePorts(){let l="",h="";try{l=await R.Promises.readFile("/proc/net/tcp","utf8"),h=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const S=c(l,h),L=await new Promise(W=>{(0,E.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(N,V,x)=>{W(V)})}),M=v(L),F=await R.Promises.readdir("/proc"),A=[];for(const W of F)try{const N=Number(W),V=I.joinPath(C.URI.file("/proc"),W);if((await R.Promises.stat(V.fsPath)).isDirectory()&&!isNaN(N)){const q=await R.Promises.readlink(I.joinPath(V,"cwd").fsPath),te=await R.Promises.readFile(I.joinPath(V,"cmdline").fsPath,"utf8");A.push({pid:N,cwd:q,cmd:te})}}catch{}const B=[],$=S.filter(W=>{const N=M[W.socket];return N||B.push(W),N}),U=o($,M,A);let K;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${B.length}`),B.length>0){const W=await new Promise(N=>{(0,E.exec)("ps -F -A -l | grep root",(V,x,q)=>{N(x)})});this._foundRootPorts=i(B,W,this._foundRootPorts),K=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${K.join(", ")}`)}return U.then(W=>K?W.concat(K):W)}};n=Ge([xe(0,t.IExtHostRpcService),xe(1,y.IExtHostInitDataService),xe(2,f.ILogService)],n),e.ExtHostTunnelService=n}),define(Ie[275],ke([1,0,18,23,21,12,3,6,108,235,53]),function(Y,e,u,t,D,P,y,C,E,I,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function _(S,L){try{return JSON.stringify(S,L)}catch{return"null"}}const T="$$ref$$",w={[T]:-1};class b{constructor(L,M){this.jsonString=L,this.referencedBuffers=M}}function g(S,L=null,M=!1){const F=[];return{jsonString:(M?_:JSON.stringify)(S,(B,$)=>{if(typeof $=="undefined")return w;if(typeof $=="object"){if($ instanceof t.VSBuffer){const U=F.push($)-1;return{[T]:U}}if(L)return L(B,$)}return $}),referencedBuffers:F}}e.stringifyJsonWithBufferRefs=g;function f(S,L,M){return JSON.parse(S,(F,A)=>{if(A){const B=A[T];if(typeof B=="number")return L[B];if(M&&A.$mid===1)return M.transformIncoming(A)}return A})}e.parseJsonAndRestoreBufferRefs=f;function p(S,L){return JSON.stringify(S,L)}function v(S){return S?(L,M)=>M&&M.$mid===1?S.transformOutgoing(M):M:null}var c;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var m;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(m=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},d=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class o extends C.Disposable{constructor(L,M=null,F=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=L,this._logger=M,this._uriTransformer=F,this._uriReplacer=v(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let A=0,B=R.ProxyIdentifier.count;A<B;A++)this._locals[A]=null,this._proxies[A]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new u.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(A=>this._receiveOneMessage(A))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(L=>{this._pendingRPCReplies[L].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(L){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(L){this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(L){this._responsiveState!==L&&(this._responsiveState=L,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(L){return this._uriTransformer?(0,E.transformIncomingURIs)(L,this._uriTransformer):L}getProxy(L){const{nid:M,sid:F}=L;return this._proxies[M]||(this._proxies[M]=this._createProxy(M,F)),this._proxies[M]}_createProxy(L,M){const F={get:(A,B)=>(typeof B=="string"&&!A[B]&&B.charCodeAt(0)===36&&(A[B]=(...$)=>this._remoteCall(L,B,$)),B===r?M:A[B])};return new Proxy(Object.create(null),F)}set(L,M){return this._locals[L.nid]=M,M}assertRegistered(L){for(let M=0,F=L.length;M<F;M++){const A=L[M];if(!this._locals[A.nid])throw new Error(`Missing proxy instance ${A.sid}`)}}_receiveOneMessage(L){if(this._isDisposed)return;const M=L.byteLength,F=i.read(L,0),A=F.readUInt8(),B=F.readUInt32();switch(A){case 1:case 2:{let{rpcId:$,method:U,args:K}=s.deserializeRequestJSONArgs(F);this._uriTransformer&&(K=(0,E.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(M,B,$,U,K,A===2);break}case 3:case 4:{let{rpcId:$,method:U,args:K}=s.deserializeRequestMixedArgs(F);this._uriTransformer&&(K=(0,E.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(M,B,$,U,K,A===4);break}case 5:{this._logger?.logIncoming(M,B,0,"ack"),this._onDidReceiveAcknowledge(B);break}case 6:{this._receiveCancel(M,B);break}case 7:{this._receiveReply(M,B,void 0);break}case 9:{let $=s.deserializeReplyOKJSON(F);this._uriTransformer&&($=(0,E.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(M,B,$);break}case 10:{const $=s.deserializeReplyOKJSONWithBuffers(F,this._uriTransformer);this._receiveReply(M,B,$);break}case 8:{const $=s.deserializeReplyOKVSBuffer(F);this._receiveReply(M,B,$);break}case 11:{let $=s.deserializeReplyErrError(F);this._uriTransformer&&($=(0,E.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(M,B,$);break}case 12:{this._receiveReplyErr(M,B,void 0);break}default:console.error("received unexpected message"),console.error(L)}}_receiveRequest(L,M,F,A,B,$){this._logger?.logIncoming(L,M,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(F)}.${A}(`,B);const U=String(M);let K,W;if($){const V=new D.CancellationTokenSource;B.push(V.token),K=this._invokeHandler(F,A,B),W=()=>V.cancel()}else K=this._invokeHandler(F,A,B),W=a;this._cancelInvokedHandlers[U]=W;const N=s.serializeAcknowledged(M);this._logger?.logOutgoing(N.byteLength,M,1,"ack"),this._protocol.send(N),K.then(V=>{delete this._cancelInvokedHandlers[U];const x=s.serializeReplyOK(M,V,this._uriReplacer);this._logger?.logOutgoing(x.byteLength,M,1,"reply:",V),this._protocol.send(x)},V=>{delete this._cancelInvokedHandlers[U];const x=s.serializeReplyErr(M,V);this._logger?.logOutgoing(x.byteLength,M,1,"replyErr:",V),this._protocol.send(x)})}_receiveCancel(L,M){this._logger?.logIncoming(L,M,1,"receiveCancel");const F=String(M);this._cancelInvokedHandlers[F]?.()}_receiveReply(L,M,F){this._logger?.logIncoming(L,M,0,"receiveReply:",F);const A=String(M);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const B=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],B.resolveOk(F)}_receiveReplyErr(L,M,F){this._logger?.logIncoming(L,M,0,"receiveReplyErr:",F);const A=String(M);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const B=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A];let $;F&&(F.$isError?($=new Error,$.name=F.name,$.message=F.message,$.stack=F.stack):$=F),B.resolveErr($)}_invokeHandler(L,M,F){try{return Promise.resolve(this._doInvokeHandler(L,M,F))}catch(A){return Promise.reject(A)}}_doInvokeHandler(L,M,F){const A=this._locals[L];if(!A)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(L));const B=A[M];if(typeof B!="function")throw new Error("Unknown method "+M+" on actor "+(0,R.getStringIdentifierForProxy)(L));return B.apply(A,F)}_remoteCall(L,M,F){if(this._isDisposed)return new I.CanceledLazyPromise;let A=null;if(F.length>0&&D.CancellationToken.isCancellationToken(F[F.length-1])&&(A=F.pop()),A&&A.isCancellationRequested)return Promise.reject(P.canceled());const B=s.serializeRequestArguments(F,this._uriReplacer),$=++this._lastMessageId,U=String($),K=new I.LazyPromise;A&&A.onCancellationRequested(()=>{const N=s.serializeCancel($);this._logger?.logOutgoing(N.byteLength,$,0,"cancel"),this._protocol.send(s.serializeCancel($))}),this._pendingRPCReplies[U]=K,this._onWillSendRequest($);const W=s.serializeRequest($,L,M,B,!!A);return this._logger?.logOutgoing(W.byteLength,$,0,`request: ${(0,R.getStringIdentifierForProxy)(L)}.${M}(`,F),this._protocol.send(W),K}}e.RPCProtocol=o,k=d,o.UNRESPONSIVE_TIME=3*1e3;class i{constructor(L,M){this._buff=L,this._offset=M}static alloc(L,M,F){const A=new i(t.VSBuffer.alloc(F+1+4),0);return A.writeUInt8(L),A.writeUInt32(M),A}static read(L,M){return new i(L,M)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(L){this._buff.writeUInt8(L,this._offset),this._offset+=1}readUInt8(){const L=this._buff.readUInt8(this._offset);return this._offset+=1,L}writeUInt32(L){this._buff.writeUInt32BE(L,this._offset),this._offset+=4}readUInt32(){const L=this._buff.readUInt32BE(this._offset);return this._offset+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this._buff.writeUInt8(L.byteLength,this._offset),this._offset+=1,this._buff.set(L,this._offset),this._offset+=L.byteLength}readShortString(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const F=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,F}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readLongString(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,F}writeBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readVSBuffer(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+L);return this._offset+=L,M}static sizeMixedArray(L){let M=0;M+=1;for(let F=0,A=L.length;F<A;F++){const B=L[F];switch(M+=1,B.type){case 1:M+=this.sizeLongString(B.value);break;case 2:M+=this.sizeVSBuffer(B.value);break;case 3:M+=this.sizeUInt32,M+=this.sizeLongString(B.value);for(let $=0;$<B.buffers.length;++$)M+=this.sizeVSBuffer(B.buffers[$]);break;case 4:break}}return M}writeMixedArray(L){this._buff.writeUInt8(L.length,this._offset),this._offset+=1;for(let M=0,F=L.length;M<F;M++){const A=L[M];switch(A.type){case 1:this.writeUInt8(1),this.writeLongString(A.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(A.value);break;case 3:this.writeUInt8(3),this.writeUInt32(A.buffers.length),this.writeLongString(A.value);for(let B=0;B<A.buffers.length;++B)this.writeBuffer(A.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const M=new Array(L);for(let F=0;F<L;F++)switch(this.readUInt8()){case 1:M[F]=this.readLongString();break;case 2:M[F]=this.readVSBuffer();break;case 3:{const B=this.readUInt32(),$=this.readLongString(),U=[];for(let K=0;K<B;++K)U.push(this.readVSBuffer());M[F]=new R.SerializableObjectWithBuffers(f($,U,null));break}case 4:M[F]=void 0;break}return M}}i.sizeUInt32=4;var n;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(n||(n={}));class s{static _useMixedArgSerialization(L){for(let M=0,F=L.length;M<F;M++)if(L[M]instanceof t.VSBuffer||L[M]instanceof R.SerializableObjectWithBuffers||typeof L[M]=="undefined")return!0;return!1}static serializeRequestArguments(L,M){if(this._useMixedArgSerialization(L)){const F=[];for(let A=0,B=L.length;A<B;A++){const $=L[A];if($ instanceof t.VSBuffer)F[A]={type:2,value:$};else if(typeof $=="undefined")F[A]={type:4};else if($ instanceof R.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:K}=g($.value,M);F[A]={type:3,value:t.VSBuffer.fromString(U),buffers:K}}else F[A]={type:1,value:t.VSBuffer.fromString(p($,M))}}return{type:1,args:F}}return{type:0,args:p(L,M)}}static serializeRequest(L,M,F,A,B){switch(A.type){case 0:return this._requestJSONArgs(L,M,F,A.args,B);case 1:return this._requestMixedArgs(L,M,F,A.args,B)}}static _requestJSONArgs(L,M,F,A,B){const $=t.VSBuffer.fromString(F),U=t.VSBuffer.fromString(A);let K=0;K+=i.sizeUInt8(),K+=i.sizeShortString($),K+=i.sizeLongString(U);const W=i.alloc(B?2:1,L,K);return W.writeUInt8(M),W.writeShortString($),W.writeLongString(U),W.buffer}static deserializeRequestJSONArgs(L){const M=L.readUInt8(),F=L.readShortString(),A=L.readLongString();return{rpcId:M,method:F,args:JSON.parse(A)}}static _requestMixedArgs(L,M,F,A,B){const $=t.VSBuffer.fromString(F);let U=0;U+=i.sizeUInt8(),U+=i.sizeShortString($),U+=i.sizeMixedArray(A);const K=i.alloc(B?4:3,L,U);return K.writeUInt8(M),K.writeShortString($),K.writeMixedArray(A),K.buffer}static deserializeRequestMixedArgs(L){const M=L.readUInt8(),F=L.readShortString(),A=L.readMixedArray(),B=new Array(A.length);for(let $=0,U=A.length;$<U;$++){const K=A[$];typeof K=="string"?B[$]=JSON.parse(K):B[$]=K}return{rpcId:M,method:F,args:B}}static serializeAcknowledged(L){return i.alloc(5,L,0).buffer}static serializeCancel(L){return i.alloc(6,L,0).buffer}static serializeReplyOK(L,M,F){if(typeof M=="undefined")return this._serializeReplyOKEmpty(L);if(M instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(L,M);if(M instanceof R.SerializableObjectWithBuffers){const{jsonString:A,referencedBuffers:B}=g(M.value,F,!0);return this._serializeReplyOKJSONWithBuffers(L,A,B)}else return this._serializeReplyOKJSON(L,_(M,F))}static _serializeReplyOKEmpty(L){return i.alloc(7,L,0).buffer}static _serializeReplyOKVSBuffer(L,M){let F=0;F+=i.sizeVSBuffer(M);const A=i.alloc(8,L,F);return A.writeVSBuffer(M),A.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static _serializeReplyOKJSON(L,M){const F=t.VSBuffer.fromString(M);let A=0;A+=i.sizeLongString(F);const B=i.alloc(9,L,A);return B.writeLongString(F),B.buffer}static _serializeReplyOKJSONWithBuffers(L,M,F){const A=t.VSBuffer.fromString(M);let B=0;B+=i.sizeUInt32,B+=i.sizeLongString(A);for(const U of F)B+=i.sizeVSBuffer(U);const $=i.alloc(10,L,B);$.writeUInt32(F.length),$.writeLongString(A);for(const U of F)$.writeBuffer(U);return $.buffer}static deserializeReplyOKJSON(L){const M=L.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(L,M){const F=L.readUInt32(),A=L.readLongString(),B=[];for(let $=0;$<F;++$)B.push(L.readVSBuffer());return new R.SerializableObjectWithBuffers(f(A,B,M))}static serializeReplyErr(L,M){const F=M?_(P.transformErrorForSerialization(M),null):void 0;if(typeof F!="string")return this._serializeReplyErrEmpty(L);const A=t.VSBuffer.fromString(F);let B=0;B+=i.sizeLongString(A);const $=i.alloc(11,L,B);return $.writeLongString(A),$.buffer}static deserializeReplyErrError(L){const M=L.readLongString();return JSON.parse(M)}static _serializeReplyErrEmpty(L){return i.alloc(12,L,0).buffer}}var l;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(l||(l={}));var h;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(h||(h={}))}),define(Ie[276],ke([1,0,3,44,51,4,43,12,18]),function(Y,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,P.createDecorator)(e.OUTPUT_SERVICE_ID);var I;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(I=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new u.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new u.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(w){this.channels.has(w.id)||(this.channels.set(w.id,w),this._onDidRegisterChannel.fire(w.id))}getChannels(){const w=[];return this.channels.forEach(b=>w.push(b)),w}getChannel(w){return this.channels.get(w)}removeChannel(w){this.channels.delete(w),this._onDidRemoveChannel.fire(w)}}t.Registry.add(e.Extensions.OutputChannels,new R);function k(T,w,b,g,f){return(0,E.createCancelablePromise)(async p=>{await(0,y.whenProviderRegistered)(b,g);const v=t.Registry.as(e.Extensions.OutputChannels);try{await _(b,1,g,f,p),v.registerChannel({id:T,label:w,file:b,log:!0})}catch(c){(0,C.isCancellationError)(c)||f.error("Error while registering log channel",b.toString(),(0,C.getErrorMessage)(c))}})}e.registerLogChannel=k;async function _(T,w,b,g,f){if(!await b.exists(T)){if(f.isCancellationRequested)throw new C.CancellationError;if(w>10)throw new Error("Timed out while waiting for file to be created");g.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",T.toString()),await(0,E.timeout)(1e3,f),await _(T,w+1,b,g,f)}}}),define(Ie[138],ke([1,0,5,6,4,17,14,276,68,26,46,152,23,10]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class w extends t.Disposable{constructor(f,p,v,c){super();this.id=f,this.name=p,this.logger=v,this.proxy=c,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(f){this.append(f+`
`)}append(f){this.write(f),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,C.OutputChannelUpdateMode.Append))}clear(){const f=this.offset;this.logger.flush(),this.proxy.$update(this.id,C.OutputChannelUpdateMode.Clear,f)}replace(f){const p=this.offset;this.write(f),this.proxy.$update(this.id,C.OutputChannelUpdateMode.Replace,p),this.visible&&this.logger.flush()}show(f,p){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof f=="boolean"?f:p))}hide(){this.proxy.$close(this.id)}write(f){this.offset+=_.VSBuffer.fromString(f).byteLength,this.logger.info(f)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=w;let b=class{constructor(f,p,v,c,m){this.extHostFileSystem=v,this.extHostFileSystemInfo=c,this.loggerService=m,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=f.getProxy(u.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(p.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(f){this.visibleChannelId=f;for(const[p,v]of this.channels)v.visible=p===this.visibleChannelId}createOutputChannel(f,p,v){if(f=f.trim(),!f)throw new Error("illegal argument `name`. must not be falsy");if((0,T.isString)(p)&&!p.trim())throw new Error("illegal argument `languageId`. must not be empty");const c=this.doCreateOutputChannel(f,p,v);return c.then(m=>{this.channels.set(m.id,m),m.visible=m.id===this.visibleChannelId}),this.createExtHostOutputChannel(f,c)}async doCreateOutputChannel(f,p,v){const c=await this.createOutputDirectory(),m=this.extHostFileSystemInfo.extUri.joinPath(c,`${this.namePool++}-${f.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.loggerService.createLogger(m,{always:!0,donotRotate:!0,donotUseFormatters:!0}),d=await this.proxy.$register(f,!1,m,p,v.identifier.value);return new w(d,f,a,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(f,p){let v=!1;const c=()=>{if(v)throw new Error("Channel has been closed")};return{get name(){return f},append(m){c(),p.then(a=>a.append(m))},appendLine(m){c(),p.then(a=>a.appendLine(m))},clear(){c(),p.then(m=>m.clear())},replace(m){c(),p.then(a=>a.replace(m))},show(m,a){c(),p.then(d=>d.show(m,a))},hide(){c(),p.then(m=>m.hide())},dispose(){v=!0,p.then(m=>m.dispose())}}}};b=Ge([xe(0,P.IExtHostRpcService),xe(1,I.IExtHostInitDataService),xe(2,E.IExtHostConsumerFileSystem),xe(3,R.IExtHostFileSystemInfo),xe(4,y.ILoggerService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(Ie[277],ke([1,0,4]),function(Y,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,u.createDecorator)("remoteAgentService")}),define(Ie[278],ke([1,0,30,11,9,13,22,2,4,204,45,226,277]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let T=class Jn{constructor(b,g,f,p){this.localUserHome=b,this.remoteAgentService=g,this.environmentService=f,this.contextService=p,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||P.OS)(),this.resolveUserHome=(async()=>{const v=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=v?.userHome??b})()}hasValidBasename(b,g,f){return typeof g=="string"||typeof g=="undefined"?this.resolveOS.then(p=>this.doHasValidBasename(b,p,g)):this.doHasValidBasename(b,g,f)}doHasValidBasename(b,g,f){return b.scheme===t.Schemas.file||b.scheme===t.Schemas.vscodeRemote?(0,u.isValidBasename)(f??(0,y.basename)(b),g===1):!0}get defaultUriScheme(){return Jn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(b,g){if(b.remoteAuthority)return t.Schemas.vscodeRemote;const f=(0,I.getVirtualWorkspaceScheme)(g.getWorkspace());if(f)return f;const p=g.getWorkspace().folders[0];if(p)return p.uri.scheme;const v=g.getWorkspace().configuration;return v?v.scheme:t.Schemas.file}userHome(b){return b?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(b=>b===1?D.win32:D.posix)}async fileURI(b){let g="";if(await this.resolveOS===1&&(b=b.replace(/\\/g,"/")),b[0]==="/"&&b[1]==="/"){const p=b.indexOf("/",2);p===-1?(g=b.substring(2),b="/"):(g=b.substring(2,p),b=b.substring(p)||"/")}return C.URI.from({scheme:t.Schemas.file,authority:g,path:b,query:"",fragment:""})}};T=Ge([xe(1,_.IRemoteAgentService),xe(2,k.IWorkbenchEnvironmentService),xe(3,R.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(Ie[71],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class u{constructor(y,C){this.line=y,this.character=C}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,C){return new u(0,0)}with(y){return new u(0,0)}}e.Position=u;class t{constructor(y,C,E,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(y,C),this.end=new u(E,I)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new t(0,0,0,0)}with(y){return new t(0,0,0,0)}}e.Range=t;var D;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ie[31],ke([1,0,16,36,24,30,8,4,9,12,71,18]),function(Y,e,u,t,D,P,y,C,E,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const _="\u27EA ",T=" characters skipped \u27EB",w=(_.length+T.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var b;(function(q){q[q.file=0]="file",q[q.text=1]="text"})(b=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(q){q[q.File=1]="File",q[q.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function f(q){return!!q.preview}e.resultIsMatch=f;function p(q){return!!q.resource}e.isFileMatch=p;function v(q){return!!q.message}e.isProgressMessage=v;var c;(function(q){q[q.Normal=0]="Normal",q[q.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(te){this.resource=te,this.results=[]}}e.FileMatch=m;class a{constructor(te,Q,le){this.ranges=Q;const pe=Array.isArray(Q)?Q:[Q];if(le&&le.matchLines===1&&d(pe)){te=(0,y.getNLines)(te,le.matchLines);let Z="",ge=0,Ee=0;const Te=Math.floor(le.charsPerLine/5),Oe=[];for(const ve of pe){const ue=Math.max(ve.startColumn-Te,0),de=ve.startColumn+le.charsPerLine;if(ue>Ee+Te+w){const we=_+(ue-Ee)+T;Z+=we+te.slice(ue,de),ge+=ue-(Ee+we.length)}else Z+=te.slice(Ee,de);Oe.push(new o(0,ve.startColumn-ge,ve.endColumn-ge)),Ee=de}this.preview={text:Z,matches:Array.isArray(this.ranges)?Oe:Oe[0]}}else{const Z=Array.isArray(Q)?Q[0].startLineNumber:Q.startLineNumber;this.preview={text:te,matches:(0,u.mapArrayOrNot)(Q,ge=>new r(ge.startLineNumber-Z,ge.startColumn,ge.endLineNumber-Z,ge.endColumn))}}}}e.TextSearchMatch=a;function d(q){const te=q[0].startLineNumber;for(const Q of q)if(Q.startLineNumber!==te||Q.endLineNumber!==te)return!1;return!0}class r{constructor(te,Q,le,pe){this.startLineNumber=te,this.startColumn=Q,this.endLineNumber=le,this.endColumn=pe}}e.SearchRange=r;class o extends r{constructor(te,Q,le){super(te,Q,te,le)}}e.OneLineRange=o;var i;(function(q){q.Default="default",q.FileNames="fileNames",q.Type="type",q.Modified="modified",q.CountDescending="countDescending",q.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function n(q,te=!0){const Q=q&&q.files&&q.files.exclude,le=te&&q&&q.search&&q.search.exclude;if(!Q&&!le)return;if(!Q||!le)return Q||le;let pe=Object.create(null);return pe=D.mixin(pe,D.deepClone(Q)),pe=D.mixin(pe,D.deepClone(le),!0),pe}e.getExcludes=n;function s(q,te){return q.excludePattern&&t.match(q.excludePattern,te)?!1:q.includePattern||q.usingSearchPaths?q.includePattern&&t.match(q.includePattern,te)?!0:q.usingSearchPaths?!!q.folderQueries&&q.folderQueries.some(Q=>{const le=Q.folder.fsPath;if(P.isEqualOrParent(te,le)){const pe=E.relative(le,te);return!Q.includePattern||!!t.match(Q.includePattern,pe)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var l;(function(q){q[q.unknownEncoding=1]="unknownEncoding",q[q.regexParseError=2]="regexParseError",q[q.globParseError=3]="globParseError",q[q.invalidLiteral=4]="invalidLiteral",q[q.rgProcessError=5]="rgProcessError",q[q.other=6]="other",q[q.canceled=7]="canceled"})(l=e.SearchErrorCode||(e.SearchErrorCode={}));class h extends Error{constructor(te,Q){super(te);this.code=Q}}e.SearchError=h;function S(q){const te=q.message;if((0,I.isCancellationError)(q))return new h(te,l.canceled);try{const Q=JSON.parse(te);return new h(Q.message,Q.code)}catch{return new h(te,l.other)}}e.deserializeSearchError=S;function L(q){const te={message:q.message,code:q.code};return new Error(JSON.stringify(te))}e.serializeSearchError=L;function M(q){return q.type==="error"?!0:q.type==="success"}e.isSerializedSearchComplete=M;function F(q){return q.type==="success"}e.isSerializedSearchSuccess=F;function A(q){return!!q.path}e.isSerializedFileMatch=A;function B(q,te){const Q=q.searchPath?q.searchPath:q.relativePath;return(0,y.fuzzyContains)(Q,te)}e.isFilePatternMatch=B;class ${constructor(te){this.path=te,this.results=[]}addMatch(te){this.results.push(te)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=$;function U(q,te){const Q={...q||{},...te||{}};return Object.keys(Q).filter(le=>{const pe=Q[le];return typeof pe=="boolean"&&pe})}e.resolvePatternsForProvider=U;class K{constructor(te,Q){this._parsedIncludeExpression=null,this._excludeExpression={...te.excludePattern||{},...Q.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let le=te.includePattern;Q.includePattern&&(le?le={...le,...Q.includePattern}:le=Q.includePattern),le&&(this._parsedIncludeExpression=t.parse(le))}matchesExcludesSync(te,Q,le){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(te,Q,le))}includedInQuerySync(te,Q,le){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(te,Q,le)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(te,Q,le))}includedInQuery(te,Q,le){const pe=this._parsedExcludeExpression(te,Q,le),Z=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(te,Q,le):!0;return(0,k.isThenable)(pe)?pe.then(ge=>ge?!1:Z()):Z()}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=K;function W(q){for(const te in q)if(typeof q[te]!="boolean")return!0;return!1}function N(q){if(!q)return;let te;return Q=>(te||(te=(q()||Promise.resolve([])).then(le=>le?x(le):{})),te.then(le=>!!le[Q]))}e.hasSiblingPromiseFn=N;function V(q){if(!q)return;let te;return Q=>{if(!te){const le=q();te=le?x(le):{}}return!!te[Q]}}e.hasSiblingFn=V;function x(q){const te={};for(const Q of q)te[Q]=!0;return te}}),define(Ie[32],ke([1,0,16,18,21,3,25,11,94,22,8,10,2,176,4,14,196,45,46,26,17,15,7,31,5]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g,f,p,v,c,m,a,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(M,F,A){return new I.ExtUri(B=>l(B,A)).isEqual(M,F)}function i(M,F,A){return o(M.uri,F.uri,A)?0:(0,R.compare)(M.uri.toString(),F.uri.toString())}function n(M,F,A){return M.index!==F.index?M.index<F.index?-1:1:o(M.uri,F.uri,A)?(0,R.compare)(M.name,F.name):(0,R.compare)(M.uri.toString(),F.uri.toString())}function s(M,F,A,B){const $=M.slice(0).sort((K,W)=>A(K,W,B)),U=F.slice(0).sort((K,W)=>A(K,W,B));return(0,u.delta)($,U,(K,W)=>A(K,W,B))}function l(M,F){const A=F.getCapabilities(M.scheme);return!(A&&A&1024)}class h extends f.Workspace{constructor(F,A,B,$,U,K,W){super(F,B.map(N=>new f.WorkspaceFolder(N)),$,U,W);this._name=A,this._isUntitled=K,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(W),B.forEach(N=>{this._workspaceFolders.push(N),this._structure.set(N.uri,N)})}static toExtHostWorkspace(F,A,B,$){if(!F)return{workspace:null,added:[],removed:[]};const{id:U,name:K,folders:W,configuration:N,transient:V,isUntitled:x}=F,q=[],te=A;A?W.forEach((Z,ge)=>{const Ee=_.URI.revive(Z.uri),Te=h._findFolder(B||A,Ee,$);Te?(Te.name=Z.name,Te.index=Z.index,q.push(Te)):q.push({uri:Ee,name:Z.name,index:ge})}):q.push(...W.map(({uri:Z,name:ge,index:Ee})=>({uri:_.URI.revive(Z),name:ge,index:Ee}))),q.sort((Z,ge)=>Z.index<ge.index?-1:1);const Q=new h(U,K,q,!!V,N?_.URI.revive(N):null,!!x,Z=>l(Z,$)),{added:le,removed:pe}=s(te?te.workspaceFolders:[],Q.workspaceFolders,i,$);return{workspace:Q,added:le,removed:pe}}static _findFolder(F,A,B){for(let $=0;$<F.folders.length;$++){const U=F.workspaceFolders[$];if(o(U.uri,A,B))return U}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,A){return A&&this._structure.get(F)&&(F=(0,I.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let S=class{constructor(F,A,B,$){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=$,this._extHostFileSystemInfo=B,this._requestIdProvider=new E.Counter,this._barrier=new t.Barrier,this._proxy=F.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(r.MainContext.MainThreadMessageService);const U=A.workspace;this._confirmedWorkspace=U?new h(U.id,U.name,[],!!U.transient,U.configuration?_.URI.revive(U.configuration):null,!!U.isUntitled,K=>l(K,B)):void 0}$initializeWorkspace(F,A){this._trusted=A,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?_.URI.from({scheme:C.Schemas.untitled,path:(0,I.basename)((0,I.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,A,B,...$){const U=[];if(Array.isArray($)&&$.forEach(x=>{_.URI.isUri(x.uri)&&!U.some(q=>o(q.uri,x.uri,this._extHostFileSystemInfo))&&U.push({uri:x.uri,name:x.name||(0,I.basenameOrAuthority)(x.uri)})}),this._unconfirmedWorkspace||[A,B].some(x=>typeof x!="number"||x<0)||B===0&&U.length===0)return!1;const K=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(A+B>K.length)return!1;const W=K.slice(0);W.splice(A,B,...U.map(x=>({uri:x.uri,name:x.name||(0,I.basenameOrAuthority)(x.uri),index:void 0})));for(let x=0;x<W.length;x++){const q=W[x];if(W.some((te,Q)=>Q!==x&&o(q.uri,te.uri,this._extHostFileSystemInfo)))return!1}W.forEach((x,q)=>x.index=q);const{added:N,removed:V}=s(K,W,n,this._extHostFileSystemInfo);if(N.length===0&&V.length===0)return!1;if(this._proxy){const x=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(x,A,B,U).then(void 0,q=>{this._unconfirmedWorkspace=void 0;const te={source:{identifier:F.identifier,label:F.displayName||F.name}};this._messageService.$showMessage(g.Severity.Error,(0,T.localize)(0,null,x,q.toString()),te,[])})}return this.trySetWorkspaceFolders(W),!0}getWorkspaceFolder(F,A){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,A)}async getWorkspaceFolder2(F,A){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,A)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!this._actualWorkspace)return;const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,A){let B,$="";if(typeof F=="string"?(B=_.URI.file(F),$=F):typeof F!="undefined"&&(B=F,$=F.fsPath),!B)return $;const U=this.getWorkspaceFolder(B,!0);if(!U)return $;typeof A=="undefined"&&this._actualWorkspace&&(A=this._actualWorkspace.folders.length>1);let K=(0,I.relativePath)(U.uri,B);return A&&U.name&&(K=`${U.name}/${K}`),K}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:A,added:B,removed:$}=h.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=A||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:B,removed:$}))}findFiles(F,A,B,$,U=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${$.value}, entryPoint: findFiles`);let K;if(A===null?K=!1:A&&(typeof A=="string"?K=A:K=A.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:W,folder:N}=L(m.GlobPattern.from(F));return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(W),(0,k.withUndefinedAsNull)(N),(0,k.withUndefinedAsNull)(K),(0,k.withUndefinedAsNull)(B),U).then(V=>Array.isArray(V)?V.map(x=>_.URI.revive(x)):[])}async findTextInFiles(F,A,B,$,U=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${$.value}, entryPoint: findTextInFiles`);const K=this._requestIdProvider.getNext(),W=typeof A.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:A.previewOptions,{includePattern:N,folder:V}=L(m.GlobPattern.from(A.include)),x=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,q={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!0,fileEncoding:A.encoding,maxResults:A.maxResults,previewOptions:W,afterContext:A.afterContext,beforeContext:A.beforeContext,includePattern:N,excludePattern:x},te=!1;if(this._activeSearchCallbacks[K]=Q=>{if(te)return;const le=_.URI.revive(Q.resource);Q.results.forEach(pe=>{(0,d.resultIsMatch)(pe)?B({uri:le,preview:{text:pe.preview.text,matches:(0,u.mapArrayOrNot)(pe.preview.matches,Z=>new a.Range(Z.startLineNumber,Z.startColumn,Z.endLineNumber,Z.endColumn))},ranges:(0,u.mapArrayOrNot)(pe.ranges,Z=>new a.Range(Z.startLineNumber,Z.startColumn,Z.endLineNumber,Z.endColumn))}):B({uri:le,text:pe.text,lineNumber:pe.lineNumber})})},U.isCancellationRequested)return{};try{const Q=await this._proxy.$startTextSearch(F,(0,k.withUndefinedAsNull)(V),q,K,U);return delete this._activeSearchCallbacks[K],Q||{}}catch(Q){throw delete this._activeSearchCallbacks[K],Q}}$handleTextSearchResult(F,A){this._activeSearchCallbacks[A]?.(F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trusted(){return this._trusted}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};S=Ge([xe(0,c.IExtHostRpcService),xe(1,v.IExtHostInitDataService),xe(2,p.IExtHostFileSystemInfo),xe(3,b.ILogService)],S),e.ExtHostWorkspace=S,e.IExtHostWorkspace=(0,w.createDecorator)("IExtHostWorkspace");function L(M){let F,A;return M&&(typeof M=="string"?F=M:(F=M.pattern,A=_.URI.revive(M.baseUri))),{includePattern:F,folder:A}}}),define(Ie[33],ke([1,0,24,3,32,5,7,199,121,10,18,4,17,14,2]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function b(d,r){if(r){const o=r.split(".");let i=d;for(let n=0;i&&n<o.length;n++)i=i[o[n]];return i}}function g(d){return d instanceof w.URI}function f(d){return d&&d.uri instanceof w.URI&&d.languageId&&typeof d.languageId=="string"}function p(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function v(d){return d&&d.uri instanceof w.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function c(d){if(g(d))return{resource:d};if(f(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(p(d))return{overrideIdentifier:d.languageId};if(v(d))return{resource:d.uri};if(d===null)return{resource:null}}let m=class{constructor(r,o,i){this._proxy=r.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=i,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new a(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,o){this.getConfigProvider().then(i=>i.$acceptConfigurationChanged(r,o))}};m=Ge([xe(0,_.IExtHostRpcService),xe(1,D.IExtHostWorkspace),xe(2,T.ILogService)],m),e.ExtHostConfiguration=m;class a{constructor(r,o,i,n){this._onDidChangeConfiguration=new t.Emitter,this._proxy=r,this._logService=n,this._extHostWorkspace=o,this._configuration=C.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,o){const i={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,i))}getConfiguration(r,o,i){const n=c(o)||{},s=this._toReadonlyValue(r?b(this._configuration.getValue(void 0,n,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,n,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,n,i?.identifier);function l(S){if(S==null)return null;if(typeof S=="boolean")return S?1:4;switch(S){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(S){return typeof b(s,S)!="undefined"},get:(S,L)=>{this._validateConfigurationAccess(r?`${r}.${S}`:S,n,i?.identifier);let M=b(s,S);if(typeof M=="undefined")M=L;else{let F;const A=(B,$)=>{let U;const K=()=>{F=F||(0,u.deepClone)(s),U=U||b(F,$)};return(0,I.isObject)(B)?new Proxy(B,{get:(W,N)=>{if(typeof N=="string"&&N.toLowerCase()==="tojson")return K(),()=>U;if(F)return U=U||b(F,$),U[N];const V=W[N];return typeof N=="string"?A(V,`${$}.${N}`):V},set:(W,N,V)=>(K(),U&&(U[N]=V),!0),deleteProperty:(W,N)=>(K(),U&&delete U[N],!0),defineProperty:(W,N,V)=>(K(),U&&Object.defineProperty(U,N,V),!0)}):B};M=A(M,S)}return M},update:(S,L,M,F)=>{S=r?`${r}.${S}`:S;const A=l(M);return L!==void 0?this._proxy.$updateConfigurationOption(A,S,L,n,F):this._proxy.$removeConfigurationOption(A,S,n,F)},inspect:S=>{S=r?`${r}.${S}`:S;const L=(0,u.deepClone)(this._configuration.inspect(S,n,this._extHostWorkspace.workspace));if(L)return{key:S,defaultValue:L.policy?.value??L.default?.value,globalValue:L.user?.value??L.application?.value,workspaceValue:L.workspace?.value,workspaceFolderValue:L.workspaceFolder?.value,defaultLanguageValue:L.default?.override,globalLanguageValue:L.user?.override??L.application?.override,workspaceLanguageValue:L.workspace?.override,workspaceFolderLanguageValue:L.workspaceFolder?.override,languageIds:L.overrideIdentifiers}}};return typeof s=="object"&&(0,u.mixin)(h,s,!1),Object.freeze(h)}_toReadonlyValue(r){const o=i=>(0,I.isObject)(i)?new Proxy(i,{get:(n,s)=>o(n[s]),set:(n,s,l)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(n,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(n,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:n=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):i;return o(r)}_validateConfigurationAccess(r,o,i){const n=E.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),s=i?`[${i.value}] `:"";if(n===4){typeof o?.resource=="undefined"&&this._logService.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(n===3){o?.resource&&this._logService.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,o){const i=new C.ConfigurationChangeEvent(r,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(n,s)=>i.affectsConfiguration(n,c(s))})}_toMap(r){return r.reduce((o,i)=>(o.set(i[0],i[1]),o),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(Y,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Y,u):D?D.value=u:e.set(Y,u),u},Me=this&&this.__classPrivateFieldGet||function(Y,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!t:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Y):t?t.value:e.get(Y)};define(Ie[72],ke([1,0,2,18,3,5,7,32,54,33,21,38,17,26,4,11,13,14,67,234,12]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g,f,p,v,c){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function($){function U(W){if(W!=null)return W}$.from=U;function K(W){if(W!=null)return W}$.to=K})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var d;(function($){function U(W){if(W!=null)return W}$.from=U;function K(W){if(W!=null)return W}$.to=K})(d=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function($){function U(W){if(W!=null)return W}$.from=U;function K(W){if(W!=null)return W}$.to=K})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var o;(function($){function U(N){if(N){const V=N;return V&&!!V.process}else return!1}$.is=U;function K(N){if(N==null)return;const V={process:N.process,args:N.args};return N.options&&(V.options=r.from(N.options)),V}$.from=K;function W(N){if(N!=null)return new y.ProcessExecution(N.process,N.args,N.options)}$.to=W})(o=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var i;(function($){function U(W){if(W!=null)return W}$.from=U;function K(W){if(W!=null)return W}$.to=K})(i=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var n;(function($){function U(N){if(N){const V=N;return V&&(!!V.commandLine||!!V.command)}else return!1}$.is=U;function K(N){if(N==null)return;const V={};return N.commandLine!==void 0?V.commandLine=N.commandLine:(V.command=N.command,V.args=N.args),N.options&&(V.options=i.from(N.options)),V}$.from=K;function W(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new y.ShellExecution(N.commandLine,N.options):new y.ShellExecution(N.command,N.args?N.args:[],N.options)}$.to=W})(n=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var s;(function($){function U(N){if(N){const V=N;return V&&V.customExecution==="customExecution"}else return!1}$.is=U;function K(N){return{customExecution:"customExecution"}}$.from=K;function W(N,V){return V.get(N)}$.to=W})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var l;(function($){function U(K,W){let N;return K.scope!==void 0&&typeof K.scope!="number"?N=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===y.TaskScope.Workspace&&W&&W.workspaceFile?N=W.workspaceFile:N=v.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:N}}$.from=U})(l=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function($){function U(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}$.from=U})(h=e.TaskGroupDTO||(e.TaskGroupDTO={}));var S;(function($){function U(N,V){if(N==null)return[];const x=[];for(const q of N){const te=K(q,V);te&&x.push(te)}return x}$.fromMany=U;function K(N,V){if(N==null)return;let x;N.execution instanceof y.ProcessExecution?x=o.from(N.execution):N.execution instanceof y.ShellExecution?x=n.from(N.execution):N.execution&&N.execution instanceof y.CustomExecution&&(x=s.from(N.execution));const q=a.from(N.definition);let te;return N.scope?typeof N.scope=="number"?te=N.scope:te=N.scope.uri:te=y.TaskScope.Workspace,!q||!te?void 0:{_id:N._id,definition:q,name:N.name,source:{extensionId:V.identifier.value,label:N.source,scope:te},execution:x,isBackground:N.isBackground,group:h.from(N.group),presentationOptions:d.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}$.from=K;async function W(N,V,x){if(N==null)return;let q;o.is(N.execution)?q=o.to(N.execution):n.is(N.execution)?q=n.to(N.execution):s.is(N.execution)&&(q=s.to(N._id,x));const te=a.to(N.definition);let Q;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Q=N.source.scope:Q=await V.resolveWorkspaceFolder(u.URI.revive(N.source.scope)):Q=y.TaskScope.Workspace),!te||!Q)return;const le=new y.Task(te,Q,N.name,N.source.label,q,N.problemMatchers);return N.isBackground!==void 0&&(le.isBackground=N.isBackground),N.group!==void 0&&(le.group=y.TaskGroup.from(N.group._id),le.group&&N.group.isDefault&&(le.group=new y.TaskGroup(le.group.id,le.group.label),N.group.isDefault===!0&&(le.group.isDefault=N.group.isDefault))),N.presentationOptions&&(le.presentationOptions=d.to(N.presentationOptions)),N._id&&(le._id=N._id),N.detail&&(le.detail=N.detail),le}$.to=W})(S=e.TaskDTO||(e.TaskDTO={}));var L;(function($){function U(W){return W}$.from=U;function K(W){if(!!W)return Object.assign(Object.create(null),W)}$.to=K})(L=e.TaskFilterDTO||(e.TaskFilterDTO={}));class M{constructor(U,K,W){this._id=K,this._task=W,m.set(this,void 0),tt(this,m,U,"f")}get task(){return this._task}terminate(){Me(this,m,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}m=new WeakMap;var F;(function($){function U(K){return{id:K._id,task:void 0}}$.from=U})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let A=class{constructor(U,K,W,N,V,x,q,te){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=U.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=N,this._configurationService=V,this._terminalService=x,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=q,this._deprecationService=te,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,K,W){if(!W)return new y.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:K,provider:W,extension:U}),this._proxy.$registerTaskProvider(N,K),new y.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(U,K){this._proxy.$registerTaskSystem(U,K)}fetchTasks(U){return this._proxy.$fetchTasks(L.from(U)).then(async K=>{const W=[];for(const N of K){const V=await S.to(N,this._workspaceProvider,this._providedCustomExecutions2);V&&W.push(V)}return W})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(K=>U.push(K)),U}terminateTask(U){if(!(U instanceof M))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,K,W){const N=this._providedCustomExecutions2.get(U.id);N&&(this._activeCustomExecutions2.set(U.id,N),this._terminalService.attachPtyToTerminal(K,await N.callback(W))),this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){const K=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const K=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:K,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const K=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:U.exitCode})}$provideTasks(U,K){const W=this._handlers.get(U);if(!W)return Promise.reject(new Error("no handler found"));const N=[],V=(0,t.asPromise)(()=>W.provider.provideTasks(R.CancellationToken.None)).then(x=>this.provideTasksInternal(K,N,W,x));return new Promise(x=>{V.then(q=>{Promise.all(N).then(()=>{x(q)})})})}async $resolveTask(U,K){const W=this._handlers.get(U);if(!W)return Promise.reject(new Error("no handler found"));if(K.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${W.type}].`);const N=await S.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const V=await W.provider.resolveTask(N,R.CancellationToken.None);if(!V)return;this.checkDeprecation(V,W);const x=S.from(V,W.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(x.execution)&&await this.addCustomExecution(x,V,!0),await this.resolveTaskInternal(x)}nextHandle(){return this._handleCounter++}async addCustomExecution(U,K,W){const N=await this._proxy.$createTaskId(U);!W&&!this._providedCustomExecutions2.has(N)&&(this._notProvidedCustomExecutions.add(N),this._activeCustomExecutions2.set(N,K.execution)),this._providedCustomExecutions2.set(N,K.execution)}async getTaskExecution(U,K){if(typeof U=="string"){const V=this._taskExecutionPromises.get(U);if(!V)throw new Error("Unexpected: The specified task is missing an execution");return V}const W=this._taskExecutionPromises.get(U.id);if(W)return W;const N=new Promise((V,x)=>{function q(te,Q,le){le?V(new M(te,Q.id,le)):x("Unexpected: Task does not exist.")}K?q(this,U,K):S.to(U.task,this._workspaceProvider,this._providedCustomExecutions2).then(te=>q(this,U,te))});return this._taskExecutionPromises.set(U.id,N),N.then(V=>(this._taskExecutions.set(U.id,V),V),V=>Promise.reject(V))}checkDeprecation(U,K){U._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));const W=this._notProvidedCustomExecutions.values();let N=W.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=W.next()}};A=Ge([xe(0,_.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,C.IExtHostWorkspace),xe(3,E.IExtHostDocumentsAndEditors),xe(4,I.IExtHostConfiguration),xe(5,k.IExtHostTerminalService),xe(6,f.ILogService),xe(7,p.IExtHostApiDeprecationService)],A),e.ExtHostTaskBase=A;let B=class extends A{constructor(U,K,W,N,V,x,q,te){super(U,K,W,N,V,x,q,te);this.registerTaskSystem(b.Schemas.vscodeRemote,{scheme:b.Schemas.vscodeRemote,authority:"",platform:g.PlatformToString(0)})}async executeTask(U,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const W=S.from(K,U);if(W===void 0)throw new Error("Task is not valid");if(s.is(W.execution))await this.addCustomExecution(W,K,!1);else throw new c.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),K);return this._proxy.$executeTask(W).catch(V=>{throw new Error(V)}),N}provideTasksInternal(U,K,W,N){const V=[];if(N)for(const x of N){this.checkDeprecation(x,W),(!x.definition||!U[x.definition.type])&&this._logService.warn(`The task [${x.source}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`);const q=S.from(x,W.extension);q&&s.is(q.execution)?(V.push(q),K.push(this.addCustomExecution(q,x,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:V,extension:W.extension}}async resolveTaskInternal(U){if(s.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,K,W){}};B=Ge([xe(0,_.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,C.IExtHostWorkspace),xe(3,E.IExtHostDocumentsAndEditors),xe(4,I.IExtHostConfiguration),xe(5,k.IExtHostTerminalService),xe(6,f.ILogService),xe(7,p.IExtHostApiDeprecationService)],B),e.WorkerExtHostTask=B,e.IExtHostTask=(0,w.createDecorator)("IExtHostTask")}),define(Ie[279],ke([1,0,9,21,49,36,22,50,31]),function(Y,e,u,t,D,P,y,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(_,T,w){this.config=_,this.provider=T,this.sessionToken=w,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=_.filePattern,this.includePattern=_.includePattern&&P.parse(_.includePattern),this.maxResults=_.maxResults||void 0,this.exists=_.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=_.excludePattern&&P.parse(_.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(_=>_.cancel()),this.activeCancellationTokens=new Set}search(_){const T=this.config.folderQueries||[];return new Promise((w,b)=>{const g=f=>{this.resultCount++,_(f)};if(this.isCanceled)return w({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(f=>{const p=f.toString(),v=u.basename(p);this.globalExcludePattern&&this.globalExcludePattern(p,v)||this.matchFile(g,{base:f,basename:v})}),Promise.all(T.map(f=>this.searchInFolder(f,g))).then(f=>{w({limitHit:this.isLimitHit,stats:f[0]||void 0})},f=>{b(new Error((0,D.toErrorMessage)(f)))})})}async searchInFolder(_,T){const w=new t.CancellationTokenSource,b=this.getSearchOptionsForFolder(_),g=this.initDirectoryTree(),f=new E.QueryGlobTester(this.config,_),p=!f.hasSiblingExcludeClauses();let v;try{this.activeCancellationTokens.add(w),v=C.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},b,w.token),m=v.elapsed(),a=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(d=>{const r=u.posix.relative(_.folder.path,d.path);if(p){const o=u.basename(d.path);this.matchFile(T,{base:_.folder,relativePath:r,basename:o});return}this.addDirectoryEntries(g,_.folder,r,T)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(g,f,T),{providerTime:m,postProcessTime:a.elapsed()})}finally{w.dispose(),this.activeCancellationTokens.delete(w)}}getSearchOptionsForFolder(_){const T=(0,E.resolvePatternsForProvider)(this.config.includePattern,_.includePattern),w=(0,E.resolvePatternsForProvider)(this.config.excludePattern,_.excludePattern);return{folder:_.folder,excludes:w,includes:T,useIgnoreFiles:!_.disregardIgnoreFiles,useGlobalIgnoreFiles:!_.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!_.disregardParentIgnoreFiles,followSymlinks:!_.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const _={rootEntries:[],pathToEntries:Object.create(null)};return _.pathToEntries["."]=_.rootEntries,_}addDirectoryEntries({pathToEntries:_},T,w,b){if(w===this.filePattern){const f=u.basename(this.filePattern);this.matchFile(b,{base:T,relativePath:this.filePattern,basename:f})}function g(f){const p=u.basename(f),v=u.dirname(f);let c=_[v];c||(c=_[v]=[],g(v)),c.push({base:T,relativePath:f,basename:p})}g(w)}matchDirectoryTree({rootEntries:_,pathToEntries:T},w,b){const g=this,f=this.filePattern;function p(v){const c=(0,E.hasSiblingFn)(()=>v.map(m=>m.basename));for(let m=0,a=v.length;m<a;m++){const d=v[m],{relativePath:r,basename:o}=d;if(w.matchesExcludesSync(r,o,f!==o?c:void 0))continue;const i=T[r];if(i)p(i);else{if(r===f)continue;g.matchFile(b,d)}if(g.isLimitHit)break}}p(_)}matchFile(_,T){(!this.includePattern||T.relativePath&&this.includePattern(T.relativePath,T.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||_(T))}}class R{constructor(){this.sessions=new Map}fileSearch(_,T,w,b){const g=this.getSessionTokenSource(_.cacheKey),f=new I(_,T,g&&g.token);let p=0;const v=c=>{p+=c.length,w(c.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(f,R.BATCH_SIZE,v,b).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:c.stats}}))}clearCache(_){const T=this.getSessionTokenSource(_);T&&T.cancel()}getSessionTokenSource(_){if(!!_)return this.sessions.has(_)||this.sessions.set(_,new t.CancellationTokenSource),this.sessions.get(_)}rawMatchToSearchItem(_){return _.relativePath?{resource:y.joinPath(_.base,_.relativePath)}:{resource:_.base}}doSearch(_,T,w,b){b.onCancellationRequested(()=>{_.cancel()});const g=p=>{p&&(f.push(p),T>0&&f.length>=T&&(w(f),f=[]))};let f=[];return _.search(g).then(p=>(f.length&&w(f),p),p=>(f.length&&w(f),Promise.reject(p)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(Ie[280],ke([1,0,16,77,36,107,25,11,9,22,8,10,2,159,187,83,14,45,130,278,31]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g,f,p,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(h,S,L,M,F){this.configurationService=h,this.workspaceContextService=S,this.editorGroupsService=L,this.logService=M,this.pathService=F}text(h,S,L={}){h=this.getContentPattern(h,L);const M=this.configurationService.getValue(),F=S&&S.some(B=>!this.configurationService.getValue({resource:B}).search.useRipgrep);return{...this.commonQuery(S?.map(f.toWorkspaceFolder),L),type:2,contentPattern:h,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:M.search.usePCRE2||F||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}getContentPattern(h,S){const L=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const M={...h,wordSeparators:L.editor.wordSeparators};return this.isCaseSensitive(h,S)&&(M.isCaseSensitive=!0),this.isMultiline(h)&&(M.isMultiline=!0),M}file(h,S={}){return{...this.commonQuery(h,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey}}handleIncludeExclude(h,S){return h?(h=Array.isArray(h)?h.map(i):i(h),S?this.parseSearchPaths(h):{pattern:d(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],S={}){const L=this.handleIncludeExclude(S.includePattern,S.expandPatterns),M=this.handleIncludeExclude(S.excludePattern,S.expandPatterns),F=h.length>1,A=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,S,M)):h.map(U=>this.getFolderQueryForRoot(U,S,M,F))).filter(U=>!!U),B={_reason:S._reason,folderQueries:A,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:M.pattern,includePattern:L.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const U=u.coalesce(u.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(V=>V.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const K=U.filter(N=>(0,c.pathIncludedInQuery)(B,N.fsPath)),W=this.commonQueryFromFileList(K);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...B,...W}}const $=S.extraFileResources&&S.extraFileResources.filter(U=>(0,c.pathIncludedInQuery)(B,U.fsPath));return B.extraFileResources=$&&$.length?$:void 0,B}commonQueryFromFileList(h){const S=[],L=new y.ResourceMap,M={};let F=!1;return h.forEach(A=>{if(A.scheme===C.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(A)){const $=this.workspaceContextService.getWorkspaceFolder(A)?.uri??A.with({path:E.dirname(A.fsPath)});let U=L.get($);U||(F=!0,U={folder:$,includePattern:{}},S.push(U),L.set($,U));const K=E.relative($.fsPath,A.fsPath);(0,k.assertIsDefined)(U.includePattern)[K.replace(/\\/g,"/")]=!0}else A.fsPath&&(F=!0,M[A.fsPath]=!0)}),{folderQueries:S,includePattern:M,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(h,S){if(S.isSmartCase){if(h.isRegExp){if(R.containsUppercaseCharacter(h.pattern,!0))return!0}else if(R.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,T.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const S=W=>E.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),M=(Array.isArray(h)?h:r(h)).map(W=>{const N=this.pathService.resolvedUserHome;return N?(0,P.untildify)(W,N.scheme===C.Schemas.file?N.fsPath:N.path):W}),F=t.groupBy(M,W=>S(W)?"searchPaths":"exprSegments"),A=(F.exprSegments||[]).map(W=>R.rtrim(W,"/")).map(W=>R.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),o(W))),B={},$=this.expandSearchPathPatterns(F.searchPaths||[]);$&&$.length&&(B.searchPaths=$);const U=u.flatten(A),K=d(...U);return K&&(B.pattern=K),B}getExcludesForFolder(h,S){return S.disregardExcludeSettings?void 0:(0,c.getExcludes)(h,!S.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const S=u.flatten(h.map(M=>{let{pathPortion:F,globPortion:A}=a(M);A&&(A=n(A));const B=this.expandOneSearchPath(F);return u.flatten(B.map($=>this.resolveOneSearchPathPattern($,A)))})),L=new Map;return S.forEach(M=>{const F=M.searchPath.toString(),A=L.get(F);A?M.pattern&&(A.pattern=A.pattern||{},A.pattern[M.pattern]=!0):L.set(F,{searchPath:M.searchPath,pattern:M.pattern?d(M.pattern):void 0})}),Array.from(L.values())}expandOneSearchPath(h){if(E.isAbsolute(h)){const S=this.workspaceContextService.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==C.Schemas.file?[{searchPath:S[0].uri.with({path:h})}]:[{searchPath:_.URI.file(E.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const S=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=i(h),h.startsWith("../")||h===".."){const M=E.posix.resolve(S.path,h);return[{searchPath:S.with({path:M})}]}const L=n(h);return[{searchPath:S,pattern:L}]}else{if(h==="./"||h===".\\")return[];{const S=h.replace(/^\.[\/\\]/,""),M=this.workspaceContextService.getWorkspace().folders.map(F=>{const A=S.match(new RegExp(`^${R.escapeRegExpCharacters(F.name)}(?:/(.*)|$)`));return A?{match:A,folder:F}:null}).filter(k.isDefined);if(M.length)return M.map(F=>{const A=F.match[1];return{searchPath:F.folder.uri,pattern:A&&n(A)}});{const F=h.match(/\.[\/\\](.+)[\/\\]?/),A=F?F[1]:h,B=w.localize(0,null,A);throw new Error(B)}}}}resolveOneSearchPathPattern(h,S){const L=h.pattern&&S?`${h.pattern}/${S}`:h.pattern||S,M=[{searchPath:h.searchPath,pattern:L}];return L&&!L.endsWith("**")&&M.push({searchPath:h.searchPath,pattern:L+"/**"}),M}getFolderQueryForSearchPath(h,S,L){const M=this.getFolderQueryForRoot((0,f.toWorkspaceFolder)(h.searchPath),S,L,!1);return M?{...M,includePattern:h.pattern}:null}getFolderQueryForRoot(h,S,L,M){let F;const A=_.URI.isUri(h)?h:h.uri;if(L.searchPaths){const W=L.searchPaths.filter(N=>(0,I.isEqual)(N.searchPath,A))[0];if(W&&!W.pattern)return null;W&&(F=W.pattern)}const B=this.configurationService.getValue({resource:A}),U={...this.getExcludesForFolder(B,S)||{},...F||{}},K=_.URI.isUri(h)?(0,I.basename)(h):h.name;return{folder:A,folderName:M?K:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!B.search.followSymlinks}}};m=Ge([xe(0,b.IConfigurationService),xe(1,f.IWorkspaceContextService),xe(2,p.IEditorGroupsService),xe(3,g.ILogService),xe(4,v.IPathService)],m),e.QueryBuilder=m;function a(l){const h=l.match(/[\*\{\}\(\)\[\]\?]/);if(h){const S=h.index,L=l.substr(0,S).match(/[/|\\][^/\\]*$/);if(L){let M=l.substr(0,L.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:l.substr((L.index||0)+1)}}}return{pathPortion:l}}function d(...l){return l.length?l.reduce((h,S)=>(h[S]=!0,h),Object.create(null)):void 0}function r(l){return D.splitGlobAware(l,",").map(h=>h.trim()).filter(h=>!!h.length)}function o(l){return[`**/${l}/**`,`**/${l}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function i(l){return l.replace(/\\/g,"/")}function n(l){return i(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function s(l,h){l=u.distinct(l,M=>M.toString());const S=[],L=h.getWorkspace();return l&&l.forEach(M=>{let F;if(h.getWorkbenchState()===2)F=(0,I.relativePath)(L.folders[0].uri,M),F&&F!=="."&&(F="./"+F);else{const A=h.getWorkspaceFolder(M);if(A){const B=A.name;if(L.folders.filter(U=>U.name===B).length===1){const U=(0,I.relativePath)(A.uri,M);U===""?F=`./${A.name}`:F=`./${A.name}/${U}`}else F=M.fsPath}}F&&S.push(F)}),S}e.resolveResourcesForSearchIncludes=s}),define(Ie[281],ke([1,0,22,2,21,12,4,280,31,45]),function(Y,e,u,t,D,P,y,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function k(b,g){const f=g.activationEvents;if(!f)return Promise.resolve(void 0);const p=[],v=[];for(const o of f)if(/^workspaceContains:/.test(o)){const i=o.substr("workspaceContains:".length);i.indexOf("*")>=0||i.indexOf("?")>=0||b.forceUsingSearch?v.push(i):p.push(i)}if(p.length===0&&v.length===0)return Promise.resolve(void 0);let c;const m=new Promise((o,i)=>{c=o}),a=o=>c({activationEvent:o}),d=Promise.all(p.map(o=>_(b,o,a))).then(()=>{}),r=T(b,g.identifier,v,a);return Promise.all([d,r]).then(()=>{c(void 0)}),m}e.checkActivateWorkspaceContainsExtension=k;async function _(b,g,f){for(const p of b.folders)if(await b.exists(u.joinPath(t.URI.revive(p),g))){f(`workspaceContains:${g}`);return}}async function T(b,g,f,p){if(f.length===0)return Promise.resolve(void 0);const v=new D.CancellationTokenSource,c=b.checkExists(b.folders,f,v.token),m=setTimeout(async()=>{v.cancel(),b.logService.info(`Not activating extension '${g.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},R);let a=!1;try{a=await c}catch(d){P.isCancellationError(d)||P.onUnexpectedError(d)}v.dispose(),clearTimeout(m),a&&p(`workspaceContains:${f.join(",")}`)}function w(b,g,f,p){const v=b.get(y.IInstantiationService),c=b.get(E.ISearchService),a=v.createInstance(C.QueryBuilder).file(g.map(d=>(0,I.toWorkspaceFolder)(t.URI.revive(d))),{_reason:"checkExists",includePattern:f,exists:!0});return c.fileSearch(a,p).then(d=>!!d.limitHit,d=>P.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=w});var tt=this&&this.__classPrivateFieldSet||function(Y,e,u,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(Y,u):D?D.value=u:e.set(Y,u),u},Me=this&&this.__classPrivateFieldGet||function(Y,e,u,t){if(u==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!t:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?t:u==="a"?t.call(Y):t?t.value:e.get(Y)};define(Ie[39],ke([1,0,171,9,73,22,18,6,25,2,14,5,33,229,91,32,27,227,12,28,23,205,7,122,4,26,69,17,85,52,38,3,281,90,207,11]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g,f,p,v,c,m,a,d,r,o,i,n,s,l,h,S,L,M,F,A){"use strict";var B,$,U;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let K=class Tn extends C.Disposable{constructor(Q,le,pe,Z,ge,Ee,Te,Oe,ve,ue){super();this._onDidChangeRemoteConnectionData=this._register(new S.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=le,this._extHostContext=pe,this._initData=Te,this._extHostWorkspace=Z,this._extHostConfiguration=ge,this._logService=Ee,this._extHostTunnelService=ve,this._extHostTerminalService=ue,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._globalRegistry=new f.ExtensionDescriptionRegistry(this._initData.allExtensions);const de=(0,g.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new f.ExtensionDescriptionRegistry(V(this._globalRegistry,de)),this._storage=new w.ExtHostStorage(this._extHostContext),this._secretState=new M.ExtHostSecretState(this._extHostContext),this._storagePath=Oe,this._instaService=Q.createChild(new s.ServiceCollection([w.IExtHostStorage,this._storage],[M.IExtHostSecretState,this._secretState]));let we=[],ie=[];this._initData.remote.isRemote&&(we=this._initData.allExtensions.filter(J=>!J.main&&!J.browser).map(J=>J.identifier),ie=this._initData.allExtensions.filter(J=>!de.has(v.ExtensionIdentifier.toKey(J.identifier.value))).filter(J=>(J.main||J.browser)&&J.api==="none").map(J=>J.identifier));const me=(0,g.extensionIdentifiersArrayToSet)(ie);this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,we,ie,{onExtensionActivationError:(J,re,O)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(J,p.transformErrorForSerialization(re),O)},actualActivateExtension:async(J,re)=>{if(me.has(v.ExtensionIdentifier.toKey(J)))return await this._mainThreadExtensionsProxy.$activateExtension(J,re),new T.HostExtension;const O=this._myRegistry.getExtensionDescription(J);return this._activateExtension(O,re)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Q){p.onUnexpectedError(Q)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let Q=[];try{Q=this._myRegistry.getAllExtensionDescriptions().map(ge=>ge.identifier).filter(ge=>this.isActivated(ge)).map(ge=>this._deactivate(ge))}catch{}await Promise.all(Q)}terminate(Q,le=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${Q}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),p.setUnexpectedErrorHandler(Z=>{this._logService.error(Z)}),this._extHostContext.dispose();const pe=this._deactivateAll();Promise.race([(0,y.timeout)(5e3),pe]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${le}`):this._logService.info(`Extension host exiting with code ${le}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(le)})}isActivated(Q){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Q):!1}async getExtension(Q){const le=await this._mainThreadExtensionsProxy.$getExtension(Q);return le&&{...le,identifier:new v.ExtensionIdentifier(le.identifier.value),extensionLocation:I.URI.revive(le.extensionLocation)}}_activateByEvent(Q,le){return this._activator.activateByEvent(Q,le)}_activateById(Q,le){return this._activator.activateById(Q,le)}activateByIdWithErrors(Q,le){return this._activateById(Q,le).then(()=>{const pe=this._activator.getActivatedExtension(Q);if(pe.activationFailed)return Promise.reject(pe.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Q=>this._myRegistry)}getExtensionExports(Q){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(Q).exports:null}async _realPathExtensionUri(Q){if(Q.scheme!==A.Schemas.file)return Q;const le=await this._hostUtils.realpath(Q.fsPath);return I.URI.file(le)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(Q=>new q(Q))),this._extensionPathIndex}async _createExtensionPathIndex(Q){const le=E.TernarySearchTree.forUris(pe=>P.extUriBiasedIgnorePathCase.ignorePathCasing(pe));return await Promise.all(Q.map(async pe=>{if(this._getEntryPoint(pe)){const Z=await this._realPathExtensionUri(pe.extensionLocation);le.set(Z,pe)}})),le}_deactivate(Q){let le=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Q))return le;const pe=this._activator.getActivatedExtension(Q);if(!pe)return le;try{typeof pe.module.deactivate=="function"&&(le=Promise.resolve(pe.module.deactivate()).then(void 0,Z=>(this._logService.error(Z),Promise.resolve(void 0))))}catch(Z){this._logService.error(`An error occurred when deactivating the extension '${Q.value}':`),this._logService.error(Z)}try{(0,C.dispose)(pe.subscriptions)}catch(Z){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${Q.value}':`),this._logService.error(Z)}return le}async _activateExtension(Q,le){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier),this._doActivateExtension(Q,le).then(pe=>{const Z=pe.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Q.identifier,Z.codeLoadingTime,Z.activateCallTime,Z.activateResolvedTime,le),this._logExtensionActivationTimes(Q,le,"success",Z),pe},pe=>{throw this._logExtensionActivationTimes(Q,le,"failure"),pe})}_logExtensionActivationTimes(Q,le,pe,Z){const ge=W(Q,le);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ge,...Z||{},outcome:pe})}_doActivateExtension(Q,le){const pe=W(Q,le);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",pe);const Z=this._getEntryPoint(Q);if(!Z)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Q.identifier.value}, startup: ${le.startup}, activationEvent: '${le.activationEvent}'${Q.identifier.value!==le.extensionId.value?`, root cause: ${le.extensionId.value}`:""}`),this._logService.flush();const ge=new T.ExtensionActivationTimesBuilder(le.startup);return Promise.all([this._loadCommonJSModule(Q.identifier,(0,P.joinPath)(Q.extensionLocation,Z),ge),this._loadExtensionContext(Q)]).then(Ee=>(D.mark(`code/extHost/willActivateExtension/${Q.identifier.value}`),Tn._callActivate(this._logService,Q.identifier,Ee[0],Ee[1],ge))).then(Ee=>(D.mark(`code/extHost/didActivateExtension/${Q.identifier.value}`),Ee))}_loadExtensionContext(Q){const le=new m.ExtensionGlobalMemento(Q,this._storage),pe=new m.ExtensionMemento(Q.identifier.value,!1,this._storage),Z=new F.ExtensionSecrets(Q,this._secretState),ge=Q.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,Ee=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Q.identifier.value}`),Promise.all([le.whenReady,pe.whenReady,this._storagePath.whenReady]).then(()=>{const Te=this;let Oe,ve;const ue=(0,g.isProposedApiEnabled)(Q,"ipc")?this._initData.messagePorts?.get(v.ExtensionIdentifier.toKey(Q.identifier)):void 0;return Object.freeze({globalState:le,workspaceState:pe,secrets:Z,subscriptions:[],get extensionUri(){return Q.extensionLocation},get extensionPath(){return Q.extensionLocation.fsPath},asAbsolutePath(de){return t.join(Q.extensionLocation.fsPath,de)},get storagePath(){return Te._storagePath.workspaceValue(Q)?.fsPath},get globalStoragePath(){return Te._storagePath.globalValue(Q).fsPath},get logPath(){return t.join(Te._initData.logsLocation.fsPath,Q.identifier.value)},get logUri(){return I.URI.joinPath(Te._initData.logsLocation,Q.identifier.value)},get storageUri(){return Te._storagePath.workspaceValue(Q)},get globalStorageUri(){return Te._storagePath.globalValue(Q)},get extensionMode(){return ge},get extension(){return Oe===void 0&&(Oe=new N(Te,Q.identifier,Q,Ee,!1)),Oe},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(Q,"extensionRuntime"),Te.extensionRuntime},get environmentVariableCollection(){return Te._extHostTerminalService.getEnvironmentVariableCollection(Q)},get messagePassingProtocol(){if(!ve){if(!ue)return;const de=S.Event.buffer(S.Event.fromDOMEventEmitter(ue,"message",we=>we.data));ue.start(),ve={onDidReceiveMessage:de,postMessage:ue.postMessage.bind(ue)}}return ve}})})}static _callActivate(Q,le,pe,Z,ge){return pe=pe||{activate:void 0,deactivate:void 0},this._callActivateOptional(Q,le,pe,Z,ge).then(Ee=>new T.ActivatedExtension(!1,null,ge.build(),pe,Ee,Z.subscriptions))}static _callActivateOptional(Q,le,pe,Z,ge){if(typeof pe.activate=="function")try{ge.activateCallStart(),Q.trace(`ExtensionService#_callActivateOptional ${le.value}`);const Ee=typeof global=="object"?global:self,Te=pe.activate.apply(Ee,[Z]);return ge.activateCallStop(),ge.activateResolveStart(),Promise.resolve(Te).then(Oe=>(ge.activateResolveStop(),Oe))}catch(Ee){return Promise.reject(Ee)}else return Promise.resolve(pe)}_activateOneStartupFinished(Q,le){this._activateById(Q.identifier,{startup:!1,extensionId:Q.identifier,activationEvent:le}).then(void 0,pe=>{this._logService.error(pe)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const Q of this._myRegistry.getAllExtensionDescriptions())if(Q.activationEvents)for(const le of Q.activationEvents)le==="onStartupFinished"&&this._activateOneStartupFinished(Q,le)}_handleEagerExtensions(){const Q=this._activateByEvent("*",!0).then(void 0,ge=>{this._logService.error(ge)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ge=>this._handleWorkspaceContainsEagerExtensions(ge.added)));const le=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],pe=this._handleWorkspaceContainsEagerExtensions(le),Z=Promise.all([Q,pe]).then(()=>{});return Promise.race([Z,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Z}_handleWorkspaceContainsEagerExtensions(Q){return Q.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(le=>this._handleWorkspaceContainsEagerExtension(Q,le))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Q,le){if(this.isActivated(le.identifier))return;const pe=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Z={logService:this._logService,folders:Q.map(Ee=>Ee.uri),forceUsingSearch:pe,exists:Ee=>this._hostUtils.exists(Ee.fsPath),checkExists:(Ee,Te,Oe)=>this._mainThreadWorkspaceProxy.$checkExists(Ee,Te,Oe)},ge=await(0,L.checkActivateWorkspaceContainsExtension)(Z,le);if(!!ge)return this._activateById(le.identifier,{startup:!0,extensionId:le.identifier,activationEvent:ge.activationEvent}).then(void 0,Ee=>this._logService.error(Ee))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Q){throw console.error(Q),Q}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Q,extensionTestsLocationURI:le}=this._initData.environment;if(!Q||!le)throw new Error(u.localize(0,null));const pe=await this._loadCommonJSModule(null,le,new T.ExtensionActivationTimesBuilder(!1));if(!pe||typeof pe.run!="function")throw new Error(u.localize(1,null,le.toString()));return new Promise((Z,ge)=>{const Ee=(ve,ue)=>{ve?ge(ve):Z(typeof ue=="number"&&ue>0?1:0)},Te=(0,P.originalFSPath)(le),Oe=pe.run(Te,Ee);Oe&&Oe.then&&Oe.then(()=>{Z(0)}).catch(ve=>{ge(ve instanceof Error&&ve.stack?ve.stack:String(ve))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Q,le){return this._resolvers[Q]=le,(0,C.toDisposable)(()=>{delete this._resolvers[Q]})}async _activateAndGetResolver(Q){const le=Q.indexOf("+");if(le===-1)throw new Error("Not an authority that can be resolved!");const pe=Q.substr(0,le);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${pe}`,!1),{authorityPrefix:pe,resolver:this._resolvers[pe]}}async $resolveAuthority(Q,le){this._logService.info(`$resolveAuthority invoked for authority (${x(Q)})`);const{authorityPrefix:pe,resolver:Z}=await this._activateAndGetResolver(Q);if(!Z)return{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${pe}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(Z)),D.mark(`code/extHost/willResolveAuthority/${pe}`);const ge=await Z.resolve(Q,{resolveAttempt:le});D.mark(`code/extHost/didResolveAuthorityOK/${pe}`);const Ee={authority:Q,host:ge.host,port:ge.port,connectionToken:ge.connectionToken},Te={extensionHostEnv:ge.extensionHostEnv,isTrusted:ge.isTrusted,authenticationSession:ge.authenticationSessionForInitializingExtensions?{id:ge.authenticationSessionForInitializingExtensions.id,providerId:ge.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Ee,options:Te,tunnelInformation:{environmentTunnels:ge.environmentTunnels,features:ge.tunnelFeatures}}}}catch(ge){if(D.mark(`code/extHost/didResolveAuthorityError/${pe}`),ge instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:ge._code,message:ge._message,detail:ge._detail}};throw ge}}async $getCanonicalURI(Q,le){this._logService.info(`$getCanonicalURI invoked for authority (${x(Q)})`);const{resolver:pe}=await this._activateAndGetResolver(Q);if(!pe)return null;const Z=I.URI.revive(le);if(typeof pe.getCanonicalURI=="undefined")return Z;const ge=await(0,y.asPromise)(()=>pe.getCanonicalURI(Z));return ge||Z}static _applyExtensionsDelta(Q,le,pe){const Z=new f.ExtensionDescriptionRegistry(Q.getAllExtensionDescriptions());Z.deltaExtensions(pe.toAdd,pe.toRemove);const ge=(0,g.extensionIdentifiersArrayToSet)(le.getAllExtensionDescriptions().map(Te=>Te.identifier));for(const Te of pe.myToRemove)ge.delete(v.ExtensionIdentifier.toKey(Te));for(const Te of pe.myToAdd)ge.add(v.ExtensionIdentifier.toKey(Te));const Ee=V(Z,ge);return{globalRegistry:Z,myExtensions:Ee}}$startExtensionHost(Q){Q.toAdd.forEach(Z=>Z.extensionLocation=I.URI.revive(Z.extensionLocation));const{globalRegistry:le,myExtensions:pe}=Tn._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Q);return this._globalRegistry.set(le.getAllExtensionDescriptions()),this._myRegistry.set(pe),this._startExtensionHost()}$activateByEvent(Q,le){return le===1?this._activateByEvent(Q,!1):this._readyToRunExtensions.wait().then(pe=>this._activateByEvent(Q,!1))}async $activate(Q,le){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(Q)?(await this._activateById(Q,le),!0):!1}async $deltaExtensions(Q){Q.toAdd.forEach(Ee=>Ee.extensionLocation=I.URI.revive(Ee.extensionLocation));const{globalRegistry:le,myExtensions:pe}=Tn._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Q),Z=await this._createExtensionPathIndex(pe);return(await this.getExtensionPathIndex()).setSearchTree(Z),this._globalRegistry.set(le.getAllExtensionDescriptions()),this._myRegistry.set(pe),Promise.resolve(void 0)}async $test_latency(Q){return Q}async $test_up(Q){return Q.byteLength}async $test_down(Q){const le=c.VSBuffer.alloc(Q),pe=Math.random()%256;for(let Z=0;Z<Q;Z++)le.writeUInt8(pe,Z);return le}async $updateRemoteConnectionData(Q){this._remoteConnectionData=Q,this._onDidChangeRemoteConnectionData.fire()}};K=Ge([xe(0,r.IInstantiationService),xe(1,e.IHostUtils),xe(2,n.IExtHostRpcService),xe(3,b.IExtHostWorkspace),xe(4,_.IExtHostConfiguration),xe(5,R.ILogService),xe(6,o.IExtHostInitDataService),xe(7,i.IExtensionStoragePaths),xe(8,l.IExtHostTunnelService),xe(9,h.IExtHostTerminalService)],K),e.AbstractExtHostExtensionService=K;function W(te,Q){return{id:te.identifier.value,name:te.name,extensionVersion:te.version,publisherDisplayName:te.publisher,activationEvents:te.activationEvents?te.activationEvents.join(","):null,isBuiltin:te.isBuiltin,reason:Q.activationEvent,reasonId:Q.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class N{constructor(Q,le,pe,Z,ge){B.set(this,void 0),$.set(this,void 0),U.set(this,void 0),tt(this,B,Q,"f"),tt(this,$,le,"f"),tt(this,U,pe.identifier,"f"),this.id=pe.identifier.value,this.extensionUri=pe.extensionLocation,this.extensionPath=t.normalize((0,P.originalFSPath)(pe.extensionLocation)),this.packageJSON=pe,this.extensionKind=Z,this.isFromDifferentExtensionHost=ge}get isActive(){return Me(this,B,"f").isActivated(Me(this,U,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Me(this,B,"f").getExtensionExports(Me(this,U,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Me(this,B,"f").activateByIdWithErrors(Me(this,U,"f"),{startup:!1,extensionId:Me(this,$,"f"),activationEvent:"api"}),this.exports}}e.Extension=N,B=new WeakMap,$=new WeakMap,U=new WeakMap;function V(te,Q){return te.getAllExtensionDescriptions().filter(le=>Q.has(v.ExtensionIdentifier.toKey(le.identifier)))}function x(te){const Q=te.indexOf("+");return Q===-1?te:te.substring(0,Q)}class q{constructor(Q){this._searchTree=Q}setSearchTree(Q){this._searchTree=Q}findSubstr(Q){return this._searchTree.findSubstr(Q)}forEach(Q){return this._searchTree.forEach(Q)}}e.ExtensionPaths=q}),define(Ie[282],ke([1,0,73,2,5,33,27,28,17,26,4,39,40,14,8]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let b=class{constructor(m,a,d,r,o,i,n){this._apiFactory=m,this._extensionRegistry=a,this._instaService=d,this._extHostConfiguration=r,this._extHostExtensionService=o,this._initData=i,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),u.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new f(this._apiFactory,a,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(p,a)),this.register(this._instaService.createInstance(g)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(v,a,this._initData.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(const a of m.nodeModuleName)this._factories.set(a,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(a=>m.alternativeModuleName(a))}};b=Ge([xe(2,R.IInstantiationService),xe(3,P.IExtHostConfiguration),xe(4,k.IExtHostExtensionService),xe(5,I.IExtHostInitDataService),xe(6,T.ILogService)],b),e.RequireInterceptor=b;let g=class Kn{constructor(m){if(m.environment.appRoot&&Kn.aliased.size){const a=(0,w.escapeRegExpCharacters)(this.forceForwardSlashes(m.environment.appRoot.fsPath)),d="[a-z0-9_.-]",r=`@${d}+\\/${d}+|${d}+`,o="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${a}/${o}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(m){if(!this.re)return;const a=this.re.exec(this.forceForwardSlashes(m));if(!a)return;const[,d,r,o]=a,i=Kn.aliased.get(r);if(i!==void 0)return console.warn(`${r} as been renamed to ${i}, please update your imports`),d+i+o}forceForwardSlashes(m){return m.replace(/\\/g,"/")}};g.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),g=Ge([xe(0,I.IExtHostInitDataService)],g);class f{constructor(m,a,d,r,o){this._apiFactory=m,this._extensionPaths=a,this._extensionRegistry=d,this._configProvider=r,this._logService=o,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,a){const d=this._extensionPaths.findSubstr(a);if(d){let r=this._extApiImpl.get(C.ExtensionIdentifier.toKey(d.identifier));return r||(r=this._apiFactory(d,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(d.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((o,i)=>r+=`	${i} -> ${o.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(m,a,d){this._extensionPaths=m,this.nodeModuleName="keytar",this._mainThreadTelemetry=a.getProxy(D.MainContext.MainThreadTelemetry);const{environment:r}=d,o=a.getProxy(D.MainContext.MainThreadKeytar);if(r.appRoot){let i=r.appRoot.fsPath;_.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,n)=>o.$getPassword(i,n),setPassword:(i,n,s)=>o.$setPassword(i,n,s),deletePassword:(i,n)=>o.$deletePassword(i,n),findPassword:i=>o.$findPassword(i),findCredentials(i){return o.$findCredentials(i)}}}load(m,a){const d=this._extensionPaths.findSubstr(a);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(m){const a=m.length;if(a<=7||!this.alternativeNames)return;const d=a-7;if((m.charAt(d)==="/"||m.charAt(d)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}};p=Ge([xe(1,E.IExtHostRpcService),xe(2,I.IExtHostInitDataService)],p);let v=class{constructor(m,a,d){this._extensionPaths=m,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=d.getProxy(D.MainContext.MainThreadTelemetry);const r=d.getProxy(D.MainContext.MainThreadWindow);this._impl=(o,i)=>{const n=t.URI.parse(o);return i?this.callOriginal(o,i):n.scheme==="http"||n.scheme==="https"?r.$openUri(n,o,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?r.$openUri(n,o,{}):this.callOriginal(o,i)}}load(m,a,d){const r=this._extensionPaths.findSubstr(a);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=d(m),this._impl}callOriginal(m,a){return this.sendNoForwardTelemetry(),this._original(m,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};v=Ge([xe(2,E.IExtHostRpcService)],v)}),define(Ie[47],ke([1,0,78,6,9,40,4,54,55,39,7,32,220,33]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,y.createDecorator)("IExtHostVariableResolverProvider");class w extends _.AbstractVariableResolverService{constructor(f,p,v,c,m,a,d){function r(){if(v){const o=v.activeEditor();if(o)return o.document.uri;const i=c.tabGroups.all.find(n=>n.isActive)?.activeTab;if(i!==void 0){if(i.input instanceof R.TextDiffTabInput||i.input instanceof R.NotebookDiffEditorTabInput)return i.input.modified;if(i.input instanceof R.TextTabInput||i.input instanceof R.NotebookEditorTabInput||i.input instanceof R.CustomEditorTabInput)return i.input.uri}}}super({getFolderUri:o=>{const i=a.folders.filter(n=>n.name===o);if(i&&i.length>0)return i[0].uri},getWorkspaceFolderCount:()=>a.folders.length,getConfigurationValue:(o,i)=>m.getConfiguration(void 0,o).get(i),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=r();if(o)return D.normalize(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(p){const o=r();if(o){const i=p.getWorkspaceFolder(o);if(i)return D.normalize(i.uri.fsPath)}}},getSelectedText:()=>{if(v){const o=v.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(v){const o=v.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>f.getExtension(o)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(P.env))}}let b=class extends t.Disposable{constructor(f,p,v,c,m){super();this.extensionService=f,this.workspaceService=p,this.editorService=v,this.configurationService=c,this.editorTabs=m,this._resolver=new u.Lazy(async()=>{const a=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async o=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new w(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,a,r,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};b=Ge([xe(0,I.IExtHostExtensionService),xe(1,k.IExtHostWorkspace),xe(2,C.IExtHostDocumentsAndEditors),xe(3,T.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs)],b),e.ExtHostVariableResolverProviderService=b}),define(Ie[74],ke([1,0,18,3,10,2,4,5,55,39,17,7,32,127,214,33,47]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,y.createDecorator)("IExtHostDebugService");let f=class{constructor(r,o,i,n,s,l){this._workspaceService=o,this._extensionService=i,this._configurationService=n,this._editorTabs=s,this._variableResolver=l,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new t.Emitter,this._onDidTerminateDebugSession=new t.Emitter,this._onDidChangeActiveDebugSession=new t.Emitter,this._onDidReceiveDebugSessionCustomEvent=new t.Emitter,this._debugServiceProxy=r.getProxy(C.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new t.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new v(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(h=>{h.onDidChange(S=>{this.registerAllDebugTypes(h)}),this.registerAllDebugTypes(h)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(r,o){const i=r;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let n=`debug:${encodeURIComponent(i.path||"")}`,s="?";return o&&(n+=`${s}session=${encodeURIComponent(o.id)}`,s="&"),n+=`${s}ref=${i.sourceReference}`,P.URI.parse(n)}else{if(i.path)return P.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const o=[];for(const i of r.getAllExtensionDescriptions())if(i.contributes){const n=i.contributes.debuggers;if(n&&n.length>0)for(const s of n)(0,w.isDebuggerMainContribution)(s)&&o.push(s.type)}this._debugServiceProxy.$registerDebugTypes(o)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(o=>r.push(o)),r}addBreakpoints(r){this.startBreakpoints();const o=r.filter(s=>{const l=s.id;return this._breakpoints.has(l)?!1:(this._breakpoints.set(l,s),!0)});this.fireBreakpointChanges(o,[],[]);const i=[],n=new Map;for(const s of o)if(s instanceof k.SourceBreakpoint){let l=n.get(s.location.uri.toString());l||(l={type:"sourceMulti",uri:s.location.uri,lines:[]},n.set(s.location.uri.toString(),l),i.push(l)),l.lines.push({id:s.id,enabled:s.enabled,condition:s.condition,hitCondition:s.hitCondition,logMessage:s.logMessage,line:s.location.range.start.line,character:s.location.range.start.character})}else s instanceof k.FunctionBreakpoint&&i.push({type:"function",id:s.id,enabled:s.enabled,hitCondition:s.hitCondition,logMessage:s.logMessage,condition:s.condition,functionName:s.functionName});return this._debugServiceProxy.$registerBreakpoints(i)}removeBreakpoints(r){this.startBreakpoints();const o=r.filter(l=>this._breakpoints.delete(l.id));this.fireBreakpointChanges([],o,[]);const i=o.filter(l=>l instanceof k.SourceBreakpoint).map(l=>l.id),n=o.filter(l=>l instanceof k.FunctionBreakpoint).map(l=>l.id),s=o.filter(l=>l instanceof k.DataBreakpoint).map(l=>l.id);return this._debugServiceProxy.$unregisterBreakpoints(i,n,s)}startDebugging(r,o,i){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,o,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,debugUI:i.debugUI,suppressSaveBeforeStart:i.suppressSaveBeforeStart})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,o,i){if(!o)return new k.Disposable(()=>{});const n=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:n,provider:o}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,i,!!o.provideDebugConfigurations,!!o.resolveDebugConfiguration,!!o.resolveDebugConfigurationWithSubstitutedVariables,n),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(s=>s.provider!==o),this._debugServiceProxy.$unregisterDebugConfigurationProvider(n)})}registerDebugAdapterDescriptorFactory(r,o,i){if(!i)return new k.Disposable(()=>{});if(!this.definesDebugType(r,o))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${o}' debugger.`);if(this.getAdapterDescriptorFactoryByType(o))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const n=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:o,handle:n,factory:i}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(o,n),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(s=>s.factory!==i),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(n)})}registerDebugAdapterTrackerFactory(r,o){if(!o)return new k.Disposable(()=>{});const i=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:i,factory:o}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(n=>n.factory!==o)})}async $runInTerminal(r,o){return Promise.resolve(void 0)}async $substituteVariables(r,o){let i;const n=await this.getFolder(r);return n&&(i={uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(i,o)}createDebugAdapter(r,o){if(r.type==="implementation")return new m(r.implementation)}createSignService(){}async $startDASession(r,o){const i=this,n=await this.getSession(o);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(n.type),n).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${n.type}' (extension might have failed to activate)`);const l=this.convertToDto(s),h=this.createDebugAdapter(l,n);if(!h)throw new Error(`Couldn't create a debug adapter for type '${n.type}'.`);const S=h;return this._debugAdapters.set(r,S),this.getDebugAdapterTrackers(n).then(L=>(L&&this._debugAdaptersTrackers.set(r,L),S.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const F=M,A={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const B=await this._signService.sign(F.arguments.value);A.body={signature:B},S.sendResponse(A)}else throw new Error("no signer")}catch(B){A.success=!1,A.message=B.message,S.sendResponse(A)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(M),M=(0,w.convertToVSCPaths)(M,!0),i._debugServiceProxy.$acceptDAMessage(r,M)}),S.onError(M=>{L&&L.onError&&L.onError(M),this._debugServiceProxy.$acceptDAError(r,M.name,M.message,M.stack)}),S.onExit(M=>{L&&L.onExit&&L.onExit((0,D.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(r,(0,D.withNullAsUndefined)(M),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),S.startSession()))})}$sendDAMessage(r,o){o=(0,w.convertToDAPaths)(o,!1);const i=this._debugAdaptersTrackers.get(r);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(o),this._debugAdapters.get(r)?.sendMessage(o)}$stopDASession(r){const o=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),o&&o.onWillStopSession&&o.onWillStopSession();const i=this._debugAdapters.get(r);return this._debugAdapters.delete(r),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const o=[],i=[],n=[];if(r.added)for(const s of r.added){const l=s.id;if(l&&!this._breakpoints.has(l)){let h;if(s.type==="function")h=new k.FunctionBreakpoint(s.functionName,s.enabled,s.condition,s.hitCondition,s.logMessage);else if(s.type==="data")h=new k.DataBreakpoint(s.label,s.dataId,s.canPersist,s.enabled,s.hitCondition,s.condition,s.logMessage);else{const S=P.URI.revive(s.uri);h=new k.SourceBreakpoint(new k.Location(S,new k.Position(s.line,s.character)),s.enabled,s.condition,s.hitCondition,s.logMessage)}h._id=l,this._breakpoints.set(l,h),o.push(h)}}if(r.removed)for(const s of r.removed){const l=this._breakpoints.get(s);l&&(this._breakpoints.delete(s),i.push(l))}if(r.changed){for(const s of r.changed)if(s.id){const l=this._breakpoints.get(s.id);if(l){if(l instanceof k.FunctionBreakpoint&&s.type==="function"){const h=l;h.enabled=s.enabled,h.condition=s.condition,h.hitCondition=s.hitCondition,h.logMessage=s.logMessage,h.functionName=s.functionName}else if(l instanceof k.SourceBreakpoint&&s.type==="source"){const h=l;h.enabled=s.enabled,h.condition=s.condition,h.hitCondition=s.hitCondition,h.logMessage=s.logMessage,h.location=new k.Location(P.URI.revive(s.uri),new k.Position(s.line,s.character))}n.push(l)}}}this.fireBreakpointChanges(o,i,n)}$provideDebugConfigurations(r,o,i){return(0,u.asPromise)(async()=>{const n=this.getConfigProviderByHandle(r);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const s=await this.getFolder(o);return n.provideDebugConfigurations(s,i)}).then(n=>{if(!n)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return n})}$resolveDebugConfiguration(r,o,i,n){return(0,u.asPromise)(async()=>{const s=this.getConfigProviderByHandle(r);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const l=await this.getFolder(o);return s.resolveDebugConfiguration(l,i,n)})}$resolveDebugConfigurationWithSubstitutedVariables(r,o,i,n){return(0,u.asPromise)(async()=>{const s=this.getConfigProviderByHandle(r);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const l=await this.getFolder(o);return s.resolveDebugConfigurationWithSubstitutedVariables(l,i,n)})}async $provideDebugAdapter(r,o){const i=this.getAdapterDescriptorFactoryByHandle(r);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const n=await this.getSession(o);return this.getAdapterDescriptor(i,n).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${n.type}'`);return this.convertToDto(s)})}async $acceptDebugSessionStarted(r){const o=await this.getSession(r);this._onDidStartDebugSession.fire(o)}async $acceptDebugSessionTerminated(r){const o=await this.getSession(r);o&&(this._onDidTerminateDebugSession.fire(o),this._debugSessions.delete(o.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,o){(await this.getSession(r))?._acceptNameChanged(o)}async $acceptDebugSessionCustomEvent(r,o){const n={session:await this.getSession(r),event:o.event,body:o.body};this._onDidReceiveDebugSessionCustomEvent.fire(n)}convertToDto(r){if(r instanceof k.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof k.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const o=this._adapterFactories.filter(i=>i.type===r);if(o.length>0)return o[0].factory}getAdapterDescriptorFactoryByHandle(r){const o=this._adapterFactories.filter(i=>i.handle===r);if(o.length>0)return o[0].factory}getConfigProviderByHandle(r){const o=this._configProviders.filter(i=>i.handle===r);if(o.length>0)return o[0].provider}definesDebugType(r,o){if(r.contributes){const i=r.contributes.debuggers;if(i&&i.length>0){for(const n of i)if(n.label&&n.type&&n.type===o)return!0}}return!1}getDebugAdapterTrackers(r){const i=r.configuration.type,n=this._trackerFactories.filter(s=>s.type===i||s.type==="*").map(s=>(0,u.asPromise)(()=>s.factory.createDebugAdapterTracker(r)).then(l=>l,l=>null));return Promise.race([Promise.all(n).then(s=>{const l=s.filter(h=>!!h);if(l.length>0)return new c(l)}),new Promise((s,l)=>{const h=setTimeout(()=>{clearTimeout(h),l(new Error("timeout"))},1e3)})]).catch(s=>{})}async getAdapterDescriptor(r,o){const i=o.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new k.DebugAdapterServer(i));if(r){const s=await this._extensionService.getExtensionRegistry();return(0,u.asPromise)(()=>r.createDebugAdapterDescriptor(o,this.daExecutableFromPackage(o,s))).then(l=>{if(l)return l})}const n=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(o,n))}daExecutableFromPackage(r,o){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,o,i){(r.length>0||o.length>0||i.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:o,changed:i}))}async getSession(r){if(r)if(typeof r=="string"){const o=this._debugSessions.get(r);if(o)return o}else{let o=this._debugSessions.get(r.id);if(!o){const i=await this.getFolder(r.folderUri),n=r.parent?this._debugSessions.get(r.parent):void 0;o=new p(this._debugServiceProxy,r.id,r.type,r.name,i,r.configuration,n),this._debugSessions.set(o.id,o),this._debugServiceProxy.$sessionCached(o.id)}return o}throw new Error("cannot find session")}getFolder(r){if(r){const o=P.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(o)}return Promise.resolve(void 0)}};f=Ge([xe(0,R.IExtHostRpcService),xe(1,_.IExtHostWorkspace),xe(2,I.IExtHostExtensionService),xe(3,b.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs),xe(5,g.IExtHostVariableResolverProvider)],f),e.ExtHostDebugServiceBase=f;class p{constructor(r,o,i,n,s,l,h){this._debugServiceProxy=r,this._id=o,this._type=i,this._name=n,this._workspaceFolder=s,this._configuration=l,this._parentSession=h}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,o){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,o)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=p;class v{constructor(r){this.value=Object.freeze({append(o){r.$appendDebugConsole(o)},appendLine(o){this.append(o+`
`)}})}}e.ExtHostDebugConsole=v;class c{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(o=>o.onWillReceiveMessage?o.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(o=>o.onDidSendMessage?o.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(o=>o.onError?o.onError(r):void 0)}onExit(r,o){this.trackers.forEach(i=>i.onExit?i.onExit(r,o):void 0)}}class m extends T.AbstractDebugAdapter{constructor(r){super();this.implementation=r,r.onDidSendMessage(o=>{this.acceptMessage(o)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends f{constructor(r,o,i,n,s,l){super(r,o,i,n,s,l)}};a=Ge([xe(0,R.IExtHostRpcService),xe(1,_.IExtHostWorkspace),xe(2,I.IExtHostExtensionService),xe(3,b.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs),xe(5,g.IExtHostVariableResolverProvider)],a),e.WorkerExtHostDebugService=a}),define(Ie[283],ke([1,0,12,73,2,5,275,14,82,85,26,194,17,64,39]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(f,p,v,c,m){this._hostUtils=v,this._rpcProtocol=new y.RPCProtocol(f,null,c),p=b._transform(p,this._rpcProtocol);const a=new I.ServiceCollection(...(0,E.getSingletonServiceDescriptors)());a.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...p,messagePorts:m}),a.set(_.IExtHostRpcService,new _.ExtHostRpcService(this._rpcProtocol)),a.set(T.IURITransformerService,new T.URITransformerService(c)),a.set(w.IHostUtils,v);const d=new k.InstantiationService(a,!0);this._logService=d.invokeFunction(n=>n.get(C.ILogService)),t.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",p),this._extensionService=d.invokeFunction(n=>n.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const r=new WeakMap;this._extensionService.getExtensionPathIndex().then(n=>{Error.prepareStackTrace=(s,l)=>{let h="",S,L;for(const M of l)h+=`
	at ${M.toString()}`,L=M.getFileName(),!S&&L&&(S=n.findSubstr(D.URI.file(L)));return r.set(s,S),`${s.name||"Error"}: ${s.message||""}${h}`}});const o=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),i=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);u.setUnexpectedErrorHandler(n=>{const s=u.transformErrorForSerialization(n),l=r.get(n);l?o.$onExtensionRuntimeError(l.identifier,s):i.$onUnexpectedError(s)})}async asBrowserUri(f){const p=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService);return D.URI.revive(await p.$asBrowserUri(f))}terminate(f){this._extensionService.terminate(f)}static _transform(f,p){f.allExtensions.forEach(c=>c.extensionLocation=D.URI.revive(p.transformIncomingURIs(c.extensionLocation))),f.environment.appRoot=D.URI.revive(p.transformIncomingURIs(f.environment.appRoot));const v=f.environment.extensionDevelopmentLocationURI;return v&&(f.environment.extensionDevelopmentLocationURI=v.map(c=>D.URI.revive(p.transformIncomingURIs(c)))),f.environment.extensionTestsLocationURI=D.URI.revive(p.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=D.URI.revive(p.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=D.URI.revive(p.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=D.URI.revive(p.transformIncomingURIs(f.logsLocation)),f.logFile=D.URI.revive(p.transformIncomingURIs(f.logFile)),f.workspace=p.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=b}),define(Ie[284],ke([1,0,18,13,177,193,201,74,55,39,17,38,7,47,32,215,217,33]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let p=class extends C.ExtHostDebugServiceBase{constructor(d,r,o,i,n,s,l){super(d,r,o,i,s,l);this._terminalService=n,this._integratedTerminalInstances=new m}createDebugAdapter(d,r){switch(d.type){case"server":return new b.SocketDebugAdapter(d);case"pipeServer":return new b.NamedPipeDebugAdapter(d);case"executable":return new b.ExecutableDebugAdapter(d,r.type)}return super.createDebugAdapter(d,r)}daExecutableFromPackage(d,r){const o=b.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),d.type);if(o)return new _.DebugAdapterExecutable(o.command,o.args,o.options)}createSignService(){return new y.SignService}async $runInTerminal(d,r){if(d.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(B=>{this._integratedTerminalInstances.onTerminalClosed(B)}));const o=await this._configurationService.getConfigProvider(),i=this._terminalService.getDefaultShell(!0),n=this._terminalService.getDefaultShellArgs(!0),s=d.title||D.localize(0,null),l=JSON.stringify({shell:i,shellArgs:n});let h=await this._integratedTerminalInstances.checkout(l,s),S,L=!1;if(h)S=d.cwd;else{const B={shellPath:i,shellArgs:n,cwd:d.cwd,name:s,iconPath:new _.ThemeIcon("debug")};L=!0,h=this._terminalService.createTerminalFromOptions(B,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(h,l)}h.show(!0);const M=await h.processId;L?await new Promise(B=>setTimeout(B,1e3)):o.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(i.indexOf("powershell")>=0||i.indexOf("pwsh")>=0||i.indexOf("cmd.exe")>=0?h.sendText("cls"):i.indexOf("bash")>=0?h.sendText("clear"):t.isWindows?h.sendText("cls"):h.sendText("clear"));const F=(0,g.prepareCommand)(i,d.args,S,d.env);h.sendText(F);const A=this.onDidTerminateDebugSession(B=>{B.id===r&&(this._integratedTerminalInstances.free(h),A.dispose())});return M}else if(d.kind==="external")return c(d,await this._configurationService.getConfigProvider());return super.$runInTerminal(d,r)}};p=Ge([xe(0,R.IExtHostRpcService),xe(1,w.IExtHostWorkspace),xe(2,I.IExtHostExtensionService),xe(3,f.IExtHostConfiguration),xe(4,k.IExtHostTerminalService),xe(5,E.IExtHostEditorTabs),xe(6,T.IExtHostVariableResolverProvider)],p),e.ExtHostDebugService=p;let v;function c(a,d){if(!v)if(t.isWindows)v=new P.WindowsExternalTerminalService;else if(t.isMacintosh)v=new P.MacExternalTerminalService;else if(t.isLinux)v=new P.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=d.getConfiguration("terminal");return v.runInTerminal(a.title,a.cwd,a.args,a.env||{},r.external||{})}e.runInExternalTerminal=c;class m{constructor(){this._terminalInstances=new Map}async checkout(d,r){const i=[...this._terminalInstances.entries()].map(([n,s])=>(0,u.createCancelablePromise)(async l=>{if(n.name!==r||s.lastUsedAt!==-1&&await(0,g.hasChildProcesses)(await n.processId))return null;const h=Date.now();return s.lastUsedAt+m.minUseDelay>h||l.isCancellationRequested||s.config!==d?null:(s.lastUsedAt=h,n)}));return await(0,u.firstParallel)(i,n=>!!n)}insert(d,r){this._terminalInstances.set(d,{lastUsedAt:Date.now(),config:r})}free(d){const r=this._terminalInstances.get(d);r&&(r.lastUsedAt=-1)}onTerminalClosed(d){this._terminalInstances.delete(d)}}m.minUseDelay=1e3}),define(Ie[285],ke([1,0,9,2,114,32,54,33,45,38,17,26,72,11,14,67,22,81,47]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let v=class extends _.ExtHostTaskBase{constructor(m,a,d,r,o,i,n,s,l){super(m,a,d,r,o,i,n,s);this.workspaceService=d,this.variableResolver=l,a.remote.isRemote&&a.remote.authority?this.registerTaskSystem(T.Schemas.vscodeRemote,{scheme:T.Schemas.vscodeRemote,authority:a.remote.authority,platform:process.platform}):this.registerTaskSystem(T.Schemas.file,{scheme:T.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(m,a){const d=a;if(!a.execution&&d._id===void 0)throw new Error("Tasks to execute must include an execution");if(d._id!==void 0){const r=_.TaskHandleDTO.from(d,this.workspaceService),o=await this._proxy.$getTaskExecution(r);if(o.task===void 0)throw new Error("Task from execution DTO is undefined");const i=await this.getTaskExecution(o,a);return this._proxy.$executeTask(r).catch(()=>{}),i}else{const r=_.TaskDTO.from(a,m);if(r===void 0)return Promise.reject(new Error("Task is not valid"));_.CustomExecutionDTO.is(r.execution)&&await this.addCustomExecution(r,a,!1);const o=await this.getTaskExecution(await this._proxy.$getTaskExecution(r),a);return this._proxy.$executeTask(r).catch(()=>{}),o}}provideTasksInternal(m,a,d,r){const o=[];if(r)for(const i of r){this.checkDeprecation(i,d),(!i.definition||!m[i.definition.type])&&this._logService.warn(`The task [${i.source}, ${i.name}] uses an undefined task type. The task will be ignored in the future.`);const n=_.TaskDTO.from(i,d.extension);n&&(o.push(n),_.CustomExecutionDTO.is(n.execution)&&a.push(this.addCustomExecution(n,i,!0)))}return{tasks:o,extension:d.extension}}async resolveTaskInternal(m){return m}async getAFolder(m){let a=m&&m.length>0?m[0]:void 0;if(!a){const d=t.URI.file((0,f.homedir)());a=new E.WorkspaceFolder({uri:d,name:g.basename(d),index:0})}return{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(m,a){const d=t.URI.revive(m),r={process:void 0,variables:Object.create(null)},o=await this._workspaceProvider.resolveWorkspaceFolder(d),i=await this._workspaceProvider.getWorkspaceFolders2()??[],n=await this.variableResolver.getResolver(),s=o?{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(i);for(const l of a.variables)r.variables[l]=await n.resolveAsync(s,l);if(a.process!==void 0){let l;if(a.process.path!==void 0){l=a.process.path.split(u.delimiter);for(let h=0;h<l.length;h++)l[h]=await n.resolveAsync(s,l[h])}r.process=await D.win32.findExecutable(await n.resolveAsync(s,a.process.name),a.process.cwd!==void 0?await n.resolveAsync(s,a.process.cwd):void 0,l)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(m,a,d){return D.win32.findExecutable(m,a,d)}};v=Ge([xe(0,R.IExtHostRpcService),xe(1,k.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,y.IExtHostDocumentsAndEditors),xe(4,C.IExtHostConfiguration),xe(5,I.IExtHostTerminalService),xe(6,w.ILogService),xe(7,b.IExtHostApiDeprecationService),xe(8,p.IExtHostVariableResolverProvider)],v),e.ExtHostTask=v}),define(Ie[286],ke([1,0,81,47]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class D extends t.ExtHostVariableResolverProviderService{homeDir(){return(0,u.homedir)()}}e.NodeExtHostVariableResolverProviderService=D}),define(Ie[139],ke([1,0,16,18,21,49,11,9,22,10,2,31]),function(Y,e,u,t,D,P,y,C,E,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class _{constructor(v,c,m,a){this.query=v,this.provider=c,this.fileUtils=m,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(v,c){const m=this.query.folderQueries||[],a=new D.CancellationTokenSource;return c.onCancellationRequested(()=>a.cancel()),new Promise((d,r)=>{this.collector=new w(v);let o=!1;const i=(n,s)=>{if(!o&&!this.isLimitHit){const l=this.resultSize(n);g(n)&&typeof this.query.maxResults=="number"&&this.resultCount+l>this.query.maxResults&&(this.isLimitHit=!0,o=!0,a.cancel(),n=this.trimResultToSize(n,this.query.maxResults-this.resultCount));const h=this.resultSize(n);this.resultCount+=h,(h>0||!g(n))&&this.collector.add(n,s)}};Promise.all(m.map((n,s)=>this.searchInFolder(n,l=>i(l,s),a.token))).then(n=>{a.dispose(),this.collector.flush();const s=n.some(l=>!!l&&!!l.limitHit);d({limitHit:this.isLimitHit||s,messages:(0,u.flatten)(n.map(l=>l?.message?(0,I.isArray)(l.message)?l.message:[l.message]:[])),stats:{type:this.processType}})},n=>{a.dispose();const s=(0,P.toErrorMessage)(n);r(new Error(s))})})}resultSize(v){return g(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}trimResultToSize(v,c){const m=Array.isArray(v.ranges)?v.ranges:[v.ranges],a=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:m.slice(0,c),preview:{matches:a.slice(0,c),text:v.preview.text},uri:v.uri}}async searchInFolder(v,c,m){const a=new k.QueryGlobTester(this.query,v),d=[],r={report:n=>{if(!this.validateProviderResult(n))return;const s=v.folder.scheme===y.Schemas.file?(0,k.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(E.dirname(n.uri))):void 0,l=E.relativePath(v.folder,n.uri);if(l){const h=a.includedInQuery(l,C.basename(l),s);(0,t.isThenable)(h)?d.push(h.then(S=>{S&&c(n)})):h&&c(n)}}},o=this.getSearchOptionsForFolder(v),i=await this.provider.provideTextSearchResults(T(this.query.contentPattern),o,r,m);return d.length&&await Promise.all(d),i}validateProviderResult(v){if(g(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(v){const c=(0,k.resolvePatternsForProvider)(this.query.includePattern,v.includePattern),m=(0,k.resolvePatternsForProvider)(this.query.excludePattern,v.excludePattern),a={folder:R.URI.from(v.folder),excludes:m,includes:c,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.fileUtils.toCanonicalName(v.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return a.usePCRE2=this.query.usePCRE2,a}}e.TextSearchManager=_;function T(p){return{isCaseSensitive:p.isCaseSensitive||!1,isRegExp:p.isRegExp||!1,isWordMatch:p.isWordMatch||!1,isMultiline:p.isMultiline||!1,pattern:p.pattern}}class w{constructor(v){this._onResult=v,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new f(512,c=>this.sendItems(c))}add(v,c){this._currentFileMatch&&(this._currentFolderIdx!==c||!E.isEqual(this._currentUri,v.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=c,this._currentFileMatch={resource:v.uri,results:[]}),this._currentFileMatch.results.push(b(v))}pushToCollector(){const v=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,v)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(v){this._onResult(v)}}e.TextSearchResultsCollector=w;function b(p){return g(p)?{preview:{matches:(0,u.mapArrayOrNot)(p.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:p.preview.text},ranges:(0,u.mapArrayOrNot)(p.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:p.text,lineNumber:p.lineNumber}}function g(p){return!!p.preview}e.extensionResultIsMatch=g;class f{constructor(v,c){this.maxBatchSize=v,this.cb=c,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(v,c){!v||this.addItemToBatch(v,c)}addItems(v,c){!v||this.addItemsToBatch(v,c)}addItemToBatch(v,c){this.batch.push(v),this.batchSize+=c,this.onUpdate()}addItemsToBatch(v,c){this.batch=this.batch.concat(v),this.batchSize+=c,this.onUpdate()}onUpdate(){this.totalNumberCompleted<f.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},f.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=f,f.TIMEOUT=4e3,f.START_BATCH_AFTER_COUNT=50}),define(Ie[75],ke([1,0,6,5,4,279,17,64,14,2,139]),function(Y,e,u,t,D,P,y,C,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let k=class{constructor(b,g,f){this.extHostRpc=b,this._uriTransformer=g,this._logService=f,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}registerTextSearchProvider(b,g){if(this._textSearchUsedSchemes.has(b))throw new Error(`a text search provider for the scheme '${b}' is already registered`);this._textSearchUsedSchemes.add(b);const f=this._handlePool++;return this._textSearchProvider.set(f,g),this._proxy.$registerTextSearchProvider(f,this._transformScheme(b)),(0,u.toDisposable)(()=>{this._textSearchUsedSchemes.delete(b),this._textSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}registerFileSearchProvider(b,g){if(this._fileSearchUsedSchemes.has(b))throw new Error(`a file search provider for the scheme '${b}' is already registered`);this._fileSearchUsedSchemes.add(b);const f=this._handlePool++;return this._fileSearchProvider.set(f,g),this._proxy.$registerFileSearchProvider(f,this._transformScheme(b)),(0,u.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(b),this._fileSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(b,g,f,p){const v=_(f),c=this._fileSearchProvider.get(b);if(c)return this._fileSearchManager.fileSearch(v,c,m=>{this._proxy.$handleFileMatch(b,g,m.map(a=>a.resource))},p);throw new Error("unknown provider: "+b)}$clearCache(b){return this._fileSearchManager.clearCache(b),Promise.resolve(void 0)}$provideTextSearchResults(b,g,f,p){const v=this._textSearchProvider.get(b);if(!v||!v.provideTextSearchResults)throw new Error(`Unknown provider ${b}`);const c=_(f);return this.createTextSearchManager(c,v).search(a=>this._proxy.$handleTextMatch(b,g,a),p)}$enableExtensionHostSearch(){}createTextSearchManager(b,g){return new R.TextSearchManager(b,g,{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}};k=Ge([xe(0,y.IExtHostRpcService),xe(1,C.IURITransformerService),xe(2,E.ILogService)],k),e.ExtHostSearch=k;function _(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(T),extraFileResources:w.extraFileResources&&w.extraFileResources.map(b=>I.URI.revive(b))}}e.reviveQuery=_;function T(w){return{...w,folder:I.URI.revive(w.folder)}}}),define(Ie[287],ke([1,0,82,138,32,135,33,37,54,38,72,74,75,91,52,67,137,68,46,90,125,55,136,14,230,47]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g,f,p,v,c,m,a,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(d.ILoggerService,a.ExtHostLoggerService),(0,u.registerSingleton)(d.ILogService,r.ExtHostLogService),(0,u.registerSingleton)(b.IExtHostApiDeprecationService,b.ExtHostApiDeprecationService),(0,u.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,u.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,u.registerSingleton)(f.IExtHostConsumerFileSystem,f.ExtHostConsumerFileSystem),(0,u.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,u.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations),(0,u.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors),(0,u.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo),(0,u.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,u.registerSingleton)(_.IExtHostSearch,_.ExtHostSearch),(0,u.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage),(0,u.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,u.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService),(0,u.registerSingleton)(w.IExtHostTunnelService,w.ExtHostTunnelService),(0,u.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow),(0,u.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace),(0,u.registerSingleton)(v.IExtHostSecretState,v.ExtHostSecretState),(0,u.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry),(0,u.registerSingleton)(m.IExtHostEditorTabs,m.ExtHostEditorTabs),(0,u.registerSingleton)(o.IExtHostVariableResolverProvider,o.ExtHostVariableResolverProviderService)}),define(Ie[92],ke([1,0,16,14,31,71]),function(Y,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=y;function C(k,_,T,w){const b=(0,u.mapArrayOrNot)(T,E),g=new D.TextSearchMatch(_,b,w),f=g.preview.matches;return{ranges:(0,u.mapArrayOrNot)(b,I),uri:k,preview:{text:g.preview.text,matches:(0,u.mapArrayOrNot)(f,I)}}}e.createTextSearchResult=C;function E(k){return new D.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function I(k){return new P.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let R=class{constructor(_,T){this.prefix=_,this.logService=T}appendLine(_){this.logService.debug(`${this.prefix}#search`,_)}};R=Ge([xe(1,t.ILogService)],R),e.OutputChannel=R}),define(Ie[288],ke([1,0,42,9,80,30,13,8,92,289]),function(Y,e,u,t,D,P,y,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(v,c,m,a){const d=_(v,c,m,a),r=c.folder.fsPath;return{cmd:u.spawn(R,d.args,{cwd:r}),rgDiskPath:R,siblingClauses:d.siblingClauses,rgArgs:d,cwd:r}}e.spawnRipgrepCmd=k;function _(v,c,m,a){const d=["--files","--hidden","--case-sensitive"];w([c],m,!1).forEach(o=>{const i=(0,E.anchorGlob)(o);if(d.push("-g",i),y.isMacintosh){const n=(0,D.normalizeNFD)(i);n!==i&&d.push("-g",n)}});const r=T([c],a,void 0,!1);return r.globArgs.forEach(o=>{const i=`!${(0,E.anchorGlob)(o)}`;if(d.push("-g",i),y.isMacintosh){const n=(0,D.normalizeNFD)(i);n!==i&&d.push("-g",n)}}),c.disregardIgnoreFiles!==!1?d.push("--no-ignore"):c.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),c.ignoreSymlinks||d.push("--follow"),v.exists&&d.push("--quiet"),d.push("--no-config"),c.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:r.siblingClauses}}function T(v,c,m,a=!0){const d=[];let r={};return v.forEach(o=>{const i=Object.assign({},o.excludePattern||{},c||{}),n=b(i,a?o.folder.fsPath:void 0,m);d.push(...n.globArgs),n.siblingClauses&&(r=Object.assign(r,n.siblingClauses))}),{globArgs:d,siblingClauses:r}}e.foldersToRgExcludeGlobs=T;function w(v,c,m=!0){const a=[];return v.forEach(d=>{const r=Object.assign({},c||{},d.includePattern||{}),o=b(r,m?d.folder.fsPath:void 0);a.push(...o.globArgs)}),a}e.foldersToIncludeGlobs=w;function b(v,c,m){const a=[],d={};return Object.keys(v).forEach(r=>{if(m&&m.has(r)||!r)return;const o=v[r];r=f(c?g(c,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof o=="boolean"&&o?(r.startsWith("\\\\")&&(r+="**"),a.push(p(r))):o&&o.when&&(d[r]=o)}),{globArgs:a,siblingClauses:d}}function g(v,c){return t.isAbsolute(c)?c:t.join(v,c)}e.getAbsoluteGlob=g;function f(v){return v=C.rtrim(v,"\\"),C.rtrim(v,"/")}function p(v){return P.getRoot(v).toLowerCase()==="c:/"?v.replace(/^c:[/\\]/i,"/"):v}e.fixDriveC=p}),define(Ie[290],ke([1,0,42,62,9,97,16,49,36,80,30,13,50,8,10,29,31,288,105]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const v=new Set;process.on("exit",()=>{v.forEach(r=>r())});class c{constructor(o){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=o,this.filePattern=o.filePattern||"",this.includePattern=o.includePattern&&E.parse(o.includePattern),this.maxResults=o.maxResults||null,this.exists=!!o.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,p.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=o.excludePattern&&E.parse(o.excludePattern),this.folderExcludePatterns=new Map,o.folderQueries.forEach(i=>{const n=Object.assign({},i.excludePattern||{},this.config.excludePattern||{}),s=i.folder.fsPath;o.folderQueries.map(l=>l.folder.fsPath).filter(l=>l!==s).forEach(l=>{(0,R.isEqualOrParent)(l,s)&&(n[D.relative(s,l)]=!0)}),this.folderExcludePatterns.set(s,new a(n,s))})}cancel(){this.isCanceled=!0,v.forEach(o=>o())}walk(o,i,n,s,l){if(this.fileWalkSW=_.StopWatch.create(!1),this.isCanceled)return l(null,this.isLimitHit);i.forEach(h=>{const S=D.basename(h.fsPath);this.globalExcludePattern&&this.globalExcludePattern(h.fsPath,S)||this.matchFile(n,{relativePath:h.fsPath,searchPath:void 0})}),this.cmdSW=_.StopWatch.create(!1),this.parallel(o,(h,S)=>{this.call(this.cmdTraversal,this,h,n,s,L=>{if(L){const M=(0,C.toErrorMessage)(L);console.error(M),this.errors.push(M),S(L,void 0)}else S(null,void 0)})},(h,S)=>{this.fileWalkSW.stop();const L=h?y.coalesce(h)[0]:null;l(L,this.isLimitHit)})}parallel(o,i,n){const s=new Array(o.length),l=new Array(o.length);let h=!1,S=0;if(o.length===0)return n(null,[]);o.forEach((L,M)=>{i(L,(F,A)=>{if(F?(h=!0,s[M]=null,l[M]=F):(s[M]=A,l[M]=null),++S===o.length)return n(h?l:null,s)})})}call(o,i,...n){try{o.apply(i,n)}catch(s){n[n.length-1](s)}}cmdTraversal(o,i,n,s){const l=o.folder.fsPath,h=k.isMacintosh,S=()=>B&&B.kill();v.add(S);let L=W=>{v.delete(S),L=()=>{},s(W)},M="";const F=this.initDirectoryTree(),A=(0,f.spawnRipgrepCmd)(this.config,o,this.config.includePattern,this.folderExcludePatterns.get(o.folder.fsPath).expression),B=A.cmd,$=!Object.keys(A.siblingClauses).length,U=A.rgArgs.args.map(W=>W.match(/^-/)?W:`'${W}'`).join(" ");let K=`${A.rgDiskPath} ${U}
 - cwd: ${A.cwd}`;A.rgArgs.siblingClauses&&(K+=`
 - Sibling clauses: ${JSON.stringify(A.rgArgs.siblingClauses)}`),n({message:K}),this.cmdResultCount=0,this.collectStdout(B,"utf8",n,(W,N,V)=>{if(W){L(W);return}if(this.isLimitHit){L();return}const q=(M+(h?I.normalizeNFC(N||""):N)).split(`
`);if(V){const te=q.length;q[te-1]=q[te-1].trim(),q[te-1]||q.pop()}else M=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=q.length,$){for(const te of q)if(this.matchFile(i,{base:l,relativePath:te,searchPath:this.getSearchPath(o,te)}),this.isLimitHit){S();break}(V||this.isLimitHit)&&L();return}this.addDirectoryEntries(o,F,l,q,i),V&&(this.matchDirectoryTree(F,l,i),L())})}spawnFindCmd(o){const i=this.folderExcludePatterns.get(o.folder.fsPath),n=i.getBasenameTerms(),s=i.getPathTerms(),l=["-L","."];if(n.length||s.length){l.push("-not","(","(");for(const h of n)l.push("-name",h),l.push("-o");for(const h of s)l.push("-path",h),l.push("-o");l.pop(),l.push(")","-prune",")")}return l.push("-type","f"),u.spawn("find",l,{cwd:o.folder.fsPath})}readStdout(o,i,n){let s="";this.collectStdout(o,i,()=>{},(l,h,S)=>{if(l){n(l);return}s+=h,S&&n(null,s)})}collectStdout(o,i,n,s){let l=(L,M,F)=>{(L||F)&&(l=()=>{},this.cmdSW&&this.cmdSW.stop()),s(L,M,F)},h=!1;o.stdout?(this.forwardData(o.stdout,i,l),o.stdout.once("data",()=>h=!0)):n({message:"stdout is null"});let S;o.stderr?S=this.collectData(o.stderr):n({message:"stderr is null"}),o.on("error",L=>{l(L)}),o.on("close",L=>{let M;!h&&(M=this.decodeData(S,i))&&d(M)?l(new Error(`command failed with error code ${L}: ${this.decodeData(S,i)}`)):(this.exists&&L===0&&(this.isLimitHit=!0),l(null,"",!0))})}forwardData(o,i,n){const s=new P.StringDecoder(i);return o.on("data",l=>{n(null,s.write(l))}),s}collectData(o){const i=[];return o.on("data",n=>{i.push(n)}),i}decodeData(o,i){const n=new P.StringDecoder(i);return o.map(s=>n.write(s)).join("")}initDirectoryTree(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}addDirectoryEntries(o,{pathToEntries:i},n,s,l){s.indexOf(this.filePattern)!==-1&&this.matchFile(l,{base:n,relativePath:this.filePattern,searchPath:this.getSearchPath(o,this.filePattern)});const h=S=>{const L=D.basename(S),M=D.dirname(S);let F=i[M];F||(F=i[M]=[],h(M)),F.push({base:n,relativePath:S,basename:L,searchPath:this.getSearchPath(o,S)})};s.forEach(h)}matchDirectoryTree({rootEntries:o,pathToEntries:i},n,s){const l=this,h=this.folderExcludePatterns.get(n),S=this.filePattern;function L(M){l.directoriesWalked++;const F=(0,g.hasSiblingFn)(()=>M.map(A=>A.basename));for(let A=0,B=M.length;A<B;A++){const $=M[A],{relativePath:U,basename:K}=$;if(h.test(U,K,S!==K?F:void 0))continue;const W=i[U];if(W)L(W);else{if(l.filesWalked++,U===S)continue;l.matchFile(s,$)}if(l.isLimitHit)break}}L(o)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(o,i,n,s,l){const h=o.folder,S=(0,g.hasSiblingFn)(()=>n);this.parallel(n,(L,M)=>{if(this.isCanceled||this.isLimitHit)return M(null);const F=i?[i,L].join(D.sep):L;if(this.folderExcludePatterns.get(o.folder.fsPath).test(F,L,this.config.filePattern!==L?S:void 0))return M(null);const A=[h.fsPath,F].join(D.sep);t.lstat(A,(B,$)=>{if(B||this.isCanceled||this.isLimitHit)return M(null);this.statLinkIfNeeded(A,$,(U,K)=>U||this.isCanceled||this.isLimitHit?M(null):K.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(A,$,(W,N)=>W||this.isCanceled||this.isLimitHit||(N=N||"",this.walkedPaths[N])?M(null):(this.walkedPaths[N]=!0,b.Promises.readdir(A).then(V=>{if(this.isCanceled||this.isLimitHit)return M(null);this.doWalk(o,F,V,s,x=>M(x||null))},V=>{M(null)})))):(this.filesWalked++,F===this.filePattern||this.maxFilesize&&w.isNumber(K.size)&&K.size>this.maxFilesize||this.matchFile(s,{base:h.fsPath,relativePath:F,searchPath:this.getSearchPath(o,F)}),M(null,void 0)))})},L=>{const M=L&&y.coalesce(L);return l(M&&M.length>0?M[0]:void 0)})}matchFile(o,i){this.isFileMatch(i)&&(!this.includePattern||this.includePattern(i.relativePath,D.basename(i.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||o(i))}isFileMatch(o){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,g.isFilePatternMatch)(o,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(o,i,n){return i.isSymbolicLink()?t.stat(o,n):n(null,i)}realPathIfNeeded(o,i,n){return i.isSymbolicLink()?t.realpath(o,(s,l)=>s?n(s):n(null,l)):n(null,o)}getSearchPath(o,i){return o.folderName?D.join(o.folderName,i):i}}e.FileWalker=c;class m{constructor(o){this.folderQueries=o.folderQueries,this.extraFiles=o.extraFileResources||[],this.walker=new c(o)}search(o,i,n){this.walker.walk(this.folderQueries,this.extraFiles,o,i,(s,l)=>{n(s,{limitHit:l,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class a{constructor(o,i){this.expression=o,this.root=i,this.init(o)}init(o){let i,n;Object.keys(o).filter(s=>o[s]).forEach(s=>{D.isAbsolute(s)?(i=i||E.getEmptyExpression(),i[s]=o[s]):(n=n||E.getEmptyExpression(),n[s]=o[s])}),this.absoluteParsedExpr=i&&E.parse(i,{trimForExclusions:!0}),this.relativeParsedExpr=n&&E.parse(n,{trimForExclusions:!0})}test(o,i,n){return this.relativeParsedExpr&&this.relativeParsedExpr(o,i,n)||this.absoluteParsedExpr&&this.absoluteParsedExpr(D.join(this.root,o),i,n)}getBasenameTerms(){const o=[];return this.absoluteParsedExpr&&o.push(...E.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&o.push(...E.getBasenameTerms(this.relativeParsedExpr)),o}getPathTerms(){const o=[];return this.absoluteParsedExpr&&o.push(...E.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&o.push(...E.getPathTerms(this.relativeParsedExpr)),o}}function d(r){const o=r.trim().split(`
`),i=o[0].trim();if(i.startsWith("Error parsing regex"))return i;if(i.startsWith("regex parse error"))return T.uppercaseFirstLetter(o[o.length-1].trim());if(i.startsWith("error parsing glob")||i.startsWith("unsupported encoding"))return i.charAt(0).toUpperCase()+i.substr(1);if(i==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(i.startsWith("Literal "))return i}e.rgErrorMsgForDisplay=d}),define(Ie[291],ke([1,0,95,23]),function(Y,e,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function D(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(o=>o===r)}e.isUTFEncoding=D,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const P=512,y=512,C=512*8,E=512*128;var I;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class R extends Error{constructor(o,i){super(o);this.decodeStreamErrorKind=i}}e.DecodeStreamError=R;class k{constructor(o){this.iconvLiteDecoder=o}static async create(o){let i;if(o!==e.UTF8)i=(await new Promise((s,l)=>{Y(["@vscode/iconv-lite-umd"],s,l)})).getDecoder(b(o));else{const n=new TextDecoder;i={write(s){return n.decode(s,{stream:!0})},end(){return n.decode()}}}return new k(i)}write(o){return this.iconvLiteDecoder.write(o)}end(){return this.iconvLiteDecoder.end()}}function _(r,o){const i=o.minBytesRequiredForDetection??o.guessEncoding?C:y;return new Promise((n,s)=>{const l=(0,u.newWriteableStream)(A=>A.join("")),h=[];let S=0,L,M;const F=async()=>{try{const A=await d({buffer:t.VSBuffer.concat(h),bytesRead:S},o.guessEncoding);if(A.seemsBinary&&o.acceptTextOnly)throw new R("Stream is binary but only text is accepted for decoding",1);A.encoding=await o.overwriteEncoding(A.encoding),L=await k.create(A.encoding);const B=L.write(t.VSBuffer.concat(h).buffer);l.write(B),h.length=0,S=0,n({stream:l,detected:A})}catch(A){M?.dispose(),l.destroy(),s(A)}};M=(0,u.listenStream)(r,{onData:async A=>{L?l.write(L.write(A.buffer)):(h.push(A),S+=A.byteLength,S>=i&&(r.pause(),await F(),setTimeout(()=>r.resume())))},onError:A=>l.error(A),onEnd:async()=>{L||await F(),l.end(L?.end())}})})}e.toDecodeStream=_;async function T(r,o,i){const s=(await new Promise((S,L)=>{Y(["@vscode/iconv-lite-umd"],S,L)})).getEncoder(b(o),i);let l=!1,h=!1;return{read(){if(h)return null;const S=r.read();if(typeof S!="string"){if(h=!0,!l&&i?.addBOM)switch(o){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const L=s.end();return L&&L.length>0?(l=!0,t.VSBuffer.wrap(L)):null}return l=!0,t.VSBuffer.wrap(s.write(S))}}}e.toEncodeReadable=T;async function w(r){return(await new Promise((i,n)=>{Y(["@vscode/iconv-lite-umd"],i,n)})).encodingExists(b(r))}e.encodingExists=w;function b(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=b;function g(r,o){if(!r||o<e.UTF16be_BOM.length)return null;const i=r.readUInt8(0),n=r.readUInt8(1);if(i===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(i===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(o<e.UTF8_BOM.length)return null;const s=r.readUInt8(2);return i===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&s===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=g;const f=["ascii","utf-16","utf-32"];async function p(r){const o=await new Promise((h,S)=>{Y(["jschardet"],h,S)}),i=r.slice(0,E),n=m(i.buffer),s=o.detect(n);if(!s||!s.encoding)return null;const l=s.encoding.toLowerCase();return 0<=f.indexOf(l)?null:c(s.encoding)}const v={ibm866:"cp866",big5:"cp950"};function c(r){const o=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return v[o]||o}function m(r){let o="";for(let i=0;i<r.length;i++)o+=String.fromCharCode(r[i]);return o}function a(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const o=r.match(/windows(\d+)/);return o?"windows-"+o[1]:r}}}e.toCanonicalName=a;function d({buffer:r,bytesRead:o},i){let n=g(r,o),s=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&r){let l=!0,h=!0,S=!1;for(let L=0;L<o&&L<P;L++){const M=L%2==1,F=r.readUInt8(L)===0;if(F&&(S=!0),l&&(M&&!F||!M&&F)&&(l=!1),h&&(M&&F||!M&&!F)&&(h=!1),F&&!l&&!h)break}S&&(l?n=e.UTF16le:h?n=e.UTF16be:s=!0)}return i&&!s&&!n&&r?p(r.slice(0,o)).then(l=>({seemsBinary:!1,encoding:l})):{seemsBinary:s,encoding:n}}e.detectEncodingFromBuffer=d,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ie[140],ke([1,0,291,29,139]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends D.TextSearchManager{constructor(C,E,I=t,R="searchProcess"){super(C,E,{readdir:k=>I.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,u.toCanonicalName)(k)},R)}}e.NativeTextSearchManager=P}),define(Ie[292],ke([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class u{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(D){if(D&&this._dragOperations.has(D)){const P=this._dragOperations.get(D);return this._dragOperations.delete(D),P}}addDragOperationTransfer(D,P){this._dragOperations.set(D,P)}getRenderedTreeElement(D){if(this._renderedElements.has(D))return this._renderedElements.get(D)}addRenderedTreeItemElement(D,P){this._renderedElements.set(D,P)}removeRenderedTreeItemElement(D){this._renderedElements.has(D)&&this._renderedElements.delete(D)}}e.TreeviewsService=u}),define(Ie[293],ke([1,0,175,7,22,2,3,6,18,7,10,16,15,21,292,27]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(v,c){if((0,R.isString)(v))return{label:v};if(v&&typeof v=="object"&&typeof v.label=="string"){let m;return Array.isArray(v.highlights)&&(m=v.highlights.filter(a=>a.length===2&&typeof a[0]=="number"&&typeof a[1]=="number"),m=m.length?m:void 0),{label:v.label,highlights:m}}}class f{constructor(c,m,a){this._proxy=c,this.commands=m,this.logService=a,this.treeViews=new Map,this.treeDragAndDropService=new w.TreeviewsService;function d(r){return r&&r.$treeViewId&&r.$treeItemHandle}m.registerArgumentProcessor({processArgument:r=>d(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(o=>d(o)?this.convertArgument(o):o):r})}registerTreeDataProvider(c,m,a){const d=this.createTreeView(c,{treeDataProvider:m},a);return{dispose:()=>d.dispose()}}createTreeView(c,m,a){if(!m||!m.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=m.dragAndDropController?.dropMimeTypes??[],r=m.dragAndDropController?.dragMimeTypes??[],o=!!m.dragAndDropController?.handleDrag,i=!!m.dragAndDropController?.handleDrop,n=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!m.showCollapseAll,canSelectMany:!!m.canSelectMany,dropMimeTypes:d,dragMimeTypes:r,hasHandleDrag:o,hasHandleDrop:i}),s=this.createExtHostTreeView(c,m,a);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(l){s.message=l},get title(){return s.title},set title(l){s.title=l},get description(){return s.description},set description(l){s.description=l},get badge(){return(0,b.checkProposedApiEnabled)(a,"badges"),s.badge},set badge(l){(0,b.checkProposedApiEnabled)(a,"badges"),s.badge=l},reveal:(l,h)=>s.reveal(l,h),dispose:async()=>{await n,this.treeViews.delete(c),s.dispose()}}}$getChildren(c,m){const a=this.treeViews.get(c);return a?a.getChildren(m):Promise.reject(new Error((0,u.localize)(0,null,c)))}async $handleDrop(c,m,a,d,r,o,i,n){const s=this.treeViews.get(c);if(!s)return Promise.reject(new Error((0,u.localize)(1,null,c)));const l=_.DataTransfer.toDataTransfer(a,async h=>(await this._proxy.$resolveDropFileData(c,m,h)).buffer);return i===c&&n&&await this.addAdditionalTransferItems(l,s,n,r,o),s.onDrop(l,d,r)}async addAdditionalTransferItems(c,m,a,d,r){const o=this.treeDragAndDropService.removeDragOperationTransfer(r);if(o)(await o)?.forEach((i,n)=>{i&&c.set(n,i)});else if(r&&m.handleDrag){const i=m.handleDrag(a,c,d);this.treeDragAndDropService.addDragOperationTransfer(r,i),await i}return c}async $handleDrag(c,m,a,d){const r=this.treeViews.get(c);if(!r)return Promise.reject(new Error((0,u.localize)(2,null,c)));const o=await this.addAdditionalTransferItems(new t.DataTransfer,r,m,d,a);if(!!o)return _.DataTransfer.toDataTransferDTO(o)}async $hasResolve(c){const m=this.treeViews.get(c);if(!m)throw new Error((0,u.localize)(3,null,c));return m.hasResolve}$resolve(c,m,a){const d=this.treeViews.get(c);if(!d)throw new Error((0,u.localize)(4,null,c));return d.resolveTreeItem(m,a)}$setExpanded(c,m,a){const d=this.treeViews.get(c);if(!d)throw new Error((0,u.localize)(5,null,c));d.setExpanded(m,a)}$setSelection(c,m){const a=this.treeViews.get(c);if(!a)throw new Error((0,u.localize)(6,null,c));a.setSelection(m)}$setVisible(c,m){const a=this.treeViews.get(c);if(!a)throw new Error((0,u.localize)(7,null,c));a.setVisible(m)}createExtHostTreeView(c,m,a){const d=new p(c,m,this._proxy,this.commands.converter,this.logService,a);return this.treeViews.set(c,d),d}convertArgument(c){const m=this.treeViews.get(c.$treeViewId);return m?m.getExtensionElement(c.$treeItemHandle):null}}e.ExtHostTreeViews=f;class p extends C.Disposable{constructor(c,m,a,d,r,o){super();if(this.viewId=c,this.proxy=a,this.commands=d,this.logService=r,this.extension=o,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new T.CancellationTokenSource,o.contributes&&o.contributes.views)for(const s in o.contributes.views)for(const l of o.contributes.views[s])l.id===c&&(this._title=l.name);this.dataProvider=m.treeDataProvider,this.dndController=m.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let i,n;this._register(y.Event.debounce(this._onDidChangeData.event,(s,l)=>(s||(s={message:!1,elements:[]}),l.element!==!1&&(i||(i=new Promise(h=>n=h),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(l.element)?s.elements.push(...l.element):s.elements.push(l.element)),l.message&&(s.message=!0),s),200,!0)(({message:s,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=n;return i=null,this.refresh(l).then(()=>h())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,R.isUndefinedOrNull)(c))}async getChildren(c){const m=c?this.getExtensionElement(c):void 0;if(c&&!m)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let a=this.getChildrenNodes(c);return a||(a=await this.fetchChildrenNodes(m)),a?a.map(d=>d.item):void 0}getExtensionElement(c){return this.elements.get(c)}reveal(c,m){m=m||{select:!0,focus:!1};const a=(0,R.isUndefinedOrNull)(m.select)?!0:m.select,d=(0,R.isUndefinedOrNull)(m.focus)?!1:m.focus,r=(0,R.isUndefinedOrNull)(m.expand)?!1:m.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(o=>this.resolveTreeNode(c,o[o.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:o.map(n=>n.item)},{select:a,focus:d,expand:r})),o=>this.logService.error(o)):this.proxy.$reveal(this.viewId,void 0,{select:a,focus:d,expand:r})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}get badge(){return this._badge}set badge(c){this._badge?.value===c?.value&&this._badge?.tooltip===c?.tooltip||(this._badge=_.ViewBadge.from(c),this.proxy.$setBadge(this.viewId,c))}setExpanded(c,m){const a=this.getExtensionElement(c);a&&(m?this._onDidExpandElement.fire(Object.freeze({element:a})):this._onDidCollapseElement.fire(Object.freeze({element:a})))}setSelection(c){(0,k.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(c,m,a){const d=[];for(const r of c){const o=this.getExtensionElement(r);o&&d.push(o)}if(!(!this.dndController?.handleDrag||d.length===0))return await this.dndController.handleDrag(d,m,a),m}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(c,m,a){const d=m?this.getExtensionElement(m):void 0;if(!(!d&&m||!this.dndController?.handleDrop))return(0,E.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(d,c,a):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,m){if(!this.dataProvider.resolveTreeItem)return;const a=this.elements.get(c);if(a){const d=this.nodes.get(a);if(d){const r=await this.dataProvider.resolveTreeItem(d.extensionItem,a,m)??d.extensionItem;return this.validateTreeItem(r),d.item.tooltip=this.getTooltip(r.tooltip),d.item.command=this.getCommand(d.disposableStore,r.command),d.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(m=>m?this.resolveUnknownParentChain(m).then(a=>this.resolveTreeNode(m,a[a.length-1]).then(d=>(a.push(d),a))):Promise.resolve([]))}resolveParent(c){const m=this.nodes.get(c);return m?Promise.resolve(m.parent?this.elements.get(m.parent.item.handle):void 0):(0,E.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,m){const a=this.nodes.get(c);return a?Promise.resolve(a):(0,E.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(d=>this.createHandle(c,d,m,!0)).then(d=>this.getChildren(m?m.item.handle:void 0).then(()=>{const r=this.getExtensionElement(d);if(r){const o=this.nodes.get(r);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(c){if(c){let m;if(typeof c=="string"){const a=this.getExtensionElement(c);m=a?this.nodes.get(a):void 0}else m=c;return m&&m.children||void 0}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const m=new T.CancellationTokenSource(this._refreshCancellationSource.token);try{const a=c?this.nodes.get(c):void 0,d=await this.dataProvider.getChildren(c);if(m.token.isCancellationRequested)return;const r=await Promise.all((0,k.coalesce)(d||[]).map(async o=>{const i=await this.dataProvider.getTreeItem(o);return i&&!m.token.isCancellationRequested?this.createAndRegisterTreeNode(o,i,a):null}));return m.token.isCancellationRequested?void 0:(0,k.coalesce)(r)}finally{m.dispose()}}refresh(c){if(c.some(a=>!a))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new T.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const a=this.getHandlesToRefresh(c);if(a.length)return this.refreshHandles(a)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const m=new Set,a=c.map(r=>this.nodes.get(r));for(const r of a)if(r&&!m.has(r.item.handle)){let o=r;for(;o&&o.parent&&a.findIndex(i=>o&&o.parent&&i&&i.item.handle===o.parent.item.handle)===-1;){const i=this.elements.get(o.parent.item.handle);o=i?this.nodes.get(i):void 0}o&&!o.parent&&m.add(r.item.handle)}const d=[];return m.forEach(r=>{const o=this.elements.get(r);if(o){const i=this.nodes.get(o);i&&(!i.parent||!m.has(i.parent.item.handle))&&d.push(r)}}),d}refreshHandles(c){const m={};return Promise.all(c.map(a=>this.refreshNode(a).then(d=>{d&&(m[a]=d.item)}))).then(()=>Object.keys(m).length?this.proxy.$refresh(this.viewId,m):void 0)}refreshNode(c){const m=this.getExtensionElement(c);if(m){const a=this.nodes.get(m);if(a)return this.clearChildren(m),(0,E.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(d=>{if(d){const r=this.createTreeNode(m,d,a.parent);return this.updateNodeCache(m,r,a,a.parent),a.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,m,a){const d=this.createTreeNode(c,m,a);if(m.id&&this.elements.has(d.item.handle))throw new Error((0,u.localize)(8,null,m.id));return this.addNodeToCache(c,d),this.addNodeToParentCache(d,a),d}getTooltip(c){return I.MarkdownString.isMarkdownString(c)?_.MarkdownString.from(c):c}getCommand(c,m){return m?this.commands.toInternal(m,c):void 0}validateTreeItem(c){I.TreeItem.isTreeItem(c)||console.log(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(c,m,a){this.validateTreeItem(m);const d=new C.DisposableStore,r=this.createHandle(c,m,a),o=this.getLightIconPath(m);return{item:{handle:r,parentHandle:a?a.item.handle:void 0,label:g(m.label,this.extension),description:m.description,resourceUri:m.resourceUri,tooltip:this.getTooltip(m.tooltip),command:this.getCommand(d,m.command),contextValue:m.contextValue,icon:o,iconDark:this.getDarkIconPath(m)||o,themeIcon:this.getThemeIcon(m),collapsibleState:(0,R.isUndefinedOrNull)(m.collapsibleState)?I.TreeItemCollapsibleState.None:m.collapsibleState,accessibilityInformation:m.accessibilityInformation},extensionItem:m,parent:a,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(c){return c.iconPath instanceof I.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:m,label:a,resourceUri:d},r,o){if(m)return`${p.ID_HANDLE_PREFIX}/${m}`;const i=g(a,this.extension),n=r?r.item.handle:p.LABEL_HANDLE_PREFIX;let s=i?i.label:d?(0,D.basename)(d):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const l=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,h=this.getChildrenNodes(r)||[];let S,L=0;do{if(S=`${n}/${L}:${s}`,o||!this.elements.has(S)||l===S)break;L++}while(L<=h.length);return S}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof I.ThemeIcon))return typeof c.iconPath=="string"||P.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof I.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return P.URI.isUri(c)?c:P.URI.file(c)}addNodeToCache(c,m){this.elements.set(m.item.handle,c),this.nodes.set(c,m)}updateNodeCache(c,m,a,d){this.elements.delete(m.item.handle),this.nodes.delete(c),m.item.handle!==a.item.handle&&this.elements.delete(a.item.handle),this.addNodeToCache(c,m);const r=this.getChildrenNodes(d)||[],o=r.filter(i=>i.item.handle===a.item.handle)[0];o&&r.splice(r.indexOf(o),1,m)}addNodeToParentCache(c,m){m?(m.children||(m.children=[]),m.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const m=this.nodes.get(c);if(m){if(m.children)for(const a of m.children){const d=this.elements.get(a.item.handle);d&&this.clear(d)}m.children=void 0}}else this.clearAll()}clear(c){const m=this.nodes.get(c);if(m){if(m.children)for(const a of m.children){const d=this.elements.get(a.item.handle);d&&this.clear(d)}this.nodes.delete(c),this.elements.delete(m.item.handle),m.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}p.LABEL_HANDLE_PREFIX="0",p.ID_HANDLE_PREFIX="1"}),define(Ie[294],ke([1,0,21,12,3,41,2,115,100,148,157,43,5,134,239,238,37,240,33,242,243,244,222,245,54,39,246,247,250,251,252,138,225,256,257,258,91,38,260,293,15,7,263,70,137,32,212,249,123,135,72,74,75,14,64,17,26,253,208,52,67,236,261,69,68,266,264,265,237,46,259,262,90,55,125,254,71,255,11,118,224,206,248,6,27,213,8]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g,f,p,v,c,m,a,d,r,o,i,n,s,l,h,S,L,M,F,A,B,$,U,K,W,N,V,x,q,te,Q,le,pe,Z,ge,Ee,Te,Oe,ve,ue,de,we,ie,me,J,re,O,H,G,X,he,be,ae,De,Ce,ze,Ke,Ne,Ye,ee,oe,ye,We,ce,Ae,Be,qe,je,Ve,nt,ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function st(it){const at=it.get(de.IExtHostInitDataService),vt=it.get(De.IExtHostFileSystemInfo),Pt=it.get(G.IExtHostConsumerFileSystem),yt=it.get(o.IExtHostExtensionService),ft=it.get(te.IExtHostWorkspace),kt=it.get(Ye.IExtHostTelemetry),Mt=it.get(p.IExtHostConfiguration),Lt=it.get(ve.IURITransformerService),Xe=it.get(ue.IExtHostRpcService),At=it.get(B.IExtHostStorage),Nt=it.get(H.IExtensionStoragePaths),Ot=it.get(Oe.ILoggerService),gt=it.get(Oe.ILogService),Dt=it.get(me.IExtHostTunnelService),Pe=it.get(J.IExtHostApiDeprecationService),Le=it.get(q.IExtHostWindow),Se=it.get(Ke.IExtHostSecretState),ne=it.get(Ne.IExtHostEditorTabs);Xe.set(_.ExtHostContext.ExtHostFileSystemInfo,vt),Xe.set(_.ExtHostContext.ExtHostLogLevelServiceShape,Ot),Xe.set(_.ExtHostContext.ExtHostWorkspace,ft),Xe.set(_.ExtHostContext.ExtHostConfiguration,Mt),Xe.set(_.ExtHostContext.ExtHostExtensionService,yt),Xe.set(_.ExtHostContext.ExtHostStorage,At),Xe.set(_.ExtHostContext.ExtHostTunnelService,Dt),Xe.set(_.ExtHostContext.ExtHostWindow,Le),Xe.set(_.ExtHostContext.ExtHostSecretState,Se),Xe.set(_.ExtHostContext.ExtHostTelemetry,kt),Xe.set(_.ExtHostContext.ExtHostEditorTabs,ne);const Fe=Xe.set(_.ExtHostContext.ExtHostDecorations,it.get(Z.IExtHostDecorations)),He=Xe.set(_.ExtHostContext.ExtHostDocumentsAndEditors,it.get(r.IExtHostDocumentsAndEditors)),et=Xe.set(_.ExtHostContext.ExtHostCommands,it.get(g.IExtHostCommands)),Ze=Xe.set(_.ExtHostContext.ExtHostTerminalService,it.get($.IExtHostTerminalService)),Je=Xe.set(_.ExtHostContext.ExtHostDebugService,it.get(Ee.IExtHostDebugService)),bt=Xe.set(_.ExtHostContext.ExtHostSearch,it.get(Te.IExtHostSearch)),Et=Xe.set(_.ExtHostContext.ExtHostTask,it.get(ge.IExtHostTask)),St=Xe.set(_.ExtHostContext.ExtHostOutputService,it.get(S.IExtHostOutputService)),mt=Xe.set(_.ExtHostContext.ExtHostUrls,new V.ExtHostUrls(Xe)),ht=Xe.set(_.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(Xe,He)),Yt=Xe.set(_.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(Xe,He,gt)),qt=Xe.set(_.ExtHostContext.ExtHostDocumentSaveParticipant,new a.ExtHostDocumentSaveParticipant(gt,ht,Xe.getProxy(_.MainContext.MainThreadBulkEdits))),wt=Xe.set(_.ExtHostContext.ExtHostNotebook,new we.ExtHostNotebookController(Xe,et,He,ht,Nt)),$t=Xe.set(_.ExtHostContext.ExtHostNotebookDocuments,new Be.ExtHostNotebookDocuments(wt)),nn=Xe.set(_.ExtHostContext.ExtHostNotebookEditors,new Ae.ExtHostNotebookEditors(gt,wt)),rn=Xe.set(_.ExtHostContext.ExtHostNotebookKernels,new ee.ExtHostNotebookKernels(Xe,at,wt,et,gt)),Ht=Xe.set(_.ExtHostContext.ExtHostNotebookRenderers,new ye.ExtHostNotebookRenderers(Xe,wt)),Tt=Xe.set(_.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(Xe,He)),Sn=Xe.set(_.ExtHostContext.ExtHostTreeViews,new K.ExtHostTreeViews(Xe.getProxy(_.MainContext.MainThreadTreeViews),et,gt)),fn=Xe.set(_.ExtHostContext.ExtHostEditorInsets,new Q.ExtHostEditorInsets(Xe.getProxy(_.MainContext.MainThreadEditorInsets),Tt,at.remote)),Ut=Xe.set(_.ExtHostContext.ExtHostDiagnostics,new v.ExtHostDiagnostics(Xe,gt,vt)),Jt=Xe.set(_.ExtHostContext.ExtHostLanguages,new l.ExtHostLanguages(Xe,ht,et.converter,Lt)),dt=Xe.set(_.ExtHostContext.ExtHostLanguageFeatures,new s.ExtHostLanguageFeatures(Xe,Lt,ht,et,Ut,gt,Pe)),mn=Xe.set(_.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(Xe,dt)),Bt=Xe.set(_.ExtHostContext.ExtHostFileSystemEventService,new n.ExtHostFileSystemEventService(Xe,gt,He)),Gt=Xe.set(_.ExtHostContext.ExtHostQuickOpen,(0,M.createExtHostQuickOpen)(Xe,ft,et)),sn=Xe.set(_.ExtHostContext.ExtHostSCM,new F.ExtHostSCM(Xe,et,gt)),gn=Xe.set(_.ExtHostContext.ExtHostComments,(0,f.createExtHostComments)(Xe,et,ht)),on=Xe.set(_.ExtHostContext.ExtHostProgress,new L.ExtHostProgress(Xe.getProxy(_.MainContext.MainThreadProgress))),Pn=Xe.set(_.ExtHostContext.ExtHosLabelService,new le.ExtHostLabelService(Xe)),yn=Xe.set(_.ExtHostContext.ExtHostTheming,new ie.ExtHostTheming(Xe)),Zt=Xe.set(_.ExtHostContext.ExtHostAuthentication,new re.ExtHostAuthentication(Xe)),pn=Xe.set(_.ExtHostContext.ExtHostTimeline,new O.ExtHostTimeline(Xe,et)),en=Xe.set(_.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(Xe,at.remote,ft,gt,Pe)),tn=Xe.set(_.ExtHostContext.ExtHostWebviewPanels,new be.ExtHostWebviewPanels(Xe,en,ft)),An=Xe.set(_.ExtHostContext.ExtHostCustomEditors,new he.ExtHostCustomEditors(Xe,ht,Nt,en,tn)),vn=Xe.set(_.ExtHostContext.ExtHostWebviewViews,new X.ExtHostWebviewViews(Xe,en)),Kt=Xe.set(_.ExtHostContext.ExtHostTesting,new Ce.ExtHostTesting(Xe,et)),Rn=Xe.set(_.ExtHostContext.ExtHostUriOpeners,new ze.ExtHostUriOpeners(Xe));Xe.set(_.ExtHostContext.ExtHostInteractive,new qe.ExtHostInteractive(Xe,wt,He,et,gt));const Ln=Object.values(_.ExtHostContext);Xe.assertRegistered(Ln);const On=new ae.ExtHostBulkEdits(Xe,He),Nn=new b.ExtHostClipboard(Xe),wn=new h.ExtHostMessageService(Xe,gt),Cn=new c.ExtHostDialogs(Xe),an=new A.ExtHostStatusBar(Xe,et.converter);return w.ExtHostApiCommands.register(et),function($e,xt,Dn){const pt=function(){let fe=!$e.isUnderDevelopment;function _e(){fe||(gt.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),fe=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")_e();else{const _t=ct;typeof _t.scheme=="undefined"&&_e(),typeof _t.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return ct}}(),cn={getSession(fe,_e,Ue){return Zt.getSession($e,fe,_e,Ue)},async hasSession(fe,_e){return(0,Ve.checkProposedApiEnabled)($e,"authSession"),!!await Zt.getSession($e,fe,_e,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(fe,_e,Ue,ct){return Zt.registerAuthenticationProvider(fe,_e,Ue,ct)}},Fn={registerCommand(fe,_e,Ue){return et.registerCommand(!0,fe,_e,Ue,void 0,$e)},registerTextEditorCommand(fe,_e,Ue){return et.registerCommand(!0,fe,(...ct)=>{const _t=Tt.getActiveTextEditor();if(!_t){gt.warn("Cannot execute "+fe+" because there is no active text editor.");return}return _t.edit(It=>{_e.apply(Ue,[_t,It,...ct])}).then(It=>{It||gt.warn("Edits from command "+fe+" were not applied.")},It=>{gt.warn("An error occurred while running command "+fe,It)})},void 0,void 0,$e)},registerDiffInformationCommand:(fe,_e,Ue)=>((0,Ve.checkProposedApiEnabled)($e,"diffCommand"),et.registerCommand(!0,fe,async(...ct)=>{const _t=He.activeEditor(!0);if(!_t){gt.warn("Cannot execute "+fe+" because there is no active text editor.");return}const It=await Tt.getDiffInformation(_t.id);_e.apply(Ue,[It,...ct])},void 0,void 0,$e)),executeCommand(fe,..._e){return et.executeCommand(fe,..._e)},getCommands(fe=!1){return et.getCommands(fe)}},In={get machineId(){return at.telemetryInfo.machineId},get sessionId(){return at.telemetryInfo.sessionId},get language(){return at.environment.appLanguage},get appName(){return at.environment.appName},get appRoot(){return at.environment.appRoot?.fsPath??""},get appHost(){return at.environment.appHost},get uriScheme(){return at.environment.appUriScheme},get clipboard(){return Nn.value},get shell(){return Ze.getDefaultShell(!1)},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)($e,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)($e,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const fe=Date.now()-new Date(at.telemetryInfo.firstSessionDate).getTime();return isNaN(fe)?!1:fe<1e3*60*60*24},openExternal(fe,_e){return Le.openUri(fe,{allowTunneling:!!at.remote.authority,allowContributedOpeners:_e?.allowContributedOpeners})},async asExternalUri(fe){if(fe.scheme===at.environment.appUriScheme)return mt.createAppUri(fe);try{return await Le.asExternalUri(fe,{allowTunneling:!!at.remote.authority})}catch(_e){if((0,ce.matchesScheme)(fe,We.Schemas.http)||(0,ce.matchesScheme)(fe,We.Schemas.https))return fe;throw _e}},get remoteName(){return(0,pe.getRemoteName)(at.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)($e,"resolvers"),at.remote.authority},get uiKind(){return at.uiKind}};at.environment.extensionTestsLocationURI||Object.freeze(In);const Mn={createTestController(fe,_e,Ue){return Kt.createTestController(fe,_e,Ue)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)($e,"testObserver"),Kt.createTestObserver()},runTests(fe){return(0,Ve.checkProposedApiEnabled)($e,"testObserver"),Kt.runTests(fe)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)($e,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)($e,"testObserver"),Kt.results}},ln=at.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,bn={getExtension(fe,_e){(0,ot.equalsIgnoreCase)(fe,"ms-vscode.references-view")&&(Pe.report("The extension 'ms-vscode.references-view' has been renamed.",$e,"Use 'vscode.references-view' instead."),fe="vscode.references-view"),(0,Ve.isProposedApiEnabled)($e,"extensionsAny")||(_e=!1);const Ue=xt.mine.getExtensionDescription(fe);if(Ue)return new o.Extension(yt,$e.identifier,Ue,ln,!1);if(_e){const ct=xt.all.getExtensionDescription(fe);if(ct)return new o.Extension(yt,$e.identifier,ct,ln,!0)}},get all(){const fe=[];for(const _e of xt.mine.getAllExtensionDescriptions())fe.push(new o.Extension(yt,$e.identifier,_e,ln,!1));return fe},get allAcrossExtensionHosts(){(0,Ve.checkProposedApiEnabled)($e,"extensionsAny");const fe=new Ve.ExtensionIdentifierSet(xt.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),_e=[];for(const Ue of xt.all.getAllExtensionDescriptions()){const ct=!fe.has(Ue.identifier);_e.push(new o.Extension(yt,$e.identifier,Ue,ln,ct))}return _e},get onDidChange(){return(0,Ve.isProposedApiEnabled)($e,"extensionsAny")?D.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},Un={createDiagnosticCollection(fe){return Ut.createDiagnosticCollection($e.identifier,fe)},get onDidChangeDiagnostics(){return Ut.onDidChangeDiagnostics},getDiagnostics:fe=>Ut.getDiagnostics(fe),getLanguages(){return Jt.getLanguages()},setTextDocumentLanguage(fe,_e){return Jt.changeLanguage(fe.uri,_e)},match(fe,_e){const Ue=ht.getDocumentData(_e.uri)?.notebook;return(0,R.score)(W.LanguageSelector.from(fe),_e.uri,_e.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(fe,_e,Ue){return dt.registerCodeActionProvider($e,pt(fe),_e,Ue)},registerDocumentPasteEditProvider(fe,_e,Ue){return(0,Ve.checkProposedApiEnabled)($e,"documentPaste"),dt.registerDocumentPasteEditProvider($e,pt(fe),_e,Ue)},registerCodeLensProvider(fe,_e){return dt.registerCodeLensProvider($e,pt(fe),_e)},registerDefinitionProvider(fe,_e){return dt.registerDefinitionProvider($e,pt(fe),_e)},registerDeclarationProvider(fe,_e){return dt.registerDeclarationProvider($e,pt(fe),_e)},registerImplementationProvider(fe,_e){return dt.registerImplementationProvider($e,pt(fe),_e)},registerTypeDefinitionProvider(fe,_e){return dt.registerTypeDefinitionProvider($e,pt(fe),_e)},registerHoverProvider(fe,_e){return dt.registerHoverProvider($e,pt(fe),_e,$e.identifier)},registerEvaluatableExpressionProvider(fe,_e){return dt.registerEvaluatableExpressionProvider($e,pt(fe),_e,$e.identifier)},registerInlineValuesProvider(fe,_e){return dt.registerInlineValuesProvider($e,pt(fe),_e,$e.identifier)},registerDocumentHighlightProvider(fe,_e){return dt.registerDocumentHighlightProvider($e,pt(fe),_e)},registerLinkedEditingRangeProvider(fe,_e){return dt.registerLinkedEditingRangeProvider($e,pt(fe),_e)},registerReferenceProvider(fe,_e){return dt.registerReferenceProvider($e,pt(fe),_e)},registerRenameProvider(fe,_e){return dt.registerRenameProvider($e,pt(fe),_e)},registerDocumentSymbolProvider(fe,_e,Ue){return dt.registerDocumentSymbolProvider($e,pt(fe),_e,Ue)},registerWorkspaceSymbolProvider(fe){return dt.registerWorkspaceSymbolProvider($e,fe)},registerDocumentFormattingEditProvider(fe,_e){return dt.registerDocumentFormattingEditProvider($e,pt(fe),_e)},registerDocumentRangeFormattingEditProvider(fe,_e){return dt.registerDocumentRangeFormattingEditProvider($e,pt(fe),_e)},registerOnTypeFormattingEditProvider(fe,_e,Ue,...ct){return dt.registerOnTypeFormattingEditProvider($e,pt(fe),_e,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(fe,_e,Ue){return dt.registerDocumentSemanticTokensProvider($e,pt(fe),_e,Ue)},registerDocumentRangeSemanticTokensProvider(fe,_e,Ue){return dt.registerDocumentRangeSemanticTokensProvider($e,pt(fe),_e,Ue)},registerSignatureHelpProvider(fe,_e,Ue,...ct){return typeof Ue=="object"?dt.registerSignatureHelpProvider($e,pt(fe),_e,Ue):dt.registerSignatureHelpProvider($e,pt(fe),_e,typeof Ue=="undefined"?[]:[Ue,...ct])},registerCompletionItemProvider(fe,_e,...Ue){return dt.registerCompletionItemProvider($e,pt(fe),_e,Ue)},registerInlineCompletionItemProvider(fe,_e){return _e.handleDidShowCompletionItem&&(0,Ve.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider($e,pt(fe),_e)},registerInlineCompletionItemProviderNew(fe,_e){if((0,Ve.checkProposedApiEnabled)($e,"inlineCompletionsNew"),_e.handleDidShowCompletionItem&&!(0,Ve.isProposedApiEnabled)($e,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return dt.registerInlineCompletionsProviderNew($e,pt(fe),_e)},registerDocumentLinkProvider(fe,_e){return dt.registerDocumentLinkProvider($e,pt(fe),_e)},registerColorProvider(fe,_e){return dt.registerColorProvider($e,pt(fe),_e)},registerFoldingRangeProvider(fe,_e){return dt.registerFoldingRangeProvider($e,pt(fe),_e)},registerSelectionRangeProvider(fe,_e){return dt.registerSelectionRangeProvider($e,fe,_e)},registerCallHierarchyProvider(fe,_e){return dt.registerCallHierarchyProvider($e,fe,_e)},registerTypeHierarchyProvider(fe,_e){return dt.registerTypeHierarchyProvider($e,fe,_e)},setLanguageConfiguration:(fe,_e)=>dt.setLanguageConfiguration($e,fe,_e),getTokenInformationAtPosition(fe,_e){return(0,Ve.checkProposedApiEnabled)($e,"tokenInformation"),Jt.tokenAtPosition(fe,_e)},registerInlayHintsProvider(fe,_e){return dt.registerInlayHintsProvider($e,fe,_e)},createLanguageStatusItem(fe,_e){return Jt.createLanguageStatusItem($e,fe,_e)},registerDocumentDropEditProvider(fe,_e){return dt.registerDocumentOnDropEditProvider($e,fe,_e)}},zt={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return Ze.activeTerminal},get terminals(){return Ze.terminals},async showTextDocument(fe,_e,Ue){const ct=await(y.URI.isUri(fe)?Promise.resolve(Vt.openTextDocument(fe)):Promise.resolve(fe));return Tt.showTextDocument(ct,_e,Ue)},createTextEditorDecorationType(fe){return Tt.createTextEditorDecorationType($e,fe)},onDidChangeActiveTextEditor(fe,_e,Ue){return Tt.onDidChangeActiveTextEditor(fe,_e,Ue)},onDidChangeVisibleTextEditors(fe,_e,Ue){return Tt.onDidChangeVisibleTextEditors(fe,_e,Ue)},onDidChangeTextEditorSelection(fe,_e,Ue){return Tt.onDidChangeTextEditorSelection(fe,_e,Ue)},onDidChangeTextEditorOptions(fe,_e,Ue){return Tt.onDidChangeTextEditorOptions(fe,_e,Ue)},onDidChangeTextEditorVisibleRanges(fe,_e,Ue){return Tt.onDidChangeTextEditorVisibleRanges(fe,_e,Ue)},onDidChangeTextEditorViewColumn(fe,_e,Ue){return Tt.onDidChangeTextEditorViewColumn(fe,_e,Ue)},onDidCloseTerminal(fe,_e,Ue){return Ze.onDidCloseTerminal(fe,_e,Ue)},onDidOpenTerminal(fe,_e,Ue){return Ze.onDidOpenTerminal(fe,_e,Ue)},onDidChangeActiveTerminal(fe,_e,Ue){return Ze.onDidChangeActiveTerminal(fe,_e,Ue)},onDidChangeTerminalDimensions(fe,_e,Ue){return(0,Ve.checkProposedApiEnabled)($e,"terminalDimensions"),Ze.onDidChangeTerminalDimensions(fe,_e,Ue)},onDidChangeTerminalState(fe,_e,Ue){return Ze.onDidChangeTerminalState(fe,_e,Ue)},onDidWriteTerminalData(fe,_e,Ue){return(0,Ve.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),Ze.onDidWriteTerminalData(fe,_e,Ue)},get state(){return Le.state},onDidChangeWindowState(fe,_e,Ue){return Le.onDidChangeWindowState(fe,_e,Ue)},showInformationMessage(fe,..._e){return wn.showMessage($e,P.default.Info,fe,_e[0],_e.slice(1))},showWarningMessage(fe,..._e){return wn.showMessage($e,P.default.Warning,fe,_e[0],_e.slice(1))},showErrorMessage(fe,..._e){return wn.showMessage($e,P.default.Error,fe,_e[0],_e.slice(1))},showQuickPick(fe,_e,Ue){return Gt.showQuickPick(fe,_e,Ue)},showWorkspaceFolderPick(fe){return Gt.showWorkspaceFolderPick(fe)},showInputBox(fe,_e){return Gt.showInput(fe,_e)},showOpenDialog(fe){return Cn.showOpenDialog(fe)},showSaveDialog(fe){return Cn.showSaveDialog(fe)},createStatusBarItem(fe,_e,Ue){let ct,_t,It;return typeof fe=="string"?(ct=fe,_t=_e,It=Ue):(_t=fe,It=_e),an.createStatusBarEntry($e,ct,_t,It)},setStatusBarMessage(fe,_e){return an.setStatusBarMessage(fe,_e)},withScmProgress(fe){return Pe.report("window.withScmProgress",$e,"Use 'withProgress' instead."),on.withProgress($e,{location:N.ProgressLocation.SourceControl},(_e,Ue)=>fe({report(ct){}}))},withProgress(fe,_e){return on.withProgress($e,fe,_e)},createOutputChannel(fe,_e){return St.createOutputChannel(fe,_e,$e)},createWebviewPanel(fe,_e,Ue,ct){return tn.createWebviewPanel($e,fe,_e,Ue,ct)},createWebviewTextEditorInset(fe,_e,Ue,ct){return(0,Ve.checkProposedApiEnabled)($e,"editorInsets"),fn.createWebviewEditorInset(fe,_e,Ue,ct,$e)},createTerminal(fe,_e,Ue){return typeof fe=="object"?"pty"in fe?Ze.createExtensionTerminal(fe):Ze.createTerminalFromOptions(fe):Ze.createTerminal(fe,_e,Ue)},registerTerminalLinkProvider(fe){return Ze.registerLinkProvider(fe)},registerTerminalProfileProvider(fe,_e){return Ze.registerProfileProvider($e,fe,_e)},registerTreeDataProvider(fe,_e){return Sn.registerTreeDataProvider(fe,_e,$e)},createTreeView(fe,_e){return Sn.createTreeView(fe,_e,$e)},registerWebviewPanelSerializer:(fe,_e)=>tn.registerWebviewPanelSerializer($e,fe,_e),registerCustomEditorProvider:(fe,_e,Ue={})=>An.registerCustomEditorProvider($e,fe,_e,Ue),registerFileDecorationProvider(fe){return Fe.registerFileDecorationProvider(fe,$e.identifier)},registerUriHandler(fe){return mt.registerUriHandler($e.identifier,fe)},createQuickPick(){return Gt.createQuickPick($e)},createInputBox(){return Gt.createInputBox($e)},get activeColorTheme(){return yn.activeColorTheme},onDidChangeActiveColorTheme(fe,_e,Ue){return yn.onDidChangeActiveColorTheme(fe,_e,Ue)},registerWebviewViewProvider(fe,_e,Ue){return vn.registerWebviewViewProvider($e,fe,_e,Ue?.webviewOptions)},get activeNotebookEditor(){return wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(fe,_e,Ue){return wt.onDidChangeActiveNotebookEditor(fe,_e,Ue)},get visibleNotebookEditors(){return wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(fe,_e,Ue){return nn.onDidChangeNotebookEditorSelection(fe,_e,Ue)},onDidChangeNotebookEditorVisibleRanges(fe,_e,Ue){return nn.onDidChangeNotebookEditorVisibleRanges(fe,_e,Ue)},showNotebookDocument(fe,_e){return y.URI.isUri(fe)&&Pe.report("window.showNotebookDocument(uri)",$e,"Please use 'window.openNotebookDocument' and 'window.showTextDocument'"),wt.showNotebookDocument(fe,_e)},registerExternalUriOpener(fe,_e,Ue){return(0,Ve.checkProposedApiEnabled)($e,"externalUriOpener"),Rn.registerExternalUriOpener($e.identifier,fe,_e,Ue)},get tabGroups(){return ne.tabGroups}},Vt={get rootPath(){return Pe.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(fe){throw t.readonly()},getWorkspaceFolder(fe){return ft.getWorkspaceFolder(fe)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(fe){throw t.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(fe){throw t.readonly()},updateWorkspaceFolders:(fe,_e,...Ue)=>ft.updateWorkspaceFolders($e,fe,_e||0,...Ue),onDidChangeWorkspaceFolders:function(fe,_e,Ue){return ft.onDidChangeWorkspace(fe,_e,Ue)},asRelativePath:(fe,_e)=>ft.getRelativePath(fe,_e),findFiles:(fe,_e,Ue,ct)=>ft.findFiles(fe,_e,Ue,$e.identifier,ct),findTextInFiles:(fe,_e,Ue,ct)=>{(0,Ve.checkProposedApiEnabled)($e,"findTextInFiles");let _t,It;return typeof _e=="object"?(_t=_e,It=Ue):(_t={},It=_e,ct=Ue),ft.findTextInFiles(fe,_t||{},It,$e.identifier,ct)},saveAll:fe=>ft.saveAll(fe),applyEdit(fe){return On.applyWorkspaceEdit(fe,$e)},createFileSystemWatcher:(fe,_e,Ue,ct)=>Bt.createFileSystemWatcher(ft,$e,fe,_e,Ue,ct),get textDocuments(){return ht.getAllDocumentData().map(fe=>fe.document)},set textDocuments(fe){throw t.readonly()},openTextDocument(fe){let _e;const Ue=fe;if(typeof fe=="string")_e=Promise.resolve(y.URI.file(fe));else if(y.URI.isUri(fe))_e=Promise.resolve(fe);else if(!Ue||typeof Ue=="object")_e=ht.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return _e.then(ct=>ht.ensureDocumentData(ct).then(_t=>_t.document))},onDidOpenTextDocument:(fe,_e,Ue)=>ht.onDidAddDocument(fe,_e,Ue),onDidCloseTextDocument:(fe,_e,Ue)=>ht.onDidRemoveDocument(fe,_e,Ue),onDidChangeTextDocument:(fe,_e,Ue)=>ht.onDidChangeDocument(fe,_e,Ue),onDidSaveTextDocument:(fe,_e,Ue)=>ht.onDidSaveDocument(fe,_e,Ue),onWillSaveTextDocument:(fe,_e,Ue)=>qt.getOnWillSaveTextDocumentEvent($e)(fe,_e,Ue),get notebookDocuments(){return wt.notebookDocuments.map(fe=>fe.apiNotebook)},async openNotebookDocument(fe,_e){let Ue;if(y.URI.isUri(fe))Ue=fe,await wt.openNotebookDocument(fe);else if(typeof fe=="string")Ue=y.URI.revive(await wt.createNotebookDocument({viewType:fe,content:_e}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(fe,_e,Ue){return $t.onDidSaveNotebookDocument(fe,_e,Ue)},onDidChangeNotebookDocument(fe,_e,Ue){return $t.onDidChangeNotebookDocument(fe,_e,Ue)},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(fe,_e,Ue,ct){return wt.registerNotebookSerializer($e,fe,_e,Ue,(0,Ve.isProposedApiEnabled)($e,"notebookLiveShare")?ct:void 0)},registerNotebookContentProvider:(fe,_e,Ue,ct)=>((0,Ve.checkProposedApiEnabled)($e,"notebookContentProvider"),Pe.report("workspace.registerNotebookContentProvider",$e,"The notebookContentProvider API is not on track for finalization and will be removed."),wt.registerNotebookContentProvider($e,fe,_e,Ue,(0,Ve.isProposedApiEnabled)($e,"notebookLiveShare")?ct:void 0)),onDidChangeConfiguration:(fe,_e,Ue)=>Dn.onDidChangeConfiguration(fe,_e,Ue),getConfiguration(fe,_e){return _e=arguments.length===1?void 0:_e,Dn.getConfiguration(fe,_e,$e)},registerTextDocumentContentProvider(fe,_e){return Yt.registerTextDocumentContentProvider(fe,_e)},registerTaskProvider:(fe,_e)=>(Pe.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider($e,fe,_e)),registerFileSystemProvider(fe,_e,Ue){return(0,je.combinedDisposable)(mn.registerFileSystemProvider($e,fe,_e,Ue),Pt.addFileSystemProvider(fe,_e))},get fs(){return Pt.value},registerFileSearchProvider:(fe,_e)=>((0,Ve.checkProposedApiEnabled)($e,"fileSearchProvider"),bt.registerFileSearchProvider(fe,_e)),registerTextSearchProvider:(fe,_e)=>((0,Ve.checkProposedApiEnabled)($e,"textSearchProvider"),bt.registerTextSearchProvider(fe,_e)),registerRemoteAuthorityResolver:(fe,_e)=>((0,Ve.checkProposedApiEnabled)($e,"resolvers"),yt.registerRemoteAuthorityResolver(fe,_e)),registerResourceLabelFormatter:fe=>((0,Ve.checkProposedApiEnabled)($e,"resolvers"),Pn.$registerResourceLabelFormatter(fe)),onDidCreateFiles:(fe,_e,Ue)=>Bt.onDidCreateFile(fe,_e,Ue),onDidDeleteFiles:(fe,_e,Ue)=>Bt.onDidDeleteFile(fe,_e,Ue),onDidRenameFiles:(fe,_e,Ue)=>Bt.onDidRenameFile(fe,_e,Ue),onWillCreateFiles:(fe,_e,Ue)=>Bt.getOnWillCreateFileEvent($e)(fe,_e,Ue),onWillDeleteFiles:(fe,_e,Ue)=>Bt.getOnWillDeleteFileEvent($e)(fe,_e,Ue),onWillRenameFiles:(fe,_e,Ue)=>Bt.getOnWillRenameFileEvent($e)(fe,_e,Ue),openTunnel:fe=>((0,Ve.checkProposedApiEnabled)($e,"resolvers"),Dt.openTunnel($e,fe).then(_e=>{if(!_e)throw new Error("cannot open tunnel");return _e})),get tunnels(){return(0,Ve.checkProposedApiEnabled)($e,"resolvers"),Dt.getTunnels()},onDidChangeTunnels:(fe,_e,Ue)=>((0,Ve.checkProposedApiEnabled)($e,"resolvers"),Dt.onDidChangeTunnels(fe,_e,Ue)),registerPortAttributesProvider:(fe,_e)=>((0,Ve.checkProposedApiEnabled)($e,"portsAttributes"),Dt.registerPortsAttributesProvider(fe,_e)),registerTimelineProvider:(fe,_e)=>((0,Ve.checkProposedApiEnabled)($e,"timeline"),pn.registerTimelineProvider(fe,_e,$e.identifier,et.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:fe=>((0,Ve.checkProposedApiEnabled)($e,"workspaceTrust"),ft.requestWorkspaceTrust(fe)),onDidGrantWorkspaceTrust:(fe,_e,Ue)=>ft.onDidGrantWorkspaceTrust(fe,_e,Ue)},Bn={get inputBox(){return Pe.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),sn.getLastInputBox($e)},createSourceControl(fe,_e,Ue){return sn.createSourceControl($e,fe,_e,Ue)}},Ft={createCommentController(fe,_e){return gn.createCommentController($e,fe,_e)}},un={get activeDebugSession(){return Je.activeDebugSession},get activeDebugConsole(){return Je.activeDebugConsole},get breakpoints(){return Je.breakpoints},onDidStartDebugSession(fe,_e,Ue){return Je.onDidStartDebugSession(fe,_e,Ue)},onDidTerminateDebugSession(fe,_e,Ue){return Je.onDidTerminateDebugSession(fe,_e,Ue)},onDidChangeActiveDebugSession(fe,_e,Ue){return Je.onDidChangeActiveDebugSession(fe,_e,Ue)},onDidReceiveDebugSessionCustomEvent(fe,_e,Ue){return Je.onDidReceiveDebugSessionCustomEvent(fe,_e,Ue)},onDidChangeBreakpoints(fe,_e,Ue){return Je.onDidChangeBreakpoints(fe,_e,Ue)},registerDebugConfigurationProvider(fe,_e,Ue){return Je.registerDebugConfigurationProvider(fe,_e,Ue||nt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(fe,_e){return Je.registerDebugAdapterDescriptorFactory($e,fe,_e)},registerDebugAdapterTrackerFactory(fe,_e){return Je.registerDebugAdapterTrackerFactory(fe,_e)},startDebugging(fe,_e,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Je.startDebugging(fe,_e,{parentSession:Ue}):Je.startDebugging(fe,_e,Ue||{})},stopDebugging(fe){return Je.stopDebugging(fe)},addBreakpoints(fe){return Je.addBreakpoints(fe)},removeBreakpoints(fe){return Je.removeBreakpoints(fe)},asDebugSourceUri(fe,_e){return Je.asDebugSourceUri(fe,_e)}},zn={registerTaskProvider:(fe,_e)=>Et.registerTaskProvider($e,fe,_e),fetchTasks:fe=>Et.fetchTasks(fe),executeTask:fe=>Et.executeTask($e,fe),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(fe,_e,Ue)=>Et.onDidStartTask(fe,_e,Ue),onDidEndTask:(fe,_e,Ue)=>Et.onDidEndTask(fe,_e,Ue),onDidStartTaskProcess:(fe,_e,Ue)=>Et.onDidStartTaskProcess(fe,_e,Ue),onDidEndTaskProcess:(fe,_e,Ue)=>Et.onDidEndTaskProcess(fe,_e,Ue)},Wn={createNotebookController(fe,_e,Ue,ct,_t){return rn.createNotebookController($e,fe,_e,Ue,ct,(0,Ve.isProposedApiEnabled)($e,"notebookMessaging")?_t:void 0)},registerNotebookCellStatusBarItemProvider:(fe,_e)=>wt.registerNotebookCellStatusBarItemProvider($e,fe,_e),createRendererMessaging(fe){return Ht.createRendererMessaging($e,fe)},onDidChangeNotebookCellExecutionState(fe,_e,Ue){return(0,Ve.checkProposedApiEnabled)($e,"notebookCellExecutionState"),rn.onDidChangeNotebookCellExecutionState(fe,_e,Ue)}};return{version:at.version,authentication:cn,commands:Fn,comments:Ft,debug:un,env:In,extensions:bn,languages:Un,notebooks:Wn,scm:Bn,tasks:zn,tests:Mn,window:zt,workspace:Vt,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:u.CancellationTokenSource,CandidatePortSource:_.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CommentThreadState:N.CommentThreadState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:nt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:N.InlineCompletionTriggerKindNew,EventEmitter:D.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionItemNew:N.InlineSuggestionNew,InlineCompletionList:N.InlineSuggestionList,InlineCompletionListNew:N.InlineSuggestionsNew,Hover:N.Hover,IndentAction:I.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:T.UIKind,Uri:y.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,DocumentDropEdit:N.DocumentDropEdit,DocumentPasteEdit:N.DocumentPasteEdit,InlayHint:N.InlayHint,InlayHintLabelPart:N.InlayHintLabelPart,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,NotebookEdit:N.NotebookEdit,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:oe.TextSearchCompleteMessageType,DataTransfer:N.DataTransfer,DataTransferItem:N.DataTransferItem,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity,QuickPickItemKind:N.QuickPickItemKind,InputBoxValidationSeverity:N.InputBoxValidationSeverity,TabInputText:N.TextTabInput,TabInputTextDiff:N.TextDiffTabInput,TabInputTextMerge:N.TextMergeTabInput,TabInputCustom:N.CustomEditorTabInput,TabInputNotebook:N.NotebookEditorTabInput,TabInputNotebookDiff:N.NotebookDiffEditorTabInput,TabInputWebview:N.WebviewEditorTabInput,TabInputTerminal:N.TerminalEditorTabInput,TabInputInteractiveWindow:N.InteractiveWindowInput,TerminalExitReason:N.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=st}),define(Ie[295],ke([1,0,268,304,305,2,306]),function(Y,e,u,t,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function C(k,_,T,w,b,g){const f=g.environment.useHostProxy,p=typeof f=="boolean"?f:!g.remote.isRemote,v=(0,y.createProxyResolver)({resolveProxy:m=>k.resolveProxy(m),getHttpProxySetting:()=>_.getConfiguration("http").get("proxy"),log:(m,a,...d)=>{switch(m){case y.LogLevel.Trace:w.trace(a,...d);break;case y.LogLevel.Debug:w.debug(a,...d);break;case y.LogLevel.Info:w.info(a,...d);break;case y.LogLevel.Warning:w.warn(a,...d);break;case y.LogLevel.Error:w.error(a,...d);break;case y.LogLevel.Critical:w.critical(a,...d);break;case y.LogLevel.Off:break;default:r(m,a,d);break}function r(o,i,...n){w.error("Unknown log level",o),w.error(i,...n)}},getLogLevel:()=>w.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:p,env:process.env}),c=E(_,v);return R(T,c)}e.connectProxyResolver=C;function E(k,_){const T={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(b=>{T.config=k.getConfiguration("http").get("proxySupport")||"off"});const w={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(b=>{w.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},u,(0,y.createHttpPatch)(u,_,{config:"off"},w,!0)),on:Object.assign({},u,(0,y.createHttpPatch)(u,_,{config:"on"},w,!0)),override:Object.assign({},u,(0,y.createHttpPatch)(u,_,{config:"override"},w,!0)),onRequest:Object.assign({},u,(0,y.createHttpPatch)(u,_,T,w,!0)),default:Object.assign(u,(0,y.createHttpPatch)(u,_,T,w,!1))},https:{off:Object.assign({},t,(0,y.createHttpPatch)(t,_,{config:"off"},w,!0)),on:Object.assign({},t,(0,y.createHttpPatch)(t,_,{config:"on"},w,!0)),override:Object.assign({},t,(0,y.createHttpPatch)(t,_,{config:"override"},w,!0)),onRequest:Object.assign({},t,(0,y.createHttpPatch)(t,_,T,w,!0)),default:Object.assign(t,(0,y.createHttpPatch)(t,_,T,w,!1))},tls:Object.assign(D,(0,y.createTlsPatch)(D))}}const I=new Map;function R(k,_){return k.getExtensionPathIndex().then(T=>{const w=Y.__$__nodeRequire("module"),b=w._load;w._load=function(f,p,v){if(f==="tls")return _.tls;if(f!=="http"&&f!=="https")return b.apply(this,arguments);const c=_[f],m=T.findSubstr(P.URI.file(p.filename));let a=I.get(m);if(a||I.set(m,a={}),!a[f]){const d=c.default;a[f]={...d}}return a[f]}})}}),define(Ie[296],ke([1,0,73,294,282,295,39,270,2,11,7,267,109,269]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class w extends D.RequireInterceptor{_installInterceptor(){const f=this,p=Y.__$__nodeRequire("module"),v=p._load;p._load=function(d,r,o){return d=m(d),f._factories.has(d)?f._factories.get(d).load(d,E.URI.file((0,_.realpathSync)(r.filename)),i=>v.apply(this,[i,r,o])):v.apply(this,arguments)};const c=p._resolveLookupPaths;p._resolveLookupPaths=(a,d)=>c.call(this,m(a),d);const m=a=>{for(const d of f._alternatives){const r=d(a);if(r){a=r;break}}return a}}}class b extends y.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=R.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(T.ExtHostConsoleForwarder);const f=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(C.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const c=this._instaService.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}await this._instaService.createInstance(w,f,{mine:this._myRegistry,all:this._globalRegistry}).install(),u.mark("code/extHost/didInitAPI");const v=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,v,this,this._logService,this._mainThreadTelemetryProxy,this._initData),u.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(f){return f.main}_loadCommonJSModule(f,p,v){if(p.scheme!==I.Schemas.file)throw new Error(`Cannot load URI: '${p}', must be of file-scheme`);let c=null;v.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${p.toString(!0)}`),this._logService.flush();try{f&&u.mark(`code/extHost/willLoadExtensionCode/${f.value}`),c=Y.__$__nodeRequire(p.fsPath)}catch(m){return Promise.reject(m)}finally{f&&u.mark(`code/extHost/didLoadExtensionCode/${f.value}`),v.codeLoadingStop()}return Promise.resolve(c)}async $setRemoteEnvironment(f){if(!!this._initData.remote.isRemote)for(const p in f){const v=f[p];v===null?delete process.env[p]:process.env[p]=v}}}e.ExtHostExtensionService=b}),define(Ie[141],ke([1,0,42,307,97,16,77,36,9,8,2,31,71,308,289,92]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const g=w.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(h){this.outputChannel=h}provideTextSearchResults(h,S,L,M){return this.outputChannel.appendLine(`provideTextSearchResults ${h.pattern}, ${JSON.stringify({...S,folder:S.folder.toString()})}`),new Promise((F,A)=>{M.onCancellationRequested(()=>x());const B=d(h,S),$=S.folder.fsPath,U=B.map(pe=>pe.match(/^-/)?pe:`'${pe}'`).join(" ");this.outputChannel.appendLine(`${g} ${U}
 - cwd: ${$}`);let K=u.spawn(g,B,{cwd:$});K.on("error",pe=>{console.error(pe),this.outputChannel.appendLine("Error: "+(pe&&pe.message)),A((0,k.serializeSearchError)(new k.SearchError(pe&&pe.message,k.SearchErrorCode.rgProcessError)))});let W=!1;const N=new c(S.maxResults,$,S.previewOptions);N.on("result",pe=>{W=!0,te="",L.report(pe)});let V=!1;const x=()=>{V=!0,K&&K.kill(),N&&N.cancel()};let q=!1;N.on("hitLimit",()=>{q=!0,x()});let te="";K.stdout.on("data",pe=>{N.handleData(pe),W||(te+=pe)});let Q=!1;K.stdout.once("data",()=>Q=!0);let le="";K.stderr.on("data",pe=>{const Z=pe.toString();this.outputChannel.appendLine(Z),le+=Z}),K.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(W?"Got result from parser":"No result from parser"),te&&this.outputChannel.appendLine(`Got data without result: ${te}`),this.outputChannel.appendLine(""),V)F({limitHit:q});else{N.flush(),K=null;let pe;le&&!Q&&(pe=p(le))?A((0,k.serializeSearchError)(new k.SearchError(pe.message,pe.code))):F({limitHit:q})}})})}}e.RipgrepTextSearchEngine=f;function p(l){const h=l.split(`
`),S=h[0].trim();if(h.some(M=>M.startsWith("regex parse error")))return new k.SearchError(v(h),k.SearchErrorCode.regexParseError);const L=S.match(/grep config error: unknown encoding: (.*)/);if(L)return new k.SearchError(`Unknown encoding: ${L[1]}`,k.SearchErrorCode.unknownEncoding);if(S.startsWith("error parsing glob"))return new k.SearchError(S.charAt(0).toUpperCase()+S.substr(1),k.SearchErrorCode.globParseError);if(S.startsWith("the literal"))return new k.SearchError(S.charAt(0).toUpperCase()+S.substr(1),k.SearchErrorCode.invalidLiteral);if(S.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(S,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=p;function v(l){const h=["Regex parse error"],S=l.filter(L=>L.startsWith("PCRE2:"));if(S.length>=1){const L=S[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const M=L.split(":")[1];h.push(":"+M)}}return h.join("")}e.buildRegexParseError=v;class c extends t.EventEmitter{constructor(h,S,L){super();this.maxResults=h,this.rootFolder=S,this.previewOptions=L,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new D.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(h,S){return super.on(h,S),this}handleData(h){if(this.isDone)return;const S=typeof h=="string"?h:this.stringDecoder.write(h);this.handleDecodedData(S)}handleDecodedData(h){let S=h.indexOf(`
`);const L=this.remainder+h;if(S>=0)S+=this.remainder.length;else{this.remainder=L;return}let M=0;for(;S>=0;)this.handleLine(L.substring(M,S).trim()),M=S+1,S=L.indexOf(`
`,M);this.remainder=L.substring(M)}handleLine(h){if(this.isDone||!h)return;let S;try{S=JSON.parse(h)}catch{throw new Error(`malformed line from rg: ${h}`)}if(S.type==="match"){const L=m(S.data.path),M=R.URI.file(E.join(this.rootFolder,L)),F=this.createTextSearchMatch(S.data,M);this.onResult(F),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(S.type==="context"){const L=m(S.data.path),M=R.URI.file(E.join(this.rootFolder,L));this.createTextSearchContext(S.data,M).forEach(A=>this.onResult(A))}}createTextSearchMatch(h,S){const L=h.line_number-1,M=m(h.lines),F=Buffer.from(M);let A=0,B=0,$=L;h.submatches.length===0&&h.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const U=(0,P.coalesce)(h.submatches.map((K,W)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const N=m(K.match),V=F.slice(A,K.start).toString().length,x=B+V,q=a(N),te=$,Q=q.numLines+te,le=q.numLines>0?q.lastLineLength:q.lastLineLength+x;return A=K.end,B=le,$=Q,new _.Range(te,x,Q,le)}));return(0,b.createTextSearchResult)(S,M,U,this.previewOptions)}createTextSearchContext(h,S){const L=m(h.lines),M=h.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((F,A)=>({text:F,uri:S,lineNumber:M+A}))}onResult(h){this.emit("result",h)}}e.RipgrepParser=c;function m(l){return l.bytes?Buffer.from(l.bytes,"base64").toString():l.text}function a(l){const h=/\n/g;let S=0,L=-1,M;for(;M=h.exec(l);)S++,L=M.index;const F=L>=0?l.length-L-1:l.length;return{numLines:S,lastLineLength:F}}function d(l,h){const S=["--hidden"];S.push(l.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:M}=(0,y.groupBy)(h.includes,A=>A.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const A=new Set;M.forEach(B=>{A.add(B)}),S.push("-g","!*"),A.forEach(B=>{r(B).map(b.anchorGlob).forEach($=>{S.push("-g",$)})})}L&&L.length&&L.forEach(A=>{S.push("-g",A)}),h.excludes.map(b.anchorGlob).forEach(A=>S.push("-g",`!${A}`)),h.maxFileSize&&S.push("--max-filesize",h.maxFileSize+""),h.useIgnoreFiles?h.useParentIgnoreFiles||S.push("--no-ignore-parent"):S.push("--no-ignore"),h.followSymlinks&&S.push("--follow"),h.encoding&&h.encoding!=="utf8"&&S.push("--encoding",h.encoding),l.pattern==="--"&&(l.isRegExp=!0,l.pattern="\\-\\-"),l.isMultiline&&!l.isRegExp&&(l.pattern=(0,I.escapeRegExpCharacters)(l.pattern),l.isRegExp=!0),h.usePCRE2&&S.push("--pcre2"),S.push("--crlf"),l.isRegExp&&(l.pattern=o(l.pattern),S.push("--engine","auto"));let F;if(l.isWordMatch){const B=(0,I.createRegExp)(l.pattern,!!l.isRegExp,{wholeWord:l.isWordMatch}).source.replace(/\\\//g,"/");S.push("--regexp",B)}else if(l.isRegExp){let A=n(l.pattern);A=s(A),S.push("--regexp",A)}else F=l.pattern,S.push("--fixed-strings");return S.push("--no-config"),h.useGlobalIgnoreFiles||S.push("--no-ignore-global"),S.push("--json"),l.isMultiline&&S.push("--multiline"),h.beforeContext&&S.push("--before-context",h.beforeContext+""),h.afterContext&&S.push("--after-context",h.afterContext+""),S.push("--"),F&&S.push(F),S.push("."),S}function r(l){const h=(0,C.splitGlobAware)(l,"/");return h.map((S,L)=>h.slice(0,L+1).join("/"))}e.spreadGlobComponents=r;function o(l){const h=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;l.match(h);)l=l.replace(h,"$1\\x{$2}");const S=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;l.match(S);)l=l.replace(S,"$1\\x{$2}");return l}e.unicodeEscapesToPCRE2=o;const i=l=>l.type==="Assertion"&&l.kind==="lookbehind";function n(l){let h;try{h=new T.RegExpParser().parsePattern(l)}catch{return l}let S="",L=0;const M=(B,$,U)=>{S+=l.slice(L,B)+U,L=$},F=[];return new T.RegExpVisitor({onCharacterEnter(B){if(B.raw!=="\\n")return;const $=F[0];if(!$)M(B.start,B.end,"\\r?\\n");else if(!F.some(i))if($.type==="CharacterClass")if($.negate){const U=l.slice($.start+2,B.start)+l.slice(B.end,$.end-1);$.parent?.type==="Quantifier"?M($.start,$.end,U?`[^${U}]`:"."):M($.start,$.end,"(?!\\r?\\n"+(U?`|[${U}]`:"")+")")}else{const U=l.slice($.start+1,B.start)+l.slice(B.end,$.end-1);M($.start,$.end,U===""?"\\r?\\n":`(?:[${U}]|\\r?\\n)`)}else $.type==="Quantifier"&&M(B.start,B.end,"(?:\\r?\\n)")},onQuantifierEnter(B){F.unshift(B)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(B){F.unshift(B)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(B){F.unshift(B)},onCharacterClassLeave(){F.shift()},onAssertionEnter(B){i(B)&&F.push(B)},onAssertionLeave(B){F[0]===B&&F.shift()}}).visit(h),S+=l.slice(L),S}e.fixRegexNewline=n;function s(l){return l.replace(/\n/g,"\\r?\\n")}e.fixNewline=s}),define(Ie[297],ke([1,0,21,141,119,11]),function(Y,e,u,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(I){this.outputChannel=I,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(I,R,k,_){const T=new t.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===P.Schemas.vscodeUserData){const w={...R,folder:R.folder.with({scheme:P.Schemas.file})},b=new D.Progress(g=>k.report({...g,uri:g.uri.with({scheme:R.folder.scheme})}));return this.withToken(_,g=>T.provideTextSearchResults(I,w,b,g))}else return this.withToken(_,w=>T.provideTextSearchResults(I,R,k,w))}async withToken(I,R){const k=C(I);this.inProgress.add(k);const _=await R(k.token);return this.inProgress.delete(k),_}dispose(){this.inProgress.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=y;function C(E){const I=new u.CancellationTokenSource;return E.onCancellationRequested(()=>I.cancel()),I}}),define(Ie[298],ke([1,0,29,141,140]),function(Y,e,u,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(E){this.query=E}search(E,I,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(T){R({message:T})}},_=new D.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(k),u);return new Promise((T,w)=>_.search(b=>{I(b.map(y))},E).then(b=>T({limitHit:b.limitHit,type:"success",stats:b.stats}),w))}}e.TextSearchEngineAdapter=P;function y(C){return{path:C.resource&&C.resource.fsPath,results:C.results,numMatches:(C.results||[]).reduce((E,I)=>{if(I.ranges){const R=I;return E+(Array.isArray(R.ranges)?R.ranges.length:1)}else return E+1},0)}}}),define(Ie[299],ke([1,0,16,18,12,3,105,9,50,2,43,31,290,298]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class w{constructor(c="searchProcess"){this.processType=c,this.caches=Object.create(null)}fileSearch(c){let m;const a=f(c),d=new P.Emitter({onFirstListenerDidAdd:()=>{m=(0,t.createCancelablePromise)(r=>this.doFileSearchWithEngine(_.Engine,a,o=>d.fire(o),r)),m.then(r=>d.fire(r),r=>d.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return d.event}textSearch(c){let m;const a=f(c),d=new P.Emitter({onFirstListenerDidAdd:()=>{m=(0,t.createCancelablePromise)(r=>this.ripgrepTextSearch(a,o=>d.fire(o),r)),m.then(r=>d.fire(r),r=>d.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return d.event}ripgrepTextSearch(c,m,a){return c.maxFileSize=(0,R.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new T.TextSearchEngineAdapter(c).search(a,m,m)}doFileSearch(c,m,a){return this.doFileSearchWithEngine(_.Engine,c,m,a)}doFileSearchWithEngine(c,m,a,d,r=w.BATCH_SIZE){let o=0;const i=s=>{Array.isArray(s)?(o+=s.length,a(s.map(l=>this.rawMatchToSearchItem(l)))):s.relativePath?(o++,a(this.rawMatchToSearchItem(s))):a(s)};if(m.sortByScore){let s=this.trySortedSearchFromCache(m,i,d);if(!s){const l=m.maxResults?Object.assign({},m,{maxResults:null}):m,h=new c(l);s=this.doSortedSearch(h,m,a,i,d)}return new Promise((l,h)=>{s.then(([S,L])=>{const M=L.map(F=>this.rawMatchToSearchItem(F));this.sendProgress(M,a,r),l(S)},h)})}const n=new c(m);return this.doSearch(n,i,r,d).then(s=>({limitHit:s.limitHit,type:"success",stats:{detailStats:s.stats,type:this.processType,fromCache:!1,resultCount:o,sortingTime:void 0}}))}rawMatchToSearchItem(c){return{path:c.base?(0,C.join)(c.base,c.relativePath):c.relativePath}}doSortedSearch(c,m,a,d,r){const o=new P.Emitter;let i=(0,t.createCancelablePromise)(s=>{let l=[];const h=S=>{Array.isArray(S)?l=S:(d(S),o.fire(S))};return this.doSearch(c,h,-1,s).then(S=>[S,l])}),n;if(m.cacheKey){n=this.getOrCreateCache(m.cacheKey);const s={promise:i,event:o.event,resolved:!1};n.resultsToSearchCache[m.filePattern||""]=s,i.then(()=>{s.resolved=!0},l=>{delete n.resultsToSearchCache[m.filePattern||""]}),i=this.preventCancellation(i)}return i.then(([s,l])=>{const h=n?n.scorerCache:Object.create(null),S=(typeof m.maxResults!="number"||m.maxResults>0)&&E.StopWatch.create(!1);return this.sortResults(m,l,h,r).then(L=>{const M=S?S.elapsed():-1;return[{type:"success",stats:{detailStats:s.stats,sortingTime:M,fromCache:!1,type:this.processType,workspaceFolderCount:m.folderQueries.length,resultCount:L.length},messages:s.messages,limitHit:s.limitHit||typeof m.maxResults=="number"&&l.length>m.maxResults},L]})})}getOrCreateCache(c){const m=this.caches[c];return m||(this.caches[c]=new b)}trySortedSearchFromCache(c,m,a){const d=c.cacheKey&&this.caches[c.cacheKey];if(!d)return;const r=this.getResultsFromCache(d,c.filePattern||"",m,a);if(r)return r.then(([o,i,n])=>{const s=E.StopWatch.create(!1);return this.sortResults(c,i,d.scorerCache,a).then(l=>{const h=s.elapsed(),S={fromCache:!0,detailStats:n,type:this.processType,resultCount:i.length,sortingTime:h};return[{type:"success",limitHit:o.limitHit||typeof c.maxResults=="number"&&i.length>c.maxResults,stats:S},l]})})}sortResults(c,m,a,d){const r=(0,y.prepareQuery)(c.filePattern||""),o=(n,s)=>(0,y.compareItemsByFuzzyScore)(n,s,r,!0,g,a),i=typeof c.maxResults=="number"?c.maxResults:Number.MAX_VALUE;return u.topAsync(m,o,i,1e4,d)}sendProgress(c,m,a){if(a&&a>0)for(let d=0;d<c.length;d+=a)m(c.slice(d,d+a));else m(c)}getResultsFromCache(c,m,a,d){const r=E.StopWatch.create(!1),o=m.indexOf(C.sep)>=0;let i;for(const h in c.resultsToSearchCache)if(m.startsWith(h)){if(o&&h.indexOf(C.sep)<0&&h!=="")continue;const S=c.resultsToSearchCache[h];i={promise:this.preventCancellation(S.promise),event:S.event,resolved:S.resolved};break}if(!i)return null;const n=r.elapsed(),s=E.StopWatch.create(!1),l=i.event(a);return d&&d.onCancellationRequested(()=>{l.dispose()}),i.promise.then(([h,S])=>{if(d&&d.isCancellationRequested)throw(0,D.canceled)();const L=[],M=(0,y.prepareQuery)(m).normalizedLowercase;for(const F of S)!(0,k.isFilePatternMatch)(F,M)||L.push(F);return[h,L,{cacheWasResolved:i.resolved,cacheLookupTime:n,cacheFilterTime:s.elapsed(),cacheEntryCount:S.length}]})}doSearch(c,m,a,d){return new Promise((r,o)=>{let i=[];d?.onCancellationRequested(()=>c.cancel()),c.search(n=>{n&&(a?(i.push(n),a>0&&i.length>=a&&(m(i),i=[])):m(n))},n=>{m(n)},(n,s)=>{i.length&&m(i),n?o(n):r(s)})})}clearCache(c){return delete this.caches[c],Promise.resolve(void 0)}preventCancellation(c){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(m,a){return c.then(m,a)}catch(m){return this.then(void 0,m)}finally(m){return c.finally(m)}}}}e.SearchService=w,w.BATCH_SIZE=512;class b{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(v){return(0,C.basename)(v.relativePath)}getItemDescription(v){return(0,C.dirname)(v.relativePath)}getItemPath(v){return v.relativePath}};function f(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(p),extraFileResources:v.extraFileResources&&v.extraFileResources.map(c=>I.URI.revive(c))}}function p(v){return{...v,folder:I.URI.revive(v.folder)}}}),define(Ie[300],ke([1,0,6,11,2,29,14,26,17,75,64,31,299,297,92,140]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let g=class extends I.ExtHostSearch{constructor(p,v,c,m){super(p,c,m);this._pfs=P,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const a=new w.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new T.RipgrepSearchProvider(a)),v.remote.isRemote&&v.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const p=new w.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new T.RipgrepSearchProvider(p)),this.registerInternalFileSearchProvider(t.Schemas.file,new _.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(p,v){const c=this._handlePool++;return this._internalFileSearchProvider=v,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(p)),(0,u.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(p,v,c,m){const a=(0,I.reviveQuery)(c);return p===this._internalFileSearchHandle?this.doInternalFileSearch(p,v,a,m):super.$provideFileSearchResults(p,v,c,m)}doInternalFileSearch(p,v,c,m){const a=d=>{if((0,k.isSerializedFileMatch)(d)&&(d=[d]),Array.isArray(d)){this._proxy.$handleFileMatch(p,v,d.map(r=>D.URI.file(r.path)));return}d.message&&this._logService.debug("ExtHostSearch",d.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,a,m)}$clearCache(p){return this._internalFileSearchProvider?.clearCache(p),super.$clearCache(p)}createTextSearchManager(p,v){return new b.NativeTextSearchManager(p,v,void 0,"textSearchProvider")}};g=Ge([xe(0,E.IExtHostRpcService),xe(1,C.IExtHostInitDataService),xe(2,R.IURITransformerService),xe(3,y.ILogService)],g),e.NativeExtHostSearch=g}),define(Ie[301],ke([1,0,82,273,285,284,300,296,274,74,39,75,72,38,52,69,272,271,14,286,47]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g,f,p,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(R.IExtHostExtensionService,C.ExtHostExtensionService),(0,u.registerSingleton)(p.ILoggerService,f.ExtHostLoggerService),(0,u.registerSingleton)(b.IExtensionStoragePaths,g.ExtensionStoragePaths),(0,u.registerSingleton)(I.IExtHostDebugService,P.ExtHostDebugService),(0,u.registerSingleton)(k.IExtHostSearch,y.NativeExtHostSearch),(0,u.registerSingleton)(_.IExtHostTask,D.ExtHostTask),(0,u.registerSingleton)(T.IExtHostTerminalService,t.ExtHostTerminalService),(0,u.registerSingleton)(w.IExtHostTunnelService,E.ExtHostTunnelService),(0,u.registerSingleton)(c.IExtHostVariableResolverProvider,v.NodeExtHostVariableResolverProviderService)}),define(Ie[309],ke([1,0,216,310,73,12,111,112,197,134,283,23,29,109,18,115,210,228,287,301]),function(Y,e,u,t,D,P,y,C,E,I,R,k,_,T,w,b,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const p=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const i=Y.__$__nodeRequire("module"),n=i._load;i._load=function(s){if(s==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return n.apply(this,arguments)}})();const v=process.exit.bind(process);function c(i){process.exit=function(n){if(i)v(n);else{const s=new Error("An extension called process.exit() and this was prevented.");console.warn(s.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let m=function(i){v()};function a(){const i=(0,f.readExtHostConnection)(process.env);if(i.type===3)return new Promise((n,s)=>{const l=h=>{const S=h[0],L=new y.BufferedEmitter;S.on("message",M=>L.fire(k.VSBuffer.wrap(M.data))),S.on("close",()=>{m("renderer closed the MessagePort")}),S.start(),n({onMessage:L.event,send:M=>S.postMessage(M.buffer)})};if(global.vscodePorts){const h=global.vscodePorts;delete global.vscodePorts,l(h)}else global.vscodePortsCallback=l});if(i.type===2)return new Promise((n,s)=>{let l=null;const h=setTimeout(()=>{m("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),S=108e5,L=3e5,M=new w.ProcessTimeRunOnceScheduler(()=>m("renderer disconnected for too long (1)"),S),F=new w.ProcessTimeRunOnceScheduler(()=>m("renderer disconnected for too long (2)"),L);process.on("message",(B,$)=>{if(B&&B.type==="VSCODE_EXTHOST_IPC_SOCKET"){$.setNoDelay(!0);const U=k.VSBuffer.wrap(Buffer.from(B.initialDataChunk,"base64"));let K;if(B.skipWebSocketFrames)K=new C.NodeSocket($,"extHost-socket");else{const W=k.VSBuffer.wrap(Buffer.from(B.inflateBytes,"base64"));K=new C.WebSocketNodeSocket(new C.NodeSocket($,"extHost-socket"),B.permessageDeflate,W,!1)}l?(M.cancel(),F.cancel(),l.beginAcceptReconnection(K,U),l.endAcceptReconnection(),l.sendResume()):(clearTimeout(h),l=new y.PersistentProtocol(K,U),l.sendResume(),l.onDidDispose(()=>m("renderer disconnected")),n(l),l.onSocketClose(()=>{M.schedule()}))}if(B&&B.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(F.isScheduled())return;M.isScheduled()&&F.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(A)});{const n=i.pipeName;return new Promise((s,l)=>{const h=u.createConnection(n,()=>{h.removeListener("error",l);const S=new y.PersistentProtocol(new C.NodeSocket(h,"extHost-renderer"));S.sendResume(),s(S)});h.once("error",l),h.on("close",()=>{m("renderer closed the socket")})})}}async function d(){const i=await a();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(n=>{(0,I.isMessageOfType)(n,2)?(this._terminating=!0,m("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||i.send(n)}async drain(){if(i.drain)return i.drain()}}}function r(i){return new Promise(n=>{const s=i.onMessage(l=>{s.dispose();const h=JSON.parse(l.toString()),S=h.commit,L=E.default.commit;S&&L&&S!==L&&v(55);let M=0;setInterval(function(){try{process.kill(h.parentPid,0),M=0}catch(A){A&&A.code==="EPERM"?(M++,M>=3&&m(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${A.message} (code: ${A.code}) (errno: ${A.errno})`)):m(`parent process ${h.parentPid} does not exist anymore: ${A.message} (code: ${A.code}) (errno: ${A.errno})`)}},1e3);let F;try{F=Y.__$__nodeRequire("native-watchdog"),F.start(h.parentPid)}catch(A){(0,P.onUnexpectedError)(A)}i.send((0,I.createMessageOfType)(0)),n({protocol:i,initData:h})});i.send((0,I.createMessageOfType)(1))})}async function o(){const i=[];process.on("unhandledRejection",(M,F)=>{i.push(F),setTimeout(()=>{const A=i.indexOf(F);A>=0&&F.catch(B=>{i.splice(A,1),(0,P.isCancellationError)(B)||(console.warn(`rejected promise not handled within 1 second: ${B}`),B&&B.stack&&console.warn(`stack trace: ${B.stack}`),M&&(0,P.onUnexpectedError)(M))})},1e3)}),process.on("rejectionHandled",M=>{const F=i.indexOf(M);F>=0&&i.splice(F,1)}),process.on("uncaughtException",function(M){(0,P.onUnexpectedError)(M)}),D.mark("code/extHost/willConnectToRenderer");const n=await d();D.mark("code/extHost/didConnectToRenderer");const s=await r(n);D.mark("code/extHost/didWaitForInitData");const{initData:l}=s;c(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=p.useHostProxy!==void 0?p.useHostProxy!=="false":void 0,l.environment.skipWorkspaceStorageLock=(0,b.boolean)(p.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(F){v(F)}exists(F){return _.Promises.exists(F)}realpath(F){return(0,T.realpath)(F)}};let S=null;l.remote.authority&&p.transformURIs&&(S=(0,g.createURITransformer)(l.remote.authority));const L=new R.ExtensionHostMain(s.protocol,l,h,S);m=M=>L.terminate(M)}e.startExtensionHostProcess=o,o().catch(i=>console.log(i))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/92fd228156aafeb326b23f6604028d342152313b/core/vs/workbench/api/node/extensionHostProcess.js.map
